/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/remote/common/remoteHosts","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ce=function(Y){for(var e=[],S=0,O=Y.length;S<O;S++)e[S]=ae[Y[S]];return e};define(ae[135],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function S(p,k,g){const l=O(p,k);if(l!==-1)return p[l]}e.$fb=S;function O(p,k,g=p.length-1){for(let l=g;l>=0;l--){const f=p[l];if(k(f))return l}return-1}e.$gb=O;function s(p,k){const g=M(p,k);return g===-1?void 0:p[g]}e.$hb=s;function M(p,k,g=0,l=p.length){let f=g,$=l;for(;f<$;){const a=Math.floor((f+$)/2);k(p[a])?f=a+1:$=a}return f-1}e.$ib=M;function D(p,k){const g=P(p,k);return g===p.length?void 0:p[g]}e.$jb=D;function P(p,k,g=0,l=p.length){let f=g,$=l;for(;f<$;){const a=Math.floor((f+$)/2);k(p[a])?$=a:f=a+1}return f}e.$kb=P;function d(p,k,g=0,l=p.length){const f=P(p,k,g,l);return f===p.length?-1:f}e.$lb=d;class u{static{this.assertInvariants=!1}constructor(k){this.e=k,this.c=0}findLastMonotonous(k){if(u.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!k(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=k}const g=M(this.e,k,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$mb=u;function b(p,k){if(p.length===0)return;let g=p[0];for(let l=1;l<p.length;l++){const f=p[l];k(f,g)>0&&(g=f)}return g}e.$nb=b;function v(p,k){if(p.length===0)return;let g=p[0];for(let l=1;l<p.length;l++){const f=p[l];k(f,g)>=0&&(g=f)}return g}e.$ob=v;function y(p,k){return b(p,(g,l)=>-k(g,l))}e.$pb=y;function h(p,k){if(p.length===0)return-1;let g=0;for(let l=1;l<p.length;l++){const f=p[l];k(f,p[g])>0&&(g=l)}return g}e.$qb=h;function m(p,k){for(const g of p){const l=k(g);if(l!==void 0)return l}}e.$rb=m}),define(ae[136],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function S(D,P){const d=Object.create(null);for(const u of D){const b=P(u);let v=d[b];v||(v=d[b]=[]),v.push(u)}return d}e.$K=S;function O(D,P){const d=[],u=[];for(const b of D)P.has(b)||d.push(b);for(const b of P)D.has(b)||u.push(b);return{removed:d,added:u}}e.$L=O;function s(D,P){const d=[],u=[];for(const[b,v]of D)P.has(b)||d.push(v);for(const[b,v]of P)D.has(b)||u.push(v);return{removed:d,added:u}}e.$M=s;function M(D,P){const d=new Set;for(const u of P)D.has(u)&&d.add(u);return d}e.$N=M}),define(ae[137],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.$nt=e.$mt=e.$lt=void 0;function S(P,d){const u=Math.pow(10,d);return Math.round(P*u)/u}class O{constructor(d,u,b,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=S(Math.max(Math.min(1,v),0),3)}static equals(d,u){return d.r===u.r&&d.g===u.g&&d.b===u.b&&d.a===u.a}}e.$lt=O;class s{constructor(d,u,b,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=S(Math.max(Math.min(1,u),0),3),this.l=S(Math.max(Math.min(1,b),0),3),this.a=S(Math.max(Math.min(1,v),0),3)}static equals(d,u){return d.h===u.h&&d.s===u.s&&d.l===u.l&&d.a===u.a}static fromRGBA(d){const u=d.r/255,b=d.g/255,v=d.b/255,y=d.a,h=Math.max(u,b,v),m=Math.min(u,b,v);let p=0,k=0;const g=(m+h)/2,l=h-m;if(l>0){switch(k=Math.min(g<=.5?l/(2*g):l/(2-2*g),1),h){case u:p=(b-v)/l+(b<v?6:0);break;case b:p=(v-u)/l+2;break;case v:p=(u-b)/l+4;break}p*=60,p=Math.round(p)}return new s(p,k,g,y)}static i(d,u,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?d+(u-d)*6*b:b<1/2?u:b<2/3?d+(u-d)*(2/3-b)*6:d}static toRGBA(d){const u=d.h/360,{s:b,l:v,a:y}=d;let h,m,p;if(b===0)h=m=p=v;else{const k=v<.5?v*(1+b):v+b-v*b,g=2*v-k;h=s.i(g,k,u+1/3),m=s.i(g,k,u),p=s.i(g,k,u-1/3)}return new O(Math.round(h*255),Math.round(m*255),Math.round(p*255),y)}}e.$mt=s;class M{constructor(d,u,b,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=S(Math.max(Math.min(1,u),0),3),this.v=S(Math.max(Math.min(1,b),0),3),this.a=S(Math.max(Math.min(1,v),0),3)}static equals(d,u){return d.h===u.h&&d.s===u.s&&d.v===u.v&&d.a===u.a}static fromRGBA(d){const u=d.r/255,b=d.g/255,v=d.b/255,y=Math.max(u,b,v),h=Math.min(u,b,v),m=y-h,p=y===0?0:m/y;let k;return m===0?k=0:y===u?k=((b-v)/m%6+6)%6:y===b?k=(v-u)/m+2:k=(u-b)/m+4,new M(Math.round(k*60),p,y,d.a)}static toRGBA(d){const{h:u,s:b,v,a:y}=d,h=v*b,m=h*(1-Math.abs(u/60%2-1)),p=v-h;let[k,g,l]=[0,0,0];return u<60?(k=h,g=m):u<120?(k=m,g=h):u<180?(g=h,l=m):u<240?(g=m,l=h):u<300?(k=m,l=h):u<=360&&(k=h,l=m),k=Math.round((k+p)*255),g=Math.round((g+p)*255),l=Math.round((l+p)*255),new O(k,g,l,y)}}e.$nt=M;class D{static fromHex(d){return D.Format.CSS.parseHex(d)||D.red}static equals(d,u){return!d&&!u?!0:!d||!u?!1:d.equals(u)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof O)this.rgba=d;else if(d instanceof s)this.i=d,this.rgba=s.toRGBA(d);else if(d instanceof M)this.j=d,this.rgba=M.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&O.equals(this.rgba,d.rgba)&&s.equals(this.hsla,d.hsla)&&M.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=D.k(this.rgba.r),u=D.k(this.rgba.g),b=D.k(this.rgba.b),v=.2126*d+.7152*u+.0722*b;return S(v,4)}static k(d){const u=d/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(d){const u=this.getRelativeLuminance(),b=d.getRelativeLuminance();return u>b?(u+.05)/(b+.05):(b+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const u=this.getRelativeLuminance(),b=d.getRelativeLuminance();return u>b}isDarkerThan(d){const u=this.getRelativeLuminance(),b=d.getRelativeLuminance();return u<b}lighten(d){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:u,g:b,b:v,a:y}=this.rgba;return new D(new O(u,b,v,y*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new O(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const u=d.rgba,b=this.rgba.a,v=u.a,y=b+v*(1-b);if(y<1e-6)return D.transparent;const h=this.rgba.r*b/y+u.r*v*(1-b)/y,m=this.rgba.g*b/y+u.g*v*(1-b)/y,p=this.rgba.b*b/y+u.b*v*(1-b)/y;return new D(new O(h,m,p,y))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:u,g:b,b:v,a:y}=this.rgba;return new D(new O(d.rgba.r-y*(d.rgba.r-u),d.rgba.g-y*(d.rgba.g-b),d.rgba.b-y*(d.rgba.b-v),1))}flatten(...d){const u=d.reduceRight((b,v)=>D.o(v,b));return D.o(this,u)}static o(d,u){const b=1-d.rgba.a;return new D(new O(b*u.rgba.r+d.rgba.a*d.rgba.r,b*u.rgba.g+d.rgba.a*d.rgba.g,b*u.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(d,u,b){if(d.isLighterThan(u))return d;b=b||.5;const v=d.getRelativeLuminance(),y=u.getRelativeLuminance();return b=b*(y-v)/y,d.lighten(b)}static getDarkerColor(d,u,b){if(d.isDarkerThan(u))return d;b=b||.5;const v=d.getRelativeLuminance(),y=u.getRelativeLuminance();return b=b*(v-y)/v,d.darken(b)}static{this.white=new D(new O(255,255,255,1))}static{this.black=new D(new O(0,0,0,1))}static{this.red=new D(new O(255,0,0,1))}static{this.blue=new D(new O(0,0,255,1))}static{this.green=new D(new O(0,255,0,1))}static{this.cyan=new D(new O(0,255,255,1))}static{this.lightgrey=new D(new O(211,211,211,1))}static{this.transparent=new D(new O(0,0,0,0))}}e.$ot=D,function(P){let d;(function(u){let b;(function(v){function y(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}v.formatRGB=y;function h(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=h;function m(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}v.formatHSL=m;function p(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=p;function k(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function g(t){return`#${k(t.rgba.r)}${k(t.rgba.g)}${k(t.rgba.b)}`}v.formatHex=g;function l(t,o=!1){return o&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${k(t.rgba.r)}${k(t.rgba.g)}${k(t.rgba.b)}${k(Math.round(t.rgba.a*255))}`}v.formatHexA=l;function f(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}v.format=f;function $(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),n=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new P(new O(r,i,n,1))}if(o===9){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),n=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),c=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new P(new O(r,i,n,c/255))}if(o===4){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),n=a(t.charCodeAt(3));return new P(new O(16*r+r,16*i+i,16*n+n))}if(o===5){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),n=a(t.charCodeAt(3)),c=a(t.charCodeAt(4));return new P(new O(16*r+r,16*i+i,16*n+n,(16*c+c)/255))}return null}v.parseHex=$;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=u.CSS||(u.CSS={}))})(d=P.Format||(P.Format={}))}(D||(e.$ot=D={}))}),define(ae[50],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function S(D){return(P,d,u)=>{let b=null,v=null;if(typeof u.value=="function"?(b="value",v=u.value):typeof u.get=="function"&&(b="get",v=u.get),!v)throw new Error("not supported");u[b]=D(v,d)}}function O(D,P,d){let u=null,b=null;if(typeof d.value=="function"?(u="value",b=d.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(u="get",b=d.get),!b)throw new Error("not supported");const v=`$memoize$${P}`;d[u]=function(...y){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,y)}),this[v]}}e.$zh=O;function s(D,P,d){return S((u,b)=>{const v=`$debounce$${b}`,y=`$debounce$result$${b}`;return function(...h){this[y]||(this[y]=d?d():void 0),clearTimeout(this[v]),P&&(this[y]=P(this[y],...h),h=[this[y]]),this[v]=setTimeout(()=>{u.apply(this,h),this[y]=d?d():void 0},D)}})}e.$Ah=s;function M(D,P,d){return S((u,b)=>{const v=`$throttle$timer$${b}`,y=`$throttle$result$${b}`,h=`$throttle$lastRun$${b}`,m=`$throttle$pending$${b}`;return function(...p){if(this[y]||(this[y]=d?d():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...p)),this[m])return;const k=this[h]+D;k<=Date.now()?(this[h]=Date.now(),u.apply(this,[this[y]]),this[y]=d?d():void 0):(this[m]=!0,this[v]=setTimeout(()=>{this[m]=!1,this[h]=Date.now(),u.apply(this,[this[y]]),this[y]=d?d():void 0},k-Date.now()))}})}e.$Bh=M}),define(ae[14],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class S{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?f.isErrorNoTelemetry(t)?new f(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=S,e.$X=new S;function O(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=O;function s(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function M(a){u(a)||e.$X.onUnexpectedError(a)}e.$1=M;function D(a){u(a)||e.$X.onUnexpectedExternalError(a)}e.$2=D;function P(a){if(a instanceof Error){const{name:t,message:o}=a,r=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:f.isErrorNoTelemetry(a)}}return a}e.$3=P;const d="Canceled";function u(a){return a instanceof b?!0:a instanceof Error&&a.name===d&&a.message===d}e.$4=u;class b extends Error{constructor(){super(d),this.name=this.message}}e.$5=b;function v(){const a=new Error(d);return a.name=a.message,a}e.$6=v;function y(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=y;function h(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=h;class m extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=m;function p(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=p;class k extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=k;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=g;class l extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=l;class f extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof f)return t;const o=new f;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=f;class $ extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}e.$cb=$}),define(ae[22],ce([0,1,14,135]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(N,Q=0){return N[N.length-(1+Q)]}e.$sb=s;function M(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.$tb=M;function D(N,Q,V=(_,z)=>_===z){if(N===Q)return!0;if(!N||!Q||N.length!==Q.length)return!1;for(let _=0,z=N.length;_<z;_++)if(!V(N[_],Q[_]))return!1;return!0}e.$ub=D;function P(N,Q){const V=N.length-1;Q<V&&(N[Q]=N[V]),N.pop()}e.$vb=P;function d(N,Q,V){return u(N.length,_=>V(N[_],Q))}e.$wb=d;function u(N,Q){let V=0,_=N-1;for(;V<=_;){const z=(V+_)/2|0,ee=Q(z);if(ee<0)V=z+1;else if(ee>0)_=z-1;else return z}return-(V+1)}e.$xb=u;function b(N,Q,V){if(N=N|0,N>=Q.length)throw new TypeError("invalid index");const _=Q[Math.floor(Q.length*Math.random())],z=[],ee=[],ne=[];for(const de of Q){const me=V(de,_);me<0?z.push(de):me>0?ee.push(de):ne.push(de)}return N<z.length?b(N,z,V):N<z.length+ne.length?ne[0]:b(N-(z.length+ne.length),ee,V)}e.$yb=b;function v(N,Q){const V=[];let _;for(const z of N.slice(0).sort(Q))!_||Q(_[0],z)!==0?(_=[z],V.push(_)):_.push(z);return V}e.$zb=v;function*y(N,Q){let V,_;for(const z of N)_!==void 0&&Q(_,z)?V.push(z):(V&&(yield V),V=[z]),_=z;V&&(yield V)}e.$Ab=y;function h(N,Q){for(let V=0;V<=N.length;V++)Q(V===0?void 0:N[V-1],V===N.length?void 0:N[V])}e.$Bb=h;function m(N,Q){for(let V=0;V<N.length;V++)Q(V===0?void 0:N[V-1],N[V],V+1===N.length?void 0:N[V+1])}e.$Cb=m;function p(N,Q,V){const _=[];function z(de,me,Ee){if(me===0&&Ee.length===0)return;const Pe=_[_.length-1];Pe&&Pe.start+Pe.deleteCount===de?(Pe.deleteCount+=me,Pe.toInsert.push(...Ee)):_.push({start:de,deleteCount:me,toInsert:Ee})}let ee=0,ne=0;for(;;){if(ee===N.length){z(ee,0,Q.slice(ne));break}if(ne===Q.length){z(ee,N.length-ee,[]);break}const de=N[ee],me=Q[ne],Ee=V(de,me);Ee===0?(ee+=1,ne+=1):Ee<0?(z(ee,1,[]),ee+=1):Ee>0&&(z(ee,0,[me]),ne+=1)}return _}e.$Db=p;function k(N,Q,V){const _=p(N,Q,V),z=[],ee=[];for(const ne of _)z.push(...N.slice(ne.start,ne.start+ne.deleteCount)),ee.push(...ne.toInsert);return{removed:z,added:ee}}e.$Eb=k;function g(N,Q,V){if(V===0)return[];const _=N.slice(0,V).sort(Q);return f(N,Q,_,V,N.length),_}e.top=g;function l(N,Q,V,_,z){return V===0?Promise.resolve([]):new Promise((ee,ne)=>{(async()=>{const de=N.length,me=N.slice(0,V).sort(Q);for(let Ee=V,Pe=Math.min(V+_,de);Ee<de;Ee=Pe,Pe=Math.min(Pe+_,de)){if(Ee>V&&await new Promise(Le=>setTimeout(Le)),z&&z.isCancellationRequested)throw new S.$5;f(N,Q,me,Ee,Pe)}return me})().then(ee,ne)})}e.$Gb=l;function f(N,Q,V,_,z){for(const ee=V.length;_<z;_++){const ne=N[_];if(Q(ne,V[ee-1])<0){V.pop();const de=(0,O.$kb)(V,me=>Q(ne,me)<0);V.splice(de,0,ne)}}}function $(N){return N.filter(Q=>!!Q)}e.$Hb=$;function a(N){let Q=0;for(let V=0;V<N.length;V++)N[V]&&(N[Q]=N[V],Q+=1);N.length=Q}e.$Ib=a;function t(N,Q,V){N.splice(V,0,N.splice(Q,1)[0])}e.$Jb=t;function o(N){return!Array.isArray(N)||N.length===0}e.$Kb=o;function r(N){return Array.isArray(N)&&N.length>0}e.$Lb=r;function i(N,Q=V=>V){const V=new Set;return N.filter(_=>{const z=Q(_);return V.has(z)?!1:(V.add(z),!0)})}e.$Mb=i;function n(N){const Q=new Set;return V=>{const _=N(V);return Q.has(_)?!1:(Q.add(_),!0)}}e.$Nb=n;function c(N,Q){return N.length>0?N[0]:Q}e.$Ob=c;function w(N,Q){return N.length>0?N[N.length-1]:Q}e.$Pb=w;function A(N,Q,V=(_,z)=>_===z){let _=0;for(let z=0,ee=Math.min(N.length,Q.length);z<ee&&V(N[z],Q[z]);z++)_++;return _}e.$Qb=A;function I(N){return[].concat(...N)}e.$Rb=I;function E(N,Q){let V=typeof Q=="number"?N:0;typeof Q=="number"?V=N:(V=0,Q=N);const _=[];if(V<=Q)for(let z=V;z<Q;z++)_.push(z);else for(let z=V;z>Q;z--)_.push(z);return _}e.$Sb=E;function C(N,Q,V){return N.reduce((_,z)=>(_[Q(z)]=V?V(z):z,_),Object.create(null))}e.$Tb=C;function j(N,Q){return N.push(Q),()=>U(N,Q)}e.$Ub=j;function U(N,Q){const V=N.indexOf(Q);if(V>-1)return N.splice(V,1),Q}e.$Vb=U;function F(N,Q,V){const _=N.slice(0,Q),z=N.slice(Q);return _.concat(V,z)}e.$Wb=F;function H(N,Q){let V;if(typeof Q=="number"){let _=Q;V=()=>{const z=Math.sin(_++)*179426549;return z-Math.floor(z)}}else V=Math.random;for(let _=N.length-1;_>0;_-=1){const z=Math.floor(V()*(_+1)),ee=N[_];N[_]=N[z],N[z]=ee}}e.$Xb=H;function J(N,Q){const V=N.indexOf(Q);V>-1&&(N.splice(V,1),N.unshift(Q))}e.$Yb=J;function le(N,Q){const V=N.indexOf(Q);V>-1&&(N.splice(V,1),N.push(Q))}e.$Zb=le;function re(N,Q){for(const V of Q)N.push(V)}e.$1b=re;function ue(N,Q){return Array.isArray(N)?N.map(Q):Q(N)}e.$2b=ue;function Z(N){return Array.isArray(N)?N:[N]}e.$3b=Z;function X(N){return N[Math.floor(Math.random()*N.length)]}e.$4b=X;function q(N,Q,V){const _=T(N,Q),z=N.length,ee=V.length;N.length=z+ee;for(let ne=z-1;ne>=_;ne--)N[ne+ee]=N[ne];for(let ne=0;ne<ee;ne++)N[ne+_]=V[ne]}e.$5b=q;function L(N,Q,V,_){const z=T(N,Q);let ee=N.splice(z,V);return ee===void 0&&(ee=[]),q(N,z,_),ee}e.$6b=L;function T(N,Q){return Q<0?Math.max(Q+N.length,0):Math.min(Q,N.length)}var G;(function(N){function Q(ee){return ee<0}N.isLessThan=Q;function V(ee){return ee<=0}N.isLessThanOrEqual=V;function _(ee){return ee>0}N.isGreaterThan=_;function z(ee){return ee===0}N.isNeitherLessOrGreaterThan=z,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function B(N,Q){return(V,_)=>Q(N(V),N(_))}e.$7b=B;function oe(...N){return(Q,V)=>{for(const _ of N){const z=_(Q,V);if(!G.isNeitherLessOrGreaterThan(z))return z}return G.neitherLessOrGreaterThan}}e.$8b=oe;const he=(N,Q)=>N-Q;e.$9b=he;const K=(N,Q)=>(0,e.$9b)(N?1:0,Q?1:0);e.$0b=K;function R(N){return(Q,V)=>-N(Q,V)}e.$$b=R;class W{constructor(Q){this.g=Q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let V=this.c;for(;V<this.g.length&&Q(this.g[V]);)V++;const _=V===this.c?null:this.g.slice(this.c,V);return this.c=V,_}takeFromEndWhile(Q){let V=this.d;for(;V>=0&&Q(this.g[V]);)V--;const _=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Q=this.g[this.c];return this.c++,Q}removeLast(){const Q=this.g[this.d];return this.d--,Q}takeCount(Q){const V=this.g.slice(this.c,this.c+Q);return this.c+=Q,V}}e.$_b=W;class x{static{this.empty=new x(Q=>{})}constructor(Q){this.iterate=Q}forEach(Q){this.iterate(V=>(Q(V),!0))}toArray(){const Q=[];return this.iterate(V=>(Q.push(V),!0)),Q}filter(Q){return new x(V=>this.iterate(_=>Q(_)?V(_):!0))}map(Q){return new x(V=>this.iterate(_=>V(Q(_))))}some(Q){let V=!1;return this.iterate(_=>(V=Q(_),!V)),V}findFirst(Q){let V;return this.iterate(_=>Q(_)?(V=_,!1):!0),V}findLast(Q){let V;return this.iterate(_=>(Q(_)&&(V=_),!0)),V}findLastMaxBy(Q){let V,_=!0;return this.iterate(z=>((_||G.isGreaterThan(Q(z,V)))&&(_=!1,V=z),!0)),V}}e.$ac=x}),define(ae[138],ce([0,1,14]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function O(u,b){if(!u)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=O;function s(u,b="Unreachable"){throw new Error(b)}e.$6c=s;function M(u){if(!u)throw new S.$cb("Assertion Failed")}e.$7c=M;function D(u){u||(0,S.$1)(new S.$cb("Assertion Failed"))}e.$8c=D;function P(u){if(!u()){debugger;u(),(0,S.$1)(new S.$cb("Assertion Failed"))}}e.$9c=P;function d(u,b){let v=0;for(;v<u.length-1;){const y=u[v],h=u[v+1];if(!b(y,h))return!1;v++}return!0}e.$0c=d}),define(ae[84],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function S(O,s){const M=this;let D=!1,P;return function(){if(D)return P;if(D=!0,s)try{P=O.apply(M,arguments)}finally{s()}else P=O.apply(M,arguments);return P}}e.$db=S}),define(ae[71],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(O){function s(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}O.is=s;const M=Object.freeze([]);function D(){return M}O.empty=D;function*P(t){yield t}O.single=P;function d(t){return s(t)?t:P(t)}O.wrap=d;function u(t){return t||M}O.from=u;function*b(t){for(let o=t.length-1;o>=0;o--)yield t[o]}O.reverse=b;function v(t){return!t||t[Symbol.iterator]().next().done===!0}O.isEmpty=v;function y(t){return t[Symbol.iterator]().next().value}O.first=y;function h(t,o){for(const r of t)if(o(r))return!0;return!1}O.some=h;function m(t,o){for(const r of t)if(o(r))return r}O.find=m;function*p(t,o){for(const r of t)o(r)&&(yield r)}O.filter=p;function*k(t,o){let r=0;for(const i of t)yield o(i,r++)}O.map=k;function*g(...t){for(const o of t)yield*o}O.concat=g;function l(t,o,r){let i=r;for(const n of t)i=o(i,n);return i}O.reduce=l;function*f(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}O.slice=f;function $(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let n=0;n<o;n++){const c=i.next();if(c.done)return[r,O.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return i}}]}O.consume=$;async function a(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}O.asyncToArray=a})(S||(e.Iterable=S={}))}),define(ae[42],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function D(t,o=!1){let r=0;const i=t.length;let n="",c=0,w=16,A=0;function I(J){let le=0,re=0;for(;le<J;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)re=re*16+ue-48;else if(ue>=65&&ue<=70)re=re*16+ue-65+10;else if(ue>=97&&ue<=102)re=re*16+ue-97+10;else break;r++,le++}return le<J&&(re=-1),re}function E(J){r=J,n="",c=0,w=16,A=0}function C(){const J=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&u(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&u(t.charCodeAt(r)))for(r++;r<t.length&&u(t.charCodeAt(r));)r++;else return A=3,t.substring(J,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&u(t.charCodeAt(r))){for(r++;r<t.length&&u(t.charCodeAt(r));)r++;le=r}else A=3;return t.substring(J,le)}function j(){let J="",le=r;for(;;){if(r>=i){J+=t.substring(le,r),A=2;break}const re=t.charCodeAt(r);if(re===34){J+=t.substring(le,r),r++;break}if(re===92){if(J+=t.substring(le,r),r++,r>=i){A=2;break}switch(t.charCodeAt(r++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const Z=I(4);Z>=0?J+=String.fromCharCode(Z):A=4;break}default:A=5}le=r;continue}if(re>=0&&re<=31)if(d(re)){J+=t.substring(le,r),A=2;break}else A=6;r++}return J}function U(){if(n="",A=0,c=r,r>=i)return c=i,w=17;let J=t.charCodeAt(r);if(P(J)){do r++,n+=String.fromCharCode(J),J=t.charCodeAt(r);while(P(J));return w=15}if(d(J))return r++,n+=String.fromCharCode(J),J===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),w=14;switch(J){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,n=j(),w=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!d(t.charCodeAt(r));)r++;return n=t.substring(le,r),w=12}if(t.charCodeAt(r+1)===42){r+=2;const re=i-1;let ue=!1;for(;r<re;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,A=1),n=t.substring(le,r),w=13}return n+=String.fromCharCode(J),r++,w=16}case 45:if(n+=String.fromCharCode(J),r++,r===i||!u(t.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=C(),w=11;default:for(;r<i&&F(J);)r++,J=t.charCodeAt(r);if(c!==r){switch(n=t.substring(c,r),n){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return n+=String.fromCharCode(J),r++,w=16}}function F(J){if(P(J)||d(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let J;do J=U();while(J>=12&&J<=15);return J}return{setPosition:E,getPosition:()=>r,scan:o?H:U,getToken:()=>w,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>A}}e.$dn=D;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function v(t,o){const r=[],i=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function A(I,E,C,j){c.value=I,c.offset=E,c.length=C,c.type=j,c.colonOffset=void 0,n=c}try{f(t,{onObjectBegin:(I,E)=>{if(o<=I)throw i;n=void 0,w=o>I,r.push("")},onObjectProperty:(I,E,C)=>{if(o<E||(A(I,E,C,"property"),r[r.length-1]=I,o<=E+C))throw i},onObjectEnd:(I,E)=>{if(o<=I)throw i;n=void 0,r.pop()},onArrayBegin:(I,E)=>{if(o<=I)throw i;n=void 0,r.push(0)},onArrayEnd:(I,E)=>{if(o<=I)throw i;n=void 0,r.pop()},onLiteralValue:(I,E,C)=>{if(o<E||(A(I,E,C,a(I)),o<=E+C))throw i},onSeparator:(I,E,C)=>{if(o<=E)throw i;if(I===":"&&n&&n.type==="property")n.colonOffset=E,w=!1,n=void 0;else if(I===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(w=!0,r[r.length-1]=""),n=void 0}}})}catch(I){if(I!==i)throw I}return{path:r,previousNode:n,isAtPropertyKey:w,matches:I=>{let E=0;for(let C=0;E<I.length&&C<r.length;C++)if(I[E]===r[C]||I[E]==="*")E++;else if(I[E]!=="**")return!1;return E===I.length}}}e.$en=v;function y(t,o=[],r=M.DEFAULT){let i=null,n=[];const c=[];function w(I){Array.isArray(n)?n.push(I):i!==null&&(n[i]=I)}return f(t,{onObjectBegin:()=>{const I={};w(I),c.push(n),n=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const I=[];w(I),c.push(n),n=I,i=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:w,onError:(I,E,C)=>{o.push({error:I,offset:E,length:C})}},r),n[0]}e.$fn=y;function h(t,o=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function c(I){return i.children.push(I),I}f(t,{onObjectBegin:I=>{i=c({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,E,C)=>{i=c({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:E,length:C,parent:i})},onObjectEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,n(I+E)},onArrayBegin:(I,E)=>{i=c({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,n(I+E)},onLiteralValue:(I,E,C)=>{c({type:a(I),offset:E,length:C,parent:i,value:I}),n(E+C)},onSeparator:(I,E,C)=>{i.type==="property"&&(I===":"?i.colonOffset=E:I===","&&n(E))},onError:(I,E,C)=>{o.push({error:I,offset:E,length:C})}},r);const A=i.children[0];return A&&delete A.parent,A}e.$gn=h;function m(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===i){r=c.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$hn=m;function p(t){if(!t.parent||!t.parent.children)return[];const o=p(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}e.$in=p;function k(t){switch(t.type){case"array":return t.children.map(k);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=k(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$jn=k;function g(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}e.$kn=g;function l(t,o,r=!1){if(g(t,o,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const c=l(i[n],o,r);if(c)return c}return t}}e.$ln=l;function f(t,o,r=M.DEFAULT){const i=D(t,!1);function n(B){return B?()=>B(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(B){return B?oe=>B(oe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const w=n(o.onObjectBegin),A=c(o.onObjectProperty),I=n(o.onObjectEnd),E=n(o.onArrayBegin),C=n(o.onArrayEnd),j=c(o.onLiteralValue),U=c(o.onSeparator),F=n(o.onComment),H=c(o.onError),J=r&&r.disallowComments,le=r&&r.allowTrailingComma;function re(){for(;;){const B=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:J||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(B){case 12:case 13:J?ue(10):F();break;case 16:ue(1);break;case 15:case 14:break;default:return B}}}function ue(B,oe=[],he=[]){if(H(B),oe.length+he.length>0){let K=i.getToken();for(;K!==17;){if(oe.indexOf(K)!==-1){re();break}else if(he.indexOf(K)!==-1)break;K=re()}}}function Z(B){const oe=i.getTokenValue();return B?j(oe):A(oe),re(),!0}function X(){switch(i.getToken()){case 11:{let B=0;try{B=JSON.parse(i.getTokenValue()),typeof B!="number"&&(ue(2),B=0)}catch{ue(2)}j(B);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return re(),!0}function q(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(Z(!1),i.getToken()===6?(U(":"),re(),G()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function L(){w(),re();let B=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(B||ue(4,[],[]),U(","),re(),i.getToken()===2&&le)break}else B&&ue(6,[],[]);q()||ue(4,[],[2,5]),B=!0}return I(),i.getToken()!==2?ue(7,[2],[]):re(),!0}function T(){E(),re();let B=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(B||ue(4,[],[]),U(","),re(),i.getToken()===4&&le)break}else B&&ue(6,[],[]);G()||ue(4,[],[4,5]),B=!0}return C(),i.getToken()!==4?ue(8,[4],[]):re(),!0}function G(){switch(i.getToken()){case 3:return T();case 1:return L();case 10:return Z(!0);default:return X()}}return re(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):G()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.$mn=f;function $(t,o){const r=D(t),i=[];let n,c=0,w;do switch(w=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:c!==w&&i.push(t.substring(c,w)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),c=r.getPosition();break}while(n!==17);return i.join("")}e.$nn=$;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$on=a}),define(ae[139],ce([0,1,42]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.$pn=void 0;function O(u,b,v){let y,h,m,p,k;if(b){for(p=b.offset,k=p+b.length,m=p;m>0&&!d(u,m-1);)m--;let w=k;for(;w<u.length&&!d(u,w);)w++;h=u.substring(m,w),y=D(h,v)}else h=u,y=0,m=0,p=0,k=u.length;const g=P(v,u);let l=!1,f=0,$;v.insertSpaces?$=M(" ",v.tabSize||4):$="	";const a=(0,S.$dn)(h,!1);let t=!1;function o(){return g+M($,y+f)}function r(){let w=a.scan();for(l=!1;w===15||w===14;)l=l||w===14,w=a.scan();return t=w===16||a.getTokenError()!==0,w}const i=[];function n(w,A,I){!t&&A<k&&I>p&&u.substring(A,I)!==w&&i.push({offset:A,length:I-A,content:w})}let c=r();if(c!==17){const w=a.getTokenOffset()+m,A=M($,y);n(A,m,w)}for(;c!==17;){let w=a.getTokenOffset()+a.getTokenLength()+m,A=r(),I="";for(;!l&&(A===12||A===13);){const C=a.getTokenOffset()+m;n(" ",w,C),w=a.getTokenOffset()+a.getTokenLength()+m,I=A===12?o():"",A=r()}if(A===2)c!==1&&(f--,I=o());else if(A===4)c!==3&&(f--,I=o());else{switch(c){case 3:case 1:f++,I=o();break;case 5:case 12:I=o();break;case 13:l?I=o():I=" ";break;case 6:I=" ";break;case 10:if(A===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:A===12||A===13?I=" ":A!==5&&A!==17&&(t=!0);break;case 16:t=!0;break}l&&(A===12||A===13)&&(I=o())}const E=a.getTokenOffset()+m;n(I,w,E),c=A}return i}e.$pn=O;function s(u,b){const v=JSON.stringify(u,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?v.replace(/\r\n|\r|\n/g,b.eol):v}e.$qn=s;function M(u,b){let v="";for(let y=0;y<b;y++)v+=u;return v}function D(u,b){let v=0,y=0;const h=b.tabSize||4;for(;v<u.length;){const m=u.charAt(v);if(m===" ")y++;else if(m==="	")y+=h;else break;v++}return Math.floor(y/h)}function P(u,b){for(let v=0;v<b.length;v++){const y=b.charAt(v);if(y==="\r")return v+1<b.length&&b.charAt(v+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return u&&u.eol||`
`}e.$rn=P;function d(u,b){return`\r
`.indexOf(u.charAt(b))!==-1}e.$sn=d}),define(ae[102],ce([0,1,42,139]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=void 0;function s(u,b,v){return M(u,b,void 0,v)}e.$tn=s;function M(u,b,v,y,h){const m=b.slice(),p=[],k=(0,S.$gn)(u,p);let g,l;for(;m.length>0&&(l=m.pop(),g=(0,S.$hn)(k,m),g===void 0&&v!==void 0);)typeof l=="string"?v={[l]:v}:v=[v];if(g)if(g.type==="object"&&typeof l=="string"&&Array.isArray(g.children)){const f=(0,S.$hn)(g,[l]);if(f!==void 0)if(v===void 0){if(!f.parent)throw new Error("Malformed AST");const $=g.children.indexOf(f.parent);let a,t=f.parent.offset+f.parent.length;if($>0){const o=g.children[$-1];a=o.offset+o.length}else a=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return D(u,{offset:a,length:t-a,content:""},y)}else return D(u,{offset:f.offset,length:f.length,content:JSON.stringify(v)},y);else{if(v===void 0)return[];const $=`${JSON.stringify(l)}: ${JSON.stringify(v)}`,a=h?h(g.children.map(o=>o.children[0].value)):g.children.length;let t;if(a>0){const o=g.children[a-1];t={offset:o.offset+o.length,length:0,content:","+$}}else g.children.length===0?t={offset:g.offset+1,length:0,content:$}:t={offset:g.offset+1,length:0,content:$+","};return D(u,t,y)}}else if(g.type==="array"&&typeof l=="number"&&Array.isArray(g.children))if(v!==void 0){const f=`${JSON.stringify(v)}`;let $;if(g.children.length===0||l===0)$={offset:g.offset+1,length:0,content:g.children.length===0?f:f+","};else{const a=l===-1||l>g.children.length?g.children.length:l,t=g.children[a-1];$={offset:t.offset+t.length,length:0,content:","+f}}return D(u,$,y)}else{const f=l,$=g.children[f];let a;if(g.children.length===1)a={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===f){const t=g.children[f-1],o=t.offset+t.length,r=g.offset+g.length;a={offset:o,length:r-2-o,content:""}}else a={offset:$.offset,length:g.children[f+1].offset-$.offset,content:""};return D(u,a,y)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${g.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(u,{offset:k?k.offset:0,length:k?k.length:0,content:JSON.stringify(v)},y)}}e.$un=M;function D(u,b,v){let y=P(u,b),h=b.offset,m=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;h>0&&!(0,O.$sn)(y,h-1);)h--;for(;m<y.length&&!(0,O.$sn)(y,m);)m++}const p=(0,O.$pn)(y,{offset:h,length:m-h},v);for(let g=p.length-1;g>=0;g--){const l=p[g];y=P(y,l),h=Math.min(h,l.offset),m=Math.max(m,l.offset+l.length),m+=l.content.length-l.length}const k=u.length-(y.length-m)-h;return[{offset:h,length:k,content:y.substring(h,m)}]}e.$vn=D;function P(u,b){return u.substring(0,b.offset)+b.content+u.substring(b.offset+b.length)}e.$wn=P;function d(u,b){const v=b.slice(0).sort((h,m)=>{const p=h.offset-m.offset;return p===0?h.length-m.length:p});let y=u.length;for(let h=v.length-1;h>=0;h--){const m=v[h];if(m.offset+m.length<=y)u=P(u,m);else throw new Error("Overlapping edit");y=m.offset}return u}e.$xn=d}),define(ae[62],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=S}),define(ae[103],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class S{static{this.Undefined=new S(void 0)}constructor(M){this.element=M,this.next=S.Undefined,this.prev=S.Undefined}}class O{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let M=this.a;for(;M!==S.Undefined;){const D=M.next;M.prev=S.Undefined,M.next=S.Undefined,M=D}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,D){const P=new S(M);if(this.a===S.Undefined)this.a=P,this.b=P;else if(D){const u=this.b;this.b=P,P.prev=u,u.next=P}else{const u=this.a;this.a=P,P.next=u,u.prev=P}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(P))}}shift(){if(this.a!==S.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==S.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==S.Undefined&&M.next!==S.Undefined){const D=M.prev;D.next=M.next,M.next.prev=D}else M.prev===S.Undefined&&M.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):M.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):M.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==S.Undefined;)yield M.element,M=M.next}}e.$4c=O}),define(ae[31],ce([0,1]),function(Y,e){"use strict";var S,O,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function M(f,$,a){let t=f.get($);return t===void 0&&(t=a,f.set($,t)),t}e.$xc=M;function D(f){const $=[];return f.forEach((a,t)=>{$.push(`${t} => ${a}`)}),`Map(${f.size}) {${$.join(", ")}}`}e.$yc=D;function P(f){const $=[];return f.forEach(a=>{$.push(a)}),`Set(${f.size}) {${$.join(", ")}}`}e.$zc=P;class d{constructor($,a){this.uri=$,this.value=a}}function u(f){return Array.isArray(f)}class b{static{this.c=$=>$.toString()}constructor($,a){if(this[S]="ResourceMap",$ instanceof b)this.d=new Map($.d),this.e=a??b.c;else if(u($)){this.d=new Map,this.e=a??b.c;for(const[t,o]of $)this.set(t,o)}else this.d=new Map,this.e=$??b.c}set($,a){return this.d.set(this.e($),new d($,a)),this}get($){return this.d.get(this.e($))?.value}has($){return this.d.has(this.e($))}get size(){return this.d.size}clear(){this.d.clear()}delete($){return this.d.delete(this.e($))}forEach($,a){typeof a<"u"&&($=$.bind(a));for(const[t,o]of this.d)$(o.value,o.uri,this)}*values(){for(const $ of this.d.values())yield $.value}*keys(){for(const $ of this.d.values())yield $.uri}*entries(){for(const $ of this.d.values())yield[$.uri,$.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,$]of this.d)yield[$.uri,$.value]}}e.$Ac=b;class v{constructor($,a){this[O]="ResourceSet",!$||typeof $=="function"?this.c=new b($):(this.c=new b(a),$.forEach(this.add,this))}get size(){return this.c.size}add($){return this.c.set($,$),this}clear(){this.c.clear()}delete($){return this.c.delete($)}forEach($,a){this.c.forEach((t,o)=>$.call(a,o,o,this))}has($){return this.c.has($)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=v;var y;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class h{constructor(){this[s]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has($){return this.c.has($)}get($,a=0){const t=this.c.get($);if(t)return a!==0&&this.l(t,a),t.value}set($,a,t=0){let o=this.c.get($);if(o)o.value=a,t!==0&&this.l(o,t);else{switch(o={key:$,value:a,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set($,o),this.f++}return this}delete($){return!!this.remove($)}remove($){const a=this.c.get($);if(a)return this.c.delete($),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const $=this.d;return this.c.delete($.key),this.k($),this.f--,$.value}forEach($,a){const t=this.g;let o=this.d;for(;o;){if(a?$.bind(a)(o.value,o.key,this):$(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const $=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if($.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}values(){const $=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if($.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}entries(){const $=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if($.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h($){if($>=this.size)return;if($===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>$;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i($){if(!this.d&&!this.e)this.e=$;else if(this.d)$.next=this.d,this.d.previous=$;else throw new Error("Invalid list");this.d=$,this.g++}j($){if(!this.d&&!this.e)this.d=$;else if(this.e)$.previous=this.e,this.e.next=$;else throw new Error("Invalid list");this.e=$,this.g++}k($){if($===this.d&&$===this.e)this.d=void 0,this.e=void 0;else if($===this.d){if(!$.next)throw new Error("Invalid list");$.next.previous=void 0,this.d=$.next}else if($===this.e){if(!$.previous)throw new Error("Invalid list");$.previous.next=void 0,this.e=$.previous}else{const a=$.next,t=$.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}$.next=void 0,$.previous=void 0,this.g++}l($,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if($===this.d)return;const t=$.next,o=$.previous;$===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),$.previous=void 0,$.next=this.d,this.d.previous=$,this.d=$,this.g++}else if(a===2){if($===this.e)return;const t=$.next,o=$.previous;$===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),$.next=void 0,$.previous=this.e,this.e.next=$,this.e=$,this.g++}}}toJSON(){const $=[];return this.forEach((a,t)=>{$.push([t,a])}),$}fromJSON($){this.clear();for(const[a,t]of $)this.set(a,t)}}e.$Cc=h;class m extends h{constructor($,a=1){super(),this.m=$,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit($){this.m=$,this.o()}get ratio(){return this.n}set ratio($){this.n=Math.min(Math.max(0,$),1),this.o()}get($,a=2){return super.get($,a)}peek($){return super.get($,0)}set($,a){return super.set($,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=m;class p{constructor(){this.c=new Map}add($){return this.c.set($,(this.c.get($)||0)+1),this}delete($){let a=this.c.get($)||0;return a===0?!1:(a--,a===0?this.c.delete($):this.c.set($,a),!0)}has($){return this.c.has($)}}e.$Ec=p;class k{constructor($){if(this.c=new Map,this.d=new Map,$)for(const[a,t]of $)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set($,a){this.c.set($,a),this.d.set(a,$)}get($){return this.c.get($)}getKey($){return this.d.get($)}delete($){const a=this.c.get($);return a===void 0?!1:(this.c.delete($),this.d.delete(a),!0)}forEach($,a){this.c.forEach((t,o)=>{$.call(a,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=k;class g{constructor(){this.c=new Map}add($,a){let t=this.c.get($);t||(t=new Set,this.c.set($,t)),t.add(a)}delete($,a){const t=this.c.get($);t&&(t.delete(a),t.size===0&&this.c.delete($))}forEach($,a){const t=this.c.get($);t&&t.forEach(a)}get($){const a=this.c.get($);return a||new Set}}e.$Gc=g;function l(f,$){if(f===$)return!0;if(f.size!==$.size)return!1;for(const[a,t]of f)if(!$.has(a)||$.get(a)!==t)return!1;for(const[a]of $)if(!f.has(a))return!1;return!0}e.$Hc=l}),define(ae[2],ce([0,1,22,136,31,84,71]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const P=!1;let d=null;class u{constructor(){this.b=new Map}static{this.a=0}c(j){let U=this.b.get(j);return U||(U={parent:null,source:null,isSingleton:!1,value:j,idx:u.a++},this.b.set(j,U)),U}trackDisposable(j){const U=this.c(j);U.source||(U.source=new Error().stack)}setParent(j,U){const F=this.c(j);F.parent=U}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,U){const F=U.get(j);if(F)return F;const H=j.parent?this.f(this.c(j.parent),U):j;return U.set(j,H),H}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,j).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(j=10,U){let F;if(U)F=U;else{const ue=new Map,Z=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,ue).isSingleton);if(Z.length===0)return;const X=new Set(Z.map(q=>q.value));if(F=Z.filter(q=>!(q.parent&&X.has(q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function H(ue){function Z(q,L){for(;q.length>0&&L.some(T=>typeof T=="string"?T===q[0]:q[0].match(T));)q.shift()}const X=ue.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return Z(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const J=new s.$Gc;for(const ue of F){const Z=H(ue);for(let X=0;X<=Z.length;X++)J.add(Z.slice(0,X).join(`
`),ue)}F.sort((0,S.$7b)(ue=>ue.idx,S.$9b));let le="",re=0;for(const ue of F.slice(0,j)){re++;const Z=H(ue),X=[];for(let q=0;q<Z.length;q++){let L=Z[q];L=`(shared with ${J.get(Z.slice(0,q+1).join(`
`)).size}/${F.length} leaks) at ${L}`;const G=J.get(Z.slice(0,q).join(`
`)),B=(0,O.$K)([...G].map(oe=>H(oe)[q]),oe=>oe);delete B[Z[q]];for(const[oe,he]of Object.entries(B))X.unshift(`    - stacktraces of ${he.length} other leaks continue with ${oe}`);X.unshift(L)}le+=`


==================== Leaking disposable ${re}/${F.length}: ${ue.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return F.length>j&&(le+=`


... and ${F.length-j} more leaking disposables

`),{leaks:F,details:le}}}e.$Ic=u;function b(C){d=C}if(e.$Jc=b,P){const C="__is_disposable_tracked__";b(new class{trackDisposable(j){const U=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[C]||console.log(U)},3e3)}setParent(j,U){if(j&&j!==t.None)try{j[C]=!0}catch{}}markAsDisposed(j){if(j&&j!==t.None)try{j[C]=!0}catch{}}markAsSingleton(j){}})}function v(C){return d?.trackDisposable(C),C}e.$Kc=v;function y(C){d?.markAsDisposed(C)}e.$Lc=y;function h(C,j){d?.setParent(C,j)}function m(C,j){if(d)for(const U of C)d.setParent(U,j)}function p(C){return d?.markAsSingleton(C),C}e.$Mc=p;function k(C){return typeof C.dispose=="function"&&C.dispose.length===0}e.$Nc=k;function g(C){if(D.Iterable.is(C)){const j=[];for(const U of C)if(U)try{U.dispose()}catch(F){j.push(F)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}e.$Oc=g;function l(C){for(const j of C)k(j)&&j.dispose();return[]}e.$Pc=l;function f(...C){const j=$(()=>g(C));return m(C,j),j}e.$Qc=f;function $(C){const j=v({dispose:(0,M.$db)(()=>{y(j),C()})});return j}e.$Rc=$;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return h(j,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),h(j,null))}}e.$Sc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,v(this),h(this.q,this)}dispose(){y(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}e.$Tc=t;class o{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&h(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&h(j,null),j}}e.$Uc=o;class r{constructor(j){this.a=new o,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=r;class i{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(j){let U=j;return this.unset=()=>U=void 0,this.isset=()=>U!==void 0,this.dispose=()=>{U&&(U(),U=void 0,y(this))},this}}e.$Xc=n;class c{constructor(){this.a=new Map}acquire(j,...U){let F=this.a.get(j);F||(F={counter:0,object:this.b(j,...U)},this.a.set(j,F));const{object:H}=F,J=(0,M.$db)(()=>{--F.counter===0&&(this.c(j,F.object),this.a.delete(j))});return F.counter++,{object:H,dispose:J}}}e.$Yc=c;class w{constructor(j){this.a=j}async acquire(j,...U){const F=this.a.acquire(j,...U);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(H){throw F.dispose(),H}}}e.$Zc=w;class A{constructor(j){this.object=j}dispose(){}}e.$1c=A;function I(C){const j=new a;try{C(j)}finally{j.dispose()}}e.$2c=I;class E{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,U,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(j)?.dispose(),this.a.set(j,U)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=E}),define(ae[85],ce([0,1,31]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=void 0;const O=new S.$Dc(1e4);function s(u){return d(u,"NFC",O)}e.$Il=s;const M=new S.$Dc(1e4);function D(u){return d(u,"NFD",M)}e.$Jl=D;const P=/[^\u0000-\u0080]/;function d(u,b,v){if(!u)return u;const y=v.get(u);if(y)return y;let h;return P.test(u)?h=u.normalize(b):h=u,v.set(u,h),h}e.$Kl=function(){const u=/[\u0300-\u036f]/g;return function(b){return D(b).replace(u,"")}}()}),define(ae[140],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function S(P,d,u){return Math.min(Math.max(P,d),u)}e.$9l=S;function O(P,d){return(d+P%d)%d}e.rot=O;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=s;class M{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=M;class D{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const u=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=D}),function(){function Y(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function D(d){M.push(d,Date.now())}function P(){const d=[];for(let u=0;u<M.length;u+=2)d.push({name:M[u],startTime:M[u+1]});return d}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(s+D.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=S(O))}(),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var O in S)(typeof exports=="object"?exports:Y)[O]=S[O]}}(typeof self<"u"?self:this,function(){return function(Y){var e={};function S(O){if(e[O])return e[O].exports;var s=e[O]={i:O,l:!1,exports:{}};return Y[O].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=Y,S.c=e,S.d=function(O,s,M){S.o(O,s)||Object.defineProperty(O,s,{enumerable:!0,get:M})},S.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},S.t=function(O,s){if(1&s&&(O=S(O)),8&s||4&s&&typeof O=="object"&&O&&O.__esModule)return O;var M=Object.create(null);if(S.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:O}),2&s&&typeof O!="string")for(var D in O)S.d(M,D,function(P){return O[P]}.bind(null,D));return M},S.n=function(O){var s=O&&O.__esModule?function(){return O.default}:function(){return O};return S.d(s,"a",s),s},S.o=function(O,s){return Object.prototype.hasOwnProperty.call(O,s)},S.p="",S(S.s=0)}([function(Y,e,S){(function(O){var s;e=Y.exports=he,s=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var te=Array.prototype.slice.call(arguments,0);te.unshift("SEMVER"),console.log.apply(console,te)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],d=e.src=[],u=0,b=u++;d[b]="0|[1-9]\\d*";var v=u++;d[v]="[0-9]+";var y=u++;d[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=u++;d[h]="("+d[b]+")\\.("+d[b]+")\\.("+d[b]+")";var m=u++;d[m]="("+d[v]+")\\.("+d[v]+")\\.("+d[v]+")";var p=u++;d[p]="(?:"+d[b]+"|"+d[y]+")";var k=u++;d[k]="(?:"+d[v]+"|"+d[y]+")";var g=u++;d[g]="(?:-("+d[p]+"(?:\\."+d[p]+")*))";var l=u++;d[l]="(?:-?("+d[k]+"(?:\\."+d[k]+")*))";var f=u++;d[f]="[0-9A-Za-z-]+";var $=u++;d[$]="(?:\\+("+d[f]+"(?:\\."+d[f]+")*))";var a=u++,t="v?"+d[h]+d[g]+"?"+d[$]+"?";d[a]="^"+t+"$";var o="[v=\\s]*"+d[m]+d[l]+"?"+d[$]+"?",r=u++;d[r]="^"+o+"$";var i=u++;d[i]="((?:<|>)?=?)";var n=u++;d[n]=d[v]+"|x|X|\\*";var c=u++;d[c]=d[b]+"|x|X|\\*";var w=u++;d[w]="[v=\\s]*("+d[c]+")(?:\\.("+d[c]+")(?:\\.("+d[c]+")(?:"+d[g]+")?"+d[$]+"?)?)?";var A=u++;d[A]="[v=\\s]*("+d[n]+")(?:\\.("+d[n]+")(?:\\.("+d[n]+")(?:"+d[l]+")?"+d[$]+"?)?)?";var I=u++;d[I]="^"+d[i]+"\\s*"+d[w]+"$";var E=u++;d[E]="^"+d[i]+"\\s*"+d[A]+"$";var C=u++;d[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=u++;d[j]="(?:~>?)";var U=u++;d[U]="(\\s*)"+d[j]+"\\s+",P[U]=new RegExp(d[U],"g");var F=u++;d[F]="^"+d[j]+d[w]+"$";var H=u++;d[H]="^"+d[j]+d[A]+"$";var J=u++;d[J]="(?:\\^)";var le=u++;d[le]="(\\s*)"+d[J]+"\\s+",P[le]=new RegExp(d[le],"g");var re=u++;d[re]="^"+d[J]+d[w]+"$";var ue=u++;d[ue]="^"+d[J]+d[A]+"$";var Z=u++;d[Z]="^"+d[i]+"\\s*("+o+")$|^$";var X=u++;d[X]="^"+d[i]+"\\s*("+t+")$|^$";var q=u++;d[q]="(\\s*)"+d[i]+"\\s*("+o+"|"+d[w]+")",P[q]=new RegExp(d[q],"g");var L=u++;d[L]="^\\s*("+d[w]+")\\s+-\\s+("+d[w]+")\\s*$";var T=u++;d[T]="^\\s*("+d[A]+")\\s+-\\s+("+d[A]+")\\s*$";var G=u++;d[G]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)s(B,d[B]),P[B]||(P[B]=new RegExp(d[B]));function oe(te,fe){if(te instanceof he)return te;if(typeof te!="string"||te.length>M||!(fe?P[r]:P[a]).test(te))return null;try{return new he(te,fe)}catch{return null}}function he(te,fe){if(te instanceof he){if(te.loose===fe)return te;te=te.version}else if(typeof te!="string")throw new TypeError("Invalid Version: "+te);if(te.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof he))return new he(te,fe);s("SemVer",te,fe),this.loose=fe;var $e=te.trim().match(fe?P[r]:P[a]);if(!$e)throw new TypeError("Invalid Version: "+te);if(this.raw=te,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Me=+Ie;if(Me>=0&&Me<D)return Me}return Ie}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=oe,e.valid=function(te,fe){var $e=oe(te,fe);return $e?$e.version:null},e.clean=function(te,fe){var $e=oe(te.trim().replace(/^[=v]+/,""),fe);return $e?$e.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(te){return s("SemVer.compare",this.version,this.loose,te),te instanceof he||(te=new he(te,this.loose)),this.compareMain(te)||this.comparePre(te)},he.prototype.compareMain=function(te){return te instanceof he||(te=new he(te,this.loose)),R(this.major,te.major)||R(this.minor,te.minor)||R(this.patch,te.patch)},he.prototype.comparePre=function(te){if(te instanceof he||(te=new he(te,this.loose)),this.prerelease.length&&!te.prerelease.length)return-1;if(!this.prerelease.length&&te.prerelease.length)return 1;if(!this.prerelease.length&&!te.prerelease.length)return 0;var fe=0;do{var $e=this.prerelease[fe],Ie=te.prerelease[fe];if(s("prerelease compare",fe,$e,Ie),$e===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if($e===void 0)return-1;if($e!==Ie)return R($e,Ie)}while(++fe)},he.prototype.inc=function(te,fe){switch(te){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+te)}return this.format(),this.raw=this.version,this},e.inc=function(te,fe,$e,Ie){typeof $e=="string"&&(Ie=$e,$e=void 0);try{return new he(te,$e).inc(fe,Ie).version}catch{return null}},e.diff=function(te,fe){if(Q(te,fe))return null;var $e=oe(te),Ie=oe(fe);if($e.prerelease.length||Ie.prerelease.length){for(var Me in $e)if((Me==="major"||Me==="minor"||Me==="patch")&&$e[Me]!==Ie[Me])return"pre"+Me;return"prerelease"}for(var Me in $e)if((Me==="major"||Me==="minor"||Me==="patch")&&$e[Me]!==Ie[Me])return Me},e.compareIdentifiers=R;var K=/^[0-9]+$/;function R(te,fe){var $e=K.test(te),Ie=K.test(fe);return $e&&Ie&&(te=+te,fe=+fe),$e&&!Ie?-1:Ie&&!$e?1:te<fe?-1:te>fe?1:0}function W(te,fe,$e){return new he(te,$e).compare(new he(fe,$e))}function x(te,fe,$e){return W(te,fe,$e)>0}function N(te,fe,$e){return W(te,fe,$e)<0}function Q(te,fe,$e){return W(te,fe,$e)===0}function V(te,fe,$e){return W(te,fe,$e)!==0}function _(te,fe,$e){return W(te,fe,$e)>=0}function z(te,fe,$e){return W(te,fe,$e)<=0}function ee(te,fe,$e,Ie){var Me;switch(fe){case"===":typeof te=="object"&&(te=te.version),typeof $e=="object"&&($e=$e.version),Me=te===$e;break;case"!==":typeof te=="object"&&(te=te.version),typeof $e=="object"&&($e=$e.version),Me=te!==$e;break;case"":case"=":case"==":Me=Q(te,$e,Ie);break;case"!=":Me=V(te,$e,Ie);break;case">":Me=x(te,$e,Ie);break;case">=":Me=_(te,$e,Ie);break;case"<":Me=N(te,$e,Ie);break;case"<=":Me=z(te,$e,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Me}function ne(te,fe){if(te instanceof ne){if(te.loose===fe)return te;te=te.value}if(!(this instanceof ne))return new ne(te,fe);s("comparator",te,fe),this.loose=fe,this.parse(te),this.semver===de?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(te,fe){return R(fe,te)},e.major=function(te,fe){return new he(te,fe).major},e.minor=function(te,fe){return new he(te,fe).minor},e.patch=function(te,fe){return new he(te,fe).patch},e.compare=W,e.compareLoose=function(te,fe){return W(te,fe,!0)},e.rcompare=function(te,fe,$e){return W(fe,te,$e)},e.sort=function(te,fe){return te.sort(function($e,Ie){return e.compare($e,Ie,fe)})},e.rsort=function(te,fe){return te.sort(function($e,Ie){return e.rcompare($e,Ie,fe)})},e.gt=x,e.lt=N,e.eq=Q,e.neq=V,e.gte=_,e.lte=z,e.cmp=ee,e.Comparator=ne;var de={};function me(te,fe){if(te instanceof me)return te.loose===fe?te:new me(te.raw,fe);if(te instanceof ne)return new me(te.value,fe);if(!(this instanceof me))return new me(te,fe);if(this.loose=fe,this.raw=te,this.set=te.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+te);this.format()}function Ee(te){return!te||te.toLowerCase()==="x"||te==="*"}function Pe(te,fe,$e,Ie,Me,Te,je,Je,Be,Ve,He,ie,ge){return((fe=Ee($e)?"":Ee(Ie)?">="+$e+".0.0":Ee(Me)?">="+$e+"."+Ie+".0":">="+fe)+" "+(Je=Ee(Be)?"":Ee(Ve)?"<"+(+Be+1)+".0.0":Ee(He)?"<"+Be+"."+(+Ve+1)+".0":ie?"<="+Be+"."+Ve+"."+He+"-"+ie:"<="+Je)).trim()}function Le(te,fe){for(var $e=0;$e<te.length;$e++)if(!te[$e].test(fe))return!1;if(fe.prerelease.length){for($e=0;$e<te.length;$e++)if(s(te[$e].semver),te[$e].semver!==de&&te[$e].semver.prerelease.length>0){var Ie=te[$e].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function ke(te,fe,$e){try{fe=new me(fe,$e)}catch{return!1}return fe.test(te)}function pe(te,fe,$e,Ie){var Me,Te,je,Je,Be;switch(te=new he(te,Ie),fe=new me(fe,Ie),$e){case">":Me=x,Te=z,je=N,Je=">",Be=">=";break;case"<":Me=N,Te=_,je=x,Je="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(te,fe,Ie))return!1;for(var Ve=0;Ve<fe.set.length;++Ve){var He=fe.set[Ve],ie=null,ge=null;if(He.forEach(function(be){be.semver===de&&(be=new ne(">=0.0.0")),ie=ie||be,ge=ge||be,Me(be.semver,ie.semver,Ie)?ie=be:je(be.semver,ge.semver,Ie)&&(ge=be)}),ie.operator===Je||ie.operator===Be||(!ge.operator||ge.operator===Je)&&Te(te,ge.semver)||ge.operator===Be&&je(te,ge.semver))return!1}return!0}ne.prototype.parse=function(te){var fe=this.loose?P[Z]:P[X],$e=te.match(fe);if(!$e)throw new TypeError("Invalid comparator: "+te);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new he($e[2],this.loose):this.semver=de},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(te){return s("Comparator.test",te,this.loose),this.semver===de||(typeof te=="string"&&(te=new he(te,this.loose)),ee(te,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(te,fe){if(!(te instanceof ne))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new me(te.value,fe),ke(this.value,$e,fe);if(te.operator==="")return $e=new me(this.value,fe),ke(te.semver,$e,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||te.operator!==">="&&te.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||te.operator!=="<="&&te.operator!=="<"),Te=this.semver.version===te.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||te.operator!==">="&&te.operator!=="<="),Je=ee(this.semver,"<",te.semver,fe)&&(this.operator===">="||this.operator===">")&&(te.operator==="<="||te.operator==="<"),Be=ee(this.semver,">",te.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(te.operator===">="||te.operator===">");return Ie||Me||Te&&je||Je||Be},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(te){return te.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(te){var fe=this.loose;te=te.trim(),s("range",te,fe);var $e=fe?P[T]:P[L];te=te.replace($e,Pe),s("hyphen replace",te),te=te.replace(P[q],"$1$2$3"),s("comparator trim",te,P[q]),te=(te=(te=te.replace(P[U],"$1~")).replace(P[le],"$1^")).split(/\s+/).join(" ");var Ie=fe?P[Z]:P[X],Me=te.split(" ").map(function(Te){return function(je,Je){return s("comp",je),je=function(Be,Ve){return Be.trim().split(/\s+/).map(function(He){return function(ie,ge){s("caret",ie,ge);var be=ge?P[ue]:P[re];return ie.replace(be,function(Se,ye,Oe,Ue,qe){var Ye;return s("caret",ie,Se,ye,Oe,Ue,qe),Ee(ye)?Ye="":Ee(Oe)?Ye=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ee(Ue)?Ye=ye==="0"?">="+ye+"."+Oe+".0 <"+ye+"."+(+Oe+1)+".0":">="+ye+"."+Oe+".0 <"+(+ye+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ye=ye==="0"?Oe==="0"?">="+ye+"."+Oe+"."+Ue+qe+" <"+ye+"."+Oe+"."+(+Ue+1):">="+ye+"."+Oe+"."+Ue+qe+" <"+ye+"."+(+Oe+1)+".0":">="+ye+"."+Oe+"."+Ue+qe+" <"+(+ye+1)+".0.0"):(s("no pr"),Ye=ye==="0"?Oe==="0"?">="+ye+"."+Oe+"."+Ue+" <"+ye+"."+Oe+"."+(+Ue+1):">="+ye+"."+Oe+"."+Ue+" <"+ye+"."+(+Oe+1)+".0":">="+ye+"."+Oe+"."+Ue+" <"+(+ye+1)+".0.0"),s("caret return",Ye),Ye})}(He,Ve)}).join(" ")}(je,Je),s("caret",je),je=function(Be,Ve){return Be.trim().split(/\s+/).map(function(He){return function(ie,ge){var be=ge?P[H]:P[F];return ie.replace(be,function(Se,ye,Oe,Ue,qe){var Ye;return s("tilde",ie,Se,ye,Oe,Ue,qe),Ee(ye)?Ye="":Ee(Oe)?Ye=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ee(Ue)?Ye=">="+ye+"."+Oe+".0 <"+ye+"."+(+Oe+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ye=">="+ye+"."+Oe+"."+Ue+qe+" <"+ye+"."+(+Oe+1)+".0"):Ye=">="+ye+"."+Oe+"."+Ue+" <"+ye+"."+(+Oe+1)+".0",s("tilde return",Ye),Ye})}(He,Ve)}).join(" ")}(je,Je),s("tildes",je),je=function(Be,Ve){return s("replaceXRanges",Be,Ve),Be.split(/\s+/).map(function(He){return function(ie,ge){ie=ie.trim();var be=ge?P[E]:P[I];return ie.replace(be,function(Se,ye,Oe,Ue,qe,Ye){s("xRange",ie,Se,ye,Oe,Ue,qe,Ye);var xe=Ee(Oe),Xe=xe||Ee(Ue),Qe=Xe||Ee(qe);return ye==="="&&Qe&&(ye=""),xe?Se=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Qe?(Xe&&(Ue=0),Qe&&(qe=0),ye===">"?(ye=">=",Xe?(Oe=+Oe+1,Ue=0,qe=0):Qe&&(Ue=+Ue+1,qe=0)):ye==="<="&&(ye="<",Xe?Oe=+Oe+1:Ue=+Ue+1),Se=ye+Oe+"."+Ue+"."+qe):Xe?Se=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":Qe&&(Se=">="+Oe+"."+Ue+".0 <"+Oe+"."+(+Ue+1)+".0"),s("xRange return",Se),Se})}(He,Ve)}).join(" ")}(je,Je),s("xrange",je),je=function(Be,Ve){return s("replaceStars",Be,Ve),Be.trim().replace(P[G],"")}(je,Je),s("stars",je),je}(Te,fe)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(Te){return!!Te.match(Ie)})),Me=Me.map(function(Te){return new ne(Te,fe)})},me.prototype.intersects=function(te,fe){if(!(te instanceof me))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Ie){return te.set.some(function(Me){return Me.every(function(Te){return Ie.intersects(Te,fe)})})})})},e.toComparators=function(te,fe){return new me(te,fe).set.map(function($e){return $e.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},me.prototype.test=function(te){if(!te)return!1;typeof te=="string"&&(te=new he(te,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Le(this.set[fe],te))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(te,fe,$e){var Ie=null,Me=null;try{var Te=new me(fe,$e)}catch{return null}return te.forEach(function(je){Te.test(je)&&(Ie&&Me.compare(je)!==-1||(Me=new he(Ie=je,$e)))}),Ie},e.minSatisfying=function(te,fe,$e){var Ie=null,Me=null;try{var Te=new me(fe,$e)}catch{return null}return te.forEach(function(je){Te.test(je)&&(Ie&&Me.compare(je)!==1||(Me=new he(Ie=je,$e)))}),Ie},e.validRange=function(te,fe){try{return new me(te,fe).range||"*"}catch{return null}},e.ltr=function(te,fe,$e){return pe(te,fe,"<",$e)},e.gtr=function(te,fe,$e){return pe(te,fe,">",$e)},e.outside=pe,e.prerelease=function(te,fe){var $e=oe(te,fe);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(te,fe,$e){return te=new me(te,$e),fe=new me(fe,$e),te.intersects(fe)},e.coerce=function(te){if(te instanceof he)return te;if(typeof te!="string")return null;var fe=te.match(P[C]);return fe==null?null:oe((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,S(1))},function(Y,e){var S,O,s=Y.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(k){if(S===setTimeout)return setTimeout(k,0);if((S===M||!S)&&setTimeout)return S=setTimeout,setTimeout(k,0);try{return S(k,0)}catch{try{return S.call(null,k,0)}catch{return S.call(this,k,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:M}catch{S=M}try{O=typeof clearTimeout=="function"?clearTimeout:D}catch{O=D}})();var d,u=[],b=!1,v=-1;function y(){b&&d&&(b=!1,d.length?u=d.concat(u):v=-1,u.length&&h())}function h(){if(!b){var k=P(y);b=!0;for(var g=u.length;g;){for(d=u,u=[];++v<g;)d&&d[v].run();v=-1,g=u.length}d=null,b=!1,function(l){if(O===clearTimeout)return clearTimeout(l);if((O===D||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(l);try{O(l)}catch{try{return O.call(null,l)}catch{return O.call(this,l)}}}(k)}}function m(k,g){this.fun=k,this.array=g}function p(){}s.nextTick=function(k){var g=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)g[l-1]=arguments[l];u.push(new m(k,g)),u.length!==1||b||P(h)},m.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=p,s.addListener=p,s.once=p,s.off=p,s.removeListener=p,s.removeAllListeners=p,s.emit=p,s.prependListener=p,s.prependOnceListener=p,s.listeners=function(k){return[]},s.binding=function(k){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(k){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ae[141],ce([0,1]),function(Y,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;class O{constructor(P,d,u){this.level=P,this.key=d,this.value=u,this.forward=[]}}const s=void 0;class M{constructor(P,d=2**16){this.comparator=P,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new O(this.c,s,s)}get size(){return this.f}clear(){this.e=new O(this.c,s,s),this.f=0}has(P){return!!M.g(this,P,this.comparator)}get(P){return M.g(this,P,this.comparator)?.value}set(P,d){return M.h(this,P,d,this.comparator)&&(this.f+=1),this}delete(P){const d=M.k(this,P,this.comparator);return d&&(this.f-=1),d}forEach(P,d){let u=this.e.forward[0];for(;u;)P.call(d,u.value,u.key,this),u=u.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",d=this.e.forward[0];for(;d;)P+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return P}static g(P,d,u){let b=P.e;for(let v=P.d-1;v>=0;v--)for(;b.forward[v]&&u(b.forward[v].key,d)<0;)b=b.forward[v];if(b=b.forward[0],b&&u(b.key,d)===0)return b}static h(P,d,u,b){const v=[];let y=P.e;for(let h=P.d-1;h>=0;h--){for(;y.forward[h]&&b(y.forward[h].key,d)<0;)y=y.forward[h];v[h]=y}if(y=y.forward[0],y&&b(y.key,d)===0)return y.value=u,!1;{const h=M.j(P);if(h>P.d){for(let m=P.d;m<h;m++)v[m]=P.e;P.d=h}y=new O(h,d,u);for(let m=0;m<h;m++)y.forward[m]=v[m].forward[m],v[m].forward[m]=y;return!0}}static j(P,d=.5){let u=1;for(;Math.random()<d&&u<P.c;)u+=1;return u}static k(P,d,u){const b=[];let v=P.e;for(let y=P.d-1;y>=0;y--){for(;v.forward[y]&&u(v.forward[y].key,d)<0;)v=v.forward[y];b[y]=v}if(v=v.forward[0],!v||u(v.key,d)!==0)return!1;for(let y=0;y<P.d&&b[y].forward[y]===v;y++)b[y].forward[y]=v.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$3r=M}),define(ae[72],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(M){return new O(M)}constructor(M){this.c=S&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Sd=O}),define(ae[3],ce([0,1,14,84,2,103,72]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.Event=void 0;const P=!1,d=!1;var u;(function(I){I.None=()=>s.$Tc.None;function E(z){if(d){const{onDidAddListener:ee}=z,ne=m.create();let de=0;z.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ne.print()),ee?.()}}}function C(z,ee){return X(z,()=>{},0,void 0,!0,void 0,ee)}I.defer=C;function j(z){return(ee,ne=null,de)=>{let me=!1,Ee;return Ee=z(Pe=>{if(!me)return Ee?Ee.dispose():me=!0,ee.call(ne,Pe)},null,de),me&&Ee.dispose(),Ee}}I.once=j;function U(z,ee,ne){return ue((de,me=null,Ee)=>z(Pe=>de.call(me,ee(Pe)),null,Ee),ne)}I.map=U;function F(z,ee,ne){return ue((de,me=null,Ee)=>z(Pe=>{ee(Pe),de.call(me,Pe)},null,Ee),ne)}I.forEach=F;function H(z,ee,ne){return ue((de,me=null,Ee)=>z(Pe=>ee(Pe)&&de.call(me,Pe),null,Ee),ne)}I.filter=H;function J(z){return z}I.signal=J;function le(...z){return(ee,ne=null,de)=>{const me=(0,s.$Qc)(...z.map(Ee=>Ee(Pe=>ee.call(ne,Pe))));return Z(me,de)}}I.any=le;function re(z,ee,ne,de){let me=ne;return U(z,Ee=>(me=ee(me,Ee),me),de)}I.reduce=re;function ue(z,ee){let ne;const de={onWillAddFirstListener(){ne=z(me.fire,me)},onDidRemoveLastListener(){ne?.dispose()}};ee||E(de);const me=new f(de);return ee?.add(me),me.event}function Z(z,ee){return ee instanceof Array?ee.push(z):ee&&ee.add(z),z}function X(z,ee,ne=100,de=!1,me=!1,Ee,Pe){let Le,ke,pe,te=0,fe;const $e={leakWarningThreshold:Ee,onWillAddFirstListener(){Le=z(Me=>{te++,ke=ee(ke,Me),de&&!pe&&(Ie.fire(ke),ke=void 0),fe=()=>{const Te=ke;ke=void 0,pe=void 0,(!de||te>1)&&Ie.fire(Te),te=0},typeof ne=="number"?(clearTimeout(pe),pe=setTimeout(fe,ne)):pe===void 0&&(pe=0,queueMicrotask(fe))})},onWillRemoveListener(){me&&te>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,Le.dispose()}};Pe||E($e);const Ie=new f($e);return Pe?.add(Ie),Ie.event}I.debounce=X;function q(z,ee=0,ne){return I.debounce(z,(de,me)=>de?(de.push(me),de):[me],ee,void 0,!0,void 0,ne)}I.accumulate=q;function L(z,ee=(de,me)=>de===me,ne){let de=!0,me;return H(z,Ee=>{const Pe=de||!ee(Ee,me);return de=!1,me=Ee,Pe},ne)}I.latch=L;function T(z,ee,ne){return[I.filter(z,ee,ne),I.filter(z,de=>!ee(de),ne)]}I.split=T;function G(z,ee=!1,ne=[],de){let me=ne.slice(),Ee=z(ke=>{me?me.push(ke):Le.fire(ke)});de&&de.add(Ee);const Pe=()=>{me?.forEach(ke=>Le.fire(ke)),me=null},Le=new f({onWillAddFirstListener(){Ee||(Ee=z(ke=>Le.fire(ke)),de&&de.add(Ee))},onDidAddFirstListener(){me&&(ee?setTimeout(Pe):Pe())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return de&&de.add(Le),Le.event}I.buffer=G;function B(z,ee){return(de,me,Ee)=>{const Pe=ee(new he);return z(function(Le){const ke=Pe.evaluate(Le);ke!==oe&&de.call(me,ke)},void 0,Ee)}}I.chain=B;const oe=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(ne=>(ee(ne),ne)),this}filter(ee){return this.f.push(ne=>ee(ne)?ne:oe),this}reduce(ee,ne){let de=ne;return this.f.push(me=>(de=ee(de,me),de)),this}latch(ee=(ne,de)=>ne===de){let ne=!0,de;return this.f.push(me=>{const Ee=ne||!ee(me,de);return ne=!1,de=me,Ee?me:oe}),this}evaluate(ee){for(const ne of this.f)if(ee=ne(ee),ee===oe)break;return ee}}function K(z,ee,ne=de=>de){const de=(...Le)=>Pe.fire(ne(...Le)),me=()=>z.on(ee,de),Ee=()=>z.removeListener(ee,de),Pe=new f({onWillAddFirstListener:me,onDidRemoveLastListener:Ee});return Pe.event}I.fromNodeEventEmitter=K;function R(z,ee,ne=de=>de){const de=(...Le)=>Pe.fire(ne(...Le)),me=()=>z.addEventListener(ee,de),Ee=()=>z.removeEventListener(ee,de),Pe=new f({onWillAddFirstListener:me,onDidRemoveLastListener:Ee});return Pe.event}I.fromDOMEventEmitter=R;function W(z){return new Promise(ee=>j(z)(ee))}I.toPromise=W;function x(z){const ee=new f;return z.then(ne=>{ee.fire(ne)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}I.fromPromise=x;function N(z,ee,ne){return ee(ne),z(de=>ee(de))}I.runAndSubscribe=N;class Q{constructor(ee,ne){this._observable=ee,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};ne||E(de),this.emitter=new f(de),ne&&ne.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,ne){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function V(z,ee){return new Q(z,ee).emitter.event}I.fromObservable=V;function _(z){return(ee,ne,de)=>{let me=0,Ee=!1;const Pe={beginUpdate(){me++},endUpdate(){me--,me===0&&(z.reportChanges(),Ee&&(Ee=!1,ee.call(ne)))},handlePossibleChange(){},handleChange(){Ee=!0}};z.addObserver(Pe),z.reportChanges();const Le={dispose(){z.removeObserver(Pe)}};return de instanceof s.$Sc?de.add(Le):Array.isArray(de)&&de.push(Le),Le}}I.fromObservableLight=_})(u||(e.Event=u={}));class b{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${b.f++}`,b.all.add(this)}start(E){this.g=new D.$Sd,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$Ud=b;let v=-1;function y(I){const E=v;return v=I,{dispose(){v=E}}}e.$Vd=y;class h{constructor(E,C=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=C,this.g=0}dispose(){this.f?.clear()}check(E,C){const j=this.threshold;if(j<=0||C<j)return;this.f||(this.f=new Map);const U=this.f.get(E.value)||0;if(this.f.set(E.value,U+1),this.g-=1,this.g<=0){this.g=j*.5;let F,H=0;for(const[J,le]of this.f)(!F||H<le)&&(F=J,H=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${H}):`),console.warn(F)}return()=>{const F=this.f.get(E.value)||0;this.f.set(E.value,F-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class k{constructor(E){this.value=E,this.id=p++}}const g=2,l=(I,E)=>{if(I instanceof k)E(I);else for(let C=0;C<I.length;C++){const j=I[C];j&&E(j)}};class f{constructor(E){this.w=0,this.f=E,this.g=v>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const E=this.t;queueMicrotask(()=>{l(E,C=>C.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,C,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Tc.None;if(this.m)return s.$Tc.None;C&&(E=E.bind(C));const U=new k(E);let F,H;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(U.stack=m.create(),F=this.g.check(U.stack,this.w+1)),P&&(U.stack=H??m.create()),this.t?this.t instanceof k?(this.u??=new a,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.w++;const J=(0,s.$Rc)(()=>{F?.(),this.x(U)});return j instanceof s.$Sc?j.add(J):Array.isArray(j)&&j.push(J),J},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const C=this.t,j=C.indexOf(E);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,C[j]=void 0;const U=this.u.current===this;if(this.w*g<=C.length){let F=0;for(let H=0;H<C.length;H++)C[H]?C[F++]=C[H]:U&&(this.u.end--,F<this.u.i&&this.u.i--);C.length=F}}y(E,C){if(!E)return;const j=this.f?.onListenerError||S.$1;if(!j){E.value(C);return}try{E.value(C)}catch(U){j(U)}}z(E){const C=E.current.t;for(;E.i<E.end;)this.y(C[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof k)this.y(this.t,E);else{const C=this.u;C.enqueue(this,E,this.t.length),this.z(C)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Wd=f;const $=()=>new a;e.$Xd=$;class a{constructor(){this.i=-1,this.end=0}enqueue(E,C,j){this.i=0,this.end=j,this.current=E,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends f{async fireAsync(E,C,j){if(this.t)for(this.h||(this.h=new M.$4c),l(this.t,U=>this.h.push([U.value,E]));this.h.size>0&&!C.isCancellationRequested;){const[U,F]=this.h.shift(),H=[],J={...F,token:C,waitUntil:le=>{if(Object.isFrozen(H))throw new Error("waitUntil can NOT be called asynchronous");j&&(le=j(le,U)),H.push(le)}};try{U(J)}catch(le){(0,S.$1)(le);continue}Object.freeze(H),await Promise.allSettled(H).then(le=>{for(const re of le)re.status==="rejected"&&(0,S.$1)(re.reason)})}}}e.$Yd=t;class o extends f{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new M.$4c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$Zd=o;class r extends o{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$1d=r;class i extends f{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}e.$2d=i;class n{constructor(){this.g=!1,this.h=[],this.f=new f({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const C={event:E,listener:null};this.h.push(C),this.g&&this.m(C);const j=()=>{this.g&&this.o(C);const U=this.h.indexOf(C);this.h.splice(U,1)};return(0,s.$Rc)((0,O.$db)(j))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(C=>this.f.fire(C))}o(E){E.listener?.dispose(),E.listener=null}dispose(){this.f.dispose();for(const E of this.h)E.listener?.dispose();this.h=[]}}e.$3d=n;class c{constructor(E,C,j,U){this.f=new s.$Sc;const F=this.f.add(new n),H=this.f.add(new s.$3c);function J(le){H.set(le,F.add(U(le)))}for(const le of E)J(le);this.f.add(C(le=>{J(le)})),this.f.add(j(le=>{H.deleteAndDispose(le)})),this.event=F.event}dispose(){this.f.dispose()}}e.$4d=c;class w{constructor(){this.f=[]}wrapEvent(E){return(C,j,U)=>E(F=>{const H=this.f[this.f.length-1];H?H.push(()=>C.call(j,F)):C.call(j,F)},void 0,U)}bufferEvents(E){const C=[];this.f.push(C);const j=E();return this.f.pop(),C.forEach(U=>U()),j}}e.$5d=w;class A{constructor(){this.f=!1,this.g=u.None,this.h=s.$Tc.None,this.j=new f({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$6d=A}),define(ae[23],ce([0,1,3]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.CancellationToken=void 0;const O=Object.freeze(function(P,d){const u=setTimeout(P.bind(d),0);return{dispose(){clearTimeout(u)}}});var s;(function(P){function d(u){return u===P.None||u===P.Cancelled||u instanceof M?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}P.isCancellationToken=d,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new S.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(d){this.f=void 0,this.g=void 0,this.g=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(d=!1){d&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$7d=D}),define(ae[142],ce([0,1,23]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=e.$Ge=e.$Fe=void 0;class O{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new S.$7d,d=this.b(P.token);return this.a={promise:d,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$Fe=O;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const d=JSON.stringify(P);return this.b!==d&&(this.b=d,this.a=this.c(P)),this.a}}e.$Ge=s;class M{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const d=this.b(P);return this.a.set(P,d),d}}e.$He=M}),define(ae[63],ce([0,1,14,2]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function s($){const a=$;return a?typeof a.read=="function":!1}e.$8d=s;function M($){const a=$;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$9d=M;function D($){const a=$;return a?M(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$0d=D;function P($,a){return new d($,a)}e.$$d=P;class d{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,S.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let o;switch(a){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u($,a){const t=[];let o;for(;(o=$.read())!==null;)t.push(o);return a(t)}e.$_d=u;function b($,a,t){const o=[];let r;for(;(r=$.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return $.read()}}}e.$ae=b;function v($,a){return new Promise((t,o)=>{const r=[];y($,{onData:i=>{a&&r.push(i)},onError:i=>{a?o(i):t(void 0)},onEnd:()=>{t(a?a(r):void 0)}})})}e.$be=v;function y($,a,t){$.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),$.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),$.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}e.$ce=y;function h($,a){return new Promise((t,o)=>{const r=new O.$Sc,i=[],n=A=>{if(i.push(A),i.length>a)return r.dispose(),$.pause(),t({stream:$,buffer:i,ended:!1})},c=A=>(r.dispose(),o(A)),w=()=>(r.dispose(),t({stream:$,buffer:i,ended:!0}));r.add((0,O.$Rc)(()=>$.removeListener("error",c))),$.on("error",c),r.add((0,O.$Rc)(()=>$.removeListener("end",w))),$.on("end",w),r.add((0,O.$Rc)(()=>$.removeListener("data",n))),$.on("data",n)})}e.$de=h;function m($,a){const t=P(a);return t.end($),t}e.$ee=m;function p(){const $=P(()=>{throw new Error("not supported")});return $.end(),$}e.$fe=p;function k($){let a=!1;return{read:()=>a?null:(a=!0,$)}}e.$ge=k;function g($,a,t){const o=P(t);return y($,{onData:r=>o.write(a.data(r)),onError:r=>o.error(a.error?a.error(r):r),onEnd:()=>o.end()}),o}e.$he=g;function l($,a,t){let o=!1;return{read:()=>{const r=a.read();return o?r:(o=!0,r!==null?t([$,r]):$)}}}e.$ie=l;function f($,a,t){let o=!1;const r=P(t);return y(a,{onData:i=>o?r.write(i):(o=!0,r.write(t([$,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write($)),r.end()}}),r}e.$je=f}),define(ae[17],ce([0,1,62,63]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const s=typeof Buffer<"u",M=new S.$V(()=>new Uint8Array(256));let D,P;class d{static alloc(C){return s?new d(Buffer.allocUnsafe(C)):new d(new Uint8Array(C))}static wrap(C){return s&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new d(C)}static fromString(C,j){return!(j?.dontUseNodeBuffer||!1)&&s?new d(Buffer.from(C)):(D||(D=new TextEncoder),new d(D.encode(C)))}static fromByteArray(C){const j=d.alloc(C.length);for(let U=0,F=C.length;U<F;U++)j.buffer[U]=C[U];return j}static concat(C,j){if(typeof j>"u"){j=0;for(let H=0,J=C.length;H<J;H++)j+=C[H].byteLength}const U=d.alloc(j);let F=0;for(let H=0,J=C.length;H<J;H++){const le=C[H];U.set(le,F),F+=le.byteLength}return U}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=d.alloc(this.byteLength);return C.set(this),C}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(C,j){return new d(this.buffer.subarray(C,j))}set(C,j){if(C instanceof d)this.buffer.set(C.buffer,j);else if(C instanceof Uint8Array)this.buffer.set(C,j);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),j);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return y(this.buffer,C)}writeUInt32BE(C,j){h(this.buffer,C,j)}readUInt32LE(C){return m(this.buffer,C)}writeUInt32LE(C,j){p(this.buffer,C,j)}readUInt8(C){return k(this.buffer,C)}writeUInt8(C,j){g(this.buffer,C,j)}indexOf(C,j=0){return u(this.buffer,C instanceof d?C.buffer:C,j)}}e.$ke=d;function u(E,C,j=0){const U=C.byteLength,F=E.byteLength;if(U===0)return 0;if(U===1)return E.indexOf(C[0]);if(U>F-j)return-1;const H=M.value;H.fill(C.length);for(let ue=0;ue<C.length;ue++)H[C[ue]]=C.length-ue-1;let J=j+C.length-1,le=J,re=-1;for(;J<F;)if(E[J]===C[le]){if(le===0){re=J;break}J--,le--}else J+=Math.max(C.length-le,H[E[J]]),le=C.length-1;return re}e.$le=u;function b(E,C){return E[C+0]<<0>>>0|E[C+1]<<8>>>0}e.$me=b;function v(E,C,j){E[j+0]=C&255,C=C>>>8,E[j+1]=C&255}e.$ne=v;function y(E,C){return E[C]*2**24+E[C+1]*2**16+E[C+2]*2**8+E[C+3]}e.$oe=y;function h(E,C,j){E[j+3]=C,C=C>>>8,E[j+2]=C,C=C>>>8,E[j+1]=C,C=C>>>8,E[j]=C}e.$pe=h;function m(E,C){return E[C+0]<<0>>>0|E[C+1]<<8>>>0|E[C+2]<<16>>>0|E[C+3]<<24>>>0}e.$qe=m;function p(E,C,j){E[j+0]=C&255,C=C>>>8,E[j+1]=C&255,C=C>>>8,E[j+2]=C&255,C=C>>>8,E[j+3]=C&255}e.$re=p;function k(E,C){return E[C]}e.$se=k;function g(E,C,j){E[j]=C}e.$te=g;function l(E){return O.$_d(E,C=>d.concat(C))}e.$ue=l;function f(E){return O.$ge(E)}e.$ve=f;function $(E){return O.$be(E,C=>d.concat(C))}e.$we=$;async function a(E){return E.ended?d.concat(E.buffer):d.concat([...E.buffer,await $(E.stream)])}e.$xe=a;function t(E){return O.$ee(E,C=>d.concat(C))}e.$ye=t;function o(E){return O.$he(E,{data:C=>typeof C=="string"?d.fromString(C):d.wrap(C)},C=>d.concat(C))}e.$ze=o;function r(E){return O.$$d(C=>d.concat(C),E)}e.$Ae=r;function i(E,C){return O.$ie(E,C,j=>d.concat(j))}e.$Be=i;function n(E,C){return O.$je(E,C,j=>d.concat(j))}e.$Ce=n;function c(E){let C=0,j=0,U=0;const F=new Uint8Array(Math.floor(E.length/4*3)),H=le=>{switch(j){case 3:F[U++]=C|le,j=0;break;case 2:F[U++]=C|le>>>2,C=le<<6,j=3;break;case 1:F[U++]=C|le>>>4,C=le<<4,j=2;break;default:C=le<<2,j=1}};for(let le=0;le<E.length;le++){const re=E.charCodeAt(le);if(re>=65&&re<=90)H(re-65);else if(re>=97&&re<=122)H(re-97+26);else if(re>=48&&re<=57)H(re-48+52);else if(re===43||re===45)H(62);else if(re===47||re===95)H(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${E[le]}`)}}const J=U;for(;j>0;)H(0);return d.wrap(F).slice(0,J)}e.$De=c;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:E},C=!0,j=!1){const U=j?A:w;let F="";const H=E.byteLength%3;let J=0;for(;J<E.byteLength-H;J+=3){const le=E[J+0],re=E[J+1],ue=E[J+2];F+=U[le>>>2],F+=U[(le<<4|re>>>4)&63],F+=U[(re<<2|ue>>>6)&63],F+=U[ue&63]}if(H===1){const le=E[J+0];F+=U[le>>>2],F+=U[le<<4&63],C&&(F+="==")}else if(H===2){const le=E[J+0],re=E[J+1];F+=U[le>>>2],F+=U[(le<<4|re>>>4)&63],F+=U[re<<2&63],C&&(F+="=")}return F}e.$Ee=I}),define(ae[25],ce([0,1,142,62]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$If=e.$Hf=e.$Gf=e.$Ff=e.GraphemeBreakType=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=void 0;function s(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$Ke=s;const M=/{(\d+)}/g;function D(ie,...ge){return ge.length===0?ie:ie.replace(M,function(be,Se){const ye=parseInt(Se,10);return isNaN(ye)||ye<0||ye>=ge.length?be:ge[ye]})}e.$Le=D;const P=/{([^}]+)}/g;function d(ie,ge){return Object.keys(ge).length===0?ie:ie.replace(P,(be,Se)=>ge[Se]??be)}e.$Me=d;function u(ie){return ie.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}e.$Ne=u;function b(ie){return ie.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.$Oe=b;function v(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Pe=v;function y(ie,ge){let be=0;const Se=ge.charCodeAt(0);for(let ye=ie.length-1;ye>=0;ye--)ie.charCodeAt(ye)===Se&&be++;return be}e.$Qe=y;function h(ie,ge,be="\u2026"){return ie.length<=ge?ie:`${ie.substr(0,ge)}${be}`}e.$Re=h;function m(ie,ge,be="\u2026"){if(ie.length<=ge)return ie;const Se=Math.ceil(ge/2)-be.length/2,ye=Math.floor(ge/2)-be.length/2;return`${ie.substr(0,Se)}${be}${ie.substr(ie.length-ye)}`}e.$Se=m;function p(ie,ge=" "){const be=k(ie,ge);return g(be,ge)}e.$Te=p;function k(ie,ge){if(!ie||!ge)return ie;const be=ge.length;if(be===0||ie.length===0)return ie;let Se=0;for(;ie.indexOf(ge,Se)===Se;)Se=Se+be;return ie.substring(Se)}e.$Ue=k;function g(ie,ge){if(!ie||!ge)return ie;const be=ge.length,Se=ie.length;if(be===0||Se===0)return ie;let ye=Se,Oe=-1;for(;Oe=ie.lastIndexOf(ge,ye-1),!(Oe===-1||Oe+be!==ye);){if(Oe===0)return"";ye=Oe}return ie.substring(0,ye)}e.$Ve=g;function l(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$We=l;function f(ie){return ie.replace(/\*/g,"")}e.$Xe=f;function $(ie,ge,be={}){if(!ie)throw new Error("Cannot create regex from empty string");ge||(ie=v(ie)),be.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let Se="";return be.global&&(Se+="g"),be.matchCase||(Se+="i"),be.multiline&&(Se+="m"),be.unicode&&(Se+="u"),new RegExp(ie,Se)}e.$Ye=$;function a(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$Ze=a;function t(ie){return ie.split(/\r\n|\r|\n/)}e.$1e=t;function o(ie){for(let ge=0,be=ie.length;ge<be;ge++){const Se=ie.charCodeAt(ge);if(Se!==32&&Se!==9)return ge}return-1}e.$2e=o;function r(ie,ge=0,be=ie.length){for(let Se=ge;Se<be;Se++){const ye=ie.charCodeAt(Se);if(ye!==32&&ye!==9)return ie.substring(ge,Se)}return ie.substring(ge,be)}e.$3e=r;function i(ie,ge=ie.length-1){for(let be=ge;be>=0;be--){const Se=ie.charCodeAt(be);if(Se!==32&&Se!==9)return be}return-1}e.$4e=i;function n(ie,ge,be){const Se=[];let ye=0;for(const Oe of ie.matchAll(ge)){if(Se.push(ie.slice(ye,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");ye=Oe.index+Oe[0].length,Se.push(be(Oe[0],...Oe.slice(1),Oe.index,ie,Oe.groups))}return Se.push(ie.slice(ye)),Promise.all(Se).then(Oe=>Oe.join(""))}e.$5e=n;function c(ie,ge){return ie<ge?-1:ie>ge?1:0}e.$6e=c;function w(ie,ge,be=0,Se=ie.length,ye=0,Oe=ge.length){for(;be<Se&&ye<Oe;be++,ye++){const Ye=ie.charCodeAt(be),xe=ge.charCodeAt(ye);if(Ye<xe)return-1;if(Ye>xe)return 1}const Ue=Se-be,qe=Oe-ye;return Ue<qe?-1:Ue>qe?1:0}e.$7e=w;function A(ie,ge){return I(ie,ge,0,ie.length,0,ge.length)}e.$8e=A;function I(ie,ge,be=0,Se=ie.length,ye=0,Oe=ge.length){for(;be<Se&&ye<Oe;be++,ye++){let Ye=ie.charCodeAt(be),xe=ge.charCodeAt(ye);if(Ye===xe)continue;if(Ye>=128||xe>=128)return w(ie.toLowerCase(),ge.toLowerCase(),be,Se,ye,Oe);C(Ye)&&(Ye-=32),C(xe)&&(xe-=32);const Xe=Ye-xe;if(Xe!==0)return Xe}const Ue=Se-be,qe=Oe-ye;return Ue<qe?-1:Ue>qe?1:0}e.$9e=I;function E(ie){return ie>=48&&ie<=57}e.$0e=E;function C(ie){return ie>=97&&ie<=122}e.$$e=C;function j(ie){return ie>=65&&ie<=90}e.$_e=j;function U(ie,ge){return ie.length===ge.length&&I(ie,ge)===0}e.$af=U;function F(ie,ge){const be=ge.length;return ge.length>ie.length?!1:I(ie,ge,0,be)===0}e.$bf=F;function H(ie,ge){const be=Math.min(ie.length,ge.length);let Se;for(Se=0;Se<be;Se++)if(ie.charCodeAt(Se)!==ge.charCodeAt(Se))return Se;return be}e.$cf=H;function J(ie,ge){const be=Math.min(ie.length,ge.length);let Se;const ye=ie.length-1,Oe=ge.length-1;for(Se=0;Se<be;Se++)if(ie.charCodeAt(ye-Se)!==ge.charCodeAt(Oe-Se))return Se;return be}e.$df=J;function le(ie){return 55296<=ie&&ie<=56319}e.$ef=le;function re(ie){return 56320<=ie&&ie<=57343}e.$ff=re;function ue(ie,ge){return(ie-55296<<10)+(ge-56320)+65536}e.$gf=ue;function Z(ie,ge,be){const Se=ie.charCodeAt(be);if(le(Se)&&be+1<ge){const ye=ie.charCodeAt(be+1);if(re(ye))return ue(Se,ye)}return Se}e.$hf=Z;function X(ie,ge){const be=ie.charCodeAt(ge-1);if(re(be)&&ge>1){const Se=ie.charCodeAt(ge-2);if(le(Se))return ue(Se,be)}return be}class q{get offset(){return this.e}constructor(ge,be=0){this.c=ge,this.d=ge.length,this.e=be}setOffset(ge){this.e=ge}prevCodePoint(){const ge=X(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=Z(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$if=q;class L{get offset(){return this.c.offset}constructor(ge,be=0){this.c=new q(ge,be)}nextGraphemeLength(){const ge=Ie.getInstance(),be=this.c,Se=be.offset;let ye=ge.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Oe=be.offset,Ue=ge.getGraphemeBreakType(be.nextCodePoint());if(fe(ye,Ue)){be.setOffset(Oe);break}ye=Ue}return be.offset-Se}prevGraphemeLength(){const ge=Ie.getInstance(),be=this.c,Se=be.offset;let ye=ge.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Oe=be.offset,Ue=ge.getGraphemeBreakType(be.prevCodePoint());if(fe(Ue,ye)){be.setOffset(Oe);break}ye=Ue}return Se-be.offset}eol(){return this.c.eol()}}e.$jf=L;function T(ie,ge){return new L(ie,ge).nextGraphemeLength()}e.$kf=T;function G(ie,ge){return new L(ie,ge).prevGraphemeLength()}e.$lf=G;function B(ie,ge){ge>0&&re(ie.charCodeAt(ge))&&ge--;const be=ge+T(ie,ge);return[be-G(ie,be),be]}e.$mf=B;function oe(ie){const ge=new L(ie);let be=0;for(;!ge.eol();)be++,ge.nextGraphemeLength();return be}e.$nf=oe;let he;function K(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function R(ie){return he||(he=K()),he.test(ie)}e.$of=R;const W=/^[\t\n\r\x20-\x7E]*$/;function x(ie){return W.test(ie)}e.$pf=x,e.$qf=/[\u2028\u2029]/;function N(ie){return e.$qf.test(ie)}e.$rf=N;function Q(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$sf=Q;function V(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$tf=V;function _(ie,ge,be=""){const Se=ie.trimStart();if(Se.length<ge)return Se;const ye=/\b/g;let Oe=0;for(;ye.test(Se)&&!(Se.length-ye.lastIndex<ge);)Oe=ye.lastIndex,ye.lastIndex+=1;return Oe===0?Se:be+Se.substring(Oe).trimStart()}e.$uf=_;const z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ee=/\x1b\].*?\x07/g;function ne(ie){return ie&&(ie=ie.replace(z,"").replace(ee,"")),ie}e.$vf=ne,e.$wf="\uFEFF";function de(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$xf=de;function me(ie){return de(ie)?ie.substr(1):ie}e.$yf=me;function Ee(ie,ge){if(!ie||!ge||ie.length<ge.length)return!1;const be=ge.length,Se=ie.toLowerCase();let ye=0,Oe=-1;for(;ye<be;){const Ue=Se.indexOf(ge[ye],Oe+1);if(Ue<0)return!1;Oe=Ue,ye++}return!0}e.$zf=Ee;function Pe(ie,ge=!1){return ie?(ge&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$Af=Pe;function Le(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$Bf=Le;function ke(ie,ge=1){if(ge===0)return"";let be=-1;do be=ie.indexOf(`
`,be+1),ge--;while(ge>0&&be>=0);return be===-1?ie:(ie[be-1]==="\r"&&be--,ie.substr(0,be))}e.$Cf=ke;function pe(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$Df=pe;function te(ie){return Ie.getInstance().getGraphemeBreakType(ie)}e.$Ef=te;function fe(ie,ge){return ie===0?ge!==5&&ge!==7:ie===2&&ge===3?!1:ie===4||ie===2||ie===3||ge===4||ge===2||ge===3?!0:!(ie===8&&(ge===8||ge===9||ge===11||ge===12)||(ie===11||ie===9)&&(ge===9||ge===10)||(ie===12||ie===10)&&ge===10||ge===5||ge===13||ge===7||ie===1||ie===13&&ge===14||ie===6&&ge===6)}var $e;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class Ie{static{this.c=null}static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Me()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const be=this.d,Se=be.length/3;let ye=1;for(;ye<=Se;)if(ge<be[3*ye])ye=2*ye;else if(ge>be[3*ye+1])ye=2*ye+1;else return be[3*ye+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(ie,ge){if(ie===0)return 0;const be=je(ie,ge);if(be!==void 0)return be;const Se=new q(ge,ie);return Se.prevCodePoint(),Se.offset}e.$Ff=Te;function je(ie,ge){const be=new q(ge,ie);let Se=be.prevCodePoint();for(;Je(Se)||Se===65039||Se===8419;){if(be.offset===0)return;Se=be.prevCodePoint()}if(!V(Se))return;let ye=be.offset;return ye>0&&be.prevCodePoint()===8205&&(ye=be.offset),ye}function Je(ie){return 127995<=ie&&ie<=127999}var Be;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.$Gf="\xA0";class Ve{static{this.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$Ge(ge=>{function be(Xe){const Qe=new Map;for(let nt=0;nt<Xe.length;nt+=2)Qe.set(Xe[nt],Xe[nt+1]);return Qe}function Se(Xe,Qe){const nt=new Map(Xe);for(const[st,ot]of Qe)nt.set(st,ot);return nt}function ye(Xe,Qe){if(!Xe)return Qe;const nt=new Map;for(const[st,ot]of Xe)Qe.has(st)&&nt.set(st,ot);return nt}const Oe=this.c.value;let Ue=ge.filter(Xe=>!Xe.startsWith("_")&&Xe in Oe);Ue.length===0&&(Ue=["_default"]);let qe;for(const Xe of Ue){const Qe=be(Oe[Xe]);qe=ye(qe,Qe)}const Ye=be(Oe._common),xe=Se(Ye,qe);return new Ve(xe)})}static getInstance(ge){return Ve.d.get(Array.from(ge))}static{this.e=new O.$V(()=>Object.keys(Ve.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ve.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Hf=Ve;class He{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(He.c())),this.d}static isInvisibleCharacter(ge){return He.e().has(ge)}static get codePoints(){return He.e()}}e.$If=He}),define(ae[45],ce([0,1,25]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;function O(g){return s(g,0)}e.$Vi=O;function s(g,l){switch(typeof g){case"object":return g===null?M(349,l):Array.isArray(g)?d(g,l):u(g,l);case"string":return P(g,l);case"boolean":return D(g,l);case"number":return M(g,l);case"undefined":return M(937,l);default:return M(617,l)}}e.$Wi=s;function M(g,l){return(l<<5)-l+g|0}e.$Xi=M;function D(g,l){return M(g?433:863,l)}function P(g,l){l=M(149417,l);for(let f=0,$=g.length;f<$;f++)l=M(g.charCodeAt(f),l);return l}e.$Yi=P;function d(g,l){return l=M(104579,l),g.reduce((f,$)=>s($,f),l)}function u(g,l){return l=M(181387,l),Object.keys(g).sort().reduce((f,$)=>(f=P($,f),s(g[$],f)),l)}class b{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=s(l,this.g),this.g}}e.$Zi=b;var v;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function y(g,l,f=32){const $=f-l,a=~((1<<$)-1);return(g<<l|(a&g)>>>$)>>>0}function h(g,l=0,f=g.byteLength,$=0){for(let a=0;a<f;a++)g[l+a]=$}function m(g,l,f="0"){for(;g.length<l;)g=f+g;return g}function p(g,l=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(f=>f.toString(16).padStart(2,"0")).join(""):m((g>>>0).toString(16),l/4)}e.$1i=p;class k{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const f=l.length;if(f===0)return;const $=this.p;let a=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=l.charCodeAt(0),r=0);;){let i=o;if(S.$ef(o))if(r+1<f){const n=l.charCodeAt(r+1);S.$ff(n)?(r++,i=S.$gf(o,n)):i=65533}else{t=o;break}else S.$ff(o)&&(i=65533);if(a=this.w($,a,i),r++,r<f)o=l.charCodeAt(r);else break}this.r=a,this.u=t}w(l,f,$){return $<128?l[f++]=$:$<2048?(l[f++]=192|($&1984)>>>6,l[f++]=128|($&63)>>>0):$<65536?(l[f++]=224|($&61440)>>>12,l[f++]=128|($&4032)>>>6,l[f++]=128|($&63)>>>0):(l[f++]=240|($&1835008)>>>18,l[f++]=128|($&258048)>>>12,l[f++]=128|($&4032)>>>6,l[f++]=128|($&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,l[0]=l[64],l[1]=l[65],l[2]=l[66]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=k.g,f=this.q;for(let w=0;w<64;w+=4)l.setUint32(w,f.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)l.setUint32(w,y(l.getUint32(w-12,!1)^l.getUint32(w-32,!1)^l.getUint32(w-56,!1)^l.getUint32(w-64,!1),1),!1);let $=this.h,a=this.l,t=this.m,o=this.n,r=this.o,i,n,c;for(let w=0;w<80;w++)w<20?(i=a&t|~a&o,n=1518500249):w<40?(i=a^t^o,n=1859775393):w<60?(i=a&t|a&o|t&o,n=2400959708):(i=a^t^o,n=3395469782),c=y($,5)+i+r+n+l.getUint32(w*4,!1)&4294967295,r=o,o=t,t=y(a,30),a=$,$=c;this.h=this.h+$&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$2i=k}),define(ae[73],ce([0,1,25]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(O||(O={})),function(s){const M="error",D="warning",P="warn",d="info",u="ignore";function b(y){return y?S.$af(M,y)?s.Error:S.$af(D,y)||S.$af(P,y)?s.Warning:S.$af(d,y)?s.Info:s.Ignore:s.Ignore}s.fromValue=b;function v(y){switch(y){case s.Error:return M;case s.Warning:return D;case s.Info:return d;default:return u}}s.toString=v}(O||(O={})),e.default=O}),define(ae[143],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(ae[59],ce([0,1,22,25]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0;class s{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const m=h.charCodeAt(0),p=this.b.charCodeAt(this.c);return m-p}value(){return this.b[this.c]}}e.$0h=s;class M{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,O.$7e)(h,this.b,0,h.length,this.c,this.d):(0,O.$9e)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$$h=M;class D{constructor(h=!0,m=!0){this.f=h,this.g=m}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let m=h.length-1;m>=0;m--,this.c--){const p=this.b.charCodeAt(m);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,O.$7e)(h,this.b,0,h.length,this.d,this.e):(0,O.$9e)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$_h=D;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class d{constructor(h,m){this.f=h,this.g=m,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,O.$8e)(h,this.c.scheme);if(this.d[this.e]===2)return(0,O.$8e)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,O.$6e)(h,this.c.query);if(this.d[this.e]===5)return(0,O.$6e)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ai=d;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(b||(b={}));class v{static forUris(h=()=>!1,m=()=>!1){return new v(new d(h,m))}static forPaths(h=!1){return new v(new D(void 0,!h))}static forStrings(){return new v(new s)}static forConfigKeys(){return new v(new M)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,m){if(m){const p=m.slice(0);(0,S.$Xb)(p);for(const k of p)this.set(k,h)}else{const p=h.slice(0);(0,S.$Xb)(p);for(const k of p)this.set(k[0],k[1])}}set(h,m){const p=this.b.reset(h);let k;this.c||(this.c=new u,this.c.segment=p.value());const g=[];for(k=this.c;;){const f=p.cmp(k.segment);if(f>0)k.left||(k.left=new u,k.left.segment=p.value()),g.push([-1,k]),k=k.left;else if(f<0)k.right||(k.right=new u,k.right.segment=p.value()),g.push([1,k]),k=k.right;else if(p.hasNext())p.next(),k.mid||(k.mid=new u,k.mid.segment=p.value()),g.push([0,k]),k=k.mid;else break}const l=k.value;k.value=m,k.key=h;for(let f=g.length-1;f>=0;f--){const $=g[f][1];$.updateHeight();const a=$.balanceFactor();if(a<-1||a>1){const t=g[f][0],o=g[f+1][0];if(t===1&&o===1)g[f][1]=$.rotateLeft();else if(t===-1&&o===-1)g[f][1]=$.rotateRight();else if(t===1&&o===-1)$.right=g[f+1][1]=g[f+1][1].rotateRight(),g[f][1]=$.rotateLeft();else if(t===-1&&o===1)$.left=g[f+1][1]=g[f+1][1].rotateLeft(),g[f][1]=$.rotateRight();else throw new Error;if(f>0)switch(g[f-1][0]){case-1:g[f-1][1].left=g[f][1];break;case 1:g[f-1][1].right=g[f][1];break;case 0:g[f-1][1].mid=g[f][1];break}else this.c=g[0][1]}}return l}get(h){return this.d(h)?.value}d(h){const m=this.b.reset(h);let p=this.c;for(;p;){const k=m.cmp(p.segment);if(k>0)p=p.left;else if(k<0)p=p.right;else if(m.hasNext())m.next(),p=p.mid;else break}return p}has(h){const m=this.d(h);return!(m?.value===void 0&&m?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,m){const p=this.b.reset(h),k=[];let g=this.c;for(;g;){const l=p.cmp(g.segment);if(l>0)k.push([-1,g]),g=g.left;else if(l<0)k.push([1,g]),g=g.right;else if(p.hasNext())p.next(),k.push([0,g]),g=g.mid;else break}if(g){if(m?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const l=this.f(g.right);if(l.key){const{key:f,value:$,segment:a}=l;this.e(l.key,!1),g.key=f,g.value=$,g.segment=a}}else{const l=g.left??g.right;if(k.length>0){const[f,$]=k[k.length-1];switch(f){case-1:$.left=l;break;case 0:$.mid=l;break;case 1:$.right=l;break}}else this.c=l}for(let l=k.length-1;l>=0;l--){const f=k[l][1];f.updateHeight();const $=f.balanceFactor();if($>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),k[l][1]=f.rotateLeft()):$<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),k[l][1]=f.rotateRight()),l>0)switch(k[l-1][0]){case-1:k[l-1][1].left=k[l][1];break;case 1:k[l-1][1].right=k[l][1];break;case 0:k[l-1][1].mid=k[l][1];break}else this.c=k[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const m=this.b.reset(h);let p=this.c,k;for(;p;){const g=m.cmp(p.segment);if(g>0)p=p.left;else if(g<0)p=p.right;else if(m.hasNext())m.next(),k=p.value||k,p=p.mid;else break}return p&&p.value||k}findSuperstr(h){return this.g(h,!1)}g(h,m){const p=this.b.reset(h);let k=this.c;for(;k;){const g=p.cmp(k.segment);if(g>0)k=k.left;else if(g<0)k=k.right;else if(p.hasNext())p.next(),k=k.mid;else return k.mid?this.h(k.mid):m?k.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[m,p]of this)h(p,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const m=[];return this.j(h,m),m[Symbol.iterator]()}j(h,m){h&&(h.left&&this.j(h.left,m),h.value&&m.push([h.key,h.value]),h.mid&&this.j(h.mid,m),h.right&&this.j(h.right,m))}_isBalanced(){const h=m=>{if(!m)return!0;const p=m.balanceFactor();return p<-1||p>1?!1:h(m.left)&&h(m.right)};return h(this.c)}}e.$bi=v}),define(ae[12],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=void 0;function S(a){return typeof a=="string"}e.$Jf=S;function O(a){return Array.isArray(a)&&a.every(t=>S(t))}e.$Kf=O;function s(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Lf=s;function M(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Mf=M;function D(a){return typeof a=="number"&&!isNaN(a)}e.$Nf=D;function P(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Of=P;function d(a){return a===!0||a===!1}e.$Pf=d;function u(a){return typeof a>"u"}e.$Qf=u;function b(a){return!v(a)}e.$Rf=b;function v(a){return u(a)||a===null}e.$Sf=v;function y(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Tf=y;function h(a){if(v(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Uf=h;function m(...a){const t=[];for(let o=0;o<a.length;o++){const r=a[o];if(v(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}e.$Vf=m;const p=Object.prototype.hasOwnProperty;function k(a){if(!s(a))return!1;for(const t in a)if(p.call(a,t))return!1;return!0}e.$Wf=k;function g(a){return typeof a=="function"}e.$Xf=g;function l(...a){return a.length>0&&a.every(g)}e.$Yf=l;function f(a,t){const o=Math.min(a.length,t.length);for(let r=0;r<o;r++)$(a[r],t[r])}e.$Zf=f;function $(a,t){if(S(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(g(t)){try{if(a instanceof t)return}catch{}if(!v(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$1f=$}),define(ae[74],ce([0,1,12]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=e.$_j=void 0;const O=Object.create(null);function s(P,d){if((0,S.$Jf)(d)){const u=O[d];if(u===void 0)throw new Error(`${P} references an unknown codicon: ${d}`);d=u}return O[P]=d,{id:P}}function M(){return O}e.$_j=M;function D(){return Object.values(e.$bk)}e.$ak=D,e.$bk={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugBreakpointPending:s("debug-breakpoint-pending",60377),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),diffSingle:s("diff-single",60450),diffMultiple:s("diff-multiple",60451),surroundWith:s("surround-with",60452),gitStash:s("git-stash",60454),gitStashApply:s("git-stash-apply",60455),gitStashPop:s("git-stash-pop",60456),coverage:s("coverage",60462),runAllCoverage:s("run-all-coverage",60461),runCoverage:s("run-all-coverage",60460),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ae[35],ce([0,1,12]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=void 0;function O(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const l=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([f,$])=>{l[f]=$&&typeof $=="object"?O($):$}),l}e.$yn=O;function s(g){if(!g||typeof g!="object")return g;const l=[g];for(;l.length>0;){const f=l.shift();Object.freeze(f);for(const $ in f)if(M.call(f,$)){const a=f[$];typeof a=="object"&&!Object.isFrozen(a)&&!(0,S.$Mf)(a)&&l.push(a)}}return g}e.$zn=s;const M=Object.prototype.hasOwnProperty;function D(g,l){return P(g,l,new Set)}e.$An=D;function P(g,l,f){if((0,S.$Sf)(g))return g;const $=l(g);if(typeof $<"u")return $;if(Array.isArray(g)){const a=[];for(const t of g)a.push(P(t,l,f));return a}if((0,S.$Lf)(g)){if(f.has(g))throw new Error("Cannot clone recursive data-structure");f.add(g);const a={};for(const t in g)M.call(g,t)&&(a[t]=P(g[t],l,f));return f.delete(g),a}return g}function d(g,l,f=!0){return(0,S.$Lf)(g)?((0,S.$Lf)(l)&&Object.keys(l).forEach($=>{$ in g?f&&((0,S.$Lf)(g[$])&&(0,S.$Lf)(l[$])?d(g[$],l[$],f):g[$]=l[$]):g[$]=l[$]}),g):l}e.$Bn=d;function u(g,l){if(g===l)return!0;if(g==null||l===null||l===void 0||typeof g!=typeof l||typeof g!="object"||Array.isArray(g)!==Array.isArray(l))return!1;let f,$;if(Array.isArray(g)){if(g.length!==l.length)return!1;for(f=0;f<g.length;f++)if(!u(g[f],l[f]))return!1}else{const a=[];for($ in g)a.push($);a.sort();const t=[];for($ in l)t.push($);if(t.sort(),!u(a,t))return!1;for(f=0;f<a.length;f++)if(!u(g[a[f]],l[a[f]]))return!1}return!0}e.$Cn=u;function b(g){const l=new Set;return JSON.stringify(g,(f,$)=>{if((0,S.$Lf)($)||Array.isArray($)){if(l.has($))return"[Circular]";l.add($)}return $})}e.$Dn=b;function v(g,l){const f=Object.create(null);return!g||!l||Object.keys(l).forEach(a=>{const t=g[a],o=l[a];u(t,o)||(f[a]=o)}),f}e.$En=v;function y(g,l){const f=l.toLowerCase(),$=Object.keys(g).find(a=>a.toLowerCase()===f);return $?g[$]:g[l]}e.$Fn=y;function h(g,l){const f=Object.create(null);for(const[$,a]of Object.entries(g))l($,a)&&(f[$]=a);return f}e.$Gn=h;function m(g){let l=[];for(;Object.prototype!==g;)l=l.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return l}e.$Hn=m;function p(g){const l=[];for(const f of m(g))typeof g[f]=="function"&&l.push(f);return l}e.$In=p;function k(g,l){const f=a=>function(){const t=Array.prototype.slice.call(arguments,0);return l(a,t)},$={};for(const a of g)$[a]=f(a);return $}e.$Jn=k}),define(ae[104],ce([0,1,74]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ck=e.ThemeColor=void 0;var O;(function(D){function P(d){return d&&typeof d=="object"&&typeof d.id=="string"}D.isThemeColor=P})(O||(e.ThemeColor=O={}));function s(D){return{id:D}}e.$ck=s;var M;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function d(l){const f=P.exec(l.id);if(!f)return d(S.$bk.error);const[,$,a]=f,t=["codicon","codicon-"+$];return a&&t.push("codicon-modifier-"+a.substring(1)),t}D.asClassNameArray=d;function u(l){return d(l).join(" ")}D.asClassName=u;function b(l){return"."+d(l).join(".")}D.asCSSSelector=b;function v(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||O.isThemeColor(l.color))}D.isThemeIcon=v;const y=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function h(l){const f=y.exec(l);if(!f)return;const[,$]=f;return{id:$}}D.fromString=h;function m(l){return{id:l}}D.fromId=m;function p(l,f){let $=l.id;const a=$.lastIndexOf("~");return a!==-1&&($=$.substring(0,a)),f&&($=`${$}~${f}`),{id:$}}D.modify=p;function k(l){const f=l.id.lastIndexOf("~");if(f!==-1)return l.id.substring(f+1)}D.getModifier=k;function g(l,f){return l.id===f.id&&l.color?.id===f.color?.id}D.isEqual=g})(M||(e.ThemeIcon=M={}))}),define(ae[32],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(s){return S.test(s)}e.$qg=O,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let d=0;d<P.length;d++)P[d]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let d=0,u="";return u+=D[M[d++]],u+=D[M[d++]],u+=D[M[d++]],u+=D[M[d++]],u+="-",u+=D[M[d++]],u+=D[M[d++]],u+="-",u+=D[M[d++]],u+=D[M[d++]],u+="-",u+=D[M[d++]],u+=D[M[d++]],u+="-",u+=D[M[d++]],u+=D[M[d++]],u+=D[M[d++]],u+=D[M[d++]],u+=D[M[d++]],u+=D[M[d++]],u}}()}),define(ae[144],ce([0,1,86,46,84]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QU=void 0;async function M(D,P){if(await new Promise((b,v)=>{const y=O.createReadStream(D),h=S.createHash("sha256");y.pipe(h);const m=(0,s.$db)((p,k)=>{y.removeAllListeners(),h.removeAllListeners(),p?v(p):b(k)});y.once("error",m),y.once("end",m),h.once("error",m),h.once("data",p=>m(void 0,p.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$QU=M}),define(ae[145],ce([0,1,26]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const P=D.replace(/\-/g,":").toLowerCase();return!O.has(P)}function M(){const D=(0,S.networkInterfaces)();for(const P in D){const d=D[P];if(d){for(const{mac:u}of d)if(s(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$_m=M}),define(ae[105],ce([0,1,87]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vg=e.$ug=e.$tg=void 0;function O(P,d,u,b=1){let v=!1;return new Promise(y=>{const h=setTimeout(()=>{if(!v)return v=!0,y(0)},u);s(P,d,b,m=>{if(!v)return v=!0,clearTimeout(h),y(m)})})}e.$tg=O;function s(P,d,u,b){if(d===0)return b(0);const v=new S.Socket;v.once("connect",()=>(D(v),s(P+u,d-1,u,b))),v.once("data",()=>{}),v.once("error",y=>(D(v),y.code!=="ECONNREFUSED"?s(P+u,d-1,u,b):b(P))),v.connect(P,"127.0.0.1")}e.$ug={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(P,d,u,b="127.0.0.1"){let v=!1,y,h=1;const m=S.createServer({pauseOnConnect:!0});function p(k,g){v||(v=!0,m.removeAllListeners(),m.close(),y&&clearTimeout(y),g(k))}return new Promise(k=>{y=setTimeout(()=>{p(0,k)},u),m.on("listening",()=>{p(P,k)}),m.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&h<d?(P++,h++,m.listen(P,b)):p(0,k)}),m.on("close",()=>{p(0,k)}),m.listen(P,b)})}e.$vg=M;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(d){console.error(d)}}}),function(){function Y(){function e(){return process.uncHostAllowlist}function S(d){const u=new Set;if(Array.isArray(d))for(const b of d)typeof b=="string"&&u.add(b);return Array.from(u)}function O(){const d=e();return d?Array.from(d):[]}function s(d){if(process.platform!=="win32")return;const u=e();if(u)if(typeof d=="string")u.add(d.toLowerCase());else for(const b of S(d))s(b)}function M(d){if(typeof d!="string")return;const u=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let b;for(const v of u){if(d.indexOf(v)!==0)continue;const h=d.indexOf("\\",v.length);if(h===-1)continue;const m=d.substring(v.length,h);if(m){b=m;break}}return b}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:O,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Y()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Y():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ae[146],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UU=e.$TU=void 0,e.$TU="vscode:contextmenu",e.$UU="vscode:onCloseContextMenu"}),define(ae[147],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2U=void 0;class S{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$2U=S}),define(ae[148],ce([11,10]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(ae[149],ce([0,1,148]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0;const O=60,s=O*60,M=s*24,D=M*7,P=M*30,d=M*365;function u(y,h,m,p){typeof y!="number"&&(y=y.getTime());const k=Math.round((new Date().getTime()-y)/1e3);if(k<-30)return(0,S.localize)(0,null,u(new Date().getTime()+k*1e3,!1));if(!p&&k<30)return(0,S.localize)(1,null);let g;return k<O?(g=k,h?g===1?m?(0,S.localize)(2,null,g):(0,S.localize)(3,null,g):m?(0,S.localize)(4,null,g):(0,S.localize)(5,null,g):g===1?m?(0,S.localize)(6,null,g):(0,S.localize)(7,null,g):m?(0,S.localize)(8,null,g):(0,S.localize)(9,null,g)):k<s?(g=Math.floor(k/O),h?g===1?m?(0,S.localize)(10,null,g):(0,S.localize)(11,null,g):m?(0,S.localize)(12,null,g):(0,S.localize)(13,null,g):g===1?m?(0,S.localize)(14,null,g):(0,S.localize)(15,null,g):m?(0,S.localize)(16,null,g):(0,S.localize)(17,null,g)):k<M?(g=Math.floor(k/s),h?g===1?m?(0,S.localize)(18,null,g):(0,S.localize)(19,null,g):m?(0,S.localize)(20,null,g):(0,S.localize)(21,null,g):g===1?m?(0,S.localize)(22,null,g):(0,S.localize)(23,null,g):m?(0,S.localize)(24,null,g):(0,S.localize)(25,null,g)):k<D?(g=Math.floor(k/M),h?g===1?(0,S.localize)(26,null,g):(0,S.localize)(27,null,g):g===1?(0,S.localize)(28,null,g):(0,S.localize)(29,null,g)):k<P?(g=Math.floor(k/D),h?g===1?m?(0,S.localize)(30,null,g):(0,S.localize)(31,null,g):m?(0,S.localize)(32,null,g):(0,S.localize)(33,null,g):g===1?m?(0,S.localize)(34,null,g):(0,S.localize)(35,null,g):m?(0,S.localize)(36,null,g):(0,S.localize)(37,null,g)):k<d?(g=Math.floor(k/P),h?g===1?m?(0,S.localize)(38,null,g):(0,S.localize)(39,null,g):m?(0,S.localize)(40,null,g):(0,S.localize)(41,null,g):g===1?m?(0,S.localize)(42,null,g):(0,S.localize)(43,null,g):m?(0,S.localize)(44,null,g):(0,S.localize)(45,null,g)):(g=Math.floor(k/d),h?g===1?m?(0,S.localize)(46,null,g):(0,S.localize)(47,null,g):m?(0,S.localize)(48,null,g):(0,S.localize)(49,null,g):g===1?m?(0,S.localize)(50,null,g):(0,S.localize)(51,null,g):m?(0,S.localize)(52,null,g):(0,S.localize)(53,null,g))}e.$xm=u;function b(y,h){const m=Math.abs(y/1e3);return m<1?h?(0,S.localize)(54,null,y):(0,S.localize)(55,null,y):m<O?h?(0,S.localize)(56,null,Math.round(y)/1e3):(0,S.localize)(57,null,Math.round(y)/1e3):m<s?h?(0,S.localize)(58,null,Math.round(y/(1e3*O))):(0,S.localize)(59,null,Math.round(y/(1e3*O))):m<M?h?(0,S.localize)(60,null,Math.round(y/(1e3*s))):(0,S.localize)(61,null,Math.round(y/(1e3*s))):(0,S.localize)(62,null,Math.round(y/(1e3*M)))}e.$ym=b;function v(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$zm=v}),define(ae[150],ce([11,10]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ae[51],ce([0,1,22,12,150]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=void 0;function M(v,y){return y&&(v.stack||v.stacktrace)?s.localize(0,null,P(v),D(v.stack)||D(v.stacktrace)):P(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?s.localize(1,null,v.message):v.message||s.localize(2,null)}function d(v=null,y=!1){if(!v)return s.localize(3,null);if(Array.isArray(v)){const h=S.$Hb(v),m=d(h[0],y);return h.length>1?s.localize(4,null,m,h.length):m}if(O.$Jf(v))return v;if(v.detail){const h=v.detail;if(h.error)return M(h.error,y);if(h.exception)return M(h.exception,y)}return v.stack?M(v,y):v.message?v.message:s.localize(5,null)}e.$Si=d;function u(v){const y=v;return y instanceof Error&&Array.isArray(y.actions)}e.$Ti=u;function b(v,y){let h;return typeof v=="string"?h=new Error(v):h=v,h.actions=y,h}e.$Ui=b}),define(ae[151],ce([11,10]),function(Y,e){return Y.create("vs/base/common/jsonErrorMessages",e)}),define(ae[152],ce([0,1,151]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;function O(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$Zp=O}),define(ae[153],ce([11,10]),function(Y,e){return Y.create("vs/base/common/platform",e)}),define(ae[4],ce([0,1,153]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let O=!1,s=!1,M=!1,D=!1,P=!1,d=!1,u=!1,b=!1,v=!1,y=!1,h,m=e.$g,p=e.$g,k,g;const l=globalThis;let f;typeof l.vscode<"u"&&typeof l.vscode.process<"u"?f=l.vscode.process:typeof process<"u"&&(f=process);const $=typeof f?.versions?.electron=="string",a=$&&f?.type==="renderer";if(typeof f=="object"){O=f.platform==="win32",s=f.platform==="darwin",M=f.platform==="linux",D=M&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,u=$,v=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$g,m=e.$g;const E=f.env.VSCODE_NLS_CONFIG;if(E)try{const C=JSON.parse(E),j=C.availableLanguages["*"];h=C.locale,p=C.osLocale,m=j||e.$g,k=C._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!a?(g=navigator.userAgent,O=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,b=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=g.indexOf("Linux")>=0,y=g?.indexOf("Mobi")>=0,d=!0,h=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$g,m=h,p=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;s?r=1:O?r=3:M&&(r=2),e.$i=O,e.$j=s,e.$k=M,e.$l=D,e.$m=P,e.$n=u,e.$o=d,e.$p=d&&typeof l.importScripts=="function",e.$q=e.$p?l.origin:void 0,e.$r=b,e.$s=y,e.$t=v,e.$u=r,e.$v=g,e.$w=m;var i;(function(E){function C(){return e.$w}E.value=C;function j(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=j;function U(){return e.$w==="en"}E.isDefault=U})(i||(e.Language=i={})),e.$x=h,e.$y=p,e.$z=k,e.$A=typeof l.postMessage=="function"&&!l.importScripts,e.$B=(()=>{if(e.$A){const E=[];l.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let U=0,F=E.length;U<F;U++){const H=E[U];if(H.id===j.data.vscodeScheduleAsyncWork){E.splice(U,1),H.callback();return}}});let C=0;return j=>{const U=++C;E.push({id:U,callback:j}),l.postMessage({vscodeScheduleAsyncWork:U},"*")}}return E=>setTimeout(E)})();var n;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||b?2:O?1:3;let c=!0,w=!1;function A(){if(!w){w=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,c=new Uint16Array(E.buffer)[0]===513}return c}e.$D=A,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(E){return parseFloat(E)>=20}e.$J=I}),define(ae[36],ce([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let O;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const M=s.process;O={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return S.$i?"win32":S.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$dc=O.platform,e.$ec=O.arch}),define(ae[9],ce([0,1,36]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const O=65,s=97,M=90,D=122,P=46,d=47,u=92,b=58,v=63;class y extends Error{constructor(o,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const c=o.indexOf(".")!==-1?"property":"argument";let w=`The "${o}" ${c} ${n} of type ${r}`;w+=`. Received type ${typeof i}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,o){if(t===null||typeof t!="object")throw new y(o,"Object",t)}function m(t,o){if(typeof t!="string")throw new y(o,"string",t)}const p=S.$dc==="win32";function k(t){return t===d||t===u}function g(t){return t===d}function l(t){return t>=O&&t<=M||t>=s&&t<=D}function f(t,o,r,i){let n="",c=0,w=-1,A=0,I=0;for(let E=0;E<=t.length;++E){if(E<t.length)I=t.charCodeAt(E);else{if(i(I))break;I=d}if(i(I)){if(!(w===E-1||A===1))if(A===2){if(n.length<2||c!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const C=n.lastIndexOf(r);C===-1?(n="",c=0):(n=n.slice(0,C),c=n.length-1-n.lastIndexOf(r)),w=E,A=0;continue}else if(n.length!==0){n="",c=0,w=E,A=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",c=2)}else n.length>0?n+=`${r}${t.slice(w+1,E)}`:n=t.slice(w+1,E),c=E-w-1;w=E,A=0}else I===P&&A!==-1?++A:A=-1}return n}function $(t,o){h(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$fc={resolve(...t){let o="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let c;if(n>=0){if(c=t[n],m(c,"path"),c.length===0)continue}else o.length===0?c=S.cwd():(c=S.env[`=${o}`]||S.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==o.toLowerCase()&&c.charCodeAt(2)===u)&&(c=`${o}\\`));const w=c.length;let A=0,I="",E=!1;const C=c.charCodeAt(0);if(w===1)k(C)&&(A=1,E=!0);else if(k(C))if(E=!0,k(c.charCodeAt(1))){let j=2,U=j;for(;j<w&&!k(c.charCodeAt(j));)j++;if(j<w&&j!==U){const F=c.slice(U,j);for(U=j;j<w&&k(c.charCodeAt(j));)j++;if(j<w&&j!==U){for(U=j;j<w&&!k(c.charCodeAt(j));)j++;(j===w||j!==U)&&(I=`\\\\${F}\\${c.slice(U,j)}`,A=j)}}}else A=1;else l(C)&&c.charCodeAt(1)===b&&(I=c.slice(0,2),A=2,w>2&&k(c.charCodeAt(2))&&(E=!0,A=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(i){if(o.length>0)break}else if(r=`${c.slice(A)}\\${r}`,i=E,E&&o.length>0)break}return r=f(r,!i,"\\",k),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){m(t,"path");const o=t.length;if(o===0)return".";let r=0,i,n=!1;const c=t.charCodeAt(0);if(o===1)return g(c)?"\\":t;if(k(c))if(n=!0,k(t.charCodeAt(1))){let A=2,I=A;for(;A<o&&!k(t.charCodeAt(A));)A++;if(A<o&&A!==I){const E=t.slice(I,A);for(I=A;A<o&&k(t.charCodeAt(A));)A++;if(A<o&&A!==I){for(I=A;A<o&&!k(t.charCodeAt(A));)A++;if(A===o)return`\\\\${E}\\${t.slice(I)}\\`;A!==I&&(i=`\\\\${E}\\${t.slice(I,A)}`,r=A)}}}else r=1;else l(c)&&t.charCodeAt(1)===b&&(i=t.slice(0,2),r=2,o>2&&k(t.charCodeAt(2))&&(n=!0,r=3));let w=r<o?f(t.slice(r),!n,"\\",k):"";return w.length===0&&!n&&(w="."),w.length>0&&k(t.charCodeAt(o-1))&&(w+="\\"),i===void 0?n?`\\${w}`:w:n?`${i}\\${w}`:`${i}${w}`},isAbsolute(t){m(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return k(r)||o>2&&l(r)&&t.charCodeAt(1)===b&&k(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let c=0;c<t.length;++c){const w=t[c];m(w,"path"),w.length>0&&(o===void 0?o=r=w:o+=`\\${w}`)}if(o===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&k(r.charCodeAt(0))){++n;const c=r.length;c>1&&k(r.charCodeAt(1))&&(++n,c>2&&(k(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<o.length&&k(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$fc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o)return"";const r=e.$fc.resolve(t),i=e.$fc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===u;)n++;let c=t.length;for(;c-1>n&&t.charCodeAt(c-1)===u;)c--;const w=c-n;let A=0;for(;A<o.length&&o.charCodeAt(A)===u;)A++;let I=o.length;for(;I-1>A&&o.charCodeAt(I-1)===u;)I--;const E=I-A,C=w<E?w:E;let j=-1,U=0;for(;U<C;U++){const H=t.charCodeAt(n+U);if(H!==o.charCodeAt(A+U))break;H===u&&(j=U)}if(U!==C){if(j===-1)return i}else{if(E>C){if(o.charCodeAt(A+U)===u)return i.slice(A+U+1);if(U===2)return i.slice(A+U)}w>C&&(t.charCodeAt(n+U)===u?j=U:U===2&&(j=3)),j===-1&&(j=0)}let F="";for(U=n+j+1;U<=c;++U)(U===c||t.charCodeAt(U)===u)&&(F+=F.length===0?"..":"\\..");return A+=j,F.length>0?`${F}${i.slice(A,I)}`:(i.charCodeAt(A)===u&&++A,i.slice(A,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===u){if(o.charCodeAt(1)===u){const r=o.charCodeAt(2);if(r!==v&&r!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(l(o.charCodeAt(0))&&o.charCodeAt(1)===b&&o.charCodeAt(2)===u)return`\\\\?\\${o}`;return t},dirname(t){m(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(o===1)return k(n)?t:".";if(k(n)){if(r=i=1,k(t.charCodeAt(1))){let A=2,I=A;for(;A<o&&!k(t.charCodeAt(A));)A++;if(A<o&&A!==I){for(I=A;A<o&&k(t.charCodeAt(A));)A++;if(A<o&&A!==I){for(I=A;A<o&&!k(t.charCodeAt(A));)A++;if(A===o)return t;A!==I&&(r=i=A+1)}}}}else l(n)&&t.charCodeAt(1)===b&&(r=o>2&&k(t.charCodeAt(2))?3:2,i=r);let c=-1,w=!0;for(let A=o-1;A>=i;--A)if(k(t.charCodeAt(A))){if(!w){c=A;break}}else w=!1;if(c===-1){if(r===-1)return".";c=r}return t.slice(0,c)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,n=!0,c;if(t.length>=2&&l(t.charCodeAt(0))&&t.charCodeAt(1)===b&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let w=o.length-1,A=-1;for(c=t.length-1;c>=r;--c){const I=t.charCodeAt(c);if(k(I)){if(!n){r=c+1;break}}else A===-1&&(n=!1,A=c+1),w>=0&&(I===o.charCodeAt(w)?--w===-1&&(i=c):(w=-1,i=A))}return r===i?i=A:i===-1&&(i=t.length),t.slice(r,i)}for(c=t.length-1;c>=r;--c)if(k(t.charCodeAt(c))){if(!n){r=c+1;break}}else i===-1&&(n=!1,i=c+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=0,r=-1,i=0,n=-1,c=!0,w=0;t.length>=2&&t.charCodeAt(1)===b&&l(t.charCodeAt(0))&&(o=i=2);for(let A=t.length-1;A>=o;--A){const I=t.charCodeAt(A);if(k(I)){if(!c){i=A+1;break}continue}n===-1&&(c=!1,n=A+1),I===P?r===-1?r=A:w!==1&&(w=1):r!==-1&&(w=-1)}return r===-1||n===-1||w===0||w===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:$.bind(null,"\\"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return k(n)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(k(n)){if(i=1,k(t.charCodeAt(1))){let j=2,U=j;for(;j<r&&!k(t.charCodeAt(j));)j++;if(j<r&&j!==U){for(U=j;j<r&&k(t.charCodeAt(j));)j++;if(j<r&&j!==U){for(U=j;j<r&&!k(t.charCodeAt(j));)j++;j===r?i=j:j!==U&&(i=j+1)}}}}else if(l(n)&&t.charCodeAt(1)===b){if(r<=2)return o.root=o.dir=t,o;if(i=2,k(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let c=-1,w=i,A=-1,I=!0,E=t.length-1,C=0;for(;E>=i;--E){if(n=t.charCodeAt(E),k(n)){if(!I){w=E+1;break}continue}A===-1&&(I=!1,A=E+1),n===P?c===-1?c=E:C!==1&&(C=1):c!==-1&&(C=-1)}return A!==-1&&(c===-1||C===0||C===1&&c===A-1&&c===w+1?o.base=o.name=t.slice(w,A):(o.name=t.slice(w,c),o.base=t.slice(w,A),o.ext=t.slice(c,A))),w>0&&w!==i?o.dir=t.slice(0,w-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(p){const t=/\\/g;return()=>{const o=S.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>S.cwd()})();e.$gc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:a();m(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===d)}return o=f(o,!r,"/",g),r?`/${o}`:o.length>0?o:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===d,r=t.charCodeAt(t.length-1)===d;return t=f(t,!o,"/",g),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===d},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];m(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const r=1,i=t.length,n=i-r,c=1,w=o.length-c,A=n<w?n:w;let I=-1,E=0;for(;E<A;E++){const j=t.charCodeAt(r+E);if(j!==o.charCodeAt(c+E))break;j===d&&(I=E)}if(E===A)if(w>A){if(o.charCodeAt(c+E)===d)return o.slice(c+E+1);if(E===0)return o.slice(c+E)}else n>A&&(t.charCodeAt(r+E)===d?I=E:E===0&&(I=0));let C="";for(E=r+I+1;E<=i;++E)(E===i||t.charCodeAt(E)===d)&&(C+=C.length===0?"..":"/..");return`${C}${o.slice(c+I)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===d;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===d){if(!i){r=n;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,n=!0,c;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let w=o.length-1,A=-1;for(c=t.length-1;c>=0;--c){const I=t.charCodeAt(c);if(I===d){if(!n){r=c+1;break}}else A===-1&&(n=!1,A=c+1),w>=0&&(I===o.charCodeAt(w)?--w===-1&&(i=c):(w=-1,i=A))}return r===i?i=A:i===-1&&(i=t.length),t.slice(r,i)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===d){if(!n){r=c+1;break}}else i===-1&&(n=!1,i=c+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=-1,r=0,i=-1,n=!0,c=0;for(let w=t.length-1;w>=0;--w){const A=t.charCodeAt(w);if(A===d){if(!n){r=w+1;break}continue}i===-1&&(n=!1,i=w+1),A===P?o===-1?o=w:c!==1&&(c=1):o!==-1&&(c=-1)}return o===-1||i===-1||c===0||c===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:$.bind(null,"/"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===d;let i;r?(o.root="/",i=1):i=0;let n=-1,c=0,w=-1,A=!0,I=t.length-1,E=0;for(;I>=i;--I){const C=t.charCodeAt(I);if(C===d){if(!A){c=I+1;break}continue}w===-1&&(A=!1,w=I+1),C===P?n===-1?n=I:E!==1&&(E=1):n!==-1&&(E=-1)}if(w!==-1){const C=c===0&&r?1:c;n===-1||E===0||E===1&&n===w-1&&n===c+1?o.base=o.name=t.slice(C,w):(o.name=t.slice(C,n),o.base=t.slice(C,w),o.ext=t.slice(n,w))}return c>0?o.dir=t.slice(0,c-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=p?e.$fc.normalize:e.$gc.normalize,e.$ic=p?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=p?e.$fc.join:e.$gc.join,e.$kc=p?e.$fc.resolve:e.$gc.resolve,e.$lc=p?e.$fc.relative:e.$gc.relative,e.$mc=p?e.$fc.dirname:e.$gc.dirname,e.$nc=p?e.$fc.basename:e.$gc.basename,e.$oc=p?e.$fc.extname:e.$gc.extname,e.$pc=p?e.$fc.format:e.$gc.format,e.$qc=p?e.$fc.parse:e.$gc.parse,e.$rc=p?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=p?e.$fc.sep:e.$gc.sep,e.$tc=p?e.$fc.delimiter:e.$gc.delimiter}),define(ae[33],ce([0,1,9,4,25,12]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function D(c){return c===47||c===92}e.$2f=D;function P(c){return c.replace(/[\\/]/g,S.$gc.sep)}e.$3f=P;function d(c){return c.indexOf("/")===-1&&(c=P(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$4f=d;function u(c,w=S.$gc.sep){if(!c)return"";const A=c.length,I=c.charCodeAt(0);if(D(I)){if(D(c.charCodeAt(1))&&!D(c.charCodeAt(2))){let C=3;const j=C;for(;C<A&&!D(c.charCodeAt(C));C++);if(j!==C&&!D(c.charCodeAt(C+1))){for(C+=1;C<A;C++)if(D(c.charCodeAt(C)))return c.slice(0,C+1).replace(/[\\/]/g,w)}}return w}else if(g(I)&&c.charCodeAt(1)===58)return D(c.charCodeAt(2))?c.slice(0,2)+w:c.slice(0,2);let E=c.indexOf("://");if(E!==-1){for(E+=3;E<A;E++)if(D(c.charCodeAt(E)))return c.slice(0,E+1)}return""}e.$5f=u;function b(c){if(!O.$i||!c||c.length<5)return!1;let w=c.charCodeAt(0);if(w!==92||(w=c.charCodeAt(1),w!==92))return!1;let A=2;const I=A;for(;A<c.length&&(w=c.charCodeAt(A),w!==92);A++);return!(I===A||(w=c.charCodeAt(A+1),isNaN(w)||w===92))}e.$6f=b;const v=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(c,w=O.$i){const A=w?v:y;return!(!c||c.length===0||/^\s+$/.test(c)||(A.lastIndex=0,A.test(c))||w&&h.test(c)||c==="."||c===".."||w&&c[c.length-1]==="."||w&&c.length!==c.trim().length||c.length>255)}e.$7f=m;function p(c,w,A){const I=c===w;return!A||I?I:!c||!w?!1:(0,s.$af)(c,w)}e.$8f=p;function k(c,w,A,I=S.sep){if(c===w)return!0;if(!c||!w||w.length>c.length)return!1;if(A){if(!(0,s.$bf)(c,w))return!1;if(w.length===c.length)return!0;let C=w.length;return w.charAt(w.length-1)===I&&C--,c.charAt(C)===I}return w.charAt(w.length-1)!==I&&(w+=I),c.indexOf(w)===0}e.$9f=k;function g(c){return c>=65&&c<=90||c>=97&&c<=122}e.$0f=g;function l(c,w){return O.$i&&c.endsWith(":")&&(c+=S.sep),(0,S.$ic)(c)||(c=(0,S.$jc)(w,c)),c=(0,S.$hc)(c),O.$i?(c=(0,s.$Ve)(c,S.sep),c.endsWith(":")&&(c+=S.sep)):(c=(0,s.$Ve)(c,S.sep),c||(c=S.sep)),c}e.$$f=l;function f(c){const w=(0,S.$hc)(c);return O.$i?c.length>3?!1:$(w)&&(c.length===2||w.charCodeAt(2)===92):w===S.$gc.sep}e.$_f=f;function $(c,w=O.$i){return w?g(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$ag=$;function a(c,w=O.$i){return $(c,w)?c[0]:void 0}e.$bg=a;function t(c,w,A){return w.length>c.length?-1:c===w?0:(A&&(c=c.toLowerCase(),w=w.toLowerCase()),c.indexOf(w))}e.$cg=t;function o(c){const w=c.split(":");let A,I,E;for(const C of w){const j=Number(C);(0,M.$Nf)(j)?I===void 0?I=j:E===void 0&&(E=j):A=A?[A,C].join(":"):C}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:I!==void 0?I:void 0,column:E!==void 0?E:I!==void 0?1:void 0}}e.$dg=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(c,w,A=8){let I="";for(let C=0;C<A;C++){let j;C===0&&O.$i&&!w&&(A===3||A===4)?j=i:j=r,I+=j.charAt(Math.floor(Math.random()*j.length))}let E;return w?E=`${w}-${I}`:E=I,c?(0,S.$jc)(c,E):E}e.$eg=n}),define(ae[75],ce([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0;var O;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(O||(e.Source=O={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(P,...d){const u=d.reduce((y,h)=>(y[h]=!0,y),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!u[y]).forEach(y=>{for(let h=0;h<b.length;h++)if(y.search(b[h])!==-1){delete P[y];break}})}e.$Tl=M;function D(P){P&&(delete P.DEBUG,S.$j&&delete P.DYLD_LIBRARY_PATH,S.$k&&delete P.LD_PRELOAD)}e.$Ul=D}),define(ae[7],ce([0,1,9,4]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,D=/^\/\//;function P(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(i,n){return!i&&!n?"file":i}function u(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==v&&(n=v+n):n=v;break}return n}const b="",v="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(n){return n instanceof h?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,c,w,A,I,E=!1){typeof n=="object"?(this.scheme=n.scheme||b,this.authority=n.authority||b,this.path=n.path||b,this.query=n.query||b,this.fragment=n.fragment||b):(this.scheme=d(n,E),this.authority=c||b,this.path=u(this.scheme,w||b),this.query=A||b,this.fragment=I||b,P(this,E))}get fsPath(){return $(this,!1)}with(n){if(!n)return this;let{scheme:c,authority:w,path:A,query:I,fragment:E}=n;return c===void 0?c=this.scheme:c===null&&(c=b),w===void 0?w=this.authority:w===null&&(w=b),A===void 0?A=this.path:A===null&&(A=b),I===void 0?I=this.query:I===null&&(I=b),E===void 0?E=this.fragment:E===null&&(E=b),c===this.scheme&&w===this.authority&&A===this.path&&I===this.query&&E===this.fragment?this:new k(c,w,A,I,E)}static parse(n,c=!1){const w=y.exec(n);return w?new k(w[2]||b,r(w[4]||b),r(w[5]||b),r(w[7]||b),r(w[9]||b),c):new k(b,b,b,b,b)}static file(n){let c=b;if(O.$i&&(n=n.replace(/\\/g,v)),n[0]===v&&n[1]===v){const w=n.indexOf(v,2);w===-1?(c=n.substring(2),n=v):(c=n.substring(2,w),n=n.substring(w)||v)}return new k("file",c,n,b,b)}static from(n,c){return new k(n.scheme,n.authority,n.path,n.query,n.fragment,c)}static joinPath(n,...c){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return O.$i&&n.scheme==="file"?w=h.file(S.$fc.join($(n,!0),...c)).path:w=S.$gc.join(n.path,...c),n.with({path:w})}toString(n=!1){return a(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof h)return n;{const c=new k(n);return c._formatted=n.external??null,c._fsPath=n._sep===p?n.fsPath??null:null,c}}else return n}}e.URI=h;function m(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=m;const p=O.$i?1:void 0;class k extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(n=!1){return n?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=p),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function l(i,n,c){let w,A=-1;for(let I=0;I<i.length;I++){const E=i.charCodeAt(I);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47||c&&E===91||c&&E===93||c&&E===58)A!==-1&&(w+=encodeURIComponent(i.substring(A,I)),A=-1),w!==void 0&&(w+=i.charAt(I));else{w===void 0&&(w=i.substr(0,I));const C=g[E];C!==void 0?(A!==-1&&(w+=encodeURIComponent(i.substring(A,I)),A=-1),w+=C):A===-1&&(A=I)}}return A!==-1&&(w+=encodeURIComponent(i.substring(A))),w!==void 0?w:i}function f(i){let n;for(let c=0;c<i.length;c++){const w=i.charCodeAt(c);w===35||w===63?(n===void 0&&(n=i.substr(0,c)),n+=g[w]):n!==void 0&&(n+=i[c])}return n!==void 0?n:i}function $(i,n){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,O.$i&&(c=c.replace(/\//g,"\\")),c}e.$wc=$;function a(i,n){const c=n?f:l;let w="",{scheme:A,authority:I,path:E,query:C,fragment:j}=i;if(A&&(w+=A,w+=":"),(I||A==="file")&&(w+=v,w+=v),I){let U=I.indexOf("@");if(U!==-1){const F=I.substr(0,U);I=I.substr(U+1),U=F.lastIndexOf(":"),U===-1?w+=c(F,!1,!1):(w+=c(F.substr(0,U),!1,!1),w+=":",w+=c(F.substr(U+1),!1,!0)),w+="@"}I=I.toLowerCase(),U=I.lastIndexOf(":"),U===-1?w+=c(I,!1,!0):(w+=c(I.substr(0,U),!1,!0),w+=I.substr(U))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const U=E.charCodeAt(1);U>=65&&U<=90&&(E=`/${String.fromCharCode(U+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const U=E.charCodeAt(0);U>=65&&U<=90&&(E=`${String.fromCharCode(U+32)}:${E.substr(2)}`)}w+=c(E,!0,!1)}return C&&(w+="?",w+=c(C,!1,!1)),j&&(w+="#",w+=n?j:l(j,!1,!1)),w}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,n=>t(n)):i}}),define(ae[154],ce([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$qq=e.$pq=e.$oq=void 0;function O(u){const b=u;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.$oq=O;function s(u){const b=[];let v;try{const y=JSON.parse(u.arguments),h=y[y.length-1];h&&h.__$stack&&(y.pop(),v=h.__$stack),b.push(...y)}catch{b.push("Unable to log remote console arguments",u.arguments)}return{args:b,stack:v}}e.$pq=s;function M(u){if(typeof u!="string")return M(s(u).stack);const b=u;if(b){const v=D(b),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$qq=M;function D(u){if(!u)return u;const b=u.indexOf(`
`);return b===-1?u:u.substring(0,b)}function P(u,b){const{args:v,stack:y}=s(u),h=typeof v[0]=="string"&&v.length===1;let m=D(y);m&&(m=`(${m.trim()})`);let p=[];if(typeof v[0]=="string"?m&&h?p=[`%c[${b}] %c${v[0]} %c${m}`,d("blue"),d(""),d("grey")]:p=[`%c[${b}] %c${v[0]}`,d("blue"),d(""),...v.slice(1)]:p=[`%c[${b}]%`,d("blue"),...v],m&&!h&&p.push(m),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,p)}e.log=P;function d(u){return`color: ${u}`}}),define(ae[76],ce([0,1,17,7]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function s(d){return JSON.stringify(d,D)}e.$Ch=s;function M(d){let u=JSON.parse(d);return u=P(u),u}e.$Dh=M;function D(d,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function P(d,u=0){if(!d||u>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return O.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof S.$ke||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let b=0;b<d.length;++b)d[b]=P(d[b],u+1);else for(const b in d)Object.hasOwnProperty.call(d,b)&&(d[b]=P(d[b],u+1))}return d}e.$Eh=P}),define(ae[13],ce([0,1,14,4,25,7]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var D;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeManagedRemoteResource="vscode-managed-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.vscodeChatCodeBlock="vscode-chat-code-block",y.vscodeChatSesssion="vscode-chat-editor",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(D||(e.Schemas=D={}));function P(y,h){return M.URI.isUri(y)?(0,s.$af)(y.scheme,h):(0,s.$bf)(y,h+":")}e.$fg=P;function d(y,...h){return h.some(m=>P(y,m))}e.$gg=d,e.$hg="vscode-tkn",e.$ig="tkn";class u{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${D.vscodeRemoteResource}`}set(h,m,p){this.a[h]=m,this.b[h]=p}setConnectionToken(h,m){this.c[h]=m}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(f){return S.$1(f),h}const m=h.authority;let p=this.a[m];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const k=this.b[m],g=this.c[m];let l=`path=${encodeURIComponent(h.path)}`;return typeof g=="string"&&(l+=`&${e.$ig}=${encodeURIComponent(g)}`),M.URI.from({scheme:O.$o?this.d:D.vscodeRemoteResource,authority:`${p}:${k}`,path:this.f,query:l})}}e.$jg=new u,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class b{static{this.a=e.$og}asBrowserUri(h){const m=this.b(h,Y);return this.uriToBrowserUri(m)}uriToBrowserUri(h){return h.scheme===D.vscodeRemote?e.$jg.rewrite(h):h.scheme===D.file&&(O.$m||O.$q===`${D.vscodeFileResource}://${b.a}`)?h.with({scheme:D.vscodeFileResource,authority:h.authority||b.a,query:null,fragment:null}):h}asFileUri(h){const m=this.b(h,Y);return this.uriToFileUri(m)}uriToFileUri(h){return h.scheme===D.vscodeFileResource?h.with({scheme:D.file,authority:h.authority!==b.a?h.authority:null,query:null,fragment:null}):h}b(h,m){return M.URI.isUri(h)?h:M.URI.parse(m.toUrl(h))}}e.$pg=new b;var v;(function(y){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(h.get("3"));const m="vscode-coi";function p(g){let l;typeof g=="string"?l=new URL(g).searchParams:g instanceof URL?l=g.searchParams:M.URI.isUri(g)&&(l=new URL(g.toString(!0)).searchParams);const f=l?.get(m);if(f)return h.get(f)}y.getHeadersFromQuery=p;function k(g,l,f){if(!globalThis.crossOriginIsolated)return;const $=l&&f?"3":f?"2":"1";g instanceof URLSearchParams?g.set(m,$):g[m]=$}y.addSearchParam=k})(v||(e.COI=v={}))}),define(ae[19],ce([0,1,33,13,9,4,25,7]),function(Y,e,S,O,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function d(h){return(0,P.$wc)(h,!0)}e.$wg=d;class u{constructor(m){this.a=m}compare(m,p,k=!1){return m===p?0:(0,D.$6e)(this.getComparisonKey(m,k),this.getComparisonKey(p,k))}isEqual(m,p,k=!1){return m===p?!0:!m||!p?!1:this.getComparisonKey(m,k)===this.getComparisonKey(p,k)}getComparisonKey(m,p=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,p,k=!1){if(m.scheme===p.scheme){if(m.scheme===O.Schemas.file)return S.$9f(d(m),d(p),this.a(m))&&m.query===p.query&&(k||m.fragment===p.fragment);if((0,e.$Ng)(m.authority,p.authority))return S.$9f(m.path,p.path,this.a(m),"/")&&m.query===p.query&&(k||m.fragment===p.fragment)}return!1}joinPath(m,...p){return P.URI.joinPath(m,...p)}basenameOrAuthority(m){return(0,e.$Fg)(m)||m.authority}basename(m){return s.$gc.basename(m.path)}extname(m){return s.$gc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let p;return m.scheme===O.Schemas.file?p=P.URI.file(s.$mc(d(m))).path:(p=s.$gc.dirname(m.path),m.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),p="/")),m.with({path:p})}normalizePath(m){if(!m.path.length)return m;let p;return m.scheme===O.Schemas.file?p=P.URI.file(s.$hc(d(m))).path:p=s.$gc.normalize(m.path),m.with({path:p})}relativePath(m,p){if(m.scheme!==p.scheme||!(0,e.$Ng)(m.authority,p.authority))return;if(m.scheme===O.Schemas.file){const l=s.$lc(d(m),d(p));return M.$i?S.$3f(l):l}let k=m.path||"/";const g=p.path||"/";if(this.a(m)){let l=0;for(const f=Math.min(k.length,g.length);l<f&&!(k.charCodeAt(l)!==g.charCodeAt(l)&&k.charAt(l).toLowerCase()!==g.charAt(l).toLowerCase());l++);k=g.substr(0,l)+k.substr(l)}return s.$gc.relative(k,g)}resolvePath(m,p){if(m.scheme===O.Schemas.file){const k=P.URI.file(s.$kc(d(m),p));return m.with({authority:k.authority,path:k.path})}return p=S.$4f(p),m.with({path:s.$gc.resolve(m.path,p)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,p){return m===p||m!==void 0&&p!==void 0&&(0,D.$af)(m,p)}hasTrailingPathSeparator(m,p=s.sep){if(m.scheme===O.Schemas.file){const k=d(m);return k.length>S.$5f(k).length&&k[k.length-1]===p}else{const k=m.path;return k.length>1&&k.charCodeAt(k.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,p=s.sep){return(0,e.$Og)(m,p)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,p=s.sep){let k=!1;if(m.scheme===O.Schemas.file){const g=d(m);k=g!==void 0&&g.length===S.$5f(g).length&&g[g.length-1]===p}else{p="/";const g=m.path;k=g.length===1&&g.charCodeAt(g.length-1)===47}return!k&&!(0,e.$Og)(m,p)?m.with({path:m.path+"/"}):m}}e.$xg=u,e.$yg=new u(()=>!1),e.$zg=new u(h=>h.scheme===O.Schemas.file?!M.$k:!0),e.$Ag=new u(h=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function b(h,m){const p=[];for(let k=0;k<h.length;k++){const g=m(h[k]);h.some((l,f)=>f===k?!1:(0,e.$Cg)(g,m(l)))||p.push(h[k])}return p}e.$Rg=b;var v;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function m(p){const k=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(f=>{const[$,a]=f.split(":");$&&a&&k.set($,a)});const l=p.path.substring(0,p.path.indexOf(";"));return l&&k.set(h.META_DATA_MIME,l),k}h.parseMetaData=m})(v||(e.DataUri=v={}));function y(h,m,p){if(m){let k=h.path;return k&&k[0]!==s.$gc.sep&&(k=s.$gc.sep+k),h.with({scheme:p,authority:m,path:k})}return h.with({scheme:p})}e.$Sg=y}),define(ae[8],ce([0,1,23,14,3,2,19,4,143,62]),function(Y,e,S,O,s,M,D,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.Promises=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function b(_){return!!_&&typeof _.then=="function"}e.$Tg=b;function v(_){const z=new S.$7d,ee=_(z.token),ne=new Promise((de,me)=>{const Ee=z.token.onCancellationRequested(()=>{Ee.dispose(),me(new O.$5)});Promise.resolve(ee).then(Pe=>{Ee.dispose(),z.dispose(),de(Pe)},Pe=>{Ee.dispose(),z.dispose(),me(Pe)})});return new class{cancel(){z.cancel(),z.dispose()}then(de,me){return ne.then(de,me)}catch(de){return this.then(void 0,de)}finally(de){return ne.finally(de)}}}e.$Ug=v;function y(_,z,ee){return new Promise((ne,de)=>{const me=z.onCancellationRequested(()=>{me.dispose(),ne(ee)});_.then(ne,de).finally(()=>me.dispose())})}e.$Vg=y;function h(_,z){return new Promise((ee,ne)=>{const de=z.onCancellationRequested(()=>{de.dispose(),ne(new O.$5)});_.then(ee,ne).finally(()=>de.dispose())})}e.$Wg=h;async function m(_){let z=-1;const ee=_.map((ne,de)=>ne.then(me=>(z=de,me)));try{return await Promise.race(ee)}finally{_.forEach((ne,de)=>{de!==z&&ne.cancel()})}}e.$Xg=m;function p(_,z,ee){let ne;const de=setTimeout(()=>{ne?.(void 0),ee?.()},z);return Promise.race([_.finally(()=>clearTimeout(de)),new Promise(me=>ne=me)])}e.$Yg=p;function k(_){return new Promise((z,ee)=>{const ne=_();b(ne)?ne.then(z,ee):z(ne)})}e.$Zg=k;function g(){let _,z;return{promise:new Promise((ne,de)=>{_=ne,z=de}),resolve:_,reject:z}}e.$1g=g;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=z,!this.b){const ee=()=>{if(this.b=null,this.f)return;const ne=this.queue(this.d);return this.d=null,ne};this.b=new Promise(ne=>{this.a.then(ee,ee).then(ne)})}return new Promise((ee,ne)=>{this.b.then(ee,ne)})}return this.a=z(),new Promise((ee,ne)=>{this.a.then(de=>{this.a=null,ee(de)},de=>{this.a=null,ne(de)})})}dispose(){this.f=!0}}e.$2g=l;class f{constructor(){this.a=Promise.resolve(null)}queue(z){return this.a=this.a.then(()=>z(),()=>z())}}e.$3g=f;class ${constructor(){this.a=new Map}queue(z,ee){const de=(this.a.get(z)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.a.get(z)===de&&this.a.delete(z)});return this.a.set(z,de),de}}e.$4g=$;const a=(_,z)=>{let ee=!0;const ne=setTimeout(()=>{ee=!1,z()},_);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(ne),ee=!1}}},t=_=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,_())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};class o{constructor(z){this.defaultDelay=z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(z,ee=this.defaultDelay){this.g=z,this.h(),this.b||(this.b=new Promise((de,me)=>{this.d=de,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const ne=()=>{this.a=null,this.d?.(null)};return this.a=ee===d.$Td?t(ne):a(ee,ne),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$5g=o;class r{constructor(z){this.a=new o(z),this.b=new l}trigger(z,ee){return this.a.trigger(()=>this.b.queue(z),ee)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$6g=r;class i{constructor(){this.a=!1,this.b=new Promise((z,ee)=>{this.d=z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$7g=i;class n extends i{constructor(z){super(),this.f=setTimeout(()=>this.open(),z)}open(){clearTimeout(this.f),super.open()}}e.$8g=n;function c(_,z){return z?new Promise((ee,ne)=>{const de=setTimeout(()=>{me.dispose(),ee()},_),me=z.onCancellationRequested(()=>{clearTimeout(de),me.dispose(),ne(new O.$5)})}):v(ee=>c(_,ee))}e.$9g=c;function w(_,z=0,ee){const ne=setTimeout(()=>{_(),ee&&de.dispose()},z),de=(0,M.$Rc)(()=>{clearTimeout(ne),ee?.deleteAndLeak(de)});return ee?.add(de),de}e.$0g=w;function A(_){const z=[];let ee=0;const ne=_.length;function de(){return ee<ne?_[ee++]():null}function me(Ee){Ee!=null&&z.push(Ee);const Pe=de();return Pe?Pe.then(me):Promise.resolve(z)}return Promise.resolve(null).then(me)}e.$$g=A;function I(_,z=ne=>!!ne,ee=null){let ne=0;const de=_.length,me=()=>{if(ne>=de)return Promise.resolve(ee);const Ee=_[ne++];return Promise.resolve(Ee()).then(Le=>z(Le)?Promise.resolve(Le):me())};return me()}e.$_g=I;function E(_,z=ne=>!!ne,ee=null){if(_.length===0)return Promise.resolve(ee);let ne=_.length;const de=()=>{ne=-1;for(const me of _)me.cancel?.()};return new Promise((me,Ee)=>{for(const Pe of _)Pe.then(Le=>{--ne>=0&&z(Le)?(de(),me(Le)):ne===0&&me(ee)}).catch(Le=>{--ne>=0&&(de(),Ee(Le))})})}e.$ah=E;class C{constructor(z){this.a=0,this.b=!1,this.f=z,this.g=[],this.d=0,this.h=new s.$Wd}whenIdle(){return this.size>0?s.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ee,ne)=>{this.g.push({factory:z,c:ee,e:ne}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const z=this.g.shift();this.d++;const ee=z.factory();ee.then(z.c,z.e),ee.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$bh=C;class j extends C{constructor(){super(1)}}e.$ch=j;class U{constructor(){this.a=new T,this.b=0}queue(z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,z())):this.a.run(this.b++,z())}}e.$dh=U;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const z=new oe;return this.b.add(z),z.p}g(){for(const[,z]of this.a)if(z.size>0)return!1;return!0}queueSize(z,ee=D.$yg){const ne=ee.getComparisonKey(z);return this.a.get(ne)?.size??0}queueFor(z,ee,ne=D.$yg){const de=ne.getComparisonKey(z);let me=this.a.get(de);if(!me){me=new j;const Ee=this.f++,Pe=s.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$3c),this.d.set(Ee,Pe),this.a.set(de,me)}return me.queue(ee)}h(){this.g()&&this.j()}j(){for(const z of this.b)z.complete();this.b.clear()}dispose(){for(const[,z]of this.a)z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$eh=F;class H{constructor(z,ee){this.a=-1,typeof z=="function"&&typeof ee=="number"&&this.setIfNotSet(z,ee)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(z,ee){this.cancel(),this.a=setTimeout(()=>{this.a=-1,z()},ee)}setIfNotSet(z,ee){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,z()},ee))}}e.$fh=H;class J{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(z,ee,ne=globalThis){this.cancel();const de=ne.setInterval(()=>{z()},ee);this.d=(0,M.$Rc)(()=>{ne.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$gh=J;class le{constructor(z,ee){this.b=-1,this.a=z,this.d=ee,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(z=this.d){this.cancel(),this.b=setTimeout(this.f,z)}get delay(){return this.d}set delay(z){this.d=z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$hh=le;class re{constructor(z,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.a=z,this.b=ee,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(z=this.b){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ih=re;class ue extends le{constructor(z,ee){super(z,ee),this.j=[]}work(z){this.j.push(z),this.isScheduled()||this.schedule()}h(){const z=this.j;this.j=[],this.a?.(z)}dispose(){this.j=[],super.dispose()}}e.$jh=ue;class Z extends M.$Tc{constructor(z,ee){super(),this.g=z,this.h=ee,this.a=[],this.b=this.B(new M.$Uc),this.f=!1}get pending(){return this.a.length}work(z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+z.length>this.g.maxBufferedWork)return!1}else if(this.pending+z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ee of z)this.a.push(ee);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$kh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$mh=(_,z)=>{(0,P.$B)(()=>{if(ee)return;const ne=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ne-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$mh=(_,z,ee)=>{const ne=_.requestIdleCallback(z,typeof ee=="number"?{timeout:ee}:void 0);let de=!1;return{dispose(){de||(de=!0,_.cancelIdleCallback(ne))}}},e.$lh=_=>(0,e.$mh)(globalThis,_)}();class X{constructor(z,ee){this.g=!1,this.d=()=>{try{this.j=ee()}catch(ne){this.l=ne}finally{this.g=!0}},this.f=(0,e.$mh)(z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$nh=X;class q extends X{constructor(z){super(globalThis,z)}}e.$oh=q;async function L(_,z,ee){let ne;for(let de=0;de<ee;de++)try{return await _()}catch(me){ne=me,await c(z)}throw ne}e.$ph=L;class T{isRunning(z){return typeof z=="number"?this.a?.taskId===z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(z,ee,ne){return this.a={taskId:z,cancel:()=>ne?.(),promise:ee},ee.then(()=>this.d(z),()=>this.d(z)),ee}d(z){this.a&&z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const z=this.b;this.b=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}queue(z){if(this.b)this.b.run=z;else{const{promise:ee,resolve:ne,reject:de}=g();this.b={run:z,promise:ee,promiseResolve:ne,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$qh=T;class G{constructor(z,ee=()=>Date.now()){this.d=z,this.f=ee,this.a=0,this.b=0}increment(){const z=this.f();return z-this.a>this.d&&(this.a=z,this.b=0),this.b++,this.b}}e.$rh=G;var B;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(B||(B={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((z,ee)=>{this.a=z,this.b=ee})}complete(z){return new Promise(ee=>{this.a(z),this.d={outcome:0,value:z},ee()})}error(z){return new Promise(ee=>{this.b(z),this.d={outcome:1,value:z},ee()})}cancel(){return this.error(new O.$5)}}e.$sh=oe;var he;(function(_){async function z(ne){let de;const me=await Promise.all(ne.map(Ee=>Ee.then(Pe=>Pe,Pe=>{de||(de=Pe)})));if(typeof de<"u")throw de;return me}_.settled=z;function ee(ne){return new Promise(async(de,me)=>{try{await ne(de,me)}catch(Ee){me(Ee)}})}_.withAsyncBody=ee})(he||(e.Promises=he={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=z.then(ee=>(this.a=ee,this.d=!0,ee),ee=>{throw this.b=ee,this.d=!0,ee})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$th=K;class R{constructor(z){this.b=z,this.a=new u.$V(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$uh=R;var W;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(W||(W={}));class x{static fromArray(z){return new x(ee=>{ee.emitMany(z)})}static fromPromise(z){return new x(async ee=>{ee.emitMany(await z)})}static fromPromises(z){return new x(async ee=>{await Promise.all(z.map(async ne=>ee.emitOne(await ne)))})}static merge(z){return new x(async ee=>{await Promise.all(z.map(async ne=>{for await(const de of ne)ee.emitOne(de)}))})}static{this.EMPTY=x.fromArray([])}constructor(z){this.a=0,this.b=[],this.d=null,this.f=new s.$Wd,queueMicrotask(async()=>{const ee={emitOne:ne=>this.g(ne),emitMany:ne=>this.h(ne),reject:ne=>this.k(ne)};try{await Promise.resolve(z(ee)),this.j()}catch(ne){this.k(ne)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(z<this.b.length)return{done:!1,value:this.b[z++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(z,ee){return new x(async ne=>{for await(const de of z)ne.emitOne(ee(de))})}map(z){return x.map(this,z)}static filter(z,ee){return new x(async ne=>{for await(const de of z)ee(de)&&ne.emitOne(de)})}filter(z){return x.filter(this,z)}static coalesce(z){return x.filter(z,ee=>!!ee)}coalesce(){return x.coalesce(this)}static async toPromise(z){const ee=[];for await(const ne of z)ee.push(ne);return ee}toPromise(){return x.toPromise(this)}g(z){this.a===0&&(this.b.push(z),this.f.fire())}h(z){this.a===0&&(this.b=this.b.concat(z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(z){this.a===0&&(this.a=2,this.d=z,this.f.fire())}}e.$vh=x;class N extends x{constructor(z,ee){super(ee),this.l=z}cancel(){this.l.cancel()}}e.$wh=N;function Q(_){const z=new S.$7d,ee=_(z.token);return new N(z,async ne=>{const de=z.token.onCancellationRequested(()=>{de.dispose(),z.dispose(),ne.reject(new O.$5)});try{for await(const me of ee){if(z.token.isCancellationRequested)return;ne.emitOne(me)}de.dispose(),z.dispose()}catch(me){de.dispose(),z.dispose(),ne.reject(me)}})}e.$xh=Q;class V{constructor(){this.a=new oe,this.b=new x(ne=>{if(z){ne.reject(z);return}return ee&&ne.emitMany(ee),this.d=de=>ne.reject(de),this.f=de=>ne.emitOne(de),this.a.p});let z,ee;this.f=ne=>{ee||(ee=[]),ee.push(ne)},this.d=ne=>{z||(z=ne)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(z){this.d(z),this.a.complete()}emitOne(z){this.f(z)}}e.$yh=V}),define(ae[106],ce([0,1,22,8,33,31,9,4,25]),function(Y,e,S,O,s,M,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=void 0;function u(){return Object.create(null)}e.$Jj=u,e.$Kj="**",e.$Lj="/";const b="[/\\\\]",v="[^/\\\\]",y=/\//g;function h(X,q){switch(X){case 0:return"";case 1:return`${v}*?`;default:return`(?:${b}|${v}+${b}${q?`|${b}${v}+`:""})*?`}}function m(X,q){if(!X)return[];const L=[];let T=!1,G=!1,B="";for(const oe of X){switch(oe){case q:if(!T&&!G){L.push(B),B="";continue}break;case"{":T=!0;break;case"}":T=!1;break;case"[":G=!0;break;case"]":G=!1;break}B+=oe}return B&&L.push(B),L}e.$Mj=m;function p(X){if(!X)return"";let q="";const L=m(X,e.$Lj);if(L.every(T=>T===e.$Kj))q=".*";else{let T=!1;L.forEach((G,B)=>{if(G===e.$Kj){if(T)return;q+=h(2,B===L.length-1)}else{let oe=!1,he="",K=!1,R="";for(const W of G){if(W!=="}"&&oe){he+=W;continue}if(K&&(W!=="]"||!R)){let x;W==="-"?x=W:(W==="^"||W==="!")&&!R?x="^":W===e.$Lj?x="":x=(0,d.$Pe)(W),R+=x;continue}switch(W){case"{":oe=!0;continue;case"[":K=!0;continue;case"}":{const N=`(?:${m(he,",").map(Q=>p(Q)).join("|")})`;q+=N,oe=!1,he="";break}case"]":{q+="["+R+"]",K=!1,R="";break}case"?":q+=v;continue;case"*":q+=h(1);continue;default:q+=(0,d.$Pe)(W)}}B<L.length-1&&(L[B+1]!==e.$Kj||B+2<L.length)&&(q+=b)}T=G===e.$Kj})}return q}const k=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,$=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Dc(1e4),o=function(){return!1},r=function(){return null};function i(X,q){if(!X)return r;let L;typeof X!="string"?L=X.pattern:L=X,L=L.trim();const T=`${L}_${!!q.trimForExclusions}`;let G=t.get(T);if(G)return n(G,X);let B;return k.test(L)?G=w(L.substr(4),L):(B=g.exec(c(L,q)))?G=A(B[1],L):(q.trimForExclusions?f:l).test(L)?G=I(L,q):(B=$.exec(c(L,q)))?G=E(B[1].substr(1),L,!0):(B=a.exec(c(L,q)))?G=E(B[1],L,!1):G=C(L),t.set(T,G),n(G,X)}function n(X,q){if(typeof q=="string")return X;const L=function(T,G){return(0,s.$9f)(T,q.base,!P.$k)?X((0,d.$Ue)(T.substr(q.base.length),D.sep),G):null};return L.allBasenames=X.allBasenames,L.allPaths=X.allPaths,L.basenames=X.basenames,L.patterns=X.patterns,L}function c(X,q){return q.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function w(X,q){return function(L,T){return typeof L=="string"&&L.endsWith(X)?q:null}}function A(X,q){const L=`/${X}`,T=`\\${X}`,G=function(oe,he){return typeof oe!="string"?null:he?he===X?q:null:oe===X||oe.endsWith(L)||oe.endsWith(T)?q:null},B=[X];return G.basenames=B,G.patterns=[q],G.allBasenames=B,G}function I(X,q){const L=ue(X.slice(1,-1).split(",").map(he=>i(he,q)).filter(he=>he!==r),X),T=L.length;if(!T)return r;if(T===1)return L[0];const G=function(he,K){for(let R=0,W=L.length;R<W;R++)if(L[R](he,K))return X;return null},B=L.find(he=>!!he.allBasenames);B&&(G.allBasenames=B.allBasenames);const oe=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return oe.length&&(G.allPaths=oe),G}function E(X,q,L){const T=D.sep===D.$gc.sep,G=T?X:X.replace(y,D.sep),B=D.sep+G,oe=D.$gc.sep+X;let he;return L?he=function(K,R){return typeof K=="string"&&(K===G||K.endsWith(B)||!T&&(K===X||K.endsWith(oe)))?q:null}:he=function(K,R){return typeof K=="string"&&(K===G||!T&&K===X)?q:null},he.allPaths=[(L?"*/":"./")+X],he}function C(X){try{const q=new RegExp(`^${p(X)}$`);return function(L){return q.lastIndex=0,typeof L=="string"&&q.test(L)?X:null}}catch{return r}}function j(X,q,L){return!X||typeof q!="string"?!1:U(X)(q,void 0,L)}e.$Nj=j;function U(X,q={}){if(!X)return o;if(typeof X=="string"||F(X)){const L=i(X,q);if(L===r)return o;const T=function(G,B){return!!L(G,B)};return L.allBasenames&&(T.allBasenames=L.allBasenames),L.allPaths&&(T.allPaths=L.allPaths),T}return le(X,q)}e.$Oj=U;function F(X){const q=X;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.$Pj=F;function H(X){return X.allBasenames||[]}e.$Qj=H;function J(X){return X.allPaths||[]}e.$Rj=J;function le(X,q){const L=ue(Object.getOwnPropertyNames(X).map(he=>re(he,X[he],q)).filter(he=>he!==r)),T=L.length;if(!T)return r;if(!L.some(he=>!!he.requiresSiblings)){if(T===1)return L[0];const he=function(W,x){let N;for(let Q=0,V=L.length;Q<V;Q++){const _=L[Q](W,x);if(typeof _=="string")return _;(0,O.$Tg)(_)&&(N||(N=[]),N.push(_))}return N?(async()=>{for(const Q of N){const V=await Q;if(typeof V=="string")return V}return null})():null},K=L.find(W=>!!W.allBasenames);K&&(he.allBasenames=K.allBasenames);const R=L.reduce((W,x)=>x.allPaths?W.concat(x.allPaths):W,[]);return R.length&&(he.allPaths=R),he}const G=function(he,K,R){let W,x;for(let N=0,Q=L.length;N<Q;N++){const V=L[N];V.requiresSiblings&&R&&(K||(K=(0,D.$nc)(he)),W||(W=K.substr(0,K.length-(0,D.$oc)(he).length)));const _=V(he,K,W,R);if(typeof _=="string")return _;(0,O.$Tg)(_)&&(x||(x=[]),x.push(_))}return x?(async()=>{for(const N of x){const Q=await N;if(typeof Q=="string")return Q}return null})():null},B=L.find(he=>!!he.allBasenames);B&&(G.allBasenames=B.allBasenames);const oe=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return oe.length&&(G.allPaths=oe),G}function re(X,q,L){if(q===!1)return r;const T=i(X,L);if(T===r)return r;if(typeof q=="boolean")return T;if(q){const G=q.when;if(typeof G=="string"){const B=(oe,he,K,R)=>{if(!R||!T(oe,he))return null;const W=G.replace("$(basename)",()=>K),x=R(W);return(0,O.$Tg)(x)?x.then(N=>N?X:null):x?X:null};return B.requiresSiblings=!0,B}}return T}function ue(X,q){const L=X.filter(he=>!!he.basenames);if(L.length<2)return X;const T=L.reduce((he,K)=>{const R=K.basenames;return R?he.concat(R):he},[]);let G;if(q){G=[];for(let he=0,K=T.length;he<K;he++)G.push(q)}else G=L.reduce((he,K)=>{const R=K.patterns;return R?he.concat(R):he},[]);const B=function(he,K){if(typeof he!="string")return null;if(!K){let W;for(W=he.length;W>0;W--){const x=he.charCodeAt(W-1);if(x===47||x===92)break}K=he.substr(W)}const R=T.indexOf(K);return R!==-1?G[R]:null};B.basenames=T,B.patterns=G,B.allBasenames=T;const oe=X.filter(he=>!he.basenames);return oe.push(B),oe}function Z(X,q){return(0,S.$ub)(X,q,(L,T)=>typeof L=="string"&&typeof T=="string"?L===T:typeof L!="string"&&typeof T!="string"?L.base===T.base&&L.pattern===T.pattern:!1)}e.$Sj=Z}),define(ae[47],ce([0,1,22,33,9,4,19,25]),function(Y,e,S,O,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=void 0;function d(i,n){const{os:c,tildify:w,relative:A}=n;if(A){const C=u(i,A,c);if(typeof C=="string")return C}let I=i.fsPath;if(c===1&&!M.$i?I=I.replace(/\//g,"\\"):c!==1&&M.$i&&(I=I.replace(/\\/g,"/")),c!==1&&w?.userHome){const C=w.userHome.fsPath;let j;i.scheme!==w.userHome.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep?j=w.userHome.with({path:i.path}).fsPath:j=I,I=y(j,C,c)}return(c===1?s.$fc:s.$gc).normalize(b(I,c===1))}e.$Xv=d;function u(i,n,c){const w=c===1?s.$fc:s.$gc,A=c===3?D.$yg:D.$Ag,I=n.getWorkspace(),E=(0,S.$Ob)(I.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep&&(i=E.uri.with({path:i.path}));const C=n.getWorkspaceFolder(i);if(!C)return;let j;if(A.isEqual(C.uri,i)?j="":j=A.relativePath(C.uri,i)??"",j&&(j=w.normalize(j)),I.folders.length>1&&!n.noPrefix){const U=C.name?C.name:A.basenameOrAuthority(C.uri);j=j?`${U} \u2022 ${j}`:U}return j}function b(i,n=M.$i){return(0,O.$ag)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$Yv=b;let v=Object.create(null);function y(i,n,c=M.OS){if(c===1||!i||!n)return i;let w=v.original===n?v.normalized:void 0;w||(w=n,M.$i&&(w=(0,O.$3f)(w)),w=`${(0,P.$Ve)(w,s.$gc.sep)}${s.$gc.sep}`,v={original:n,normalized:w});let A=i;return M.$i&&(A=(0,O.$3f)(A)),(c===3?A.startsWith(w):(0,P.$bf)(A,w))?`~/${A.substr(w.length)}`:i}e.$Zv=y;function h(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$1v=h;const m="\u2026",p="\\\\",k="~";function g(i,n=s.sep){const c=new Array(i.length);let w=!1;for(let A=0;A<i.length;A++){const I=i[A];if(I===""){c[A]=`.${n}`;continue}if(!I){c[A]=I;continue}w=!0;let E="",C=I;C.indexOf(p)===0?(E=C.substr(0,C.indexOf(p)+p.length),C=C.substr(C.indexOf(p)+p.length)):C.indexOf(n)===0?(E=C.substr(0,C.indexOf(n)+n.length),C=C.substr(C.indexOf(n)+n.length)):C.indexOf(k)===0&&(E=C.substr(0,C.indexOf(k)+k.length),C=C.substr(C.indexOf(k)+k.length));const j=C.split(n);for(let U=1;w&&U<=j.length;U++)for(let F=j.length-U;w&&F>=0;F--){w=!1;let H=j.slice(F,F+U).join(n);for(let J=0;!w&&J<i.length;J++)if(J!==A&&i[J]&&i[J].indexOf(H)>-1){const le=F+U===j.length,re=F>0&&i[J].indexOf(n)>-1?n+H:H,ue=i[J].endsWith(re);w=!le||ue}if(!w){let J="";(j[0].endsWith(":")||E!=="")&&(F===1&&(F=0,U++,H=j[0]+n+H),F>0&&(J=j[0]+n),J=E+J),F>0&&(J=J+m+n),J=J+H,F+U<j.length&&(J=J+n+m),c[A]=J}}w&&(c[A]=I)}return c}e.$2v=g;var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function f(i,n=Object.create(null)){const c=[];let w=!1,A="";for(const I of i)if(I==="$"||w&&I==="{")A&&c.push({value:A,type:l.TEXT}),A="",w=!0;else if(I==="}"&&w){const E=n[A];if(typeof E=="string")E.length&&c.push({value:E,type:l.VARIABLE});else if(E){const C=c[c.length-1];(!C||C.type!==l.SEPARATOR)&&c.push({value:E.label,type:l.SEPARATOR})}A="",w=!1}else A+=I;return A&&!w&&c.push({value:A,type:l.TEXT}),c.filter((I,E)=>{if(I.type===l.SEPARATOR){const C=c[E-1],j=c[E+1];return[C,j].every(U=>U&&(U.type===l.VARIABLE||U.type===l.TEXT)&&U.value.length>0)}return!0}).map(I=>I.value).join("")}e.$3v=f;function $(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.$4v=$;function a(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$5v=a;function t(i){return i.replace(/&/g,"&&")}e.$6v=t;function o(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const c=r(i.substring(0,n)),w=i.substring(n);return{name:c.name+w,parentPath:c.parentPath}}}return r(i)}e.$7v=o;function r(i){const n=i.indexOf("/")!==-1?s.$gc:s.$fc,c=n.basename(i),w=n.dirname(i);return c.length?{name:c,parentPath:w}:{name:w,parentPath:""}}}),define(ae[155],ce([0,1,17,7]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function s(v){return v.toJSON()}class M{constructor(y){this.a=y}transformIncoming(y){const h=this.a.transformIncoming(y);return h===y?y:s(O.URI.from(h))}transformOutgoing(y){const h=this.a.transformOutgoing(y);return h===y?y:s(O.URI.from(h))}transformOutgoingURI(y){const h=this.a.transformOutgoing(y);return h===y?y:O.URI.from(h)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$7m=M,e.$8m=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function D(v,y,h){if(!v||h>200)return null;if(typeof v=="object"){if(v instanceof O.URI)return y.transformOutgoing(v);for(const m in v)if(Object.hasOwnProperty.call(v,m)){const p=D(v[m],y,h+1);p!==null&&(v[m]=p)}}return null}function P(v,y){const h=D(v,y,0);return h===null?v:h}e.$9m=P;function d(v,y,h,m){if(!v||m>200)return null;if(typeof v=="object"){if(v.$mid===1)return h?O.URI.revive(y.transformIncoming(v)):y.transformIncoming(v);if(v instanceof S.$ke)return null;for(const p in v)if(Object.hasOwnProperty.call(v,p)){const k=d(v[p],y,h,m+1);k!==null&&(v[p]=k)}}return null}function u(v,y){const h=d(v,y,!1,0);return h===null?v:h}e.$0m=u;function b(v,y){const h=d(v,y,!0,0);return h===null?v:h}e.$$m=b}),define(ae[88],ce([0,1,26,59,32,145,4]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=void 0,e.$an=new class{c(y){return this.a||(this.a=O.$bi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,h=0;const m=(0,S.networkInterfaces)();for(const p in m){const k=m[p];if(k)for(const{mac:g,internal:l}of k)l||(h+=1,this.c(g.toUpperCase())&&(y+=1))}this.b=h>0?y/h:0}return this.b}};let P;async function d(y){return P||(P=(async()=>await u(y)||s.$rg())()),P}e.$bn=d;async function u(y){try{const h=await new Promise((p,k)=>{Y(["crypto"],p,k)}),m=(0,M.$_m)();return h.createHash("sha256").update(m,"utf8").digest("hex")}catch(h){y(h);return}}const b="Software\\Microsoft\\SQMClient";async function v(y){if(D.$i){const h=await new Promise((m,p)=>{Y(["@vscode/windows-registry"],m,p)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",b,"MachineId")||""}catch(m){return y(m),""}}return""}e.$cn=v}),define(ae[21],ce([0,1,46,26,156,8,33,85,9,4,19,7]),function(Y,e,S,O,s,M,D,P,d,u,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function h(re,ue=y.UNLINK,Z){if((0,D.$_f)(re))throw new Error("rimraf - will refuse to recursively delete root");return ue===y.UNLINK?p(re):m(re,Z)}async function m(re,ue=(0,D.$eg)((0,O.tmpdir)())){try{try{await S.promises.rename(re,ue)}catch(Z){return Z.code==="ENOENT"?void 0:p(re)}p(ue).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function p(re){return(0,s.promisify)(S.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function k(re){if((0,D.$_f)(re))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=k;async function g(re,ue){return $(await(ue?l(re):(0,s.promisify)(S.readdir)(re)))}async function l(re){try{return await(0,s.promisify)(S.readdir)(re,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const ue=[],Z=await g(re);for(const X of Z){let q=!1,L=!1,T=!1;try{const G=await e.Promises.lstat((0,d.$jc)(re,X));q=G.isFile(),L=G.isDirectory(),T=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ue.push({name:X,isFile:()=>q,isDirectory:()=>L,isSymbolicLink:()=>T})}return ue}function f(re){return $(S.readdirSync(re))}e.readdirSync=f;function $(re){return re.map(ue=>typeof ue=="string"?u.$j?(0,P.$Il)(ue):ue:(ue.name=u.$j?(0,P.$Il)(ue.name):ue.name,ue))}async function a(re){const ue=await g(re),Z=[];for(const X of ue)await o.existsDirectory((0,d.$jc)(re,X))&&Z.push(X);return Z}function t(re,ue=1e3){return new Promise(Z=>{let X=!1;const q=setInterval(()=>{X||(X=!0,S.access(re,L=>{X=!1,L&&(clearInterval(q),Z(void 0))}))},ue)})}e.whenDeleted=t;var o;(function(re){async function ue(q){let L;try{if(L=await e.Promises.lstat(q),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(u.$i&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw G}throw T}}re.stat=ue;async function Z(q){try{const{stat:L,symbolicLink:T}=await re.stat(q);return L.isFile()&&T?.dangling!==!0}catch{}return!1}re.existsFile=Z;async function X(q){try{const{stat:L,symbolicLink:T}=await re.stat(q);return L.isDirectory()&&T?.dangling!==!0}catch{}return!1}re.existsDirectory=X})(o||(e.SymlinkSupport=o={}));const r=new M.$eh;function i(re,ue,Z){return r.queueFor(v.URI.file(re),()=>{const X=I(Z);return new Promise((q,L)=>w(re,ue,X,T=>T?L(T):q()))},b.$zg)}let n=!0;function c(re){n=re}e.configureFlushOnWrite=c;function w(re,ue,Z,X){if(!n)return S.writeFile(re,ue,{mode:Z.mode,flag:Z.flag},X);S.open(re,Z.flag,Z.mode,(q,L)=>{if(q)return X(q);S.writeFile(L,ue,T=>{if(T)return S.close(L,()=>X(T));S.fdatasync(L,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),c(!1)),S.close(L,B=>X(B))))})})}function A(re,ue,Z){const X=I(Z);if(!n)return S.writeFileSync(re,ue,{mode:X.mode,flag:X.flag});const q=S.openSync(re,X.flag,X.mode);try{S.writeFileSync(q,ue);try{S.fdatasyncSync(q)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),c(!1)}}finally{S.closeSync(q)}}e.writeFileSync=A;function I(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function E(re,ue,Z=6e4){if(re!==ue)try{u.$i&&typeof Z=="number"?await C(re,ue,Date.now(),Z):await(0,s.promisify)(S.rename)(re,ue)}catch(X){if(re.toLowerCase()!==ue.toLowerCase()&&X.code==="EXDEV"||re.endsWith("."))await j(re,ue,{preserveSymlinks:!1}),await h(re,y.MOVE);else throw X}}async function C(re,ue,Z,X,q=0){try{return await(0,s.promisify)(S.rename)(re,ue)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-Z>=X)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${L}`),L;if(q===0){let T=!1;try{const{stat:G}=await o.stat(ue);G.isFile()||(T=!0)}catch{}if(T)throw L}return await(0,M.$9g)(Math.min(100,q*10)),C(re,ue,Z,X,q+1)}}async function j(re,ue,Z){return F(re,ue,{root:{source:re,target:ue},options:Z,handledSourcePaths:new Set})}const U=511;async function F(re,ue,Z){if(Z.handledSourcePaths.has(re))return;Z.handledSourcePaths.add(re);const{stat:X,symbolicLink:q}=await o.stat(re);if(q){if(Z.options.preserveSymlinks)try{return await le(re,ue,Z)}catch{}if(q.dangling)return}return X.isDirectory()?H(re,ue,X.mode&U,Z):J(re,ue,X.mode&U)}async function H(re,ue,Z,X){await e.Promises.mkdir(ue,{recursive:!0,mode:Z});const q=await g(re);for(const L of q)await F((0,d.$jc)(re,L),(0,d.$jc)(ue,L),X)}async function J(re,ue,Z){await e.Promises.copyFile(re,ue),await e.Promises.chmod(ue,Z)}async function le(re,ue,Z){let X=await e.Promises.readlink(re);(0,D.$9f)(X,Z.root.source,!u.$k)&&(X=(0,d.$jc)(Z.root.target,X.substr(Z.root.source.length+1))),await e.Promises.symlink(X,ue)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(re,ue,Z,X,q)=>new Promise((L,T)=>{S.read(re,ue,Z,X,q,(G,B,oe)=>G?T(G):L({bytesRead:B,buffer:oe}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(re,ue,Z,X,q)=>new Promise((L,T)=>{S.write(re,ue,Z,X,q,(G,B,oe)=>G?T(G):L({bytesWritten:B,buffer:oe}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return h}get rename(){return E}get copy(){return j}}}),define(ae[107],ce([0,1,46,9,4,25,21]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=void 0;function P(y){if(s.$k)return y;const h=(0,O.$mc)(y);if(y===h)return y;const m=((0,O.$nc)(y)||y).toLowerCase();try{const k=(0,D.readdirSync)(h).filter(g=>g.toLowerCase()===m);if(k.length===1){const g=P(h);if(g)return(0,O.$jc)(g,k[0])}else if(k.length>1){const g=k.indexOf(m);if(g>=0){const l=P(h);if(l)return(0,O.$jc)(l,k[g])}}}catch{}return null}e.$vq=P;async function d(y){if(s.$k)return y;const h=(0,O.$mc)(y);if(y===h)return y;const m=((0,O.$nc)(y)||y).toLowerCase();try{const k=(await D.Promises.readdir(h)).filter(g=>g.toLowerCase()===m);if(k.length===1){const g=await d(h);if(g)return(0,O.$jc)(g,k[0])}else if(k.length>1){const g=k.indexOf(m);if(g>=0){const l=await d(h);if(l)return(0,O.$jc)(l,k[g])}}}catch{}return null}e.$wq=d;async function u(y){try{return await D.Promises.realpath(y)}catch{const m=v(y);return await D.Promises.access(m,S.constants.R_OK),m}}e.$xq=u;function b(y){try{return S.realpathSync(y)}catch{const m=v(y);return S.accessSync(m,S.constants.R_OK),m}}e.$yq=b;function v(y){return(0,M.$Ve)((0,O.$hc)(y),O.sep)}}),define(ae[108],ce([0,1,26,9,21]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=void 0;const M=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var d;(function($){$[$.x64=0]="x64",$[$.x86=1]="x86",$[$.ARM=2]="ARM"})(d||(d={}));let u;switch(process.arch){case"ia32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class v{constructor(a,t,o){this.exePath=a,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:$=!1}={}){return $?u===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:$=!1,findPreview:a=!1}={}){const t=y({useAlternateBitness:$});if(!t)return null;const o=O.$jc(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const w of await s.Promises.readdir(o)){let A=-1;if(a){const E=w.indexOf("-");if(E<0)continue;const C=w.substring(0,E);if(!M.test(C)||w.substring(E+1)!=="preview")continue;A=parseInt(C,10)}else{if(!M.test(w))continue;A=parseInt(w,10)}if(A<=r)continue;const I=O.$jc(o,w,"pwsh.exe");await s.SymlinkSupport.existsFile(I)&&(i=I,r=A)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",c=a?" Preview":"";return new v(i,`PowerShell${c}${n}`,!0)}async function m({findPreview:$}={}){if(!process.env.LOCALAPPDATA)return null;const a=O.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=$?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(a))if(t.test(r)){const i=O.$jc(a,r,"pwsh.exe");return new v(i,o)}return null}function p(){const $=O.$jc(S.homedir(),".dotnet","tools","pwsh.exe");return new v($,".NET Core PowerShell Global Tool")}function k(){const $=O.$jc(process.env.windir,u===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v($,"Windows PowerShell",!0)}async function*g(){let $=await h();$&&(yield $),$=await h({useAlternateBitness:!0}),$&&(yield $),$=await m(),$&&(yield $),$=p(),$&&(yield $),$=await h({findPreview:!0}),$&&(yield $),$=await m({findPreview:!0}),$&&(yield $),$=await h({useAlternateBitness:!0,findPreview:!0}),$&&(yield $),$=k(),$&&(yield $)}async function*l(){for await(const $ of g())await $.exists()&&(yield $)}e.$Rl=l;async function f(){for await(const $ of l())return $;return null}e.$Sl=f}),define(ae[89],ce([0,1,9,4,36,75,12,21]),function(Y,e,S,O,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Wl=e.$Vl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function d(v=s.env){return v.comspec||"cmd.exe"}e.$Vl=d;function u(v){let y=[],h=!1;const m=function(p){if(h){y.push(p);return}(!v.send(p,g=>{if(g&&console.error(g),h=!1,y.length>0){const l=y.slice(0);y=[],l.forEach(f=>m(f))}})||O.$i)&&(h=!0)};return{send:m}}e.$Wl=u;var b;(function(v){async function y(h,m,p){if(S.$ic(h))return h;if(m===void 0&&(m=s.cwd()),S.$mc(h)!=="."||(p===void 0&&D.$Jf(s.env.PATH)&&(p=s.env.PATH.split(S.$tc)),p===void 0||p.length===0))return S.$jc(m,h);async function g(l){if(await P.Promises.exists(l)){let f;try{f=await P.Promises.stat(l)}catch($){$.message.startsWith("EACCES")&&(f=await P.Promises.lstat(l))}return f?!f.isDirectory():!1}return!1}for(const l of p){let f;if(S.$ic(l)?f=S.$jc(l,h):f=S.$jc(m,l,h),await g(f))return f;let $=f+".com";if(await g($)||($=f+".exe",await g($)))return $}return S.$jc(m,h)}v.findExecutable=y})(b||(e.win32=b={}))}),define(ae[109],ce([0,1,48,13]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=void 0;function s(D){return new Promise((P,d)=>{let u;const b=new Map;function v(h,m,p,k,g){const l=b.get(m);if(h===D||l){const f={name:y(p),cmd:p,pid:h,ppid:m,load:k,mem:g};b.set(h,f),h===D&&(u=f),l&&(l.children||(l.children=[]),l.children.push(f),l.children.length>1&&(l.children=l.children.sort(($,a)=>$.pid-a.pid)))}}function y(h){const m=/--utility-sub-type=network/i,p=/--crashes-directory/i,k=/\\pipe\\winpty-control/i,g=/conhost\.exe.+--headless/i,l=/--type=([a-zA-Z-]+)/;if(p.exec(h))return"electron-crash-reporter";if(k.exec(h))return"winpty-agent";if(g.exec(h))return"conpty-agent";let f=l.exec(h);if(f&&f.length===2)return f[1]==="renderer"?"window":f[1]==="utility"?m.exec(h)?"utility-network-service":"utility-process":f[1]==="extensionHost"?"extension-host":f[1];const $=/[a-zA-Z-]+\.js/g;let a="";do f=$.exec(h),f&&(a+=f+" ");while(f);return a&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${a})`:h}if(process.platform==="win32"){const h=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,p)=>{Y(["@vscode/windows-process-tree"],m,p)}).then(m=>{m.getProcessList(D,p=>{if(!p){d(new Error(`Root process ${D} not found`));return}m.getProcessCpuUsage(p,k=>{const g=new Map;k.forEach(l=>{const f=h(l.commandLine||"");g.set(l.pid,{name:y(f),cmd:f,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),u=g.get(D),u?(g.forEach(l=>{const f=g.get(l.ppid);f&&(f.children||(f.children=[]),f.children.push(l))}),g.forEach(l=>{l.children&&(l.children=l.children.sort((f,$)=>f.pid-$.pid))}),P(u)):d(new Error(`Root process ${D} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let h=function(){let m=[u];const p=[];for(;m.length;){const g=m.shift();g&&(p.push(g.pid),g.children&&(m=m.concat(g.children)))}let k=JSON.stringify(O.$pg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);k+=" "+p.join(" "),(0,S.exec)(k,{},(g,l,f)=>{if(g||f)d(g||new Error(f.toString()));else{const $=l.toString().split(`
`);for(let a=0;a<p.length;a++){const t=b.get(p[a]);t.load=parseFloat($[a])}if(!u){d(new Error(`Root process ${D} not found`));return}P(u)}})};(0,S.exec)("which ps",{},(m,p,k)=>{if(m||k)if(process.platform!=="linux")d(m||new Error(k.toString()));else{const g=JSON.stringify(O.$pg.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(g,{},(l,f,$)=>{l||$?d(l||new Error($.toString())):(M(f,v),h())})}else{const g=p.toString().trim();(0,S.exec)(`${g} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,$,a)=>{f||a&&!a.includes("screen size is bogus")?d(f||new Error(a.toString())):(M($,v),process.platform==="linux"?h():u?P(u):d(new Error(`Root process ${D} not found`)))})}})}})}e.$7r=s;function M(D,P){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=D.toString().split(`
`);for(const b of u){const v=d.exec(b.trim());v&&v.length===6&&P(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ae[110],ce([0,1,26,4,108,89]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=void 0;async function D(v,y){return v===1?O.$i?b():M.$Vl(y):d(v,y)}e.$Xl=D;let P=null;function d(v,y){if(O.$k&&v===2||O.$j&&v===3)return"/bin/bash";if(!P){let h;if(O.$i)h="/bin/bash";else{if(h=y.SHELL,!h)try{h=(0,S.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}P=h}return P}let u=null;async function b(){return u||(u=(await(0,s.$Sl)()).exePath),u}});var ve=this&&this.__decorate||function(Y,e,S,O){var s=arguments.length,M=s<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,S):O,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Y,e,S,O);else for(var P=Y.length-1;P>=0;P--)(D=Y[P])&&(M=(s<3?D(M):s>3?D(e,S,M):D(e,S))||M);return s>3&&M&&Object.defineProperty(e,S,M),M};define(ae[43],ce([0,1,22,8,17,23,50,14,3,2,76,25,12]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.ProxyChannel=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.RequestInitiator=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;var h;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(h||(h={}));function m(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(p||(p={}));function k(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(g||(g={}));function l(q){let L=0;for(let T=0;;T+=7){const G=q.read(1);if(L|=(G.buffer[0]&127)<<T,!(G.buffer[0]&128))return L}}const f=r(0);function $(q,L){if(L===0){q.write(f);return}let T=0;for(let B=L;B!==0;B=B>>>7)T++;const G=s.$ke.alloc(T);for(let B=0;L!==0;B++)G.buffer[B]=L&127,L=L>>>7,L>0&&(G.buffer[B]|=128);q.write(G)}class a{constructor(L){this.b=L,this.a=0}read(L){const T=this.b.slice(this.a,this.a+L);return this.a+=T.byteLength,T}}e.$Fh=a;class t{constructor(){this.a=[]}get buffer(){return s.$ke.concat(this.a)}write(L){this.a.push(L)}}e.$Gh=t;var o;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(o||(o={}));function r(q){const L=s.$ke.alloc(1);return L.writeUInt8(q,0),L}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function c(q,L){if(typeof L>"u")q.write(i.Undefined);else if(typeof L=="string"){const T=s.$ke.fromString(L);q.write(i.String),$(q,T.byteLength),q.write(T)}else if(n&&Buffer.isBuffer(L)){const T=s.$ke.wrap(L);q.write(i.Buffer),$(q,T.byteLength),q.write(T)}else if(L instanceof s.$ke)q.write(i.VSBuffer),$(q,L.byteLength),q.write(L);else if(Array.isArray(L)){q.write(i.Array),$(q,L.length);for(const T of L)c(q,T)}else if(typeof L=="number"&&(L|0)===L)q.write(i.Uint),$(q,L);else{const T=s.$ke.fromString(JSON.stringify(L));q.write(i.Object),$(q,T.byteLength),q.write(T)}}e.$Hh=c;function w(q){switch(q.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return q.read(l(q)).toString();case o.Buffer:return q.read(l(q)).buffer;case o.VSBuffer:return q.read(l(q));case o.Array:{const T=l(q),G=[];for(let B=0;B<T;B++)G.push(w(q));return G}case o.Object:return JSON.parse(q.read(l(q)).toString());case o.Int:return l(q)}}e.$Ih=w;class A{constructor(L,T,G=null,B=1e3){this.h=L,this.j=T,this.k=G,this.l=B,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(L,T){this.b.set(L,T),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const T=this.o([L.type]);this.k?.logOutgoing(T,0,1,k(L.type));return}case 201:case 202:case 204:case 203:{const T=this.o([L.type,L.id],L.data);this.k?.logOutgoing(T,L.id,1,k(L.type),L.data);return}}}o(L,T=void 0){const G=new t;return c(G,L),c(G,T),this.p(G.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const T=new a(L),G=w(T),B=w(T),oe=G[0];switch(oe){case 100:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}: ${G[2]}.${G[3]}`,B),this.s({type:oe,id:G[1],channelName:G[2],name:G[3],arg:B});case 102:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}: ${G[2]}.${G[3]}`,B),this.t({type:oe,id:G[1],channelName:G[2],name:G[3],arg:B});case 101:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}`),this.u({type:oe,id:G[1]});case 103:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}`),this.u({type:oe,id:G[1]})}}s(L){const T=this.b.get(L.channelName);if(!T){this.v(L);return}const G=new M.$7d;let B;try{B=T.call(this.j,L.name,L.arg,G.token)}catch(K){B=Promise.reject(K)}const oe=L.id;B.then(K=>{this.m({id:oe,data:K,type:201})},K=>{K instanceof Error?this.m({id:oe,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:oe,data:K,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,u.$Rc)(()=>G.cancel());this.d.set(L.id,he)}t(L){const T=this.b.get(L.channelName);if(!T){this.v(L);return}const G=L.id,oe=T.listen(this.j,L.name,L.arg)(he=>this.m({id:G,data:he,type:204}));this.d.set(L.id,oe)}u(L){const T=this.d.get(L.id);T&&(T.dispose(),this.d.delete(L.id))}v(L){let T=this.g.get(L.channelName);T||(T=[],this.g.set(L.channelName,T));const G=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);T.push({request:L,timeoutTimer:G})}w(L){const T=this.g.get(L);if(T){for(const G of T)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$Oc)(this.d.values()),this.d.clear()}}e.$Jh=A;var I;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class E{constructor(L,T=null){this.l=L,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=T}getChannel(L){const T=this;return{call(G,B,oe){return T.a?Promise.reject(new P.$5):T.m(L,G,B,oe)},listen(G,B){return T.a?d.Event.None:T.o(L,G,B)}}}m(L,T,G,B=M.CancellationToken.None){const oe=this.g++,K={id:oe,type:100,channelName:L,name:T,arg:G};if(B.isCancellationRequested)return Promise.reject(new P.$5);let R;return new Promise((x,N)=>{if(B.isCancellationRequested)return N(new P.$5);const Q=()=>{const ee=ne=>{switch(ne.type){case 201:this.f.delete(oe),x(ne.data);break;case 202:{this.f.delete(oe);const de=new Error(ne.data.message);de.stack=Array.isArray(ne.data.stack)?ne.data.stack.join(`
`):ne.data.stack,de.name=ne.data.name,N(de);break}case 203:this.f.delete(oe),N(ne.data);break}};this.f.set(oe,ee),this.p(K)};let V=null;this.b===g.Idle?Q():(V=(0,O.$Ug)(ee=>this.u()),V.then(()=>{V=null,Q()}));const _=()=>{V?(V.cancel(),V=null):this.p({id:oe,type:101}),N(new P.$5)},z=B.onCancellationRequested(_);R=(0,u.$Qc)((0,u.$Rc)(_),z),this.d.add(R)}).finally(()=>{R.dispose(),this.d.delete(R)})}o(L,T,G){const B=this.g++,he={id:B,type:102,channelName:L,name:T,arg:G};let K=null;const R=new d.$Wd({onWillAddFirstListener:()=>{K=(0,O.$Ug)(x=>this.u()),K.then(()=>{K=null,this.d.add(R),this.p(he)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(R),this.p({id:B,type:103}))}}),W=x=>R.fire(x.data);return this.f.set(B,W),R.event}p(L){switch(L.type){case 100:case 102:{const T=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(T,L.id,0,`${m(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const T=this.q([L.type,L.id]);this.j?.logOutgoing(T,L.id,0,m(L.type));return}}}q(L,T=void 0){const G=new t;return c(G,L),c(G,T),this.r(G.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const T=new a(L),G=w(T),B=w(T),oe=G[0];switch(oe){case 200:return this.j?.logIncoming(L.byteLength,0,0,k(oe)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,G[1],0,k(oe),B),this.t({type:G[0],id:G[1],data:B})}}t(L){if(L.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$Oc)(this.d.values()),this.d.clear()}}e.$Kh=E,ve([D.$zh],E.prototype,"onDidInitializePromise",null);class C{get connections(){const L=[];return this.f.forEach(T=>L.push(T)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new d.$Wd,this.onDidAddConnection=this.g.event,this.h=new d.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new u.$Sc,this.j.add(L(({protocol:T,onDidClientDisconnect:G})=>{const B=d.Event.once(T.onMessage);this.j.add(B(oe=>{const he=new a(oe),K=w(he),R=new A(T,K),W=new E(T);this.a.forEach((N,Q)=>R.registerChannel(Q,N));const x={channelServer:R,channelClient:W,ctx:K};this.f.add(x),this.g.fire(x),this.j.add(G(()=>{R.dispose(),W.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(L,T){const G=this;return{call(B,oe,he){let K;if((0,y.$Xf)(T)){const W=(0,S.$4b)(G.connections.filter(T));K=W?Promise.resolve(W):d.Event.toPromise(d.Event.filter(G.onDidAddConnection,T))}else K=T.routeCall(G,B,oe);const R=K.then(W=>W.channelClient.getChannel(L));return U(R).call(B,oe,he)},listen(B,oe){if((0,y.$Xf)(T))return G.k(L,T,B,oe);const he=T.routeEvent(G,B,oe).then(K=>K.channelClient.getChannel(L));return U(he).listen(B,oe)}}}k(L,T,G,B){const oe=this;let he;const K=new d.$Wd({onWillAddFirstListener:()=>{he=new u.$Sc;const R=new d.$3d,W=new Map,x=Q=>{const _=Q.channelClient.getChannel(L).listen(G,B),z=R.add(_);W.set(Q,z)},N=Q=>{const V=W.get(Q);V&&(V.dispose(),W.delete(Q))};oe.connections.filter(T).forEach(x),d.Event.filter(oe.onDidAddConnection,T)(x,void 0,he),oe.onDidRemoveConnection(N,void 0,he),R.event(K.fire,K,he),he.add(R)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return K.event}registerChannel(L,T){this.a.set(L,T);for(const G of this.f)G.channelServer.registerChannel(L,T)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Lh=C;class j{constructor(L,T,G=null){const B=new t;c(B,T),L.send(B.buffer),this.a=new E(L,G),this.d=new A(L,T,G)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,T){this.d.registerChannel(L,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Mh=j;function U(q){return{call(L,T,G){return q.then(B=>B.call(L,T,G))},listen(L,T){const G=new d.$6d;return q.then(B=>G.input=B.listen(L,T)),G.event}}}e.$Nh=U;function F(q){let L=!1;return{call(T,G,B){return L?q.call(T,G,B):(0,O.$9g)(0).then(()=>L=!0).then(()=>q.call(T,G,B))},listen(T,G){if(L)return q.listen(T,G);const B=new d.$6d;return(0,O.$9g)(0).then(()=>L=!0).then(()=>B.input=q.listen(T,G)),B.event}}}e.$Oh=F;class H{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const T of L.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await d.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$Ph=H;var J;(function(q){function L(oe,he,K){const R=oe,W=K&&K.disableMarshalling,x=new Map;for(const N in R)G(N)&&x.set(N,d.Event.buffer(R[N],!0,void 0,he));return new class{listen(N,Q,V){const _=x.get(Q);if(_)return _;if(B(Q)){const z=R[Q];if(typeof z=="function")return z.call(R,V)}throw new P.$bb(`Event not found: ${Q}`)}call(N,Q,V){const _=R[Q];if(typeof _=="function"){if(!W&&Array.isArray(V))for(let ee=0;ee<V.length;ee++)V[ee]=(0,b.$Eh)(V[ee]);let z=_.apply(R,V);return z instanceof Promise||(z=Promise.resolve(z)),z}throw new P.$bb(`Method not found: ${Q}`)}}}q.fromService=L;function T(oe,he){const K=he&&he.disableMarshalling;return new Proxy({},{get(R,W){if(typeof W=="string")return he?.properties?.has(W)?he.properties.get(W):B(W)?function(x){return oe.listen(W,x)}:G(W)?oe.listen(W):async function(...x){let N;he&&!(0,y.$Sf)(he.context)?N=[he.context,...x]:N=x;const Q=await oe.call(W,N);return K?Q:(0,b.$Eh)(Q)};throw new P.$bb(`Property not found: ${String(W)}`)}})}q.toService=T;function G(oe){return oe[0]==="o"&&oe[1]==="n"&&v.$_e(oe.charCodeAt(2))}function B(oe){return/^onDynamic/.test(oe)&&v.$_e(oe.charCodeAt(9))}})(J||(e.ProxyChannel=J={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const L=q.toString();if(L!=="[object Object]")return L}return q}function ue(q){return Array.isArray(q)?q.map(re):re(q)}function Z(q,L,T,G,B,oe,he){he=ue(he);const K=le[B],R=K[G%K.length];let W=[`%c[${q}]%c[${String(L).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(oe)?(W=W.concat(he),W.push(")")):W.push(he),console.log.apply(console,W)}class X{constructor(L,T){this.d=L,this.f=T,this.a=0,this.b=0}logOutgoing(L,T,G,B,oe){this.b+=L,Z(this.d,this.b,L,T,G,B,oe)}logIncoming(L,T,G,B,oe){this.a+=L,Z(this.f,this.a,L,T,G,B,oe)}}e.$Qh=X}),define(ae[157],ce([0,1,17,3,43]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZU=e.$YU=void 0;class M{constructor(d){this.a=d,this.onMessage=O.Event.fromDOMEventEmitter(this.a,"message",u=>u.data?S.$ke.wrap(u.data):S.$ke.alloc(0)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}e.$YU=M;class D extends s.$Mh{constructor(d,u){const b=new M(d);super(b,u),this.b=b}dispose(){this.b.disconnect(),super.dispose()}}e.$ZU=D}),define(ae[111],ce([0,1,17,3,2,43]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.ProtocolConstants=e.$Rh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let c=0;function w(I,E){if(!n.has(I)){const C=String(++c);n.set(I,C)}return n.get(I)}function A(I,E,C,j){if(!i.enableDiagnostics)return;const U=w(I,E);if(j instanceof S.$ke||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const F=S.$ke.alloc(j.byteLength);F.set(j),i.records.push({timestamp:Date.now(),id:U,label:E,type:C,buff:F})}else i.records.push({timestamp:Date.now(),id:U,label:E,type:C,data:j})}i.traceSocketEvent=A})(P||(e.SocketDiagnostics=P={}));var d;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d||(e.SocketCloseEventType=d={}));let u=null;function b(){return u||(u=S.$ke.alloc(0)),u}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,c){if(n===0)return b();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const E=this.a[0];return c&&(this.a.shift(),this.b-=n),E}if(this.a[0].byteLength>n){const E=this.a[0].slice(0,n);return c&&(this.a[0]=this.a[0].slice(n),this.b-=n),E}const w=S.$ke.alloc(n);let A=0,I=0;for(;n>0;){const E=this.a[I];if(E.byteLength>n){const C=E.slice(0,n);w.set(C,A),A+=n,c&&(this.a[I]=E.slice(n),this.b-=n),n-=n}else w.set(E,A),A+=E.byteLength,c?(this.a.shift(),this.b-=E.byteLength):I++,n-=E.byteLength}return w}}e.$Rh=v;var y;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(y||(y={}));function h(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(m||(e.ProtocolConstants=m={}));class p{constructor(n,c,w,A){this.type=n,this.id=c,this.ack=w,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class k extends s.$Tc{constructor(n){super(),this.f=this.B(new O.$Wd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new v,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const w=this.g.messageType,A=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new p(w,A,I,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=S.$ke.alloc(13);c.writeUInt8(n.type,0),c.writeUInt32BE(n.id,1),c.writeUInt32BE(n.ack,5),c.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(c,n.data)}g(n,c){const w=this.f===0;return this.d.push(n,c),this.f+=n.byteLength+c.byteLength,w}h(){const n=S.$ke.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,c){this.g(n,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class l extends s.$Tc{constructor(n){super(),this.f=new O.$Wd,this.onMessage=this.f.event,this.g=new O.$Wd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new g(this.a)),this.c=this.B(new k(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new p(1,0,0,n))}}e.$Sh=l;class f extends M.$Mh{static fromSocket(n,c){return new f(new l(n),c)}get onDidDispose(){return this.b.onDidDispose}constructor(n,c,w=null){super(n,c,w),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Th=f;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$Wd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Uh=$;class a{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,c=this.a;for(;c;)c=c.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let c=0,w=this.a;for(;w;)n[c++]=w.data,w=w.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const c=new a(n);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let c=0;c<o.a;c++)this.c[c]=n-1e3*c;setInterval(()=>{for(let c=o.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),c=(1+o.a)*1e3;let w=0;for(let A=0;A<o.a;A++)n-this.c[A]<=c&&w++;return 1-w/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new $,this.onControlMessage=this.u.event,this.v=new $,this.onMessage=this.v.event,this.w=new $,this.onDidDispose=this.w.event,this.x=new $,this.onSocketClose=this.x.event,this.y=new $,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Sc,this.o=n.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new k(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new p(5,0,0,b());this.p.write(n),this.p.flush()}sendPause(){const n=new p(7,0,0,b());this.p.write(n)}sendResume(){const n=new p(8,0,0,b());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,c){this.a=!0,this.r.dispose(),this.r=new s.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new k(this.o)),this.r.add(this.q.onMessage(w=>this.z(w))),this.r.add(this.o.onClose(w=>this.x.fire(w))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new p(3,0,this.h,b());this.p.write(n);const c=this.b.toArray();for(let w=0,A=c.length;w<A;w++)this.p.write(c[w]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const c=this.b.peek();if(c&&c.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new p(6,0,0,b())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const c=this.b.toArray();for(let w=0,A=c.length;w<A;w++)this.p.write(c[w]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const c=++this.c;this.h=this.g;const w=new p(1,c,this.h,n);this.b.push(w),this.a||(this.p.write(w),this.B())}sendControl(n){const c=new p(2,0,0,n);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),c=Date.now()-n.writtenTime,w=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(c>=2e4&&w>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:w});return}const I=Math.max(2e4-c,2e4-w,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new p(3,0,this.h,b());this.p.write(n)}D(){this.h=this.g;const n=new p(9,0,this.h,b());this.p.write(n)}}e.$Vh=r}),define(ae[37],ce([0,1,15,14,13]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VU=void 0;class M{constructor(){this.a=new WeakMap}on(P,d){const u=(b,...v)=>{this.b(P,b)&&d(b,...v)};return this.a.set(d,u),S.ipcMain.on(P,u),this}once(P,d){return S.ipcMain.once(P,(u,...b)=>{this.b(P,u)&&d(u,...b)}),this}handle(P,d){return S.ipcMain.handle(P,(u,...b)=>this.b(P,u)?d(u,...b):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return S.ipcMain.removeHandler(P),this}removeListener(P,d){const u=this.a.get(d);return u&&(S.ipcMain.removeListener(P,u),this.a.delete(d)),this}b(P,d){if(!P||!P.startsWith("vscode:"))return(0,O.$1)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const u=d.senderFrame,b=u.url;if(!b||b==="about:blank")return!0;let v="unknown";try{v=new URL(b).host}catch{return(0,O.$1)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${b}'.`),!1}return v!==s.$og?((0,O.$1)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${v}'.`),!1):u.parent!==null?((0,O.$1)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${v}' is not a main frame.`),!1):!0}}e.$VU=new M}),define(ae[158],ce([0,1,15,37,146]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WU=void 0;function M(){O.$VU.on(s.$TU,(P,d,u,b,v)=>{const y=D(P,b,u);y.popup({x:v?v.x:void 0,y:v?v.y:void 0,positioningItem:v?v.positioningItem:void 0,callback:()=>{y&&P.sender.send(s.$UU,d)}})})}e.$WU=M;function D(P,d,u){const b=new S.Menu;return u.forEach(v=>{let y;v.type==="separator"?y=new S.MenuItem({type:v.type}):Array.isArray(v.submenu)?y=new S.MenuItem({submenu:D(P,d,v.submenu),label:v.label}):y=new S.MenuItem({label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:v.enabled,visible:v.visible,click:(h,m,p)=>P.sender.send(d,v.id,p)}),b.append(y)}),b}}),define(ae[159],ce([0,1,37,17,3,2,43,147]),function(Y,e,S,O,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3U=void 0;function d(b,v){const y=s.Event.fromNodeEventEmitter(S.$VU,v,(m,p)=>({event:m,message:p})),h=s.Event.filter(y,({event:m})=>m.sender.id===b);return s.Event.map(h,({message:m})=>m&&O.$ke.wrap(m))}class u extends D.$Lh{static{this.b=new Map}static d(){const v=s.Event.fromNodeEventEmitter(S.$VU,"vscode:hello",({sender:y})=>y);return s.Event.map(v,y=>{const h=y.id;u.b.get(h)?.dispose();const p=new s.$Wd;u.b.set(h,(0,M.$Rc)(()=>p.fire()));const k=d(h,"vscode:message"),g=s.Event.any(s.Event.signal(d(h,"vscode:disconnect")),p.event);return{protocol:new P.$2U(y,k),onDidClientDisconnect:g}})}constructor(){super(u.d())}}e.$3U=u}),define(ae[112],ce([0,1,37,3,32,157]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5U=e.$4U=void 0;class D extends M.$ZU{constructor(u,b){super({addEventListener:(v,y)=>u.addListener(v,y),removeEventListener:(v,y)=>u.removeListener(v,y),postMessage:v=>u.postMessage(v),start:()=>u.start(),close:()=>u.close()},b)}}e.$4U=D;async function P(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const u=(0,s.$rg)();d.webContents.send("vscode:createMessageChannel",u);const b=O.Event.fromNodeEventEmitter(S.$VU,"vscode:createMessageChannelResult",(y,h)=>({nonce:h,port:y.ports[0]})),{port:v}=await O.Event.toPromise(O.Event.once(O.Event.filter(b,y=>y.nonce===u)));return v}e.$5U=P}),define(ae[160],ce([0,1,48,8,17,23,154,14,3,2,35,89,75,43]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;class m extends h.$Jh{constructor(g){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",l=>s.$ke.wrap(Buffer.from(l,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$sq=m;class p{constructor(g,l){this.i=g,this.j=l,this.c=new Set,this.g=new Map,this.h=new d.$Wd,this.onDidProcessExit=this.h.event;const f=l&&l.timeout?l.timeout:6e4;this.b=new O.$5g(f),this.d=null,this.f=null}getChannel(g){const l=this;return{call(f,$,a){return l.k(g,f,$,a)},listen(f,$){return l.l(g,f,$)}}}k(g,l,f,$=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const a=this.n(g),t=(0,O.$Ug)(i=>a.call(l,f,i)),o=$.onCancellationRequested(()=>t.cancel()),r=(0,u.$Rc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,l,f){if(!this.b)return d.Event.None;this.b.cancel();let $;const a=new d.$Wd({onWillAddFirstListener:()=>{$=this.n(g).listen(l,f)(a.fire,a),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,b.$yn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.$Ul)(l.env),this.d=(0,S.fork)(this.i,g,l);const f=new d.$Wd;d.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$oq)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}f.fire(s.$ke.wrap(Buffer.from(n,"base64")))});const a=this.j.useQueue?(0,v.$Wl)(this.d):this.d,t=n=>this.d&&this.d.connected&&a.send(n.buffer.toString("base64")),o=f.event,r={send:t,onMessage:o};this.f=new h.$Kh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,c)=>{process.removeListener("exit",i),this.c.forEach(w=>(0,u.$Oc)(w)),this.c.clear(),n!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:c})})}return this.f}n(g){let l=this.g.get(g);return l||(l=this.m.getChannel(g),this.g.set(g,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$tq=p}),define(ae[113],ce([0,1,8,3,2,76,12]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.StorageState=e.$rp=e.StorageHint=void 0;var P;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function d(y){const h=y;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$rp=d;var u;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(u||(e.StorageState=u={}));class b extends s.$Tc{static{this.a=100}constructor(h,m=Object.create(null)){super(),this.r=h,this.s=m,this.b=this.B(new O.$Zd),this.onDidChangeStorage=this.b.event,this.c=u.None,this.f=new Map,this.g=this.B(new S.$6g(b.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach((m,p)=>this.w(p,m)),h.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(h,m){if(this.c===u.Closed)return;let p=!1;(0,D.$Sf)(m)?p=this.f.delete(h):this.f.get(h)!==m&&(this.f.set(h,m),p=!0),p&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===u.None&&(this.c=u.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,m){const p=this.f.get(h);return(0,D.$Sf)(p)?m:p}getBoolean(h,m){const p=this.get(h);return(0,D.$Sf)(p)?m:p==="true"}getNumber(h,m){const p=this.get(h);return(0,D.$Sf)(p)?m:parseInt(p,10)}getObject(h,m){const p=this.get(h);return(0,D.$Sf)(p)?m:(0,M.$Dh)(p)}async set(h,m,p=!1){if(this.c===u.Closed)return;if((0,D.$Sf)(m))return this.delete(h,p);const k=(0,D.$Lf)(m)||Array.isArray(m)?(0,M.$Ch)(m):String(m);if(this.f.get(h)!==k)return this.f.set(h,k),this.j.set(h,k),this.h.delete(h),this.b.fire({key:h,external:p}),this.D()}async delete(h,m=!1){if(!(this.c===u.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:m}),this.D()}async optimize(){if(this.c!==u.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=u.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(this.z)return this.D(h)}async D(h){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$sp=b;class v{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((m,p)=>this.a.set(p,m)),h.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$tp=v}),define(ae[161],ce([0,1,8,3,31,9,21]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oV=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return O.Event.None}static{this.a=2e3}static{this.b=256}constructor(b,v=Object.create(null)){this.g=b,this.h=v,this.c=(0,M.$nc)(this.g),this.d=new d(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,v=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(h=>v.set(h.key,h.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(b){const v=await this.f;return this.j(v,b)}j(b,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,s.$yc)(v.insert):"0"}), delete(${v.delete?(0,s.$zc)(v.delete):"0"})`),this.t(b,()=>{const y=v.insert,h=v.delete;if(y&&y.size>0){const m=[];m.push([]);let p=0;y.forEach((k,g)=>{let l=m[p];l.length>P.b&&(p++,l=[],m.push(l)),l.push(g,k)}),m.forEach(k=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(k.length/2).fill("(?,?)").join(",")}`,g=>g.run(k),()=>{const g=[];let l=0;return y.forEach((f,$)=>{g.push($),l+=f.length}),`Keys: ${g.join(", ")} Length: ${l}`})})}if(h&&h.size){const m=[];m.push([]);let p=0;h.forEach(k=>{let g=m[p];g.length>P.b&&(p++,g=[],m.push(g)),g.push(k)}),m.forEach(k=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(k.length).fill("?").join(",")})`,g=>g.run(k),()=>{const g=[];return h.forEach(l=>{g.push(l)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const b=await this.f;return this.q(b,"VACUUM")}async close(b){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,b)}k(b,v){return new Promise((y,h)=>{b.db.close(m=>(m&&this.o(b,`[storage ${this.c}] close(): ${m}`),this.g===P.IN_MEMORY_PATH?y():!b.isErroneous&&!b.isInMemory?this.l().then(y,p=>(this.d.error(`[storage ${this.c}] backup(): ${p}`),y())):typeof v=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(p=>{const k=()=>this.k(p,void 0);return this.j(p,{insert:v()}).then(()=>k(),g=>(k(),Promise.reject(g)))})).then(y,h):h(m||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return D.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const v=await this.f,y=await this.r(v,b?"PRAGMA integrity_check":"PRAGMA quick_check"),h=b?y.integrity_check:y.quick_check;return v.isErroneous?`${h} (last error: ${v.lastError})`:v.isInMemory?`${h} (in-memory!)`:h}async n(b,v=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${v})`);try{return await this.p(b)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&v)return await(0,S.$9g)(P.a),this.n(b,!1);try{await D.Promises.unlink(b);try{await D.Promises.rename(this.m(b),b,!1)}catch{}return await this.p(b)}catch(h){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${h}`),this.p(P.IN_MEMORY_PATH)}}}o(b,v){b.isErroneous=!0,b.lastError=v,this.d.error(v)}p(b){return new Promise((v,y)=>{new Promise((h,m)=>{Y(["@vscode/sqlite3"],h,m)}).then(h=>{const m={db:new(this.d.isTracing?h.verbose().Database:h.Database)(b,p=>p?m.db&&p.code!=="SQLITE_CANTOPEN"?m.db.close(()=>y(p)):y(p):this.q(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(m),k=>m.db.close(()=>y(k)))),isInMemory:b===P.IN_MEMORY_PATH};m.db.on("error",p=>this.o(m,`[storage ${this.c}] Error (event): ${p}`)),this.d.isTracing&&m.db.on("trace",p=>this.d.trace(`[storage ${this.c}] Trace (event): ${p}`))},y)})}q(b,v){return new Promise((y,h)=>{b.db.exec(v,m=>m?(this.o(b,`[storage ${this.c}] exec(): ${m}`),h(m)):y())})}r(b,v){return new Promise((y,h)=>{b.db.get(v,(m,p)=>m?(this.o(b,`[storage ${this.c}] get(): ${m}`),h(m)):y(p))})}s(b,v){return new Promise((y,h)=>{b.db.all(v,(m,p)=>m?(this.o(b,`[storage ${this.c}] all(): ${m}`),h(m)):y(p))})}t(b,v){return new Promise((y,h)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),v(),b.db.run("END TRANSACTION",m=>m?(this.o(b,`[storage ${this.c}] transaction(): ${m}`),h(m)):y())})})}u(b,v,y,h){const m=b.db.prepare(v),p=k=>{this.o(b,`[storage ${this.c}] prepare(): ${k} (${v}). Details: ${h()}`)};m.on("error",p),y(m),m.finalize(k=>{k&&p(k),m.removeListener("error",p)})}}e.$oV=P;class d{static{this.a="VSCODE_TRACE_STORAGE"}constructor(b){b&&typeof b.logTrace=="function"&&process.env[d.a]&&(this.b=b.logTrace),b&&typeof b.logError=="function"&&(this.c=b.logError)}get isTracing(){return!!this.b}trace(b){this.b?.(b)}error(b){this.c?.(b)}}}),define(ae[162],ce([11,10]),function(Y,e){return Y.create("vs/code/electron-main/app",e)}),define(ae[163],ce([11,10]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[164],ce([11,10]),function(Y,e){return Y.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[165],ce([11,10]),function(Y,e){return Y.create("vs/platform/contextkey/common/scanner",e)}),define(ae[166],ce([11,10]),function(Y,e){return Y.create("vs/platform/dialogs/common/dialogs",e)}),define(ae[167],ce([11,10]),function(Y,e){return Y.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ae[168],ce([11,10]),function(Y,e){return Y.create("vs/platform/environment/node/argv",e)}),define(ae[169],ce([11,10]),function(Y,e){return Y.create("vs/platform/environment/node/argvHelper",e)}),define(ae[170],ce([11,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[171],ce([11,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[172],ce([11,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[173],ce([11,10]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[174],ce([11,10]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ae[175],ce([11,10]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(ae[176],ce([11,10]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ae[177],ce([11,10]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(ae[178],ce([11,10]),function(Y,e){return Y.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ae[179],ce([11,10]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[180],ce([11,10]),function(Y,e){return Y.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ae[181],ce([11,10]),function(Y,e){return Y.create("vs/platform/menubar/electron-main/menubar",e)}),define(ae[182],ce([11,10]),function(Y,e){return Y.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ae[183],ce([11,10]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(ae[184],ce([11,10]),function(Y,e){return Y.create("vs/platform/shell/node/shellEnv",e)}),define(ae[185],ce([11,10]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[186],ce([11,10]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ae[187],ce([11,10]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ae[188],ce([11,10]),function(Y,e){return Y.create("vs/platform/update/common/update.config.contribution",e)}),define(ae[189],ce([11,10]),function(Y,e){return Y.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[190],ce([11,10]),function(Y,e){return Y.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ae[191],ce([11,10]),function(Y,e){return Y.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ae[192],ce([11,10]),function(Y,e){return Y.create("vs/platform/workspace/common/workspace",e)}),define(ae[193],ce([11,10]),function(Y,e){return Y.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ae[194],ce([11,10]),function(Y,e){return Y.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ae[195],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cb=e.$5cb=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$5cb=S;function O(s){return s&&s.hasOwnProperty("workspace")}e.$6cb=O}),define(ae[196],ce([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p0b=e.$o0b=e.$n0b=void 0;function O(D){return typeof D?.backupFolder=="string"}e.$n0b=O;function s(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(d=>({workspace:{id:d.id,configPath:S.URI.parse(d.configURIPath)},remoteAuthority:d.remoteAuthority})))}catch{}return P}e.$o0b=s;function M(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(d=>({folderUri:S.URI.parse(d.folderUri),remoteAuthority:d.remoteAuthority})))}catch{}return P}e.$p0b=M}),define(ae[197],ce([0,1,14,165]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.TokenType=void 0;var s;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...u){switch(u.length){case 1:return(0,O.localize)(0,null,u[0]);case 2:return(0,O.localize)(1,null,u[0],u[1]);case 3:return(0,O.localize)(2,null,u[0],u[1],u[2]);default:return}}const D=(0,O.localize)(3,null),P=(0,O.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const v=this.d,y=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:y};this.g.push({offset:v,lexeme:y,additionalInfo:b}),this.f.push(h)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const v=this.c.substring(this.d,this.e),y=d.b.get(v);y?this.k(y):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,v=!1,y=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(P);return}const m=this.c.charCodeAt(b);if(v)v=!1;else if(m===47&&!y){b++;break}else m===91?y=!0:m===92?v=!0:m===93&&(y=!1);b++}for(;b<this.c.length&&d.a.has(this.c.charCodeAt(b));)b++;this.e=b;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$3i=d}),define(ae[198],ce([0,1,3,2]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=void 0;class s{constructor(){this.a=new S.$Wd,this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd}static{this.ChannelName="extensionhostdebugservice"}call(P,d,u){switch(d){case"close":return Promise.resolve(this.a.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(P,d,u){switch(d){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$eo=s;class M extends O.$Tc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,d,u){this.b.call("attach",[P,d,u])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,d){this.b.call("terminate",[P,d])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,d){return this.b.call("openExtensionDevelopmentHostWindow",[P,d])}}e.$fo=M}),define(ae[199],ce([0,1,149,50,13,9,36,19,7]),function(Y,e,S,O,s,M,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0,e.$Am=/^([^.]+\..+)[:=](.+)$/;class u{get appRoot(){return(0,M.$mc)(s.$pg.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,M.$jc)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,P.$Ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$Ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,S.$zm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$jc)(this.userDataPath,"logs",h)}return d.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$Ig)(d.URI.file((0,M.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$Ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$Ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$Ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=D.env.VSCODE_PORTABLE;return h?d.URI.file((0,M.$jc)(h,"argv.json")):(0,P.$Ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,M.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,M.$kc)(h):(0,M.$hc)((0,M.$jc)(s.$pg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?d.URI.file((0,M.$kc)(h)):d.URI.file((0,M.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,M.$kc)(h);const m=D.env.VSCODE_EXTENSIONS;if(m)return m;const p=D.env.VSCODE_PORTABLE;return p?(0,M.$jc)(p,"extensions"):(0,P.$Ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(m=>/^[^:/?#]+?:\/\//.test(m)?d.URI.parse(m):d.URI.file((0,M.$hc)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?d.URI.parse(h):d.URI.file((0,M.$hc)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Am.test(h))}get extensionLogLevel(){const h=[];for(const m of this.args.log||[]){const p=e.$Am.exec(m);p&&p[1]&&p[2]&&h.push([p[1],p[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,P.$Ig)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=D.env.VSCODE_PORTABLE;return h?d.URI.file((0,M.$jc)(h,"policy.json")):(0,P.$Ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,m,p){this.a=h,this.b=m,this.c=p,this.editSessionId=this.args.editSessionId}}e.$Bm=u,ve([O.$zh],u.prototype,"appRoot",null),ve([O.$zh],u.prototype,"userHome",null),ve([O.$zh],u.prototype,"userDataPath",null),ve([O.$zh],u.prototype,"appSettingsHome",null),ve([O.$zh],u.prototype,"tmpDir",null),ve([O.$zh],u.prototype,"cacheHome",null),ve([O.$zh],u.prototype,"stateResource",null),ve([O.$zh],u.prototype,"userRoamingDataHome",null),ve([O.$zh],u.prototype,"userDataSyncHome",null),ve([O.$zh],u.prototype,"sync",null),ve([O.$zh],u.prototype,"machineSettingsResource",null),ve([O.$zh],u.prototype,"workspaceStorageHome",null),ve([O.$zh],u.prototype,"localHistoryHome",null),ve([O.$zh],u.prototype,"keyboardLayoutResource",null),ve([O.$zh],u.prototype,"argvResource",null),ve([O.$zh],u.prototype,"isExtensionDevelopment",null),ve([O.$zh],u.prototype,"untitledWorkspacesHome",null),ve([O.$zh],u.prototype,"builtinExtensionsPath",null),ve([O.$zh],u.prototype,"extensionsPath",null),ve([O.$zh],u.prototype,"extensionDevelopmentLocationURI",null),ve([O.$zh],u.prototype,"extensionDevelopmentKind",null),ve([O.$zh],u.prototype,"extensionTestsLocationURI",null),ve([O.$zh],u.prototype,"debugExtensionHost",null),ve([O.$zh],u.prototype,"logLevel",null),ve([O.$zh],u.prototype,"extensionLogLevel",null),ve([O.$zh],u.prototype,"serviceMachineIdResource",null),ve([O.$zh],u.prototype,"disableTelemetry",null),ve([O.$zh],u.prototype,"disableWorkspaceTrust",null),ve([O.$zh],u.prototype,"useInMemorySecretStorage",null),ve([O.$zh],u.prototype,"policyFile",null);function b(y,h){return v(y["inspect-extensions"],y["inspect-brk-extensions"],5870,h,y.debugId,y.extensionEnvironment)}e.$Cm=b;function v(y,h,m,p,k,g){const f=Number(h||y)||(p?null:m),$=f?!!h:!1;let a;if(g)try{a=JSON.parse(g)}catch{}return{port:f,break:$,debugId:k,env:a}}e.$Dm=v}),define(ae[114],ce([0,1,309,4,168]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Yl=["tunnel","serve-web"],e.$Zl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(p,k,g=D){const l=p.find(c=>c.length>0&&c[0]!=="-"),f={},$=["_"],a=[],t={};let o;for(const c in k){const w=k[c];w.type==="subcommand"?c===l&&(o=w):(w.alias&&(f[c]=w.alias),w.type==="string"||w.type==="string[]"?($.push(c),w.deprecates&&$.push(...w.deprecates)):w.type==="boolean"&&(a.push(c),w.deprecates&&a.push(...w.deprecates)),w.global&&(t[c]=w))}if(o&&l){const c=t;for(const E in o.options)c[E]=o.options[E];const w=p.filter(E=>E!==l),A=g.getSubcommandReporter?g.getSubcommandReporter(l):void 0,I=P(w,c,A);return{[l]:I,_:[]}}const r=S(p,{string:$,boolean:a,alias:f}),i={},n=r;i._=r._.map(c=>String(c)).filter(c=>c.length>0),delete n._;for(const c in k){const w=k[c];if(w.type==="subcommand")continue;w.alias&&delete n[w.alias];let A=n[c];if(w.deprecates)for(const I of w.deprecates)n.hasOwnProperty(I)&&(A||(A=n[I],A&&g.onDeprecatedOption(I,w.deprecationMessage||(0,s.localize)(38,null,c))),delete n[I]);if(typeof A<"u"){if(w.type==="string[]"){if(Array.isArray(A)||(A=[A]),!w.allowEmptyValue){const I=A.filter(E=>E.length>0);I.length!==A.length&&(g.onEmptyValue(c),A=I.length>0?I:void 0)}}else w.type==="string"&&(Array.isArray(A)?(A=A.pop(),g.onMultipleValues(c,A)):!A&&!w.allowEmptyValue&&(g.onEmptyValue(c),A=void 0));i[c]=A,w.deprecationMessage&&g.onDeprecatedOption(c,w.deprecationMessage)}delete n[c]}for(const c in n)g.onUnknownOption(c);return i}e.$1l=P;function d(p,k){let g="";return k.args&&(Array.isArray(k.args)?g=` <${k.args.join("> <")}>`:g=` <${k.args}>`),k.alias?`-${k.alias} --${p}${g}`:`--${p}${g}`}function u(p,k){const g=[];for(const l in p){const f=p[l],$=d(l,f);g.push([$,f.description])}return b(g,k)}e.$2l=u;function b(p,k){const l=p.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(k-l<25)return p.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const f=k-l-1,$=[];for(const a of p){const t=a[0],o=y(a[1],f),r=v(l-t.length-2);$.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)$.push(v(l)+o[i])}return $}function v(p){return" ".repeat(p)}function y(p,k){const g=[];for(;p.length;){const l=p.length<k?p.length:p.lastIndexOf(" ",k),f=p.slice(0,l).trim();p=p.slice(l),g.push(f)}return g}function h(p,k,g,l,f){const $=process.stdout.isTTY&&process.stdout.columns||80,a=f?.noInputFiles!==!0?`[${(0,s.localize)(39,null)}...]`:"",t=[`${p} ${g}`];t.push(""),t.push(`${(0,s.localize)(40,null)}: ${k} [${(0,s.localize)(41,null)}]${a}`),t.push(""),f?.noPipe!==!0&&(O.$i?t.push((0,s.localize)(42,null,k)):t.push((0,s.localize)(43,null,k)),t.push(""));const o={},r=[];for(const i in l){const n=l[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let c=o[n.cat];c||(o[n.cat]=c={}),c[i]=n}}for(const i in o){const n=i,c=o[n];c&&(t.push(M[n]),t.push(...u(c,$)),t.push(""))}return r.length&&(t.push((0,s.localize)(44,null)),t.push(...b(r.map(i=>[i.command,i.description]),$)),t.push("")),t.join(`
`)}e.$3l=h;function m(p,k){return`${p||(0,s.localize)(45,null)}
${k||(0,s.localize)(46,null)}
${process.arch}`}e.$4l=m}),define(ae[200],ce([0,1,87,198,114]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$20b=void 0;class M extends O.$eo{constructor(P){super(),this.f=P}call(P,d,u){return d==="openExtensionDevelopmentHostWindow"?this.g(u[0],u[1]):super.call(P,d,u)}async g(P,d){const u=(0,s.$1l)(P,s.$Zl);u.debugRenderer=d;const b=u.extensionDevelopmentPath;if(!b)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:u,forceProfile:u.profile,forceTempProfile:u["profile-temp"]});if(!d)return{success:!0};const y=v.win;if(!y)return{success:!0};const h=y.webContents.debugger;let m=h.isAttached()?1/0:0;const p=(0,S.createServer)(k=>{m++===0&&h.attach();let g=!1;const l=a=>{g||k.write(JSON.stringify(a)+"\0")},f=(a,t,o,r)=>l({method:t,params:o,sessionId:r});y.on("close",()=>{h.removeListener("message",f),k.end(),g=!0}),h.addListener("message",f);let $=Buffer.alloc(0);k.on("data",a=>{$=Buffer.concat([$,a]);for(let t=$.indexOf(0);t!==-1;t=$.indexOf(0)){let o;try{const r=$.slice(0,t).toString("utf8");$=$.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}h.sendCommand(o.method,o.params,o.sessionId).then(r=>l({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>l({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),k.on("error",a=>{console.error("error on cdp pipe:",a)}),k.on("close",()=>{g=!0,--m===0&&h.detach()})});return await new Promise(k=>p.listen(0,k)),y.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.$20b=M}),define(ae[64],ce([0,1,310,169,114]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.$5l=void 0;function M(v,y){const h=(f,$)=>{console.warn((0,O.localize)(0,null,f,$))},m=f=>{console.warn((0,O.localize)(1,null,f))},p=(f,$)=>{console.warn((0,O.localize)(2,null,f,$))},k=f=>({onUnknownOption:$=>{s.$Yl.includes(f)||console.warn((0,O.localize)(3,null,$,f))},onMultipleValues:h,onEmptyValue:m,onDeprecatedOption:p,getSubcommandReporter:s.$Yl.includes(f)?k:void 0}),g={onUnknownOption:f=>{console.warn((0,O.localize)(4,null,f))},onMultipleValues:h,onEmptyValue:m,onDeprecatedOption:p,getSubcommandReporter:k},l=(0,s.$1l)(v,s.$Zl,y?g:void 0);return l.goto&&l._.forEach(f=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(f),(0,O.localize)(5,null))),l}function D(v){const y=v.findIndex(h=>!/^-/.test(h));if(y>-1)return[...v.slice(0,y),...v.slice(y+1)]}function P(v){let[,...y]=v;process.env.VSCODE_DEV&&(y=D(y)||[]);const h=!b(process.env);return M(y,h)}e.$5l=P;function d(v){let[,,...y]=v;return process.env.VSCODE_DEV&&(y=D(y)||[]),M(y,!0)}e.$6l=d;function u(v,...y){const h=v.indexOf("--");return h===-1?v.push(...y):v.splice(h,0,...y),v}e.$7l=u;function b(v){return v.VSCODE_CLI==="1"}e.$8l=b}),function(){"use strict";function Y(e,S,O){function s(D,P){const d=M(D,P),u=[d];return e.isAbsolute(d)||u.unshift(O),e.resolve(...u)}function M(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,P);const b=D["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(v,"AppData","Roaming")}break;case"darwin":u=e.join(S.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,P)}return{getUserDataPath:s}}if(typeof define=="function")define(ae[201],ce([115,26,36]),function(e,S,O){return Y(e,S,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=Y(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[90],ce([0,1,26,199,201]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=void 0;class M extends O.$Bm{constructor(u,b){super(u,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(u,b.nameShort)},b)}}e.$Em=M;function D(d,u){return(0,O.$Dm)(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,u,d.extensionEnvironment)}e.$Fm=D;function P(d,u){return(0,O.$Dm)(d["inspect-sharedprocess"],d["inspect-brk-sharedprocess"],5879,u,d.extensionEnvironment)}e.$Gm=P}),define(ae[202],ce([0,1,46,26,33]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=void 0;function M(D){const P=(0,s.$eg)((0,O.tmpdir)());try{return(0,S.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(d){D&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.$j_b=M}),define(ae[203],ce([0,1,12,171]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;function s(D,P,d,u){try{M(D,P,d,u)}catch(b){D.error(b?.message??b)}return P}e.$1p=s;function M(D,P,d,u){const b=(v,y,h)=>{const m=v[y];if((0,S.$Jf)(m)){const p=m,k=p.length;if(k>1&&p[0]==="%"&&p[k-1]==="%"){const g=p.substr(1,k-2);let l=d[g];l===void 0&&u&&(l=u[g]);const f=typeof l=="string"?l:l?.message,$=u?.[g],a=typeof $=="string"?$:$?.message;if(!f){a||D.warn(`[${P.name}]: ${(0,O.localize)(0,null,g)}`);return}if(h&&(y==="title"||y==="category")&&a&&a!==f){const t={value:f,original:a};v[y]=t}else v[y]=f}}else if((0,S.$Lf)(m))for(const p in m)m.hasOwnProperty(p)&&(p==="commands"?b(m,p,!0):b(m,p,h));else if(Array.isArray(m))for(let p=0;p<m.length;p++)b(m,p,h)};for(const v in P)P.hasOwnProperty(v)&&b(P,v)}}),define(ae[204],ce([0,1,19,73,173,205]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function d(g){return g=g.trim(),g==="*"||D.test(g)}e.$cp=d;function u(g){if(!d(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=g.match(D);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.$dp=u;function b(g){if(!g)return null;const l=g.majorBase,f=g.majorMustEqual,$=g.minorBase;let a=g.minorMustEqual;const t=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(l===0||(a=!1),o=!1);let r=0;if(g.preRelease){const i=P.exec(g.preRelease);if(i){const[,n,c,w]=i;r=Date.UTC(Number(n),Number(c)-1,Number(w))}}return{majorBase:l,majorMustEqual:f,minorBase:$,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:r}}e.$ep=b;function v(g,l,f){let $;typeof g=="string"?$=b(u(g)):$=g;let a;l instanceof Date?a=l.getTime():typeof l=="string"&&(a=new Date(l).getTime());let t;if(typeof f=="string"?t=b(u(f)):t=f,!$||!t)return!1;const o=$.majorBase,r=$.minorBase,i=$.patchBase;let n=t.majorBase,c=t.minorBase,w=t.patchBase;const A=t.notBefore;let I=t.majorMustEqual,E=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:r>c?!0:r<c||a&&a<A?!1:i>=w:(o===1&&n===0&&(!I||!E||!C)&&(n=1,c=0,w=0,I=!0,E=!1,C=!1),o<n?!1:o>n?!I:r<c?!1:r>c?!E:i<w?!1:i>w?!C:!(a&&a<A))}e.$fp=v;function y(g,l,f,$,a){const t=[];if(typeof $.publisher<"u"&&typeof $.publisher!="string")return t.push([O.default.Error,s.localize(0,null)]),t;if(typeof $.name!="string")return t.push([O.default.Error,s.localize(1,null,"name")]),t;if(typeof $.version!="string")return t.push([O.default.Error,s.localize(2,null,"version")]),t;if(!$.engines)return t.push([O.default.Error,s.localize(3,null,"engines")]),t;if(typeof $.engines.vscode!="string")return t.push([O.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof $.extensionDependencies<"u"&&!k($.extensionDependencies))return t.push([O.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof $.activationEvents<"u"){if(!k($.activationEvents))return t.push([O.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof $.main>"u"&&typeof $.browser>"u")return t.push([O.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof $.extensionKind<"u"&&typeof $.main>"u"&&t.push([O.default.Warning,s.localize(8,null,"extensionKind")]),typeof $.main<"u"){if(typeof $.main!="string")return t.push([O.default.Error,s.localize(9,null,"main")]),t;{const i=(0,S.$Ig)(f,$.main);(0,S.$Cg)(i,f)||t.push([O.default.Warning,s.localize(10,null,i.path,f.path)])}}if(typeof $.browser<"u"){if(typeof $.browser!="string")return t.push([O.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,S.$Ig)(f,$.browser);(0,S.$Cg)(i,f)||t.push([O.default.Warning,s.localize(12,null,i.path,f.path)])}}if(!M.valid($.version))return t.push([O.default.Error,s.localize(13,null)]),t;const o=[];if(!h(g,l,$,a,o))for(const i of o)t.push([O.default.Error,i]);return t}e.$gp=y;function h(g,l,f,$,a){return $||typeof f.main>"u"&&typeof f.browser>"u"?!0:p(g,l,f.engines.vscode,a)}e.$hp=h;function m(g,l,f){return g==="*"||p(l,f,g)}e.$ip=m;function p(g,l,f,$=[]){const a=b(u(f));if(!a)return $.push(s.localize(14,null,f)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return $.push(s.localize(15,null,f)),!1}else if(!a.majorMustEqual)return $.push(s.localize(16,null,f)),!1;return v(g,l,a)?!0:($.push(s.localize(17,null,g,f)),!1)}function k(g){if(!Array.isArray(g))return!1;for(let l=0,f=g.length;l<f;l++)if(typeof g[l]!="string")return!1;return!0}}),define(ae[206],ce([0,1,17,32]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function s(M,D,P){let d=P&&P.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const b=(await D.readFile(M.serviceMachineIdResource)).value.toString();d=(0,O.$qg)(b)?b:null}catch{d=null}if(!d){d=(0,O.$rg)();try{await D.writeFile(M.serviceMachineIdResource,S.$ke.fromString(d))}catch{}}return P?.store("storage.serviceMachineId",d,-1,1),d}e.$Cp=s}),define(ae[77],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class S{constructor(s,M=[],D=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.$5h=S}),define(ae[207],ce([0,1,77]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const O=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(P,d,u){d instanceof S.$5h||(d=new S.$5h(d,[],!!u)),O.push([P,d])}e.$1r=M;function D(){return O}e.$2r=D}),define(ae[208],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class S{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=S;class O{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const D of this.a.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const P=this.lookupOrInsertNode(M),d=this.lookupOrInsertNode(D);P.outgoing.set(d.key,d),d.incoming.set(P.key,P)}removeNode(M){const D=this.b(M);this.a.delete(D);for(const P of this.a.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(M){const D=this.b(M);let P=this.a.get(D);return P||(P=new S(D,M),this.a.set(D,P)),P}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[D,P]of this.a)M.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this.a){const P=new Set([M]),d=this.c(D,P);if(d)return d}}c(M,D){for(const[P,d]of M.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const u=this.c(d,D);if(u)return u;D.delete(P)}}}e.$Fq=O}),define(ae[6],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e._util=void 0;var S;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(d){return d[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(S||(e._util=S={})),e.$7h=s("instantiationService");function O(D,P,d){P[S.DI_TARGET]===P?P[S.DI_DEPENDENCIES].push({id:D,index:d}):(P[S.DI_DEPENDENCIES]=[{id:D,index:d}],P[S.DI_TARGET]=P)}function s(D){if(S.serviceIds.has(D))return S.serviceIds.get(D);const P=function(d,u,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(P,d,b)};return P.toString=()=>D,S.serviceIds.set(D,P),P}e.$8h=s;function M(D){return D}e.$9h=M}),define(ae[78],ce([0,1,13,6]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i$b=e.$h$b=void 0,e.$h$b=(0,O.$8h)("auxiliaryWindowsMainService");function s(M){return M?.opener?.url.startsWith(`${S.Schemas.vscodeFileResource}://${S.$og}/`)}e.$i$b=s}),define(ae[65],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q0b=void 0,e.$q0b=(0,S.$8h)("backupMainService")}),define(ae[18],ce([0,1,12,7,6]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.ConfigurationTarget=e.$Di=e.$Ci=e.$Bi=void 0,e.$Bi=(0,s.$8h)("configurationService");function M(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof O.URI)}e.$Ci=M;function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof O.URI)}e.$Di=D;var P;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function d(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ei=d;function u(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.$Fi=u;function b(g,l){const f=Object.create(null);for(const $ in g)v(f,$,g[$],l);return f}e.$Gi=b;function v(g,l,f,$){const a=l.split("."),t=a.pop();let o=g;for(let r=0;r<a.length;r++){const i=a[r];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:$(`Ignoring ${l} as ${a.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=f}catch{$(`Ignoring ${l} as ${a.join(".")} is ${JSON.stringify(o)}`)}else $(`Ignoring ${l} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.$Hi=v;function y(g,l){const f=l.split(".");h(g,f)}e.$Ii=y;function h(g,l){const f=l.shift();if(l.length===0){delete g[f];return}if(Object.keys(g).indexOf(f)!==-1){const $=g[f];typeof $=="object"&&!Array.isArray($)&&(h($,l),Object.keys($).length===0&&delete g[f])}}function m(g,l,f){function $(o,r){let i=o;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const a=l.split("."),t=$(g,a);return typeof t>"u"?f:t}e.$Ji=m;function p(g,l,f){Object.keys(l).forEach($=>{$!=="__proto__"&&($ in g?S.$Lf(g[$])&&S.$Lf(l[$])?p(g[$],l[$],f):f&&(g[$]=l[$]):g[$]=l[$])})}e.$Ki=p;function k(g){return g.replace(/[\[\]]/g,"")}e.$Li=k}),define(ae[116],ce([0,1,4,25,197,6,164,14]),function(Y,e,S,O,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.ContextKeyExprType=e.$4i=void 0;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",S.$j),d.set("isLinux",S.$k),d.set("isWindows",S.$i),d.set("isWeb",S.$o),d.set("isMacNative",S.$j&&!S.$o),d.set("isEdge",S.$H),d.set("isFirefox",S.$F),d.set("isChrome",S.$E),d.set("isSafari",S.$G);function u(K,R){if(d.get(K)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(K,R)}e.$4i=u;const b=Object.prototype.hasOwnProperty;var v;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const y={regexParsingWithErrorRecovery:!0},h=(0,D.localize)(0,null),m=(0,D.localize)(1,null),p=(0,D.localize)(2,null),k=(0,D.localize)(3,null),g=(0,D.localize)(4,null),l=(0,D.localize)(5,null),f=(0,D.localize)(6,null),$=(0,D.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=y){this.k=R,this.d=new s.$3i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const W=this.l();if(!this.E()){const x=this.D(),N=x.type===17?l:void 0;throw this.h.push({message:g,offset:x.offset,lexeme:s.$3i.getLexeme(x),additionalInfo:N}),a.c}return W}catch(W){if(W!==a.c)throw W;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const W=this.o();R.push(W)}return R.length===1?R[0]:t.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const W=this.s();R.push(W)}return R.length===1?R[0]:t.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const W=this.l();return this.A(1,k),W?.negate()}case 17:return this.z(),j.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const W=this.l();return this.A(1,k),W}case 17:{const W=R.lexeme;if(this.z(),this.y(9)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==10)throw this.B("REGEX",N);const Q=N.lexeme,V=Q.lastIndexOf("/"),_=V===Q.length-1?void 0:this.w(Q.substring(V+1));let z;try{z=new RegExp(Q.substring(1,V),_)}catch{throw this.B("REGEX",N)}return re.create(W,z)}switch(N.type){case 10:case 19:{const Q=[N.lexeme];this.z();let V=this.D(),_=0;for(let me=0;me<N.lexeme.length;me++)N.lexeme.charCodeAt(me)===40?_++:N.lexeme.charCodeAt(me)===41&&_--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let me=0;me<V.lexeme.length;me++)V.lexeme.charCodeAt(me)===40?_++:N.lexeme.charCodeAt(me)===41&&_--}if(_<0)break;Q.push(s.$3i.getLexeme(V)),this.z(),V=this.D()}const z=Q.join(""),ee=z.lastIndexOf("/"),ne=ee===z.length-1?void 0:this.w(z.substring(ee+1));let de;try{de=new RegExp(z.substring(1,ee),ne)}catch{throw this.B("REGEX",N)}return t.regex(W,de)}case 18:{const Q=N.lexeme;this.z();let V=null;if(!(0,O.$Ke)(Q)){const _=Q.indexOf("/"),z=Q.lastIndexOf("/");if(_!==z&&_>=0){const ee=Q.slice(_+1,z),ne=Q[z+1]==="i"?"i":"";try{V=new RegExp(ee,ne)}catch{throw this.B("REGEX",N)}}}if(V===null)throw this.B("REGEX",N);return re.create(W,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const N=this.u();return t.notIn(W,N)}switch(this.D().type){case 3:{this.z();const N=this.u();if(this.x().type===18)return t.equals(W,N);switch(N){case"true":return t.has(W);case"false":return t.not(W);default:return t.equals(W,N)}}case 4:{this.z();const N=this.u();if(this.x().type===18)return t.notEquals(W,N);switch(N){case"true":return t.not(W);case"false":return t.has(W);default:return t.notEquals(W,N)}}case 5:return this.z(),J.create(W,this.u());case 6:return this.z(),le.create(W,this.u());case 7:return this.z(),F.create(W,this.u());case 8:return this.z(),H.create(W,this.u());case 13:return this.z(),t.in(W,this.u());default:return t.has(W)}}case 20:throw this.h.push({message:f,offset:R.offset,lexeme:"",additionalInfo:$}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,W){if(this.C(R))return this.z();throw this.B(W,this.D())}B(R,W,x){const N=(0,D.localize)(8,null,R,s.$3i.getLexeme(W)),Q=W.offset,V=s.$3i.getLexeme(W);return this.h.push({message:N,offset:Q,lexeme:V,additionalInfo:x}),a.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$5i=a;class t{static false(){return n.INSTANCE}static true(){return c.INSTANCE}static has(R){return w.create(R)}static equals(R,W){return A.create(R,W)}static notEquals(R,W){return C.create(R,W)}static regex(R,W){return re.create(R,W)}static in(R,W){return I.create(R,W)}static notIn(R,W){return E.create(R,W)}static not(R){return j.create(R)}static and(...R){return X.create(R,null,!0)}static or(...R){return q.create(R,null,!0)}static greater(R,W){return F.create(R,W)}static greaterEquals(R,W){return H.create(R,W)}static smaller(R,W){return J.create(R,W)}static smallerEquals(R,W){return le.create(R,W)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.$6i=t;function o(K){const R=new a({regexParsingWithErrorRecovery:!1});return K.map(W=>(R.parse(W),R.lexingErrors.length>0?R.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,D.localize)(9,null,x.additionalInfo):(0,D.localize)(10,null),offset:x.offset,length:x.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.$7i=o;function r(K,R){const W=K?K.substituteConstants():void 0,x=R?R.substituteConstants():void 0;return!W&&!x?!0:!W||!x?!1:W.equals(x)}e.$8i=r;function i(K,R){return K.cmp(R)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return c.INSTANCE}}e.$9i=n;class c{static{this.INSTANCE=new c}constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return n.INSTANCE}}e.$0i=c;class w{static create(R,W=null){const x=d.get(R);return typeof x=="boolean"?x?c.INSTANCE:n.INSTANCE:new w(R,W)}constructor(R,W){this.key=R,this.c=W,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:T(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=d.get(this.key);return typeof R=="boolean"?R?c.INSTANCE:n.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$$i=w;class A{static create(R,W,x=null){if(typeof W=="boolean")return W?w.create(R,x):j.create(R,x);const N=d.get(R);return typeof N=="boolean"?W===(N?"true":"false")?c.INSTANCE:n.INSTANCE:new A(R,W,x)}constructor(R,W,x){this.c=R,this.d=W,this.f=x,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:G(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=d.get(this.c);if(typeof R=="boolean"){const W=R?"true":"false";return this.d===W?c.INSTANCE:n.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$_i=A;class I{static create(R,W){return new I(R,W)}constructor(R,W){this.d=R,this.f=W,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:G(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const W=R.getValue(this.f),x=R.getValue(this.d);return Array.isArray(W)?W.includes(x):typeof x=="string"&&typeof W=="object"&&W!==null?b.call(W,x):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$aj=I;class E{static create(R,W){return new E(R,W)}constructor(R,W){this.d=R,this.f=W,this.type=11,this.c=I.create(R,W)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$bj=E;class C{static create(R,W,x=null){if(typeof W=="boolean")return W?j.create(R,x):w.create(R,x);const N=d.get(R);return typeof N=="boolean"?W===(N?"true":"false")?n.INSTANCE:c.INSTANCE:new C(R,W,x)}constructor(R,W,x){this.c=R,this.d=W,this.f=x,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:G(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=d.get(this.c);if(typeof R=="boolean"){const W=R?"true":"false";return this.d===W?n.INSTANCE:c.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$cj=C;class j{static create(R,W=null){const x=d.get(R);return typeof x=="boolean"?x?n.INSTANCE:c.INSTANCE:new j(R,W)}constructor(R,W){this.c=R,this.d=W,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:T(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=d.get(this.c);return typeof R=="boolean"?R?n.INSTANCE:c.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$dj=j;function U(K,R){if(typeof K=="string"){const W=parseFloat(K);isNaN(W)||(K=W)}return typeof K=="string"||typeof K=="number"?R(K):n.INSTANCE}class F{static create(R,W,x=null){return U(W,N=>new F(R,N,x))}constructor(R,W,x){this.c=R,this.d=W,this.f=x,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:G(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$ej=F;class H{static create(R,W,x=null){return U(W,N=>new H(R,N,x))}constructor(R,W,x){this.c=R,this.d=W,this.f=x,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:G(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$fj=H;class J{static create(R,W,x=null){return U(W,N=>new J(R,N,x))}constructor(R,W,x){this.c=R,this.d=W,this.f=x,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:G(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$gj=J;class le{static create(R,W,x=null){return U(W,N=>new le(R,N,x))}constructor(R,W,x){this.c=R,this.d=W,this.f=x,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:G(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$hj=le;class re{static create(R,W){return new re(R,W)}constructor(R,W){this.d=R,this.f=W,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const W=this.f?this.f.source:"",x=R.f?R.f.source:"";return W<x?-1:W>x?1:0}equals(R){if(R.type===this.type){const W=this.f?this.f.source:"",x=R.f?R.f.source:"";return this.d===R.d&&W===x}return!1}substituteConstants(){return this}evaluate(R){const W=R.getValue(this.d);return this.f?this.f.test(W):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$ij=re;class ue{static create(R){return new ue(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new ue(this.c.map(R))}negate(){return this.c}}e.$jj=ue;function Z(K){let R=null;for(let W=0,x=K.length;W<x;W++){const N=K[W].substituteConstants();if(K[W]!==N&&R===null){R=[];for(let Q=0;Q<W;Q++)R[Q]=K[Q]}R!==null&&(R[W]=N)}return R===null?K:R}class X{static create(R,W,x){return X.d(R,W,x)}constructor(R,W){this.expr=R,this.c=W,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let W=0,x=this.expr.length;W<x;W++){const N=i(this.expr[W],R.expr[W]);if(N!==0)return N}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let W=0,x=this.expr.length;W<x;W++)if(!this.expr[W].equals(R.expr[W]))return!1;return!0}return!1}substituteConstants(){const R=Z(this.expr);return R===this.expr?this:X.create(R,this.c,!1)}evaluate(R){for(let W=0,x=this.expr.length;W<x;W++)if(!this.expr[W].evaluate(R))return!1;return!0}static d(R,W,x){const N=[];let Q=!1;for(const V of R)if(V){if(V.type===1){Q=!0;continue}if(V.type===0)return n.INSTANCE;if(V.type===6){N.push(...V.expr);continue}N.push(V)}if(N.length===0&&Q)return c.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(i);for(let V=1;V<N.length;V++)N[V-1].equals(N[V])&&(N.splice(V,1),V--);if(N.length===1)return N[0];for(;N.length>1;){const V=N[N.length-1];if(V.type!==9)break;N.pop();const _=N.pop(),z=N.length===0,ee=q.create(V.expr.map(ne=>X.create([ne,_],null,x)),null,z);ee&&(N.push(ee),N.sort(i))}if(N.length===1)return N[0];if(x){for(let V=0;V<N.length;V++)for(let _=V+1;_<N.length;_++)if(N[V].negate().equals(N[_]))return n.INSTANCE;if(N.length===1)return N[0]}return new X(N,W)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const W of this.expr)R.push(...W.keys());return R}map(R){return new X(this.expr.map(W=>W.map(R)),null)}negate(){if(!this.c){const R=[];for(const W of this.expr)R.push(W.negate());this.c=q.create(R,this,!0)}return this.c}}e.$kj=X;class q{static create(R,W,x){return q.d(R,W,x)}constructor(R,W){this.expr=R,this.c=W,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let W=0,x=this.expr.length;W<x;W++){const N=i(this.expr[W],R.expr[W]);if(N!==0)return N}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let W=0,x=this.expr.length;W<x;W++)if(!this.expr[W].equals(R.expr[W]))return!1;return!0}return!1}substituteConstants(){const R=Z(this.expr);return R===this.expr?this:q.create(R,this.c,!1)}evaluate(R){for(let W=0,x=this.expr.length;W<x;W++)if(this.expr[W].evaluate(R))return!0;return!1}static d(R,W,x){let N=[],Q=!1;if(R){for(let V=0,_=R.length;V<_;V++){const z=R[V];if(z){if(z.type===0){Q=!0;continue}if(z.type===1)return c.INSTANCE;if(z.type===9){N=N.concat(z.expr);continue}N.push(z)}}if(N.length===0&&Q)return n.INSTANCE;N.sort(i)}if(N.length!==0){if(N.length===1)return N[0];for(let V=1;V<N.length;V++)N[V-1].equals(N[V])&&(N.splice(V,1),V--);if(N.length===1)return N[0];if(x){for(let V=0;V<N.length;V++)for(let _=V+1;_<N.length;_++)if(N[V].negate().equals(N[_]))return c.INSTANCE;if(N.length===1)return N[0]}return new q(N,W)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const W of this.expr)R.push(...W.keys());return R}map(R){return new q(this.expr.map(W=>W.map(R)),null)}negate(){if(!this.c){const R=[];for(const W of this.expr)R.push(W.negate());for(;R.length>1;){const W=R.shift(),x=R.shift(),N=[];for(const Q of he(W))for(const V of he(x))N.push(X.create([Q,V],null,!1));R.unshift(q.create(N,null,!1))}this.c=q.create(R,this,!0)}return this.c}}e.$lj=q;class L extends w{static{this.d=[]}static all(){return L.d.values()}constructor(R,W,x){super(R,null),this.f=W,typeof x=="object"?L.d.push({...x,key:R}):x!==!0&&L.d.push({key:R,description:x,type:W!=null?typeof W:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return A.create(this.key,R)}notEqualsTo(R){return C.create(this.key,R)}}e.$mj=L,e.$nj=(0,M.$8h)("contextKeyService");function T(K,R){return K<R?-1:K>R?1:0}function G(K,R,W,x){return K<W?-1:K>W?1:R<x?-1:R>x?1:0}function B(K,R){if(K.type===0||R.type===1)return!0;if(K.type===9)return R.type===9?oe(K.expr,R.expr):!1;if(R.type===9){for(const W of R.expr)if(B(K,W))return!0;return!1}if(K.type===6){if(R.type===6)return oe(R.expr,K.expr);for(const W of K.expr)if(B(W,R))return!0;return!1}return K.equals(R)}e.$oj=B;function oe(K,R){let W=0,x=0;for(;W<K.length&&x<R.length;){const N=K[W].cmp(R[x]);if(N<0)return!1;N===0&&W++,x++}return W===K.length}function he(K){return K.type===9?K.expr:[K]}}),define(ae[91],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=e.ID=void 0,e.ID="diagnosticsService",e.$Lm=(0,S.$8h)(e.ID);function O(M){return!!M.hostName&&!!M.errorMessage}e.$Mm=O;class s{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$Nm=s}),define(ae[117],ce([0,1,19,73,166,6,47,4,35]),function(Y,e,S,O,s,M,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_v=e.$$v=e.ConfirmResult=e.$0v=e.$9v=e.$8v=void 0,e.$8v=(0,M.$8h)("dialogService");var u;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(u||(u={}));class b{a(k){return this.d(k,u.Confirmation)}b(k){return this.d(k,u.Prompt)}c(k){return this.d(k,u.Input)}d(k,g){const l=[];switch(g){case u.Confirmation:{const f=k;f.primaryButton?l.push(f.primaryButton):l.push((0,s.localize)(0,null)),f.cancelButton?l.push(f.cancelButton):l.push((0,s.localize)(1,null));break}case u.Prompt:{const f=k;Array.isArray(f.buttons)&&f.buttons.length>0&&l.push(...f.buttons.map($=>$.label)),f.cancelButton&&(f.cancelButton===!0?l.push((0,s.localize)(2,null)):typeof f.cancelButton=="string"?l.push(f.cancelButton):f.cancelButton.label?l.push(f.cancelButton.label):l.push((0,s.localize)(3,null))),l.length===0&&l.push((0,s.localize)(4,null));break}case u.Input:{const f=k;f.primaryButton?l.push(f.primaryButton):l.push((0,s.localize)(5,null)),f.cancelButton?l.push(f.cancelButton):l.push((0,s.localize)(6,null));break}}return l}e(k){if(typeof k=="string")return k;if(typeof k=="number")return k===O.default.Info?"info":k===O.default.Error?"error":k===O.default.Warning?"warning":"none"}f(k,g,l){const f=[...k.buttons??[]];k.cancelButton&&typeof k.cancelButton!="string"&&typeof k.cancelButton!="boolean"&&f.push(k.cancelButton);let $=f[g]?.run({checkboxChecked:l});return $ instanceof Promise||($=Promise.resolve($)),{result:$,checkboxChecked:l}}}e.$9v=b,e.$0v=(0,M.$8h)("fileDialogService");var v;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(v||(e.ConfirmResult=v={}));const y=10;function h(p){const k=[];return k.push(...p.slice(0,y).map(g=>typeof g=="string"?g:(0,S.$Fg)(g))),p.length>y&&(p.length-y===1?k.push((0,s.localize)(7,null)):k.push((0,s.localize)(8,null,p.length-y))),k.push(""),k.join(`
`)}e.$$v=h;function m(p,k){const g=(0,d.$yn)(p);let l=(g.buttons??[]).map(t=>(0,D.$5v)(t)),f=(p.buttons||[]).map((t,o)=>o),$=0,a=g.cancelId??l.length-1;if(l.length>1){const t=typeof a=="number"?l[a]:void 0;if(P.$k||P.$j){if(typeof t=="string"&&l.length>1&&a!==1){l.splice(a,1),l.splice(1,0,t);const o=f[a];f.splice(a,1),f.splice(1,0,o),a=1}P.$k&&l.length>1&&(l=l.reverse(),f=f.reverse(),$=l.length-1,typeof t=="string"&&(a=$-1))}else if(P.$i&&typeof t=="string"&&l.length>1&&a!==l.length-1){l.splice(a,1),l.push(t);const o=f[a];f.splice(a,1),f.push(o),a=l.length-1}}return g.buttons=l,g.defaultId=$,g.cancelId=a,g.noLink=!0,g.title=g.title||k.nameLong,{options:g,buttonIndeces:f}}e.$_v=m}),define(ae[118],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GV=e.$FV=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$EV=e.$DV=void 0,e.$DV=(0,S.$8h)("encryptionService"),e.$EV=(0,S.$8h)("encryptionMainService");var O;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(O||(e.PasswordStoreCLIOption=O={}));var s;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$FV=M;function D(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$GV=D}),define(ae[38],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=void 0,e.$ci=(0,S.$8h)("environmentService"),e.$di=(0,S.$9h)(e.$ci)}),define(ae[119],ce([0,1,170,6]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ExtensionGalleryErrorCode=e.$Co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0,e.$po="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$qo=new RegExp(e.$po),e.$ro="__web_extension",e.$so="skipWalkthrough",e.$to="extensionsSync",e.$uo="dependecyOrPackExtensionInstall";function s(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$vo=s;function M(f){switch(f){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$wo=M;function D(f,$){switch(f){case 3:return $==="x64"?"win32-x64":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$xo=D;function P(f,$){return $==="web"&&!f.includes("web")}e.$yo=P;function d(f,$,a){return P($,a)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===a}e.$zo=d;function u(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$Ao=u;var b;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var v;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var y;(function(f){f.Install="install",f.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var h;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$Bo=(0,O.$8h)("extensionGalleryService");var m;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.DownloadSignature="DownloadSignature",f.UpdateMetadata="UpdateMetadata",f.Extract="Extract",f.Scanning="Scanning",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.NotAllowed="NotAllowed",f.Gallery="Gallery",f.Unknown="Unknown",f.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var p;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class k extends Error{constructor($,a){super($),this.code=a,this.name=a}}e.$Co=k;var g;(function(f){f.Timeout="Timeout",f.Cancelled="Cancelled",f.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class l extends Error{constructor($,a){super($),this.code=a,this.name=a}}e.$Do=l,e.$Eo=(0,O.$8h)("extensionManagementService"),e.$Fo="extensionsIdentifiers/disabled",e.$Go="extensionsIdentifiers/enabled",e.$Ho=(0,O.$8h)("IGlobalExtensionEnablementService"),e.$Io=(0,O.$8h)("IExtensionTipsService"),e.$Jo=(0,S.localize2)(0,"Extensions"),e.$Ko=(0,S.localize2)(1,"Preferences")}),define(ae[209],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$00b=e.$90b=void 0,e.$90b=(0,S.$8h)("extensionHostStarter"),e.$00b="extensionHostStarter"}),define(ae[210],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c3b=e.$b3b=void 0,e.$b3b=(0,S.$8h)("externalTerminal"),e.$c3b="Terminal.app"}),define(ae[211],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_0b=void 0,e.$_0b=(0,S.$8h)("externalTerminal")}),define(ae[212],ce([0,1,48,50,13,9,4,75,21,89,174,210]),function(Y,e,S,O,s,M,D,P,d,u,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$b=e.$b$b=e.$a$b=void 0;const y=b.localize(0,null);class h{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await k.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends h{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(S,a,u.$Vl(),t)}spawnTerminal(a,t,o,r){const i=t.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=M.$nc(i,".exe").toLowerCase();if(n==="cmder")return a.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return i.indexOf(" ")>=0&&c.push('""'),c.push(i),n==="wt"&&c.push("-d ."),new Promise((w,A)=>{const I=g(process),E=a.spawn(o,c,{cwd:r,env:I,detached:!0});E.on("error",A),E.on("exit",()=>w())})}async runInTerminal(a,t,o,r,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:m.getDefaultTerminalWindows(),c=await m.f();return new Promise((w,A)=>{const I=`"${t} - ${y}"`,E=`""${o.join('" "')}" & pause"`,C=Object.assign({},g(process),r);Object.keys(C).filter(J=>C[J]===null).forEach(J=>delete C[J]);const j={cwd:t,env:C,windowsVerbatimArguments:!0};let U,F;M.$nc(n,".exe")==="wt"?(U=n,F=["-d",".",m.b,"/c",E]):c?(U=c,F=["-d",t,n,"/c",E]):(U=m.b,F=["/c","start",I,"/wait",n,"/c",E]),S.spawn(U,F,j).on("error",J=>{A(l(J))}),w(void 0)})}static getDefaultTerminalWindows(){if(!m.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return m.d}static async f(){try{const a=await u.win32.findExecutable("wt");return await d.Promises.exists(a)?a:void 0}catch{return}}}e.$a$b=m,ve([O.$zh],m,"f",null);class p extends h{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(S,a,t)}runInTerminal(a,t,o,r,i){const n=i.osxExec||v.$c3b;return new Promise((c,w)=>{if(n===v.$c3b||n==="iTerm.app"){const A=n===v.$c3b?"TerminalHelper":"iTermHelper",E=[s.$pg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${A}.scpt`).fsPath,"-t",a||y,"-w",t];for(const U of o)E.push("-a"),E.push(U);if(r){const U=Object.assign({},g(process),r);for(const F in U){const H=U[F];H===null?(E.push("-u"),E.push(F)):(E.push("-e"),E.push(`${F}=${H}`))}}let C="";const j=S.spawn(p.b,E);j.on("error",U=>{w(l(U))}),j.stderr.on("data",U=>{C+=U.toString()}),j.on("exit",U=>{if(U===0)c(void 0);else if(C){const F=C.split(`
`,1);w(new Error(F[0]))}else w(new Error(b.localize(1,null,A,U)))})}else w(new Error(b.localize(2,null,n)))})}spawnTerminal(a,t,o){const r=t.osxExec||v.$c3b;return new Promise((i,n)=>{const c=["-a",r];o&&c.push(o);const w=g(process),A=a.spawn("/usr/bin/open",c,{cwd:o,env:w});A.on("error",n),A.on("exit",()=>i())})}}e.$b$b=p;class k extends h{static{this.b=b.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(S,a,t)}runInTerminal(a,t,o,r,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):k.getDefaultTerminalLinuxReady();return new Promise((c,w)=>{const A=[];n.then(I=>{I.indexOf("gnome-terminal")>=0?A.push("-x"):A.push("-e"),A.push("bash"),A.push("-c");const E=`${f(o)}; echo; read -p "${k.b}" -n1;`;A.push(`''${E}''`);const C=Object.assign({},g(process),r);Object.keys(C).filter(H=>C[H]===null).forEach(H=>delete C[H]);const j={cwd:t,env:C};let U="";const F=S.spawn(I,A,j);F.on("error",H=>{w(l(H))}),F.stderr.on("data",H=>{U+=H.toString()}),F.on("exit",H=>{if(H===0)c(void 0);else if(U){const J=U.split(`
`,1);w(new Error(J[0]))}else w(new Error(b.localize(4,null,I,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!k.d)if(!D.$k)k.d=Promise.resolve("xterm");else{const a=await d.Promises.exists("/etc/debian_version");k.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return k.d}spawnTerminal(a,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):k.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{r.then(c=>{const w=g(process),A=a.spawn(c,[],{cwd:o,env:w});A.on("error",n),A.on("exit",()=>i())})})}}e.$c$b=k;function g($){const a={...$.env};return(0,P.$Tl)(a),a}function l($){return"errno"in $&&$.errno==="ENOENT"&&"path"in $&&typeof $.path=="string"?new Error(b.localize(5,null,$.path)):$}function f($){let a="";for(const t of $)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(ae[16],ce([0,1,59,9,25,12,7,176,6,4,13,62]),function(Y,e,S,O,s,M,D,P,d,u,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileKind=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileOperationResult=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileChangeType=e.$Kk=e.FileOperation=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderErrorCode=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileSystemProviderCapabilities=e.$uk=e.FilePermission=e.FileType=e.$tk=e.$sk=void 0,e.$sk=(0,d.$8h)("fileService");function y(B){return B.create===!0}e.$tk=y;var h;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var m;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function p(B){const oe=B;return!!oe&&typeof oe.onDidChange=="function"}e.$uk=p;var k;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(k||(e.FileSystemProviderCapabilities=k={}));function g(B){return!!(B.capabilities&2)}e.$vk=g;function l(B){return!!(B.capabilities&8)}e.$wk=l;function f(B){return!!(B.capabilities&131072)}e.$xk=f;function $(B){return!!(B.capabilities&4)}e.$yk=$;function a(B){return!!(B.capabilities&16)}e.$zk=a;function t(B){return g(B)?!!(B.capabilities&16384):!1}e.$Ak=t;function o(B){return g(B)?!!(B.capabilities&32768):!1}e.$Bk=o;function r(B){return!!(B.capabilities&65536)}e.$Ck=r;function i(B){return!!(B.capabilities&2048)}e.$Dk=i;var n;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class c extends Error{static create(oe,he){const K=new c(oe.toString(),he);return I(K,he),K}constructor(oe,he){super(oe),this.code=he}}e.$Ek=c;function w(B,oe){return c.create(B,oe)}e.$Fk=w;function A(B){return B||w((0,P.localize)(0,null),n.Unknown)}e.$Gk=A;function I(B,oe){return B.name=oe?`${oe} (FileSystemError)`:"FileSystemError",B}e.$Hk=I;function E(B){if(!B)return n.Unknown;if(B instanceof c)return B.code;const oe=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!oe)return n.Unknown;switch(oe[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$Ik=E;function C(B){if(B instanceof le)return B.fileOperationResult;switch(E(B)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$Jk=C;var j;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class U{constructor(oe,he,K){this.resource=oe,this.operation=he,this.target=K}isOperation(oe){return this.operation===oe}}e.$Kk=U;var F;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class H{static{this.a=null}constructor(oe,he){this.c=he,this.b=void 0,this.d=new v.$V(()=>{const K=S.$bi.forUris(()=>this.c);return K.fill(this.rawAdded.map(R=>[R,!0])),K}),this.f=new v.$V(()=>{const K=S.$bi.forUris(()=>this.c);return K.fill(this.rawUpdated.map(R=>[R,!0])),K}),this.g=new v.$V(()=>{const K=S.$bi.forUris(()=>this.c);return K.fill(this.rawDeleted.map(R=>[R,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of oe){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==H.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=H.a):this.b!==void 0&&(this.b=H.a))}}contains(oe,...he){return this.h(oe,{includeChildren:!1},...he)}affects(oe,...he){return this.h(oe,{includeChildren:!0},...he)}h(oe,he,...K){if(!oe)return!1;const R=K.length>0;return!!((!R||K.includes(1))&&(this.d.value.get(oe)||he.includeChildren&&this.d.value.findSuperstr(oe))||(!R||K.includes(0))&&(this.f.value.get(oe)||he.includeChildren&&this.f.value.findSuperstr(oe))||(!R||K.includes(2))&&(this.g.value.findSubstr(oe)||he.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$Lk=H;function J(B,oe,he){return!B||!oe||B===oe||oe.length>B.length?!1:(oe.charAt(oe.length-1)!==O.sep&&(oe+=O.sep),he?(0,s.$bf)(B,oe):B.indexOf(oe)===0)}e.$Mk=J;class le extends Error{constructor(oe,he,K){super(oe),this.fileOperationResult=he,this.options=K}}e.$Nk=le;class re extends le{constructor(oe,he,K,R){super(oe,he,R),this.fileOperationResult=he,this.size=K}}e.$Ok=re;class ue extends le{constructor(oe,he,K){super(oe,2,K),this.stat=he}}e.$Pk=ue;var Z;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$Qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Sk="files.associations",e.$Tk="files.exclude",e.$Uk="files.readonlyInclude",e.$Vk="files.readonlyExclude",e.$Wk="files.readonlyFromPermissions";var X;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$Xk="";function q(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.$Yk=q;async function L(B,oe){if(!oe.hasProvider(D.URI.from({scheme:B.scheme})))return new Promise(he=>{const K=oe.onDidChangeFileSystemProviderRegistrations(R=>{R.scheme===B.scheme&&R.added&&(K.dispose(),he())})})}e.$Zk=L;class T{static{this.KB=1024}static{this.MB=T.KB*T.KB}static{this.GB=T.MB*T.KB}static{this.TB=T.GB*T.KB}static formatSize(oe){return(0,M.$Nf)(oe)||(oe=0),oe<T.KB?(0,P.localize)(1,null,oe.toFixed(0)):oe<T.MB?(0,P.localize)(2,null,(oe/T.KB).toFixed(2)):oe<T.GB?(0,P.localize)(3,null,(oe/T.MB).toFixed(2)):oe<T.TB?(0,P.localize)(4,null,(oe/T.GB).toFixed(2)):(0,P.localize)(5,null,(oe/T.TB).toFixed(2))}}e.$1k=T;function G(B){const oe=typeof B=="string"||B?.scheme===b.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===b.Schemas.file?1024*T.MB:oe?10*T.MB:u.$o?50*T.MB:1024*T.MB}e.$2k=G}),define(ae[120],ce([0,1,17,14,177,16]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;async function D(b,v,y,h,m,p){let k;try{await P(b,v,y,h,m,p)}catch(g){k=g}finally{k&&m.errorTransformer&&(k=m.errorTransformer(k)),typeof k<"u"&&y.error(k),y.end()}}e.$dq=D;async function P(b,v,y,h,m,p){d(p);const k=await b.open(v,{create:!1});try{d(p);let g=0,l=0,f=m&&typeof m.length=="number"?m.length:void 0,$=S.$ke.alloc(Math.min(m.bufferSize,typeof f=="number"?f:m.bufferSize)),a=m&&typeof m.position=="number"?m.position:0,t=0;do l=await b.read(k,a,$.buffer,t,$.byteLength-t),a+=l,t+=l,g+=l,typeof f=="number"&&(f-=l),t===$.byteLength&&(await y.write(h($)),$=S.$ke.alloc(Math.min(m.bufferSize,typeof f=="number"?f:m.bufferSize)),t=0);while(l>0&&(typeof f!="number"||f>0)&&d(p)&&u(g,m));if(t>0){let o=t;typeof f=="number"&&(o=Math.min(t,f)),y.write(h($.slice(0,o)))}}catch(g){throw(0,M.$Gk)(g)}finally{await b.close(k)}}function d(b){if(b.isCancellationRequested)throw(0,O.$6)();return!0}function u(b,v){if(typeof v?.limits?.size=="number"&&b>v.limits.size)throw(0,M.$Fk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[66],ce([0,1,106,2,9,4,7,16]),function(Y,e,S,O,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=void 0;function d(g){return g.recursive===!0}e.$fq=d;class u extends O.$Tc{static{this.a=5}constructor(l,f,$,a){super(),this.h=l,this.j=f,this.m=$,this.n=a,this.c=this.B(new O.$Uc),this.f=void 0,this.g=0}s(){const l=new O.$Sc;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(f=>this.h(f))),l.add(this.b.onDidLogMessage(f=>this.j(f))),l.add(this.b.onDidError(f=>this.t(f)))}t(l){this.n.restartOnError?this.g<u.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$gq=u;class b extends u{constructor(l,f,$){super(l,f,$,{type:"node.js",restartOnError:!1})}}e.$hq=b;class v extends u{constructor(l,f,$){super(l,f,$,{type:"universal",restartOnError:!0})}}e.$iq=v;function y(g){return g.map(l=>({type:l.type,resource:D.URI.revive(l.resource),cId:l.cId}))}e.$jq=y;function h(g){const l=new k;for(const f of g)l.processEvent(f);return l.coalesce()}e.$kq=h;function m(g,l){return typeof l=="string"&&!l.startsWith(S.$Kj)&&!(0,s.$ic)(l)?{base:g,pattern:l}:l}e.$lq=m;function p(g,l){const f=[];for(const $ of l)f.push((0,S.$Oj)(m(g,$)));return f}e.$mq=p;class k{constructor(){this.a=new Set,this.b=new Map}c(l){return M.$k?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const f=this.b.get(this.c(l));let $=!1;if(f){const a=f.type,t=l.type;f.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?$=!0:a===1&&t===2?(this.b.delete(this.c(l)),this.a.delete(f)):a===2&&t===1?f.type=0:a===1&&t===0||(f.type=t)}else $=!0;$&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],f=[];return Array.from(this.a).filter($=>$.type!==2?(l.push($),!1):!0).sort(($,a)=>$.resource.fsPath.length-a.resource.fsPath.length).filter($=>f.some(a=>(0,P.$Mk)($.resource.fsPath,a,!M.$k))?!1:(f.push($.resource.fsPath),!0)).concat(l)}}}),define(ae[213],ce([0,1,17,51,14,3,2,63,32,16,66]),function(Y,e,S,O,s,M,D,P,d,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=void 0,e.$FO="localFilesystem";class v extends D.$Tc{constructor(h,m){super(),this.a=h,this.b=m,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$Wd),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$Wd),this.onDidWatchError=this.g.event,this.h=(0,d.$rg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,m){const{buffer:p}=await this.a.call("readFile",[h,m]);return p}readFileStream(h,m,p){const k=(0,P.$$d)(l=>S.$ke.concat(l.map(f=>S.$ke.wrap(f))).buffer),g=new D.$Sc;return g.add(this.a.listen("readFileStream",[h,m])(l=>{if(l instanceof S.$ke)k.write(l.buffer);else{if(l==="end")k.end();else{let f;if(l instanceof Error)f=l;else{const $=l;f=(0,u.$Fk)($.message??(0,O.$Si)($),$.code??u.FileSystemProviderErrorCode.Unknown)}k.error(f),k.end()}g.dispose()}})),g.add(p.onCancellationRequested(()=>{k.error((0,s.$6)()),k.end(),g.dispose()})),k}writeFile(h,m,p){return this.a.call("writeFile",[h,S.$ke.wrap(m),p])}open(h,m){return this.a.call("open",[h,m])}close(h){return this.a.call("close",[h])}async read(h,m,p,k,g){const[l,f]=await this.a.call("read",[h,m,g]);return p.set(l.buffer.slice(0,f),k),f}write(h,m,p,k,g){return this.a.call("write",[h,m,S.$ke.wrap(p),k,g])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,m){return this.a.call("delete",[h,m])}rename(h,m,p){return this.a.call("rename",[h,m,p])}copy(h,m,p){return this.a.call("copy",[h,m,p])}cloneFile(h,m){return this.a.call("cloneFile",[h,m])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const m=h;this.f.fire((0,b.$jq)(m))}else{const m=h;this.g.fire(m)}}))}watch(h,m){const p=(0,d.$rg)();return this.a.call("watch",[this.h,p,h,m]),(0,D.$Rc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$GO=v}),define(ae[214],ce([0,1,46,8,23,33,2,85,9,4,19,7,107,21,66]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0;class p extends D.$Tc{static{this.a=100}static{this.b=75}constructor(l,f,$,a){super(),this.m=l,this.n=f,this.r=$,this.s=a,this.c=this.B(new O.$kh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new O.$jh(t=>this.z(t),p.b)),this.g=(0,m.$mq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,m.$mq)(this.m.path,this.m.includes):void 0,this.j=new s.$7d,this.ready=this.t()}async t(){try{const l=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const f=await h.Promises.stat(l);this.B(await this.w(l,f.isDirectory()))}catch(l){l.code!=="ENOENT"?this.D(l):this.G(l)}}async u(l){let f=l.path;try{f=await h.Promises.realpath(l.path),l.path===f&&(f=await(0,y.$wq)(l.path)??l.path),l.path!==f&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${l.path}, real: ${f})`)}catch{}return f}async w(l,f){if(u.$j&&(0,M.$9f)(l,"/Volumes/",!0))return this.D(`Refusing to watch ${l} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Tc.None;const $=new s.$7d(this.j.token),a=new D.$Sc;try{const t=v.URI.file(this.m.path),o=(0,d.$nc)(l),r=(0,S.watch)(l);a.add((0,D.$Rc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${l}'`);const i=new Set;if(f)try{for(const c of await h.Promises.readdir(l))i.add(c)}catch(c){this.D(c)}const n=new Map;a.add((0,D.$Rc)(()=>{for(const[,c]of n)c.dispose();n.clear()})),r.on("error",(c,w)=>{this.D(`Failed to watch ${l} for changes using fs.watch() (${c}, ${w})`),this.dispose()}),r.on("change",(c,w)=>{if($.token.isCancellationRequested)return;this.G(`[raw] ["${c}"] ${w}`);let A="";if(w&&(A=w.toString(),u.$j&&(A=(0,P.$Il)(A))),!(!A||c!=="change"&&c!=="rename"))if(f)if(c==="rename"){n.get(A)?.dispose();const I=setTimeout(async()=>{if(n.delete(A),A===o&&!await h.Promises.exists(l)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,d.$jc)(l,A));if($.token.isCancellationRequested)return;let C;E?i.has(A)?C=0:(C=1,i.add(A)):(i.delete(A),C=2),this.y({resource:(0,b.$Ig)(t,A),type:C,cId:this.m.correlationId})},p.a);n.set(A,(0,D.$Rc)(()=>clearTimeout(I)))}else{let I;i.has(A)?I=0:(I=1,i.add(A)),this.y({resource:(0,b.$Ig)(t,A),type:I,cId:this.m.correlationId})}else if(c==="rename"||A!==o){const I=setTimeout(async()=>{const E=await h.Promises.exists(l);$.token.isCancellationRequested||(E?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(l,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);a.clear(),a.add((0,D.$Rc)(()=>clearTimeout(I)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await h.Promises.exists(l)&&!$.token.isCancellationRequested&&this.D(`Failed to watch ${l} for changes using fs.watch() (${t.toString()})`)}return(0,D.$Rc)(()=>{$.dispose(!0),a.dispose()})}y(l,f=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`),!f&&this.g.some($=>$(l.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${l.resource.fsPath}`):!f&&this.h&&this.h.length>0&&!this.h.some($=>$(l.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${l.resource.fsPath}`):this.f.work(l))}z(l){const f=(0,m.$kq)(l);if(f.length>0){if(this.s)for(const a of f)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(f)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(l){if(u.$k)return h.Promises.exists(l);try{const f=(0,d.$nc)(l);return(await h.Promises.readdir((0,d.$mc)(l))).some(a=>a===f)}catch(f){return this.G(f),!1}}setVerboseLogging(l){this.s=l}D(l){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${l}`})}F(l){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${l}`})}G(l){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${l}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$zq=p;async function k(g,l,f,$,a=512){const t=await h.Promises.open(g,"r"),o=Buffer.allocUnsafe(a),r=new s.$7d($);let i,n=!1;const c={path:g,excludes:[],recursive:!1},w=new p(c,A=>{(async()=>{for(const{type:I}of A)if(I===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await h.Promises.read(t,o,0,a,null);if(!E||r.token.isCancellationRequested)break;l(o.slice(0,E))}}catch(E){i=new Error(E),r.dispose(!0)}finally{n=!1}}})()});return await w.ready,f(),new Promise((A,I)=>{r.token.onCancellationRequested(async()=>{w.dispose();try{await h.Promises.close(t)}catch(E){i=new Error(E)}i?I(i):A()})})}e.$Aq=k}),define(ae[215],ce([0,1,3,106,2,4,214]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class P extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new S.$Wd),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$Wd),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(u){const b=this.j(u),v=b.filter(h=>{const m=this.c.get(h.path);return m?!(0,O.$Sj)(m.request.excludes,h.excludes)||!(0,O.$Sj)(m.request.includes,h.includes):!0}),y=Array.from(this.c.values()).filter(({request:h})=>!b.find(m=>m.path===h.path&&(0,O.$Sj)(m.excludes,h.excludes)&&(0,O.$Sj)(m.includes,h.includes))).map(({request:h})=>h.path);v.length&&this.m(`Request to start watching: ${v.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const h of y)this.h(h);for(const h of v)this.g(h)}g(u){const b=new D.$zq(u,y=>this.a.fire(y),y=>this.b.fire(y),this.f),v={request:u,instance:b};this.c.set(u.path,v)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const b=this.c.get(u);b&&(this.c.delete(u),b.instance.dispose())}j(u){const b=new Map;for(const v of u){const y=M.$k?v.path:v.path.toLowerCase();let h=b.get(v.correlationId);h||(h=new Map,b.set(v.correlationId,h)),h.set(y,v)}return Array.from(b.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(u){this.f=u;for(const[,b]of this.c)b.instance.setVerboseLogging(u)}m(u){this.f&&this.b.fire({type:"trace",message:this.n(u)})}n(u,b){return b?`[File Watcher (node.js)] ${u} (path: ${b.request.path})`:`[File Watcher (node.js)] ${u}`}}e.$Bq=P}),define(ae[216],ce([0,1,66,215]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class s extends S.$hq{constructor(D,P,d){super(D,P,d),this.s()}r(D){return D.add(new O.$Bq)}}e.$Cq=s}),define(ae[217],ce([0,1,13,43,160,66]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;class D extends M.$iq{constructor(d,u,b){super(d,u,b),this.s()}r(d){const u=d.add(new s.$tq(S.$pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(u.onDidProcessExit(({code:b,signal:v})=>this.t(`terminated by itself with code ${b}, signal: ${v}`))),O.ProxyChannel.toService((0,O.$Oh)(u.getChannel("watcher")))}}e.$uq=D}),define(ae[92],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=void 0;class S{constructor(...s){this.a=new Map;for(const[M,D]of s)this.set(M,D)}set(s,M){const D=this.a.get(s);return this.a.set(s,M),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$6h=S}),define(ae[218],ce([0,1,8,14,2,77,208,6,92,103]),function(Y,e,S,O,s,M,D,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const b=!1;class v extends Error{constructor(k){super("cyclic dependency between services"),this.message=k.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${k.toString()}`}}class y{constructor(k=new d.$6h,g=!1,l,f=b){this.f=k,this.g=g,this.h=l,this.i=f,this.o=new Set,this.f.set(P.$7h,this),this._globalGraph=f?l?._globalGraph??new D.$Fq($=>$):void 0}createChild(k){return new y(k,this.g,this,this.i)}invokeFunction(k,...g){const l=m.traceInvocation(this.i,k);let f=!1;try{return k({get:a=>{if(f)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,l);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...g)}finally{f=!0,l.stop()}}createInstance(k,...g){let l,f;return k instanceof M.$5h?(l=m.traceCreation(this.i,k.ctor),f=this.j(k.ctor,k.staticArguments.concat(g),l)):(l=m.traceCreation(this.i,k),f=this.j(k,g,l)),l.stop(),f}j(k,g=[],l){const f=P._util.getServiceDependencies(k).sort((t,o)=>t.index-o.index),$=[];for(const t of f){const o=this.m(t.id,l);o||this.u(`[createInstance] ${k.name} depends on UNKNOWN service ${t.id}.`,!1),$.push(o)}const a=f.length>0?f[0].index:g.length;if(g.length!==a){console.trace(`[createInstance] First service dependency of ${k.name} at position ${a+1} conflicts with ${g.length} static arguments`);const t=a-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,a)}return Reflect.construct(k,g.concat($))}k(k,g){if(this.f.get(k)instanceof M.$5h)this.f.set(k,g);else if(this.h)this.h.k(k,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(k){const g=this.f.get(k);return!g&&this.h?this.h.l(k):g}m(k,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(k));const l=this.l(k);return l instanceof M.$5h?this.q(k,l,g.branch(k,!0)):(g.branch(k,!1),l)}q(k,g,l){if(this.o.has(k))throw new Error(`illegal state - RECURSIVELY instantiating service '${k}'`);this.o.add(k);try{return this.r(k,g,l)}finally{this.o.delete(k)}}r(k,g,l){const f=new D.$Fq(t=>t.id.toString());let $=0;const a=[{id:k,desc:g,_trace:l}];for(;a.length;){const t=a.pop();if(f.lookupOrInsertNode(t),$++>1e3)throw new v(f);for(const o of P._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${k} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof M.$5h){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};f.insertEdge(t,i),a.push(i)}}}for(;;){const t=f.roots();if(t.length===0){if(!f.isEmpty())throw new v(f);break}for(const{data:o}of t){if(this.l(o.id)instanceof M.$5h){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}f.removeNode(o)}}return this.l(k)}s(k,g,l=[],f,$){if(this.f.get(k)instanceof M.$5h)return this.t(k,g,l,f,$);if(this.h)return this.h.s(k,g,l,f,$);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(k,g,l=[],f,$){if(f){const a=new y(void 0,this.g,this,this.i);a.c=String(k);const t=new Map,o=new S.$oh(()=>{const r=a.j(g,l,$);for(const[i,n]of t){const c=r[i];if(typeof c=="function")for(const w of n)w.disposable=c.apply(r,w.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let w=t.get(i);return w||(w=new u.$4c,t.set(i,w)),(I,E,C)=>{if(o.isInitialized)return o.value[i](I,E,C);{const j={listener:[I,E,C],disposable:void 0},U=w.push(j);return(0,s.$Rc)(()=>{U(),j.disposable?.dispose()})}}}if(i in r)return r[i];const n=o.value;let c=n[i];return typeof c!="function"||(c=c.bind(n),r[i]=c),c},set(r,i,n){return o.value[i]=n,!0},getPrototypeOf(r){return g.prototype}})}else return this.j(g,l,$)}u(k,g){if(g&&console.warn(k),this.g)throw new Error(k)}}e.$Gq=y;var h;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(h||(h={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(k,g){return k?new m(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(k,g){return k?new m(1,g.name):m.c}static{this.f=0}constructor(k,g){this.type=k,this.name=g,this.g=Date.now(),this.h=[]}branch(k,g){const l=new m(3,k.toString());return this.h.push([k,g,l]),l}stop(){const k=Date.now()-this.g;m.f+=k;let g=!1;function l($,a){const t=[],o=new Array($+1).join("	");for(const[r,i,n]of a.h)if(i&&n){g=!0,t.push(`${o}CREATES -> ${r}`);const c=l($+1,n);c&&t.push(c)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${k.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(k>2||g)&&m.all.add(f.join(`
`))}}e.$Hq=m}),define(ae[219],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DAb=e.IssueType=void 0;var O;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(O||(e.IssueType=O={})),e.$DAb=(0,S.$8h)("issueService")}),define(ae[5],ce([0,1,51,3,45,2,31,4,19,12,7,116,6]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.log=e.$sj=e.LogLevel=e.$rj=e.$qj=e.$pj=void 0,e.$pj=(0,y.$8h)("logService"),e.$qj=(0,y.$8h)("loggerService");function h(){return new Date().toISOString()}function m(I){return(0,u.$Nf)(I)}e.$rj=m;var p;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$sj=p.Info;function k(I,E,C){switch(E){case p.Trace:I.trace(C);break;case p.Debug:I.debug(C);break;case p.Info:I.info(C);break;case p.Warning:I.warn(C);break;case p.Error:I.error(C);break;case p.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=k;function g(I,E=!1){let C="";for(let j=0;j<I.length;j++){let U=I[j];if(U instanceof Error&&(U=(0,S.$Si)(U,E)),typeof U=="object")try{U=JSON.stringify(U)}catch{}C+=(j>0?" ":"")+U}return C}class l extends M.$Tc{constructor(){super(...arguments),this.b=e.$sj,this.c=this.B(new O.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==p.Off&&this.b<=E}}e.$uj=l;class f extends l{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...C){this.f(p.Trace)&&this.g(p.Trace,g([E,...C],!0))}debug(E,...C){this.f(p.Debug)&&this.g(p.Debug,g([E,...C]))}info(E,...C){this.f(p.Info)&&this.g(p.Info,g([E,...C]))}warn(E,...C){this.f(p.Warning)&&this.g(p.Warning,g([E,...C]))}error(E,...C){if(this.f(p.Error))if(E instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=E.stack,this.g(p.Error,g(j))}else this.g(p.Error,g([E,...C]))}flush(){}}e.$vj=f;class $ extends l{constructor(E=e.$sj){super(),this.setLevel(E),this.g=!P.$i}trace(E,...C){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,E,...C):console.log(`[main ${h()}]`,E,...C))}debug(E,...C){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,E,...C):console.log(`[main ${h()}]`,E,...C))}info(E,...C){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,E,...C):console.log(`[main ${h()}]`,E,...C))}warn(E,...C){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,E,...C):console.warn(`[main ${h()}]`,E,...C))}error(E,...C){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,E,...C):console.error(`[main ${h()}]`,E,...C))}flush(){}}e.$wj=$;class a extends l{constructor(E=e.$sj,C=!0){super(),this.g=C,this.setLevel(E)}trace(E,...C){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...C):console.log(E,...C))}debug(E,...C){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...C):console.log(E,...C))}info(E,...C){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...C):console.log(E,...C))}warn(E,...C){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...C):console.log(E,...C))}error(E,...C){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...C):console.error(E,...C))}flush(){}}e.$xj=a;class t extends l{constructor(E,C=e.$sj){super(),this.g=E,this.setLevel(C)}trace(E,...C){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(E),...C])}debug(E,...C){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(E),...C])}info(E,...C){this.f(p.Info)&&this.g.log(p.Info,[this.h(E),...C])}warn(E,...C){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(E),...C])}error(E,...C){this.f(p.Error)&&this.g.log(p.Error,[this.h(E),...C])}h(E){return typeof E=="string"?E:(0,S.$Si)(E,this.f(p.Trace))}flush(){}}e.$yj=t;class o extends l{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const C of this.g)C.setLevel(E);super.setLevel(E)}trace(E,...C){for(const j of this.g)j.trace(E,...C)}debug(E,...C){for(const j of this.g)j.debug(E,...C)}info(E,...C){for(const j of this.g)j.info(E,...C)}warn(E,...C){for(const j of this.g)j.warn(E,...C)}error(E,...C){for(const j of this.g)j.error(E,...C)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$zj=o;class r extends M.$Tc{constructor(E,C,j){if(super(),this.h=E,this.j=C,this.b=new D.$Ac,this.c=this.B(new O.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$Wd),this.onDidChangeVisibility=this.g.event,j)for(const U of j)this.b.set(U.resource,{logger:void 0,info:U})}m(E){return(0,u.$Jf)(E)?[...this.b.values()].find(C=>C.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,C){const j=this.n(E),U=(0,u.$Jf)(E)?E:C?.id??(0,s.$Vi)(j.toString()).toString(16);let F=this.b.get(j)?.logger;const H=C?.logLevel==="always"?p.Trace:C?.logLevel;F||(F=this.s(j,H??this.getLogLevel(j)??this.h,{...C,id:U}));const J={logger:F,info:{resource:j,id:U,logLevel:H,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(J.info),this.b.set(j,J),F}n(E){return(0,u.$Jf)(E)?(0,d.$Ig)(this.j,`${E}.log`):E}setLogLevel(E,C){if(b.URI.isUri(E)){const j=E,U=C,F=this.b.get(j);F&&U!==F.info.logLevel&&(F.info.logLevel=U===this.h?void 0:U,F.logger?.setLevel(U),this.b.set(F.info.resource,F),this.f.fire([j,U]))}else{this.h=E;for(const[j,U]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,C){const j=this.m(E);j&&C!==!j.info.hidden&&(j.info.hidden=!C,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,C]))}getLogLevel(E){let C;return E&&(C=this.b.get(E)?.info.logLevel),C??this.h}registerLogger(E){const C=this.b.get(E.resource);C?C.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const C=this.b.get(E);C&&(C.logger&&C.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Aj=r;class i{constructor(){this.onDidChangeLogLevel=new O.$Wd().event}setLevel(E){}getLevel(){return p.Info}trace(E,...C){}debug(E,...C){}info(E,...C){}warn(E,...C){}error(E,...C){}critical(E,...C){}dispose(){}flush(){}}e.$Bj=i;class n extends i{}e.$Cj=n;function c(I){if(I.verbose)return p.Trace;if(typeof I.logLevel=="string"){const E=A(I.logLevel.toLowerCase());if(E!==void 0)return E}return e.$sj}e.$Dj=c;function w(I){switch(I){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$Ej=w;function A(I){switch(I){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$Fj=A,e.$Gj=new v.$mj("logLevel",w(p.Info))});var se=this&&this.__param||function(Y,e){return function(S,O){e(S,O,Y)}};define(ae[220],ce([0,1,15,4,5]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$80b=void 0;const M=S.safeStorage;let D=class{constructor(d){this.a=d,S.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(d){this.a.trace("[EncryptionMainService] Encrypting value.");try{const u=JSON.stringify(M.encryptString(d));return this.a.trace("[EncryptionMainService] Encrypted value."),u}catch(u){throw this.a.error(u),u}}async decrypt(d){let u;try{if(u=JSON.parse(d),!u.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${d}`);const b=Buffer.from(u.data);this.a.trace("[EncryptionMainService] Decrypting value.");const v=M.decryptString(b);return this.a.trace("[EncryptionMainService] Decrypted value."),v}catch(b){throw this.a.error(b),b}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(O.$i)return Promise.resolve("dpapi");if(O.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const d=M.getSelectedStorageBackend();return Promise.resolve(d)}catch(d){this.a.error(d)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(O.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(O.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$80b=D,e.$80b=D=ve([se(0,s.$pj)],D)}),define(ae[221],ce([0,1,22,8,14,3,2,9,66,5]),function(Y,e,S,O,s,M,D,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class b extends D.$Tc{constructor(y,h){super(),this.a=y,this.b=h,this.c=this.B(new M.$Wd),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Wd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$6g(0)),this.w=[],this.y=this.B(new O.$6g(0))}watch(y,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n(y,h):this.z(y,h)}n(y,h){const m={path:this.H(y),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},p=(0,S.$Ub)(this.j,m);return this.r(),(0,D.$Rc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,s.$1)(y))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,d.$jq)(h)),h=>this.G(h),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const h of this.j)(0,d.$fq)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const h of this.j)(0,d.$fq)(h)&&y.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,h){const m={path:this.H(y),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},p=(0,S.$Ub)(this.w,m);return this.C(),(0,D.$Rc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,s.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,d.$jq)(y)),y=>this.G(y),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,P.$hc)(y.fsPath)}}e.$nq=b}),define(ae[222],ce([0,1,22,8,17,23,3,45,71,2,59,13,67,19,63,175,16,120,5,14]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;let a=class extends u.$Tc{static{$=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new D.$Wd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Wd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Wd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Wd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Wd),this.Y=this.B(new D.$Wd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Wd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new O.$eh)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${o}`);const i=new u.$Sc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(n=>{const c=new k.$Lk(n,!this.S(r));this.X.fire(c),c.hasCorrelation()||this.Y.fire(c)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,u.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,u.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await O.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return d.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,h.$Mg)(o))throw new k.$Nk((0,p.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new f.$bb;throw i.message=(0,p.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,k.$yk)(r)||(0,k.$vk)(r)||(0,k.$zk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,k.$yk)(r)||(0,k.$vk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,k.$Ik)(i)===k.FileSystemProviderErrorCode.FileNotFound?new k.$Nk((0,p.localize)(2,null,this.sb(o)),1):(0,k.$Gk)(i)}}async s(o,r){const i=await this.j(o),n=this.S(i),c=r?.resolveTo,w=r?.resolveSingleChildDescendants,A=r?.resolveMetadata,I=await i.stat(o);let E;return this.t(i,o,I,void 0,!!A,(C,j)=>(E||(E=b.$bi.forUris(()=>!n),E.set(o,!0),c&&E.fill(!0,c)),E.get(C.resource)||E.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&w?j===1:!1))}async t(o,r,i,n,c,w){const{providerExtUri:A}=this.R(o),I={resource:r,name:A.basename(r),isFile:(i.type&k.FileType.File)!==0,isDirectory:(i.type&k.FileType.Directory)!==0,isSymbolicLink:(i.type&k.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&k.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&k.FilePermission.Locked),etag:(0,k.$Yk)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&w(I,n)){try{const E=await o.readdir(r),C=await O.Promises.settled(E.map(async([j,U])=>{try{const F=A.joinPath(r,j),H=c?await o.stat(F):{type:U};return await this.t(o,F,H,E.length,c,w)}catch(F){return this.b.trace(F),null}}));I.children=(0,S.$Hb)(C)}catch(E){this.b.trace(E),I.children=[]}return I}return I}async resolveAll(o){return O.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new k.$Nk((0,p.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$ke.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,r);return this.r.fire(new k.$Kk(o,0,n)),n}async writeFile(o,r,i){const n=this.qb(await this.n(o),o),{providerExtUri:c}=this.R(n);let w=i;if((0,k.$Bk)(n)&&!w?.atomic){const A=n.enforceAtomicWriteFile?.(o);A&&(w={...i,atomic:A})}try{await this.w(n,o,w)||await this.U(n,c.dirname(o));let I;if((0,k.$vk)(n)&&!(r instanceof s.$ke))if((0,m.$9d)(r)){const E=await(0,m.$de)(r,3);E.ended?I=s.$ke.concat(E.buffer):I=E}else I=(0,m.$ae)(r,E=>s.$ke.concat(E),3);else I=r;!(0,k.$yk)(n)||(0,k.$vk)(n)&&I instanceof s.$ke||(0,k.$vk)(n)&&(0,k.$Bk)(n)&&w?.atomic?await this.hb(n,o,w,I):await this.db(n,o,w,I instanceof s.$ke?(0,s.$ve)(I):I),this.r.fire(new k.$Kk(o,4))}catch(A){throw new k.$Nk((0,p.localize)(4,null,this.sb(o),(0,k.$Gk)(A).toString()),(0,k.$Jk)(A),w)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(r)));if(n)throw new Error((0,p.localize)(8,null,this.sb(r)))}let w;try{w=await o.stat(r)}catch{return}if(w.type&k.FileType.Directory)throw new k.$Nk((0,p.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,w),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==k.$Xk&&typeof w.mtime=="number"&&typeof w.size=="number"&&i.mtime<w.mtime&&i.etag!==(0,k.$Yk)({mtime:i.mtime,size:w.size}))throw new k.$Nk((0,p.localize)(10,null),3,i);return w}async readFile(o,r,i){const n=await this.m(o);return r?.atomic?this.z(n,o,r,i):this.C(n,o,r,i)}async z(o,r,i,n){return new Promise((c,w)=>{this.cb.queueFor(r,async()=>{try{const A=await this.C(o,r,i,n);c(A)}catch(A){w(A)}},this.R(o).providerExtUri)})}async C(o,r,i,n){const c=await this.D(o,r,{...i,preferUnbuffered:!0},n);return{...c,value:await(0,s.$we)(c.value)}}async readFileStream(o,r,i){const n=await this.m(o);return this.D(n,o,r,i)}async D(o,r,i,n){const c=new M.$7d(n);let w=i;(0,k.$Ak)(o)&&o.enforceAtomicReadFile?.(r)&&(w={...i,atomic:!0});const A=this.J(r,w).then(E=>E,E=>{throw c.dispose(!0),E});let I;try{return typeof w?.etag=="string"&&w.etag!==k.$Xk&&await A,w?.atomic&&(0,k.$Ak)(o)||!((0,k.$yk)(o)||(0,k.$zk)(o))||(0,k.$vk)(o)&&w?.preferUnbuffered?I=this.I(o,r,w):(0,k.$zk)(o)?I=this.G(o,r,c.token,w):I=this.H(o,r,c.token,w),I.on("end",()=>c.dispose()),I.on("error",()=>c.dispose()),{...await A,value:I}}catch(E){throw I&&await(0,m.$be)(I),this.F(E,r,w)}}F(o,r,i){const n=(0,p.localize)(11,null,this.sb(r),(0,k.$Gk)(o).toString());return o instanceof k.$Pk?new k.$Pk(n,o.stat,i):o instanceof k.$Ok?new k.$Ok(n,o.fileOperationResult,o.size,o.options):new k.$Nk(n,(0,k.$Jk)(o),i)}G(o,r,i,n=Object.create(null)){const c=o.readFileStream(r,n,i);return(0,m.$he)(c,{data:w=>w instanceof s.$ke?w:s.$ke.wrap(w),error:w=>this.F(w,r,n)},w=>s.$ke.concat(w))}H(o,r,i,n=Object.create(null)){const c=(0,s.$Ae)();return(0,g.$dq)(o,r,c,w=>w,{...n,bufferSize:this.a,errorTransformer:w=>this.F(w,r,n)},i),c}I(o,r,i){const n=(0,m.$$d)(c=>s.$ke.concat(c));return(async()=>{try{let c;i?.atomic&&(0,k.$Ak)(o)?c=await o.readFile(r,{atomic:!0}):c=await o.readFile(r),typeof i?.position=="number"&&(c=c.slice(i.position)),typeof i?.length=="number"&&(c=c.slice(0,i.length)),this.L(r,c.byteLength,i),n.end(s.$ke.wrap(c))}catch(c){n.error(c),n.end()}})(),n}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new k.$Nk((0,p.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==k.$Xk&&r.etag===i.etag)throw new k.$Pk((0,p.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new k.$Ok((0,p.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,n){if(o.toString()!==r.toString())try{const c=i==="move"?this.qb(await this.n(o),o):await this.m(o),w=this.qb(await this.n(r),r);await this.Q(c,o,w,r,i,n)}catch(c){return c}return!0}async move(o,r,i){const n=this.qb(await this.n(o),o),c=this.qb(await this.n(r),r),w=await this.N(n,o,c,r,"move",!!i),A=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new k.$Kk(o,w==="move"?2:3,A)),A}async copy(o,r,i){const n=await this.m(o),c=this.qb(await this.n(r),r),w=await this.N(n,o,c,r,"copy",!!i),A=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new k.$Kk(o,w==="copy"?3:2,A)),A}async N(o,r,i,n,c,w){if(r.toString()===n.toString())return c;const{exists:A,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,i,n,c,w);if(A&&!I&&w&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),c==="copy"){if(o===i&&(0,k.$wk)(o))await o.copy(r,n,{overwrite:w});else{const E=await this.resolve(r);E.isDirectory?await this.P(o,E,i,n):await this.O(o,r,i,n)}return c}else return o===i?(await o.rename(r,n,{overwrite:w}),c):(await this.N(o,r,i,n,"copy",w),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,n){if((0,k.$yk)(o)&&(0,k.$yk)(i))return this.jb(o,r,i,n);if((0,k.$yk)(o)&&(0,k.$vk)(i))return this.pb(o,r,i,n);if((0,k.$vk)(o)&&(0,k.$yk)(i))return this.nb(o,r,i,n);if((0,k.$vk)(o)&&(0,k.$vk)(i))return this.lb(o,r,i,n)}async P(o,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await O.Promises.settled(r.children.map(async c=>{const w=this.R(i).providerExtUri.joinPath(n,c.name);return c.isDirectory?this.P(o,await this.resolve(c.resource),i,w):this.O(o,c.resource,i,w)}))}async Q(o,r,i,n,c,w){let A=!1;if(o===i){const{providerExtUri:E,isPathCaseSensitive:C}=this.R(o);if(C||(A=E.isEqual(r,n)),A&&c==="copy")throw new Error((0,p.localize)(15,null,this.sb(r),this.sb(n)));if(!A&&E.isEqualOrParent(n,r))throw new Error((0,p.localize)(16,null,this.sb(r),this.sb(n)))}const I=await this.exists(n);if(I&&!A){if(!w)throw new k.$Nk((0,p.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===i){const{providerExtUri:E}=this.R(o);if(E.isEqualOrParent(r,n))throw new Error((0,p.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:A}}R(o){const r=this.S(o);return{providerExtUri:r?h.$yg:h.$Ag,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new k.$Kk(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&k.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(r)));break}catch(c){if((0,k.$Ik)(c)!==k.FileSystemProviderErrorCode.FileNotFound)throw c;i.push(n.basename(r)),r=n.dirname(r)}for(let c=i.length-1;c>=0;c--){r=n.joinPath(r,i[c]);try{await o.mkdir(r)}catch(w){if((0,k.$Ik)(w)!==k.FileSystemProviderErrorCode.FileExists)throw w}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(o)));const c=r?.atomic;if(c&&!(i.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(o)));if(n&&c)throw new Error((0,p.localize)(22,null,this.sb(o)));let w;try{w=await i.stat(o)}catch{}if(w)this.rb(o,w);else throw new k.$Nk((0,p.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let n=r;if((0,k.$Ck)(i)&&!n?.atomic){const I=i.enforceAtomicDelete?.(o);I&&(n={...r,atomic:I})}const c=!!n?.useTrash,w=!!n?.recursive,A=n?.atomic??!1;await i.delete(o,{recursive:w,useTrash:c,atomic:A}),this.r.fire(new k.$Kk(o,1))}async cloneFile(o,r){const i=await this.j(o),n=this.qb(await this.n(r),r);if(!(i===n&&this.R(i).providerExtUri.isEqual(o,r)))return i===n&&(0,k.$xk)(i)?i.cloneFile(o,r):(await this.U(n,this.R(n).providerExtUri.dirname(r)),i===n&&(0,k.$wk)(i)?this.cb.queueFor(o,()=>i.copy(o,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,n,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:$.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new u.$Sc;let n=!1,c=()=>{n=!0};i.add((0,u.$Rc)(()=>c())),(async()=>{try{const A=await this.bb(o,r);n?(0,u.$Oc)(A):c=()=>(0,u.$Oc)(A)}catch(A){this.b.error(A)}})();const w=r.correlationId;if(typeof w=="number"){const A=i.add(new D.$Wd);return i.add(this.X.event(E=>{E.correlates(w)&&A.fire(E)})),{onDidChange:A.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),n=(0,P.$Vi)([this.R(i).providerExtUri.getComparisonKey(o),r]);let c=this.$.get(n);return c||(c={count:0,disposable:i.watch(o,r)},this.$.set(n,c)),c.count+=1,(0,u.$Rc)(()=>{c&&(c.count--,c.count===0&&((0,u.$Oc)(c.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,u.$Oc)(o.disposable);this.$.clear()}async db(o,r,i,n){return this.cb.queueFor(r,async()=>{const c=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,m.$9d)(n)||(0,m.$0d)(n)?await this.eb(o,c,n):await this.fb(o,c,n)}catch(w){throw(0,k.$Gk)(w)}finally{await o.close(c)}},this.R(o).providerExtUri)}async eb(o,r,i){let n=0,c;if((0,m.$0d)(i)){if(i.buffer.length>0){const w=s.$ke.concat(i.buffer);await this.gb(o,r,w,w.byteLength,n,0),n+=w.byteLength}if(i.ended)return;c=i.stream}else c=i;return new Promise((w,A)=>{(0,m.$ce)(c,{onData:async I=>{c.pause();try{await this.gb(o,r,I,I.byteLength,n,0)}catch(E){return A(E)}n+=I.byteLength,setTimeout(()=>c.resume())},onError:I=>A(I),onEnd:()=>w()})})}async fb(o,r,i){let n=0,c;for(;(c=i.read())!==null;)await this.gb(o,r,c,c.byteLength,n,0),n+=c.byteLength}async gb(o,r,i,n,c,w){let A=0;for(;A<n;){const I=await o.write(r,c+A,i.buffer,w+A,n-A);A+=I}}async hb(o,r,i,n){return this.cb.queueFor(r,()=>this.ib(o,r,i,n),this.R(o).providerExtUri)}async ib(o,r,i,n){let c;n instanceof s.$ke?c=n:(0,m.$9d)(n)?c=await(0,s.$we)(n):(0,m.$0d)(n)?c=await(0,s.$xe)(n):c=(0,s.$ue)(n),await o.writeFile(r,c.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,n){return this.cb.queueFor(n,()=>this.kb(o,r,i,n),this.R(i).providerExtUri)}async kb(o,r,i,n){let c,w;try{c=await o.open(r,{create:!1}),w=await i.open(n,{create:!0,unlock:!1});const A=s.$ke.alloc(this.a);let I=0,E=0,C=0;do C=await o.read(c,I,A.buffer,E,A.byteLength-E),await this.gb(i,w,A,C,I,E),I+=C,E+=C,E===A.byteLength&&(E=0);while(C>0)}catch(A){throw(0,k.$Gk)(A)}finally{await O.Promises.settled([typeof c=="number"?o.close(c):Promise.resolve(),typeof w=="number"?i.close(w):Promise.resolve()])}}async lb(o,r,i,n){return this.cb.queueFor(n,()=>this.mb(o,r,i,n),this.R(i).providerExtUri)}async mb(o,r,i,n){return i.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,n){return this.cb.queueFor(n,()=>this.ob(o,r,i,n),this.R(i).providerExtUri)}async ob(o,r,i,n){const c=await i.open(n,{create:!0,unlock:!1});try{const w=await o.readFile(r);await this.gb(i,c,s.$ke.wrap(w),w.byteLength,0,0)}catch(w){throw(0,k.$Gk)(w)}finally{await i.close(c)}}async pb(o,r,i,n){const c=await(0,s.$we)(this.H(o,r,M.CancellationToken.None));await this.hb(i,n,void 0,c)}qb(o,r){if(o.capabilities&2048)throw new k.$Nk((0,p.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&k.FilePermission.Readonly)throw new k.$Nk((0,p.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};e.$eq=a,e.$eq=a=$=ve([se(0,l.$pj)],a)}),define(ae[93],ce([0,1,46,311,8,31,17,3,33,2,9,4,19,63,21,179,16,120,221,51,217,216]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0,(()=>{try{(0,O.gracefulify)(S)}catch(o){console.error(`Error enabling graceful-fs: ${(0,f.$Si)(o)}`)}})();class t extends l.$nq{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=P.Event.None,this.N=new M.$Ac(n=>y.$zg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await m.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:k.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await m.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async c=>{try{let w;c.isSymbolicLink()?w=(await this.stat((0,y.$Ig)(r,c.name))).type:w=this.M(c),n.push([c.name,w])}catch(w){this.a.trace(w)}})),n}catch(i){throw this.fb(i)}}M(r,i){let n;return i?.dangling?n=k.FileType.Unknown:r.isFile()?n=k.FileType.File:r.isDirectory()?n=k.FileType.Directory:n=k.FileType.Unknown,i&&(n|=k.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const c=new s.$7g;return this.N.set(r,c),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,u.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===c&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),c.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const c=this.H(r);return await m.Promises.readFile(c)}catch(c){throw this.fb(c)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const c=(0,h.$$d)(w=>D.$ke.concat(w.map(A=>D.$ke.wrap(A))).buffer);return(0,g.$dq)(this,r,c,w=>w.buffer,{...i,bufferSize:256*1024},n),c}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,y.$Ig)((0,y.$Hg)(r),`${(0,y.$Fg)(r)}${n.atomic.postfix}`),i,n):this.S(r,i,n)}async Q(r){try{const i=this.H(r),{symbolicLink:n}=await m.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(r,i,n,c){const w=new u.$Sc;try{w.add(await this.O(r)),w.add(await this.O(i)),await this.S(i,n,c,!0);try{await this.rename(i,r,{overwrite:!0})}catch(A){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{w.dispose()}}async S(r,i,n,c){let w;try{const A=this.H(r);if(!n.create||!n.overwrite){if(await m.Promises.exists(A)){if(!n.overwrite)throw(0,k.$Fk)((0,p.localize)(0,null),k.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,k.$Fk)((0,p.localize)(1,null),k.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:n.unlock},c),await this.write(w,0,i,0,i.byteLength)}catch(A){throw await this.gb(r,A)}finally{typeof w=="number"&&await this.close(w)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,n){const c=this.H(r);let w;(0,k.$tk)(i)&&!n&&(w=await this.O(r));let A;try{if((0,k.$tk)(i)&&i.unlock)try{const{stat:E}=await m.SymlinkSupport.stat(c);E.mode&128||await m.Promises.chmod(c,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let I;if((0,k.$tk)(i)){if(v.$i)try{await m.Promises.truncate(c,0),I="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}I||(I="w")}else I="r";A=await m.Promises.open(c,I)}catch(I){throw w?.dispose(),(0,k.$tk)(i)?await this.gb(r,I):this.fb(I)}if(this.U.set(A,0),(0,k.$tk)(i)&&this.X.set(A,r),w){const I=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${c})`),this.W.set(A,w),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${c})`),I.dispose())}return A}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await m.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await m.Promises.close(r)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,c,w){const A=this.Z(r,i);let I=null;try{I=(await m.Promises.read(r,n,c,w,A)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(r,A,I)}return I}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,n){const c=this.U.get(r);typeof c=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(r,c+n):this.U.delete(r)))}async write(r,i,n,c,w){return(0,s.$ph)(()=>this.ab(r,i,n,c,w),100,3)}async ab(r,i,n,c,w){const A=this.Z(r,i);let I=null;try{I=(await m.Promises.write(r,n,c,w,A)).bytesWritten}catch(E){throw await this.gb(this.X.get(r),E)}finally{this.$(r,A,I)}return I}async mkdir(r){try{await m.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let c;i?.atomic!==!1&&i.atomic.postfix&&(c=(0,b.$jc)((0,b.$mc)(n),`${(0,b.$nc)(n)}${i.atomic.postfix}`)),await m.Promises.rm(n,m.RimRafMode.MOVE,c)}else try{await m.Promises.unlink(n)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let w=!1;try{const{stat:A,symbolicLink:I}=await m.SymlinkSupport.stat(n);w=A.isDirectory()&&!I}catch{}if(w)await m.Promises.rmdir(n);else throw c}else throw c}}catch(n){throw this.fb(n)}}async rename(r,i,n){const c=this.H(r),w=this.H(i);if(c!==w)try{await this.bb(r,i,"move",n.overwrite),await m.Promises.rename(c,w)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,p.localize)(2,null,(0,b.$nc)(c),(0,b.$nc)((0,b.$mc)(w)),A.toString()))),this.fb(A)}}async copy(r,i,n){const c=this.H(r),w=this.H(i);if(c!==w)try{await this.bb(r,i,"copy",n.overwrite),await m.Promises.copy(c,w,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,p.localize)(3,null,(0,b.$nc)(c),(0,b.$nc)((0,b.$mc)(w)),A.toString()))),this.fb(A)}}async bb(r,i,n,c){const w=this.H(r),A=this.H(i);let I=!1;if(!!(this.capabilities&1024)||(I=(0,d.$8f)(w,A,!0)),I){if(n==="copy")throw(0,k.$Fk)((0,p.localize)(4,null),k.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const C=await this.L(r);if(!C)throw(0,k.$Fk)((0,p.localize)(5,null),k.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(i);if(j){if(!c)throw(0,k.$Fk)((0,p.localize)(6,null),k.FileSystemProviderErrorCode.FileExists);C.type&k.FileType.File&&j.type&k.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,n){const c=this.H(r),w=this.H(i),A=!!(this.capabilities&1024);if((0,d.$8f)(c,w,!A))return;const I=new u.$Sc;try{I.add(await this.O(r)),I.add(await this.O(i)),n&&await m.Promises.mkdir((0,b.$mc)(w),{recursive:!0}),await m.Promises.copyFile(c,w)}catch(E){if(E.code==="ENOENT"&&!n)return this.cb(r,i,!0);throw this.fb(E)}finally{I.dispose()}}t(r,i,n){return new $.$uq(c=>r(c),c=>i(c),n)}F(r,i,n){return new a.$Cq(c=>r(c),c=>i(c),n)}fb(r){if(r instanceof k.$Ek)return r;let i=r,n;switch(r.code){case"ENOENT":n=k.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=k.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=k.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=k.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=k.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=k.FileSystemProviderErrorCode.Unknown;break;default:n=k.FileSystemProviderErrorCode.Unknown}return(0,k.$Fk)(i,n)}async gb(r,i){let n=this.fb(i);if(r&&n.code===k.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await m.SymlinkSupport.stat(this.H(r));c.mode&128||(n=(0,k.$Fk)(i,k.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return n}}e.$Dq=t}),define(ae[223],ce([0,1,3,93,2,17,63,23]),function(Y,e,S,O,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=void 0;class d extends s.$Tc{constructor(v,y){super(),this.a=v,this.b=y,this.F=new Map,this.G=new Map}call(v,y,h){const m=this.c(v);switch(y){case"stat":return this.g(m,h[0]);case"readdir":return this.h(m,h[0]);case"open":return this.r(m,h[0],h[1]);case"close":return this.s(h[0]);case"read":return this.t(h[0],h[1],h[2]);case"readFile":return this.j(m,h[0],h[1]);case"write":return this.u(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.n(m,h[0],h[1],h[2]);case"rename":return this.z(m,h[0],h[1],h[2]);case"copy":return this.C(m,h[0],h[1],h[2]);case"cloneFile":return this.D(m,h[0],h[1]);case"mkdir":return this.w(m,h[0]);case"delete":return this.y(m,h[0],h[1]);case"watch":return this.I(m,h[0],h[1],h[2],h[3]);case"unwatch":return this.J(h[0],h[1])}throw new Error(`IPC Command ${y} not found`)}listen(v,y,h){const m=this.c(v);switch(y){case"fileChange":return this.H(m,h[0]);case"readFileStream":return this.m(m,h[0],h[1])}throw new Error(`Unknown event ${y}`)}g(v,y){const h=this.f(v,y,!0);return this.a.stat(h)}h(v,y){const h=this.f(v,y);return this.a.readdir(h)}async j(v,y,h){const m=this.f(v,y,!0),p=await this.a.readFile(m,h);return M.$ke.wrap(p)}m(v,y,h){const m=this.f(v,y,!0),p=new P.$7d,k=new S.$Wd({onDidRemoveLastListener:()=>{p.cancel()}}),g=this.a.readFileStream(m,h,p.token);return(0,D.$ce)(g,{onData:l=>k.fire(M.$ke.wrap(l)),onError:l=>k.fire(l),onEnd:()=>{k.fire("end"),k.dispose(),p.dispose()}}),k.event}n(v,y,h,m){const p=this.f(v,y);return this.a.writeFile(p,h.buffer,m)}r(v,y,h){const m=this.f(v,y,!0);return this.a.open(m,h)}s(v){return this.a.close(v)}async t(v,y,h){const m=M.$ke.alloc(h),k=await this.a.read(v,y,m.buffer,0,h);return[m,k]}u(v,y,h,m,p){return this.a.write(v,y,h.buffer,m,p)}w(v,y){const h=this.f(v,y);return this.a.mkdir(h)}y(v,y,h){const m=this.f(v,y);return this.a.delete(m,h)}z(v,y,h,m){const p=this.f(v,y),k=this.f(v,h);return this.a.rename(p,k,m)}C(v,y,h,m){const p=this.f(v,y),k=this.f(v,h);return this.a.copy(p,k,m)}D(v,y,h){const m=this.f(v,y),p=this.f(v,h);return this.a.cloneFile(m,p)}H(v,y){const h=new S.$Wd({onWillAddFirstListener:()=>{this.F.set(y,this.L(v,h))},onDidRemoveLastListener:()=>{(0,s.$Oc)(this.F.get(y)),this.F.delete(y)}});return h.event}async I(v,y,h,m,p){const k=this.F.get(y);if(k){const g=this.f(v,m),l=k.watch(h,g,p);this.G.set(y+h,l)}}async J(v,y){const h=v+y,m=this.G.get(h);m&&((0,s.$Oc)(m),this.G.delete(h))}dispose(){super.dispose();for(const[,v]of this.G)v.dispose();this.G.clear();for(const[,v]of this.F)v.dispose();this.F.clear()}}e.$as=d;class u extends s.$Tc{constructor(v,y,h,m){super(),this.c=v,this.f=h,this.g=m,this.a=new Map,this.b=this.B(new O.$Dq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(v){const y=this.B(new S.$Wd);this.B(y.event(h=>{v.fire(h.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type,cId:m.cId})))})),this.B(this.b.onDidChangeFile(h=>y.fire(h))),this.B(this.b.onDidWatchError(h=>v.fire(h)))}j(v){}m(v){}watch(v,y,h){const m=this.m(this.g);return Array.isArray(m)&&(h.excludes=[...h.excludes,...m]),this.a.set(v,this.b.watch(y,h)),(0,s.$Rc)(()=>{(0,s.$Oc)(this.a.get(v)),this.a.delete(v)})}dispose(){for(const[,v]of this.a)v.dispose();this.a.clear(),super.dispose()}}e.$bs=u}),define(ae[224],ce([0,1,15,178,4,7,16,9,223,155]),function(Y,e,S,O,s,M,D,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=void 0;class b extends d.$as{constructor(h,m,p){super(h,m),this.M=p}c(h){return u.$8m}f(h,m){return M.URI.revive(m)}async y(h,m,p){if(!p.useTrash)return super.y(h,m,p);const k=this.f(h,m),g=(0,P.$hc)(k.fsPath);try{await S.shell.trashItem(g)}catch{throw(0,D.$Fk)(s.$i?(0,O.localize)(0,null,(0,P.$nc)(g)):(0,O.localize)(1,null,(0,P.$nc)(g)),D.FileSystemProviderErrorCode.Unknown)}}L(h,m){return new v(h,m,this.b,this.M)}}e.$d$b=b;class v extends d.$bs{watch(h,m,p){if(p.recursive)throw(0,D.$Fk)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(h,m,p)}}}),define(ae[225],ce([0,1,5]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$77b=void 0;class O extends S.$vj{constructor(M=S.$sj){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(M){this.n=M;for(const{level:D,message:P}of this.m)(0,S.log)(M,D,P);this.m=[]}g(M,D){this.n?(0,S.log)(this.n,M,D):this.getLevel()<=M&&this.m.push({level:M,message:D})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$77b=O}),define(ae[226],ce([0,1,7,3,5,2]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=e.$Cr=void 0;class D extends s.$Aj{constructor(v,y,h,m,p){super(y,h,m),this.r=v,this.t=p,this.B(p.listen("onDidChangeLogLevel",v)(k=>{(0,s.$rj)(k)?super.setLogLevel(k):super.setLogLevel(S.URI.revive(k[0]),k[1])})),this.B(p.listen("onDidChangeVisibility",v)(([k,g])=>super.setVisibility(S.URI.revive(k),g))),this.B(p.listen("onDidChangeLoggers",v)(({added:k,removed:g})=>{for(const l of k)super.registerLogger({...l,resource:S.URI.revive(l.resource)});for(const l of g)super.deregisterLogger(l.resource)}))}createConsoleMainLogger(){return new s.$yj({log:(v,y)=>{this.t.call("consoleLog",[v,y])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,y){super.setLogLevel(v,y),this.t.call("setLogLevel",[v,y])}setVisibility(v,y){super.setVisibility(v,y),this.t.call("setVisibility",[this.n(v),y])}s(v,y,h){return new P(this.t,v,y,h,this.r)}static setLogLevel(v,y,h){return v.call("setLogLevel",[y,h])}}e.$Cr=D;class P extends s.$vj{constructor(v,y,h,m,p){super(m?.logLevel==="always"),this.r=v,this.s=y,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[y,m,p]).then(()=>{this.u(this.n),this.m=!0})}g(v,y){const h=[[v,y]];this.m?this.u(h):this.n.push(...h)}u(v){this.r.call("log",[this.s,v])}}class d{constructor(v,y){this.a=v,this.b=y}listen(v,y){const h=this.b(v);switch(y){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(p=>this.c(p,h)),removed:[...m.removed].map(p=>this.c(p,h))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,m=>[h.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,m=>(0,s.$rj)(m)?m:[h.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${y}`)}async call(v,y,h){const m=this.b(v);switch(y){case"setLogLevel":return(0,s.$rj)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(S.URI.revive(m.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,m)))}throw new Error(`Call not found: ${y}`)}c(v,y){return{...v,resource:y.transformOutgoingURI(v.resource)}}}e.$Dr=d;class u extends M.$Tc{constructor(v,y){super(),y.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(h=>y.call("setLogLevel",[h]))),y.call("getRegisteredLoggers").then(h=>{for(const m of h)v.registerLogger({...m,resource:S.URI.revive(m.resource)})}),this.B(y.listen("onDidChangeVisibility")(([h,m])=>v.setVisibility(S.URI.revive(h),m))),this.B(y.listen("onDidChangeLoggers")(({added:h,removed:m})=>{for(const p of h)v.registerLogger({...p,resource:S.URI.revive(p.resource)});for(const p of m)v.deregisterLogger(p.resource)}))}}e.$Er=u}),define(ae[227],ce([0,1,2,5]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=void 0;class s extends S.$Tc{constructor(D,P=[]){super(),this.a=new O.$zj([D,...P]),this.B(D.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...P){this.a.trace(D,...P)}debug(D,...P){this.a.debug(D,...P)}info(D,...P){this.a.info(D,...P)}warn(D,...P){this.a.warn(D,...P)}error(D,...P){this.a.error(D,...P)}flush(){this.a.flush()}}e.$XO=s}),define(ae[228],ce([0,1,31,7,5]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_$b=void 0;class M{constructor(P){this.b=P,this.a=new S.$Ac}listen(P,d,u){switch(d){case"onDidChangeLoggers":return u?this.b.getOnDidChangeLoggersEvent(u):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return u?this.b.getOnDidChangeLogLevelEvent(u):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return u?this.b.getOnDidChangeVisibilityEvent(u):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${d}`)}async call(P,d,u){switch(d){case"createLogger":this.c(O.URI.revive(u[0]),u[1],u[2]);return;case"log":return this.e(O.URI.revive(u[0]),u[1]);case"consoleLog":return this.d(u[0],u[1]);case"setLogLevel":return(0,s.$rj)(u[0])?this.b.setLogLevel(u[0]):this.b.setLogLevel(O.URI.revive(u[0]),u[1]);case"setVisibility":return this.b.setVisibility(O.URI.revive(u[0]),u[1]);case"registerLogger":return this.b.registerLogger({...u[0],resource:O.URI.revive(u[0].resource)},u[1]);case"deregisterLogger":return this.b.deregisterLogger(O.URI.revive(u[0]))}throw new Error(`Call not found: ${d}`)}c(P,d,u){this.a.set(P,this.b.createLogger(P,d,u))}d(P,d){let u=console.log;switch(P){case s.LogLevel.Error:u=console.error;break;case s.LogLevel.Warning:u=console.warn;break;case s.LogLevel.Info:u=console.info;break}u.call(console,...d)}e(P,d){const u=this.a.get(P);if(!u)throw new Error("Create the logger before logging");for(const[b,v]of d)(0,s.log)(u,b,v)}}e.$_$b=M}),define(ae[229],ce([0,1,16,5]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MO=void 0;var s;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(s||(s={}));async function M(u,b,v,y,h){try{const m=await new Promise((k,g)=>{Y(["@vscode/spdlog"],k,g)});m.setFlushOn(s.Trace);const p=await m.createAsyncRotatingLogger(u,b,v,y);return h?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(m){console.error(m)}return null}function D(u,b,v){switch(b){case O.LogLevel.Trace:u.trace(v);break;case O.LogLevel.Debug:u.debug(v);break;case O.LogLevel.Info:u.info(v);break;case O.LogLevel.Warning:u.warn(v);break;case O.LogLevel.Error:u.error(v);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function P(u,b){switch(b){case O.LogLevel.Trace:u.setLevel(s.Trace);break;case O.LogLevel.Debug:u.setLevel(s.Debug);break;case O.LogLevel.Info:u.setLevel(s.Info);break;case O.LogLevel.Warning:u.setLevel(s.Warning);break;case O.LogLevel.Error:u.setLevel(s.Error);break;case O.LogLevel.Off:u.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class d extends O.$vj{constructor(b,v,y,h,m){super(),this.m=[],this.setLevel(m),this.n=this.s(b,v,y,h),this.B(this.onDidChangeLogLevel(p=>{this.r&&P(this.r,p)}))}async s(b,v,y,h){const m=y?6:1,p=30/m*S.$1k.MB,k=await M(b,v,p,m,h);if(k){this.r=k,P(this.r,this.getLevel());for(const{level:g,message:l}of this.m)D(this.r,g,l);this.m=[]}}g(b,v){this.r?D(this.r,b,v):this.getLevel()<=b&&this.m.push({level:b,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$MO=d}),define(ae[230],ce([0,1,32,5,229]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=void 0;class M extends O.$Aj{s(P,d,u){return new s.$MO((0,S.$rg)(),P.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,d)}}e.$NO=M}),define(ae[68],ce([0,1,31,3,6,5,230]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L0b=e.$K0b=void 0,e.$K0b=(0,s.$9h)(M.$qj);class P extends D.$NO{constructor(){super(...arguments),this.u=new S.$Ac}createLogger(u,b,v){v!==void 0&&this.u.set(this.n(u),v);try{return super.createLogger(u,b)}catch(y){throw this.u.delete(this.n(u)),y}}registerLogger(u,b){b!==void 0&&this.u.set(u.resource,b),super.registerLogger(u)}deregisterLogger(u){this.u.delete(u),super.deregisterLogger(u)}getRegisteredLoggers(u){const b=[];for(const v of super.getRegisteredLoggers())u===this.u.get(v.resource)&&b.push(v);return b}getOnDidChangeLogLevelEvent(u){return O.Event.filter(this.onDidChangeLogLevel,b=>(0,M.$rj)(b)||this.w(b[0],u))}getOnDidChangeVisibilityEvent(u){return O.Event.filter(this.onDidChangeVisibility,([b])=>this.w(b,u))}getOnDidChangeLoggersEvent(u){return O.Event.filter(O.Event.map(this.onDidChangeLoggers,b=>({added:[...b.added].filter(y=>this.w(y.resource,u)),removed:[...b.removed].filter(y=>this.w(y.resource,u))})),b=>b.added.length>0||b.removed.length>0)}deregisterLoggers(u){for(const[b,v]of this.u)v===u&&this.deregisterLogger(b)}w(u,b){const v=this.u.get(u);return v===void 0||v===b}dispose(){super.dispose(),this.u.clear()}}e.$L0b=P}),define(ae[231],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u$b=e.$t$b=e.$s$b=e.$r$b=void 0;function S(D){return D.submenu!==void 0}e.$r$b=S;function O(D){return D.id==="vscode.menubar.separator"}e.$s$b=O;function s(D){return D.uri!==void 0}e.$t$b=s;function M(D){return!S(D)&&!O(D)&&!s(D)}e.$u$b=M}),define(ae[39],ce([0,1,3,71,2,6]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=void 0,e.$Mn=(0,M.$8h)("policy");class D extends s.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$Wd),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const b=Object.keys(this.f).length;return this.f={...u,...this.f},b!==Object.keys(this.f).length&&await this.j(u),O.Iterable.reduce(this.g.entries(),(v,[y,h])=>({...v,[y]:h}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(u,[b,v])=>({...u,[b]:{definition:v,value:this.g.get(b)}}),{})}}e.$Nn=D;class P{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$On=P}),define(ae[232],ce([0,1,8,3,71,12,16,5,39]),function(Y,e,S,O,s,M,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s_b=void 0;function u(v,y){const h=[];for(const m of new Set(s.Iterable.concat(v.keys(),y.keys())))v.get(m)!==y.get(m)&&h.push(m);return h}let b=class extends d.$Nn{constructor(y,h,m){super(),this.m=y,this.n=h,this.s=m,this.c=this.B(new S.$6g(500));const p=O.Event.filter(h.onDidFilesChange,k=>k.affects(y));this.B(h.watch(y)),this.B(p(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const h=await this.n.readFile(this.m),m=JSON.parse(h.value.toString());if(!(0,M.$Lf)(m))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(m))this.f[p]&&y.set(p,m[p])}catch(h){h.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",h)}return y}async w(){const y=await this.u(),h=u(this.g,y);this.g=y,h.length>0&&this.h.fire(h)}};e.$s_b=b,e.$s_b=b=ve([se(1,D.$sk),se(2,P.$pj)],b)}),define(ae[233],ce([0,1,3,2,39]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=e.$3$b=void 0;class M{constructor(d){this.b=d,this.a=new O.$Sc}listen(d,u){switch(u){case"onDidChange":return S.Event.map(this.b.onDidChange,b=>b.reduce((v,y)=>({...v,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${u}`)}call(d,u,b){switch(u){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${u}`)}dispose(){this.a.dispose()}}e.$3$b=M;class D extends s.$Nn{constructor(d,u){super(),this.a=u;for(const b in d){const{definition:v,value:y}=d[b];this.f[b]=v,y!==void 0&&this.g.set(b,y)}this.a.listen("onDidChange")(b=>{for(const v in b){const y=b[v];y===null?this.g.delete(v):this.g.set(v,y)}this.h.fire(Object.keys(b))})}async j(d){const u=await this.a.call("updatePolicyDefinitions",d);for(const b in u)this.g.set(b,u[b])}}e.$4$b=D}),define(ae[234],ce([0,1,39,8,2,5]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r_b=void 0;let D=class extends S.$Nn{constructor(d,u){super(),this.m=d,this.n=u,this.a=new O.$2g,this.b=this.B(new s.$Uc)}async j(d){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(d).length} policy definitions`);const{createWatcher:u}=await new Promise((b,v)=>{Y(["@vscode/policy-watcher"],b,v)});await this.a.queue(()=>new Promise((b,v)=>{try{this.b.value=u(this.n,d,y=>{this.t(y),b()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),v(y)}}))}t(d){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(d)}`);for(const u in d){const b=d[u];b===void 0?this.g.delete(u):this.g.set(u,b)}this.h.fire(Object.keys(d))}};e.$r_b=D,e.$r_b=D=ve([se(0,M.$pj)],D)}),define(ae[79],ce([0,1,36]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const M=s.context.configuration();if(M)O=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,S.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:M.version})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(ae[27],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=void 0,e.$Hj=(0,S.$8h)("productService"),e.$Ij="vscode://schemas/vscode-product"}),define(ae[235],ce([0,1,8,5]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g$b=void 0;let s=class{constructor(D,P,d){this.a=D,this.b=P,this.c=d}async inspect(D){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$9g)(D);const d=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),d.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$g$b=s,e.$g$b=s=ve([se(2,O.$pj)],s)}),define(ae[80],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t0b=void 0,e.$t0b=(0,S.$8h)("protocolMainService")}),define(ae[44],ce([0,1,138,12]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class s{constructor(){this.a=new Map}add(D,P){S.ok(O.$Jf(D)),S.ok(O.$Lf(P)),S.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,P)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$Kn=new s}),define(ae[236],ce([0,1,3,44]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this.b=new S.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,u){this.a[s(d)]=u,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const D=new M;O.$Kn.add(e.$Ln.JSONContribution,D)}),define(ae[52],ce([0,1,22,3,12,163,18,236,44]),function(Y,e,S,O,s,M,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ConfigurationScope=e.$Pn=e.EditPresentationTypes=void 0;var u;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(u||(e.EditPresentationTypes=u={})),e.$Pn={Configuration:"base.contributions.configuration"};var b;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn="vscode://schemas/settings/resourceLanguage",e.$Xn="vscode://schemas/settings/configurationDefaults";const v=d.$Kn.as(P.$Ln.JSONContribution);class y{constructor(){this.h=new Set,this.i=new O.$Wd,this.onDidSchemaChange=this.i.event,this.j=new O.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$Wn,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),v.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),v.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),v.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:n}of t)for(const c in i)if(o.add(c),e.$Zn.test(c)){const w=this.a.get(c),A=w?.valuesSources??new Map;if(n)for(const j of Object.keys(i[c]))A.set(j,n);const I={...w?.value||{},...i[c]};this.a.set(c,{source:n,value:I,valuesSources:A});const E=(0,D.$Li)(c),C={type:"object",default:I,description:M.localize(1,null,E),$ref:e.$Wn,defaultDefaultValue:I,source:s.$Jf(n)?void 0:n,defaultValueSource:n};r.push(...p(c)),this.d[c]=C,this.b.properties[c]=C}else{this.a.set(c,{value:i[c],source:n});const w=this.d[c];w&&(this.w(c,w),this.r(c,w))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const n in r){const c=this.a.get(n),w=s.$Jf(i)?i:i?.id,A=s.$Jf(c?.source)?c?.source:c?.source?.id;if(w===A)if(o.add(n),this.a.delete(n),e.$Zn.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const n in i.properties){o.add(n);const c=this.d[n];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,o=!0,r,i,n=3,c){n=s.$Sf(t.scope)?n:t.scope;const w=t.properties;if(w)for(const I in w){const E=w[I];if(o&&f(I,E)){delete w[I];continue}if(E.source=r,E.defaultDefaultValue=w[I].default,this.w(I,E),e.$Zn.test(I)?E.scope=void 0:(E.scope=s.$Sf(E.scope)?n:E.scope,E.restricted=s.$Sf(E.restricted)?!!i?.includes(I):E.restricted),w[I].hasOwnProperty("included")&&!w[I].included){this.f[I]=w[I],delete w[I];continue}else this.d[I]=w[I],w[I].policy?.name&&this.e.set(w[I].policy.name,I);!w[I].deprecationMessage&&w[I].markdownDeprecationMessage&&(w[I].deprecationMessage=w[I].markdownDeprecationMessage),c.add(I)}const A=t.allOf;if(A)for(const I of A)this.p(I,o,r,i,n,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const c in i)this.r(c,i[c]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$Qn.properties[t]=o,o.scope){case 1:e.$Rn.properties[t]=o;break;case 2:e.$Sn.properties[t]=o;break;case 6:e.$Tn.properties[t]=o;break;case 3:e.$Un.properties[t]=o;break;case 4:e.$Vn.properties[t]=o;break;case 5:e.$Vn.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$Qn.properties[t],o.scope){case 1:delete e.$Rn.properties[t];break;case 2:delete e.$Sn.properties[t];break;case 6:delete e.$Tn.properties[t];break;case 3:delete e.$Un.properties[t];break;case 4:case 5:delete e.$Vn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$Wn};this.w(o,r),e.$Qn.properties[o]=r,e.$Rn.properties[o]=r,e.$Sn.properties[o]=r,e.$Tn.properties[o]=r,e.$Un.properties[o]=r,e.$Vn.properties[o]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$Wn};e.$Qn.patternProperties[e.$Yn]=t,e.$Rn.patternProperties[e.$Yn]=t,e.$Sn.patternProperties[e.$Yn]=t,e.$Tn.patternProperties[e.$Yn]=t,e.$Un.patternProperties[e.$Yn]=t,e.$Vn.patternProperties[e.$Yn]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$Qf(i)&&(i=o.defaultDefaultValue,n=void 0),s.$Qf(i)&&(i=g(o.type)),o.default=i,o.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",m=new RegExp(h,"g");e.$Yn=`^(${h})+$`,e.$Zn=new RegExp(e.$Yn);function p(a){const t=[];if(e.$Zn.test(a)){let o=m.exec(a);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=m.exec(a)}}return(0,S.$Mb)(t)}e.$1n=p;function k(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}e.$2n=k;function g(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$3n=g;const l=new y;d.$Kn.add(e.$Pn.Configuration,l);function f(a,t){return a.trim()?e.$Zn.test(a)?M.localize(7,null,a):l.getConfigurationProperties()[a]!==void 0?M.localize(8,null,a):t.policy?.name&&l.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,a,t.policy?.name,l.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$4n=f;function $(){const a=[],t=l.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$5n=$}),define(ae[121],ce([0,1,22,3,42,2,31,35,12,7,18,52,44]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0;function h(o){return Object.isFrozen(o)?o:P.$zn(o)}class m{constructor(r={},i=[],n=[],c){this.b=r,this.c=i,this.d=n,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof m)return i;const n=new p("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,b.$Ji)(this.contents,r):this.contents}inspect(r,i){const n=this;return{get value(){return h(n.rawConfiguration.getValue(r))},get override(){return i?h(n.rawConfiguration.getOverrideValue(r,i)):void 0},get merged(){return h(i?n.rawConfiguration.override(i).getValue(r):n.rawConfiguration.getValue(r))},get overrides(){const c=[];for(const{contents:w,identifiers:A,keys:I}of n.rawConfiguration.overrides){const E=new m(w,I).getValue(r);E!==void 0&&c.push({identifiers:A,value:E})}return c.length?h(c):void 0}}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,b.$Ji)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return S.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return S.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=P.$yn(this.contents),n=P.$yn(this.overrides),c=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const A of r)if(w.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(i,A.contents);for(const I of A.overrides){const[E]=n.filter(C=>S.$ub(C.identifiers,I.identifiers));E?(this.h(E.contents,I.contents),E.keys.push(...I.keys),E.keys=S.$Mb(E.keys)):n.push(P.$yn(I))}for(const I of A.keys)c.indexOf(I)===-1&&c.push(I)}return new m(i,c,n,w.every(A=>A instanceof m)?void 0:w)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const c of S.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let w=this.contents[c];const A=i[c];A&&(typeof w=="object"&&typeof A=="object"?(w=P.$yn(w),this.h(w,A)):w=A),n[c]=w}return new m(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&d.$Lf(r[n])&&d.$Lf(i[n])){this.h(r[n],i[n]);continue}r[n]=P.$yn(i[n])}}i(r){let i=null,n=null;const c=w=>{w&&(n?this.h(n,w):n=P.$yn(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===r?i=w.contents:w.identifiers.includes(r)&&c(w.contents);return c(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,b.$Ii)(this.contents,r),v.$Zn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>S.$ub(n.identifiers,(0,v.$1n)(r))),1))}j(r,i,n){(0,b.$Hi)(this.contents,r,i,c=>console.error(c)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),v.$Zn.test(r)&&this.overrides.push({identifiers:(0,v.$1n)(r),keys:Object.keys(this.contents[r]),contents:(0,b.$Gi)(this.contents[r],c=>console.error(c))})}}e.$6n=m;class p{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!d.$Sf(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:c,overrides:w,restricted:A,hasExcludedProperties:I}=this.h(r,i);this.b=new m(n,c,w,I?[r]:void 0),this.c=A||[]}g(r){let i={},n=null,c=[];const w=[],A=[];function I(C){Array.isArray(c)?c.push(C):n!==null&&(c[n]=C)}const E={onObjectBegin:()=>{const C={};I(C),w.push(c),c=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{c=w.pop()},onArrayBegin:()=>{const C=[];I(C),w.push(c),c=C,n=null},onArrayEnd:()=>{c=w.pop()},onLiteralValue:I,onError:(C,j,U)=>{A.push({error:C,offset:j,length:U})}};if(r)try{s.$mn(r,E),i=c[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return i}h(r,i){const n=y.$Kn.as(v.$Pn.Configuration).getConfigurationProperties(),c=this.i(r,n,!0,i);r=c.raw;const w=(0,b.$Gi)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),A=Object.keys(r),I=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:w,keys:A,overrides:I,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(r,i,n,c){let w=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:w};const A={},I=[];for(const E in r)if(v.$Zn.test(E)&&n){const C=this.i(r[E],i,!1,c);A[E]=C.raw,w=w||C.hasExcludedProperties,I.push(...C.restricted)}else{const C=i[E],j=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&I.push(E),!c.exclude?.includes(E)&&(c.include?.includes(E)||(j===void 0||c.scopes===void 0||c.scopes.includes(j))&&!(c.skipRestricted&&C?.restricted))?A[E]=r[E]:w=!0}return{raw:A,restricted:I,hasExcludedProperties:w}}j(r,i){const n=[];for(const c of Object.keys(r))if(v.$Zn.test(c)){const w={};for(const A in r[c])w[A]=r[c][A];n.push({identifiers:(0,v.$1n)(c),keys:Object.keys(w),contents:(0,b.$Gi)(w,i)})}return n}}e.$7n=p;class k extends M.$Tc{constructor(r,i,n,c){super(),this.c=r,this.f=i,this.g=c,this.b=this.B(new O.$Wd),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,w=>w.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&n.isEqual(w.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$8n=k;class g{constructor(r,i,n,c,w,A,I,E,C,j,U,F,H){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=c,this.d=w,this.f=A,this.g=I,this.h=E,this.i=C,this.j=j,this.k=U,this.l=F,this.m=H}get value(){return h(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class l{constructor(r,i,n,c,w=new m,A=new m,I=new D.$Ac,E=new m,C=new D.$Ac){this.c=r,this.d=i,this.f=n,this.g=c,this.h=w,this.i=A,this.j=I,this.l=E,this.m=C,this.a=null,this.b=new D.$Ac,this.n=null}getValue(r,i,n){return this.p(r,i,n).getValue(r)}updateValue(r,i,n={}){let c;n.resource?(c=this.m.get(n.resource),c||(c=new m,this.m.set(n.resource,c))):c=this.l,i===void 0?c.removeValue(r):c.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const c=this.p(r,i,n),w=this.t(i.resource,n),A=i.resource?this.m.get(i.resource)||this.l:this.l,I=new Set;for(const E of c.overrides)for(const C of E.identifiers)c.getOverrideValue(r,C)!==void 0&&I.add(C);return new g(r,i,c.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,w||void 0,A)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:c,updated:w,removed:A}=a(this.c,r);i=[...c,...w,...A]}for(const c of i)for(const w of(0,v.$1n)(c)){const A=this.c.getKeysForOverrideIdentifier(w),I=r.getKeysForOverrideIdentifier(w),E=[...I.filter(C=>A.indexOf(C)===-1),...A.filter(C=>I.indexOf(C)===-1),...A.filter(C=>!P.$Cn(this.c.override(w).getValue(C),r.override(w).getValue(C)))];n.push([w,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:c}=a(this.d,r),w=[...i,...n,...c];return w.length&&this.updatePolicyConfiguration(r),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:c,overrides:w}=a(this.applicationConfiguration,r),A=[...i,...n,...c];return A.length&&this.updateApplicationConfiguration(r),{keys:A,overrides:w}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:c,overrides:w}=a(this.localUserConfiguration,r),A=[...i,...n,...c];return A.length&&this.updateLocalUserConfiguration(r),{keys:A,overrides:w}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:c,overrides:w}=a(this.remoteUserConfiguration,r),A=[...i,...n,...c];return A.length&&this.updateRemoteUserConfiguration(r),{keys:A,overrides:w}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:c,overrides:w}=a(this.workspaceConfiguration,r),A=[...i,...n,...c];return A.length&&this.updateWorkspaceConfiguration(r),{keys:A,overrides:w}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:c,updated:w,removed:A,overrides:I}=a(n,i),E=[...c,...w,...A];return(E.length||!n)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:I}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:c,removed:w,overrides:A}=a(i,void 0);return{keys:[...n,...c,...w],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,n){let c=this.q(i,n);return i.overrideIdentifier&&(c=c.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(c=c.merge(this.d)),c}q({resource:r},i){let n=this.r();if(i&&r){const c=i.getFolder(r);c&&(n=this.s(c.uri)||n);const w=this.m.get(r);w&&(n=n.merge(w))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const n=this.r(),c=this.j.get(r);c?(i=n.merge(c),this.b.set(r,i)):i=n}return i}t(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:c,keys:w}=this.j.get(i);return r.push([i,{contents:n,overrides:c,keys:w}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c))),[...i.values()]}static parse(r){const i=this.w(r.defaults),n=this.w(r.policy),c=this.w(r.application),w=this.w(r.user),A=this.w(r.workspace),I=r.folders.reduce((E,C)=>(E.set(u.URI.revive(C[0]),this.w(C[1])),E),new D.$Ac);return new l(i,n,c,w,new m,A,I,new m,new D.$Ac)}static w(r){return new m(r.contents,r.keys,r.overrides)}}e.$9n=l;function f(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const c of o)c.keys.forEach(w=>r.add(w)),c.overrides.forEach(([w,A])=>{const I=(0,D.$xc)(i,w,new Set);A.forEach(E=>I.add(E))});const n=[];return i.forEach((c,w)=>n.push([w,[...c.values()]])),{keys:[...r.values()],overrides:n}}e.$0n=f;class ${constructor(r,i,n,c){this.change=r,this.f=i,this.g=n,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const w of r.keys)this.affectedKeys.add(w);for(const[,w]of r.overrides)for(const A of w)this.affectedKeys.add(A);this.d=this.a;for(const w of this.affectedKeys)this.d+=w+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=l.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,c=this.d.indexOf(n);if(c<0)return!1;const w=c+n.length;if(w>=this.d.length)return!1;const A=this.d.charCodeAt(w);if(A!==this.b&&A!==this.c)return!1;if(i){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,E=this.g.getValue(r,i,this.h);return!P.$Cn(I,E)}return!0}}e.$$n=$;function a(o,r){const{added:i,removed:n,updated:c}=t(r?.rawConfiguration,o?.rawConfiguration),w=[],A=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const E=I.filter(C=>!A.includes(C));for(const C of E)w.push([C,r.getKeysForOverrideIdentifier(C)])}if(o){const E=A.filter(C=>!I.includes(C));for(const C of E)w.push([C,o.getKeysForOverrideIdentifier(C)])}if(r&&o){for(const E of A)if(I.includes(E)){const C=t({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});w.push([E,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:n,updated:c,overrides:w}}function t(o,r){const i=o?r?o.keys.filter(w=>r.keys.indexOf(w)===-1):[...o.keys]:[],n=r?o?r.keys.filter(w=>o.keys.indexOf(w)===-1):[...r.keys]:[],c=[];if(o&&r){for(const w of r.keys)if(o.keys.indexOf(w)!==-1){const A=(0,b.$Ji)(r.contents,w),I=(0,b.$Ji)(o.contents,w);P.$Cn(A,I)||c.push(w)}}return{added:i,removed:n,updated:c}}}),define(ae[237],ce([0,1,22,3,2,35,12,121,52,5,39,44]),function(Y,e,S,O,s,M,D,P,d,u,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=void 0;class y extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new O.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$6n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$Kn.as(d.$Pn.Configuration).onDidUpdateConfiguration(({properties:k,defaultsOverrides:g})=>this.c(Array.from(k),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(k,g){this.h(k,v.$Kn.as(d.$Pn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:k})}f(){return{}}g(){this.b=new P.$6n;const k=v.$Kn.as(d.$Pn.Configuration).getConfigurationProperties();this.h(Object.keys(k),k)}h(k,g){const l=this.f();for(const f of k){const $=l[f],a=g[f];$!==void 0?this.b.addValue(f,$):a?this.b.addValue(f,a.default):this.b.removeValue(f)}}}e.$_n=y;class h{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new P.$6n}async initialize(){return this.configurationModel}}e.$ao=h;let m=class extends s.$Tc{get configurationModel(){return this.b}constructor(k,g,l){super(),this.c=k,this.f=g,this.g=l,this.a=this.B(new O.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$6n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(k=>this.j(k))),this.B(this.c.onDidChangeConfiguration(async({properties:k})=>this.m(await this.h(k),!0))),this.b}async h(k){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",k);const g={},l=[],f=v.$Kn.as(d.$Pn.Configuration).getConfigurationProperties();for(const $ of k){const a=f[$];if(!a){l.push($);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}l.push($),g[a.policy.name]={type:a.type}}}return(0,D.$Wf)(g)||await this.f.updatePolicyDefinitions(g),l}j(k){this.g.trace("PolicyConfiguration#onDidChangePolicies",k);const g=v.$Kn.as(d.$Pn.Configuration).getPolicyConfigurations(),l=(0,S.$Hb)(k.map(f=>g.get(f)));this.m(l,!0)}m(k,g){this.g.trace("PolicyConfiguration#update",k);const l=v.$Kn.as(d.$Pn.Configuration).getConfigurationProperties(),f=[],$=this.b.isEmpty();for(const a of k){const t=l[a]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);($?o!==void 0:!(0,M.$Cn)(this.b.getValue(a),o))&&f.push([a,o])}else this.b.getValue(a)!==void 0&&f.push([a,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const a=this.b;this.b=new P.$6n;for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,o]of f)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);g&&this.a.fire(this.b)}}};e.$bo=m,e.$bo=m=ve([se(1,b.$Mn),se(2,u.$pj)],m)}),define(ae[238],ce([0,1,22,8,17,3,42,102,2,35,4,19,18,121,52,237,39]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class g extends d.$Tc{constructor($,a,t,o){super(),this.m=$,this.h=this.B(new M.$Wd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$_n),this.c=t instanceof k.$On?new p.$ao:this.B(new p.$bo(this.b,t,o)),this.f=this.B(new h.$8n(this.m,{},v.$zg,a)),this.a=new h.$9n(this.b.configurationModel,this.c.configurationModel,new h.$6n,new h.$6n),this.j=new l($,a,this),this.g=this.B(new O.$hh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:i})=>this.r(r,i))),this.B(this.c.onDidChangeConfiguration(r=>this.s(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,a,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$9n($,a,new h.$6n,t)}getConfigurationData(){return this.a.toData()}getValue($,a){const t=typeof $=="string"?$:void 0,o=(0,y.$Ci)($)?$:(0,y.$Ci)(a)?a:{};return this.a.getValue(t,o,void 0)}async updateValue($,a,t,o,r){const i=(0,y.$Di)(t)?t:(0,y.$Ci)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,n=i?o:t;if(n!==void 0&&n!==3&&n!==2)throw new Error(`Unable to write ${$} to target ${n}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,S.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const c=this.inspect($,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(c.policyValue!==void 0)throw new Error(`Unable to write ${$} because it is configured in system policy.`);if((0,u.$Cn)(a,c.defaultValue)&&(a=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const A=i.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(E=>(0,S.$ub)([...E.identifiers].sort(),A));I&&(i.overrideIdentifiers=I.identifiers)}const w=i?.overrideIdentifiers?.length?[(0,m.$2n)(i.overrideIdentifiers),$]:[$];await this.j.write(w,a),await this.reloadConfiguration()}inspect($,a={}){return this.a.inspect($,a,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.n($)}n($){const a=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration($);this.t(t,a,2)}r($,a){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration($,a);this.t(o,t,7)}s($){const a=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration($);this.t(t,a,7)}t($,a,t){const o=new h.$$n($,{data:a},this.a);o.source=t,this.h.fire(o)}}e.$co=g;class l{constructor($,a,t){this.b=$,this.c=a,this.d=t,this.a=new O.$ch}write($,a){return this.a.queue(()=>this.e($,a))}async e($,a){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,D.$fn)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(t,$,a);t=(0,P.$xn)(t,r),await this.c.writeFile(this.b,s.$ke.fromString(t))}f($,a,t){const{tabSize:o,insertSpaces:r,eol:i}=this.h;if(!a.length){const n=JSON.stringify(t,null,r?" ".repeat(o):"	");return[{content:n,length:n.length,offset:0}]}return(0,P.$un)($,a,t,{tabSize:o,insertSpaces:r,eol:i})}get h(){if(!this.g){let $=b.OS===3||b.OS===2?`
`:`\r
`;const a=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});a&&typeof a=="string"&&a!=="auto"&&($=a),this.g={eol:$,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[239],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g_b=e.$f_b=e.$e_b=void 0,e.$e_b="request",e.$f_b="remoteResourceHandler";class S{async routeCall(s,M,D){if(M!==e.$e_b)throw new Error(`Call not found: ${M}`);const P=D[0];if(P?.authority){const d=s.connections.find(u=>u.ctx===P.authority);if(d)return d}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$g_b=S}),define(ae[240],ce([0,1,14,6]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.RemoteAuthorityResolverErrorCode=e.$_k=e.$$k=e.RemoteConnectionType=e.$0k=void 0,e.$0k=(0,O.$8h)("remoteAuthorityResolverService");var s;(function(b){b[b.WebSocket=0]="WebSocket",b[b.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$$k=M;class D{constructor(v,y){this.host=v,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$_k=D;var P;(function(b){b.Unknown="Unknown",b.NotAvailable="NotAvailable",b.TemporarilyNotAvailable="TemporarilyNotAvailable",b.NoResolverFound="NoResolverFound",b.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class d extends S.$bb{static isNotAvailable(v){return v instanceof d&&v._code===P.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof d&&v._code===P.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof d&&v._code===P.NoResolverFound}static isInvalidAuthority(v){return v instanceof d&&v._code===P.InvalidAuthority}static isHandled(v){return v instanceof d&&v.isHandled}constructor(v,y=P.Unknown,h){super(v),this._message=v,this._code=y,this._detail=h,this.isHandled=y===P.NotAvailable&&h===!0,Object.setPrototypeOf(this,d.prototype)}}e.$al=d;function u(b){const v=b.indexOf("+");return v===-1?b:b.substring(0,v)}e.$bl=u}),define(ae[60],ce([0,1,13]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0;function O(u){return u.scheme===S.Schemas.vscodeRemote?u.authority:void 0}e.$cl=O;function s(u){if(!u)return;const b=u.indexOf("+");return b<0?u:u.substr(0,b)}e.$dl=s;function M(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.$el=M;function D(u){const{host:b,port:v}=d(u);if(typeof v>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:b,port:v}}e.$fl=D;function P(u,b){let{host:v,port:y}=d(u);return typeof y>"u"&&(y=b),{host:v,port:y}}e.$gl=P;function d(u){const b=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const v=u.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const y=u.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:u,port:void 0}}}),define(ae[122],ce([0,1,25,6,60]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function M(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$lm=M,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(D||(e.ExtensionType=D={}));var P;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class d{constructor(k){this.value=k,this._lower=k.toLowerCase()}static equals(k,g){if(typeof k>"u"||k===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof k=="string"||typeof g=="string"){const l=typeof k=="string"?k:k.value,f=typeof g=="string"?g:g.value;return S.$af(l,f)}return k._lower===g._lower}static toKey(k){return typeof k=="string"?k.toLowerCase():k._lower}}e.$nm=d;class u{get size(){return this.c.size}constructor(k){if(this.c=new Set,k)for(const g of k)this.add(g)}add(k){this.c.add(d.toKey(k))}delete(k){return this.c.delete(d.toKey(k))}has(k){return this.c.has(d.toKey(k))}}e.$om=u;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete(k){this.c.delete(d.toKey(k))}get(k){return this.c.get(d.toKey(k))}has(k){return this.c.has(d.toKey(k))}set(k,g){this.c.set(d.toKey(k),g)}values(){return this.c.values()}forEach(k){this.c.forEach(k)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=b;function v(p){return y(p)}e.$qm=v;function y(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$rm=y;function h(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$sm=h;function m(p,k){if(k){const g=`onResolveRemoteAuthority:${(0,s.$dl)(k)}`;return!!p.activationEvents?.includes(g)}return!1}e.$tm=m,e.$um=(0,O.$8h)("IBuiltinExtensionsScannerService")}),define(ae[241],ce([0,1,8,17,23,14,3,2,67,72,32,111,240,60]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.PersistentConnectionEventType=e.$nl=e.$ml=e.$ll=e.ConnectionType=void 0;const m=30*1e3;var p;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function k(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(K){const R=new s.$7d;return setTimeout(()=>R.cancel(),K),R.token}function l(K,R){if(K.isCancellationRequested||R.isCancellationRequested)return s.CancellationToken.Cancelled;const W=new s.$7d;return K.onCancellationRequested(()=>W.cancel()),R.onCancellationRequested(()=>W.cancel()),W.token}class f{get didTimeout(){return this.c==="timedout"}constructor(R){this.c="pending",this.d=new P.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,S.$1g)(),R.isCancellationRequested?this.h():this.d.add(R.onCancellationRequested(()=>this.h()))}registerDisposable(R){this.c==="pending"?this.d.add(R):R.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(R))}reject(R){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(R))}}function $(K,R){const W=new f(R);return W.registerDisposable(K.onControlMessage(x=>{const N=JSON.parse(x.toString()),Q=L(N);Q?W.reject(Q):W.resolve(N)})),W.promise}function a(K,R,W,x,N,Q,V,_){const z=new f(_),ee=u.$Sd.create(!1);return K.info(`Creating a socket (${V})...`),d.mark(`code/willCreateSocket/${Q}`),R.connect(W,x,N,V).then(ne=>{z.didTimeout?(d.mark(`code/didCreateSocketError/${Q}`),K.info(`Creating a socket (${V}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),ne?.dispose()):(d.mark(`code/didCreateSocketOK/${Q}`),K.info(`Creating a socket (${V}) was successful after ${ee.elapsed()} ms.`),z.resolve(ne))},ne=>{d.mark(`code/didCreateSocketError/${Q}`),K.info(`Creating a socket (${V}) returned an error after ${ee.elapsed()} ms.`),K.error(ne),z.reject(ne)}),z.promise}function t(K,R){const W=new f(R);return K.then(x=>{W.didTimeout||W.resolve(x)},x=>{W.didTimeout||W.reject(x)}),W.promise}async function o(K,R,W,x){const N=oe(K,R);K.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await a(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,h.$el)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,k(R),`renderer-${k(R)}-${K.reconnectionToken}`,x)}catch(ne){throw K.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ne),ne}K.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let V,_;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(Q,null),V=K.reconnectionProtocol,_=!1):(V=new v.$Vh({socket:Q}),_=!0),K.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const z=await t(K.signService.createNewMessage((0,b.$rg)()),x),ee={type:"auth",auth:K.connectionToken||"00000000000000000000",data:z.data};V.sendControl(O.$ke.fromString(JSON.stringify(ee)));try{const ne=await $(V,l(x,g(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(K.logService.trace(`${N} 4/6. received SignRequest control message.`),!await t(K.signService.validate(z,ne.signedData),x)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const me=await t(K.signService.sign(ne.data),x),Ee={type:"connectionType",commit:K.commit,signedData:me,desiredConnectionType:R};return W&&(Ee.args=W),K.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(O.$ke.fromString(JSON.stringify(Ee))),{protocol:V,ownsProtocol:_}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(K.logService.error(`${N} the handshake timed out. Error:`),K.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${N} received error control message when negotiating connection. Error:`),K.logService.error(ne)),_&&q(V),ne}}async function r(K,R,W,x){const N=Date.now(),Q=oe(K,R),{protocol:V,ownsProtocol:_}=await o(K,R,W,x),z=new f(x);return z.registerDisposable(V.onControlMessage(ee=>{const ne=JSON.parse(ee.toString()),de=L(ne);de?(K.logService.error(`${Q} received error control message when negotiating connection. Error:`),K.logService.error(de),_&&q(V),z.reject(de)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${he(N)}!`),z.resolve({protocol:V,firstMessage:ne}))})),z.promise}async function i(K,R){const{protocol:W}=await r(K,1,void 0,R);return{protocol:W}}async function n(K,R,W){const{protocol:x,firstMessage:N}=await r(K,2,R,W),Q=N&&N.debugPort;return{protocol:x,debugPort:Q}}async function c(K,R,W){const x=Date.now(),N=oe(K,3),{protocol:Q}=await o(K,3,R,W);return K.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${he(x)}!`),Q}async function w(K,R,W){const{connectTo:x,connectionToken:N}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:x,connectionToken:N,reconnectionToken:R,reconnectionProtocol:W,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function A(K,R,W){return E(K,async x=>{const{protocol:N}=await i(x,s.CancellationToken.None);return new Z(K,R,W,x.reconnectionToken,N)})}e.$ll=A;async function I(K,R){return E(K,async W=>{const{protocol:x,debugPort:N}=await n(W,R,s.CancellationToken.None);return new X(K,R,W.reconnectionToken,x,N)})}e.$ml=I;async function E(K,R){for(let x=1;;x++)try{const N=(0,b.$rg)(),Q=await w(K,N,null);return await R(Q)}catch(N){if(x<5)K.logService.error(`[remote-connection][attempt ${x}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(N);else throw K.logService.error(`[remote-connection][attempt ${x}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(N),ue.triggerPermanentFailure(0,0,y.$al.isHandled(N)),N}}async function C(K,R,W){const x=await w(K,(0,b.$rg)(),null);return await c(x,{host:R,port:W},s.CancellationToken.None)}e.$nl=C;function j(K){return(0,S.$Ug)(R=>new Promise((W,x)=>{const N=setTimeout(W,K*1e3);R.onCancellationRequested(()=>{clearTimeout(N),W()})}))}var U;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class F{constructor(R,W){this.reconnectionToken=R,this.millisSinceLastIncomingData=W,this.type=0}}e.$ol=F;class H{constructor(R,W,x,N){this.reconnectionToken=R,this.millisSinceLastIncomingData=W,this.durationSeconds=x,this.c=N,this.type=1}skipWait(){this.c.cancel()}}e.$pl=H;class J{constructor(R,W,x){this.reconnectionToken=R,this.millisSinceLastIncomingData=W,this.attempt=x,this.type=2}}e.$ql=J;class le{constructor(R,W,x){this.reconnectionToken=R,this.millisSinceLastIncomingData=W,this.attempt=x,this.type=4}}e.$rl=le;class re{constructor(R,W,x,N){this.reconnectionToken=R,this.millisSinceLastIncomingData=W,this.attempt=x,this.handled=N,this.type=3}}e.$sl=re;class ue extends P.$Tc{static triggerPermanentFailure(R,W,x){this._permanentFailure=!0,this.f=R,this.g=W,this.h=x,this.j.forEach(N=>N.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(R=>R.y())}static debugPauseSocketWriting(){this.j.forEach(R=>R.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(R,W,x,N,Q){super(),this.t=R,this.u=W,this.reconnectionToken=x,this.protocol=N,this.w=Q,this.m=this.B(new D.$Wd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(N.onSocketClose(V=>{const _=B(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(N.onSocketTimeout(V=>{const _=B(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,P.$Rc)(()=>{const V=ue.j.indexOf(this);V>=0&&ue.j.splice(V,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const R=B(this.t,this.reconnectionToken,!0);this.u.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const N=x<W.length?W[x]:W[W.length-1];try{if(N>0){const V=j(N);this.m.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,V)),this.u.logService.info(`${R} waiting for ${N} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this.u.logService.info(`${R} resolving connection...`);const Q=await w(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${R} connecting to ${Q.connectTo}...`),await this.G(Q,g(m)),this.u.logService.info(`${R} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this.u.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(y.$al.isTemporarilyNotAvailable(Q)){this.u.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.u.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((0,M.$4)(Q)){this.u.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if(Q instanceof y.$al){this.u.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,y.$al.isHandled(Q));break}this.u.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!this.n&&!this.s)}C(R,W,x){this.w?ue.triggerPermanentFailure(R,W,x):this.D(R,W,x)}D(R,W,x){this.m.fire(new re(this.reconnectionToken,R,W,x)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$tl=ue;class Z extends ue{constructor(R,W,x,N,Q){super(1,R,N,Q,!0),this.client=this.B(new v.$Th(Q,{remoteAuthority:W,clientId:x},R.ipcLogger))}async G(R,W){await i(R,W)}}e.$ul=Z;class X extends ue{constructor(R,W,x,N,Q){super(2,R,x,N,!1),this.H=W,this.debugPort=Q}async G(R,W){await n(R,this.H,W)}}e.$vl=X;function q(K){try{K.acceptDisconnect();const R=K.getSocket();K.dispose(),R.dispose()}catch(R){(0,M.$1)(R)}}function L(K){if(K&&K.type==="error"){const R=new Error(`Connection error: ${K.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function T(K,R){for(;K.length<R;)K+=" ";return K}function G(K,R){return`[remote-connection][${T(k(K),13)}][${R.substr(0,5)}\u2026]`}function B(K,R,W){return`${G(K,R)}[${W?"reconnect":"initial"}]`}function oe(K,R){return`${B(R,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function he(K){return`${Date.now()-K} ms`}}),define(ae[242],ce([0,1,2,6]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=void 0,e.$hl=(0,O.$8h)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,P){return this.a[D]??=[],this.a[D].push(P),(0,S.$Rc)(()=>{const d=this.a[D]?.indexOf(P);typeof d=="number"&&d>=0&&this.a[D]?.splice(d,1)})}b(D){return(this.a[D.type]||[]).find(d=>d.supports(D))}connect(D,P,d,u){const b=this.b(D);if(!b)throw new Error(`No socket factory found for ${D}`);return b.connect(D,P,d,u)}}e.$il=s}),define(ae[243],ce([0,1,26,48,21,115]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f$b=void 0;let D;async function P(h=!1){return(D===void 0||h)&&(D=d()),D}e.$f$b=P;async function d(){const h=u();if(h===void 0)return!1;if(h>=22e3){const m=v();if(m)return new Promise(p=>{O.execFile(m,["--status"],k=>p(!k))})}else{const m=y();if(m)try{if((await s.Promises.stat(m)).isFile())return!0}catch{}}return!1}function u(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(h)return parseInt(h[3])}function b(h){const m=process.env.SystemRoot;if(m){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(m,p?"Sysnative":"System32",h)}}function v(){return b("wsl.exe")}function y(){return b("lxss\\LxssManager.dll")}}),define(ae[53],ce([0,1,17,14,2,183,52,6,5,44]),function(Y,e,S,O,s,M,D,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$jp=(0,P.$8h)("requestService");class b{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class v extends s.$Tc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,M.localize)(0,null),when:d.$Gj.isEqualTo((0,d.$Ej)(d.LogLevel.Trace)).serialize()})}async c(a,t,o){const r=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new b(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,O.$0)(i)),i}}}e.$kp=v;function y($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}e.$lp=y;function h($){return $.res.statusCode===204}e.$mp=h;async function m($){return h($)?null:(await(0,S.$we)($.stream)).toString()}e.$np=m;async function p($){if(!y($))throw new Error("Server returned "+$.res.statusCode);return m($)}e.$op=p;async function k($){if(!y($))throw new Error("Server returned "+$.res.statusCode);if(h($))return null;const t=(await(0,S.$we)($.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$pp=k;function g($){f($)}e.$qp=g;let l;function f($){const a=u.$Kn.as(D.$Pn.Configuration),t=l;l={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[l],remove:t?[t]:[]})}f(1)}),define(ae[244],ce([0,1,17,23]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=void 0;class s{constructor(P){this.a=P}listen(P,d){throw new Error("Invalid listen")}call(P,d,u,b=O.CancellationToken.None){switch(d){case"request":return this.a.request(u[0],b).then(async({res:v,stream:y})=>{const h=await(0,S.$we)(y);return[{statusCode:v.statusCode,headers:v.headers},h]});case"resolveProxy":return this.a.resolveProxy(u[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$mr=s;class M{constructor(P){this.a=P}async request(P,d){const[u,b]=await this.a.call("request",[P],d);return{res:u,stream:(0,S.$ye)(b)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$nr=M}),define(ae[245],ce([0,1,246,12]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;function s(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function M(D,P,d={}){const u=(0,S.parse)(D),b=d.proxyUrl||s(u,P);if(!b)return null;const v=(0,S.parse)(b);if(!/^https?:$/.test(v.protocol||""))return null;const y={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,O.$Pf)(d.strictSSL)?d.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((h,m)=>{Y(["http-proxy-agent"],h,m)})).HttpProxyAgent(b,y):new(await new Promise((h,m)=>{Y(["https-proxy-agent"],h,m)})).HttpsProxyAgent(b,y)}e.$or=M}),define(ae[247],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$b=e.$B$b=e.$A$b=void 0,e.$A$b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$B$b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$C$b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[94],ce([0,1,48,9,184,23,51,14,4,32,110,64,8,140]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=void 0;let m;async function p(g,l,f,$){return f["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.$i?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$8l)($)&&!f["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$8l)($)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=y.Promises.withAsyncBody(async(a,t)=>{const o=new M.$7d;let r=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,h.$9l)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{a(await k(l,o.token))}catch(c){!(0,P.$4)(c)&&!o.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,D.$Si)(c)))):a({})}finally{clearTimeout(n),o.dispose()}})),m)}e.$bm=p;async function k(g,l){const f=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",f);const $=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",$);const a=(0,u.$rg)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const r=await(0,b.$Xl)(d.OS,o);return g.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(l.isCancellationRequested)return n(new P.$5);const c=(0,O.$nc)(r);let w,A;const I="";/^pwsh(-preview)?$/.test(c)?(w=`& '${process.execPath}' ${I} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,A=["-Login","-Command"]):c==="nu"?(w=`^'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,A=["-i","-l","-c"]):c==="xonsh"?(w=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,A=["-i","-l","-c"]):(w=`'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"||c==="csh"?A=["-ic"]:A=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(A),w);const E=(0,S.spawn)(r,[...A,w],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});l.onCancellationRequested(()=>(E.kill(),n(new P.$5))),E.on("error",U=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,D.$Si)(U)),n(U)});const C=[];E.stdout.on("data",U=>C.push(U));const j=[];E.stderr.on("data",U=>j.push(U)),E.on("close",(U,F)=>{const H=Buffer.concat(C).toString("utf8");g.trace("getUnixShellEnvironment#raw",H);const J=Buffer.concat(j).toString("utf8");if(J.trim()&&g.trace("getUnixShellEnvironment#stderr",J),U||F)return n(new Error((0,s.localize)(2,null,U,F)));const le=t.exec(H),re=le?le[1]:"{}";try{const ue=JSON.parse(re);f?ue.ELECTRON_RUN_AS_NODE=f:delete ue.ELECTRON_RUN_AS_NODE,$?ue.ELECTRON_NO_ATTACH_CONSOLE=$:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){g.error("getUnixShellEnvironment#errorCaught",(0,D.$Si)(ue)),n(ue)}})})}}),define(ae[248],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const D=String(S.a++);return this.b.set(D,M),{id:D,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(M)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$w7b=S}),define(ae[95],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=void 0,e.$jl="signService",e.$kl=(0,S.$8h)(e.$jl)}),define(ae[249],ce([0,1,248]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q_b=void 0;class O extends S.$w7b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(D=>new D.signer().sign(M))}h(){return new Promise((M,D)=>Y(["vsda"],M,D))}}e.$q_b=O}),define(ae[34],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=void 0,e.$OO=(0,S.$8h)("stateReadService"),e.$PO=(0,S.$8h)("stateService")}),define(ae[123],ce([0,1,8,17,2,12,38,16,5]),function(Y,e,S,O,s,M,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=e.$QO=e.SaveStrategy=void 0;var u;(function(h){h[h.IMMEDIATE=0]="IMMEDIATE",h[h.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class b extends s.$Tc{constructor(m,p,k,g){super(),this.h=m,this.j=p,this.m=k,this.n=g,this.a=Object.create(null),this.b="",this.c=this.B(new S.$6g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.m.error(m)}}getItem(m,p){const k=this.a[m];return(0,M.$Sf)(k)?p:k}setItem(m,p){this.setItems([{key:m,data:p}])}setItems(m){let p=!1;for(const{key:k,data:g}of m)this.a[k]!==g&&((0,M.$Sf)(g)?(0,M.$Qf)(this.a[k])||(this.a[k]=void 0,p=!0):(this.a[k]=g,p=!0));p&&this.s()}removeItem(m){(0,M.$Qf)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,O.$ke.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(p){this.m.error(p)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$QO=b;let v=class extends s.$Tc{constructor(m,p,k,g){super(),this.a=this.B(new b(p.stateResource,m,k,g))}async init(){await this.a.init()}getItem(m,p){return this.a.getItem(m,p)}};e.$RO=v,e.$RO=v=ve([se(1,D.$ci),se(2,d.$pj),se(3,P.$sk)],v);class y extends v{setItem(m,p){this.a.setItem(m,p)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$SO=y}),define(ae[124],ce([0,1,4,36,32]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function M(d){if(S.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function D(d,u,b,v,y,h,m,p,k){const g=Object.create(null);g["common.machineId"]=h,g["common.sqmId"]=m,g.sessionID=(0,s.$rg)()+Date.now(),g.commitHash=v,g.version=y,g["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,S.$h)(S.$u),g["common.nodePlatform"]=O.$dc,g["common.nodeArch"]=b,g["common.product"]=k||"desktop",p&&(g["common.msftInternal"]=p);let l=0;const f=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),S.$l&&(g["common.snap"]="true");const $=M(u);return $&&(g["common.platformDetail"]=$),g}e.$Lo=D;function P(d){const u=O.env.USERDNSDOMAIN;if(!u)return!1;const b=u.toLowerCase();return d.some(v=>b===v)}e.$Mo=P}),define(ae[28],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0,e.$wl=(0,S.$8h)("telemetryService"),e.$xl=(0,S.$8h)("customEndpointTelemetryService"),e.$yl="telemetry.currentSessionDate",e.$zl="telemetry.firstSessionDate",e.$Al="telemetry.lastSessionDate",e.$Bl="telemetry.machineId",e.$Cl="telemetry.sqmId",e.$Dl="telemetry",e.$El="telemetry.telemetryLevel",e.$Fl="telemetry.enableCrashReporter",e.$Gl="telemetry.enableTelemetry";var O;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(ae[250],ce([0,1,26,8,42,13,9,4,7,88,21,109,91,16,27,28]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.$8r=void 0;const k=new Map;async function g(t,o){const r=`${t}::${o.join(":")}`,i=k.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,w=new Map,A=2e4;function I(C,j,U,F){const H=j.substring(C.length+1);return O.Promises.withAsyncBody(async J=>{let le;try{le=await b.Promises.readdir(j,{withFileTypes:!0})}catch{J();return}if(F.count>=A){F.count+=le.length,F.maxReached=!0,J();return}let re=le.length;if(re===0){J();return}let ue=le;F.count+le.length>A&&(F.maxReached=!0,re=A-F.count,ue=le.slice(0,re)),F.count+=le.length;for(const Z of ue)if(Z.isDirectory()){if(U.includes(Z.name)||await I(C,(0,D.$jc)(j,Z.name),U,F),--re===0){J();return}}else{const X=Z.name.lastIndexOf(".");if(X>=0){const q=Z.name.substring(X+1);q&&c.set(q,(c.get(q)??0)+1)}for(const q of n)q.relativePathPattern?.test(H)!==!1&&q.filePattern.test(Z.name)&&w.set(q.tag,(w.get(q.tag)??0)+1);if(--re===0){J();return}}})}const E=O.Promises.withAsyncBody(async C=>{const j={count:0,maxReached:!1};await I(t,t,o,j);const U=await $(t);C({configFiles:l(w),fileTypes:l(c),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:U})});return k.set(r,E),E}e.$8r=g;function l(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function f(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/h.$1k.GB).toFixed(2)}GB (${(S.freemem()/h.$1k.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$an.value()*100)}%`},o=S.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$9r=f;async function $(t){try{const o=new Map,r=(0,D.$jc)(t,".vscode","launch.json"),i=await b.Promises.readFile(r),n=[],c=(0,s.$fn)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$on)(c)==="object"&&c.configurations)for(const w of c.configurations){const A=w.type;A&&(o.has(A)?o.set(A,o.get(A)+1):o.set(A,1))}return l(o)}catch{return[]}}e.$0r=$;let a=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const i=S.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/h.$1k.GB).toFixed(2)}GB (${(S.freemem()/h.$1k.GB).toFixed(2)}GB free)`),P.$i||r.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(u.$an.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,v.$7r)(o.mainPID),this.k(o)]).then(async i=>{let[n,c]=i,w=this.m(o,n);return r.forEach(A=>{if((0,y.$Mm)(A))w+=`
${A.errorMessage}`,c+=`
${A.errorMessage}`;else if(w+=`

Remote: ${A.hostName}`,A.processes&&(w+=`
${this.m(o,A.processes)}`),A.workspaceMetadata){c+=`
|  Remote: ${A.hostName}`;for(const I of Object.keys(A.workspaceMetadata)){const E=A.workspaceMetadata[I];let C=`${E.fileCount} files`;E.maxFilesReached&&(C=`more than ${C}`),c+=`|    Folder (${I}): ${C}`,c+=this.h(E)}}}),{processInfo:w,workspaceInfo:c}})}async getSystemInfo(o,r){const{memory:i,vmHint:n,os:c,cpus:w}=f(),A={os:c,memory:i,cpus:w,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return P.$i||(A.load=`${S.loadavg().map(I=>Math.round(I)).join(", ")}`),P.$k&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(o,r){const i=[];return(0,v.$7r)(o.mainPID).then(async n=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,n)),o.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(c=>{if((0,y.$Mm)(c))i.push(`
${c.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${c.hostName}`),i.push(this.f(c.machineInfo)),c.processes&&i.push(this.m(o,c.processes)),c.workspaceMetadata)for(const w of Object.keys(c.workspaceMetadata)){const A=c.workspaceMetadata[w];let I=`${A.fileCount} files`;A.maxFilesReached&&(I=`more than ${I}`),i.push(`Folder (${w}): ${I}`),i.push(this.h(A))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let n=0;const c=(E,C)=>{const j=` ${E}(${C})`;n+j.length>60?(r.push(w),w="|                 ",n=w.length):n+=j.length,w+=j};let w="|      File types:";const A=10,I=o.fileTypes.length>A?A:o.fileTypes.length;for(let E=0;E<I;E++){const C=o.fileTypes[E];c(C.name,C.count)}if(r.push(w),o.configFiles.length>=0&&(w="|      Conf files:",n=0,o.configFiles.forEach(E=>{c(E.name,E.count)}),r.push(w)),o.launchConfigFiles.length>0){let E="|      Launch Configs:";o.launchConfigFiles.forEach(C=>{const j=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;E+=j}),r.push(E)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(c=>{const w=d.URI.revive(c);if(w.scheme===M.Schemas.file){const A=w.fsPath;i.push(g(A,["node_modules",".git"]).then(I=>{let E=`${I.fileCount} files`;I.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,D.$nc)(A)}): ${E}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${A} (${I.toString()})`)}))}else r.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const i=new Map;o.windows.forEach(c=>i.set(c.pid,`window [${c.id}] (${c.title})`)),o.pidToNames.forEach(({pid:c,name:w})=>i.set(c,w));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,n,r,0),n.join(`
`)}n(o,r,i,n,c){const w=c===0;let A;w?A=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?A=r.get(n.pid):A=`${"  ".repeat(c)} ${n.name}`;const I=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(I/h.$1k.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(n.children)&&n.children.forEach(E=>this.n(o,r,i,E,c+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const n=d.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const c=n.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(A=>r.add(A.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=d.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const c=await g(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),c.fileTypes.forEach(w=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})}),c.launchConfigFiles.forEach(w=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})}),c.configFiles.forEach(w=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})})}catch{}}}};e.$$r=a,e.$$r=a=ve([se(0,p.$wl),se(1,m.$Hj)],a)}),define(ae[251],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G$b=e.$F$b=void 0;class S{constructor(M){this.b=M}listen(M,D){throw new Error(`Event not found: ${D}`)}call(M,D,{eventName:P,data:d}){return this.b.forEach(u=>u.log(P,d)),Promise.resolve(null)}}e.$F$b=S;class O{constructor(M){this.b=M}log(M,D){return this.b.call("log",{eventName:M,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$G$b=O}),define(ae[54],ce([0,1,35,12,60,124,28]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class P{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$No=P;class d{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=d,e.$Po=new d;class u{async publicLog(o,r,i){}async publicLogError(o,r,i){}}e.$Qo=u,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function b(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}e.$Uo=b;function v(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Vo=v;function y(t){const o=t.getValue(D.$El),r=t.getValue(D.$Fl);if(t.getValue(D.$Gl)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=y;function h(t){const o={},r={},i={};k(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const c=i[n];typeof c=="number"?r[n]=c:typeof c=="boolean"?r[n]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${c.length}`),o[n]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(o[n]=c)}return{properties:o,measurements:r}}e.$Xo=h;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(t){if(!t)return"none";const o=(0,s.$dl)(t);return m.has(o)?o:"other"}e.$Yo=p;function k(t,o,r=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const c=t[n],w=i?i+n:n;Array.isArray(c)?o[w]=(0,S.$Dn)(c):c instanceof Date?o[w]=c.toISOString():(0,O.$Lf)(c)?r<2?k(c,o,r+1,w+"."):o[w]=(0,S.$Dn)(c):o[w]=c}}function g(t,o){const r=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,M.$Mo)(r)||i}e.$Zo=g;function l(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$1o=l;function f(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const A of o)for(;;){const I=A.exec(t);if(!I)break;i.push([I.index,A.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const A=c.exec(t);if(!A)break;const I=i.some(([E,C])=>A.index<C&&E<c.lastIndex);!n.test(A[0])&&!I&&(r+=t.substring(w,A.index)+"<REDACTED: user-file-path>",w=c.lastIndex)}return w<t.length&&(r+=t.substr(w)),r}function $(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function a(t,o){return(0,S.$An)(t,r=>{if(r instanceof P||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=f(i,o);for(const n of o)i=i.replace(n,"");return i=$(i),i}})}e.$2o=a}),define(ae[125],ce([0,1,25,119,122,4,7,14,36,54]),function(Y,e,S,O,s,M,D,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function b(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,S.$8e)(r.id,i.id)===0}e.$3o=b;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const n=i.manifest?i.manifest.version:i.version,c=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,n,c)}static parse(i){const n=v.exec(i);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,c="undefined"){this.version=n,this.targetPlatform=c,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?b(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$4o=y;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const i=h.exec(r);return i&&i[1]?[k(i[1]),i[2]]:[k(r),void 0]}e.$5o=m;function p(r,i){return`${r}.${i}`}e.$6o=p;function k(r){return r.toLowerCase()}e.$7o=k;function g(r,i){return k(p(r??s.$jm,i))}e.$8o=g;function l(r,i){const n=[],c=w=>{for(const A of n)if(A.some(I=>b(i(I),i(w))))return A;return null};for(const w of r){const A=c(w);A?A.push(w):n.push([w])}return n}e.$9o=l;function f(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$0o=f;function $(r){return{id:new u.$No(r.identifier.id),name:new u.$No(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$$o=$,e.$_o=new s.$nm("pprice.better-merge");function a(r,i){const n=[],c=i.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const w=c.shift();if(w&&n.every(A=>!b(A.identifier,{id:w}))){const A=r.filter(I=>b(I.identifier,{id:w}));A.length===1&&(n.push(A[0]),c.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$ap=a;async function t(r,i){if(!M.$k)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){i.debug("Error while getting the os-release file.",(0,P.$0)(w))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const n=await t(r,i),c=(0,O.$xo)(n?"alpine":M.$u,d.$ec);return i.debug("ComputeTargetPlatform:",c),c}e.$bp=o}),define(ae[252],ce([0,1,206,54]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;async function s(M,D,P,d,u,b,v){const y={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${D.nameShort})`};if((0,O.$Uo)(D,P)&&(0,O.$Wo)(d)===3){const h=await(0,S.$Cp)(P,u,b);y["X-Market-User-Id"]=h,y["VSCode-SessionId"]=v.machineId||h}return y}e.$Dp=s}),define(ae[253],ce([0,1,2,35,4,25,185,18,52,79,27,44,28,54]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,l,f){this.k=l,this.l=f,this.d={},this.i=new S.$Sc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,M.$Pe)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Pe)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(y.$El)||$.affectsConfiguration(y.$Gl)||$.affectsConfiguration(y.$Fl))&&this.m()}))}setExperimentProperty(g,l){this.d[g]=l}m(){let g=(0,h.$Wo)(this.k);const l=this.l.enabledTelemetryLevels;if(l){this.h=this.sendErrorTelemetry?l.error:!1;const f=l.usage?3:l.error?2:0;g=Math.min(g,f)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,l,f){this.g<l||(f=(0,O.$Bn)(f,this.d),f=(0,h.$2o)(f,this.j),f=(0,O.$Bn)(f,this.c),this.b.forEach($=>$.log(g,f)))}publicLog(g,l){this.n(g,3,l)}publicLog2(g,l){this.publicLog(g,l)}publicLogError(g,l){this.h&&this.n(g,2,l)}publicLogError2(g,l){this.publicLogError(g,l)}};e.$rr=m,e.$rr=m=ve([se(1,P.$Bi),se(2,b.$Hj)],m);function p(){const k=(0,D.localize)(0,null,u.default.nameLong),g=u.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=s.$o?"":(0,D.localize)(3,null),f=(0,D.localize)(4,null),$=(0,D.localize)(5,null),a=(0,D.localize)(6,null),t=(0,D.localize)(7,null),o=`
|       | ${f} | ${$} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${k} ${g} ${l}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}v.$Kn.as(d.$Pn.Configuration).registerConfiguration({id:y.$Dl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[y.$El]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$Kn.as(d.$Pn.Configuration).registerConfiguration({id:y.$Dl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[y.$Gl]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,D.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,D.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${y.$El}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[254],ce([0,1,4,88,28]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9$b=e.$8$b=void 0;async function M(P,d){let u=P.getItem(s.$Bl);return(typeof u!="string"||S.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,O.$bn)(d.error.bind(d))),u}e.$8$b=M;async function D(P,d){let u=P.getItem(s.$Cl);return typeof u!="string"&&(u=await(0,O.$cn)(d.error.bind(d))),u}e.$9$b=D}),define(ae[255],ce([0,1,28,254]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$$b=e.$0$b=void 0;async function s(D,P){const d=await(0,O.$8$b)(D,P);return D.setItem(S.$Bl,d),d}e.$0$b=s;async function M(D,P){const d=await(0,O.$9$b)(D,P);return D.setItem(S.$Cl,d),d}e.$$$b=M}),define(ae[126],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(ae[256],ce([0,1,4,126]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0;const s=new Map([[O.EnvironmentVariableMutatorType.Append,"APPEND"],[O.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[O.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(b){this.collections=b,this.a=new Map,this.b=new Map,b.forEach((v,y)=>{this.d(v,y);const h=v.map.entries();let m=h.next();for(;!m.done;){const p=m.value[1],k=m.value[0];let g=this.a.get(k);if(g||(g=[],this.a.set(k,g)),g.length>0&&g[0].type===O.EnvironmentVariableMutatorType.Replace){m=h.next();continue}const l={extensionIdentifier:y,value:p.value,type:p.type,scope:p.scope,variable:p.variable,options:p.options};l.scope||delete l.scope,g.unshift(l),m=h.next()}})}async applyToProcessEnvironment(b,v,y){let h;S.$i&&(h={},Object.keys(b).forEach(m=>h[m.toLowerCase()]=m));for(const[m,p]of this.getVariableMap(v)){const k=S.$i&&h[m.toLowerCase()]||m;for(const g of p){const l=y?await y(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case O.EnvironmentVariableMutatorType.Append:b[k]=(b[k]||"")+l;break;case O.EnvironmentVariableMutatorType.Prepend:b[k]=l+(b[k]||"");break;case O.EnvironmentVariableMutatorType.Replace:b[k]=l;break}if(g.options?.applyAtShellIntegration??!1){const f=`VSCODE_ENV_${s.get(g.type)}`;b[f]=(b[f]?b[f]+":":"")+m+"="+this.c(l)}}}}c(b){return b.replaceAll(":","\\x3a")}diff(b,v){const y=new Map,h=new Map,m=new Map;if(b.getVariableMap(v).forEach((p,k)=>{const g=this.getVariableMap(v).get(k),l=P(p,g);l&&y.set(k,l)}),this.getVariableMap(v).forEach((p,k)=>{const g=b.getVariableMap(v).get(k),l=P(p,g);l&&m.set(k,l)}),this.getVariableMap(v).forEach((p,k)=>{const g=b.getVariableMap(v).get(k),l=d(p,g);l&&h.set(k,l)}),!(y.size===0&&h.size===0&&m.size===0))return{added:y,changed:h,removed:m}}getVariableMap(b){const v=new Map;for(const y of this.a.values()){const h=y.filter(m=>D(m,b));h.length>0&&v.set(h[0].variable,h)}return v}getDescriptionMap(b){const v=new Map;for(const y of this.b.values()){const h=y.filter(m=>D(m,b,!0));for(const m of h)v.set(m.extensionIdentifier,m.description)}return v}d(b,v){if(!b.descriptionMap)return;const y=b.descriptionMap.entries();let h=y.next();for(;!h.done;){const m=h.value[1],p=h.value[0];let k=this.b.get(p);k||(k=[],this.b.set(p,k));const g={extensionIdentifier:v,scope:m.scope,description:m.description};g.scope||delete g.scope,k.push(g),h=y.next()}}}e.$Ur=M;function D(u,b,v=!1){return u.scope?!!(u.scope.workspaceFolder&&b?.workspaceFolder&&u.scope.workspaceFolder.index===b.workspaceFolder.index):v?b===u.scope:!0}function P(u,b){if(!b)return u;const v=new Set;b.forEach(h=>v.add(h.extensionIdentifier));const y=[];return u.forEach(h=>{v.has(h.extensionIdentifier)||y.push(h)}),y.length===0?void 0:y}function d(u,b){if(!b)return;const v=new Map;b.forEach(h=>v.set(h.extensionIdentifier,h));const y=[];return u.forEach(h=>{const m=v.get(h.extensionIdentifier);m&&(h.type!==m.type||h.value!==m.value||h.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&y.push(m)}),y.length===0?void 0:y}}),define(ae[257],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=void 0;function S(d){return[...d.entries()]}e.$Or=S;function O(d){return d?[...d.entries()]:[]}e.$Pr=O;function s(d){return new Map(d)}e.$Qr=s;function M(d){return new Map(d??[])}e.$Rr=M;function D(d){return Array.from(d.entries()).map(u=>[u[0],S(u[1].map),O(u[1].descriptionMap)])}e.$Sr=D;function P(d){return new Map(d.map(u=>[u[0],{map:s(u[1]),descriptionMap:M(u[2])}]))}e.$Tr=P}),define(ae[258],ce([0,1,8,23,3,2,5]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;let P=class extends M.$Tc{constructor(u,b){super(),this.h=b,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Wd),this.onCreateRequest=this.g.event,this.b=u===void 0?15e3:u,this.B((0,M.$Rc)(()=>{for(const v of this.f.values())(0,M.$Oc)(v)}))}createRequest(u){return new Promise((b,v)=>{const y=++this.a;this.c.set(y,b),this.g.fire({requestId:y,...u});const h=new O.$7d;(0,S.$9g)(this.b,h.token).then(()=>v(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,M.$Rc)(()=>h.cancel())])})}acceptReply(u,b){const v=this.c.get(u);v?(this.c.delete(u),(0,M.$Oc)(this.f.get(u)||[]),this.f.delete(u),v(b)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${u}`)}};e.$Fr=P,e.$Fr=P=ve([se(1,D.$pj)],P)}),define(ae[127],ce([0,1,6,116,44]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.$zr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$yr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$xr=void 0,e.$xr=new O.$mj("terminalTabFocusMode",!1,!0);var M;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var D;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var P;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh"})(P||(e.PosixShellType=P={}));var d;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash"})(d||(e.WindowsShellType=d={}));var u;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(u||(e.TitleEventSource=u={}));var b;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(b||(e.TerminalIpcChannels=b={}));var v;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$yr=(0,S.$8h)("ptyService");var y;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var h;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(h||(e.TerminalLocation=h={}));var m;(function(a){a.TerminalView="view",a.Editor="editor"})(m||(e.TerminalLocationString=m={}));var p;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(p||(e.LocalReconnectConstants=p={}));var k;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(k||(e.FlowControlConstants=k={}));var g;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var l;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var f;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(f||(e.TerminalExitReason=f={})),e.$zr={Backend:"workbench.contributions.terminal.processBackend"};class ${constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$Kn.add(e.$zr.Backend,new $),e.$Ar=(0,S.$8h)("localPtyService"),e.$Br=(0,S.$8h)("terminalLogService")}),define(ae[259],ce([0,1,74,7,187,104]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.$Hr=e.$Gr=void 0;function D(y,h){const m=[{name:null,description:(0,s.localize)(0,null)}];return m.push(...y.map(p=>({name:p.profileName,description:P(p)}))),h&&m.push(...h.map(p=>({name:p.title,description:d(p)}))),{values:m.map(p=>p.name),markdownDescriptions:m.map(p=>p.description)}}e.$Gr=D;function P(y){let h=`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$bk.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?h+=`
- args: "${y.args}"`:h+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(h+=`
- overrideName: ${y.overrideName}`),y.color&&(h+=`
- color: ${y.color}`),y.env&&(h+=`
- env: ${JSON.stringify(y.env)}`),h}function d(y){return`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$bk.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function u(y,h){if(!y&&!h)return!0;if(typeof y=="string"&&typeof h=="string")return y===h;if(Array.isArray(y)&&Array.isArray(h)){if(y.length!==h.length)return!1;for(let m=0;m<y.length;m++)if(y[m]!==h[m])return!1;return!0}return!1}e.$Hr=u;function b(y,h){if(!y&&!h)return!0;if(!y||!h)return!1;if(M.ThemeIcon.isThemeIcon(y)&&M.ThemeIcon.isThemeIcon(h))return y.id===h.id&&y.color===h.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof h=="object"&&"light"in h&&"dark"in h){const m=y,p=h;if((O.URI.isUri(m.light)||v(m.light))&&(O.URI.isUri(m.dark)||v(m.dark))&&(O.URI.isUri(p.light)||v(p.light))&&(O.URI.isUri(p.dark)||v(p.dark)))return m.light.path===p.light.path&&m.dark.path===p.dark.path}if(O.URI.isUri(y)&&O.URI.isUri(h)||v(y)||v(h)){const m=y,p=h;return m.path===p.path&&m.scheme===p.scheme}return!1}e.$Ir=b;function v(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$Jr=v}),define(ae[260],ce([0,1,74,4,186,52,44,259]),function(Y,e,S,O,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=e.$Lr=e.$Kr=void 0,e.$Kr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Lr={type:"string",enum:Array.from((0,S.$ak)(),k=>k.id),markdownEnumDescriptions:Array.from((0,S.$ak)(),k=>`$(${k.id})`)};const d={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$Lr},color:{description:(0,s.localize)(3,null),...e.$Kr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},u={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...d}},b={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...d}};function v(k){const g=k===2?"linux":k===1?"osx":"windows";return(0,s.localize)(7,null,(0,O.$h)(k),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:v(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...d}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...d}},{type:"null"},u]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:v(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...d}},{type:"null"},u]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:v(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...d}},{type:"null"},u]}},"terminal.integrated.useWslProfiles":{description:(0,s.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){D.$Kn.as(M.$Pn.Configuration).registerConfiguration(y),p()}e.$Mr=h;let m;function p(k,g){const l=D.$Kn.as(M.$Pn.Configuration);let f;k&&(f=(0,P.$Gr)(k?.profiles,g));const $=m;m={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:k?.os===3?f?.values:void 0,markdownEnumDescriptions:k?.os===3?f?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:k?.os===2?f?.values:void 0,markdownEnumDescriptions:k?.os===2?f?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:k?.os===1?f?.values:void 0,markdownEnumDescriptions:k?.os===1?f?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[m],remove:$?[$]:[]})}e.$Nr=p}),define(ae[261],ce([0,1,26,13,35,9,4,36,25,12,21,126,257,256]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=void 0;function m(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$Vr=m;async function p(i,n,c,w=P.env,A=b.Promises.exists){if(M.$ic(i))return await A(i)?i:void 0;if(n===void 0&&(n=P.cwd()),M.$mc(i)!=="."){const j=M.$jc(n,i);return await A(j)?j:void 0}const E=(0,s.$Fn)(w,"PATH");if(c===void 0&&(0,u.$Jf)(E)&&(c=E.split(M.$tc)),c===void 0||c.length===0){const j=M.$jc(n,i);return await A(j)?j:void 0}for(const j of c){let U;if(M.$ic(j)?U=M.$jc(j,i):U=M.$jc(n,j,i),await A(U))return U;if(D.$i){let F=U+".com";if(await A(F)||(F=U+".exe",await A(F)))return F}}const C=M.$jc(n,i);return await A(C)?C:void 0}e.$Wr=p;function k(i,n,c,w,A){const I=D.$i&&(!n.windowsEnableConpty||m()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||I)return;const E=i.args,C=P.$dc==="win32"?M.$nc(i.executable).toLowerCase():M.$nc(i.executable),j=M.$mc(O.$pg.asFileUri("").fsPath);let U;const F={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(F.VSCODE_NONCE=n.shellIntegration.nonce),D.$i){if(C==="pwsh.exe"||C==="powershell.exe")return!E||o(E)?U=f.get(l.WindowsPwsh):t(E)&&(U=f.get(l.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,d.$Le)(U[U.length-1],j,""),n.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),{newArgs:U,envMixin:F}):void 0;w.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(C){case"bash":return!E||E.length===0?U=f.get(l.Bash):r(E)&&(F.VSCODE_SHELL_LOGIN="1",g(n,F),U=f.get(l.Bash)),U?(U=[...U],U[U.length-1]=(0,d.$Le)(U[U.length-1],j),{newArgs:U,envMixin:F}):void 0;case"fish":{const H=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",J=M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return F.XDG_DATA_DIRS=`${H}:${J}`,g(n,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!E||o(E)?U=f.get(l.Pwsh):t(E)&&(U=f.get(l.PwshLogin)),U?(n.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),U=[...U],U[U.length-1]=(0,d.$Le)(U[U.length-1],j,""),{newArgs:U,envMixin:F}):void 0;case"zsh":{if(!E||E.length===0?U=f.get(l.Zsh):r(E)?(U=f.get(l.ZshLogin),g(n,F)):(E===f.get(l.Zsh)||E===f.get(l.ZshLogin))&&(U=E),!U)return;U=[...U],U[U.length-1]=(0,d.$Le)(U[U.length-1],j);let H;try{H=S.userInfo().username}catch{H="unknown"}const J=M.$jc(S.tmpdir(),`${H}-${A.applicationName}-zsh`);F.ZDOTDIR=J;const le=c?.ZDOTDIR??S.homedir()??"~";F.USER_ZDOTDIR=le;const re=[];return re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$jc(J,".zshrc")}),re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$jc(J,".zprofile")}),re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$jc(J,".zshenv")}),re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$jc(J,".zlogin")}),{newArgs:U,envMixin:F,filesToCopy:re}}}w.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$Xr=k;function g(i,n){if(D.$j&&i.environmentVariableCollections){const c=(0,y.$Tr)(i.environmentVariableCollections),A=new h.$Ur(c).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),I=[];if(A)for(const E of A)E.type===v.EnvironmentVariableMutatorType.Prepend&&I.push(E.value);I.length>0&&(n.VSCODE_PATH_PREFIX=I.join(""))}}var l;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(l||(l={}));const f=new Map;f.set(l.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(l.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(l.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(l.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(l.Zsh,["-i"]),f.set(l.ZshLogin,["-il"]),f.set(l.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const $=["-login","-l"],a=["-nol","-nologo"];function t(i){return typeof i=="string"?$.includes(i.toLowerCase()):i.length===1&&$.includes(i[0].toLowerCase())||i.length===2&&($.includes(i[0].toLowerCase())||$.includes(i[1].toLowerCase()))&&(a.includes(i[0].toLowerCase())||a.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?a.includes(i.toLowerCase()):i.length===0||i?.length===1&&a.includes(i[0].toLowerCase())}function r(i){return i==="string"&&$.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&$.includes(i[0].toLowerCase())}}),define(ae[262],ce([0,1,48,74,9,4,12,21,108,261,115]),function(Y,e,S,O,s,M,D,P,d,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0;var v;(function(c){c.UnixShellsPath="/etc/shells"})(v||(v={}));let y,h=!0;function m(c,w,A,I,E=process.env,C,j,U,F){return C=C||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},M.$i?p(A,C,E,j,I.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:I.getValue("terminal.integrated.profiles.windows"),typeof w=="string"?w:I.getValue("terminal.integrated.defaultProfile.windows"),F,U):r(C,j,A,c&&typeof c=="object"?{...c}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof w=="string"?w:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,U,E)}e.$Yr=m;async function p(c,w,A,I,E,C,j,U,F){const H=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),J=`${process.env.windir}\\${H?"Sysnative":"System32"}`;let le=!1;(0,u.$Vr)()>=16299&&(le=!0),await f(U);const re=new Map;if(c){re.set("PowerShell",{source:"PowerShell",icon:O.$bk.terminalPowershell,isAutoDetected:!0}),re.set("Windows PowerShell",{path:`${J}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.$bk.terminalPowershell,isAutoDetected:!0}),re.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),re.set("Command Prompt",{path:`${J}\\cmd.exe`,icon:O.$bk.terminalCmd,isAutoDetected:!0}),re.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),re.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:O.$bk.terminalBash,isAutoDetected:!0});const Z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;re.set("Cmder",{path:`${J}\\cmd.exe`,args:["/K",Z],requiresPath:process.env.CMDER_ROOT?Z:{path:Z,isUnsafe:!0},isAutoDetected:!0})}i(C,re);const ue=await k(re.entries(),j,w,A,I,F);if(c&&E)try{const Z=await t(`${J}\\${le?"wsl":"bash"}.exe`,j);for(const X of Z)(!C||!(X.profileName in C))&&ue.push(X)}catch{h&&(I?.trace("WSL is not installed, so could not detect WSL profiles"),h=!1)}return ue}async function k(c,w,A,I=process.env,E,C){const j=[];for(const[U,F]of c)j.push(g(U,F,w,A,I,E,C));return(await Promise.all(j)).filter(U=>!!U)}async function g(c,w,A,I,E=process.env,C,j){if(w===null)return;let U,F,H;if("source"in w&&!("path"in w)){const ue=y?.get(w.source);if(!ue)return;U=ue.paths,F=w.args||ue.args,w.icon?H=l(w.icon):ue.icon&&(H=ue.icon)}else U=Array.isArray(w.path)?w.path:[w.path],F=M.$i||Array.isArray(w.args)?w.args:void 0,H=l(w.icon);let J;if(j){const ue=U.map(X=>typeof X=="string"?X:X.path),Z=await j(ue);J=new Array(U.length);for(let X=0;X<U.length;X++)typeof U[X]=="string"?J[X]=Z[X]:J[X]={path:Z[X],isUnsafe:!0}}else J=U.slice();let le;if(w.requiresPath){let ue;if((0,D.$Jf)(w.requiresPath)?ue=w.requiresPath:(ue=w.requiresPath.path,w.requiresPath.isUnsafe&&(le=ue)),!await I.existsFile(ue))return}const re=await n(c,A,J,I,E,F,w.env,w.overrideName,w.isAutoDetected,le);if(!re){C?.debug("Terminal profile not validated",c,U);return}return re.isAutoDetected=w.isAutoDetected,re.icon=H,re.color=w.color,re}function l(c){return typeof c=="string"?{id:c}:c}async function f(c){if(y&&!c)return;const[w,A]=await Promise.all([$(),c||a()]);y=new Map,y.set("Git Bash",{profileName:"Git Bash",paths:w,args:["--login","-i"]}),y.set("PowerShell",{profileName:"PowerShell",paths:A,icon:O.$bk.terminalPowershell})}async function $(){const c=new Set,w=await(0,u.$Wr)("git.exe");if(w){const E=(0,b.dirname)(w);c.add((0,b.resolve)(E,"../.."))}function A(E,C){C&&E.add(C)}A(c,process.env.ProgramW6432),A(c,process.env.ProgramFiles),A(c,process.env["ProgramFiles(X86)"]),A(c,`${process.env.LocalAppData}\\Program`);const I=[];for(const E of c)I.push(`${E}\\Git\\bin\\bash.exe`,`${E}\\Git\\usr\\bin\\bash.exe`,`${E}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function a(){const c=[];for await(const w of(0,d.$Rl)())c.push(w.exePath);return c}async function t(c,w){const A=[],I=await new Promise((j,U)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,H)=>{if(F)return U("Problem occurred when getting wsl distros");j(H)})});if(!I)return[];const E=new RegExp(/[\r?\n]/),C=I.split(E).filter(j=>j.trim().length>0&&j!=="");for(const j of C){if(j===""||j.startsWith("docker-desktop"))continue;const U=`${j} (WSL)`,F={profileName:U,path:c,args:["-d",`${j}`],isDefault:U===w,icon:o(j),isAutoDetected:!1};A.push(F)}return A}function o(c){return c.includes("Ubuntu")?O.$bk.terminalUbuntu:c.includes("Debian")?O.$bk.terminalDebian:O.$bk.terminalLinux}async function r(c,w,A,I,E,C,j,U){const F=new Map;if(A&&await c.existsFile("/etc/shells")){const H=(await c.readFile("/etc/shells")).toString(),J=(C||H.split(`
`)).map(re=>{const ue=re.indexOf("#");return ue===-1?re:re.substring(0,ue)}).filter(re=>re.trim().length>0),le=new Map;for(const re of J){let ue=(0,s.$nc)(re),Z=le.get(ue)||0;Z++,Z>1&&(ue=`${ue} (${Z})`),le.set(ue,Z),F.set(ue,{path:re,isAutoDetected:!0})}}return i(I,F),await k(F.entries(),E,c,U,w,j)}function i(c,w){if(c)for(const[A,I]of Object.entries(c))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?w.delete(A):(I.icon=I.icon||w.get(A)?.icon,w.set(A,I))}async function n(c,w,A,I,E,C,j,U,F,H){if(A.length===0)return Promise.resolve(void 0);const J=A.shift();if(J==="")return n(c,w,A,I,E,C,j,U,F);const le=typeof J!="string"&&J.isUnsafe,re=typeof J=="string"?J:J.path,ue={profileName:c,path:re,args:C,env:j,overrideName:U,isAutoDetected:F,isDefault:c===w,isUnsafePath:le,requiresUnsafePath:H};if((0,s.$nc)(re)===re){const X=E.PATH?E.PATH.split(s.$tc):void 0,q=await(0,u.$Wr)(re,void 0,X,void 0,I.existsFile);return q?(ue.path=q,ue.isFromPath=!0,ue):n(c,w,A,I,E,C)}return await I.existsFile((0,s.$hc)(re))?ue:n(c,w,A,I,E,C,j,U,F)}}),define(ae[263],ce([0,1,3,2,4,43,18,5,226,94,258,127,260,262,110,72]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;var k;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(k||(k={}));let g=class extends O.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(f,$,a,t){super(),this.M=f,this.N=$,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$Wd),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$Wd),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$Wd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$Wd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$Wd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$Wd),this.onProcessData=this.D.event,this.F=this.B(new S.$Wd),this.onProcessReady=this.F.event,this.G=this.B(new S.$Wd),this.onProcessReplay=this.G.event,this.H=this.B(new S.$Wd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$Wd),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$Wd),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$Wd),this.onProcessExit=this.L.event,(0,y.$Mr)(),this.B(this.M),this.B((0,O.$Rc)(()=>this.W())),this.j=this.B(new b.$Fr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,u.$bm)(this.N,this.O,{_:[]},process.env)}catch(f){return this.O.error("ptyHost was unable to resolve shell environment",f),{}}}U(){const f=this.M.start(),$=f.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService($.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(f.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=k.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=M.ProxyChannel.toService($.getChannel(v.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new d.$Er(this.P,$.getChannel(v.TerminalIpcChannels.Logger))),this.a=f,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[f,t]}async createProcess(f,$,a,t,o,r,i,n,c,w,A){const I=setTimeout(()=>this.$(),v.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(f,$,a,t,o,r,i,n,c,w,A);return clearTimeout(I),E}updateTitle(f,$,a){return this.f.updateTitle(f,$,a)}updateIcon(f,$,a,t){return this.f.updateIcon(f,$,a,t)}attachToProcess(f){return this.f.attachToProcess(f)}detachFromProcess(f,$){return this.f.detachFromProcess(f,$)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(f){return this.f.start(f)}shutdown(f,$){return this.f.shutdown(f,$)}input(f,$){return this.f.input(f,$)}processBinary(f,$){return this.f.processBinary(f,$)}resize(f,$,a){return this.f.resize(f,$,a)}clearBuffer(f){return this.f.clearBuffer(f)}acknowledgeDataEvent(f,$){return this.f.acknowledgeDataEvent(f,$)}setUnicodeVersion(f,$){return this.f.setUnicodeVersion(f,$)}getInitialCwd(f){return this.f.getInitialCwd(f)}getCwd(f){return this.f.getCwd(f)}async getLatency(){const f=new p.$Sd,$=await this.f.getLatency();return f.stop(),[{label:"ptyhostservice<->ptyhost",latency:f.elapsed()},...$]}orphanQuestionReply(f){return this.f.orphanQuestionReply(f)}installAutoReply(f,$){return this.f.installAutoReply(f,$)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(f){return this.f.uninstallAutoReply(f)}getDefaultSystemShell(f){return this.g?.getDefaultSystemShell(f)??(0,m.$Xl)(f??s.OS,process.env)}async getProfiles(f,$,a,t=!1){const o=await this.S();return(0,h.$Yr)($,a,t,this.N,o,void 0,this.O,this.bb.bind(this,f))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(f,$){return this.f.getWslPath(f,$)}getRevivedPtyNewId(f,$){return this.f.getRevivedPtyNewId(f,$)}setTerminalLayoutInfo(f){return this.f.setTerminalLayoutInfo(f)}async getTerminalLayoutInfo(f){return this.g?.getTerminalLayoutInfo(f)}async requestDetachInstance(f,$){return this.f.requestDetachInstance(f,$)}async acceptDetachInstanceReply(f,$){return this.f.acceptDetachInstanceReply(f,$)}async freePortKillProcess(f){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(f)}async serializeTerminalState(f){return this.f.serializeTerminalState(f)}async reviveTerminalProcesses(f,$,a){return this.f.reviveTerminalProcesses(f,$,a)}async refreshProperty(f,$){return this.f.refreshProperty(f,$)}async updateProperty(f,$,a){return this.f.updateProperty(f,$,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(f){this.ab(),this.s=setTimeout(()=>this.Y(),f?v.HeartbeatConstants.ConnectingBeatInterval:v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(f,$){return this.j.createRequest({workspaceId:f,originalText:$})}async acceptPtyHostResolvedVariables(f,$){this.j.acceptReply(f,$)}};e.$Zr=g,e.$Zr=g=ve([se(1,D.$Bi),se(2,P.$pj),se(3,P.$qj)],g)}),define(ae[69],ce([0,1,15,3,2,4,18,6,34]),function(Y,e,S,O,s,M,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v0b=e.$u0b=void 0;const u="#FFFFFF",b="#1E1E1E",v="#000000",y="#FFFFFF",h="theme",m="themeBackground",p="windowSplash";e.$u0b=(0,P.$8h)("themeMainService");let k=class extends s.$Tc{constructor(l,f){super(),this.b=l,this.c=f,this.a=this.B(new O.$Wd),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration($=>{$.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(O.Event.fromNodeEventEmitter(S.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":S.nativeTheme.themeSource="dark";break;case"light":S.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":S.nativeTheme.themeSource="light";break;case"vs-dark":S.nativeTheme.themeSource="dark";break;default:S.nativeTheme.themeSource="system"}break;default:S.nativeTheme.themeSource="system";break}}getColorScheme(){if(M.$i){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const l=this.getColorScheme();if(l.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return l.dark?v:y;let f=this.b.getItem(m,null);if(!f)switch(this.g()){case"vs":f=u;break;case"hc-black":f=v;break;case"hc-light":f=y;break;default:f=b}return M.$j&&f.toUpperCase()===b&&(f="#171717"),f}g(){switch(this.b.getItem(h,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(l,f){this.b.setItems([{key:h,data:f.baseTheme},{key:m,data:f.colorInfo.background},{key:p,data:f}]),typeof l=="number"&&this.h(l,f),this.f()}h(l,f){for(const $ of S.BrowserWindow.getAllWindows())if($.id===l){$.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(p)}};e.$v0b=k,e.$v0b=k=ve([se(0,d.$PO),se(1,D.$Bi)],k)}),define(ae[128],ce([0,1,3,7,18,6,5]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.ProvidedOnAutoForward=e.$Ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dv=e.$Cv=void 0,e.$Cv=(0,M.$8h)("tunnelService"),e.$Dv=(0,M.$8h)("sharedTunnelsService");var P;(function(g){g.Http="http",g.Https="https"})(P||(e.TunnelProtocol=P={}));var d;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(d||(e.TunnelPrivacyId=d={}));function u(g){return!!g.forwardPort}e.$Ev=u;var b;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function v(g,{checkQuery:l=!0}={}){if(g.scheme!=="http"&&g.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(f)return{address:f[1],port:+f[2]};if(!g.query||!l)return;const $=g.query.split("&");for(const a of $){const t=a.split("=")[1];if(/^https?:/.exec(t)){const o=v(O.URI.parse(t));if(o)return o}}}e.$Fv=v,e.$Gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(g){return e.$Gv.indexOf(g)>=0}e.$Hv=y,e.$Iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function h(g){return e.$Iv.indexOf(g)>=0}e.$Jv=h;function m(g,l,f,$){if(f===1)return!1;if(f===2&&h(l)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(a?.length===4&&parseInt(a[1])>=18)return!1}return g<1024}e.$Kv=m;class p{constructor(l,f,$){this.remoteAddress=l,this.localAddress=f,this.b=$,this.a=new S.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lv=p;let k=class{constructor(l,f){this.k=l,this.l=f,this.a=new S.$Wd,this.onTunnelOpened=this.a.event,this.b=new S.$Wd,this.onTunnelClosed=this.b.event,this.c=new S.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const l=this.l.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.i=l.privacyOptions,this.h=l.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const l=[],f=Array.from(this.e.values());for(const $ of f){const a=Array.from($.values());for(const t of a){const o=await t.value;o&&typeof o!="string"&&l.push(o)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:f}of l.values())await f.then($=>typeof $!="string"?$?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,f,$,a,t){this.q(l,f,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:f,localAddress:$,privacy:a,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,f){(h(l)||y(l))&&(l=e.$Gv[0]);const $=this.s(l,f);if($)return++$.refcount,$.value}openTunnel(l,f,$,a,t,o=!1,r,i){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${$} on local port ${t}.`);const n=this.f??l;if(!n)return;if(f||(f="localhost"),a||(a=this.m),this.f&&this.j.has($)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.t(n,f,$,a,t,o,r,i);return c?c.then(w=>{if(w){if(typeof w=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(f,$),w}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(f,$);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const A=this.o(w);return(w.tunnelRemoteHost!==f||w.tunnelRemotePort!==$)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&w.privacy!==r&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(A),A}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}o(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const f=this.e.get(l.tunnelRemoteHost);if(f){const $=f.get(l.tunnelRemotePort);$&&($.refcount--,await this.p(l.tunnelRemoteHost,l.tunnelRemotePort,$))}}}}async p(l,f,$){if($.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${f}.`);const a=$.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(f),a}}async closeTunnel(l,f){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${f} `);const $=this.e.get(l);if($&&$.has(f)){const a=$.get(f);a.refcount=0,await this.p(l,f,a)}}q(l,f,$){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(f,{refcount:1,value:$})}async r(l,f){const $=this.e.get(l);if($){const a=$.get(f),t=a?await a.value:void 0;(!t||typeof t=="string")&&$.delete(f),$.size===0&&this.e.delete(l)}}s(l,f){const $=[l];y(l)?($.push(...e.$Gv),$.push(...e.$Iv)):h(l)&&$.push(...e.$Iv);const a=$.map(t=>this.e.get(t));for(const t of a){const o=t?.get(f);if(o)return o}}canTunnel(l){return!!v(l)}u(l,f,$,a,t,o,r){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${$} on local port ${a}.`);const i=$;this.j.add(i);const n=a===void 0?$:a,c={elevationRequired:t?this.isPortPrivileged(n):!1},w={remoteAddress:{host:f,port:$},localAddressPort:a,privacy:o,public:o?o!==d.Private:void 0,protocol:r},A=l.forwardPort(w,c);return A?(this.q(f,$,A),A.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(i)})):this.j.delete(i),A}};e.$Mv=k,e.$Mv=k=ve([se(0,D.$pj),se(1,s.$Bi)],k)}),define(ae[49],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UV=e.$TV=e.DisablementReason=e.UpdateType=e.StateType=void 0;var O;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(O||(e.StateType=O={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$TV={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,P)=>({type:"idle",updateType:D,error:P}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$UV=(0,S.$8h)("updateService")}),define(ae[264],ce([0,1,4,188,52,44]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$Kn.as(s.$Pn.Configuration).registerConfiguration({id:"update",order:15,title:(0,O.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,O.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,O.localize)(2,null),(0,O.localize)(3,null),(0,O.localize)(4,null),(0,O.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,O.localize)(6,null),deprecationMessage:(0,O.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,O.localize)(8,null),description:(0,O.localize)(9,null),included:S.$i&&!S.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,O.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ae[265],ce([0,1,3,49]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=e.$H$b=void 0;class s{constructor(P){this.a=P}listen(P,d){switch(d){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${d}`)}call(P,d,u){switch(d){case"checkForUpdates":return this.a.checkForUpdates(u);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(u)}throw new Error(`Call not found: ${d}`)}}e.$H$b=s;class M{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new S.$Wd,this.onStateChange=this.a.event,this.b=O.$TV.Uninitialized,this.c.listen("onStateChange")(d=>this.state=d),this.c.call("_getInitialState").then(d=>this.state=d)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$I$b=M}),define(ae[40],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=void 0,e.$3k=(0,S.$8h)("IUriIdentityService")}),define(ae[266],ce([0,1,40,207,16,19,141,3,2]),function(Y,e,S,O,s,M,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;class u{static{this._clock=0}constructor(y){this.uri=y,this.time=u._clock++}touch(){return this.time=u._clock++,this}}let b=class{constructor(y){this.g=y,this.c=new d.$Sc,this.f=2**16;const h=new Map,m=p=>{let k=h.get(p.scheme);return k===void 0&&(k=y.hasProvider(p)&&!this.g.hasCapability(p,1024),h.set(p.scheme,k)),k};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(p=>{h.delete(p.scheme)})),this.extUri=new M.$xg(m),this.d=new D.$3r((p,k)=>this.extUri.compare(p,k,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,M.$Jg)(y));const h=this.d.get(y);return h?h.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new u(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((m,p)=>m[1].time<p[1].time?1:m[1].time>p[1].time?-1:0);u._clock=0,this.d.clear();const h=this.f*.5;for(let m=0;m<h;m++)this.d.set(y[m][0],y[m][1].touch())}};e.$4r=b,e.$4r=b=ve([se(0,s.$sk)],b),(0,O.$1r)(S.$3k,b,1)}),define(ae[129],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KV=void 0,e.$KV=(0,S.$8h)("urlService")}),define(ae[267],ce([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R$b=e.$Q$b=e.$P$b=void 0;class O{constructor(P){this.a=P}listen(P,d){throw new Error(`Event not found: ${d}`)}call(P,d,u){switch(d){case"handleURL":return this.a.handleURL(S.URI.revive(u[0]),u[1])}throw new Error(`Call not found: ${d}`)}}e.$P$b=O;class s{constructor(P){this.a=P}handleURL(P,d){return this.a.call("handleURL",[P.toJSON(),d])}}e.$Q$b=s;class M{constructor(P,d){this.a=P,this.b=d}async routeCall(P,d,u,b){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(Array.isArray(u)&&u.length>0){const v=S.URI.revive(u[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const y=/\bwindowId=(\d+)/.exec(v.query);if(y){const h=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${h}"`,v.toString(!0));const m=new RegExp(`window:${h}`),p=P.connections.find(k=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",k.ctx),m.test(k.ctx)));if(p)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),p;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,d,u,b)}routeEvent(P,d){throw new Error(`Event not found: ${d}`)}}e.$R$b=M}),define(ae[268],ce([0,1,8,2,7,27]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MV=e.$LV=void 0;class D extends O.$Tc{constructor(){super(...arguments),this.a=new Set}open(u,b){const v=[...this.a.values()];return(0,S.$_g)(v.map(y=>()=>y.handleURL(u,b)),void 0,!1).then(y=>y||!1)}registerHandler(u){return this.a.add(u),(0,O.$Rc)(()=>this.a.delete(u))}}e.$LV=D;let P=class extends D{constructor(u){super(),this.b=u}create(u){let{authority:b,path:v,query:y,fragment:h}=u||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&v&&v.indexOf("/")!==0&&(v=`/${v}`),s.URI.from({scheme:this.b.urlProtocol,authority:b,path:v,query:y,fragment:h})}};e.$MV=P,e.$MV=P=ve([se(0,M.$Hj)],P)}),define(ae[269],ce([0,1,15,8,3,2,4,7]),function(Y,e,S,O,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S$b=void 0;class d extends M.$Tc{constructor(b,v,y,h,m,p){if(super(),this.c=v,this.f=p,this.a=[],this.b=0,b&&(p.trace("ElectronURLListener initialUrisToHandle:",b.map(l=>l.originalUrl)),this.a=b),D.$i){const l=h.isBuilt?[]:[`"${h.appRoot}"`];l.push("--open-url","--"),S.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,l)}const k=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(l,f)=>({event:l,url:f})),({event:l,url:f})=>(l.preventDefault(),f));this.B(k(l=>{const f=this.g(l);f&&this.c.open(f,{originalUrl:l})})),y.getWindows().filter(l=>l.isReady).length>0?(p.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(p.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(y.onDidSignalReadyWindow)(()=>this.h())))}g(b){try{return P.URI.parse(b)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const b=[];for(const v of this.a)await this.c.open(v.uri,{originalUrl:v.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),b.push(v));b.length!==0&&(this.a=b,(0,O.$0g)(()=>this.h(),500,this.q))}}e.$S$b=d}),define(ae[270],ce([0,1,3,2,16,59,31]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t_b=void 0;class P extends O.$Tc{constructor(u,b,v,y,h,m){super(),this.f=u,this.g=b,this.h=v,this.j=y,this.m=h,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$Wd),this.onDidChangeFile=this.a.event,this.b=M.$bi.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const u of this.j.profiles)this.c.add(u.settingsResource),this.c.add(u.keybindingsResource),this.c.add(u.tasksResource),this.c.add(u.extensionsResource)}open(u,b){return this.g.open(this.t(u),b)}close(u){return this.g.close(u)}read(u,b,v,y,h){return this.g.read(u,b,v,y,h)}write(u,b,v,y,h){return this.g.write(u,b,v,y,h)}watch(u,b){this.b.set(u,u);const v=this.g.watch(this.t(u),b);return(0,O.$Rc)(()=>{this.b.delete(u),v.dispose()})}stat(u){return this.g.stat(this.t(u))}mkdir(u){return this.g.mkdir(this.t(u))}rename(u,b,v){return this.g.rename(this.t(u),this.t(b),v)}readFile(u,b){return this.g.readFile(this.t(u),b)}readFileStream(u,b,v){return this.g.readFileStream(this.t(u),b,v)}readdir(u){return this.g.readdir(this.t(u))}enforceAtomicReadFile(u){return this.c.has(u)}writeFile(u,b,v){return this.g.writeFile(this.t(u),b,v)}enforceAtomicWriteFile(u){return this.c.has(u)?{postfix:".vsctmp"}:!1}delete(u,b){return this.g.delete(this.t(u),b)}copy(u,b,v){if((0,s.$wk)(this.g))return this.g.copy(this.t(u),this.t(b),v);throw new Error("copy not supported")}cloneFile(u,b){if((0,s.$xk)(this.g))return this.g.cloneFile(this.t(u),this.t(b));throw new Error("clone not supported")}s(u){const b=[];for(const v of u){if(v.resource.scheme!==this.f)continue;const y=this.u(v.resource);this.b.findSubstr(y)&&b.push({resource:y,type:v.type,cId:v.cId})}b.length&&(this.n.debug("User data changed"),this.a.fire(b))}t(u){return u.with({scheme:this.f})}u(u){return u.with({scheme:this.h})}}e.$t_b=P}),define(ae[271],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a_b=void 0,e.$a_b="utilityProcessWorker"}),define(ae[272],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T$b=void 0,e.$T$b=(0,S.$8h)("webviewManagerService")}),define(ae[273],ce([0,1,15,2,13,7]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U$b=void 0;class D extends O.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const d=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,d)}b(d,u){try{const b=M.URI.parse(d.url),v=D.a.get(b.path);if(typeof v=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${v}`,h=s.$pg.asFileUri(y);return u({path:h.fsPath,headers:{...s.COI.getHeadersFromQuery(d.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return u({error:-10})}catch{}return u({error:-2})}}e.$U$b=D}),define(ae[55],ce([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=e.$VC=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$UC=e.$TC=e.$SC=e.$RC=e.$QC=e.$PC=void 0,e.$PC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function O(g){return typeof g.parentId=="number"}e.$QC=O;function s(g){return!!g.workspaceUri}e.$RC=s;function M(g){return!!g.folderUri}e.$SC=M;function D(g){return!!g.fileUri}e.$TC=D;function P(g){const l=y(g),f=g.getValue("window.menuBarVisibility");return f==="default"||l&&f==="compact"||S.$j&&S.$m?"classic":f}e.$UC=P;var d;(function(g){g.TITLE_BAR_STYLE="window.titleBarStyle",g.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(d||(e.TitleBarSetting=d={}));var u;(function(g){g.NATIVE="native",g.CUSTOM="custom"})(u||(e.TitlebarStyle=u={}));var b;(function(g){g.AUTO="auto",g.WINDOWED="windowed",g.NEVER="never"})(b||(e.CustomTitleBarVisibility=b={}));function v(g,l){return!0}e.$VC=v;function y(g,l){return l||(l=h(g)),l==="native"}e.$WC=y;function h(g){if(S.$o)return"custom";const l=g.getValue("window");if(l){if(S.$j&&l.nativeTabs===!0||S.$j&&l.nativeFullScreen===!1)return"native";const a=l.titleBarStyle;if(a==="native"||a==="custom")return a}return S.$k?"native":"custom"}e.$XC=h;function m(g){return!(!S.$i||S.$o||y(g))}e.$YC=m;function p(g){const l=g.getValue("window");return!l||typeof l.nativeFullScreen!="boolean"||l.nativeTabs?!0:l.nativeFullScreen!==!1}e.$ZC=p;function k(g=0){return Math.pow(1.2,g)}e.$1C=k}),define(ae[96],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$k0b=e.UnloadReason=e.LoadReason=void 0;var S;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var O;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(O||(e.UnloadReason=O={}));const s=function(P=1){return{width:1024,height:768,mode:P}};e.$k0b=s;var M;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(ae[274],ce([0,1,8,3,2]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1$b=void 0;class M extends s.$Tc{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:d,getActiveWindowId:u}){super(),this.a=this.B(new s.$Sc),O.Event.latch(O.Event.any(P,d))(this.f,this,this.a),this.b=(0,S.$Ug)(()=>u()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$1$b=M}),define(ae[30],ce([0,1,192,9,59,19,7,6,13]),function(Y,e,S,O,s,M,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.WorkbenchState=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0,e.$ei=(0,P.$8h)("contextService");function u(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$fi=u;function b(i){return typeof i?.id=="string"&&!u(i)&&!y(i)}e.$gi=b,e.$hi={id:"ext-dev"},e.$ii={id:"empty-window"};function v(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.$nc)(i)}:n?e.$hi:e.$ii;const c=i;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.$ji=v;function y(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$ki=y;function h(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const c=i;if(c?.configPath)return{id:c.id,configPath:D.URI.revive(c.configPath)};if(i?.id)return{id:i.id}}e.$li=h;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$mi=p;function k(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$ni=k;class g{constructor(n,c,w,A,I){this.h=n,this.j=w,this.k=A,this.l=I,this.c=s.$bi.forUris(this.l,()=>!0),this.folders=c}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$bi.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$oi=g;class l{constructor(n,c){this.raw=c,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$Ig)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$pi=l;function f(i){return new l({uri:i,index:0,name:(0,M.$Eg)(i)},{uri:i.toString()})}e.$qi=f,e.$ri="code-workspace",e.$si=`.${e.$ri}`,e.$ti=[{name:(0,S.localize)(0,null),extensions:[e.$ri]}],e.$ui="workspace.json";function $(i,n){return M.$zg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$vi=$;function a(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===d.Schemas.tmp}e.$wi=a,e.$xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$xi}e.$yi=t;function o(i,n){return!$(i,n)&&!a(i)}e.$zi=o;function r(i){return(typeof i=="string"?(0,O.$oc)(i):(0,M.$Gg)(i))===e.$si}e.$Ai=r}),define(ae[56],ce([0,1,15,8,45,47,2,85,4,21,167,117,6,5,27,30]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s0b=e.$r0b=void 0,e.$r0b=(0,y.$8h)("dialogMainService");let k=class{constructor(l,f){this.d=l,this.e=f,this.a=new Map,this.b=new Map,this.c=new O.$ch}pickFileFolder(l,f){return this.f({...l,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},f)}pickFolder(l,f){return this.f({...l,pickFolders:!0,title:(0,b.localize)(1,null)},f)}pickFile(l,f){return this.f({...l,pickFiles:!0,title:(0,b.localize)(2,null)},f)}pickWorkspace(l,f){const $=(0,b.localize)(3,null),a=(0,M.$5v)((0,b.localize)(4,null)),t=p.$ti;return this.f({...l,pickFiles:!0,title:$,filters:t,buttonLabel:a},f)}async f(l,f){const $={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters,defaultPath:l.defaultPath};(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&($.properties=void 0,l.pickFiles&&l.pickFolders&&($.properties=["multiSelections","openDirectory","openFile","createDirectory"])),$.properties||($.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),d.$j&&$.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog($,(f||S.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(l){if(l){let f=this.b.get(l.id);return f||(f=new O.$ch,this.b.set(l.id,f)),f}else return this.c}showMessageBox(l,f){return this.g(f).queue(async()=>{const{options:$,buttonIndeces:a}=(0,v.$_v)(l,this.e);let t;return f?t=await S.dialog.showMessageBox(f,$):t=await S.dialog.showMessageBox($),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(l,f){const $=this.j(l,f);if(!$)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(f).queue(async()=>{let a;return f?a=await S.dialog.showSaveDialog(f,l):a=await S.dialog.showSaveDialog(l),a.filePath=this.h(a.filePath),a})}finally{(0,D.$Oc)($)}}h(l){return l&&d.$j&&(l=(0,P.$Il)(l)),l}i(l){return l.map(f=>this.h(f))}async showOpenDialog(l,f){l.defaultPath&&(await u.Promises.exists(l.defaultPath)||(l.defaultPath=void 0));const $=this.j(l,f);if(!$)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(f).queue(async()=>{let a;return f?a=await S.dialog.showOpenDialog(f,l):a=await S.dialog.showOpenDialog(l),a.filePaths=this.i(a.filePaths),a})}finally{(0,D.$Oc)($)}}j(l,f){if(!f)return D.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",l);let $=this.a.get(f.id);$||($=new Set,this.a.set(f.id,$));const a=(0,s.$Vi)(l);if(!$.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",l),$.add(a),(0,D.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",l),$?.delete(a),$?.size===0&&this.a.delete(f.id)})}};e.$s0b=k,e.$s0b=k=ve([se(0,h.$pj),se(1,m.$Hj)],k)}),define(ae[275],ce([0,1,3,2,76,30]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=void 0;class D extends O.$Tc{static{this.a=100}constructor(d,u){super(),this.f=d,this.g=u,this.b=this.B(new S.$Wd),this.c=new Map,this.h(u.applicationStorage,this.b)}h(d,u){this.B(S.Event.debounce(d.onDidChangeStorage,(b,v)=>(b?b.push(v):b=[v],b),D.a)(b=>{b.length&&u.fire(this.j(b,d))}))}j(d,u){const b=new Map,v=new Set;return d.forEach(y=>{const h=u.get(y.key);typeof h=="string"?b.set(y.key,h):v.add(y.key)}),{changed:Array.from(b.entries()),deleted:Array.from(v.values())}}listen(d,u,b){switch(u){case"onDidChangeStorage":{const v=b.profile?(0,s.$Eh)(b.profile):void 0;if(!v)return this.b.event;let y=this.c.get(v.id);return y||(y=this.B(new S.$Wd),this.h(this.g.profileStorage(v),y),this.c.set(v.id,y)),y.event}}throw new Error(`Event not found: ${u}`)}async call(d,u,b){const v=b.profile?(0,s.$Eh)(b.profile):void 0,y=(0,M.$li)(b.workspace),h=await this.m(v,y);switch(u){case"getItems":return Array.from(h.items.entries());case"updateItems":{const m=b;if(m.insert)for(const[p,k]of m.insert)h.set(p,k);m.delete?.forEach(p=>h.delete(p));break}case"optimize":return h.optimize();case"isUsed":{const m=b.payload;if(typeof m=="string")return this.g.isUsed(m)}default:throw new Error(`Call not found: ${u}`)}}async m(d,u){let b;u?b=this.g.workspaceStorage(u):d?b=this.g.profileStorage(d):b=this.g.applicationStorage;try{await b.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${u?"workspace":d?"profile":"application"} storage due to ${v}`)}return b}}e.$E$b=D}),define(ae[41],ce([0,1,45,3,2,19,7,189,38,16,6,5,30,31,40,8,32,25,12]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.ProfileResourceType=void 0;var f;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(f||(e.ProfileResourceType=f={}));function $(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$4k=$,e.$5k=(0,b.$8h)("IUserDataProfilesService");function a(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$6k=a;function t(i,n,c,w,A,I){return{id:i,name:n,location:c,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:I&&A?.useDefaultFlags?.globalState?I.globalStorageHome:(0,M.$Ig)(c,"globalStorage"),settingsResource:I&&A?.useDefaultFlags?.settings?I.settingsResource:(0,M.$Ig)(c,"settings.json"),keybindingsResource:I&&A?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,M.$Ig)(c,"keybindings.json"),tasksResource:I&&A?.useDefaultFlags?.tasks?I.tasksResource:(0,M.$Ig)(c,"tasks.json"),snippetsHome:I&&A?.useDefaultFlags?.snippets?I.snippetsHome:(0,M.$Ig)(c,"snippets"),extensionsResource:I&&A?.useDefaultFlags?.extensions?I.extensionsResource:(0,M.$Ig)(c,"extensions.json"),cacheHome:(0,M.$Ig)(w,i),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$7k=t;let o=class extends s.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,c,w,A){super(),this.t=n,this.u=c,this.w=w,this.y=A,this.f=!0,this.h=this.B(new O.$Wd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$Wd),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$Wd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$Wd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$Ac,emptyWindows:new Map},this.profilesHome=(0,M.$Ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$Ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),c=[n];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,l.$Jf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}c.push(t((0,M.$Fg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.y.error(I)}const w=new h.$Ac,A=new Map;if(c.length)try{const I=this.Q();if(I.workspaces)for(const[E,C]of Object.entries(I.workspaces)){const j=D.URI.parse(E),U=c.find(F=>F.id===C);U&&w.set(j,U)}if(I.emptyWindows)for(const[E,C]of Object.entries(I.emptyWindows)){const j=c.find(U=>U.id===C);j&&A.set(E,j)}}catch(I){this.y.error(I)}this.z={profiles:c,workspaces:w,emptyWindows:A}}return this.z}D(){const n=t("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const c="Temp",w=new RegExp(`${(0,g.$Pe)(c)}\\s(\\d+)`);let A=0;for(const E of this.profiles){const C=w.exec(E.name),j=C?parseInt(C[1]):0;A=j>A?j:A}const I=`${c} ${A+1}`;return this.createProfile((0,S.$Vi)((0,k.$rg)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,c,w){return this.createProfile((0,S.$Vi)((0,k.$rg)()).toString(16),n,c,w)}async createProfile(n,c,w,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(n,c,w);return A&&await this.setProfileForWorkspace(A,I),I}async F(n,c,w){if(!(0,l.$Jf)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(c);return A||(A=(async()=>{try{const I=this.profiles.find(j=>j.name===c||j.id===n);if(I)return I;const E=t(n,c,(0,M.$Ig)(this.profilesHome,n),this.g,w,this.defaultProfile);await this.u.createFolder(E.location);const C=[];return this.j.fire({profile:E,join(j){C.push(j)}}),await p.Promises.settled(C),this.I([E],[],[]),E}finally{this.r.delete(c)}})(),this.r.set(c,A)),A}async updateProfile(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let w=this.profiles.find(A=>A.id===n.id);if(!w)throw new Error(`Profile '${n.name}' does not exist`);return w=t(w.id,c.name??w.name,w.location,this.g,{shortName:c.shortName??w.shortName,icon:c.icon===null?void 0:c.icon??w.icon,transient:c.transient??w.isTransient,useDefaultFlags:c.useDefaultFlags??w.useDefaultFlags},this.defaultProfile),this.I([],[],[w]),w}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(A=>A.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);const w=[];this.m.fire({profile:c,join(A){w.push(A)}});try{await Promise.allSettled(w)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])c.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])c.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[c],[]);try{await this.u.del(c.cacheHome,{recursive:!0})}catch(A){(0,u.$Jk)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=this.profiles.find(A=>A.id===c.id);if(!w)throw new Error(`Profile '${c.name}' does not exist`);this.L(n,w)}unsetWorkspace(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,c)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(c=>c.isDirectory&&this.profiles.every(w=>!this.w.extUri.isEqual(w.location,c.resource))).map(c=>this.u.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(c=>!this.H(c));await Promise.allSettled(n.map(c=>this.removeProfile(c)))}getProfileForWorkspace(n){const c=this.G(n);return D.URI.isUri(c)?this.s.workspaces.get(c)??this.C.workspaces.get(c):this.s.emptyWindows.get(c)??this.C.emptyWindows.get(c)}G(n){return(0,y.$fi)(n)?n.uri:(0,y.$ki)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.s.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.C.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.C.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,n.location)))}I(n,c,w){const A=[...this.profiles,...n],I=[];this.s.profiles=[];for(let E of A)E.isDefault||c.some(C=>E.id===C.id)||(E=w.find(C=>E.id===C.id)??E,E.isTransient?this.s.profiles.push(E):I.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(I),this.z=void 0,this.J(n,c,w)}J(n,c,w){this.h.fire({added:n,removed:c,updated:w,all:this.profiles})}L(n,c,w){w=c?.isTransient?!0:w,w||this.L(n,void 0,!0);const A=this.G(n),I=w?this.s:this.C;D.URI.isUri(A)?(I.workspaces.delete(A),c&&I.workspaces.set(A,c)):(I.emptyWindows.delete(A),c&&I.emptyWindows.set(A,c)),w||this.M()}M(){const n={};for(const[w,A]of this.C.workspaces.entries())n[w.toString()]=A.id;const c={};for(const[w,A]of this.C.emptyWindows.entries())c[w.toString()]=A.id;this.R({workspaces:n,emptyWindows:c}),this.z=void 0}N(n){const c={},w=this.D();if(n.workspaces)for(const[I,E]of Object.entries(n.workspaces)){const C=D.URI.parse(E);c[I]=this.w.extUri.isEqual(C,w.location)?w.id:this.w.extUri.basename(C)}const A={};if(n.emptyWindows)for(const[I,E]of Object.entries(n.emptyWindows)){const C=D.URI.parse(E);A[I]=this.w.extUri.isEqual(C,w.location)?w.id:this.w.extUri.basename(C)}return{workspaces:c,emptyWindows:A}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$8k=o,e.$8k=o=ve([se(0,d.$ci),se(1,u.$sk),se(2,m.$3k),se(3,v.$pj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$9k=r}),define(ae[81],ce([0,1,8,17,2,3,31,7,119,125,16,6,5,41,40,12,14,28]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.ExtensionsProfileScanningErrorCode=void 0;var l;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(l||(e.ExtensionsProfileScanningErrorCode=l={}));class f extends Error{constructor(r,i){super(r),this.code=i}}e.$Wp=f,e.$Xp=(0,v.$8h)("IExtensionsProfileScannerService");let $=class extends s.$Tc{constructor(r,i,n,c,w,A){super(),this.j=r,this.m=i,this.n=n,this.r=c,this.s=w,this.t=A,this.b=this.B(new M.$Wd),this.onAddExtensions=this.b.event,this.c=this.B(new M.$Wd),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$Wd),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$Wd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],c=[];try{return await this.u(i,w=>{const A=[];for(const I of w)r.some(([E])=>(0,u.$3o)(E.identifier,I.identifier)&&E.manifest.version!==I.version)?n.push(I):A.push(I);for(const[I,E]of r){const C=A.findIndex(U=>(0,u.$3o)(U.identifier,I.identifier)&&U.version===I.manifest.version),j={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:E};C===-1?(c.push(j),A.push(j)):A.splice(C,1,j)}return c.length&&this.b.fire({extensions:c,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),A}),c.length&&this.c.fire({extensions:c,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),c}catch(w){throw c.length&&this.c.fire({extensions:c,error:w,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:w,profileLocation:i}),w}}async updateMetadata(r,i){const n=[];return await this.u(i,c=>{const w=[];for(const A of c){const I=r.find(([E])=>(0,u.$3o)(E.identifier,A.identifier)&&E.manifest.version===A.version);I&&(A.metadata={...A.metadata,...I[1]},n.push(A)),w.push(A)}return w}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,c=>{const w=[];for(const A of c)(0,u.$3o)(A.identifier,r.identifier)?n.push(A):w.push(A);return n.length&&this.f.fire({extensions:n,profileLocation:i}),w}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(c){throw n.length&&this.g.fire({extensions:n,error:c,profileLocation:i}),c}}async u(r,i,n){return this.F(r).queue(async()=>{let c=[],w;try{const A=await this.m.readFile(r);w=JSON.parse(A.value.toString().trim()||"[]")}catch(A){if((0,b.$Jk)(A)!==1)throw A;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(w=await this.D()),!w&&n?.bailOutWhenFileNotFound)throw new f((0,k.$0)(A),"ERROR_PROFILE_NOT_FOUND")}if(w){Array.isArray(w)||this.w(r);let A=!1;for(const I of w){a(I)||this.w(r);let E;if((0,p.$Jf)(I.relativeLocation)&&I.relativeLocation)E=this.z(I.relativeLocation);else if((0,p.$Jf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{E=P.URI.revive(I.location);const C=this.y(E);C&&(A=!0,I.relativeLocation=C)}(0,p.$Qf)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(A=!0,I.metadata.hasPreReleaseVersion=!0),c.push({identifier:I.identifier,location:E,version:I.version,metadata:I.metadata})}A&&await this.m.writeFile(r,O.$ke.fromString(JSON.stringify(w)))}if(i){c=i(c);const A=c.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,O.$ke.fromString(JSON.stringify(A)))}return c})}w(r){const i=new f(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(w){if((0,b.$Jk)(w)===1)return;throw w}this.t.info("Migrating extensions from old default profile location",r.toString());let c;try{const w=JSON.parse(n);Array.isArray(w)&&w.every(A=>a(A))?c=w:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",w)}catch(w){this.t.error(w)}if(c)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,O.$ke.fromString(JSON.stringify(c)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(w){if((0,b.$Jk)(w)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw w}try{await this.m.del(r)}catch(w){(0,b.$Jk)(w)!==1&&this.t.error(w)}try{await this.m.del(i)}catch(w){(0,b.$Jk)(w)!==1&&this.t.error(w)}return c})()),this.C}F(r){let i=this.h.get(r);return i||(i=new S.$ch,this.h.set(r,i)),i}};e.$Yp=$,e.$Yp=$=ve([se(1,b.$sk),se(2,h.$5k),se(3,m.$3k),se(4,g.$wl),se(5,y.$pj)],$);function a(o){return(0,p.$Lf)(o)&&(0,d.$Ao)(o.identifier)&&(t(o.location)||(0,p.$Jf)(o.location)&&o.location)&&((0,p.$Qf)(o.relativeLocation)||(0,p.$Jf)(o.relativeLocation))&&o.version&&(0,p.$Jf)(o.version)}function t(o){return o?(0,p.$Jf)(o.path)&&(0,p.$Jf)(o.scheme):!1}}),define(ae[130],ce([0,1,22,8,35,17,14,42,152,2,13,9,4,19,205,73,12,7,172,38,125,122,204,16,6,5,27,3,76,81,41,40,203]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f,$,a,t,o,r,i,n,c,w,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.Translations=void 0;var j;(function(ue){function Z(X,q){if(X===q)return!0;const L=Object.keys(X),T=new Set;for(const G of Object.keys(q))T.add(G);if(L.length!==T.size)return!1;for(const G of L){if(X[G]!==q[G])return!1;T.delete(G)}return T.size===0}ue.equals=Z})(j||(e.Translations=j={})),e.$2p=(0,r.$8h)("IExtensionsScannerService");let U=class extends u.$Tc{constructor(Z,X,q,L,T,G,B,oe,he,K,R,W){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=X,this.r=q,this.s=L,this.t=T,this.u=G,this.w=B,this.y=oe,this.z=he,this.C=K,this.D=R,this.F=W,this.g=this.B(new c.$Wd),this.onDidChangeCache=this.g.event,this.h=(0,h.$Ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(J,this.s,this.h)),this.m=this.B(this.F.createInstance(J,this.s,this.h)),this.n=this.B(this.F.createInstance(H,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,$.$bp)(this.w,this.y)),this.G}async scanAllExtensions(Z,X,q){const[L,T]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(X)]),G=q?await this.scanExtensionsUnderDevelopment(Z,[...L,...T]):[];return this.L(L,T,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const X=[];X.push(this.M(!!Z.useCache,Z.language)),X.push(this.N(Z.language,!!Z.checkControlFile));const[q,L]=await Promise.all(X);return this.J([...q,...L],0,Z,!1)}async scanUserExtensions(Z){const X=Z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const q=this.D.extUri.isEqual(Z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(X,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,q),T=Z.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let G;try{G=await T.scanExtensions(L)}catch(B){if(B instanceof A.$Wp&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await T.scanExtensions(L);else throw B}return G=await this.J(G,1,Z,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Z,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===b.Schemas.file).map(async L=>{const T=await this.P(L,!1,1,!0,Z.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(T)).map(B=>(B.type=X.find(oe=>(0,$.$3o)(oe.identifier,B.identifier))?.type??B.type,this.n.validate(B,T)))}))).flat();return this.J(q,"development",Z,!0)}return[]}async scanExistingExtension(Z,X,q){const L=await this.P(Z,!1,X,!0,q.language,!0,void 0),T=await this.n.scanExtension(L);return!T||!q.includeInvalid&&!T.isValid?null:T}async scanOneOrMultipleExtensions(Z,X,q){const L=await this.P(Z,!1,X,!0,q.language,!0,void 0),T=await this.n.scanOneOrMultipleExtensions(L);return this.J(T,X,q,!0)}async scanMetadata(Z){const X=(0,h.$Ig)(Z,"package.json"),q=(await this.w.readFile(X)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(Z,X){const q=(0,h.$Ig)(Z,"package.json"),L=(await this.w.readFile(q)).value.toString(),T=JSON.parse(L);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,T.__metadata={...T.__metadata,...X},await this.w.writeFile((0,h.$Ig)(Z,"package.json"),M.$ke.fromString(JSON.stringify(T,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof A.$Wp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.u.addExtensionsToProfile(Z.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$ke.fromString(JSON.stringify([])))}catch(X){(0,o.$Jk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.y.error(Z)}finally{this.H=void 0}})()),this.H}async J(Z,X,q,L){return q.includeAllVersions||(Z=this.L(X===0?Z:void 0,X===1?Z:void 0,X==="development"?Z:void 0,await this.getTargetPlatform(),L)),q.includeInvalid||(Z=Z.filter(T=>T.isValid)),Z.sort((T,G)=>{const B=v.$nc(T.location.fsPath),oe=v.$nc(G.location.fsPath);return B<oe?-1:B>oe?1:0})}L(Z,X,q,L,T){const G=(oe,he,K)=>{if(oe.isValid&&!he.isValid)return!1;if(oe.isValid===he.isValid){if(T&&m.gt(oe.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(m.eq(oe.manifest.version,he.manifest.version)){if(oe.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`),!0},B=new a.$pm;return Z?.forEach(oe=>{const he=B.get(oe.identifier.id);(!he||G(he,oe,!1))&&B.set(oe.identifier.id,oe)}),X?.forEach(oe=>{const he=B.get(oe.identifier.id);if(!he&&Z&&oe.type===0){this.y.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!he||G(he,oe,!1))&&B.set(oe.identifier.id,oe)}),q?.forEach(oe=>{const he=B.get(oe.identifier.id);(!he||G(he,oe,!0))&&B.set(oe.identifier.id,oe),B.set(oe.identifier.id,oe)}),[...B.values()]}async M(Z,X){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),T=await(Z&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",T.length),T}async N(Z,X){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const L=X?await this.O():{},T=[],G=g.URI.file(v.$hc(v.$jc(b.$pg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of q){const he=L[oe.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":T.push((0,h.$Ig)(G,oe.name));break;default:T.push(g.URI.file(he));break}}const B=await Promise.all(T.map(async oe=>this.n.scanExtension(await this.P(oe,!1,0,!0,Z,!0,void 0))));return this.y.trace("Scanned dev system extensions:",B.length),(0,S.$Hb)(B)}async O(){try{const Z=await this.w.readFile(this.r);return JSON.parse(Z.value.toString())}catch{return{}}}async P(Z,X,q,L,T,G,B){const oe=await this.f(T??y.$w),he=await this.Q(Z),K=X&&!this.D.extUri.isEqual(Z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,R=K?await this.Q(K):void 0;return new F(Z,he,K,R,X,B,q,L,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,T,oe)}async Q(Z){try{const X=await this.w.stat(Z);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$3p=U,e.$3p=U=ve([se(4,I.$5k),se(5,A.$Xp),se(6,o.$sk),se(7,i.$pj),se(8,f.$ci),se(9,n.$Hj),se(10,E.$3k),se(11,r.$7h)],U);class F{constructor(Z,X,q,L,T,G,B,oe,he,K,R,W,x,N,Q){this.location=Z,this.mtime=X,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=L,this.profile=T,this.profileScanOptions=G,this.type=B,this.excludeObsolete=oe,this.validate=he,this.productVersion=K,this.productDate=R,this.productCommit=W,this.devMode=x,this.language=N,this.translations=Q}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,X){return(0,h.$Bg)(Z.location,X.location)&&Z.mtime===X.mtime&&(0,h.$Bg)(Z.applicationExtensionslocation,X.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&Z.profile===X.profile&&s.$Cn(Z.profileScanOptions,X.profileScanOptions)&&Z.type===X.type&&Z.excludeObsolete===X.excludeObsolete&&Z.validate===X.validate&&Z.productVersion===X.productVersion&&Z.productDate===X.productDate&&Z.productCommit===X.productCommit&&Z.devMode===X.devMode&&Z.language===X.language&&j.equals(Z.translations,X.translations)}}e.$4p=F;let H=class extends u.$Tc{constructor(Z,X,q,L,T){super(),this.f=Z,this.g=X,this.h=q,this.j=L,this.m=T}async scanExtensions(Z){const X=Z.profile?await this.r(Z):await this.n(Z);let q={};if(Z.excludeObsolete&&Z.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(L)}catch{}return(0,k.$Wf)(q)?X:X.filter(L=>!q[$.$4o.create(L).toString()])}async n(Z){const X=await this.j.resolve(Z.location);if(!X.children?.length)return[];const q=await Promise.all(X.children.map(async L=>{if(!L.isDirectory||Z.type===1&&(0,h.$Fg)(L.resource).indexOf(".")===0)return null;const T=new F(L.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(T)}));return(0,S.$Hb)(q).sort((L,T)=>L.location.path<T.location.path?-1:1)}async r(Z){let X=await this.s(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){X=X.filter(L=>!L.metadata?.isApplicationScoped);const q=await this.s(Z.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,Z);X.push(...q)}return X}async s(Z,X,q){const L=await this.g.scanProfileExtensions(Z,q.profileScanOptions);if(!L.length)return[];const T=await Promise.all(L.map(async G=>{if(X(G)){const B=new F(G.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B,G.metadata)}return null}));return(0,S.$Hb)(T)}async scanOneOrMultipleExtensions(Z){try{if(await this.j.exists((0,h.$Ig)(Z.location,"package.json"))){const X=await this.scanExtension(Z);return X?[X]:[]}else return await this.scanExtensions(Z)}catch(X){return this.m.error(`Error scanning extensions at ${Z.location.path}:`,(0,D.$0)(X)),[]}}async scanExtension(Z,X){try{let q=await this.scanExtensionManifest(Z.location);if(q){q.publisher||(q.publisher=a.$jm),X=X??q.__metadata,delete q.__metadata;const L=(0,$.$8o)(q.publisher,q.name),T=X?.id?{id:L,uuid:X.id}:{id:L},G=X?.isSystem?0:Z.type,B=G===0||!!X?.isBuiltin;q=await this.t(Z.location,q,F.createNlsConfiguration(Z));const oe={type:G,identifier:T,manifest:q,location:Z.location,isBuiltin:B,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return Z.validate?this.validate(oe,Z):oe}}catch(q){Z.type!==0&&this.m.error(q)}return null}validate(Z,X){let q=!0;const L=(0,t.$gp)(X.productVersion,X.productDate,X.location,Z.manifest,Z.isBuiltin);for(const[T,G]of L)T===p.default.Error&&(q=!1,this.m.error(this.z(X.location,G)));return Z.isValid=q,Z.validations=L,Z}async scanExtensionManifest(Z){const X=(0,h.$Ig)(Z,"package.json");let q;try{q=(await this.j.readFile(X)).value.toString()}catch(T){return(0,o.$Jk)(T)!==1&&this.m.error(this.z(Z,(0,l.localize)(0,null,X.path,T.message))),null}let L;try{L=JSON.parse(q)}catch{const G=[];(0,P.$fn)(q,G);for(const B of G)this.m.error(this.z(Z,(0,l.localize)(1,null,X.path,B.offset,B.length,(0,d.$Zp)(B.error))));return null}return(0,P.$on)(L)!=="object"?(this.m.error(this.z(Z,(0,l.localize)(2,null,X.path))),null):L}async t(Z,X,q){const L=await this.u(Z,X,q);if(L)try{const T=[],G=await this.w(L.default,T);if(T.length>0)return T.forEach(oe=>{this.m.error(this.z(Z,(0,l.localize)(3,null,L.default?.path,(0,d.$Zp)(oe.error))))}),X;if((0,P.$on)(L)!=="object")return this.m.error(this.z(Z,(0,l.localize)(4,null,L.default?.path))),X;const B=L.values||Object.create(null);return(0,C.$1p)(this.m,X,B,G)}catch{}return X}async u(Z,X,q){const L=(0,h.$Ig)(Z,"package.nls.json"),T=(he,K)=>{K.forEach(R=>{this.m.error(this.z(Z,(0,l.localize)(5,null,he?.path,(0,d.$Zp)(R.error))))})},G=he=>{this.m.error(this.z(Z,(0,l.localize)(6,null,he?.path)))},B=`${X.publisher}.${X.name}`,oe=q.translations[B];if(oe)try{const he=g.URI.file(oe),K=(await this.j.readFile(he)).value.toString(),R=[],W=(0,P.$fn)(K,R);return R.length>0?(T(he,R),{values:void 0,default:L}):(0,P.$on)(W)!=="object"?(G(he),{values:void 0,default:L}):{values:W.contents?W.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let K;try{K=await this.y(Z,q)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const R=(await this.j.readFile(K.localized)).value.toString(),W=[],x=(0,P.$fn)(R,W);return W.length>0?(T(K.localized,W),{values:void 0,default:K.original}):(0,P.$on)(x)!=="object"?(G(K.localized),{values:void 0,default:K.original}):{values:x,default:K.original}}catch{return{values:void 0,default:K.original}}}}async w(Z,X){if(Z)try{const q=(await this.j.readFile(Z)).value.toString();return(0,P.$fn)(q,X)}catch{}}y(Z,X){return new Promise((q,L)=>{const T=G=>{const B=(0,h.$Ig)(Z,`package.nls.${G}.json`);this.j.exists(B).then(oe=>{oe&&q({localized:B,original:(0,h.$Ig)(Z,"package.nls.json")});const he=G.lastIndexOf("-");he===-1?q({localized:(0,h.$Ig)(Z,"package.nls.json"),original:null}):(G=G.substring(0,he),T(G))})};if(X.devMode||X.pseudo||!X.language)return q({localized:(0,h.$Ig)(Z,"package.nls.json"),original:null});T(X.language)})}z(Z,X){return`[${Z.path}]: ${X}`}};H=ve([se(1,A.$Xp),se(2,E.$3k),se(3,o.$sk),se(4,i.$pj)],H);let J=class extends H{constructor(Z,X,q,L,T,G,B){super(X,L,T,G,B),this.G=Z,this.H=q,this.D=this.B(new O.$6g(3e3)),this.F=this.B(new c.$Wd),this.onDidChangeCache=this.F.event}async scanExtensions(Z){const X=this.M(Z),q=await this.I(X);if(this.C=Z,q&&q.input&&F.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",Z.location.toString()),this.D.trigger(()=>this.L()),q.result.map(T=>(T.location=g.URI.revive(T.location),T));const L=await super.scanExtensions(Z);return await this.J(X,{input:Z,result:L}),L}async I(Z){try{const X=await this.j.readFile(Z),q=JSON.parse(X.value.toString());return{result:q.result,input:(0,w.$Eh)(q.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",Z.path,(0,D.$0)(X))}return null}async J(Z,X){try{await this.j.writeFile(Z,M.$ke.fromString(JSON.stringify(X)))}catch(q){this.m.debug("Error while writing the extension cache file:",Z.path,(0,D.$0)(q))}}async L(){if(!this.C)return;const Z=this.M(this.C),X=await this.I(Z);if(!X)return;const q=X.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$Cn(L,q))try{this.m.info("Invalidating Cache",q,L),await this.j.del(Z),this.F.fire()}catch(T){this.m.error(T)}}M(Z){const X=this.N(Z);return this.h.extUri.joinPath(X.cacheHome,Z.type===0?a.$im:a.$hm)}N(Z){return Z.type===0?this.H.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(Z.location,X.extensionsResource))??this.G:this.H.defaultProfile}};J=ve([se(2,I.$5k),se(3,A.$Xp),se(4,E.$3k),se(5,o.$sk),se(6,i.$pj)],J);function le(ue,Z){const X=(0,$.$6o)(ue.manifest.publisher,ue.manifest.name);return{id:X,identifier:new a.$nm(X),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Z,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.$5p=le;class re extends U{constructor(Z,X,q,L,T,G,B,oe,he,K,R,W){super(Z,X,(0,h.$Ig)(q,".vscode-oss-dev","extensions","control.json"),L,T,G,B,oe,he,K,R,W),this.R=(async()=>{if(y.$z)try{const x=await this.w.readFile(g.URI.file(y.$z));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.R}}e.$6p=re}),define(ae[276],ce([0,1,5,41,40,28,81,16,38,7]),function(Y,e,S,O,s,M,D,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=void 0;let b=class extends D.$Yp{constructor(y,h,m,p,k,g){super(u.URI.file(y.extensionsPath),h,m,p,k,g)}};e.$WO=b,e.$WO=b=ve([se(0,d.$di),se(1,P.$sk),se(2,O.$5k),se(3,s.$3k),se(4,M.$wl),se(5,S.$pj)],b)}),define(ae[277],ce([0,1,7,38,81,130,16,6,5,27,40,41]),function(Y,e,S,O,s,M,D,P,d,u,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=void 0;let y=class extends M.$6p{constructor(m,p,k,g,l,f,$,a){super(S.URI.file(l.builtinExtensionsPath),S.URI.file(l.extensionsPath),l.userHome,m.defaultProfile,m,p,k,g,l,f,$,a)}};e.$5$b=y,e.$5$b=y=ve([se(0,v.$5k),se(1,s.$Xp),se(2,D.$sk),se(3,d.$pj),se(4,O.$di),se(5,u.$Hj),se(6,b.$3k),se(7,P.$7h)],y)}),define(ae[278],ce([0,1,15,2,13,9,4,59,7,32,37,38,5,41]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k_b=void 0;let m=class extends O.$Tc{constructor(k,g,l){super(),this.c=k,this.f=l,this.a=P.$bi.forPaths(!D.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(k.appRoot),this.addValidFileRoot(k.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(k.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:k}=S.session;k.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,l)=>this.j(g,l)),k.protocol.interceptFileProtocol(s.Schemas.file,(g,l)=>this.h(g,l)),this.B((0,O.$Rc)(()=>{k.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),k.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(k){const g=(0,M.$hc)(k);return this.a.get(g)?O.$Tc.None:(this.a.set(g,!0),(0,O.$Rc)(()=>this.a.delete(g)))}h(k,g){const l=d.URI.parse(k.url);return this.f.error(`Refused to load resource ${l.fsPath} from ${s.Schemas.file}: protocol (original URL: ${k.url})`),g({error:-3})}j(k,g){const l=this.m(k);let f;return this.c.crossOriginIsolated&&((0,M.$nc)(l)==="workbench.html"||(0,M.$nc)(l)==="workbench-dev.html"?f=s.COI.CoopAndCoep:f=s.COI.getHeadersFromQuery(k.url)),this.a.findSubstr(l)?g({path:l,headers:f}):this.b.has((0,M.$oc)(l).toLowerCase())?g({path:l}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${l} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${k.url})`),g({error:-3}))}m(k){const g=d.URI.parse(k.url),l=s.$pg.uriToFileUri(g);return(0,M.$hc)(l.fsPath)}createIPCObjectUrl(){let k;const g=d.URI.from({scheme:"vscode",path:(0,u.$rg)()}),l=g.toString(),f=async()=>k;return b.$VU.handle(l,f),this.f.trace(`IPC Object URL: Registered new channel ${l}.`),{resource:g,update:$=>k=$,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${l}.`),b.$VU.removeHandler(l)}}}};e.$k_b=m,e.$k_b=m=ve([se(0,v.$di),se(1,h.$5k),se(2,y.$pj)],m)}),define(ae[97],ce([0,1,8,3,2,67,12,113,6,41]),function(Y,e,S,O,s,M,D,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$wp=e.$vp=e.$up=void 0,e.$up="__$__isNewStorageMarker",e.$vp="__$__targetStorageMarker",e.$wp=(0,d.$8h)("storageService");var b;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var v;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var y;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function h(l){const f=l.get(e.$vp);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.$xp=h;class m extends s.$Tc{static{this.a=60*1e3}constructor(f={flushInterval:m.a}){super(),this.m=f,this.b=this.B(new O.$Zd),this.c=this.B(new O.$Zd),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$Wd),this.onWillSaveState=this.f.event,this.h=this.B(new S.$hh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(f,$,a){return O.Event.filter(this.b.event,t=>t.scope===f&&($===void 0||t.key===$),a)}n(){this.j.value=(0,S.$lh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(f,$){const{key:a,external:t}=$;if(a===e.$vp){switch(f){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:f})}else this.b.fire({scope:f,key:a,target:this.J(f)[a],external:t})}w(f){this.f.fire({reason:f})}get(f,$,a){return this.P($)?.get(f,a)}getBoolean(f,$,a){return this.P($)?.getBoolean(f,a)}getNumber(f,$,a){return this.P($)?.getNumber(f,a)}getObject(f,$,a){return this.P($)?.getObject(f,a)}storeAll(f,$){this.y(()=>{for(const a of f)this.store(a.key,a.value,a.scope,a.target,$)})}store(f,$,a,t,o=!1){if((0,D.$Sf)($)){this.remove(f,a,o);return}this.y(()=>{this.z(f,a,t),this.P(a)?.set(f,$,o)})}remove(f,$,a=!1){this.y(()=>{this.z(f,$,void 0),this.P($)?.delete(f,a)})}y(f){this.b.pause(),this.c.pause();try{f()}finally{this.b.resume(),this.c.resume()}}keys(f,$){const a=[],t=this.J(f);for(const o of Object.keys(t))t[o]===$&&a.push(o);return a}z(f,$,a,t=!1){const o=this.J($);typeof a=="number"?o[f]!==a&&(o[f]=a,this.P($)?.set(e.$vp,JSON.stringify(o),t)):typeof o[f]=="number"&&(delete o[f],this.P($)?.set(e.$vp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(f){switch(f){case-1:return this.I;case 0:return this.G;default:return this.D}}L(f){const $=this.P(f);return $?h($):Object.create(null)}isNew(f){return this.getBoolean(e.$up,f)===!0}async flush(f=b.NONE){this.f.fire({reason:f});const $=this.P(-1),a=this.P(0),t=this.P(1);switch(f){case b.NONE:await S.Promises.settled([$?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await S.Promises.settled([$?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.P(-1)?.items??new Map,$=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return g(f,$,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(f){return await this.flush(),this.P(f)?.optimize()}async switch(f,$){return this.w(b.NONE),(0,u.$4k)(f)?this.R(f,$):this.S(f,$)}M(f,$){return!(f.id===$.id||p($)&&p(f))}N(f,$,a){this.y(()=>{const t=new Set;for(const[o,r]of f)t.add(o),$.get(o)!==r&&this.u(a,{key:o,external:!0});for(const[o]of $.items)t.has(o)||this.u(a,{key:o,external:!0})})}}e.$yp=m;function p(l){return l.isDefault||!!l.useDefaultFlags?.globalState}e.$zp=p;class k extends m{constructor(){super(),this.U=this.B(new P.$sp(new P.$tp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$sp(new P.$tp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$sp(new P.$tp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(f=>this.u(1,f))),this.B(this.W.onDidChangeStorage(f=>this.u(0,f))),this.B(this.U.onDidChangeStorage(f=>this.u(-1,f)))}P(f){switch(f){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(f){return!1}}e.$Ap=k;async function g(l,f,$,a,t,o){const r=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,n=new Map;l.forEach((j,U)=>{i.set(U,j),n.set(U,r(j))});const c=new Map,w=new Map;f.forEach((j,U)=>{c.set(U,j),w.set(U,r(j))});const A=new Map,I=new Map;$.forEach((j,U)=>{A.set(U,j),I.set(U,r(j))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const E=[];if(i.forEach((j,U)=>{E.push({key:U,value:j})}),console.table(E),console.groupEnd(),console.log(n),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];c.forEach((U,F)=>{j.push({key:F,value:U})}),console.table(j),console.groupEnd(),console.log(w)}console.group(`Storage: Workspace (path: ${o})`);const C=[];A.forEach((j,U)=>{C.push({key:U,value:j})}),console.table(C),console.groupEnd(),console.log(I)}e.$Bp=g}),define(ae[279],ce([0,1,22,8,3,2,9,72,7,21,113,161,5,97,28,30,13]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U0b=e.$T0b=e.$S0b=e.$R0b=void 0;class g extends M.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$Wd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Wd),this.onDidCloseStorage=this.c.event,this.f=this.B(new b.$sp(new b.$tp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new O.$sh,this.whenInit=this.h.p,this.j=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===b.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(h.$up);i===void 0?r.set(h.$up,!0):i&&r.set(h.$up,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=b.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===y.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new P.$Sd(!1);await this.w(),r.stop(),r.elapsed()>g.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,S.top)(Array.from(this.f.items.entries()).map(([c,w])=>({key:c,length:w.length})),(c,w)=>w.length-c.length,5).map(c=>`${c.key}:${c.length}`).join(", "),n=(await this.n.stat(d.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=b.StorageState.Closed,await this.f.close()}}class l extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$jc)(this.z.globalStorageHome.with({scheme:k.Schemas.file}).fsPath,l.y)}constructor(r,i,n,c){super(n,c),this.z=r,this.C=i}async t(){return new b.$sp(new v.$oV(this.path??v.$oV.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}class f extends l{constructor(r,i,n,c){super(r,i,n,c)}}e.$R0b=f;class $ extends l{constructor(r,i,n,c){super(i.defaultProfile,r,n,c)}async s(r){await super.s(r),this.G(r)}G(r){r.get(m.$zl,void 0)===void 0&&r.set(m.$zl,new Date().toUTCString());const n=r.get(m.$yl,void 0),c=new Date().toUTCString();r.set(m.$Al,typeof n>"u"?null:n),r.set(m.$yl,c)}}e.$S0b=$;class a extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,this.C.id,a.y)}constructor(r,i,n,c,w){super(n,w),this.C=r,this.D=i,this.F=c}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new b.$sp(new v.$oV(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:i?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:v.$oV.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,this.C.id),i=(0,D.$jc)(r,a.y);return await u.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await u.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,p.$fi)(this.C)?i={folder:this.C.uri.toString()}:(0,p.$ki)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,D.$jc)(r,a.z);await u.Promises.exists(n)||await u.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$T0b=a;class t extends g{get path(){}async t(){return new b.$sp(new b.$tp,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.$U0b=t}),define(ae[280],ce([0,1,3,2,97]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=void 0;class M extends O.$Tc{constructor(P,d,u){super(),this.b=P,this.c=d,this.f=u;const b=this.B(new O.$Uc);this.a=this.B(new S.$Wd({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new O.$Sc;return P.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(d,u)=>(d?d.push(u.key):d=[u.key],d),100)(d=>this.h(d))),P.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(d,u)=>{d||(d=new Map);let b=d.get(u.profile.id);return b||d.set(u.profile.id,b={profile:u.profile,keys:[],storage:u.storage}),b.keys.push(u.key),d},100)(d=>this.j(d))),P}h(P){const d=P.includes(s.$vp)?[this.c.defaultProfile]:[],u=[];if(P=P.filter(b=>b!==s.$vp),P.length){const b=(0,s.$xp)(this.b.applicationStorage.storage);u.push({profile:this.c.defaultProfile,changes:P.map(v=>({key:v,scope:0,target:b[v]}))})}this.m(d,u)}j(P){const d=[],u=new Map;for(const[b,v]of P.entries()){v.keys.includes(s.$vp)&&d.push(v.profile);const y=v.keys.filter(h=>h!==s.$vp);if(y.length){const h=(0,s.$xp)(v.storage.storage);u.set(b,{profile:v.profile,changes:y.map(m=>({key:m,scope:0,target:h[m]}))})}}this.m(d,[...u.values()])}m(P,d){(P.length||d.length)&&this.a.fire({valueChanges:d,targetChanges:P})}listen(P,d,u){switch(d){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${d}`)}async call(P,d){throw new Error(`Call not found: ${d}`)}}e.$7$b=M}),define(ae[281],ce([0,1,7,38,16,5,34,40,41,12,123]),function(Y,e,S,O,s,M,D,P,d,u,b){"use strict";var v,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=e.$UO=e.$TO=void 0;let h=class extends d.$8k{static{v=this}static{this.a="profileAssociationsMigration"}constructor(g,l,f,$,a){super(f,$,l,a),this.U=g,this.W=f}O(){return this.U.getItem(v.b,[]).map(l=>({...l,location:(0,u.$Jf)(l.location)?this.w.extUri.joinPath(this.profilesHome,l.location):S.URI.revive(l.location)}))}Q(){const g=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$TO=h,e.$TO=h=v=ve([se(0,D.$OO),se(1,P.$3k),se(2,O.$di),se(3,s.$sk),se(4,M.$pj)],h);let m=y=class extends h{constructor(g,l,f,$,a){super(g,l,f,$,a),this.$=g}P(g){g.length?this.$.setItem(y.b,g.map(l=>({...l,location:this.w.extUri.basename(l.location)}))):this.$.removeItem(y.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(y.c,g):this.$.removeItem(y.c)}Q(){const g="workspaceAndProfileInfo",l=this.$.getItem(g,void 0);if(l){this.$.removeItem(g);const $=l.reduce((a,{workspace:t,profile:o})=>(a[S.URI.revive(t).toString()]=S.URI.revive(o).toString(),a),{});this.$.setItem(y.c,{workspaces:$})}const f=super.Q();return this.$.getItem(y.a,!1)||(this.R(f),this.$.setItem(y.a,!0)),f}};e.$UO=m,e.$UO=m=y=ve([se(0,D.$PO),se(1,P.$3k),se(2,O.$di),se(3,s.$sk),se(4,M.$pj)],m);let p=class extends m{constructor(g,l,f,$){super(new b.$SO(0,l,$,f),g,l,f,$)}async init(){return await this.$.init(),super.init()}};e.$VO=p,e.$VO=p=ve([se(0,P.$3k),se(1,O.$di),se(2,s.$sk),se(3,M.$pj)],p)}),define(ae[57],ce([0,1,38,16,6,5,40,41,281,34]),function(Y,e,S,O,s,M,D,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A0b=e.$z0b=void 0,e.$z0b=(0,s.$9h)(P.$5k);let b=class extends d.$UO{constructor(y,h,m,p,k){super(y,h,m,p,k)}getAssociatedEmptyWindows(){const y=[];for(const h of this.C.emptyWindows.keys())y.push({id:h});return y}};e.$A0b=b,e.$A0b=b=ve([se(0,u.$PO),se(1,D.$3k),se(2,S.$di),se(3,O.$sk),se(4,M.$pj)],b)}),define(ae[131],ce([0,1,19,7,30]),function(Y,e,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D0b=e.$C0b=e.$B0b=void 0;async function M(d,u,b){for(const y of d){const h=y.openedWorkspace;if((0,s.$ki)(h)){const m=await b(h);if(m){if(m.folders.some(p=>S.$zg.isEqualOrParent(u,p.uri)))return y}else if(S.$zg.isEqualOrParent(u,h.configPath))return y}}const v=d.filter(y=>(0,s.$fi)(y.openedWorkspace)&&S.$zg.isEqualOrParent(u,y.openedWorkspace.uri));if(v.length)return v.sort((y,h)=>-(y.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.$B0b=M;function D(d,u){for(const b of d)if((0,s.$ki)(b.openedWorkspace)&&S.$zg.isEqual(b.openedWorkspace.configPath,u)||(0,s.$fi)(b.openedWorkspace)&&S.$zg.isEqual(b.openedWorkspace.uri,u))return b}e.$C0b=D;function P(d,u){const b=v=>u.some(y=>S.$zg.isEqual(O.URI.file(y),O.URI.file(v)));for(const v of d)if(v.config?.extensionDevelopmentPath?.some(y=>b(y)))return v}e.$D0b=P}),define(ae[98],ce([0,1,33,42,102,47,13,9,4,19,7,6,60,30]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddb=e.$cdb=e.$bdb=e.$adb=e.$_cb=e.$$cb=e.$0cb=e.$9cb=e.$8cb=e.$7cb=void 0,e.$7cb=(0,v.$8h)("workspacesService");function m(I){return I.hasOwnProperty("workspace")}e.$8cb=m;function p(I){return I.hasOwnProperty("folderUri")}e.$9cb=p;function k(I){return I.hasOwnProperty("fileUri")}e.$0cb=k;function g(I){return l(I)||f(I)}e.$$cb=g;function l(I){const E=I;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function f(I){const E=I;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function $(I,E,C,j,U){if(I.scheme!==j.scheme)return{name:C,uri:I.toString(!0)};let F=E?void 0:U.relativePath(j,I);if(F!==void 0)F.length===0?F=".":d.$i&&(F=a(F));else if(I.scheme===D.Schemas.file)F=I.fsPath,d.$i&&(F=a(F));else if(U.isEqualAuthority(I.authority,j.authority))F=I.path;else return{name:C,uri:I.toString(!0)};return{name:C,path:F}}e.$_cb=$;function a(I){return I=(0,M.$Yv)(I),(0,S.$6f)(I)||(I=(0,S.$3f)(I)),I}function t(I,E,C){const j=[],U=new Set,F=C.dirname(E);for(const H of I){let J;if(l(H))H.path&&(J=C.resolvePath(F,H.path));else if(f(H))try{J=b.URI.parse(H.uri),J.path[0]!==P.$gc.sep&&(J=J.with({path:P.$gc.sep+J.path}))}catch(le){console.warn(le)}if(J){const le=C.getComparisonKey(J);if(!U.has(le)){U.add(le);const re=H.name||C.basenameOrAuthority(J);j.push(new h.$pi({uri:J,name:re,index:j.length},H))}}}return j}e.$adb=t;function o(I,E,C,j,U){const F=r(E,I),H=U.dirname(E),J=U.dirname(j),le=[];for(const X of F.folders){const q=l(X)?U.resolvePath(H,X.path):b.URI.parse(X.uri);let L;C?L=!1:L=!l(X)||(0,P.$ic)(X.path),le.push($(q,L,X.name,J,U))}const re={insertSpaces:!1,tabSize:4,eol:d.$k||d.$j?`
`:`\r
`},ue=s.$un(I,["folders"],le,re);let Z=s.$xn(I,ue);return(0,u.$Ng)(F.remoteAuthority,(0,y.$cl)(j))&&(Z=s.$xn(Z,s.$tn(Z,["remoteAuthority"],re))),Z}e.$bdb=o;function r(I,E){const C=O.$fn(E);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(j=>g(j));else throw new Error(`${I} looks like an invalid workspace file.`);return C}function i(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function n(I){return typeof I.folderUri=="string"}function c(I){return typeof I.fileUri=="string"}function w(I,E){const C={workspaces:[],files:[]};if(I){const j=function(F,H){for(let J=0;J<F.length;J++)try{H(F[J],J)}catch(le){E.warn(`Error restoring recent entry ${JSON.stringify(F[J])}: ${le.toString()}. Skip entry.`)}},U=I;Array.isArray(U.entries)&&j(U.entries,F=>{const H=F.label,J=F.remoteAuthority;i(F)?C.workspaces.push({label:H,remoteAuthority:J,workspace:{id:F.workspace.id,configPath:b.URI.parse(F.workspace.configPath)}}):n(F)?C.workspaces.push({label:H,remoteAuthority:J,folderUri:b.URI.parse(F.folderUri)}):c(F)&&C.files.push({label:H,remoteAuthority:J,fileUri:b.URI.parse(F.fileUri)})})}return C}e.$cdb=w;function A(I){const E={entries:[]};for(const C of I.workspaces)p(C)?E.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):E.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of I.files)E.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return E}e.$ddb=A}),define(ae[99],ce([0,1,86,13,4,19]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0b=e.$G0b=e.$F0b=e.$E0b=void 0,e.$E0b=128/4;function D(u){function b(){let v=u.scheme===O.Schemas.file?(0,M.$wg)(u):u.toString();return s.$k||(v=v.toLowerCase()),(0,S.createHash)("md5").update(v).digest("hex")}return{id:b(),configPath:u}}e.$F0b=D;function P(u,b){function v(){if(u.scheme!==O.Schemas.file)return(0,S.createHash)("md5").update(u.toString()).digest("hex");if(!b)return;let h;return s.$k?h=b.ino:s.$j?h=b.birthtime.getTime():s.$i&&(typeof b.birthtimeMs=="number"?h=Math.floor(b.birthtimeMs):h=b.birthtime.getTime()),(0,S.createHash)("md5").update(u.fsPath).update(h?String(h):"").digest("hex")}const y=v();if(typeof y=="string")return{id:y,uri:u}}e.$G0b=P;function d(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$H0b=d}),define(ae[100],ce([0,1,86,87,26,282,17,14,3,2,9,4,32,43,111]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0;class p{traceSocketEvent(E,C){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,C)}constructor(E,C=""){this.f=!0,this.debugLabel=C,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,P.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const C=j=>{this.traceSocketEvent("read",j),E(D.$ke.wrap(j))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(E){const C=j=>{E({type:0,hadError:j,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(E){const C=()=>{E()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,P.$1)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,P.$1)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Wh=p;var k;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(k||(k={}));var g;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(g||(g={}));class l extends u.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,C){this.socket.traceSocketEvent(E,C)}constructor(E,C,j,U){super(),this.f=this.B(new d.$Wd),this.g=this.B(new d.$Wd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:j?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new f(this,C,j,U,this.f,(F,H)=>this.m(F,H))),this.B(this.a.onError(F=>{console.error(F),(0,P.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new m.$Rh,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let C=0;for(;C<E.byteLength;)this.a.writeMessage(E.slice(C,Math.min(C+262144,E.byteLength)),{compressed:!0,opcode:2}),C+=262144}m(E,{compressed:C,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let U=2;E.byteLength<126?U+=0:E.byteLength<2**16?U+=2:U+=8;const F=D.$ke.alloc(U),H=C?64:0,J=j&15;if(F.writeUInt8(128|H|J,0),E.byteLength<126)F.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){F.writeUInt8(126,1);let le=1;F.writeUInt8(E.byteLength>>>8&255,++le),F.writeUInt8(E.byteLength>>>0&255,++le)}else{F.writeUInt8(127,1);let le=1;F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(E.byteLength>>>24&255,++le),F.writeUInt8(E.byteLength>>>16&255,++le),F.writeUInt8(E.byteLength>>>8&255,++le),F.writeUInt8(E.byteLength>>>0&255,++le)}this.socket.write(D.$ke.concat([F,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const C=this.b.peek(this.j.readLen),j=C.readUInt8(0),U=(j&128)>>>7,F=(j&64)>>>6,H=j&15,J=C.readUInt8(1),le=(J&128)>>>7,re=J&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(re===126?2:0)+(re===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=H,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const C=this.b.read(this.j.readLen),j=C.readUInt8(1),U=(j&128)>>>7;let F=j&127,H=1;F===126?F=C.readUInt8(++H)*2**8+C.readUInt8(++H):F===127&&(F=C.readUInt8(++H)*0+C.readUInt8(++H)*0+C.readUInt8(++H)*0+C.readUInt8(++H)*0+C.readUInt8(++H)*2**24+C.readUInt8(++H)*2**16+C.readUInt8(++H)*2**8+C.readUInt8(++H));let J=0;U&&(J=C.readUInt8(++H)*2**24+C.readUInt8(++H)*2**16+C.readUInt8(++H)*2**8+C.readUInt8(++H)),this.j.state=3,this.j.readLen=F,this.j.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const C=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),t(C,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(C,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(C,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Xh=l;class f extends u.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$ke.alloc(0)}constructor(E,C,j,U,F,H){super(),this.n=E,this.r=F,this.s=H,this.a=this.B(new d.$Wd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new d.$Wd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new d.$Wd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,C?(this.b=this.B(new $(this.n,U,j,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(J=>this.a.fire(J))),this.B(this.f.onError(J=>this.a.fire(J)))):(this.b=null,this.f=null)}writeMessage(E,C){this.g.push({data:E,options:C}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:C}=this.g.shift();if(this.f&&C.compressed){const j=await this.w(this.f,E);this.s(j,C)}else this.s(E,{...C,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,C){return new Promise((j,U)=>{E.write(C),E.flush(F=>j(F))})}acceptFrame(E,C,j){this.h.push({data:E,isCompressed:C,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const C=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(C)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,C,j){return new Promise((U,F)=>{E.write(C),j&&E.write(D.$ke.fromByteArray([0,0,255,255])),E.flush(H=>U(H))})}}class $ extends u.$Tc{get recordedInflateBytes(){return this.j?D.$ke.concat(this.f):D.$ke.alloc(0)}constructor(E,C,j,U){super(),this.h=E,this.j=C,this.a=this.B(new d.$Wd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(U),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(D.$ke.wrap(F))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const C=D.$ke.concat(this.g);this.g.length=0,E(C)})}}class a extends u.$Tc{constructor(E,C){super(),this.g=E,this.a=this.B(new d.$Wd),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(D.$ke.wrap(j))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let C=D.$ke.concat(this.f);this.f.length=0,C=C.slice(0,C.byteLength-4),E(C)})}}function t(I,E){if(E===0)return;const C=I.byteLength>>>2;for(let le=0;le<C;le++){const re=I.readUInt32BE(le*4);I.writeUInt32BE(re^E,le*4)}const j=C*4,U=I.byteLength-j,F=E>>>24&255,H=E>>>16&255,J=E>>>8&255;U>=1&&I.writeUInt8(I.readUInt8(j)^F,j),U>=2&&I.writeUInt8(I.readUInt8(j+1)^H,j+1),U>=3&&I.writeUInt8(I.readUInt8(j+2)^J,j+2)}e.$Yh=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function r(){const I=(0,y.$rg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const E=process.platform!=="darwin"&&e.$Yh?e.$Yh:(0,s.tmpdir)(),C=(0,b.$jc)(E,`vscode-ipc-${I}.sock`);return n(C),C}e.$Zh=r;function i(I,E,C){const U=(0,S.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${C}-${E}-sock`;const F=C.substr(0,4),H=E.substr(0,6);let J;return process.platform!=="darwin"&&e.$Yh&&!process.env.VSCODE_PORTABLE?J=(0,b.$jc)(e.$Yh,`vscode-${U}-${F}-${H}.sock`):J=(0,b.$jc)(I,`${F}-${H}.sock`),n(J),J}e.$1h=i;function n(I){const E=o[v.$u];typeof E=="number"&&I.length>=E&&console.warn(`WARNING: IPC handle "${I}" is longer than ${E} chars, try a shorter --user-data-dir`)}class c extends h.$Lh{static b(E){const C=d.Event.fromNodeEventEmitter(E,"connection");return d.Event.map(C,j=>({protocol:new m.$Sh(new p(j,"ipc-server-connection")),onDidClientDisconnect:d.Event.once(d.Event.fromNodeEventEmitter(j,"close"))}))}constructor(E){super(c.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$2h=c;function w(I){return new Promise((E,C)=>{const j=(0,O.createServer)();j.on("error",C),j.listen(I,()=>{j.removeListener("error",C),E(new c(j))})})}e.$3h=w;function A(I,E){return new Promise((C,j)=>{const U=(0,O.createConnection)(I,()=>{U.removeListener("error",j),C(m.$Th.fromSocket(new p(U,`ipc-client${E}`),E))});U.once("error",j)})}e.$4h=A}),define(ae[24],ce([0,1,50,9,4,100,38,90,6]),function(Y,e,S,O,s,M,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m0b=e.$l0b=void 0,e.$l0b=(0,d.$9h)(D.$ci);class u extends P.$Em{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,O.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,O.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$1h)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,O.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const v in process.env)if(v.endsWith("_VSCODE_SNAP_ORIG")){const y=v.slice(0,-17);if(this.d[y])continue;process.env[y]&&(this.d[y]=process.env[y]),process.env[v]?process.env[y]=process.env[v]:delete process.env[y]}}}restoreSnapExportedVariables(){if(s.$k)for(const v in this.d)process.env[v]=this.d[v],delete this.d[v]}}e.$m0b=u,ve([S.$zh],u.prototype,"cachedLanguagesPath",null),ve([S.$zh],u.prototype,"backupHome",null),ve([S.$zh],u.prototype,"mainIPCHandle",null),ve([S.$zh],u.prototype,"mainLockfile",null),ve([S.$zh],u.prototype,"disableUpdates",null),ve([S.$zh],u.prototype,"crossOriginIsolated",null),ve([S.$zh],u.prototype,"codeCachePath",null),ve([S.$zh],u.prototype,"useCodeCache",null)}),define(ae[283],ce([0,1,86,33,13,9,4,19,21,196,18,24,34,16,5,195,30,99]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$10b=void 0;let f=class{static{l=this}static{this.a="backupWorkspaces"}constructor(a,t,o,r){this.j=a,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$zg,this.i={isEqual:(i,n)=>(0,O.$8f)(i,n,!D.$k)}}async initialize(){const a=this.m.getItem(l.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,u.$o0b)(a)),this.e=await this.v((0,u.$p0b)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==h.$Rk.OFF}q(){return this.s()===h.$Rk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||h.$Rk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(r=>a.workspace.id===r.workspace.id)||(this.d.push(a),this.C());const o=(0,M.$jc)(this.c,a.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(a,t){if(await d.Promises.exists(a)&&await this.z(a),await d.Promises.exists(t))try{await d.Promises.rename(t,a,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,M.$jc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,M.$jc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const r of a){const i=r.workspace;if(!(0,k.$ki)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$jc)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await d.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!o.has(n)){o.add(n);const c=(0,M.$jc)(this.c,this.D(r));await this.B(c)?i.scheme!==s.Schemas.file||await d.Promises.exists(i.fsPath)?t.push(r):await this.z(c):await this.x(c)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const n=(0,M.$jc)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(a){try{await d.Promises.rm(a,d.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,g.$H0b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,g.$H0b)();return{backupFolder:a.id}}async z(a){const t=this.y(),o=(0,M.$jc)(this.c,t.backupFolder);try{await d.Promises.rename(a,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,u.$n0b)(a)?t=(0,M.$jc)(this.c,a.backupFolder):(0,p.$5cb)(a)?t=(0,M.$jc)(this.c,this.D(a)):t=(0,M.$jc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await d.Promises.readdir(a);for(const o of t)try{if((await d.Promises.readdir((0,M.$jc)(a,o))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(l.a,a)}D(a){const t=a.folderUri;let o;return t.scheme===s.Schemas.file?o=D.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,S.createHash)("md5").update(o).digest("hex")}};e.$10b=f,e.$10b=f=l=ve([se(0,v.$l0b),se(1,b.$Bi),se(2,m.$pj),se(3,y.$PO)],f)}),define(ae[20],ce([0,1,15,37,8,3,2,4,36,12,6,5,34,24]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Q0b=e.LifecycleMainPhase=e.ShutdownReason=e.$P0b=void 0,e.$P0b=(0,b.$8h)("lifecycleMainService");var p;(function(l){l[l.QUIT=1]="QUIT",l[l.KILL=2]="KILL"})(p||(e.ShutdownReason=p={}));var k;(function(l){l[l.Starting=1]="Starting",l[l.Ready=2]="Ready",l[l.AfterWindowOpen=3]="AfterWindowOpen",l[l.Eventually=4]="Eventually"})(k||(e.LifecycleMainPhase=k={}));let g=class extends D.$Tc{static{m=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(f,$,a){super(),this.F=f,this.G=$,this.H=a,this.c=this.B(new M.$Wd),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$Wd),this.onWillShutdown=this.f.event,this.g=this.B(new M.$Wd),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$Wd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(m.b),this.m&&this.G.removeItem(m.b)}J(){const f=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$j&&this.t===0&&this.L(1))};S.app.addListener("before-quit",f);const $=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$j)&&S.app.quit()};S.app.addListener("window-all-closed",$),S.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",f),S.app.removeListener("window-all-closed",$),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(f){if(this.y)return this.y;const $=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:f,join(t,o){$.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{$.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(f){if(f<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===f)return;this.S(`lifecycle (main): phase changed (value: ${f})`),this.n=f;const $=this.C.get(this.n);$&&($.open(),this.C.delete(this.n))}async when(f){if(f<=this.n)return;let $=this.C.get(f);$||($=new s.$7g,this.C.set(f,$)),await $.wait()}registerWindow(f){const $=new D.$Sc;this.t++,$.add(f.onWillLoad(t=>this.g.fire({window:f,workspace:t.workspace,reason:t.reason})));const a=(0,u.$Uf)(f.win);a.on("close",t=>{const o=f.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${f.id}`),t.preventDefault(),this.unload(f,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(f),f.close()})}),a.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${f.id}`),this.t--,$.dispose(),this.t===0&&(!P.$j||this.j)&&this.L(1)})}registerAuxWindow(f){const $=(0,u.$Uf)(f.win);$.on("close",a=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${f.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),a.preventDefault())}),$.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${f.id}`)})}async reload(f,$){await this.unload(f,3)||f.reload($)}unload(f,$){const a=this.z.get(f.id);if(a)return a;const t=this.M(f,$).finally(()=>{this.z.delete(f.id)});return this.z.set(f.id,t),t}async M(f,$){if(!f.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${f.id}`);const a=this.j?2:$,t=await this.P(f,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${f.id})`),this.N(t)):(await this.Q(f,a),!1)}N(f){return f?(this.O(!0),this.j=!1,!0):!1}O(f){this.w&&(this.w(f),this.w=void 0,this.u=void 0)}P(f,$){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;O.$VU.once(o,()=>{a(!1)}),O.$VU.once(r,()=>{a(!0)}),f.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:$})})}Q(f,$){return new Promise(a=>{const o=`vscode:reply${this.s++}`;O.$VU.once(o,()=>a()),f.send("vscode:onWillUnload",{replyChannel:o,reason:$})})}quit(f){return this.R(f).then($=>{if(!$&&f)try{if(P.$i){const a=(0,d.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return $})}R(f){return this.S(`Lifecycle#quit() - begin (willRestart: ${f})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(f&&this.G.setItem(m.b,!0),this.u=new Promise($=>{this.w=$,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(f){this.H.args["enable-smoke-test-driver"]?this.F.info(f):this.F.trace(f)}setRelaunchHandler(f){this.D=f}async relaunch(f){this.S("Lifecycle#relaunch()");const $=process.argv.slice(1);if(f?.addArgs&&$.push(...f.addArgs),f?.removeArgs)for(const o of f.removeArgs){const r=$.indexOf(o);r>=0&&$.splice(r,1)}const a=()=>{this.D?.handleRelaunch(f)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:$}))};S.app.once("quit",a),await this.quit(!0)&&S.app.removeListener("quit",a)}async kill(f){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$9g)(1e3),(async()=>{for(const $ of S.BrowserWindow.getAllWindows())if($&&!$.isDestroyed()){let a;$.webContents&&!$.webContents.isDestroyed()?a=new Promise(t=>$.once("closed",t)):a=Promise.resolve(),$.destroy(),await a}})()]),S.app.exit(f)}};e.$Q0b=g,e.$Q0b=g=m=ve([se(0,v.$pj),se(1,y.$PO),se(2,h.$l0b)],g)}),define(ae[284],ce([0,1,4,3,2,6,20]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n$b=e.$m$b=void 0,e.$m$b=(0,M.$8h)("keyboardLayoutMainService");let P=class extends s.$Tc{constructor(b){super(),this.a=this.B(new O.$Wd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((v,y)=>{Y(["native-keymap"],v,y)});this.c=d(b),S.$t||b.onDidChangeKeyboardLayout(()=>{this.c=d(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$n$b=P,e.$n$b=P=ve([se(0,D.$P0b)],P);function d(u){const b=u.getKeyMap(),v=u.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:v}}}),define(ae[285],ce([0,1,246,8,17,14,12,18,38,94,5,53,245,282]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;let m=class extends v.$kp{constructor(l,f,$,a){super(a),this.m=l,this.n=f,this.r=$,this.s(),this.B(l.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const l=this.m.getValue("http");this.f=l?.proxy,this.g=!!l?.proxyStrictSSL,this.h=l?.proxyAuthorization}async request(l,f){const{f:$,g:a}=this;let t;try{t=await(0,u.$bm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$0)(i)))}const o={...process.env,...t},r=l.agent?l.agent:await(0,y.$or)(l.url||"",o,{proxyUrl:$,strictSSL:a});return l.agent=r,l.strictSSL=a,this.h&&(l.headers={...l.headers||{},"Proxy-Authorization":this.h}),this.c(l.isChromiumNetwork?"electron":"node",l,()=>k(l,f))}async resolveProxy(l){}async loadCertificates(){return(await new Promise((f,$)=>{Y(["@vscode/proxy-agent"],f,$)})).loadSystemCertificates({log:this.r})}};e.$pr=m,e.$pr=m=ve([se(0,P.$Bi),se(1,d.$di),se(2,b.$pj),se(3,b.$qj)],m);async function p(g){return((0,S.parse)(g.url).protocol==="https:"?await new Promise(($,a)=>{Y(["https"],$,a)}):await new Promise(($,a)=>{Y(["http"],$,a)})).request}async function k(g,l){return O.Promises.withAsyncBody(async(f,$)=>{const a=(0,S.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await p(g),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,D.$Pf)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password);const r=t(o,i=>{const n=(0,D.$Nf)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)k({...g,url:i.headers.location,followRedirects:n-1},l).then(f,$);else{let c=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(c=i.pipe((0,h.createGunzip)())),f({res:i,stream:(0,s.$ze)(c)})}});r.on("error",$),g.timeout&&r.setTimeout(g.timeout),g.isChromiumNetwork&&r.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&r.write(g.data),r.end(),l.onCancellationRequested(()=>{r.abort(),$(new M.$5)})})}e.$qr=k}),define(ae[286],ce([0,1,15,285]),function(Y,e,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p_b=void 0;function s(D){return S.net.request}class M extends O.$pr{request(P,d){return super.request({...P||{},getRawRequest:s,isChromiumNetwork:!0},d)}}e.$p_b=M}),define(ae[82],ce([0,1,7,3,2,38,16,6,20,5,97,279,41,57,40,13]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y0b=e.$X0b=e.$W0b=e.$V0b=void 0,e.$V0b=(0,P.$8h)("storageMainService");let k=class extends s.$Tc{constructor(f,$,a,t,o,r){super(),this.c=f,this.f=$,this.g=a,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new O.$Wd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(f=>{f.window.profile&&this.profileStorage(f.window.profile).init(),f.workspace&&this.workspaceStorage(f.workspace).init()})),this.B(this.h.onWillShutdown(f=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=f.reason,f.join("applicationStorage",this.applicationStorage.close());for(const[,$]of this.t)f.join("profileStorage",$.close());for(const[,$]of this.w)f.join("workspaceStorage",$.close())})),this.B(this.g.onWillCreateProfile(f=>{f.join((async()=>{await this.j.exists(f.profile.globalStorageHome)||await this.j.createFolder(f.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(f=>{const $=this.t.get(f.profile.id);$&&f.join($.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const f=new v.$S0b(this.n(),this.g,this.c,this.j);return this.B(O.Event.once(f.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),f}profileStorage(f){if((0,b.$zp)(f))return this.applicationStorage;let $=this.t.get(f.id);if(!$){this.c.trace(`StorageMainService: creating profile storage (${f.name})`),$=this.B(this.u(f)),this.t.set(f.id,$);const a=this.B($.onDidChangeStorage(t=>this.b.fire({...t,storage:$,profile:f})));this.B(O.Event.once($.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${f.name})`),this.t.delete(f.id),a.dispose()}))}return $}u(f){return this.a===2?new v.$U0b(this.c,this.j):new v.$R0b(f,this.n(),this.c,this.j)}workspaceStorage(f){let $=this.w.get(f.id);return $||(this.c.trace(`StorageMainService: creating workspace storage (${f.id})`),$=this.B(this.y(f)),this.w.set(f.id,$),this.B(O.Event.once($.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${f.id})`),this.w.delete(f.id)}))),$}y(f){return this.a===2?new v.$U0b(this.c,this.j):new v.$T0b(f,this.n(),this.c,this.f,this.j)}isUsed(f){const $=S.URI.file(f);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(S.URI.file(a.path),$))return!0;return!1}};e.$W0b=k,e.$W0b=k=ve([se(0,u.$pj),se(1,M.$ci),se(2,h.$z0b),se(3,d.$P0b),se(4,D.$sk),se(5,m.$3k)],k),e.$X0b=(0,P.$8h)("applicationStorageMainService");let g=class extends b.$yp{constructor(f,$){super(),this.s=f,this.U=$,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(f){if(f===-1)return this.U.applicationStorage.storage}Q(f){if(f===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$Y0b=g,e.$Y0b=g=ve([se(0,y.$5k),se(1,e.$V0b)],g)}),define(ae[287],ce([0,1,87,26,105,100,8,2,4,18,5,27,241,242,95,128,17]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o_b=e.$n_b=e.$m_b=e.$l_b=void 0;async function g(t,o,r,i,n){let c;for(let w=3;w&&(c?.dispose(),c=await new l(t,o,r,i,n).waitForReady(),!(n&&s.$ug[n]||!s.$ug[c.tunnelLocalPort]));w--);return c}class l extends P.$Tc{constructor(o,r,i,n,c){super(),this.m=r,this.n=c,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=S.createServer(),this.c=new D.$7g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=w=>this.r(w),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,p.$Jv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$vg)(o,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,p.$Hv)(this.tunnelRemoteHost)||(0,p.$Jv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,y.$nl)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),c=i.readEntireBuffer();i.dispose(),c.byteLength>0&&o.write(c.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof M.$Wh?n.socket.destroy():n.end()}),n instanceof M.$Wh?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write(k.$ke.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$l_b=l;let f=class extends p.$Mv{constructor(o,r,i,n,c){super(r,c),this.v=o,this.w=i,this.y=n}isPortPrivileged(o){return(0,p.$Kv)(o,this.m,d.OS,O.release())}t(o,r,i,n,c,w,A,I){const E=this.s(r,i);if(E)return++E.refcount,E.value;if((0,p.$Ev)(o))return this.u(o,r,i,c,w,A,I);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${c}.`);const C={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},j=g(C,n,r,i,c);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,i,j),j}}};e.$m_b=f,e.$m_b=f=ve([se(0,h.$hl),se(1,b.$pj),se(2,m.$kl),se(3,v.$Hj),se(4,u.$Bi)],f);let $=class extends f{constructor(o,r,i,n,c){super(o,r,i,n,c)}};e.$n_b=$,e.$n_b=$=ve([se(0,h.$hl),se(1,b.$pj),se(2,m.$kl),se(3,v.$Hj),se(4,u.$Bi)],$);let a=class extends P.$Tc{constructor(o,r,i,n,c){super(),this.b=o,this.c=r,this.f=i,this.g=n,this.h=c,this.a=new Map}async openTunnel(o,r,i,n,c,w,A,I,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${w}.`),!this.a.has(o)){const C=new $(this.b,this.c,this.g,this.f,this.h);this.B(C),this.a.set(o,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,n,c,w,A,I,E)}};e.$o_b=a,e.$o_b=a=ve([se(0,h.$hl),se(1,b.$pj),se(2,v.$Hj),se(3,m.$kl),se(4,u.$Bi)],a)}),define(ae[101],ce([0,1,8,23,3,18,24,20,5,27,53,49]),function(Y,e,S,O,s,M,D,P,d,u,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=e.$J$b=void 0;function y(m,p,k){return`${k.updateUrl}/api/update/${m}/${p}/${k.commit}`}e.$J$b=y;let h=class{get state(){return this.b}d(p){this.j.info("update#setState",p.type),this.b=p,this.c.fire(p)}constructor(p,k,g,l,f,$){this.f=p,this.g=k,this.h=g,this.i=l,this.j=f,this.k=$,this.b=v.$TV.Uninitialized,this.c=new s.$Wd,this.onStateChange=this.c.event,p.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(v.$TV.Disabled(0));return}if(this.h.disableUpdates){this.d(v.$TV.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(v.$TV.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.g.getValue("update.mode"),k=this.m(p);if(!k){this.d(v.$TV.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(k),!this.a){this.d(v.$TV.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const g=new URL(this.a);g.searchParams.set("prss","true"),this.a=g.toString()}if(this.d(v.$TV.Idle(this.q())),p==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(p){return p==="none"?void 0:this.k.quality}n(p=60*60*1e3){return(0,S.$9g)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(p){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(p)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(p){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},O.CancellationToken.None)).res.statusCode===204}catch(k){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(k);return}}async _applySpecificUpdate(p){}q(){return 1}r(){}};e.$K$b=h,e.$K$b=h=ve([se(0,P.$P0b),se(1,M.$Bi),se(2,D.$l0b),se(3,b.$jp),se(4,d.$pj),se(5,u.$Hj)],h)}),define(ae[288],ce([0,1,15,50,3,45,2,18,24,20,5,27,53,28,49,101]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=void 0;let k=class extends p.$K$b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",(l,f)=>f)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(l,f,$)=>({url:f,version:$,productVersion:$}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(l,f,$,a)=>({releaseNotes:f,version:$,productVersion:$,date:a}))}constructor(l,f,$,a,t,o,r){super(l,f,a,t,o,r),this.z=$,this.u=new D.$Sc,l.setRelaunchHandler(this)}handleRelaunch(l){return l?.addArgs||l?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(l){this.z.publicLog2("update:error",{messageHash:String((0,M.$Vi)(String(l)))}),this.j.error("UpdateService error:",l);const f=this.state.type==="checking for updates"&&this.state.explicit?l:void 0;this.d(m.$TV.Idle(1,f))}s(l){let f;this.k.darwinUniversalAssetId?f=this.k.darwinUniversalAssetId:f=process.arch==="x64"?"darwin":"darwin-arm64";const $=(0,p.$J$b)(f,l,this.k);try{S.autoUpdater.setFeedURL({url:$})}catch(a){this.j.error("Failed to set update feed URL",a);return}return $}t(l){this.d(m.$TV.CheckingForUpdates(l)),S.autoUpdater.checkForUpdates()}E(l){this.state.type==="checking for updates"&&this.d(m.$TV.Downloading(l))}F(l){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:l.version}),this.d(m.$TV.Ready(l)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(m.$TV.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$L$b=k,ve([O.$zh],k.prototype,"v",null),ve([O.$zh],k.prototype,"w",null),ve([O.$zh],k.prototype,"x",null),ve([O.$zh],k.prototype,"y",null),e.$L$b=k=ve([se(0,u.$P0b),se(1,P.$Bi),se(2,h.$wl),se(3,d.$l0b),se(4,y.$jp),se(5,b.$pj),se(6,v.$Hj)],k)}),define(ae[289],ce([0,1,48,46,8,3,9,24,20,5,28,49]),function(Y,e,S,O,s,M,D,P,d,u,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N$b=void 0;let y=class{get state(){return this.a}d(p){this.g.info("update#setState",p.type),this.a=p,this.b.fire(p)}constructor(p,k,g){if(this.f=p,this.g=g,this.a=v.$TV.Uninitialized,this.b=new M.$Wd,this.onStateChange=this.b.event,k.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.$TV.Idle(this.k())),this.h(30*1e3).then(void 0,l=>this.g.error(l))}h(p=60*60*1e3){return(0,s.$9g)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(p){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(p)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(p){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(p){}};y=ve([se(0,d.$P0b),se(1,P.$l0b),se(2,u.$pj)],y);let h=class extends y{constructor(p,k,g,l,f,$){super(g,l,f),this.o=p,this.p=k,this.q=$;const a=(0,O.watch)(D.$mc(this.o)),t=M.Event.fromNodeEventEmitter(a,"change",(n,c)=>c),o=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(o,(n,c)=>c,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(v.$TV.CheckingForUpdates(!1)),this.u().then(p=>{p?this.d(v.$TV.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$TV.Idle(2)))},p=>{this.g.error(p),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$TV.Idle(2,p.message||p))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+D.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const p=await new Promise((g,l)=>(0,O.realpath)(`${D.$mc(this.o)}/current`,(f,$)=>f?l(f):g($))),k=D.$nc(p);return this.p!==k}isLatestVersion(){return this.u().then(void 0,p=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$N$b=h,e.$N$b=h=ve([se(2,d.$P0b),se(3,P.$l0b),se(4,u.$pj),se(5,b.$wl)],h)}),define(ae[29],ce([0,1,15,4,6,96,55,69,27,18,24,9,137]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.$y0b=e.$x0b=e.OpenContext=e.$w0b=void 0,e.$w0b=(0,s.$8h)("windowsMainService");var h;(function(g){g[g.CLI=0]="CLI",g[g.DOCK=1]="DOCK",g[g.MENU=2]="MENU",g[g.DIALOG=3]="DIALOG",g[g.DESKTOP=4]="DESKTOP",g[g.API=5]="API"})(h||(e.OpenContext=h={}));function m(g,l,f){const $=g.get(P.$u0b),a=g.get(d.$Hj),t=g.get(u.$Bi),o=g.get(b.$l0b),r=t.getValue("window"),i={backgroundColor:$.getBackgroundColor(),minWidth:D.$PC.WIDTH,minHeight:D.$PC.HEIGHT,title:a.nameLong,...f,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.$1C)(l?.zoomLevel??r?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...f?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(l&&(i.x=l.x,i.y=l.y,i.width=l.width,i.height=l.height),O.$k?i.icon=(0,v.$jc)(o.appRoot,"resources/linux/code.png"):O.$i&&!o.isBuilt&&(i.icon=(0,v.$jc)(o.appRoot,"resources/win32/code_150x150.png")),O.$j&&(i.acceptFirstMouse=!0,r?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),O.$j&&!(0,D.$ZC)(t)&&(i.fullscreenable=!1),O.$j&&r?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,D.$WC)(t)&&(i.titleBarStyle="hidden",O.$j||(i.frame=!1),(0,D.$YC)(t))){const w=$.getWindowSplash()?.colorInfo.titleBarBackground??$.getBackgroundColor(),A=y.$ot.fromHex(w).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:w,symbolColor:A}}return i}e.$x0b=m;function p(g){let l,f=Number.MIN_VALUE;for(const $ of g)$.lastFocusTime>f&&(f=$.lastFocusTime,l=$);return l}e.$y0b=p;var k;(function(g){function l($,a,t=S.screen.getAllDisplays()){if($.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){$.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){$.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=f(t[0]);if(i){let n=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};$.trace("window#validateWindowState: 1 monitor working area",i),n(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),n()}return a}if(a.display&&a.mode===3){const i=t.find(n=>n.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){$.trace("window#validateWindowState: restoring fullscreen to previous display");const n=(0,M.$k0b)(3);return n.x=i.bounds.x,n.y=i.bounds.y,n}}let o,r;try{o=S.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),r=f(o)}catch{}if(o&&r&&a.x+a.width>r.x&&a.y+a.height>r.y&&a.x<r.x+r.width&&a.y<r.y+r.height)return $.trace("window#validateWindowState: multi-monitor working area",r),a}g.validateWindowState=l;function f($){if($.workArea.width>0&&$.workArea.height>0)return $.workArea;if($.bounds.width>0&&$.bounds.height>0)return $.bounds}})(k||(e.WindowStateValidator=k={}))}),define(ae[290],ce([0,1,15,23,3,45,2,32,118,5,82,29]),function(Y,e,S,O,s,M,D,P,d,u,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z0b=void 0;var y;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let h=class extends D.$Tc{constructor(p,k,g,l){super(),this.g=p,this.h=k,this.j=g,this.m=l,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const p=s.Event.fromNodeEventEmitter(S.app,"login",(k,g,l,f,$)=>({event:k,webContents:g,req:l,authInfo:f,callback:$}));this.B(p(this.r,this))}async r({event:p,authInfo:k,req:g,callback:l}){if(!k.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}p.preventDefault();let f;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),f=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(k);try{f=await this.b}finally{this.b=void 0}}l(f?.username,f?.password)}async s(p){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const k=await this.t(p);if(k)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),k;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(p){this.g.trace("auth#doResolveProxyCredentials - enter",p);const k=String((0,M.$Vi)({scheme:p.scheme,host:p.host,port:p.port}));let g,l;try{const t=this.m.get(this.a+k,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));g=o.username,l=o.password}}catch(t){this.g.error(t)}if(this.c!==y.StoredCredentialsUsed&&typeof g=="string"&&typeof l=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:g,password:l};const f=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!f){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${f.id} to handle proxy login`);const $={authInfo:p,username:this.f?.username??g,password:this.f?.password??l,replyChannel:`vscode:proxyAuthResponse:${(0,P.$rg)()}`};f.sendWhenReady("vscode:openProxyAuthenticationDialog",O.CancellationToken.None,$),this.c=y.LoginDialogShown;const a=await new Promise(t=>{const o=async(r,i,n)=>{if(i===$.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${f.id}`),f.win?.webContents.off("ipc-message",o),n){const c={username:n.username,password:n.password};try{if(n.remember){const w=await this.j.encrypt(JSON.stringify(c));this.m.store(this.a+k,w,-1,1)}else this.m.remove(this.a+k,-1)}catch(w){this.g.error(w)}t({username:c.username,password:c.password})}else t(void 0)};f.win?.webContents.on("ipc-message",o)});return this.f=a,a}};e.$Z0b=h,e.$Z0b=h=ve([se(0,u.$pj),se(1,v.$w0b),se(2,d.$EV),se(3,b.$X0b)],h)}),define(ae[291],ce([0,1,15,22,4,7,21,18,64,6,5,129,29]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q$b=e.$p$b=e.ID=void 0,e.ID="launchMainService",e.$p$b=(0,u.$8h)(e.ID);let h=class{constructor(p,k,g,l){this.a=p,this.b=k,this.c=g,this.d=l}async start(p,k){this.a.trace("Received data from other instance: ",p,k),s.$j&&S.app.focus({steal:!0});const g=this.e(p);if(g.length){let l=Promise.resolve();if(this.b.getWindowCount()===0){const f=(0,O.$Ob)(await this.b.openEmptyWindow({context:4}));f&&(l=f.ready())}l.then(()=>{for(const{uri:f,originalUrl:$}of g)this.c.open(f,{originalUrl:$})})}else return this.f(p,k)}e(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,O.$Hb)(p._urls.map(k=>{try{return{uri:M.URI.parse(k),originalUrl:k}}catch{return null}})):[]}async f(p,k){const g=(0,d.$8l)(k)?0:4;let l=[];const f=p.wait&&p.waitMarkerFilePath?M.URI.file(p.waitMarkerFilePath):void 0,$=p.remote||void 0,a={context:g,cli:p,userEnv:p["preserve-env"]||g===0?k:void 0,waitMarkerFileURI:f,remoteAuthority:$,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,a);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let t=!1;if(p["new-window"]||p["unity-launch"]||a.forceProfile||a.forceTempProfile)t=!0;else if(p["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)l=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,a),l=[o]):l=await this.b.open({...a,forceEmpty:!0})}}else l=await this.b.open({...a,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(f&&l.length===1&&l[0])return Promise.race([l[0].whenClosedOrLoaded,(0,D.whenDeleted)(f.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$q$b=h,e.$q$b=h=ve([se(0,b.$pj),se(1,y.$w0b),se(2,v.$KV),se(3,P.$Bi)],h)}),define(ae[292],ce([0,1,2,20,57,30,8,29]),function(Y,e,S,O,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6$b=void 0;let d=class extends S.$Tc{constructor(b,v,y){super(),this.a=v,this.b=y,this.B(b.onWillLoadWindow(h=>{h.reason===2&&this.c(h.window)})),this.B(b.onBeforeCloseWindow(h=>this.c(h))),this.B(new D.$hh(()=>this.g(),30*1e3)).schedule()}async c(b){const v=this.f(b),y=this.a.getProfileForWorkspace(v);y?.isTransient&&(this.a.unsetWorkspace(v,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,M.$ji)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const v=this.b.getWindows().map(y=>this.f(y));for(const y of b)v.some(h=>h.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$6$b=d,e.$6$b=d=ve([se(0,O.$P0b),se(1,s.$z0b),se(2,P.$w0b)],d)}),define(ae[61],ce([0,1,15,2,3,5,312,8,13,29,73,28,20,75,35,4,132]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$40b=e.$30b=void 0;function l(a){return typeof a.responseWindowId=="number"}let f=class extends O.$Tc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++g.a),this.f=this.B(new s.$Wd),this.onStdout=this.f.event,this.g=this.B(new s.$Wd),this.onStderr=this.g.event,this.h=this.B(new s.$Wd),this.onMessage=this.h.event,this.j=this.B(new s.$Wd),this.onSpawn=this.j.event,this.m=this.B(new s.$Wd),this.onExit=this.m.event,this.n=this.B(new s.$Wd),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case b.default.Error:this.u.error(r);break;case b.default.Warning:this.u.warn(r);break;case b.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",b.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=d.$pg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],n=this.t.execArgv??[],c=this.t.allowLoadingUnsignedLibraries,w=this.t.forceAllocationsToV8Sandbox,A="pipe",I=this.F(t);return this.z("creating new...",b.default.Info),this.r=S.utilityProcess.fork(r,i,{serviceName:o,env:I,execArgv:n,allowLoadingUnsignedLibraries:c,forceAllocationsToV8Sandbox:w,stdio:A}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,m.$yn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,p.$i&&((0,k.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,k.getUNCHostAllowlist)().join("\\")),(0,h.$Ul)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&g.b.set(t.pid,{pid:t.pid,name:l(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",b.default.Info),this.j.fire(t.pid)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,b.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,b.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){this.r&&this.r.postMessage(t,o)}connect(t){const{port1:o,port2:r}=new S.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",b.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",b.default.Info),this.r.kill()?(this.z("successfully killed the process",b.default.Info),this.H()):this.z("unable to kill the process",b.default.Warning)}H(){typeof this.s=="number"&&g.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",b.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,P.$9g)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,b.default.Info),this.kill()))}};e.$30b=f,e.$30b=f=g=ve([se(0,M.$pj),se(1,v.$wl),se(2,y.$P0b)],f);let $=class extends f{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",b.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$40b=$,e.$40b=$=ve([se(0,M.$pj),se(1,u.$w0b),se(2,v.$wl),se(3,y.$P0b)],$)}),define(ae[293],ce([0,1,14,3,5,20,8,61,29,28]),function(Y,e,S,O,s,M,D,P,d,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$$0b=void 0;let v=class{static{b=this}static{this.a=0}constructor(h,m,p,k){this.d=h,this.f=m,this.g=p,this.h=k,this.b=new Map,this.c=!1,this.f.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(h){const m=this.b.get(h);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout(h){return this.i(h).onStdout}onDynamicStderr(h){return this.i(h).onStderr}onDynamicMessage(h){return this.i(h).onMessage}onDynamicExit(h){return this.i(h).onExit}async createExtensionHost(){if(this.c)throw(0,S.$6)();const h=String(++b.a),m=new P.$40b(this.d,this.g,this.h,this.f);return this.b.set(h,m),m.onExit(({pid:p,code:k,signal:g})=>{this.d.info(`Extension host with pid ${p} exited with code: ${k}, signal: ${g}.`),setTimeout(()=>{m.dispose(),this.b.delete(h)}),setTimeout(()=>{try{process.kill(p,0),this.d.error(`Extension host with pid ${p} still exists, forcefully killing it...`),process.kill(p)}catch{}},1e3)}),{id:h}}async start(h,m){if(this.c)throw(0,S.$6)();const p=this.i(h);return p.start({...m,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:m.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:h}),{pid:await O.Event.toPromise(p.onSpawn)}}async enableInspectPort(h){if(this.c)throw(0,S.$6)();const m=this.b.get(h);return m?m.enableInspectPort():!1}async kill(h){if(this.c)throw(0,S.$6)();const m=this.b.get(h);m&&m.kill()}async _killAllNow(){for(const[,h]of this.b)h.kill()}async _waitForAllExit(h){const m=[];for(const[,p]of this.b)m.push(p.waitForExit(h));return D.Promises.settled(m).then(()=>{})}};e.$$0b=v,e.$$0b=v=b=ve([se(0,s.$pj),se(1,M.$P0b),se(2,d.$w0b),se(3,u.$wl)],v)}),define(ae[294],ce([0,1,37,8,2,24,20,5,41,39,68,61,54,90,12,247]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D$b=void 0;let k=class extends s.$Tc{constructor(l,f,$,a,t,o,r,i){super(),this.c=l,this.f=f,this.g=$,this.h=a,this.j=t,this.m=o,this.n=r,this.r=i,this.a=new O.$7g,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){S.$VU.on(p.$B$b.request,(l,f)=>this.t(l,f,p.$B$b.response)),S.$VU.on(p.$C$b.request,(l,f)=>this.t(l,f,p.$C$b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(l,f,$){this.m.trace(`[SharedProcess] onWindowConnection for: ${$}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect($);if(l.sender.isDestroyed())return a.close();l.sender.postMessage($,f,[a])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(p.$A$b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const l=new O.$sh;this.b?this.b.once(p.$A$b.initDone,()=>l.complete()):S.$VU.once(p.$A$b.initDone,()=>l.complete()),await l.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const l=new O.$sh;this.b?this.b.once(p.$A$b.ipcReady,()=>l.complete()):S.$VU.once(p.$A$b.ipcReady,()=>l.complete()),await l.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new v.$30b(this.m,y.$Po,this.j));const l=(0,h.$Gm)(this.g.args,this.g.isBuilt);let f;l.port&&(f=["--nolazy"],l.break?f.push(`--inspect-brk=${l.port}`):f.push(`--inspect=${l.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:f})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(l){return await this.z,(0,m.$Uf)(this.b).connect(l)}};e.$D$b=k,e.$D$b=k=ve([se(2,M.$l0b),se(3,d.$5k),se(4,D.$P0b),se(5,P.$pj),se(6,b.$K0b),se(7,u.$Mn)],k)}),define(ae[295],ce([0,1,24,90,20,5,54,61,112,37,2,3,35,18,13]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d_b=void 0;let p=class extends b.$Tc{constructor(g,l,f,$,a){super(),this.f=g,this.g=l,this.h=f,this.j=$,this.m=a,this.a=void 0,this.b=new v.$Wd,this.onRequestConnection=this.b.event,this.c=new v.$Wd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),u.$VU.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,b.$Rc)(()=>{u.$VU.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$30b(this.m,D.$Po,this.j);const g=(0,O.$Fm)(this.h.args,this.h.isBuilt),l=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:l,args:["--logsPath",this.h.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this.n()});const f=this.a.connect(),$=new d.$4U(f,"ptyHost"),a=new b.$Sc;return a.add($),a.add((0,b.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:$,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,y.$yn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},l=this.g.getValue("terminal.integrated.developer.ptyHost.latency");l&&typeof l=="number"&&(g.VSCODE_LATENCY=String(l));const f=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return f&&typeof f=="number"&&(g.VSCODE_STARTUP_DELAY=String(f)),this.h.restoreSnapExportedVariables(),g}r(g,l){this.b.fire();const f=this.a.connect();if(g.sender.isDestroyed()){f.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",l,[f])}};e.$d_b=p,e.$d_b=p=ve([se(1,h.$Bi),se(2,S.$l0b),se(3,s.$P0b),se(4,M.$pj)],p)}),define(ae[296],ce([0,1,2,6,5,29,61,28,45,3,8,20]),function(Y,e,S,O,s,M,D,P,d,u,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c_b=e.$b_b=void 0,e.$b_b=(0,O.$8h)("utilityProcessWorker");let y=class extends S.$Tc{constructor(p,k,g,l){super(),this.b=p,this.c=k,this.f=g,this.g=l,this.a=new Map}async createWorker(p){const k=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${k})`);const g=this.h(p);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${k})`),this.disposeWorker(p));const l=new h(this.b,this.c,this.f,this.g,p);if(!l.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,l);const f=new b.$sh;return u.Event.once(l.onDidTerminate)($=>{$.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${$.code}, signal: ${$.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${$.code}, signal: ${$.signal}`),this.a.delete(g),f.complete({reason:$})}),f.p}h(p){return(0,d.$Vi)({moduleId:p.process.moduleId,windowId:p.reply.windowId})}async disposeWorker(p){const k=this.h(p),g=this.a.get(k);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),g.kill(),this.a.delete(k))}};e.$c_b=y,e.$c_b=y=ve([se(0,s.$pj),se(1,M.$w0b),se(2,P.$wl),se(3,v.$P0b)],y);let h=class extends S.$Tc{constructor(p,k,g,l,f){super(),this.c=p,this.f=k,this.g=g,this.h=l,this.j=f,this.a=this.B(new u.$Wd),this.onDidTerminate=this.a.event,this.b=new D.$40b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(p=>this.a.fire({code:p.code,signal:p.signal}))),this.B(this.b.onCrash(p=>this.a.fire({code:p.code,signal:"ECRASH"})))}spawn(){const k=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:k,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};h=ve([se(0,s.$pj),se(1,M.$w0b),se(2,P.$wl),se(3,v.$P0b)],h)}),define(ae[297],ce([0,1,15,3,2,273,29]),function(Y,e,S,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=void 0;let P=class extends s.$Tc{constructor(u){super(),this.b=u,this.a=this.B(new O.$Wd),this.onFoundInFrame=this.a.event,this.B(new M.$U$b)}async setIgnoreMenuShortcuts(u,b){let v;if(typeof u.windowId=="number"){const{windowId:y}=u,h=this.b.getWindowById(y);if(!h?.win)throw new Error(`Invalid windowId: ${y}`);v=h.win.webContents}else{const{webContentsId:y}=u;if(v=S.webContents.fromId(y),!v)throw new Error(`Invalid webContentsId: ${y}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(b)}async findInFrame(u,b,v,y){const m=this.c(u,b);if(typeof m.findInFrame=="function"){m.findInFrame(v,{findNext:y.findNext,forward:y.forward});const p=(k,g)=>{g.finalUpdate&&(this.a.fire(g),m.removeListener("found-in-frame",p))};m.on("found-in-frame",p)}}async stopFindInFrame(u,b,v){const h=this.c(u,b);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(u,b){const v=this.b.getWindowById(u.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${u}`);const y=v.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===b);if(!y)throw new Error(`Unknown frame: ${b}`);return y}};e.$V$b=P,e.$V$b=P=ve([se(0,D.$w0b)],P)}),define(ae[298],ce([0,1,15,2,4,19,7,18,20,5,34,29,96,30]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=e.$X$b=e.$W$b=void 0;let p=class extends O.$Tc{static{m=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,o,r,i){super(),this.g=a,this.h=t,this.j=o,this.m=r,this.n=i,this.b=k(this.h.getItem(m.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(a.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):a.add(n.uiState.display)),n}));const r=l(t);this.h.setItem(m.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,h.$ki)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,i=(0,h.$fi)(a.openedWorkspace)&&o.folderUri&&M.$zg.isEqual(o.folderUri,a.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,h.$ki)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,h.$fi)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const w=a.workspace;if((0,h.$ki)(w)){const I=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===w.id).map(E=>E.uiState);if(I.length)return I[0]}if((0,h.$fi)(w)){const I=this.state.openedWindows.filter(E=>E.folderUri&&M.$zg.isEqual(E.folderUri,w.uri)).map(E=>E.uiState);if(I.length)return I[0]}else if(a.backupPath){const I=this.state.openedWindows.filter(E=>E.backupPath===a.backupPath).map(E=>E.uiState);if(I.length)return I[0]}const A=this.c||this.state.lastActiveWindow;if(!t&&A)return A.uiState}let o;const r=S.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$j){const w=S.screen.getCursorScreenPoint();o=S.screen.getDisplayNearestPoint(w)}!o&&t&&(o=S.screen.getDisplayMatching(t.getBounds())),o||(o=S.screen.getPrimaryDisplay()||r[0])}let i=(0,y.$k0b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const n=this.n.getValue("window");let c=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,c=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,c=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const w=t.serializeWindowState();w.mode===3?i.mode=3:i={...w,zoomLevel:void 0},c=i.mode!==3&&n.newWindowDimensions==="offset"}}return c&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.$W$b=p,e.$W$b=p=m=ve([se(0,v.$w0b),se(1,b.$PO),se(2,d.$P0b),se(3,u.$pj),se(4,P.$Bi)],p);function k($){const a={openedWindows:[]},t=$||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=g(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=g(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>g(o))),a}e.$X$b=k;function g($){const a={uiState:$.uiState};return $.backupPath&&(a.backupPath=$.backupPath),$.remoteAuthority&&(a.remoteAuthority=$.remoteAuthority),$.folder&&(a.folderUri=D.URI.parse($.folder)),$.workspaceIdentifier&&(a.workspace={id:$.workspaceIdentifier.id,configPath:D.URI.parse($.workspaceIdentifier.configURIPath)}),a}function l($){return{lastActiveWindow:$.lastActiveWindow&&f($.lastActiveWindow),lastPluginDevelopmentHostWindow:$.lastPluginDevelopmentHostWindow&&f($.lastPluginDevelopmentHostWindow),openedWindows:$.openedWindows.map(a=>f(a))}}e.$Y$b=l;function f($){return{workspaceIdentifier:$.workspace&&{id:$.workspace.id,configURIPath:$.workspace.configPath.toString()},folder:$.folderUri&&$.folderUri.toString(),backupPath:$.backupPath,remoteAuthority:$.remoteAuthority,uiState:$.uiState}}}),define(ae[58],ce([0,1,15,3,42,2,13,9,19,21,194,65,56,24,6,5,57,131,30,98,99]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0b=e.$I0b=void 0,e.$I0b=(0,m.$8h)("workspacesManagementMainService");let a=class extends M.$Tc{constructor(o,r,i,n,c){super(),this.g=o,this.h=r,this.j=i,this.m=n,this.n=c,this.a=this.B(new O.$Wd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new O.$Wd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await u.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(r=>(0,d.$Ig)(this.c,r,l.$ui));for(const r of o){const i=(0,$.$F0b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>u.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===D.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(n=>this.t(o,n),n=>{}):this.t(o,i)}catch{return}}s(o){return(0,l.$vi)(o,this.g)||(0,l.$Ai)(o)}t(o,r){try{const i=this.u(o,r),n=(0,$.$F0b)(o);return{id:n.id,configPath:n.configPath,folders:(0,f.$adb)(i.folders,n.configPath,d.$zg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,s.$fn)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,f.$$cb)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:n}=this.w(o,r),c=i.configPath.fsPath;return await u.Promises.mkdir((0,P.$mc)(c),{recursive:!0}),await u.Promises.writeFile(c,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,d.$Ig)(this.c,i),c=(0,d.$Ig)(n,l.$ui),w=[];for(const A of o)w.push((0,f.$_cb)(A.uri,!0,A.name,n,d.$zg));return{workspace:(0,$.$F0b)(c),storedWorkspace:{folders:w,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,$.$F0b)(o)}isUntitledWorkspace(o){return(0,l.$vi)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,d.$wg)(o.configPath);try{await u.Promises.rm((0,P.$mc)(r));const i=(0,P.$jc)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,o.id);await u.Promises.exists(i)&&await u.Promises.writeFile((0,P.$jc)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const c=await this.C(o,(0,$.$F0b)(i));if(c)return this.b.fire({window:o,workspace:c.workspace}),c}async z(o,r,i){return i?(0,l.$ki)(o.openedWorkspace)&&d.$zg.isEqual(o.openedWorkspace.configPath,i)?!1:(0,g.$C0b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,b.localize)(0,null)],message:(0,b.localize)(1,null,(0,d.$Fg)(i)),detail:(0,b.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,l.$ki)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$J0b=a,e.$J0b=a=ve([se(0,h.$l0b),se(1,p.$pj),se(2,k.$z0b),se(3,v.$q0b),se(4,y.$r0b)],a)}),define(ae[133],ce([0,1,15,37,23,6,29,30,58,12,5,61]),function(Y,e,S,O,s,M,D,P,d,u,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$70b=e.$60b=e.ID=void 0,e.ID="diagnosticsMainService",e.$60b=(0,M.$8h)(e.ID);let y=class{constructor(m,p,k){this.a=m,this.b=p,this.c=k}async getRemoteDiagnostics(m){const p=this.a.getWindows();return(await Promise.all(p.map(async g=>{const l=g.remoteAuthority;if(!l)return;const f=`vscode:getDiagnosticInfoResponse${g.id}`,$={includeProcesses:m.includeProcesses,folders:m.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(a=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:f,args:$}),O.$VU.once(f,(t,o)=>{o||a({hostName:l,errorMessage:`Unable to resolve connection to '${l}'.`}),a(o)}),setTimeout(()=>{a({hostName:l,errorMessage:`Connection to '${l}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const m=[];for(const k of S.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(k.id);g?m.push(await this.d(g)):m.push(this.e(k))}const p=[];for(const{pid:k,name:g}of v.$30b.getAll())p.push({pid:k,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:m,pidToNames:p,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(m){const p=await this.f(m),k=(0,u.$Uf)(m.win);return this.e(k,p,m.remoteAuthority)}e(m,p=[],k){return{id:m.id,pid:m.webContents.getOSProcessId(),title:m.getTitle(),folderURIs:p,remoteAuthority:k}}async f(m){const p=[],k=m.openedWorkspace;if((0,P.$fi)(k))p.push(k.uri);else if((0,P.$ki)(k)){const g=await this.b.resolveLocalWorkspace(k.configPath);g&&g.folders.forEach(f=>{p.push(f.uri)})}return p}};e.$70b=y,e.$70b=y=ve([se(0,D.$w0b),se(1,d.$I0b),se(2,b.$pj)],y)}),define(ae[70],ce([0,1,48,15,26,156,50,3,2,13,9,4,7,107,88,21,105,182,56,24,6,20,5,27,69,29,30,58,17,243,235,78,14]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f,$,a,t,o,r,i,n,c,w,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k$b=e.$j$b=void 0,e.$j$b=(0,$.$8h)("nativeHostMainService");let j=class extends d.$Tc{constructor(F,H,J,le,re,ue,Z,X,q){super(),this.a=F,this.b=H,this.c=J,this.f=le,this.g=re,this.h=ue,this.j=Z,this.m=X,this.n=q,this.onDidOpenMainWindow=P.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=P.Event.any(P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:T,y:G})=>({windowId:L.id,x:T,y:G})),({windowId:L})=>!!this.a.getWindowById(L)),P.Event.filter(P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:T,y:G})=>({windowId:L.id,x:T,y:G})),({windowId:L})=>!!this.b.getWindowById(L))),this.onDidMaximizeWindow=P.Event.any(P.Event.filter(P.Event.map(this.a.onDidMaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),P.Event.filter(P.Event.map(this.b.onDidMaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidUnmaximizeWindow=P.Event.any(P.Event.filter(P.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),P.Event.filter(P.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidChangeWindowFullScreen=P.Event.any(P.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),P.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(O.app,"browser-window-blur",(L,T)=>T.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),P.Event.filter(P.Event.fromNodeEventEmitter(O.app,"browser-window-focus",(L,T)=>T.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=P.Event.any(this.onDidBlurMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(O.app,"browser-window-blur",(L,T)=>T),L=>(0,E.$i$b)(L.webContents)),L=>L.id)),this.onDidFocusMainOrAuxiliaryWindow=P.Event.any(this.onDidFocusMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(O.app,"browser-window-focus",(L,T)=>T),L=>(0,E.$i$b)(L.webContents)),L=>L.id)),this.onDidResumeOS=P.Event.fromNodeEventEmitter(O.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new P.$Wd),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(O.screen,"display-metrics-changed",(L,T,G)=>G),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),P.Event.fromNodeEventEmitter(O.screen,"display-added"),P.Event.fromNodeEventEmitter(O.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,H){const J=this.a.getWindows().map(re=>({id:re.id,workspace:re.openedWorkspace??(0,n.$ji)(re.backupPath,re.isExtensionDevelopmentHost),title:re.win?.getTitle()??"",filename:re.getRepresentedFilename(),dirty:re.isDocumentEdited()})),le=[];return H.includeAuxiliaryWindows&&le.push(...this.b.getWindows().map(re=>({id:re.id,parentId:re.parentId,title:re.win?.getTitle()??"",filename:re.getRepresentedFilename()}))),[...J,...le]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const H=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(H)return H.id}openWindow(F,H,J){return Array.isArray(H)?this.s(F,H,J):this.t(F,H)}async s(F,H,J=Object.create(null)){H.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:H,cli:this.g.args,forceNewWindow:J.forceNewWindow,forceReuseWindow:J.forceReuseWindow,preferNewWindow:J.preferNewWindow,diffMode:J.diffMode,mergeMode:J.mergeMode,addMode:J.addMode,gotoLineMode:J.gotoLineMode,noRecentEntry:J.noRecentEntry,waitMarkerFileURI:J.waitMarkerFileURI,remoteAuthority:J.remoteAuthority||void 0,forceProfile:J.forceProfile,forceTempProfile:J.forceTempProfile})}async t(F,H){await this.a.openEmptyWindow({context:5,contextWindowId:F},H)}async toggleFullScreen(F,H){this.C(H?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,H){this.C(H?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const H=O.screen.getCursorScreenPoint(),J=O.screen.getDisplayNearestPoint(H);return{point:H,display:J.bounds}}async isMaximized(F,H){return this.C(H?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,H){this.C(H?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,H){this.C(H?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,H){this.C(H?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,H){this.C(H?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,H,J){const le=this.C(J?.targetWindowId,F);if(le?.win){if(le.win.isFullScreen()){const re=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await re}le.win.setBounds(H)}}async updateWindowControls(F,H){this.C(H?.targetWindowId,F)?.updateWindowControls(H)}async focusWindow(F,H){this.C(H?.targetWindowId,F)?.focus({force:H?.force??!1})}async setMinimumSize(F,H,J){const le=this.D(F);if(le?.win){const[re,ue]=le.win.getSize(),[Z,X]=le.win.getMinimumSize(),[q,L]=[H??Z,J??X],[T,G]=[Math.max(re,q),Math.max(ue,L)];(Z!==q||X!==L)&&le.win.setMinimumSize(q,L),(re!==T||ue!==G)&&le.win.setSize(T,G)}}async saveWindowSplash(F,H){this.m.saveWindowSplash(F,H)}async installShellCommand(F){const{source:H,target:J}=await this.u();try{const{symbolicLink:le}=await p.SymlinkSupport.stat(H);if(le&&!le.dangling){const re=await(0,h.$xq)(H);if(J===re)return}await p.Promises.unlink(H)}catch(le){if(le.code!=="ENOENT")throw le}try{await p.Promises.symlink(J,H)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:re}=await this.showMessageBox(F,{type:"info",message:(0,g.localize)(0,null,this.j.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(re===1)throw new C.$5;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${J}' '${H}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(ue)}catch{throw new Error((0,g.localize)(3,null,H))}}}async uninstallShellCommand(F){const{source:H}=await this.u();try{await p.Promises.unlink(H)}catch(J){switch(J.code){case"EACCES":{const{response:le}=await this.showMessageBox(F,{type:"info",message:(0,g.localize)(4,null,this.j.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(le===1)throw new C.$5;try{const re=`osascript -e "do shell script \\"rm '${H}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(re)}catch{throw new Error((0,g.localize)(7,null,H))}break}case"ENOENT":break;default:throw J}}}async u(){const F=(0,b.$kc)(this.g.appRoot,"bin","code"),H=`/usr/local/bin/${this.j.applicationName}`;if(!await p.Promises.exists(F))throw new Error((0,g.localize)(8,null,F));return{source:H,target:F}}async showMessageBox(F,H){const J=this.C(H?.targetWindowId,F);return this.c.showMessageBox(H,J?.win??void 0)}async showSaveDialog(F,H){const J=this.C(H?.targetWindowId,F);return this.c.showSaveDialog(H,J?.win??void 0)}async showOpenDialog(F,H){const J=this.C(H?.targetWindowId,F);return this.c.showOpenDialog(H,J?.win??void 0)}async pickFileFolderAndOpen(F,H){const J=await this.c.pickFileFolder(H);J&&await this.w(await Promise.all(J.map(async le=>await p.SymlinkSupport.existsDirectory(le)?{folderUri:y.URI.file(le)}:{fileUri:y.URI.file(le)})),H,F)}async pickFolderAndOpen(F,H){const J=await this.c.pickFolder(H);J&&await this.w(J.map(le=>({folderUri:y.URI.file(le)})),H,F)}async pickFileAndOpen(F,H){const J=await this.c.pickFile(H);J&&await this.w(J.map(le=>({fileUri:y.URI.file(le)})),H,F)}async pickWorkspaceAndOpen(F,H){const J=await this.c.pickWorkspace(H);J&&await this.w(J.map(le=>({workspaceUri:y.URI.file(le)})),H,F)}async w(F,H,J){await this.a.open({context:3,contextWindowId:J,cli:this.g.args,urisToOpen:F,forceNewWindow:H.forceNewWindow})}async showItemInFolder(F,H){O.shell.showItemInFolder(H)}async setRepresentedFilename(F,H,J){this.C(J?.targetWindowId,F)?.setRepresentedFilename(H)}async setDocumentEdited(F,H,J){this.C(J?.targetWindowId,F)?.setDocumentEdited(H)}async openExternal(F,H){return this.g.unsetSnapExportedVariables(),O.shell.openExternal(H),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,H){return O.shell.trashItem(H)}async isAdmin(){let F;return v.$i?F=(await new Promise((H,J)=>{Y(["native-is-elevated"],H,J)}))():F=process.getuid?.()===0,F}async writeElevated(F,H,J,le){const re=await new Promise((ue,Z)=>{Y(["@vscode/sudo-prompt"],ue,Z)});return new Promise((ue,Z)=>{const X=[`"${this.z}"`];le?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${H.fsPath}"`,`"${J.fsPath}"`);const q={name:this.j.nameLong.replace("-",""),icns:v.$j&&this.g.isBuilt?(0,b.$jc)((0,b.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};re.exec(X.join(" "),q,(L,T,G)=>{T&&this.h.trace(`[sudo-prompt] received stdout: ${T}`),G&&this.h.trace(`[sudo-prompt] received stderr: ${G}`),L?Z(L):ue(void 0)})})}async isRunningUnderARM64Translation(){return v.$k||v.$i?!1:O.app.runningUnderARM64Translation}get z(){return v.$i?this.g.isBuilt?(0,b.$jc)((0,b.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,b.$jc)(this.g.appRoot,"scripts","code-cli.bat"):v.$k?this.g.isBuilt?(0,b.$jc)((0,b.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,b.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,b.$jc)(this.g.appRoot,"bin","code"):(0,b.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return m.$an.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return v.$i&&(0,A.$f$b)()}async killProcess(F,H,J){process.kill(H,J)}async readClipboardText(F,H){return O.clipboard.readText(H)}async writeClipboardText(F,H,J){return O.clipboard.writeText(H,J)}async readClipboardFindText(F){return O.clipboard.readFindText()}async writeClipboardFindText(F,H){return O.clipboard.writeFindText(H)}async writeClipboardBuffer(F,H,J,le){return O.clipboard.writeBuffer(H,Buffer.from(J.buffer),le)}async readClipboardBuffer(F,H){return w.$ke.wrap(O.clipboard.readBuffer(H))}async hasClipboard(F,H,J){return O.clipboard.has(H,J)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){O.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){O.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){O.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){O.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){O.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,H){this.D(F)?.updateTouchBar(H)}async notifyReady(F){this.D(F)?.setReady()}async relaunch(F,H){return this.f.relaunch(H)}async reload(F,H){const J=this.D(F);if(J){if((0,n.$ki)(J.openedWorkspace)){const le=J.openedWorkspace.configPath;if(le.scheme===u.Schemas.file&&(await this.n.resolveLocalWorkspace(le))?.transient)return this.openWindow(J.id,{forceReuseWindow:!0})}return this.f.reload(J,H?.disableExtensions!==void 0?{_:[],"disable-extensions":H.disableExtensions}:void 0)}}async closeWindow(F,H){return this.C(H?.targetWindowId,F)?.win?.close()}async quit(F){const H=this.a.getLastActiveWindow();H?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&H.win?H.win.close():this.f.quit()}async exit(F,H){await this.f.kill(H)}async resolveProxy(F,H){return this.D(F)?.win?.webContents?.session?.resolveProxy(H)}async loadCertificates(F){return(await new Promise((J,le)=>{Y(["@vscode/proxy-agent"],J,le)})).loadSystemCertificates({log:this.h})}findFreePort(F,H,J,le,re=1){return(0,k.$tg)(H,J,le,re)}async openDevTools(F,H){this.C(H?.targetWindowId,F)?.win?.webContents.openDevTools(H?.mode?{mode:H.mode,activate:H.activate}:void 0)}async toggleDevTools(F,H){this.C(H?.targetWindowId,F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,H,J){const le=this.D(F);if(!le||!le.win)throw new Error;return await new I.$g$b(le.win,H,this.h).inspect(J)}async windowsGetStringRegKey(F,H,J,le){if(!v.$i)return;const re=await new Promise((ue,Z)=>{Y(["@vscode/windows-registry"],ue,Z)});try{return re.GetStringRegKey(H,J,le)}catch{return}}C(F,H){return this.D(F)??this.F(F)??this.D(H)}D(F){if(typeof F=="number")return this.a.getWindowById(F)}F(F){if(typeof F=="number")return this.b.getWindowById(F)}};e.$k$b=j,ve([D.$zh],j.prototype,"z",null),e.$k$b=j=ve([se(0,i.$w0b),se(1,E.$h$b),se(2,l.$r0b),se(3,a.$P0b),se(4,f.$l0b),se(5,t.$pj),se(6,o.$Hj),se(7,r.$u0b),se(8,c.$I0b)],j)}),define(ae[299],ce([0,1,15,26,8,23,33,2,13,4,7,109,37,180,91,133,56,24,5,70,79,27,80,34,61,55,29]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f,$,a,t,o,r,i,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$l$b=void 0;const w="issue.processExplorerWindowState";let A=class{static{c=this}static{this.a="#1E1E1E"}constructor(C,j,U,F,H,J,le,re,ue,Z,X){this.g=C,this.h=j,this.i=U,this.j=F,this.k=H,this.l=J,this.m=le,this.n=re,this.o=ue,this.p=Z,this.q=X,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){y.$VU.on("vscode:listProcesses",async C=>{const j=[];try{j.push({name:(0,h.localize)(0,null),rootProcess:await(0,v.$7r)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(F=>{(0,m.$Mm)(F)?j.push({name:F.hostName,rootProcess:F}):F.processes&&j.push({name:F.hostName,rootProcess:F.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(C,"vscode:listProcessesResponse",j)}),y.$VU.on("vscode:workbenchCommand",(C,j)=>{const{id:U,from:F,args:H}=j;let J;switch(F){case"processExplorer":J=this.f;break;default:throw new Error(`Unexpected command source: ${F}`)}J?.webContents.send("vscode:runAction",{id:U,from:F,args:H})}),y.$VU.on("vscode:closeProcessExplorer",C=>{this.d?.close()}),y.$VU.on("vscode:pidToNameRequest",async C=>{const j=await this.k.getMainDiagnostics(),U=[];for(const F of j.windows)U.push([F.pid,`window [${F.id}] (${F.title})`]);for(const{pid:F,name:H}of r.$30b.getAll())U.push([F,H]);this.t(C,"vscode:pidToNameResponse",U)})}async openReporter(C){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const j=new P.$Sc,U=j.add(this.n.createIPCObjectUrl()),F=this.v(this.c,700,800);this.b=this.u(F,U,{backgroundColor:C.styles.backgroundColor,title:(0,h.localize)(1,null),zoomLevel:C.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:C,disableExtensions:!!this.h.disableExtensions,os:{type:(0,O.type)(),arch:(0,O.arch)(),release:(0,O.release)()},product:$.default}),this.b.loadURL(d.$pg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(C){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const j=new P.$Sc,U=j.add(this.n.createIPCObjectUrl()),F=this.p.getItem(w,void 0),H=I(F)?F:this.v(this.f,800,500);this.d=this.u(H,U,{backgroundColor:C.styles.backgroundColor,title:(0,h.localize)(2,null),zoomLevel:C.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:C,product:$.default}),this.d.loadURL(d.$pg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const J=()=>{if(!this.d)return;const le=this.d.getSize(),re=this.d.getPosition();if(!le||!re)return;const ue={width:le[0],height:le[1],x:re[0],y:re[1]};this.p.setItem(w,ue)};this.d.on("moved",J),this.d.on("resized",J)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const C=await S.contentTracing.stopRecording(`${(0,D.$eg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null,C),buttons:[(0,h.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,C)}async getSystemStatus(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(C,j)}async $getSystemInfo(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(C,j)}async $getPerformanceInfo(){try{const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(C,j)}catch(C){throw this.i.warn("issueService#getPerformanceInfo ",C.message),C}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(C){this.i.error(C)}}async $showConfirmCloseDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,h.localize)(6,null),buttons:[(0,h.localize)(7,null),(0,h.localize)(8,null)]},this.b);C===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,h.localize)(9,null),buttons:[(0,h.localize)(10,null),(0,h.localize)(11,null)]},this.b);return C===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const C=this.q.getWindowById(this.c.id);if(!C)throw new Error("Window not found");return C}async $getIssueReporterUri(C){const j=this.issueReporterWindowCheck(),U=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return s.Promises.withAsyncBody(async(F,H)=>{const J=new M.$7d;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",J.token,{replyChannel:U,extensionId:C}),y.$VU.once(U,(le,re)=>{F(b.URI.parse(re))});try{await(0,s.$9g)(5e3),J.cancel(),H(new Error("Timed out waiting for issue reporter URI"))}finally{y.$VU.removeHandler(U)}})}async $getIssueReporterData(C){const j=this.issueReporterWindowCheck(),U=`vscode:triggerIssueDataProviderResponse${j.id}`;return s.Promises.withAsyncBody(async F=>{const H=new M.$7d;j.sendWhenReady("vscode:triggerIssueDataProvider",H.token,{replyChannel:U,extensionId:C}),y.$VU.once(U,(J,le)=>{F(le)});try{await(0,s.$9g)(5e3),H.cancel(),F("Error: Extension timed out waiting for issue reporter data")}finally{y.$VU.removeHandler(U)}})}async $getIssueReporterTemplate(C){const j=this.issueReporterWindowCheck(),U=`vscode:triggerIssueDataTemplateResponse${j.id}`;return s.Promises.withAsyncBody(async F=>{const H=new M.$7d;j.sendWhenReady("vscode:triggerIssueDataTemplate",H.token,{replyChannel:U,extensionId:C}),y.$VU.once(U,(J,le)=>{F(le)});try{await(0,s.$9g)(5e3),H.cancel(),F("Error: Extension timed out waiting for issue reporter template")}finally{y.$VU.removeHandler(U)}})}async $getReporterStatus(C,j){const U=[!1,!1],F=this.issueReporterWindowCheck(),H="vscode:triggerReporterStatus",J=new M.$7d;return F.sendWhenReady(H,J.token,{replyChannel:H,extensionId:C,extensionName:j}),await(0,s.$Yg)(new Promise(re=>y.$VU.once("vscode:triggerReporterStatusResponse",(ue,Z)=>re(Z))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),J.cancel()})??U}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(C){C.isMinimized()&&C.restore(),C.focus()}t(C,j,...U){C.sender.isDestroyed()||C.sender.send(j,...U)}u(C,j,U,F){const H=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:C.width,height:C.height,minWidth:300,minHeight:200,x:C.x,y:C.y,title:U.title,backgroundColor:U.backgroundColor||c.a,webPreferences:{preload:d.$pg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$1C)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return H.setMenuBarVisibility(!1),H}v(C,j,U){let F;const H=S.screen.getAllDisplays();if(H.length===1)F=H[0];else{if(u.$j){const re=S.screen.getCursorScreenPoint();F=S.screen.getDisplayNearestPoint(re)}!F&&C&&(F=S.screen.getDisplayMatching(C.getBounds())),F||(F=S.screen.getPrimaryDisplay()||H[0])}const J=F.bounds,le={width:j,height:U,x:J.x+J.width/2-j/2,y:J.y+J.height/2-U/2};return J.width>0&&J.height>0&&(le.x<J.x&&(le.x=J.x),le.y<J.y&&(le.y=J.y),le.x>J.x+J.width&&(le.x=J.x),le.y>J.y+J.height&&(le.y=J.y),le.width>J.width&&(le.width=J.width),le.height>J.height&&(le.height=J.height)),le}};e.$l$b=A,e.$l$b=A=c=ve([se(1,g.$l0b),se(2,l.$pj),se(3,m.$Lm),se(4,p.$60b),se(5,k.$r0b),se(6,f.$j$b),se(7,t.$t0b),se(8,a.$Hj),se(9,o.$PO),se(10,n.$w0b)],A);function I(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(ae[300],ce([0,1,23,18,24,20,5,70,27,53,28,49,101]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M$b=void 0;let h=class extends y.$K$b{constructor(p,k,g,l,f,$,a,t){super(p,k,l,f,$,t),this.e=g,this.u=a}s(p){return(0,y.$J$b)(`linux-${process.arch}`,p,this.k)}t(p){this.a&&(this.d(v.$TV.CheckingForUpdates(p)),this.i.request({url:this.a},S.CancellationToken.None).then(u.$pp).then(k=>{!k||!k.url||!k.version||!k.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!p}),this.d(v.$TV.Idle(1))):this.d(v.$TV.AvailableForDownload(k))}).then(void 0,k=>{this.j.error(k);const g=p?k.message||k:void 0;this.d(v.$TV.Idle(1,g))}))}async o(p){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):p.update.url&&this.u.openExternal(void 0,p.update.url),this.d(v.$TV.Idle(1))}};e.$M$b=h,e.$M$b=h=ve([se(0,M.$P0b),se(1,O.$Bi),se(2,b.$wl),se(3,s.$l0b),se(4,u.$jp),se(5,D.$pj),se(6,P.$j$b),se(7,d.$Hj)],h)}),define(ae[301],ce([0,1,48,46,26,8,23,50,45,9,7,144,21,18,24,16,20,5,70,27,53,28,49,101]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f,$,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O$b=void 0;async function r(w,A=1e3){for(;!w();)await(0,M.$9g)(A)}let i;function n(){return typeof i>"u"&&(i=O.existsSync(u.$jc(u.$mc(process.execPath),"unins000.exe"))?0:1),i}let c=class extends o.$K$b{get cachePath(){const A=u.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return y.Promises.mkdir(A,{recursive:!0}).then(()=>A)}constructor(A,I,E,C,j,U,F,H,J){super(A,I,C,j,U,J),this.u=E,this.v=F,this.w=H,A.setRelaunchHandler(this)}handleRelaunch(A){return A?.addArgs||A?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$TV.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(A){let I=`win32-${process.arch}`;return n()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$J$b)(I,A,this.k)}t(A){this.a&&(this.d(t.$TV.CheckingForUpdates(A)),this.i.request({url:this.a},D.CancellationToken.None).then($.$pp).then(I=>{const E=n();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!A}),this.d(t.$TV.Idle(E)),Promise.resolve(null)):E===1?(this.d(t.$TV.AvailableForDownload(I)),Promise.resolve(null)):(this.d(t.$TV.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(C=>y.Promises.exists(C).then(j=>{if(j)return Promise.resolve(C);const U=`${C}.tmp`;return this.i.request({url:I.url},D.CancellationToken.None).then(F=>this.v.writeFile(b.URI.file(U),F.stream)).then(I.sha256hash?()=>(0,v.$QU)(U,I.sha256hash):()=>{}).then(()=>y.Promises.rename(U,C,!1)).then(()=>C)})).then(C=>{const j=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:C},j?this.k.target==="user"?this.p():this.d(t.$TV.Downloaded(I)):this.d(t.$TV.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,d.$Vi)(String(I)))}),this.j.error(I);const E=A?I.message||I:void 0;this.d(t.$TV.Idle(n(),E))}))}async o(A){A.update.url&&this.w.openExternal(void 0,A.update.url),this.d(t.$TV.Idle(n()))}async B(A){const I=await this.cachePath;return u.$jc(I,`CodeSetup-${this.k.quality}-${A}.exe`)}async C(A=null){const I=A?U=>!new RegExp(`${this.k.quality}-${A}\\.exe$`).test(U):()=>!0,E=await this.cachePath,j=(await y.Promises.readdir(E)).filter(I).map(async U=>{try{await y.Promises.unlink(u.$jc(E,U))}catch{}});await Promise.all(j)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const A=this.state.update;this.d(t.$TV.Updating(A));const I=await this.cachePath;this.e.updateFilePath=u.$jc(I,`CodeSetup-${this.k.quality}-${A.version}.flag`),await y.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$TV.Idle(n()))});const C=`${this.k.win32MutexName}-ready`,j=await new Promise((U,F)=>{Y(["@vscode/windows-mutex"],U,F)});r(()=>j.isActive(C)).then(()=>this.d(t.$TV.Ready(A)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?O.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(A){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),E={version:"unknown",productVersion:"unknown"};this.d(t.$TV.Downloading(E)),this.e={packagePath:A},I?this.k.target==="user"?this.p():this.d(t.$TV.Downloaded(E)):this.d(t.$TV.Ready(E))}};e.$O$b=c,ve([P.$zh],c.prototype,"cachePath",null),e.$O$b=c=ve([se(0,k.$P0b),se(1,h.$Bi),se(2,a.$wl),se(3,m.$l0b),se(4,$.$jp),se(5,g.$pj),se(6,p.$sk),se(7,l.$j$b),se(8,f.$Hj)],c)}),define(ae[134],ce([0,1,15,8,23,51,3,2,13,67,4,7,190,26,65,18,56,24,64,16,20,5,27,80,252,82,28,104,69,55,29,30,58,96,39,34,57,68,22,6]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f,$,a,t,o,r,i,n,c,w,A,I,E,C,j,U,F,H,J,le,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N0b=e.$M0b=void 0;var ue;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(ue||(ue={}));class Z extends P.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(D.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(D.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(D.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(D.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(D.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(D.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const T=!(0,A.$WC)(this.r);if(b.$j&&T&&L.setSheetOffset((0,b.$J)((0,h.release)())?28:22),T&&(b.$i&&(0,A.$YC)(this.r)||b.$j)){const G=this.s.getItem(Z.C);G&&this.updateWindowControls({height:G})}b.$i&&T&&L.hookWindowMessage(278,()=>{const[B,oe]=L.getPosition(),he=S.screen.getCursorScreenPoint(),K=he.x-B,R=he.y-oe;return!(K>30&&R>=0&&R<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:K,y:R})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),b.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.G?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.G?.complete(!0)})))}constructor(L,T,G,B){super(),this.r=L,this.s=T,this.t=G,this.u=B,this.a=this.B(new D.$Wd),this.onDidClose=this.a.event,this.b=this.B(new D.$Wd),this.onDidMaximize=this.b.event,this.c=this.B(new D.$Wd),this.onDidUnmaximize=this.c.event,this.f=this.B(new D.$Wd),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new D.$Wd),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new D.$Wd),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.D=(0,A.$YC)(this.r),this.F=void 0,this.G=void 0}setRepresentedFilename(L){b.$j?this.win?.setRepresentedFilename(L):this.w=L}getRepresentedFilename(){return b.$j?this.win?.getRepresentedFilename():this.w}setDocumentEdited(L){b.$j&&this.win?.setDocumentEdited(L),this.z=L}isDocumentEdited(){return b.$j?!!this.win?.isDocumentEdited():!!this.z}focus(L){b.$j&&L?.force&&S.app.focus({steal:!0});const T=this.win;T&&(T.isMinimized()&&T.restore(),T.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(b.$j)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.C="windowControlHeight"}updateWindowControls(L){const T=this.win;if(T){if(L.height&&this.s.setItem(X.C,L.height),b.$i&&this.D)T.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(b.$j&&L.height!==void 0){const G=(L.height-15)/2;G?T.setWindowButtonPosition({x:G,y:G}):T.setWindowButtonPosition(null)}}}toggleFullScreen(){this.H(!this.isFullScreen,!1)}H(L,T){(0,A.$ZC)(this.r)?this.I(L,T):this.L(L)}get isFullScreen(){if(b.$j&&typeof this.F=="boolean")return this.F;const L=this.win,T=L?.isFullScreen(),G=L?.isSimpleFullScreen();return!!(T||G)}I(L,T){const G=this.win;G?.isSimpleFullScreen()&&G?.setSimpleFullScreen(!1),this.J(L,T)}J(L,T){if(b.$j){this.F=L;const B=this.G=new O.$sh;(async()=>{const oe=await Promise.race([B.p,(0,O.$9g)(1e4).then(()=>!1)]);this.G===B&&(this.F=void 0,this.G=void 0,!oe&&L&&T&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}L(L){const T=this.win;T?.isFullScreen()&&this.J(!1,!1),T?.setSimpleFullScreen(L),T?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$M0b=Z;let X=class extends Z{get id(){return this.P}get backupPath(){return this.R?.backupPath}get openedWorkspace(){return this.R?.workspace}get profile(){if(!this.config)return;const L=this.gb.profiles.find(T=>T.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.gb.getProfileForWorkspace(this.config.workspace??(0,E.$ji)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.R?.remoteAuthority}get config(){return this.R}get isExtensionDevelopmentHost(){return!!this.R?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.R?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.R?.debugId}constructor(L,T,G,B,oe,he,K,R,W,x,N,Q,V,_,z,ee,ne,de,me,Ee,Pe){super(x,Ee,B,T),this.eb=G,this.fb=oe,this.gb=he,this.hb=K,this.ib=R,this.jb=W,this.kb=N,this.lb=Q,this.mb=V,this.nb=_,this.ob=z,this.pb=ee,this.qb=ne,this.rb=de,this.sb=me,this.M=this.B(new D.$Wd),this.onWillLoad=this.M.event,this.N=this.B(new D.$Wd),this.onDidSignalReady=this.N.event,this.O=this.B(new D.$Wd),this.onDidDestroy=this.O.event,this.W=[],this.X=[],this.Y=void 0,this.Z=void 0,this.$=void 0,this.ab=this.B(this.rb.createIPCObjectUrl()),this.db=!1,this.tb=0;{const[Le,ke]=this.Db(L.state);this.S=Le,this.u.trace("window#ctor: using window state",Le);const pe=this.S.mode===0||this.S.mode===3,te=Pe.invokeFunction(I.$x0b,this.S,{show:!pe,webPreferences:{preload:d.$pg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.ab.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,u.mark)("code/willCreateCodeBrowserWindow"),this.m=new S.BrowserWindow(te),(0,u.mark)("code/didCreateCodeBrowserWindow"),this.P=this.m.id,this.n(this.m);const fe=this.r.getValue("window"),$e=b.$j&&fe?.nativeTabs===!0;(b.$j||b.$i)&&ke&&(!$e||S.BrowserWindow.getAllWindows().length===1)&&[this.S.width,this.S.height,this.S.x,this.S.y].every(Ie=>typeof Ie=="number")&&this.m.setBounds({width:this.S.width,height:this.S.height,x:this.S.x,y:this.S.y}),pe&&((0,u.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.S.mode===3&&this.H(!0,!0),this.m.show(),(0,u.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Jb(),this.ub()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.P})`),this.tb=2;this.W.length;)this.W.pop()(this);this.N.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.W.push(L)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(L=>{function T(){G.dispose(),B.dispose(),L()}const G=this.onDidClose(()=>T()),B=this.onWillLoad(()=>T())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(T,G)=>this.xb(2,{...G})),this.m.webContents.on("did-fail-load",(T,G,B)=>this.xb(3,{reason:B,exitCode:G})),this.m.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.bb&&(this.R=this.bb,this.bb=void 0)}),this.B(this.onDidMaximize(()=>{this.R&&(this.R.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.R&&(this.R.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(T=>this.Ab(T))),this.B(this.lb.onDidDeleteUntitledWorkspace(T=>this.zb(T)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(T,G)=>{const B=await this.wb();G({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,B)})})}wb(){return this.vb||(this.vb=(0,r.$Dp)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(L,T){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:L,reason:T?.reason,code:T?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:B}=await this.ob.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null),(0,y.localize)(2,null)],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),checkboxLabel:this.R?.workspace?(0,y.localize)(5,null):void 0},this.m);if(G!==2){const oe=G===0;await this.yb(oe,B)}}else if(L===2){let G;T?G=(0,y.localize)(7,null,T.reason,T.exitCode??"<unknown>"):G=(0,y.localize)(6,null);const{response:B,checkboxChecked:oe}=await this.ob.showMessageBox({type:"warning",buttons:[this.R?.workspace?(0,y.localize)(8,null):(0,y.localize)(9,null),(0,y.localize)(10,null)],message:G,detail:this.R?.workspace?(0,y.localize)(11,null):(0,y.localize)(12,null),checkboxLabel:this.R?.workspace?(0,y.localize)(13,null):void 0},this.m),he=B===0;await this.yb(he,oe)}break}}async yb(L,T){const G=this.R?.workspace;if(T&&G)try{const B=this.jb.workspaceStorage(G);await B.init(),B.delete("memento/workbench.parts.editor"),await B.close()}catch(B){this.u.error(B)}this.O.fire();try{if(L&&this.R){let B,oe;(0,E.$fi)(G)?B={folderUri:G.uri}:(0,E.$ki)(G)?B={workspaceUri:G.configPath}:oe=!0,(0,le.$Ob)(await this.sb.open({context:5,userEnv:this.R.userEnv,cli:{...this.t.args,_:[]},urisToOpen:B?[B]:void 0,forceEmpty:oe,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(L){this.R?.workspace?.id===L.id&&(this.R.workspace=void 0)}Ab(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const T=this.Fb();T!==this.U&&(this.U=T,this.Gb(T))}if(!L||L.affectsConfiguration("http.proxy")){let T=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.Y||G!==this.Z)){this.Y=T,this.Z=G;const B=T||"",oe=G?`${G},<local>`:"<local>";this.u.trace(`Setting proxy to '${B}', bypassing '${oe}'`),this.m.webContents.session.setProxy({proxyRules:B,proxyBypassRules:oe,pacScript:""})}}}addTabbedWindow(L){b.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,T=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.P})`),this.isDocumentEdited()&&(!T.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(L,T),this.tb===0?this.R=L:this.bb=L,this.tb=1,this.m.loadURL(d.$pg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.db;this.db=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new O.$hh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.M.fire({workspace:L.workspace,reason:T.isReload?3:G?2:1})}Bb(L,T){const G=(this.R??this.bb)?.userEnv;if(G){const B=(0,l.$8l)(G)&&!(0,l.$8l)(L.userEnv),oe=this.isExtensionDevelopmentHost;(B||oe)&&(L.userEnv={...G,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(L["disable-extensions"]=T.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.kb.getWindowSplash(),L.zoomLevel=this.Ib(),L.isCustomZoomLevel=typeof this.$=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,u.mark)("code/willOpenNewWindow"),L.perfMarks=(0,u.getMarks)(),this.ab.update(L)}async reload(L){const T=Object.assign({},this.R);T.workspace=await this.Cb(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&L&&(T.verbose=L.verbose,T.debugId=L.debugId,T.extensionEnvironment=L.extensionEnvironment,T["inspect-extensions"]=L["inspect-extensions"],T["inspect-brk-extensions"]=L["inspect-brk-extensions"],T["extensions-dir"]=L["extensions-dir"]),T.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),T.isInitialStartup=!1,T.policiesData=this.fb.serialize(),T.continueOn=this.t.continueOn,T.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},T.logLevel=this.eb.getLogLevel(),T.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(T,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Cb(L){if((0,E.$ki)(L.workspace)){const T=L.workspace.configPath;if(T.scheme===d.Schemas.file&&!await this.hb.exists(T))return}else if((0,E.$fi)(L.workspace)){const T=L.workspace.uri;if(T.scheme===d.Schemas.file&&!await this.hb.exists(T))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,j.$k0b)();if(this.isFullScreen){let G;try{G=S.screen.getDisplayMatching(this.getBounds())}catch{}const B=(0,j.$k0b)();return{mode:3,display:G?G.id:void 0,width:this.S.width||B.width,height:this.S.height||B.height,x:this.S.x||0,y:this.S.y||0,zoomLevel:this.$}}const L=Object.create(null);let T;if(!b.$j&&this.m.isMaximized()?T=0:T=1,T===0?L.mode=0:L.mode=1,T===1||T===0){let G;T===1?G=this.getBounds():G=this.m.getNormalBounds(),L.x=G.x,L.y=G.y,L.width=G.width,L.height=G.height}return L.zoomLevel=this.$,L}Db(L){(0,u.mark)("code/willRestoreCodeWindowState");let T=!1;if(L){this.$=L.zoomLevel;try{const G=S.screen.getAllDisplays();T=G.length>1,L=I.WindowStateValidator.validateWindowState(this.u,L,G)}catch(G){this.u.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}}return(0,u.mark)("code/didRestoreCodeWindowState"),[L||(0,j.$k0b)(),T]}getBounds(){const[L,T]=this.m.getPosition(),[G,B]=this.m.getSize();return{x:L,y:T,width:G,height:B}}H(L,T){super.H(L,T),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.U&&this.Gb(this.U,!1)}Fb(){let L=(0,A.$UC)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Gb(L,T=!0){b.$j||(L==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,y.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Hb(L)}):this.Hb(L))}Hb(L){const T=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!T),this.m.autoHideMenuBar=T;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.$=L}Ib(){return typeof this.$=="number"?this.$:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,T,...G){this.isReady?this.send(L,...G):this.ready().then(()=>{T.isCancellationRequested||this.send(L,...G)})}send(L,...T){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...T)}catch(G){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.P}: ${(0,M.$Si)(G)}`)}}}updateTouchBar(L){b.$j&&this.X.forEach((T,G)=>{const B=L[G];T.segments=this.Lb(B)})}Jb(){if(b.$j){for(let L=0;L<10;L++){const T=this.Kb();this.X.push(T)}this.m.setTouchBar(new S.TouchBar({items:this.X}))}}Kb(L=[]){const T=this.Lb(L),G=new S.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:B=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:G.segments[B].id,from:"touchbar"})}});return G}Lb(L=[]){return L.map(G=>{let B;G.icon&&!c.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===d.Schemas.file&&(B=S.nativeImage.createFromPath(v.URI.revive(G.icon.dark).fsPath),B.isEmpty()&&(B=void 0));let oe;return typeof G.title=="string"?oe=G.title:oe=G.title.value,{id:G.id,label:B?void 0:oe,icon:B}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$N0b=X,e.$N0b=X=ve([se(1,a.$pj),se(2,J.$K0b),se(3,g.$l0b),se(4,U.$Mn),se(5,H.$z0b),se(6,f.$sk),se(7,i.$X0b),se(8,i.$V0b),se(9,p.$Bi),se(10,w.$u0b),se(11,C.$I0b),se(12,m.$q0b),se(13,n.$wl),se(14,k.$r0b),se(15,$.$P0b),se(16,t.$Hj),se(17,o.$t0b),se(18,I.$w0b),se(19,F.$PO),se(20,re.$7h)],X)}),define(ae[302],ce([0,1,15,4,18,24,20,5,34,55,134]),function(Y,e,S,O,s,M,D,P,d,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O0b=void 0;let v=class extends b.$M0b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(h,m,p,k,g,l){super(k,g,m,p),this.M=h,this.N=l,this.id=this.M.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.M.isDestroyed())return;const h=S.BrowserWindow.fromWebContents(this.M);h&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(h),h.setMenu(null),(O.$i||O.$k)&&(0,u.$WC)(this.r)&&h.setAutoHideMenuBar(!0),this.N.registerAuxWindow(this))}};e.$O0b=v,e.$O0b=v=ve([se(1,M.$l0b),se(2,P.$pj),se(3,s.$Bi),se(4,d.$PO),se(5,D.$P0b)],v)}),define(ae[303],ce([0,1,15,3,2,13,37,302,6,5,29]),function(Y,e,S,O,s,M,D,P,d,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h_b=void 0;let v=class extends s.$Tc{constructor(h,m){super(),this.h=h,this.j=m,this.a=this.B(new O.$Wd),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new O.$Wd),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new O.$Wd),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new O.$Wd),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){S.app.on("browser-window-created",(h,m)=>{const p=this.getWindowById(m.id);p&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow())}),D.$VU.handle("vscode:registerAuxiliaryWindow",async(h,m)=>{const p=this.getWindowById(h.sender.id);return p&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=m),h.sender.id})}createWindow(h){return this.h.invokeFunction(b.$x0b,this.n(h),{webPreferences:{preload:M.$pg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}n(h){const m={},p=h.features.split(",");for(const k of p){const[g,l]=k.split("=");switch(g){case"width":m.width=parseInt(l,10);break;case"height":m.height=parseInt(l,10);break;case"left":m.x=parseInt(l,10);break;case"top":m.y=parseInt(l,10);break}}return b.WindowStateValidator.validateWindowState(this.j,m)}registerWindow(h){const m=new s.$Sc,p=this.h.createInstance(P.$O0b,h);this.g.set(p.id,p),m.add((0,s.$Rc)(()=>this.g.delete(p.id))),m.add(p.onDidMaximize(()=>this.a.fire(p))),m.add(p.onDidUnmaximize(()=>this.b.fire(p))),m.add(p.onDidEnterFullScreen(()=>this.c.fire({window:p,fullscreen:!0}))),m.add(p.onDidLeaveFullScreen(()=>this.c.fire({window:p,fullscreen:!1}))),m.add(p.onDidTriggerSystemContextMenu(({x:k,y:g})=>this.f.fire({window:p,x:k,y:g}))),O.Event.once(p.onDidClose)(()=>m.dispose())}getWindowById(h){return this.g.get(h)}getFocusedWindow(){const h=S.BrowserWindow.getFocusedWindow();if(h)return this.getWindowById(h.id)}getLastActiveWindow(){return(0,b.$y0b)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$h_b=v,e.$h_b=v=ve([se(0,d.$7h),se(1,u.$pj)],v)}),define(ae[83],ce([0,1,15,22,8,3,47,2,13,4,19,7,21,193,6,20,5,82,98,30,58,31,56]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f,$,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$w$b=e.$v$b=void 0,e.$v$b=(0,m.$8h)("workspacesHistoryMainService");let r=class extends P.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(n,c,w,A,I){super(),this.f=n,this.g=c,this.h=w,this.j=A,this.m=I,this.c=this.B(new M.$Wd),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new s.$6g(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let c=[],w=[];for(const I of n)if((0,l.$8cb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(c,I.workspace)&&c.push(I);else if((0,l.$9cb)(I))this.y(c,I.folderUri)||c.push(I);else{const E=this.z(w,I.fileUri),C=I.fileUri.scheme===d.Schemas.file&&o.G.indexOf((0,b.$Fg)(I.fileUri))>=0;!E&&!C&&(w.push(I),u.$i&&I.fileUri.scheme===d.Schemas.file&&S.app.addRecentDocument(I.fileUri.fsPath))}const A=await this.r({workspaces:c,files:w});c=A.workspaces,w=A.files,c.length>o.a&&(c.length=o.a),w.length>o.a&&(w.length=o.a),await this.t({workspaces:c,files:w}),this.c.fire(),u.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(n){const c=E=>{const C=this.u(E);for(const j of n)if(b.$zg.isEqual(j,C))return!1;return!0},w=await this.getRecentlyOpened(),A=w.workspaces.filter(c),I=w.files.filter(c);(A.length!==w.workspaces.length||I.length!==w.files.length)&&(await this.t({files:I,workspaces:A}),this.c.fire(),u.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:c}=await this.m.showMessageBox({type:"warning",buttons:[(0,h.localize)(0,null),(0,h.localize)(1,null)],message:(0,h.localize)(2,null),detail:(0,h.localize)(3,null),cancelId:1});if(c!==0)return}await this.t({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(n){const c=new a.$Ac(I=>b.$zg.getComparisonKey(I));if(n?.workspaces)for(const I of n.workspaces)c.set(this.u(I),I);const w=new a.$Ac(I=>b.$zg.getComparisonKey(I));if(n?.files)for(const I of n.files)w.set(this.u(I),I);const A=await this.s();for(const I of A.workspaces){const E=c.get(this.u(I));E?E.label=E.label??I.label:c.set(this.u(I),I)}for(const I of A.files){const E=w.get(this.u(I));E?E.label=E.label??I.label:w.set(this.u(I),I)}return{workspaces:[...c.values()],files:[...w.values()]}}async s(){await this.j.whenReady;let n;const c=this.j.get(o.b,-1);if(typeof c=="string")try{n=JSON.parse(c)}catch(w){this.f.error("Unexpected error parsing opened paths list",w)}return(0,l.$cdb)(n,this.f)}async t(n){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,l.$ddb)(n)),-1,1)}u(n){return(0,l.$9cb)(n)?n.folderUri:(0,l.$0cb)(n)?n.fileUri:n.workspace.configPath}w(n,c){return!!n.find(w=>(0,l.$8cb)(w)&&w.workspace.id===c.id)}y(n,c){return!!n.find(w=>(0,l.$9cb)(w)&&b.$zg.isEqual(w.folderUri,c))}z(n,c){return!!n.find(w=>b.$zg.isEqual(w.fileUri,c))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){u.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!u.$i)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(4,null),description:(0,h.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const c=[];for(const I of S.app.getJumpListSettings().removedItems){const E=I.args;if(E){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(E);C&&c.push(v.URI.parse(C[2]))}}await this.removeRecentlyOpened(c);let w=!1;const A=(0,O.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const E=(0,l.$8cb)(I)?I.workspace:I.folderUri,{title:C,description:j}=this.L(E,I.label);let U;return v.URI.isUri(E)?U=`--folder-uri "${E.toString()}"`:(w=!0,U=`--file-uri "${E.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:j.substr(0,255),program:process.execPath,args:U,iconPath:"explorer.exe",iconIndex:0}}));A.length>0&&n.push({type:"custom",name:w?(0,h.localize)(6,null):(0,h.localize)(7,null),items:A})}n.push({type:"recent"});try{const c=S.app.setJumpList(n);c&&c!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${c}`)}catch(c){this.f.warn("updateWindowsJumpList#setJumpList",c)}}L(n,c){if(c)return{title:(0,D.$7v)(c).name,description:c};if(v.URI.isUri(n))return{title:(0,b.$Fg)(n),description:this.M(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,h.localize)(8,null),description:""};let w=(0,b.$Fg)(n.configPath);return w.endsWith(f.$ri)&&(w=w.substr(0,w.length-f.$ri.length-1)),{title:(0,h.localize)(9,null,w),description:this.M(n.configPath)}}M(n){return n.scheme==="file"?(0,D.$Yv)(n.fsPath):n.toString()}async N(){if(!u.$j)return;S.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),c=[];let w=0;for(let I=0;I<n.workspaces.length&&w<o.C;I++){const E=this.u(n.workspaces[I]);if(E.scheme===d.Schemas.file){const C=(0,b.$wg)(E);await y.Promises.exists(C)&&(c.push(C),w++)}}const A=[];for(let I=0;I<n.files.length&&w<o.D;I++){const E=this.u(n.files[I]);if(E.scheme===d.Schemas.file){const C=(0,b.$wg)(E);if(o.G.includes((0,b.$Fg)(E))||c.includes(C))continue;await y.Promises.exists(C)&&(A.push(C),w++)}}A.reverse().forEach(I=>S.app.addRecentDocument(I)),c.reverse().forEach(I=>S.app.addRecentDocument(I))}};e.$w$b=r,e.$w$b=r=o=ve([se(0,k.$pj),se(1,$.$I0b),se(2,p.$P0b),se(3,g.$X0b),se(4,t.$r0b)],r)}),define(ae[304],ce([0,1,15,8,23,47,4,7,181,78,18,24,20,5,231,70,27,34,28,49,55,29,83]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f,$,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$x$b=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(w,A,I,E,C,j,U,F,H,J,le,re){this.n=w,this.o=A,this.p=I,this.q=E,this.r=C,this.s=j,this.t=U,this.u=F,this.v=H,this.w=J,this.x=le,this.y=re,this.m=Object.create(null),this.g=new O.$hh(()=>this.F(),0),this.h=new O.$hh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$j||(0,$.$WC)(A))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const w=this.t.getItem(o.a);w&&(w.menus&&(this.k=w.menus),w.keybindings&&(this.l=w.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(j,U,F)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:U?.id})},this.m["workbench.action.newWindow"]=(j,U,F)=>this.p.openEmptyWindow({context:2,contextWindowId:U?.id}),this.m["workbench.action.files.openFileFolder"]=(j,U,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(j,U,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(j,U,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const w=this.x.youTubeUrl;w&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(w,"openYouTubeUrl"));const A=this.x.requestFeatureUrl;A&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(A,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const E=this.x.licenseUrl;E&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$w){const j=E.indexOf("?")>0?"&":"?";this.ab(`${E}${j}lang=${D.$w}`,"openLicenseUrl")}else this.ab(E,"openLicenseUrl")});const C=this.x.privacyStatementUrl;C&&E&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(C,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(w=>this.G(w)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const w=this.o.getValue("window.enableMenuBarMnemonics");return typeof w!="boolean"?!0:w}get D(){if(!D.$j)return!1;const w=this.o.getValue("window.nativeTabs");return typeof w!="boolean"?!1:w}updateMenu(w,A){this.k=w.menus,this.l=w.keybindings,this.t.setItem(o.a,w),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(w){D.$j&&(w.oldCount===0&&w.newCount>0||w.oldCount>0&&w.newCount===0)&&(this.d=w.newCount===0,this.E())}H(){if(!D.$j)return;const w=S.BrowserWindow.getFocusedWindow();this.f=!w||!!this.y.getWindowById(w.id),this.E()}I(){const w=S.Menu.getApplicationMenu();if(w&&this.j.push(w),Object.keys(this.k).length===0){this.J(D.$j?new S.Menu:null);return}const A=new S.Menu;let I;if(D.$j){const C=new S.Menu;I=new S.MenuItem({label:this.x.nameShort,submenu:C}),this.K(C),A.append(I)}if(D.$j&&!this.c){this.c=!0;const C=new S.Menu;C.append(new S.MenuItem({label:this.cb(d.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(C)}if(this.M("File")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(d.localize(1,null)),submenu:C});this.O(C,"File"),A.append(j)}if(this.M("Edit")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(d.localize(2,null)),submenu:C});this.O(C,"Edit"),A.append(j)}if(this.M("Selection")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(d.localize(3,null)),submenu:C});this.O(C,"Selection"),A.append(j)}if(this.M("View")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(d.localize(4,null)),submenu:C});this.O(C,"View"),A.append(j)}if(this.M("Go")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(d.localize(5,null)),submenu:C});this.O(C,"Go"),A.append(j)}if(this.M("Run")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(d.localize(6,null)),submenu:C});this.O(C,"Run"),A.append(j)}if(this.M("Terminal")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(d.localize(7,null)),submenu:C});this.O(C,"Terminal"),A.append(j)}let E;if(this.M("Window")){const C=new S.Menu;E=new S.MenuItem({label:this.cb(d.localize(8,null)),submenu:C,role:"window"}),this.U(C)}if(E&&A.append(E),this.M("Help")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(d.localize(9,null)),submenu:C,role:"help"});this.O(C,"Help"),A.append(j)}A.items&&A.items.length>0?this.J(A):this.J(null),this.h.schedule()}J(w){if(S.Menu.setApplicationMenu(w),w)for(const A of this.y.getWindows())A.win?.setMenu(null)}K(w){const A=this.W(d.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let E;if(this.M("Preferences")){const re=new S.Menu;this.O(re,"Preferences"),E=new S.MenuItem({label:this.cb(d.localize(11,null)),submenu:re})}const C=new S.Menu,j=new S.MenuItem({label:d.localize(12,null),role:"services",submenu:C}),U=new S.MenuItem({label:d.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new S.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),H=new S.MenuItem({label:d.localize(15,null),role:"unhide"}),J=new S.MenuItem(this.$("workbench.action.quit",{label:d.localize(16,null,this.x.nameLong),click:async(re,ue,Z)=>{const X=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||X?.win?.isMinimized())&&await this.L(Z)&&this.w.quit(void 0)}})),le=[A];le.push(...I),E&&le.push(n(),E),le.push(n(),j,n(),U,F,H,n(),J),le.forEach(re=>w.append(re))}async L(w){if(this.p.getWindowCount()===0)return!0;const A=this.o.getValue("window.confirmBeforeClose");if(A==="always"||A==="keyboardOnly"&&this.S(w)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[d.localize(17,null),d.localize(18,null)],message:d.localize(19,null)});return I===0}return!0}M(w){if(!D.$j&&!(0,$.$WC)(this.o))return!1;switch(w){case"File":case"Help":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[w];case"Window":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[w]}}N(w,A){A.forEach(I=>{if((0,m.$s$b)(I))w.append(n());else if((0,m.$r$b)(I)){const E=new S.Menu,C=new S.MenuItem({label:this.cb(I.label),submenu:E});this.N(E,I.submenu.items),w.append(C)}else(0,m.$t$b)(I)?w.append(this.Q(I)):(0,m.$u$b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(w),D.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?w.append(new S.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):w.append(this.W(I.label,I.id,!1,I.checked)):w.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):w.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(w,A){this.k&&this.k[A]&&this.N(w,this.k[A].items)}P(w){const A=this.V();A.length&&(A.forEach(I=>w.append(I)),w.append(n()))}Q(w){const A=P.URI.revive(w.uri),I=w.id,E=I==="openRecentFile"?{fileUri:A}:I==="openRecentWorkspace"?{workspaceUri:A}:{folderUri:A};return new S.MenuItem(this.$(I,{label:w.label,click:async(C,j,U)=>{const F=this.R(U);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[E],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:w.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([A])}},!1))}R(w){return!!(w&&(!D.$j&&(w.ctrlKey||w.shiftKey)||D.$j&&(w.metaKey||w.altKey)))}S(w){return!!(w.triggeredByAccelerator||w.altKey||w.ctrlKey||w.metaKey||w.shiftKey)}T(w,A,I){const E={label:this.cb(w),role:I,enabled:!0};return new S.MenuItem(this.Z(A,E))}U(w){const A=new S.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new S.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),E=new S.MenuItem({label:d.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),C=this.W(d.localize(23,null),"workbench.action.switchWindow"),j=[];this.D&&(j.push(n()),j.push(this.W(d.localize(24,null),"workbench.action.newWindowTab")),j.push(this.T(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),j.push(this.T(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),j.push(this.T(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),j.push(this.T(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[A,I,n(),C,...j,n(),E].forEach(U=>w.append(U))}V(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.cb(d.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.cb(d.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.cb(d.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.cb(d.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(w,A,I,E){const C=this.cb(w),j=typeof A=="function"?A:(le,re,ue)=>{const Z=le?le.userSettingsLabel:null;let X=A;Array.isArray(A)&&(X=this.R(ue)?A[1]:A[0]),Z&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Z}):this.Y({type:"commandId",commandId:X})},U=typeof I=="boolean"?I:this.p.getWindowCount()>0,F=typeof E=="boolean"?E:!1,H={label:C,click:j,enabled:U};F&&(H.type="checkbox",H.checked=F);let J;return typeof A=="string"?J=A:Array.isArray(A)&&(J=A[0]),D.$j&&(J==="editor.action.clipboardCutAction"?H.role="cut":J==="editor.action.clipboardCopyAction"?H.role="copy":J==="editor.action.clipboardPasteAction"&&(H.role="paste"),J==="undo"?H.click=this.X(j,{inDevTools:le=>le.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):J==="redo"?H.click=this.X(j,{inDevTools:le=>le.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):J==="editor.action.selectAll"&&(H.click=this.X(j,{inDevTools:le=>le.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.Z(J,H))}X(w,A){return(I,E,C)=>{const j=S.BrowserWindow.getFocusedWindow();if(!j)return A.inNoWindow();if(j.webContents.isDevToolsFocused()&&j.webContents.devToolsWebContents)return A.inDevTools(j.webContents.devToolsWebContents);w(I,E||j,C)}}Y(w){let A=S.BrowserWindow.getFocusedWindow();if(A){const E=this.y.getWindowById(A.id);E&&(A=this.p.getWindowById(E.parentId)?.win??null)}if(!A){const E=this.p.getLastActiveWindow();E?.win?.isMinimized()&&(A=E.win)}const I=A?this.p.getWindowById(A.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",w),D.$j&&!this.q.isBuilt&&!I.isReady&&(w.type==="commandId"&&w.commandId==="workbench.action.toggleDevTools"||w.type!=="commandId"&&w.userSettingsLabel==="alt+cmd+i"))return!1;if(w.type==="commandId"){const E={id:w.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,E)}else{const E={userSettingsLabel:w.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,E)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",w),!1}Z(w,A){const I=typeof w=="string"?this.l[w]:void 0;if(I?.label){if(I.isNative!==!1)A.accelerator=I.label,A.userSettingsLabel=I.userSettingsLabel;else if(typeof A.label=="string"){const E=A.label.indexOf("[");E>=0?A.label=`${A.label.substr(0,E)} [${I.label}]`:A.label=`${A.label} [${I.label}]`}}else A.accelerator=void 0;return A}$(w,A,I=!A.accelerator){I&&(A=this.Z(w,A));const E=A.click;return A.click=(C,j,U)=>{this.bb(w),E?.(C,j,U)},A}ab(w,A){this.w.openExternal(void 0,w),this.bb(A)}bb(w){this.r.publicLog2("workbenchActionExecuted",{id:w,from:r})}cb(w){return(0,M.$4v)(w,!this.C)}};e.$x$b=i,e.$x$b=i=o=ve([se(0,f.$UV),se(1,b.$Bi),se(2,a.$w0b),se(3,v.$l0b),se(4,l.$wl),se(5,t.$v$b),se(6,g.$PO),se(7,y.$P0b),se(8,h.$pj),se(9,p.$j$b),se(10,k.$Hj),se(11,u.$h$b)],i);function n(){return new S.MenuItem({type:"separator"})}}),define(ae[305],ce([0,1,6,20,5,304]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z$b=e.$y$b=void 0,e.$y$b=(0,S.$8h)("menubarMainService");let D=class{constructor(d,u,b){this.b=d,this.c=u,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$x$b)}async updateMenubar(d,u){this.d.trace("menubarService#updateMenubar",d),(await this.a).updateMenu(u,d)}};e.$z$b=D,e.$z$b=D=ve([se(0,S.$7h),se(1,O.$P0b),se(2,s.$pj)],D)}),define(ae[306],ce([0,1,15,21,132,26,22,23,3,33,47,2,13,9,67,4,36,19,12,7,191,65,18,56,24,16,6,20,5,79,80,60,34,55,134,29,131,298,30,99,83,58,69,39,57,68,78]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f,$,a,t,o,r,i,n,c,w,A,I,E,C,j,U,F,H,J,le,re,ue,Z,X,q,L,T,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z$b=void 0;function B(K){return(0,le.$ki)(K?.workspace)}function oe(K){return(0,le.$fi)(K?.workspace)}let he=class extends v.$Tc{constructor(R,W,x,N,Q,V,_,z,ee,ne,de,me,Ee,Pe,Le,ke,pe,te,fe,$e){super(),this.s=R,this.t=W,this.u=x,this.w=N,this.z=Q,this.C=V,this.D=_,this.F=z,this.G=ee,this.H=ne,this.I=de,this.J=me,this.L=Ee,this.M=Pe,this.N=Le,this.O=ke,this.P=pe,this.Q=te,this.R=fe,this.S=$e,this.a=this.B(new d.$Wd),this.onDidOpenWindow=this.a.event,this.b=this.B(new d.$Wd),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new d.$Wd),this.onDidDestroyWindow=this.c.event,this.f=this.B(new d.$Wd),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new d.$Wd),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new d.$Wd),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new d.$Wd),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new d.$Wd),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new J.$W$b(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(R=>this.b.fire(R.window))),this.B(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const W=new v.$Sc;if(W.add(d.Event.any(R.onDidClose,R.onDidDestroy)(()=>W.dispose())),R.config.extensionDevelopmentPath)for(const x of R.config.extensionDevelopmentPath)W.add(this.Q.addValidFileRoot(x));R.config.extensionTestsPath&&W.add(this.Q.addValidFileRoot(R.config.extensionTestsPath))}}))}openEmptyWindow(R,W){const x=this.F.args,N=W?.remoteAuthority||void 0,Q=!0,V=W?.forceReuseWindow,_=!V;return this.open({...R,cli:x,forceEmpty:Q,forceNewWindow:_,forceReuseWindow:V,remoteAuthority:N})}openExistingWindow(R,W){R.focus(),this.W(W,[R])}async open(R){this.w.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const W=[],x=[],N=[],Q=[],V=[];let _,z=0;const ee=await this.cb(R);this.w.trace("windowsManager#open pathsToOpen",ee);for(const Pe of ee)oe(Pe)?R.addMode?W.push(Pe):x.push(Pe):B(Pe)?N.push(Pe):Pe.fileUri?(_||(_={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),_.filesToOpenOrCreate.push(Pe)):Pe.backupPath?V.push({backupFolder:(0,h.$nc)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):z++;R.diffMode&&_&&_.filesToOpenOrCreate.length>=2&&(_.filesToDiff=_.filesToOpenOrCreate.slice(0,2),_.filesToOpenOrCreate=[]),R.mergeMode&&_&&_.filesToOpenOrCreate.length===4&&(_.filesToMerge=_.filesToOpenOrCreate.slice(0,4),_.filesToOpenOrCreate=[],_.filesToDiff=[]),_&&R.waitMarkerFileURI&&(_.filesToWait={paths:(0,D.$Hb)([..._.filesToDiff,_.filesToMerge[3],..._.filesToOpenOrCreate]),waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(Q.push(...this.M.getUntitledWorkspaces()),N.push(...Q),V.push(...this.I.getEmptyWindowBackups())):V.length=0;const{windows:ne,filesOpenedInWindow:de}=await this.X(R,N,x,V,z,_,W);if(this.w.trace(`windowsManager#open used window count ${ne.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${x.length}, emptyToRestore: ${V.length}, emptyToOpen: ${z})`),ne.length>1)if(de)de.focus();else{const Pe=this.r.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let Le=!0,ke=!0;if(Pe){const pe=ne.filter(te=>this.r.state.lastActiveWindow&&te.backupPath===this.r.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Le=!1,ke=!1)}if(Le)for(let pe=ne.length-1;pe>=0;pe--){const te=ne[pe];if(!(te.openedWorkspace&&Q.some(fe=>te.openedWorkspace&&fe.workspace.id===te.openedWorkspace.id)||te.backupPath&&V.some(fe=>te.backupPath&&fe.backupFolder===(0,h.$nc)(te.backupPath)))){te.focus(),ke=!1;break}}ke&&ne[ne.length-1].focus()}const me=_&&_.filesToDiff.length>0,Ee=_&&_.filesToMerge.length>0;if(!ne.some(Pe=>Pe.isExtensionDevelopmentHost)&&!me&&!Ee&&!R.noRecentEntry){const Pe=[];for(const Le of ee)B(Le)&&!Le.transient?Pe.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):oe(Le)?Pe.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Pe.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.L.addRecentlyOpened(Pe)}return this.W(R,ne),ne}W(R,W){const x=R.waitMarkerFileURI;R.context===0&&x&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.P.del(x)}catch{}})()}async X(R,W,x,N,Q,V,_){const z=[];let ee;function ne(pe,te){z.push(pe),te&&(ee=pe,V=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:me}=this.ob(R);if(!R.initialStartup&&_.length>0){const pe=_[0].remoteAuthority,te=this.ub(pe);te&&ne(this.$(te,_.map(fe=>fe.workspace.uri)))}const Ee=x.length+W.length+N.length;if(V&&Ee===0){const pe=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],te=this.getWindows().filter($e=>V&&(0,g.$Ng)($e.remoteAuthority,V.remoteAuthority));let fe;pe?.fileUri&&!me&&((R.context===4||R.context===0||R.context===1)&&(fe=await(0,H.$B0b)(te,pe.fileUri,async $e=>$e.configPath.scheme===y.Schemas.file?this.M.resolveLocalWorkspace($e.configPath):void 0)),fe||(fe=this.vb(te))),fe?(0,le.$ki)(fe.openedWorkspace)?W.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,le.$fi)(fe.openedWorkspace)?x.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):ne(this.Y(R,fe,V),!0):ne(await this.pb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile}),!0)}const Pe=(0,D.$Mb)(W,pe=>pe.workspace.id);if(Pe.length>0){const pe=(0,D.$Hb)(Pe.map(te=>(0,H.$C0b)(this.getWindows(),te.workspace.configPath)));if(pe.length>0){const te=pe[0],fe=(0,g.$Ng)(V?.remoteAuthority,te.remoteAuthority)?V:void 0;ne(this.Y(R,te,fe),!!fe),de=!0}for(const te of Pe){if(pe.some(Ie=>Ie.openedWorkspace&&Ie.openedWorkspace.id===te.workspace.id))continue;const fe=te.remoteAuthority,$e=(0,g.$Ng)(V?.remoteAuthority,fe)?V:void 0;ne(await this.bb(R,te,de,$e),!!$e),de=!0}}const Le=(0,D.$Mb)(x,pe=>g.$zg.getComparisonKey(pe.workspace.uri));if(Le.length>0){const pe=(0,D.$Hb)(Le.map(te=>(0,H.$C0b)(this.getWindows(),te.workspace.uri)));if(pe.length>0){const te=pe[0],fe=(0,g.$Ng)(V?.remoteAuthority,te.remoteAuthority)?V:void 0;ne(this.Y(R,te,fe),!!fe),de=!0}for(const te of Le){if(pe.some(Ie=>(0,le.$fi)(Ie.openedWorkspace)&&g.$zg.isEqual(Ie.openedWorkspace.uri,te.workspace.uri)))continue;const fe=te.remoteAuthority,$e=(0,g.$Ng)(V?.remoteAuthority,fe)?V:void 0;ne(await this.bb(R,te,de,$e),!!$e),de=!0}}const ke=(0,D.$Mb)(N,pe=>pe.backupFolder);if(ke.length>0)for(const pe of ke){const te=pe.remoteAuthority,fe=(0,g.$Ng)(V?.remoteAuthority,te)?V:void 0;ne(await this.ab(R,!0,te,fe,pe),!!fe),de=!0}if(z.length===0||V){V&&!Q&&Q++;const pe=V?V.remoteAuthority:R.remoteAuthority;for(let te=0;te<Q;te++)ne(await this.ab(R,de,pe,V),!!V),de=!0}return{windows:(0,D.$Mb)(z),filesOpenedInWindow:ee}}Y(R,W,x){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:x}),this.Z(W);const N={filesToOpenOrCreate:x?.filesToOpenOrCreate,filesToDiff:x?.filesToDiff,filesToMerge:x?.filesToMerge,filesToWait:x?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",P.CancellationToken.None,N),W}Z(R){let W=R;const x=S.BrowserWindow.getFocusedWindow();if(x&&x.id!==R.id){const N=this.S.getWindowById(x.id);N&&N.parentId===R.id&&(W=N)}W.focus()}$(R,W){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),R.focus();const x={foldersToAdd:W};return R.sendWhenReady("vscode:addFolders",P.CancellationToken.None,x),R}ab(R,W,x,N,Q){this.w.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:x,filesToOpen:N,forceNewWindow:W});let V;return!W&&typeof R.contextWindowId=="number"&&(V=this.getWindowById(R.contextWindowId)),this.pb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:x,forceNewWindow:W,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:N,windowToUse:V,emptyWindowBackupInfo:Q,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}bb(R,W,x,N,Q){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:N}),!x&&!Q&&typeof R.contextWindowId=="number"&&(Q=this.getWindowById(R.contextWindowId)),this.pb({workspace:W.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:x,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:N,windowToUse:Q,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}async cb(R){let W,x=!1,N=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(W=await this.db(R),x=!0):R.forceEmpty?W=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(W=await this.eb(R.cli),W.length===0&&W.push(Object.create(null)),x=!0):(W=await this.gb(),W.length===0&&W.push(Object.create(null)),N=!0),!R.addMode&&x){const Q=W.filter(V=>oe(V));if(Q.length>1){const V=Q[0].remoteAuthority;if(Q.every(_=>(0,g.$Ng)(_.remoteAuthority,V))){const _=await this.M.createUntitledWorkspace(Q.map(z=>({uri:z.workspace.uri})));W.push({workspace:_,remoteAuthority:V}),W=W.filter(z=>!oe(z))}}}if(R.initialStartup&&!N&&this.J.getValue("window")?.restoreWindows==="preserve"){const Q=await this.gb();W.unshift(...Q.filter(V=>B(V)||oe(V)||V.backupPath))}return W}async db(R){const W={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority},x=await Promise.all((0,D.$Hb)(R.urisToOpen||[]).map(async N=>{const Q=await this.ib(N,W);if(Q)return Q.label=N.label,Q;const V=this.kb(N);this.O.showMessageBox({type:"info",buttons:[(0,$.localize)(0,null)],message:V.scheme===y.Schemas.file?(0,$.localize)(1,null):(0,$.localize)(2,null),detail:V.scheme===y.Schemas.file?(0,$.localize)(3,null,(0,b.$Xv)(V,{os:p.OS,tildify:this.F})):(0,$.localize)(4,null,V.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Hb)(x)}async eb(R){const W=[],x={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:R.diff&&R._.length===2||R.merge&&R._.length===4},N=R["folder-uri"];if(N){const _=await Promise.all(N.map(z=>{const ee=this.fb(z);if(ee)return this.ib({folderUri:ee},x)}));W.push(...(0,D.$Hb)(_))}const Q=R["file-uri"];if(Q){const _=await Promise.all(Q.map(z=>{const ee=this.fb(z);if(ee)return this.ib((0,le.$Ai)(z)?{workspaceUri:ee}:{fileUri:ee},x)}));W.push(...(0,D.$Hb)(_))}const V=await Promise.all(R._.map(_=>x.remoteAuthority?this.nb(_,x):this.lb(_,x)));return W.push(...(0,D.$Hb)(V)),W}fb(R){try{const W=f.URI.parse(R);if(!W.scheme){this.w.error(`Invalid URI input string, scheme missing: ${R}`);return}return W.path?W:W.with({path:"/"})}catch(W){this.w.error(`Invalid URI input string: ${R}, ${W.message}`)}}async gb(){const R=this.hb();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];R!=="one"&&W.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&W.push(this.r.state.lastActiveWindow);const x=await Promise.all(W.map(async N=>{if(N.workspace){const Q=await this.ib({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});if(B(Q))return Q}else if(N.folderUri){const Q=await this.ib({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});if(oe(Q))return Q}else if(R!=="folders"&&N.backupPath)return{backupPath:N.backupPath,remoteAuthority:N.remoteAuthority}}));return(0,D.$Hb)(x)}}}hb(){let R;return this.H.wasRestarted?R="all":(R=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}async ib(R,W=Object.create(null)){const x=this.kb(R);return x.scheme===y.Schemas.file?((0,j.$TC)(R)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.lb(x.fsPath,W)):this.jb(R,W)}jb(R,W){let x=this.kb(R);const N=(0,E.$cl)(x)||W.remoteAuthority;if(x=(0,g.$Pg)((0,g.$Jg)(x)),(0,j.$TC)(R)){if(W.gotoLineMode){const{path:Q,line:V,column:_}=(0,u.$dg)(x.path);return{fileUri:x.with({path:Q}),options:{selection:V?{startLineNumber:V,startColumn:_||1}:void 0},remoteAuthority:N}}return{fileUri:x,remoteAuthority:N}}else if((0,j.$RC)(R))return{workspace:(0,re.$F0b)(x),remoteAuthority:N};return{workspace:(0,re.$G0b)(x),remoteAuthority:N}}kb(R){return(0,j.$RC)(R)?R.workspaceUri:(0,j.$SC)(R)?R.folderUri:R.fileUri}async lb(R,W,x){let N,Q;W.gotoLineMode&&({path:R,line:N,column:Q}=(0,u.$dg)(R)),R=(0,u.$$f)((0,h.$hc)(R),(0,k.cwd)());try{const V=await O.Promises.stat(R);if(V.isFile()){if(!W.forceOpenWorkspaceAsFile){const _=await this.M.resolveLocalWorkspace(f.URI.file(R));if(_)return _.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:_.id,configPath:_.configPath},type:i.FileType.File,exists:!0,remoteAuthority:_.remoteAuthority,transient:_.transient}}return{fileUri:f.URI.file(R),type:i.FileType.File,exists:!0,options:{selection:N?{startLineNumber:N,startColumn:Q||1}:void 0}}}else{if(V.isDirectory())return{workspace:(0,re.$G0b)(f.URI.file(R),V),type:i.FileType.Directory,exists:!0};if(!p.$i&&R==="/dev/null")return{fileUri:f.URI.file(R),type:i.FileType.File,exists:!0}}}catch(V){if(V.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!x)return this.mb(R,W);const _=f.URI.file(R);if(this.L.removeRecentlyOpened([_]),W.ignoreFileNotFound)return{fileUri:_,type:i.FileType.File,exists:!1}}}async mb(R,W){const x=f.URI.file(R),{response:N,checkboxChecked:Q}=await this.O.showMessageBox({type:"warning",buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null),(0,$.localize)(7,null)],message:(0,$.localize)(8,null,x.authority),detail:(0,$.localize)(9,null,(0,b.$Xv)(x,{os:p.OS,tildify:this.F})),checkboxLabel:(0,$.localize)(10,null,x.authority),cancelId:1});if(N===0){if((0,s.addUNCHostToAllowlist)(x.authority),Q){const V={channel:"vscode:configureAllowedUNCHost",args:x.authority};this.sendToFocused(V.channel,V.args),this.sendToOpeningWindow(V.channel,V.args)}return this.lb(R,W,!0)}if(N===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(R,W)}nb(R,W){const x=R.charCodeAt(0),N=W.remoteAuthority;let Q,V;W.gotoLineMode&&({path:R,line:Q,column:V}=(0,u.$dg)(R)),x!==47&&((0,u.$0f)(x)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,u.$3f)(R)),R=`/${R}`);const _=f.URI.from({scheme:y.Schemas.vscodeRemote,authority:N,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,le.$Ai)(R))return W.forceOpenWorkspaceAsFile?{fileUri:_,options:{selection:Q?{startLineNumber:Q,startColumn:V||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,re.$F0b)(_),remoteAuthority:N};if(W.gotoLineMode||h.$gc.basename(R).indexOf(".")!==-1)return{fileUri:_,options:{selection:Q?{startLineNumber:Q,startColumn:V||1}:void 0},remoteAuthority:N}}return{workspace:(0,re.$G0b)(_),remoteAuthority:N}}ob(R){const W=this.J.getValue("window"),x=W?.openFoldersInNewWindow||"default",N=W?.openFilesInNewWindow||"off";let Q=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&(x==="on"||x==="off")&&(Q=x==="on");let V=!1;return R.forceNewWindow||R.forceReuseWindow?V=!!R.forceNewWindow&&!R.forceReuseWindow:(p.$j?R.context===1&&(V=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!R.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(V=N==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(R,W){const x=(0,H.$D0b)(this.getWindows(),R);if(x)return this.H.reload(x,W.cli),x.focus(),[x];let N=W.cli["folder-uri"]||[],Q=W.cli["file-uri"]||[],V=W.cli._;if(!V.length&&!N.length&&!Q.length&&!W.cli.extensionTestsPath){const ee=this.r.state.lastPluginDevelopmentHostWindow,ne=ee?.workspace??ee?.folderUri;ne&&(f.URI.isUri(ne)?ne.scheme===y.Schemas.file?V=[ne.fsPath]:N=[ne.toString()]:ne.configPath.scheme===y.Schemas.file?V=[(0,g.$wg)(ne.configPath)]:Q=[ne.configPath.toString()])}let _=W.remoteAuthority;for(const ee of R)if(ee.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=f.URI.parse(ee),de=(0,E.$cl)(ne);de&&(_?(0,g.$Ng)(de,_)||this.w.error("more than one extension development path authority"):_=de)}V=V.filter(ee=>{const ne=f.URI.file(ee);return(0,H.$C0b)(this.getWindows(),ne)?!1:(0,g.$Ng)((0,E.$cl)(ne),_)}),N=N.filter(ee=>{const ne=this.fb(ee);return ne&&(0,H.$C0b)(this.getWindows(),ne)?!1:ne?(0,g.$Ng)((0,E.$cl)(ne),_):!1}),Q=Q.filter(ee=>{const ne=this.fb(ee);return ne&&(0,H.$C0b)(this.getWindows(),ne)?!1:ne?(0,g.$Ng)((0,E.$cl)(ne),_):!1}),W.cli._=V,W.cli["folder-uri"]=N,W.cli["file-uri"]=Q;const z={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!V.length&&!N.length&&!Q.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:_,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(z)}async pb(R){const W=this.J.getValue("window"),x=this.getLastActiveWindow(),N=x?.profile??this.G.defaultProfile;let Q;!R.forceNewWindow&&!R.forceNewTabbedWindow&&(Q=R.windowToUse||x,Q&&Q.focus());const V={...this.F.args,...R.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,h.$jc)(this.F.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:N},homeDir:this.F.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.u,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToMerge:R.filesToOpen?.filesToMerge,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:y.Schemas.file}).fsPath,product:A.default,isInitialStartup:R.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(Q){const _=Q.config;!V.extensionDevelopmentPath&&_?.extensionDevelopmentPath&&(V.extensionDevelopmentPath=_.extensionDevelopmentPath,V.extensionDevelopmentKind=_.extensionDevelopmentKind,V["enable-proposed-api"]=_["enable-proposed-api"],V.verbose=_.verbose,V["inspect-extensions"]=_["inspect-extensions"],V["inspect-brk-extensions"]=_["inspect-brk-extensions"],V.debugId=_.debugId,V.extensionEnvironment=_.extensionEnvironment,V["extensions-dir"]=_["extensions-dir"],V["disable-extensions"]=_["disable-extensions"]),V.loggers={global:V.loggers.global,window:_?.loggers.window??V.loggers.window}}else{const _=this.r.getNewWindowState(V);(0,m.mark)("code/willCreateCodeWindow");const z=Q=this.N.createInstance(U.$N0b,{state:_,extensionDevelopmentPath:V.extensionDevelopmentPath,isExtensionTestHost:!!V.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(z),this.n.set(z.id,z),this.a.fire(z),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ee=new v.$Sc;ee.add(z.onDidSignalReady(()=>this.b.fire(z))),ee.add(d.Event.once(z.onDidClose)(()=>this.sb(z,ee))),ee.add(d.Event.once(z.onDidDestroy)(()=>this.tb(z))),ee.add(z.onDidMaximize(()=>this.g.fire(z))),ee.add(z.onDidUnmaximize(()=>this.h.fire(z))),ee.add(z.onDidEnterFullScreen(()=>this.j.fire({window:z,fullscreen:!0}))),ee.add(z.onDidLeaveFullScreen(()=>this.j.fire({window:z,fullscreen:!1}))),ee.add(z.onDidTriggerSystemContextMenu(({x:de,y:me})=>this.m.fire({window:z,x:de,y:me})));const ne=(0,l.$Uf)(z.win?.webContents);ne.removeAllListeners("devtools-reload-page"),ne.on("devtools-reload-page",()=>this.H.reload(z)),this.H.registerWindow(z)}return V.windowId=Q.id,Q.isReady?this.H.unload(Q,4).then(async _=>{_||await this.qb(Q,V,R,N)}):await this.qb(Q,V,R,N),Q}async qb(R,W,x,N){if(W.extensionDevelopmentPath||((0,le.$ki)(W.workspace)?W.backupPath=this.I.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,le.$fi)(W.workspace)?W.backupPath=this.I.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.I.registerEmptyWindowBackup({backupFolder:x.emptyWindowBackupInfo?.backupFolder??(0,re.$H0b)().id,remoteAuthority:W.remoteAuthority})),this.G.isEnabled()){const Q=W.workspace??(0,le.$ji)(W.backupPath,!1),V=this.rb(x,Q,N),_=V instanceof Promise?await V:V;W.profiles.profile=_,W.extensionDevelopmentPath||await this.G.setProfileForWorkspace(Q,_)}R.load(W)}rb(R,W,x){return R.forceProfile?this.G.profiles.find(N=>N.name===R.forceProfile)??this.G.createNamedProfile(R.forceProfile):R.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(W)??x}sb(R,W){this.n.delete(R.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),W.dispose()}tb(R){this.n.delete(R.id),this.c.fire(R)}getFocusedWindow(){const R=S.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(R){return this.vb(this.getWindows().filter(W=>(0,g.$Ng)(W.remoteAuthority,R)))}vb(R){return(0,F.$y0b)(R)}sendToFocused(R,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(R,P.CancellationToken.None,...W)}sendToOpeningWindow(R,...W){this.B(d.Event.once(this.onDidSignalReadyWindow)(x=>{x.sendWhenReady(R,P.CancellationToken.None,...W)}))}sendToAll(R,W,x){for(const N of this.getWindows())x&&x.indexOf(N.id)>=0||N.sendWhenReady(R,P.CancellationToken.None,W)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(R){return this.n.get(R)}getWindowByWebContents(R){const W=S.BrowserWindow.fromWebContents(R);if(W)return this.getWindowById(W.id)}};e.$Z$b=he,e.$Z$b=he=ve([se(3,w.$pj),se(4,T.$K0b),se(5,C.$PO),se(6,q.$Mn),se(7,r.$l0b),se(8,L.$z0b),se(9,c.$P0b),se(10,a.$q0b),se(11,t.$Bi),se(12,ue.$v$b),se(13,Z.$I0b),se(14,n.$7h),se(15,o.$r0b),se(16,i.$sk),se(17,I.$t0b),se(18,X.$u0b),se(19,G.$h$b)],he)}),define(ae[307],ce([0,1,65,29,83,58]),function(Y,e,S,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=void 0;let D=class{constructor(d,u,b,v){this.a=d,this.b=u,this.c=b,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(d,u){const b=this.b.getWindowById(d);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),u)}createUntitledWorkspace(d,u,b){return this.a.createUntitledWorkspace(u,b)}deleteUntitledWorkspace(d,u){return this.a.deleteUntitledWorkspace(u)}getWorkspaceIdentifier(d,u){return this.a.getWorkspaceIdentifier(u)}getRecentlyOpened(d){return this.c.getRecentlyOpened()}addRecentlyOpened(d,u){return this.c.addRecentlyOpened(u)}removeRecentlyOpened(d,u){return this.c.removeRecentlyOpened(u)}clearRecentlyOpened(d){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$2$b=D,e.$2$b=D=ve([se(0,M.$I0b),se(1,O.$w0b),se(2,s.$v$b),se(3,S.$q0b)],D)}),define(ae[308],ce([0,1,15,132,37,26,17,51,14,33,3,42,47,2,13,9,4,12,7,32,158,43,159,112,290,162,65,283,18,200,91,133,56,118,220,24,64,94,209,293,211,212,213,16,224,93,77,6,92,219,299,284,291,20,5,305,70,27,60,294,95,34,275,82,124,28,251,253,54,49,265,288,300,289,301,129,267,268,269,272,297,55,29,306,274,30,98,83,307,58,39,233,57,244,53,81,130,277,292,280,8,255,276,228,68,296,271,22,127,295,263,239,62,78,303]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f,$,a,t,o,r,i,n,c,w,A,I,E,C,j,U,F,H,J,le,re,ue,Z,X,q,L,T,G,B,oe,he,K,R,W,x,N,Q,V,_,z,ee,ne,de,me,Ee,Pe,Le,ke,pe,te,fe,$e,Ie,Me,Te,je,Je,Be,Ve,He,ie,ge,be,Se,ye,Oe,Ue,qe,Ye,xe,Xe,Qe,nt,st,ot,pt,yt,vt,kt,Et,St,at,gt,Pt,It,Ct,ct,Dt,$t,lt,At,Ot,ut,Rt,ht,Mt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$i_b=void 0;let dt=class extends h.$Tc{static{ft=this}static{this.a={[m.Schemas.file]:"security.promptForLocalFileProtocolHandling",[m.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ce,De,Re,we,Ae,Ne,ze,Ke,We,Fe,Ge,Ze){super(),this.g=Ce,this.h=De,this.j=Re,this.m=we,this.n=Ae,this.s=Ne,this.t=ze,this.u=Ke,this.w=We,this.y=Fe,this.z=Ge,this.C=Ze,this.D(),this.F()}D(){const Ce=We=>We?.startsWith(`${m.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((We,Fe,Ge,Ze)=>Ce(Ze.requestingUrl)?Ge(De.has(Fe)):Ge(!1)),S.session.defaultSession.setPermissionCheckHandler((We,Fe,Ge,Ze)=>Ce(Ze.requestingUrl)?De.has(Fe):!1);const Re=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,m.Schemas.vscodeManagedRemoteResource,"devtools"]),we=We=>{for(let Fe=We;Fe;Fe=Fe.parent)if(Fe.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},Ae=We=>We.resourceType==="xhr"||we(We.frame),Ne=We=>{const Fe=We.frame;if(!Fe||!this.b)return!1;const Ge=S.BrowserWindow.getAllWindows();for(const Ze of Ge)if(Fe.processId===Ze.webContents.mainFrame.processId)return!0;return!1},ze=(We,Fe)=>{if(We.path!=="/index.html")return!0;const Ge=Fe.frame;if(!Ge||!this.b)return!1;for(const Ze of this.b.getWindows())if(Ze.win&&Ge.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((We,Fe)=>{const Ge=l.URI.parse(We.url);return Ge.scheme===m.Schemas.vscodeWebview&&!ze(Ge,We)?(this.m.error("Blocked vscode-webview request",We.url),Fe({cancel:!0})):Ge.scheme===m.Schemas.vscodeFileResource&&!Ne(We)?(this.m.error("Blocked vscode-file request",We.url),Fe({cancel:!0})):Ge.path.endsWith(".svg")&&!Re.has(Ge.scheme)?Fe({cancel:!Ae(We)}):Fe({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((We,Fe)=>{const Ge=We.responseHeaders,Ze=Ge["content-type"]||Ge["Content-Type"];if(Ze&&Array.isArray(Ze)){const _e=l.URI.parse(We.url);if(_e.path.endsWith(".svg")&&Re.has(_e.scheme))return Ge["Content-Type"]=["image/svg+xml"],Fe({cancel:!1,responseHeaders:Ge});if(!_e.path.endsWith(m.Schemas.vscodeRemoteResource)&&Ze.some(tt=>tt.toLowerCase().includes("image/svg")))return Fe({cancel:!Ae(We)})}return Fe({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((We,Fe)=>{if(We.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ge=We.responseHeaders??Object.create(null);if(Ge["Access-Control-Allow-Origin"]===void 0)return Ge["Access-Control-Allow-Origin"]=["*"],Fe({cancel:!1,responseHeaders:Ge})}return Fe({cancel:!1})});const Ke=S.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,p.$jc)(this.s.codeCachePath,"chrome")),k.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,O.disableUNCAccessRestrictions)():(0,O.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,d.setUnexpectedErrorHandler)(Re=>this.H(Re)),process.on("uncaughtException",Re=>{(0,d.$Z)(Re)||(0,d.$1)(Re)}),process.on("unhandledRejection",Re=>(0,d.$1)(Re)),this.t.onWillShutdown(()=>this.dispose()),(0,$.$WU)(),S.app.on("accessibility-support-changed",(Re,we)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",we)}),S.app.on("activate",async(Re,we)=>{this.m.trace("app#activate"),we||await this.b?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Re,we)=>{(0,ht.$i$b)(we)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(we)),we.on("will-navigate",Ae=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),we.setWindowOpenHandler(Ae=>Ae.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ae)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ae.url}}`),this.f?.openExternal(void 0,Ae.url),{action:"deny"}))});let Ce=[],De;S.app.on("open-file",(Re,we)=>{this.m.trace("app#open-file: ",we),Re.preventDefault(),Ce.push((0,Ue.$Ai)(we)?{workspaceUri:l.URI.file(we)}:{fileUri:l.URI.file(we)}),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],De=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$VU.handle("vscode:fetchShellEnv",Re=>{const we=this.b?.getWindowByWebContents(Re.sender);let Ae,Ne;return we?.config?(Ae=we.config,Ne={...process.env,...we.config.userEnv}):(Ae=this.s.args,Ne=process.env),this.X(Ae,Ne,!1)}),s.$VU.handle("vscode:writeNlsFile",(Re,we,Ae)=>{const Ne=this.G([we]);if(!Ne||typeof Ae!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Ne,D.$ke.fromString(Ae))}),s.$VU.handle("vscode:readNlsFile",async(Re,...we)=>{const Ae=this.G(we);if(!Ae)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ae)).value.toString()}),s.$VU.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),s.$VU.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),s.$VU.on("vscode:reloadWindow",Re=>Re.sender.reload()),s.$VU.handle("vscode:notifyZoomLevel",async(Re,we)=>{const Ae=this.b?.getWindowById(Re.sender.id);Ae&&Ae.notifyZoomLevel(we)})}G(Ce){let De;for(const Re of Ce)typeof Re=="string"&&(typeof De!="string"?De=Re:De=(0,p.$jc)(De,Re));if(!(typeof De!="string"||!(0,p.$ic)(De)||!(0,u.$9f)(De,this.s.cachedLanguagesPath,!k.$k)))return l.URI.file(De)}H(Ce){if(Ce){const De={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.m.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.m.error(Ce.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ce=this.z.win32AppUserModelId;k.$i&&Ce&&S.app.setAppUserModelId(Ce);try{k.$j&&this.u.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.m.error(Fe)}const De=new t.$3U;this.t.onWillShutdown(Fe=>{Fe.reason===2&&De.dispose()}),this.m.trace("Resolving machine identifier...");const[Re,we]=await Promise.all([(0,gt.$0$b)(this.w,this.m),(0,gt.$$$b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Re}`);const{sharedProcessReady:Ae,sharedProcessClient:Ne}=this.P(Re,we),ze=await this.Q(Re,we,Ae);this.B(ze.createInstance(r.$Z0b)),this.B(ze.createInstance(Et.$6$b)),ze.invokeFunction(Fe=>this.R(Fe,De,Ne));const Ke=await ze.invokeFunction(Fe=>this.I(Fe,De));this.J(De),this.t.phase=2,await ze.invokeFunction(Fe=>this.S(Fe,Ke)),this.t.phase=3,this.U(),this.B(new at.$hh(()=>{this.B((0,at.$lh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ce,De){const Re=this.b=Ce.get(Se.$w0b),we=Ce.get(Je.$KV),Ae=this.f=Ce.get(V.$j$b),Ne=Ce.get(C.$r0b),ze=this;we.registerHandler({async handleURL(_e,tt){return ze.O(Re,Ne,we,_e,tt)}});const Ke=this.B(new Oe.$1$b({onDidOpenMainWindow:Ae.onDidOpenMainWindow,onDidFocusMainWindow:Ae.onDidFocusMainWindow,getActiveWindowId:()=>Ae.getActiveWindowId(-1)})),We=new a.$Ph(_e=>Ke.getActiveClientId().then(tt=>_e===tt)),Fe=new Be.$R$b(We,this.m),Ge=De.getChannel("urlHandler",Fe);we.registerHandler(new Be.$Q$b(Ge));const Ze=await this.L(Re,Ne);return this.B(new He.$S$b(Ze?.urls,we,Re,this.s,this.z,this.m)),Ze}J(Ce){const De=()=>({statusCode:404,data:"Not found"}),Re=new Rt.$V(()=>Ce.getChannel(ut.$f_b,new ut.$g_b));S.protocol.registerBufferProtocol(m.Schemas.vscodeManagedRemoteResource,(we,Ae)=>{const Ne=l.URI.parse(we.url);if(!Ne.authority.startsWith("window:"))return Ae(De());Re.value.call(ut.$e_b,[Ne]).then(ze=>Ae({...ze,data:Buffer.from(ze.body,"base64")}),ze=>{this.m.warn("error dispatching remote resource call",ze),Ae({statusCode:500,data:String(ze)})})})}async L(Ce,De){const Re=this.s.args["open-url"]?this.s.args._urls||[]:[];Re.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Re);const we=global.getOpenUrls()||[];if(we.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),Re.length+we.length===0)return;const Ae=[...Re,...we].map(Ke=>{try{return{uri:l.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),Ne=[],ze=[];for(const Ke of Ae){if(!Ke)continue;const We=this.N(Ke.uri);if(We)if(await this.M(We,Ce,De)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),We),Ne.push(We);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),ze.push(Ke)}return{urls:ze,openables:Ne}}async M(Ce,De,Re){let we,Ae;if((0,be.$RC)(Ce)?(we=Ce.workspaceUri,Ae=(0,i.localize)(0,null,we.scheme===m.Schemas.file?(0,y.$Xv)(we,{os:k.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(0,be.$SC)(Ce)?(we=Ce.folderUri,Ae=(0,i.localize)(1,null,we.scheme===m.Schemas.file?(0,y.$Xv)(we,{os:k.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(we=Ce.fileUri,Ae=(0,i.localize)(2,null,we.scheme===m.Schemas.file?(0,y.$Xv)(we,{os:k.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)),we.scheme!==m.Schemas.file&&we.scheme!==m.Schemas.vscodeRemote||this.u.getValue(ft.a[we.scheme])===!1)return!1;const{response:ze,checkboxChecked:Ke}=await Re.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Ae,detail:(0,i.localize)(5,null),checkboxLabel:we.scheme===m.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(ze!==0)return!0;if(Ke){const We={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===m.Schemas.file?"local":"remote"};De.sendToFocused(We.channel,We.args),De.sendToOpeningWindow(We.channel,We.args)}return!1}N(Ce){if(Ce.path){if(Ce.authority===m.Schemas.file){const De=l.URI.file(Ce.fsPath);return(0,Ue.$Ai)(De)?{workspaceUri:De}:{fileUri:De}}else if(Ce.authority===m.Schemas.vscodeRemote){const De=Ce.path.indexOf(p.$gc.sep,1);if(De!==-1){const Re=Ce.path.substring(1,De),we=Ce.path.substring(De);let Ae=Ce.query;const Ne=new URLSearchParams(Ce.query);Ne.get("windowId")==="_blank"&&(Ne.delete("windowId"),Ae=Ne.toString());const ze=l.URI.from({scheme:m.Schemas.vscodeRemote,authority:Re,path:we,query:Ae,fragment:Ce.fragment});return(0,Ue.$Ai)(we)?{workspaceUri:ze}:/:[\d]+$/.test(we)?{fileUri:ze}:{folderUri:ze}}}}}async O(Ce,De,Re,we,Ae){this.m.trace("app#handleProtocolUrl():",we.toString(!0),Ae),we.scheme===this.z.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:l.URI.parse(we.query).path,query:""}));let Ne=!1;const ze=new URLSearchParams(we.query);ze.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),ze.delete("windowId"),we=we.with({query:ze.toString()}),Ne=!0):k.$j&&Ce.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),Ne=!0);const Ke=ze.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),ze.delete("continueOn"),we=we.with({query:ze.toString()}),this.s.continueOn=Ke??void 0);const We=this.N(we);return We?await this.M(We,Ce,De)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",We,we.toString(!0)),(0,$t.$Ob)(await Ce.open({context:5,cli:{...this.s.args},urisToOpen:[We],forceNewWindow:Ne,gotoLineMode:!0}))?.focus(),!0):Ne?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,$t.$Ob)(await Ce.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,z.$cl)(we)}))?.ready(),Re.open(we,Ae)):(this.m.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Ae),!1)}P(Ce,De){const Re=this.B(this.j.createInstance(ee.$D$b,Ce,De)),we=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ne=await Re.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$4U(Ne,"main")})();return{sharedProcessReady:(async()=>(await Re.whenReady(),we))(),sharedProcessClient:we}}async Q(Ce,De,Re){const we=new oe.$6h;switch(process.platform){case"win32":we.set(fe.$UV,new G.$5h(je.$O$b));break;case"linux":k.$l?we.set(fe.$UV,new G.$5h(Te.$N$b,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(fe.$UV,new G.$5h(Me.$M$b));break;case"darwin":we.set(fe.$UV,new G.$5h(Ie.$L$b));break}we.set(Se.$w0b,new G.$5h(ye.$Z$b,[Ce,De,this.h],!1)),we.set(ht.$h$b,new G.$5h(Mt.$h_b,void 0,!1));const Ae=new C.$s0b(this.m,this.z);we.set(C.$r0b,Ae),we.set(W.$p$b,new G.$5h(W.$q$b,void 0,!1)),we.set(E.$60b,new G.$5h(E.$70b,void 0,!1)),we.set(I.$Lm,a.ProxyChannel.toService((0,a.$Nh)(Re.then(Fe=>Fe.getChannel("diagnostics"))))),we.set(he.$DAb,new G.$5h(K.$l$b,[this.h])),we.set(j.$EV,new G.$5h(U.$80b)),we.set(R.$m$b,new G.$5h(R.$n$b)),we.set(V.$j$b,new G.$5h(V.$k$b,void 0,!1)),we.set(ie.$T$b,new G.$5h(ge.$V$b)),we.set(Q.$y$b,new G.$5h(Q.$z$b)),we.set(le.$90b,new G.$5h(re.$$0b)),we.set(Ee.$V0b,new G.$5h(Ee.$W0b)),we.set(Ee.$X0b,new G.$5h(Ee.$Y0b));const Ne=new At.$d_b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),ze=new Ot.$Zr(Ne,this.u,this.m,this.n);we.set(lt.$Ar,ze),k.$i?we.set(ue.$_0b,new G.$5h(Z.$a$b)):k.$j?we.set(ue.$_0b,new G.$5h(Z.$b$b)):k.$k&&we.set(ue.$_0b,new G.$5h(Z.$c$b));const Ke=new c.$10b(this.s,this.u,this.m,this.w);we.set(n.$q0b,Ke);const We=new Xe.$J0b(this.s,this.m,this.C,Ke,Ae);if(we.set(Xe.$I0b,We),we.set(qe.$7cb,new G.$5h(xe.$2$b,void 0,!1)),we.set(Ye.$v$b,new G.$5h(Ye.$w$b,void 0,!1)),we.set(Je.$KV,new G.$5h(Ve.$MV,void 0,!1)),(0,te.$Uo)(this.z,this.s)){const Fe=(0,te.$Zo)(this.z,this.u),Ge=(0,a.$Nh)(Re.then(rt=>rt.getChannel("telemetryAppender"))),Ze=new ke.$G$b(Ge),_e=(0,Pe.$Lo)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,Ce,De,Fe),tt=(0,te.$1o)(this.s),it={appenders:[Ze],commonProperties:_e,piiPaths:tt,sendErrorTelemetry:!0};we.set(Le.$wl,new G.$5h(pe.$rr,[it],!1))}else we.set(Le.$wl,te.$Po);return we.set(yt.$Xp,new G.$5h(Pt.$WO,void 0,!0)),we.set(vt.$2p,new G.$5h(kt.$5$b,void 0,!0)),we.set(ct.$b_b,new G.$5h(ct.$c_b,void 0,!0)),await at.Promises.settled([Ke.initialize(),We.initialize()]),this.j.createChild(we)}R(Ce,De,Re){const we=this.B(new h.$Sc),Ae=a.ProxyChannel.fromService(Ce.get(W.$p$b),we,{disableMarshalling:!0});this.g.registerChannel("launch",Ae);const Ne=a.ProxyChannel.fromService(Ce.get(E.$60b),we,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Ne);const ze=new nt.$3$b(Ce.get(Qe.$Mn));De.registerChannel("policy",ze),Re.then(et=>et.registerChannel("policy",ze));const Ke=this.y.getProvider(m.Schemas.file);(0,g.$Tf)(Ke instanceof T.$Dq);const We=new L.$d$b(Ke,this.m,this.s);De.registerChannel(X.$FO,We),Re.then(et=>et.registerChannel(X.$FO,We));const Fe=a.ProxyChannel.fromService(Ce.get(st.$z0b),we);De.registerChannel("userDataProfiles",Fe),Re.then(et=>et.registerChannel("userDataProfiles",Fe));const Ge=new ot.$mr(Ce.get(pt.$jp));Re.then(et=>et.registerChannel("request",Ge));const Ze=new $e.$H$b(Ce.get(fe.$UV));De.registerChannel("update",Ze);const _e=a.ProxyChannel.fromService(Ce.get(he.$DAb),we);De.registerChannel("issue",_e);const tt=a.ProxyChannel.fromService(Ce.get(j.$EV),we);De.registerChannel("encryption",tt);const it=a.ProxyChannel.fromService(Ce.get(ne.$kl),we);De.registerChannel("sign",it);const rt=a.ProxyChannel.fromService(Ce.get(R.$m$b),we);De.registerChannel("keyboardLayout",rt),this.f=Ce.get(V.$j$b);const mt=a.ProxyChannel.fromService(this.f,we);De.registerChannel("nativeHost",mt),Re.then(et=>et.registerChannel("nativeHost",mt));const jt=a.ProxyChannel.fromService(Ce.get(qe.$7cb),we);De.registerChannel("workspaces",jt);const Lt=a.ProxyChannel.fromService(Ce.get(Q.$y$b),we);De.registerChannel("menubar",Lt);const Wt=a.ProxyChannel.fromService(Ce.get(Je.$KV),we);De.registerChannel("url",Wt);const Ft=a.ProxyChannel.fromService(Ce.get(ie.$T$b),we);De.registerChannel("webview",Ft);const wt=this.B(new me.$E$b(this.m,Ce.get(Ee.$V0b)));De.registerChannel("storage",wt),Re.then(et=>et.registerChannel("storage",wt));const Ut=this.B(new St.$7$b(Ce.get(Ee.$V0b),Ce.get(st.$z0b),this.m));Re.then(et=>et.registerChannel("profileStorageListener",Ut));const Tt=a.ProxyChannel.fromService(Ce.get(lt.$Ar),we);De.registerChannel(lt.TerminalIpcChannels.LocalPty,Tt);const Nt=a.ProxyChannel.fromService(Ce.get(ue.$_0b),we);De.registerChannel("externalTerminal",Nt);const bt=new It.$_$b(Ce.get(Ct.$K0b));De.registerChannel("logger",bt),Re.then(et=>et.registerChannel("logger",bt));const zt=new A.$20b(Ce.get(Se.$w0b));De.registerChannel("extensionhostdebugservice",zt);const Bt=a.ProxyChannel.fromService(Ce.get(le.$90b),we);De.registerChannel(le.$00b,Bt);const qt=a.ProxyChannel.fromService(Ce.get(ct.$b_b),we);De.registerChannel(Dt.$a_b,qt)}async S(Ce,De){const Re=this.b=Ce.get(Se.$w0b);this.c=Ce.get(ht.$h$b);const we=(0,H.$8l)(process.env)?0:4,Ae=this.s.args;if(De){if(De.openables.length>0)return Re.open({context:we,cli:Ae,urisToOpen:De.openables,gotoLineMode:!0,initialStartup:!0});if(De.urls.length>0)for(const it of De.urls){const rt=new URLSearchParams(it.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:rt.toString()}),Re.open({context:we,cli:Ae,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,ze=Ae._.length,Ke=!!Ae["folder-uri"],We=!!Ae["file-uri"],Fe=Ae["skip-add-to-recently-opened"]===!0,Ge=Ae.wait&&Ae.waitMarkerFilePath?l.URI.file(Ae.waitMarkerFilePath):void 0,Ze=Ae.remote||void 0,_e=Ae.profile,tt=Ae["profile-temp"];if(!ze&&!Ke&&!We){if(Ae["new-window"]||_e||tt)return Re.open({context:we,cli:Ae,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Fe,waitMarkerFileURI:Ge,initialStartup:!0,remoteAuthority:Ze,forceProfile:_e,forceTempProfile:tt});if(Ne.length)return Re.open({context:1,cli:Ae,urisToOpen:Ne.map(it=>(0,Ue.$Ai)(it)?{workspaceUri:l.URI.file(it)}:{fileUri:l.URI.file(it)}),noRecentEntry:Fe,waitMarkerFileURI:Ge,initialStartup:!0})}return Re.open({context:we,cli:Ae,forceNewWindow:Ae["new-window"]||!ze&&Ae["unity-launch"],diffMode:Ae.diff,mergeMode:Ae.merge,noRecentEntry:Fe,waitMarkerFileURI:Ge,gotoLineMode:Ae.goto,initialStartup:!0,remoteAuthority:Ze,forceProfile:_e,forceTempProfile:tt})}U(){this.W(),S.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(Ce,De)=>{De({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})}),this.X(this.s.args,process.env,!0),this.Y(),k.$j&&S.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ce=this.z.win32MutexName;if(k.$i&&Ce)try{const De=await new Promise((we,Ae)=>{Y(["@vscode/windows-mutex"],we,Ae)}),Re=new De.Mutex(Ce);b.Event.once(this.t.onWillShutdown)(()=>Re.release())}catch(De){this.m.error(De)}}async X(Ce,De,Re){try{return await(0,J.$bm)(this.u,this.m,Ce,De)}catch(we){const Ae=(0,P.$Si)(we);Re?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ae):this.m.error(Ae)}return{}}async Y(){try{const De=(await this.y.readFile(this.s.argvResource)).value.toString(),Re=JSON.parse((0,v.$nn)(De)),Ae=(0,te.$Wo)(this.u)>=1;if(Re["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ae},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,f.$rg)()}"`,"}"],ze=De.substring(0,De.length-2).concat(`,
`,Ne.join(`
`));await this.y.writeFile(this.s.argvResource,D.$ke.fromString(ze))}else{const Ne=De.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ae},`);Ne!==De&&await this.y.writeFile(this.s.argvResource,D.$ke.fromString(Ne))}}catch(Ce){this.m.error(Ce)}}};e.$i_b=dt,e.$i_b=dt=ft=ve([se(2,B.$7h),se(3,N.$pj),se(4,N.$qj),se(5,F.$l0b),se(6,x.$P0b),se(7,w.$Bi),se(8,de.$PO),se(9,q.$sk),se(10,_.$Hj),se(11,st.$z0b)],dt)}),define(ae[313],ce([0,1,15,46,7,22,8,51,14,33,3,47,13,9,67,4,36,25,21,43,100,308,10,18,238,250,24,64,202,16,222,93,77,218,92,20,225,5,79,27,80,278,128,287,53,286,95,249,34,54,69,57,39,234,232,2,40,266,68,227,117,123,270,264]),function(Y,e,S,O,s,M,D,P,d,u,b,v,y,h,m,p,k,g,l,f,$,a,t,o,r,i,n,c,w,A,I,E,C,j,U,F,H,J,le,re,ue,Z,X,q,L,T,G,B,oe,he,K,R,W,x,N,Q,V,_,z,ee,ne,de,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ee{main(){try{this.a()}catch(ke){console.error(ke.message),S.app.exit(1)}}async a(){(0,d.setUnexpectedErrorHandler)(je=>console.error(je));const[ke,pe,te,fe,$e,Ie,Me,Te]=this.b();try{try{await this.d(te,Te,fe,$e,Me)}catch(je){throw this.f(te,Me,je),je}await ke.invokeFunction(async je=>{const Je=je.get(J.$pj),Be=je.get(F.$P0b),Ve=je.get(A.$sk),He=je.get(J.$qj),ie=await this.e(Je,te,Be,ke,Me,!0);return l.Promises.writeFile(te.mainLockfile,String(process.pid)).catch(ge=>{Je.warn(`app#startup(): Error writing main lockfile: ${ge.stack}`)}),Ie.logger=He.createLogger("main",{name:(0,t.localize)(0,null)}),b.Event.once(Be.onWillShutdown)(ge=>{Ve.dispose(),fe.dispose(),ge.join("instanceLockfile",l.Promises.unlink(te.mainLockfile).catch(()=>{}))}),ke.createInstance(a.$i_b,ie,pe).startup()})}catch(je){ke.invokeFunction(this.i,je)}}b(){const ke=new U.$6h,pe=new Q.$Sc;process.once("exit",()=>pe.dispose());const te={_serviceBrand:void 0,...le.default};ke.set(re.$Hj,te);const fe=new n.$m0b(this.j(),te),$e=this.c(fe);ke.set(n.$l0b,fe);const Ie=new z.$L0b((0,J.$Dj)(fe),fe.logsHome);ke.set(z.$K0b,Ie);const Me=new H.$77b(Ie.getLogLevel()),Te=pe.add(new ee.$XO(Me,[new J.$wj(Ie.getLogLevel())]));ke.set(J.$pj,Te);const je=new I.$eq(Te);ke.set(A.$sk,je);const Je=new E.$Dq(Te);je.registerProvider(y.Schemas.file,Je);const Be=new _.$4r(je);ke.set(V.$3k,Be);const Ve=new de.$SO(1,fe,Te,je);ke.set(oe.$OO,Ve),ke.set(oe.$PO,Ve);const He=new R.$A0b(Ve,Be,fe,je,Te);ke.set(R.$z0b,He),je.registerProvider(y.Schemas.vscodeUserData,new me.$t_b(y.Schemas.file,Je,y.Schemas.vscodeUserData,He,Be,Te));const ie=p.$i&&te.win32RegValueName?pe.add(new x.$r_b(Te,te.win32RegValueName)):fe.policyFile?pe.add(new N.$s_b(fe.policyFile,je,Te)):new W.$On;ke.set(W.$Mn,ie);const ge=new r.$co(He.defaultProfile.settingsResource,je,ie,Te);return ke.set(o.$Bi,ge),ke.set(F.$P0b,new C.$5h(F.$Q0b,void 0,!1)),ke.set(L.$jp,new C.$5h(T.$p_b,void 0,!0)),ke.set(K.$u0b,new C.$5h(K.$v0b)),ke.set(G.$kl,new C.$5h(B.$q_b,void 0,!1)),ke.set(X.$Cv,new C.$5h(q.$n_b)),ke.set(ue.$t0b,new Z.$k_b(fe,He,Te)),[new j.$Gq(ke,!0),$e,fe,ge,Ve,Me,te,He]}c(ke){const pe={VSCODE_IPC_HOOK:ke.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(te=>{const fe=process.env[te];typeof fe=="string"&&(pe[te]=fe)}),Object.assign(process.env,pe),pe}async d(ke,pe,te,fe,$e){await D.Promises.settled([Promise.all([ke.extensionsPath,ke.codeCachePath,ke.logsHome.with({scheme:y.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,ke.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,ke.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,ke.backupHome].map(Ie=>Ie?l.Promises.mkdir(Ie,{recursive:!0}):void 0)),fe.init(),te.initialize()]),pe.init()}async e(ke,pe,te,fe,$e,Ie){let Me;try{(0,m.mark)("code/willStartMainServer"),Me=await(0,$.$3h)(pe.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),b.Event.once(te.onWillShutdown)(()=>Me.dispose())}catch(Te){if(Te.code!=="EADDRINUSE")throw this.f(pe,$e,Te),Te;let je;try{je=await(0,$.$4h)(pe.mainIPCHandle,"main")}catch(He){if(!Ie||p.$i||He.code!=="ECONNREFUSED")throw He.code==="EPERM"&&this.g((0,t.localize)(1,null,$e.nameShort),(0,t.localize)(2,null),$e),He;try{(0,O.unlinkSync)(pe.mainIPCHandle)}catch(ie){throw ke.warn("Could not delete obsolete instance handle",ie),ie}return this.e(ke,pe,te,fe,$e,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const He=`Running extension tests from the command line is currently only supported if no other instance of ${$e.nameShort} is running.`;throw ke.error(He),je.dispose(),new Error(He)}let Je;!pe.args.wait&&!pe.args.status&&(Je=setTimeout(()=>{this.g((0,t.localize)(3,null,$e.nameShort),(0,t.localize)(4,null),$e)},1e4));const Be=f.ProxyChannel.toService(je.getChannel("launch"),{disableMarshalling:!0}),Ve=f.ProxyChannel.toService(je.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return fe.invokeFunction(async()=>{const He=new i.$$r(he.$Po,$e),ie=await Ve.getMainDiagnostics(),ge=await Ve.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),be=await He.getDiagnostics(ie,ge);throw console.log(be),new d.$ab});throw p.$i&&await this.h(Be,ke),ke.trace("Sending env to running instance..."),await Be.start(pe.args,process.env),je.dispose(),Je&&clearTimeout(Je),new d.$ab("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,t.localize)(5,null,$e.nameShort)),new d.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Me}f(ke,pe,te){if(te.code==="EACCES"||te.code==="EPERM"){const fe=(0,M.$Hb)([ke.userDataPath,ke.extensionsPath,$.$Yh]).map($e=>(0,v.$Xv)(s.URI.file($e),{os:p.OS,tildify:ke}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,P.$Si)(te),fe.join(`
`)),pe)}}g(ke,pe,te){S.dialog.showMessageBoxSync((0,ne.$_v)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ke,detail:pe},te).options)}async h(ke,pe){if(p.$i){const te=await ke.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",te);try{(await new Promise((fe,$e)=>{Y(["windows-foreground-love"],fe,$e)})).allowSetForegroundWindow(te)}catch(fe){pe.error(fe)}}}i(ke,pe){const te=ke.get(J.$pj),fe=ke.get(F.$P0b);let $e=0;pe&&(pe.isExpected?pe.message&&te.trace(pe.message):($e=1,pe.stack?te.error(pe.stack):te.error(`Startup error: ${pe.toString()}`))),fe.kill($e)}j(){const ke=this.k((0,c.$5l)(process.argv));if(ke.wait&&!ke.waitMarkerFilePath){const pe=(0,w.$j_b)(ke.verbose);pe&&((0,c.$7l)(process.argv,"--waitMarkerFilePath",pe),ke.waitMarkerFilePath=pe)}return ke}k(ke){if(ke["open-url"]&&(ke._urls=ke._,ke._=[]),!ke.remote){const pe=this.l(ke._,ke.goto);ke._=pe}return ke}l(ke,pe){const te=(0,k.cwd)(),fe=ke.map(Me=>{let Te=String(Me),je;pe&&(je=(0,u.$dg)(Te),Te=je.path),Te&&(Te=this.m(te,Te));const Je=(0,u.$$f)(Te,te),Be=(0,h.$nc)(Je);return Be&&!(0,u.$7f)(Be)?null:pe&&je?(je.path=Je,this.n(je)):Je}),$e=p.$i||p.$j,Ie=(0,M.$Mb)(fe,Me=>Me&&$e?Me.toLowerCase():Me||"");return(0,M.$Hb)(Ie)}m(ke,pe){return p.$i&&(pe=(0,g.$Ve)(pe,'"')),pe=(0,g.$Te)((0,g.$Te)(pe," "),"	"),p.$i&&(pe=(0,h.$kc)(ke,pe),pe=(0,g.$Ve)(pe,".")),pe}n(ke){const pe=[ke.path];return typeof ke.line=="number"&&pe.push(String(ke.line)),typeof ke.column=="number"&&pe.push(String(ke.column)),pe.join(":")}}new Ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/420099cb092f0994ecb1e7af4c679dc0ffe57fa3/core/vs/code/electron-main/main.js.map
