/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/uri","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(se){for(var e=[],O=0,A=se.length;O<A;O++)e[O]=le[se[O]];return e};define(le[124],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class O{static get(){const D=new Map,L=new Map,I=new Map,R=new Map;function S(h,$){h.has($.detail)||h.set($.detail,-$.timestamp)}function g(h,$){const p=h.get($.detail);p&&(p>=0||h.set($.detail,p+$.timestamp))}let P=[];typeof se=="function"&&typeof se.getStats=="function"&&(P=se.getStats().slice(0).sort((h,$)=>h.timestamp-$.timestamp));for(const h of P)switch(h.type){case 10:S(D,h);break;case 11:case 12:g(D,h);break;case 21:S(L,h);break;case 22:g(L,h);break;case 33:S(I,h);break;case 34:g(I,h);break;case 31:S(R,h);break;case 32:g(R,h);break}let k=0;I.forEach(h=>k+=h);function m(h){const $=[];return h.forEach((p,E)=>$.push([E,p])),$}return{amdLoad:m(D),amdInvoke:m(L),nodeRequire:m(I),nodeEval:m(R),nodeRequireTotal:k}}static toMarkdownTable(D,L){let I="";const R=[];return D.forEach((S,g)=>{R[g]=S.length}),L.forEach(S=>{S.forEach((g,P)=>{typeof g>"u"&&(g=S[P]="-");const k=g.toString().length;R[P]=Math.max(k,R[P])})}),D.forEach((S,g)=>{I+=`| ${S+" ".repeat(R[g]-S.toString().length)} `}),I+=`|
`,D.forEach((S,g)=>{I+=`| ${"-".repeat(R[g])} `}),I+=`|
`,L.forEach(S=>{S.forEach((g,P)=>{typeof g<"u"&&(I+=`| ${g+" ".repeat(R[P]-g.toString().length)} `)}),I+=`|
`}),I}}e.$U=O}),define(le[125],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function O(p,E,l){const u=A(p,E);if(u!==-1)return p[u]}e.$fb=O;function A(p,E,l=p.length-1){for(let u=l;u>=0;u--){const d=p[u];if(E(d))return u}return-1}e.$gb=A;function D(p,E){const l=L(p,E);return l===-1?void 0:p[l]}e.$hb=D;function L(p,E,l=0,u=p.length){let d=l,c=u;for(;d<c;){const y=Math.floor((d+c)/2);E(p[y])?d=y+1:c=y}return d-1}e.$ib=L;function I(p,E){const l=R(p,E);return l===p.length?void 0:p[l]}e.$jb=I;function R(p,E,l=0,u=p.length){let d=l,c=u;for(;d<c;){const y=Math.floor((d+c)/2);E(p[y])?c=y:d=y+1}return d}e.$kb=R;function S(p,E,l=0,u=p.length){const d=R(p,E,l,u);return d===p.length?-1:d}e.$lb=S;class g{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(g.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!E(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const l=L(this.e,E,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=g;function P(p,E){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const d=p[u];E(d,l)>0&&(l=d)}return l}e.$nb=P;function k(p,E){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const d=p[u];E(d,l)>=0&&(l=d)}return l}e.$ob=k;function m(p,E){return P(p,(l,u)=>-E(l,u))}e.$pb=m;function h(p,E){if(p.length===0)return-1;let l=0;for(let u=1;u<p.length;u++){const d=p[u];E(d,p[l])>0&&(l=u)}return l}e.$qb=h;function $(p,E){for(const l of p){const u=E(l);if(u!==void 0)return u}}e.$rb=$}),define(le[126],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function O(I,R){const S=Object.create(null);for(const g of I){const P=R(g);let k=S[P];k||(k=S[P]=[]),k.push(g)}return S}e.$K=O;function A(I,R){const S=[],g=[];for(const P of I)R.has(P)||S.push(P);for(const P of R)I.has(P)||g.push(P);return{removed:S,added:g}}e.$L=A;function D(I,R){const S=[],g=[];for(const[P,k]of I)R.has(P)||S.push(k);for(const[P,k]of R)I.has(P)||g.push(k);return{removed:S,added:g}}e.$M=D;function L(I,R){const S=new Set;for(const g of R)I.has(g)&&S.add(g);return S}e.$N=L}),define(le[85],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function O(I){return(R,S,g)=>{let P=null,k=null;if(typeof g.value=="function"?(P="value",k=g.value):typeof g.get=="function"&&(P="get",k=g.get),!k)throw new Error("not supported");g[P]=I(k,S)}}function A(I,R,S){let g=null,P=null;if(typeof S.value=="function"?(g="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(g="get",P=S.get),!P)throw new Error("not supported");const k=`$memoize$${R}`;S[g]=function(...m){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,m)}),this[k]}}e.$zh=A;function D(I,R,S){return O((g,P)=>{const k=`$debounce$${P}`,m=`$debounce$result$${P}`;return function(...h){this[m]||(this[m]=S?S():void 0),clearTimeout(this[k]),R&&(this[m]=R(this[m],...h),h=[this[m]]),this[k]=setTimeout(()=>{g.apply(this,h),this[m]=S?S():void 0},I)}})}e.$Ah=D;function L(I,R,S){return O((g,P)=>{const k=`$throttle$timer$${P}`,m=`$throttle$result$${P}`,h=`$throttle$lastRun$${P}`,$=`$throttle$pending$${P}`;return function(...p){if(this[m]||(this[m]=S?S():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...p)),this[$])return;const E=this[h]+I;E<=Date.now()?(this[h]=Date.now(),g.apply(this,[this[m]]),this[m]=S?S():void 0):(this[$]=!0,this[k]=setTimeout(()=>{this[$]=!1,this[h]=Date.now(),g.apply(this,[this[m]]),this[m]=S?S():void 0},E-Date.now()))}})}e.$Bh=L}),define(le[7],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class O{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?d.isErrorNoTelemetry(i)?new d(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=O,e.$X=new O;function A(y){e.$X.setUnexpectedErrorHandler(y)}e.setUnexpectedErrorHandler=A;function D(y){if(!y||typeof y!="object")return!1;const i=y;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=D;function L(y){g(y)||e.$X.onUnexpectedError(y)}e.$1=L;function I(y){g(y)||e.$X.onUnexpectedExternalError(y)}e.$2=I;function R(y){if(y instanceof Error){const{name:i,message:o}=y,n=y.stacktrace||y.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:d.isErrorNoTelemetry(y)}}return y}e.$3=R;const S="Canceled";function g(y){return y instanceof P?!0:y instanceof Error&&y.name===S&&y.message===S}e.$4=g;class P extends Error{constructor(){super(S),this.name=this.message}}e.$5=P;function k(){const y=new Error(S);return y.name=y.message,y}e.$6=k;function m(y){return y?new Error(`Illegal argument: ${y}`):new Error("Illegal argument")}e.$7=m;function h(y){return y?new Error(`Illegal state: ${y}`):new Error("Illegal state")}e.$8=h;class $ extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=$;function p(y){return y?y.message?y.message:y.stack?y.stack.split(`
`)[0]:String(y):"Error"}e.$0=p;class E extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=E;class l extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=l;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class d extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof d)return i;const o=new d;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=d;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(le[17],he([0,1,7,125]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function D(U,Z=0){return U[U.length-(1+Z)]}e.$sb=D;function L(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.$tb=L;function I(U,Z,_=(ie,J)=>ie===J){if(U===Z)return!0;if(!U||!Z||U.length!==Z.length)return!1;for(let ie=0,J=U.length;ie<J;ie++)if(!_(U[ie],Z[ie]))return!1;return!0}e.$ub=I;function R(U,Z){const _=U.length-1;Z<_&&(U[Z]=U[_]),U.pop()}e.$vb=R;function S(U,Z,_){return g(U.length,ie=>_(U[ie],Z))}e.$wb=S;function g(U,Z){let _=0,ie=U-1;for(;_<=ie;){const J=(_+ie)/2|0,ne=Z(J);if(ne<0)_=J+1;else if(ne>0)ie=J-1;else return J}return-(_+1)}e.$xb=g;function P(U,Z,_){if(U=U|0,U>=Z.length)throw new TypeError("invalid index");const ie=Z[Math.floor(Z.length*Math.random())],J=[],ne=[],ce=[];for(const fe of Z){const de=_(fe,ie);de<0?J.push(fe):de>0?ne.push(fe):ce.push(fe)}return U<J.length?P(U,J,_):U<J.length+ce.length?ce[0]:P(U-(J.length+ce.length),ne,_)}e.$yb=P;function k(U,Z){const _=[];let ie;for(const J of U.slice(0).sort(Z))!ie||Z(ie[0],J)!==0?(ie=[J],_.push(ie)):ie.push(J);return _}e.$zb=k;function*m(U,Z){let _,ie;for(const J of U)ie!==void 0&&Z(ie,J)?_.push(J):(_&&(yield _),_=[J]),ie=J;_&&(yield _)}e.$Ab=m;function h(U,Z){for(let _=0;_<=U.length;_++)Z(_===0?void 0:U[_-1],_===U.length?void 0:U[_])}e.$Bb=h;function $(U,Z){for(let _=0;_<U.length;_++)Z(_===0?void 0:U[_-1],U[_],_+1===U.length?void 0:U[_+1])}e.$Cb=$;function p(U,Z,_){const ie=[];function J(fe,de,me){if(de===0&&me.length===0)return;const Ee=ie[ie.length-1];Ee&&Ee.start+Ee.deleteCount===fe?(Ee.deleteCount+=de,Ee.toInsert.push(...me)):ie.push({start:fe,deleteCount:de,toInsert:me})}let ne=0,ce=0;for(;;){if(ne===U.length){J(ne,0,Z.slice(ce));break}if(ce===Z.length){J(ne,U.length-ne,[]);break}const fe=U[ne],de=Z[ce],me=_(fe,de);me===0?(ne+=1,ce+=1):me<0?(J(ne,1,[]),ne+=1):me>0&&(J(ne,0,[de]),ce+=1)}return ie}e.$Db=p;function E(U,Z,_){const ie=p(U,Z,_),J=[],ne=[];for(const ce of ie)J.push(...U.slice(ce.start,ce.start+ce.deleteCount)),ne.push(...ce.toInsert);return{removed:J,added:ne}}e.$Eb=E;function l(U,Z,_){if(_===0)return[];const ie=U.slice(0,_).sort(Z);return d(U,Z,ie,_,U.length),ie}e.top=l;function u(U,Z,_,ie,J){return _===0?Promise.resolve([]):new Promise((ne,ce)=>{(async()=>{const fe=U.length,de=U.slice(0,_).sort(Z);for(let me=_,Ee=Math.min(_+ie,fe);me<fe;me=Ee,Ee=Math.min(Ee+ie,fe)){if(me>_&&await new Promise(Pe=>setTimeout(Pe)),J&&J.isCancellationRequested)throw new O.$5;d(U,Z,de,me,Ee)}return de})().then(ne,ce)})}e.$Gb=u;function d(U,Z,_,ie,J){for(const ne=_.length;ie<J;ie++){const ce=U[ie];if(Z(ce,_[ne-1])<0){_.pop();const fe=(0,A.$kb)(_,de=>Z(ce,de)<0);_.splice(fe,0,ce)}}}function c(U){return U.filter(Z=>!!Z)}e.$Hb=c;function y(U){let Z=0;for(let _=0;_<U.length;_++)U[_]&&(U[Z]=U[_],Z+=1);U.length=Z}e.$Ib=y;function i(U,Z,_){U.splice(_,0,U.splice(Z,1)[0])}e.$Jb=i;function o(U){return!Array.isArray(U)||U.length===0}e.$Kb=o;function n(U){return Array.isArray(U)&&U.length>0}e.$Lb=n;function s(U,Z=_=>_){const _=new Set;return U.filter(ie=>{const J=Z(ie);return _.has(J)?!1:(_.add(J),!0)})}e.$Mb=s;function t(U){const Z=new Set;return _=>{const ie=U(_);return Z.has(ie)?!1:(Z.add(ie),!0)}}e.$Nb=t;function r(U,Z){return U.length>0?U[0]:Z}e.$Ob=r;function a(U,Z){return U.length>0?U[U.length-1]:Z}e.$Pb=a;function v(U,Z,_=(ie,J)=>ie===J){let ie=0;for(let J=0,ne=Math.min(U.length,Z.length);J<ne&&_(U[J],Z[J]);J++)ie++;return ie}e.$Qb=v;function w(U){return[].concat(...U)}e.$Rb=w;function f(U,Z){let _=typeof Z=="number"?U:0;typeof Z=="number"?_=U:(_=0,Z=U);const ie=[];if(_<=Z)for(let J=_;J<Z;J++)ie.push(J);else for(let J=_;J>Z;J--)ie.push(J);return ie}e.$Sb=f;function b(U,Z,_){return U.reduce((ie,J)=>(ie[Z(J)]=_?_(J):J,ie),Object.create(null))}e.$Tb=b;function C(U,Z){return U.push(Z),()=>N(U,Z)}e.$Ub=C;function N(U,Z){const _=U.indexOf(Z);if(_>-1)return U.splice(_,1),Z}e.$Vb=N;function T(U,Z,_){const ie=U.slice(0,Z),J=U.slice(Z);return ie.concat(_,J)}e.$Wb=T;function M(U,Z){let _;if(typeof Z=="number"){let ie=Z;_=()=>{const J=Math.sin(ie++)*179426549;return J-Math.floor(J)}}else _=Math.random;for(let ie=U.length-1;ie>0;ie-=1){const J=Math.floor(_()*(ie+1)),ne=U[ie];U[ie]=U[J],U[J]=ne}}e.$Xb=M;function q(U,Z){const _=U.indexOf(Z);_>-1&&(U.splice(_,1),U.unshift(Z))}e.$Yb=q;function Y(U,Z){const _=U.indexOf(Z);_>-1&&(U.splice(_,1),U.push(Z))}e.$Zb=Y;function X(U,Z){for(const _ of Z)U.push(_)}e.$1b=X;function x(U,Z){return Array.isArray(U)?U.map(Z):Z(U)}e.$2b=x;function V(U){return Array.isArray(U)?U:[U]}e.$3b=V;function Q(U){return U[Math.floor(Math.random()*U.length)]}e.$4b=Q;function H(U,Z,_){const ie=te(U,Z),J=U.length,ne=_.length;U.length=J+ne;for(let ce=J-1;ce>=ie;ce--)U[ce+ne]=U[ce];for(let ce=0;ce<ne;ce++)U[ce+ie]=_[ce]}e.$5b=H;function W(U,Z,_,ie){const J=te(U,Z);let ne=U.splice(J,_);return ne===void 0&&(ne=[]),H(U,J,ie),ne}e.$6b=W;function te(U,Z){return Z<0?Math.max(Z+U.length,0):Math.min(Z,U.length)}var oe;(function(U){function Z(ne){return ne<0}U.isLessThan=Z;function _(ne){return ne<=0}U.isLessThanOrEqual=_;function ie(ne){return ne>0}U.isGreaterThan=ie;function J(ne){return ne===0}U.isNeitherLessOrGreaterThan=J,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function ee(U,Z){return(_,ie)=>Z(U(_),U(ie))}e.$7b=ee;function ae(...U){return(Z,_)=>{for(const ie of U){const J=ie(Z,_);if(!oe.isNeitherLessOrGreaterThan(J))return J}return oe.neitherLessOrGreaterThan}}e.$8b=ae;const G=(U,Z)=>U-Z;e.$9b=G;const z=(U,Z)=>(0,e.$9b)(U?1:0,Z?1:0);e.$0b=z;function j(U){return(Z,_)=>-U(Z,_)}e.$$b=j;class F{constructor(Z){this.g=Z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let _=this.c;for(;_<this.g.length&&Z(this.g[_]);)_++;const ie=_===this.c?null:this.g.slice(this.c,_);return this.c=_,ie}takeFromEndWhile(Z){let _=this.d;for(;_>=0&&Z(this.g[_]);)_--;const ie=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Z=this.g[this.c];return this.c++,Z}removeLast(){const Z=this.g[this.d];return this.d--,Z}takeCount(Z){const _=this.g.slice(this.c,this.c+Z);return this.c+=Z,_}}e.$_b=F;class B{static{this.empty=new B(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(_=>(Z(_),!0))}toArray(){const Z=[];return this.iterate(_=>(Z.push(_),!0)),Z}filter(Z){return new B(_=>this.iterate(ie=>Z(ie)?_(ie):!0))}map(Z){return new B(_=>this.iterate(ie=>_(Z(ie))))}some(Z){let _=!1;return this.iterate(ie=>(_=Z(ie),!_)),_}findFirst(Z){let _;return this.iterate(ie=>Z(ie)?(_=ie,!1):!0),_}findLast(Z){let _;return this.iterate(ie=>(Z(ie)&&(_=ie),!0)),_}findLastMaxBy(Z){let _,ie=!0;return this.iterate(J=>((ie||oe.isGreaterThan(Z(J,_)))&&(ie=!1,_=J),!0)),_}}e.$ac=B}),define(le[127],he([0,1,7]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function A(g,P){if(!g)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=A;function D(g,P="Unreachable"){throw new Error(P)}e.$6c=D;function L(g){if(!g)throw new O.$cb("Assertion Failed")}e.$7c=L;function I(g){g||(0,O.$1)(new O.$cb("Assertion Failed"))}e.$8c=I;function R(g){if(!g()){debugger;g(),(0,O.$1)(new O.$cb("Assertion Failed"))}}e.$9c=R;function S(g,P){let k=0;for(;k<g.length-1;){const m=g[k],h=g[k+1];if(!P(m,h))return!1;k++}return!0}e.$0c=S}),define(le[86],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function O(A,D){const L=this;let I=!1,R;return function(){if(I)return R;if(I=!0,D)try{R=A.apply(L,arguments)}finally{D()}else R=A.apply(L,arguments);return R}}e.$db=O}),define(le[61],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var O;(function(A){function D(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}A.is=D;const L=Object.freeze([]);function I(){return L}A.empty=I;function*R(i){yield i}A.single=R;function S(i){return D(i)?i:R(i)}A.wrap=S;function g(i){return i||L}A.from=g;function*P(i){for(let o=i.length-1;o>=0;o--)yield i[o]}A.reverse=P;function k(i){return!i||i[Symbol.iterator]().next().done===!0}A.isEmpty=k;function m(i){return i[Symbol.iterator]().next().value}A.first=m;function h(i,o){for(const n of i)if(o(n))return!0;return!1}A.some=h;function $(i,o){for(const n of i)if(o(n))return n}A.find=$;function*p(i,o){for(const n of i)o(n)&&(yield n)}A.filter=p;function*E(i,o){let n=0;for(const s of i)yield o(s,n++)}A.map=E;function*l(...i){for(const o of i)yield*o}A.concat=l;function u(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}A.reduce=u;function*d(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}A.slice=d;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,A.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}A.consume=c;async function y(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}A.asyncToArray=y})(O||(e.Iterable=O={}))}),define(le[34],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function I(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,v=0;function w(q){let Y=0,X=0;for(;Y<q;){const x=i.charCodeAt(n);if(x>=48&&x<=57)X=X*16+x-48;else if(x>=65&&x<=70)X=X*16+x-65+10;else if(x>=97&&x<=102)X=X*16+x-97+10;else break;n++,Y++}return Y<q&&(X=-1),X}function f(q){n=q,t="",r=0,a=16,v=0}function b(){const q=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&g(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&g(i.charCodeAt(n)))for(n++;n<i.length&&g(i.charCodeAt(n));)n++;else return v=3,i.substring(q,n);let Y=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&g(i.charCodeAt(n))){for(n++;n<i.length&&g(i.charCodeAt(n));)n++;Y=n}else v=3;return i.substring(q,Y)}function C(){let q="",Y=n;for(;;){if(n>=s){q+=i.substring(Y,n),v=2;break}const X=i.charCodeAt(n);if(X===34){q+=i.substring(Y,n),n++;break}if(X===92){if(q+=i.substring(Y,n),n++,n>=s){v=2;break}switch(i.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const V=w(4);V>=0?q+=String.fromCharCode(V):v=4;break}default:v=5}Y=n;continue}if(X>=0&&X<=31)if(S(X)){q+=i.substring(Y,n),v=2;break}else v=6;n++}return q}function N(){if(t="",v=0,r=n,n>=s)return r=s,a=17;let q=i.charCodeAt(n);if(R(q)){do n++,t+=String.fromCharCode(q),q=i.charCodeAt(n);while(R(q));return a=15}if(S(q))return n++,t+=String.fromCharCode(q),q===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(q){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=C(),a=10;case 47:{const Y=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!S(i.charCodeAt(n));)n++;return t=i.substring(Y,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const X=s-1;let x=!1;for(;n<X;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=i.substring(Y,n),a=13}return t+=String.fromCharCode(q),n++,a=16}case 45:if(t+=String.fromCharCode(q),n++,n===s||!g(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=b(),a=11;default:for(;n<s&&T(q);)n++,q=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(q),n++,a=16}}function T(q){if(R(q)||S(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let q;do q=N();while(q>=12&&q<=15);return q}return{setPosition:f,getPosition:()=>n,scan:o?M:N,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$dn=I;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function g(i){return i>=48&&i<=57}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function k(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(w,f,b,C){r.value=w,r.offset=f,r.length=b,r.type=C,r.colonOffset=void 0,t=r}try{d(i,{onObjectBegin:(w,f)=>{if(o<=w)throw s;t=void 0,a=o>w,n.push("")},onObjectProperty:(w,f,b)=>{if(o<f||(v(w,f,b,"property"),n[n.length-1]=w,o<=f+b))throw s},onObjectEnd:(w,f)=>{if(o<=w)throw s;t=void 0,n.pop()},onArrayBegin:(w,f)=>{if(o<=w)throw s;t=void 0,n.push(0)},onArrayEnd:(w,f)=>{if(o<=w)throw s;t=void 0,n.pop()},onLiteralValue:(w,f,b)=>{if(o<f||(v(w,f,b,y(w)),o<=f+b))throw s},onSeparator:(w,f,b)=>{if(o<=f)throw s;if(w===":"&&t&&t.type==="property")t.colonOffset=f,a=!1,t=void 0;else if(w===","){const C=n[n.length-1];typeof C=="number"?n[n.length-1]=C+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(w){if(w!==s)throw w}return{path:n,previousNode:t,isAtPropertyKey:a,matches:w=>{let f=0;for(let b=0;f<w.length&&b<n.length;b++)if(w[f]===n[b]||w[f]==="*")f++;else if(w[f]!=="**")return!1;return f===w.length}}}e.$en=k;function m(i,o=[],n=L.DEFAULT){let s=null,t=[];const r=[];function a(w){Array.isArray(t)?t.push(w):s!==null&&(t[s]=w)}return d(i,{onObjectBegin:()=>{const w={};a(w),r.push(t),t=w,s=null},onObjectProperty:w=>{s=w},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const w=[];a(w),r.push(t),t=w,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(w,f,b)=>{o.push({error:w,offset:f,length:b})}},n),t[0]}e.$fn=m;function h(i,o=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(w){s.type==="property"&&(s.length=w-s.offset,s=s.parent)}function r(w){return s.children.push(w),w}d(i,{onObjectBegin:w=>{s=r({type:"object",offset:w,length:-1,parent:s,children:[]})},onObjectProperty:(w,f,b)=>{s=r({type:"property",offset:f,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:w,offset:f,length:b,parent:s})},onObjectEnd:(w,f)=>{s.length=w+f-s.offset,s=s.parent,t(w+f)},onArrayBegin:(w,f)=>{s=r({type:"array",offset:w,length:-1,parent:s,children:[]})},onArrayEnd:(w,f)=>{s.length=w+f-s.offset,s=s.parent,t(w+f)},onLiteralValue:(w,f,b)=>{r({type:y(w),offset:f,length:b,parent:s,value:w}),t(f+b)},onSeparator:(w,f,b)=>{s.type==="property"&&(w===":"?s.colonOffset=f:w===","&&t(f))},onError:(w,f,b)=>{o.push({error:w,offset:f,length:b})}},n);const v=s.children[0];return v&&delete v.parent,v}e.$gn=h;function $(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$hn=$;function p(i){if(!i.parent||!i.parent.children)return[];const o=p(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.$in=p;function E(i){switch(i.type){case"array":return i.children.map(E);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=E(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$jn=E;function l(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.$kn=l;function u(i,o,n=!1){if(l(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=u(s[t],o,n);if(r)return r}return i}}e.$ln=u;function d(i,o,n=L.DEFAULT){const s=I(i,!1);function t(ee){return ee?()=>ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ee){return ee?ae=>ee(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),v=r(o.onObjectProperty),w=t(o.onObjectEnd),f=t(o.onArrayBegin),b=t(o.onArrayEnd),C=r(o.onLiteralValue),N=r(o.onSeparator),T=t(o.onComment),M=r(o.onError),q=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function X(){for(;;){const ee=s.scan();switch(s.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:q||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ee){case 12:case 13:q?x(10):T();break;case 16:x(1);break;case 15:case 14:break;default:return ee}}}function x(ee,ae=[],G=[]){if(M(ee),ae.length+G.length>0){let z=s.getToken();for(;z!==17;){if(ae.indexOf(z)!==-1){X();break}else if(G.indexOf(z)!==-1)break;z=X()}}}function V(ee){const ae=s.getTokenValue();return ee?C(ae):v(ae),X(),!0}function Q(){switch(s.getToken()){case 11:{let ee=0;try{ee=JSON.parse(s.getTokenValue()),typeof ee!="number"&&(x(2),ee=0)}catch{x(2)}C(ee);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return X(),!0}function H(){return s.getToken()!==10?(x(3,[],[2,5]),!1):(V(!1),s.getToken()===6?(N(":"),X(),oe()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function W(){a(),X();let ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ee||x(4,[],[]),N(","),X(),s.getToken()===2&&Y)break}else ee&&x(6,[],[]);H()||x(4,[],[2,5]),ee=!0}return w(),s.getToken()!==2?x(7,[2],[]):X(),!0}function te(){f(),X();let ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ee||x(4,[],[]),N(","),X(),s.getToken()===4&&Y)break}else ee&&x(6,[],[]);oe()||x(4,[],[4,5]),ee=!0}return b(),s.getToken()!==4?x(8,[4],[]):X(),!0}function oe(){switch(s.getToken()){case 3:return te();case 1:return W();case 10:return V(!0);default:return Q()}}return X(),s.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):oe()?(s.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$mn=d;function c(i,o){const n=I(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}e.$nn=c;function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$on=y}),define(le[42],he([0,1,34]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.$pn=void 0;function A(g,P,k){let m,h,$,p,E;if(P){for(p=P.offset,E=p+P.length,$=p;$>0&&!S(g,$-1);)$--;let a=E;for(;a<g.length&&!S(g,a);)a++;h=g.substring($,a),m=I(h,k)}else h=g,m=0,$=0,p=0,E=g.length;const l=R(k,g);let u=!1,d=0,c;k.insertSpaces?c=L(" ",k.tabSize||4):c="	";const y=(0,O.$dn)(h,!1);let i=!1;function o(){return l+L(c,m+d)}function n(){let a=y.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=y.scan();return i=a===16||y.getTokenError()!==0,a}const s=[];function t(a,v,w){!i&&v<E&&w>p&&g.substring(v,w)!==a&&s.push({offset:v,length:w-v,content:a})}let r=n();if(r!==17){const a=y.getTokenOffset()+$,v=L(c,m);t(v,$,a)}for(;r!==17;){let a=y.getTokenOffset()+y.getTokenLength()+$,v=n(),w="";for(;!u&&(v===12||v===13);){const b=y.getTokenOffset()+$;t(" ",a,b),a=y.getTokenOffset()+y.getTokenLength()+$,w=v===12?o():"",v=n()}if(v===2)r!==1&&(d--,w=o());else if(v===4)r!==3&&(d--,w=o());else{switch(r){case 3:case 1:d++,w=o();break;case 5:case 12:w=o();break;case 13:u?w=o():w=" ";break;case 6:w=" ";break;case 10:if(v===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?w=" ":v!==5&&v!==17&&(i=!0);break;case 16:i=!0;break}u&&(v===12||v===13)&&(w=o())}const f=y.getTokenOffset()+$;t(w,a,f),r=v}return s}e.$pn=A;function D(g,P){const k=JSON.stringify(g,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?k.replace(/\r\n|\r|\n/g,P.eol):k}e.$qn=D;function L(g,P){let k="";for(let m=0;m<P;m++)k+=g;return k}function I(g,P){let k=0,m=0;const h=P.tabSize||4;for(;k<g.length;){const $=g.charAt(k);if($===" ")m++;else if($==="	")m+=h;else break;k++}return Math.floor(m/h)}function R(g,P){for(let k=0;k<P.length;k++){const m=P.charAt(k);if(m==="\r")return k+1<P.length&&P.charAt(k+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return g&&g.eol||`
`}e.$rn=R;function S(g,P){return`\r
`.indexOf(g.charAt(P))!==-1}e.$sn=S}),define(le[62],he([0,1,34,42]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=void 0;function D(g,P,k){return L(g,P,void 0,k)}e.$tn=D;function L(g,P,k,m,h){const $=P.slice(),p=[],E=(0,O.$gn)(g,p);let l,u;for(;$.length>0&&(u=$.pop(),l=(0,O.$hn)(E,$),l===void 0&&k!==void 0);)typeof u=="string"?k={[u]:k}:k=[k];if(l)if(l.type==="object"&&typeof u=="string"&&Array.isArray(l.children)){const d=(0,O.$hn)(l,[u]);if(d!==void 0)if(k===void 0){if(!d.parent)throw new Error("Malformed AST");const c=l.children.indexOf(d.parent);let y,i=d.parent.offset+d.parent.length;if(c>0){const o=l.children[c-1];y=o.offset+o.length}else y=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return I(g,{offset:y,length:i-y,content:""},m)}else return I(g,{offset:d.offset,length:d.length,content:JSON.stringify(k)},m);else{if(k===void 0)return[];const c=`${JSON.stringify(u)}: ${JSON.stringify(k)}`,y=h?h(l.children.map(o=>o.children[0].value)):l.children.length;let i;if(y>0){const o=l.children[y-1];i={offset:o.offset+o.length,length:0,content:","+c}}else l.children.length===0?i={offset:l.offset+1,length:0,content:c}:i={offset:l.offset+1,length:0,content:c+","};return I(g,i,m)}}else if(l.type==="array"&&typeof u=="number"&&Array.isArray(l.children))if(k!==void 0){const d=`${JSON.stringify(k)}`;let c;if(l.children.length===0||u===0)c={offset:l.offset+1,length:0,content:l.children.length===0?d:d+","};else{const y=u===-1||u>l.children.length?l.children.length:u,i=l.children[y-1];c={offset:i.offset+i.length,length:0,content:","+d}}return I(g,c,m)}else{const d=u,c=l.children[d];let y;if(l.children.length===1)y={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===d){const i=l.children[d-1],o=i.offset+i.length,n=l.offset+l.length;y={offset:o,length:n-2-o,content:""}}else y={offset:c.offset,length:l.children[d+1].offset-c.offset,content:""};return I(g,y,m)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${l.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return I(g,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(k)},m)}}e.$un=L;function I(g,P,k){let m=R(g,P),h=P.offset,$=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;h>0&&!(0,A.$sn)(m,h-1);)h--;for(;$<m.length&&!(0,A.$sn)(m,$);)$++}const p=(0,A.$pn)(m,{offset:h,length:$-h},k);for(let l=p.length-1;l>=0;l--){const u=p[l];m=R(m,u),h=Math.min(h,u.offset),$=Math.max($,u.offset+u.length),$+=u.content.length-u.length}const E=g.length-(m.length-$)-h;return[{offset:h,length:E,content:m.substring(h,$)}]}e.$vn=I;function R(g,P){return g.substring(0,P.offset)+P.content+g.substring(P.offset+P.length)}e.$wn=R;function S(g,P){const k=P.slice(0).sort((h,$)=>{const p=h.offset-$.offset;return p===0?h.length-$.length:p});let m=g.length;for(let h=k.length-1;h>=0;h--){const $=k[h];if($.offset+$.length<=m)g=R(g,$);else throw new Error("Overlapping edit");m=$.offset}return g}e.$xn=S}),define(le[52],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class O{constructor(D){this.d=D,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=O}),define(le[87],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class O{static{this.Undefined=new O(void 0)}constructor(L){this.element=L,this.next=O.Undefined,this.prev=O.Undefined}}class A{constructor(){this.a=O.Undefined,this.b=O.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===O.Undefined}clear(){let L=this.a;for(;L!==O.Undefined;){const I=L.next;L.prev=O.Undefined,L.next=O.Undefined,L=I}this.a=O.Undefined,this.b=O.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,I){const R=new O(L);if(this.a===O.Undefined)this.a=R,this.b=R;else if(I){const g=this.b;this.b=R,R.prev=g,g.next=R}else{const g=this.a;this.a=R,R.next=g,g.prev=R}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(R))}}shift(){if(this.a!==O.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==O.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==O.Undefined&&L.next!==O.Undefined){const I=L.prev;I.next=L.next,L.next.prev=I}else L.prev===O.Undefined&&L.next===O.Undefined?(this.a=O.Undefined,this.b=O.Undefined):L.next===O.Undefined?(this.b=this.b.prev,this.b.next=O.Undefined):L.prev===O.Undefined&&(this.a=this.a.next,this.a.prev=O.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==O.Undefined;)yield L.element,L=L.next}}e.$4c=A}),define(le[35],he([0,1]),function(se,e){"use strict";var O,A,D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function L(d,c,y){let i=d.get(c);return i===void 0&&(i=y,d.set(c,i)),i}e.$xc=L;function I(d){const c=[];return d.forEach((y,i)=>{c.push(`${i} => ${y}`)}),`Map(${d.size}) {${c.join(", ")}}`}e.$yc=I;function R(d){const c=[];return d.forEach(y=>{c.push(y)}),`Set(${d.size}) {${c.join(", ")}}`}e.$zc=R;class S{constructor(c,y){this.uri=c,this.value=y}}function g(d){return Array.isArray(d)}class P{static{this.c=c=>c.toString()}constructor(c,y){if(this[O]="ResourceMap",c instanceof P)this.d=new Map(c.d),this.e=y??P.c;else if(g(c)){this.d=new Map,this.e=y??P.c;for(const[i,o]of c)this.set(i,o)}else this.d=new Map,this.e=c??P.c}set(c,y){return this.d.set(this.e(c),new S(c,y)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,y){typeof y<"u"&&(c=c.bind(y));for(const[i,o]of this.d)c(o.value,o.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(O=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}e.$Ac=P;class k{constructor(c,y){this[A]="ResourceSet",!c||typeof c=="function"?this.c=new P(c):(this.c=new P(y),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,y){this.c.forEach((i,o)=>c.call(y,o,o,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=k;var m;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class h{constructor(){this[D]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,y=0){const i=this.c.get(c);if(i)return y!==0&&this.l(i,y),i.value}set(c,y,i=0){let o=this.c.get(c);if(o)o.value=y,i!==0&&this.l(o,i);else{switch(o={key:c,value:y,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(c,o),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const y=this.c.get(c);if(y)return this.c.delete(c),this.k(y),this.f--,y.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,y){const i=this.g;let o=this.d;for(;o;){if(y?c.bind(y)(o.value,o.key,this):c(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,y=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==y)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,y=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==y)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,y=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==y)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let y=this.d,i=this.size;for(;y&&i>c;)this.c.delete(y.key),y=y.next,i--;this.d=y,this.f=i,y&&(y.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const y=c.next,i=c.previous;if(!y||!i)throw new Error("Invalid list");y.previous=i,i.next=y}c.next=void 0,c.previous=void 0,this.g++}l(c,y){if(!this.d||!this.e)throw new Error("Invalid list");if(!(y!==1&&y!==2)){if(y===1){if(c===this.d)return;const i=c.next,o=c.previous;c===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(y===2){if(c===this.e)return;const i=c.next,o=c.previous;c===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((y,i)=>{c.push([i,y])}),c}fromJSON(c){this.clear();for(const[y,i]of c)this.set(y,i)}}e.$Cc=h;class $ extends h{constructor(c,y=1){super(),this.m=c,this.n=Math.min(Math.max(0,y),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,y=2){return super.get(c,y)}peek(c){return super.get(c,0)}set(c,y){return super.set(c,y,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=$;class p{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let y=this.c.get(c)||0;return y===0?!1:(y--,y===0?this.c.delete(c):this.c.set(c,y),!0)}has(c){return this.c.has(c)}}e.$Ec=p;class E{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[y,i]of c)this.set(y,i)}clear(){this.c.clear(),this.d.clear()}set(c,y){this.c.set(c,y),this.d.set(y,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const y=this.c.get(c);return y===void 0?!1:(this.c.delete(c),this.d.delete(y),!0)}forEach(c,y){this.c.forEach((i,o)=>{c.call(y,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=E;class l{constructor(){this.c=new Map}add(c,y){let i=this.c.get(c);i||(i=new Set,this.c.set(c,i)),i.add(y)}delete(c,y){const i=this.c.get(c);i&&(i.delete(y),i.size===0&&this.c.delete(c))}forEach(c,y){const i=this.c.get(c);i&&i.forEach(y)}get(c){const y=this.c.get(c);return y||new Set}}e.$Gc=l;function u(d,c){if(d===c)return!0;if(d.size!==c.size)return!1;for(const[y,i]of d)if(!c.has(y)||c.get(y)!==i)return!1;for(const[y]of c)if(!d.has(y))return!1;return!0}e.$Hc=u}),define(le[2],he([0,1,17,126,35,86,61]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const R=!1;let S=null;class g{constructor(){this.b=new Map}static{this.a=0}c(C){let N=this.b.get(C);return N||(N={parent:null,source:null,isSingleton:!1,value:C,idx:g.a++},this.b.set(C,N)),N}trackDisposable(C){const N=this.c(C);N.source||(N.source=new Error().stack)}setParent(C,N){const T=this.c(C);T.parent=N}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,N){const T=N.get(C);if(T)return T;const M=C.parent?this.f(this.c(C.parent),N):C;return N.set(C,M),M}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,C).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(C=10,N){let T;if(N)T=N;else{const x=new Map,V=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,x).isSingleton);if(V.length===0)return;const Q=new Set(V.map(H=>H.value));if(T=V.filter(H=>!(H.parent&&Q.has(H.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function M(x){function V(H,W){for(;H.length>0&&W.some(te=>typeof te=="string"?te===H[0]:H[0].match(te));)H.shift()}const Q=x.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return V(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const q=new D.$Gc;for(const x of T){const V=M(x);for(let Q=0;Q<=V.length;Q++)q.add(V.slice(0,Q).join(`
`),x)}T.sort((0,O.$7b)(x=>x.idx,O.$9b));let Y="",X=0;for(const x of T.slice(0,C)){X++;const V=M(x),Q=[];for(let H=0;H<V.length;H++){let W=V[H];W=`(shared with ${q.get(V.slice(0,H+1).join(`
`)).size}/${T.length} leaks) at ${W}`;const oe=q.get(V.slice(0,H).join(`
`)),ee=(0,A.$K)([...oe].map(ae=>M(ae)[H]),ae=>ae);delete ee[V[H]];for(const[ae,G]of Object.entries(ee))Q.unshift(`    - stacktraces of ${G.length} other leaks continue with ${ae}`);Q.unshift(W)}Y+=`


==================== Leaking disposable ${X}/${T.length}: ${x.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return T.length>C&&(Y+=`


... and ${T.length-C} more leaking disposables

`),{leaks:T,details:Y}}}e.$Ic=g;function P(b){S=b}if(e.$Jc=P,R){const b="__is_disposable_tracked__";P(new class{trackDisposable(C){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[b]||console.log(N)},3e3)}setParent(C,N){if(C&&C!==i.None)try{C[b]=!0}catch{}}markAsDisposed(C){if(C&&C!==i.None)try{C[b]=!0}catch{}}markAsSingleton(C){}})}function k(b){return S?.trackDisposable(b),b}e.$Kc=k;function m(b){S?.markAsDisposed(b)}e.$Lc=m;function h(b,C){S?.setParent(b,C)}function $(b,C){if(S)for(const N of b)S.setParent(N,C)}function p(b){return S?.markAsSingleton(b),b}e.$Mc=p;function E(b){return typeof b.dispose=="function"&&b.dispose.length===0}e.$Nc=E;function l(b){if(I.Iterable.is(b)){const C=[];for(const N of b)if(N)try{N.dispose()}catch(T){C.push(T)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}e.$Oc=l;function u(b){for(const C of b)E(C)&&C.dispose();return[]}e.$Pc=u;function d(...b){const C=c(()=>l(b));return $(b,C),C}e.$Qc=d;function c(b){const C=k({dispose:(0,L.$db)(()=>{m(C),b()})});return C}e.$Rc=c;class y{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,k(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return h(C,this),this.g?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),h(C,null))}}e.$Sc=y;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new y,k(this),h(this.q,this)}dispose(){m(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Tc=i;class o{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&h(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&h(C,null),C}}e.$Uc=o;class n{constructor(C){this.a=new o,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=n;class s{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(C){let N=C;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,m(this))},this}}e.$Xc=t;class r{constructor(){this.a=new Map}acquire(C,...N){let T=this.a.get(C);T||(T={counter:0,object:this.b(C,...N)},this.a.set(C,T));const{object:M}=T,q=(0,L.$db)(()=>{--T.counter===0&&(this.c(C,T.object),this.a.delete(C))});return T.counter++,{object:M,dispose:q}}}e.$Yc=r;class a{constructor(C){this.a=C}async acquire(C,...N){const T=this.a.acquire(C,...N);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(M){throw T.dispose(),M}}}e.$Zc=a;class v{constructor(C){this.object=C}dispose(){}}e.$1c=v;function w(b){const C=new y;try{b(C)}finally{C.dispose()}}e.$2c=w;class f{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,N,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(C)?.dispose(),this.a.set(C,N)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=f}),define(le[88],he([0,1,35]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=void 0;const A=new O.$Dc(1e4);function D(g){return S(g,"NFC",A)}e.$Il=D;const L=new O.$Dc(1e4);function I(g){return S(g,"NFD",L)}e.$Jl=I;const R=/[^\u0000-\u0080]/;function S(g,P,k){if(!g)return g;const m=k.get(g);if(m)return m;let h;return R.test(g)?h=g.normalize(P):h=g,k.set(g,h),h}e.$Kl=function(){const g=/[\u0300-\u036f]/g;return function(P){return I(P).replace(g,"")}}()}),function(){function se(D){const L=[];typeof D=="number"&&L.push("code/timeOrigin",D);function I(S){L.push(S,Date.now())}function R(){const S=[];for(let g=0;g<L.length;g+=2)S.push({name:L[g],startTime:L[g+1]});return S}return{mark:I,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const I of performance.getEntriesByType("mark"))L.push({name:I.name,startTime:Math.round(D+I.startTime)});return L}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function O(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=O(A))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var A in O)(typeof exports=="object"?exports:se)[A]=O[A]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function O(A){if(e[A])return e[A].exports;var D=e[A]={i:A,l:!1,exports:{}};return se[A].call(D.exports,D,D.exports,O),D.l=!0,D.exports}return O.m=se,O.c=e,O.d=function(A,D,L){O.o(A,D)||Object.defineProperty(A,D,{enumerable:!0,get:L})},O.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},O.t=function(A,D){if(1&D&&(A=O(A)),8&D||4&D&&typeof A=="object"&&A&&A.__esModule)return A;var L=Object.create(null);if(O.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:A}),2&D&&typeof A!="string")for(var I in A)O.d(L,I,function(R){return A[R]}.bind(null,I));return L},O.n=function(A){var D=A&&A.__esModule?function(){return A.default}:function(){return A};return O.d(D,"a",D),D},O.o=function(A,D){return Object.prototype.hasOwnProperty.call(A,D)},O.p="",O(O.s=0)}([function(se,e,O){(function(A){var D;e=se.exports=G,D=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],g=0,P=g++;S[P]="0|[1-9]\\d*";var k=g++;S[k]="[0-9]+";var m=g++;S[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=g++;S[h]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var $=g++;S[$]="("+S[k]+")\\.("+S[k]+")\\.("+S[k]+")";var p=g++;S[p]="(?:"+S[P]+"|"+S[m]+")";var E=g++;S[E]="(?:"+S[k]+"|"+S[m]+")";var l=g++;S[l]="(?:-("+S[p]+"(?:\\."+S[p]+")*))";var u=g++;S[u]="(?:-?("+S[E]+"(?:\\."+S[E]+")*))";var d=g++;S[d]="[0-9A-Za-z-]+";var c=g++;S[c]="(?:\\+("+S[d]+"(?:\\."+S[d]+")*))";var y=g++,i="v?"+S[h]+S[l]+"?"+S[c]+"?";S[y]="^"+i+"$";var o="[v=\\s]*"+S[$]+S[u]+"?"+S[c]+"?",n=g++;S[n]="^"+o+"$";var s=g++;S[s]="((?:<|>)?=?)";var t=g++;S[t]=S[k]+"|x|X|\\*";var r=g++;S[r]=S[P]+"|x|X|\\*";var a=g++;S[a]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[l]+")?"+S[c]+"?)?)?";var v=g++;S[v]="[v=\\s]*("+S[t]+")(?:\\.("+S[t]+")(?:\\.("+S[t]+")(?:"+S[u]+")?"+S[c]+"?)?)?";var w=g++;S[w]="^"+S[s]+"\\s*"+S[a]+"$";var f=g++;S[f]="^"+S[s]+"\\s*"+S[v]+"$";var b=g++;S[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=g++;S[C]="(?:~>?)";var N=g++;S[N]="(\\s*)"+S[C]+"\\s+",R[N]=new RegExp(S[N],"g");var T=g++;S[T]="^"+S[C]+S[a]+"$";var M=g++;S[M]="^"+S[C]+S[v]+"$";var q=g++;S[q]="(?:\\^)";var Y=g++;S[Y]="(\\s*)"+S[q]+"\\s+",R[Y]=new RegExp(S[Y],"g");var X=g++;S[X]="^"+S[q]+S[a]+"$";var x=g++;S[x]="^"+S[q]+S[v]+"$";var V=g++;S[V]="^"+S[s]+"\\s*("+o+")$|^$";var Q=g++;S[Q]="^"+S[s]+"\\s*("+i+")$|^$";var H=g++;S[H]="(\\s*)"+S[s]+"\\s*("+o+"|"+S[a]+")",R[H]=new RegExp(S[H],"g");var W=g++;S[W]="^\\s*("+S[a]+")\\s+-\\s+("+S[a]+")\\s*$";var te=g++;S[te]="^\\s*("+S[v]+")\\s+-\\s+("+S[v]+")\\s*$";var oe=g++;S[oe]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)D(ee,S[ee]),R[ee]||(R[ee]=new RegExp(S[ee]));function ae(ue,ge){if(ue instanceof G)return ue;if(typeof ue!="string"||ue.length>L||!(ge?R[n]:R[y]).test(ue))return null;try{return new G(ue,ge)}catch{return null}}function G(ue,ge){if(ue instanceof G){if(ue.loose===ge)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof G))return new G(ue,ge);D("SemVer",ue,ge),this.loose=ge;var we=ue.trim().match(ge?R[n]:R[y]);if(!we)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Re=+Ce;if(Re>=0&&Re<I)return Re}return Ce}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ue,ge){var we=ae(ue,ge);return we?we.version:null},e.clean=function(ue,ge){var we=ae(ue.trim().replace(/^[=v]+/,""),ge);return we?we.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(ue){return D("SemVer.compare",this.version,this.loose,ue),ue instanceof G||(ue=new G(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},G.prototype.compareMain=function(ue){return ue instanceof G||(ue=new G(ue,this.loose)),j(this.major,ue.major)||j(this.minor,ue.minor)||j(this.patch,ue.patch)},G.prototype.comparePre=function(ue){if(ue instanceof G||(ue=new G(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var ge=0;do{var we=this.prerelease[ge],Ce=ue.prerelease[ge];if(D("prerelease compare",ge,we,Ce),we===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(we===void 0)return-1;if(we!==Ce)return j(we,Ce)}while(++ge)},G.prototype.inc=function(ue,ge){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,ge,we,Ce){typeof we=="string"&&(Ce=we,we=void 0);try{return new G(ue,we).inc(ge,Ce).version}catch{return null}},e.diff=function(ue,ge){if(Z(ue,ge))return null;var we=ae(ue),Ce=ae(ge);if(we.prerelease.length||Ce.prerelease.length){for(var Re in we)if((Re==="major"||Re==="minor"||Re==="patch")&&we[Re]!==Ce[Re])return"pre"+Re;return"prerelease"}for(var Re in we)if((Re==="major"||Re==="minor"||Re==="patch")&&we[Re]!==Ce[Re])return Re},e.compareIdentifiers=j;var z=/^[0-9]+$/;function j(ue,ge){var we=z.test(ue),Ce=z.test(ge);return we&&Ce&&(ue=+ue,ge=+ge),we&&!Ce?-1:Ce&&!we?1:ue<ge?-1:ue>ge?1:0}function F(ue,ge,we){return new G(ue,we).compare(new G(ge,we))}function B(ue,ge,we){return F(ue,ge,we)>0}function U(ue,ge,we){return F(ue,ge,we)<0}function Z(ue,ge,we){return F(ue,ge,we)===0}function _(ue,ge,we){return F(ue,ge,we)!==0}function ie(ue,ge,we){return F(ue,ge,we)>=0}function J(ue,ge,we){return F(ue,ge,we)<=0}function ne(ue,ge,we,Ce){var Re;switch(ge){case"===":typeof ue=="object"&&(ue=ue.version),typeof we=="object"&&(we=we.version),Re=ue===we;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof we=="object"&&(we=we.version),Re=ue!==we;break;case"":case"=":case"==":Re=Z(ue,we,Ce);break;case"!=":Re=_(ue,we,Ce);break;case">":Re=B(ue,we,Ce);break;case">=":Re=ie(ue,we,Ce);break;case"<":Re=U(ue,we,Ce);break;case"<=":Re=J(ue,we,Ce);break;default:throw new TypeError("Invalid operator: "+ge)}return Re}function ce(ue,ge){if(ue instanceof ce){if(ue.loose===ge)return ue;ue=ue.value}if(!(this instanceof ce))return new ce(ue,ge);D("comparator",ue,ge),this.loose=ge,this.parse(ue),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ue,ge){return j(ge,ue)},e.major=function(ue,ge){return new G(ue,ge).major},e.minor=function(ue,ge){return new G(ue,ge).minor},e.patch=function(ue,ge){return new G(ue,ge).patch},e.compare=F,e.compareLoose=function(ue,ge){return F(ue,ge,!0)},e.rcompare=function(ue,ge,we){return F(ge,ue,we)},e.sort=function(ue,ge){return ue.sort(function(we,Ce){return e.compare(we,Ce,ge)})},e.rsort=function(ue,ge){return ue.sort(function(we,Ce){return e.rcompare(we,Ce,ge)})},e.gt=B,e.lt=U,e.eq=Z,e.neq=_,e.gte=ie,e.lte=J,e.cmp=ne,e.Comparator=ce;var fe={};function de(ue,ge){if(ue instanceof de)return ue.loose===ge?ue:new de(ue.raw,ge);if(ue instanceof ce)return new de(ue.value,ge);if(!(this instanceof de))return new de(ue,ge);if(this.loose=ge,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function me(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function Ee(ue,ge,we,Ce,Re,Me,je,ze,Fe,Te,qe,re,$e){return((ge=me(we)?"":me(Ce)?">="+we+".0.0":me(Re)?">="+we+"."+Ce+".0":">="+ge)+" "+(ze=me(Fe)?"":me(Te)?"<"+(+Fe+1)+".0.0":me(qe)?"<"+Fe+"."+(+Te+1)+".0":re?"<="+Fe+"."+Te+"."+qe+"-"+re:"<="+ze)).trim()}function Pe(ue,ge){for(var we=0;we<ue.length;we++)if(!ue[we].test(ge))return!1;if(ge.prerelease.length){for(we=0;we<ue.length;we++)if(D(ue[we].semver),ue[we].semver!==fe&&ue[we].semver.prerelease.length>0){var Ce=ue[we].semver;if(Ce.major===ge.major&&Ce.minor===ge.minor&&Ce.patch===ge.patch)return!0}return!1}return!0}function Oe(ue,ge,we){try{ge=new de(ge,we)}catch{return!1}return ge.test(ue)}function Ne(ue,ge,we,Ce){var Re,Me,je,ze,Fe;switch(ue=new G(ue,Ce),ge=new de(ge,Ce),we){case">":Re=B,Me=J,je=U,ze=">",Fe=">=";break;case"<":Re=U,Me=ie,je=B,ze="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(ue,ge,Ce))return!1;for(var Te=0;Te<ge.set.length;++Te){var qe=ge.set[Te],re=null,$e=null;if(qe.forEach(function(be){be.semver===fe&&(be=new ce(">=0.0.0")),re=re||be,$e=$e||be,Re(be.semver,re.semver,Ce)?re=be:je(be.semver,$e.semver,Ce)&&($e=be)}),re.operator===ze||re.operator===Fe||(!$e.operator||$e.operator===ze)&&Me(ue,$e.semver)||$e.operator===Fe&&je(ue,$e.semver))return!1}return!0}ce.prototype.parse=function(ue){var ge=this.loose?R[V]:R[Q],we=ue.match(ge);if(!we)throw new TypeError("Invalid comparator: "+ue);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new G(we[2],this.loose):this.semver=fe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(ue){return D("Comparator.test",ue,this.loose),this.semver===fe||(typeof ue=="string"&&(ue=new G(ue,this.loose)),ne(ue,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(ue,ge){if(!(ue instanceof ce))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new de(ue.value,ge),Oe(this.value,we,ge);if(ue.operator==="")return we=new de(this.value,ge),Oe(ue.semver,we,ge);var Ce=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),Me=this.semver.version===ue.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),ze=ne(this.semver,"<",ue.semver,ge)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),Fe=ne(this.semver,">",ue.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Ce||Re||Me&&je||ze||Fe},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ue){var ge=this.loose;ue=ue.trim(),D("range",ue,ge);var we=ge?R[te]:R[W];ue=ue.replace(we,Ee),D("hyphen replace",ue),ue=ue.replace(R[H],"$1$2$3"),D("comparator trim",ue,R[H]),ue=(ue=(ue=ue.replace(R[N],"$1~")).replace(R[Y],"$1^")).split(/\s+/).join(" ");var Ce=ge?R[V]:R[Q],Re=ue.split(" ").map(function(Me){return function(je,ze){return D("comp",je),je=function(Fe,Te){return Fe.trim().split(/\s+/).map(function(qe){return function(re,$e){D("caret",re,$e);var be=$e?R[x]:R[X];return re.replace(be,function(ve,ye,Se,Ie,De){var Ae;return D("caret",re,ve,ye,Se,Ie,De),me(ye)?Ae="":me(Se)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":me(Ie)?Ae=ye==="0"?">="+ye+"."+Se+".0 <"+ye+"."+(+Se+1)+".0":">="+ye+"."+Se+".0 <"+(+ye+1)+".0.0":De?(D("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ae=ye==="0"?Se==="0"?">="+ye+"."+Se+"."+Ie+De+" <"+ye+"."+Se+"."+(+Ie+1):">="+ye+"."+Se+"."+Ie+De+" <"+ye+"."+(+Se+1)+".0":">="+ye+"."+Se+"."+Ie+De+" <"+(+ye+1)+".0.0"):(D("no pr"),Ae=ye==="0"?Se==="0"?">="+ye+"."+Se+"."+Ie+" <"+ye+"."+Se+"."+(+Ie+1):">="+ye+"."+Se+"."+Ie+" <"+ye+"."+(+Se+1)+".0":">="+ye+"."+Se+"."+Ie+" <"+(+ye+1)+".0.0"),D("caret return",Ae),Ae})}(qe,Te)}).join(" ")}(je,ze),D("caret",je),je=function(Fe,Te){return Fe.trim().split(/\s+/).map(function(qe){return function(re,$e){var be=$e?R[M]:R[T];return re.replace(be,function(ve,ye,Se,Ie,De){var Ae;return D("tilde",re,ve,ye,Se,Ie,De),me(ye)?Ae="":me(Se)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":me(Ie)?Ae=">="+ye+"."+Se+".0 <"+ye+"."+(+Se+1)+".0":De?(D("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ae=">="+ye+"."+Se+"."+Ie+De+" <"+ye+"."+(+Se+1)+".0"):Ae=">="+ye+"."+Se+"."+Ie+" <"+ye+"."+(+Se+1)+".0",D("tilde return",Ae),Ae})}(qe,Te)}).join(" ")}(je,ze),D("tildes",je),je=function(Fe,Te){return D("replaceXRanges",Fe,Te),Fe.split(/\s+/).map(function(qe){return function(re,$e){re=re.trim();var be=$e?R[f]:R[w];return re.replace(be,function(ve,ye,Se,Ie,De,Ae){D("xRange",re,ve,ye,Se,Ie,De,Ae);var We=me(Se),Ue=We||me(Ie),Be=Ue||me(De);return ye==="="&&Be&&(ye=""),We?ve=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Be?(Ue&&(Ie=0),Be&&(De=0),ye===">"?(ye=">=",Ue?(Se=+Se+1,Ie=0,De=0):Be&&(Ie=+Ie+1,De=0)):ye==="<="&&(ye="<",Ue?Se=+Se+1:Ie=+Ie+1),ve=ye+Se+"."+Ie+"."+De):Ue?ve=">="+Se+".0.0 <"+(+Se+1)+".0.0":Be&&(ve=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0"),D("xRange return",ve),ve})}(qe,Te)}).join(" ")}(je,ze),D("xrange",je),je=function(Fe,Te){return D("replaceStars",Fe,Te),Fe.trim().replace(R[oe],"")}(je,ze),D("stars",je),je}(Me,ge)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Me){return!!Me.match(Ce)})),Re=Re.map(function(Me){return new ce(Me,ge)})},de.prototype.intersects=function(ue,ge){if(!(ue instanceof de))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Ce){return ue.set.some(function(Re){return Re.every(function(Me){return Ce.intersects(Me,ge)})})})})},e.toComparators=function(ue,ge){return new de(ue,ge).set.map(function(we){return we.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new G(ue,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Pe(this.set[ge],ue))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(ue,ge,we){var Ce=null,Re=null;try{var Me=new de(ge,we)}catch{return null}return ue.forEach(function(je){Me.test(je)&&(Ce&&Re.compare(je)!==-1||(Re=new G(Ce=je,we)))}),Ce},e.minSatisfying=function(ue,ge,we){var Ce=null,Re=null;try{var Me=new de(ge,we)}catch{return null}return ue.forEach(function(je){Me.test(je)&&(Ce&&Re.compare(je)!==1||(Re=new G(Ce=je,we)))}),Ce},e.validRange=function(ue,ge){try{return new de(ue,ge).range||"*"}catch{return null}},e.ltr=function(ue,ge,we){return Ne(ue,ge,"<",we)},e.gtr=function(ue,ge,we){return Ne(ue,ge,">",we)},e.outside=Ne,e.prerelease=function(ue,ge){var we=ae(ue,ge);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(ue,ge,we){return ue=new de(ue,we),ge=new de(ge,we),ue.intersects(ge)},e.coerce=function(ue){if(ue instanceof G)return ue;if(typeof ue!="string")return null;var ge=ue.match(R[b]);return ge==null?null:ae((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,O(1))},function(se,e){var O,A,D=se.exports={};function L(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function R(E){if(O===setTimeout)return setTimeout(E,0);if((O===L||!O)&&setTimeout)return O=setTimeout,setTimeout(E,0);try{return O(E,0)}catch{try{return O.call(null,E,0)}catch{return O.call(this,E,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:L}catch{O=L}try{A=typeof clearTimeout=="function"?clearTimeout:I}catch{A=I}})();var S,g=[],P=!1,k=-1;function m(){P&&S&&(P=!1,S.length?g=S.concat(g):k=-1,g.length&&h())}function h(){if(!P){var E=R(m);P=!0;for(var l=g.length;l;){for(S=g,g=[];++k<l;)S&&S[k].run();k=-1,l=g.length}S=null,P=!1,function(u){if(A===clearTimeout)return clearTimeout(u);if((A===I||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(u);try{A(u)}catch{try{return A.call(null,u)}catch{return A.call(this,u)}}}(E)}}function $(E,l){this.fun=E,this.array=l}function p(){}D.nextTick=function(E){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];g.push(new $(E,l)),g.length!==1||P||R(h)},$.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=p,D.addListener=p,D.once=p,D.off=p,D.removeListener=p,D.removeAllListeners=p,D.emit=p,D.prependListener=p,D.prependOnceListener=p,D.listeners=function(E){return[]},D.binding=function(E){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(E){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(le[128],he([0,1]),function(se,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;class A{constructor(R,S,g){this.level=R,this.key=S,this.value=g,this.forward=[]}}const D=void 0;class L{constructor(R,S=2**16){this.comparator=R,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new A(this.c,D,D)}get size(){return this.f}clear(){this.e=new A(this.c,D,D),this.f=0}has(R){return!!L.g(this,R,this.comparator)}get(R){return L.g(this,R,this.comparator)?.value}set(R,S){return L.h(this,R,S,this.comparator)&&(this.f+=1),this}delete(R){const S=L.k(this,R,this.comparator);return S&&(this.f-=1),S}forEach(R,S){let g=this.e.forward[0];for(;g;)R.call(S,g.value,g.key,this),g=g.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",S=this.e.forward[0];for(;S;)R+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return R}static g(R,S,g){let P=R.e;for(let k=R.d-1;k>=0;k--)for(;P.forward[k]&&g(P.forward[k].key,S)<0;)P=P.forward[k];if(P=P.forward[0],P&&g(P.key,S)===0)return P}static h(R,S,g,P){const k=[];let m=R.e;for(let h=R.d-1;h>=0;h--){for(;m.forward[h]&&P(m.forward[h].key,S)<0;)m=m.forward[h];k[h]=m}if(m=m.forward[0],m&&P(m.key,S)===0)return m.value=g,!1;{const h=L.j(R);if(h>R.d){for(let $=R.d;$<h;$++)k[$]=R.e;R.d=h}m=new A(h,S,g);for(let $=0;$<h;$++)m.forward[$]=k[$].forward[$],k[$].forward[$]=m;return!0}}static j(R,S=.5){let g=1;for(;Math.random()<S&&g<R.c;)g+=1;return g}static k(R,S,g){const P=[];let k=R.e;for(let m=R.d-1;m>=0;m--){for(;k.forward[m]&&g(k.forward[m].key,S)<0;)k=k.forward[m];P[m]=k}if(k=k.forward[0],!k||g(k.key,S)!==0)return!1;for(let m=0;m<R.d&&P[m].forward[m]===k;m++)P[m].forward[m]=k.forward[m];for(;R.d>0&&R.e.forward[R.d-1]===D;)R.d-=1;return!0}}e.$3r=L}),define(le[63],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0;const O=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(L){return new A(L)}constructor(L){this.c=O&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Sd=A}),define(le[3],he([0,1,7,86,2,87,63]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.Event=void 0;const R=!1,S=!1;var g;(function(w){w.None=()=>D.$Tc.None;function f(J){if(S){const{onDidAddListener:ne}=J,ce=$.create();let fe=0;J.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),ne?.()}}}function b(J,ne){return Q(J,()=>{},0,void 0,!0,void 0,ne)}w.defer=b;function C(J){return(ne,ce=null,fe)=>{let de=!1,me;return me=J(Ee=>{if(!de)return me?me.dispose():de=!0,ne.call(ce,Ee)},null,fe),de&&me.dispose(),me}}w.once=C;function N(J,ne,ce){return x((fe,de=null,me)=>J(Ee=>fe.call(de,ne(Ee)),null,me),ce)}w.map=N;function T(J,ne,ce){return x((fe,de=null,me)=>J(Ee=>{ne(Ee),fe.call(de,Ee)},null,me),ce)}w.forEach=T;function M(J,ne,ce){return x((fe,de=null,me)=>J(Ee=>ne(Ee)&&fe.call(de,Ee),null,me),ce)}w.filter=M;function q(J){return J}w.signal=q;function Y(...J){return(ne,ce=null,fe)=>{const de=(0,D.$Qc)(...J.map(me=>me(Ee=>ne.call(ce,Ee))));return V(de,fe)}}w.any=Y;function X(J,ne,ce,fe){let de=ce;return N(J,me=>(de=ne(de,me),de),fe)}w.reduce=X;function x(J,ne){let ce;const fe={onWillAddFirstListener(){ce=J(de.fire,de)},onDidRemoveLastListener(){ce?.dispose()}};ne||f(fe);const de=new d(fe);return ne?.add(de),de.event}function V(J,ne){return ne instanceof Array?ne.push(J):ne&&ne.add(J),J}function Q(J,ne,ce=100,fe=!1,de=!1,me,Ee){let Pe,Oe,Ne,ue=0,ge;const we={leakWarningThreshold:me,onWillAddFirstListener(){Pe=J(Re=>{ue++,Oe=ne(Oe,Re),fe&&!Ne&&(Ce.fire(Oe),Oe=void 0),ge=()=>{const Me=Oe;Oe=void 0,Ne=void 0,(!fe||ue>1)&&Ce.fire(Me),ue=0},typeof ce=="number"?(clearTimeout(Ne),Ne=setTimeout(ge,ce)):Ne===void 0&&(Ne=0,queueMicrotask(ge))})},onWillRemoveListener(){de&&ue>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,Pe.dispose()}};Ee||f(we);const Ce=new d(we);return Ee?.add(Ce),Ce.event}w.debounce=Q;function H(J,ne=0,ce){return w.debounce(J,(fe,de)=>fe?(fe.push(de),fe):[de],ne,void 0,!0,void 0,ce)}w.accumulate=H;function W(J,ne=(fe,de)=>fe===de,ce){let fe=!0,de;return M(J,me=>{const Ee=fe||!ne(me,de);return fe=!1,de=me,Ee},ce)}w.latch=W;function te(J,ne,ce){return[w.filter(J,ne,ce),w.filter(J,fe=>!ne(fe),ce)]}w.split=te;function oe(J,ne=!1,ce=[],fe){let de=ce.slice(),me=J(Oe=>{de?de.push(Oe):Pe.fire(Oe)});fe&&fe.add(me);const Ee=()=>{de?.forEach(Oe=>Pe.fire(Oe)),de=null},Pe=new d({onWillAddFirstListener(){me||(me=J(Oe=>Pe.fire(Oe)),fe&&fe.add(me))},onDidAddFirstListener(){de&&(ne?setTimeout(Ee):Ee())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return fe&&fe.add(Pe),Pe.event}w.buffer=oe;function ee(J,ne){return(fe,de,me)=>{const Ee=ne(new G);return J(function(Pe){const Oe=Ee.evaluate(Pe);Oe!==ae&&fe.call(de,Oe)},void 0,me)}}w.chain=ee;const ae=Symbol("HaltChainable");class G{constructor(){this.f=[]}map(ne){return this.f.push(ne),this}forEach(ne){return this.f.push(ce=>(ne(ce),ce)),this}filter(ne){return this.f.push(ce=>ne(ce)?ce:ae),this}reduce(ne,ce){let fe=ce;return this.f.push(de=>(fe=ne(fe,de),fe)),this}latch(ne=(ce,fe)=>ce===fe){let ce=!0,fe;return this.f.push(de=>{const me=ce||!ne(de,fe);return ce=!1,fe=de,me?de:ae}),this}evaluate(ne){for(const ce of this.f)if(ne=ce(ne),ne===ae)break;return ne}}function z(J,ne,ce=fe=>fe){const fe=(...Pe)=>Ee.fire(ce(...Pe)),de=()=>J.on(ne,fe),me=()=>J.removeListener(ne,fe),Ee=new d({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Ee.event}w.fromNodeEventEmitter=z;function j(J,ne,ce=fe=>fe){const fe=(...Pe)=>Ee.fire(ce(...Pe)),de=()=>J.addEventListener(ne,fe),me=()=>J.removeEventListener(ne,fe),Ee=new d({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Ee.event}w.fromDOMEventEmitter=j;function F(J){return new Promise(ne=>C(J)(ne))}w.toPromise=F;function B(J){const ne=new d;return J.then(ce=>{ne.fire(ce)},()=>{ne.fire(void 0)}).finally(()=>{ne.dispose()}),ne.event}w.fromPromise=B;function U(J,ne,ce){return ne(ce),J(fe=>ne(fe))}w.runAndSubscribe=U;class Z{constructor(ne,ce){this._observable=ne,this.f=0,this.g=!1;const fe={onWillAddFirstListener:()=>{ne.addObserver(this)},onDidRemoveLastListener:()=>{ne.removeObserver(this)}};ce||f(fe),this.emitter=new d(fe),ce&&ce.add(this.emitter)}beginUpdate(ne){this.f++}handlePossibleChange(ne){}handleChange(ne,ce){this.g=!0}endUpdate(ne){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _(J,ne){return new Z(J,ne).emitter.event}w.fromObservable=_;function ie(J){return(ne,ce,fe)=>{let de=0,me=!1;const Ee={beginUpdate(){de++},endUpdate(){de--,de===0&&(J.reportChanges(),me&&(me=!1,ne.call(ce)))},handlePossibleChange(){},handleChange(){me=!0}};J.addObserver(Ee),J.reportChanges();const Pe={dispose(){J.removeObserver(Ee)}};return fe instanceof D.$Sc?fe.add(Pe):Array.isArray(fe)&&fe.push(Pe),Pe}}w.fromObservableLight=ie})(g||(e.Event=g={}));class P{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${P.f++}`,P.all.add(this)}start(f){this.g=new I.$Sd,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Ud=P;let k=-1;function m(w){const f=k;return k=w,{dispose(){k=f}}}e.$Vd=m;class h{constructor(f,b=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=b,this.g=0}dispose(){this.f?.clear()}check(f,b){const C=this.threshold;if(C<=0||b<C)return;this.f||(this.f=new Map);const N=this.f.get(f.value)||0;if(this.f.set(f.value,N+1),this.g-=1,this.g<=0){this.g=C*.5;let T,M=0;for(const[q,Y]of this.f)(!T||M<Y)&&(T=q,M=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${M}):`),console.warn(T)}return()=>{const T=this.f.get(f.value)||0;this.f.set(f.value,T-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class E{constructor(f){this.value=f,this.id=p++}}const l=2,u=(w,f)=>{if(w instanceof E)f(w);else for(let b=0;b<w.length;b++){const C=w[b];C&&f(C)}};class d{constructor(f){this.w=0,this.f=f,this.g=k>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const f=this.t;queueMicrotask(()=>{u(f,b=>b.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,b,C)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.$Tc.None;if(this.m)return D.$Tc.None;b&&(f=f.bind(b));const N=new E(f);let T,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=$.create(),T=this.g.check(N.stack,this.w+1)),R&&(N.stack=M??$.create()),this.t?this.t instanceof E?(this.u??=new y,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,D.$Rc)(()=>{T?.(),this.x(N)});return C instanceof D.$Sc?C.add(q):Array.isArray(C)&&C.push(q),q},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const b=this.t,C=b.indexOf(f);if(C===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,b[C]=void 0;const N=this.u.current===this;if(this.w*l<=b.length){let T=0;for(let M=0;M<b.length;M++)b[M]?b[T++]=b[M]:N&&(this.u.end--,T<this.u.i&&this.u.i--);b.length=T}}y(f,b){if(!f)return;const C=this.f?.onListenerError||O.$1;if(!C){f.value(b);return}try{f.value(b)}catch(N){C(N)}}z(f){const b=f.current.t;for(;f.i<f.end;)this.y(b[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof E)this.y(this.t,f);else{const b=this.u;b.enqueue(this,f,this.t.length),this.z(b)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Wd=d;const c=()=>new y;e.$Xd=c;class y{constructor(){this.i=-1,this.end=0}enqueue(f,b,C){this.i=0,this.end=C,this.current=f,this.value=b}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends d{async fireAsync(f,b,C){if(this.t)for(this.h||(this.h=new L.$4c),u(this.t,N=>this.h.push([N.value,f]));this.h.size>0&&!b.isCancellationRequested;){const[N,T]=this.h.shift(),M=[],q={...T,token:b,waitUntil:Y=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");C&&(Y=C(Y,N)),M.push(Y)}};try{N(q)}catch(Y){(0,O.$1)(Y);continue}Object.freeze(M),await Promise.allSettled(M).then(Y=>{for(const X of Y)X.status==="rejected"&&(0,O.$1)(X.reason)})}}}e.$Yd=i;class o extends d{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new L.$4c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Zd=o;class n extends o{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$1d=n;class s extends d{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(b=>super.fire(b)),this.h=[]}))}}e.$2d=s;class t{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const b={event:f,listener:null};this.h.push(b),this.g&&this.m(b);const C=()=>{this.g&&this.o(b);const N=this.h.indexOf(b);this.h.splice(N,1)};return(0,D.$Rc)((0,A.$db)(C))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(b=>this.f.fire(b))}o(f){f.listener?.dispose(),f.listener=null}dispose(){this.f.dispose();for(const f of this.h)f.listener?.dispose();this.h=[]}}e.$3d=t;class r{constructor(f,b,C,N){this.f=new D.$Sc;const T=this.f.add(new t),M=this.f.add(new D.$3c);function q(Y){M.set(Y,T.add(N(Y)))}for(const Y of f)q(Y);this.f.add(b(Y=>{q(Y)})),this.f.add(C(Y=>{M.deleteAndDispose(Y)})),this.event=T.event}dispose(){this.f.dispose()}}e.$4d=r;class a{constructor(){this.f=[]}wrapEvent(f){return(b,C,N)=>f(T=>{const M=this.f[this.f.length-1];M?M.push(()=>b.call(C,T)):b.call(C,T)},void 0,N)}bufferEvents(f){const b=[];this.f.push(b);const C=f();return this.f.pop(),b.forEach(N=>N()),C}}e.$5d=a;class v{constructor(){this.f=!1,this.g=g.None,this.h=D.$Tc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$6d=v}),define(le[26],he([0,1,3]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.CancellationToken=void 0;const A=Object.freeze(function(R,S){const g=setTimeout(R.bind(S),0);return{dispose(){clearTimeout(g)}}});var D;(function(R){function S(g){return g===R.None||g===R.Cancelled||g instanceof L?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=S,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:O.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(D||(e.CancellationToken=D={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new O.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=D.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=D.None}}e.$7d=I}),define(le[129],he([0,1,26]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=e.$Ge=e.$Fe=void 0;class A{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new O.$7d,S=this.b(R.token);return this.a={promise:S,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$Fe=A;class D{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const S=JSON.stringify(R);return this.b!==S&&(this.b=S,this.a=this.c(R)),this.a}}e.$Ge=D;class L{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const S=this.b(R);return this.a.set(R,S),S}}e.$He=L}),define(le[47],he([0,1,7,2]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function D(c){const y=c;return y?typeof y.read=="function":!1}e.$8d=D;function L(c){const y=c;return y?[y.on,y.pause,y.resume,y.destroy].every(i=>typeof i=="function"):!1}e.$9d=L;function I(c){const y=c;return y?L(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.$0d=I;function R(c,y){return new S(c,y)}e.$$d=R;class S{constructor(y,i){this.e=y,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(i=>i(y))}h(y){this.c.error.length===0?(0,O.$1)(y):this.c.error.slice(0).forEach(i=>i(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,i){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(y,i){if(this.a.destroyed)return;let o;switch(y){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(c,y){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return y(i)}e.$_d=g;function P(c,y,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?y(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}e.$ae=P;function k(c,y){return new Promise((i,o)=>{const n=[];m(c,{onData:s=>{y&&n.push(s)},onError:s=>{y?o(s):i(void 0)},onEnd:()=>{i(y?y(n):void 0)}})})}e.$be=k;function m(c,y,i){c.on("error",o=>{i?.isCancellationRequested||y.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||y.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||y.onData(o)})}e.$ce=m;function h(c,y){return new Promise((i,o)=>{const n=new A.$Sc,s=[],t=v=>{if(s.push(v),s.length>y)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=v=>(n.dispose(),o(v)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,A.$Rc)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,A.$Rc)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,A.$Rc)(()=>c.removeListener("data",t))),c.on("data",t)})}e.$de=h;function $(c,y){const i=R(y);return i.end(c),i}e.$ee=$;function p(){const c=R(()=>{throw new Error("not supported")});return c.end(),c}e.$fe=p;function E(c){let y=!1;return{read:()=>y?null:(y=!0,c)}}e.$ge=E;function l(c,y,i){const o=R(i);return m(c,{onData:n=>o.write(y.data(n)),onError:n=>o.error(y.error?y.error(n):n),onEnd:()=>o.end()}),o}e.$he=l;function u(c,y,i){let o=!1;return{read:()=>{const n=y.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}e.$ie=u;function d(c,y,i){let o=!1;const n=R(i);return m(y,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}e.$je=d}),define(le[14],he([0,1,52,47]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const D=typeof Buffer<"u",L=new O.$V(()=>new Uint8Array(256));let I,R;class S{static alloc(b){return D?new S(Buffer.allocUnsafe(b)):new S(new Uint8Array(b))}static wrap(b){return D&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new S(b)}static fromString(b,C){return!(C?.dontUseNodeBuffer||!1)&&D?new S(Buffer.from(b)):(I||(I=new TextEncoder),new S(I.encode(b)))}static fromByteArray(b){const C=S.alloc(b.length);for(let N=0,T=b.length;N<T;N++)C.buffer[N]=b[N];return C}static concat(b,C){if(typeof C>"u"){C=0;for(let M=0,q=b.length;M<q;M++)C+=b[M].byteLength}const N=S.alloc(C);let T=0;for(let M=0,q=b.length;M<q;M++){const Y=b[M];N.set(Y,T),T+=Y.byteLength}return N}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=S.alloc(this.byteLength);return b.set(this),b}toString(){return D?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(b,C){return new S(this.buffer.subarray(b,C))}set(b,C){if(b instanceof S)this.buffer.set(b.buffer,C);else if(b instanceof Uint8Array)this.buffer.set(b,C);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),C);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return m(this.buffer,b)}writeUInt32BE(b,C){h(this.buffer,b,C)}readUInt32LE(b){return $(this.buffer,b)}writeUInt32LE(b,C){p(this.buffer,b,C)}readUInt8(b){return E(this.buffer,b)}writeUInt8(b,C){l(this.buffer,b,C)}indexOf(b,C=0){return g(this.buffer,b instanceof S?b.buffer:b,C)}}e.$ke=S;function g(f,b,C=0){const N=b.byteLength,T=f.byteLength;if(N===0)return 0;if(N===1)return f.indexOf(b[0]);if(N>T-C)return-1;const M=L.value;M.fill(b.length);for(let x=0;x<b.length;x++)M[b[x]]=b.length-x-1;let q=C+b.length-1,Y=q,X=-1;for(;q<T;)if(f[q]===b[Y]){if(Y===0){X=q;break}q--,Y--}else q+=Math.max(b.length-Y,M[f[q]]),Y=b.length-1;return X}e.$le=g;function P(f,b){return f[b+0]<<0>>>0|f[b+1]<<8>>>0}e.$me=P;function k(f,b,C){f[C+0]=b&255,b=b>>>8,f[C+1]=b&255}e.$ne=k;function m(f,b){return f[b]*2**24+f[b+1]*2**16+f[b+2]*2**8+f[b+3]}e.$oe=m;function h(f,b,C){f[C+3]=b,b=b>>>8,f[C+2]=b,b=b>>>8,f[C+1]=b,b=b>>>8,f[C]=b}e.$pe=h;function $(f,b){return f[b+0]<<0>>>0|f[b+1]<<8>>>0|f[b+2]<<16>>>0|f[b+3]<<24>>>0}e.$qe=$;function p(f,b,C){f[C+0]=b&255,b=b>>>8,f[C+1]=b&255,b=b>>>8,f[C+2]=b&255,b=b>>>8,f[C+3]=b&255}e.$re=p;function E(f,b){return f[b]}e.$se=E;function l(f,b,C){f[C]=b}e.$te=l;function u(f){return A.$_d(f,b=>S.concat(b))}e.$ue=u;function d(f){return A.$ge(f)}e.$ve=d;function c(f){return A.$be(f,b=>S.concat(b))}e.$we=c;async function y(f){return f.ended?S.concat(f.buffer):S.concat([...f.buffer,await c(f.stream)])}e.$xe=y;function i(f){return A.$ee(f,b=>S.concat(b))}e.$ye=i;function o(f){return A.$he(f,{data:b=>typeof b=="string"?S.fromString(b):S.wrap(b)},b=>S.concat(b))}e.$ze=o;function n(f){return A.$$d(b=>S.concat(b),f)}e.$Ae=n;function s(f,b){return A.$ie(f,b,C=>S.concat(C))}e.$Be=s;function t(f,b){return A.$je(f,b,C=>S.concat(C))}e.$Ce=t;function r(f){let b=0,C=0,N=0;const T=new Uint8Array(Math.floor(f.length/4*3)),M=Y=>{switch(C){case 3:T[N++]=b|Y,C=0;break;case 2:T[N++]=b|Y>>>2,b=Y<<6,C=3;break;case 1:T[N++]=b|Y>>>4,b=Y<<4,C=2;break;default:b=Y<<2,C=1}};for(let Y=0;Y<f.length;Y++){const X=f.charCodeAt(Y);if(X>=65&&X<=90)M(X-65);else if(X>=97&&X<=122)M(X-97+26);else if(X>=48&&X<=57)M(X-48+52);else if(X===43||X===45)M(62);else if(X===47||X===95)M(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${f[Y]}`)}}const q=N;for(;C>0;)M(0);return S.wrap(T).slice(0,q)}e.$De=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:f},b=!0,C=!1){const N=C?v:a;let T="";const M=f.byteLength%3;let q=0;for(;q<f.byteLength-M;q+=3){const Y=f[q+0],X=f[q+1],x=f[q+2];T+=N[Y>>>2],T+=N[(Y<<4|X>>>4)&63],T+=N[(X<<2|x>>>6)&63],T+=N[x&63]}if(M===1){const Y=f[q+0];T+=N[Y>>>2],T+=N[Y<<4&63],b&&(T+="==")}else if(M===2){const Y=f[q+0],X=f[q+1];T+=N[Y>>>2],T+=N[(Y<<4|X>>>4)&63],T+=N[X<<2&63],b&&(T+="=")}return T}e.$Ee=w}),define(le[27],he([0,1,129,52]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$If=e.$Hf=e.$Gf=e.$Ff=e.GraphemeBreakType=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=void 0;function D(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.$Ke=D;const L=/{(\d+)}/g;function I(re,...$e){return $e.length===0?re:re.replace(L,function(be,ve){const ye=parseInt(ve,10);return isNaN(ye)||ye<0||ye>=$e.length?be:$e[ye]})}e.$Le=I;const R=/{([^}]+)}/g;function S(re,$e){return Object.keys($e).length===0?re:re.replace(R,(be,ve)=>$e[ve]??be)}e.$Me=S;function g(re){return re.replace(/[<>"'&]/g,$e=>{switch($e){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return $e})}e.$Ne=g;function P(re){return re.replace(/[<>&]/g,function($e){switch($e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return $e}})}e.$Oe=P;function k(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Pe=k;function m(re,$e){let be=0;const ve=$e.charCodeAt(0);for(let ye=re.length-1;ye>=0;ye--)re.charCodeAt(ye)===ve&&be++;return be}e.$Qe=m;function h(re,$e,be="\u2026"){return re.length<=$e?re:`${re.substr(0,$e)}${be}`}e.$Re=h;function $(re,$e,be="\u2026"){if(re.length<=$e)return re;const ve=Math.ceil($e/2)-be.length/2,ye=Math.floor($e/2)-be.length/2;return`${re.substr(0,ve)}${be}${re.substr(re.length-ye)}`}e.$Se=$;function p(re,$e=" "){const be=E(re,$e);return l(be,$e)}e.$Te=p;function E(re,$e){if(!re||!$e)return re;const be=$e.length;if(be===0||re.length===0)return re;let ve=0;for(;re.indexOf($e,ve)===ve;)ve=ve+be;return re.substring(ve)}e.$Ue=E;function l(re,$e){if(!re||!$e)return re;const be=$e.length,ve=re.length;if(be===0||ve===0)return re;let ye=ve,Se=-1;for(;Se=re.lastIndexOf($e,ye-1),!(Se===-1||Se+be!==ye);){if(Se===0)return"";ye=Se}return re.substring(0,ye)}e.$Ve=l;function u(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$We=u;function d(re){return re.replace(/\*/g,"")}e.$Xe=d;function c(re,$e,be={}){if(!re)throw new Error("Cannot create regex from empty string");$e||(re=k(re)),be.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ve="";return be.global&&(ve+="g"),be.matchCase||(ve+="i"),be.multiline&&(ve+="m"),be.unicode&&(ve+="u"),new RegExp(re,ve)}e.$Ye=c;function y(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.$Ze=y;function i(re){return re.split(/\r\n|\r|\n/)}e.$1e=i;function o(re){for(let $e=0,be=re.length;$e<be;$e++){const ve=re.charCodeAt($e);if(ve!==32&&ve!==9)return $e}return-1}e.$2e=o;function n(re,$e=0,be=re.length){for(let ve=$e;ve<be;ve++){const ye=re.charCodeAt(ve);if(ye!==32&&ye!==9)return re.substring($e,ve)}return re.substring($e,be)}e.$3e=n;function s(re,$e=re.length-1){for(let be=$e;be>=0;be--){const ve=re.charCodeAt(be);if(ve!==32&&ve!==9)return be}return-1}e.$4e=s;function t(re,$e,be){const ve=[];let ye=0;for(const Se of re.matchAll($e)){if(ve.push(re.slice(ye,Se.index)),Se.index===void 0)throw new Error("match.index should be defined");ye=Se.index+Se[0].length,ve.push(be(Se[0],...Se.slice(1),Se.index,re,Se.groups))}return ve.push(re.slice(ye)),Promise.all(ve).then(Se=>Se.join(""))}e.$5e=t;function r(re,$e){return re<$e?-1:re>$e?1:0}e.$6e=r;function a(re,$e,be=0,ve=re.length,ye=0,Se=$e.length){for(;be<ve&&ye<Se;be++,ye++){const Ae=re.charCodeAt(be),We=$e.charCodeAt(ye);if(Ae<We)return-1;if(Ae>We)return 1}const Ie=ve-be,De=Se-ye;return Ie<De?-1:Ie>De?1:0}e.$7e=a;function v(re,$e){return w(re,$e,0,re.length,0,$e.length)}e.$8e=v;function w(re,$e,be=0,ve=re.length,ye=0,Se=$e.length){for(;be<ve&&ye<Se;be++,ye++){let Ae=re.charCodeAt(be),We=$e.charCodeAt(ye);if(Ae===We)continue;if(Ae>=128||We>=128)return a(re.toLowerCase(),$e.toLowerCase(),be,ve,ye,Se);b(Ae)&&(Ae-=32),b(We)&&(We-=32);const Ue=Ae-We;if(Ue!==0)return Ue}const Ie=ve-be,De=Se-ye;return Ie<De?-1:Ie>De?1:0}e.$9e=w;function f(re){return re>=48&&re<=57}e.$0e=f;function b(re){return re>=97&&re<=122}e.$$e=b;function C(re){return re>=65&&re<=90}e.$_e=C;function N(re,$e){return re.length===$e.length&&w(re,$e)===0}e.$af=N;function T(re,$e){const be=$e.length;return $e.length>re.length?!1:w(re,$e,0,be)===0}e.$bf=T;function M(re,$e){const be=Math.min(re.length,$e.length);let ve;for(ve=0;ve<be;ve++)if(re.charCodeAt(ve)!==$e.charCodeAt(ve))return ve;return be}e.$cf=M;function q(re,$e){const be=Math.min(re.length,$e.length);let ve;const ye=re.length-1,Se=$e.length-1;for(ve=0;ve<be;ve++)if(re.charCodeAt(ye-ve)!==$e.charCodeAt(Se-ve))return ve;return be}e.$df=q;function Y(re){return 55296<=re&&re<=56319}e.$ef=Y;function X(re){return 56320<=re&&re<=57343}e.$ff=X;function x(re,$e){return(re-55296<<10)+($e-56320)+65536}e.$gf=x;function V(re,$e,be){const ve=re.charCodeAt(be);if(Y(ve)&&be+1<$e){const ye=re.charCodeAt(be+1);if(X(ye))return x(ve,ye)}return ve}e.$hf=V;function Q(re,$e){const be=re.charCodeAt($e-1);if(X(be)&&$e>1){const ve=re.charCodeAt($e-2);if(Y(ve))return x(ve,be)}return be}class H{get offset(){return this.e}constructor($e,be=0){this.c=$e,this.d=$e.length,this.e=be}setOffset($e){this.e=$e}prevCodePoint(){const $e=Q(this.c,this.e);return this.e-=$e>=65536?2:1,$e}nextCodePoint(){const $e=V(this.c,this.d,this.e);return this.e+=$e>=65536?2:1,$e}eol(){return this.e>=this.d}}e.$if=H;class W{get offset(){return this.c.offset}constructor($e,be=0){this.c=new H($e,be)}nextGraphemeLength(){const $e=Ce.getInstance(),be=this.c,ve=be.offset;let ye=$e.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Se=be.offset,Ie=$e.getGraphemeBreakType(be.nextCodePoint());if(ge(ye,Ie)){be.setOffset(Se);break}ye=Ie}return be.offset-ve}prevGraphemeLength(){const $e=Ce.getInstance(),be=this.c,ve=be.offset;let ye=$e.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Se=be.offset,Ie=$e.getGraphemeBreakType(be.prevCodePoint());if(ge(Ie,ye)){be.setOffset(Se);break}ye=Ie}return ve-be.offset}eol(){return this.c.eol()}}e.$jf=W;function te(re,$e){return new W(re,$e).nextGraphemeLength()}e.$kf=te;function oe(re,$e){return new W(re,$e).prevGraphemeLength()}e.$lf=oe;function ee(re,$e){$e>0&&X(re.charCodeAt($e))&&$e--;const be=$e+te(re,$e);return[be-oe(re,be),be]}e.$mf=ee;function ae(re){const $e=new W(re);let be=0;for(;!$e.eol();)be++,$e.nextGraphemeLength();return be}e.$nf=ae;let G;function z(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(re){return G||(G=z()),G.test(re)}e.$of=j;const F=/^[\t\n\r\x20-\x7E]*$/;function B(re){return F.test(re)}e.$pf=B,e.$qf=/[\u2028\u2029]/;function U(re){return e.$qf.test(re)}e.$rf=U;function Z(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.$sf=Z;function _(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.$tf=_;function ie(re,$e,be=""){const ve=re.trimStart();if(ve.length<$e)return ve;const ye=/\b/g;let Se=0;for(;ye.test(ve)&&!(ve.length-ye.lastIndex<$e);)Se=ye.lastIndex,ye.lastIndex+=1;return Se===0?ve:be+ve.substring(Se).trimStart()}e.$uf=ie;const J=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ne=/\x1b\].*?\x07/g;function ce(re){return re&&(re=re.replace(J,"").replace(ne,"")),re}e.$vf=ce,e.$wf="\uFEFF";function fe(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.$xf=fe;function de(re){return fe(re)?re.substr(1):re}e.$yf=de;function me(re,$e){if(!re||!$e||re.length<$e.length)return!1;const be=$e.length,ve=re.toLowerCase();let ye=0,Se=-1;for(;ye<be;){const Ie=ve.indexOf($e[ye],Se+1);if(Ie<0)return!1;Se=Ie,ye++}return!0}e.$zf=me;function Ee(re,$e=!1){return re?($e&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.$Af=Ee;function Pe(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.$Bf=Pe;function Oe(re,$e=1){if($e===0)return"";let be=-1;do be=re.indexOf(`
`,be+1),$e--;while($e>0&&be>=0);return be===-1?re:(re[be-1]==="\r"&&be--,re.substr(0,be))}e.$Cf=Oe;function Ne(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.$Df=Ne;function ue(re){return Ce.getInstance().getGraphemeBreakType(re)}e.$Ef=ue;function ge(re,$e){return re===0?$e!==5&&$e!==7:re===2&&$e===3?!1:re===4||re===2||re===3||$e===4||$e===2||$e===3?!0:!(re===8&&($e===8||$e===9||$e===11||$e===12)||(re===11||re===9)&&($e===9||$e===10)||(re===12||re===10)&&$e===10||$e===5||$e===13||$e===7||re===1||re===13&&$e===14||re===6&&$e===6)}var we;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(we||(e.GraphemeBreakType=we={}));class Ce{static{this.c=null}static getInstance(){return Ce.c||(Ce.c=new Ce),Ce.c}constructor(){this.d=Re()}getGraphemeBreakType($e){if($e<32)return $e===10?3:$e===13?2:4;if($e<127)return 0;const be=this.d,ve=be.length/3;let ye=1;for(;ye<=ve;)if($e<be[3*ye])ye=2*ye;else if($e>be[3*ye+1])ye=2*ye+1;else return be[3*ye+2];return 0}}function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(re,$e){if(re===0)return 0;const be=je(re,$e);if(be!==void 0)return be;const ve=new H($e,re);return ve.prevCodePoint(),ve.offset}e.$Ff=Me;function je(re,$e){const be=new H($e,re);let ve=be.prevCodePoint();for(;ze(ve)||ve===65039||ve===8419;){if(be.offset===0)return;ve=be.prevCodePoint()}if(!_(ve))return;let ye=be.offset;return ye>0&&be.prevCodePoint()===8205&&(ye=be.offset),ye}function ze(re){return 127995<=re&&re<=127999}var Fe;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.$Gf="\xA0";class Te{static{this.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new O.$Ge($e=>{function be(Ue){const Be=new Map;for(let Ve=0;Ve<Ue.length;Ve+=2)Be.set(Ue[Ve],Ue[Ve+1]);return Be}function ve(Ue,Be){const Ve=new Map(Ue);for(const[Ze,et]of Be)Ve.set(Ze,et);return Ve}function ye(Ue,Be){if(!Ue)return Be;const Ve=new Map;for(const[Ze,et]of Ue)Be.has(Ze)&&Ve.set(Ze,et);return Ve}const Se=this.c.value;let Ie=$e.filter(Ue=>!Ue.startsWith("_")&&Ue in Se);Ie.length===0&&(Ie=["_default"]);let De;for(const Ue of Ie){const Be=be(Se[Ue]);De=ye(De,Be)}const Ae=be(Se._common),We=ve(Ae,De);return new Te(We)})}static getInstance($e){return Te.d.get(Array.from($e))}static{this.e=new A.$V(()=>Object.keys(Te.c.value).filter($e=>!$e.startsWith("_")))}static getLocales(){return Te.e.value}constructor($e){this.f=$e}isAmbiguous($e){return this.f.has($e)}getPrimaryConfusable($e){return this.f.get($e)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Hf=Te;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter($e){return qe.e().has($e)}static get codePoints(){return qe.e()}}e.$If=qe}),define(le[53],he([0,1,27]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;function A(l){return D(l,0)}e.$Vi=A;function D(l,u){switch(typeof l){case"object":return l===null?L(349,u):Array.isArray(l)?S(l,u):g(l,u);case"string":return R(l,u);case"boolean":return I(l,u);case"number":return L(l,u);case"undefined":return L(937,u);default:return L(617,u)}}e.$Wi=D;function L(l,u){return(u<<5)-u+l|0}e.$Xi=L;function I(l,u){return L(l?433:863,u)}function R(l,u){u=L(149417,u);for(let d=0,c=l.length;d<c;d++)u=L(l.charCodeAt(d),u);return u}e.$Yi=R;function S(l,u){return u=L(104579,u),l.reduce((d,c)=>D(c,d),u)}function g(l,u){return u=L(181387,u),Object.keys(l).sort().reduce((d,c)=>(d=R(c,d),D(l[c],d)),u)}class P{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=D(u,this.g),this.g}}e.$Zi=P;var k;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function m(l,u,d=32){const c=d-u,y=~((1<<c)-1);return(l<<u|(y&l)>>>c)>>>0}function h(l,u=0,d=l.byteLength,c=0){for(let y=0;y<d;y++)l[u+y]=c}function $(l,u,d="0"){for(;l.length<u;)l=d+l;return l}function p(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(d=>d.toString(16).padStart(2,"0")).join(""):$((l>>>0).toString(16),u/4)}e.$1i=p;class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const d=u.length;if(d===0)return;const c=this.p;let y=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=u.charCodeAt(0),n=0);;){let s=o;if(O.$ef(o))if(n+1<d){const t=u.charCodeAt(n+1);O.$ff(t)?(n++,s=O.$gf(o,t)):s=65533}else{i=o;break}else O.$ff(o)&&(s=65533);if(y=this.w(c,y,s),n++,n<d)o=u.charCodeAt(n);else break}this.r=y,this.u=i}w(u,d,c){return c<128?u[d++]=c:c<2048?(u[d++]=192|(c&1984)>>>6,u[d++]=128|(c&63)>>>0):c<65536?(u[d++]=224|(c&61440)>>>12,u[d++]=128|(c&4032)>>>6,u[d++]=128|(c&63)>>>0):(u[d++]=240|(c&1835008)>>>18,u[d++]=128|(c&258048)>>>12,u[d++]=128|(c&4032)>>>6,u[d++]=128|(c&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=E.g,d=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,d.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,m(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let c=this.h,y=this.l,i=this.m,o=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=y&i|~y&o,t=1518500249):a<40?(s=y^i^o,t=1859775393):a<60?(s=y&i|y&o|i&o,t=2400959708):(s=y^i^o,t=3395469782),r=m(c,5)+s+n+t+u.getUint32(a*4,!1)&4294967295,n=o,o=i,i=m(y,30),y=c,c=r;this.h=this.h+c&4294967295,this.l=this.l+y&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$2i=E}),define(le[89],he([0,1,27]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(A||(A={})),function(D){const L="error",I="warning",R="warn",S="info",g="ignore";function P(m){return m?O.$af(L,m)?D.Error:O.$af(I,m)||O.$af(R,m)?D.Warning:O.$af(S,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=P;function k(m){switch(m){case D.Error:return L;case D.Warning:return I;case D.Info:return S;default:return g}}D.toString=k}(A||(A={})),e.default=A}),define(le[130],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(le[48],he([0,1,17,27]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0;class D{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const $=h.charCodeAt(0),p=this.b.charCodeAt(this.c);return $-p}value(){return this.b[this.c]}}e.$0h=D;class L{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,A.$7e)(h,this.b,0,h.length,this.c,this.d):(0,A.$9e)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$$h=L;class I{constructor(h=!0,$=!0){this.f=h,this.g=$}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let $=h.length-1;$>=0;$--,this.c--){const p=this.b.charCodeAt($);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,A.$7e)(h,this.b,0,h.length,this.d,this.e):(0,A.$9e)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$_h=I;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(h,$){this.f=h,this.g=$,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,A.$8e)(h,this.c.scheme);if(this.d[this.e]===2)return(0,A.$8e)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,A.$6e)(h,this.c.query);if(this.d[this.e]===5)return(0,A.$6e)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ai=S;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(P||(P={}));class k{static forUris(h=()=>!1,$=()=>!1){return new k(new S(h,$))}static forPaths(h=!1){return new k(new I(void 0,!h))}static forStrings(){return new k(new D)}static forConfigKeys(){return new k(new L)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,$){if($){const p=$.slice(0);(0,O.$Xb)(p);for(const E of p)this.set(E,h)}else{const p=h.slice(0);(0,O.$Xb)(p);for(const E of p)this.set(E[0],E[1])}}set(h,$){const p=this.b.reset(h);let E;this.c||(this.c=new g,this.c.segment=p.value());const l=[];for(E=this.c;;){const d=p.cmp(E.segment);if(d>0)E.left||(E.left=new g,E.left.segment=p.value()),l.push([-1,E]),E=E.left;else if(d<0)E.right||(E.right=new g,E.right.segment=p.value()),l.push([1,E]),E=E.right;else if(p.hasNext())p.next(),E.mid||(E.mid=new g,E.mid.segment=p.value()),l.push([0,E]),E=E.mid;else break}const u=E.value;E.value=$,E.key=h;for(let d=l.length-1;d>=0;d--){const c=l[d][1];c.updateHeight();const y=c.balanceFactor();if(y<-1||y>1){const i=l[d][0],o=l[d+1][0];if(i===1&&o===1)l[d][1]=c.rotateLeft();else if(i===-1&&o===-1)l[d][1]=c.rotateRight();else if(i===1&&o===-1)c.right=l[d+1][1]=l[d+1][1].rotateRight(),l[d][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=l[d+1][1]=l[d+1][1].rotateLeft(),l[d][1]=c.rotateRight();else throw new Error;if(d>0)switch(l[d-1][0]){case-1:l[d-1][1].left=l[d][1];break;case 1:l[d-1][1].right=l[d][1];break;case 0:l[d-1][1].mid=l[d][1];break}else this.c=l[0][1]}}return u}get(h){return this.d(h)?.value}d(h){const $=this.b.reset(h);let p=this.c;for(;p;){const E=$.cmp(p.segment);if(E>0)p=p.left;else if(E<0)p=p.right;else if($.hasNext())$.next(),p=p.mid;else break}return p}has(h){const $=this.d(h);return!($?.value===void 0&&$?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,$){const p=this.b.reset(h),E=[];let l=this.c;for(;l;){const u=p.cmp(l.segment);if(u>0)E.push([-1,l]),l=l.left;else if(u<0)E.push([1,l]),l=l.right;else if(p.hasNext())p.next(),E.push([0,l]),l=l.mid;else break}if(l){if($?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const u=this.f(l.right);if(u.key){const{key:d,value:c,segment:y}=u;this.e(u.key,!1),l.key=d,l.value=c,l.segment=y}}else{const u=l.left??l.right;if(E.length>0){const[d,c]=E[E.length-1];switch(d){case-1:c.left=u;break;case 0:c.mid=u;break;case 1:c.right=u;break}}else this.c=u}for(let u=E.length-1;u>=0;u--){const d=E[u][1];d.updateHeight();const c=d.balanceFactor();if(c>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),E[u][1]=d.rotateLeft()):c<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),E[u][1]=d.rotateRight()),u>0)switch(E[u-1][0]){case-1:E[u-1][1].left=E[u][1];break;case 1:E[u-1][1].right=E[u][1];break;case 0:E[u-1][1].mid=E[u][1];break}else this.c=E[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const $=this.b.reset(h);let p=this.c,E;for(;p;){const l=$.cmp(p.segment);if(l>0)p=p.left;else if(l<0)p=p.right;else if($.hasNext())$.next(),E=p.value||E,p=p.mid;else break}return p&&p.value||E}findSuperstr(h){return this.g(h,!1)}g(h,$){const p=this.b.reset(h);let E=this.c;for(;E;){const l=p.cmp(E.segment);if(l>0)E=E.left;else if(l<0)E=E.right;else if(p.hasNext())p.next(),E=E.mid;else return E.mid?this.h(E.mid):$?E.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[$,p]of this)h(p,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const $=[];return this.j(h,$),$[Symbol.iterator]()}j(h,$){h&&(h.left&&this.j(h.left,$),h.value&&$.push([h.key,h.value]),h.mid&&this.j(h.mid,$),h.right&&this.j(h.right,$))}_isBalanced(){const h=$=>{if(!$)return!0;const p=$.balanceFactor();return p<-1||p>1?!1:h($.left)&&h($.right)};return h(this.c)}}e.$bi=k}),define(le[12],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=void 0;function O(y){return typeof y=="string"}e.$Jf=O;function A(y){return Array.isArray(y)&&y.every(i=>O(i))}e.$Kf=A;function D(y){return typeof y=="object"&&y!==null&&!Array.isArray(y)&&!(y instanceof RegExp)&&!(y instanceof Date)}e.$Lf=D;function L(y){const i=Object.getPrototypeOf(Uint8Array);return typeof y=="object"&&y instanceof i}e.$Mf=L;function I(y){return typeof y=="number"&&!isNaN(y)}e.$Nf=I;function R(y){return!!y&&typeof y[Symbol.iterator]=="function"}e.$Of=R;function S(y){return y===!0||y===!1}e.$Pf=S;function g(y){return typeof y>"u"}e.$Qf=g;function P(y){return!k(y)}e.$Rf=P;function k(y){return g(y)||y===null}e.$Sf=k;function m(y,i){if(!y)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$Tf=m;function h(y){if(k(y))throw new Error("Assertion Failed: argument is undefined or null");return y}e.$Uf=h;function $(...y){const i=[];for(let o=0;o<y.length;o++){const n=y[o];if(k(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}e.$Vf=$;const p=Object.prototype.hasOwnProperty;function E(y){if(!D(y))return!1;for(const i in y)if(p.call(y,i))return!1;return!0}e.$Wf=E;function l(y){return typeof y=="function"}e.$Xf=l;function u(...y){return y.length>0&&y.every(l)}e.$Yf=u;function d(y,i){const o=Math.min(y.length,i.length);for(let n=0;n<o;n++)c(y[n],i[n])}e.$Zf=d;function c(y,i){if(O(i)){if(typeof y!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(l(i)){try{if(y instanceof i)return}catch{}if(!k(y)&&y.constructor===i||i.length===1&&i.call(void 0,y)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$1f=c}),define(le[30],he([0,1,12]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=void 0;function A(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([d,c])=>{u[d]=c&&typeof c=="object"?A(c):c}),u}e.$yn=A;function D(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const d=u.shift();Object.freeze(d);for(const c in d)if(L.call(d,c)){const y=d[c];typeof y=="object"&&!Object.isFrozen(y)&&!(0,O.$Mf)(y)&&u.push(y)}}return l}e.$zn=D;const L=Object.prototype.hasOwnProperty;function I(l,u){return R(l,u,new Set)}e.$An=I;function R(l,u,d){if((0,O.$Sf)(l))return l;const c=u(l);if(typeof c<"u")return c;if(Array.isArray(l)){const y=[];for(const i of l)y.push(R(i,u,d));return y}if((0,O.$Lf)(l)){if(d.has(l))throw new Error("Cannot clone recursive data-structure");d.add(l);const y={};for(const i in l)L.call(l,i)&&(y[i]=R(l[i],u,d));return d.delete(l),y}return l}function S(l,u,d=!0){return(0,O.$Lf)(l)?((0,O.$Lf)(u)&&Object.keys(u).forEach(c=>{c in l?d&&((0,O.$Lf)(l[c])&&(0,O.$Lf)(u[c])?S(l[c],u[c],d):l[c]=u[c]):l[c]=u[c]}),l):u}e.$Bn=S;function g(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let d,c;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(d=0;d<l.length;d++)if(!g(l[d],u[d]))return!1}else{const y=[];for(c in l)y.push(c);y.sort();const i=[];for(c in u)i.push(c);if(i.sort(),!g(y,i))return!1;for(d=0;d<y.length;d++)if(!g(l[y[d]],u[y[d]]))return!1}return!0}e.$Cn=g;function P(l){const u=new Set;return JSON.stringify(l,(d,c)=>{if((0,O.$Lf)(c)||Array.isArray(c)){if(u.has(c))return"[Circular]";u.add(c)}return c})}e.$Dn=P;function k(l,u){const d=Object.create(null);return!l||!u||Object.keys(u).forEach(y=>{const i=l[y],o=u[y];g(i,o)||(d[y]=o)}),d}e.$En=k;function m(l,u){const d=u.toLowerCase(),c=Object.keys(l).find(y=>y.toLowerCase()===d);return c?l[c]:l[u]}e.$Fn=m;function h(l,u){const d=Object.create(null);for(const[c,y]of Object.entries(l))u(c,y)&&(d[c]=y);return d}e.$Gn=h;function $(l){let u=[];for(;Object.prototype!==l;)u=u.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return u}e.$Hn=$;function p(l){const u=[];for(const d of $(l))typeof l[d]=="function"&&u.push(d);return u}e.$In=p;function E(l,u){const d=y=>function(){const i=Array.prototype.slice.call(arguments,0);return u(y,i)},c={};for(const y of l)c[y]=d(y);return c}e.$Jn=E}),define(le[32],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(D){return O.test(D)}e.$qg=A,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const L=new Uint8Array(16),I=[];for(let R=0;R<256;R++)I.push(R.toString(16).padStart(2,"0"));return function(){D(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,g="";return g+=I[L[S++]],g+=I[L[S++]],g+=I[L[S++]],g+=I[L[S++]],g+="-",g+=I[L[S++]],g+=I[L[S++]],g+="-",g+=I[L[S++]],g+=I[L[S++]],g+="-",g+=I[L[S++]],g+=I[L[S++]],g+="-",g+=I[L[S++]],g+=I[L[S++]],g+=I[L[S++]],g+=I[L[S++]],g+=I[L[S++]],g+=I[L[S++]],g}}()}),define(le[131],he([0,1,36]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(I){const R=I.replace(/\-/g,":").toLowerCase();return!A.has(R)}function L(){const I=(0,O.networkInterfaces)();for(const R in I){const S=I[R];if(S){for(const{mac:g}of S)if(D(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$_m=L}),define(le[132],he([0,1,267,14]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RU=void 0;class D extends O.Transform{constructor(I){if(super(),typeof I=="number")this.b=I,this.c=1;else{const R=Buffer.isBuffer(I)?I:Buffer.from(I);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(I,R,S){this.a?this.a=Buffer.concat([this.a,I]):this.a=I;let g=0;for(;g<this.a.length;){const P=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,A.$le)(this.a,this.b,g);if(P===-1)break;this.push(this.a.slice(g,P+this.c)),g=P+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),S()}_flush(I){this.a&&this.push(this.a),I()}}e.$RU=D}),define(le[133],he([0,1,64]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vg=e.$ug=e.$tg=void 0;function A(R,S,g,P=1){let k=!1;return new Promise(m=>{const h=setTimeout(()=>{if(!k)return k=!0,m(0)},g);D(R,S,P,$=>{if(!k)return k=!0,clearTimeout(h),m($)})})}e.$tg=A;function D(R,S,g,P){if(S===0)return P(0);const k=new O.Socket;k.once("connect",()=>(I(k),D(R+g,S-1,g,P))),k.once("data",()=>{}),k.once("error",m=>(I(k),m.code!=="ECONNREFUSED"?D(R+g,S-1,g,P):P(R))),k.connect(R,"127.0.0.1")}e.$ug={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(R,S,g,P="127.0.0.1"){let k=!1,m,h=1;const $=O.createServer({pauseOnConnect:!0});function p(E,l){k||(k=!0,$.removeAllListeners(),$.close(),m&&clearTimeout(m),l(E))}return new Promise(E=>{m=setTimeout(()=>{p(0,E)},g),$.on("listening",()=>{p(R,E)}),$.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&h<S?(R++,h++,$.listen(R,P)):p(0,E)}),$.on("close",()=>{p(0,E)}),$.listen(R,P)})}e.$vg=L;function I(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(S){console.error(S)}}}),define(le[134],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8U=void 0;function O(A){return!!A.parentPort}e.$8U=O}),define(le[135],he([13,10]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],he([0,1,135]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0;const A=60,D=A*60,L=D*24,I=L*7,R=L*30,S=L*365;function g(m,h,$,p){typeof m!="number"&&(m=m.getTime());const E=Math.round((new Date().getTime()-m)/1e3);if(E<-30)return(0,O.localize)(0,null,g(new Date().getTime()+E*1e3,!1));if(!p&&E<30)return(0,O.localize)(1,null);let l;return E<A?(l=E,h?l===1?$?(0,O.localize)(2,null,l):(0,O.localize)(3,null,l):$?(0,O.localize)(4,null,l):(0,O.localize)(5,null,l):l===1?$?(0,O.localize)(6,null,l):(0,O.localize)(7,null,l):$?(0,O.localize)(8,null,l):(0,O.localize)(9,null,l)):E<D?(l=Math.floor(E/A),h?l===1?$?(0,O.localize)(10,null,l):(0,O.localize)(11,null,l):$?(0,O.localize)(12,null,l):(0,O.localize)(13,null,l):l===1?$?(0,O.localize)(14,null,l):(0,O.localize)(15,null,l):$?(0,O.localize)(16,null,l):(0,O.localize)(17,null,l)):E<L?(l=Math.floor(E/D),h?l===1?$?(0,O.localize)(18,null,l):(0,O.localize)(19,null,l):$?(0,O.localize)(20,null,l):(0,O.localize)(21,null,l):l===1?$?(0,O.localize)(22,null,l):(0,O.localize)(23,null,l):$?(0,O.localize)(24,null,l):(0,O.localize)(25,null,l)):E<I?(l=Math.floor(E/L),h?l===1?(0,O.localize)(26,null,l):(0,O.localize)(27,null,l):l===1?(0,O.localize)(28,null,l):(0,O.localize)(29,null,l)):E<R?(l=Math.floor(E/I),h?l===1?$?(0,O.localize)(30,null,l):(0,O.localize)(31,null,l):$?(0,O.localize)(32,null,l):(0,O.localize)(33,null,l):l===1?$?(0,O.localize)(34,null,l):(0,O.localize)(35,null,l):$?(0,O.localize)(36,null,l):(0,O.localize)(37,null,l)):E<S?(l=Math.floor(E/R),h?l===1?$?(0,O.localize)(38,null,l):(0,O.localize)(39,null,l):$?(0,O.localize)(40,null,l):(0,O.localize)(41,null,l):l===1?$?(0,O.localize)(42,null,l):(0,O.localize)(43,null,l):$?(0,O.localize)(44,null,l):(0,O.localize)(45,null,l)):(l=Math.floor(E/S),h?l===1?$?(0,O.localize)(46,null,l):(0,O.localize)(47,null,l):$?(0,O.localize)(48,null,l):(0,O.localize)(49,null,l):l===1?$?(0,O.localize)(50,null,l):(0,O.localize)(51,null,l):$?(0,O.localize)(52,null,l):(0,O.localize)(53,null,l))}e.$xm=g;function P(m,h){const $=Math.abs(m/1e3);return $<1?h?(0,O.localize)(54,null,m):(0,O.localize)(55,null,m):$<A?h?(0,O.localize)(56,null,Math.round(m)/1e3):(0,O.localize)(57,null,Math.round(m)/1e3):$<D?h?(0,O.localize)(58,null,Math.round(m/(1e3*A))):(0,O.localize)(59,null,Math.round(m/(1e3*A))):$<L?h?(0,O.localize)(60,null,Math.round(m/(1e3*D))):(0,O.localize)(61,null,Math.round(m/(1e3*D))):(0,O.localize)(62,null,Math.round(m/(1e3*L)))}e.$ym=P;function k(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$zm=k}),define(le[136],he([13,10]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,17,12,136]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=void 0;function L(k,m){return m&&(k.stack||k.stacktrace)?D.localize(0,null,R(k),I(k.stack)||I(k.stacktrace)):R(k)}function I(k){return Array.isArray(k)?k.join(`
`):k}function R(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function S(k=null,m=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const h=O.$Hb(k),$=S(h[0],m);return h.length>1?D.localize(4,null,$,h.length):$}if(A.$Jf(k))return k;if(k.detail){const h=k.detail;if(h.error)return L(h.error,m);if(h.exception)return L(h.exception,m)}return k.stack?L(k,m):k.message?k.message:D.localize(5,null)}e.$Si=S;function g(k){const m=k;return m instanceof Error&&Array.isArray(m.actions)}e.$Ti=g;function P(k,m){let h;return typeof k=="string"?h=new Error(k):h=k,h.actions=m,h}e.$Ui=P}),define(le[137],he([13,10]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],he([0,1,137]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;function A(D){switch(D){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.$Zp=A}),define(le[139],he([13,10]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],he([0,1,139]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let A=!1,D=!1,L=!1,I=!1,R=!1,S=!1,g=!1,P=!1,k=!1,m=!1,h,$=e.$g,p=e.$g,E,l;const u=globalThis;let d;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?d=u.vscode.process:typeof process<"u"&&(d=process);const c=typeof d?.versions?.electron=="string",y=c&&d?.type==="renderer";if(typeof d=="object"){A=d.platform==="win32",D=d.platform==="darwin",L=d.platform==="linux",I=L&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,g=c,k=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$g,$=e.$g;const f=d.env.VSCODE_NLS_CONFIG;if(f)try{const b=JSON.parse(f),C=b.availableLanguages["*"];h=b.locale,p=b.osLocale,$=C||e.$g,E=b._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!y?(l=navigator.userAgent,A=l.indexOf("Windows")>=0,D=l.indexOf("Macintosh")>=0,P=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=l.indexOf("Linux")>=0,m=l?.indexOf("Mobi")>=0,S=!0,h=O.getConfiguredDefaultLocale(O.localize(0,null))||e.$g,$=h,p=navigator.language):console.error("Unable to resolve platform.");var i;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let n=0;D?n=1:A?n=3:L&&(n=2),e.$i=A,e.$j=D,e.$k=L,e.$l=I,e.$m=R,e.$n=g,e.$o=S,e.$p=S&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=P,e.$s=m,e.$t=k,e.$u=n,e.$v=l,e.$w=$;var s;(function(f){function b(){return e.$w}f.value=b;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}f.isDefaultVariant=C;function N(){return e.$w==="en"}f.isDefault=N})(s||(e.Language=s={})),e.$x=h,e.$y=p,e.$z=E,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const f=[];u.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let N=0,T=f.length;N<T;N++){const M=f[N];if(M.id===C.data.vscodeScheduleAsyncWork){f.splice(N,1),M.callback();return}}});let b=0;return C=>{const N=++b;f.push({id:N,callback:C}),u.postMessage({vscodeScheduleAsyncWork:N},"*")}}return f=>setTimeout(f)})();var t;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=D||P?2:A?1:3;let r=!0,a=!1;function v(){if(!a){a=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,r=new Uint16Array(f.buffer)[0]===513}return r}e.$D=v,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(f){return parseFloat(f)>=20}e.$J=w}),define(le[37],he([0,1,5]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let A;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.process<"u"){const L=D.process;A={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return O.$i?"win32":O.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$dc=A.platform,e.$ec=A.arch}),define(le[16],he([0,1,37]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const A=65,D=97,L=90,I=122,R=46,S=47,g=92,P=58,k=63;class m extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function $(i,o){if(typeof i!="string")throw new m(o,"string",i)}const p=O.$dc==="win32";function E(i){return i===S||i===g}function l(i){return i===S}function u(i){return i>=A&&i<=L||i>=D&&i<=I}function d(i,o,n,s){let t="",r=0,a=-1,v=0,w=0;for(let f=0;f<=i.length;++f){if(f<i.length)w=i.charCodeAt(f);else{if(s(w))break;w=S}if(s(w)){if(!(a===f-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const b=t.lastIndexOf(n);b===-1?(t="",r=0):(t=t.slice(0,b),r=t.length-1-t.lastIndexOf(n)),a=f,v=0;continue}else if(t.length!==0){t="",r=0,a=f,v=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,f)}`:t=i.slice(a+1,f),r=f-a-1;a=f,v=0}else w===R&&v!==-1?++v:v=-1}return t}function c(i,o){h(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.$fc={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],$(r,"path"),r.length===0)continue}else o.length===0?r=O.cwd():(r=O.env[`=${o}`]||O.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let v=0,w="",f=!1;const b=r.charCodeAt(0);if(a===1)E(b)&&(v=1,f=!0);else if(E(b))if(f=!0,E(r.charCodeAt(1))){let C=2,N=C;for(;C<a&&!E(r.charCodeAt(C));)C++;if(C<a&&C!==N){const T=r.slice(N,C);for(N=C;C<a&&E(r.charCodeAt(C));)C++;if(C<a&&C!==N){for(N=C;C<a&&!E(r.charCodeAt(C));)C++;(C===a||C!==N)&&(w=`\\\\${T}\\${r.slice(N,C)}`,v=C)}}}else v=1;else u(b)&&r.charCodeAt(1)===P&&(w=r.slice(0,2),v=2,a>2&&E(r.charCodeAt(2))&&(f=!0,v=3));if(w.length>0)if(o.length>0){if(w.toLowerCase()!==o.toLowerCase())continue}else o=w;if(s){if(o.length>0)break}else if(n=`${r.slice(v)}\\${n}`,s=f,f&&o.length>0)break}return n=d(n,!s,"\\",E),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){$(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return l(r)?"\\":i;if(E(r))if(t=!0,E(i.charCodeAt(1))){let v=2,w=v;for(;v<o&&!E(i.charCodeAt(v));)v++;if(v<o&&v!==w){const f=i.slice(w,v);for(w=v;v<o&&E(i.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&!E(i.charCodeAt(v));)v++;if(v===o)return`\\\\${f}\\${i.slice(w)}\\`;v!==w&&(s=`\\\\${f}\\${i.slice(w,v)}`,n=v)}}}else n=1;else u(r)&&i.charCodeAt(1)===P&&(s=i.slice(0,2),n=2,o>2&&E(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?d(i.slice(n),!t,"\\",E):"";return a.length===0&&!t&&(a="."),a.length>0&&E(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){$(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return E(n)||o>2&&u(n)&&i.charCodeAt(1)===P&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];$(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&E(n.charCodeAt(0))){++t;const r=n.length;r>1&&E(n.charCodeAt(1))&&(++t,r>2&&(E(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&E(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$fc.normalize(o)},relative(i,o){if($(i,"from"),$(o,"to"),i===o)return"";const n=e.$fc.resolve(i),s=e.$fc.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===g;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===g;)r--;const a=r-t;let v=0;for(;v<o.length&&o.charCodeAt(v)===g;)v++;let w=o.length;for(;w-1>v&&o.charCodeAt(w-1)===g;)w--;const f=w-v,b=a<f?a:f;let C=-1,N=0;for(;N<b;N++){const M=i.charCodeAt(t+N);if(M!==o.charCodeAt(v+N))break;M===g&&(C=N)}if(N!==b){if(C===-1)return s}else{if(f>b){if(o.charCodeAt(v+N)===g)return s.slice(v+N+1);if(N===2)return s.slice(v+N)}a>b&&(i.charCodeAt(t+N)===g?C=N:N===2&&(C=3)),C===-1&&(C=0)}let T="";for(N=t+C+1;N<=r;++N)(N===r||i.charCodeAt(N)===g)&&(T+=T.length===0?"..":"\\..");return v+=C,T.length>0?`${T}${s.slice(v,w)}`:(s.charCodeAt(v)===g&&++v,s.slice(v,w))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$fc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const n=o.charCodeAt(2);if(n!==k&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(u(o.charCodeAt(0))&&o.charCodeAt(1)===P&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return i},dirname(i){$(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return E(t)?i:".";if(E(t)){if(n=s=1,E(i.charCodeAt(1))){let v=2,w=v;for(;v<o&&!E(i.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&E(i.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&!E(i.charCodeAt(v));)v++;if(v===o)return i;v!==w&&(n=s=v+1)}}}}else u(t)&&i.charCodeAt(1)===P&&(n=o>2&&E(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let v=o-1;v>=s;--v)if(E(i.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&$(o,"ext"),$(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&u(i.charCodeAt(0))&&i.charCodeAt(1)===P&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,v=-1;for(r=i.length-1;r>=n;--r){const w=i.charCodeAt(r);if(E(w)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=v))}return n===s?s=v:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(E(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){$(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===P&&u(i.charCodeAt(0))&&(o=s=2);for(let v=i.length-1;v>=o;--v){const w=i.charCodeAt(v);if(E(w)){if(!r){s=v+1;break}continue}t===-1&&(r=!1,t=v+1),w===R?n===-1?n=v:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){$(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return E(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(E(t)){if(s=1,E(i.charCodeAt(1))){let C=2,N=C;for(;C<n&&!E(i.charCodeAt(C));)C++;if(C<n&&C!==N){for(N=C;C<n&&E(i.charCodeAt(C));)C++;if(C<n&&C!==N){for(N=C;C<n&&!E(i.charCodeAt(C));)C++;C===n?s=C:C!==N&&(s=C+1)}}}}else if(u(t)&&i.charCodeAt(1)===P){if(n<=2)return o.root=o.dir=i,o;if(s=2,E(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,v=-1,w=!0,f=i.length-1,b=0;for(;f>=s;--f){if(t=i.charCodeAt(f),E(t)){if(!w){a=f+1;break}continue}v===-1&&(w=!1,v=f+1),t===R?r===-1?r=f:b!==1&&(b=1):r!==-1&&(b=-1)}return v!==-1&&(r===-1||b===0||b===1&&r===v-1&&r===a+1?o.base=o.name=i.slice(a,v):(o.name=i.slice(a,r),o.base=i.slice(a,v),o.ext=i.slice(r,v))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const y=(()=>{if(p){const i=/\\/g;return()=>{const o=O.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>O.cwd()})();e.$gc={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:y();$(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===S)}return o=d(o,!n,"/",l),n?`/${o}`:o.length>0?o:"."},normalize(i){if($(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S,n=i.charCodeAt(i.length-1)===S;return i=d(i,!o,"/",l),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return $(i,"path"),i.length>0&&i.charCodeAt(0)===S},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];$(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$gc.normalize(o)},relative(i,o){if($(i,"from"),$(o,"to"),i===o||(i=e.$gc.resolve(i),o=e.$gc.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,v=t<a?t:a;let w=-1,f=0;for(;f<v;f++){const C=i.charCodeAt(n+f);if(C!==o.charCodeAt(r+f))break;C===S&&(w=f)}if(f===v)if(a>v){if(o.charCodeAt(r+f)===S)return o.slice(r+f+1);if(f===0)return o.slice(r+f)}else t>v&&(i.charCodeAt(n+f)===S?w=f:f===0&&(w=0));let b="";for(f=n+w+1;f<=s;++f)(f===s||i.charCodeAt(f)===S)&&(b+=b.length===0?"..":"/..");return`${b}${o.slice(r+w)}`},toNamespacedPath(i){return i},dirname(i){if($(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===S){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&$(o,"ext"),$(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,v=-1;for(r=i.length-1;r>=0;--r){const w=i.charCodeAt(r);if(w===S){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=v))}return n===s?s=v:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===S){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){$(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const v=i.charCodeAt(a);if(v===S){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),v===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){$(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===S;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,v=!0,w=i.length-1,f=0;for(;w>=s;--w){const b=i.charCodeAt(w);if(b===S){if(!v){r=w+1;break}continue}a===-1&&(v=!1,a=w+1),b===R?t===-1?t=w:f!==1&&(f=1):t!==-1&&(f=-1)}if(a!==-1){const b=r===0&&n?1:r;t===-1||f===0||f===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(b,a):(o.name=i.slice(b,t),o.base=i.slice(b,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=p?e.$fc.normalize:e.$gc.normalize,e.$ic=p?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=p?e.$fc.join:e.$gc.join,e.$kc=p?e.$fc.resolve:e.$gc.resolve,e.$lc=p?e.$fc.relative:e.$gc.relative,e.$mc=p?e.$fc.dirname:e.$gc.dirname,e.$nc=p?e.$fc.basename:e.$gc.basename,e.$oc=p?e.$fc.extname:e.$gc.extname,e.$pc=p?e.$fc.format:e.$gc.format,e.$qc=p?e.$fc.parse:e.$gc.parse,e.$rc=p?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=p?e.$fc.sep:e.$gc.sep,e.$tc=p?e.$fc.delimiter:e.$gc.delimiter}),define(le[49],he([0,1,16,5,27,12]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function I(r){return r===47||r===92}e.$2f=I;function R(r){return r.replace(/[\\/]/g,O.$gc.sep)}e.$3f=R;function S(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$4f=S;function g(r,a=O.$gc.sep){if(!r)return"";const v=r.length,w=r.charCodeAt(0);if(I(w)){if(I(r.charCodeAt(1))&&!I(r.charCodeAt(2))){let b=3;const C=b;for(;b<v&&!I(r.charCodeAt(b));b++);if(C!==b&&!I(r.charCodeAt(b+1))){for(b+=1;b<v;b++)if(I(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,a)}}return a}else if(l(w)&&r.charCodeAt(1)===58)return I(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<v;f++)if(I(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.$5f=g;function P(r){if(!A.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const w=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(w===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}e.$6f=P;const k=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(r,a=A.$i){const v=a?k:m;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&h.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$7f=$;function p(r,a,v){const w=r===a;return!v||w?w:!r||!a?!1:(0,D.$af)(r,a)}e.$8f=p;function E(r,a,v,w=O.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,D.$bf)(r,a))return!1;if(a.length===r.length)return!0;let b=a.length;return a.charAt(a.length-1)===w&&b--,r.charAt(b)===w}return a.charAt(a.length-1)!==w&&(a+=w),r.indexOf(a)===0}e.$9f=E;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.$0f=l;function u(r,a){return A.$i&&r.endsWith(":")&&(r+=O.sep),(0,O.$ic)(r)||(r=(0,O.$jc)(a,r)),r=(0,O.$hc)(r),A.$i?(r=(0,D.$Ve)(r,O.sep),r.endsWith(":")&&(r+=O.sep)):(r=(0,D.$Ve)(r,O.sep),r||(r=O.sep)),r}e.$$f=u;function d(r){const a=(0,O.$hc)(r);return A.$i?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===O.$gc.sep}e.$_f=d;function c(r,a=A.$i){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$ag=c;function y(r,a=A.$i){return c(r,a)?r[0]:void 0}e.$bg=y;function i(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$cg=i;function o(r){const a=r.split(":");let v,w,f;for(const b of a){const C=Number(b);(0,L.$Nf)(C)?w===void 0?w=C:f===void 0&&(f=C):v=v?[v,b].join(":"):b}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:w!==void 0?w:void 0,column:f!==void 0?f:w!==void 0?1:void 0}}e.$dg=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,v=8){let w="";for(let b=0;b<v;b++){let C;b===0&&A.$i&&!a&&(v===3||v===4)?C=s:C=n,w+=C.charAt(Math.floor(Math.random()*C.length))}let f;return a?f=`${a}-${w}`:f=w,r?(0,O.$jc)(r,f):f}e.$eg=t}),define(le[140],he([0,1,16]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=e.$hs=void 0,e.$hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const k=(0,O.$oc)(P),m=A[k.toLowerCase()];return m!==void 0?m:I(P)}e.$is=L;function I(P){const k=(0,O.$oc)(P);return D[k.toLowerCase()]}e.$js=I;function R(P){for(const k in D)if(D[k]===P)return k}e.$ks=R;const S=/^(.+)\/(.+?)(;.+)?$/;function g(P,k){const m=S.exec(P);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:k?void 0:P}e.$ls=g}),define(le[90],he([0,1,5]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0;var A;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(A||(e.Source=A={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function L(R,...S){const g=S.reduce((m,h)=>(m[h]=!0,m),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(m=>!g[m]).forEach(m=>{for(let h=0;h<P.length;h++)if(m.search(P[h])!==-1){delete R[m];break}})}e.$Tl=L;function I(R){R&&(delete R.DEBUG,O.$j&&delete R.DYLD_LIBRARY_PATH,O.$k&&delete R.LD_PRELOAD)}e.$Ul=I}),define(le[9],he([0,1,16,5]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,L=/^\//,I=/^\/\//;function R(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!L.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,t){return!s&&!t?"file":s}function g(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==k&&(t=k+t):t=k;break}return t}const P="",k="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(t){return t instanceof h?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,v,w,f=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=S(t,f),this.authority=r||P,this.path=g(this.scheme,a||P),this.query=v||P,this.fragment=w||P,R(this,f))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:v,query:w,fragment:f}=t;return r===void 0?r=this.scheme:r===null&&(r=P),a===void 0?a=this.authority:a===null&&(a=P),v===void 0?v=this.path:v===null&&(v=P),w===void 0?w=this.query:w===null&&(w=P),f===void 0?f=this.fragment:f===null&&(f=P),r===this.scheme&&a===this.authority&&v===this.path&&w===this.query&&f===this.fragment?this:new E(r,a,v,w,f)}static parse(t,r=!1){const a=m.exec(t);return a?new E(a[2]||P,n(a[4]||P),n(a[5]||P),n(a[7]||P),n(a[9]||P),r):new E(P,P,P,P,P)}static file(t){let r=P;if(A.$i&&(t=t.replace(/\\/g,k)),t[0]===k&&t[1]===k){const a=t.indexOf(k,2);a===-1?(r=t.substring(2),t=k):(r=t.substring(2,a),t=t.substring(a)||k)}return new E("file",r,t,P,P)}static from(t,r){return new E(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return A.$i&&t.scheme==="file"?a=h.file(O.$fc.join(c(t,!0),...r)).path:a=O.$gc.join(t.path,...r),t.with({path:a})}toString(t=!1){return y(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof h)return t;{const r=new E(t);return r._formatted=t.external??null,r._fsPath=t._sep===p?t.fsPath??null:null,r}}else return t}}e.URI=h;function $(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$vc=$;const p=A.$i?1:void 0;class E extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function u(s,t,r){let a,v=-1;for(let w=0;w<s.length;w++){const f=s.charCodeAt(w);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47||r&&f===91||r&&f===93||r&&f===58)v!==-1&&(a+=encodeURIComponent(s.substring(v,w)),v=-1),a!==void 0&&(a+=s.charAt(w));else{a===void 0&&(a=s.substr(0,w));const b=l[f];b!==void 0?(v!==-1&&(a+=encodeURIComponent(s.substring(v,w)),v=-1),a+=b):v===-1&&(v=w)}}return v!==-1&&(a+=encodeURIComponent(s.substring(v))),a!==void 0?a:s}function d(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=l[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,A.$i&&(r=r.replace(/\//g,"\\")),r}e.$wc=c;function y(s,t){const r=t?d:u;let a="",{scheme:v,authority:w,path:f,query:b,fragment:C}=s;if(v&&(a+=v,a+=":"),(w||v==="file")&&(a+=k,a+=k),w){let N=w.indexOf("@");if(N!==-1){const T=w.substr(0,N);w=w.substr(N+1),N=T.lastIndexOf(":"),N===-1?a+=r(T,!1,!1):(a+=r(T.substr(0,N),!1,!1),a+=":",a+=r(T.substr(N+1),!1,!0)),a+="@"}w=w.toLowerCase(),N=w.lastIndexOf(":"),N===-1?a+=r(w,!1,!0):(a+=r(w.substr(0,N),!1,!0),a+=w.substr(N))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const N=f.charCodeAt(1);N>=65&&N<=90&&(f=`/${String.fromCharCode(N+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const N=f.charCodeAt(0);N>=65&&N<=90&&(f=`${String.fromCharCode(N+32)}:${f.substr(2)}`)}a+=r(f,!0,!1)}return b&&(a+="?",a+=r(b,!1,!1)),C&&(a+="#",a+=t?C:u(C,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[141],he([0,1,9]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$qq=e.$pq=e.$oq=void 0;function A(g){const P=g;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$oq=A;function D(g){const P=[];let k;try{const m=JSON.parse(g.arguments),h=m[m.length-1];h&&h.__$stack&&(m.pop(),k=h.__$stack),P.push(...m)}catch{P.push("Unable to log remote console arguments",g.arguments)}return{args:P,stack:k}}e.$pq=D;function L(g){if(typeof g!="string")return L(D(g).stack);const P=g;if(P){const k=I(P),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(m&&m.length===4)return{uri:O.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$qq=L;function I(g){if(!g)return g;const P=g.indexOf(`
`);return P===-1?g:g.substring(0,P)}function R(g,P){const{args:k,stack:m}=D(g),h=typeof k[0]=="string"&&k.length===1;let $=I(m);$&&($=`(${$.trim()})`);let p=[];if(typeof k[0]=="string"?$&&h?p=[`%c[${P}] %c${k[0]} %c${$}`,S("blue"),S(""),S("grey")]:p=[`%c[${P}] %c${k[0]}`,S("blue"),S(""),...k.slice(1)]:p=[`%c[${P}]%`,S("blue"),...k],$&&!h&&p.push($),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,p)}e.log=R;function S(g){return`color: ${g}`}}),define(le[66],he([0,1,14,9]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function D(S){return JSON.stringify(S,I)}e.$Ch=D;function L(S){let g=JSON.parse(S);return g=R(g),g}e.$Dh=L;function I(S,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(S,g=0){if(!S||g>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return A.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 17:return new Date(S.source)}if(S instanceof O.$ke||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let P=0;P<S.length;++P)S[P]=R(S[P],g+1);else for(const P in S)Object.hasOwnProperty.call(S,P)&&(S[P]=R(S[P],g+1))}return S}e.$Eh=R}),define(le[23],he([0,1,7,5,27,9]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var I;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(I||(e.Schemas=I={}));function R(m,h){return L.URI.isUri(m)?(0,D.$af)(m.scheme,h):(0,D.$bf)(m,h+":")}e.$fg=R;function S(m,...h){return h.some($=>R(m,$))}e.$gg=S,e.$hg="vscode-tkn",e.$ig="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${I.vscodeRemoteResource}`}set(h,$,p){this.a[h]=$,this.b[h]=p}setConnectionToken(h,$){this.c[h]=$}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(d){return O.$1(d),h}const $=h.authority;let p=this.a[$];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const E=this.b[$],l=this.c[$];let u=`path=${encodeURIComponent(h.path)}`;return typeof l=="string"&&(u+=`&${e.$ig}=${encodeURIComponent(l)}`),L.URI.from({scheme:A.$o?this.d:I.vscodeRemoteResource,authority:`${p}:${E}`,path:this.f,query:u})}}e.$jg=new g,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class P{static{this.a=e.$og}asBrowserUri(h){const $=this.b(h,se);return this.uriToBrowserUri($)}uriToBrowserUri(h){return h.scheme===I.vscodeRemote?e.$jg.rewrite(h):h.scheme===I.file&&(A.$m||A.$q===`${I.vscodeFileResource}://${P.a}`)?h.with({scheme:I.vscodeFileResource,authority:h.authority||P.a,query:null,fragment:null}):h}asFileUri(h){const $=this.b(h,se);return this.uriToFileUri($)}uriToFileUri(h){return h.scheme===I.vscodeFileResource?h.with({scheme:I.file,authority:h.authority!==P.a?h.authority:null,query:null,fragment:null}):h}b(h,$){return L.URI.isUri(h)?h:L.URI.parse($.toUrl(h))}}e.$pg=new P;var k;(function(m){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(h.get("3"));const $="vscode-coi";function p(l){let u;typeof l=="string"?u=new URL(l).searchParams:l instanceof URL?u=l.searchParams:L.URI.isUri(l)&&(u=new URL(l.toString(!0)).searchParams);const d=u?.get($);if(d)return h.get(d)}m.getHeadersFromQuery=p;function E(l,u,d){if(!globalThis.crossOriginIsolated)return;const c=u&&d?"3":d?"2":"1";l instanceof URLSearchParams?l.set($,c):l[$]=c}m.addSearchParam=E})(k||(e.COI=k={}))}),define(le[142],he([0,1,124,23,5,9]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=void 0;class I{constructor(m,h,$){this.id=m,this.dependencies=h,this.callback=$}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,h,$)=>{typeof m!="string"&&($=h,h=m,m=null),(typeof h!="object"||!Array.isArray(h))&&($=h,h=null),this.c.push(new I(m,h,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const h=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!h)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(m){return new Promise((h,$)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const E=()=>{p.removeEventListener("load",l),p.removeEventListener("error",u)},l=d=>{E(),h(this.c.pop())},u=d=>{E(),$(d)};p.addEventListener("load",l),p.addEventListener("error",u),this.f&&(m=this.f.createScriptURL(m)),p.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(p)})}i(m){return new Promise((h,$)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),h(this.c.pop())}catch(p){$(p)}})}async j(m){try{const h=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,E=L.URI.parse(m).fsPath,l=h.readFileSync(E).toString(),u=p.wrap(l.replace(/^#!.*/,""));return new $.Script(u).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const S=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function P(k,m,h){if(O.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[k]&&(k=g[k]);const $=`${k}/${m}`;if(S.has($))return S.get($);let p;if(/^\w[\w\d+.-]*:\/\//.test($))p=$;else{const d=`${h&&!D.$o?A.$mg:A.$lg}/${$}`;p=A.$pg.asBrowserUri(d).toString(!0)}const E=R.INSTANCE.load(p);return S.set($,E),E}else return await new Promise(($,p)=>{se([k],$,p)})}e.$jD=P}),define(le[20],he([0,1,49,23,16,5,27,9]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function S(h){return(0,R.$wc)(h,!0)}e.$wg=S;class g{constructor($){this.a=$}compare($,p,E=!1){return $===p?0:(0,I.$6e)(this.getComparisonKey($,E),this.getComparisonKey(p,E))}isEqual($,p,E=!1){return $===p?!0:!$||!p?!1:this.getComparisonKey($,E)===this.getComparisonKey(p,E)}getComparisonKey($,p=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,p,E=!1){if($.scheme===p.scheme){if($.scheme===A.Schemas.file)return O.$9f(S($),S(p),this.a($))&&$.query===p.query&&(E||$.fragment===p.fragment);if((0,e.$Ng)($.authority,p.authority))return O.$9f($.path,p.path,this.a($),"/")&&$.query===p.query&&(E||$.fragment===p.fragment)}return!1}joinPath($,...p){return R.URI.joinPath($,...p)}basenameOrAuthority($){return(0,e.$Fg)($)||$.authority}basename($){return D.$gc.basename($.path)}extname($){return D.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let p;return $.scheme===A.Schemas.file?p=R.URI.file(D.$mc(S($))).path:(p=D.$gc.dirname($.path),$.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),p="/")),$.with({path:p})}normalizePath($){if(!$.path.length)return $;let p;return $.scheme===A.Schemas.file?p=R.URI.file(D.$hc(S($))).path:p=D.$gc.normalize($.path),$.with({path:p})}relativePath($,p){if($.scheme!==p.scheme||!(0,e.$Ng)($.authority,p.authority))return;if($.scheme===A.Schemas.file){const u=D.$lc(S($),S(p));return L.$i?O.$3f(u):u}let E=$.path||"/";const l=p.path||"/";if(this.a($)){let u=0;for(const d=Math.min(E.length,l.length);u<d&&!(E.charCodeAt(u)!==l.charCodeAt(u)&&E.charAt(u).toLowerCase()!==l.charAt(u).toLowerCase());u++);E=l.substr(0,u)+E.substr(u)}return D.$gc.relative(E,l)}resolvePath($,p){if($.scheme===A.Schemas.file){const E=R.URI.file(D.$kc(S($),p));return $.with({authority:E.authority,path:E.path})}return p=O.$4f(p),$.with({path:D.$gc.resolve($.path,p)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,p){return $===p||$!==void 0&&p!==void 0&&(0,I.$af)($,p)}hasTrailingPathSeparator($,p=D.sep){if($.scheme===A.Schemas.file){const E=S($);return E.length>O.$5f(E).length&&E[E.length-1]===p}else{const E=$.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,p=D.sep){return(0,e.$Og)($,p)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,p=D.sep){let E=!1;if($.scheme===A.Schemas.file){const l=S($);E=l!==void 0&&l.length===O.$5f(l).length&&l[l.length-1]===p}else{p="/";const l=$.path;E=l.length===1&&l.charCodeAt(l.length-1)===47}return!E&&!(0,e.$Og)($,p)?$.with({path:$.path+"/"}):$}}e.$xg=g,e.$yg=new g(()=>!1),e.$zg=new g(h=>h.scheme===A.Schemas.file?!L.$k:!0),e.$Ag=new g(h=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function P(h,$){const p=[];for(let E=0;E<h.length;E++){const l=$(h[E]);h.some((u,d)=>d===E?!1:(0,e.$Cg)(l,$(u)))||p.push(h[E])}return p}e.$Rg=P;var k;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function $(p){const E=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(d=>{const[c,y]=d.split(":");c&&y&&E.set(c,y)});const u=p.path.substring(0,p.path.indexOf(";"));return u&&E.set(h.META_DATA_MIME,u),E}h.parseMetaData=$})(k||(e.DataUri=k={}));function m(h,$,p){if($){let E=h.path;return E&&E[0]!==D.$gc.sep&&(E=D.$gc.sep+E),h.with({scheme:p,authority:$,path:E})}return h.with({scheme:p})}e.$Sg=m}),define(le[6],he([0,1,26,7,3,2,20,5,130,52]),function(se,e,O,A,D,L,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.Promises=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function P(ie){return!!ie&&typeof ie.then=="function"}e.$Tg=P;function k(ie){const J=new O.$7d,ne=ie(J.token),ce=new Promise((fe,de)=>{const me=J.token.onCancellationRequested(()=>{me.dispose(),de(new A.$5)});Promise.resolve(ne).then(Ee=>{me.dispose(),J.dispose(),fe(Ee)},Ee=>{me.dispose(),J.dispose(),de(Ee)})});return new class{cancel(){J.cancel(),J.dispose()}then(fe,de){return ce.then(fe,de)}catch(fe){return this.then(void 0,fe)}finally(fe){return ce.finally(fe)}}}e.$Ug=k;function m(ie,J,ne){return new Promise((ce,fe)=>{const de=J.onCancellationRequested(()=>{de.dispose(),ce(ne)});ie.then(ce,fe).finally(()=>de.dispose())})}e.$Vg=m;function h(ie,J){return new Promise((ne,ce)=>{const fe=J.onCancellationRequested(()=>{fe.dispose(),ce(new A.$5)});ie.then(ne,ce).finally(()=>fe.dispose())})}e.$Wg=h;async function $(ie){let J=-1;const ne=ie.map((ce,fe)=>ce.then(de=>(J=fe,de)));try{return await Promise.race(ne)}finally{ie.forEach((ce,fe)=>{fe!==J&&ce.cancel()})}}e.$Xg=$;function p(ie,J,ne){let ce;const fe=setTimeout(()=>{ce?.(void 0),ne?.()},J);return Promise.race([ie.finally(()=>clearTimeout(fe)),new Promise(de=>ce=de)])}e.$Yg=p;function E(ie){return new Promise((J,ne)=>{const ce=ie();P(ce)?ce.then(J,ne):J(ce)})}e.$Zg=E;function l(){let ie,J;return{promise:new Promise((ce,fe)=>{ie=ce,J=fe}),resolve:ie,reject:J}}e.$1g=l;class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const ne=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(ne,ne).then(ce)})}return new Promise((ne,ce)=>{this.b.then(ne,ce)})}return this.a=J(),new Promise((ne,ce)=>{this.a.then(fe=>{this.a=null,ne(fe)},fe=>{this.a=null,ce(fe)})})}dispose(){this.f=!0}}e.$2g=u;class d{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$3g=d;class c{constructor(){this.a=new Map}queue(J,ne){const fe=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.a.get(J)===fe&&this.a.delete(J)});return this.a.set(J,fe),fe}}e.$4g=c;const y=(ie,J)=>{let ne=!0;const ce=setTimeout(()=>{ne=!1,J()},ie);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(ce),ne=!1}}},i=ie=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ie())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class o{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,ne=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((fe,de)=>{this.d=fe,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=ne===S.$Td?i(ce):y(ne,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$5g=o;class n{constructor(J){this.a=new o(J),this.b=new u}trigger(J,ne){return this.a.trigger(()=>this.b.queue(J),ne)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$6g=n;class s{constructor(){this.a=!1,this.b=new Promise((J,ne)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$7g=s;class t extends s{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$8g=t;function r(ie,J){return J?new Promise((ne,ce)=>{const fe=setTimeout(()=>{de.dispose(),ne()},ie),de=J.onCancellationRequested(()=>{clearTimeout(fe),de.dispose(),ce(new A.$5)})}):k(ne=>r(ie,ne))}e.$9g=r;function a(ie,J=0,ne){const ce=setTimeout(()=>{ie(),ne&&fe.dispose()},J),fe=(0,L.$Rc)(()=>{clearTimeout(ce),ne?.deleteAndLeak(fe)});return ne?.add(fe),fe}e.$0g=a;function v(ie){const J=[];let ne=0;const ce=ie.length;function fe(){return ne<ce?ie[ne++]():null}function de(me){me!=null&&J.push(me);const Ee=fe();return Ee?Ee.then(de):Promise.resolve(J)}return Promise.resolve(null).then(de)}e.$$g=v;function w(ie,J=ce=>!!ce,ne=null){let ce=0;const fe=ie.length,de=()=>{if(ce>=fe)return Promise.resolve(ne);const me=ie[ce++];return Promise.resolve(me()).then(Pe=>J(Pe)?Promise.resolve(Pe):de())};return de()}e.$_g=w;function f(ie,J=ce=>!!ce,ne=null){if(ie.length===0)return Promise.resolve(ne);let ce=ie.length;const fe=()=>{ce=-1;for(const de of ie)de.cancel?.()};return new Promise((de,me)=>{for(const Ee of ie)Ee.then(Pe=>{--ce>=0&&J(Pe)?(fe(),de(Pe)):ce===0&&de(ne)}).catch(Pe=>{--ce>=0&&(fe(),me(Pe))})})}e.$ah=f;class b{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new D.$Wd}whenIdle(){return this.size>0?D.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ne,ce)=>{this.g.push({factory:J,c:ne,e:ce}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const ne=J.factory();ne.then(J.c,J.e),ne.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$bh=b;class C extends b{constructor(){super(1)}}e.$ch=C;class N{constructor(){this.a=new te,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$dh=N;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new ae;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,ne=I.$yg){const ce=ne.getComparisonKey(J);return this.a.get(ce)?.size??0}queueFor(J,ne,ce=I.$yg){const fe=ce.getComparisonKey(J);let de=this.a.get(fe);if(!de){de=new C;const me=this.f++,Ee=D.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$3c),this.d.set(me,Ee),this.a.set(fe,de)}return de.queue(ne)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$eh=T;class M{constructor(J,ne){this.a=-1,typeof J=="function"&&typeof ne=="number"&&this.setIfNotSet(J,ne)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,ne){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},ne)}setIfNotSet(J,ne){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},ne))}}e.$fh=M;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,ne,ce=globalThis){this.cancel();const fe=ce.setInterval(()=>{J()},ne);this.d=(0,L.$Rc)(()=>{ce.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$gh=q;class Y{constructor(J,ne){this.b=-1,this.a=J,this.d=ne,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$hh=Y;class X{constructor(J,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.a=J,this.b=ne,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ih=X;class x extends Y{constructor(J,ne){super(J,ne),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$jh=x;class V extends L.$Tc{constructor(J,ne){super(),this.g=J,this.h=ne,this.a=[],this.b=this.B(new L.$Uc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ne of J)this.a.push(ne);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Y(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$kh=V,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$mh=(ie,J)=>{(0,R.$B)(()=>{if(ne)return;const ce=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$mh=(ie,J,ne)=>{const ce=ie.requestIdleCallback(J,typeof ne=="number"?{timeout:ne}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,ie.cancelIdleCallback(ce))}}},e.$lh=ie=>(0,e.$mh)(globalThis,ie)}();class Q{constructor(J,ne){this.g=!1,this.d=()=>{try{this.j=ne()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$mh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$nh=Q;class H extends Q{constructor(J){super(globalThis,J)}}e.$oh=H;async function W(ie,J,ne){let ce;for(let fe=0;fe<ne;fe++)try{return await ie()}catch(de){ce=de,await r(J)}throw ce}e.$ph=W;class te{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,ne,ce){return this.a={taskId:J,cancel:()=>ce?.(),promise:ne},ne.then(()=>this.d(J),()=>this.d(J)),ne}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:ne,resolve:ce,reject:fe}=l();this.b={run:J,promise:ne,promiseResolve:ce,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$qh=te;class oe{constructor(J,ne=()=>Date.now()){this.d=J,this.f=ne,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$rh=oe;var ee;(function(ie){ie[ie.Resolved=0]="Resolved",ie[ie.Rejected=1]="Rejected"})(ee||(ee={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,ne)=>{this.a=J,this.b=ne})}complete(J){return new Promise(ne=>{this.a(J),this.d={outcome:0,value:J},ne()})}error(J){return new Promise(ne=>{this.b(J),this.d={outcome:1,value:J},ne()})}cancel(){return this.error(new A.$5)}}e.$sh=ae;var G;(function(ie){async function J(ce){let fe;const de=await Promise.all(ce.map(me=>me.then(Ee=>Ee,Ee=>{fe||(fe=Ee)})));if(typeof fe<"u")throw fe;return de}ie.settled=J;function ne(ce){return new Promise(async(fe,de)=>{try{await ce(fe,de)}catch(me){de(me)}})}ie.withAsyncBody=ne})(G||(e.Promises=G={}));class z{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(ne=>(this.a=ne,this.d=!0,ne),ne=>{throw this.b=ne,this.d=!0,ne})}requireValue(){if(!this.d)throw new A.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$th=z;class j{constructor(J){this.b=J,this.a=new g.$V(()=>new z(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$uh=j;var F;(function(ie){ie[ie.Initial=0]="Initial",ie[ie.DoneOK=1]="DoneOK",ie[ie.DoneError=2]="DoneError"})(F||(F={}));class B{static fromArray(J){return new B(ne=>{ne.emitMany(J)})}static fromPromise(J){return new B(async ne=>{ne.emitMany(await J)})}static fromPromises(J){return new B(async ne=>{await Promise.all(J.map(async ce=>ne.emitOne(await ce)))})}static merge(J){return new B(async ne=>{await Promise.all(J.map(async ce=>{for await(const fe of ce)ne.emitOne(fe)}))})}static{this.EMPTY=B.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new D.$Wd,queueMicrotask(async()=>{const ne={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(J(ne)),this.j()}catch(ce){this.k(ce)}finally{ne.emitOne=void 0,ne.emitMany=void 0,ne.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(J,ne){return new B(async ce=>{for await(const fe of J)ce.emitOne(ne(fe))})}map(J){return B.map(this,J)}static filter(J,ne){return new B(async ce=>{for await(const fe of J)ne(fe)&&ce.emitOne(fe)})}filter(J){return B.filter(this,J)}static coalesce(J){return B.filter(J,ne=>!!ne)}coalesce(){return B.coalesce(this)}static async toPromise(J){const ne=[];for await(const ce of J)ne.push(ce);return ne}toPromise(){return B.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$vh=B;class U extends B{constructor(J,ne){super(ne),this.l=J}cancel(){this.l.cancel()}}e.$wh=U;function Z(ie){const J=new O.$7d,ne=ie(J.token);return new U(J,async ce=>{const fe=J.token.onCancellationRequested(()=>{fe.dispose(),J.dispose(),ce.reject(new A.$5)});try{for await(const de of ne){if(J.token.isCancellationRequested)return;ce.emitOne(de)}fe.dispose(),J.dispose()}catch(de){fe.dispose(),J.dispose(),ce.reject(de)}})}e.$xh=Z;class _{constructor(){this.a=new ae,this.b=new B(ce=>{if(J){ce.reject(J);return}return ne&&ce.emitMany(ne),this.d=fe=>ce.reject(fe),this.f=fe=>ce.emitOne(fe),this.a.p});let J,ne;this.f=ce=>{ne||(ne=[]),ne.push(ce)},this.d=ce=>{J||(J=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$yh=_}),define(le[91],he([0,1,17,6,49,35,16,5,27]),function(se,e,O,A,D,L,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=void 0;function g(){return Object.create(null)}e.$Jj=g,e.$Kj="**",e.$Lj="/";const P="[/\\\\]",k="[^/\\\\]",m=/\//g;function h(Q,H){switch(Q){case 0:return"";case 1:return`${k}*?`;default:return`(?:${P}|${k}+${P}${H?`|${P}${k}+`:""})*?`}}function $(Q,H){if(!Q)return[];const W=[];let te=!1,oe=!1,ee="";for(const ae of Q){switch(ae){case H:if(!te&&!oe){W.push(ee),ee="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ee+=ae}return ee&&W.push(ee),W}e.$Mj=$;function p(Q){if(!Q)return"";let H="";const W=$(Q,e.$Lj);if(W.every(te=>te===e.$Kj))H=".*";else{let te=!1;W.forEach((oe,ee)=>{if(oe===e.$Kj){if(te)return;H+=h(2,ee===W.length-1)}else{let ae=!1,G="",z=!1,j="";for(const F of oe){if(F!=="}"&&ae){G+=F;continue}if(z&&(F!=="]"||!j)){let B;F==="-"?B=F:(F==="^"||F==="!")&&!j?B="^":F===e.$Lj?B="":B=(0,S.$Pe)(F),j+=B;continue}switch(F){case"{":ae=!0;continue;case"[":z=!0;continue;case"}":{const U=`(?:${$(G,",").map(Z=>p(Z)).join("|")})`;H+=U,ae=!1,G="";break}case"]":{H+="["+j+"]",z=!1,j="";break}case"?":H+=k;continue;case"*":H+=h(1);continue;default:H+=(0,S.$Pe)(F)}}ee<W.length-1&&(W[ee+1]!==e.$Kj||ee+2<W.length)&&(H+=P)}te=oe===e.$Kj})}return H}const E=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.$Dc(1e4),o=function(){return!1},n=function(){return null};function s(Q,H){if(!Q)return n;let W;typeof Q!="string"?W=Q.pattern:W=Q,W=W.trim();const te=`${W}_${!!H.trimForExclusions}`;let oe=i.get(te);if(oe)return t(oe,Q);let ee;return E.test(W)?oe=a(W.substr(4),W):(ee=l.exec(r(W,H)))?oe=v(ee[1],W):(H.trimForExclusions?d:u).test(W)?oe=w(W,H):(ee=c.exec(r(W,H)))?oe=f(ee[1].substr(1),W,!0):(ee=y.exec(r(W,H)))?oe=f(ee[1],W,!1):oe=b(W),i.set(te,oe),t(oe,Q)}function t(Q,H){if(typeof H=="string")return Q;const W=function(te,oe){return(0,D.$9f)(te,H.base,!R.$k)?Q((0,S.$Ue)(te.substr(H.base.length),I.sep),oe):null};return W.allBasenames=Q.allBasenames,W.allPaths=Q.allPaths,W.basenames=Q.basenames,W.patterns=Q.patterns,W}function r(Q,H){return H.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function a(Q,H){return function(W,te){return typeof W=="string"&&W.endsWith(Q)?H:null}}function v(Q,H){const W=`/${Q}`,te=`\\${Q}`,oe=function(ae,G){return typeof ae!="string"?null:G?G===Q?H:null:ae===Q||ae.endsWith(W)||ae.endsWith(te)?H:null},ee=[Q];return oe.basenames=ee,oe.patterns=[H],oe.allBasenames=ee,oe}function w(Q,H){const W=x(Q.slice(1,-1).split(",").map(G=>s(G,H)).filter(G=>G!==n),Q),te=W.length;if(!te)return n;if(te===1)return W[0];const oe=function(G,z){for(let j=0,F=W.length;j<F;j++)if(W[j](G,z))return Q;return null},ee=W.find(G=>!!G.allBasenames);ee&&(oe.allBasenames=ee.allBasenames);const ae=W.reduce((G,z)=>z.allPaths?G.concat(z.allPaths):G,[]);return ae.length&&(oe.allPaths=ae),oe}function f(Q,H,W){const te=I.sep===I.$gc.sep,oe=te?Q:Q.replace(m,I.sep),ee=I.sep+oe,ae=I.$gc.sep+Q;let G;return W?G=function(z,j){return typeof z=="string"&&(z===oe||z.endsWith(ee)||!te&&(z===Q||z.endsWith(ae)))?H:null}:G=function(z,j){return typeof z=="string"&&(z===oe||!te&&z===Q)?H:null},G.allPaths=[(W?"*/":"./")+Q],G}function b(Q){try{const H=new RegExp(`^${p(Q)}$`);return function(W){return H.lastIndex=0,typeof W=="string"&&H.test(W)?Q:null}}catch{return n}}function C(Q,H,W){return!Q||typeof H!="string"?!1:N(Q)(H,void 0,W)}e.$Nj=C;function N(Q,H={}){if(!Q)return o;if(typeof Q=="string"||T(Q)){const W=s(Q,H);if(W===n)return o;const te=function(oe,ee){return!!W(oe,ee)};return W.allBasenames&&(te.allBasenames=W.allBasenames),W.allPaths&&(te.allPaths=W.allPaths),te}return Y(Q,H)}e.$Oj=N;function T(Q){const H=Q;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$Pj=T;function M(Q){return Q.allBasenames||[]}e.$Qj=M;function q(Q){return Q.allPaths||[]}e.$Rj=q;function Y(Q,H){const W=x(Object.getOwnPropertyNames(Q).map(G=>X(G,Q[G],H)).filter(G=>G!==n)),te=W.length;if(!te)return n;if(!W.some(G=>!!G.requiresSiblings)){if(te===1)return W[0];const G=function(F,B){let U;for(let Z=0,_=W.length;Z<_;Z++){const ie=W[Z](F,B);if(typeof ie=="string")return ie;(0,A.$Tg)(ie)&&(U||(U=[]),U.push(ie))}return U?(async()=>{for(const Z of U){const _=await Z;if(typeof _=="string")return _}return null})():null},z=W.find(F=>!!F.allBasenames);z&&(G.allBasenames=z.allBasenames);const j=W.reduce((F,B)=>B.allPaths?F.concat(B.allPaths):F,[]);return j.length&&(G.allPaths=j),G}const oe=function(G,z,j){let F,B;for(let U=0,Z=W.length;U<Z;U++){const _=W[U];_.requiresSiblings&&j&&(z||(z=(0,I.$nc)(G)),F||(F=z.substr(0,z.length-(0,I.$oc)(G).length)));const ie=_(G,z,F,j);if(typeof ie=="string")return ie;(0,A.$Tg)(ie)&&(B||(B=[]),B.push(ie))}return B?(async()=>{for(const U of B){const Z=await U;if(typeof Z=="string")return Z}return null})():null},ee=W.find(G=>!!G.allBasenames);ee&&(oe.allBasenames=ee.allBasenames);const ae=W.reduce((G,z)=>z.allPaths?G.concat(z.allPaths):G,[]);return ae.length&&(oe.allPaths=ae),oe}function X(Q,H,W){if(H===!1)return n;const te=s(Q,W);if(te===n)return n;if(typeof H=="boolean")return te;if(H){const oe=H.when;if(typeof oe=="string"){const ee=(ae,G,z,j)=>{if(!j||!te(ae,G))return null;const F=oe.replace("$(basename)",()=>z),B=j(F);return(0,A.$Tg)(B)?B.then(U=>U?Q:null):B?Q:null};return ee.requiresSiblings=!0,ee}}return te}function x(Q,H){const W=Q.filter(G=>!!G.basenames);if(W.length<2)return Q;const te=W.reduce((G,z)=>{const j=z.basenames;return j?G.concat(j):G},[]);let oe;if(H){oe=[];for(let G=0,z=te.length;G<z;G++)oe.push(H)}else oe=W.reduce((G,z)=>{const j=z.patterns;return j?G.concat(j):G},[]);const ee=function(G,z){if(typeof G!="string")return null;if(!z){let F;for(F=G.length;F>0;F--){const B=G.charCodeAt(F-1);if(B===47||B===92)break}z=G.substr(F)}const j=te.indexOf(z);return j!==-1?oe[j]:null};ee.basenames=te,ee.patterns=oe,ee.allBasenames=te;const ae=Q.filter(G=>!G.basenames);return ae.push(ee),ae}function V(Q,H){return(0,O.$ub)(Q,H,(W,te)=>typeof W=="string"&&typeof te=="string"?W===te:typeof W!="string"&&typeof te!="string"?W.base===te.base&&W.pattern===te.pattern:!1)}e.$Sj=V}),define(le[92],he([0,1,14,9]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function D(k){return k.toJSON()}class L{constructor(m){this.a=m}transformIncoming(m){const h=this.a.transformIncoming(m);return h===m?m:D(A.URI.from(h))}transformOutgoing(m){const h=this.a.transformOutgoing(m);return h===m?m:D(A.URI.from(h))}transformOutgoingURI(m){const h=this.a.transformOutgoing(m);return h===m?m:A.URI.from(h)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$7m=L,e.$8m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function I(k,m,h){if(!k||h>200)return null;if(typeof k=="object"){if(k instanceof A.URI)return m.transformOutgoing(k);for(const $ in k)if(Object.hasOwnProperty.call(k,$)){const p=I(k[$],m,h+1);p!==null&&(k[$]=p)}}return null}function R(k,m){const h=I(k,m,0);return h===null?k:h}e.$9m=R;function S(k,m,h,$){if(!k||$>200)return null;if(typeof k=="object"){if(k.$mid===1)return h?A.URI.revive(m.transformIncoming(k)):m.transformIncoming(k);if(k instanceof O.$ke)return null;for(const p in k)if(Object.hasOwnProperty.call(k,p)){const E=S(k[p],m,h,$+1);E!==null&&(k[p]=E)}}return null}function g(k,m){const h=S(k,m,!1,0);return h===null?k:h}e.$0m=g;function P(k,m){const h=S(k,m,!0,0);return h===null?k:h}e.$$m=P}),define(le[143],he([0,1,36,48,32,131,5]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=void 0,e.$an=new class{c(m){return this.a||(this.a=A.$bi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,h=0;const $=(0,O.networkInterfaces)();for(const p in $){const E=$[p];if(E)for(const{mac:l,internal:u}of E)u||(h+=1,this.c(l.toUpperCase())&&(m+=1))}this.b=h>0?m/h:0}return this.b}};let R;async function S(m){return R||(R=(async()=>await g(m)||D.$rg())()),R}e.$bn=S;async function g(m){try{const h=await new Promise((p,E)=>{se(["crypto"],p,E)}),$=(0,L.$_m)();return h.createHash("sha256").update($,"utf8").digest("hex")}catch(h){m(h);return}}const P="Software\\Microsoft\\SQMClient";async function k(m){if(I.$i){const h=await new Promise(($,p)=>{se(["@vscode/windows-registry"],$,p)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch($){return m($),""}}return""}e.$cn=k}),define(le[31],he([0,1,54,36,268,6,49,88,16,5,20,9]),function(se,e,O,A,D,L,I,R,S,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function h(X,x=m.UNLINK,V){if((0,I.$_f)(X))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?p(X):$(X,V)}async function $(X,x=(0,I.$eg)((0,A.tmpdir)())){try{try{await O.promises.rename(X,x)}catch(V){return V.code==="ENOENT"?void 0:p(X)}p(x).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function p(X){return(0,D.promisify)(O.rm)(X,{recursive:!0,force:!0,maxRetries:3})}function E(X){if((0,I.$_f)(X))throw new Error("rimraf - will refuse to recursively delete root");O.rmSync(X,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=E;async function l(X,x){return c(await(x?u(X):(0,D.promisify)(O.readdir)(X)))}async function u(X){try{return await(0,D.promisify)(O.readdir)(X,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const x=[],V=await l(X);for(const Q of V){let H=!1,W=!1,te=!1;try{const oe=await e.Promises.lstat((0,S.$jc)(X,Q));H=oe.isFile(),W=oe.isDirectory(),te=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}x.push({name:Q,isFile:()=>H,isDirectory:()=>W,isSymbolicLink:()=>te})}return x}function d(X){return c(O.readdirSync(X))}e.readdirSync=d;function c(X){return X.map(x=>typeof x=="string"?g.$j?(0,R.$Il)(x):x:(x.name=g.$j?(0,R.$Il)(x.name):x.name,x))}async function y(X){const x=await l(X),V=[];for(const Q of x)await o.existsDirectory((0,S.$jc)(X,Q))&&V.push(Q);return V}function i(X,x=1e3){return new Promise(V=>{let Q=!1;const H=setInterval(()=>{Q||(Q=!0,O.access(X,W=>{Q=!1,W&&(clearInterval(H),V(void 0))}))},x)})}e.whenDeleted=i;var o;(function(X){async function x(H){let W;try{if(W=await e.Promises.lstat(H),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(g.$i&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw oe}throw te}}X.stat=x;async function V(H){try{const{stat:W,symbolicLink:te}=await X.stat(H);return W.isFile()&&te?.dangling!==!0}catch{}return!1}X.existsFile=V;async function Q(H){try{const{stat:W,symbolicLink:te}=await X.stat(H);return W.isDirectory()&&te?.dangling!==!0}catch{}return!1}X.existsDirectory=Q})(o||(e.SymlinkSupport=o={}));const n=new L.$eh;function s(X,x,V){return n.queueFor(k.URI.file(X),()=>{const Q=w(V);return new Promise((H,W)=>a(X,x,Q,te=>te?W(te):H()))},P.$zg)}let t=!0;function r(X){t=X}e.configureFlushOnWrite=r;function a(X,x,V,Q){if(!t)return O.writeFile(X,x,{mode:V.mode,flag:V.flag},Q);O.open(X,V.flag,V.mode,(H,W)=>{if(H)return Q(H);O.writeFile(W,x,te=>{if(te)return O.close(W,()=>Q(te));O.fdatasync(W,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),r(!1)),O.close(W,ee=>Q(ee))))})})}function v(X,x,V){const Q=w(V);if(!t)return O.writeFileSync(X,x,{mode:Q.mode,flag:Q.flag});const H=O.openSync(X,Q.flag,Q.mode);try{O.writeFileSync(H,x);try{O.fdatasyncSync(H)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r(!1)}}finally{O.closeSync(H)}}e.writeFileSync=v;function w(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function f(X,x,V=6e4){if(X!==x)try{g.$i&&typeof V=="number"?await b(X,x,Date.now(),V):await(0,D.promisify)(O.rename)(X,x)}catch(Q){if(X.toLowerCase()!==x.toLowerCase()&&Q.code==="EXDEV"||X.endsWith("."))await C(X,x,{preserveSymlinks:!1}),await h(X,m.MOVE);else throw Q}}async function b(X,x,V,Q,H=0){try{return await(0,D.promisify)(O.rename)(X,x)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-V>=Q)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${W}`),W;if(H===0){let te=!1;try{const{stat:oe}=await o.stat(x);oe.isFile()||(te=!0)}catch{}if(te)throw W}return await(0,L.$9g)(Math.min(100,H*10)),b(X,x,V,Q,H+1)}}async function C(X,x,V){return T(X,x,{root:{source:X,target:x},options:V,handledSourcePaths:new Set})}const N=511;async function T(X,x,V){if(V.handledSourcePaths.has(X))return;V.handledSourcePaths.add(X);const{stat:Q,symbolicLink:H}=await o.stat(X);if(H){if(V.options.preserveSymlinks)try{return await Y(X,x,V)}catch{}if(H.dangling)return}return Q.isDirectory()?M(X,x,Q.mode&N,V):q(X,x,Q.mode&N)}async function M(X,x,V,Q){await e.Promises.mkdir(x,{recursive:!0,mode:V});const H=await l(X);for(const W of H)await T((0,S.$jc)(X,W),(0,S.$jc)(x,W),Q)}async function q(X,x,V){await e.Promises.copyFile(X,x),await e.Promises.chmod(x,V)}async function Y(X,x,V){let Q=await e.Promises.readlink(X);(0,I.$9f)(Q,V.root.source,!g.$k)&&(Q=(0,S.$jc)(V.root.target,Q.substr(V.root.source.length+1))),await e.Promises.symlink(Q,x)}e.Promises=new class{get access(){return(0,D.promisify)(O.access)}get stat(){return(0,D.promisify)(O.stat)}get lstat(){return(0,D.promisify)(O.lstat)}get utimes(){return(0,D.promisify)(O.utimes)}get read(){return(X,x,V,Q,H)=>new Promise((W,te)=>{O.read(X,x,V,Q,H,(oe,ee,ae)=>oe?te(oe):W({bytesRead:ee,buffer:ae}))})}get readFile(){return(0,D.promisify)(O.readFile)}get write(){return(X,x,V,Q,H)=>new Promise((W,te)=>{O.write(X,x,V,Q,H,(oe,ee,ae)=>oe?te(oe):W({bytesWritten:ee,buffer:ae}))})}get appendFile(){return(0,D.promisify)(O.appendFile)}get fdatasync(){return(0,D.promisify)(O.fdatasync)}get truncate(){return(0,D.promisify)(O.truncate)}get copyFile(){return(0,D.promisify)(O.copyFile)}get open(){return(0,D.promisify)(O.open)}get close(){return(0,D.promisify)(O.close)}get symlink(){return(0,D.promisify)(O.symlink)}get readlink(){return(0,D.promisify)(O.readlink)}get chmod(){return(0,D.promisify)(O.chmod)}get mkdir(){return(0,D.promisify)(O.mkdir)}get unlink(){return(0,D.promisify)(O.unlink)}get rmdir(){return(0,D.promisify)(O.rmdir)}get realpath(){return(0,D.promisify)(O.realpath)}async exists(X){try{return await e.Promises.access(X),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return y}get writeFile(){return s}get rm(){return h}get rename(){return f}get copy(){return C}}}),define(le[144],he([0,1,54,16,5,27,31]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=void 0;function R(m){if(D.$k)return m;const h=(0,A.$mc)(m);if(m===h)return m;const $=((0,A.$nc)(m)||m).toLowerCase();try{const E=(0,I.readdirSync)(h).filter(l=>l.toLowerCase()===$);if(E.length===1){const l=R(h);if(l)return(0,A.$jc)(l,E[0])}else if(E.length>1){const l=E.indexOf($);if(l>=0){const u=R(h);if(u)return(0,A.$jc)(u,E[l])}}}catch{}return null}e.$vq=R;async function S(m){if(D.$k)return m;const h=(0,A.$mc)(m);if(m===h)return m;const $=((0,A.$nc)(m)||m).toLowerCase();try{const E=(await I.Promises.readdir(h)).filter(l=>l.toLowerCase()===$);if(E.length===1){const l=await S(h);if(l)return(0,A.$jc)(l,E[0])}else if(E.length>1){const l=E.indexOf($);if(l>=0){const u=await S(h);if(u)return(0,A.$jc)(u,E[l])}}}catch{}return null}e.$wq=S;async function g(m){try{return await I.Promises.realpath(m)}catch{const $=k(m);return await I.Promises.access($,O.constants.R_OK),$}}e.$xq=g;function P(m){try{return O.realpathSync(m)}catch{const $=k(m);return O.accessSync($,O.constants.R_OK),$}}e.$yq=P;function k(m){return(0,L.$Ve)((0,A.$hc)(m),A.sep)}}),define(le[145],he([0,1,16,5,37,90,12,31]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Wl=e.$Vl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function S(k=D.env){return k.comspec||"cmd.exe"}e.$Vl=S;function g(k){let m=[],h=!1;const $=function(p){if(h){m.push(p);return}(!k.send(p,l=>{if(l&&console.error(l),h=!1,m.length>0){const u=m.slice(0);m=[],u.forEach(d=>$(d))}})||A.$i)&&(h=!0)};return{send:$}}e.$Wl=g;var P;(function(k){async function m(h,$,p){if(O.$ic(h))return h;if($===void 0&&($=D.cwd()),O.$mc(h)!=="."||(p===void 0&&I.$Jf(D.env.PATH)&&(p=D.env.PATH.split(O.$tc)),p===void 0||p.length===0))return O.$jc($,h);async function l(u){if(await R.Promises.exists(u)){let d;try{d=await R.Promises.stat(u)}catch(c){c.message.startsWith("EACCES")&&(d=await R.Promises.lstat(u))}return d?!d.isDirectory():!1}return!1}for(const u of p){let d;if(O.$ic(u)?d=O.$jc(u,h):d=O.$jc($,u,h),await l(d))return d;let c=d+".com";if(await l(c)||(c=d+".exe",await l(c)))return c}return O.$jc($,h)}k.findExecutable=m})(P||(e.win32=P={}))}),define(le[146],he([0,1,67,23]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=void 0;function D(I){return new Promise((R,S)=>{let g;const P=new Map;function k(h,$,p,E,l){const u=P.get($);if(h===I||u){const d={name:m(p),cmd:p,pid:h,ppid:$,load:E,mem:l};P.set(h,d),h===I&&(g=d),u&&(u.children||(u.children=[]),u.children.push(d),u.children.length>1&&(u.children=u.children.sort((c,y)=>c.pid-y.pid)))}}function m(h){const $=/--utility-sub-type=network/i,p=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(p.exec(h))return"electron-crash-reporter";if(E.exec(h))return"winpty-agent";if(l.exec(h))return"conpty-agent";let d=u.exec(h);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?$.exec(h)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const c=/[a-zA-Z-]+\.js/g;let y="";do d=c.exec(h),d&&(y+=d+" ");while(d);return y&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${y})`:h}if(process.platform==="win32"){const h=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,p)=>{se(["@vscode/windows-process-tree"],$,p)}).then($=>{$.getProcessList(I,p=>{if(!p){S(new Error(`Root process ${I} not found`));return}$.getProcessCpuUsage(p,E=>{const l=new Map;E.forEach(u=>{const d=h(u.commandLine||"");l.set(u.pid,{name:m(d),cmd:d,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),g=l.get(I),g?(l.forEach(u=>{const d=l.get(u.ppid);d&&(d.children||(d.children=[]),d.children.push(u))}),l.forEach(u=>{u.children&&(u.children=u.children.sort((d,c)=>d.pid-c.pid))}),R(g)):S(new Error(`Root process ${I} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let h=function(){let $=[g];const p=[];for(;$.length;){const l=$.shift();l&&(p.push(l.pid),l.children&&($=$.concat(l.children)))}let E=JSON.stringify(A.$pg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+p.join(" "),(0,O.exec)(E,{},(l,u,d)=>{if(l||d)S(l||new Error(d.toString()));else{const c=u.toString().split(`
`);for(let y=0;y<p.length;y++){const i=P.get(p[y]);i.load=parseFloat(c[y])}if(!g){S(new Error(`Root process ${I} not found`));return}R(g)}})};(0,O.exec)("which ps",{},($,p,E)=>{if($||E)if(process.platform!=="linux")S($||new Error(E.toString()));else{const l=JSON.stringify(A.$pg.asFileUri("vs/base/node/ps.sh").fsPath);(0,O.exec)(l,{},(u,d,c)=>{u||c?S(u||new Error(c.toString())):(L(d,k),h())})}else{const l=p.toString().trim();(0,O.exec)(`${l} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,c,y)=>{d||y&&!y.includes("screen size is bogus")?S(d||new Error(y.toString())):(L(c,k),process.platform==="linux"?h():g?R(g):S(new Error(`Root process ${I} not found`)))})}})}})}e.$7r=D;function L(I,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=I.toString().split(`
`);for(const P of g){const k=S.exec(P.trim());k&&k.length===6&&R(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}});var pe=this&&this.__decorate||function(se,e,O,A){var D=arguments.length,L=D<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,O):A,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(se,e,O,A);else for(var R=se.length-1;R>=0;R--)(I=se[R])&&(L=(D<3?I(L):D>3?I(e,O,L):I(e,O))||L);return D>3&&L&&Object.defineProperty(e,O,L),L};define(le[40],he([0,1,17,6,14,26,85,7,3,2,66,27,12]),function(se,e,O,A,D,L,I,R,S,g,P,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.ProxyChannel=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.RequestInitiator=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;var h;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(h||(h={}));function $(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(p||(p={}));function E(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(l||(l={}));function u(H){let W=0;for(let te=0;;te+=7){const oe=H.read(1);if(W|=(oe.buffer[0]&127)<<te,!(oe.buffer[0]&128))return W}}const d=n(0);function c(H,W){if(W===0){H.write(d);return}let te=0;for(let ee=W;ee!==0;ee=ee>>>7)te++;const oe=D.$ke.alloc(te);for(let ee=0;W!==0;ee++)oe.buffer[ee]=W&127,W=W>>>7,W>0&&(oe.buffer[ee]|=128);H.write(oe)}class y{constructor(W){this.b=W,this.a=0}read(W){const te=this.b.slice(this.a,this.a+W);return this.a+=te.byteLength,te}}e.$Fh=y;class i{constructor(){this.a=[]}get buffer(){return D.$ke.concat(this.a)}write(W){this.a.push(W)}}e.$Gh=i;var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(o||(o={}));function n(H){const W=D.$ke.alloc(1);return W.writeUInt8(H,0),W}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(H,W){if(typeof W>"u")H.write(s.Undefined);else if(typeof W=="string"){const te=D.$ke.fromString(W);H.write(s.String),c(H,te.byteLength),H.write(te)}else if(t&&Buffer.isBuffer(W)){const te=D.$ke.wrap(W);H.write(s.Buffer),c(H,te.byteLength),H.write(te)}else if(W instanceof D.$ke)H.write(s.VSBuffer),c(H,W.byteLength),H.write(W);else if(Array.isArray(W)){H.write(s.Array),c(H,W.length);for(const te of W)r(H,te)}else if(typeof W=="number"&&(W|0)===W)H.write(s.Uint),c(H,W);else{const te=D.$ke.fromString(JSON.stringify(W));H.write(s.Object),c(H,te.byteLength),H.write(te)}}e.$Hh=r;function a(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(u(H)).toString();case o.Buffer:return H.read(u(H)).buffer;case o.VSBuffer:return H.read(u(H));case o.Array:{const te=u(H),oe=[];for(let ee=0;ee<te;ee++)oe.push(a(H));return oe}case o.Object:return JSON.parse(H.read(u(H)).toString());case o.Int:return u(H)}}e.$Ih=a;class v{constructor(W,te,oe=null,ee=1e3){this.h=W,this.j=te,this.k=oe,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(W,te){this.b.set(W,te),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const te=this.o([W.type]);this.k?.logOutgoing(te,0,1,E(W.type));return}case 201:case 202:case 204:case 203:{const te=this.o([W.type,W.id],W.data);this.k?.logOutgoing(te,W.id,1,E(W.type),W.data);return}}}o(W,te=void 0){const oe=new i;return r(oe,W),r(oe,te),this.p(oe.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const te=new y(W),oe=a(te),ee=a(te),ae=oe[0];switch(ae){case 100:return this.k?.logIncoming(W.byteLength,oe[1],1,`${$(ae)}: ${oe[2]}.${oe[3]}`,ee),this.s({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:ee});case 102:return this.k?.logIncoming(W.byteLength,oe[1],1,`${$(ae)}: ${oe[2]}.${oe[3]}`,ee),this.t({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:ee});case 101:return this.k?.logIncoming(W.byteLength,oe[1],1,`${$(ae)}`),this.u({type:ae,id:oe[1]});case 103:return this.k?.logIncoming(W.byteLength,oe[1],1,`${$(ae)}`),this.u({type:ae,id:oe[1]})}}s(W){const te=this.b.get(W.channelName);if(!te){this.v(W);return}const oe=new L.$7d;let ee;try{ee=te.call(this.j,W.name,W.arg,oe.token)}catch(z){ee=Promise.reject(z)}const ae=W.id;ee.then(z=>{this.m({id:ae,data:z,type:201})},z=>{z instanceof Error?this.m({id:ae,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:ae,data:z,type:203})}).finally(()=>{G.dispose(),this.d.delete(W.id)});const G=(0,g.$Rc)(()=>oe.cancel());this.d.set(W.id,G)}t(W){const te=this.b.get(W.channelName);if(!te){this.v(W);return}const oe=W.id,ae=te.listen(this.j,W.name,W.arg)(G=>this.m({id:oe,data:G,type:204}));this.d.set(W.id,ae)}u(W){const te=this.d.get(W.id);te&&(te.dispose(),this.d.delete(W.id))}v(W){let te=this.g.get(W.channelName);te||(te=[],this.g.set(W.channelName,te));const oe=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);te.push({request:W,timeoutTimer:oe})}w(W){const te=this.g.get(W);if(te){for(const oe of te)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Jh=v;var w;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class f{constructor(W,te=null){this.l=W,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=te}getChannel(W){const te=this;return{call(oe,ee,ae){return te.a?Promise.reject(new R.$5):te.m(W,oe,ee,ae)},listen(oe,ee){return te.a?S.Event.None:te.o(W,oe,ee)}}}m(W,te,oe,ee=L.CancellationToken.None){const ae=this.g++,z={id:ae,type:100,channelName:W,name:te,arg:oe};if(ee.isCancellationRequested)return Promise.reject(new R.$5);let j;return new Promise((B,U)=>{if(ee.isCancellationRequested)return U(new R.$5);const Z=()=>{const ne=ce=>{switch(ce.type){case 201:this.f.delete(ae),B(ce.data);break;case 202:{this.f.delete(ae);const fe=new Error(ce.data.message);fe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,fe.name=ce.data.name,U(fe);break}case 203:this.f.delete(ae),U(ce.data);break}};this.f.set(ae,ne),this.p(z)};let _=null;this.b===l.Idle?Z():(_=(0,A.$Ug)(ne=>this.u()),_.then(()=>{_=null,Z()}));const ie=()=>{_?(_.cancel(),_=null):this.p({id:ae,type:101}),U(new R.$5)},J=ee.onCancellationRequested(ie);j=(0,g.$Qc)((0,g.$Rc)(ie),J),this.d.add(j)}).finally(()=>{j.dispose(),this.d.delete(j)})}o(W,te,oe){const ee=this.g++,G={id:ee,type:102,channelName:W,name:te,arg:oe};let z=null;const j=new S.$Wd({onWillAddFirstListener:()=>{z=(0,A.$Ug)(B=>this.u()),z.then(()=>{z=null,this.d.add(j),this.p(G)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(j),this.p({id:ee,type:103}))}}),F=B=>j.fire(B.data);return this.f.set(ee,F),j.event}p(W){switch(W.type){case 100:case 102:{const te=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(te,W.id,0,`${$(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const te=this.q([W.type,W.id]);this.j?.logOutgoing(te,W.id,0,$(W.type));return}}}q(W,te=void 0){const oe=new i;return r(oe,W),r(oe,te),this.r(oe.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const te=new y(W),oe=a(te),ee=a(te),ae=oe[0];switch(ae){case 200:return this.j?.logIncoming(W.byteLength,0,0,E(ae)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,oe[1],0,E(ae),ee),this.t({type:oe[0],id:oe[1],data:ee})}}t(W){if(W.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Kh=f,pe([I.$zh],f.prototype,"onDidInitializePromise",null);class b{get connections(){const W=[];return this.f.forEach(te=>W.push(te)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new S.$Wd,this.onDidAddConnection=this.g.event,this.h=new S.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new g.$Sc,this.j.add(W(({protocol:te,onDidClientDisconnect:oe})=>{const ee=S.Event.once(te.onMessage);this.j.add(ee(ae=>{const G=new y(ae),z=a(G),j=new v(te,z),F=new f(te);this.a.forEach((U,Z)=>j.registerChannel(Z,U));const B={channelServer:j,channelClient:F,ctx:z};this.f.add(B),this.g.fire(B),this.j.add(oe(()=>{j.dispose(),F.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(W,te){const oe=this;return{call(ee,ae,G){let z;if((0,m.$Xf)(te)){const F=(0,O.$4b)(oe.connections.filter(te));z=F?Promise.resolve(F):S.Event.toPromise(S.Event.filter(oe.onDidAddConnection,te))}else z=te.routeCall(oe,ee,ae);const j=z.then(F=>F.channelClient.getChannel(W));return N(j).call(ee,ae,G)},listen(ee,ae){if((0,m.$Xf)(te))return oe.k(W,te,ee,ae);const G=te.routeEvent(oe,ee,ae).then(z=>z.channelClient.getChannel(W));return N(G).listen(ee,ae)}}}k(W,te,oe,ee){const ae=this;let G;const z=new S.$Wd({onWillAddFirstListener:()=>{G=new g.$Sc;const j=new S.$3d,F=new Map,B=Z=>{const ie=Z.channelClient.getChannel(W).listen(oe,ee),J=j.add(ie);F.set(Z,J)},U=Z=>{const _=F.get(Z);_&&(_.dispose(),F.delete(Z))};ae.connections.filter(te).forEach(B),S.Event.filter(ae.onDidAddConnection,te)(B,void 0,G),ae.onDidRemoveConnection(U,void 0,G),j.event(z.fire,z,G),G.add(j)},onDidRemoveLastListener:()=>{G?.dispose(),G=void 0}});return z.event}registerChannel(W,te){this.a.set(W,te);for(const oe of this.f)oe.channelServer.registerChannel(W,te)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Lh=b;class C{constructor(W,te,oe=null){const ee=new i;r(ee,te),W.send(ee.buffer),this.a=new f(W,oe),this.d=new v(W,te,oe)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,te){this.d.registerChannel(W,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Mh=C;function N(H){return{call(W,te,oe){return H.then(ee=>ee.call(W,te,oe))},listen(W,te){const oe=new S.$6d;return H.then(ee=>oe.input=ee.listen(W,te)),oe.event}}}e.$Nh=N;function T(H){let W=!1;return{call(te,oe,ee){return W?H.call(te,oe,ee):(0,A.$9g)(0).then(()=>W=!0).then(()=>H.call(te,oe,ee))},listen(te,oe){if(W)return H.listen(te,oe);const ee=new S.$6d;return(0,A.$9g)(0).then(()=>W=!0).then(()=>ee.input=H.listen(te,oe)),ee.event}}}e.$Oh=T;class M{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const te of W.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await S.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$Ph=M;var q;(function(H){function W(ae,G,z){const j=ae,F=z&&z.disableMarshalling,B=new Map;for(const U in j)oe(U)&&B.set(U,S.Event.buffer(j[U],!0,void 0,G));return new class{listen(U,Z,_){const ie=B.get(Z);if(ie)return ie;if(ee(Z)){const J=j[Z];if(typeof J=="function")return J.call(j,_)}throw new R.$bb(`Event not found: ${Z}`)}call(U,Z,_){const ie=j[Z];if(typeof ie=="function"){if(!F&&Array.isArray(_))for(let ne=0;ne<_.length;ne++)_[ne]=(0,P.$Eh)(_[ne]);let J=ie.apply(j,_);return J instanceof Promise||(J=Promise.resolve(J)),J}throw new R.$bb(`Method not found: ${Z}`)}}}H.fromService=W;function te(ae,G){const z=G&&G.disableMarshalling;return new Proxy({},{get(j,F){if(typeof F=="string")return G?.properties?.has(F)?G.properties.get(F):ee(F)?function(B){return ae.listen(F,B)}:oe(F)?ae.listen(F):async function(...B){let U;G&&!(0,m.$Sf)(G.context)?U=[G.context,...B]:U=B;const Z=await ae.call(F,U);return z?Z:(0,P.$Eh)(Z)};throw new R.$bb(`Property not found: ${String(F)}`)}})}H.toService=te;function oe(ae){return ae[0]==="o"&&ae[1]==="n"&&k.$_e(ae.charCodeAt(2))}function ee(ae){return/^onDynamic/.test(ae)&&k.$_e(ae.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const W=H.toString();if(W!=="[object Object]")return W}return H}function x(H){return Array.isArray(H)?H.map(X):X(H)}function V(H,W,te,oe,ee,ae,G){G=x(G);const z=Y[ee],j=z[oe%z.length];let F=[`%c[${H}]%c[${String(W).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${j}`];/\($/.test(ae)?(F=F.concat(G),F.push(")")):F.push(G),console.log.apply(console,F)}class Q{constructor(W,te){this.d=W,this.f=te,this.a=0,this.b=0}logOutgoing(W,te,oe,ee,ae){this.b+=W,V(this.d,this.b,W,te,oe,ee,ae)}logIncoming(W,te,oe,ee,ae){this.a+=W,V(this.f,this.a,W,te,oe,ee,ae)}}e.$Qh=Q}),define(le[68],he([0,1,14,3,2,40]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.ProtocolConstants=e.$Rh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(w,f){if(!t.has(w)){const b=String(++r);t.set(w,b)}return t.get(w)}function v(w,f,b,C){if(!s.enableDiagnostics)return;const N=a(w,f);if(C instanceof O.$ke||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const T=O.$ke.alloc(C.byteLength);T.set(C),s.records.push({timestamp:Date.now(),id:N,label:f,type:b,buff:T})}else s.records.push({timestamp:Date.now(),id:N,label:f,type:b,data:C})}s.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var S;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let g=null;function P(){return g||(g=O.$ke.alloc(0)),g}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return P();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const f=this.a[0];return r&&(this.a.shift(),this.b-=t),f}if(this.a[0].byteLength>t){const f=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),f}const a=O.$ke.alloc(t);let v=0,w=0;for(;t>0;){const f=this.a[w];if(f.byteLength>t){const b=f.slice(0,t);a.set(b,v),v+=t,r&&(this.a[w]=f.slice(t),this.b-=t),t-=t}else a.set(f,v),v+=f.byteLength,r?(this.a.shift(),this.b-=f.byteLength):w++,t-=f.byteLength}return a}}e.$Rh=k;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class p{constructor(t,r,a,v){this.type=t,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends D.$Tc{constructor(t){super(),this.f=this.B(new A.$Wd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new k,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(a,v,w,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=O.$ke.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=O.$ke.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class u extends D.$Tc{constructor(t){super(),this.f=new A.$Wd,this.onMessage=this.f.event,this.g=new A.$Wd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new l(this.a)),this.c=this.B(new E(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new p(1,0,0,t))}}e.$Sh=u;class d extends L.$Mh{static fromSocket(t,r){return new d(new u(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Th=d;class c{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$Wd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Uh=c;class y{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new y(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let v=0;v<o.a;v++)t-this.c[v]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new c,this.onControlMessage=this.u.event,this.v=new c,this.onMessage=this.v.event,this.w=new c,this.onDidDispose=this.w.event,this.x=new c,this.onSocketClose=this.x.event,this.y=new c,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new D.$Sc,this.o=t.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new E(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new p(5,0,0,P());this.p.write(t),this.p.flush()}sendPause(){const t=new p(7,0,0,P());this.p.write(t)}sendResume(){const t=new p(8,0,0,P());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new D.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new E(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new p(3,0,this.h,P());this.p.write(t);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,P())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new p(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new p(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const w=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new p(3,0,this.h,P());this.p.write(t)}D(){this.h=this.g;const t=new p(9,0,this.h,P());this.p.write(t)}}e.$Vh=n}),define(le[93],he([0,1,67,6,14,26,141,7,3,2,30,145,90,40]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;class $ extends h.$Jh{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",u=>D.$ke.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$sq=$;class p{constructor(l,u){this.i=l,this.j=u,this.c=new Set,this.g=new Map,this.h=new S.$Wd,this.onDidProcessExit=this.h.event;const d=u&&u.timeout?u.timeout:6e4;this.b=new A.$5g(d),this.d=null,this.f=null}getChannel(l){const u=this;return{call(d,c,y){return u.k(l,d,c,y)},listen(d,c){return u.l(l,d,c)}}}k(l,u,d,c=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const y=this.n(l),i=(0,A.$Ug)(s=>y.call(u,d,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,g.$Rc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,u,d){if(!this.b)return S.Event.None;this.b.cancel();let c;const y=new S.$Wd({onWillAddFirstListener:()=>{c=this.n(l).listen(u,d)(y.fire,y),this.c.add(c)},onDidRemoveLastListener:()=>{this.c.delete(c),c.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return y.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,P.$yn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,m.$Ul)(u.env),this.d=(0,O.fork)(this.i,l,u);const d=new S.$Wd;S.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,I.$oq)(t)){(0,I.log)(t,`IPC Library: ${this.j.serverName}`);return}d.fire(D.$ke.wrap(Buffer.from(t,"base64")))});const y=this.j.useQueue?(0,k.$Wl)(this.d):this.d,i=t=>this.d&&this.d.connected&&y.send(t.buffer.toString("base64")),o=d.event,n={send:i,onMessage:o};this.f=new h.$Kh(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,g.$Oc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(l){let u=this.g.get(l);return u||(u=this.m.getChannel(l),this.g.set(l,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$tq=p}),define(le[147],he([0,1,134,14,40,3,12,17]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0U=e.$9U=void 0;class S{constructor(m){this.a=m,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",h=>h.data?A.$ke.wrap(h.data):A.$ke.alloc(0)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class g extends D.$Lh{static b(m){(0,I.$Tf)((0,O.$8U)(process),"Electron Utility Process");const h=new L.$Wd;return process.parentPort.on("message",$=>{if(m?.handledClientConnection($))return;const p=(0,R.$Ob)($.ports);p&&h.fire(p)}),L.Event.map(h.event,$=>({protocol:new S($),onDidClientDisconnect:L.Event.fromNodeEventEmitter($,"close")}))}constructor(m){super(g.b(m))}}e.$9U=g;function P(k,m,h){const $=p=>{p.data===m&&(k.removeListener("message",$),h())};k.on("message",$)}e.$0U=P}),define(le[69],he([0,1,6,3,2,66,12]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.StorageState=e.$rp=e.StorageHint=void 0;var R;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function S(m){const h=m;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$rp=S;var g;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(g||(e.StorageState=g={}));class P extends D.$Tc{static{this.a=100}constructor(h,$=Object.create(null)){super(),this.r=h,this.s=$,this.b=this.B(new A.$Zd),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new O.$6g(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach(($,p)=>this.w(p,$)),h.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(h,$){if(this.c===g.Closed)return;let p=!1;(0,I.$Sf)($)?p=this.f.delete(h):this.f.get(h)!==$&&(this.f.set(h,$),p=!0),p&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,$){const p=this.f.get(h);return(0,I.$Sf)(p)?$:p}getBoolean(h,$){const p=this.get(h);return(0,I.$Sf)(p)?$:p==="true"}getNumber(h,$){const p=this.get(h);return(0,I.$Sf)(p)?$:parseInt(p,10)}getObject(h,$){const p=this.get(h);return(0,I.$Sf)(p)?$:(0,L.$Dh)(p)}async set(h,$,p=!1){if(this.c===g.Closed)return;if((0,I.$Sf)($))return this.delete(h,p);const E=(0,I.$Lf)($)||Array.isArray($)?(0,L.$Ch)($):String($);if(this.f.get(h)!==E)return this.f.set(h,E),this.j.set(h,E),this.h.delete(h),this.b.fire({key:h,external:p}),this.D()}async delete(h,$=!1){if(!(this.c===g.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:$}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(this.z)return this.D(h)}async D(h){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$sp=P;class k{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach(($,p)=>this.a.set(p,$)),h.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$tp=k}),define(le[148],he([13,10]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],he([0,1,54,6,16,12,31,148]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.zip=e.$Op=e.$Np=void 0,e.$Np="end of central directory record signature not found";const S=new RegExp(e.$Np);class g extends Error{constructor(y,i){let o=i.message;switch(y){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=y,this.cause=i}}e.$Op=g;function P(c){const y=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>y&i).reduce((i,o)=>i+o,y&61440)}function k(c){if(c instanceof g)return c;let y;return S.test(c.message)&&(y="CorruptZip"),new g(y,c)}function m(c,y,i,o,n,s){const t=D.$mc(y),r=D.$jc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,y)));const a=D.$jc(o,y);let v;return s.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(I.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((w,f)=>{if(!s.isCancellationRequested)try{v=(0,O.createWriteStream)(a,{mode:i}),v.once("close",()=>w()),v.once("error",f),c.once("error",f),c.pipe(v)}catch(b){f(b)}}))}function h(c,y,i,o){let n=(0,A.$Ug)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const v=new A.$3g,w=f=>{f.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new g("Incomplete",new Error(R.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",f=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(f.fileName)){w(o);return}const b=f.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(b)){const T=D.$jc(y,b);n=(0,A.$Ug)(M=>I.Promises.mkdir(T,{recursive:!0}).then(()=>w(M)).then(void 0,a));return}const C=p(c,f),N=P(f);n=(0,A.$Ug)(T=>v.queue(()=>C.then(M=>m(M,b,N,y,i,T).then(()=>w(T)))).then(null,a))})}).finally(()=>t.dispose())}async function $(c,y=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,y?{lazyEntries:!0}:void 0,(s,t)=>{s?n(k(s)):o((0,L.$Uf)(t))})})}function p(c,y){return new Promise((i,o)=>{c.openReadStream(y,(n,s)=>{n?o(k(n)):i((0,L.$Uf)(s))})})}async function E(c,y){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;y.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,O.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}e.zip=E;function l(c,y,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=$(c,!0);return i.overwrite&&(s=s.then(t=>I.Promises.rm(y).then(()=>t))),s.then(t=>h(t,y,{sourcePathRegex:n},o))}e.$Qp=l;function u(c,y){return $(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===y&&p(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(R.localize(2,null,y))))}))}function d(c,y){return u(c,y).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}e.$Rp=d}),define(le[149],he([13,10]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[150],he([13,10]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[151],he([13,10]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[152],he([13,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[153],he([13,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[154],he([13,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[155],he([13,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[156],he([13,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[157],he([13,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[158],he([13,10]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[159],he([13,10]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[160],he([13,10]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[161],he([13,10]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[162],he([13,10]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[163],he([13,10]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[164],he([13,10]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[165],he([13,10]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[166],he([13,10]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[167],he([13,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[168],he([13,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[169],he([13,10]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[170],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[171],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[172],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[173],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[174],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[175],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[176],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[177],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[178],he([13,10]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[179],he([0,1,7,151]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.TokenType=void 0;var D;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(D||(e.TokenType=D={}));function L(...g){switch(g.length){case 1:return(0,A.localize)(0,null,g[0]);case 2:return(0,A.localize)(1,null,g[0],g[1]);case 3:return(0,A.localize)(2,null,g[0],g[1],g[2]);default:return}}const I=(0,A.localize)(3,null),R=(0,A.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,O.$8)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const k=this.d,m=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:m};this.g.push({offset:k,lexeme:m,additionalInfo:P}),this.f.push(h)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const k=this.c.substring(this.d,this.e),m=S.b.get(k);m?this.k(m):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,k=!1,m=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(R);return}const $=this.c.charCodeAt(P);if(k)k=!1;else if($===47&&!m){P++;break}else $===91?m=!0:$===92?k=!0:$===93&&(m=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$3i=S}),define(le[180],he([0,1,65,85,23,16,37,20,9]),function(se,e,O,A,D,L,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0,e.$Am=/^([^.]+\..+)[:=](.+)$/;class g{get appRoot(){return(0,L.$mc)(D.$pg.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,L.$jc)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,R.$Ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$Ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,O.$zm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$jc)(this.userDataPath,"logs",h)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$Ig)(S.URI.file((0,L.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$Ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$Ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$Ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=I.env.VSCODE_PORTABLE;return h?S.URI.file((0,L.$jc)(h,"argv.json")):(0,R.$Ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,L.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,L.$kc)(h):(0,L.$hc)((0,L.$jc)(D.$pg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?S.URI.file((0,L.$kc)(h)):S.URI.file((0,L.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,L.$kc)(h);const $=I.env.VSCODE_EXTENSIONS;if($)return $;const p=I.env.VSCODE_PORTABLE;return p?(0,L.$jc)(p,"extensions"):(0,R.$Ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map($=>/^[^:/?#]+?:\/\//.test($)?S.URI.parse($):S.URI.file((0,L.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?S.URI.parse(h):S.URI.file((0,L.$hc)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Am.test(h))}get extensionLogLevel(){const h=[];for(const $ of this.args.log||[]){const p=e.$Am.exec($);p&&p[1]&&p[2]&&h.push([p[1],p[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.$Ig)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=I.env.VSCODE_PORTABLE;return h?S.URI.file((0,L.$jc)(h,"policy.json")):(0,R.$Ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,$,p){this.a=h,this.b=$,this.c=p,this.editSessionId=this.args.editSessionId}}e.$Bm=g,pe([A.$zh],g.prototype,"appRoot",null),pe([A.$zh],g.prototype,"userHome",null),pe([A.$zh],g.prototype,"userDataPath",null),pe([A.$zh],g.prototype,"appSettingsHome",null),pe([A.$zh],g.prototype,"tmpDir",null),pe([A.$zh],g.prototype,"cacheHome",null),pe([A.$zh],g.prototype,"stateResource",null),pe([A.$zh],g.prototype,"userRoamingDataHome",null),pe([A.$zh],g.prototype,"userDataSyncHome",null),pe([A.$zh],g.prototype,"sync",null),pe([A.$zh],g.prototype,"machineSettingsResource",null),pe([A.$zh],g.prototype,"workspaceStorageHome",null),pe([A.$zh],g.prototype,"localHistoryHome",null),pe([A.$zh],g.prototype,"keyboardLayoutResource",null),pe([A.$zh],g.prototype,"argvResource",null),pe([A.$zh],g.prototype,"isExtensionDevelopment",null),pe([A.$zh],g.prototype,"untitledWorkspacesHome",null),pe([A.$zh],g.prototype,"builtinExtensionsPath",null),pe([A.$zh],g.prototype,"extensionsPath",null),pe([A.$zh],g.prototype,"extensionDevelopmentLocationURI",null),pe([A.$zh],g.prototype,"extensionDevelopmentKind",null),pe([A.$zh],g.prototype,"extensionTestsLocationURI",null),pe([A.$zh],g.prototype,"debugExtensionHost",null),pe([A.$zh],g.prototype,"logLevel",null),pe([A.$zh],g.prototype,"extensionLogLevel",null),pe([A.$zh],g.prototype,"serviceMachineIdResource",null),pe([A.$zh],g.prototype,"disableTelemetry",null),pe([A.$zh],g.prototype,"disableWorkspaceTrust",null),pe([A.$zh],g.prototype,"useInMemorySecretStorage",null),pe([A.$zh],g.prototype,"policyFile",null);function P(m,h){return k(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId,m.extensionEnvironment)}e.$Cm=P;function k(m,h,$,p,E,l){const d=Number(h||m)||(p?null:$),c=d?!!h:!1;let y;if(l)try{y=JSON.parse(l)}catch{}return{port:d,break:c,debugId:E,env:y}}e.$Dm=k}),function(){"use strict";function se(e,O,A){function D(I,R){const S=L(I,R),g=[S];return e.isAbsolute(S)||g.unshift(A),e.resolve(...g)}function L(I,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const P=I["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(k,"AppData","Roaming")}break;case"darwin":g=e.join(O.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:D}}if(typeof define=="function")define(le[181],he([269,36,37]),function(e,O,A){return se(e,O,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=se(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[182],he([0,1,36,180,181]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=void 0;class L extends A.$Bm{constructor(g,P){super(g,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,D.getUserDataPath)(g,P.nameShort)},P)}}e.$Em=L;function I(S,g){return(0,A.$Dm)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,g,S.extensionEnvironment)}e.$Fm=I;function R(S,g){return(0,A.$Dm)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,g,S.extensionEnvironment)}e.$Gm=R}),define(le[183],he([0,1,12,154]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;function D(I,R,S,g){try{L(I,R,S,g)}catch(P){I.error(P?.message??P)}return R}e.$1p=D;function L(I,R,S,g){const P=(k,m,h)=>{const $=k[m];if((0,O.$Jf)($)){const p=$,E=p.length;if(E>1&&p[0]==="%"&&p[E-1]==="%"){const l=p.substr(1,E-2);let u=S[l];u===void 0&&g&&(u=g[l]);const d=typeof u=="string"?u:u?.message,c=g?.[l],y=typeof c=="string"?c:c?.message;if(!d){y||I.warn(`[${R.name}]: ${(0,A.localize)(0,null,l)}`);return}if(h&&(m==="title"||m==="category")&&y&&y!==d){const i={value:d,original:y};k[m]=i}else k[m]=d}}else if((0,O.$Lf)($))for(const p in $)$.hasOwnProperty(p)&&(p==="commands"?P($,p,!0):P($,p,h));else if(Array.isArray($))for(let p=0;p<$.length;p++)P($,p,h)};for(const k in R)R.hasOwnProperty(k)&&P(R,k)}}),define(le[184],he([0,1,70,157]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;function D(L){return(0,O.$Rp)(L,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.$9p=D}),define(le[185],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=e.$mac=void 0;class O{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$mac=O;class A{constructor(L){this.a=L}listen(L,I){throw new Error(`Event not found: ${I}`)}call(L,I,R){switch(I){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${I}`)}}e.$nac=A}),define(le[71],he([0,1,20,89,158,55]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||I.test(l)}e.$cp=S;function g(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(I);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$dp=g;function P(l){if(!l)return null;const u=l.majorBase,d=l.majorMustEqual,c=l.minorBase;let y=l.minorMustEqual;const i=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(u===0||(y=!1),o=!1);let n=0;if(l.preRelease){const s=R.exec(l.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:u,majorMustEqual:d,minorBase:c,minorMustEqual:y,patchBase:i,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:n}}e.$ep=P;function k(l,u,d){let c;typeof l=="string"?c=P(g(l)):c=l;let y;u instanceof Date?y=u.getTime():typeof u=="string"&&(y=new Date(u).getTime());let i;if(typeof d=="string"?i=P(g(d)):i=d,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const v=i.notBefore;let w=i.majorMustEqual,f=i.minorMustEqual,b=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||y&&y<v?!1:s>=a:(o===1&&t===0&&(!w||!f||!b)&&(t=1,r=0,a=0,w=!0,f=!1,b=!1),o<t?!1:o>t?!w:n<r?!1:n>r?!f:s<a?!1:s>a?!b:!(y&&y<v))}e.$fp=k;function m(l,u,d,c,y){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([A.default.Error,D.localize(0,null)]),i;if(typeof c.name!="string")return i.push([A.default.Error,D.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([A.default.Error,D.localize(2,null,"version")]),i;if(!c.engines)return i.push([A.default.Error,D.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([A.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!E(c.extensionDependencies))return i.push([A.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!E(c.activationEvents))return i.push([A.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([A.default.Error,D.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([A.default.Warning,D.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([A.default.Error,D.localize(9,null,"main")]),i;{const s=(0,O.$Ig)(d,c.main);(0,O.$Cg)(s,d)||i.push([A.default.Warning,D.localize(10,null,s.path,d.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([A.default.Error,D.localize(11,null,"browser")]),i;{const s=(0,O.$Ig)(d,c.browser);(0,O.$Cg)(s,d)||i.push([A.default.Warning,D.localize(12,null,s.path,d.path)])}}if(!L.valid(c.version))return i.push([A.default.Error,D.localize(13,null)]),i;const o=[];if(!h(l,u,c,y,o))for(const s of o)i.push([A.default.Error,s]);return i}e.$gp=m;function h(l,u,d,c,y){return c||typeof d.main>"u"&&typeof d.browser>"u"?!0:p(l,u,d.engines.vscode,y)}e.$hp=h;function $(l,u,d){return l==="*"||p(u,d,l)}e.$ip=$;function p(l,u,d,c=[]){const y=P(g(d));if(!y)return c.push(D.localize(14,null,d)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return c.push(D.localize(15,null,d)),!1}else if(!y.majorMustEqual)return c.push(D.localize(16,null,d)),!1;return k(l,u,y)?!0:(c.push(D.localize(17,null,l,d)),!1)}function E(l){if(!Array.isArray(l))return!1;for(let u=0,d=l.length;u<d;u++)if(typeof l[u]!="string")return!1;return!0}}),define(le[43],he([0,1,14,32]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function D(L,I,R){let S=R&&R.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const P=(await I.readFile(L.serviceMachineIdResource)).value.toString();S=(0,A.$qg)(P)?P:null}catch{S=null}if(!S){S=(0,A.$rg)();try{await I.writeFile(L.serviceMachineIdResource,O.$ke.fromString(S))}catch{}}return R?.store("storage.serviceMachineId",S,-1,1),S}e.$Cp=D}),define(le[72],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class O{constructor(D,L=[],I=!1){this.ctor=D,this.staticArguments=L,this.supportsDelayedInstantiation=I}}e.$5h=O}),define(le[186],he([0,1,72]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const A=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function L(R,S,g){S instanceof O.$5h||(S=new O.$5h(S,[],!!g)),A.push([R,S])}e.$1r=L;function I(){return A}e.$2r=I}),define(le[187],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class O{constructor(L,I){this.key=L,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=O;class A{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const I of this.a.values())I.outgoing.size===0&&L.push(I);return L}insertEdge(L,I){const R=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(I);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(L){const I=this.b(L);this.a.delete(I);for(const R of this.a.values())R.outgoing.delete(I),R.incoming.delete(I)}lookupOrInsertNode(L){const I=this.b(L);let R=this.a.get(I);return R||(R=new O(I,L),this.a.set(I,R)),R}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[I,R]of this.a)L.push(`${I}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,I]of this.a){const R=new Set([L]),S=this.c(I,R);if(S)return S}}c(L,I){for(const[R,S]of L.outgoing){if(I.has(R))return[...I,R].join(" -> ");I.add(R);const g=this.c(S,I);if(g)return g;I.delete(R)}}}e.$Fq=A}),define(le[4],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e._util=void 0;var O;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=R})(O||(e._util=O={})),e.$7h=D("instantiationService");function A(I,R,S){R[O.DI_TARGET]===R?R[O.DI_DEPENDENCIES].push({id:I,index:S}):(R[O.DI_DEPENDENCIES]=[{id:I,index:S}],R[O.DI_TARGET]=R)}function D(I){if(O.serviceIds.has(I))return O.serviceIds.get(I);const R=function(S,g,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(R,S,P)};return R.toString=()=>I,O.serviceIds.set(I,R),R}e.$8h=D;function L(I){return I}e.$9h=L}),define(le[188],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=void 0,e.$Y_b=(0,O.$8h)("checksumService")}),define(le[21],he([0,1,12,9,4]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.ConfigurationTarget=e.$Di=e.$Ci=e.$Bi=void 0,e.$Bi=(0,D.$8h)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof A.URI)}e.$Ci=L;function I(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof A.URI)}e.$Di=I;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function S(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ei=S;function g(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$Fi=g;function P(l,u){const d=Object.create(null);for(const c in l)k(d,c,l[c],u);return d}e.$Gi=P;function k(l,u,d,c){const y=u.split("."),i=y.pop();let o=l;for(let n=0;n<y.length;n++){const s=y[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${u} as ${y.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=d}catch{c(`Ignoring ${u} as ${y.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${u} as ${y.join(".")} is ${JSON.stringify(o)}`)}e.$Hi=k;function m(l,u){const d=u.split(".");h(l,d)}e.$Ii=m;function h(l,u){const d=u.shift();if(u.length===0){delete l[d];return}if(Object.keys(l).indexOf(d)!==-1){const c=l[d];typeof c=="object"&&!Array.isArray(c)&&(h(c,u),Object.keys(c).length===0&&delete l[d])}}function $(l,u,d){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const y=u.split("."),i=c(l,y);return typeof i>"u"?d:i}e.$Ji=$;function p(l,u,d){Object.keys(u).forEach(c=>{c!=="__proto__"&&(c in l?O.$Lf(l[c])&&O.$Lf(u[c])?p(l[c],u[c],d):d&&(l[c]=u[c]):l[c]=u[c])})}e.$Ki=p;function E(l){return l.replace(/[\[\]]/g,"")}e.$Li=E}),define(le[94],he([0,1,5,27,179,4,150,7]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.ContextKeyExprType=e.$4i=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",O.$j),S.set("isLinux",O.$k),S.set("isWindows",O.$i),S.set("isWeb",O.$o),S.set("isMacNative",O.$j&&!O.$o),S.set("isEdge",O.$H),S.set("isFirefox",O.$F),S.set("isChrome",O.$E),S.set("isSafari",O.$G);function g(z,j){if(S.get(z)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(z,j)}e.$4i=g;const P=Object.prototype.hasOwnProperty;var k;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const m={regexParsingWithErrorRecovery:!0},h=(0,I.localize)(0,null),$=(0,I.localize)(1,null),p=(0,I.localize)(2,null),E=(0,I.localize)(3,null),l=(0,I.localize)(4,null),u=(0,I.localize)(5,null),d=(0,I.localize)(6,null),c=(0,I.localize)(7,null);class y{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=m){this.k=j,this.d=new D.$3i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const B=this.D(),U=B.type===17?u:void 0;throw this.h.push({message:l,offset:B.offset,lexeme:D.$3i.getLexeme(B),additionalInfo:U}),y.c}return F}catch(F){if(F!==y.c)throw F;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const F=this.o();j.push(F)}return j.length===1?j[0]:i.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const F=this.s();j.push(F)}return j.length===1?j[0]:i.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,E),F?.negate()}case 17:return this.z(),C.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const F=this.l();return this.A(1,E),F}case 17:{const F=j.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const Z=U.lexeme,_=Z.lastIndexOf("/"),ie=_===Z.length-1?void 0:this.w(Z.substring(_+1));let J;try{J=new RegExp(Z.substring(1,_),ie)}catch{throw this.B("REGEX",U)}return X.create(F,J)}switch(U.type){case 10:case 19:{const Z=[U.lexeme];this.z();let _=this.D(),ie=0;for(let de=0;de<U.lexeme.length;de++)U.lexeme.charCodeAt(de)===40?ie++:U.lexeme.charCodeAt(de)===41&&ie--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let de=0;de<_.lexeme.length;de++)_.lexeme.charCodeAt(de)===40?ie++:U.lexeme.charCodeAt(de)===41&&ie--}if(ie<0)break;Z.push(D.$3i.getLexeme(_)),this.z(),_=this.D()}const J=Z.join(""),ne=J.lastIndexOf("/"),ce=ne===J.length-1?void 0:this.w(J.substring(ne+1));let fe;try{fe=new RegExp(J.substring(1,ne),ce)}catch{throw this.B("REGEX",U)}return i.regex(F,fe)}case 18:{const Z=U.lexeme;this.z();let _=null;if(!(0,A.$Ke)(Z)){const ie=Z.indexOf("/"),J=Z.lastIndexOf("/");if(ie!==J&&ie>=0){const ne=Z.slice(ie+1,J),ce=Z[J+1]==="i"?"i":"";try{_=new RegExp(ne,ce)}catch{throw this.B("REGEX",U)}}}if(_===null)throw this.B("REGEX",U);return X.create(F,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const U=this.u();return i.notIn(F,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return i.equals(F,U);switch(U){case"true":return i.has(F);case"false":return i.not(F);default:return i.equals(F,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return i.notEquals(F,U);switch(U){case"true":return i.not(F);case"false":return i.has(F);default:return i.notEquals(F,U)}}case 5:return this.z(),q.create(F,this.u());case 6:return this.z(),Y.create(F,this.u());case 7:return this.z(),T.create(F,this.u());case 8:return this.z(),M.create(F,this.u());case 13:return this.z(),i.in(F,this.u());default:return i.has(F)}}case 20:throw this.h.push({message:d,offset:j.offset,lexeme:"",additionalInfo:c}),y.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,F){if(this.C(j))return this.z();throw this.B(F,this.D())}B(j,F,B){const U=(0,I.localize)(8,null,j,D.$3i.getLexeme(F)),Z=F.offset,_=D.$3i.getLexeme(F);return this.h.push({message:U,offset:Z,lexeme:_,additionalInfo:B}),y.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$5i=y;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(j){return a.create(j)}static equals(j,F){return v.create(j,F)}static notEquals(j,F){return b.create(j,F)}static regex(j,F){return X.create(j,F)}static in(j,F){return w.create(j,F)}static notIn(j,F){return f.create(j,F)}static not(j){return C.create(j)}static and(...j){return Q.create(j,null,!0)}static or(...j){return H.create(j,null,!0)}static greater(j,F){return T.create(j,F)}static greaterEquals(j,F){return M.create(j,F)}static smaller(j,F){return q.create(j,F)}static smallerEquals(j,F){return Y.create(j,F)}static{this.c=new y({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$6i=i;function o(z){const j=new y({regexParsingWithErrorRecovery:!1});return z.map(F=>(j.parse(F),j.lexingErrors.length>0?j.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,I.localize)(9,null,B.additionalInfo):(0,I.localize)(10,null),offset:B.offset,length:B.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$7i=o;function n(z,j){const F=z?z.substituteConstants():void 0,B=j?j.substituteConstants():void 0;return!F&&!B?!0:!F||!B?!1:F.equals(B)}e.$8i=n;function s(z,j){return z.cmp(j)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return r.INSTANCE}}e.$9i=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return t.INSTANCE}}e.$0i=r;class a{static create(j,F=null){const B=S.get(j);return typeof B=="boolean"?B?r.INSTANCE:t.INSTANCE:new a(j,F)}constructor(j,F){this.key=j,this.c=F,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:te(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=S.get(this.key);return typeof j=="boolean"?j?r.INSTANCE:t.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$$i=a;class v{static create(j,F,B=null){if(typeof F=="boolean")return F?a.create(j,B):C.create(j,B);const U=S.get(j);return typeof U=="boolean"?F===(U?"true":"false")?r.INSTANCE:t.INSTANCE:new v(j,F,B)}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=S.get(this.c);if(typeof j=="boolean"){const F=j?"true":"false";return this.d===F?r.INSTANCE:t.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$_i=v;class w{static create(j,F){return new w(j,F)}constructor(j,F){this.d=j,this.f=F,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const F=j.getValue(this.f),B=j.getValue(this.d);return Array.isArray(F)?F.includes(B):typeof B=="string"&&typeof F=="object"&&F!==null?P.call(F,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$aj=w;class f{static create(j,F){return new f(j,F)}constructor(j,F){this.d=j,this.f=F,this.type=11,this.c=w.create(j,F)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$bj=f;class b{static create(j,F,B=null){if(typeof F=="boolean")return F?C.create(j,B):a.create(j,B);const U=S.get(j);return typeof U=="boolean"?F===(U?"true":"false")?t.INSTANCE:r.INSTANCE:new b(j,F,B)}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=S.get(this.c);if(typeof j=="boolean"){const F=j?"true":"false";return this.d===F?t.INSTANCE:r.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$cj=b;class C{static create(j,F=null){const B=S.get(j);return typeof B=="boolean"?B?t.INSTANCE:r.INSTANCE:new C(j,F)}constructor(j,F){this.c=j,this.d=F,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:te(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=S.get(this.c);return typeof j=="boolean"?j?t.INSTANCE:r.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$dj=C;function N(z,j){if(typeof z=="string"){const F=parseFloat(z);isNaN(F)||(z=F)}return typeof z=="string"||typeof z=="number"?j(z):t.INSTANCE}class T{static create(j,F,B=null){return N(F,U=>new T(j,U,B))}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$ej=T;class M{static create(j,F,B=null){return N(F,U=>new M(j,U,B))}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$fj=M;class q{static create(j,F,B=null){return N(F,U=>new q(j,U,B))}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$gj=q;class Y{static create(j,F,B=null){return N(F,U=>new Y(j,U,B))}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$hj=Y;class X{static create(j,F){return new X(j,F)}constructor(j,F){this.d=j,this.f=F,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const F=this.f?this.f.source:"",B=j.f?j.f.source:"";return F<B?-1:F>B?1:0}equals(j){if(j.type===this.type){const F=this.f?this.f.source:"",B=j.f?j.f.source:"";return this.d===j.d&&F===B}return!1}substituteConstants(){return this}evaluate(j){const F=j.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$ij=X;class x{static create(j){return new x(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new x(this.c.map(j))}negate(){return this.c}}e.$jj=x;function V(z){let j=null;for(let F=0,B=z.length;F<B;F++){const U=z[F].substituteConstants();if(z[F]!==U&&j===null){j=[];for(let Z=0;Z<F;Z++)j[Z]=z[Z]}j!==null&&(j[F]=U)}return j===null?z:j}class Q{static create(j,F,B){return Q.d(j,F,B)}constructor(j,F){this.expr=j,this.c=F,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const U=s(this.expr[F],j.expr[F]);if(U!==0)return U}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(j.expr[F]))return!1;return!0}return!1}substituteConstants(){const j=V(this.expr);return j===this.expr?this:Q.create(j,this.c,!1)}evaluate(j){for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].evaluate(j))return!1;return!0}static d(j,F,B){const U=[];let Z=!1;for(const _ of j)if(_){if(_.type===1){Z=!0;continue}if(_.type===0)return t.INSTANCE;if(_.type===6){U.push(..._.expr);continue}U.push(_)}if(U.length===0&&Z)return r.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(s);for(let _=1;_<U.length;_++)U[_-1].equals(U[_])&&(U.splice(_,1),_--);if(U.length===1)return U[0];for(;U.length>1;){const _=U[U.length-1];if(_.type!==9)break;U.pop();const ie=U.pop(),J=U.length===0,ne=H.create(_.expr.map(ce=>Q.create([ce,ie],null,B)),null,J);ne&&(U.push(ne),U.sort(s))}if(U.length===1)return U[0];if(B){for(let _=0;_<U.length;_++)for(let ie=_+1;ie<U.length;ie++)if(U[_].negate().equals(U[ie]))return t.INSTANCE;if(U.length===1)return U[0]}return new Q(U,F)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const F of this.expr)j.push(...F.keys());return j}map(j){return new Q(this.expr.map(F=>F.map(j)),null)}negate(){if(!this.c){const j=[];for(const F of this.expr)j.push(F.negate());this.c=H.create(j,this,!0)}return this.c}}e.$kj=Q;class H{static create(j,F,B){return H.d(j,F,B)}constructor(j,F){this.expr=j,this.c=F,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const U=s(this.expr[F],j.expr[F]);if(U!==0)return U}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(j.expr[F]))return!1;return!0}return!1}substituteConstants(){const j=V(this.expr);return j===this.expr?this:H.create(j,this.c,!1)}evaluate(j){for(let F=0,B=this.expr.length;F<B;F++)if(this.expr[F].evaluate(j))return!0;return!1}static d(j,F,B){let U=[],Z=!1;if(j){for(let _=0,ie=j.length;_<ie;_++){const J=j[_];if(J){if(J.type===0){Z=!0;continue}if(J.type===1)return r.INSTANCE;if(J.type===9){U=U.concat(J.expr);continue}U.push(J)}}if(U.length===0&&Z)return t.INSTANCE;U.sort(s)}if(U.length!==0){if(U.length===1)return U[0];for(let _=1;_<U.length;_++)U[_-1].equals(U[_])&&(U.splice(_,1),_--);if(U.length===1)return U[0];if(B){for(let _=0;_<U.length;_++)for(let ie=_+1;ie<U.length;ie++)if(U[_].negate().equals(U[ie]))return r.INSTANCE;if(U.length===1)return U[0]}return new H(U,F)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const F of this.expr)j.push(...F.keys());return j}map(j){return new H(this.expr.map(F=>F.map(j)),null)}negate(){if(!this.c){const j=[];for(const F of this.expr)j.push(F.negate());for(;j.length>1;){const F=j.shift(),B=j.shift(),U=[];for(const Z of G(F))for(const _ of G(B))U.push(Q.create([Z,_],null,!1));j.unshift(H.create(U,null,!1))}this.c=H.create(j,this,!0)}return this.c}}e.$lj=H;class W extends a{static{this.d=[]}static all(){return W.d.values()}constructor(j,F,B){super(j,null),this.f=F,typeof B=="object"?W.d.push({...B,key:j}):B!==!0&&W.d.push({key:j,description:B,type:F!=null?typeof F:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return v.create(this.key,j)}notEqualsTo(j){return b.create(this.key,j)}}e.$mj=W,e.$nj=(0,L.$8h)("contextKeyService");function te(z,j){return z<j?-1:z>j?1:0}function oe(z,j,F,B){return z<F?-1:z>F?1:j<B?-1:j>B?1:0}function ee(z,j){if(z.type===0||j.type===1)return!0;if(z.type===9)return j.type===9?ae(z.expr,j.expr):!1;if(j.type===9){for(const F of j.expr)if(ee(z,F))return!0;return!1}if(z.type===6){if(j.type===6)return ae(j.expr,z.expr);for(const F of z.expr)if(ee(F,j))return!0;return!1}return z.equals(j)}e.$oj=ee;function ae(z,j){let F=0,B=0;for(;F<z.length&&B<j.length;){const U=z[F].cmp(j[B]);if(U<0)return!1;U===0&&F++,B++}return F===z.length}function G(z){return z.type===9?z.expr:[z]}}),define(le[95],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=e.ID=void 0,e.ID="diagnosticsService",e.$Lm=(0,O.$8h)(e.ID);function A(L){return!!L.hostName&&!!L.errorMessage}e.$Mm=A;class D{async getPerformanceInfo(I,R){return{}}async getSystemInfo(I,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,R){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$Nm=D}),define(le[96],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go=(0,O.$8h)("downloadService")}),define(le[15],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=void 0,e.$ci=(0,O.$8h)("environmentService"),e.$di=(0,O.$9h)(e.$ci)}),define(le[29],he([0,1,153,4]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ExtensionGalleryErrorCode=e.$Co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0,e.$po="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$qo=new RegExp(e.$po),e.$ro="__web_extension",e.$so="skipWalkthrough",e.$to="extensionsSync",e.$uo="dependecyOrPackExtensionInstall";function D(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$vo=D;function L(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$wo=L;function I(d,c){switch(d){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$xo=I;function R(d,c){return c==="web"&&!d.includes("web")}e.$yo=R;function S(d,c,y){return R(c,y)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===y}e.$zo=S;function g(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.$Ao=g;var P;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var k;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var m;(function(d){d.Install="install",d.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var h;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$Bo=(0,A.$8h)("extensionGalleryService");var $;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.DownloadSignature="DownloadSignature",d.UpdateMetadata="UpdateMetadata",d.Extract="Extract",d.Scanning="Scanning",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.NotAllowed="NotAllowed",d.Gallery="Gallery",d.Unknown="Unknown",d.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var p;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class E extends Error{constructor(c,y){super(c),this.code=y,this.name=y}}e.$Co=E;var l;(function(d){d.Timeout="Timeout",d.Cancelled="Cancelled",d.Failed="Failed"})(l||(e.ExtensionGalleryErrorCode=l={}));class u extends Error{constructor(c,y){super(c),this.code=y,this.name=y}}e.$Do=u,e.$Eo=(0,A.$8h)("extensionManagementService"),e.$Fo="extensionsIdentifiers/disabled",e.$Go="extensionsIdentifiers/enabled",e.$Ho=(0,A.$8h)("IGlobalExtensionEnablementService"),e.$Io=(0,A.$8h)("IExtensionTipsService"),e.$Jo=(0,O.localize2)(0,"Extensions"),e.$Ko=(0,O.localize2)(1,"Preferences")}),define(le[189],he([0,1,3,2,30,9,92,29]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=void 0;function S(E,l){return E?L.URI.revive(l?l.transformIncoming(E):E):void 0}function g(E,l){return l?l.transformOutgoingURI(E):E}function P(E,l){l=l||I.$8m;const u=E.manifest;return{...(0,I.$$m)({...E,manifest:void 0},l),manifest:u}}function k(E,l){return E?.profileLocation?(0,I.$$m)(E,l??I.$8m):E}function m(E,l){return l?(0,D.$An)(E,u=>u instanceof L.URI?l.transformOutgoingURI(u):void 0):E}class h{constructor(l,u){this.a=l,this.b=u,this.onInstallExtension=O.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=O.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=O.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=O.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=O.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,u){const d=this.b(l);switch(u){case"onInstallExtension":return O.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,d):c.profileLocation}));case"onDidInstallExtensions":return O.Event.map(this.onDidInstallExtensions,c=>c.map(y=>({...y,local:y.local?m(y.local,d):y.local,profileLocation:y.profileLocation?g(y.profileLocation,d):y.profileLocation})));case"onUninstallExtension":return O.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,d):c.profileLocation}));case"onDidUninstallExtension":return O.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,d):c.profileLocation}));case"onDidUpdateExtensionMetadata":return O.Event.map(this.onDidUpdateExtensionMetadata,c=>m(c,d))}throw new Error("Invalid listen")}async call(l,u,d){const c=this.b(l);switch(u){case"zip":{const y=P(d[0],c),i=await this.a.zip(y);return g(i,c)}case"unzip":return this.a.unzip(S(d[0],c));case"install":return this.a.install(S(d[0],c),k(d[1],c));case"installFromLocation":return this.a.installFromLocation(S(d[0],c),S(d[1],c));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(d[0],S(d[1],c),S(d[2],c));case"getManifest":return this.a.getManifest(S(d[0],c));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],k(d[1],c));case"installGalleryExtensions":{const y=d[0];return this.a.installGalleryExtensions(y.map(({extension:i,options:o})=>({extension:i,options:k(o,c)??{}})))}case"uninstall":return this.a.uninstall(P(d[0],c),k(d[1],c));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(d[0],c));case"getInstalled":return(await this.a.getInstalled(d[0],S(d[1],c))).map(i=>m(i,c));case"toggleAppliationScope":{const y=await this.a.toggleAppliationScope(P(d[0],c),S(d[1],c));return m(y,c)}case"copyExtensions":return this.a.copyExtensions(S(d[0],c),S(d[1],c));case"updateMetadata":{const y=await this.a.updateMetadata(P(d[0],c),d[1],S(d[2],c));return m(y,c)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1],d[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Kp=h;class $ extends A.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new O.$Wd),this.f=this.B(new O.$Wd),this.g=this.B(new O.$Wd),this.h=this.B(new O.$Wd),this.j=this.B(new O.$Wd),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?L.URI.revive(u.source):u.source,profileLocation:L.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(d=>({...d,local:d.local?P(d.local,null):d.local,source:this.r(d.source)?L.URI.revive(d.source):d.source,profileLocation:L.URI.revive(d.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:L.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:L.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(P(u,null))))}n(l,u){l.fire(u)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const u=await this.getTargetPlatform();return l.allTargetPlatforms.some(d=>(0,R.$zo)(d,l.allTargetPlatforms,u))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(u=>L.URI.revive(u)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,u){return Promise.resolve(this.m.call("install",[l,u])).then(d=>P(d,null))}installFromLocation(l,u){return Promise.resolve(this.m.call("installFromLocation",[l,u])).then(d=>P(d,null))}async installExtensionsFromProfile(l,u,d){return(await this.m.call("installExtensionsFromProfile",[l,u,d])).map(y=>P(y,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,u){return Promise.resolve(this.m.call("installFromGallery",[l,u])).then(d=>P(d,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(d=>({...d,local:d.local?P(d.local,null):d.local,source:this.r(d.source)?L.URI.revive(d.source):d.source,profileLocation:L.URI.revive(d.profileLocation)}))}uninstall(l,u){return Promise.resolve(this.m.call("uninstall",[l,u]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(u=>P(u,null))}getInstalled(l=null,u){return Promise.resolve(this.m.call("getInstalled",[l,u])).then(d=>d.map(c=>P(c,null)))}updateMetadata(l,u,d){return Promise.resolve(this.m.call("updateMetadata",[l,u,d])).then(c=>P(c,null))}toggleAppliationScope(l,u){return this.m.call("toggleAppliationScope",[l,u]).then(d=>P(d,null))}copyExtensions(l,u){return this.m.call("copyExtensions",[l,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,u,d){const c=await this.m.call("download",[l,u,d]);return L.URI.revive(c)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Lp=$;class p{constructor(l){this.a=l}listen(l,u){throw new Error("Invalid listen")}call(l,u,d){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Mp=p}),define(le[97],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yZb=e.RecommendationsNotificationResult=e.$xZb=e.RecommendationSource=void 0;var A;(function(I){I[I.FILE=1]="FILE",I[I.WORKSPACE=2]="WORKSPACE",I[I.EXE=3]="EXE"})(A||(e.RecommendationSource=A={}));function D(I){switch(I){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$xZb=D;var L;(function(I){I.Ignored="ignored",I.Cancelled="cancelled",I.TooMany="toomany",I.IncompatibleWindow="incompatibleWindow",I.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$yZb=(0,O.$8h)("IExtensionRecommendationNotificationService")}),define(le[11],he([0,1,48,16,27,12,9,160,4,5,23,52]),function(se,e,O,A,D,L,I,R,S,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileKind=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileOperationResult=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileChangeType=e.$Kk=e.FileOperation=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderErrorCode=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileSystemProviderCapabilities=e.$uk=e.FilePermission=e.FileType=e.$tk=e.$sk=void 0,e.$sk=(0,S.$8h)("fileService");function m(ee){return ee.create===!0}e.$tk=m;var h;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var $;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})($||(e.FilePermission=$={}));function p(ee){const ae=ee;return!!ae&&typeof ae.onDidChange=="function"}e.$uk=p;var E;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(E||(e.FileSystemProviderCapabilities=E={}));function l(ee){return!!(ee.capabilities&2)}e.$vk=l;function u(ee){return!!(ee.capabilities&8)}e.$wk=u;function d(ee){return!!(ee.capabilities&131072)}e.$xk=d;function c(ee){return!!(ee.capabilities&4)}e.$yk=c;function y(ee){return!!(ee.capabilities&16)}e.$zk=y;function i(ee){return l(ee)?!!(ee.capabilities&16384):!1}e.$Ak=i;function o(ee){return l(ee)?!!(ee.capabilities&32768):!1}e.$Bk=o;function n(ee){return!!(ee.capabilities&65536)}e.$Ck=n;function s(ee){return!!(ee.capabilities&2048)}e.$Dk=s;var t;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ae,G){const z=new r(ae.toString(),G);return w(z,G),z}constructor(ae,G){super(ae),this.code=G}}e.$Ek=r;function a(ee,ae){return r.create(ee,ae)}e.$Fk=a;function v(ee){return ee||a((0,R.localize)(0,null),t.Unknown)}e.$Gk=v;function w(ee,ae){return ee.name=ae?`${ae} (FileSystemError)`:"FileSystemError",ee}e.$Hk=w;function f(ee){if(!ee)return t.Unknown;if(ee instanceof r)return ee.code;const ae=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!ae)return t.Unknown;switch(ae[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$Ik=f;function b(ee){if(ee instanceof Y)return ee.fileOperationResult;switch(f(ee)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$Jk=b;var C;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class N{constructor(ae,G,z){this.resource=ae,this.operation=G,this.target=z}isOperation(ae){return this.operation===ae}}e.$Kk=N;var T;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class M{static{this.a=null}constructor(ae,G){this.c=G,this.b=void 0,this.d=new k.$V(()=>{const z=O.$bi.forUris(()=>this.c);return z.fill(this.rawAdded.map(j=>[j,!0])),z}),this.f=new k.$V(()=>{const z=O.$bi.forUris(()=>this.c);return z.fill(this.rawUpdated.map(j=>[j,!0])),z}),this.g=new k.$V(()=>{const z=O.$bi.forUris(()=>this.c);return z.fill(this.rawDeleted.map(j=>[j,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of ae){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==M.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ae,...G){return this.h(ae,{includeChildren:!1},...G)}affects(ae,...G){return this.h(ae,{includeChildren:!0},...G)}h(ae,G,...z){if(!ae)return!1;const j=z.length>0;return!!((!j||z.includes(1))&&(this.d.value.get(ae)||G.includeChildren&&this.d.value.findSuperstr(ae))||(!j||z.includes(0))&&(this.f.value.get(ae)||G.includeChildren&&this.f.value.findSuperstr(ae))||(!j||z.includes(2))&&(this.g.value.findSubstr(ae)||G.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$Lk=M;function q(ee,ae,G){return!ee||!ae||ee===ae||ae.length>ee.length?!1:(ae.charAt(ae.length-1)!==A.sep&&(ae+=A.sep),G?(0,D.$bf)(ee,ae):ee.indexOf(ae)===0)}e.$Mk=q;class Y extends Error{constructor(ae,G,z){super(ae),this.fileOperationResult=G,this.options=z}}e.$Nk=Y;class X extends Y{constructor(ae,G,z,j){super(ae,G,j),this.fileOperationResult=G,this.size=z}}e.$Ok=X;class x extends Y{constructor(ae,G,z){super(ae,2,z),this.stat=G}}e.$Pk=x;var V;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$Qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Sk="files.associations",e.$Tk="files.exclude",e.$Uk="files.readonlyInclude",e.$Vk="files.readonlyExclude",e.$Wk="files.readonlyFromPermissions";var Q;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$Xk="";function H(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}e.$Yk=H;async function W(ee,ae){if(!ae.hasProvider(I.URI.from({scheme:ee.scheme})))return new Promise(G=>{const z=ae.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===ee.scheme&&j.added&&(z.dispose(),G())})})}e.$Zk=W;class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(ae){return(0,L.$Nf)(ae)||(ae=0),ae<te.KB?(0,R.localize)(1,null,ae.toFixed(0)):ae<te.MB?(0,R.localize)(2,null,(ae/te.KB).toFixed(2)):ae<te.GB?(0,R.localize)(3,null,(ae/te.MB).toFixed(2)):ae<te.TB?(0,R.localize)(4,null,(ae/te.GB).toFixed(2)):(0,R.localize)(5,null,(ae/te.TB).toFixed(2))}}e.$1k=te;function oe(ee){const ae=typeof ee=="string"||ee?.scheme===P.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===P.Schemas.file?1024*te.MB:ae?10*te.MB:g.$o?50*te.MB:1024*te.MB}e.$2k=oe});var K=this&&this.__param||function(se,e){return function(O,A){e(O,A,se)}};define(le[190],he([0,1,73,47,11]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=void 0;let L=class{constructor(R){this.a=R}async checksum(R){const S=(await this.a.readFileStream(R)).value;return new Promise((g,P)=>{const k=(0,O.createHash)("sha256");(0,A.$ce)(S,{onData:m=>k.update(m.buffer),onError:m=>P(m),onEnd:()=>g(k.digest("base64").replace(/=+$/,""))})})}};e.$Z_b=L,e.$Z_b=L=pe([K(0,D.$sk)],L)}),define(le[98],he([0,1,14,7,161,11]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;async function I(P,k,m,h,$,p){let E;try{await R(P,k,m,h,$,p)}catch(l){E=l}finally{E&&$.errorTransformer&&(E=$.errorTransformer(E)),typeof E<"u"&&m.error(E),m.end()}}e.$dq=I;async function R(P,k,m,h,$,p){S(p);const E=await P.open(k,{create:!1});try{S(p);let l=0,u=0,d=$&&typeof $.length=="number"?$.length:void 0,c=O.$ke.alloc(Math.min($.bufferSize,typeof d=="number"?d:$.bufferSize)),y=$&&typeof $.position=="number"?$.position:0,i=0;do u=await P.read(E,y,c.buffer,i,c.byteLength-i),y+=u,i+=u,l+=u,typeof d=="number"&&(d-=u),i===c.byteLength&&(await m.write(h(c)),c=O.$ke.alloc(Math.min($.bufferSize,typeof d=="number"?d:$.bufferSize)),i=0);while(u>0&&(typeof d!="number"||d>0)&&S(p)&&g(l,$));if(i>0){let o=i;typeof d=="number"&&(o=Math.min(i,d)),m.write(h(c.slice(0,o)))}}catch(l){throw(0,L.$Gk)(l)}finally{await P.close(E)}}function S(P){if(P.isCancellationRequested)throw(0,A.$6)();return!0}function g(P,k){if(typeof k?.limits?.size=="number"&&P>k.limits.size)throw(0,L.$Fk)((0,D.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[50],he([0,1,91,2,16,5,9,11]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=void 0;function S(l){return l.recursive===!0}e.$fq=S;class g extends A.$Tc{static{this.a=5}constructor(u,d,c,y){super(),this.h=u,this.j=d,this.m=c,this.n=y,this.c=this.B(new A.$Uc),this.f=void 0,this.g=0}s(){const u=new A.$Sc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(d=>this.h(d))),u.add(this.b.onDidLogMessage(d=>this.j(d))),u.add(this.b.onDidError(d=>this.t(d)))}t(u){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$gq=g;class P extends g{constructor(u,d,c){super(u,d,c,{type:"node.js",restartOnError:!1})}}e.$hq=P;class k extends g{constructor(u,d,c){super(u,d,c,{type:"universal",restartOnError:!0})}}e.$iq=k;function m(l){return l.map(u=>({type:u.type,resource:I.URI.revive(u.resource),cId:u.cId}))}e.$jq=m;function h(l){const u=new E;for(const d of l)u.processEvent(d);return u.coalesce()}e.$kq=h;function $(l,u){return typeof u=="string"&&!u.startsWith(O.$Kj)&&!(0,D.$ic)(u)?{base:l,pattern:u}:u}e.$lq=$;function p(l,u){const d=[];for(const c of u)d.push((0,O.$Oj)($(l,c)));return d}e.$mq=p;class E{constructor(){this.a=new Set,this.b=new Map}c(u){return L.$k?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const d=this.b.get(this.c(u));let c=!1;if(d){const y=d.type,i=u.type;d.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?c=!0:y===1&&i===2?(this.b.delete(this.c(u)),this.a.delete(d)):y===2&&i===1?d.type=0:y===1&&i===0||(d.type=i)}else c=!0;c&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],d=[];return Array.from(this.a).filter(c=>c.type!==2?(u.push(c),!1):!0).sort((c,y)=>c.resource.fsPath.length-y.resource.fsPath.length).filter(c=>d.some(y=>(0,R.$Mk)(c.resource.fsPath,y,!L.$k))?!1:(d.push(c.resource.fsPath),!0)).concat(u)}}}),define(le[191],he([0,1,14,38,7,3,2,47,32,11,50]),function(se,e,O,A,D,L,I,R,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=void 0,e.$FO="localFilesystem";class k extends I.$Tc{constructor(h,$){super(),this.a=h,this.b=$,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$Wd),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$Wd),this.onDidWatchError=this.g.event,this.h=(0,S.$rg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,$){const{buffer:p}=await this.a.call("readFile",[h,$]);return p}readFileStream(h,$,p){const E=(0,R.$$d)(u=>O.$ke.concat(u.map(d=>O.$ke.wrap(d))).buffer),l=new I.$Sc;return l.add(this.a.listen("readFileStream",[h,$])(u=>{if(u instanceof O.$ke)E.write(u.buffer);else{if(u==="end")E.end();else{let d;if(u instanceof Error)d=u;else{const c=u;d=(0,g.$Fk)(c.message??(0,A.$Si)(c),c.code??g.FileSystemProviderErrorCode.Unknown)}E.error(d),E.end()}l.dispose()}})),l.add(p.onCancellationRequested(()=>{E.error((0,D.$6)()),E.end(),l.dispose()})),E}writeFile(h,$,p){return this.a.call("writeFile",[h,O.$ke.wrap($),p])}open(h,$){return this.a.call("open",[h,$])}close(h){return this.a.call("close",[h])}async read(h,$,p,E,l){const[u,d]=await this.a.call("read",[h,$,l]);return p.set(u.buffer.slice(0,d),E),d}write(h,$,p,E,l){return this.a.call("write",[h,$,O.$ke.wrap(p),E,l])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,$){return this.a.call("delete",[h,$])}rename(h,$,p){return this.a.call("rename",[h,$,p])}copy(h,$,p){return this.a.call("copy",[h,$,p])}cloneFile(h,$){return this.a.call("cloneFile",[h,$])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const $=h;this.f.fire((0,P.$jq)($))}else{const $=h;this.g.fire($)}}))}watch(h,$){const p=(0,S.$rg)();return this.a.call("watch",[this.h,p,h,$]),(0,I.$Rc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$GO=k}),define(le[192],he([0,1,54,6,26,49,2,88,16,5,20,9,144,31,50]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0;class p extends I.$Tc{static{this.a=100}static{this.b=75}constructor(u,d,c,y){super(),this.m=u,this.n=d,this.r=c,this.s=y,this.c=this.B(new A.$kh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new A.$jh(i=>this.z(i),p.b)),this.g=(0,$.$mq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$mq)(this.m.path,this.m.includes):void 0,this.j=new D.$7d,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const d=await h.Promises.stat(u);this.B(await this.w(u,d.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let d=u.path;try{d=await h.Promises.realpath(u.path),u.path===d&&(d=await(0,m.$wq)(u.path)??u.path),u.path!==d&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${d})`)}catch{}return d}async w(u,d){if(g.$j&&(0,L.$9f)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.$Tc.None;const c=new D.$7d(this.j.token),y=new I.$Sc;try{const i=k.URI.file(this.m.path),o=(0,S.$nc)(u),n=(0,O.watch)(u);y.add((0,I.$Rc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${u}'`);const s=new Set;if(d)try{for(const r of await h.Promises.readdir(u))s.add(r)}catch(r){this.D(r)}const t=new Map;y.add((0,I.$Rc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(c.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let v="";if(a&&(v=a.toString(),g.$j&&(v=(0,R.$Il)(v))),!(!v||r!=="change"&&r!=="rename"))if(d)if(r==="rename"){t.get(v)?.dispose();const w=setTimeout(async()=>{if(t.delete(v),v===o&&!await h.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,S.$jc)(u,v));if(c.token.isCancellationRequested)return;let b;f?s.has(v)?b=0:(b=1,s.add(v)):(s.delete(v),b=2),this.y({resource:(0,P.$Ig)(i,v),type:b,cId:this.m.correlationId})},p.a);t.set(v,(0,I.$Rc)(()=>clearTimeout(w)))}else{let w;s.has(v)?w=0:(w=1,s.add(v)),this.y({resource:(0,P.$Ig)(i,v),type:w,cId:this.m.correlationId})}else if(r==="rename"||v!==o){const w=setTimeout(async()=>{const f=await h.Promises.exists(u);c.token.isCancellationRequested||(f?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),y.add(await this.w(u,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);y.clear(),y.add((0,I.$Rc)(()=>clearTimeout(w)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await h.Promises.exists(u)&&!c.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${i.toString()})`)}return(0,I.$Rc)(()=>{c.dispose(!0),y.dispose()})}y(u,d=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!d&&this.g.some(c=>c(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!d&&this.h&&this.h.length>0&&!this.h.some(c=>c(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const d=(0,$.$kq)(u);if(d.length>0){if(this.s)for(const y of d)this.G(` >> normalized ${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`);this.c.work(d)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(g.$k)return h.Promises.exists(u);try{const d=(0,S.$nc)(u);return(await h.Promises.readdir((0,S.$mc)(u))).some(y=>y===d)}catch(d){return this.G(d),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$zq=p;async function E(l,u,d,c,y=512){const i=await h.Promises.open(l,"r"),o=Buffer.allocUnsafe(y),n=new D.$7d(c);let s,t=!1;const r={path:l,excludes:[],recursive:!1},a=new p(r,v=>{(async()=>{for(const{type:w}of v)if(w===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:f}=await h.Promises.read(i,o,0,y,null);if(!f||n.token.isCancellationRequested)break;u(o.slice(0,f))}}catch(f){s=new Error(f),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,d(),new Promise((v,w)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await h.Promises.close(i)}catch(f){s=new Error(f)}s?w(s):v()})})}e.$Aq=E}),define(le[193],he([0,1,3,91,2,5,192]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class R extends D.$Tc{constructor(){super(...arguments),this.a=this.B(new O.$Wd),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$Wd),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(g){const P=this.j(g),k=P.filter(h=>{const $=this.c.get(h.path);return $?!(0,A.$Sj)($.request.excludes,h.excludes)||!(0,A.$Sj)($.request.includes,h.includes):!0}),m=Array.from(this.c.values()).filter(({request:h})=>!P.find($=>$.path===h.path&&(0,A.$Sj)($.excludes,h.excludes)&&(0,A.$Sj)($.includes,h.includes))).map(({request:h})=>h.path);k.length&&this.m(`Request to start watching: ${k.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const h of m)this.h(h);for(const h of k)this.g(h)}g(g){const P=new I.$zq(g,m=>this.a.fire(m),m=>this.b.fire(m),this.f),k={request:g,instance:P};this.c.set(g.path,k)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const P=this.c.get(g);P&&(this.c.delete(g),P.instance.dispose())}j(g){const P=new Map;for(const k of g){const m=L.$k?k.path:k.path.toLowerCase();let h=P.get(k.correlationId);h||(h=new Map,P.set(k.correlationId,h)),h.set(m,k)}return Array.from(P.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,P]of this.c)P.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,P){return P?`[File Watcher (node.js)] ${g} (path: ${P.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$Bq=R}),define(le[194],he([0,1,50,193]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class D extends O.$hq{constructor(I,R,S){super(I,R,S),this.s()}r(I){return I.add(new A.$Bq)}}e.$Cq=D}),define(le[195],he([0,1,23,40,93,50]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;class I extends L.$iq{constructor(S,g,P){super(S,g,P),this.s()}r(S){const g=S.add(new D.$tq(O.$pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(g.onDidProcessExit(({code:P,signal:k})=>this.t(`terminated by itself with code ${P}, signal: ${k}`))),A.ProxyChannel.toService((0,A.$Oh)(g.getChannel("watcher")))}}e.$uq=I}),define(le[74],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=void 0;class O{constructor(...D){this.a=new Map;for(const[L,I]of D)this.set(L,I)}set(D,L){const I=this.a.get(D);return this.a.set(D,L),I}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$6h=O}),define(le[196],he([0,1,6,7,2,72,187,4,74,87]),function(se,e,O,A,D,L,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const P=!1;class k extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class m{constructor(E=new S.$6h,l=!1,u,d=P){this.f=E,this.g=l,this.h=u,this.i=d,this.o=new Set,this.f.set(R.$7h,this),this._globalGraph=d?u?._globalGraph??new I.$Fq(c=>c):void 0}createChild(E){return new m(E,this.g,this,this.i)}invokeFunction(E,...l){const u=$.traceInvocation(this.i,E);let d=!1;try{return E({get:y=>{if(d)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(y,u);if(!i)throw new Error(`[invokeFunction] unknown service '${y}'`);return i}},...l)}finally{d=!0,u.stop()}}createInstance(E,...l){let u,d;return E instanceof L.$5h?(u=$.traceCreation(this.i,E.ctor),d=this.j(E.ctor,E.staticArguments.concat(l),u)):(u=$.traceCreation(this.i,E),d=this.j(E,l,u)),u.stop(),d}j(E,l=[],u){const d=R._util.getServiceDependencies(E).sort((i,o)=>i.index-o.index),c=[];for(const i of d){const o=this.m(i.id,u);o||this.u(`[createInstance] ${E.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const y=d.length>0?d[0].index:l.length;if(l.length!==y){console.trace(`[createInstance] First service dependency of ${E.name} at position ${y+1} conflicts with ${l.length} static arguments`);const i=y-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,y)}return Reflect.construct(E,l.concat(c))}k(E,l){if(this.f.get(E)instanceof L.$5h)this.f.set(E,l);else if(this.h)this.h.k(E,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(E){const l=this.f.get(E);return!l&&this.h?this.h.l(E):l}m(E,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const u=this.l(E);return u instanceof L.$5h?this.q(E,u,l.branch(E,!0)):(l.branch(E,!1),u)}q(E,l,u){if(this.o.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.o.add(E);try{return this.r(E,l,u)}finally{this.o.delete(E)}}r(E,l,u){const d=new I.$Fq(i=>i.id.toString());let c=0;const y=[{id:E,desc:l,_trace:u}];for(;y.length;){const i=y.pop();if(d.lookupOrInsertNode(i),c++>1e3)throw new k(d);for(const o of R._util.getServiceDependencies(i.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${E} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof L.$5h){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};d.insertEdge(i,s),y.push(s)}}}for(;;){const i=d.roots();if(i.length===0){if(!d.isEmpty())throw new k(d);break}for(const{data:o}of i){if(this.l(o.id)instanceof L.$5h){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}d.removeNode(o)}}return this.l(E)}s(E,l,u=[],d,c){if(this.f.get(E)instanceof L.$5h)return this.t(E,l,u,d,c);if(this.h)return this.h.s(E,l,u,d,c);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(E,l,u=[],d,c){if(d){const y=new m(void 0,this.g,this,this.i);y.c=String(E);const i=new Map,o=new O.$oh(()=>{const n=y.j(l,u,c);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)a.disposable=r.apply(n,a.listener)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new g.$4c,i.set(s,a)),(w,f,b)=>{if(o.isInitialized)return o.value[s](w,f,b);{const C={listener:[w,f,b],disposable:void 0},N=a.push(C);return(0,D.$Rc)(()=>{N(),C.disposable?.dispose()})}}}if(s in n)return n[s];const t=o.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return o.value[s]=t,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,u,c)}u(E,l){if(l&&console.warn(E),this.g)throw new Error(E)}}e.$Gq=m;var h;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(h||(h={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(E,l){return E?new $(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(E,l){return E?new $(1,l.name):$.c}static{this.f=0}constructor(E,l){this.type=E,this.name=l,this.g=Date.now(),this.h=[]}branch(E,l){const u=new $(3,E.toString());return this.h.push([E,l,u]),u}stop(){const E=Date.now()-this.g;$.f+=E;let l=!1;function u(c,y){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of y.h)if(s&&t){l=!0,i.push(`${o}CREATES -> ${n}`);const r=u(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(E>2||l)&&$.all.add(d.join(`
`))}}e.$Hq=$}),define(le[56],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=e.$u_b=void 0,e.$u_b=(0,O.$8h)("mainProcessService");class A{constructor(L,I){this.a=L,this.b=I}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,I){this.a.registerChannel(L,I)}}e.$v_b=A}),define(le[75],he([0,1,26,2,5,163,29,4]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.$ir=void 0;function S(P){return P.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}e.$ir=S,e.$jr=(0,R.$8h)("languagePackService");let g=class extends A.$Tc{constructor(k){super(),this.c=k}async getAvailableLanguages(){const k=new O.$7d;setTimeout(()=>k.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},k.token)}catch{return[]}const $=m.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(E=>E.startsWith("lp-"))).map(p=>{const E=p.properties.localizedLanguages?.[0],l=S(p);return{...this.f(l,E,p),extensionId:p.identifier.id,galleryExtension:p}});return $.push(this.f("en","English")),$}f(k,m,h){const $=m??k;let p;if($!==k&&(p=`(${k})`),k.toLowerCase()===D.$w.toLowerCase()&&(p??="",p+=(0,L.localize)(0,null)),h?.installCount){p??="";const E=h.installCount;let l;E>1e6?l=`${Math.floor(E/1e5)/10}M`:E>1e3?l=`${Math.floor(E/1e3)}K`:l=String(E),p+=` $(cloud-download) ${l}`}return{id:k,label:$,description:p}}};e.$kr=g,e.$kr=g=pe([K(0,I.$Bo)],g)}),define(le[197],he([0,1,2,75]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=void 0;let D=class extends O.$Tc{constructor(I){super(),this.a=I,this.b()}b(){this.a.update()}};e.$V_b=D,e.$V_b=D=pe([K(0,A.$jr)],D)}),define(le[8],he([0,1,38,3,53,2,35,5,20,12,9,94,4]),function(se,e,O,A,D,L,I,R,S,g,P,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.log=e.$sj=e.LogLevel=e.$rj=e.$qj=e.$pj=void 0,e.$pj=(0,m.$8h)("logService"),e.$qj=(0,m.$8h)("loggerService");function h(){return new Date().toISOString()}function $(w){return(0,g.$Nf)(w)}e.$rj=$;var p;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$sj=p.Info;function E(w,f,b){switch(f){case p.Trace:w.trace(b);break;case p.Debug:w.debug(b);break;case p.Info:w.info(b);break;case p.Warning:w.warn(b);break;case p.Error:w.error(b);break;case p.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=E;function l(w,f=!1){let b="";for(let C=0;C<w.length;C++){let N=w[C];if(N instanceof Error&&(N=(0,O.$Si)(N,f)),typeof N=="object")try{N=JSON.stringify(N)}catch{}b+=(C>0?" ":"")+N}return b}class u extends L.$Tc{constructor(){super(...arguments),this.b=e.$sj,this.c=this.B(new A.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==p.Off&&this.b<=f}}e.$uj=u;class d extends u{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...b){this.f(p.Trace)&&this.g(p.Trace,l([f,...b],!0))}debug(f,...b){this.f(p.Debug)&&this.g(p.Debug,l([f,...b]))}info(f,...b){this.f(p.Info)&&this.g(p.Info,l([f,...b]))}warn(f,...b){this.f(p.Warning)&&this.g(p.Warning,l([f,...b]))}error(f,...b){if(this.f(p.Error))if(f instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=f.stack,this.g(p.Error,l(C))}else this.g(p.Error,l([f,...b]))}flush(){}}e.$vj=d;class c extends u{constructor(f=e.$sj){super(),this.setLevel(f),this.g=!R.$i}trace(f,...b){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,f,...b):console.log(`[main ${h()}]`,f,...b))}debug(f,...b){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,f,...b):console.log(`[main ${h()}]`,f,...b))}info(f,...b){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,f,...b):console.log(`[main ${h()}]`,f,...b))}warn(f,...b){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,f,...b):console.warn(`[main ${h()}]`,f,...b))}error(f,...b){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,f,...b):console.error(`[main ${h()}]`,f,...b))}flush(){}}e.$wj=c;class y extends u{constructor(f=e.$sj,b=!0){super(),this.g=b,this.setLevel(f)}trace(f,...b){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...b):console.log(f,...b))}debug(f,...b){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...b):console.log(f,...b))}info(f,...b){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...b):console.log(f,...b))}warn(f,...b){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...b):console.log(f,...b))}error(f,...b){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...b):console.error(f,...b))}flush(){}}e.$xj=y;class i extends u{constructor(f,b=e.$sj){super(),this.g=f,this.setLevel(b)}trace(f,...b){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(f),...b])}debug(f,...b){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(f),...b])}info(f,...b){this.f(p.Info)&&this.g.log(p.Info,[this.h(f),...b])}warn(f,...b){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(f),...b])}error(f,...b){this.f(p.Error)&&this.g.log(p.Error,[this.h(f),...b])}h(f){return typeof f=="string"?f:(0,O.$Si)(f,this.f(p.Trace))}flush(){}}e.$yj=i;class o extends u{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const b of this.g)b.setLevel(f);super.setLevel(f)}trace(f,...b){for(const C of this.g)C.trace(f,...b)}debug(f,...b){for(const C of this.g)C.debug(f,...b)}info(f,...b){for(const C of this.g)C.info(f,...b)}warn(f,...b){for(const C of this.g)C.warn(f,...b)}error(f,...b){for(const C of this.g)C.error(f,...b)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose();super.dispose()}}e.$zj=o;class n extends L.$Tc{constructor(f,b,C){if(super(),this.h=f,this.j=b,this.b=new I.$Ac,this.c=this.B(new A.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$Wd),this.onDidChangeVisibility=this.g.event,C)for(const N of C)this.b.set(N.resource,{logger:void 0,info:N})}m(f){return(0,g.$Jf)(f)?[...this.b.values()].find(b=>b.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,b){const C=this.n(f),N=(0,g.$Jf)(f)?f:b?.id??(0,D.$Vi)(C.toString()).toString(16);let T=this.b.get(C)?.logger;const M=b?.logLevel==="always"?p.Trace:b?.logLevel;T||(T=this.s(C,M??this.getLogLevel(C)??this.h,{...b,id:N}));const q={logger:T,info:{resource:C,id:N,logLevel:M,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(q.info),this.b.set(C,q),T}n(f){return(0,g.$Jf)(f)?(0,S.$Ig)(this.j,`${f}.log`):f}setLogLevel(f,b){if(P.URI.isUri(f)){const C=f,N=b,T=this.b.get(C);T&&N!==T.info.logLevel&&(T.info.logLevel=N===this.h?void 0:N,T.logger?.setLevel(N),this.b.set(T.info.resource,T),this.f.fire([C,N]))}else{this.h=f;for(const[C,N]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,b){const C=this.m(f);C&&b!==!C.info.hidden&&(C.info.hidden=!b,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,b]))}getLogLevel(f){let b;return f&&(b=this.b.get(f)?.info.logLevel),b??this.h}registerLogger(f){const b=this.b.get(f.resource);b?b.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const b=this.b.get(f);b&&(b.logger&&b.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Aj=n;class s{constructor(){this.onDidChangeLogLevel=new A.$Wd().event}setLevel(f){}getLevel(){return p.Info}trace(f,...b){}debug(f,...b){}info(f,...b){}warn(f,...b){}error(f,...b){}critical(f,...b){}dispose(){}flush(){}}e.$Bj=s;class t extends s{}e.$Cj=t;function r(w){if(w.verbose)return p.Trace;if(typeof w.logLevel=="string"){const f=v(w.logLevel.toLowerCase());if(f!==void 0)return f}return e.$sj}e.$Dj=r;function a(w){switch(w){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$Ej=a;function v(w){switch(w){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$Fj=v,e.$Gj=new k.$mj("logLevel",a(p.Info))}),define(le[198],he([0,1,6,7,2,23,16,20,31,15,8]),function(se,e,O,A,D,L,I,R,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W_b=void 0;let k=class extends D.$Tc{constructor(h,$){super(),this.a=h,this.b=$,this.B(new O.$hh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const h=(0,R.$Fg)(this.a.logsHome),$=(0,R.$Hg)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,l=(await S.Promises.readdir($)).filter(d=>/^\d{8}T\d{6}$/.test(d)).sort().filter(d=>d!==h),u=l.slice(0,Math.max(0,l.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(d=>S.Promises.rm((0,I.$jc)($,d)))))}catch(h){(0,A.$1)(h)}}};e.$W_b=k,e.$W_b=k=pe([K(0,g.$ci),K(1,P.$pj)],k)}),define(le[99],he([0,1,7,4,8]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=void 0,e.$Hp=(0,A.$8h)("IExtensionSignatureVerificationService");let L=class{constructor(R){this.b=R}c(){return this.a||(this.a=new Promise((R,S)=>se(["node-vsce-sign"],async g=>R(g),S))),this.a}async verify(R,S,g){let P;try{P=await this.c()}catch(k){return this.b.error("Could not load vsce-sign module",(0,O.$0)(k)),!1}return P.verify(R,S,g)}};e.$Ip=L,e.$Ip=L=pe([K(0,D.$pj)],L)}),define(le[199],he([0,1,17,6,7,3,2,16,50,8]),function(se,e,O,A,D,L,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class P extends I.$Tc{constructor(m,h){super(),this.a=m,this.b=h,this.c=this.B(new L.$Wd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Wd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$6g(0)),this.w=[],this.y=this.B(new A.$6g(0))}watch(m,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n(m,h):this.z(m,h)}n(m,h){const $={path:this.H(m),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},p=(0,O.$Ub)(this.j,$);return this.r(),(0,I.$Rc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,D.$1)(m))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,S.$jq)(h)),h=>this.G(h),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const h of this.j)(0,S.$fq)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const h of this.j)(0,S.$fq)(h)&&m.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,h){const $={path:this.H(m),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},p=(0,O.$Ub)(this.w,$);return this.C(),(0,I.$Rc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,D.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,S.$jq)(m)),m=>this.G(m),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,R.$hc)(m.fsPath)}}e.$nq=P}),define(le[200],he([0,1,17,6,14,26,3,53,61,2,48,23,100,20,47,159,11,98,8,7]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;let y=class extends g.$Tc{static{c=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new I.$Wd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$Wd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$Wd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new I.$Wd),this.onDidRunOperation=this.r.event,this.X=this.B(new I.$Wd),this.Y=this.B(new I.$Wd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new I.$Wd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$eh)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const s=new g.$Sc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new E.$Lk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,g.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,g.$Oc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await A.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return S.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,h.$Mg)(o))throw new E.$Nk((0,p.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new d.$bb;throw s.message=(0,p.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,E.$yk)(n)||(0,E.$vk)(n)||(0,E.$zk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,E.$yk)(n)||(0,E.$vk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,E.$Ik)(s)===E.FileSystemProviderErrorCode.FileNotFound?new E.$Nk((0,p.localize)(2,null,this.sb(o)),1):(0,E.$Gk)(s)}}async s(o,n){const s=await this.j(o),t=this.S(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,w=await s.stat(o);let f;return this.t(s,o,w,void 0,!!v,(b,C)=>(f||(f=P.$bi.forUris(()=>!t),f.set(o,!0),r&&f.fill(!0,r)),f.get(b.resource)||f.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&a?C===1:!1))}async t(o,n,s,t,r,a){const{providerExtUri:v}=this.R(o),w={resource:n,name:v.basename(n),isFile:(s.type&E.FileType.File)!==0,isDirectory:(s.type&E.FileType.Directory)!==0,isSymbolicLink:(s.type&E.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&E.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&E.FilePermission.Locked),etag:(0,E.$Yk)({mtime:s.mtime,size:s.size}),children:void 0};if(w.isDirectory&&a(w,t)){try{const f=await o.readdir(n),b=await A.Promises.settled(f.map(async([C,N])=>{try{const T=v.joinPath(n,C),M=r?await o.stat(T):{type:N};return await this.t(o,T,M,f.length,r,a)}catch(T){return this.b.trace(T),null}}));w.children=(0,O.$Hb)(b)}catch(f){this.b.trace(f),w.children=[]}return w}return w}async resolveAll(o){return A.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new E.$Nk((0,p.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=D.$ke.fromString(""),s){await this.u(o,s);const t=await this.writeFile(o,n);return this.r.fire(new E.$Kk(o,0,t)),t}async writeFile(o,n,s){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=s;if((0,E.$Bk)(t)&&!a?.atomic){const v=t.enforceAtomicWriteFile?.(o);v&&(a={...s,atomic:v})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let w;if((0,E.$vk)(t)&&!(n instanceof D.$ke))if((0,$.$9d)(n)){const f=await(0,$.$de)(n,3);f.ended?w=D.$ke.concat(f.buffer):w=f}else w=(0,$.$ae)(n,f=>D.$ke.concat(f),3);else w=n;!(0,E.$yk)(t)||(0,E.$vk)(t)&&w instanceof D.$ke||(0,E.$vk)(t)&&(0,E.$Bk)(t)&&a?.atomic?await this.hb(t,o,a,w):await this.db(t,o,a,w instanceof D.$ke?(0,D.$ve)(w):w),this.r.fire(new E.$Kk(o,4))}catch(v){throw new E.$Nk((0,p.localize)(4,null,this.sb(o),(0,E.$Gk)(v).toString()),(0,E.$Jk)(v),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(t)throw new Error((0,p.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&E.FileType.Directory)throw new E.$Nk((0,p.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==E.$Xk&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,E.$Yk)({mtime:s.mtime,size:a.size}))throw new E.$Nk((0,p.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.m(o);return n?.atomic?this.z(t,o,n,s):this.C(t,o,n,s)}async z(o,n,s,t){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const v=await this.C(o,n,s,t);r(v)}catch(v){a(v)}},this.R(o).providerExtUri)})}async C(o,n,s,t){const r=await this.D(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,D.$we)(r.value)}}async readFileStream(o,n,s){const t=await this.m(o);return this.D(t,o,n,s)}async D(o,n,s,t){const r=new L.$7d(t);let a=s;(0,E.$Ak)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const v=this.J(n,a).then(f=>f,f=>{throw r.dispose(!0),f});let w;try{return typeof a?.etag=="string"&&a.etag!==E.$Xk&&await v,a?.atomic&&(0,E.$Ak)(o)||!((0,E.$yk)(o)||(0,E.$zk)(o))||(0,E.$vk)(o)&&a?.preferUnbuffered?w=this.I(o,n,a):(0,E.$zk)(o)?w=this.G(o,n,r.token,a):w=this.H(o,n,r.token,a),w.on("end",()=>r.dispose()),w.on("error",()=>r.dispose()),{...await v,value:w}}catch(f){throw w&&await(0,$.$be)(w),this.F(f,n,a)}}F(o,n,s){const t=(0,p.localize)(11,null,this.sb(n),(0,E.$Gk)(o).toString());return o instanceof E.$Pk?new E.$Pk(t,o.stat,s):o instanceof E.$Ok?new E.$Ok(t,o.fileOperationResult,o.size,o.options):new E.$Nk(t,(0,E.$Jk)(o),s)}G(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,$.$he)(r,{data:a=>a instanceof D.$ke?a:D.$ke.wrap(a),error:a=>this.F(a,n,t)},a=>D.$ke.concat(a))}H(o,n,s,t=Object.create(null)){const r=(0,D.$Ae)();return(0,l.$dq)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},s),r}I(o,n,s){const t=(0,$.$$d)(r=>D.$ke.concat(r));return(async()=>{try{let r;s?.atomic&&(0,E.$Ak)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.L(n,r.byteLength,s),t.end(D.$ke.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new E.$Nk((0,p.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==E.$Xk&&n.etag===s.etag)throw new E.$Pk((0,p.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new E.$Ok((0,p.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!s),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$Kk(o,a==="move"?2:3,v)),v}async copy(o,n,s){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!s),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$Kk(o,a==="copy"?3:2,v)),v}async N(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:w}=await this.Q(o,n,s,t,r,a);if(v&&!w&&a&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,E.$wk)(o))await o.copy(n,t,{overwrite:a});else{const f=await this.resolve(n);f.isDirectory?await this.P(o,f,s,t):await this.O(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,t){if((0,E.$yk)(o)&&(0,E.$yk)(s))return this.jb(o,n,s,t);if((0,E.$yk)(o)&&(0,E.$vk)(s))return this.pb(o,n,s,t);if((0,E.$vk)(o)&&(0,E.$yk)(s))return this.nb(o,n,s,t);if((0,E.$vk)(o)&&(0,E.$vk)(s))return this.lb(o,n,s,t)}async P(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await A.Promises.settled(n.children.map(async r=>{const a=this.R(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),s,a):this.O(o,r.resource,s,a)}))}async Q(o,n,s,t,r,a){let v=!1;if(o===s){const{providerExtUri:f,isPathCaseSensitive:b}=this.R(o);if(b||(v=f.isEqual(n,t)),v&&r==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&f.isEqualOrParent(t,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(t)))}const w=await this.exists(t);if(w&&!v){if(!a)throw new E.$Nk((0,p.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===s){const{providerExtUri:f}=this.R(o);if(f.isEqualOrParent(n,t))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:w,isSameResourceWithDifferentPathCase:v}}R(o){const n=this.S(o);return{providerExtUri:n?h.$yg:h.$Ag,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new E.$Kk(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&E.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(r){if((0,E.$Ik)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,E.$Ik)(a)!==E.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,p.localize)(22,null,this.sb(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.rb(o,a);else throw new E.$Nk((0,p.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const w=await this.resolve(o);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let t=n;if((0,E.$Ck)(s)&&!t?.atomic){const w=s.enforceAtomicDelete?.(o);w&&(t={...n,atomic:w})}const r=!!t?.useTrash,a=!!t?.recursive,v=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:v}),this.r.fire(new E.$Kk(o,1))}async cloneFile(o,n){const s=await this.j(o),t=this.qb(await this.n(n),n);if(!(s===t&&this.R(s).providerExtUri.isEqual(o,n)))return s===t&&(0,E.$xk)(s)?s.cloneFile(o,n):(await this.U(t,this.R(t).providerExtUri.dirname(n)),s===t&&(0,E.$wk)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,t,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new g.$Sc;let t=!1,r=()=>{t=!0};s.add((0,g.$Rc)(()=>r())),(async()=>{try{const v=await this.bb(o,n);t?(0,g.$Oc)(v):r=()=>(0,g.$Oc)(v)}catch(v){this.b.error(v)}})();const a=n.correlationId;if(typeof a=="number"){const v=s.add(new I.$Wd);return s.add(this.X.event(f=>{f.correlates(a)&&v.fire(f)})),{onDidChange:v.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),t=(0,R.$Vi)([this.R(s).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,g.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Oc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,g.$Oc)(o.disposable);this.$.clear()}async db(o,n,s,t){return this.cb.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,$.$9d)(t)||(0,$.$0d)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,E.$Gk)(a)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,n,s){let t=0,r;if((0,$.$0d)(s)){if(s.buffer.length>0){const a=D.$ke.concat(s.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,v)=>{(0,$.$ce)(r,{onData:async w=>{r.pause();try{await this.gb(o,n,w,w.byteLength,t,0)}catch(f){return v(f)}t+=w.byteLength,setTimeout(()=>r.resume())},onError:w=>v(w),onEnd:()=>a()})})}async fb(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,s,t,r,a){let v=0;for(;v<t;){const w=await o.write(n,r+v,s.buffer,a+v,t-v);v+=w}}async hb(o,n,s,t){return this.cb.queueFor(n,()=>this.ib(o,n,s,t),this.R(o).providerExtUri)}async ib(o,n,s,t){let r;t instanceof D.$ke?r=t:(0,$.$9d)(t)?r=await(0,D.$we)(t):(0,$.$0d)(t)?r=await(0,D.$xe)(t):r=(0,D.$ue)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,t){return this.cb.queueFor(t,()=>this.kb(o,n,s,t),this.R(s).providerExtUri)}async kb(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const v=D.$ke.alloc(this.a);let w=0,f=0,b=0;do b=await o.read(r,w,v.buffer,f,v.byteLength-f),await this.gb(s,a,v,b,w,f),w+=b,f+=b,f===v.byteLength&&(f=0);while(b>0)}catch(v){throw(0,E.$Gk)(v)}finally{await A.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(o,n,s,t){return this.cb.queueFor(t,()=>this.mb(o,n,s,t),this.R(s).providerExtUri)}async mb(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,t){return this.cb.queueFor(t,()=>this.ob(o,n,s,t),this.R(s).providerExtUri)}async ob(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(s,r,D.$ke.wrap(a),a.byteLength,0,0)}catch(a){throw(0,E.$Gk)(a)}finally{await s.close(r)}}async pb(o,n,s,t){const r=await(0,D.$we)(this.H(o,n,L.CancellationToken.None));await this.hb(s,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new E.$Nk((0,p.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&E.FilePermission.Readonly)throw new E.$Nk((0,p.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===k.Schemas.file?o.fsPath:o.toString(!0)}};e.$eq=y,e.$eq=y=c=pe([K(0,u.$pj)],y)}),define(le[201],he([0,1,54,270,6,35,14,3,49,2,16,5,20,47,31,162,11,98,199,38,195,194]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0,(()=>{try{(0,A.gracefulify)(O)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.$Si)(o)}`)}})();class i extends u.$nq{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.N=new L.$Ac(t=>m.$zg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,k.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:t}=await $.SymlinkSupport.stat(this.H(n));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:E.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await $.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,m.$Ig)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.fb(s)}}M(n,s){let t;return s?.dangling?t=E.FileType.Unknown:n.isFile()?t=E.FileType.File:n.isDirectory()?t=E.FileType.Directory:t=E.FileType.Unknown,s&&(t|=E.FileType.SymbolicLink),t}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new D.$7g;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,g.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await $.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){i.I&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,h.$$d)(a=>I.$ke.concat(a.map(v=>I.$ke.wrap(v))).buffer);return(0,l.$dq)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,m.$Ig)((0,m.$Hg)(n),`${(0,m.$Fg)(n)}${t.atomic.postfix}`),s,t):this.S(n,s,t)}async Q(n){try{const s=this.H(n),{symbolicLink:t}=await $.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async R(n,s,t,r){const a=new g.$Sc;try{a.add(await this.O(n)),a.add(await this.O(s)),await this.S(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(v){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{a.dispose()}}async S(n,s,t,r){let a;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await $.Promises.exists(v)){if(!t.overwrite)throw(0,E.$Fk)((0,p.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,E.$Fk)((0,p.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){i.Y=n}async open(n,s,t){const r=this.H(n);let a;(0,E.$tk)(s)&&!t&&(a=await this.O(n));let v;try{if((0,E.$tk)(s)&&s.unlock)try{const{stat:f}=await $.SymlinkSupport.stat(r);f.mode&128||await $.Promises.chmod(r,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let w;if((0,E.$tk)(s)){if(k.$i)try{await $.Promises.truncate(r,0),w="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}w||(w="w")}else w="r";v=await $.Promises.open(r,w)}catch(w){throw a?.dispose(),(0,E.$tk)(s)?await this.gb(n,w):this.fb(w)}if(this.U.set(v,0),(0,E.$tk)(s)&&this.X.set(v,n),a){const w=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,a),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),w.dispose())}return v}async close(n){const s=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&i.Y)try{await $.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await $.Promises.close(n)}catch(t){throw this.fb(t)}finally{s&&(this.W.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const v=this.Z(n,s);let w=null;try{w=(await $.Promises.read(n,t,r,a,v)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(n,v,w)}return w}Z(n,s){return s===this.U.get(n)?null:s}$(n,s,t){const r=this.U.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,s,t,r,a){return(0,D.$ph)(()=>this.ab(n,s,t,r,a),100,3)}async ab(n,s,t,r,a){const v=this.Z(n,s);let w=null;try{w=(await $.Promises.write(n,t,r,a,v)).bytesWritten}catch(f){throw await this.gb(this.X.get(n),f)}finally{this.$(n,v,w)}return w}async mkdir(n){try{await $.Promises.mkdir(this.H(n))}catch(s){throw this.fb(s)}}async delete(n,s){try{const t=this.H(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,P.$jc)((0,P.$mc)(t),`${(0,P.$nc)(t)}${s.atomic.postfix}`)),await $.Promises.rm(t,$.RimRafMode.MOVE,r)}else try{await $.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:w}=await $.SymlinkSupport.stat(t);a=v.isDirectory()&&!w}catch{}if(a)await $.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"move",t.overwrite),await $.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(a)),v.toString()))),this.fb(v)}}async copy(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"copy",t.overwrite),await $.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(a)),v.toString()))),this.fb(v)}}async bb(n,s,t,r){const a=this.H(n),v=this.H(s);let w=!1;if(!!(this.capabilities&1024)||(w=(0,S.$8f)(a,v,!0)),w){if(t==="copy")throw(0,E.$Fk)((0,p.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const b=await this.L(n);if(!b)throw(0,E.$Fk)((0,p.localize)(5,null),E.FileSystemProviderErrorCode.FileNotFound);const C=await this.L(s);if(C){if(!r)throw(0,E.$Fk)((0,p.localize)(6,null),E.FileSystemProviderErrorCode.FileExists);b.type&E.FileType.File&&C.type&E.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.cb(n,s,!1)}async cb(n,s,t){const r=this.H(n),a=this.H(s),v=!!(this.capabilities&1024);if((0,S.$8f)(r,a,!v))return;const w=new g.$Sc;try{w.add(await this.O(n)),w.add(await this.O(s)),t&&await $.Promises.mkdir((0,P.$mc)(a),{recursive:!0}),await $.Promises.copyFile(r,a)}catch(f){if(f.code==="ENOENT"&&!t)return this.cb(n,s,!0);throw this.fb(f)}finally{w.dispose()}}t(n,s,t){return new c.$uq(r=>n(r),r=>s(r),t)}F(n,s,t){return new y.$Cq(r=>n(r),r=>s(r),t)}fb(n){if(n instanceof E.$Ek)return n;let s=n,t;switch(n.code){case"ENOENT":t=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=E.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=E.FileSystemProviderErrorCode.Unknown;break;default:t=E.FileSystemProviderErrorCode.Unknown}return(0,E.$Fk)(s,t)}async gb(n,s){let t=this.fb(s);if(n&&t.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,E.$Fk)(s,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$Dq=i}),define(le[101],he([0,1,3,2,4,8]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=e.$jac=void 0,e.$jac=(0,D.$8h)("sharedProcessLifecycleService");let I=class extends A.$Tc{constructor(S){super(),this.b=S,this.a=this.B(new O.$Wd),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$kac=I,e.$kac=I=pe([K(0,L.$pj)],I)}),define(le[202],he([0,1,9,3,8,2]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=e.$Cr=void 0;class I extends D.$Aj{constructor(k,m,h,$,p){super(m,h,$),this.r=k,this.t=p,this.B(p.listen("onDidChangeLogLevel",k)(E=>{(0,D.$rj)(E)?super.setLogLevel(E):super.setLogLevel(O.URI.revive(E[0]),E[1])})),this.B(p.listen("onDidChangeVisibility",k)(([E,l])=>super.setVisibility(O.URI.revive(E),l))),this.B(p.listen("onDidChangeLoggers",k)(({added:E,removed:l})=>{for(const u of E)super.registerLogger({...u,resource:O.URI.revive(u.resource)});for(const u of l)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new D.$yj({log:(k,m)=>{this.t.call("consoleLog",[k,m])}})}registerLogger(k){super.registerLogger(k),this.t.call("registerLogger",[k,this.r])}deregisterLogger(k){super.deregisterLogger(k),this.t.call("deregisterLogger",[k,this.r])}setLogLevel(k,m){super.setLogLevel(k,m),this.t.call("setLogLevel",[k,m])}setVisibility(k,m){super.setVisibility(k,m),this.t.call("setVisibility",[this.n(k),m])}s(k,m,h){return new R(this.t,k,m,h,this.r)}static setLogLevel(k,m,h){return k.call("setLogLevel",[m,h])}}e.$Cr=I;class R extends D.$vj{constructor(k,m,h,$,p){super($?.logLevel==="always"),this.r=k,this.s=m,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[m,$,p]).then(()=>{this.u(this.n),this.m=!0})}g(k,m){const h=[[k,m]];this.m?this.u(h):this.n.push(...h)}u(k){this.r.call("log",[this.s,k])}}class S{constructor(k,m){this.a=k,this.b=m}listen(k,m){const h=this.b(k);switch(m){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(p=>this.c(p,h)),removed:[...$.removed].map(p=>this.c(p,h))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,$=>[h.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,$=>(0,D.$rj)($)?$:[h.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${m}`)}async call(k,m,h){const $=this.b(k);switch(m){case"setLogLevel":return(0,D.$rj)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(O.URI.revive($.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,$)))}throw new Error(`Call not found: ${m}`)}c(k,m){return{...k,resource:m.transformOutgoingURI(k.resource)}}}e.$Dr=S;class g extends L.$Tc{constructor(k,m){super(),m.call("setLogLevel",[k.getLogLevel()]),this.B(k.onDidChangeLogLevel(h=>m.call("setLogLevel",[h]))),m.call("getRegisteredLoggers").then(h=>{for(const $ of h)k.registerLogger({...$,resource:O.URI.revive($.resource)})}),this.B(m.listen("onDidChangeVisibility")(([h,$])=>k.setVisibility(O.URI.revive(h),$))),this.B(m.listen("onDidChangeLoggers")(({added:h,removed:$})=>{for(const p of h)k.registerLogger({...p,resource:O.URI.revive(p.resource)});for(const p of $)k.deregisterLogger(p.resource)}))}}e.$Er=g}),define(le[203],he([0,1,2,8]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=void 0;class D extends O.$Tc{constructor(I,R=[]){super(),this.a=new A.$zj([I,...R]),this.B(I.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...R){this.a.trace(I,...R)}debug(I,...R){this.a.debug(I,...R)}info(I,...R){this.a.info(I,...R)}warn(I,...R){this.a.warn(I,...R)}error(I,...R){this.a.error(I,...R)}flush(){this.a.flush()}}e.$XO=D}),define(le[57],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=void 0,e.$e$b=(0,O.$8h)("nativeHostService")}),define(le[204],he([0,1,40,56]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=void 0;let D=class{constructor(I,R){return this.windowId=I,O.ProxyChannel.toService(R.getChannel("nativeHost"),{context:I,properties:(()=>{const S=new Map;return S.set("windowId",I),S})()})}};e.$A_b=D,e.$A_b=D=pe([K(1,A.$u_b)],D)}),define(le[58],he([0,1,3,61,2,4]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=void 0,e.$Mn=(0,L.$8h)("policy");class I extends D.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$Wd),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const P=Object.keys(this.f).length;return this.f={...g,...this.f},P!==Object.keys(this.f).length&&await this.j(g),A.Iterable.reduce(this.g.entries(),(k,[m,h])=>({...k,[m]:h}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(g,[P,k])=>({...g,[P]:{definition:k,value:this.g.get(P)}}),{})}}e.$Nn=I;class R{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$On=R}),define(le[205],he([0,1,3,2,58]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=e.$3$b=void 0;class L{constructor(S){this.b=S,this.a=new A.$Sc}listen(S,g){switch(g){case"onDidChange":return O.Event.map(this.b.onDidChange,P=>P.reduce((k,m)=>({...k,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(S,g,P){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$3$b=L;class I extends D.$Nn{constructor(S,g){super(),this.a=g;for(const P in S){const{definition:k,value:m}=S[P];this.f[P]=k,m!==void 0&&this.g.set(P,m)}this.a.listen("onDidChange")(P=>{for(const k in P){const m=P[k];m===null?this.g.delete(k):this.g.set(k,m)}this.h.fire(Object.keys(P))})}async j(S){const g=await this.a.call("updatePolicyDefinitions",S);for(const P in g)this.g.set(P,g[P])}}e.$4$b=I}),define(le[102],he([0,1,37]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.context<"u"){const L=D.context.configuration();if(L)A=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:L.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(le[24],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=void 0,e.$Hj=(0,O.$8h)("productService"),e.$Ij="vscode://schemas/vscode-product"}),define(le[206],he([0,1,6,7,2,16,31,8,24]),function(se,e,O,A,D,L,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T_b=void 0;let g=class extends D.$Tc{constructor(k,m,h){super(),this.b=m,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,k&&this.B(new O.$hh(()=>{this.f(k)},3e4)).schedule()}async f(k){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),h=(0,L.$mc)(k),$=(0,L.$nc)(k),p=await I.Promises.readdir(h);await Promise.all(p.map(async E=>{if(E===$)return;const l=(0,L.$jc)(h,E),u=await I.Promises.stat(l);if(u.isDirectory()&&m-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${E}.`),I.Promises.rm(l)}))}catch(m){(0,A.$1)(m)}}};e.$T_b=g,e.$T_b=g=pe([K(1,S.$Hj),K(2,R.$pj)],g)}),define(le[207],he([0,1,6,7,2,16,31,15,8,24]),function(se,e,O,A,D,L,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U_b=void 0;let P=class extends D.$Tc{constructor(m,h,$){super(),this.b=m,this.c=h,this.f=$,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new O.$hh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),h=JSON.parse(await I.Promises.readFile((0,L.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(h)){const d=h[u];m[`${d.hash}.${u}`]=!0}const $=(0,L.$jc)(this.b.userDataPath,"clp");if(!await I.Promises.exists($))return;const E=await I.Promises.readdir($);for(const u of E){if(m[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await I.Promises.rm((0,L.$jc)($,u))}const l=Date.now();for(const u of Object.keys(m)){const d=(0,L.$jc)($,u),c=await I.Promises.readdir(d);for(const y of c){if(y==="tcf.json")continue;const i=(0,L.$jc)(d,y),o=await I.Promises.stat(i);o.isDirectory()&&l-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.$jc)(u,y)}`),await I.Promises.rm(i))}}}catch(m){(0,A.$1)(m)}}};e.$U_b=P,e.$U_b=P=pe([K(0,R.$di),K(1,S.$pj),K(2,g.$Hj)],P)}),define(le[208],he([0,1,16,4]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$rF=void 0,e.$rF=(0,A.$8h)("IV8InspectProfilingService");var D;(function(L){function I(S){return!!(S.samples&&S.timeDeltas)}L.isValidProfile=I;function R(S,g="noAbsolutePaths"){for(const P of S.nodes)P.callFrame&&P.callFrame.url&&((0,O.$ic)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,O.$jc)(g,(0,O.$nc)(P.callFrame.url)));return S}L.rewriteAbsolutePaths=R})(D||(e.Utils=D={}))}),define(le[209],he([0,1,32]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=void 0;class A{constructor(){this.a=new Map}async startProfiling(L){const R=await(await new Promise((g,P)=>{se(["v8-inspect-profiler"],g,P)})).startProfiling({port:L.port,checkForPaused:!0}),S=(0,O.$rg)();return this.a.set(S,R),S}async stopProfiling(L){const I=this.a.get(L);if(!I)throw new Error(`UNKNOWN session '${L}'`);const R=await I.stop();return this.a.delete(L),R.profile}}e.$__b=A}),define(le[41],he([0,1,127,12]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class D{constructor(){this.a=new Map}add(I,R){O.ok(A.$Jf(I)),O.ok(A.$Lf(R)),O.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,R)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$Kn=new D}),define(le[103],he([0,1,3,41]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this.b=new O.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,g){this.a[D(S)]=g,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const I=new L;A.$Kn.add(e.$Ln.JSONContribution,I)}),define(le[44],he([0,1,17,3,12,149,21,103,41]),function(se,e,O,A,D,L,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ConfigurationScope=e.$Pn=e.EditPresentationTypes=void 0;var g;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$Pn={Configuration:"base.contributions.configuration"};var P;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn="vscode://schemas/settings/resourceLanguage",e.$Xn="vscode://schemas/settings/configurationDefaults";const k=S.$Kn.as(R.$Ln.JSONContribution);class m{constructor(){this.h=new Set,this.i=new A.$Wd,this.onDidSchemaChange=this.i.event,this.j=new A.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Wn,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),k.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),k.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),k.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.$Zn.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(t)for(const C of Object.keys(s[r]))v.set(C,t);const w={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:w,valuesSources:v});const f=(0,I.$Li)(r),b={type:"object",default:w,description:L.localize(1,null,f),$ref:e.$Wn,defaultDefaultValue:w,source:D.$Jf(t)?void 0:t,defaultValueSource:t};n.push(...p(r)),this.d[r]=b,this.b.properties[r]=b}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=D.$Jf(s)?s:s?.id,v=D.$Jf(r?.source)?r?.source:r?.source?.id;if(a===v)if(o.add(t),this.a.delete(t),e.$Zn.test(t))delete this.d[t],delete this.b.properties[t];else{const w=this.d[t];w&&(this.w(t,w),this.r(t,w))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,n,s,t=3,r){t=D.$Sf(i.scope)?t:i.scope;const a=i.properties;if(a)for(const w in a){const f=a[w];if(o&&d(w,f)){delete a[w];continue}if(f.source=n,f.defaultDefaultValue=a[w].default,this.w(w,f),e.$Zn.test(w)?f.scope=void 0:(f.scope=D.$Sf(f.scope)?t:f.scope,f.restricted=D.$Sf(f.restricted)?!!s?.includes(w):f.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.f[w]=a[w],delete a[w];continue}else this.d[w]=a[w],a[w].policy?.name&&this.e.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),r.add(w)}const v=i.allOf;if(v)for(const w of v)this.p(w,o,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$Qn.properties[i]=o,o.scope){case 1:e.$Rn.properties[i]=o;break;case 2:e.$Sn.properties[i]=o;break;case 6:e.$Tn.properties[i]=o;break;case 3:e.$Un.properties[i]=o;break;case 4:e.$Vn.properties[i]=o;break;case 5:e.$Vn.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$Qn.properties[i],o.scope){case 1:delete e.$Rn.properties[i];break;case 2:delete e.$Sn.properties[i];break;case 6:delete e.$Tn.properties[i];break;case 3:delete e.$Un.properties[i];break;case 4:case 5:delete e.$Vn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$Wn};this.w(o,n),e.$Qn.properties[o]=n,e.$Rn.properties[o]=n,e.$Sn.properties[o]=n,e.$Tn.properties[o]=n,e.$Un.properties[o]=n,e.$Vn.properties[o]=n}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$Wn};e.$Qn.patternProperties[e.$Yn]=i,e.$Rn.patternProperties[e.$Yn]=i,e.$Sn.patternProperties[e.$Yn]=i,e.$Tn.patternProperties[e.$Yn]=i,e.$Un.patternProperties[e.$Yn]=i,e.$Vn.patternProperties[e.$Yn]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let s=n?.value,t=n?.source;D.$Qf(s)&&(s=o.defaultDefaultValue,t=void 0),D.$Qf(s)&&(s=l(o.type)),o.default=s,o.defaultValueSource=t}}const h="\\[([^\\]]+)\\]",$=new RegExp(h,"g");e.$Yn=`^(${h})+$`,e.$Zn=new RegExp(e.$Yn);function p(y){const i=[];if(e.$Zn.test(y)){let o=$.exec(y);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=$.exec(y)}}return(0,O.$Mb)(i)}e.$1n=p;function E(y){return y.reduce((i,o)=>`${i}[${o}]`,"")}e.$2n=E;function l(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$3n=l;const u=new m;S.$Kn.add(e.$Pn.Configuration,u);function d(y,i){return y.trim()?e.$Zn.test(y)?L.localize(7,null,y):u.getConfigurationProperties()[y]!==void 0?L.localize(8,null,y):i.policy?.name&&u.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,y,i.policy?.name,u.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$4n=d;function c(){const y=[],i=u.getConfigurationProperties();for(const o of Object.keys(i))y.push([o,i[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.$5n=c}),define(le[76],he([0,1,17,3,34,2,35,30,12,9,21,44,41]),function(se,e,O,A,D,L,I,R,S,g,P,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0;function h(o){return Object.isFrozen(o)?o:R.$zn(o)}class ${constructor(n={},s=[],t=[],r){this.b=n,this.c=s,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof $)return s;const t=new p("");return t.parseRaw(s),t.configurationModel});this.f=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.$Ji)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return h(t.rawConfiguration.getValue(n))},get override(){return s?h(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return h(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:v,keys:w}of t.rawConfiguration.overrides){const f=new $(a,w).getValue(n);f!==void 0&&r.push({identifiers:v,value:f})}return r.length?h(r):void 0}}}getOverrideValue(n,s){const t=this.i(s);return t?n?(0,P.$Ji)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return O.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return O.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=R.$yn(this.contents),t=R.$yn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of n)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(s,v.contents);for(const w of v.overrides){const[f]=t.filter(b=>O.$ub(b.identifiers,w.identifiers));f?(this.h(f.contents,w.contents),f.keys.push(...w.keys),f.keys=O.$Mb(f.keys)):t.push(R.$yn(w))}for(const w of v.keys)r.indexOf(w)===-1&&r.push(w)}return new $(s,r,t,a.every(v=>v instanceof $)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of O.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const v=s[r];v&&(typeof a=="object"&&typeof v=="object"?(a=R.$yn(a),this.h(a,v)):a=v),t[r]=a}return new $(t,this.keys,this.overrides)}h(n,s){for(const t of Object.keys(s)){if(t in n&&S.$Lf(n[t])&&S.$Lf(s[t])){this.h(n[t],s[t]);continue}n[t]=R.$yn(s[t])}}i(n){let s=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$yn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,P.$Ii)(this.contents,n),k.$Zn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>O.$ub(t.identifiers,(0,k.$1n)(n))),1))}j(n,s,t){(0,P.$Hi)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),k.$Zn.test(n)&&this.overrides.push({identifiers:(0,k.$1n)(n),keys:Object.keys(this.contents[n]),contents:(0,P.$Gi)(this.contents[n],r=>console.error(r))})}}e.$6n=$;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!S.$Sf(n)){const t=this.g(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:v,hasExcludedProperties:w}=this.h(n,s);this.b=new $(t,r,a,w?[n]:void 0),this.c=v||[]}g(n){let s={},t=null,r=[];const a=[],v=[];function w(b){Array.isArray(r)?r.push(b):t!==null&&(r[t]=b)}const f={onObjectBegin:()=>{const b={};w(b),a.push(r),r=b,t=null},onObjectProperty:b=>{t=b},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const b=[];w(b),a.push(r),r=b,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:w,onError:(b,C,N)=>{v.push({error:b,offset:C,length:N})}};if(n)try{D.$mn(n,f),s=r[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return s}h(n,s){const t=m.$Kn.as(k.$Pn.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,s);n=r.raw;const a=(0,P.$Gi)(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),v=Object.keys(n),w=this.j(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:a,keys:v,overrides:w,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const v={},w=[];for(const f in n)if(k.$Zn.test(f)&&t){const b=this.i(n[f],s,!1,r);v[f]=b.raw,a=a||b.hasExcludedProperties,w.push(...b.restricted)}else{const b=s[f],C=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&w.push(f),!r.exclude?.includes(f)&&(r.include?.includes(f)||(C===void 0||r.scopes===void 0||r.scopes.includes(C))&&!(r.skipRestricted&&b?.restricted))?v[f]=n[f]:a=!0}return{raw:v,restricted:w,hasExcludedProperties:a}}j(n,s){const t=[];for(const r of Object.keys(n))if(k.$Zn.test(r)){const a={};for(const v in n[r])a[v]=n[r][v];t.push({identifiers:(0,k.$1n)(r),keys:Object.keys(a),contents:(0,P.$Gi)(a,s)})}return t}}e.$7n=p;class E extends L.$Tc{constructor(n,s,t,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new A.$Wd),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$8n=E;class l{constructor(n,s,t,r,a,v,w,f,b,C,N,T,M){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=w,this.h=f,this.i=b,this.j=C,this.k=N,this.l=T,this.m=M}get value(){return h(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class u{constructor(n,s,t,r,a=new $,v=new $,w=new I.$Ac,f=new $,b=new I.$Ac){this.c=n,this.d=s,this.f=t,this.g=r,this.h=a,this.i=v,this.j=w,this.l=f,this.m=b,this.a=null,this.b=new I.$Ac,this.n=null}getValue(n,s,t){return this.p(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new $,this.m.set(t.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.a=null)}inspect(n,s,t){const r=this.p(n,s,t),a=this.t(s.resource,t),v=s.resource?this.m.get(s.resource)||this.l:this.l,w=new Set;for(const f of r.overrides)for(const b of f.identifiers)r.getOverrideValue(n,b)!==void 0&&w.add(b);return new l(n,s,r.getValue(n),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,v)}keys(n){const s=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:v}=y(this.c,n);s=[...r,...a,...v]}for(const r of s)for(const a of(0,k.$1n)(r)){const v=this.c.getKeysForOverrideIdentifier(a),w=n.getKeysForOverrideIdentifier(a),f=[...w.filter(b=>v.indexOf(b)===-1),...v.filter(b=>w.indexOf(b)===-1),...v.filter(b=>!R.$Cn(this.c.override(a).getValue(b),n.override(a).getValue(b)))];t.push([a,f])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=y(this.d,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=y(this.applicationConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=y(this.localUserConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=y(this.remoteUserConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=y(this.workspaceConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:v,overrides:w}=y(t,s),f=[...r,...a,...v];return(f.length||!t)&&this.updateFolderConfiguration(n,s),{keys:f,overrides:w}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:v}=y(s,void 0);return{keys:[...t,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,s,t){let r=this.q(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},s){let t=this.r();if(s&&n){const r=s.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let s=this.b.get(n);if(!s){const t=this.r(),r=this.j.get(n);r?(s=t.merge(r),this.b.set(n,s)):s=t}return s}t(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),v=this.w(n.workspace),w=n.folders.reduce((f,b)=>(f.set(g.URI.revive(b[0]),this.w(b[1])),f),new I.$Ac);return new u(s,t,r,a,new $,v,w,new $,new I.$Ac)}static w(n){return new $(n.contents,n.keys,n.overrides)}}e.$9n=u;function d(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,v])=>{const w=(0,I.$xc)(s,a,new Set);v.forEach(f=>w.add(f))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$0n=d;class c{constructor(n,s,t,r){this.change=n,this.f=s,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(s){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,f=this.g.getValue(n,s,this.h);return!R.$Cn(w,f)}return!0}}e.$$n=c;function y(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],v=o?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const f=w.filter(b=>!v.includes(b));for(const b of f)a.push([b,n.getKeysForOverrideIdentifier(b)])}if(o){const f=v.filter(b=>!w.includes(b));for(const b of f)a.push([b,o.getKeysForOverrideIdentifier(b)])}if(n&&o){for(const f of v)if(w.includes(f)){const b=i({contents:o.getOverrideValue(void 0,f)||{},keys:o.getKeysForOverrideIdentifier(f)},{contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)});a.push([f,[...b.added,...b.removed,...b.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const v=(0,P.$Ji)(n.contents,a),w=(0,P.$Ji)(o.contents,a);R.$Cn(v,w)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[210],he([0,1,17,3,2,30,12,76,44,8,58,41]),function(se,e,O,A,D,L,I,R,S,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=void 0;class m extends D.$Tc{constructor(){super(...arguments),this.a=this.B(new A.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new R.$6n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(k.$Kn.as(S.$Pn.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:l})=>this.c(Array.from(E),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(E,l){this.h(E,k.$Kn.as(S.$Pn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:E})}f(){return{}}g(){this.b=new R.$6n;const E=k.$Kn.as(S.$Pn.Configuration).getConfigurationProperties();this.h(Object.keys(E),E)}h(E,l){const u=this.f();for(const d of E){const c=u[d],y=l[d];c!==void 0?this.b.addValue(d,c):y?this.b.addValue(d,y.default):this.b.removeValue(d)}}}e.$_n=m;class h{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new R.$6n}async initialize(){return this.configurationModel}}e.$ao=h;let $=class extends D.$Tc{get configurationModel(){return this.b}constructor(E,l,u){super(),this.c=E,this.f=l,this.g=u,this.a=this.B(new A.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new R.$6n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(E=>this.j(E))),this.B(this.c.onDidChangeConfiguration(async({properties:E})=>this.m(await this.h(E),!0))),this.b}async h(E){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",E);const l={},u=[],d=k.$Kn.as(S.$Pn.Configuration).getConfigurationProperties();for(const c of E){const y=d[c];if(!y){u.push(c);continue}if(y.policy){if(y.type!=="string"&&y.type!=="number"){this.g.warn(`Policy ${y.policy.name} has unsupported type ${y.type}`);continue}u.push(c),l[y.policy.name]={type:y.type}}}return(0,I.$Wf)(l)||await this.f.updatePolicyDefinitions(l),u}j(E){this.g.trace("PolicyConfiguration#onDidChangePolicies",E);const l=k.$Kn.as(S.$Pn.Configuration).getPolicyConfigurations(),u=(0,O.$Hb)(E.map(d=>l.get(d)));this.m(u,!0)}m(E,l){this.g.trace("PolicyConfiguration#update",E);const u=k.$Kn.as(S.$Pn.Configuration).getConfigurationProperties(),d=[],c=this.b.isEmpty();for(const y of E){const i=u[y]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(c?o!==void 0:!(0,L.$Cn)(this.b.getValue(y),o))&&d.push([y,o])}else this.b.getValue(y)!==void 0&&d.push([y,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const y=this.b;this.b=new R.$6n;for(const i of y.keys)this.b.setValue(i,y.getValue(i));for(const[i,o]of d)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);l&&this.a.fire(this.b)}}};e.$bo=$,e.$bo=$=pe([K(1,P.$Mn),K(2,g.$pj)],$)}),define(le[211],he([0,1,17,6,14,3,34,62,2,30,5,20,21,76,44,210,58]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class l extends S.$Tc{constructor(c,y,i,o){super(),this.m=c,this.h=this.B(new L.$Wd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$_n),this.c=i instanceof E.$On?new p.$ao:this.B(new p.$bo(this.b,i,o)),this.f=this.B(new h.$8n(this.m,{},k.$zg,y)),this.a=new h.$9n(this.b.configurationModel,this.c.configurationModel,new h.$6n,new h.$6n),this.j=new u(c,y,this),this.g=this.B(new A.$hh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:s})=>this.r(n,s))),this.B(this.c.onDidChangeConfiguration(n=>this.s(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[c,y,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$9n(c,y,new h.$6n,i)}getConfigurationData(){return this.a.toData()}getValue(c,y){const i=typeof c=="string"?c:void 0,o=(0,m.$Ci)(c)?c:(0,m.$Ci)(y)?y:{};return this.a.getValue(i,o,void 0)}async updateValue(c,y,i,o,n){const s=(0,m.$Di)(i)?i:(0,m.$Ci)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${c} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,O.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(c,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${c} because it is configured in system policy.`);if((0,g.$Cn)(y,r.defaultValue)&&(y=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const v=s.overrideIdentifiers.sort(),w=this.a.localUserConfiguration.overrides.find(f=>(0,O.$ub)([...f.identifiers].sort(),v));w&&(s.overrideIdentifiers=w.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,$.$2n)(s.overrideIdentifiers),c]:[c];await this.j.write(a,y),await this.reloadConfiguration()}inspect(c,y={}){return this.a.inspect(c,y,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const c=await this.f.loadConfiguration();this.n(c)}n(c){const y=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(c);this.t(i,y,2)}r(c,y){const i=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(c,y);this.t(o,i,7)}s(c){const y=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(c);this.t(i,y,7)}t(c,y,i){const o=new h.$$n(c,{data:y},this.a);o.source=i,this.h.fire(o)}}e.$co=l;class u{constructor(c,y,i){this.b=c,this.c=y,this.d=i,this.a=new A.$ch}write(c,y){return this.a.queue(()=>this.e(c,y))}async e(c,y){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,I.$fn)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(i,c,y);i=(0,R.$xn)(i,n),await this.c.writeFile(this.b,D.$ke.fromString(i))}f(c,y,i){const{tabSize:o,insertSpaces:n,eol:s}=this.h;if(!y.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,R.$un)(c,y,i,{tabSize:o,insertSpaces:n,eol:s})}get h(){if(!this.g){let c=P.OS===3||P.OS===2?`
`:`\r
`;const y=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});y&&typeof y=="string"&&y!=="auto"&&(c=y),this.g={eol:c,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[212],he([0,1,14,3,2,68]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zsb=e.$ysb=e.$xsb=e.$wsb=void 0;const I=(g,P,k)=>{const m=new Uint8Array(16);for(let p=0;p<16;p++)m[p]=Math.round(Math.random()*256);const h=(0,O.$Ee)(O.$ke.wrap(m));return[`GET ws://localhost${g}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`].join(`\r
`)+`\r
\r
`};e.$wsb=I,e.$xsb=O.$ke.fromString(`\r
\r
`);async function R(g,P,k,m,h){g.write(O.$ke.fromString((0,e.$wsb)(P,k,m)));const $=new D.$Sc;try{return await new Promise((p,E)=>{let l;$.add(g.onData(u=>{l?l=O.$ke.concat([l,u],l.byteLength+u.byteLength):l=u;const d=l.indexOf(e.$xsb);if(d===-1)return;p(g),g.pauseData();const c=l.slice(d+e.$xsb.byteLength);c.byteLength&&h.onData.fire(c)})),$.add(g.onClose(u=>E(u??new Error("socket closed")))),$.add(g.onEnd(()=>E(new Error("socket ended"))))})}catch(p){throw g.dispose(),p}finally{$.dispose()}}e.$ysb=R;class S extends D.$Tc{constructor(P,k){super(),this.g=P,this.a=this.B(new A.$Zd),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new A.$Wd),this.onDidDispose=this.b.event,this.f=!1,this.B(k.onData),this.B(k.onData.event(m=>this.a.fire(m))),this.onClose=this.B(k.onClose).event,this.onEnd=this.B(k.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,k){L.SocketDiagnostics.traceSocketEvent(this,this.g,P,k)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$zsb=S}),define(le[213],he([0,1,7,4]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.RemoteAuthorityResolverErrorCode=e.$_k=e.$$k=e.RemoteConnectionType=e.$0k=void 0,e.$0k=(0,A.$8h)("remoteAuthorityResolverService");var D;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(D||(e.RemoteConnectionType=D={}));class L{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$$k=L;class I{constructor(k,m){this.host=k,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$_k=I;var R;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class S extends O.$bb{static isNotAvailable(k){return k instanceof S&&k._code===R.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof S&&k._code===R.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof S&&k._code===R.NoResolverFound}static isInvalidAuthority(k){return k instanceof S&&k._code===R.InvalidAuthority}static isHandled(k){return k instanceof S&&k.isHandled}constructor(k,m=R.Unknown,h){super(k),this._message=k,this._code=m,this._detail=h,this.isHandled=m===R.NotAvailable&&h===!0,Object.setPrototypeOf(this,S.prototype)}}e.$al=S;function g(P){const k=P.indexOf("+");return k===-1?P:P.substring(0,k)}e.$bl=g}),define(le[77],he([0,1,23]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0;function A(g){return g.scheme===O.Schemas.vscodeRemote?g.authority:void 0}e.$cl=A;function D(g){if(!g)return;const P=g.indexOf("+");return P<0?g:g.substr(0,P)}e.$dl=D;function L(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$el=L;function I(g){const{host:P,port:k}=S(g);if(typeof k>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:P,port:k}}e.$fl=I;function R(g,P){let{host:k,port:m}=S(g);return typeof m>"u"&&(m=P),{host:k,port:m}}e.$gl=R;function S(g){const P=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const k=g.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const m=g.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:g,port:void 0}}}),define(le[45],he([0,1,27,4,77]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function L(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$lm=L,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(I||(e.ExtensionType=I={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class S{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,l){if(typeof E>"u"||E===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof E=="string"||typeof l=="string"){const u=typeof E=="string"?E:E.value,d=typeof l=="string"?l:l.value;return O.$af(u,d)}return E._lower===l._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.$nm=S;class g{get size(){return this.c.size}constructor(E){if(this.c=new Set,E)for(const l of E)this.add(l)}add(E){this.c.add(S.toKey(E))}delete(E){return this.c.delete(S.toKey(E))}has(E){return this.c.has(S.toKey(E))}}e.$om=g;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(E){this.c.delete(S.toKey(E))}get(E){return this.c.get(S.toKey(E))}has(E){return this.c.has(S.toKey(E))}set(E,l){this.c.set(S.toKey(E),l)}values(){return this.c.values()}forEach(E){this.c.forEach(E)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=P;function k(p){return m(p)}e.$qm=k;function m(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$rm=m;function h(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$sm=h;function $(p,E){if(E){const l=`onResolveRemoteAuthority:${(0,D.$dl)(E)}`;return!!p.activationEvents?.includes(l)}return!1}e.$tm=$,e.$um=(0,A.$8h)("IBuiltinExtensionsScannerService")}),define(le[214],he([0,1,2,45,11]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class L extends O.$Tc{constructor(R,S,g,P,k){super(),this.a=R,this.b=S,this.c=g,this.f=k,this.B(P.onDidInstallExtensions(m=>this.g(m))),this.B(P.onDidUninstallExtension(m=>this.h(m)))}g(R){for(const S of R)S.local&&this.invalidate(S.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,R)&&await this.j(S);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,A.$hm))}catch(S){(0,D.$Jk)(S)!==1&&this.f.error(S)}}}e.$0p=L}),define(le[215],he([0,1,6,14,26,7,3,2,100,63,32,68,213,77]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.PersistentConnectionEventType=e.$nl=e.$ml=e.$ll=e.ConnectionType=void 0;const $=30*1e3;var p;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function E(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(z){const j=new D.$7d;return setTimeout(()=>j.cancel(),z),j.token}function u(z,j){if(z.isCancellationRequested||j.isCancellationRequested)return D.CancellationToken.Cancelled;const F=new D.$7d;return z.onCancellationRequested(()=>F.cancel()),j.onCancellationRequested(()=>F.cancel()),F.token}class d{get didTimeout(){return this.c==="timedout"}constructor(j){this.c="pending",this.d=new R.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,O.$1g)(),j.isCancellationRequested?this.h():this.d.add(j.onCancellationRequested(()=>this.h()))}registerDisposable(j){this.c==="pending"?this.d.add(j):j.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(j))}reject(j){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(j))}}function c(z,j){const F=new d(j);return F.registerDisposable(z.onControlMessage(B=>{const U=JSON.parse(B.toString()),Z=W(U);Z?F.reject(Z):F.resolve(U)})),F.promise}function y(z,j,F,B,U,Z,_,ie){const J=new d(ie),ne=g.$Sd.create(!1);return z.info(`Creating a socket (${_})...`),S.mark(`code/willCreateSocket/${Z}`),j.connect(F,B,U,_).then(ce=>{J.didTimeout?(S.mark(`code/didCreateSocketError/${Z}`),z.info(`Creating a socket (${_}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),ce?.dispose()):(S.mark(`code/didCreateSocketOK/${Z}`),z.info(`Creating a socket (${_}) was successful after ${ne.elapsed()} ms.`),J.resolve(ce))},ce=>{S.mark(`code/didCreateSocketError/${Z}`),z.info(`Creating a socket (${_}) returned an error after ${ne.elapsed()} ms.`),z.error(ce),J.reject(ce)}),J.promise}function i(z,j){const F=new d(j);return z.then(B=>{F.didTimeout||F.resolve(B)},B=>{F.didTimeout||F.reject(B)}),F.promise}async function o(z,j,F,B){const U=ae(z,j);z.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await y(z.logService,z.remoteSocketFactoryService,z.connectTo,(0,h.$el)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,E(j),`renderer-${E(j)}-${z.reconnectionToken}`,B)}catch(ce){throw z.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ce),ce}z.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let _,ie;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(Z,null),_=z.reconnectionProtocol,ie=!1):(_=new k.$Vh({socket:Z}),ie=!0),z.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const J=await i(z.signService.createNewMessage((0,P.$rg)()),B),ne={type:"auth",auth:z.connectionToken||"00000000000000000000",data:J.data};_.sendControl(A.$ke.fromString(JSON.stringify(ne)));try{const ce=await c(_,u(B,l(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(z.logService.trace(`${U} 4/6. received SignRequest control message.`),!await i(z.signService.validate(J,ce.signedData),B)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await i(z.signService.sign(ce.data),B),me={type:"connectionType",commit:z.commit,signedData:de,desiredConnectionType:j};return F&&(me.args=F),z.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(A.$ke.fromString(JSON.stringify(me))),{protocol:_,ownsProtocol:ie}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(z.logService.error(`${U} the handshake timed out. Error:`),z.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${U} received error control message when negotiating connection. Error:`),z.logService.error(ce)),ie&&H(_),ce}}async function n(z,j,F,B){const U=Date.now(),Z=ae(z,j),{protocol:_,ownsProtocol:ie}=await o(z,j,F,B),J=new d(B);return J.registerDisposable(_.onControlMessage(ne=>{const ce=JSON.parse(ne.toString()),fe=W(ce);fe?(z.logService.error(`${Z} received error control message when negotiating connection. Error:`),z.logService.error(fe),ie&&H(_),J.reject(fe)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${G(U)}!`),J.resolve({protocol:_,firstMessage:ce}))})),J.promise}async function s(z,j){const{protocol:F}=await n(z,1,void 0,j);return{protocol:F}}async function t(z,j,F){const{protocol:B,firstMessage:U}=await n(z,2,j,F),Z=U&&U.debugPort;return{protocol:B,debugPort:Z}}async function r(z,j,F){const B=Date.now(),U=ae(z,3),{protocol:Z}=await o(z,3,j,F);return z.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${G(B)}!`),Z}async function a(z,j,F){const{connectTo:B,connectionToken:U}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,connectTo:B,connectionToken:U,reconnectionToken:j,reconnectionProtocol:F,remoteSocketFactoryService:z.remoteSocketFactoryService,signService:z.signService,logService:z.logService}}async function v(z,j,F){return f(z,async B=>{const{protocol:U}=await s(B,D.CancellationToken.None);return new V(z,j,F,B.reconnectionToken,U)})}e.$ll=v;async function w(z,j){return f(z,async F=>{const{protocol:B,debugPort:U}=await t(F,j,D.CancellationToken.None);return new Q(z,j,F.reconnectionToken,B,U)})}e.$ml=w;async function f(z,j){for(let B=1;;B++)try{const U=(0,P.$rg)(),Z=await a(z,U,null);return await j(Z)}catch(U){if(B<5)z.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(U);else throw z.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(U),x.triggerPermanentFailure(0,0,m.$al.isHandled(U)),U}}async function b(z,j,F){const B=await a(z,(0,P.$rg)(),null);return await r(B,{host:j,port:F},D.CancellationToken.None)}e.$nl=b;function C(z){return(0,O.$Ug)(j=>new Promise((F,B)=>{const U=setTimeout(F,z*1e3);j.onCancellationRequested(()=>{clearTimeout(U),F()})}))}var N;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class T{constructor(j,F){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.type=0}}e.$ol=T;class M{constructor(j,F,B,U){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.durationSeconds=B,this.c=U,this.type=1}skipWait(){this.c.cancel()}}e.$pl=M;class q{constructor(j,F,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=2}}e.$ql=q;class Y{constructor(j,F,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=4}}e.$rl=Y;class X{constructor(j,F,B,U){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.attempt=B,this.handled=U,this.type=3}}e.$sl=X;class x extends R.$Tc{static triggerPermanentFailure(j,F,B){this._permanentFailure=!0,this.f=j,this.g=F,this.h=B,this.j.forEach(U=>U.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(j=>j.y())}static debugPauseSocketWriting(){this.j.forEach(j=>j.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(j,F,B,U,Z){super(),this.t=j,this.u=F,this.reconnectionToken=B,this.protocol=U,this.w=Z,this.m=this.B(new I.$Wd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(U.onSocketClose(_=>{const ie=ee(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ie} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ie} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ie} received socket close event.`),this.y()})),this.B(U.onSocketTimeout(_=>{const ie=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Rc)(()=>{const _=x.j.indexOf(this);_>=0&&x.j.splice(_,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const j=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const U=B<F.length?F[B]:F[F.length-1];try{if(U>0){const _=C(U);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,_)),this.u.logService.info(`${j} waiting for ${U} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${j} resolving connection...`);const Z=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${j} connecting to ${Z.connectTo}...`),await this.G(Z,l($)),this.u.logService.info(`${j} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(m.$al.isTemporarilyNotAvailable(Z)){this.u.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.u.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((0,L.$4)(Z)){this.u.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if(Z instanceof m.$al){this.u.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,m.$al.isHandled(Z));break}this.u.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(j,F,B){this.w?x.triggerPermanentFailure(j,F,B):this.D(j,F,B)}D(j,F,B){this.m.fire(new X(this.reconnectionToken,j,F,B)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$tl=x;class V extends x{constructor(j,F,B,U,Z){super(1,j,U,Z,!0),this.client=this.B(new k.$Th(Z,{remoteAuthority:F,clientId:B},j.ipcLogger))}async G(j,F){await s(j,F)}}e.$ul=V;class Q extends x{constructor(j,F,B,U,Z){super(2,j,B,U,!1),this.H=F,this.debugPort=Z}async G(j,F){await t(j,this.H,F)}}e.$vl=Q;function H(z){try{z.acceptDisconnect();const j=z.getSocket();z.dispose(),j.dispose()}catch(j){(0,L.$1)(j)}}function W(z){if(z&&z.type==="error"){const j=new Error(`Connection error: ${z.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function te(z,j){for(;z.length<j;)z+=" ";return z}function oe(z,j){return`[remote-connection][${te(E(z),13)}][${j.substr(0,5)}\u2026]`}function ee(z,j,F){return`${oe(z,j)}[${F?"reconnect":"initial"}]`}function ae(z,j){return`${ee(j,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.connectTo}]`}function G(z){return`${Date.now()-z} ms`}}),define(le[104],he([0,1,2,4]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=void 0,e.$hl=(0,A.$8h)("remoteSocketFactoryService");class D{constructor(){this.a={}}register(I,R){return this.a[I]??=[],this.a[I].push(R),(0,O.$Rc)(()=>{const S=this.a[I]?.indexOf(R);typeof S=="number"&&S>=0&&this.a[I]?.splice(S,1)})}b(I){return(this.a[I.type]||[]).find(S=>S.supports(I))}connect(I,R,S,g){const P=this.b(I);if(!P)throw new Error(`No socket factory found for ${I}`);return P.connect(I,R,S,g)}}e.$il=D}),define(le[216],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0_b=e.$9_b=void 0,e.$9_b=(0,O.$8h)("sharedProcessTunnelService"),e.$0_b="sharedProcessTunnel"}),define(le[105],he([0,1,4,164]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hac=e.$gac=e.$fac=e.$eac=e.$dac=e.TunnelStates=e.$cac=e.$bac=void 0,e.$bac=(0,O.$8h)("IRemoteTunnelService"),e.$cac={active:!1};var D;(function(L){L.disconnected=I=>({type:"disconnected",onTokenFailed:I}),L.connected=(I,R)=>({type:"connected",info:I,serviceInstallFailed:R}),L.connecting=I=>({type:"connecting",progress:I}),L.uninitialized={type:"uninitialized"}})(D||(e.TunnelStates=D={})),e.$dac="remote.tunnels.access",e.$eac=e.$dac+".hostNameOverride",e.$fac=e.$dac+".preventSleep",e.$gac="remoteTunnelService",e.$hac=(0,A.localize)(0,null)}),define(le[59],he([0,1,14,7,2,166,44,4,8,41]),function(se,e,O,A,D,L,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$jp=(0,R.$8h)("requestService");class P{constructor(y){this.b=y}toJSON(){if(!this.a){const y=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?y[i]="*****":y[i]=this.b[i];this.a=y}return this.a}}class k extends D.$Tc{constructor(y){super(),this.b=0,this.a=y.createLogger("network",{name:(0,L.localize)(0,null),when:S.$Gj.isEqualTo((0,S.$Ej)(S.LogLevel.Trace)).serialize()})}async c(y,i,o){const n=`${y} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new P(i.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,A.$0)(s)),s}}}e.$kp=k;function m(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}e.$lp=m;function h(c){return c.res.statusCode===204}e.$mp=h;async function $(c){return h(c)?null:(await(0,O.$we)(c.stream)).toString()}e.$np=$;async function p(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);return $(c)}e.$op=p;async function E(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);if(h(c))return null;const i=(await(0,O.$we)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.$pp=E;function l(c){d(c)}e.$qp=l;let u;function d(c){const y=g.$Kn.as(I.$Pn.Configuration),i=u;u={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},y.updateConfigurations({add:[u],remove:i?[i]:[]})}d(1)}),define(le[217],he([0,1,26,23,11,59]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aP=void 0;let I=class{constructor(S,g){this.a=S,this.b=g}async download(S,g,P=O.CancellationToken.None){if(S.scheme===A.Schemas.file||S.scheme===A.Schemas.vscodeRemote){await this.b.copy(S,g);return}const k={type:"GET",url:S.toString(!0)},m=await this.a.request(k,P);if(m.res.statusCode===200)await this.b.writeFile(g,m.stream);else{const h=await(0,L.$op)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${h}`)}}};e.$aP=I,e.$aP=I=pe([K(0,L.$jp),K(1,D.$sk)],I)}),define(le[218],he([0,1,14,26]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=void 0;class D{constructor(R){this.a=R}listen(R,S){throw new Error("Invalid listen")}call(R,S,g,P=A.CancellationToken.None){switch(S){case"request":return this.a.request(g[0],P).then(async({res:k,stream:m})=>{const h=await(0,O.$we)(m);return[{statusCode:k.statusCode,headers:k.headers},h]});case"resolveProxy":return this.a.resolveProxy(g[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$mr=D;class L{constructor(R){this.a=R}async request(R,S){const[g,P]=await this.a.call("request",[R],S);return{res:g,stream:(0,O.$ye)(P)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$nr=L}),define(le[219],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$b=e.$B$b=e.$A$b=void 0,e.$A$b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$B$b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$C$b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[220],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=void 0;class O{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(D){try{const L=await this.c();if(L){const I=String(O.a++);return this.b.set(I,L),{id:I,data:L.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,L){if(!D.id)return!0;const I=this.b.get(D.id);if(!I)return!1;this.b.delete(D.id);try{return I.validate(L)==="ok"}catch{return!1}finally{I.dispose?.()}}async sign(D){try{return await this.d(D)}catch{}return D}}e.$w7b=O}),define(le[106],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=void 0,e.$jl="signService",e.$kl=(0,O.$8h)(e.$jl)}),define(le[221],he([0,1,220]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q_b=void 0;class A extends O.$w7b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(I=>new I.signer().sign(L))}h(){return new Promise((L,I)=>se(["vsda"],L,I))}}e.$q_b=A}),define(le[78],he([0,1,3,2]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JGb=e.$IGb=e.$HGb=e.$GGb=void 0;class D extends A.$Tc{constructor(k,m,h){super(),this.a=k,this.b=m,this.c=h}async getItems(){const k={profile:this.b,workspace:this.c},m=await this.a.call("getItems",k);return new Map(m)}updateItems(k){const m={profile:this.b,workspace:this.c};return k.insert&&(m.insert=Array.from(k.insert.entries())),k.delete&&(m.delete=Array.from(k.delete.values())),this.a.call("updateItems",m)}optimize(){const k={profile:this.b,workspace:this.c};return this.a.call("optimize",k)}}class L extends D{constructor(k,m){super(k,m,void 0),this.f=this.B(new O.$Wd),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(k=>this.h(k)))}h(k){(Array.isArray(k.changed)||Array.isArray(k.deleted))&&this.f.fire({changed:k.changed?new Map(k.changed):void 0,deleted:k.deleted?new Set(k.deleted):void 0})}}class I extends L{constructor(k){super(k,void 0)}async close(){this.dispose()}}e.$GGb=I;class R extends L{constructor(k,m){super(k,m)}async close(){this.dispose()}}e.$HGb=R;class S extends D{constructor(k,m){super(k,void 0,m),this.onDidChangeItemsExternal=O.Event.None}async close(){this.dispose()}}e.$IGb=S;class g{constructor(k){this.a=k}isUsed(k){const m={payload:k,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.$JGb=g}),define(le[107],he([0,1,5,37,32]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function L(S){if(O.$u===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function I(S,g,P,k,m,h,$,p,E){const l=Object.create(null);l["common.machineId"]=h,l["common.sqmId"]=$,l.sessionID=(0,D.$rg)()+Date.now(),l.commitHash=k,l.version=m,l["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,O.$h)(O.$u),l["common.nodePlatform"]=A.$dc,l["common.nodeArch"]=P,l["common.product"]=E||"desktop",p&&(l["common.msftInternal"]=p);let u=0;const d=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),O.$l&&(l["common.snap"]="true");const c=L(g);return c&&(l["common.platformDetail"]=c),l}e.$Lo=I;function R(S){const g=A.env.USERDNSDOMAIN;if(!g)return!1;const P=g.toLowerCase();return S.some(k=>P===k)}e.$Mo=R}),define(le[22],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0,e.$wl=(0,O.$8h)("telemetryService"),e.$xl=(0,O.$8h)("customEndpointTelemetryService"),e.$yl="telemetry.currentSessionDate",e.$zl="telemetry.firstSessionDate",e.$Al="telemetry.lastSessionDate",e.$Bl="telemetry.machineId",e.$Cl="telemetry.sqmId",e.$Dl="telemetry",e.$El="telemetry.telemetryLevel",e.$Fl="telemetry.enableCrashReporter",e.$Gl="telemetry.enableTelemetry";var A;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var D;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(le[222],he([0,1,36,6,34,23,16,5,9,143,31,146,95,11,24,22]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.$8r=void 0;const E=new Map;async function l(i,o){const n=`${i}::${o.join(":")}`,s=E.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function w(b,C,N,T){const M=C.substring(b.length+1);return A.Promises.withAsyncBody(async q=>{let Y;try{Y=await P.Promises.readdir(C,{withFileTypes:!0})}catch{q();return}if(T.count>=v){T.count+=Y.length,T.maxReached=!0,q();return}let X=Y.length;if(X===0){q();return}let x=Y;T.count+Y.length>v&&(T.maxReached=!0,X=v-T.count,x=Y.slice(0,X)),T.count+=Y.length;for(const V of x)if(V.isDirectory()){if(N.includes(V.name)||await w(b,(0,I.$jc)(C,V.name),N,T),--X===0){q();return}}else{const Q=V.name.lastIndexOf(".");if(Q>=0){const H=V.name.substring(Q+1);H&&r.set(H,(r.get(H)??0)+1)}for(const H of t)H.relativePathPattern?.test(M)!==!1&&H.filePattern.test(V.name)&&a.set(H.tag,(a.get(H.tag)??0)+1);if(--X===0){q();return}}})}const f=A.Promises.withAsyncBody(async b=>{const C={count:0,maxReached:!1};await w(i,i,o,C);const N=await c(i);b({configFiles:u(a),fileTypes:u(r),fileCount:C.count,maxFilesReached:C.maxReached,launchConfigFiles:N})});return E.set(n,f),f}e.$8r=l;function u(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function d(){const i={os:`${O.type()} ${O.arch()} ${O.release()}`,memory:`${(O.totalmem()/h.$1k.GB).toFixed(2)}GB (${(O.freemem()/h.$1k.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$an.value()*100)}%`},o=O.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.$9r=d;async function c(i){try{const o=new Map,n=(0,I.$jc)(i,".vscode","launch.json"),s=await P.Promises.readFile(n),t=[],r=(0,D.$fn)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,D.$on)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(o.has(v)?o.set(v,o.get(v)+1):o.set(v,1))}return u(o)}catch{return[]}}e.$0r=c;let y=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${O.type()} ${O.arch()} ${O.release()}`);const s=O.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(O.totalmem()/h.$1k.GB).toFixed(2)}GB (${(O.freemem()/h.$1k.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${O.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(g.$an.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,k.$7r)(o.mainPID),this.k(o)]).then(async s=>{let[t,r]=s,a=this.m(o,t);return n.forEach(v=>{if((0,m.$Mm)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(o,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const w of Object.keys(v.workspaceMetadata)){const f=v.workspaceMetadata[w];let b=`${f.fileCount} files`;f.maxFilesReached&&(b=`more than ${b}`),r+=`|    Folder (${w}): ${b}`,r+=this.h(f)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=d(),v={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(v.load=`${O.loadavg().map(w=>Math.round(w)).join(", ")}`),R.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(o,n){const s=[];return(0,k.$7r)(o.mainPID).then(async t=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,m.$Mm)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let w=`${v.fileCount} files`;v.maxFilesReached&&(w=`more than ${w}`),s.push(`Folder (${a}): ${w}`),s.push(this.h(v))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let t=0;const r=(f,b)=>{const C=` ${f}(${b})`;t+C.length>60?(n.push(a),a="|                 ",t=a.length):t+=C.length,a+=C};let a="|      File types:";const v=10,w=o.fileTypes.length>v?v:o.fileTypes.length;for(let f=0;f<w;f++){const b=o.fileTypes[f];r(b.name,b.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(f=>{r(f.name,f.count)}),n.push(a)),o.launchConfigFiles.length>0){let f="|      Launch Configs:";o.launchConfigFiles.forEach(b=>{const C=b.count>1?` ${b.name}(${b.count})`:` ${b.name}`;f+=C}),n.push(f)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=S.URI.revive(r);if(a.scheme===L.Schemas.file){const v=a.fsPath;s.push(l(v,["node_modules",".git"]).then(w=>{let f=`${w.fileCount} files`;w.maxFilesReached&&(f=`more than ${f}`),n.push(`|    Folder (${(0,I.$nc)(v)}): ${f}`),n.push(this.h(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${w.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,t,n,0),t.join(`
`)}n(o,n,s,t,r){const a=r===0;let v;a?v=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const w=process.platform==="win32"?t.mem:O.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(w/h.$1k.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(f=>this.n(o,n,s,f,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=S.URI.revive(s);if(t.scheme!==L.Schemas.file)continue;const r=t.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=S.URI.revive(n);if(s.scheme!==L.Schemas.file)continue;const t=s.fsPath;try{const r=await l(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$$r=y,e.$$r=y=pe([K(0,p.$wl),K(1,$.$Hj)],y)}),define(le[108],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G$b=e.$F$b=void 0;class O{constructor(L){this.b=L}listen(L,I){throw new Error(`Event not found: ${I}`)}call(L,I,{eventName:R,data:S}){return this.b.forEach(g=>g.log(R,S)),Promise.resolve(null)}}e.$F$b=O;class A{constructor(L){this.b=L}log(L,I){return this.b.call("log",{eventName:L,data:I}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$G$b=A}),define(le[46],he([0,1,30,12,77,107,22]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class R{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$No=R;class S{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=S,e.$Po=new S;class g{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$Qo=g,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function P(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}e.$Uo=P;function k(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Vo=k;function m(i){const o=i.getValue(I.$El),n=i.getValue(I.$Fl);if(i.getValue(I.$Gl)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=m;function h(i){const o={},n={},s={};E(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}e.$Xo=h;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(i){if(!i)return"none";const o=(0,D.$dl)(i);return $.has(o)?o:"other"}e.$Yo=p;function E(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,O.$Dn)(r):r instanceof Date?o[a]=r.toISOString():(0,A.$Lf)(r)?n<2?E(r,o,n+1,a+"."):o[a]=(0,O.$Dn)(r):o[a]=r}}function l(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,L.$Mo)(n)||s}e.$Zo=l;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$1o=u;function d(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const v of o)for(;;){const w=v.exec(i);if(!w)break;s.push([w.index,v.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const v=r.exec(i);if(!v)break;const w=s.some(([f,b])=>v.index<b&&f<r.lastIndex);!t.test(v[0])&&!w&&(n+=i.substring(a,v.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function y(i,o){return(0,O.$An)(i,n=>{if(n instanceof R||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=d(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}e.$2o=y}),define(le[33],he([0,1,27,29,45,5,9,7,37,46]),function(se,e,O,A,D,L,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function P(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,O.$8e)(n.id,s.id)===0}e.$3o=P;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,t,r)}static parse(s){const t=k.exec(s);return t&&t[1]&&t[2]?new m({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?P(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$4o=m;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const s=h.exec(n);return s&&s[1]?[E(s[1]),s[2]]:[E(n),void 0]}e.$5o=$;function p(n,s){return`${n}.${s}`}e.$6o=p;function E(n){return n.toLowerCase()}e.$7o=E;function l(n,s){return E(p(n??D.$jm,s))}e.$8o=l;function u(n,s){const t=[],r=a=>{for(const v of t)if(v.some(w=>P(s(w),s(a))))return v;return null};for(const a of n){const v=r(a);v?v.push(a):t.push([a])}return t}e.$9o=u;function d(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$0o=d;function c(n){return{id:new g.$No(n.identifier.id),name:new g.$No(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$$o=c,e.$_o=new D.$nm("pprice.better-merge");function y(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(v=>!P(v.identifier,{id:a}))){const v=n.filter(w=>P(w.identifier,{id:a}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$ap=y;async function i(n,s){if(!L.$k)return!1;let t;try{t=(await n.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,A.$xo)(t?"alpine":L.$u,S.$ec);return s.debug("ComputeTargetPlatform:",r),r}e.$bp=o}),define(le[223],he([0,1,17,2,20,9,11,24,6,3,16,5,37,33]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E9b=e.$D9b=void 0;let $=class extends A.$Tc{constructor(d,c){super(),this.b=d,this.c=c,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,y])=>this.a.set(y.configPath,y))}getConfigBasedTips(d){return this.f(d)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(d){const c=[];for(const[y,i]of this.a)if(!(i.configScheme&&i.configScheme!==d.scheme))try{const o=(await this.b.readFile((0,D.$Ig)(d,y))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.$D9b=$,e.$D9b=$=pe([K(0,I.$sk),K(1,R.$Hj)],$);const p="extensionTips/promptedExecutableTips",E="extensionTips/lastPromptedMediumImpExeTime";class l extends ${constructor(d,c,y,i,o,n,s,t){super(s,t),this.r=d,this.s=c,this.t=y,this.u=i,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],w=[],f=[];Object.entries(a.recommendations).forEach(([b,C])=>{C.important?a.important?v.push({extensionId:b,extensionName:C.name,isExtensionPack:!!C.isExtensionPack}):w.push({extensionId:b,extensionName:C.name,isExtensionPack:!!C.isExtensionPack}):f.push({extensionId:b,extensionName:C.name,isExtensionPack:!!C.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),w.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),f.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:f})}),(0,S.$0g)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const d=await this.O(this.g),c=await this.O(this.h);return[...d,...c]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const d=await this.O(this.g),c=await this.O(this.h),y=await this.u.getInstalled();this.m=this.D(d,y),this.n=this.D(c,y)}D(d,c){const y=new Map;d.forEach(t=>y.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...y.keys()],c);for(const t of i){const r=y.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=y.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of o){const r=y.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[d,c]=[...this.m.entries()][0];this.H(c).then(y=>{switch(y){case"reacted":this.M(c[0].exeName,c);break;case"ignored":this.m.delete(d);break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new A.$Uc);i.value=(0,S.$0g)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const d=this.I(),c=Date.now()-d,y=7*24*60*60*1e3;if(c<y){const n=this.B(new A.$Uc);n.value=(0,S.$0g)(()=>{n.dispose(),this.G()},y-c);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const s=this.B(new A.$Uc);s.value=(0,S.$0g)(()=>{s.dispose(),this.G()},y);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new A.$Uc);s.value=(0,S.$0g)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(d){const c=await this.u.getInstalled(1),y=d.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,h.$3o)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:y,source:3,name:d[0].exeFriendlyName,searchValue:`@exe:"${d[0].exeName}"`})}I(){let d=this.w.getNumber(E,-1);return d||(d=Date.now(),this.J(d)),d}J(d){this.w.store(E,d,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(d,c){const y=this.L();y[d]=c.map(({extensionId:i})=>i.toLowerCase()),this.w.store(p,JSON.stringify(y),-1,0)}N(d,c){const y=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return d.forEach(n=>{o.has(n.toLowerCase())?y.push(n):i.push(n)}),{installed:y,uninstalled:i}}async O(d){const c=[],y=new Map;for(const i of d.keys()){const o=d.get(i);if(!o||!(0,O.$Lb)(o.recommendations))continue;const n=[];k.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(n.push((0,P.$jc)("/usr/local/bin",i)),n.push((0,P.$jc)("/usr/bin",i)),n.push((0,P.$jc)(this.r.fsPath,i)));for(const s of n){let t=y.get(s);if(t===void 0&&(t=await this.b.exists(L.URI.file(s)),y.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:w}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:w})}}return c}}e.$E9b=l}),define(le[224],he([0,1,26,33]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OZb=void 0;async function D(L,I,R,S,g){try{const P=await L.getExtensionsControlManifest();if(!P.deprecated)return;const k=await L.getInstalled(1);for(const[m,h]of Object.entries(P.deprecated)){if(!h?.extension)continue;const{id:$,autoMigrate:p,preRelease:E}=h.extension;if(!p)continue;const l=k.find(d=>(0,A.$3o)(d.identifier,{id:m}));if(!l)continue;const u=(await I.getExtensions([{id:$,preRelease:E}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0];if(!u){g.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${$}' extension is not found`);continue}try{g.info(`Migrating '${l.identifier.id}' extension to '${$}' extension...`);const d=!S.getDisabledExtensions().some(y=>(0,A.$3o)(y,l.identifier));await L.uninstall(l),g.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let c=k.find(y=>(0,A.$3o)(y.identifier,{id:$}));(!c||!c.isPreReleaseVersion&&d)&&(c=await L.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${c.identifier.id}'`),d||(await S.disableExtension(c.identifier),g.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),p.storage&&(R.addToMigrationList((0,A.$6o)(l.manifest.publisher,l.manifest.name),(0,A.$6o)(c.manifest.publisher,c.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${l.identifier.id}' extension to '${$}' extension.`)}catch(d){g.error(d)}}}catch(P){g.error(P)}}e.$OZb=D}),define(le[225],he([0,1,6,7,2,23,20,55,12,32,31,70,21,15,29,33,99,11,8]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;let c=class extends D.$Tc{static{d=this}static{this.c=".sigzip"}constructor(i,o,n,s,t,r){super(),this.h=o,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,n){await this.g;const s=(0,I.$Ig)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,o))}catch(r){throw new $.$Co(r.message,$.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===u.LogLevel.Trace)}catch(a){const v=a;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${v.output}`),t===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(w){this.r.error(w)}throw new $.$Co(k.$Np,$.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,S.$Pf)(o)?o:!0}async u(i){await this.g;const o=(0,I.$Ig)(this.extensionsDownloadDir,`${this.z(i)}${d.c}`);try{await this.w(i,o,n=>this.j.downloadSignatureArchive(i,n))}catch(n){throw new $.$Co(n.message,$.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==L.Schemas.file){await n(o);return}const s=(0,I.$Ig)(this.extensionsDownloadDir,`.${(0,g.$rg)()}`);await this.h.exists(s)||await n(s);try{await P.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,A.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(d.c))s.push(a.resource);else{const v=p.$4o.parse(a.name);v&&n.push([v,a])}const t=(0,p.$9o)(n,([a])=>a),r=[];for(const a of t)a.sort((v,w)=>R.rcompare(v[0].version,w[0].version)),o.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await O.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?p.$4o.create(i).toString().toLowerCase():(0,g.$rg)()}};e.$7p=c,e.$7p=c=d=pe([K(0,h.$di),K(1,l.$sk),K(2,$.$Bo),K(3,m.$Bi),K(4,E.$Hp),K(5,u.$pj)],c)}),define(le[226],he([0,1,3,2,35,33,45]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;class R extends A.$Tc{constructor(g,P,k,m,h,$,p){super(),this.f=g,this.g=P,this.h=k,this.j=m,this.m=h,this.n=$,this.r=p,this.a=this.B(new O.$Wd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$3c),this.s().then(null,E=>p.error(E))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(P=>(this.c.set(P.id,(0,A.$Qc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(g){for(const P of g.extensions)this.I(this.L(P.identifier,P.version),g.profileLocation)}async y(g){for(const P of g.extensions){const k=this.L(P.identifier,P.version);g.error?this.J(k,g.profileLocation):this.I(k,g.profileLocation)}}async z(g){for(const P of g.extensions)this.J(this.L(P.identifier,P.version),g.profileLocation)}async C(g){const P=[],k=[];for(const m of g.extensions){const h=this.L(m.identifier,m.version);g.error?this.I(h,g.profileLocation):(this.J(h,g.profileLocation),this.b.has(h)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),k.push(this.f.scanInstalledExtensionAtLocation(m.location).then($=>{$?P.push($):this.r.info("Extension not found at the location",m.location.toString())},$=>this.r.error($)))))}try{await Promise.all(k),P.length&&await this.H(P)}catch(m){this.r.error(m)}}D(g){for(const P of this.h.profiles)g.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(g){const P=[],k=[],m=await this.j.scanProfileExtensions(g),h=new Set,$=new Set;for(const[p,E]of this.b)E.has(g)&&$.add(p);for(const p of m){const E=this.L(p.identifier,p.version);h.add(E),$.has(E)||(P.push(p.identifier),this.I(E,g))}for(const p of $)if(!h.has(p)){const E=this.M(p);E&&(k.push(E.identifier),this.J(p,g))}(P.length||k.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:g}:void 0,removed:k.length?{extensions:k,profileLocation:g}:void 0})}async G(g){const P=await this.j.scanProfileExtensions(g);for(const k of P)this.I(this.L(k.identifier,k.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(k=>!this.b.has(this.L(k.identifier,k.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,P){let k=this.b.get(g);k||this.b.set(g,k=new D.$Bc(m=>this.m.extUri.getComparisonKey(m))),k.add(P)}J(g,P){const k=this.b.get(g);k&&k.delete(P),k?.size||this.b.delete(g)}L(g,P){return`${I.$nm.toKey(g.id)}@${P}`}M(g){const[P,k]=(0,L.$5o)(g);return k?{identifier:{id:P},version:k}:void 0}}e.$$p=R}),define(le[227],he([0,1,43,46]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;async function D(L,I,R,S,g,P,k){const m={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${I.nameShort})`};if((0,A.$Uo)(I,R)&&(0,A.$Wo)(S)===3){const h=await(0,O.$Cp)(R,g,P);m["X-Market-User-Id"]=h,m["VSCode-SessionId"]=k.machineId||h}return m}e.$Dp=D}),define(le[228],he([0,1,73,17,6,2,23,16,31,15,29,33,8,75,9]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;let p=class extends h.$kr{constructor(d,c,y,i){super(y),this.h=d,this.j=i,this.g=this.B(new E(c,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(d,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const o=i.translations[d];return o?$.URI.file(o):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),c=Object.keys(d).map(y=>{const i=d[y];return{...this.f(y,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((y,i)=>y.label.localeCompare(i.label)),c}async m(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",d.identifier.id),await this.update())}async n(d){const c=await this.g.getLanguagePacks();Object.keys(c).some(y=>c[y]&&c[y].extensions.some(i=>(0,k.$3o)(i.extensionIdentifier,d.identifier)))&&(this.j.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),y=await this.g.update(c);return!(0,A.$ub)(Object.keys(d),Object.keys(y))}};e.$lr=p,e.$lr=p=pe([K(0,P.$Eo),K(1,g.$di),K(2,P.$Bo),K(3,m.$pj)],p);let E=class extends L.$Tc{constructor(d,c){super(),this.j=c,this.c={},this.f=(0,R.$jc)(d.userDataPath,"languagepacks.json"),this.g=new D.$ch}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.s(c=>{Object.keys(c).forEach(y=>delete c[y]),this.m(c,...d)}).then(()=>this.c)}m(d,...c){for(const y of c)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.n(d,y);Object.keys(d).forEach(y=>this.r(d[y]))}n(d,c){const y=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===I.Schemas.file&&l(o)){let n=d[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},d[o.languageId]=n);const s=n.extensions.filter(t=>(0,k.$3o)(t.extensionIdentifier,y))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:y,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.$jc)(c.location.fsPath,t.path)}}r(d){if(d){const c=(0,O.createHash)("md5");for(const y of d.extensions)c.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);d.hash=c.digest("hex")}}s(d=()=>null){return this.g.queue(()=>{let c=null;return S.Promises.readFile(this.f,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(c=d(y),y)).then(y=>{for(const o of Object.keys(y))y[o]||delete y[o];this.c=y,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),S.Promises.writeFile(this.f,i)}).then(()=>c,y=>this.j.error(y))})}};E=pe([K(0,g.$di),K(1,m.$pj)],E);function l(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const d of u.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(le[229],he([0,1,142,7,30,46]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function S(P,k,m){const h=await(0,O.$jD)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,O.$jD)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new h.AppInsightsCore,E=new $.PostChannel,l={instrumentationKey:P,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(m){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};l.extensionConfig[E.identifier]=u}return p.initialize(l,[]),p.addTelemetryInitializer(u=>{u.ext=u.ext??{},u.ext.web=u.ext.web??{},u.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',k&&(u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),p}class g{constructor(k,m,h,$,p){this.e=k,this.f=m,this.g=h,this.h=p,this.c=I,this.d=R,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(k){if(this.a){if(typeof this.a!="string"){k(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(m=>{k(m)},m=>{(0,A.$1)(m),console.error(m)})}}log(k,m){if(!this.a)return;m=(0,D.$Bn)(m,this.g),m=(0,L.$Xo)(m);const h=this.f+"/"+k;try{this.i($=>{$.pluginVersionString=m?.properties.version??"Unknown",$.track({name:h,baseData:{name:h,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(k=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,k(void 0)})})}):Promise.resolve(void 0)}}e.$KO=g}),define(le[109],he([0,1,2,167,15,8,24,46]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$48b=void 0;let S=class extends O.$Tc{constructor(P,k,m,h,$=""){super(),this.b=$;const p=k.getLogger(R.$Ro);if(p)this.a=this.B(p);else{const l=(0,R.$Vo)(h,m)?" (Not Sent)":"",u=()=>(0,R.$Uo)(h,m)&&P.getLevel()===L.LogLevel.Trace;this.a=this.B(k.createLogger(R.$Ro,{name:(0,A.localize)(0,null,l),hidden:!u()})),this.B(P.onDidChangeLogLevel(()=>k.setVisibility(R.$Ro,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,k){this.a.trace(`${this.b}telemetry/${P}`,(0,R.$Xo)(k))}};e.$48b=S,e.$48b=S=pe([K(0,L.$pj),K(1,L.$qj),K(2,D.$ci),K(3,I.$Hj)],S)}),define(le[110],he([0,1,2,30,5,27,168,21,44,102,24,41,22,46]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,u,d){this.k=u,this.l=d,this.d={},this.i=new O.$Sc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this.f)this.j.push(new RegExp((0,L.$Pe)(c),"gi")),c.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$Pe)(c.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(c=>{(c.affectsConfiguration(m.$El)||c.affectsConfiguration(m.$Gl)||c.affectsConfiguration(m.$Fl))&&this.m()}))}setExperimentProperty(l,u){this.d[l]=u}m(){let l=(0,h.$Wo)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const d=u.usage?3:u.error?2:0;l=Math.min(l,d)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,u,d){this.g<u||(d=(0,A.$Bn)(d,this.d),d=(0,h.$2o)(d,this.j),d=(0,A.$Bn)(d,this.c),this.b.forEach(c=>c.log(l,d)))}publicLog(l,u){this.n(l,3,u)}publicLog2(l,u){this.publicLog(l,u)}publicLogError(l,u){this.h&&this.n(l,2,u)}publicLogError2(l,u){this.publicLogError(l,u)}};e.$rr=$,e.$rr=$=pe([K(1,R.$Bi),K(2,P.$Hj)],$);function p(){const E=(0,I.localize)(0,null,g.default.nameLong),l=g.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=D.$o?"":(0,I.localize)(3,null),d=(0,I.localize)(4,null),c=(0,I.localize)(5,null),y=(0,I.localize)(6,null),i=(0,I.localize)(7,null),o=`
|       | ${d} | ${c} | ${y} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,I.localize)(8,null);return`
${E} ${l} ${u}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}k.$Kn.as(S.$Pn.Configuration).registerConfiguration({id:m.$Dl,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[m.$El]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.$Kn.as(S.$Pn.Configuration).registerConfiguration({id:m.$Dl,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[m.$Gl]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,I.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,I.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${m.$El}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[230],he([0,1,14,26,271,229]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=void 0;async function I(P,k){const m=await k.request(P,A.CancellationToken.None),h=(await(0,O.$we)(m.stream)).toString(),$=m.res.statusCode??200;return{headers:m.res.headers,statusCode:$,responseData:h}}async function R(P){const k={method:P.type,headers:P.headers};return new Promise((h,$)=>{const p=D.request(P.url??"",k,E=>{E.on("data",function(l){h({headers:E.headers,statusCode:E.statusCode??200,responseData:l.toString()})}),E.on("error",function(l){$(l)})});p.write(P.data,E=>{E&&$(E)}),p.end()})}async function S(P,k,m){const h=typeof k.data=="string"?k.data:new TextDecoder().decode(k.data),$={type:"POST",headers:{...k.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(k.data).toString()},url:k.urlString,data:h};try{const p=P?await I($,P):await R($);m(p.statusCode,p.headers,p.responseData)}catch{m(0,{})}}class g extends L.$KO{constructor(k,m,h,$,p){const E={sendPOST:(l,u)=>{S(k,l,u)}};super(m,h,$,p,E)}}e.$LO=g}),define(le[231],he([0,1,23,93,21,15,8,24,22,108,109,110]),function(se,e,O,A,D,L,I,R,S,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1_b=void 0;let m=class{constructor($,p,E,l,u,d){this.b=$,this.c=p,this.d=E,this.e=l,this.f=u,this.g=d,this.a=new Map}h($){if(!this.a.has($.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const E=[$.id,JSON.stringify(p),$.aiKey],u=new A.$tq(O.$pg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:E,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),d=[new g.$G$b(u),new P.$48b(this.d,this.e,this.f,this.g,`[${$.id}] `)];this.a.set($.id,new k.$rr({appenders:d,sendErrorTelemetry:$.sendErrorTelemetry},this.b,this.g))}return this.a.get($.id)}publicLog($,p,E){this.h($).publicLog(p,E)}publicLogError($,p,E){this.h($).publicLogError(p,E)}};e.$1_b=m,e.$1_b=m=pe([K(0,D.$Bi),K(1,S.$wl),K(2,I.$pj),K(3,I.$qj),K(4,L.$ci),K(5,R.$Hj)],m)}),define(le[79],he([0,1,3,9,21,4,8]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.ProvidedOnAutoForward=e.$Ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dv=e.$Cv=void 0,e.$Cv=(0,L.$8h)("tunnelService"),e.$Dv=(0,L.$8h)("sharedTunnelsService");var R;(function(l){l.Http="http",l.Https="https"})(R||(e.TunnelProtocol=R={}));var S;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(S||(e.TunnelPrivacyId=S={}));function g(l){return!!l.forwardPort}e.$Ev=g;var P;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(P||(e.ProvidedOnAutoForward=P={}));function k(l,{checkQuery:u=!0}={}){if(l.scheme!=="http"&&l.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(d)return{address:d[1],port:+d[2]};if(!l.query||!u)return;const c=l.query.split("&");for(const y of c){const i=y.split("=")[1];if(/^https?:/.exec(i)){const o=k(A.URI.parse(i));if(o)return o}}}e.$Fv=k,e.$Gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(l){return e.$Gv.indexOf(l)>=0}e.$Hv=m,e.$Iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function h(l){return e.$Iv.indexOf(l)>=0}e.$Jv=h;function $(l,u,d,c){if(d===1)return!1;if(d===2&&h(u)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(y?.length===4&&parseInt(y[1])>=18)return!1}return l<1024}e.$Kv=$;class p{constructor(u,d,c){this.remoteAddress=u,this.localAddress=d,this.b=c,this.a=new O.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lv=p;let E=class{constructor(u,d){this.k=u,this.l=d,this.a=new O.$Wd,this.onTunnelOpened=this.a.event,this.b=new O.$Wd,this.onTunnelClosed=this.b.event,this.c=new O.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const u=this.l.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.f=u,u?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.g=u.elevation,this.i=u.privacyOptions,this.h=u.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const u=[],d=Array.from(this.e.values());for(const c of d){const y=Array.from(c.values());for(const i of y){const o=await i.value;o&&typeof o!="string"&&u.push(o)}}return u}async dispose(){for(const u of this.e.values()){for(const{value:d}of u.values())await d.then(c=>typeof c!="string"?c?.dispose():void 0);u.clear()}this.e.clear()}setEnvironmentTunnel(u,d,c,y,i){this.q(u,d,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:d,localAddress:c,privacy:y,protocol:i,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,d){(h(u)||m(u))&&(u=e.$Gv[0]);const c=this.s(u,d);if(c)return++c.refcount,c.value}openTunnel(u,d,c,y,i,o=!1,n,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${c} on local port ${i}.`);const t=this.f??u;if(!t)return;if(d||(d="localhost"),y||(y=this.m),this.f&&this.j.has(c)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.t(t,d,c,y,i,o,n,s);return r?r.then(a=>{if(a){if(typeof a=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(d,c),a}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(d,c);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.o(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==c)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&a.privacy!==n&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}o(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this.e.get(u.tunnelRemoteHost);if(d){const c=d.get(u.tunnelRemotePort);c&&(c.refcount--,await this.p(u.tunnelRemoteHost,u.tunnelRemotePort,c))}}}}async p(u,d,c){if(c.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const y=c.value.then(async i=>{i&&typeof i!="string"&&(await i.dispose(!0),this.b.fire({host:i.tunnelRemoteHost,port:i.tunnelRemotePort}))});return this.e.has(u)&&this.e.get(u).delete(d),y}}async closeTunnel(u,d){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const c=this.e.get(u);if(c&&c.has(d)){const y=c.get(d);y.refcount=0,await this.p(u,d,y)}}q(u,d,c){this.e.has(u)||this.e.set(u,new Map),this.e.get(u).set(d,{refcount:1,value:c})}async r(u,d){const c=this.e.get(u);if(c){const y=c.get(d),i=y?await y.value:void 0;(!i||typeof i=="string")&&c.delete(d),c.size===0&&this.e.delete(u)}}s(u,d){const c=[u];m(u)?(c.push(...e.$Gv),c.push(...e.$Iv)):h(u)&&c.push(...e.$Iv);const y=c.map(i=>this.e.get(i));for(const i of y){const o=i?.get(d);if(o)return o}}canTunnel(u){return!!k(u)}u(u,d,c,y,i,o,n){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${c} on local port ${y}.`);const s=c;this.j.add(s);const t=y===void 0?c:y,r={elevationRequired:i?this.isPortPrivileged(t):!1},a={remoteAddress:{host:d,port:c},localAddressPort:y,privacy:o,public:o?o!==S.Private:void 0,protocol:n},v=u.forwardPort(a,r);return v?(this.q(d,c,v),v.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),v}};e.$Mv=E,e.$Mv=E=pe([K(0,I.$pj),K(1,D.$Bi)],E)}),define(le[232],he([0,1,8,79,2,7,6]),function(se,e,O,A,D,L,I){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$$_b=void 0;class S extends D.$Tc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new I.$sh),this.b.p)}setAddress(k){this.a=k,this.b&&(this.b.complete(k),this.b=null)}setTunnel(k){this.B(k)}}let g=class extends D.$Tc{static{R=this}static{this.a=0}constructor(k,m){super(),this.f=k,this.g=m,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(k=>k.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(k,m,h,$,p,E,l){const u=new S,d=await Promise.resolve(this.f.openTunnel(k,u,h,$,p,E,l));if(!d||typeof d=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${h}:${$} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(m))throw this.c.delete(m),u.dispose(),await d.dispose(),(0,L.$6)();return u.setTunnel(d),this.b.set(m,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${m}: ${d.localAddress} (local) to ${h}:${$} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(k,m){const h=this.b.get(k);h&&h.setAddress(m)}async destroyTunnel(k){const m=this.b.get(k);if(m){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${k}.`),this.b.delete(k),await m.dispose();return}this.c.add(k)}};e.$$_b=g,e.$$_b=g=R=pe([K(0,A.$Dv),K(1,O.$pj)],g)}),define(le[28],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=void 0,e.$3k=(0,O.$8h)("IUriIdentityService")}),define(le[233],he([0,1,28,186,11,20,128,3,2]),function(se,e,O,A,D,L,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;class g{static{this._clock=0}constructor(m){this.uri=m,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let P=class{constructor(m){this.g=m,this.c=new S.$Sc,this.f=2**16;const h=new Map,$=p=>{let E=h.get(p.scheme);return E===void 0&&(E=m.hasProvider(p)&&!this.g.hasCapability(p,1024),h.set(p.scheme,E)),E};this.c.add(R.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(p=>{h.delete(p.scheme)})),this.extUri=new L.$xg($),this.d=new I.$3r((p,E)=>this.extUri.compare(p,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,L.$Jg)(m));const h=this.d.get(m);return h?h.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new g(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort(($,p)=>$[1].time<p[1].time?1:$[1].time>p[1].time?-1:0);g._clock=0,this.d.clear();const h=this.f*.5;for(let $=0;$<h;$++)this.d.set(m[$][0],m[$][1].touch())}};e.$4r=P,e.$4r=P=pe([K(0,D.$sk)],P),(0,A.$1r)(O.$3k,P,1)}),define(le[234],he([0,1,3,2,11,48,35]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t_b=void 0;class R extends A.$Tc{constructor(g,P,k,m,h,$){super(),this.f=g,this.g=P,this.h=k,this.j=m,this.m=h,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$Wd),this.onDidChangeFile=this.a.event,this.b=L.$bi.forUris(()=>!(this.capabilities&1024)),this.c=new I.$Bc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,P){return this.g.open(this.t(g),P)}close(g){return this.g.close(g)}read(g,P,k,m,h){return this.g.read(g,P,k,m,h)}write(g,P,k,m,h){return this.g.write(g,P,k,m,h)}watch(g,P){this.b.set(g,g);const k=this.g.watch(this.t(g),P);return(0,A.$Rc)(()=>{this.b.delete(g),k.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,P,k){return this.g.rename(this.t(g),this.t(P),k)}readFile(g,P){return this.g.readFile(this.t(g),P)}readFileStream(g,P,k){return this.g.readFileStream(this.t(g),P,k)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,P,k){return this.g.writeFile(this.t(g),P,k)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,P){return this.g.delete(this.t(g),P)}copy(g,P,k){if((0,D.$wk)(this.g))return this.g.copy(this.t(g),this.t(P),k);throw new Error("copy not supported")}cloneFile(g,P){if((0,D.$xk)(this.g))return this.g.cloneFile(this.t(g),this.t(P));throw new Error("clone not supported")}s(g){const P=[];for(const k of g){if(k.resource.scheme!==this.f)continue;const m=this.u(k.resource);this.b.findSubstr(m)&&P.push({resource:m,type:k.type,cId:k.cId})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$t_b=R}),define(le[80],he([0,1,62]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nGb=e.$mGb=e.edit=void 0;function A(I,R,S,g){const P=(0,O.$un)(I,R,S,g)[0];return P&&(I=I.substring(0,P.offset)+P.content+I.substring(P.offset+P.length)),I}e.edit=A;function D(I,R,S){let g=S;for(;g>=0;){if(I.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&I.charAt(g)===R.charAt(0))return g+2}return 0}e.$mGb=D;function L(I,R,S){let g=S;for(;g>=0;)if(I.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&I.charAt(g)===R.charAt(1)))return g;return I.length-1}e.$nGb=L}),define(le[235],he([0,1,30,55,12]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J7b=void 0;function L(h,$,p,E,l,u){const d=[],c=[],y=[];if(!$){const q=h.filter(({identifier:Y})=>l.every(X=>X.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:d,removed:c,updated:y},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}h=h.map(k),$=$.map(k),p=p?p.map(k):null;const i=new Map,o=q=>{q.uuid&&i.set(q.id.toLowerCase(),q.uuid)};h.forEach(({identifier:q})=>o(q)),$.forEach(({identifier:q})=>o(q)),p?.forEach(({identifier:q})=>o(q)),E?.forEach(({identifier:q})=>o(q)),u?.forEach(q=>o(q));const n=q=>{const Y=q.identifier.uuid||i.get(q.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${q.identifier.id.toLowerCase()}`},s=(q,Y)=>(q.set(n(Y),Y),q),t=h.reduce(s,new Map),r=$.reduce(s,new Map),a=$.reduce((q,Y)=>s(q,(0,O.$yn)(Y)),new Map),v=p?p.reduce(s,new Map):null,w=E.reduce(s,new Map),f=l.reduce((q,Y)=>{const X=i.get(Y.toLowerCase());return q.add(X?`uuid:${X}`:`id:${Y.toLowerCase()}`)},new Set),b=u?u.reduce((q,{id:Y,uuid:X})=>(X=X??i.get(Y.toLowerCase()),q.add(X?`uuid:${X}`:`id:${Y.toLowerCase()}`)),new Set):null,C=I(t,r,f,!1);if(C.added.size>0||C.removed.size>0||C.updated.size>0){const q=I(v,t,f,!1),Y=I(v,r,f,!0),X=(x,V,Q,H)=>{let W,te,oe;return V.installed?(W=H.pinned,oe=H.preRelease,W&&(te=H.version)):(W=Q.pinned,oe=Q.preRelease,W&&(te=Q.version)),W===void 0&&(W=V.pinned,W&&(te=V.version)),oe===void 0&&(oe=V.preRelease),{...H,installed:V.installed||Q.installed,pinned:W,preRelease:oe,version:te??(Q.version&&(!V.installed||A.gt(Q.version,V.version))?Q.version:V.version),state:S(V,Q,v?.get(x))}};for(const x of Y.removed.values()){const V=t.get(x);if(!V)continue;const Q=(0,D.$Uf)(v?.get(x)),H=b&&!b.has(x)&&Q.installed;V.installed&&H?c.push(V.identifier):a.set(x,V)}for(const x of Y.added.values()){const V=(0,D.$Uf)(r.get(x)),Q=t.get(x);if(Q){if(C.updated.has(x)){const H=X(x,Q,V,V);R(Q,V,!1,!1)||y.push(m(H,x)),a.set(x,H)}}else V.installed&&d.push(m(V,x))}for(const x of Y.updated.values()){const V=(0,D.$Uf)(r.get(x)),Q=(0,D.$Uf)(v?.get(x)),H=t.get(x);if(H)if(b&&!b.has(x)&&Q.installed&&H.installed&&!V.installed)c.push(H.identifier);else{const te=X(x,H,V,V);y.push(m(te,x)),a.set(x,te)}else V.installed&&d.push(m(V,x))}for(const x of q.added.values())Y.added.has(x)||a.set(x,(0,D.$Uf)(t.get(x)));for(const x of q.updated.values()){if(Y.removed.has(x)||Y.updated.has(x))continue;const V=(0,D.$Uf)(t.get(x)),Q=(0,D.$Uf)(r.get(x));a.set(x,X(x,V,Q,V))}for(const x of q.removed.values())Y.updated.has(x)||Y.removed.has(x)||w.has(x)||(0,D.$Uf)(r.get(x)).installed&&b&&(b.has(x)||!(0,D.$Uf)(v?.get(x)).installed||a.delete(x))}const N=[],T=I(r,a,new Set,!0),M=T.added.size>0||T.updated.size>0||T.removed.size>0;return M&&a.forEach((q,Y)=>N.push(m(q,Y))),{local:{added:d,removed:c,updated:y},remote:M?{added:[...T.added].map(q=>a.get(q)),updated:[...T.updated].map(q=>a.get(q)),removed:[...T.removed].map(q=>r.get(q)),all:N}:null}}e.$J7b=L;function I(h,$,p,E){const l=h?[...h.keys()].filter(i=>!p.has(i)):[],u=[...$.keys()].filter(i=>!p.has(i)),d=u.filter(i=>!l.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=l.filter(i=>!u.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),y=new Set;for(const i of l){if(c.has(i))continue;const o=h.get(i),n=$.get(i);(!n||!R(o,n,E,!0))&&y.add(i)}return{added:d,removed:c,updated:y}}function R(h,$,p,E){return!(h.disabled!==$.disabled||!!h.isApplicationScoped!=!!$.isApplicationScoped||E&&h.installed!==$.installed||h.installed&&$.installed&&(h.preRelease!==$.preRelease||h.pinned!==$.pinned||$.pinned&&h.version!==$.version)||!P(h.state,$.state)||p&&h.version!==$.version)}function S(h,$,p){const E=h.state,l=$.state,u=p?.state;if(!$.version||E&&A.gt(h.version,$.version))return E;if(l&&A.gt($.version,h.version)||!E)return l;if(!l)return E;const d=(0,O.$yn)(E),c=u?g(u,l):{added:Object.keys(l).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},y=u?g(u,E):{added:Object.keys(E).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])d[i]=l[i];for(const i of c.removed.values())y.updated.has(i)||delete d[i];return d}function g(h,$){const p=Object.keys(h),E=Object.keys($),l=E.filter(c=>!p.includes(c)).reduce((c,y)=>(c.add(y),c),new Set),u=p.filter(c=>!E.includes(c)).reduce((c,y)=>(c.add(y),c),new Set),d=new Set;for(const c of p){if(u.has(c))continue;const y=h[c],i=$[c];(0,O.$Cn)(y,i)||d.add(c)}return{added:l,removed:u,updated:d}}function P(h={},$={}){const{added:p,removed:E,updated:l}=g(h,$);return p.size===0&&E.size===0&&l.size===0}function k(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function m(h,$){const p={...h,identifier:{id:h.identifier.id,uuid:$.startsWith("uuid:")?$.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete p.disabled,h.installed||delete p.installed,h.state||delete p.state,h.isApplicationScoped||delete p.isApplicationScoped,p}}),define(le[111],he([0,1,17,21,4]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sIb=e.$rIb=void 0,e.$rIb=(0,D.$8h)("IIgnoredExtensionsManagementService");let L=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,S){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return g=g.filter(P=>P!==R&&P!==`-${R}`),S&&g.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,S){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return g=g.filter(P=>P!==R&&P!==`-${R}`),S&&g.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const S=R.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),g=this.b().map(m=>m.toLowerCase()),P=[],k=[];if(Array.isArray(g))for(const m of g)m.startsWith("-")?k.push(m.substring(1)):P.push(m);return(0,O.$Mb)([...S,...P].filter(m=>!k.includes(m)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$sIb=L,e.$sIb=L=pe([K(0,A.$Bi)],L)}),define(le[236],he([0,1,17,34,30,94,80]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=void 0;function R(c){return(0,A.$fn)(c)||[]}async function S(c,y,i,o,n){const s=R(c),t=R(y),r=i?R(i):null,a=[...s,...t,...r||[]].map(X=>X.key),v=await n.resolveUserBindings(a),w=P(s,t,r,v);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:y,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const f=m(s),b=m(t),C=r?m(r):null,N=$(f,b,v),T=C?$(C,f,v):{added:[...f.keys()].reduce((X,x)=>(X.add(x),X),new Set),removed:new Set,updated:new Set},M=C?$(C,b,v):{added:[...b.keys()].reduce((X,x)=>(X.add(x),X),new Set),removed:new Set,updated:new Set},q=g(N,T,M);let Y=c;for(const X of q.removed.values())q.conflicts.has(X)||(Y=u(Y,X,o));for(const X of q.added.values()){if(q.conflicts.has(X))continue;const x=b.get(X);if(x.some(V=>V.command!==`-${X}`&&w.conflicts.has(v[V.key]))){q.conflicts.add(X);continue}Y=l(Y,x,o)}for(const X of q.updated.values()){if(q.conflicts.has(X))continue;const x=b.get(X);if(x.some(V=>V.command!==`-${X}`&&w.conflicts.has(v[V.key]))){q.conflicts.add(X);continue}Y=d(Y,X,x,o)}return{mergeContent:Y,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.$P7b=S;function g(c,y,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of y.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(y.updated.has(r)?t.add(r):n.add(r));for(const r of y.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(y.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of y.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(y.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function P(c,y,i,o){const n=new Set,s=k(c,o),t=k(y,o),r=i?k(i,o):null,a=h(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?h(r,s):{added:[...s.keys()].reduce((T,M)=>(T.add(M),T),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=r?h(r,t):{added:[...t.keys()].reduce((T,M)=>(T.add(M),T),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:f,removed:b,updated:C,conflicts:N}=g(a,v,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:b,updated:C,conflicts:N}}function k(c,y){const i=new Map;for(const o of c){const n=y[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function m(c){const y=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=y.get(o);n||(n=[],y.set(o,n)),n.push(i)}return y}function h(c,y){const i=[...c.keys()],o=[...y.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(w=>({...w,key:r})),v=y.get(r).map(w=>({...w,key:r}));(0,O.$ub)(a,v,(w,f)=>E(w,f))||t.add(r)}return{added:n,removed:s,updated:t}}function $(c,y,i){const o=[...c.keys()],n=[...y.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const v=c.get(a).map(f=>({...f,key:i[f.key]})),w=y.get(a).map(f=>({...f,key:i[f.key]}));p(v,w)||r.add(a)}return{added:s,removed:t,updated:r}}function p(c,y){return!(!(0,O.$ub)(c.filter(({command:i})=>i[0]!=="-"),y.filter(({command:i})=>i[0]!=="-"),(i,o)=>E(i,o))||!(0,O.$ub)(c.filter(({command:i})=>i[0]==="-"),y.filter(({command:i})=>i[0]==="-"),(i,o)=>E(i,o)))}function E(c,y){if(c.command!==y.command||c.key!==y.key)return!1;const i=L.$6i.deserialize(c.when),o=L.$6i.deserialize(y.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!D.$Cn(c.args,y.args))}function l(c,y,i){for(const o of y)c=I.edit(c,[-1],o,i);return c}function u(c,y,i){const o=R(c);for(let n=o.length-1;n>=0;n--)(o[n].command===y||o[n].command===`-${y}`)&&(c=I.edit(c,[n],void 0,i));return c}function d(c,y,i,o){const n=R(c),s=n.findIndex(t=>t.command===y||t.command===`-${y}`);for(let t=n.length-1;t>=0;t--)(n[t].command===y||n[t].command===`-${y}`)&&(c=I.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=I.edit(c,[s],i[t],o);return c}}),define(le[237],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X7b=e.$W7b=void 0;function O(L,I,R){const S={},g={},P=new Set;if(!I)return{local:{added:S,updated:g,removed:[...P.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const k=A(L,I);if(k.added.size===0&&k.removed.size===0&&k.updated.size===0)return{local:{added:S,updated:g,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=A(R,L),h=A(R,I),$={},p={},E=new Set,l=new Set;for(const u of m.removed.values())h.updated.has(u)?S[u]=I[u]:E.add(u);for(const u of h.removed.values())l.has(u)||(m.updated.has(u)?l.add(u):P.add(u));for(const u of m.updated.values())l.has(u)||(h.updated.has(u)?k.updated.has(u)&&l.add(u):p[u]=L[u]);for(const u of h.updated.values())l.has(u)||(m.updated.has(u)?k.updated.has(u)&&l.add(u):L[u]!==void 0&&(g[u]=I[u]));for(const u of m.added.values())l.has(u)||(h.added.has(u)?k.updated.has(u)&&l.add(u):$[u]=L[u]);for(const u of h.added.values())l.has(u)||(m.added.has(u)?k.updated.has(u)&&l.add(u):S[u]=I[u]);return{local:{added:S,removed:[...P.values()],updated:g},remote:{added:$,removed:[...E.values()],updated:p},conflicts:[...l.values()]}}e.$W7b=O;function A(L,I){const R=L?Object.keys(L):[],S=I?Object.keys(I):[],g=S.filter(m=>!R.includes(m)).reduce((m,h)=>(m.add(h),m),new Set),P=R.filter(m=>!S.includes(m)).reduce((m,h)=>(m.add(h),m),new Set),k=new Set;for(const m of R){if(P.has(m))continue;const h=L[m],$=I[m];h!==$&&k.add(m)}return{added:g,removed:P,updated:k}}function D(L,I){const{added:R,removed:S,updated:g}=A(L,I);return R.size===0&&S.size===0&&g.size===0}e.$X7b=D}),define(le[238],he([0,1,30]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H9b=void 0;function A(L,I,R,S){const g={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!I){const m=L.filter(({id:h})=>!S.includes(h));return m.length?P.added=m:P=null,{local:g,remote:P}}const k=D(L,I,S);if(k.added.length>0||k.removed.length>0||k.updated.length>0){const m=D(R,L,S),h=D(R,I,S);for(const $ of h.removed){const p=L.find(E=>E.id===$);p&&g.removed.push(p)}for(const $ of h.added){const p=I.find(E=>E.id===$);m.added.includes($)?k.updated.includes($)&&g.updated.push(p):g.added.push(p)}for(const $ of h.updated)g.updated.push(I.find(p=>p.id===$));for(const $ of m.added)h.added.includes($)||P.added.push(L.find(p=>p.id===$));for(const $ of m.updated)h.removed.includes($)||h.updated.includes($)||P.updated.push(L.find(p=>p.id===$));for(const $ of m.removed){const p=I.find(E=>E.id===$);p&&P.removed.push(p)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:g,remote:P}}e.$H9b=A;function D(L,I,R){L=L?L.filter(({id:h})=>!R.includes(h)):[],I=I.filter(({id:h})=>!R.includes(h));const S=L.map(({id:h})=>h),g=I.map(({id:h})=>h),P=g.filter(h=>!S.includes(h)),k=S.filter(h=>!g.includes(h)),m=[];for(const{id:h,name:$,shortName:p,icon:E,useDefaultFlags:l}of L){if(k.includes(h))continue;const u=I.find(d=>d.id===h);(!u||u.name!==$||u.shortName!==p||u.icon!==E||!(0,O.$Cn)(u.useDefaultFlags,l))&&m.push(h)}return{added:P,removed:k,updated:m}}}),define(le[25],he([0,1,17,12,174,44,29,4,103,41]),function(se,e,O,A,D,L,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vob=e.$uob=e.$tob=e.$sob=e.$rob=e.$qob=e.$pob=e.$oob=e.$nob=e.$mob=e.$lob=e.MergeState=e.Change=e.SyncStatus=e.$kob=e.$job=e.$iob=e.UserDataSyncErrorCode=e.$hob=e.$gob=e.$fob=e.$eob=e.$dob=e.$cob=e.$bob=e.$aob=e.$_nb=e.SyncResource=e.$$nb=e.$0nb=e.$9nb=e.$8nb=e.$7nb=e.$6nb=void 0;function P(){const t=g.$Kn.as(L.$Pn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$6nb=P;function k(){const t=g.$Kn.as(L.$Pn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(w=>!!t[w].ignoreSync),a=Object.keys(t).filter(w=>t[w].scope===2||t[w].scope===6),v=P();return(0,O.$Mb)([...r,...a,...v])}e.$7nb=k,e.$8nb="settingsSync",e.$9nb="settingsSync.keybindingsPerPlatform";function m(){const t="vscode://schemas/ignoredSettings",r=g.$Kn.as(L.$Pn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.$9nb]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:I.$po,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.$Kn.as(S.$Ln.JSONContribution),v=()=>{const w=P(),f=k(),b=Object.keys(L.$Qn.properties).filter(T=>!f.includes(T)),C=f.filter(T=>!w.includes(T)),N={items:{type:"string",enum:[...b,...C.map(T=>`-${T}`)]}};a.registerSchema(t,N)};return r.onDidUpdateConfiguration(()=>v())}e.$0nb=m;function h(t){return t&&(0,A.$Lf)(t)&&(0,A.$Jf)(t.id)&&Array.isArray(t.scopes)}e.$$nb=h;var $;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})($||(e.SyncResource=$={})),e.$_nb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(t,...r){return t?[t,...r]:r}e.$aob=p;function E(t,r,a,v){return v.joinPath(a.userDataSyncHome,...p(t,r,`lastSync${r}.json`))}e.$bob=E,e.$cob=(0,R.$8h)("IUserDataSyncStoreManagementService"),e.$dob=(0,R.$8h)("IUserDataSyncStoreService"),e.$eob=(0,R.$8h)("IUserDataSyncLocalStoreService"),e.$fob="x-operation-id",e.$gob="X-Execution-Id";function l(t){const r={};return r[e.$gob]=t,r}e.$hob=l;var u;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class d extends Error{constructor(r,a,v,w){super(r),this.code=a,this.resource=v,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$iob=d;class c extends d{constructor(r,a,v,w,f){super(r,v,void 0,f),this.url=a,this.serverCode=w}}e.$job=c;class y extends d{constructor(r,a){super(r,a)}}e.$kob=y,function(t){function r(a){if(a instanceof t)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const w=v[2]==="unknown"?void 0:v[2],f=v[3]==="unknown"?void 0:v[3];return new t(a.message,v[1],w,f)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(d||(e.$iob=d={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$lob="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$mob=s,e.$nob=(0,R.$8h)("IUserDataSyncEnablementService"),e.$oob=(0,R.$8h)("IUserDataSyncService"),e.$pob=(0,R.$8h)("IUserDataSyncResourceProviderService"),e.$qob=(0,R.$8h)("IUserDataAutoSyncService"),e.$rob=(0,R.$8h)("IUserDataSyncUtilService"),e.$sob=(0,R.$8h)("IUserDataSyncLogService"),e.$tob="userDataSync",e.$uob="vscode-userdata-sync",e.$vob="preview"}),define(le[239],he([0,1,30,25]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MHb=void 0;function D(I,R,S,g,P){if(!R)return{remote:{added:Object.keys(I),removed:[],updated:[],all:Object.keys(I).length>0?I:null},local:{added:{},removed:[],updated:{}}};const k=L(I,R);if(k.added.size===0&&k.removed.size===0&&k.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=S?L(S,R):{added:Object.keys(R).reduce((u,d)=>(u.add(d),u),new Set),removed:new Set,updated:new Set},h=S?L(S,I):{added:Object.keys(I).reduce((u,d)=>(u.add(d),u),new Set),removed:new Set,updated:new Set},$={added:{},removed:[],updated:{}},p=O.$yn(R),E=!S;for(const u of h.added.values())u!==A.$lob&&E&&m.added.has(u)||(p[u]=I[u]);for(const u of h.updated.values())p[u]=I[u];for(const u of h.removed.values())g.unregistered.includes(u)||delete p[u];for(const u of m.added.values()){const d=R[u];if(g.machine.includes(u)){P.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(S&&h.added.has(u))continue;const c=I[u];c&&c.value===d.value||u===A.$lob&&E&&h.added.has(u)||(c?$.updated[u]=d:$.added[u]=d)}for(const u of m.updated.values()){const d=R[u];if(g.machine.includes(u)){P.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(u)||h.removed.has(u))continue;const c=I[u];c&&c.value===d.value||($.updated[u]=d)}for(const u of m.removed.values()){if(g.machine.includes(u)){P.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}h.updated.has(u)||h.removed.has(u)||$.removed.push(u)}const l=L(R,p);return{local:$,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:p}}}e.$MHb=D;function L(I,R){const S=Object.keys(I),g=Object.keys(R),P=g.filter(h=>!S.includes(h)).reduce((h,$)=>(h.add($),h),new Set),k=S.filter(h=>!g.includes(h)).reduce((h,$)=>(h.add($),h),new Set),m=new Set;for(const h of S){if(k.has(h))continue;const $=I[h],p=R[h];O.$Cn($,p)||m.add(h)}return{added:P,removed:k,updated:m}}}),define(le[240],he([0,1,17,34,62,42,30,80,25]),function(se,e,O,A,D,L,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tGb=e.$sGb=e.$rGb=e.$qGb=e.$pGb=e.$oGb=void 0;function g(a,v,w){let f=[];w?f=k(w):f=P(v);const b=[],C=[...(0,S.$6nb)()];if(Array.isArray(f))for(const N of f)N.startsWith("-")?C.push(N.substring(1)):b.push(N);return(0,O.$Mb)([...a,...b].filter(N=>!C.includes(N)))}e.$oGb=g;function P(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function k(a){const v=(0,A.$fn)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function m(a,v){const w=(0,A.$fn)(a)||{};let f="{}";for(const b of Object.keys(w)){const C=(0,D.$un)(f,[b],w[b],v);f=(0,D.$xn)(f,C)}return f}e.$pGb=m;function h(a,v,w,f){if(w.length){const b=r(v),C=(0,A.$fn)(v)||{},N=(0,A.$fn)(a);if(!N)return a;const T=[];for(const M of w){const q=C[M],Y=N[M];q===void 0?a=R.edit(a,[M],void 0,f):Y!==void 0?a=R.edit(a,[M],q,f):T.push(i(M,b))}T.sort((M,q)=>M.startOffset-q.startOffset),T.forEach(M=>a=u(M.setting.key,v,a,f))}return a}e.$qGb=h;function $(a,v,w,f,b,C){const N=h(a,v,f,C),T=w!==N,M=w!==v;if(!T&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(T&&!M)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(M&&!T)return{conflictsSettings:[],localContent:h(v,a,f,C),remoteContent:null,hasConflicts:!1};if(w===null&&E(a)){const F=p(a,v,f)?null:h(v,a,f,C);return{conflictsSettings:[],localContent:F,remoteContent:null,hasConflicts:!1}}let q=a,Y=v;const X=(0,A.$fn)(a),x=(0,A.$fn)(v),V=w?(0,A.$fn)(w):null,Q=f.reduce((F,B)=>(F.add(B),F),new Set),H=l(X,x,Q),W=l(V,X,Q),te=l(V,x,Q),oe=new Map,ee=new Set,ae=F=>{ee.add(F);const B=b.filter(({key:U})=>U===F)[0];B?(q=R.edit(q,[F],B.value,C),Y=R.edit(Y,[F],B.value,C)):oe.set(F,{key:F,localValue:X[F],remoteValue:x[F]})};for(const F of W.removed.values())te.updated.has(F)?ae(F):Y=R.edit(Y,[F],void 0,C);for(const F of te.removed.values())ee.has(F)||(W.updated.has(F)?ae(F):q=R.edit(q,[F],void 0,C));for(const F of W.updated.values())ee.has(F)||(te.updated.has(F)?H.updated.has(F)&&ae(F):Y=R.edit(Y,[F],X[F],C));for(const F of te.updated.values())ee.has(F)||(W.updated.has(F)?H.updated.has(F)&&ae(F):q=R.edit(q,[F],x[F],C));for(const F of W.added.values())ee.has(F)||(te.added.has(F)?H.updated.has(F)&&ae(F):Y=u(F,q,Y,C));for(const F of te.added.values())ee.has(F)||(W.added.has(F)?H.updated.has(F)&&ae(F):q=u(F,Y,q,C));const G=oe.size>0||!p(q,Y,f),z=G||!p(q,a,[]),j=G||!p(Y,v,[]);return{localContent:z?q:null,remoteContent:j?Y:null,conflictsSettings:[...oe.values()],hasConflicts:G}}e.$rGb=$;function p(a,v,w){if(a===v)return!0;const f=(0,A.$fn)(a),b=(0,A.$fn)(v),C=w.reduce((M,q)=>(M.add(q),M),new Set),N=r(a).filter(M=>!(M.setting&&C.has(M.setting.key))),T=r(v).filter(M=>!(M.setting&&C.has(M.setting.key)));if(N.length!==T.length)return!1;for(let M=0;M<N.length;M++){const q=N[M],Y=T[M];if(q.setting&&Y.setting){if(q.setting.key!==Y.setting.key||!I.$Cn(f[q.setting.key],b[q.setting.key]))return!1}else if(!q.setting&&!Y.setting){if(q.value!==Y.value)return!1}else return!1}return!0}function E(a){return a?r(a).length===0:!0}e.$sGb=E;function l(a,v,w){const f=a?Object.keys(a).filter(M=>!w.has(M)):[],b=Object.keys(v).filter(M=>!w.has(M)),C=b.filter(M=>!f.includes(M)).reduce((M,q)=>(M.add(q),M),new Set),N=f.filter(M=>!b.includes(M)).reduce((M,q)=>(M.add(q),M),new Set),T=new Set;if(a)for(const M of f){if(N.has(M))continue;const q=a[M],Y=v[M];I.$Cn(q,Y)||T.add(M)}return{added:C,removed:N,updated:T}}function u(a,v,w,f){const b=(0,A.$fn)(v),C=r(v),N=r(w),T=d(a,C,N);return c(w,a,b[a],T,N,f)}e.$tGb=u;function d(a,v,w){const f=v.findIndex(C=>C.setting?.key===a),b=v[f-1];if(b){if(b.setting){const N=i(b.setting.key,w);if(N)return{index:w.indexOf(N),insertAfter:!0}}else{const N=o(f,v);if(N){const T=i(N.setting.key,w);if(T){const M=n(w.indexOf(T),w),q=s(v,N,v[f]);if(M){const Y=s(w,T,M),X=t(q,Y);return X?{index:w.indexOf(X),insertAfter:!0}:{index:w.indexOf(M),insertAfter:!1}}else{const Y=s(w,T,w[w.length-1]),X=t(q,Y);return X?{index:w.indexOf(X),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const C=v[f+1];if(C)if(C.setting){const N=i(C.setting.key,w);if(N)return{index:w.indexOf(N),insertAfter:!1}}else{const N=n(f,v);if(N){const T=i(N.setting.key,w);if(T){const M=o(w.indexOf(T),w),q=s(v,v[f],N);if(M){const Y=s(w,M,T),X=t(q.reverse(),Y.reverse());return X?{index:w.indexOf(X),insertAfter:!1}:{index:w.indexOf(M),insertAfter:!0}}else{const Y=s(w,w[0],T),X=t(q.reverse(),Y.reverse());return X?{index:w.indexOf(X),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function c(a,v,w,f,b,C){let N;return f.index===-1?N=(0,D.$un)(a,[v],w,C):N=y(a,v,w,f,b,C).map(T=>(0,D.$vn)(a,T,C)[0]),(0,D.$xn)(a,N)}function y(a,v,w,f,b,C){const N=`${JSON.stringify(v)}: ${JSON.stringify(w)}`,T=(0,L.$rn)(C,a),M=b[f.index];if(f.insertAfter){const q=[];if(M.setting)q.push({offset:M.endOffset,length:0,content:","+N});else{const Y=n(f.index,b),X=o(f.index,b),x=X?.setting?.commaOffset;X&&x===void 0&&q.push({offset:X.endOffset,length:0,content:","});const V=x!==void 0&&x>M.endOffset;q.push({offset:V?x+1:M.endOffset,length:0,content:Y?T+N+",":T+N})}return q}else{if(M.setting)return[{offset:M.startOffset,length:0,content:N+","}];const q=(b[f.index-1]&&!b[f.index-1].setting?T:"")+N+(n(f.index,b)?",":"")+T;return[{offset:M.startOffset,length:0,content:q}]}}function i(a,v){return v.filter(w=>w.setting?.key===a)[0]}function o(a,v){for(let w=a-1;w>=0;w--)if(v[w].setting)return v[w]}function n(a,v){for(let w=a+1;w<v.length;w++)if(v[w].setting)return v[w]}function s(a,v,w){const f=a.indexOf(v),b=a.indexOf(w);return a.filter((C,N)=>f<N&&N<b)}function t(a,v){if(a.length&&v.length){let w=0;for(;w<v.length&&w<a.length;w++)if(a[w].value!==v[w].value)return v[w-1];return v[w-1]}}function r(a){const v=[];let w=-1,f,b;const C={onObjectBegin:N=>{w++},onObjectProperty:(N,T,M)=>{w===0&&(f=T,b=N)},onObjectEnd:(N,T)=>{w--,w===0&&v.push({startOffset:f,endOffset:N+T,value:a.substring(f,N+T),setting:{key:b,commaOffset:void 0}})},onArrayBegin:(N,T)=>{w++},onArrayEnd:(N,T)=>{w--,w===0&&v.push({startOffset:f,endOffset:N+T,value:a.substring(f,N+T),setting:{key:b,commaOffset:void 0}})},onLiteralValue:(N,T,M)=>{w===0&&v.push({startOffset:f,endOffset:T+M,value:a.substring(f,T+M),setting:{key:b,commaOffset:void 0}})},onSeparator:(N,T,M)=>{if(w===0&&N===","){let q=v.length-1;for(;q>=0&&!v[q].setting;q--);const Y=v[q];Y&&v.splice(q,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:T}})}},onComment:(N,T)=>{w===0&&v.push({startOffset:N,endOffset:N+T,value:a.substring(N,N+T)})}};return(0,A.$mn)(a,C),v}}),define(le[81],he([0,1,3,2,4,25]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Fb=e.$$Fb=void 0,e.$$Fb=(0,D.$8h)("IUserDataSyncAccountService");let I=class extends A.$Tc{get account(){return this.a}constructor(S,g){super(),this.g=S,this.h=g,this.b=this.B(new O.$Wd),this.onDidChangeAccount=this.b.event,this.c=this.B(new O.$Wd),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(P=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,P),this.updateAccount(void 0),P==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$_Fb=I,e.$_Fb=I=pe([K(0,L.$dob),K(1,L.$sob)],I)}),define(le[241],he([0,1,20,175,15,8,25]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tIb=void 0;let R=class extends L.$uj{constructor(g,P){super(),this.g=this.B(g.createLogger((0,O.$Ig)(P.logsHome,`${I.$tob}.log`),{id:I.$tob,name:(0,A.localize)(0,null)}))}trace(g,...P){this.g.trace(g,...P)}debug(g,...P){this.g.debug(g,...P)}info(g,...P){this.g.info(g,...P)}warn(g,...P){this.g.warn(g,...P)}error(g,...P){this.g.error(g,...P)}flush(){this.g.flush()}};e.$tIb=R,e.$tIb=R=pe([K(0,L.$qj),K(1,D.$ci)],R)}),define(le[242],he([0,1,6,3,2]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1$b=void 0;class L extends D.$Tc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:S,getActiveWindowId:g}){super(),this.a=this.B(new D.$Sc),A.Event.latch(A.Event.any(R,S))(this.f,this,this.a),this.b=(0,O.$Ug)(()=>g()),(async()=>{try{const k=await this.b;this.c=typeof this.c=="number"?this.c:k}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$1$b=L}),define(le[112],he([0,1,178,16,48,20,9,4,23]),function(se,e,O,A,D,L,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.WorkbenchState=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0,e.$ei=(0,R.$8h)("contextService");function g(s){const t=s;return typeof t?.id=="string"&&I.URI.isUri(t.uri)}e.$fi=g;function P(s){return typeof s?.id=="string"&&!g(s)&&!m(s)}e.$gi=P,e.$hi={id:"ext-dev"},e.$ii={id:"empty-window"};function k(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,A.$nc)(s)}:t?e.$hi:e.$ii;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$ji=k;function m(s){const t=s;return typeof t?.id=="string"&&I.URI.isUri(t.configPath)}e.$ki=m;function h(s){const t=s;if(t?.uri)return{id:t.id,uri:I.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:I.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$li=h;var $;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function p(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$mi=p;function E(s){const t=s;return!!(t&&typeof t=="object"&&I.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$ni=E;class l{constructor(t,r,a,v,w){this.h=t,this.j=a,this.k=v,this.l=w,this.c=D.$bi.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=D.$bi.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$oi=l;class u{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.$Ig)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$pi=u;function d(s){return new u({uri:s,index:0,name:(0,L.$Eg)(s)},{uri:s.toString()})}e.$qi=d,e.$ri="code-workspace",e.$si=`.${e.$ri}`,e.$ti=[{name:(0,O.localize)(0,null),extensions:[e.$ri]}],e.$ui="workspace.json";function c(s,t){return L.$zg.isEqualOrParent(s,t.untitledWorkspacesHome)}e.$vi=c;function y(s){let t;return I.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===S.Schemas.tmp}e.$wi=y,e.$xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$xi}e.$yi=i;function o(s,t){return!c(s,t)&&!y(s)}e.$zi=o;function n(s){return(typeof s=="string"?(0,A.$oc)(s):(0,L.$Gg)(s))===e.$si}e.$Ai=n}),define(le[18],he([0,1,53,3,2,20,9,169,15,11,4,8,112,35,28,6,32,27,12]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.ProfileResourceType=void 0;var d;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&I.URI.isUri(t.location)&&I.URI.isUri(t.globalStorageHome)&&I.URI.isUri(t.settingsResource)&&I.URI.isUri(t.keybindingsResource)&&I.URI.isUri(t.tasksResource)&&I.URI.isUri(t.snippetsHome)&&I.URI.isUri(t.extensionsResource))}e.$4k=c,e.$5k=(0,P.$8h)("IUserDataProfilesService");function y(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:I.URI.revive(s.location).with({scheme:t}),globalStorageHome:I.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:I.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:I.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:I.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:I.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:I.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:I.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$6k=y;function i(s,t,r,a,v,w){return{id:s,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:w&&v?.useDefaultFlags?.globalState?w.globalStorageHome:(0,L.$Ig)(r,"globalStorage"),settingsResource:w&&v?.useDefaultFlags?.settings?w.settingsResource:(0,L.$Ig)(r,"settings.json"),keybindingsResource:w&&v?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,L.$Ig)(r,"keybindings.json"),tasksResource:w&&v?.useDefaultFlags?.tasks?w.tasksResource:(0,L.$Ig)(r,"tasks.json"),snippetsHome:w&&v?.useDefaultFlags?.snippets?w.snippetsHome:(0,L.$Ig)(r,"snippets"),extensionsResource:w&&v?.useDefaultFlags?.extensions?w.extensionsResource:(0,L.$Ig)(r,"extensions.json"),cacheHome:(0,L.$Ig)(a,s),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$7k=i;let o=class extends D.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,v){super(),this.t=t,this.u=r,this.w=a,this.y=v,this.f=!0,this.h=this.B(new A.$Wd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$Wd),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$Wd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$Wd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$Ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$Ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,u.$Jf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}r.push(i((0,L.$Fg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},t))}}catch(w){this.y.error(w)}const a=new h.$Ac,v=new Map;if(r.length)try{const w=this.Q();if(w.workspaces)for(const[f,b]of Object.entries(w.workspaces)){const C=I.URI.parse(f),N=r.find(T=>T.id===b);N&&a.set(C,N)}if(w.emptyWindows)for(const[f,b]of Object.entries(w.emptyWindows)){const C=r.find(N=>N.id===b);C&&v.set(f,C)}}catch(w){this.y.error(w)}this.z={profiles:r,workspaces:a,emptyWindows:v}}return this.z}D(){const t=i("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,l.$Pe)(r)}\\s(\\d+)`);let v=0;for(const f of this.profiles){const b=a.exec(f.name),C=b?parseInt(b[1]):0;v=C>v?C:v}const w=`${r} ${v+1}`;return this.createProfile((0,O.$Vi)((0,E.$rg)()).toString(16),w,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,O.$Vi)((0,E.$rg)()).toString(16),t,r,a)}async createProfile(t,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(t,r,a);return v&&await this.setProfileForWorkspace(v,w),w}async F(t,r,a){if(!(0,u.$Jf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const w=this.profiles.find(C=>C.name===r||C.id===t);if(w)return w;const f=i(t,r,(0,L.$Ig)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(f.location);const b=[];return this.j.fire({profile:f,join(C){b.push(C)}}),await p.Promises.settled(b),this.I([f],[],[]),f}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,g.$Jk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return I.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,m.$fi)(t)?t.uri:(0,m.$ki)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const v=[...this.profiles,...t],w=[];this.s.profiles=[];for(let f of v)f.isDefault||r.some(b=>f.id===b.id)||(f=a.find(b=>f.id===b.id)??f,f.isTransient?this.s.profiles.push(f):w.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(w),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const v=this.G(t),w=a?this.s:this.C;I.URI.isUri(v)?(w.workspaces.delete(v),r&&w.workspaces.set(v,r)):(w.emptyWindows.delete(v),r&&w.emptyWindows.set(v,r)),a||this.M()}M(){const t={};for(const[a,v]of this.C.workspaces.entries())t[a.toString()]=v.id;const r={};for(const[a,v]of this.C.emptyWindows.entries())r[a.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[w,f]of Object.entries(t.workspaces)){const b=I.URI.parse(f);r[w]=this.w.extUri.isEqual(b,a.location)?a.id:this.w.extUri.basename(b)}const v={};if(t.emptyWindows)for(const[w,f]of Object.entries(t.emptyWindows)){const b=I.URI.parse(f);v[w]=this.w.extUri.isEqual(b,a.location)?a.id:this.w.extUri.basename(b)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$8k=o,e.$8k=o=pe([K(0,S.$ci),K(1,g.$sk),K(2,$.$3k),K(3,k.$pj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$9k=n}),define(le[243],he([0,1,6,2,18]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aac=void 0;let L=class extends A.$Tc{constructor(R){super(),this.B(new O.$hh(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$aac=L,e.$aac=L=pe([K(0,D.$5k)],L)}),define(le[244],he([0,1,17,6,26,7,3,2,5,12,9,152,29,33,45,8,24,22,28,18]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;let c=class extends R.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,v,w,f){super(),this.z=t,this.C=r,this.D=a,this.F=v,this.G=w,this.H=f,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new I.$Wd),this.s=this.B(new I.$Wd),this.t=this.B(new I.$Wd),this.u=this.B(new I.$Wd),this.w=this.B(new I.$Wd),this.y=[],this.B((0,R.$Rc)(()=>{this.j.forEach(({task:b})=>b.cancel()),this.m.forEach(b=>b.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,m.$zo)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:w})=>(0,h.$3o)(w,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:new m.$Co(`Unknown error while installing extension ${t.identifier.id}`,m.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new m.$Co(k.localize(0,null),m.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:v,options:w})=>{try{const f=await this.N(v,!!w?.installGivenVersion,!!w?.installPreReleaseVersion);a.push({...f,options:w})}catch(f){r.push({identifier:v.identifier,operation:2,source:v,error:f})}})),a.length&&r.push(...await this.I(a));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!P.URI.isUri(v.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,h.$$o)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,r)}async toggleAppliationScope(t,r){if((0,$.$qm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const w=(await this.getInstalled(1,v.extensionsResource)).find(f=>(0,h.$3o)(f.identifier,t.identifier));w?this.w.fire(w):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[],a=new Map,v=[],w=[],f=(C,N)=>`${h.$4o.create(C).toString()}-${N.toString()}`,b=(C,N,T)=>{const M=this.Y(C,N,T),q=P.URI.isUri(N)?N.path:`${N.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`;a.set(q,{task:M,manifest:C}),this.n.fire({identifier:M.identifier,source:N,profileLocation:T.profileLocation}),this.F.info("Installing extension:",M.identifier.id),P.URI.isUri(N)||this.j.set(f(N,T.profileLocation),{task:M,waitingTasks:[]})};try{for(const{manifest:C,extension:N,options:T}of t){const M=T.isApplicationScoped||T.isBuiltin||(0,$.$qm)(C),q={...T,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(N)?T.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:M,profileLocation:M?this.H.defaultProfile.extensionsResource:T.profileLocation??this.X()},Y=P.URI.isUri(N)?void 0:this.j.get(f(N,q.profileLocation));Y?(this.F.info("Extension is already requested to install",Y.task.identifier.id),v.push(Y.task.waitUntilTaskIsFinished())):b(C,N,q)}await Promise.all([...a.values()].map(async({task:C,manifest:N})=>{if(C.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",C.identifier.id);else try{const T=await this.M(C.identifier,N,!!C.options.installOnlyNewlyAddedFromExtensionPack,!!C.options.installPreReleaseVersion,C.options.profileLocation),M=await this.getInstalled(void 0,C.options.profileLocation),q={...C.options,donotIncludePackAndDependencies:!0,context:{...C.options.context,[m.$uo]:!0}};for(const{gallery:Y,manifest:X}of(0,O.$Mb)(T,({gallery:x})=>x.identifier.id)){if(a.has(`${Y.identifier.id.toLowerCase()}-${q.profileLocation.toString()}`))continue;const x=this.j.get(f(Y,q.profileLocation));if(x){if(this.J(C,x.task)){const V=x.task.identifier;this.F.info("Waiting for already requested installing extension",V.id,C.identifier.id),x.waitingTasks.push(C),v.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,Q=>Q.some(H=>(0,h.$3o)(H.identifier,V)))).then(Q=>{if(this.F.info("Finished waiting for already requested installing extension",V.id,C.identifier.id),!Q.find(W=>(0,h.$3o)(W.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else M.some(({identifier:V})=>(0,h.$3o)(V,Y.identifier))||b(X,Y,q)}}catch(T){if(P.URI.isUri(C.source))(0,O.$Lb)(N.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",C.identifier.id,T.message),(0,O.$Lb)(N.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",C.identifier.id,T.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",C.identifier.id),T}})),await this.L([...a.values()].map(async({task:C})=>{const N=new Date().getTime();try{const T=await C.run();if(await this.L(this.y.map(M=>M.postInstall(T,C.source,C.options,D.CancellationToken.None))),!P.URI.isUri(C.source)){const M=C.operation===3,q=M?void 0:(new Date().getTime()-C.source.lastUpdated)/1e3;if(o(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$$o)(C.source),verificationStatus:C.verificationStatus,duration:new Date().getTime()-N,durationSinceUpdate:q}),S.$o&&C.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}w.push({local:T,identifier:C.identifier,operation:C.operation,source:C.source,context:C.options.context,profileLocation:C.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){throw this.F.error("Error while installing the extension",C.identifier.id,(0,L.$0)(T)),T}})),v.length&&await this.L(v);for(const C of w)this.F.info("Extension installed successfully:",C.identifier.id),r.push(C);return r}catch(C){w.length&&await Promise.allSettled(w.map(async({local:N,profileLocation:T})=>{try{await this.Z(N,{versionOnly:!0,profileLocation:T}).run(),this.F.info("Rollback: Uninstalled extension",N.identifier.id)}catch(M){this.F.warn("Rollback: Error while uninstalling extension",N.identifier.id,(0,L.$0)(M))}}));for(const{task:N}of a.values())N.cancel(),r.push({identifier:N.identifier,operation:2,source:N.source,context:N.options.context,profileLocation:N.profileLocation,error:C});throw C}finally{for(const{task:C}of a.values())C.source&&!P.URI.isUri(C.source)&&this.j.delete(f(C.source,C.profileLocation));r.length&&this.s.fire(r)}}J(t,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===t&&(v.includes(r)||v.some(w=>this.J(w,r)))||a===r&&v[0]&&!this.J(t,v[0]))return!1;return!0}async L(t){const r=[],a=[],v=await Promise.allSettled(t);for(const w of v)w.status==="fulfilled"?r.push(w.value):a.push(w.reason);if(a.length)throw y(a);return r}async M(t,r,a,v,w){if(!this.z.isEnabled())return[];const f=await this.getInstalled(void 0,w),b=[],C=[],N=async(T,M)=>{b.push(T);const q=M.extensionDependencies||[],Y=[...q];if(M.extensionPack){const X=a?f.find(x=>(0,h.$3o)(x.identifier,T)):void 0;for(const x of M.extensionPack)X&&X.manifest.extensionPack&&X.manifest.extensionPack.some(V=>(0,h.$3o)({id:V},{id:x}))||Y.every(V=>!(0,h.$3o)({id:V},{id:x}))&&Y.push(x)}if(Y.length){const X=Y.filter(x=>b.every(V=>!(0,h.$3o)(V,{id:x})));if(X.length){const x=await this.z.getExtensions(X.map(V=>({id:V,preRelease:v})),D.CancellationToken.None);for(const V of x){if(b.find(W=>(0,h.$3o)(W,V.identifier)))continue;const Q=q.some(W=>(0,h.$3o)({id:W},V.identifier));let H;try{H=await this.N(V,!1,v)}catch(W){if(Q)throw W;this.F.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,L.$0)(W));continue}C.push({gallery:H.extension,manifest:H.manifest}),await N(H.extension.identifier,H.manifest)}}}};return await N(t,r),C}async N(t,r,a){let v;const w=await this.getExtensionsControlManifest();if(w.malicious.some(C=>(0,h.$3o)(t.identifier,C)))throw new m.$Co(k.localize(1,null,t.identifier.id),m.ExtensionManagementErrorCode.Malicious);const f=w.deprecated[t.identifier.id.toLowerCase()];if(f?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${f.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:f.extension.id,preRelease:f.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0],!v)throw new m.$Co(k.localize(2,null,t.identifier.id,f.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const C=await this.getTargetPlatform();throw new m.$Co(k.localize(3,null,t.identifier.id,this.G.nameLong,(0,m.$vo)(C)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.O(t,r,a),!v)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],D.CancellationToken.None))[0]?new m.$Co(k.localize(4,null,t.displayName??t.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$Co(k.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const b=await this.z.getManifest(v,D.CancellationToken.None);if(b===null)throw new m.$Co(`Missing manifest for extension ${v.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(b.version!==v.version)throw new m.$Co(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:b}}async O(t,r,a){const v=await this.getTargetPlatform();let w=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(w=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:v,compatible:!0},D.CancellationToken.None))[0]||null),!w&&await this.z.isExtensionCompatible(t,a,v)&&(w=t),w||(r?w=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},D.CancellationToken.None))[0]||null:w=await this.z.getCompatibleExtension(t,a,v)),w}async P(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},v=T=>`${T.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,w=this.m.get(v(t.identifier));if(w)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),w.waitUntilTaskIsFinished();const f=T=>{const M=this.Z(T,a);return this.m.set(v(M.extension.identifier),M),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped}),M},b=(T,M)=>{M?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString(),M.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,M.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,h.$0o)(T),error:M}),this.u.fire({identifier:T.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped})},C=[],N=[];try{C.push(f(t));const T=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const M=this.S(t,T);for(const q of M)this.m.has(v(q.identifier))?this.F.info("Extensions is already requested to uninstall",q.identifier.id):C.push(f(q))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(C.map(M=>M.extension),T,t),await this.L(C.map(async M=>{try{if(await M.run(),await this.L(this.y.map(q=>q.postUninstall(M.extension,a,D.CancellationToken.None))),M.extension.identifier.uuid)try{await this.z.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}b(M.extension)}catch(q){const Y=q instanceof m.$Co?q:new m.$Co((0,L.$0)(q),m.ExtensionManagementErrorCode.Internal);throw b(M.extension,Y),Y}finally{N.push(M)}}))}catch(T){const M=T instanceof m.$Co?T:new m.$Co((0,L.$0)(T),m.ExtensionManagementErrorCode.Internal);for(const q of C){try{q.cancel()}catch{}N.includes(q)||b(q.extension,M)}throw M}finally{for(const T of C)this.m.delete(v(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}Q(t,r,a){for(const v of t){const w=this.U(v,r);if(w.length){const f=w.filter(b=>!t.some(C=>(0,h.$3o)(C.identifier,b.identifier)));if(f.length)throw new Error(this.R(v,f,a))}}}R(t,r,a){return a===t?r.length===1?k.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?k.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const w=r.filter(b=>!b.isBuiltin&&v.some(C=>(0,h.$3o)({id:C},b.identifier))),f=[];for(const b of w)f.push(...this.S(b,r,a));return[...w,...f]}return[]}U(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,h.$3o)({id:v},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$0)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$Sp=c,e.$Sp=c=pe([K(0,m.$Bo),K(1,l.$wl),K(2,u.$3k),K(3,p.$pj),K(4,E.$Hj),K(5,d.$5k)],c);function y(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$Tp=y;function i(s){if(s instanceof m.$Co)return s;if(s instanceof m.$Do){const r=new m.$Co(s.message,m.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new m.$Co(s.message,m.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}e.$Up=i;function o(s,t,{extensionData:r,verificationStatus:a,duration:v,error:w,durationSinceUpdate:f}){let b,C;(0,g.$Rf)(a)&&(a===!0?a="Verified":(a===!1||(b=m.ExtensionManagementErrorCode.Signature,C=a),a="Unverified")),w&&(w instanceof m.$Co||w instanceof m.$Do?(b=w.code,w.code===m.ExtensionManagementErrorCode.Signature&&(C=w.message)):b=m.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!w,duration:v,errorcode:b,errorcodeDetail:C,durationSinceUpdate:f})}class n{constructor(){this.d=new A.$7g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.$Ug)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$Ug)(t=>new Promise((r,a)=>{const v=t.onCancellationRequested(()=>{v.dispose(),a(new L.$5)})})),this.d.open()),this.g.cancel()}}e.$Vp=n}),define(le[51],he([0,1,6,14,2,3,35,9,29,33,11,4,8,18,28,12,7,22]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class d extends Error{constructor(n,s){super(n),this.code=s}}e.$Wp=d,e.$Xp=(0,k.$8h)("IExtensionsProfileScannerService");let c=class extends D.$Tc{constructor(n,s,t,r,a,v){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=v,this.b=this.B(new L.$Wd),this.onAddExtensions=this.b.event,this.c=this.B(new L.$Wd),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$Wd),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$Wd),this.onDidRemoveExtensions=this.g.event,this.h=new I.$Ac}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s){const t=[],r=[];try{return await this.u(s,a=>{const v=[];for(const w of a)n.some(([f])=>(0,g.$3o)(f.identifier,w.identifier)&&f.manifest.version!==w.version)?t.push(w):v.push(w);for(const[w,f]of n){const b=v.findIndex(N=>(0,g.$3o)(N.identifier,w.identifier)&&N.version===w.manifest.version),C={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:f};b===-1?(r.push(C),v.push(C)):v.splice(b,1,C)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),t.length&&this.f.fire({extensions:t,profileLocation:s}),v}),r.length&&this.c.fire({extensions:r,profileLocation:s}),t.length&&this.g.fire({extensions:t,profileLocation:s}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:s}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const v of r){const w=n.find(([f])=>(0,g.$3o)(f.identifier,v.identifier)&&f.manifest.version===v.version);w&&(v.metadata={...v.metadata,...w[1]},t.push(v)),a.push(v)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const v of r)(0,g.$3o)(v.identifier,n.identifier)?t.push(v):a.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const v=await this.m.readFile(n);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,P.$Jk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new d((0,E.$0)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let v=!1;for(const w of a){y(w)||this.w(n);let f;if((0,p.$Jf)(w.relativeLocation)&&w.relativeLocation)f=this.z(w.relativeLocation);else if((0,p.$Jf)(w.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${w.location}`);continue}else{f=R.URI.revive(w.location);const b=this.y(f);b&&(v=!0,w.relativeLocation=b)}(0,p.$Qf)(w.metadata?.hasPreReleaseVersion)&&w.metadata?.preRelease&&(v=!0,w.metadata.hasPreReleaseVersion=!0),r.push({identifier:w.identifier,location:f,version:w.version,metadata:w.metadata})}v&&await this.m.writeFile(n,A.$ke.fromString(JSON.stringify(a)))}if(s){r=s(r);const v=r.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.y(w.location),metadata:w.metadata}));await this.m.writeFile(n,A.$ke.fromString(JSON.stringify(v)))}return r})}w(n){const s=new d(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,P.$Jk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(v=>y(v))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$ke.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,P.$Jk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,P.$Jk)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,P.$Jk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new O.$ch,this.h.set(n,s)),s}};e.$Yp=c,e.$Yp=c=pe([K(1,P.$sk),K(2,h.$5k),K(3,$.$3k),K(4,l.$wl),K(5,m.$pj)],c);function y(o){return(0,p.$Lf)(o)&&(0,S.$Ao)(o.identifier)&&(i(o.location)||(0,p.$Jf)(o.location)&&o.location)&&((0,p.$Qf)(o.relativeLocation)||(0,p.$Jf)(o.relativeLocation))&&o.version&&(0,p.$Jf)(o.version)}function i(o){return o?(0,p.$Jf)(o.path)&&(0,p.$Jf)(o.scheme):!1}}),define(le[82],he([0,1,17,6,30,14,7,34,138,2,23,16,5,20,55,89,12,9,155,15,33,45,71,11,4,8,24,3,66,51,18,28,183]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d,c,y,i,o,n,s,t,r,a,v,w,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.Translations=void 0;var C;(function(x){function V(Q,H){if(Q===H)return!0;const W=Object.keys(Q),te=new Set;for(const oe of Object.keys(H))te.add(oe);if(W.length!==te.size)return!1;for(const oe of W){if(Q[oe]!==H[oe])return!1;te.delete(oe)}return te.size===0}x.equals=V})(C||(e.Translations=C={})),e.$2p=(0,n.$8h)("IExtensionsScannerService");let N=class extends g.$Tc{constructor(V,Q,H,W,te,oe,ee,ae,G,z,j,F){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=Q,this.r=H,this.s=W,this.t=te,this.u=oe,this.w=ee,this.y=ae,this.z=G,this.C=z,this.D=j,this.F=F,this.g=this.B(new r.$Wd),this.onDidChangeCache=this.g.event,this.h=(0,h.$Ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(M,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,c.$bp)(this.w,this.y)),this.G}async scanAllExtensions(V,Q,H){const[W,te]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(Q)]),oe=H?await this.scanExtensionsUnderDevelopment(V,[...W,...te]):[];return this.L(W,te,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const Q=[];Q.push(this.M(!!V.useCache,V.language)),Q.push(this.N(V.language,!!V.checkControlFile));const[H,W]=await Promise.all(Q);return this.J([...H,...W],0,V,!1)}async scanUserExtensions(V){const Q=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const H=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(Q,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,H),te=V.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let oe;try{oe=await te.scanExtensions(W)}catch(ee){if(ee instanceof v.$Wp&&ee.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),oe=await te.scanExtensions(W);else throw ee}return oe=await this.J(oe,1,V,!0),this.y.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(V,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===P.Schemas.file).map(async W=>{const te=await this.P(W,!1,1,!0,V.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(te)).map(ee=>(ee.type=Q.find(ae=>(0,c.$3o)(ae.identifier,ee.identifier))?.type??ee.type,this.n.validate(ee,te)))}))).flat();return this.J(H,"development",V,!0)}return[]}async scanExistingExtension(V,Q,H){const W=await this.P(V,!1,Q,!0,H.language,!0,void 0),te=await this.n.scanExtension(W);return!te||!H.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(V,Q,H){const W=await this.P(V,!1,Q,!0,H.language,!0,void 0),te=await this.n.scanOneOrMultipleExtensions(W);return this.J(te,Q,H,!0)}async scanMetadata(V){const Q=(0,h.$Ig)(V,"package.json"),H=(await this.w.readFile(Q)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(V,Q){const H=(0,h.$Ig)(V,"package.json"),W=(await this.w.readFile(H)).value.toString(),te=JSON.parse(W);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,te.__metadata={...te.__metadata,...Q},await this.w.writeFile((0,h.$Ig)(V,"package.json"),L.$ke.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof v.$Wp&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$ke.fromString(JSON.stringify([])))}catch(Q){(0,o.$Jk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,Q,H,W){return H.includeAllVersions||(V=this.L(Q===0?V:void 0,Q===1?V:void 0,Q==="development"?V:void 0,await this.getTargetPlatform(),W)),H.includeInvalid||(V=V.filter(te=>te.isValid)),V.sort((te,oe)=>{const ee=k.$nc(te.location.fsPath),ae=k.$nc(oe.location.fsPath);return ee<ae?-1:ee>ae?1:0})}L(V,Q,H,W,te){const oe=(ae,G,z)=>{if(ae.isValid&&!G.isValid)return!1;if(ae.isValid===G.isValid){if(te&&$.gt(ae.manifest.version,G.manifest.version))return this.y.debug(`Skipping extension ${G.location.path} with lower version ${G.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if($.eq(ae.manifest.version,G.manifest.version)){if(ae.type===0)return this.y.debug(`Skipping extension ${G.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===W)return this.y.debug(`Skipping extension ${G.location.path} from different target platform ${G.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${ae.location.path} with ${G.location.path}.`):this.y.debug(`Overwriting user extension ${ae.location.path} with ${G.location.path}.`),!0},ee=new y.$pm;return V?.forEach(ae=>{const G=ee.get(ae.identifier.id);(!G||oe(G,ae,!1))&&ee.set(ae.identifier.id,ae)}),Q?.forEach(ae=>{const G=ee.get(ae.identifier.id);if(!G&&V&&ae.type===0){this.y.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!G||oe(G,ae,!1))&&ee.set(ae.identifier.id,ae)}),H?.forEach(ae=>{const G=ee.get(ae.identifier.id);(!G||oe(G,ae,!0))&&ee.set(ae.identifier.id,ae),ee.set(ae.identifier.id,ae)}),[...ee.values()]}async M(V,Q){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),te=await(V&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",te.length),te}async N(V,Q){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const W=Q?await this.O():{},te=[],oe=l.URI.file(k.$hc(k.$jc(P.$pg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of H){const G=W[ae.name]||"marketplace";switch(G){case"disabled":break;case"marketplace":te.push((0,h.$Ig)(oe,ae.name));break;default:te.push(l.URI.file(G));break}}const ee=await Promise.all(te.map(async ae=>this.n.scanExtension(await this.P(ae,!1,0,!0,V,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ee.length),(0,O.$Hb)(ee)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,Q,H,W,te,oe,ee){const ae=await this.f(te??m.$w),G=await this.Q(V),z=Q&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,j=z?await this.Q(z):void 0;return new T(V,G,z,j,Q,ee,H,W,oe,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,te,ae)}async Q(V){try{const Q=await this.w.stat(V);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$3p=N,e.$3p=N=pe([K(4,w.$5k),K(5,v.$Xp),K(6,o.$sk),K(7,s.$pj),K(8,d.$ci),K(9,t.$Hj),K(10,f.$3k),K(11,n.$7h)],N);class T{constructor(V,Q,H,W,te,oe,ee,ae,G,z,j,F,B,U,Z){this.location=V,this.mtime=Q,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=W,this.profile=te,this.profileScanOptions=oe,this.type=ee,this.excludeObsolete=ae,this.validate=G,this.productVersion=z,this.productDate=j,this.productCommit=F,this.devMode=B,this.language=U,this.translations=Z}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,Q){return(0,h.$Bg)(V.location,Q.location)&&V.mtime===Q.mtime&&(0,h.$Bg)(V.applicationExtensionslocation,Q.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&V.profile===Q.profile&&D.$Cn(V.profileScanOptions,Q.profileScanOptions)&&V.type===Q.type&&V.excludeObsolete===Q.excludeObsolete&&V.validate===Q.validate&&V.productVersion===Q.productVersion&&V.productDate===Q.productDate&&V.productCommit===Q.productCommit&&V.devMode===Q.devMode&&V.language===Q.language&&C.equals(V.translations,Q.translations)}}e.$4p=T;let M=class extends g.$Tc{constructor(V,Q,H,W,te){super(),this.f=V,this.g=Q,this.h=H,this.j=W,this.m=te}async scanExtensions(V){const Q=V.profile?await this.r(V):await this.n(V);let H={};if(V.excludeObsolete&&V.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(W)}catch{}return(0,E.$Wf)(H)?Q:Q.filter(W=>!H[c.$4o.create(W).toString()])}async n(V){const Q=await this.j.resolve(V.location);if(!Q.children?.length)return[];const H=await Promise.all(Q.children.map(async W=>{if(!W.isDirectory||V.type===1&&(0,h.$Fg)(W.resource).indexOf(".")===0)return null;const te=new T(W.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te)}));return(0,O.$Hb)(H).sort((W,te)=>W.location.path<te.location.path?-1:1)}async r(V){let Q=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){Q=Q.filter(W=>!W.metadata?.isApplicationScoped);const H=await this.s(V.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,V);Q.push(...H)}return Q}async s(V,Q,H){const W=await this.g.scanProfileExtensions(V,H.profileScanOptions);if(!W.length)return[];const te=await Promise.all(W.map(async oe=>{if(Q(oe)){const ee=new T(oe.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee,oe.metadata)}return null}));return(0,O.$Hb)(te)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,h.$Ig)(V.location,"package.json"))){const Q=await this.scanExtension(V);return Q?[Q]:[]}else return await this.scanExtensions(V)}catch(Q){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,I.$0)(Q)),[]}}async scanExtension(V,Q){try{let H=await this.scanExtensionManifest(V.location);if(H){H.publisher||(H.publisher=y.$jm),Q=Q??H.__metadata,delete H.__metadata;const W=(0,c.$8o)(H.publisher,H.name),te=Q?.id?{id:W,uuid:Q.id}:{id:W},oe=Q?.isSystem?0:V.type,ee=oe===0||!!Q?.isBuiltin;H=await this.t(V.location,H,T.createNlsConfiguration(V));const ae={type:oe,identifier:te,manifest:H,location:V.location,isBuiltin:ee,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return V.validate?this.validate(ae,V):ae}}catch(H){V.type!==0&&this.m.error(H)}return null}validate(V,Q){let H=!0;const W=(0,i.$gp)(Q.productVersion,Q.productDate,Q.location,V.manifest,V.isBuiltin);for(const[te,oe]of W)te===p.default.Error&&(H=!1,this.m.error(this.z(Q.location,oe)));return V.isValid=H,V.validations=W,V}async scanExtensionManifest(V){const Q=(0,h.$Ig)(V,"package.json");let H;try{H=(await this.j.readFile(Q)).value.toString()}catch(te){return(0,o.$Jk)(te)!==1&&this.m.error(this.z(V,(0,u.localize)(0,null,Q.path,te.message))),null}let W;try{W=JSON.parse(H)}catch{const oe=[];(0,R.$fn)(H,oe);for(const ee of oe)this.m.error(this.z(V,(0,u.localize)(1,null,Q.path,ee.offset,ee.length,(0,S.$Zp)(ee.error))));return null}return(0,R.$on)(W)!=="object"?(this.m.error(this.z(V,(0,u.localize)(2,null,Q.path))),null):W}async t(V,Q,H){const W=await this.u(V,Q,H);if(W)try{const te=[],oe=await this.w(W.default,te);if(te.length>0)return te.forEach(ae=>{this.m.error(this.z(V,(0,u.localize)(3,null,W.default?.path,(0,S.$Zp)(ae.error))))}),Q;if((0,R.$on)(W)!=="object")return this.m.error(this.z(V,(0,u.localize)(4,null,W.default?.path))),Q;const ee=W.values||Object.create(null);return(0,b.$1p)(this.m,Q,ee,oe)}catch{}return Q}async u(V,Q,H){const W=(0,h.$Ig)(V,"package.nls.json"),te=(G,z)=>{z.forEach(j=>{this.m.error(this.z(V,(0,u.localize)(5,null,G?.path,(0,S.$Zp)(j.error))))})},oe=G=>{this.m.error(this.z(V,(0,u.localize)(6,null,G?.path)))},ee=`${Q.publisher}.${Q.name}`,ae=H.translations[ee];if(ae)try{const G=l.URI.file(ae),z=(await this.j.readFile(G)).value.toString(),j=[],F=(0,R.$fn)(z,j);return j.length>0?(te(G,j),{values:void 0,default:W}):(0,R.$on)(F)!=="object"?(oe(G),{values:void 0,default:W}):{values:F.contents?F.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let z;try{z=await this.y(V,H)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const j=(await this.j.readFile(z.localized)).value.toString(),F=[],B=(0,R.$fn)(j,F);return F.length>0?(te(z.localized,F),{values:void 0,default:z.original}):(0,R.$on)(B)!=="object"?(oe(z.localized),{values:void 0,default:z.original}):{values:B,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(V,Q){if(V)try{const H=(await this.j.readFile(V)).value.toString();return(0,R.$fn)(H,Q)}catch{}}y(V,Q){return new Promise((H,W)=>{const te=oe=>{const ee=(0,h.$Ig)(V,`package.nls.${oe}.json`);this.j.exists(ee).then(ae=>{ae&&H({localized:ee,original:(0,h.$Ig)(V,"package.nls.json")});const G=oe.lastIndexOf("-");G===-1?H({localized:(0,h.$Ig)(V,"package.nls.json"),original:null}):(oe=oe.substring(0,G),te(oe))})};if(Q.devMode||Q.pseudo||!Q.language)return H({localized:(0,h.$Ig)(V,"package.nls.json"),original:null});te(Q.language)})}z(V,Q){return`[${V.path}]: ${Q}`}};M=pe([K(1,v.$Xp),K(2,f.$3k),K(3,o.$sk),K(4,s.$pj)],M);let q=class extends M{constructor(V,Q,H,W,te,oe,ee){super(Q,W,te,oe,ee),this.G=V,this.H=H,this.D=this.B(new A.$6g(3e3)),this.F=this.B(new r.$Wd),this.onDidChangeCache=this.F.event}async scanExtensions(V){const Q=this.M(V),H=await this.I(Q);if(this.C=V,H&&H.input&&T.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),H.result.map(te=>(te.location=l.URI.revive(te.location),te));const W=await super.scanExtensions(V);return await this.J(Q,{input:V,result:W}),W}async I(V){try{const Q=await this.j.readFile(V),H=JSON.parse(Q.value.toString());return{result:H.result,input:(0,a.$Eh)(H.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",V.path,(0,I.$0)(Q))}return null}async J(V,Q){try{await this.j.writeFile(V,L.$ke.fromString(JSON.stringify(Q)))}catch(H){this.m.debug("Error while writing the extension cache file:",V.path,(0,I.$0)(H))}}async L(){if(!this.C)return;const V=this.M(this.C),Q=await this.I(V);if(!Q)return;const H=Q.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!D.$Cn(W,H))try{this.m.info("Invalidating Cache",H,W),await this.j.del(V),this.F.fire()}catch(te){this.m.error(te)}}M(V){const Q=this.N(V);return this.h.extUri.joinPath(Q.cacheHome,V.type===0?y.$im:y.$hm)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(V.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};q=pe([K(2,w.$5k),K(3,v.$Xp),K(4,f.$3k),K(5,o.$sk),K(6,s.$pj)],q);function Y(x,V){const Q=(0,c.$6o)(x.manifest.publisher,x.manifest.name);return{id:Q,identifier:new y.$nm(Q),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:V,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$5p=Y;class X extends N{constructor(V,Q,H,W,te,oe,ee,ae,G,z,j,F){super(V,Q,(0,h.$Ig)(H,".vscode-oss-dev","extensions","control.json"),W,te,oe,ee,ae,G,z,j,F),this.R=(async()=>{if(m.$z)try{const B=await this.w.readFile(l.URI.file(m.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(V){return this.R}}e.$6p=X}),define(le[245],he([0,1,67,6,38,3,2,23,16,31,8,18]),function(se,e,O,A,D,L,I,R,S,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;let m=class extends I.$Tc{constructor($,p){super(),this.b=$,this.f=p,this.a=new A.$bh(5)}async postUninstall($){const p=this.g($,"uninstall");p&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(E){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(E)}}));try{await g.Promises.rm(this.m($))}catch(E){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(E)}}g($,p){const E=`vscode:${p}`;if($.location.scheme===R.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[E]=="string"){const l=$.manifest.scripts[E].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn($.identifier.id,$.manifest.version,`${E} should be a node script`),null):{script:(0,S.$jc)($.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h($,p,E,l,u){return new Promise((d,c)=>{const y=this.j($,p,E,u);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):d(void 0)};y.on("error",n=>{o((0,D.$Si)(n)||"Unknown")}),y.on("exit",(n,s)=>{o(n?`post-${p} process exited with code ${n}`:void 0)}),l&&(i=setTimeout(()=>{i=null,y.kill(),c("timed out")},5e3))})}j($,p,E,l){const u={silent:!0,execArgv:void 0},d=(0,O.fork)($,[`--type=extension-post-${p}`,...E],u);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const c=L.Event.fromNodeEventEmitter(d.stdout,"data"),y=L.Event.fromNodeEventEmitter(d.stderr,"data");c(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${p}`,n)),y(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${p}`,n));const i=L.Event.any(L.Event.map(c,n=>({data:`%c${n}`,format:[""]})),L.Event.map(y,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),d}m($){return(0,S.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$8p=m,e.$8p=m=pe([K(0,k.$5k),K(1,P.$pj)],m)}),define(le[113],he([0,1,6,14,26,38,7,3,53,2,35,23,16,20,55,12,9,32,31,70,156,96,15,244,29,33,51,82,225,245,184,214,226,71,11,4,8,24,22,28,18]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d,c,y,i,o,n,s,t,r,a,v,w,f,b,C,N,T,M,q,Y,X,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.$_p=void 0,e.$_p=(0,T.$9h)(n.$Eo);const V=".vsctmp";let Q=class extends o.$Sp{constructor(G,z,j,F,B,U,Z,_,ie,J,ne,ce){super(G,z,ne,j,J,ce),this.eb=B,this.fb=U,this.gb=Z,this.hb=ie,this.db=new Map,this.qb=new P.$Bc;const fe=this.B(_.createInstance(v.$8p));this.ab=this.B(_.createInstance(H,me=>fe.postUninstall(me))),this.bb=this.B(new f.$0p(ce,ie,ne,this,this.F)),this.cb=this.B(_.createInstance(a.$7p));const de=this.B(new b.$$p(this,this.eb,ce,U,ne,ie,j));this.B(de.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$bp)(this.hb,this.F)),this.ib}async zip(G){this.F.trace("ExtensionManagementService#zip",G.identifier.id);const z=await this.ob(G),j=await(0,d.zip)((0,h.$Ig)(this.cb.extensionsDownloadDir,(0,l.$rg)()).fsPath,z);return E.URI.file(j)}async unzip(G){return this.F.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const{location:z,cleanup:j}=await this.kb(G),F=m.$kc(z.fsPath);try{return await(0,w.$9p)(F)}finally{await j()}}getInstalled(G,z=this.H.defaultProfile.extensionsResource){return this.ab.scanExtensions(G??null,z)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(G){return this.ab.scanUserExtensionAtLocation(G)}async install(G,z={}){this.F.trace("ExtensionManagementService#install",G.toString());const{location:j,cleanup:F}=await this.kb(G);try{const B=await(0,w.$9p)(m.$kc(j.fsPath)),U=(0,s.$8o)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,C.$ip)(B.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(0,null,U,this.G.version));const _=(await this.I([{manifest:B,extension:j,options:z}])).find(({identifier:ie})=>(0,s.$3o)(ie,{id:U}));if(_?.local)return _.local;throw _?.error?_.error:(0,o.$Up)(new Error(`Unknown error while installing extension ${U}`))}finally{await F()}}async installFromLocation(G,z){this.F.trace("ExtensionManagementService#installFromLocation",G.toString());const j=await this.ab.scanUserExtensionAtLocation(G);if(!j||!j.manifest.name||!j.manifest.version)throw new Error(`Cannot find a valid extension from the location ${G.toString()}`);return await this.tb([[j,void 0]],z),this.F.info("Successfully installed extension",j.identifier.id,z.toString()),j}async installExtensionsFromProfile(G,z,j){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",G,z.toString(),j.toString());const F=(await this.ab.scanExtensions(1,z)).filter(B=>G.some(U=>(0,s.$3o)(U,B.identifier)));if(F.length){const B=await Promise.all(F.map(U=>this.ab.scanMetadata(U,z)));await this.tb(F.map((U,Z)=>[U,B[Z]]),j),this.F.info("Successfully installed extensions",F.map(U=>U.identifier.id),j.toString())}return F}async updateMetadata(G,z,j=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",G.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0,z.hasPreReleaseVersion=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),G=await this.ab.updateMetadata(G,z,j),this.bb.invalidate(j),this.w.fire(G),G}async reinstallFromGallery(G){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",G.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1,null));const z=await this.getTargetPlatform(),[j]=await this.z.getExtensions([{...G.identifier,preRelease:G.preRelease}],{targetPlatform:z,compatible:!0},D.CancellationToken.None);if(!j)throw new Error(c.localize(2,null));await this.ab.setUninstalled(G);try{await this.ab.removeUninstalledExtension(G)}catch(F){throw new Error(c.localize(3,null,(0,L.$Si)(F)))}return this.installFromGallery(j)}$(G,z,j,F){return this.ab.copyExtension(G,z,j,F)}copyExtensions(G,z){return this.ab.copyExtensions(G,z)}markAsUninstalled(...G){return this.ab.setUninstalled(...G)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(G){this.F.error(G)}}async download(G,z,j){const{location:F}=await this.cb.download(G,z,!j);return F}async kb(G){if(G.scheme===k.Schemas.file)return{location:G,async cleanup(){}};this.F.trace("Downloading extension from",G.toString());const z=(0,h.$Ig)(this.cb.extensionsDownloadDir,(0,l.$rg)());return await this.gb.download(G,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.hb.del(z)}catch(F){this.F.error(F)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(G,z,j){if(E.URI.isUri(z))return new oe(G,z,j,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const F=s.$4o.create(z).toString();let B=this.db.get(F);return B||(this.db.set(F,B=new te(G,z,j,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),B.waitUntilTaskIsFinished().finally(()=>this.db.delete(F))),B}Z(G,z){return new ee(G,z.profileLocation,this.fb)}async ob(G){const z=async F=>{let B=await u.Promises.readdir(F);B=B.map(_=>m.$jc(F,_));const U=await Promise.all(B.map(_=>u.Promises.stat(_)));let Z=Promise.resolve([]);return U.forEach((_,ie)=>{const J=B[ie];_.isFile()&&(Z=Z.then(ne=>[...ne,J])),_.isDirectory()&&(Z=Z.then(ne=>z(J).then(ce=>[...ne,...ce])))}),Z};return(await z(G.location.fsPath)).map(F=>({path:`extension/${m.$lc(G.location.fsPath,F)}`,localPath:F}))}async pb({added:G,removed:z}){if(z){const j=G&&this.D.extUri.isEqual(z.profileLocation,G.profileLocation)?z.extensions.filter(F=>G.extensions.every(B=>!(0,s.$3o)(B,F))):z.extensions;for(const F of j)this.F.info("Extensions removed from another source",F.id,z.profileLocation.toString()),this.u.fire({identifier:F,profileLocation:z.profileLocation})}if(G){const F=(await this.ab.scanExtensions(1,G.profileLocation)).filter(B=>G.extensions.some(U=>(0,s.$3o)(U,B.identifier)));this.s.fire(F.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,G.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:G.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(z=>this.qb.add(z)));const G=await this.hb.resolve(this.eb.userExtensionsLocation);for(const z of G.children??[])z.isDirectory&&this.qb.add(z.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(z=>this.sb(z)))}async sb(G){if(!G.affects(this.eb.userExtensionsLocation,1))return;const z=[];for(const j of G.rawAdded){if(this.qb.has(j)||!this.D.extUri.isEqual(this.D.extUri.dirname(j),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(j,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(j).startsWith(".")||!(await this.hb.stat(j)).isDirectory)continue;const F=await this.ab.scanUserExtensionAtLocation(j);F&&F.installedTimestamp===void 0&&(this.qb.add(j),z.push(F))}z.length&&(await this.tb(z.map(j=>[j,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(j=>j.identifier.id)))}async tb(G,z){const j=G.map(F=>F[0]);await this.ub(j),await this.fb.addExtensionsToProfile(G,z),this.s.fire(j.map(F=>({local:F,identifier:F.identifier,operation:1,profileLocation:z})))}async ub(G){const z=await this.ab.getUninstalledExtensions();for(const j of G){const F=s.$4o.create(j);z[F.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",F.id),await this.ab.setInstalled(F),this.F.info("Removed the extension from uninstalled list:",F.id))}}};e.$aq=Q,e.$aq=Q=pe([K(0,n.$Bo),K(1,Y.$wl),K(2,M.$pj),K(3,i.$di),K(4,r.$2p),K(5,t.$Xp),K(6,y.$go),K(7,T.$7h),K(8,N.$sk),K(9,q.$Hj),K(10,X.$3k),K(11,x.$5k)],Q);let H=class extends g.$Tc{constructor(G,z,j,F,B,U){super(),this.j=G,this.m=z,this.n=j,this.s=F,this.t=B,this.u=U,this.h=this.B(new R.$Wd),this.onExtract=this.h.event,this.c=(0,h.$Ig)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$ch}async cleanUp(){await this.H(),await this.G()}async scanExtensions(G,z){const j={includeInvalid:!0,profileLocation:z};let F=[];return G===null||G===0?F.push(...await this.n.scanAllExtensions({includeInvalid:!0},j,!1)):G===1&&F.push(...await this.n.scanUserExtensions(j)),F=G!==null?F.filter(B=>B.type===G):F,Promise.all(F.map(B=>this.F(B)))}async scanAllUserExtensions(G){const z=await this.n.scanUserExtensions({includeAllVersions:!G,includeInvalid:!0});return Promise.all(z.map(j=>this.F(j)))}async scanUserExtensionAtLocation(G){try{const z=await this.n.scanExistingExtension(G,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(G,z,j,F,B){const U=G.toString(),Z=E.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$rg)()}`)),_=E.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,U));let ie=await this.m.exists(_);if(ie&&F){try{await this.y(G.id,_,"removeExisting")}catch{throw new n.$Co(c.localize(4,null,_.fsPath,G.id),n.ExtensionManagementErrorCode.Delete)}ie=!1}if(ie)await this.n.updateMetadata(_,j);else try{try{this.u.trace(`Started extracting the extension from ${z} to ${_.fsPath}`),await(0,d.$Qp)(z,Z.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${_}:`,G.id)}catch(J){let ne=n.ExtensionManagementErrorCode.Extract;throw J instanceof d.$Op&&(J.type==="CorruptZip"?ne=n.ExtensionManagementErrorCode.CorruptZip:J.type==="Incomplete"&&(ne=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Co(J.message,ne)}await this.n.updateMetadata(Z,j);try{this.u.trace(`Started renaming the extension from ${Z.fsPath} to ${_.fsPath}`),await this.C(Z.fsPath,_.fsPath),this.u.info("Renamed to",_.fsPath)}catch(J){if(J.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",G.id);else throw this.u.info(`Rename failed because of ${(0,I.$0)(J)}. Deleted from extracted location`,Z),J}this.h.fire(_)}catch(J){try{await this.m.del(Z,{recursive:!0})}catch{}throw J}return this.D(_,1)}async scanMetadata(G,z){return z?(await this.w(G,z))?.metadata:this.n.scanMetadata(G.location)}async w(G,z){return(await this.s.scanProfileExtensions(z)).find(F=>(0,s.$3o)(F.identifier,G.identifier))}async updateMetadata(G,z,j){return j?await this.s.updateMetadata([[G,z]],j):await this.n.updateMetadata(G.location,z),this.D(G.location,G.type,j)}getUninstalledExtensions(){return this.z()}async setUninstalled(...G){const z=G.map(j=>s.$4o.create(j));await this.z(j=>z.forEach(F=>{j[F.toString()]=!0,this.u.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(G){await this.z(z=>delete z[G.toString()])}async removeExtension(G,z){if(this.t.extUri.isEqualOrParent(G.location,this.n.userExtensionsLocation))return this.y(G.identifier.id,G.location,z)}async removeUninstalledExtension(G){await this.removeExtension(G,"uninstalled"),await this.z(z=>delete z[s.$4o.create(G).toString()])}async copyExtension(G,z,j,F){const B=await this.w(G,z),U=await this.w(G,j);if(F={...B?.metadata,...F},U)if(this.t.extUri.isEqual(U.location,G.location))await this.s.updateMetadata([[G,{...U.metadata,...F}]],j);else{const Z=await this.D(U.location,G.type,j);await this.s.removeExtensionFromProfile(Z,j),await this.s.addExtensionsToProfile([[G,{...U.metadata,...F}]],j)}else await this.s.addExtensionsToProfile([[G,F]],j);return this.D(G.location,G.type,j)}async copyExtensions(G,z){const j=await this.scanExtensions(1,G),F=await Promise.all(j.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,G)]));await this.s.addExtensionsToProfile(F,z)}async y(G,z,j){this.u.trace(`Deleting ${j} extension from disk`,G,z.fsPath);const F=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,S.$Vi)((0,l.$rg)()).toString(16)}${V}`);await this.C(z.fsPath,F.fsPath),await this.m.del(F,{recursive:!0}),this.u.info(`Deleted ${j} extension from disk`,G,z.fsPath)}async z(G){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(F){if((0,N.$Jk)(F)!==1)throw F}let j={};if(z)try{j=JSON.parse(z)}catch{}return G&&(G(j),Object.keys(j).length?await this.m.writeFile(this.c,A.$ke.fromString(JSON.stringify(j))):await this.m.del(this.c)),j})}async C(G,z){try{await u.Promises.rename(G,z,2*60*1e3)}catch(j){throw new n.$Co(j.message||c.localize(5,null,G,z),j.code||n.ExtensionManagementErrorCode.Rename)}}async D(G,z,j){if(j){const B=(await this.n.scanUserExtensions({profileLocation:j})).find(U=>this.t.extUri.isEqual(U.location,G));if(B)return this.F(B)}else{const F=await this.n.scanExistingExtension(G,z,{includeInvalid:!0});if(F)return this.F(F)}throw new Error(c.localize(6,null,G.path))}async F(G){const z=await this.m.resolve(G.location);let j,F;return z.children&&(j=z.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,F=z.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:G.identifier,type:G.type,isBuiltin:G.isBuiltin||!!G.metadata?.isBuiltin,location:G.location,manifest:G.manifest,targetPlatform:G.targetPlatform,validations:G.validations,isValid:G.isValid,readmeUrl:j,changelogUrl:F,publisherDisplayName:G.metadata?.publisherDisplayName||null,publisherId:G.metadata?.publisherId||null,isApplicationScoped:!!G.metadata?.isApplicationScoped,isMachineScoped:!!G.metadata?.isMachineScoped,isPreReleaseVersion:!!G.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!G.metadata?.hasPreReleaseVersion,preRelease:!!G.metadata?.preRelease,installedTimestamp:G.metadata?.installedTimestamp,updated:!!G.metadata?.updated,pinned:!!G.metadata?.pinned}}async G(){const G=await this.getUninstalledExtensions();if(Object.keys(G).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(G));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),j=new Set;for(const B of z)G[s.$4o.create(B).toString()]||j.add(B.identifier.id.toLowerCase());try{const B=(0,s.$9o)(z,U=>U.identifier);await O.Promises.settled(B.map(async U=>{const Z=U.sort((_,ie)=>$.rcompare(_.manifest.version,ie.manifest.version))[0];j.has(Z.identifier.id.toLowerCase())||await this.j(await this.F(Z))}))}catch(B){this.u.error(B)}const F=z.filter(B=>B.metadata&&G[s.$4o.create(B).toString()]);await Promise.allSettled(F.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let G;try{G=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,N.$Jk)(z)!==1&&this.u.error(z);return}if(G?.children)try{await Promise.allSettled(G.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(j){(0,N.$Jk)(j)!==1&&this.u.error(j)}}}))}catch{}}};e.$bq=H,e.$bq=H=pe([K(1,N.$sk),K(2,r.$2p),K(3,t.$Xp),K(4,X.$3k),K(5,M.$pj)],H);class W extends o.$Vp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$Qf)(this.options.operation)?this.l:this.options.operation}constructor(G,z,j,F,B,U,Z,_,ie){super(),this.identifier=G,this.source=z,this.options=j,this.m=F,this.n=B,this.o=U,this.p=Z,this.q=_,this.s=ie,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(G){const[z,j]=await this.x(G);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,j]],this.j),z}async u({zipPath:G,key:z,metadata:j},F,B){let U=await this.v(z);return U?U=await this.m.updateMetadata(U,j):(this.s.trace("Extracting extension...",z.id),U=await this.m.extractUserExtension(z,G,j,F,B),this.s.info("Extracting extension completed.",z.id)),U}async v(G){return await this.w(G)?(this.s.trace("Removing the extension from uninstalled list:",G.id),await this.m.setInstalled(G),this.s.info("Removed the extension from uninstalled list:",G.id),(await this.m.scanAllUserExtensions(!0)).find(F=>s.$4o.create(F).equals(G))):void 0}async w(G){return!!(await this.m.getUninstalledExtensions())[G.toString()]}}class te extends W{constructor(G,z,j,F,B,U,Z,_,ie,J){super(z.identifier,z,j,B,U,Z,_,ie,J),this.y=z,this.z=F}async x(G){let z;try{z=await this.m.scanExtensions(null,this.options.profileLocation)}catch(Z){throw new n.$Co(Z,n.ExtensionManagementErrorCode.Scanning)}const j=z.find(Z=>(0,s.$3o)(Z.identifier,this.y.identifier));j&&(this.l=3);const F={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||j?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||j?.isMachineScoped,isBuiltin:this.options.isBuiltin||j?.isBuiltin,isSystem:j?.type===0?!0:void 0,updated:!!j,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:j?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??j?.pinned,preRelease:(0,p.$Pf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||j?.preRelease};if(j?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(j,F),F]}catch(Z){throw new n.$Co((0,I.$0)(Z),n.ExtensionManagementErrorCode.UpdateMetadata)}const{location:B,verificationStatus:U}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=U,this.B(B.fsPath),[await this.u({zipPath:B.fsPath,key:s.$4o.create(this.y),metadata:F},!1,G),F]}catch(Z){try{await this.z.delete(B)}catch(_){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,I.$0)(_))}throw Z}}async B(G){try{await(0,w.$9p)(G)}catch(z){throw new n.$Co((0,o.$Tp)(z).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$cq=te;class oe extends W{constructor(G,z,j,F,B,U,Z,_,ie,J){super({id:(0,s.$8o)(G.publisher,G.name)},z,j,B,U,Z,_,ie,J),this.y=G,this.z=z,this.A=F}async h(G){const z=await super.h(G);return this.D(z,G),z}async x(G){const z=new s.$4o(this.identifier,this.y.version),F=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Z=>(0,s.$3o)(this.identifier,Z.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||F?.isMachineScoped,isBuiltin:this.options.isBuiltin||F?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??F?.pinned};if(F)if(this.l=3,z.equals(new s.$4o(F.identifier,F.manifest.version)))try{await this.m.removeExtension(F,"existing")}catch{throw new Error(c.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&$.gt(F.manifest.version,this.y.version)&&await this.m.setUninstalled(F);else{const Z=await this.v(z);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error(c.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:m.$kc(this.z.fsPath),key:z,metadata:B},!0,G),B]}async D(G,z){try{let[j]=await this.A.getExtensions([{id:G.identifier.id,version:G.manifest.version}],z);if(j||([j]=await this.A.getExtensions([{id:G.identifier.id}],z)),j){const F={id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId,isPreReleaseVersion:j.properties.isPreReleaseVersion,hasPreReleaseVersion:G.hasPreReleaseVersion||j.properties.isPreReleaseVersion,preRelease:j.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(G,F,this.options.profileLocation)}}catch{}}}class ee extends o.$Vp{constructor(G,z,j){super(),this.extension=G,this.j=z,this.k=j}async h(G){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[246],he([0,1,8,18,28,22,51,11,15,9]),function(se,e,O,A,D,L,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=void 0;let P=class extends I.$Yp{constructor(m,h,$,p,E,l){super(g.URI.file(m.extensionsPath),h,$,p,E,l)}};e.$WO=P,e.$WO=P=pe([K(0,S.$di),K(1,R.$sk),K(2,A.$5k),K(3,D.$3k),K(4,L.$wl),K(5,O.$pj)],P)}),define(le[247],he([0,1,9,15,51,82,11,4,8,24,28,18]),function(se,e,O,A,D,L,I,R,S,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=void 0;let m=class extends L.$6p{constructor($,p,E,l,u,d,c,y){super(O.URI.file(u.builtinExtensionsPath),O.URI.file(u.extensionsPath),u.userHome,$.defaultProfile,$,p,E,l,u,d,c,y)}};e.$5$b=m,e.$5$b=m=pe([K(0,k.$5k),K(1,D.$Xp),K(2,I.$sk),K(3,S.$pj),K(4,A.$di),K(5,g.$Hj),K(6,P.$3k),K(7,R.$7h)],m)}),define(le[19],he([0,1,6,3,2,100,12,69,4,18]),function(se,e,O,A,D,L,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$wp=e.$vp=e.$up=void 0,e.$up="__$__isNewStorageMarker",e.$vp="__$__targetStorageMarker",e.$wp=(0,S.$8h)("storageService");var P;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var k;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var m;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function h(u){const d=u.get(e.$vp);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.$xp=h;class $ extends D.$Tc{static{this.a=60*1e3}constructor(d={flushInterval:$.a}){super(),this.m=d,this.b=this.B(new A.$Zd),this.c=this.B(new A.$Zd),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$Wd),this.onWillSaveState=this.f.event,this.h=this.B(new O.$hh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new D.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,c,y){return A.Event.filter(this.b.event,i=>i.scope===d&&(c===void 0||i.key===c),y)}n(){this.j.value=(0,O.$lh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,D.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,c){const{key:y,external:i}=c;if(y===e.$vp){switch(d){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:y,target:this.J(d)[y],external:i})}w(d){this.f.fire({reason:d})}get(d,c,y){return this.P(c)?.get(d,y)}getBoolean(d,c,y){return this.P(c)?.getBoolean(d,y)}getNumber(d,c,y){return this.P(c)?.getNumber(d,y)}getObject(d,c,y){return this.P(c)?.getObject(d,y)}storeAll(d,c){this.y(()=>{for(const y of d)this.store(y.key,y.value,y.scope,y.target,c)})}store(d,c,y,i,o=!1){if((0,I.$Sf)(c)){this.remove(d,y,o);return}this.y(()=>{this.z(d,y,i),this.P(y)?.set(d,c,o)})}remove(d,c,y=!1){this.y(()=>{this.z(d,c,void 0),this.P(c)?.delete(d,y)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,c){const y=[],i=this.J(d);for(const o of Object.keys(i))i[o]===c&&y.push(o);return y}z(d,c,y,i=!1){const o=this.J(c);typeof y=="number"?o[d]!==y&&(o[d]=y,this.P(c)?.set(e.$vp,JSON.stringify(o),i)):typeof o[d]=="number"&&(delete o[d],this.P(c)?.set(e.$vp,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(d){switch(d){case-1:return this.I;case 0:return this.G;default:return this.D}}L(d){const c=this.P(d);return c?h(c):Object.create(null)}isNew(d){return this.getBoolean(e.$up,d)===!0}async flush(d=P.NONE){this.f.fire({reason:d});const c=this.P(-1),y=this.P(0),i=this.P(1);switch(d){case P.NONE:await O.Promises.settled([c?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await O.Promises.settled([c?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,y=this.P(1)?.items??new Map;return l(d,c,y,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,c){return this.w(P.NONE),(0,g.$4k)(d)?this.R(d,c):this.S(d,c)}M(d,c){return!(d.id===c.id||p(c)&&p(d))}N(d,c,y){this.y(()=>{const i=new Set;for(const[o,n]of d)i.add(o),c.get(o)!==n&&this.u(y,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.u(y,{key:o,external:!0})})}}e.$yp=$;function p(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$zp=p;class E extends ${constructor(){super(),this.U=this.B(new R.$sp(new R.$tp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$sp(new R.$tp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$sp(new R.$tp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(1,d))),this.B(this.W.onDidChangeStorage(d=>this.u(0,d))),this.B(this.U.onDidChangeStorage(d=>this.u(-1,d)))}P(d){switch(d){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$Ap=E;async function l(u,d,c,y,i,o){const n=C=>{try{return JSON.parse(C)}catch{return C}},s=new Map,t=new Map;u.forEach((C,N)=>{s.set(N,C),t.set(N,n(C))});const r=new Map,a=new Map;d.forEach((C,N)=>{r.set(N,C),a.set(N,n(C))});const v=new Map,w=new Map;c.forEach((C,N)=>{v.set(N,C),w.set(N,n(C))}),console.group(y!==i?`Storage: Application (path: ${y})`:`Storage: Application & Profile (path: ${y}, default profile)`);const f=[];if(s.forEach((C,N)=>{f.push({key:N,value:C})}),console.table(f),console.groupEnd(),console.log(t),y!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const C=[];r.forEach((N,T)=>{C.push({key:T,value:N})}),console.table(C),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const b=[];v.forEach((C,N)=>{b.push({key:N,value:C})}),console.table(b),console.groupEnd(),console.log(w)}e.$Bp=l}),define(le[114],he([0,1,3,2,12,29,33,19]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Fb=e.$9Fb=void 0;let S=class extends A.$Tc{constructor(k,m){super(),this.a=new O.$Wd,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(k)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(m.onDidInstallExtensions(h=>h.forEach(({local:$,operation:p})=>{$&&p===4&&this.f($.identifier)})))}async enableExtension(k,m){return this.f(k)?(this.a.fire({extensions:[k],source:m}),!0):!1}async disableExtension(k,m){return this.c(k)?(this.a.fire({extensions:[k],source:m}),!0):!1}getDisabledExtensions(){return this.h(L.$Fo)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(k){const m=this.getDisabledExtensions();return m.every(h=>!(0,I.$3o)(h,k))?(m.push(k),this.g(m),!0):!1}f(k){const m=this.getDisabledExtensions();for(let h=0;h<m.length;h++){const $=m[h];if((0,I.$3o)($,k))return m.splice(h,1),this.g(m),!0}return!1}g(k){this.j(L.$Fo,k)}h(k){return this.b.get(k,0)}j(k,m){this.b.set(k,m,0)}};e.$9Fb=S,e.$9Fb=S=pe([K(0,R.$wp),K(1,L.$Eo)],S);class g extends A.$Tc{constructor(k){super(),this.c=k,this.a=Object.create(null),this.b=this.B(new O.$Wd),this.onDidChange=this.b.event,this.B(k.onDidChangeValue(0,void 0,this.B(new A.$Sc))(m=>this.f(m)))}get(k,m){let h;return m===0?((0,D.$Sf)(this.a[k])&&(this.a[k]=this.g(k,m)),h=this.a[k]):h=this.g(k,m),JSON.parse(h)}set(k,m,h){const $=JSON.stringify(m.map(({id:E,uuid:l})=>({id:E,uuid:l})));this.g(k,h)!==$&&(h===0&&(m.length?this.a[k]=$:delete this.a[k]),this.h(k,m.length?$:void 0,h))}f(k){if(!(0,D.$Sf)(this.a[k.key])&&this.g(k.key,k.scope)!==this.a[k.key]){const h=this.get(k.key,k.scope);delete this.a[k.key];const $=this.get(k.key,k.scope),p=h.filter(l=>!$.some(u=>(0,I.$3o)(l,u))),E=$.filter(l=>!h.some(u=>(0,I.$3o)(u,l)));(p.length||E.length)&&this.b.fire([...p,...E])}}g(k,m){return this.c.get(k,m,"[]")}h(k,m,h){m?this.c.store(k,m,h,1):this.c.remove(k,h)}}e.$0Fb=g}),define(le[248],he([0,1,17,26,7,5,37,12,9,21,15,29,33,71,11,8,24,59,227,19,22,63]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=void 0;const i=L.$o?"web":(0,k.$xo)(L.$u,I.$ec),o="X-Market-Search-Activity-Id";var n;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished",F[F.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...F){return String(F.reduce((B,U)=>B|U,0))}var t;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class f{constructor(B=w){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,U=this.d.pageSize){return new f({...this.d,pageNumber:B,pageSize:U})}withFilter(B,...U){const Z=[...this.d.criteria,...U.length?U.map(_=>({filterType:B,value:_})):[{filterType:B}]];return new f({...this.d,criteria:Z})}withSortBy(B){return new f({...this.d,sortBy:B})}withSortOrder(B){return new f({...this.d,sortOrder:B})}withFlags(...B){return new f({...this.d,flags:B.reduce((U,Z)=>U|Z,0)})}withAssetTypes(...B){return new f({...this.d,assetTypes:B})}withSource(B){return new f({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:U,pageSize:Z,sortBy:_,sortOrder:ie,flags:J,assetTypes:ne}=this.d;return{filters:[{criteria:B,pageNumber:U,pageSize:Z,sortBy:_,sortOrder:ie}],assetTypes:ne,flags:J}}get searchText(){const B=this.d.criteria.filter(U=>U.filterType===t.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function b(F,B){const U=(F||[]).filter(Z=>Z.statisticName===B)[0];return U?U.value:0}function C(F){const B="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(Z=>Z.assetType.indexOf(B)===0).reduce((Z,_)=>{const ie=M(F,_.assetType);return ie&&Z.push([_.assetType.substring(B.length),ie]),Z},[])}function N(F){if(F.properties){const B=F.properties.filter(_=>_.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Z=B.filter(_=>U.test(_.value))[0];return Z?{uri:Z.value,fallbackUri:Z.value}:null}return M(F,r.Repository)}function T(F){return{uri:`${F.fallbackAssetUri}/${r.VSIX}?redirect=true${F.targetPlatform?`&targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${r.VSIX}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}}function M(F,B){return F.files.filter(Z=>Z.assetType===B)[0]?{uri:`${F.assetUri}/${B}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${B}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}:null}function q(F,B){const U=F.properties?F.properties.filter(_=>_.key===B):[],Z=U.length>0&&U[0].value;return Z?Z.split(",").map(_=>(0,m.$7o)(_)):[]}function Y(F){const B=F.properties?F.properties.filter(U=>U.key===a.Engine):[];return B.length>0&&B[0].value||""}function X(F){const B=F.properties?F.properties.filter(U=>U.key===a.PreRelease):[];return B.length>0&&B[0].value==="true"}function x(F){const B=F.properties?F.properties.filter(Z=>Z.key===a.LocalizedLanguages):[],U=B.length>0&&B[0].value||"";return U?U.split(","):[]}function V(F){return F.properties?.find(B=>B.key===a.SponsorLink)?.value}function Q(F){return F.properties?.find(B=>B.key===a.SupportLink)?.value}function H(F){return F.indexOf("preview")!==-1}function W(F){return F.targetPlatform?(0,k.$wo)(F.targetPlatform):"undefined"}function te(F){const B=(0,O.$Mb)(F.versions.map(W)),U=!!F.tags?.includes(k.$ro),Z=B.indexOf("web");return U?Z===-1&&B.push("web"):Z!==-1&&B.splice(Z,1),B}function oe(F,B){for(let U=0;U<F.length;U++){const Z=F[U];if(Z.version===F[U-1]?.version){let _=U;if(W(Z)===B)for(;_>0&&F[_-1].version===Z.version;)_--;_!==U&&(F.splice(U,1),F.splice(_,0,Z))}}return F}e.$Ep=oe;function ee(F,B,U){F.telemetryData={index:B,querySource:U,queryActivityId:F.queryContext?.[o]}}function ae(F,B,U,Z){const _=F.versions[0],ie={manifest:M(B,r.Manifest),readme:M(B,r.Details),changelog:M(B,r.Changelog),license:M(B,r.License),repository:N(B),download:T(B),icon:M(B,r.Icon),signature:M(B,r.Signature),coreTranslations:C(B)};return{identifier:{id:(0,m.$8o)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:B.version,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,publisherDomain:F.publisher.domain?{link:F.publisher.domain,verified:!!F.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(_),description:F.shortDescription||"",installCount:b(F.statistics,"install"),rating:b(F.statistics,"averagerating"),ratingCount:b(F.statistics,"ratingcount"),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),allTargetPlatforms:U,assets:ie,properties:{dependencies:q(B,a.Dependency),extensionPack:q(B,a.ExtensionPack),engine:Y(B),localizedLanguages:x(B),targetPlatform:W(B),isPreReleaseVersion:X(B)},hasPreReleaseVersion:X(_),hasReleaseVersion:!0,preview:H(F.flags),isSigned:!!ie.signature,queryContext:Z,supportLink:Q(_)}}let G=class{constructor(B,U,Z,_,ie,J,ne,ce){this.k=U,this.l=Z,this.n=_,this.o=ie,this.q=J,this.u=ne,this.w=ce;const fe=ne.extensionsGallery,de=fe?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=de?fe.servicePPEUrl:fe?.serviceUrl,this.g=de?void 0:fe?.searchUrl,this.h=fe?.controlUrl,this.j=(0,u.$Dp)(ne.version,ne,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,U,Z){const _=A.CancellationToken.isCancellationToken(U)?{}:U,ie=A.CancellationToken.isCancellationToken(U)?U:Z,J=[],ne=[],ce=[],fe=[];let de=!0;for(const Pe of B){Pe.uuid?ne.push(Pe.uuid):J.push(Pe.id);const Oe=!!(Pe.version||Pe.preRelease);ce.push({id:Pe.id,uuid:Pe.uuid,includePreRelease:Oe}),Pe.version&&fe.push({id:Pe.id,uuid:Pe.uuid,version:Pe.version}),de=de&&!!Pe.hasPreRelease&&!Oe}if(!ne.length&&!J.length)return[];let me=new f().withPage(1,B.length);ne.length&&(me=me.withFilter(t.ExtensionId,...ne)),J.length&&(me=me.withFilter(t.ExtensionName,...J)),(_.queryAllVersions||de)&&(me=me.withFlags(me.flags,n.IncludeVersions)),_.source&&(me=me.withSource(_.source));const{extensions:Ee}=await this.z(me,{targetPlatform:_.targetPlatform??i,includePreRelease:ce,versions:fe,compatible:!!_.compatible},ie);return _.source&&Ee.forEach((Pe,Oe)=>ee(Pe,Oe,_.source)),Ee}async getCompatibleExtension(B,U,Z){if((0,k.$yo)(B.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(B,U,Z))return B;const _=new f().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,B.identifier.uuid),{extensions:ie}=await this.z(_,{targetPlatform:Z,compatible:!0,includePreRelease:U},A.CancellationToken.None);return ie[0]||null}async isExtensionCompatible(B,U,Z){if(!(0,k.$zo)(B.properties.targetPlatform,B.allTargetPlatforms,Z)||!U&&B.properties.isPreReleaseVersion)return!1;let _=B.properties.engine;if(!_){const ie=await this.getManifest(B,A.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");_=ie.engines.vscode}return(0,h.$ip)(_,this.u.version,this.u.date)}async y(B,U,Z,_,ie){if(!(0,k.$zo)(W(B),_,ie)||U!=="any"&&X(B)!==(U==="prerelease"))return!1;if(Z)try{const J=await this.E(B);if(!(0,h.$ip)(J,this.u.version,this.u.date))return!1}catch(J){return this.l.error(`Error while getting the engine for the version ${B.version}.`,(0,D.$0)(J)),!1}return!0}async query(B,U){let Z=B.text||"";const _=B.pageSize??50;let ie=new f().withPage(1,_);Z?(Z=Z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(ie=ie.withFilter(t.Category,Ee||me),"")),Z=Z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(ie=ie.withFilter(t.Tag,Ee||me),"")),Z=Z.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(t.Featured),"")),Z=Z.trim(),Z&&(Z=Z.length<200?Z:Z.substring(0,200),ie=ie.withFilter(t.SearchText,Z)),ie=ie.withSortBy(0)):B.ids?ie=ie.withFilter(t.ExtensionId,...B.ids):B.names?ie=ie.withFilter(t.ExtensionName,...B.names):ie=ie.withSortBy(4),typeof B.sortBy=="number"&&(ie=ie.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(ie=ie.withSortOrder(B.sortOrder)),B.source&&(ie=ie.withSource(B.source));const J=async(de,me)=>{const{extensions:Ee,total:Pe}=await this.z(de,{targetPlatform:i,compatible:!1,includePreRelease:!!B.includePreRelease},me);return Ee.forEach((Oe,Ne)=>ee(Oe,(de.pageNumber-1)*de.pageSize+Ne,B.source)),{extensions:Ee,total:Pe}},{extensions:ne,total:ce}=await J(ie,U),fe=async(de,me)=>{if(me.isCancellationRequested)throw new D.$5;const{extensions:Ee}=await J(ie.withPage(de+1),me);return Ee};return{firstPage:ne,total:ce,pageSize:ie.pageSize,getPage:fe}}async z(B,U,Z){const _=B.flags;B.flags&n.IncludeLatestVersionOnly&&B.flags&n.IncludeVersions&&(B=B.withFlags(B.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(B.flags&n.IncludeLatestVersionOnly)&&!(B.flags&n.IncludeVersions)&&(B=B.withFlags(B.flags,n.IncludeLatestVersionOnly)),U.versions?.length&&(B=B.withFlags(B.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),B=B.withFlags(B.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:ie,total:J,context:ne}=await this.B(B,Z);if(!(B.flags&n.IncludeLatestVersionOnly)){const me=[];for(const Ee of ie){const Pe=await this.A(Ee,U,ne);Pe&&me.push(Pe)}return{extensions:me,total:J}}const fe=[],de=new Map;for(let me=0;me<ie.length;me++){const Ee=ie[me],Pe={id:(0,m.$8o)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Oe=(0,R.$Pf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ue=>(0,m.$3o)(ue,Pe))?.includePreRelease;if(U.compatible&&(0,k.$yo)(te(Ee),U.targetPlatform))continue;const Ne=await this.A(Ee,U,ne);!Ne||Ne.properties.isPreReleaseVersion&&(!Oe||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==U.targetPlatform&&Ne.hasPreReleaseVersion?de.set(Ee.extensionId,me):fe.push([me,Ne])}if(de.size){const me=new y.$Sd,Ee=new f().withFlags(_&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(t.ExtensionId,...de.keys()),{extensions:Pe}=await this.z(Ee,U,Z);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:de.size});for(const Oe of Pe){const Ne=de.get(Oe.identifier.uuid);fe.push([Ne,Oe])}}return{extensions:fe.sort((me,Ee)=>me[0]-Ee[0]).map(([,me])=>me),total:J}}async A(B,U,Z){const _={id:(0,m.$8o)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},ie=U.versions?.find(fe=>(0,m.$3o)(fe,_))?.version,J=(0,R.$Pf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(fe=>(0,m.$3o)(fe,_))?.includePreRelease,ne=te(B),ce=oe(B.versions,U.targetPlatform);if(U.compatible&&(0,k.$yo)(ne,U.targetPlatform))return null;for(let fe=0;fe<ce.length;fe++){const de=ce[fe];if(!(ie&&de.version!==ie)){if(await this.y(de,J?"any":"release",U.compatible,ne,U.targetPlatform))return ae(B,de,ne,Z);if(ie&&de.version===ie)return null}}return ie||U.compatible?null:ae(B,B.versions[0],ne)}async B(B,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const Z=await this.j,_=JSON.stringify(B.raw),ie={...Z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},J=new y.$Sd;let ne,ce,fe=0;try{if(ne=await this.k.request({type:"POST",url:this.g&&B.criteria.some(me=>me.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:ie},U),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:fe};const de=await(0,l.$pp)(ne);if(de){const me=de.results[0],Ee=me.extensions,Pe=me.resultMetadata&&me.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return fe=Pe&&Pe.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:fe,context:{[o]:ne.res.headers.activityid}}}return{galleryExtensions:[],total:fe}}catch(de){const me=(0,D.$4)(de)?k.ExtensionGalleryErrorCode.Cancelled:(0,D.$0)(de).startsWith("XHR timeout")?k.ExtensionGalleryErrorCode.Timeout:k.ExtensionGalleryErrorCode.Failed;throw ce=new k.$Do((0,D.$0)(de),me),ce}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(_.length),duration:J.elapsed(),success:!!ne&&(0,l.$lp)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:ce?.code,count:String(fe)})}}async reportStatistic(B,U,Z,_){if(!this.isEnabled())return;const ie=L.$o?this.x(`/itemName/${B}.${U}/version/${Z}/statType/${_==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${U}/${Z}/stats?statType=${_}`),J=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:J};try{await this.k.request({type:"POST",url:ie,headers:ce},A.CancellationToken.None)}catch{}}async download(B,U,Z){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const _=(0,m.$$o)(B),ie=new Date().getTime(),J=me=>this.o.publicLog("galleryService:downloadVSIX",{..._,duration:me}),ne=Z===2?"install":Z===3?"update":"",ce=ne?{uri:`${B.assets.download.uri}${S.URI.parse(B.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${B.assets.download.fallbackUri}${S.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:B.assets.download,fe=B.queryContext?.[o]?{[o]:B.queryContext[o]}:void 0,de=await this.D(ce,fe?{headers:fe}:void 0);await this.q.writeFile(U,de.stream),J(new Date().getTime()-ie)}async downloadSignatureArchive(B,U){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const Z=await this.D(B.assets.signature);await this.q.writeFile(U,Z.stream)}async getReadme(B,U){if(B.assets.readme){const Z=await this.D(B.assets.readme,{},U);return await(0,l.$op)(Z)||""}return""}async getManifest(B,U){if(B.assets.manifest){const Z=await this.D(B.assets.manifest,{},U),_=await(0,l.$op)(Z);return _?JSON.parse(_):null}return null}async C(B,U){const Z=M(B,r.Manifest);if(!Z)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},ie=await this.D(Z,{headers:_});return await(0,l.$pp)(ie)}async getCoreTranslation(B,U){const Z=B.assets.coreTranslations.filter(_=>_[0]===U.toUpperCase())[0];if(Z){const _=await this.D(Z[1]),ie=await(0,l.$op)(_);return ie?JSON.parse(ie):null}return null}async getChangelog(B,U){if(B.assets.changelog){const Z=await this.D(B.assets.changelog,{},U);return await(0,l.$op)(Z)||""}return""}async getAllCompatibleVersions(B,U,Z){let _=new f().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?_=_.withFilter(t.ExtensionId,B.identifier.uuid):_=_.withFilter(t.ExtensionName,B.identifier.id);const{galleryExtensions:ie}=await this.B(_,A.CancellationToken.None);if(!ie.length)return[];const J=te(ie[0]);if((0,k.$yo)(J,Z))return[];const ne=[];await Promise.all(ie[0].versions.map(async de=>{try{await this.y(de,U?"any":"release",!0,J,Z)&&ne.push(de)}catch{}}));const ce=[],fe=new Set;for(const de of oe(ne,Z))fe.has(de.version)||(fe.add(de.version),ce.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:X(de)}));return ce}async D(B,U={},Z=A.CancellationToken.None){const _=await this.j,ie={type:"GET"},J={..._,...U.headers||{}};U={...U,...ie,headers:J};const ne=B.uri,ce=B.fallbackUri,fe={...U,url:ne};try{const de=await this.k.request(fe,Z);if(de.res.statusCode===200)return de;const me=await(0,l.$op)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${me}`)}catch(de){if((0,D.$4)(de))throw de;const me=(0,D.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{url:ne,message:me});const Ee={...U,url:ce};return this.k.request(Ee,Z)}}async E(B){let U=Y(B);if(!U){const Z=await this.C(B,A.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");U=Z.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const B=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.$pp)(B),Z=[],_={},ie=[];if(U){for(const J of U.malicious)Z.push({id:J});if(U.migrateToPreRelease)for(const[J,ne]of Object.entries(U.migrateToPreRelease))(!ne.engine||(0,h.$ip)(ne.engine,this.u.version,this.u.date))&&(_[J.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[J,ne]of Object.entries(U.deprecated))ne&&(_[J.toLowerCase()]=(0,R.$Pf)(ne)?{}:ne);if(U.search)for(const J of U.search)ie.push(J)}return{malicious:Z,deprecated:_,search:ie}}};G=pe([K(1,l.$jp),K(2,p.$pj),K(3,P.$ci),K(4,c.$wl),K(5,$.$sk),K(6,E.$Hj),K(7,g.$Bi)],G);let z=class extends G{constructor(B,U,Z,_,ie,J,ne,ce){super(B,U,Z,_,ie,J,ne,ce)}};e.$Fp=z,e.$Fp=z=pe([K(0,d.$wp),K(1,l.$jp),K(2,p.$pj),K(3,P.$ci),K(4,c.$wl),K(5,$.$sk),K(6,E.$Hj),K(7,g.$Bi)],z);let j=class extends G{constructor(B,U,Z,_,ie,J,ne){super(void 0,B,U,Z,_,ie,J,ne)}};e.$Gp=j,e.$Gp=j=pe([K(0,l.$jp),K(1,p.$pj),K(2,P.$ci),K(3,c.$wl),K(4,$.$sk),K(5,E.$Hj),K(6,g.$Bi)],j)}),define(le[83],he([0,1,4,3,2,19,33,24,17,8,12]),function(se,e,O,A,D,L,I,R,S,g,P){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$pv=e.$ov=void 0,e.$ov=(0,O.$8h)("IExtensionStorageService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let h=class extends D.$Tc{static{k=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,I.$7o)(p.id)}@${p.version}`}static c(p){const E=m.exec(p);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(p,E){const l=await p.getInstalled(),u=[];for(const[d,c]of k.f(E)){const y=l.find(i=>(0,I.$3o)(i.identifier,{id:d}))?.manifest.version;for(const i of c)y!==i&&u.push(k.b({id:d,version:i}))}for(const d of u)E.remove(d,0)}static f(p){const E=new Map,l=p.keys(0,1);for(const u of l){const d=k.c(u);if(d){let c=E.get(d.id.toLowerCase());c||E.set(d.id.toLowerCase(),c=[]),c.push(d.version)}}return E}constructor(p,E,l){super(),this.j=p,this.m=E,this.n=l,this.g=this.B(new A.$Wd),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=k.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new D.$Sc))(u=>this.r(u)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const E=k.c(p.key);if(E){if(this.j.get(p.key,0)===void 0)this.h.delete(E.id.toLowerCase());else{let l=this.h.get(E.id.toLowerCase());l||this.h.set(E.id.toLowerCase(),l=[]),l.push(E.version),this.g.fire()}return}}s(p){if((0,P.$Jf)(p))return p;const E=p.manifest?p.manifest.publisher:p.publisher,l=p.manifest?p.manifest.name:p.name;return(0,I.$6o)(E,l)}getExtensionState(p,E){const l=this.s(p),u=this.getExtensionStateRaw(p,E);if(u)try{return JSON.parse(u)}catch(d){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${E}): ${d}`)}}getExtensionStateRaw(p,E){const l=this.s(p),u=this.j.get(l,E?0:1);return u&&u?.length>k.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${E}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(p,E,l){const u=this.s(p);E===void 0?this.j.remove(u,l?0:1):this.j.store(u,JSON.stringify(E),l?0:1,1)}setKeysForSync(p,E){this.j.store(k.b(p),JSON.stringify(E),0,1)}getKeysForSync(p){const E=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],l=this.j.get(k.b(p),0),u=l?JSON.parse(l):void 0;return u&&E?(0,S.$Mb)([...u,...E]):u||E}addToMigrationList(p,E){if(p!==E){const l=this.t.filter(u=>!u.includes(p)&&!u.includes(E));l.push([p,E]),this.t=l}}getSourceExtensionToMigrate(p){const E=this.t.find(([,l])=>p===l);return E?E[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const E=JSON.parse(p);if(Array.isArray(E))return E}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$pv=h,e.$pv=h=k=pe([K(0,L.$wp),K(1,R.$Hj),K(2,g.$pj)],h)}),define(le[249],he([0,1,2,29,83,224,113,8,19]),function(se,e,O,A,D,L,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iac=void 0;let g=class extends O.$Tc{constructor(k,m,h,$,p,E){super(),k.cleanUp(),(0,L.$OZb)(k,m,h,$,E),D.$pv.removeOutdatedExtensionVersions(k,p)}};e.$iac=g,e.$iac=g=pe([K(0,I.$_p),K(1,A.$Bo),K(2,D.$ov),K(3,A.$Ho),K(4,S.$wp),K(5,R.$pj)],g)}),define(le[250],he([0,1,29,11,24,15,97,57,19,22,223]),function(se,e,O,A,D,L,I,R,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0;let k=class extends P.$E9b{constructor(h,$,p,E,l,u,d,c){super(h.userHome,l,$,p,E,u,d,c)}};e.$pac=k,e.$pac=k=pe([K(0,L.$di),K(1,g.$wl),K(2,O.$Eo),K(3,S.$wp),K(4,R.$e$b),K(5,I.$yZb),K(6,A.$sk),K(7,D.$Hj)],k)}),define(le[251],he([0,1,105,3,22,15,2,8,16,67,24,5,6,101,21,165,36,19,12,132,20]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=void 0;const y=[O.$eac,O.$fac],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends I.$Tc{constructor(a,v,w,f,b,C,N){super(),this.y=a,this.z=v,this.C=w,this.D=C,this.F=N,this.f=new A.$Wd,this.onDidTokenFailed=this.f.event,this.g=new A.$Wd,this.onDidChangeTunnelStatus=this.g.event,this.h=new A.$Wd,this.onDidChangeMode=this.h.event,this.n=O.$cac,this.w=!1,this.I=(T,M)=>{M?this.j.error(T):this.j.info(T)},this.j=this.B(f.createLogger((0,c.$Ig)(w.logsHome,`${O.$gac}.log`),{id:O.$gac,name:O.$hac})),this.t=new m.$5g(100),this.B(this.j.onDidChangeLogLevel(T=>this.j.info("Log level changed to "+(0,R.$Ej)(T)))),this.B(b.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(C.onDidChangeConfiguration(T=>{y.some(M=>T.affectsConfiguration(M))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=O.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let a;k.$j?a=this.C.appRoot:a=(0,S.$mc)((0,S.$mc)(this.C.appRoot)),this.u=(0,S.$jc)(a,"bin",`${this.z.tunnelApplicationName}${k.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(O.$cac);try{a&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(O.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",v=!1;const w=(M,q)=>{q?this.j.error(M):a+=M,!this.C.isBuilt&&M.startsWith("   Compiling")&&this.G(O.TunnelStates.connecting((0,p.localize)(0,null)))},f=this.O("status",["status"],w);this.r=f;try{if(await f,this.r!==f)return;let M;try{M=JSON.parse(a.trim().split(`
`).find(q=>q.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(O.TunnelStates.disconnected());return}if(v=M.service_installed,this.j.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this.n.active){this.G(O.TunnelStates.disconnected());return}}catch(M){this.j.error(M),this.G(O.TunnelStates.disconnected());return}finally{this.r===f&&(this.r=void 0)}const b=this.n.active?this.n.session:void 0;if(b&&b.token){const M=b.token;this.G(O.TunnelStates.connecting((0,p.localize)(1,null,b.accountLabel,b.providerId)));const q=(X,x)=>{X=X.replaceAll(M,"*".repeat(4)),w(X,x)},Y=this.O("login",["user","login","--provider",b.providerId,"--access-token",M,"--log",(0,R.$Ej)(this.j.getLevel())],q);this.r=Y;try{if(await Y,this.r!==Y)return}catch(X){this.j.error(X),this.r=void 0,this.f.fire(b),this.G(O.TunnelStates.disconnected(b));return}}const C=this.Q();C?this.G(O.TunnelStates.connecting((0,p.localize)(2,null,C))):this.G(O.TunnelStates.connecting((0,p.localize)(3,null)));const N=["--accept-server-license-terms","--log",(0,R.$Ej)(this.j.getLevel())];C?N.push("--name",C):N.push("--random-name");let T=!1;return this.n.active&&this.n.asService&&!v&&(T=await this.M(N)===!1),this.N(b,N,T)}async M(a){let v;try{v=await this.O("serviceInstall",["service","install",...a])}catch(w){this.j.error(w),v=1}if(v!==0){const w=(0,p.localize)(4,null);return this.j.warn(w),this.G(O.TunnelStates.connecting(w)),!1}return!0}async N(a,v,w){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let f=!1;const b=this.O("tunnel",v,(C,N)=>{N?this.j.error(C):this.j.info(C),C.includes("Connected to an existing tunnel process")&&(f=!0);const T=C.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const M={link:T[1],domain:T[2],tunnelName:T[4],isAttached:f};this.G(O.TunnelStates.connected(M,w))}else C.match(/error refreshing token/)&&(b.cancel(),this.f.fire(a),this.G(O.TunnelStates.disconnected(a)))});this.r=b,b.finally(()=>{b===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=O.$cac,this.G(O.TunnelStates.disconnected()))})}O(a,v,w=this.I){return(0,m.$Ug)(f=>new Promise((b,C)=>{f.isCancellationRequested&&b(-1);let N;const T=["ignore","pipe","pipe"];if(f.onCancellationRequested(()=>{N&&(this.j.info(`${a} terminating(${N.pid})`),N.kill())}),!this.C.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${a} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),N=(0,g.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,S.$jc)(this.C.appRoot,"cli"),stdio:T});else{w(`Running tunnel CLI
`,!1);const M=this.J();w(`${a} Spawning: ${M} tunnel ${v.join(" ")}
`,!1),N=(0,g.spawn)(M,["tunnel",...v],{cwd:(0,E.homedir)(),stdio:T})}N.stdout.pipe(new d.$RU(`
`)).on("data",M=>{if(N){const q=M.toString();w(q,!1)}}),N.stderr.pipe(new d.$RU(`
`)).on("data",M=>{if(N){const q=M.toString();w(q,!0)}}),N.on("exit",M=>{N&&(w(`${a} exit(${N.pid}): + ${M} `,!1),N=void 0,b(M||0))}),N.on("error",M=>{N&&(w(`${a} error(${N.pid}): + ${M} `,!0),N=void 0,C())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(O.$fac)}Q(){let a=this.D.getValue(O.$eac)||(0,E.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),v=this.F.getBoolean(o,-1,!1);if(a){const w=JSON.parse(a);if(w&&(0,u.$Jf)(w.accountLabel)&&(0,u.$Jf)(w.sessionId)&&(0,u.$Jf)(w.providerId))return{active:!0,session:w,asService:v};this.j.error("Problems restoring session from storage, invalid format",w)}}catch(a){this.j.error("Problems restoring session from storage",a)}return O.$cac}S(a){if(a.active){const v={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(v),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$lac=n,e.$lac=n=pe([K(0,D.$wl),K(1,P.$Hj),K(2,L.$di),K(3,R.$qj),K(4,h.$jac),K(5,$.$Bi),K(6,l.$wp)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[252],he([0,1,6,2,23,20,69,19,78,18]),function(se,e,O,A,D,L,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=void 0;class P extends R.$yp{constructor(m,h,$,p){super(),this.bb=m,this.cb=h,this.db=$,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new A.$Sc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new A.$Sc),this.ab=this.hb(this.bb)}fb(){const m=this.B(new S.$GGb(this.db.getChannel("storage"))),h=this.B(new I.$sp(m));return this.B(h.onDidChangeStorage($=>this.u(-1,$))),h}gb(m){this.X.clear(),this.W=m;let h;if((0,R.$zp)(m))h=this.U;else{const $=this.X.add(new S.$HGb(this.db.getChannel("storage"),m));h=this.X.add(new I.$sp($))}return this.X.add(h.onDidChangeStorage($=>this.u(0,$))),h}hb(m){this.$.clear(),this.Z=m?.id;let h;if(m){const $=this.$.add(new S.$IGb(this.db.getChannel("storage"),m));h=this.$.add(new I.$sp($)),this.$.add(h.onDidChangeStorage(p=>this.u(1,p)))}return h}async O(){await O.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(m){switch(m){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(m){switch(m){case-1:return this.s.globalStorageHome.with({scheme:D.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:D.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$Ig)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:D.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await O.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(m){if(!this.M(this.W,m))return;const h=this.Y,$=h.items;h!==this.U&&await h.close(),this.Y=this.gb(m),await this.Y.init(),this.N($,this.Y,0)}async S(m,h){const $=this.ab,p=$?.items??new Map;await $?.close(),this.ab=this.hb(m),await this.ab.init(),this.N(p,this.ab,1)}hasScope(m){return(0,g.$4k)(m)?this.W.id===m.id:this.Z===m.id}}e.$qac=P}),define(le[253],he([0,1,3,2,18,92]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=e.$4O=void 0;class I{constructor(g,P){this.a=g,this.b=P}listen(g,P){const k=this.b(g);switch(P){case"onDidChangeProfiles":return O.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(h=>(0,L.$9m)({...h},k)),added:m.added.map(h=>(0,L.$9m)({...h},k)),removed:m.removed.map(h=>(0,L.$9m)({...h},k)),updated:m.updated.map(h=>(0,L.$9m)({...h},k))}))}throw new Error(`Invalid listen ${P}`)}async call(g,P,k){const m=this.b(g);switch(P){case"createProfile":{const h=await this.a.createProfile(k[0],k[1],k[2]);return(0,L.$9m)({...h},m)}case"updateProfile":{let h=(0,D.$6k)((0,L.$0m)(k[0],m),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,k[1]),(0,L.$9m)({...h},m)}case"removeProfile":{const h=(0,D.$6k)((0,L.$0m)(k[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${P}`)}}e.$4O=I;class R extends A.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,P,k){super(),this.profilesHome=P,this.f=k,this.a=[],this.b=this.B(new O.$Wd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(m=>(0,D.$6k)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const h=m.added.map(E=>(0,D.$6k)(E,this.profilesHome.scheme)),$=m.removed.map(E=>(0,D.$6k)(E,this.profilesHome.scheme)),p=m.updated.map(E=>(0,D.$6k)(E,this.profilesHome.scheme));this.a=m.all.map(E=>(0,D.$6k)(E,this.profilesHome.scheme)),this.b.fire({added:h,removed:$,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,P,k){const m=await this.f.call("createNamedProfile",[g,P,k]);return(0,D.$6k)(m,this.profilesHome.scheme)}async createProfile(g,P,k,m){const h=await this.f.call("createProfile",[g,P,k,m]);return(0,D.$6k)(h,this.profilesHome.scheme)}async createTransientProfile(g){const P=await this.f.call("createTransientProfile",[g]);return(0,D.$6k)(P,this.profilesHome.scheme)}async setProfileForWorkspace(g,P){await this.f.call("setProfileForWorkspace",[g,P])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,P){const k=await this.f.call("updateProfile",[g,P]);return(0,D.$6k)(k,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$5O=R}),define(le[60],he([0,1,2,69,4,19,3,78,18]),function(se,e,O,A,D,L,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MGb=e.$LGb=e.$KGb=void 0,e.$KGb=(0,D.$8h)("IUserDataProfileStorageService");let g=class extends O.$Tc{constructor(h){super(),this.a=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async $=>this.b($))}async updateStorageData(h,$,p){return this.withProfileScopedStorageService(h,async E=>this.c(E,$,p))}async withProfileScopedStorageService(h,$){if(this.a.hasScope(h))return $(this.a);const p=await this.g(h),E=new k(p);try{await E.initialize();const l=await $(E);return await E.flush(),l}finally{E.dispose(),await this.f(p)}}b(h){const $=new Map,p=E=>{for(const l of h.keys(0,E))$.set(l,{value:h.get(l,0),target:E})};return p(0),p(1),$}c(h,$,p){h.storeAll(Array.from($.entries()).map(([E,l])=>({key:E,value:l,scope:0,target:p})),!0)}async f(h){try{await h.close()}finally{(0,O.$Nc)(h)&&h.dispose()}}};e.$LGb=g,e.$LGb=g=pe([K(0,L.$wp)],g);class P extends g{constructor(h,$,p,E){super(p),this.j=h;const l=h.getChannel("profileStorageListener"),u=this.B(new O.$Uc);this.h=this.B(new I.$Wd({onWillAddFirstListener:()=>{u.value=l.listen("onDidChange")(d=>{E.trace("profile storage changes",d),this.h.fire({targetChanges:d.targetChanges.map(c=>(0,S.$6k)(c,$.profilesHome.scheme)),valueChanges:d.valueChanges.map(c=>({...c,profile:(0,S.$6k)(c.profile,$.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(h){const $=this.j.getChannel("storage");return(0,L.$zp)(h)?new R.$GGb($):new R.$HGb($,h)}}e.$MGb=P;class k extends L.$yp{constructor(h){super({flushInterval:100}),this.s=this.B(new A.$sp(h))}O(){return this.s.init()}P(h){return h===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[254],he([0,1,19,8,18,56,60]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8_b=void 0;let R=class extends I.$MGb{constructor(g,P,k,m){super(g,P,k,m)}};e.$8_b=R,e.$8_b=R=pe([K(0,L.$u_b),K(1,D.$5k),K(2,O.$wp),K(3,A.$pj)],R)}),define(le[39],he([0,1,17,6,14,26,3,34,2,27,12,170,21,15,11,8,43,19,22,28,25,18]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LHb=e.$KHb=e.$JHb=e.$IHb=e.$HHb=e.$GHb=e.$FHb=void 0;function i(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||o(v.syncData)))}e.$FHb=i;function o(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$GHb=o;function n(v,w){return`${(0,g.$Bf)(v)}${w.isDefault?"":` (${w.name})`}`}e.$HHb=n;let s=class extends S.$Tc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(w,f,b,C,N,T,M,q,Y,X,x,V){super(),this.syncResource=w,this.collection=f,this.G=b,this.H=C,this.I=N,this.J=T,this.L=M,this.M=q,this.N=Y,this.O=X,this.P=x,this.c=null,this.m="idle",this.n=this.B(new I.$Wd),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new I.$Wd),this.onDidChangeConflicts=this.t.event,this.u=this.B(new A.$6g(50)),this.w=this.B(new I.$Wd),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(w.syncResource,w.profile),this.h=V.extUri,this.f=this.h.joinPath(C.userDataSyncHome,...(0,c.$aob)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,c.$vob),this.y=(0,c.$bob)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,C,this.h),this.j=(0,E.$Cp)(C,b,N)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const f=await this.Y(w.remoteUserData,w.lastSyncUserData,!0,this.ob());this.S(f)}else{this.O.trace(`${this.D}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.ub(w):!0)&&this.w.fire()}}S(w){this.m!==w&&(this.m=w,this.n.fire(w))}async sync(w,f={}){await this.U(w,!0,this.ob(),f)}async preview(w,f,b={}){return this.U(w,!1,f,b)}async apply(w,f={}){try{this.F={...f};const b=await this.ab(w);return this.S(b),this.c}finally{this.F={}}}async U(w,f,b,C){try{if(this.F={...C},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let N="idle";try{const T=await this.getLastSyncUserData(),M=await this.X(w,T);return N=await this.Y(M,T,f,b),N==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(N)}}finally{this.F={}}}async replace(w){const f=this.kb(w);if(!f)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const b=await this.getLastSyncUserData(),C=await this.X(null,b),N=await this.W(C),T=await this.qb({ref:C.ref,syncData:f},b,N,this.ob(),L.CancellationToken.None),M=[];for(const q of T){const Y=await this.sb(q,q.remoteResource,void 0,L.CancellationToken.None),{remoteChange:X}=await this.sb(q,q.previewResource,q.remoteContent,L.CancellationToken.None);M.push([q,{...Y,remoteChange:X!==0?X:2}])}await this.tb(C,b,M,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(w){const f=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===f}async X(w,f){if(f){const b=w?w[this.resource]:void 0;if(f.ref===b||b===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async Y(w,f,b,C){if(w.syncData&&w.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new c.$iob((0,k.localize)(0,null,this.resource,this.pb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(w,f,b,C)}catch(N){if(N instanceof c.$iob)switch(N.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(w,f,b,C);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.Y(w,f,b,C)}throw N}}async Z(w,f,b,C){try{const N=await this.W(w),T=!N&&f===null&&this.gb()!==void 0,M=b&&!T;this.c||(this.c=(0,A.$Ug)(Y=>this.eb(w,f,N,M,C,Y)));let q=await this.c;if(b&&T){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of q.resourcePreviews)q=await this.accept(Y.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":b?await this.ab(!1):"syncing"}catch(N){throw this.c=null,N}}async merge(w){return await this.$(w,async f=>{const b=await this.rb(f,L.CancellationToken.None);await this.G.writeFile(f.previewResource,D.$ke.fromString(b?.content||""));const C=b&&!b.hasConflicts?await this.sb(f,f.previewResource,void 0,L.CancellationToken.None):void 0;return f.acceptResult=C,f.mergeState=b.hasConflicts?"conflict":C?"accepted":"preview",f.localChange=C?C.localChange:b.localChange,f.remoteChange=C?C.remoteChange:b.remoteChange,f}),this.c}async accept(w,f){return await this.$(w,async b=>{const C=await this.sb(b,w,f,L.CancellationToken.None);return b.acceptResult=C,b.mergeState="accepted",b.localChange=C.localChange,b.remoteChange=C.remoteChange,b}),this.c}async discard(w){return await this.$(w,async f=>{const b=await this.rb(f,L.CancellationToken.None);return await this.G.writeFile(f.previewResource,D.$ke.fromString(b.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=b.localChange,f.remoteChange=b.remoteChange,f}),this.c}async $(w,f){if(!this.c)return;let b=await this.c;const C=b.resourcePreviews.findIndex(({localResource:N,remoteResource:T,previewResource:M})=>this.h.isEqual(N,w)||this.h.isEqual(T,w)||this.h.isEqual(M,w));C!==-1&&(this.c=(0,A.$Ug)(async N=>{const T=[...b.resourcePreviews];return T[C]=await f(T[C]),{...b,resourcePreviews:T}}),b=await this.c,this.cb(b.resourcePreviews),b.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(w){if(!this.c)return"idle";const f=await this.c;return f.resourcePreviews.some(({mergeState:b})=>b==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:b})=>b!=="accepted")?"syncing":(await this.tb(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(b=>[b,b.acceptResult]),w),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(w){const f=w.filter(({mergeState:b})=>b==="conflict");(0,O.$ub)(this.s,f,(b,C)=>this.h.isEqual(b.previewResource,C.previewResource))||(this.s=f,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async db(w){const f=this.c?await this.c:null;if(f)for(const b of f.resourcePreviews){if(this.h.isEqual(b.acceptedResource,w))return b.acceptResult?b.acceptResult.content:null;if(this.h.isEqual(b.remoteResource,w))return b.remoteContent;if(this.h.isEqual(b.localResource,w))return b.localContent;if(this.h.isEqual(b.baseResource,w))return b.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(w){(0,$.$Jk)(w)!==1&&this.O.error(w)}}async eb(w,f,b,C,N,T){const M=await this.qb(w,f,b,N,T),q=[];for(const Y of M){const X=Y.previewResource.with({scheme:c.$uob,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)q.push({...Y,acceptedResource:X,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=C?await this.rb(Y,T):void 0;if(T.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,D.$ke.fromString(x?.content||""));const V=x&&!x.hasConflicts?await this.sb(Y,Y.previewResource,void 0,T):void 0;q.push({...Y,acceptResult:V,mergeState:x?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:x?x.localChange:Y.localChange,remoteChange:V?V.remoteChange:x?x.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:f,resourcePreviews:q,isLastSyncFromCurrentMachine:b}}async getLastSyncUserData(){let w=this.gb();if(w||(w=await this.jb()),!w)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const f=JSON.parse(w),b=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!f.version&&!!b&&f.version!==b,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${b}.`),await this.resetLocal(),null;let C,N=1;for(;C===void 0&&N++<6;)try{const T=await this.hb();T&&(T.ref===f.ref?C=T.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(T){if(T instanceof $.$Nk&&T.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(T instanceof c.$iob)throw T;this.O.error(T,N)}}if(C===void 0)try{const T=await this.J.resolveResourceContent(this.resource,f.ref,this.collection,this.F);C=T===null?null:this.kb(T),await this.ib({ref:f.ref,syncData:C})}catch(T){if(T instanceof c.$iob&&T.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw T}return C===void 0?null:{...f,syncData:C}}async fb(w,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const b=this.M.getResourceSyncStateVersion(this.resource),C={ref:w.ref,version:b,...f};this.I.store(this.z,JSON.stringify(C),-1,1),await this.ib(w)}gb(){return this.I.get(this.z,-1)}async hb(){const w=(await this.G.readFile(this.y)).value.toString();try{const f=w?JSON.parse(w):void 0;if(i(f))return f}catch(f){this.O.error(f)}}async ib(w){await this.G.writeFile(this.y,D.$ke.fromString(JSON.stringify(w)))}async jb(){try{const w=await this.G.readFile(this.y),f=JSON.parse(w.value.toString());await this.G.del(this.y),f.ref&&f.content!==void 0?(this.I.store(this.z,JSON.stringify({...f,content:void 0}),-1,1),await this.ib({ref:f.ref,syncData:f.content===null?null:JSON.parse(f.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,f)}catch(w){w instanceof $.$Nk&&w.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(w)}return this.I.get(this.z,-1)}async getRemoteUserData(w){const{ref:f,content:b}=await this.lb(w);let C=null;return b!==null&&(C=this.kb(b)),{ref:f,syncData:C}}kb(w){try{const f=JSON.parse(w);if(o(f))return f}catch(f){this.O.error(f)}throw new c.$iob((0,k.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(w){const f=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.J.readResource(this.resource,f,this.collection,this.F)}async mb(w,f){const b=await this.j,C={version:this.pb,machineId:b,content:w};try{return f=await this.J.writeResource(this.resource,JSON.stringify(C),f,this.collection,this.F),{ref:f,syncData:C}}catch(N){throw N instanceof c.$iob&&N.code==="TooLarge"&&(N=new c.$iob(N.message,N.code,this.resource)),N}}async nb(w){const f={version:this.pb,content:w};return this.L.writeResource(this.resource,JSON.stringify(f),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(c.$8nb)}};e.$IHb=s,e.$IHb=s=pe([K(2,$.$sk),K(3,h.$ci),K(4,l.$wp),K(5,c.$dob),K(6,c.$eob),K(7,c.$nob),K(8,u.$wl),K(9,c.$sob),K(10,m.$Bi),K(11,d.$3k)],s);let t=class extends s{constructor(w,f,b,C,N,T,M,q,Y,X,x,V,Q){super(f,b,C,N,T,M,q,Y,X,x,V,Q),this.r=w,this.B(this.G.watch(this.h.dirname(w))),this.B(this.G.onDidFilesChange(H=>this.yb(H)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(w,f,b){try{f?await this.G.writeFile(this.r,D.$ke.fromString(w),b?void 0:f):await this.G.createFile(this.r,D.$ke.fromString(w),{overwrite:b})}catch(C){throw C instanceof $.$Nk&&C.fileOperationResult===1||C instanceof $.$Nk&&C.fileOperationResult===3?new c.$iob(C.message,"LocalPreconditionFailed"):C}}async xb(){try{await this.G.del(this.r)}catch(w){if(!(w instanceof $.$Nk&&w.fileOperationResult===1))throw w}}yb(w){w.contains(this.r)&&this.Q()}};e.$JHb=t,e.$JHb=t=pe([K(3,$.$sk),K(4,h.$ci),K(5,l.$wp),K(6,c.$dob),K(7,c.$eob),K(8,c.$nob),K(9,u.$wl),K(10,c.$sob),K(11,m.$Bi),K(12,d.$3k)],t);let r=class extends t{constructor(w,f,b,C,N,T,M,q,Y,X,x,V,Q,H){super(w,f,b,C,N,T,M,q,Y,X,x,Q,H),this.zb=V,this.Bb=void 0}Ab(w,f){const b=[],C=(0,R.$fn)(w,b,{allowEmptyContent:!0,allowTrailingComma:!0});return b.length>0||!(0,P.$Qf)(C)&&f!==Array.isArray(C)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$KHb=r,e.$KHb=r=pe([K(3,$.$sk),K(4,h.$ci),K(5,l.$wp),K(6,c.$dob),K(7,c.$eob),K(8,c.$nob),K(9,u.$wl),K(10,c.$sob),K(11,c.$rob),K(12,m.$Bi),K(13,d.$3k)],r);let a=class{constructor(w,f,b,C,N,T,M){this.resource=w,this.g=f,this.h=b,this.j=C,this.k=N,this.l=T,this.d=M.extUri,this.f=(0,c.$bob)(void 0,this.resource,b,this.d)}async initialize({ref:w,content:f}){if(!f){this.j.info("Remote content does not exist.",this.resource);return}const b=this.m(f);if(b)try{await this.o({ref:w,syncData:b})}catch(C){this.j.error(C)}}m(w){try{const f=JSON.parse(w);if(o(f))return f}catch(f){this.j.error(f)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const b={ref:w.ref,version:void 0,...f};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(b),-1,1),await this.k.writeFile(this.f,D.$ke.fromString(JSON.stringify(w)))}};e.$LHb=a,e.$LHb=a=pe([K(1,y.$5k),K(2,h.$ci),K(3,p.$pj),K(4,$.$sk),K(5,l.$wp),K(6,d.$3k)],a)}),define(le[115],he([0,1,6,26,7,3,42,2,27,21,15,114,29,33,83,45,11,4,74,8,19,22,28,18,39,235,111,25,60]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d,c,y,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O7b=e.$N7b=e.$M7b=e.$L7b=e.$K7b=void 0;async function v(T,M){const q=JSON.parse(T.content);if(T.version===1||T.version===2){const Y=(await M.getInstalled(0)).filter(X=>X.isBuiltin);for(const X of q)T.version===1&&(X.enabled===!1&&(X.disabled=!0),delete X.enabled),T.version===2&&Y.every(x=>!(0,h.$3o)(x.identifier,X.identifier))&&(X.installed=!0)}return q}function w(T){return JSON.parse(T.content)}e.$K7b=w;function f(T,M){return T.sort((q,Y)=>!q.identifier.uuid&&Y.identifier.uuid?-1:q.identifier.uuid&&!Y.identifier.uuid?1:(0,S.$6e)(q.identifier.id,Y.identifier.id)),M?(0,I.$qn)(T,{}):JSON.stringify(T)}e.$L7b=f;let b=class extends n.$IHb{constructor(M,q,Y,X,x,V,Q,H,W,te,oe,ee,ae,G,z,j,F){super({syncResource:"extensions",profile:M},q,X,Y,x,V,Q,ee,ae,te,oe,z),this.Cb=H,this.Db=W,this.Eb=F,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$uob,authority:"base"}),this.yb=this.wb.with({scheme:r.$uob,authority:"local"}),this.zb=this.wb.with({scheme:r.$uob,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$uob,authority:"accepted"}),this.Bb=this.Eb.createInstance(C),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:U})=>!!U)),L.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),L.Event.filter(j.onDidChange,B=>B.valueChanges.some(({profile:U,changes:Z})=>this.syncResource.profile.id===U.id&&Z.some(_=>_.key===m.$Fo))),G.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(M,q){const Y=M.syncData?await v(M.syncData,this.Cb):null,X=q?.skippedExtensions??[],x=q?.builtinExtensions??null,V=q?.syncData?await v(q.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:te}=(0,s.$J7b)(Q,Y,V,X,H,x),oe={local:W,remote:te,content:this.Hb(Q,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:te!==null?2:0},ee=this.Ob(Q,!1);return[{skippedExtensions:X,builtinExtensions:x,baseResource:this.xb,baseContent:V?this.Ob(V,!1):ee,localResource:this.yb,localContent:ee,localExtensions:Q,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:oe,localChange:oe.localChange,remoteChange:oe.remoteChange,acceptedResource:this.Ab}]}async ub(M){const q=M.syncData?await v(M.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:X}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,s.$J7b)(Y,q,q,M.skippedExtensions||[],X,M.builtinExtensions||[]);return x!==null}Hb(M,q,Y,X){const x=[...q,...Y],V=new Set,Q=H=>{V.add(H.id.toLowerCase()),H.uuid&&V.add(H.uuid)};x.forEach(({identifier:H})=>Q(H)),X.forEach(Q);for(const H of M)V.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&V.has(H.identifier.uuid)||x.push(H);return this.Ob(x,!1)}async rb(M,q){return{...M.previewResult,hasConflicts:!1}}async sb(M,q,Y,X){if(this.h.isEqual(q,this.yb))return this.Kb(M);if(this.h.isEqual(q,this.zb))return this.Lb(M);if(this.h.isEqual(q,this.wb))return M.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(M){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),X=(0,s.$J7b)(M.localExtensions,null,null,M.skippedExtensions,Y,M.builtinExtensions),{local:x,remote:V}=X;return{content:M.localContent,local:x,remote:V,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:V!==null?2:0}}async Lb(M){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),X=M.remoteContent?JSON.parse(M.remoteContent):null;if(X!==null){const x=(0,s.$J7b)(M.localExtensions,X,M.localExtensions,[],Y,M.builtinExtensions),{local:V,remote:Q}=x;return{content:M.remoteContent,local:V,remote:Q,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(M,q,Y,X){let{skippedExtensions:x,builtinExtensions:V,localExtensions:Q}=Y[0][0];const{local:H,remote:W,localChange:te,remoteChange:oe}=Y[0][1];if(te===0&&oe===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),te!==0&&(await this.nb(JSON.stringify(Q)),x=await this.Bb.updateLocalExtensions(H.added,H.removed,H.updated,x,this.syncResource.profile)),W){this.O.trace(`${this.D}: Updating remote extensions...`);const ee=JSON.stringify(W.all);M=await this.mb(ee,X?null:M.ref),this.O.info(`${this.D}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(ae=>ae.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(ae=>ae.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(ae=>ae.identifier.id))}.`:""}`)}q?.ref!==M.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),V=this.Nb(Q,V),await this.fb(M,{skippedExtensions:x,builtinExtensions:V}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ee=>ee.identifier.id))}.`:""}`))}Nb(M,q){const Y=new Set,X=[];for(const x of M)Y.add(x.identifier.id.toLowerCase()),x.installed||X.push(x.identifier);if(q)for(const x of q)Y.has(x.id.toLowerCase())||X.push(x);return X}async resolveContent(M){if(this.h.isEqual(this.zb,M)||this.h.isEqual(this.xb,M)||this.h.isEqual(this.yb,M)||this.h.isEqual(this.Ab,M)){const q=await this.db(M);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(M,q){return f(M,q)}async hasLocalData(){try{const{localExtensions:M}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(M.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$M7b=b,e.$M7b=b=pe([K(2,P.$ci),K(3,E.$sk),K(4,c.$wp),K(5,r.$dob),K(6,r.$eob),K(7,m.$Eo),K(8,t.$rIb),K(9,r.$sob),K(10,g.$Bi),K(11,r.$nob),K(12,y.$wl),K(13,$.$ov),K(14,i.$3k),K(15,a.$KGb),K(16,l.$7h)],b);let C=class{constructor(M,q,Y,X,x,V){this.a=M,this.b=q,this.c=Y,this.d=X,this.f=x,this.g=V}async getLocalExtensions(M){const q=await this.a.getInstalled(void 0,M.extensionsResource),Y=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(M,async(x,V)=>{const Q=x.getDisabledExtensions();return q.map(H=>{const{identifier:W,isBuiltin:te,manifest:oe,preRelease:ee,pinned:ae,isApplicationScoped:G}=H,z={identifier:W,preRelease:ee,version:oe.version,pinned:!!ae};G&&!(0,p.$qm)(oe)&&(z.isApplicationScoped=G),Q.some(j=>(0,h.$3o)(j,W))&&(z.disabled=!0),te||(z.installed=!0);try{const j=V.getKeysForSync({id:W.id,version:oe.version});if(j){const F=V.getExtensionState(H,!0)||{};z.state=Object.keys(F).reduce((B,U)=>(j.includes(U)&&(B[U]=F[U]),B),{})}}catch(j){this.g.info(`${(0,n.$HHb)("extensions",M)}: Error while parsing extension state`,(0,D.$0)(j))}return z})}),ignoredExtensions:Y}}async updateLocalExtensions(M,q,Y,X,x){const V=(0,n.$HHb)("extensions",x),Q=[],H=new Map,W=[],te=[],oe=await this.a.getInstalled(void 0,x.extensionsResource);if((M.length||Y.length)&&await this.j(x,async(G,z)=>{await O.Promises.settled([...M,...Y].map(async j=>{const F=oe.find(Z=>(0,h.$3o)(Z.identifier,j.identifier));if(F&&F.isBuiltin){j.state&&F.manifest.version===j.version&&this.h(j.state,F,F.manifest.version,z),G.getDisabledExtensions().some(_=>(0,h.$3o)(_,j.identifier))!==!!j.disabled&&(j.disabled?(this.g.trace(`${V}: Disabling extension...`,j.identifier.id),await G.disableExtension(j.identifier),this.g.info(`${V}: Disabled extension`,j.identifier.id)):(this.g.trace(`${V}: Enabling extension...`,j.identifier.id),await G.enableExtension(j.identifier),this.g.info(`${V}: Enabled extension`,j.identifier.id))),W.push(j.identifier);return}const B=j.pinned?j.version:void 0,U=(await this.c.getExtensions([{...j.identifier,version:B,preRelease:B?void 0:j.preRelease}],A.CancellationToken.None))[0];if(j.state&&(F?F.manifest.version===j.version:U)&&this.h(j.state,F||U,F?.manifest.version,z),U)try{G.getDisabledExtensions().some(_=>(0,h.$3o)(_,j.identifier))!==!!j.disabled&&(j.disabled?(this.g.trace(`${V}: Disabling extension...`,j.identifier.id,U.version),await G.disableExtension(U.identifier),this.g.info(`${V}: Disabled extension`,j.identifier.id,U.version)):(this.g.trace(`${V}: Enabling extension...`,j.identifier.id,U.version),await G.enableExtension(U.identifier),this.g.info(`${V}: Enabled extension`,j.identifier.id,U.version))),(!F||F.preRelease!==j.preRelease||F.pinned!==j.pinned||B&&F.manifest.version!==B)&&(await this.a.canInstall(U)?(Q.push({extension:U,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:j.pinned&&!!j.version,installPreReleaseVersion:j.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:j.isApplicationScoped,context:{[m.$so]:!0,[m.$to]:!0}}}),H.set(U.identifier.id.toLowerCase(),j)):(this.g.info(`${V}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),te.push(j)))}catch(Z){te.push(j),this.g.error(Z),this.g.info(`${V}: Skipped synchronizing extension`,U.displayName||U.identifier.id)}else te.push(j),this.g.info(`${V}: Skipped synchronizing extension because the extension is not found.`,j.identifier.id)}))}),q.length){const G=oe.filter(({identifier:z,isBuiltin:j})=>!j&&q.some(F=>(0,h.$3o)(z,F)));await O.Promises.settled(G.map(async z=>{this.g.trace(`${V}: Uninstalling local extension...`,z.identifier.id),await this.a.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${V}: Uninstalled local extension.`,z.identifier.id),W.push(z.identifier)}))}const ee=await this.a.installGalleryExtensions(Q);for(const{identifier:G,local:z,error:j,source:F}of ee){const B=F;if(z)this.g.info(`${V}: Installed extension.`,G.id,B.version),W.push(G);else{const U=H.get(G.id.toLowerCase());U&&(te.push(U),this.g.info(`${V}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),j instanceof m.$Co&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(j.code)?this.g.info(`${V}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):j&&this.g.error(j)}}const ae=[];for(const G of X)W.some(z=>(0,h.$3o)(z,G.identifier))||ae.push(G);for(const G of te)ae.some(z=>(0,h.$3o)(z.identifier,G.identifier))||ae.push(G);return ae}h(M,q,Y,X){const x=X.getExtensionState(q,!0)||{},V=Y?X.getKeysForSync({id:q.identifier.id,version:Y}):void 0;V?V.forEach(Q=>{x[Q]=M[Q]}):Object.keys(M).forEach(Q=>x[Q]=M[Q]),X.setExtensionState(q,x,!0)}async j(M,q){return this.b.withProfileScopedStorageService(M,async Y=>{const X=new R.$Sc,x=this.f.createChild(new u.$6h([c.$wp,Y])),V=X.add(x.createInstance(k.$9Fb)),Q=X.add(x.createInstance($.$pv));try{return await q(V,Q)}finally{X.dispose()}})}};e.$N7b=C,e.$N7b=C=pe([K(0,m.$Eo),K(1,a.$KGb),K(2,m.$Bo),K(3,t.$rIb),K(4,l.$7h),K(5,r.$sob)],C);let N=class extends n.$LHb{constructor(M,q,Y,X,x,V,Q,H){super("extensions",X,x,V,Y,Q,H),this.p=M,this.q=q}async t(M){return M.syncData?await v(M.syncData,this.p):null}u(M,q){const Y=[],X=[],x=[];for(const V of M){if(this.q.hasToNeverSyncExtension(V.identifier.id))continue;const Q=q.find(H=>(0,h.$3o)(H.identifier,V.identifier));Q?(Y.push(Q),V.disabled&&x.push(V.identifier)):V.installed&&(X.push({...V.identifier,preRelease:!!V.preRelease}),V.disabled&&x.push(V.identifier))}return{installedExtensions:Y,newExtensions:X,disabledExtensions:x,remoteExtensions:M}}};e.$O7b=N,e.$O7b=N=pe([K(0,m.$Eo),K(1,t.$rIb),K(2,E.$sk),K(3,o.$5k),K(4,P.$ci),K(5,d.$pj),K(6,c.$wp),K(7,i.$3k)],N)}),define(le[116],he([0,1,14,7,3,34,42,5,32,21,15,11,8,43,19,22,28,39,80,239,25,18,60,4]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d,c,y,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RHb=e.$QHb=e.$PHb=e.$OHb=e.$NHb=void 0;const n="globalState.argv.",s=["locale"];function t(b,C){const N=b.storage?Object.keys(b.storage).sort():[],T={};return N.forEach(M=>T[M]=b.storage[M]),b.storage=T,C?(0,I.$qn)(b,{}):JSON.stringify(b)}e.$NHb=t;const r=1;let a=class extends l.$IHb{constructor(C,N,T,M,q,Y,X,x,V,Q,H,W,te,oe){super({syncResource:"globalState",profile:C},N,M,x,W,q,Y,V,Q,X,H,te),this.Bb=T,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:c.$uob,authority:"base"}),this.xb=this.vb.with({scheme:c.$uob,authority:"local"}),this.yb=this.vb.with({scheme:c.$uob,authority:"remote"}),this.zb=this.vb.with({scheme:c.$uob,authority:"accepted"}),this.Ab=oe.createInstance(v),this.B(M.watch(this.h.dirname(this.H.argvResource))),this.B(D.Event.any(D.Event.filter(M.onDidFilesChange,ee=>ee.contains(this.H.argvResource)),D.Event.filter(T.onDidChange,ee=>!!(ee.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||ee.valueChanges.some(({profile:ae,changes:G})=>this.syncResource.profile.id===ae.id&&G.some(z=>z.target===0)))))(()=>this.Q()))}async qb(C,N,T){const M=C.syncData?JSON.parse(C.syncData.content):null;N=N===null&&T?C:N;const q=N&&N.syncData?JSON.parse(N.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);M?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const X=await this.Jb(q),{local:x,remote:V}=(0,d.$MHb)(Y.storage,M?M.storage:null,q?q.storage:null,X,this.O),Q={content:null,local:x,remote:V,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:V.all!==null?2:0},H=t(Y,!1);return[{baseResource:this.wb,baseContent:q?t(q,!1):H,localResource:this.xb,localContent:H,localUserData:Y,remoteResource:this.yb,remoteContent:M?t(M,!1):null,previewResource:this.vb,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.zb,storageKeys:X}]}async ub(C){const N=C.syncData?JSON.parse(C.syncData.content):null;if(N===null)return!0;const T=await this.Ab.getLocalGlobalState(this.syncResource.profile),M=await this.Jb(N),{remote:q}=(0,d.$MHb)(T.storage,N.storage,N.storage,M,this.O);return q.all!==null}async rb(C,N){return{...C.previewResult,hasConflicts:!1}}async sb(C,N,T,M){if(this.h.isEqual(N,this.xb))return this.Gb(C);if(this.h.isEqual(N,this.yb))return this.Hb(C);if(this.h.isEqual(N,this.vb))return C.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async Gb(C){return{content:C.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(C.localUserData.storage),removed:[],updated:[],all:C.localUserData.storage},localChange:0,remoteChange:2}}async Hb(C){if(C.remoteContent!==null){const N=JSON.parse(C.remoteContent),{local:T,remote:M}=(0,d.$MHb)(C.localUserData.storage,N.storage,null,C.storageKeys,this.O);return{content:C.remoteContent,local:T,remote:M,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:C.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(C,N,T,M){const{localUserData:q}=T[0][0],{local:Y,remote:X,localChange:x,remoteChange:V}=T[0][1];if(x===0&&V===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),V!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Q=JSON.stringify({storage:X.all});C=await this.mb(Q,M?null:C.ref),this.O.info(`${this.D}: Updated remote ui state.${X.added.length?` Added: ${X.added}.`:""}${X.updated.length?` Updated: ${X.updated}.`:""}${X.removed.length?` Removed: ${X.removed}.`:""}`)}N?.ref!==C.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(C),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(C){if(this.h.isEqual(this.yb,C)||this.h.isEqual(this.wb,C)||this.h.isEqual(this.xb,C)||this.h.isEqual(this.zb,C)){const N=await this.db(C);return N&&t(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:C}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(C).length>1||C[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(C){const N=await this.Bb.readStorageData(this.syncResource.profile),T=[],M=[];for(const[X,x]of N)x.target===0?T.push(X):x.target===1&&M.push(X);const q=[...T,...M],Y=C?.storage?Object.keys(C.storage).filter(X=>!X.startsWith(n)&&!q.includes(X)&&N.get(X)!==void 0):[];if(!R.$o){const X=[...c.$_nb.map(x=>(0,c.$mob)(x)),c.$lob];Y.push(...X),M.push(...X)}return{user:T,machine:M,unregistered:Y}}};e.$OHb=a,e.$OHb=a=pe([K(2,i.$KGb),K(3,k.$sk),K(4,c.$dob),K(5,c.$eob),K(6,c.$sob),K(7,P.$ci),K(8,c.$nob),K(9,p.$wl),K(10,g.$Bi),K(11,$.$wp),K(12,E.$3k),K(13,o.$7h)],a);let v=class{constructor(C,N,T,M){this.a=C,this.b=N,this.c=T,this.d=M}async getLocalGlobalState(C){const N={};if(C.isDefault){const M=await this.f(),q=(0,L.$fn)(M);for(const Y of s)q[Y]!==void 0&&(N[`${n}${Y}`]={version:1,value:q[Y]})}const T=await this.c.readStorageData(C);for(const[M,q]of T)q.value&&q.target===0&&(N[M]={version:1,value:q.value});return{storage:N}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const C=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),C.value.toString()}catch(C){this.d.debug((0,A.$0)(C))}return"{}"}async writeLocalGlobalState({added:C,removed:N,updated:T},M){const q=(0,l.$HHb)("globalState",M),Y={},X=new Map,x=await this.c.readStorageData(M),V=(Q,H)=>{for(const W of Q){if(W.startsWith(n)){Y[W.substring(n.length)]=H?H[W].value:void 0;continue}if(H){const te=H[W];te.value!==x.get(W)?.value&&X.set(W,te.value)}else x.get(W)!==void 0&&X.set(W,void 0)}};if(V(Object.keys(C),C),V(Object.keys(T),T),V(N),Object.keys(Y).length){this.d.trace(`${q}: Updating locale...`);const Q=await this.f();let H=Q;for(const W of Object.keys(Y))H=(0,u.edit)(H,[W],Y[W],{});Q!==H&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,O.$ke.fromString(H)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}X.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(M,X,0),this.d.info(`${q}: Updated global state`,[...X.keys()]))}};e.$PHb=v,e.$PHb=v=pe([K(0,k.$sk),K(1,P.$ci),K(2,i.$KGb),K(3,c.$sob)],v);let w=class extends l.$LHb{constructor(C,N,T,M,q,Y){super("globalState",T,M,q,N,C,Y)}async o(C){const N=C.syncData?JSON.parse(C.syncData.content):null;if(!N){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const T={},M={};for(const q of Object.keys(N.storage))q.startsWith(n)?T[q.substring(n.length)]=N.storage[q].value:this.l.get(q,0)===void 0&&(M[q]=N.storage[q].value);if(Object.keys(T).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(T))q=(0,u.edit)(q,[Y],T[Y],{});await this.k.writeFile(this.h.argvResource,O.$ke.fromString(q))}if(Object.keys(M).length){const q=[];for(const Y of Object.keys(M))q.push({key:Y,value:M[Y],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$QHb=w,e.$QHb=w=pe([K(0,$.$wp),K(1,k.$sk),K(2,y.$5k),K(3,P.$ci),K(4,c.$sob),K(5,E.$3k)],w);let f=class{constructor(C,N,T,M,q){this.a=C,this.b=N,this.c=T,this.d=M,this.f=q}getSyncStoreType(C){return this.h(C)?.storage[c.$lob]?.value}async sync(C){const N=(0,c.$hob)((0,S.$rg)());try{return await this.g(C,N)}catch(T){if(T instanceof c.$iob)switch(T.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(C,N)}throw T}}async g(C,N){const T=await this.a.readResource("globalState",null,void 0,N),M=this.h(T)||{storage:{}};M.storage[c.$lob]={value:C,version:r};const q=await(0,h.$Cp)(this.c,this.d,this.b),Y={version:r,machineId:q,content:t(M,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),T.ref,void 0,N)}h({content:C}){if(!C)return null;const N=JSON.parse(C);if((0,l.$GHb)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.$RHb=f,e.$RHb=f=pe([K(1,$.$wp),K(2,P.$ci),K(3,k.$sk),K(4,m.$pj)],f)}),define(le[117],he([0,1,17,14,3,34,5,12,171,21,15,11,19,22,28,18,39,236,25]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7b=e.$R7b=e.$Q7b=void 0;function d(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,R.$Qf)(s.all)?null:s.all;switch(I.OS){case 2:return(0,R.$Qf)(s.mac)?null:s.mac;case 3:return(0,R.$Qf)(s.linux)?null:s.linux;case 1:return(0,R.$Qf)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.$Q7b=d;let c=class extends E.$KHb{constructor(o,n,s,t,r,a,v,w,f,b,C,N,T){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,w,f,b,s,t,v,N,r,C,a,T),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$uob,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$uob,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$uob,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$uob,authority:"accepted"}),this.B(D.Event.filter(a.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,s,t){const r=o.syncData?d(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?o:n;const a=n?this.Ob(n):null,v=await this.vb(),w=await this.Cb();let f=null,b=!1,C=!1,N=!1;if(r){let q=v?v.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new u.$iob((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,l.$P7b)(q,r,a,w,this.zb);Y.hasChanges&&(f=Y.mergeContent,N=Y.hasConflicts,b=N||Y.mergeContent!==q,C=N||Y.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=v.value.toString(),C=!0);const T={content:N?a:f,localChange:b?v?2:1:0,remoteChange:C?2:0,hasConflicts:N},M=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:M,localChange:T.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:T.remoteChange,previewResource:this.Eb,previewResult:T,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,l.$P7b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:v,remoteChange:w}=s[0][1];if(v===0&&w===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new u.$iob((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),w!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const f=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(f,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,L.$fn)(o.value.toString());if((0,O.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:d(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=o,I.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(u.$9nb)}};e.$R7b=c,e.$R7b=c=pe([K(2,u.$dob),K(3,u.$eob),K(4,u.$sob),K(5,g.$Bi),K(6,u.$nob),K(7,k.$sk),K(8,P.$ci),K(9,m.$wp),K(10,u.$rob),K(11,h.$wl),K(12,$.$3k)],c);let y=class extends E.$LHb{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,A.$ke.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,L.$fn)(o.value.toString());return!(0,O.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return d(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$S7b=y,e.$S7b=y=pe([K(0,k.$sk),K(1,p.$5k),K(2,P.$ci),K(3,u.$sob),K(4,m.$wp),K(5,$.$3k)],y)}),define(le[118],he([0,1,14,3,172,21,76,15,29,11,19,22,28,18,39,240,25]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V7b=e.$U7b=e.$T7b=void 0;function l(y){return y&&y.settings&&typeof y.settings=="string"&&Object.keys(y).length===1}function u(y){const i=JSON.parse(y);return l(i)?i:{settings:y}}e.$T7b=u;let d=class extends $.$KHb{constructor(i,o,n,s,t,r,a,v,w,f,b,C,N,T){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,b,C,v,w,f,T),this.Eb=N,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:E.$uob,authority:"base"}),this.localResource=this.previewResource.with({scheme:E.$uob,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.$uob,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.$uob,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.X(i,o),s=this.Lb(n),t=new I.$7n(E.$8nb);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(E.$8nb)||{}}async qb(i,o,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&n?i:o;const a=o?this.Lb(o):null,v=await this.Pb();let w=null,f=!1,b=!1,C=!1;if(r){let q=s?s.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,p.$rGb)(q,r.settings,a?a.settings:null,v,[],t);w=Y.localContent||Y.remoteContent,f=Y.localContent!==null,b=Y.remoteContent!==null,C=Y.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),w=s.value.toString().trim()||"{}",this.Qb(w),b=!0);const N=s?s.value.toString():null,T=a?.settings??null,M={content:C?T:w,localChange:f?2:0,remoteChange:b?2:0,hasConflicts:C};return[{fileContent:s,baseResource:this.baseResource,baseContent:T,localResource:this.localResource,localContent:N,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,p.$rGb)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,p.$qGb)(i.previewResult.content,"{}",s,n):null}}async sb(i,o,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,p.$qGb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,p.$qGb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,p.$qGb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:v}=n[0][1];if(a===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const w=await this.Cb(),f=this.Lb(i),b=await this.Pb(r);r=(0,p.$qGb)(r,f?f.settings:"{}",b,w),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,p.$sGb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const n=await this.Cb(),s=await this.Pb();o=(0,p.$qGb)(o,"{}",s,n)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return u(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(A.Event.any(A.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),A.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,p.$oGb)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new E.$iob((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$U7b=d,e.$U7b=d=pe([K(2,g.$sk),K(3,R.$ci),K(4,P.$wp),K(5,E.$dob),K(6,E.$eob),K(7,E.$sob),K(8,E.$rob),K(9,L.$Bi),K(10,E.$nob),K(11,k.$wl),K(12,S.$Eo),K(13,m.$3k)],d);let c=class extends $.$LHb{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,O.$ke.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$sGb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return u(i)}catch(o){this.j.error(o)}return null}};e.$V7b=c,e.$V7b=c=pe([K(0,g.$sk),K(1,h.$5k),K(2,R.$ci),K(3,E.$sob),K(4,P.$wp),K(5,m.$3k)],c)}),define(le[119],he([0,1,14,3,30,21,15,11,19,22,28,18,39,237,25]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=e.$Z7b=e.$Y7b=void 0;function p(u){return JSON.parse(u.content)}e.$Y7b=p;let E=class extends m.$IHb{constructor(d,c,y,i,o,n,s,t,r,a,v,w){super({syncResource:"snippets",profile:d},c,i,y,o,n,s,a,v,t,r,w),this.pb=1,this.vb=d.snippetsHome,this.B(this.G.watch(y.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(A.Event.filter(this.G.onDidFilesChange,f=>f.affects(this.vb))(()=>this.Q()))}async qb(d,c,y){const i=await this.Hb(),o=this.Gb(i),n=d.syncData?this.Fb(d.syncData):null;c=c===null&&y?d:c;const s=c&&c.syncData?this.Fb(c.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,h.$W7b)(o,n,s);return this.Bb(t,i,n||{},s||{})}async ub(d){const c=d.syncData?this.Fb(d.syncData):null;if(c===null)return!0;const y=await this.Hb(),i=this.Gb(y),o=(0,h.$W7b)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(d,c){return d.previewResult}async sb(d,c,y,i){if(this.h.isEqualOrParent(c,this.g.with({scheme:$.$uob,authority:"local"})))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:d.fileContent?d.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(c,this.g.with({scheme:$.$uob,authority:"remote"})))return{content:d.remoteContent,localChange:d.remoteContent!==null?d.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(c,this.g))return y===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:y,localChange:y===null?d.fileContent!==null?3:0:2,remoteChange:y===null?d.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(d,c,y,i){const o=y.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:n})=>n!==0)&&(d=await this.Eb(o,d,i)),c?.ref!==d.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(d),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(d,c,y,i){const o=new Map;for(const n of Object.keys(d.local.added)){const s={content:d.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"remote"}),remoteContent:y[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"accepted"})})}for(const n of Object.keys(d.local.updated)){const s={content:d.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"remote"}),remoteContent:y[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"accepted"})})}for(const n of d.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"accepted"})})}for(const n of Object.keys(d.remote.added)){const s={content:d.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"accepted"})})}for(const n of Object.keys(d.remote.updated)){const s={content:d.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"remote"}),remoteContent:y[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"accepted"})})}for(const n of d.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"remote"}),remoteContent:y[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"accepted"})})}for(const n of d.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:y[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"remote"}),remoteContent:y[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"remote"}),remoteContent:y[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$uob,authority:"accepted"})})}return[...o.values()]}async resolveContent(d){return this.h.isEqualOrParent(d,this.g.with({scheme:$.$uob,authority:"remote"}))||this.h.isEqualOrParent(d,this.g.with({scheme:$.$uob,authority:"local"}))||this.h.isEqualOrParent(d,this.g.with({scheme:$.$uob,authority:"base"}))||this.h.isEqualOrParent(d,this.g.with({scheme:$.$uob,authority:"accepted"}))?this.db(d):null}async hasLocalData(){try{const d=await this.Hb();if(Object.keys(d).length)return!0}catch{}return!1}async Cb(d){const c={};for(const y of d)y.fileContent&&(c[this.h.basename(y.localResource)]=y.fileContent);await this.nb(JSON.stringify(this.Gb(c)))}async Db(d,c){for(const{fileContent:y,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of d)if(s!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,O.$ke.fromString(i.content),{overwrite:c}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,O.$ke.fromString(i.content),c?void 0:y),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(d,c,y){const i=c.syncData?this.Fb(c.syncData):{},o=(0,D.$yn)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of d)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,h.$X7b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),c=await this.mb(JSON.stringify(o),y?null:c.ref),this.O.info(`${this.D}: Updated remote snippets`)),c}Fb(d){return p(d)}Gb(d){const c={};for(const y of Object.keys(d))c[y]=d[y].value.toString();return c}async Hb(){const d={};let c;try{c=await this.G.resolve(this.vb)}catch(y){if(y instanceof R.$Nk&&y.fileOperationResult===1)return d;throw y}for(const y of c.children||[]){const i=y.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);d[n]=s}}return d}};e.$Z7b=E,e.$Z7b=E=pe([K(2,I.$ci),K(3,R.$sk),K(4,S.$wp),K(5,$.$dob),K(6,$.$eob),K(7,$.$sob),K(8,L.$Bi),K(9,$.$nob),K(10,g.$wl),K(11,P.$3k)],E);let l=class extends m.$LHb{constructor(d,c,y,i,o,n){super("snippets",c,y,i,d,o,n)}async o(d){const c=d.syncData?JSON.parse(d.syncData.content):null;if(!c){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,O.$ke.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(d)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(d){return d.fileOperationResult===1}}};e.$17b=l,e.$17b=l=pe([K(0,R.$sk),K(1,k.$5k),K(2,I.$ci),K(3,$.$sob),K(4,S.$wp),K(5,P.$3k)],l)}),define(le[120],he([0,1,14,21,15,11,19,22,28,18,39,25]),function(se,e,O,A,D,L,I,R,S,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$47b=e.$37b=e.$27b=void 0;function m(E,l){try{return JSON.parse(E).tasks??null}catch(u){return l.error(u),null}}e.$27b=m;let h=class extends P.$JHb{constructor(l,u,d,c,y,i,o,n,s,t,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},u,n,s,t,d,c,o,r,y,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:k.$uob,authority:"base"}),this.Cb=this.Ab.with({scheme:k.$uob,authority:"local"}),this.Db=this.Ab.with({scheme:k.$uob,authority:"remote"}),this.Eb=this.Ab.with({scheme:k.$uob,authority:"accepted"})}async qb(l,u,d,c){const y=l.syncData?m(l.syncData.content,this.O):null;u=u===null&&d?l:u;const i=u?.syncData?m(u.syncData.content,this.O):null,o=await this.vb();let n=null,s=!1,t=!1,r=!1;if(l.syncData){const w=o?o.value.toString():null;if(!i||i!==w||i!==y){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const f=p(w,y,i);n=f.content,r=f.hasConflicts,s=f.hasLocalChanged,t=f.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:v,localChange:a.localChange,remoteResource:this.Db,remoteContent:y,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const u=l?.syncData?m(l.syncData.content,this.O):null;if(u===null)return!0;const d=await this.vb(),c=d?d.value.toString():null,y=p(c,u,u);return y.hasLocalChanged||y.hasRemoteChanged}async rb(l,u){return l.previewResult}async sb(l,u,d,c){if(this.h.isEqual(u,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return d===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:d,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(l,u,d,c){const{fileContent:y}=d[0][0],{content:i,localChange:o,remoteChange:n}=d[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),y&&await this.nb(JSON.stringify(this.Kb(y.value.toString()))),i?await this.wb(i,y,c):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));l=await this.mb(s,c?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$37b=h,e.$37b=h=pe([K(2,k.$dob),K(3,k.$eob),K(4,k.$sob),K(5,A.$Bi),K(6,k.$nob),K(7,L.$sk),K(8,D.$ci),K(9,I.$wp),K(10,R.$wl),K(11,S.$3k)],h);let $=class extends P.$LHb{constructor(l,u,d,c,y,i){super("tasks",u,d,c,l,y,i),this.c=this.g.defaultProfile.tasksResource}async o(l){const u=l.syncData?m(l.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,O.$ke.fromString(u)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$47b=$,e.$47b=$=pe([K(0,L.$sk),K(1,g.$5k),K(2,D.$ci),K(3,k.$sob),K(4,I.$wp),K(5,S.$3k)],$);function p(E,l,u){if(E===null&&l===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(E===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const d=u!==E,c=u!==l;return!d&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:d&&!c?{content:E,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!d?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:E,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,42,21,15,11,19,22,28,18,39,238,25]),function(se,e,O,A,D,L,I,R,S,g,P,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9b=e.$J9b=e.$I9b=void 0;let h=class extends P.$IHb{constructor(l,u,d,c,y,i,o,n,s,t,r,a,v){super({syncResource:"profiles",profile:l},u,c,y,i,o,n,r,a,s,t,v),this.vb=d,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.$uob,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$uob,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$uob,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$uob,authority:"accepted"}),this.B(d.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?p(l.syncData):null}async getRemoteSyncedProfiles(l){const u=await this.getLastSyncUserData(),d=await this.X(l,u);return d?.syncData?p(d.syncData):null}async qb(l,u,d){if(!this.vb.isEnabled())throw new m.$iob("Cannot sync profiles because they are disabled","LocalError");const c=l.syncData?p(l.syncData):null,y=u?.syncData?p(u.syncData):null,i=this.Db(),{local:o,remote:n}=(0,k.$H9b)(i,c,y,[]),s={local:o,remote:n,content:y?this.Eb(y):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=$(i,!1);return[{baseResource:this.baseResource,baseContent:y?this.Eb(y):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.Eb(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const u=l?.syncData?p(l.syncData):null,d=this.Db(),{remote:c}=(0,k.$H9b)(d,u,u,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async rb(l,u){return{...l.previewResult,hasConflicts:!1}}async sb(l,u,d,c){if(this.h.isEqual(u,this.localResource))return this.Ab(l);if(this.h.isEqual(u,this.remoteResource))return this.Bb(l);if(this.h.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(l){const u=this.Db(),d=(0,k.$H9b)(u,null,null,[]),{local:c,remote:y}=d;return{content:l.localContent,local:c,remote:y,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:y!==null?2:0}}async Bb(l){const u=l.remoteContent?JSON.parse(l.remoteContent):null,d=[],c=[];for(const y of this.Db()){const i=u?.find(o=>o.id===y.id);i&&(d.push({id:y.id,name:y.name,collection:i.collection}),c.push(y))}if(u!==null){const y=(0,k.$H9b)(c,u,d,[]),{local:i,remote:o}=y;return{content:l.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,u,d,c){const{local:y,remote:i,localChange:o,remoteChange:n}=d[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=d[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.$iob("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb($(this.Db(),!1));const t=[];for(const r of y.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of y.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of y.updated){const a=this.vb.profiles.find(v=>v.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),s.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:v})=>a.id===v),1);for(const a of i?.updated||[]){const v=s.find(({id:w})=>a.id===w);v&&s.splice(s.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(s,c?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,u){return this.mb(this.Eb(l),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const u=await this.db(l);return u&&(0,O.$qn)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((u,d)=>u.name.localeCompare(d.name)))}};e.$I9b=h,e.$I9b=h=pe([K(2,g.$5k),K(3,L.$sk),K(4,D.$ci),K(5,I.$wp),K(6,m.$dob),K(7,m.$eob),K(8,m.$sob),K(9,A.$Bi),K(10,m.$nob),K(11,R.$wl),K(12,S.$3k)],h);function $(E,l){const u=[...E].sort((d,c)=>d.name.localeCompare(c.name)).map(d=>({id:d.id,name:d.name}));return l?(0,O.$qn)(u,{}):JSON.stringify(u)}e.$J9b=$;function p(E){return JSON.parse(E.content)}e.$K9b=p}),define(le[255],he([0,1,3,2,5,15,19,22,25]),function(se,e,O,A,D,L,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v9b=void 0;const g="sync.enable";let P=class extends A.$Tc{constructor(m,h,$,p){super(),this.c=m,this.f=h,this.g=$,this.h=p,this.a=new O.$Wd,this.onDidChangeEnablement=this.a.event,this.b=new O.$Wd,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(-1,void 0,this.B(new A.$Sc))(E=>this.m(E)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:m}),this.c.store(g,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,S.$mob)(m),-1,!0)}setResourceEnablement(m,h){if(this.isResourceEnabled(m)!==h){const $=(0,S.$mob)(m);this.j($,h)}}getResourceSyncStateVersion(m){}j(m,h){this.c.store(m,h,-1,D.$o?0:1)}m(m){if(g===m.key){this.a.fire(this.isEnabled());return}const h=S.$_nb.filter($=>(0,S.$mob)($)===m.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};e.$v9b=P,e.$v9b=P=pe([K(0,I.$wp),K(1,R.$wl),K(2,L.$ci),K(3,S.$cob)],P)}),define(le[256],he([0,1,6,14,65,2,20,21,15,11,18,25]),function(se,e,O,A,D,L,I,R,S,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=void 0;let m=class extends L.$Tc{constructor($,p,E,l,u){super(),this.a=$,this.b=p,this.c=E,this.f=l,this.g=u,this.h()}async h(){for(const p of this.g.profiles)for(const E of k.$_nb)try{await this.m(this.j(E,p.isDefault?void 0:p.id))}catch(l){this.f.error(l)}let $;try{$=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,g.$Jk)(p)!==1&&this.f.error(p);return}if($.children){for(const p of $.children)if(p.isDirectory&&!this.g.profiles.some(E=>E.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(E){this.f.error(E)}}}async getAllResourceRefs($,p,E){const l=this.j($,p,E);try{const u=await this.b.resolve(l);if(u.children)return u.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.n(c)}))}catch(u){if((0,g.$Jk)(u)!==1)throw u}return[]}async resolveResourceContent($,p,E,l){const u=this.j($,E,l),d=(0,I.$Ig)(u,p);try{return(await this.b.readFile(d)).value.toString()}catch(c){return this.f.error(c),null}}async writeResource($,p,E,l,u){const d=this.j($,l,u),c=(0,I.$Ig)(d,`${(0,D.$zm)(E).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(c,A.$ke.fromString(p))}catch(y){this.f.error(y)}}j($,p,E=this.a.userDataSyncHome){return(0,I.$Ig)(E,...p?[p,$]:[$])}async m($){try{try{if(!await this.b.exists($))return}catch{return}const p=await this.b.resolve($);if(p.children){const E=p.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=E.filter(c=>Date.now()-this.n(c)>l);const d=E.length-u.length;d<10&&(u=u.slice(10-d)),await O.Promises.settled(u.map(async c=>{this.f.info("Deleting from backup",c.resource.path),await this.b.del(c.resource)}))}}catch(p){this.f.error(p)}}n($){return new Date(parseInt($.name.substring(0,4)),parseInt($.name.substring(4,6))-1,parseInt($.name.substring(6,8)),parseInt($.name.substring(9,11)),parseInt($.name.substring(11,13)),parseInt($.name.substring(13,15))).getTime()}};e.$G9b=m,e.$G9b=m=pe([K(0,S.$ci),K(1,g.$sk),K(2,R.$Bi),K(3,k.$sob),K(4,P.$5k)],m)}),define(le[84],he([0,1,3,2,5,27,176,15,11,4,24,43,19,25]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$5nb=e.$4nb=e.$3nb=void 0,e.$3nb=(0,g.$8h)("IUserDataSyncMachinesService");const p="sync.currentMachineName",E="Safari",l="Chrome",u="Edge",d="Firefox",c="Android";function y(n){switch(n){case E:case l:case u:case d:case c:case(0,D.$h)(0):return!0}return!1}e.$4nb=y;function i(){return D.$G?E:D.$E?l:D.$H?u:D.$F?d:D.$I?c:(0,D.$h)(D.$o?0:D.$u)}let o=class extends A.$Tc{static{$=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,v,w){super(),this.h=r,this.j=a,this.m=v,this.n=w,this.c=this.B(new O.$Wd),this.onDidChange=this.c.event,this.g=null,this.f=(0,k.$Cp)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:v})=>v!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),v=a.machines.find(({id:w})=>w===s);if(v){v.name=t,await this.t(a);const w=await this.f;s===w&&this.h.store(p,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const v=t.machines.find(w=>w.id===r);v&&(v.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(p,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,L.$Pe)(r)}\\s#(\\d+)`);let v=0;for(const w of s){const f=a.exec(w.name),b=f?parseInt(f[1]):0;v=b>v?b:v}return`${r} #${v+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==$.a)throw new Error((0,I.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource($.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[$.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource($.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:$.a,machines:[]}}};e.$5nb=o,e.$5nb=o=$=pe([K(0,R.$ci),K(1,S.$sk),K(2,m.$wp),K(3,h.$dob),K(4,h.$sob),K(5,P.$Hj)],o)}),define(le[257],he([0,1,6,65,38,7,3,2,5,20,9,173,24,19,22,25,81,84]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M9b=void 0;const u="sync.disableMachineEventually",d="sync.sessionId",c="sync.storeUrl",y="sync.productQuality";let i=class extends R.$Tc{get n(){const s=this.H.get(c,-1);return s?P.URI.parse(s):void 0}set n(s){s?this.H.store(c,s.toString(),-1,1):this.H.remove(c,-1)}get s(){return this.H.get(y,-1)}set s(s){s?this.H.store(y,s,-1,1):this.H.remove(y,-1)}constructor(s,t,r,a,v,w,f,b,C,N){super(),this.u=t,this.w=r,this.y=a,this.z=v,this.C=w,this.D=f,this.F=b,this.G=C,this.H=N,this.a=this.B(new R.$Uc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new I.$Wd),this.onError=this.h.event,this.S=[],this.f=this.B(new O.$6g(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$Bg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(f.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(T=>this.triggerSync([T],!1,!1))),this.B(I.Event.filter(this.y.onDidChangeResourceEnablement,([,T])=>T)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,A.$zm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(d,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=p.$iob.toUserDataSyncError(s);t instanceof p.$kob&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?S.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(u,!0,-1,1),await(0,O.$9g)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$M9b=i,e.$M9b=i=pe([K(0,m.$Hj),K(1,p.$cob),K(2,p.$dob),K(3,p.$nob),K(4,p.$oob),K(5,p.$sob),K(6,E.$$Fb),K(7,$.$wl),K(8,l.$3nb),K(9,h.$wp)],i);class o extends R.$Tc{static{this.a="Interval"}constructor(s,t,r,a,v,w,f,b,C){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=v,this.w=w,this.y=f,this.z=b,this.C=C,this.b=this.B(new R.$Uc),this.c=this.B(new I.$Wd),this.onDidStartSync=this.c.event,this.f=this.B(new I.$Wd),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Rc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,O.$0g)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(s,t){const r=(0,O.$Ug)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,L.$4)(v))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$Bg)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,g.$Bg)(t.defaultUrl,s.defaultUrl)||!(0,g.$Bg)(t.insidersUrl,s.insidersUrl)||!(0,g.$Bg)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(v){if(this.y.error(v),a=v,p.$iob.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(w){this.y.error(w),a=w}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$kob((0,k.localize)(0,null),"DefaultServiceChanged"):new p.$kob((0,k.localize)(1,null),"ServiceChanged"):new p.$kob((0,k.localize)(2,null),"TurnedOff");const r=this.C.get(d,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$kob((0,k.localize)(3,null),"DefaultServiceChanged"):new p.$kob((0,k.localize)(4,null),"ServiceChanged"):new p.$kob((0,k.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=a.find(f=>f.isCurrent);if(v?.disabled)throw new p.$kob((0,k.localize)(6,null),"TurnedOff");const w=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-w}),this.g===null)try{this.g=await this.s.manifest(null)}catch(f){throw new p.$kob((0,D.$Si)(f),f instanceof p.$iob?f.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(d,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(le[258],he([0,1,9,177,15,11,43,19,28,25,18,39,119,118,117,21,120,115,116,4,121,42,27]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d,c,y,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$i0b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,v,w,f,b,C,N,T){this.e=t,this.f=r,this.g=a,this.h=w,this.i=f,this.j=b,this.k=C,this.l=N,this.n=T,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,c.$K9b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const v=this.L(a,"profiles");return(0,c.$K9b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(w=>({...w,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:w})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:w,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:w,ref:f})=>({created:w,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:f,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,I.$Cp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,v,w){if(t){const{content:f}=await this.M(r,v,a);return f}return this.f.resolveResourceContent(r,v,a,w)}q(t,r,a){const v=this.L(r,t);switch(t){case"settings":return this.t(v,a);case"keybindings":return this.v(v,a);case"tasks":return this.x(v,a);case"snippets":return this.z(v,a);case"globalState":return this.E(v,a);case"extensions":return this.B(v,a);case"profiles":return this.H(v,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(v=>v.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,h.$T7b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,$.$Q7b)(t.content,!!this.l.getValue(g.$9nb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,E.$27b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const v=this.L(a,"snippets");if(v){const w=(0,m.$Y7b)(v),f=[];for(const b of Object.keys(w)){const C=this.d.joinPath(t,b),N=r?this.d.joinPath(r.snippetsHome,b):this.d.joinPath(t,o.a);f.push({resource:C,comparableResource:N})}return f}}return[]}z(t,r){return(0,m.$Y7b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,l.$L7b)((0,l.$K7b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(l.$N7b).getLocalExtensions(t);return(0,l.$L7b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,u.$NHb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(u.$PHb).getLocalGlobalState(t);return(0,u.$NHb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,y.$qn)(JSON.parse(t.content),{})}return null}async I(t){return(0,c.$J9b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$Te)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(O.URI.from({scheme:g.$uob,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==g.$uob)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let v,w;const f=[];let b,C,N,T,M;for(;r.length;){const q=r.shift();q.startsWith("scheme:")?v=q.substring(7):q.startsWith("authority:")?w=q.substring(10):q.startsWith("syncResource:")?b=q.substring(13):q.startsWith("profile:")?C=q.substring(8):q.startsWith("collection:")?N=q.substring(11):q.startsWith("ref:")?T=q.substring(4):b?M=q:f.push(q)}return{remote:a,syncResource:b,profile:C,collection:N,ref:T,node:M,location:v&&w!==void 0?this.d.joinPath(O.URI.from({scheme:v,authority:w,query:t.query,fragment:t.fragment,path:"/"}),...f):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,k.$GHb)(a))return a}catch(a){this.g.error(a)}throw new g.$iob((0,A.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const v=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:v}}};e.$i0b=n,e.$i0b=n=o=pe([K(0,g.$dob),K(1,g.$eob),K(2,g.$sob),K(3,S.$3k),K(4,D.$ci),K(5,R.$wp),K(6,L.$sk),K(7,P.$5k),K(8,p.$Bi),K(9,d.$7h)],n)}),define(le[259],he([0,1,17,6,26,38,3,2,20,12,32,21,29,11,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d,c,y,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L9b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Tc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(b,C,N,T,M,q,Y,X,x,V,Q){super(),this.C=b,this.D=C,this.F=N,this.G=T,this.H=M,this.I=q,this.J=Y,this.L=X,this.M=x,this.N=V,this.O=Q,this.f="uninitialized",this.g=this.B(new I.$Wd),this.onDidChangeStatus=this.g.event,this.h=this.B(new I.$Wd),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new I.$Wd),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new I.$Wd),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new I.$Wd),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new I.$Wd),this.onDidResetLocal=this.w.event,this.y=this.B(new I.$Wd),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=N.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Rc)(()=>this.bb()))}async createSyncTask(b,C){this.cb(),this.H.info("Sync started.");const N=new Date().getTime(),T=(0,P.$rg)();try{const X=(0,s.$hob)(T);C&&(X["Cache-Control"]="no-cache"),b=await this.D.manifest(b,X)}catch(X){const x=s.$iob.toUserDataSyncError(X);throw w(x,T,this.F,this.I),x}const M=!1,q=this;let Y;return{manifest:b,async run(){if(M)throw new Error("Can run a task only once");Y=(0,A.$Ug)(X=>q.P(b,!1,T,X)),await Y.finally(()=>Y=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-N}ms`),q.$()},stop(){return Y?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$iob("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const b=new Date().getTime(),C=(0,P.$rg)(),N=(0,s.$hob)(C);let T;try{T=await this.D.manifest(null,N)}catch(Y){const X=s.$iob.toUserDataSyncError(Y);throw w(X,C,this.F,this.I),X}await this.resetLocal();const M=this,q=new D.$7d;return{id:C,async merge(){return M.P(T,!0,C,q.token)},async apply(){try{try{await M.R(T,C,q.token)}catch(Y){if(s.$iob.toUserDataSyncError(Y).code==="MethodNotFound")M.H.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.H.info("Applying manual sync again..."),await M.R(T,C,q.token);else throw Y}}catch(Y){throw M.H.error(Y),Y}M.H.info(`Sync done. Took ${new Date().getTime()-b}ms`),M.$()},async stop(){q.cancel(),await M.U(),await M.resetLocal()}}}async P(b,C,N,T){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(M,b,C,N,T));const q=M.enabled.find(Y=>Y.resource==="profiles");if(q){const Y=await q.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.Q(Y,b,C,N,T)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(b,C,N,T,M){for(const q of b){if(M.isCancellationRequested)return;const Y=this.M.profiles.find(x=>x.id===q.id);if(!Y){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const X=this.getOrCreateActiveProfileSynchronizer(Y,q);this.n.push(...await this.S(X,C,N,T,M))}for(const[q,Y]of this.z.entries())this.M.profiles.some(X=>X.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(q))}async R(b,C,N){const T=this.ab();for(const x of T){if(N.isCancellationRequested)return;await x.apply(C,N)}const M=T.find(x=>x.profile.isDefault);if(!M)return;const q=M.enabled.find(x=>x.resource==="profiles");if(!q)return;const X=(await q.getRemoteSyncedProfiles(b?.latest??null)||[]).filter(x=>T.every(V=>V.profile.id!==x.id));X.length&&await this.Q(X,b,!1,C,N)}async S(b,C,N,T,M){return(await b.sync(C,N,T,M)).map(([Y,X])=>({profile:b.profile,syncResource:Y,error:X}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(b=>b.stop()))}async resolveContent(b){const C=await this.N.resolveContent(b);if(C)return C;for(const N of this.ab())for(const T of N.enabled){const M=await T.resolveContent(b);if(M)return M}return null}async replace(b){this.cb();const C=this.N.resolveUserDataSyncResource(b);if(!C)return;const N=await this.resolveContent(b.uri);N&&await this.W(C.profile,async T=>{if(C.syncResource===T.resource)return await T.replace(N),!0})}async accept(b,C,N,T){this.cb(),await this.W(b.profile,async M=>{if(b.syncResource===M.resource)return await M.accept(C,N),T&&await M.apply((0,g.$Pf)(T)?!1:T.force,(0,s.$hob)((0,P.$rg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async C=>{if(C.resource!=="globalState"&&await C.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async C=>{if(await C.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(b){this.H.error(b)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[b]of this.z.values())try{await b.resetLocal()}catch(C){this.H.error(C)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const b=await this.N.getRemoteSyncedProfiles(),C=b.map(q=>q.collection),N=await this.D.getAllCollections(),T=N.filter(q=>!C.includes(q));T.length&&(this.H.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const M=b.filter(q=>N.includes(q.collection));if(M.length!==b.length){const q=this.G.createInstance(n.$I9b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(M,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(b){this.cb();const C=await this.D.getActivityData();await this.C.writeFile(b,C)}async extractActivityData(b,C){const N=(await this.C.readFile(b)).value.toString(),T=JSON.parse(N);if(T.resources)for(const M in T.resources)for(const q of T.resources[M])await this.O.writeResource(M,q.content,new Date(q.created*1e3),void 0,C);if(T.collections)for(const M in T.collections)for(const q in T.collections[M].resources)for(const Y of T.collections[M].resources?.[q]??[])await this.O.writeResource(q,Y.content,new Date(Y.created*1e3),M,C)}async W(b,C){const N=new R.$Sc;try{const T=this.z.get(b.id);if(T){const x=await this.X(T[0],C,N);return(0,g.$Qf)(x)?null:x}if(b.isDefault){const x=N.add(this.G.createInstance(a,b,void 0)),V=await this.X(x,C,N);return(0,g.$Qf)(V)?null:V}if(this.M.isEnabled())return null;const M=N.add(this.G.createInstance(n.$I9b,b,void 0)),q=await this.D.manifest(null),X=(await M.getRemoteSyncedProfiles(q?.latest??null)||[]).find(x=>x.id===b.id);if(X){const x=N.add(this.G.createInstance(a,b,X.collection)),V=await this.X(x,C,N);return(0,g.$Qf)(V)?null:V}return null}finally{N.dispose()}}async X(b,C,N){const T=[...b.enabled,...b.disabled.reduce((M,q)=>(q!=="workspaceState"&&M.push(N.add(b.createSynchronizer(q))),M),[])];for(const M of T){const q=await C(M);if(!(0,g.$Qf)(q))return q}}Y(b){const C=this.f;this.f!==b&&(this.f=b,this.g.fire(b),C==="hasConflicts"&&this.$())}Z(){const b=this.ab().map(C=>C.conflicts).flat();(0,O.$ub)(this.j,b,(C,N)=>C.profile.id===N.profile.id&&C.syncResource===N.syncResource&&(0,O.$ub)(C.conflicts,N.conflicts,(T,M)=>(0,S.$Bg)(T.previewResource,M.previewResource)))||(this.j=b,this.m.fire(b))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(b,C){let N=this.z.get(b.id);if(N&&N[0].collection!==C?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.z.delete(b.id)),!N){const T=new R.$Sc,M=T.add(this.G.createInstance(a,b,C?.collection));T.add(M.onDidChangeStatus(q=>this.Y(q))),T.add(M.onDidChangeConflicts(q=>this.Z())),T.add(M.onDidChangeLocal(q=>this.h.fire(q))),this.z.set(b.id,N=[M,T])}return N[0]}ab(){const b=[];for(const[C]of this.z.values())b.push(C);return b}bb(){this.z.forEach(([,b])=>b.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$L9b=r,e.$L9b=r=pe([K(0,h.$sk),K(1,s.$dob),K(2,s.$cob),K(3,$.$7h),K(4,s.$sob),K(5,E.$wl),K(6,p.$wp),K(7,s.$nob),K(8,l.$5k),K(9,s.$pob),K(10,s.$eob)],r);let a=class extends R.$Tc{get enabled(){return this.f.sort((b,C)=>b[1]-C[1]).map(([b])=>b)}get disabled(){return s.$_nb.filter(b=>!this.r.isResourceEnabled(b))}get status(){return this.g}get conflicts(){return this.m}constructor(b,C,N,T,M,q,Y,X,x,V){super(),this.profile=b,this.collection=C,this.r=N,this.t=T,this.u=M,this.w=q,this.y=Y,this.z=X,this.C=x,this.D=V,this.f=[],this.g="idle",this.h=this.B(new I.$Wd),this.onDidChangeStatus=this.h.event,this.j=this.B(new I.$Wd),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new I.$Wd),this.onDidChangeConflicts=this.n.event,this.B(N.onDidChangeResourceEnablement(([Q,H])=>this.F(Q,H))),this.B((0,R.$Rc)(()=>this.f.splice(0,this.f.length).forEach(([,,Q])=>Q.dispose())));for(const Q of s.$_nb)N.isResourceEnabled(Q)&&this.G(Q)}F(b,C){C?this.G(b):this.H(b)}G(b){if(this.f.some(([M])=>M.resource===b))return;if(b==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(b==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||b==="workspaceState")return;if(b!=="profiles"&&this.profile.useDefaultFlags?.[b]){this.z.debug(`Skipping syncing ${b} in ${this.profile.name} because it is already synced by default profile`);return}const C=new R.$Sc,N=C.add(this.createSynchronizer(b));C.add(N.onDidChangeStatus(()=>this.L())),C.add(N.onDidChangeConflicts(()=>this.M())),C.add(N.onDidChangeLocal(()=>this.j.fire(b)));const T=this.N(b);this.f.push([N,T,C])}H(b){const C=this.f.findIndex(([N])=>N.resource===b);if(C!==-1){const[[N,,T]]=this.f.splice(C,1);T.dispose(),this.L(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,M=>this.z.error(M))}}createSynchronizer(b){switch(b){case"settings":return this.t.createInstance(y.$U7b,this.profile,this.collection);case"keybindings":return this.t.createInstance(c.$R7b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$Z7b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$37b,this.profile,this.collection);case"globalState":return this.t.createInstance(d.$OHb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$M7b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$I9b,this.profile,this.collection)}}async sync(b,C,N,T){if(T.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const q=[],Y=(0,s.$hob)(N),X=(this.collection?b?.collections?.[this.collection]?.latest:b?.latest)??null,x=C?await this.I(X):{};for(const V of M){if(T.isCancellationRequested)return[];if(!this.r.isResourceEnabled(V.resource))return[];try{if(C){const Q=await V.preview(X,x,Y);if(Q)for(const H of Q.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await V.merge(H.previewResource)}else await V.sync(X,Y)}catch(Q){const H=s.$iob.toUserDataSyncError(Q);if(w(H,N,this.w,this.y),v(Q))throw H;this.z.error(Q),this.z.error(`${V.resource}: ${(0,L.$Si)(Q)}`),q.push([V.resource,H])}}return q}finally{this.L()}}async apply(b,C){const N=(0,s.$hob)(b);for(const T of this.enabled){if(C.isCancellationRequested)return;try{await T.apply(!1,N)}catch(M){const q=s.$iob.toUserDataSyncError(M);if(w(q,b,this.w,this.y),v(M))throw q;this.z.error(M),this.z.error(`${T.resource}: ${(0,L.$Si)(M)}`)}}}async stop(){for(const b of this.enabled)try{b.status!=="idle"&&await b.stop()}catch(C){this.z.error(C)}}async resetLocal(){for(const b of this.enabled)try{await b.resetLocal()}catch(C){this.z.error(`${b.resource}: ${(0,L.$Si)(C)}`),this.z.error(C)}}async I(b){if(!this.profile.isDefault)return{};const C=this.D.getValue(s.$8nb),N=this.enabled.find(T=>T instanceof y.$U7b);if(N){const T=await N.getRemoteUserDataSyncConfiguration(b);return{...C,...T}}return C}J(b){this.g!==b&&(this.g=b,this.h.fire(b))}L(){return this.M(),this.enabled.some(b=>b.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(b=>b.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const b=this.enabled.filter(C=>C.status==="hasConflicts").filter(C=>C.conflicts.conflicts.length>0).map(C=>C.conflicts);(0,O.$ub)(this.m,b,(C,N)=>C.syncResource===N.syncResource&&(0,O.$ub)(C.conflicts,N.conflicts,(T,M)=>(0,S.$Bg)(T.previewResource,M.previewResource)))||(this.m=b,this.n.fire(b))}N(b){switch(b){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=pe([K(2,s.$nob),K(3,$.$7h),K(4,m.$Bo),K(5,s.$cob),K(6,E.$wl),K(7,s.$sob),K(8,l.$5k),K(9,k.$Bi)],a);function v(f){if(f instanceof s.$iob)switch(f.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(f,b,C,N){N.publicLog2("sync/error",{code:f.code,serverCode:f instanceof s.$job?String(f.serverCode):void 0,url:f instanceof s.$job?f.url:void 0,resource:f.resource,executionId:b,service:C.userDataSyncStore.url.toString()})}}),define(le[260],he([0,1,3,2,9,18,25]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7_b=e.$6_b=void 0;function R(m,h){return{...m,profile:(0,L.$6k)(m.profile,h.profilesHome.scheme)}}function S(m){return{created:m.created,uri:D.URI.revive(m.uri)}}class g{constructor(h,$,p){this.c=h,this.d=$,this.f=p,this.a=new Map,this.b=new O.$Wd}listen(h,$){switch($){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${$}`)}async call(h,$,p){try{return await this.g(h,$,p)}catch(E){throw this.f.error(E),E}}async g(h,$,p){switch($){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(p[0]));case"accept":return this.c.accept(R(p[0],this.d),D.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(S(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(D.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(D.URI.revive(p[0]),D.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if($.startsWith("manualSync/")){const E=$.substring(11),l=p[0],u=this.h(l);switch(p=p.slice(1),E){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(h){const $=this.a.get(this.j(h));if(!$)throw new Error(`Manual sync taks not found: ${h}`);return $}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.$6_b=g;let P=class extends A.$Tc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,$){super(),this.n=$,this.b="uninitialized",this.c=this.B(new O.$Wd),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new O.$Wd),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new O.$Wd),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new O.$Wd),this.onSyncErrors=this.m.event,this.a={call(p,E,l){return h.call(p,E,l).then(null,u=>{throw I.$iob.toUserDataSyncError(u)})},listen(p,E){return h.listen(p,E)}},this.a.call("_getInitialData").then(([p,E,l])=>{this.s(p),this.t(E),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(E=>({...E,error:I.$iob.toUserDataSyncError(E.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),$=this;return new k(h,{async call(E,l,u){return $.a.call(`manualSync/${E}`,[h,...Array.isArray(l)?l:[l]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,$,p,E){return this.a.call("accept",[h,$,p,E])}resolveContent(h){return this.a.call("resolveContent",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}saveRemoteActivityData(h){return this.a.call("getRemoteActivityData",[h])}extractActivityData(h,$){return this.a.call("extractActivityData",[h,$])}async s(h){this.b=h,this.c.fire(h)}async t(h){this.f=h.map($=>({syncResource:$.syncResource,profile:(0,L.$6k)($.profile,this.n.profilesHome.scheme),conflicts:$.conflicts.map(p=>({...p,baseResource:D.URI.revive(p.baseResource),localResource:D.URI.revive(p.localResource),remoteResource:D.URI.revive(p.remoteResource),previewResource:D.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(h){this.h!==h&&(this.h=h,this.j.fire(h))}};e.$7_b=P,e.$7_b=P=pe([K(1,L.$5k)],P);class k extends A.$Tc{constructor(h,$){super(),this.id=h,this.a=$}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[122],he([0,1,6,26,7,3,2,140,5,20,12,9,32,21,15,11,24,59,43,19,25]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EHb=e.$DHb=e.$CHb=e.$BHb=e.$AHb=void 0;const y="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends I.$Tc{get userDataSyncStore(){return this.b}get c(){return this.h.get(c.$lob,-1)}set c(N){this.h.store(c.$lob,N,-1,S.$o?0:1)}constructor(N,T,M){super(),this.f=N,this.g=T,this.h=M,this.a=this.B(new L.$Wd),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new I.$Sc);this.B(L.Event.filter(M.onDidChangeValue(-1,c.$lob,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[y]),this.a.fire()}m(N){if(N&&(N=S.$o&&N.web?{...N,...N.web}:N,(0,P.$Jf)(N.url)&&(0,P.$Lf)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(T=>Array.isArray(N.authenticationProviders[T].scopes)))){const T=N,M=!!T.canSwitch,q=T.url===T.insidersUrl?"insiders":"stable",Y=(M?this.c:void 0)||q,X=Y==="insiders"?T.insidersUrl:Y==="stable"?T.stableUrl:T.url;return{url:k.URI.parse(X),type:Y,defaultType:q,defaultUrl:k.URI.parse(T.url),stableUrl:k.URI.parse(T.stableUrl),insidersUrl:k.URI.parse(T.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(T.authenticationProviders).reduce((x,V)=>(x.push({id:V,scopes:T.authenticationProviders[V].scopes}),x),[])}}}};e.$AHb=a,e.$AHb=a=pe([K(0,E.$Hj),K(1,h.$Bi),K(2,d.$wp)],a);let v=class extends a{constructor(N,T,M){super(N,T,M);const q=this.h.get(i,-1);q&&(this.n=JSON.parse(q));const Y=this.f[y];Y?this.h.store(i,JSON.stringify(Y),-1,1):this.h.remove(i,-1)}async switch(N){N!==this.c&&(this.c=N,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$BHb=v,e.$BHb=v=pe([K(0,E.$Hj),K(1,h.$Bi),K(2,d.$wp)],v);let w=class extends I.$Tc{get donotMakeRequestsUntil(){return this.j}constructor(N,T,M,q,Y,X,x){super(),this.n=M,this.r=q,this.s=x,this.g=this.B(new L.$Wd),this.onTokenFailed=this.g.event,this.h=this.B(new L.$Wd),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$Wd),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(N),this.c=(0,u.$Cp)(Y,X,x).then(V=>{const Q={"X-Client-Name":`${T.applicationName}${S.$o?"-web":""}`,"X-Client-Version":T.version};return T.commit&&(Q["X-Client-Commit"]=T.commit),Q}),this.f=new b(t,r,this.n,this.r),this.u(),this.B((0,I.$Rc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(N,T){this.b={token:N,type:T}}t(N){this.a=N?(0,g.$Ig)(N,"v1"):void 0}u(){const N=this.s.getNumber(o,-1);N&&Date.now()<N&&this.y(new Date(N))}y(N){this.j?.getTime()!==N?.getTime()&&(this.j=N,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,O.$Ug)(T=>(0,O.$9g)(this.j.getTime()-Date.now(),T).then(()=>this.y(void 0))),this.w.then(null,T=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,g.$Ig)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const M=await this.D(T,{type:"GET",headers:N},[],A.CancellationToken.None);return(await(0,l.$pp)(M))?.map(({id:q})=>q)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,g.$Ig)(this.a,"collection").toString();N={...N},N["Content-Type"]=R.$hs.text;const M=await this.D(T,{type:"POST",headers:N},[],A.CancellationToken.None),q=await(0,l.$op)(M);if(!q)throw new c.$job("Server did not return the collection id",T,"NoCollection",M.res.statusCode,M.res.headers[c.$fob]);return q}async deleteCollection(N,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=N?(0,g.$Ig)(this.a,"collection",N).toString():(0,g.$Ig)(this.a,"collection").toString();T={...T},await this.D(M,{type:"DELETE",headers:T},[],A.CancellationToken.None)}async getAllResourceRefs(N,T){if(!this.a)throw new Error("No settings sync store url configured.");const M=this.z(this.a,T,N),q={},Y=await this.D(M.toString(),{type:"GET",headers:q},[],A.CancellationToken.None);return(await(0,l.$pp)(Y)||[]).map(({url:x,created:V})=>({ref:(0,g.$Kg)(M,M.with({path:x})),created:V*1e3}))}async resolveResourceContent(N,T,M,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,g.$Ig)(this.z(this.a,M,N),T).toString();q={...q},q["Cache-Control"]="no-cache";const X=await this.D(Y,{type:"GET",headers:q},[],A.CancellationToken.None);return await(0,l.$op)(X)}async deleteResource(N,T,M){if(!this.a)throw new Error("No settings sync store url configured.");const q=T!==null?(0,g.$Ig)(this.z(this.a,M,N),T).toString():this.z(this.a,M,N).toString(),Y={};await this.D(q,{type:"DELETE",headers:Y},[],A.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,g.$Ig)(this.a,"resource").toString(),T={"Content-Type":R.$hs.text};await this.D(N,{type:"DELETE",headers:T},[],A.CancellationToken.None)}async readResource(N,T,M,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,g.$Ig)(this.z(this.a,M,N),"latest").toString();q={...q},q["Cache-Control"]="no-cache",T&&(q["If-None-Match"]=T.ref);const X=await this.D(Y,{type:"GET",headers:q},[304],A.CancellationToken.None);let x=null;if(X.res.statusCode===304&&(x=T),x===null){const V=X.res.headers.etag;if(!V)throw new c.$job("Server did not return the ref",Y,"NoRef",X.res.statusCode,X.res.headers[c.$fob]);const Q=await(0,l.$op)(X);if(!Q&&X.res.statusCode===304)throw new c.$job("Empty response",Y,"EmptyResponse",X.res.statusCode,X.res.headers[c.$fob]);x={ref:V,content:Q}}return x}async writeResource(N,T,M,q,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=this.z(this.a,q,N).toString();Y={...Y},Y["Content-Type"]=R.$hs.text,M&&(Y["If-Match"]=M);const x=await this.D(X,{type:"POST",data:T,headers:Y},[],A.CancellationToken.None),V=x.res.headers.etag;if(!V)throw new c.$job("Server did not return the ref",X,"NoRef",x.res.statusCode,x.res.headers[c.$fob]);return V}async manifest(N,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,g.$Ig)(this.a,"manifest").toString();T={...T},T["Content-Type"]="application/json",N&&(T["If-None-Match"]=N.ref);const q=await this.D(M,{type:"GET",headers:T},[304],A.CancellationToken.None);let Y=null;if(q.res.statusCode===304&&(Y=N),!Y){const x=q.res.headers.etag;if(!x)throw new c.$job("Server did not return the ref",M,"NoRef",q.res.statusCode,q.res.headers[c.$fob]);const V=await(0,l.$op)(q);if(!V&&q.res.statusCode===304)throw new c.$job("Empty response",M,"EmptyResponse",q.res.statusCode,q.res.headers[c.$fob]);V&&(Y={...JSON.parse(V),ref:x})}const X=this.s.get(n,-1);return X&&Y&&X!==Y.session&&this.C(),Y===null&&X&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,g.$Ig)(this.a,"download").toString(),T={},M=await this.D(N,{type:"GET",headers:T},[],A.CancellationToken.None);if(!(0,l.$lp)(M))throw new c.$job("Server returned "+M.res.statusCode,N,"EmptyResponse",M.res.statusCode,M.res.headers[c.$fob]);if((0,l.$mp)(M))throw new c.$job("Empty response",N,"EmptyResponse",M.res.statusCode,M.res.headers[c.$fob]);return M.stream}z(N,T,M){return T?(0,g.$Ig)(N,"collection",T,"resource",M):(0,g.$Ig)(N,"resource",M)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(N,T,M,q){if(!this.b)throw new c.$job("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new c.$job(`${T.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;T.headers={...T.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(T.headers),this.r.trace("Sending request to server",{url:N,type:T.type,headers:{...T.headers,authorization:void 0}});let X;try{X=await this.f.request(N,T,q)}catch(W){if(!(W instanceof c.$job)){let te="RequestFailed";const oe=(0,D.$0)(W).toLowerCase();oe.includes("xhr timeout")?te="RequestTimeout":oe.includes("protocol")&&oe.includes("not supported")?te="RequestProtocolNotSupported":oe.includes("request path contains unescaped characters")?te="RequestPathNotEscaped":oe.includes("headers must be an object")?te="RequestHeadersNotObject":(0,D.$4)(W)&&(te="RequestCanceled"),W=new c.$job(`Connection refused for the request '${N}'.`,N,te,void 0,void 0)}throw this.r.info("Request failed",N),W}const x=X.res.headers[c.$fob],V={url:N,status:X.res.statusCode,"execution-id":T.headers[c.$gob],"operation-id":x},Q=(0,l.$lp)(X)||X.res.statusCode&&M.includes(X.res.statusCode);let H="";if(Q?this.r.trace("Request succeeded",V):(H=await(0,l.$np)(X)||"",this.r.info("Request failed",V,H)),X.res.statusCode===401||X.res.statusCode===403){if(this.b=void 0,X.res.statusCode===401)throw this.g.fire("Unauthorized"),new c.$job(`${T.type} request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",X.res.statusCode,x);if(X.res.statusCode===403)throw this.g.fire("Forbidden"),new c.$job(`${T.type} request '${N}' failed because the access is forbidden (403).`,N,"Forbidden",X.res.statusCode,x)}if(this.h.fire(),X.res.statusCode===404)throw new c.$job(`${T.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",X.res.statusCode,x);if(X.res.statusCode===405)throw new c.$job(`${T.type} request '${N}' failed because the requested endpoint is not found (405). ${H}`,N,"MethodNotFound",X.res.statusCode,x);if(X.res.statusCode===409)throw new c.$job(`${T.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",X.res.statusCode,x);if(X.res.statusCode===410)throw new c.$job(`${T.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",X.res.statusCode,x);if(X.res.statusCode===412)throw new c.$job(`${T.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",X.res.statusCode,x);if(X.res.statusCode===413)throw new c.$job(`${T.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",X.res.statusCode,x);if(X.res.statusCode===426)throw new c.$job(`${T.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",X.res.statusCode,x);if(X.res.statusCode===429){const W=X.res.headers["retry-after"];throw W?(this.y(new Date(Date.now()+parseInt(W)*1e3)),new c.$job(`${T.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",X.res.statusCode,x)):new c.$job(`${T.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",X.res.statusCode,x)}if(!Q)throw new c.$job("Server returned "+X.res.statusCode,N,"Unknown",X.res.statusCode,x);return X}F(N){let T=this.s.get(s,-1);T===void 0&&(T=(0,m.$rg)(),this.s.store(s,T,-1,1)),N["X-Machine-Session-Id"]=T;const M=this.s.get(n,-1);M!==void 0&&(N["X-User-Session-Id"]=M)}};e.$CHb=w,e.$CHb=w=pe([K(1,E.$Hj),K(2,l.$jp),K(3,c.$sob),K(4,$.$ci),K(5,p.$sk),K(6,d.$wp)],w);let f=class extends w{constructor(N,T,M,q,Y,X,x){super(N.userDataSyncStore?.url,T,M,q,Y,X,x),this.B(N.onDidChangeUserDataSyncStore(()=>this.t(N.userDataSyncStore?.url)))}};e.$DHb=f,e.$DHb=f=pe([K(0,c.$cob),K(1,E.$Hj),K(2,l.$jp),K(3,c.$sob),K(4,$.$ci),K(5,p.$sk),K(6,d.$wp)],f);class b{constructor(N,T,M,q){this.c=N,this.d=T,this.f=M,this.g=q,this.a=[],this.b=void 0}request(N,T,M){if(this.h()&&this.i(),T.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new c.$job(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(T,M)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$EHb=b}),define(le[261],he([0,1,3,2,9,21,24,19,122]),function(se,e,O,A,D,L,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5_b=e.$4_b=e.$3_b=e.$2_b=void 0;class g{constructor($){this.a=$}listen($,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${p}`)}call($,p,E){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(E)}throw new Error("Invalid call")}}e.$2_b=g;class P extends A.$Tc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor($){super(),this.c=$,this.b=this.B(new O.$Wd),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(p=>{this.a=p,this.B(this.c.listen("onDidChangeAccount")(E=>{this.a=E,this.b.fire(E)}))})}updateAccount($){return this.c.call("updateAccount",$)}}e.$3_b=P;class k{constructor($){this.a=$}listen($,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call($,p,E){switch(p){case"switch":return this.a.switch(E[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$4_b=k;let m=class extends S.$AHb{constructor($,p,E,l){super(p,E,l),this.n=$,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch($){return this.n.call("switch",[$])}async getPreviousUserDataSyncStore(){const $=await this.n.call("getPreviousUserDataSyncStore");return this.r($)}r($){return{url:D.URI.revive($.url),type:$.type,defaultUrl:D.URI.revive($.defaultUrl),insidersUrl:D.URI.revive($.insidersUrl),stableUrl:D.URI.revive($.stableUrl),canSwitch:$.canSwitch,authenticationProviders:$.authenticationProviders}}};e.$5_b=m,e.$5_b=m=pe([K(1,I.$Hj),K(2,L.$Bi),K(3,R.$wp)],m)}),define(le[262],he([0,1,3,57,24,19,22,257,25,81,84]),function(se,e,O,A,D,L,I,R,S,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;let k=class extends R.$M9b{constructor(h,$,p,E,l,u,d,c,y,i,o){super(h,$,p,E,l,d,c,y,i,o),this.B(O.Event.debounce(O.Event.any(O.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),O.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$oac=k,e.$oac=k=pe([K(0,D.$Hj),K(1,S.$cob),K(2,S.$dob),K(3,S.$nob),K(4,S.$oob),K(5,A.$e$b),K(6,S.$sob),K(7,g.$$Fb),K(8,I.$wl),K(9,P.$3nb),K(10,L.$wp)],k)}),define(le[263],he([0,1,73,23,5,20]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0b=e.$G0b=e.$F0b=e.$E0b=void 0,e.$E0b=128/4;function I(g){function P(){let k=g.scheme===A.Schemas.file?(0,L.$wg)(g):g.toString();return D.$k||(k=k.toLowerCase()),(0,O.createHash)("md5").update(k).digest("hex")}return{id:P(),configPath:g}}e.$F0b=I;function R(g,P){function k(){if(g.scheme!==A.Schemas.file)return(0,O.createHash)("md5").update(g.toString()).digest("hex");if(!P)return;let h;return D.$k?h=P.ino:D.$j?h=P.birthtime.getTime():D.$i&&(typeof P.birthtimeMs=="number"?h=Math.floor(P.birthtimeMs):h=P.birthtime.getTime()),(0,O.createHash)("md5").update(g.fsPath).update(h?String(h):"").digest("hex")}const m=k();if(typeof m=="string")return{id:m,uri:g}}e.$G0b=R;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$H0b=S}),define(le[264],he([0,1,6,7,2,16,31,15,8,78,112,263,57,56,23]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=void 0;let p=class extends D.$Tc{constructor(l,u,d,c){super(),this.a=l,this.b=u,this.c=d,this.f=c,this.B(new O.$hh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,u=await I.Promises.readdir(l),d=new g.$JGb(this.f.getChannel("storage"));await Promise.all(u.map(async c=>{const y=(0,L.$jc)(l,c);c.length===k.$E0b||c===P.$hi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await d.isUsed(y)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await I.Promises.rm(y))}))}catch(l){(0,A.$1)(l)}}};e.$X_b=p,e.$X_b=p=pe([K(0,R.$di),K(1,S.$pj),K(2,m.$e$b),K(3,h.$u_b)],p)}),define(le[123],he([0,1,73,64,36,272,14,7,3,2,16,5,32,40,68]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0;class p{traceSocketEvent(f,b){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,b)}constructor(f,b=""){this.f=!0,this.debugLabel=b,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,R.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const b=C=>{this.traceSocketEvent("read",C),f(I.$ke.wrap(C))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(f){const b=C=>{f({type:0,hadError:C,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(f){const b=()=>{f()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,R.$1)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,R.$1)(b)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$Wh=p;var E;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(E||(E={}));var l;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(l||(l={}));class u extends g.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,b){this.socket.traceSocketEvent(f,b)}constructor(f,b,C,N){super(),this.f=this.B(new S.$Wd),this.g=this.B(new S.$Wd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:C?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new d(this,b,C,N,this.f,(T,M)=>this.m(T,M))),this.B(this.a.onError(T=>{console.error(T),(0,R.$1)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new $.$Rh,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let b=0;for(;b<f.byteLength;)this.a.writeMessage(f.slice(b,Math.min(b+262144,f.byteLength)),{compressed:!0,opcode:2}),b+=262144}m(f,{compressed:b,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let N=2;f.byteLength<126?N+=0:f.byteLength<2**16?N+=2:N+=8;const T=I.$ke.alloc(N),M=b?64:0,q=C&15;if(T.writeUInt8(128|M|q,0),f.byteLength<126)T.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){T.writeUInt8(126,1);let Y=1;T.writeUInt8(f.byteLength>>>8&255,++Y),T.writeUInt8(f.byteLength>>>0&255,++Y)}else{T.writeUInt8(127,1);let Y=1;T.writeUInt8(0,++Y),T.writeUInt8(0,++Y),T.writeUInt8(0,++Y),T.writeUInt8(0,++Y),T.writeUInt8(f.byteLength>>>24&255,++Y),T.writeUInt8(f.byteLength>>>16&255,++Y),T.writeUInt8(f.byteLength>>>8&255,++Y),T.writeUInt8(f.byteLength>>>0&255,++Y)}this.socket.write(I.$ke.concat([T,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const b=this.b.peek(this.j.readLen),C=b.readUInt8(0),N=(C&128)>>>7,T=(C&64)>>>6,M=C&15,q=b.readUInt8(1),Y=(q&128)>>>7,X=q&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(X===126?2:0)+(X===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const b=this.b.read(this.j.readLen),C=b.readUInt8(1),N=(C&128)>>>7;let T=C&127,M=1;T===126?T=b.readUInt8(++M)*2**8+b.readUInt8(++M):T===127&&(T=b.readUInt8(++M)*0+b.readUInt8(++M)*0+b.readUInt8(++M)*0+b.readUInt8(++M)*0+b.readUInt8(++M)*2**24+b.readUInt8(++M)*2**16+b.readUInt8(++M)*2**8+b.readUInt8(++M));let q=0;N&&(q=b.readUInt8(++M)*2**24+b.readUInt8(++M)*2**16+b.readUInt8(++M)*2**8+b.readUInt8(++M)),this.j.state=3,this.j.readLen=T,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const b=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",b),i(b,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",b),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(b,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(b,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Xh=u;class d extends g.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$ke.alloc(0)}constructor(f,b,C,N,T,M){super(),this.n=f,this.r=T,this.s=M,this.a=this.B(new S.$Wd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$Wd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$Wd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,b?(this.b=this.B(new c(this.n,N,C,{windowBits:15})),this.f=this.B(new y(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(f,b){this.g.push({data:f,options:b}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:b}=this.g.shift();if(this.f&&b.compressed){const C=await this.w(this.f,f);this.s(C,b)}else this.s(f,{...b,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,b){return new Promise((C,N)=>{f.write(b),f.flush(T=>C(T))})}acceptFrame(f,b,C){this.h.push({data:f,isCompressed:b,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const b=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(b)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,b,C){return new Promise((N,T)=>{f.write(b),C&&f.write(I.$ke.fromByteArray([0,0,255,255])),f.flush(M=>N(M))})}}class c extends g.$Tc{get recordedInflateBytes(){return this.j?I.$ke.concat(this.f):I.$ke.alloc(0)}constructor(f,b,C,N){super(),this.h=f,this.j=b,this.a=this.B(new S.$Wd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(N),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(I.$ke.wrap(T))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const b=I.$ke.concat(this.g);this.g.length=0,f(b)})}}class y extends g.$Tc{constructor(f,b){super(),this.g=f,this.a=this.B(new S.$Wd),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(I.$ke.wrap(C))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let b=I.$ke.concat(this.f);this.f.length=0,b=b.slice(0,b.byteLength-4),f(b)})}}function i(w,f){if(f===0)return;const b=w.byteLength>>>2;for(let Y=0;Y<b;Y++){const X=w.readUInt32BE(Y*4);w.writeUInt32BE(X^f,Y*4)}const C=b*4,N=w.byteLength-C,T=f>>>24&255,M=f>>>16&255,q=f>>>8&255;N>=1&&w.writeUInt8(w.readUInt8(C)^T,C),N>=2&&w.writeUInt8(w.readUInt8(C+1)^M,C+1),N>=3&&w.writeUInt8(w.readUInt8(C+2)^q,C+2)}e.$Yh=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const w=(0,m.$rg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const f=process.platform!=="darwin"&&e.$Yh?e.$Yh:(0,D.tmpdir)(),b=(0,P.$jc)(f,`vscode-ipc-${w}.sock`);return t(b),b}e.$Zh=n;function s(w,f,b){const N=(0,O.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${b}-${f}-sock`;const T=b.substr(0,4),M=f.substr(0,6);let q;return process.platform!=="darwin"&&e.$Yh&&!process.env.VSCODE_PORTABLE?q=(0,P.$jc)(e.$Yh,`vscode-${N}-${T}-${M}.sock`):q=(0,P.$jc)(w,`${T}-${M}.sock`),t(q),q}e.$1h=s;function t(w){const f=o[k.$u];typeof f=="number"&&w.length>=f&&console.warn(`WARNING: IPC handle "${w}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends h.$Lh{static b(f){const b=S.Event.fromNodeEventEmitter(f,"connection");return S.Event.map(b,C=>({protocol:new $.$Sh(new p(C,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(C,"close"))}))}constructor(f){super(r.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$2h=r;function a(w){return new Promise((f,b)=>{const C=(0,A.createServer)();C.on("error",b),C.listen(w,()=>{C.removeListener("error",b),f(new r(C))})})}e.$3h=a;function v(w,f){return new Promise((b,C)=>{const N=(0,A.createConnection)(w,()=>{N.removeListener("error",C),b($.$Th.fromSocket(new p(N,`ipc-client${f}`),f))});N.once("error",C)})}e.$4h=v}),define(le[265],he([0,1,64,123,212]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=void 0,e.$rac=new class{supports(L){return!0}connect({host:L,port:I},R,S,g){return new Promise((P,k)=>{const m=O.createConnection({host:L,port:I},()=>{m.removeListener("error",k),m.write((0,D.$wsb)(R,S,g));const h=$=>{$.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",h),P(new A.$Wh(m,g)))};m.on("data",h)});m.setNoDelay(!0),m.once("error",k)})}}}),define(le[266],he([0,1,64,36,133,123,6,2,5,21,8,24,215,104,106,79,14]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o_b=e.$n_b=e.$m_b=e.$l_b=void 0;async function l(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new u(i,o,n,s,t).waitForReady(),!(t&&D.$ug[t]||!D.$ug[r.tunnelLocalPort]));a--);return r}class u extends R.$Tc{constructor(o,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=O.createServer(),this.c=new I.$7g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,p.$Jv)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,D.$vg)(o,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,p.$Hv)(this.tunnelRemoteHost)||(0,p.$Jv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,m.$nl)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof L.$Wh?t.socket.destroy():t.end()}),t instanceof L.$Wh?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(E.$ke.wrap(s))),o.resume()}t(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.$l_b=u;let d=class extends p.$Mv{constructor(o,n,s,t,r){super(n,r),this.v=o,this.w=s,this.y=t}isPortPrivileged(o){return(0,p.$Kv)(o,this.m,S.OS,A.release())}t(o,n,s,t,r,a,v,w){const f=this.s(n,s);if(f)return++f.refcount,f.value;if((0,p.$Ev)(o))return this.u(o,n,s,r,a,v,w);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const b={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=l(b,t,n,s,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,C),C}}};e.$m_b=d,e.$m_b=d=pe([K(0,h.$hl),K(1,P.$pj),K(2,$.$kl),K(3,k.$Hj),K(4,g.$Bi)],d);let c=class extends d{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.$n_b=c,e.$n_b=c=pe([K(0,h.$hl),K(1,P.$pj),K(2,$.$kl),K(3,k.$Hj),K(4,g.$Bi)],c);let y=class extends R.$Tc{constructor(o,n,s,t,r){super(),this.b=o,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,s,t,r,a,v,w,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(o)){const b=new c(this.b,this.c,this.g,this.f,this.h);this.B(b),this.a.set(o,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,s,t,r,a,v,w,f)}};e.$o_b=y,e.$o_b=y=pe([K(0,h.$hl),K(1,P.$pj),K(2,k.$Hj),K(3,$.$kl),K(4,g.$Bi)],y)}),define(le[273],he([0,1,36,38,7,2,23,9,17,3,40,147,206,207,197,198,264,188,190,21,211,95,222,96,217,15,114,248,29,99,189,113,97,11,200,201,72,4,196,74,75,228,8,202,102,24,59,19,107,22,108,109,110,46,231,83,111,25,81,256,261,241,84,255,259,260,122,60,254,242,106,221,79,266,216,232,28,233,5,234,191,209,208,82,247,18,51,205,58,253,230,243,105,258,249,10,203,101,251,246,218,185,57,204,262,250,56,252,104,265,182,219]),function(se,e,O,A,D,L,I,R,S,g,P,k,m,h,$,p,E,l,u,d,c,y,i,o,n,s,t,r,a,v,w,f,b,C,N,T,M,q,Y,X,x,V,Q,H,W,te,oe,ee,ae,G,z,j,F,B,U,Z,_,ie,J,ne,ce,fe,de,me,Ee,Pe,Oe,Ne,ue,ge,we,Ce,Re,Me,je,ze,Fe,Te,qe,re,$e,be,ve,ye,Se,Ie,De,Ae,We,Ue,Be,Ve,Ze,et,vt,Et,kt,dt,St,Ct,Pt,Rt,It,Ot,jt,Dt,$t,Lt,gt,At,Nt,nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends L.$Tc{constructor(ke){super(),this.f=ke,this.a=this.B(new k.$9U(this)),this.b=void 0,this.c=this.B(new g.$Wd),this.g()}g(){let ke=!1;const Le=()=>{ke||(ke=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Le),(0,k.$0U)(process.parentPort,nt.$A$b.exit,Le)}async init(){const ke=await this.h();(0,ie.$0nb)(),ke.invokeFunction(Le=>{const Xe=Le.get(Q.$pj),He=Le.get(G.$wl),Qe=Le.get(Ie.$5k);Xe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Le),this.m(Xe),this.n(He,Qe),this.B(Qe.onDidChangeProfiles(()=>this.n(He,Qe)))}),this.B((0,L.$Qc)(ke.createInstance(m.$T_b,this.f.codeCachePath),ke.createInstance(h.$U_b),ke.createInstance(E.$X_b),ke.createInstance(p.$W_b),ke.createInstance($.$V_b),ke.createInstance(vt.$iac),ke.createInstance(Ve.$aac)))}async h(){const ke=new X.$6h,Le={_serviceBrand:void 0,...W.default};ke.set(te.$Hj,Le);const Xe=new P.$Ph(Ge=>Ge==="main"),He=new $t.$v_b(this.a,Xe);ke.set($t.$u_b,He);const Qe=this.f.policiesData?new Ae.$4$b(this.f.policiesData,He.getChannel("policy")):new We.$On;ke.set(We.$Mn,Qe);const Je=new Nt.$Em(this.f.args,Le);ke.set(s.$di,Je);const _e=new H.$Cr(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Ge=>({...Ge,resource:R.URI.revive(Ge.resource)})),He.getChannel("logger"));ke.set(Q.$qj,_e);const rt=this.B(_e.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),lt=this.B(new Q.$xj(rt.getLevel())),Ke=this.B(new kt.$XO(rt,[lt]));ke.set(Q.$pj,Ke),this.b=this.B(new dt.$kac(Ke)),ke.set(dt.$jac,this.b);const Ye=this.B(new N.$eq(Ke));ke.set(C.$sk,Ye);const ht=this.B(new T.$Dq(Ke));Ye.registerProvider(I.Schemas.file,ht);const ot=new Te.$4r(Ye);ke.set(Fe.$3k,ot);const xe=this.B(new Ue.$5O(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));ke.set(Ie.$5k,xe);const ut=this.B(new re.$t_b(I.Schemas.file,this.B(new $e.$GO(He.getChannel($e.$FO),{pathCaseSensitive:qe.$k})),I.Schemas.vscodeUserData,xe,ot,Ke));Ye.registerProvider(I.Schemas.vscodeUserData,ut);const tt=this.B(new c.$co(xe.defaultProfile.settingsResource,Ye,Qe,Ke));ke.set(d.$Bi,tt);const ft=new Lt.$qac(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},He,Je);ke.set(ee.$wp,ft),this.B((0,L.$Rc)(()=>ft.flush())),await Promise.all([tt.initialize(),ft.initialize()]);const wt=new Pt.$nr(He.getChannel("request"));ke.set(oe.$jp,wt),ke.set(l.$Y_b,new M.$5h(u.$Z_b,void 0,!1)),ke.set(ve.$rF,new M.$5h(be.$__b,void 0,!1));const bt=new Ot.$A_b(-1,He);ke.set(It.$e$b,bt),ke.set(o.$go,new M.$5h(n.$aP,void 0,!0));const Tt=this.B(new ge.$1$b(bt)),Mt=new P.$Ph(Ge=>Tt.getActiveClientId().then(ct=>Ge===ct));ke.set(b.$yZb,new Rt.$mac(this.a.getChannel("extensionRecommendationNotification",Mt)));let at;const it=[],pt=(0,B.$Zo)(Le,tt);if((0,B.$Uo)(Le,Je)){const Ge=new j.$48b(Ke,_e,Je,Le);if(it.push(Ge),!(0,B.$Vo)(Le,Je)&&Le.aiConfig?.ariaKey){const ct=new Be.$LO(wt,pt,"monacoworkbench",null,Le.aiConfig.ariaKey);this.B((0,L.$Rc)(()=>ct.flush())),it.push(ct)}at=new F.$rr({appenders:it,commonProperties:(0,ae.$Lo)((0,O.release)(),(0,O.hostname)(),process.arch,Le.commit,Le.version,this.f.machineId,this.f.sqmId,pt),sendErrorTelemetry:!0,piiPaths:(0,B.$1o)(Je)},tt,Le)}else{at=B.$Po;const Ge=B.$To;it.push(Ge)}this.a.registerChannel("telemetryAppender",new z.$F$b(it)),ke.set(G.$wl,at);const Ut=new U.$1_b(tt,at,Ke,_e,Je,Le);ke.set(G.$xl,Ut),ke.set(De.$Xp,new M.$5h(Ct.$WO,void 0,!0)),ke.set(ye.$2p,new M.$5h(Se.$5$b,void 0,!0)),ke.set(v.$Hp,new M.$5h(v.$Ip,void 0,!0)),ke.set(f.$_p,new M.$5h(f.$aq,void 0,!0)),ke.set(a.$Bo,new M.$5h(r.$Fp,void 0,!0)),ke.set(a.$Io,new M.$5h(Dt.$pac,void 0,!1)),ke.set(x.$jr,new M.$5h(V.$lr,void 0,!1)),ke.set(y.$Lm,new M.$5h(i.$$r,void 0,!1)),ke.set(J.$$Fb,new M.$5h(J.$_Fb,void 0,!0)),ke.set(ie.$sob,new M.$5h(fe.$tIb,void 0,!0)),ke.set(ie.$rob,P.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),ke.set(a.$Ho,new M.$5h(t.$9Fb,void 0,!1)),ke.set(_.$rIb,new M.$5h(_.$sIb,void 0,!0)),ke.set(Z.$ov,new M.$5h(Z.$pv)),ke.set(ie.$cob,new M.$5h(Oe.$BHb,void 0,!0)),ke.set(ie.$dob,new M.$5h(Oe.$DHb,void 0,!0)),ke.set(de.$3nb,new M.$5h(de.$5nb,void 0,!0)),ke.set(ie.$eob,new M.$5h(ne.$G9b,void 0,!1)),ke.set(ie.$nob,new M.$5h(me.$v9b,void 0,!0)),ke.set(ie.$oob,new M.$5h(Ee.$L9b,void 0,!1)),ke.set(Ne.$KGb,new M.$5h(ue.$8_b,void 0,!0)),ke.set(ie.$pob,new M.$5h(et.$i0b,void 0,!0)),ke.set(we.$kl,new M.$5h(Ce.$q_b,void 0,!1));const yt=new gt.$il;return ke.set(gt.$hl,yt),yt.register(0,At.$rac),ke.set(Re.$Dv,new M.$5h(Me.$o_b)),ke.set(je.$9_b,new M.$5h(ze.$$_b)),ke.set(Ze.$bac,new M.$5h(St.$lac)),new Y.$Gq(ke)}j(ke){const Le=new w.$Kp(ke.get(a.$Eo),()=>null);this.a.registerChannel("extensions",Le);const Xe=P.ProxyChannel.fromService(ke.get(x.$jr),this.q);this.a.registerChannel("languagePacks",Xe);const He=P.ProxyChannel.fromService(ke.get(y.$Lm),this.q);this.a.registerChannel("diagnostics",He);const Qe=new w.$Mp(ke.get(a.$Io));this.a.registerChannel("extensionTipsService",Qe);const Je=P.ProxyChannel.fromService(ke.get(l.$Y_b),this.q);this.a.registerChannel("checksum",Je);const _e=P.ProxyChannel.fromService(ke.get(ve.$rF),this.q);this.a.registerChannel("v8InspectProfiling",_e);const rt=P.ProxyChannel.fromService(ke.get(de.$3nb),this.q);this.a.registerChannel("userDataSyncMachines",rt);const lt=P.ProxyChannel.fromService(ke.get(G.$xl),this.q);this.a.registerChannel("customEndpointTelemetry",lt);const Ke=new ce.$2_b(ke.get(J.$$Fb));this.a.registerChannel("userDataSyncAccount",Ke);const Ye=new ce.$4_b(ke.get(ie.$cob));this.a.registerChannel("userDataSyncStoreManagement",Ye);const ht=new Pe.$6_b(ke.get(ie.$oob),ke.get(Ie.$5k),ke.get(Q.$pj));this.a.registerChannel("userDataSync",ht);const ot=this.B(ke.get(q.$7h).createInstance(jt.$oac));this.a.registerChannel("userDataAutoSync",P.ProxyChannel.fromService(ot,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(ke.get(ie.$pob),this.q));const xe=P.ProxyChannel.fromService(ke.get(je.$9_b),this.q);this.a.registerChannel(je.$0_b,xe);const ut=P.ProxyChannel.fromService(ke.get(Ze.$bac),this.q);this.a.registerChannel("remoteTunnel",ut)}m(ke){process.on("uncaughtException",Le=>(0,D.$1)(Le)),process.on("unhandledRejection",Le=>(0,D.$1)(Le)),(0,D.setUnexpectedErrorHandler)(Le=>{const Xe=(0,A.$Si)(Le,!0);Xe&&ke.error(`[uncaught exception in sharedProcess]: ${Xe}`)})}n(ke,Le){ke.publicLog2("profilesInfo",{count:Le.profiles.length})}handledClientConnection(ke){if(ke.data!==nt.$C$b.response)return!1;const Le=(0,S.$Ob)(ke.ports);return Le?(this.c.fire(Le),!0):!1}}async function mt(st){const ke=new Ft(st);process.parentPort.postMessage(nt.$A$b.ipcReady),await ke.init(),process.parentPort.postMessage(nt.$A$b.initDone)}e.main=mt,process.parentPort.once("message",st=>{mt(st.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/420099cb092f0994ecb1e7af4c679dc0ffe57fa3/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
