/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/htmlContent","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostChatProvider","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Me=function(fe){for(var e=[],S=0,M=fe.length;S<M;S++)e[S]=Ae[fe[S]];return e};define(Ae[67],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function S(R){return(m,f,D)=>{let L=null,k=null;if(typeof D.value=="function"?(L="value",k=D.value):typeof D.get=="function"&&(L="get",k=D.get),!k)throw new Error("not supported");D[L]=R(k,f)}}function M(R,m,f){let D=null,L=null;if(typeof f.value=="function"?(D="value",L=f.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(D="get",L=f.get),!L)throw new Error("not supported");const k=`$memoize$${m}`;f[D]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,l)}),this[k]}}e.$zh=M;function I(R,m,f){return S((D,L)=>{const k=`$debounce$${L}`,l=`$debounce$result$${L}`;return function(...$){this[l]||(this[l]=f?f():void 0),clearTimeout(this[k]),m&&(this[l]=m(this[l],...$),$=[this[l]]),this[k]=setTimeout(()=>{D.apply(this,$),this[l]=f?f():void 0},R)}})}e.$Ah=I;function A(R,m,f){return S((D,L)=>{const k=`$throttle$timer$${L}`,l=`$throttle$result$${L}`,$=`$throttle$lastRun$${L}`,w=`$throttle$pending$${L}`;return function(...r){if(this[l]||(this[l]=f?f():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...r)),this[w])return;const c=this[$]+R;c<=Date.now()?(this[$]=Date.now(),D.apply(this,[this[l]]),this[l]=f?f():void 0):(this[w]=!0,this[k]=setTimeout(()=>{this[w]=!1,this[$]=Date.now(),D.apply(this,[this[l]]),this[l]=f?f():void 0},c-Date.now()))}})}e.$Bh=A}),define(Ae[88],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=e.$FN=void 0;class S{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$FN=S,e.$GN=new S("id#")}),define(Ae[120],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(t,d=!1){let n=0;const b=t.length;let E="",h=0,v=16,P=0;function g(U){let C=0,F=0;for(;C<U;){const W=t.charCodeAt(n);if(W>=48&&W<=57)F=F*16+W-48;else if(W>=65&&W<=70)F=F*16+W-65+10;else if(W>=97&&W<=102)F=F*16+W-97+10;else break;n++,C++}return C<U&&(F=-1),F}function p(U){n=U,E="",h=0,v=16,P=0}function y(){const U=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&D(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&D(t.charCodeAt(n)))for(n++;n<t.length&&D(t.charCodeAt(n));)n++;else return P=3,t.substring(U,n);let C=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&D(t.charCodeAt(n))){for(n++;n<t.length&&D(t.charCodeAt(n));)n++;C=n}else P=3;return t.substring(U,C)}function T(){let U="",C=n;for(;;){if(n>=b){U+=t.substring(C,n),P=2;break}const F=t.charCodeAt(n);if(F===34){U+=t.substring(C,n),n++;break}if(F===92){if(U+=t.substring(C,n),n++,n>=b){P=2;break}switch(t.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const re=g(4);re>=0?U+=String.fromCharCode(re):P=4;break}default:P=5}C=n;continue}if(F>=0&&F<=31)if(f(F)){U+=t.substring(C,n),P=2;break}else P=6;n++}return U}function N(){if(E="",P=0,h=n,n>=b)return h=b,v=17;let U=t.charCodeAt(n);if(m(U)){do n++,E+=String.fromCharCode(U),U=t.charCodeAt(n);while(m(U));return v=15}if(f(U))return n++,E+=String.fromCharCode(U),U===13&&t.charCodeAt(n)===10&&(n++,E+=`
`),v=14;switch(U){case 123:return n++,v=1;case 125:return n++,v=2;case 91:return n++,v=3;case 93:return n++,v=4;case 58:return n++,v=6;case 44:return n++,v=5;case 34:return n++,E=T(),v=10;case 47:{const C=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<b&&!f(t.charCodeAt(n));)n++;return E=t.substring(C,n),v=12}if(t.charCodeAt(n+1)===42){n+=2;const F=b-1;let W=!1;for(;n<F;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,W=!0;break}n++}return W||(n++,P=1),E=t.substring(C,n),v=13}return E+=String.fromCharCode(U),n++,v=16}case 45:if(E+=String.fromCharCode(U),n++,n===b||!D(t.charCodeAt(n)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return E+=y(),v=11;default:for(;n<b&&J(U);)n++,U=t.charCodeAt(n);if(h!==n){switch(E=t.substring(h,n),E){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return E+=String.fromCharCode(U),n++,v=16}}function J(U){if(m(U)||f(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:p,getPosition:()=>n,scan:d?q:N,getToken:()=>v,getTokenValue:()=>E,getTokenOffset:()=>h,getTokenLength:()=>n-h,getTokenError:()=>P}}e.$dn=R;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function D(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function k(t,d){const n=[],b=new Object;let E;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function P(g,p,y,T){h.value=g,h.offset=p,h.length=y,h.type=T,h.colonOffset=void 0,E=h}try{o(t,{onObjectBegin:(g,p)=>{if(d<=g)throw b;E=void 0,v=d>g,n.push("")},onObjectProperty:(g,p,y)=>{if(d<p||(P(g,p,y,"property"),n[n.length-1]=g,d<=p+y))throw b},onObjectEnd:(g,p)=>{if(d<=g)throw b;E=void 0,n.pop()},onArrayBegin:(g,p)=>{if(d<=g)throw b;E=void 0,n.push(0)},onArrayEnd:(g,p)=>{if(d<=g)throw b;E=void 0,n.pop()},onLiteralValue:(g,p,y)=>{if(d<p||(P(g,p,y,u(g)),d<=p+y))throw b},onSeparator:(g,p,y)=>{if(d<=p)throw b;if(g===":"&&E&&E.type==="property")E.colonOffset=p,v=!1,E=void 0;else if(g===","){const T=n[n.length-1];typeof T=="number"?n[n.length-1]=T+1:(v=!0,n[n.length-1]=""),E=void 0}}})}catch(g){if(g!==b)throw g}return{path:n,previousNode:E,isAtPropertyKey:v,matches:g=>{let p=0;for(let y=0;p<g.length&&y<n.length;y++)if(g[p]===n[y]||g[p]==="*")p++;else if(g[p]!=="**")return!1;return p===g.length}}}e.$en=k;function l(t,d=[],n=A.DEFAULT){let b=null,E=[];const h=[];function v(g){Array.isArray(E)?E.push(g):b!==null&&(E[b]=g)}return o(t,{onObjectBegin:()=>{const g={};v(g),h.push(E),E=g,b=null},onObjectProperty:g=>{b=g},onObjectEnd:()=>{E=h.pop()},onArrayBegin:()=>{const g=[];v(g),h.push(E),E=g,b=null},onArrayEnd:()=>{E=h.pop()},onLiteralValue:v,onError:(g,p,y)=>{d.push({error:g,offset:p,length:y})}},n),E[0]}e.$fn=l;function $(t,d=[],n=A.DEFAULT){let b={type:"array",offset:-1,length:-1,children:[],parent:void 0};function E(g){b.type==="property"&&(b.length=g-b.offset,b=b.parent)}function h(g){return b.children.push(g),g}o(t,{onObjectBegin:g=>{b=h({type:"object",offset:g,length:-1,parent:b,children:[]})},onObjectProperty:(g,p,y)=>{b=h({type:"property",offset:p,length:-1,parent:b,children:[]}),b.children.push({type:"string",value:g,offset:p,length:y,parent:b})},onObjectEnd:(g,p)=>{b.length=g+p-b.offset,b=b.parent,E(g+p)},onArrayBegin:(g,p)=>{b=h({type:"array",offset:g,length:-1,parent:b,children:[]})},onArrayEnd:(g,p)=>{b.length=g+p-b.offset,b=b.parent,E(g+p)},onLiteralValue:(g,p,y)=>{h({type:u(g),offset:p,length:y,parent:b,value:g}),E(p+y)},onSeparator:(g,p,y)=>{b.type==="property"&&(g===":"?b.colonOffset=p:g===","&&E(p))},onError:(g,p,y)=>{d.push({error:g,offset:p,length:y})}},n);const P=b.children[0];return P&&delete P.parent,P}e.$gn=$;function w(t,d){if(!t)return;let n=t;for(const b of d)if(typeof b=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let E=!1;for(const h of n.children)if(Array.isArray(h.children)&&h.children[0].value===b){n=h.children[1],E=!0;break}if(!E)return}else{const E=b;if(n.type!=="array"||E<0||!Array.isArray(n.children)||E>=n.children.length)return;n=n.children[E]}return n}e.$hn=w;function r(t){if(!t.parent||!t.parent.children)return[];const d=r(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;d.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&d.push(n)}return d}e.$in=r;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const d=Object.create(null);for(const n of t.children){const b=n.children[1];b&&(d[n.children[0].value]=c(b))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$jn=c;function s(t,d,n=!1){return d>=t.offset&&d<t.offset+t.length||n&&d===t.offset+t.length}e.$kn=s;function i(t,d,n=!1){if(s(t,d,n)){const b=t.children;if(Array.isArray(b))for(let E=0;E<b.length&&b[E].offset<=d;E++){const h=i(b[E],d,n);if(h)return h}return t}}e.$ln=i;function o(t,d,n=A.DEFAULT){const b=R(t,!1);function E(se){return se?()=>se(b.getTokenOffset(),b.getTokenLength()):()=>!0}function h(se){return se?$e=>se($e,b.getTokenOffset(),b.getTokenLength()):()=>!0}const v=E(d.onObjectBegin),P=h(d.onObjectProperty),g=E(d.onObjectEnd),p=E(d.onArrayBegin),y=E(d.onArrayEnd),T=h(d.onLiteralValue),N=h(d.onSeparator),J=E(d.onComment),q=h(d.onError),U=n&&n.disallowComments,C=n&&n.allowTrailingComma;function F(){for(;;){const se=b.scan();switch(b.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:U||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(se){case 12:case 13:U?W(10):J();break;case 16:W(1);break;case 15:case 14:break;default:return se}}}function W(se,$e=[],te=[]){if(q(se),$e.length+te.length>0){let X=b.getToken();for(;X!==17;){if($e.indexOf(X)!==-1){F();break}else if(te.indexOf(X)!==-1)break;X=F()}}}function re(se){const $e=b.getTokenValue();return se?T($e):P($e),F(),!0}function ce(){switch(b.getToken()){case 11:{let se=0;try{se=JSON.parse(b.getTokenValue()),typeof se!="number"&&(W(2),se=0)}catch{W(2)}T(se);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return F(),!0}function we(){return b.getToken()!==10?(W(3,[],[2,5]),!1):(re(!1),b.getToken()===6?(N(":"),F(),ve()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function De(){v(),F();let se=!1;for(;b.getToken()!==2&&b.getToken()!==17;){if(b.getToken()===5){if(se||W(4,[],[]),N(","),F(),b.getToken()===2&&C)break}else se&&W(6,[],[]);we()||W(4,[],[2,5]),se=!0}return g(),b.getToken()!==2?W(7,[2],[]):F(),!0}function he(){p(),F();let se=!1;for(;b.getToken()!==4&&b.getToken()!==17;){if(b.getToken()===5){if(se||W(4,[],[]),N(","),F(),b.getToken()===4&&C)break}else se&&W(6,[],[]);ve()||W(4,[],[4,5]),se=!0}return y(),b.getToken()!==4?W(8,[4],[]):F(),!0}function ve(){switch(b.getToken()){case 3:return he();case 1:return De();case 10:return re(!0);default:return ce()}}return F(),b.getToken()===17?n.allowEmptyContent?!0:(W(4,[],[]),!1):ve()?(b.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$mn=o;function a(t,d){const n=R(t),b=[];let E,h=0,v;do switch(v=n.getPosition(),E=n.scan(),E){case 12:case 13:case 17:h!==v&&b.push(t.substring(h,v)),d!==void 0&&b.push(n.getTokenValue().replace(/[^\r\n]/g,d)),h=n.getPosition();break}while(E!==17);return b.join("")}e.$nn=a;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$on=u}),function(fe,e){typeof define=="function"&&define.amd?define(Ae[121],Me([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(Pe,be){for(var me=0;me<be.length;me++){var G=be[me];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(Pe,G.key,G)}}function S(Pe,be,me){return be&&e(Pe.prototype,be),me&&e(Pe,me),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function M(Pe,be){if(Pe){if(typeof Pe=="string")return I(Pe,be);var me=Object.prototype.toString.call(Pe).slice(8,-1);if(me==="Object"&&Pe.constructor&&(me=Pe.constructor.name),me==="Map"||me==="Set")return Array.from(Pe);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return I(Pe,be)}}function I(Pe,be){(be==null||be>Pe.length)&&(be=Pe.length);for(var me=0,G=new Array(be);me<be;me++)G[me]=Pe[me];return G}function A(Pe,be){var me=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(me)return(me=me.call(Pe)).next.bind(me);if(Array.isArray(Pe)||(me=M(Pe))||be&&Pe&&typeof Pe.length=="number"){me&&(Pe=me);var G=0;return function(){return G>=Pe.length?{done:!0}:{done:!1,value:Pe[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=R();function m(Pe){fe.defaults=Pe}var f=/[&<>"']/,D=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},$=function(be){return l[be]};function w(Pe,be){if(be){if(f.test(Pe))return Pe.replace(D,$)}else if(L.test(Pe))return Pe.replace(k,$);return Pe}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Pe){return Pe.replace(r,function(be,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(Pe,be){Pe=typeof Pe=="string"?Pe:Pe.source,be=be||"";var me={replace:function(_,le){return le=le.source||le,le=le.replace(s,"$1"),Pe=Pe.replace(_,le),me},getRegex:function(){return new RegExp(Pe,be)}};return me}var o=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(Pe,be,me){if(Pe){var G;try{G=decodeURIComponent(c(me)).replace(o,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}be&&!a.test(me)&&(me=E(be,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var t={},d=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,b=/^([^:]+:\/*[^/]*)[\s\S]*$/;function E(Pe,be){t[" "+Pe]||(d.test(Pe)?t[" "+Pe]=Pe+"/":t[" "+Pe]=g(Pe,"/",!0)),Pe=t[" "+Pe];var me=Pe.indexOf(":")===-1;return be.substring(0,2)==="//"?me?be:Pe.replace(n,"$1")+be:be.charAt(0)==="/"?me?be:Pe.replace(b,"$1")+be:Pe+be}var h={exec:function(){}};function v(Pe){for(var be=1,me,G;be<arguments.length;be++){me=arguments[be];for(G in me)Object.prototype.hasOwnProperty.call(me,G)&&(Pe[G]=me[G])}return Pe}function P(Pe,be){var me=Pe.replace(/\|/g,function(le,de,Le){for(var ge=!1,ke=de;--ke>=0&&Le[ke]==="\\";)ge=!ge;return ge?"|":" |"}),G=me.split(/ \|/),_=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>be)G.splice(be);else for(;G.length<be;)G.push("");for(;_<G.length;_++)G[_]=G[_].trim().replace(/\\\|/g,"|");return G}function g(Pe,be,me){var G=Pe.length;if(G===0)return"";for(var _=0;_<G;){var le=Pe.charAt(G-_-1);if(le===be&&!me)_++;else if(le!==be&&me)_++;else break}return Pe.slice(0,G-_)}function p(Pe,be){if(Pe.indexOf(be[1])===-1)return-1;for(var me=Pe.length,G=0,_=0;_<me;_++)if(Pe[_]==="\\")_++;else if(Pe[_]===be[0])G++;else if(Pe[_]===be[1]&&(G--,G<0))return _;return-1}function y(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(Pe,be){if(be<1)return"";for(var me="";be>1;)be&1&&(me+=Pe),be>>=1,Pe+=Pe;return me+Pe}function N(Pe,be,me,G){var _=be.href,le=be.title?w(be.title):null,de=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){G.state.inLink=!0;var Le={type:"link",raw:me,href:_,title:le,text:de,tokens:G.inlineTokens(de)};return G.state.inLink=!1,Le}return{type:"image",raw:me,href:_,title:le,text:w(de)}}function J(Pe,be){var me=Pe.match(/^(\s+)(?:```)/);if(me===null)return be;var G=me[1];return be.split(`
`).map(function(_){var le=_.match(/^\s+/);if(le===null)return _;var de=le[0];return de.length>=G.length?_.slice(G.length):_}).join(`
`)}var q=function(){function Pe(me){this.options=me||fe.defaults}var be=Pe.prototype;return be.space=function(G){var _=this.rules.block.newline.exec(G);if(_&&_[0].length>0)return{type:"space",raw:_[0]}},be.code=function(G){var _=this.rules.block.code.exec(G);if(_){var le=_[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:_[0],codeBlockStyle:"indented",text:this.options.pedantic?le:g(le,`
`)}}},be.fences=function(G){var _=this.rules.block.fences.exec(G);if(_){var le=_[0],de=J(le,_[3]||"");return{type:"code",raw:le,lang:_[2]?_[2].trim():_[2],text:de}}},be.heading=function(G){var _=this.rules.block.heading.exec(G);if(_){var le=_[2].trim();if(/#$/.test(le)){var de=g(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:_[0],depth:_[1].length,text:le,tokens:this.lexer.inline(le)}}},be.hr=function(G){var _=this.rules.block.hr.exec(G);if(_)return{type:"hr",raw:_[0]}},be.blockquote=function(G){var _=this.rules.block.blockquote.exec(G);if(_){var le=_[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:_[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},be.list=function(G){var _=this.rules.block.list.exec(G);if(_){var le,de,Le,ge,ke,Ie,O,K,j,H,Q,oe,Ee=_[1].trim(),Be=Ee.length>1,We={type:"list",raw:"",ordered:Be,start:Be?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Be?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Be?Ee:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(oe=!1,!(!(_=Ze.exec(G))||this.rules.block.hr.test(G)));){if(le=_[0],G=G.substring(le.length),K=_[2].split(`
`,1)[0],j=G.split(`
`,1)[0],this.options.pedantic?(ge=2,Q=K.trimLeft()):(ge=_[2].search(/[^ ]/),ge=ge>4?1:ge,Q=K.slice(ge),ge+=_[1].length),Ie=!1,!K&&/^ *$/.test(j)&&(le+=j+`
`,G=G.substring(j.length+1),oe=!0),!oe)for(var _e=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),at=new RegExp("^ {0,"+Math.min(3,ge-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,ge-1)+"}#");G&&(H=G.split(`
`,1)[0],K=H,this.options.pedantic&&(K=K.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(K)||et.test(K)||_e.test(K)||at.test(G)));){if(K.search(/[^ ]/)>=ge||!K.trim())Q+=`
`+K.slice(ge);else if(!Ie)Q+=`
`+K;else break;!Ie&&!K.trim()&&(Ie=!0),le+=H+`
`,G=G.substring(H.length+1)}We.loose||(O?We.loose=!0:/\n *\n *$/.test(le)&&(O=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(Q),de&&(Le=de[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:le,task:!!de,checked:Le,loose:!1,text:Q}),We.raw+=le}We.items[We.items.length-1].raw=le.trimRight(),We.items[We.items.length-1].text=Q.trimRight(),We.raw=We.raw.trimRight();var ct=We.items.length;for(ke=0;ke<ct;ke++){this.lexer.state.top=!1,We.items[ke].tokens=this.lexer.blockTokens(We.items[ke].text,[]);var Ue=We.items[ke].tokens.filter(function(Z){return Z.type==="space"}),vt=Ue.every(function(Z){for(var x=Z.raw.split(""),pe=0,Ve=A(x),Ye;!(Ye=Ve()).done;){var it=Ye.value;if(it===`
`&&(pe+=1),pe>1)return!0}return!1});!We.loose&&Ue.length&&vt&&(We.loose=!0,We.items[ke].loose=!0)}return We}},be.html=function(G){var _=this.rules.block.html.exec(G);if(_){var le={type:"html",raw:_[0],pre:!this.options.sanitizer&&(_[1]==="pre"||_[1]==="script"||_[1]==="style"),text:_[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(_[0]):w(_[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},be.def=function(G){var _=this.rules.block.def.exec(G);if(_){_[3]&&(_[3]=_[3].substring(1,_[3].length-1));var le=_[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:_[0],href:_[2],title:_[3]}}},be.table=function(G){var _=this.rules.block.table.exec(G);if(_){var le={type:"table",header:P(_[1]).map(function(O){return{text:O}}),align:_[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:_[3]&&_[3].trim()?_[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=_[0];var de=le.align.length,Le,ge,ke,Ie;for(Le=0;Le<de;Le++)/^ *-+: *$/.test(le.align[Le])?le.align[Le]="right":/^ *:-+: *$/.test(le.align[Le])?le.align[Le]="center":/^ *:-+ *$/.test(le.align[Le])?le.align[Le]="left":le.align[Le]=null;for(de=le.rows.length,Le=0;Le<de;Le++)le.rows[Le]=P(le.rows[Le],le.header.length).map(function(O){return{text:O}});for(de=le.header.length,ge=0;ge<de;ge++)le.header[ge].tokens=this.lexer.inline(le.header[ge].text);for(de=le.rows.length,ge=0;ge<de;ge++)for(Ie=le.rows[ge],ke=0;ke<Ie.length;ke++)Ie[ke].tokens=this.lexer.inline(Ie[ke].text);return le}}},be.lheading=function(G){var _=this.rules.block.lheading.exec(G);if(_)return{type:"heading",raw:_[0],depth:_[2].charAt(0)==="="?1:2,text:_[1],tokens:this.lexer.inline(_[1])}},be.paragraph=function(G){var _=this.rules.block.paragraph.exec(G);if(_){var le=_[1].charAt(_[1].length-1)===`
`?_[1].slice(0,-1):_[1];return{type:"paragraph",raw:_[0],text:le,tokens:this.lexer.inline(le)}}},be.text=function(G){var _=this.rules.block.text.exec(G);if(_)return{type:"text",raw:_[0],text:_[0],tokens:this.lexer.inline(_[0])}},be.escape=function(G){var _=this.rules.inline.escape.exec(G);if(_)return{type:"escape",raw:_[0],text:w(_[1])}},be.tag=function(G){var _=this.rules.inline.tag.exec(G);if(_)return!this.lexer.state.inLink&&/^<a /i.test(_[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(_[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(_[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(_[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:_[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(_[0]):w(_[0]):_[0]}},be.link=function(G){var _=this.rules.inline.link.exec(G);if(_){var le=_[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=g(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Le=p(_[2],"()");if(Le>-1){var ge=_[0].indexOf("!")===0?5:4,ke=ge+_[1].length+Le;_[2]=_[2].substring(0,Le),_[0]=_[0].substring(0,ke).trim(),_[3]=""}}var Ie=_[2],O="";if(this.options.pedantic){var K=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);K&&(Ie=K[1],O=K[3])}else O=_[3]?_[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(le)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),N(_,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:O&&O.replace(this.rules.inline._escapes,"$1")},_[0],this.lexer)}},be.reflink=function(G,_){var le;if((le=this.rules.inline.reflink.exec(G))||(le=this.rules.inline.nolink.exec(G))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=_[de.toLowerCase()],!de||!de.href){var Le=le[0].charAt(0);return{type:"text",raw:Le,text:Le}}return N(le,de,le[0],this.lexer)}},be.emStrong=function(G,_,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(G);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Le=de[1]||de[2]||"";if(!Le||Le&&(le===""||this.rules.inline.punctuation.exec(le))){var ge=de[0].length-1,ke,Ie,O=ge,K=0,j=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,_=_.slice(-1*G.length+ge);(de=j.exec(_))!=null;)if(ke=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!ke){if(Ie=ke.length,de[3]||de[4]){O+=Ie;continue}else if((de[5]||de[6])&&ge%3&&!((ge+Ie)%3)){K+=Ie;continue}if(O-=Ie,!(O>0)){if(Ie=Math.min(Ie,Ie+O+K),Math.min(ge,Ie)%2){var H=G.slice(1,ge+de.index+Ie);return{type:"em",raw:G.slice(0,ge+de.index+Ie+1),text:H,tokens:this.lexer.inlineTokens(H)}}var Q=G.slice(2,ge+de.index+Ie-1);return{type:"strong",raw:G.slice(0,ge+de.index+Ie+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},be.codespan=function(G){var _=this.rules.inline.code.exec(G);if(_){var le=_[2].replace(/\n/g," "),de=/[^ ]/.test(le),Le=/^ /.test(le)&&/ $/.test(le);return de&&Le&&(le=le.substring(1,le.length-1)),le=w(le,!0),{type:"codespan",raw:_[0],text:le}}},be.br=function(G){var _=this.rules.inline.br.exec(G);if(_)return{type:"br",raw:_[0]}},be.del=function(G){var _=this.rules.inline.del.exec(G);if(_)return{type:"del",raw:_[0],text:_[2],tokens:this.lexer.inlineTokens(_[2])}},be.autolink=function(G,_){var le=this.rules.inline.autolink.exec(G);if(le){var de,Le;return le[2]==="@"?(de=w(this.options.mangle?_(le[1]):le[1]),Le="mailto:"+de):(de=w(le[1]),Le=de),{type:"link",raw:le[0],text:de,href:Le,tokens:[{type:"text",raw:de,text:de}]}}},be.url=function(G,_){var le;if(le=this.rules.inline.url.exec(G)){var de,Le;if(le[2]==="@")de=w(this.options.mangle?_(le[0]):le[0]),Le="mailto:"+de;else{var ge;do ge=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(ge!==le[0]);de=w(le[0]),le[1]==="www."?Le="http://"+de:Le=de}return{type:"link",raw:le[0],text:de,href:Le,tokens:[{type:"text",raw:de,text:de}]}}},be.inlineText=function(G,_){var le=this.rules.inline.text.exec(G);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):w(le[0]):le[0]:de=w(this.options.smartypants?_(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},Pe}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=i(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=i(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=i(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=i(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=i(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=v({},U),U.gfm=v({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=i(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=v({},U.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=i(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=i(U._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=i(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=i(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=i(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=i(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=i(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=i(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=i(C.reflink).replace("label",C._label).replace("ref",U._label).getRegex(),C.nolink=i(C.nolink).replace("ref",U._label).getRegex(),C.reflinkSearch=i(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=v({},C),C.pedantic=v({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=v({},C.normal,{escape:i(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=i(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=v({},C.gfm,{br:i(C.br).replace("{2,}","*").getRegex(),text:i(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Pe){var be="",me,G,_=Pe.length;for(me=0;me<_;me++)G=Pe.charCodeAt(me),Math.random()>.5&&(G="x"+G.toString(16)),be+="&#"+G+";";return be}var re=function(){function Pe(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||fe.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:U.normal,inline:C.normal};this.options.pedantic?(G.block=U.pedantic,G.inline=C.pedantic):this.options.gfm&&(G.block=U.gfm,this.options.breaks?G.inline=C.breaks:G.inline=C.gfm),this.tokenizer.rules=G}Pe.lex=function(G,_){var le=new Pe(_);return le.lex(G)},Pe.lexInline=function(G,_){var le=new Pe(_);return le.inlineTokens(G)};var be=Pe.prototype;return be.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var _;_=this.inlineQueue.shift();)this.inlineTokens(_.src,_.tokens);return this.tokens},be.blockTokens=function(G,_){var le=this;_===void 0&&(_=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(O,K,j){return K+"    ".repeat(j.length)});for(var de,Le,ge,ke;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(O){return(de=O.call({lexer:le},G,_))?(G=G.substring(de.raw.length),_.push(de),!0):!1}))){if(de=this.tokenizer.space(G)){G=G.substring(de.raw.length),de.raw.length===1&&_.length>0?_[_.length-1].raw+=`
`:_.push(de);continue}if(de=this.tokenizer.code(G)){G=G.substring(de.raw.length),Le=_[_.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+de.raw,Le.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):_.push(de);continue}if(de=this.tokenizer.fences(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.heading(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.hr(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.blockquote(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.list(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.html(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.def(G)){G=G.substring(de.raw.length),Le=_[_.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+de.raw,Le.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.lheading(G)){G=G.substring(de.raw.length),_.push(de);continue}if(ge=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var O=1/0,K=G.slice(1),j=void 0;le.options.extensions.startBlock.forEach(function(H){j=H.call({lexer:this},K),typeof j=="number"&&j>=0&&(O=Math.min(O,j))}),O<1/0&&O>=0&&(ge=G.substring(0,O+1))}(),this.state.top&&(de=this.tokenizer.paragraph(ge))){Le=_[_.length-1],ke&&Le.type==="paragraph"?(Le.raw+=`
`+de.raw,Le.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):_.push(de),ke=ge.length!==G.length,G=G.substring(de.raw.length);continue}if(de=this.tokenizer.text(G)){G=G.substring(de.raw.length),Le=_[_.length-1],Le&&Le.type==="text"?(Le.raw+=`
`+de.raw,Le.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):_.push(de);continue}if(G){var Ie="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,_},be.inline=function(G,_){return _===void 0&&(_=[]),this.inlineQueue.push({src:G,tokens:_}),_},be.inlineTokens=function(G,_){var le=this;_===void 0&&(_=[]);var de,Le,ge,ke=G,Ie,O,K;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)j.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ie.index)+"["+T("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"["+T("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(O||(K=""),O=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return(de=Q.call({lexer:le},G,_))?(G=G.substring(de.raw.length),_.push(de),!0):!1}))){if(de=this.tokenizer.escape(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.tag(G)){G=G.substring(de.raw.length),Le=_[_.length-1],Le&&de.type==="text"&&Le.type==="text"?(Le.raw+=de.raw,Le.text+=de.text):_.push(de);continue}if(de=this.tokenizer.link(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(de.raw.length),Le=_[_.length-1],Le&&de.type==="text"&&Le.type==="text"?(Le.raw+=de.raw,Le.text+=de.text):_.push(de);continue}if(de=this.tokenizer.emStrong(G,ke,K)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.codespan(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.br(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.del(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.autolink(G,W)){G=G.substring(de.raw.length),_.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(G,W))){G=G.substring(de.raw.length),_.push(de);continue}if(ge=G,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,oe=G.slice(1),Ee=void 0;le.options.extensions.startInline.forEach(function(Be){Ee=Be.call({lexer:this},oe),typeof Ee=="number"&&Ee>=0&&(Q=Math.min(Q,Ee))}),Q<1/0&&Q>=0&&(ge=G.substring(0,Q+1))}(),de=this.tokenizer.inlineText(ge,F)){G=G.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(K=de.raw.slice(-1)),O=!0,Le=_[_.length-1],Le&&Le.type==="text"?(Le.raw+=de.raw,Le.text+=de.text):_.push(de);continue}if(G){var H="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return _},S(Pe,null,[{key:"rules",get:function(){return{block:U,inline:C}}}]),Pe}(),ce=function(){function Pe(me){this.options=me||fe.defaults}var be=Pe.prototype;return be.code=function(G,_,le){var de=(_||"").match(/\S*/)[0];if(this.options.highlight){var Le=this.options.highlight(G,de);Le!=null&&Le!==G&&(le=!0,G=Le)}return G=G.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+w(de,!0)+'">'+(le?G:w(G,!0))+`</code></pre>
`:"<pre><code>"+(le?G:w(G,!0))+`</code></pre>
`},be.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},be.html=function(G){return G},be.heading=function(G,_,le,de){if(this.options.headerIds){var Le=this.options.headerPrefix+de.slug(le);return"<h"+_+' id="'+Le+'">'+G+"</h"+_+`>
`}return"<h"+_+">"+G+"</h"+_+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(G,_,le){var de=_?"ol":"ul",Le=_&&le!==1?' start="'+le+'"':"";return"<"+de+Le+`>
`+G+"</"+de+`>
`},be.listitem=function(G){return"<li>"+G+`</li>
`},be.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(G){return"<p>"+G+`</p>
`},be.table=function(G,_){return _&&(_="<tbody>"+_+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+_+`</table>
`},be.tablerow=function(G){return`<tr>
`+G+`</tr>
`},be.tablecell=function(G,_){var le=_.header?"th":"td",de=_.align?"<"+le+' align="'+_.align+'">':"<"+le+">";return de+G+("</"+le+`>
`)},be.strong=function(G){return"<strong>"+G+"</strong>"},be.em=function(G){return"<em>"+G+"</em>"},be.codespan=function(G){return"<code>"+G+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(G){return"<del>"+G+"</del>"},be.link=function(G,_,le){if(G=u(this.options.sanitize,this.options.baseUrl,G),G===null)return le;var de='<a href="'+w(G)+'"';return _&&(de+=' title="'+_+'"'),de+=">"+le+"</a>",de},be.image=function(G,_,le){if(G=u(this.options.sanitize,this.options.baseUrl,G),G===null)return le;var de='<img src="'+G+'" alt="'+le+'"';return _&&(de+=' title="'+_+'"'),de+=this.options.xhtml?"/>":">",de},be.text=function(G){return G},Pe}(),we=function(){function Pe(){}var be=Pe.prototype;return be.strong=function(G){return G},be.em=function(G){return G},be.codespan=function(G){return G},be.del=function(G){return G},be.html=function(G){return G},be.text=function(G){return G},be.link=function(G,_,le){return""+le},be.image=function(G,_,le){return""+le},be.br=function(){return""},Pe}(),De=function(){function Pe(){this.seen={}}var be=Pe.prototype;return be.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(G,_){var le=G,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[G];do de++,le=G+"-"+de;while(this.seen.hasOwnProperty(le))}return _||(this.seen[G]=de,this.seen[le]=0),le},be.slug=function(G,_){_===void 0&&(_={});var le=this.serialize(G);return this.getNextSafeSlug(le,_.dryrun)},Pe}(),he=function(){function Pe(me){this.options=me||fe.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new De}Pe.parse=function(G,_){var le=new Pe(_);return le.parse(G)},Pe.parseInline=function(G,_){var le=new Pe(_);return le.parseInline(G)};var be=Pe.prototype;return be.parse=function(G,_){_===void 0&&(_=!0);var le="",de,Le,ge,ke,Ie,O,K,j,H,Q,oe,Ee,Be,We,Ze,_e,at,rt,et,ct=G.length;for(de=0;de<ct;de++){if(Q=G[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(et=this.options.extensions.renderers[Q.type].call({parser:this},Q),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){le+=et||"";continue}switch(Q.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,c(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for(j="",K="",ke=Q.header.length,Le=0;Le<ke;Le++)K+=this.renderer.tablecell(this.parseInline(Q.header[Le].tokens),{header:!0,align:Q.align[Le]});for(j+=this.renderer.tablerow(K),H="",ke=Q.rows.length,Le=0;Le<ke;Le++){for(O=Q.rows[Le],K="",Ie=O.length,ge=0;ge<Ie;ge++)K+=this.renderer.tablecell(this.parseInline(O[ge].tokens),{header:!1,align:Q.align[ge]});H+=this.renderer.tablerow(K)}le+=this.renderer.table(j,H);continue}case"blockquote":{H=this.parse(Q.tokens),le+=this.renderer.blockquote(H);continue}case"list":{for(oe=Q.ordered,Ee=Q.start,Be=Q.loose,ke=Q.items.length,H="",Le=0;Le<ke;Le++)Ze=Q.items[Le],_e=Ze.checked,at=Ze.task,We="",Ze.task&&(rt=this.renderer.checkbox(_e),Be?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=rt+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=rt+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:rt}):We+=rt),We+=this.parse(Ze.tokens,Be),H+=this.renderer.listitem(We,at,_e);le+=this.renderer.list(H,oe,Ee);continue}case"html":{le+=this.renderer.html(Q.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(H=Q.tokens?this.parseInline(Q.tokens):Q.text;de+1<ct&&G[de+1].type==="text";)Q=G[++de],H+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);le+=_?this.renderer.paragraph(H):H;continue}default:{var Ue='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Ue);return}else throw new Error(Ue)}}}return le},be.parseInline=function(G,_){_=_||this.renderer;var le="",de,Le,ge,ke=G.length;for(de=0;de<ke;de++){if(Le=G[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Le.type]&&(ge=this.options.extensions.renderers[Le.type].call({parser:this},Le),ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Le.type))){le+=ge||"";continue}switch(Le.type){case"escape":{le+=_.text(Le.text);break}case"html":{le+=_.html(Le.text);break}case"link":{le+=_.link(Le.href,Le.title,this.parseInline(Le.tokens,_));break}case"image":{le+=_.image(Le.href,Le.title,Le.text);break}case"strong":{le+=_.strong(this.parseInline(Le.tokens,_));break}case"em":{le+=_.em(this.parseInline(Le.tokens,_));break}case"codespan":{le+=_.codespan(Le.text);break}case"br":{le+=_.br();break}case"del":{le+=_.del(this.parseInline(Le.tokens,_));break}case"text":{le+=_.text(Le.text);break}default:{var Ie='Token with "'+Le.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return le},Pe}();function ve(Pe,be,me){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof be=="function"&&(me=be,be=null),be=v({},ve.defaults,be||{}),y(be),me){var G=be.highlight,_;try{_=re.lex(Pe,be)}catch(ke){return me(ke)}var le=function(Ie){var O;if(!Ie)try{be.walkTokens&&ve.walkTokens(_,be.walkTokens),O=he.parse(_,be)}catch(K){Ie=K}return be.highlight=G,Ie?me(Ie):me(null,O)};if(!G||G.length<3||(delete be.highlight,!_.length))return le();var de=0;ve.walkTokens(_,function(ke){ke.type==="code"&&(de++,setTimeout(function(){G(ke.text,ke.lang,function(Ie,O){if(Ie)return le(Ie);O!=null&&O!==ke.text&&(ke.text=O,ke.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Le(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+w(ke.message+"",!0)+"</pre>";throw ke}try{var ge=re.lex(Pe,be);if(be.walkTokens){if(be.async)return Promise.all(ve.walkTokens(ge,be.walkTokens)).then(function(){return he.parse(ge,be)}).catch(Le);ve.walkTokens(ge,be.walkTokens)}return he.parse(ge,be)}catch(ke){Le(ke)}}ve.options=ve.setOptions=function(Pe){return v(ve.defaults,Pe),m(ve.defaults),ve},ve.getDefaults=R,ve.defaults=fe.defaults,ve.use=function(){for(var Pe=arguments.length,be=new Array(Pe),me=0;me<Pe;me++)be[me]=arguments[me];var G=v.apply(void 0,[{}].concat(be)),_=ve.defaults.extensions||{renderers:{},childTokens:{}},le;be.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(ge){if(!ge.name)throw new Error("extension name required");if(ge.renderer){var ke=_.renderers?_.renderers[ge.name]:null;ke?_.renderers[ge.name]=function(){for(var Ie=arguments.length,O=new Array(Ie),K=0;K<Ie;K++)O[K]=arguments[K];var j=ge.renderer.apply(this,O);return j===!1&&(j=ke.apply(this,O)),j}:_.renderers[ge.name]=ge.renderer}if(ge.tokenizer){if(!ge.level||ge.level!=="block"&&ge.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");_[ge.level]?_[ge.level].unshift(ge.tokenizer):_[ge.level]=[ge.tokenizer],ge.start&&(ge.level==="block"?_.startBlock?_.startBlock.push(ge.start):_.startBlock=[ge.start]:ge.level==="inline"&&(_.startInline?_.startInline.push(ge.start):_.startInline=[ge.start]))}ge.childTokens&&(_.childTokens[ge.name]=ge.childTokens)})),de.renderer&&function(){var ge=ve.defaults.renderer||new ce,ke=function(K){var j=ge[K];ge[K]=function(){for(var H=arguments.length,Q=new Array(H),oe=0;oe<H;oe++)Q[oe]=arguments[oe];var Ee=de.renderer[K].apply(ge,Q);return Ee===!1&&(Ee=j.apply(ge,Q)),Ee}};for(var Ie in de.renderer)ke(Ie);G.renderer=ge}(),de.tokenizer&&function(){var ge=ve.defaults.tokenizer||new q,ke=function(K){var j=ge[K];ge[K]=function(){for(var H=arguments.length,Q=new Array(H),oe=0;oe<H;oe++)Q[oe]=arguments[oe];var Ee=de.tokenizer[K].apply(ge,Q);return Ee===!1&&(Ee=j.apply(ge,Q)),Ee}};for(var Ie in de.tokenizer)ke(Ie);G.tokenizer=ge}(),de.walkTokens){var Le=ve.defaults.walkTokens;G.walkTokens=function(ge){var ke=[];return ke.push(de.walkTokens.call(this,ge)),Le&&(ke=ke.concat(Le.call(this,ge))),ke}}le&&(G.extensions=_),ve.setOptions(G)})},ve.walkTokens=function(Pe,be){for(var me=[],G=function(){var Le=le.value;switch(me=me.concat(be.call(ve,Le)),Le.type){case"table":{for(var ge=A(Le.header),ke;!(ke=ge()).done;){var Ie=ke.value;me=me.concat(ve.walkTokens(Ie.tokens,be))}for(var O=A(Le.rows),K;!(K=O()).done;)for(var j=K.value,H=A(j),Q;!(Q=H()).done;){var oe=Q.value;me=me.concat(ve.walkTokens(oe.tokens,be))}break}case"list":{me=me.concat(ve.walkTokens(Le.items,be));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Le.type]?ve.defaults.extensions.childTokens[Le.type].forEach(function(Ee){me=me.concat(ve.walkTokens(Le[Ee],be))}):Le.tokens&&(me=me.concat(ve.walkTokens(Le.tokens,be)))}},_=A(Pe),le;!(le=_()).done;)G();return me},ve.parseInline=function(Pe,be){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");be=v({},ve.defaults,be||{}),y(be);try{var me=re.lexInline(Pe,be);return be.walkTokens&&ve.walkTokens(me,be.walkTokens),he.parseInline(me,be)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+w(G.message+"",!0)+"</pre>";throw G}},ve.Parser=he,ve.parser=he.parse,ve.Renderer=ce,ve.TextRenderer=we,ve.Lexer=re,ve.lexer=re.lex,ve.Tokenizer=q,ve.Slugger=De,ve.parse=ve;var se=ve.options,$e=ve.setOptions,te=ve.use,X=ve.walkTokens,V=ve.parseInline,ie=ve,Ce=he.parse,Te=re.lex;fe.Lexer=re,fe.Parser=he,fe.Renderer=ce,fe.Slugger=De,fe.TextRenderer=we,fe.Tokenizer=q,fe.getDefaults=R,fe.lexer=Te,fe.marked=ve,fe.options=se,fe.parse=ie,fe.parseInline=V,fe.parser=Ce,fe.setOptions=$e,fe.use=te,fe.walkTokens=X,Object.defineProperty(fe,"__esModule",{value:!0})}),define(Ae[122],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=void 0;function S(r){const c=A(r);if(c&&c.length>0)return new Uint32Array(c)}e.$Tj=S;let M=0;const I=new Uint32Array(10);function A(r){if(M=0,R(r,k,4352),M>0||(R(r,l,4449),M>0)||(R(r,$,4520),M>0)||(R(r,w,12593),M))return I.subarray(0,M);if(r>=44032&&r<=55203){const c=r-44032,s=c%588,i=Math.floor(c/588),o=Math.floor(s/28),a=s%28-1;if(i<k.length?R(i,k,0):4352+i-12593<w.length&&R(4352+i,w,12593),o<l.length?R(o,l,0):4449+o-12593<w.length&&R(4449+o-12593,w,12593),a>=0&&(a<$.length?R(a,$,0):4520+a-12593<w.length&&R(4520+a-12593,w,12593)),M>0)return I.subarray(0,M)}}function R(r,c,s){r>=s&&r<s+c.length&&m(c[r-s])}function m(r){r!==0&&(I[M++]=r&255,r>>8&&(I[M++]=r>>8&255),r>>16&&(I[M++]=r>>16&255))}var f;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var D;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(D||(D={}));var L;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(L||(L={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),$=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),w=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ae[123],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function S(m,f,D){return Math.min(Math.max(m,f),D)}e.$9l=S;function M(m,f){return(f+m%f)%f}e.rot=M;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=I;class A{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=A;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const D=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=R}),function(){function fe(I){const A=[];typeof I=="number"&&A.push("code/timeOrigin",I);function R(f){A.push(f,Date.now())}function m(){const f=[];for(let D=0;D<A.length;D+=2)f.push({name:A[D],startTime:A[D+1]});return f}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(I+R.startTime)});return A}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function S(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=S(M))}(),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var M in S)(typeof exports=="object"?exports:fe)[M]=S[M]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function S(M){if(e[M])return e[M].exports;var I=e[M]={i:M,l:!1,exports:{}};return fe[M].call(I.exports,I,I.exports,S),I.l=!0,I.exports}return S.m=fe,S.c=e,S.d=function(M,I,A){S.o(M,I)||Object.defineProperty(M,I,{enumerable:!0,get:A})},S.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},S.t=function(M,I){if(1&I&&(M=S(M)),8&I||4&I&&typeof M=="object"&&M&&M.__esModule)return M;var A=Object.create(null);if(S.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:M}),2&I&&typeof M!="string")for(var R in M)S.d(A,R,function(m){return M[m]}.bind(null,R));return A},S.n=function(M){var I=M&&M.__esModule?function(){return M.default}:function(){return M};return S.d(I,"a",I),I},S.o=function(M,I){return Object.prototype.hasOwnProperty.call(M,I)},S.p="",S(S.s=0)}([function(fe,e,S){(function(M){var I;e=fe.exports=te,I=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],f=e.src=[],D=0,L=D++;f[L]="0|[1-9]\\d*";var k=D++;f[k]="[0-9]+";var l=D++;f[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=D++;f[$]="("+f[L]+")\\.("+f[L]+")\\.("+f[L]+")";var w=D++;f[w]="("+f[k]+")\\.("+f[k]+")\\.("+f[k]+")";var r=D++;f[r]="(?:"+f[L]+"|"+f[l]+")";var c=D++;f[c]="(?:"+f[k]+"|"+f[l]+")";var s=D++;f[s]="(?:-("+f[r]+"(?:\\."+f[r]+")*))";var i=D++;f[i]="(?:-?("+f[c]+"(?:\\."+f[c]+")*))";var o=D++;f[o]="[0-9A-Za-z-]+";var a=D++;f[a]="(?:\\+("+f[o]+"(?:\\."+f[o]+")*))";var u=D++,t="v?"+f[$]+f[s]+"?"+f[a]+"?";f[u]="^"+t+"$";var d="[v=\\s]*"+f[w]+f[i]+"?"+f[a]+"?",n=D++;f[n]="^"+d+"$";var b=D++;f[b]="((?:<|>)?=?)";var E=D++;f[E]=f[k]+"|x|X|\\*";var h=D++;f[h]=f[L]+"|x|X|\\*";var v=D++;f[v]="[v=\\s]*("+f[h]+")(?:\\.("+f[h]+")(?:\\.("+f[h]+")(?:"+f[s]+")?"+f[a]+"?)?)?";var P=D++;f[P]="[v=\\s]*("+f[E]+")(?:\\.("+f[E]+")(?:\\.("+f[E]+")(?:"+f[i]+")?"+f[a]+"?)?)?";var g=D++;f[g]="^"+f[b]+"\\s*"+f[v]+"$";var p=D++;f[p]="^"+f[b]+"\\s*"+f[P]+"$";var y=D++;f[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=D++;f[T]="(?:~>?)";var N=D++;f[N]="(\\s*)"+f[T]+"\\s+",m[N]=new RegExp(f[N],"g");var J=D++;f[J]="^"+f[T]+f[v]+"$";var q=D++;f[q]="^"+f[T]+f[P]+"$";var U=D++;f[U]="(?:\\^)";var C=D++;f[C]="(\\s*)"+f[U]+"\\s+",m[C]=new RegExp(f[C],"g");var F=D++;f[F]="^"+f[U]+f[v]+"$";var W=D++;f[W]="^"+f[U]+f[P]+"$";var re=D++;f[re]="^"+f[b]+"\\s*("+d+")$|^$";var ce=D++;f[ce]="^"+f[b]+"\\s*("+t+")$|^$";var we=D++;f[we]="(\\s*)"+f[b]+"\\s*("+d+"|"+f[v]+")",m[we]=new RegExp(f[we],"g");var De=D++;f[De]="^\\s*("+f[v]+")\\s+-\\s+("+f[v]+")\\s*$";var he=D++;f[he]="^\\s*("+f[P]+")\\s+-\\s+("+f[P]+")\\s*$";var ve=D++;f[ve]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)I(se,f[se]),m[se]||(m[se]=new RegExp(f[se]));function $e(j,H){if(j instanceof te)return j;if(typeof j!="string"||j.length>A||!(H?m[n]:m[u]).test(j))return null;try{return new te(j,H)}catch{return null}}function te(j,H){if(j instanceof te){if(j.loose===H)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof te))return new te(j,H);I("SemVer",j,H),this.loose=H;var Q=j.trim().match(H?m[n]:m[u]);if(!Q)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(oe){if(/^[0-9]+$/.test(oe)){var Ee=+oe;if(Ee>=0&&Ee<R)return Ee}return oe}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=$e,e.valid=function(j,H){var Q=$e(j,H);return Q?Q.version:null},e.clean=function(j,H){var Q=$e(j.trim().replace(/^[=v]+/,""),H);return Q?Q.version:null},e.SemVer=te,te.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},te.prototype.toString=function(){return this.version},te.prototype.compare=function(j){return I("SemVer.compare",this.version,this.loose,j),j instanceof te||(j=new te(j,this.loose)),this.compareMain(j)||this.comparePre(j)},te.prototype.compareMain=function(j){return j instanceof te||(j=new te(j,this.loose)),V(this.major,j.major)||V(this.minor,j.minor)||V(this.patch,j.patch)},te.prototype.comparePre=function(j){if(j instanceof te||(j=new te(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var H=0;do{var Q=this.prerelease[H],oe=j.prerelease[H];if(I("prerelease compare",H,Q,oe),Q===void 0&&oe===void 0)return 0;if(oe===void 0)return 1;if(Q===void 0)return-1;if(Q!==oe)return V(Q,oe)}while(++H)},te.prototype.inc=function(j,H){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,H,Q,oe){typeof Q=="string"&&(oe=Q,Q=void 0);try{return new te(j,Q).inc(H,oe).version}catch{return null}},e.diff=function(j,H){if(Pe(j,H))return null;var Q=$e(j),oe=$e(H);if(Q.prerelease.length||oe.prerelease.length){for(var Ee in Q)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Q[Ee]!==oe[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in Q)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Q[Ee]!==oe[Ee])return Ee},e.compareIdentifiers=V;var X=/^[0-9]+$/;function V(j,H){var Q=X.test(j),oe=X.test(H);return Q&&oe&&(j=+j,H=+H),Q&&!oe?-1:oe&&!Q?1:j<H?-1:j>H?1:0}function ie(j,H,Q){return new te(j,Q).compare(new te(H,Q))}function Ce(j,H,Q){return ie(j,H,Q)>0}function Te(j,H,Q){return ie(j,H,Q)<0}function Pe(j,H,Q){return ie(j,H,Q)===0}function be(j,H,Q){return ie(j,H,Q)!==0}function me(j,H,Q){return ie(j,H,Q)>=0}function G(j,H,Q){return ie(j,H,Q)<=0}function _(j,H,Q,oe){var Ee;switch(H){case"===":typeof j=="object"&&(j=j.version),typeof Q=="object"&&(Q=Q.version),Ee=j===Q;break;case"!==":typeof j=="object"&&(j=j.version),typeof Q=="object"&&(Q=Q.version),Ee=j!==Q;break;case"":case"=":case"==":Ee=Pe(j,Q,oe);break;case"!=":Ee=be(j,Q,oe);break;case">":Ee=Ce(j,Q,oe);break;case">=":Ee=me(j,Q,oe);break;case"<":Ee=Te(j,Q,oe);break;case"<=":Ee=G(j,Q,oe);break;default:throw new TypeError("Invalid operator: "+H)}return Ee}function le(j,H){if(j instanceof le){if(j.loose===H)return j;j=j.value}if(!(this instanceof le))return new le(j,H);I("comparator",j,H),this.loose=H,this.parse(j),this.semver===de?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(j,H){return V(H,j)},e.major=function(j,H){return new te(j,H).major},e.minor=function(j,H){return new te(j,H).minor},e.patch=function(j,H){return new te(j,H).patch},e.compare=ie,e.compareLoose=function(j,H){return ie(j,H,!0)},e.rcompare=function(j,H,Q){return ie(H,j,Q)},e.sort=function(j,H){return j.sort(function(Q,oe){return e.compare(Q,oe,H)})},e.rsort=function(j,H){return j.sort(function(Q,oe){return e.rcompare(Q,oe,H)})},e.gt=Ce,e.lt=Te,e.eq=Pe,e.neq=be,e.gte=me,e.lte=G,e.cmp=_,e.Comparator=le;var de={};function Le(j,H){if(j instanceof Le)return j.loose===H?j:new Le(j.raw,H);if(j instanceof le)return new Le(j.value,H);if(!(this instanceof Le))return new Le(j,H);if(this.loose=H,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function ge(j){return!j||j.toLowerCase()==="x"||j==="*"}function ke(j,H,Q,oe,Ee,Be,We,Ze,_e,at,rt,et,ct){return((H=ge(Q)?"":ge(oe)?">="+Q+".0.0":ge(Ee)?">="+Q+"."+oe+".0":">="+H)+" "+(Ze=ge(_e)?"":ge(at)?"<"+(+_e+1)+".0.0":ge(rt)?"<"+_e+"."+(+at+1)+".0":et?"<="+_e+"."+at+"."+rt+"-"+et:"<="+Ze)).trim()}function Ie(j,H){for(var Q=0;Q<j.length;Q++)if(!j[Q].test(H))return!1;if(H.prerelease.length){for(Q=0;Q<j.length;Q++)if(I(j[Q].semver),j[Q].semver!==de&&j[Q].semver.prerelease.length>0){var oe=j[Q].semver;if(oe.major===H.major&&oe.minor===H.minor&&oe.patch===H.patch)return!0}return!1}return!0}function O(j,H,Q){try{H=new Le(H,Q)}catch{return!1}return H.test(j)}function K(j,H,Q,oe){var Ee,Be,We,Ze,_e;switch(j=new te(j,oe),H=new Le(H,oe),Q){case">":Ee=Ce,Be=G,We=Te,Ze=">",_e=">=";break;case"<":Ee=Te,Be=me,We=Ce,Ze="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(O(j,H,oe))return!1;for(var at=0;at<H.set.length;++at){var rt=H.set[at],et=null,ct=null;if(rt.forEach(function(Ue){Ue.semver===de&&(Ue=new le(">=0.0.0")),et=et||Ue,ct=ct||Ue,Ee(Ue.semver,et.semver,oe)?et=Ue:We(Ue.semver,ct.semver,oe)&&(ct=Ue)}),et.operator===Ze||et.operator===_e||(!ct.operator||ct.operator===Ze)&&Be(j,ct.semver)||ct.operator===_e&&We(j,ct.semver))return!1}return!0}le.prototype.parse=function(j){var H=this.loose?m[re]:m[ce],Q=j.match(H);if(!Q)throw new TypeError("Invalid comparator: "+j);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new te(Q[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(j){return I("Comparator.test",j,this.loose),this.semver===de||(typeof j=="string"&&(j=new te(j,this.loose)),_(j,this.operator,this.semver,this.loose))},le.prototype.intersects=function(j,H){if(!(j instanceof le))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Le(j.value,H),O(this.value,Q,H);if(j.operator==="")return Q=new Le(this.value,H),O(j.semver,Q,H);var oe=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Be=this.semver.version===j.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ze=_(this.semver,"<",j.semver,H)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),_e=_(this.semver,">",j.semver,H)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return oe||Ee||Be&&We||Ze||_e},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(j){var H=this.loose;j=j.trim(),I("range",j,H);var Q=H?m[he]:m[De];j=j.replace(Q,ke),I("hyphen replace",j),j=j.replace(m[we],"$1$2$3"),I("comparator trim",j,m[we]),j=(j=(j=j.replace(m[N],"$1~")).replace(m[C],"$1^")).split(/\s+/).join(" ");var oe=H?m[re]:m[ce],Ee=j.split(" ").map(function(Be){return function(We,Ze){return I("comp",We),We=function(_e,at){return _e.trim().split(/\s+/).map(function(rt){return function(et,ct){I("caret",et,ct);var Ue=ct?m[W]:m[F];return et.replace(Ue,function(vt,Z,x,pe,Ve){var Ye;return I("caret",et,vt,Z,x,pe,Ve),ge(Z)?Ye="":ge(x)?Ye=">="+Z+".0.0 <"+(+Z+1)+".0.0":ge(pe)?Ye=Z==="0"?">="+Z+"."+x+".0 <"+Z+"."+(+x+1)+".0":">="+Z+"."+x+".0 <"+(+Z+1)+".0.0":Ve?(I("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ye=Z==="0"?x==="0"?">="+Z+"."+x+"."+pe+Ve+" <"+Z+"."+x+"."+(+pe+1):">="+Z+"."+x+"."+pe+Ve+" <"+Z+"."+(+x+1)+".0":">="+Z+"."+x+"."+pe+Ve+" <"+(+Z+1)+".0.0"):(I("no pr"),Ye=Z==="0"?x==="0"?">="+Z+"."+x+"."+pe+" <"+Z+"."+x+"."+(+pe+1):">="+Z+"."+x+"."+pe+" <"+Z+"."+(+x+1)+".0":">="+Z+"."+x+"."+pe+" <"+(+Z+1)+".0.0"),I("caret return",Ye),Ye})}(rt,at)}).join(" ")}(We,Ze),I("caret",We),We=function(_e,at){return _e.trim().split(/\s+/).map(function(rt){return function(et,ct){var Ue=ct?m[q]:m[J];return et.replace(Ue,function(vt,Z,x,pe,Ve){var Ye;return I("tilde",et,vt,Z,x,pe,Ve),ge(Z)?Ye="":ge(x)?Ye=">="+Z+".0.0 <"+(+Z+1)+".0.0":ge(pe)?Ye=">="+Z+"."+x+".0 <"+Z+"."+(+x+1)+".0":Ve?(I("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ye=">="+Z+"."+x+"."+pe+Ve+" <"+Z+"."+(+x+1)+".0"):Ye=">="+Z+"."+x+"."+pe+" <"+Z+"."+(+x+1)+".0",I("tilde return",Ye),Ye})}(rt,at)}).join(" ")}(We,Ze),I("tildes",We),We=function(_e,at){return I("replaceXRanges",_e,at),_e.split(/\s+/).map(function(rt){return function(et,ct){et=et.trim();var Ue=ct?m[p]:m[g];return et.replace(Ue,function(vt,Z,x,pe,Ve,Ye){I("xRange",et,vt,Z,x,pe,Ve,Ye);var it=ge(x),st=it||ge(pe),Ne=st||ge(Ve);return Z==="="&&Ne&&(Z=""),it?vt=Z===">"||Z==="<"?"<0.0.0":"*":Z&&Ne?(st&&(pe=0),Ne&&(Ve=0),Z===">"?(Z=">=",st?(x=+x+1,pe=0,Ve=0):Ne&&(pe=+pe+1,Ve=0)):Z==="<="&&(Z="<",st?x=+x+1:pe=+pe+1),vt=Z+x+"."+pe+"."+Ve):st?vt=">="+x+".0.0 <"+(+x+1)+".0.0":Ne&&(vt=">="+x+"."+pe+".0 <"+x+"."+(+pe+1)+".0"),I("xRange return",vt),vt})}(rt,at)}).join(" ")}(We,Ze),I("xrange",We),We=function(_e,at){return I("replaceStars",_e,at),_e.trim().replace(m[ve],"")}(We,Ze),I("stars",We),We}(Be,H)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Be){return!!Be.match(oe)})),Ee=Ee.map(function(Be){return new le(Be,H)})},Le.prototype.intersects=function(j,H){if(!(j instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(oe){return j.set.some(function(Ee){return Ee.every(function(Be){return oe.intersects(Be,H)})})})})},e.toComparators=function(j,H){return new Le(j,H).set.map(function(Q){return Q.map(function(oe){return oe.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new te(j,this.loose));for(var H=0;H<this.set.length;H++)if(Ie(this.set[H],j))return!0;return!1},e.satisfies=O,e.maxSatisfying=function(j,H,Q){var oe=null,Ee=null;try{var Be=new Le(H,Q)}catch{return null}return j.forEach(function(We){Be.test(We)&&(oe&&Ee.compare(We)!==-1||(Ee=new te(oe=We,Q)))}),oe},e.minSatisfying=function(j,H,Q){var oe=null,Ee=null;try{var Be=new Le(H,Q)}catch{return null}return j.forEach(function(We){Be.test(We)&&(oe&&Ee.compare(We)!==1||(Ee=new te(oe=We,Q)))}),oe},e.validRange=function(j,H){try{return new Le(j,H).range||"*"}catch{return null}},e.ltr=function(j,H,Q){return K(j,H,"<",Q)},e.gtr=function(j,H,Q){return K(j,H,">",Q)},e.outside=K,e.prerelease=function(j,H){var Q=$e(j,H);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(j,H,Q){return j=new Le(j,Q),H=new Le(H,Q),j.intersects(H)},e.coerce=function(j){if(j instanceof te)return j;if(typeof j!="string")return null;var H=j.match(m[y]);return H==null?null:$e((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,S(1))},function(fe,e){var S,M,I=fe.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(c){if(S===setTimeout)return setTimeout(c,0);if((S===A||!S)&&setTimeout)return S=setTimeout,setTimeout(c,0);try{return S(c,0)}catch{try{return S.call(null,c,0)}catch{return S.call(this,c,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:A}catch{S=A}try{M=typeof clearTimeout=="function"?clearTimeout:R}catch{M=R}})();var f,D=[],L=!1,k=-1;function l(){L&&f&&(L=!1,f.length?D=f.concat(D):k=-1,D.length&&$())}function $(){if(!L){var c=m(l);L=!0;for(var s=D.length;s;){for(f=D,D=[];++k<s;)f&&f[k].run();k=-1,s=D.length}f=null,L=!1,function(i){if(M===clearTimeout)return clearTimeout(i);if((M===R||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(i);try{M(i)}catch{try{return M.call(null,i)}catch{return M.call(this,i)}}}(c)}}function w(c,s){this.fun=c,this.array=s}function r(){}I.nextTick=function(c){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];D.push(new w(c,s)),D.length!==1||L||m($)},w.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=r,I.addListener=r,I.once=r,I.off=r,I.removeListener=r,I.removeAllListeners=r,I.emit=r,I.prependListener=r,I.prependOnceListener=r,I.listeners=function(c){return[]},I.binding=function(c){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(c){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ae[124],Me([1,0,15,6]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function I(a){const u=a;return u?typeof u.read=="function":!1}e.$8d=I;function A(a){const u=a;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.$9d=A;function R(a){const u=a;return u?A(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$0d=R;function m(a,u){return new f(a,u)}e.$$d=m;class f{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,S.$1)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let d;switch(u){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const n=d.indexOf(t);n>=0&&d.splice(n,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function D(a,u){const t=[];let d;for(;(d=a.read())!==null;)t.push(d);return u(t)}e.$_d=D;function L(a,u,t){const d=[];let n;for(;(n=a.read())!==null&&d.length<t;)d.push(n);return n===null&&d.length>0?u(d):{read:()=>{if(d.length>0)return d.shift();if(typeof n<"u"){const b=n;return n=void 0,b}return a.read()}}}e.$ae=L;function k(a,u){return new Promise((t,d)=>{const n=[];l(a,{onData:b=>{u&&n.push(b)},onError:b=>{u?d(b):t(void 0)},onEnd:()=>{t(u?u(n):void 0)}})})}e.$be=k;function l(a,u,t){a.on("error",d=>{t?.isCancellationRequested||u.onError(d)}),a.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),a.on("data",d=>{t?.isCancellationRequested||u.onData(d)})}e.$ce=l;function $(a,u){return new Promise((t,d)=>{const n=new M.$Sc,b=[],E=P=>{if(b.push(P),b.length>u)return n.dispose(),a.pause(),t({stream:a,buffer:b,ended:!1})},h=P=>(n.dispose(),d(P)),v=()=>(n.dispose(),t({stream:a,buffer:b,ended:!0}));n.add((0,M.$Rc)(()=>a.removeListener("error",h))),a.on("error",h),n.add((0,M.$Rc)(()=>a.removeListener("end",v))),a.on("end",v),n.add((0,M.$Rc)(()=>a.removeListener("data",E))),a.on("data",E)})}e.$de=$;function w(a,u){const t=m(u);return t.end(a),t}e.$ee=w;function r(){const a=m(()=>{throw new Error("not supported")});return a.end(),a}e.$fe=r;function c(a){let u=!1;return{read:()=>u?null:(u=!0,a)}}e.$ge=c;function s(a,u,t){const d=m(t);return l(a,{onData:n=>d.write(u.data(n)),onError:n=>d.error(u.error?u.error(n):n),onEnd:()=>d.end()}),d}e.$he=s;function i(a,u,t){let d=!1;return{read:()=>{const n=u.read();return d?n:(d=!0,n!==null?t([a,n]):a)}}}e.$ie=i;function o(a,u,t){let d=!1;const n=m(t);return l(u,{onData:b=>d?n.write(b):(d=!0,n.write(t([a,b]))),onError:b=>n.error(b),onEnd:()=>{d||(d=!0,n.write(a)),n.end()}}),n}e.$je=o}),define(Ae[23],Me([1,0,39,124]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const I=typeof Buffer<"u",A=new S.$V(()=>new Uint8Array(256));let R,m;class f{static alloc(y){return I?new f(Buffer.allocUnsafe(y)):new f(new Uint8Array(y))}static wrap(y){return I&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new f(y)}static fromString(y,T){return!(T?.dontUseNodeBuffer||!1)&&I?new f(Buffer.from(y)):(R||(R=new TextEncoder),new f(R.encode(y)))}static fromByteArray(y){const T=f.alloc(y.length);for(let N=0,J=y.length;N<J;N++)T.buffer[N]=y[N];return T}static concat(y,T){if(typeof T>"u"){T=0;for(let q=0,U=y.length;q<U;q++)T+=y[q].byteLength}const N=f.alloc(T);let J=0;for(let q=0,U=y.length;q<U;q++){const C=y[q];N.set(C,J),J+=C.byteLength}return N}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=f.alloc(this.byteLength);return y.set(this),y}toString(){return I?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(y,T){return new f(this.buffer.subarray(y,T))}set(y,T){if(y instanceof f)this.buffer.set(y.buffer,T);else if(y instanceof Uint8Array)this.buffer.set(y,T);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),T);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return l(this.buffer,y)}writeUInt32BE(y,T){$(this.buffer,y,T)}readUInt32LE(y){return w(this.buffer,y)}writeUInt32LE(y,T){r(this.buffer,y,T)}readUInt8(y){return c(this.buffer,y)}writeUInt8(y,T){s(this.buffer,y,T)}indexOf(y,T=0){return D(this.buffer,y instanceof f?y.buffer:y,T)}}e.$ke=f;function D(p,y,T=0){const N=y.byteLength,J=p.byteLength;if(N===0)return 0;if(N===1)return p.indexOf(y[0]);if(N>J-T)return-1;const q=A.value;q.fill(y.length);for(let W=0;W<y.length;W++)q[y[W]]=y.length-W-1;let U=T+y.length-1,C=U,F=-1;for(;U<J;)if(p[U]===y[C]){if(C===0){F=U;break}U--,C--}else U+=Math.max(y.length-C,q[p[U]]),C=y.length-1;return F}e.$le=D;function L(p,y){return p[y+0]<<0>>>0|p[y+1]<<8>>>0}e.$me=L;function k(p,y,T){p[T+0]=y&255,y=y>>>8,p[T+1]=y&255}e.$ne=k;function l(p,y){return p[y]*2**24+p[y+1]*2**16+p[y+2]*2**8+p[y+3]}e.$oe=l;function $(p,y,T){p[T+3]=y,y=y>>>8,p[T+2]=y,y=y>>>8,p[T+1]=y,y=y>>>8,p[T]=y}e.$pe=$;function w(p,y){return p[y+0]<<0>>>0|p[y+1]<<8>>>0|p[y+2]<<16>>>0|p[y+3]<<24>>>0}e.$qe=w;function r(p,y,T){p[T+0]=y&255,y=y>>>8,p[T+1]=y&255,y=y>>>8,p[T+2]=y&255,y=y>>>8,p[T+3]=y&255}e.$re=r;function c(p,y){return p[y]}e.$se=c;function s(p,y,T){p[T]=y}e.$te=s;function i(p){return M.$_d(p,y=>f.concat(y))}e.$ue=i;function o(p){return M.$ge(p)}e.$ve=o;function a(p){return M.$be(p,y=>f.concat(y))}e.$we=a;async function u(p){return p.ended?f.concat(p.buffer):f.concat([...p.buffer,await a(p.stream)])}e.$xe=u;function t(p){return M.$ee(p,y=>f.concat(y))}e.$ye=t;function d(p){return M.$he(p,{data:y=>typeof y=="string"?f.fromString(y):f.wrap(y)},y=>f.concat(y))}e.$ze=d;function n(p){return M.$$d(y=>f.concat(y),p)}e.$Ae=n;function b(p,y){return M.$ie(p,y,T=>f.concat(T))}e.$Be=b;function E(p,y){return M.$je(p,y,T=>f.concat(T))}e.$Ce=E;function h(p){let y=0,T=0,N=0;const J=new Uint8Array(Math.floor(p.length/4*3)),q=C=>{switch(T){case 3:J[N++]=y|C,T=0;break;case 2:J[N++]=y|C>>>2,y=C<<6,T=3;break;case 1:J[N++]=y|C>>>4,y=C<<4,T=2;break;default:y=C<<2,T=1}};for(let C=0;C<p.length;C++){const F=p.charCodeAt(C);if(F>=65&&F<=90)q(F-65);else if(F>=97&&F<=122)q(F-97+26);else if(F>=48&&F<=57)q(F-48+52);else if(F===43||F===45)q(62);else if(F===47||F===95)q(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${p[C]}`)}}const U=N;for(;T>0;)q(0);return f.wrap(J).slice(0,U)}e.$De=h;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:p},y=!0,T=!1){const N=T?P:v;let J="";const q=p.byteLength%3;let U=0;for(;U<p.byteLength-q;U+=3){const C=p[U+0],F=p[U+1],W=p[U+2];J+=N[C>>>2],J+=N[(C<<4|F>>>4)&63],J+=N[(F<<2|W>>>6)&63],J+=N[W&63]}if(q===1){const C=p[U+0];J+=N[C>>>2],J+=N[C<<4&63],y&&(J+="==")}else if(q===2){const C=p[U+0],F=p[U+1];J+=N[C>>>2],J+=N[(C<<4|F>>>4)&63],J+=N[F<<2&63],y&&(J+="=")}return J}e.$Ee=g}),define(Ae[125],Me([1,0,28,122,13]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.FuzzyScore=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.or=void 0;function A(...ge){return function(ke,Ie){for(let O=0,K=ge.length;O<K;O++){const j=ge[O](ke,Ie);if(j)return j}return null}}e.or=A,e.$Vj=R.bind(void 0,!1),e.$Wj=R.bind(void 0,!0);function R(ge,ke,Ie){if(!Ie||Ie.length<ke.length)return null;let O;return ge?O=I.$bf(Ie,ke):O=Ie.indexOf(ke)===0,O?ke.length>0?[{start:0,end:ke.length}]:[]:null}function m(ge,ke){const Ie=ke.toLowerCase().indexOf(ge.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+ge.length}]}e.$Xj=m;function f(ge,ke){return D(ge.toLowerCase(),ke.toLowerCase(),0,0)}e.$Yj=f;function D(ge,ke,Ie,O){if(Ie===ge.length)return[];if(O===ke.length)return null;if(ge[Ie]===ke[O]){let K=null;return(K=D(ge,ke,Ie+1,O+1))?a({start:O,end:O+1},K):null}return D(ge,ke,Ie,O+1)}function L(ge){return 97<=ge&&ge<=122}function k(ge){return 65<=ge&&ge<=90}e.$Zj=k;function l(ge){return 48<=ge&&ge<=57}function $(ge){return ge===32||ge===9||ge===10||ge===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ge=>w.add(ge.charCodeAt(0)));function r(ge){return $(ge)||w.has(ge)}function c(ge,ke){return ge===ke||r(ge)&&r(ke)}const s=new Map;function i(ge){if(s.has(ge))return s.get(ge);let ke;const Ie=(0,M.$Tj)(ge);return Ie&&(ke=Ie),s.set(ge,ke),ke}function o(ge){return L(ge)||k(ge)||l(ge)}function a(ge,ke){return ke.length===0?ke=[ge]:ge.end===ke[0].start?ke[0].start=ge.start:ke.unshift(ge),ke}function u(ge,ke){for(let Ie=ke;Ie<ge.length;Ie++){const O=ge.charCodeAt(Ie);if(k(O)||l(O)||Ie>0&&!o(ge.charCodeAt(Ie-1)))return Ie}return ge.length}function t(ge,ke,Ie,O){if(Ie===ge.length)return[];if(O===ke.length)return null;if(ge[Ie]!==ke[O].toLowerCase())return null;{let K=null,j=O+1;for(K=t(ge,ke,Ie+1,O+1);!K&&(j=u(ke,j))<ke.length;)K=t(ge,ke,Ie+1,j),j++;return K===null?null:a({start:O,end:O+1},K)}}function d(ge){let ke=0,Ie=0,O=0,K=0,j=0;for(let Be=0;Be<ge.length;Be++)j=ge.charCodeAt(Be),k(j)&&ke++,L(j)&&Ie++,o(j)&&O++,l(j)&&K++;const H=ke/ge.length,Q=Ie/ge.length,oe=O/ge.length,Ee=K/ge.length;return{upperPercent:H,lowerPercent:Q,alphaPercent:oe,numericPercent:Ee}}function n(ge){const{upperPercent:ke,lowerPercent:Ie}=ge;return Ie===0&&ke>.6}function b(ge){const{upperPercent:ke,lowerPercent:Ie,alphaPercent:O,numericPercent:K}=ge;return Ie>.2&&ke<.8&&O>.6&&K<.2}function E(ge){let ke=0,Ie=0,O=0,K=0;for(let j=0;j<ge.length;j++)O=ge.charCodeAt(j),k(O)&&ke++,L(O)&&Ie++,$(O)&&K++;return(ke===0||Ie===0)&&K===0?ge.length<=30:ke<=5}function h(ge,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!E(ge))return null;ke.length>60&&(ke=ke.substring(0,60));const Ie=d(ke);if(!b(Ie)){if(!n(Ie))return null;ke=ke.toLowerCase()}let O=null,K=0;for(ge=ge.toLowerCase();K<ke.length&&(O=t(ge,ke,0,K))===null;)K=u(ke,K+1);return O}e.$1j=h;function v(ge,ke,Ie=!1){if(!ke||ke.length===0)return null;let O=null,K=0;for(ge=ge.toLowerCase(),ke=ke.toLowerCase();K<ke.length&&(O=P(ge,ke,0,K,Ie),O===null);)K=g(ke,K+1);return O}e.$2j=v;function P(ge,ke,Ie,O,K){let j=0;if(Ie===ge.length)return[];if(O===ke.length)return null;if(!c(ge.charCodeAt(Ie),ke.charCodeAt(O))){const oe=i(ge.charCodeAt(Ie));if(!oe)return null;for(let Ee=0;Ee<oe.length;Ee++)if(!c(oe[Ee],ke.charCodeAt(O+Ee)))return null;j+=oe.length-1}let H=null,Q=O+j+1;if(H=P(ge,ke,Ie+1,Q,K),!K)for(;!H&&(Q=g(ke,Q))<ke.length;)H=P(ge,ke,Ie+1,Q,K),Q++;if(!H)return null;if(ge.charCodeAt(Ie)!==ke.charCodeAt(O)){const oe=i(ge.charCodeAt(Ie));if(!oe)return H;for(let Ee=0;Ee<oe.length;Ee++)if(oe[Ee]!==ke.charCodeAt(O+Ee))return H}return a({start:O,end:O+j+1},H)}function g(ge,ke){for(let Ie=ke;Ie<ge.length;Ie++)if(r(ge.charCodeAt(Ie))||Ie>0&&r(ge.charCodeAt(Ie-1)))return Ie;return ge.length}const p=A(e.$Wj,h,m),y=A(e.$Wj,h,f),T=new S.$Dc(1e4);function N(ge,ke,Ie=!1){if(typeof ge!="string"||typeof ke!="string")return null;let O=T.get(ge);O||(O=new RegExp(I.$We(ge),"i"),T.set(ge,O));const K=O.exec(ke);return K?[{start:K.index,end:K.index+K[0].length}]:Ie?y(ge,ke):p(ge,ke)}e.$3j=N;function J(ge,ke){const Ie=be(ge,ge.toLowerCase(),0,ke,ke.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ie?U(Ie):null}e.$4j=J;function q(ge,ke,Ie,O,K,j){const H=Math.min(13,ge.length);for(;Ie<H;Ie++){const Q=be(ge,ke,Ie,O,K,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,j]}e.$5j=q;function U(ge){if(typeof ge>"u")return[];const ke=[],Ie=ge[1];for(let O=ge.length-1;O>1;O--){const K=ge[O]+Ie,j=ke[ke.length-1];j&&j.end===K?j.end=K+1:ke.push({start:K,end:K+1})}return ke}e.$6j=U;const C=128;function F(){const ge=[],ke=[];for(let Ie=0;Ie<=C;Ie++)ke[Ie]=0;for(let Ie=0;Ie<=C;Ie++)ge.push(ke.slice(0));return ge}function W(ge){const ke=[];for(let Ie=0;Ie<=ge;Ie++)ke[Ie]=0;return ke}const re=W(2*C),ce=W(2*C),we=F(),De=F(),he=F(),ve=!1;function se(ge,ke,Ie,O,K){function j(Q,oe,Ee=" "){for(;Q.length<oe;)Q=Ee+Q;return Q}let H=` |   |${O.split("").map(Q=>j(Q,3)).join("|")}
`;for(let Q=0;Q<=Ie;Q++)Q===0?H+=" |":H+=`${ke[Q-1]}|`,H+=ge[Q].slice(0,K+1).map(oe=>j(oe.toString(),3)).join("|")+`
`;return H}function $e(ge,ke,Ie,O){ge=ge.substr(ke),Ie=Ie.substr(O),console.log(se(De,ge,ge.length,Ie,Ie.length)),console.log(se(he,ge,ge.length,Ie,Ie.length)),console.log(se(we,ge,ge.length,Ie,Ie.length))}function te(ge,ke){if(ke<0||ke>=ge.length)return!1;const Ie=ge.codePointAt(ke);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$tf(Ie)}}function X(ge,ke){if(ke<0||ke>=ge.length)return!1;switch(ge.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function V(ge,ke,Ie){return ke[ge]!==Ie[ge]}function ie(ge,ke,Ie,O,K,j,H=!1){for(;ke<Ie&&K<j;)ge[ke]===O[K]&&(H&&(re[ke]=K),ke+=1),K+=1;return ke===Ie}e.$7j=ie;var Ce;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Te;(function(ge){ge.Default=[-100,0];function ke(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}ge.isDefault=ke})(Te||(e.FuzzyScore=Te={}));class Pe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ke,Ie){this.firstMatchCanBeWeak=ke,this.boostFullMatch=Ie}}e.$8j=Pe;function be(ge,ke,Ie,O,K,j,H=Pe.default){const Q=ge.length>C?C:ge.length,oe=O.length>C?C:O.length;if(Ie>=Q||j>=oe||Q-Ie>oe-j||!ie(ke,Ie,Q,K,j,oe,!0))return;me(Q,oe,Ie,j,ke,K);let Ee=1,Be=1,We=Ie,Ze=j;const _e=[!1];for(Ee=1,We=Ie;We<Q;Ee++,We++){const Ue=re[We],vt=ce[We],Z=We+1<Q?ce[We+1]:oe;for(Be=Ue-j+1,Ze=Ue;Ze<Z;Be++,Ze++){let x=Number.MIN_SAFE_INTEGER,pe=!1;Ze<=vt&&(x=G(ge,ke,We,Ie,O,K,Ze,oe,j,we[Ee-1][Be-1]===0,_e));let Ve=0;x!==Number.MAX_SAFE_INTEGER&&(pe=!0,Ve=x+De[Ee-1][Be-1]);const Ye=Ze>Ue,it=Ye?De[Ee][Be-1]+(we[Ee][Be-1]>0?-5:0):0,st=Ze>Ue+1&&we[Ee][Be-1]>0,Ne=st?De[Ee][Be-2]+(we[Ee][Be-2]>0?-5:0):0;if(st&&(!Ye||Ne>=it)&&(!pe||Ne>=Ve))De[Ee][Be]=Ne,he[Ee][Be]=3,we[Ee][Be]=0;else if(Ye&&(!pe||it>=Ve))De[Ee][Be]=it,he[Ee][Be]=2,we[Ee][Be]=0;else if(pe)De[Ee][Be]=Ve,he[Ee][Be]=1,we[Ee][Be]=we[Ee-1][Be-1]+1;else throw new Error("not possible")}}if(ve&&$e(ge,Ie,O,j),!_e[0]&&!H.firstMatchCanBeWeak)return;Ee--,Be--;const at=[De[Ee][Be],j];let rt=0,et=0;for(;Ee>=1;){let Ue=Be;do{const vt=he[Ee][Ue];if(vt===3)Ue=Ue-2;else if(vt===2)Ue=Ue-1;else break}while(Ue>=1);rt>1&&ke[Ie+Ee-1]===K[j+Be-1]&&!V(Ue+j-1,O,K)&&rt+1>we[Ee][Ue]&&(Ue=Be),Ue===Be?rt++:rt=1,et||(et=Ue),Ee--,Be=Ue-1,at.push(Be)}oe===Q&&H.boostFullMatch&&(at[0]+=2);const ct=et-Q;return at[0]-=ct,at}e.$9j=be;function me(ge,ke,Ie,O,K,j){let H=ge-1,Q=ke-1;for(;H>=Ie&&Q>=O;)K[H]===j[Q]&&(ce[H]=Q,H--),Q--}function G(ge,ke,Ie,O,K,j,H,Q,oe,Ee,Be){if(ke[Ie]!==j[H])return Number.MIN_SAFE_INTEGER;let We=1,Ze=!1;return H===Ie-O?We=ge[Ie]===K[H]?7:5:V(H,K,j)&&(H===0||!V(H-1,K,j))?(We=ge[Ie]===K[H]?7:5,Ze=!0):te(j,H)&&(H===0||!te(j,H-1))?We=5:(te(j,H-1)||X(j,H-1))&&(We=5,Ze=!0),We>1&&Ie===O&&(Be[0]=!0),Ze||(Ze=V(H,K,j)||te(j,H-1)||X(j,H-1)),Ie===O?H>oe&&(We-=Ze?3:5):Ee?We+=Ze?2:0:We+=Ze?0:1,H+1===Q&&(We-=Ze?3:5),We}function _(ge,ke,Ie,O,K,j,H){return de(ge,ke,Ie,O,K,j,!0,H)}e.$0j=_;function le(ge,ke,Ie,O,K,j,H){return de(ge,ke,Ie,O,K,j,!1,H)}e.$$j=le;function de(ge,ke,Ie,O,K,j,H,Q){let oe=be(ge,ke,Ie,O,K,j,Q);if(oe&&!H)return oe;if(ge.length>=3){const Ee=Math.min(7,ge.length-1);for(let Be=Ie+1;Be<Ee;Be++){const We=Le(ge,Be);if(We){const Ze=be(We,We.toLowerCase(),Ie,O,K,j,Q);Ze&&(Ze[0]-=3,(!oe||Ze[0]>oe[0])&&(oe=Ze))}}}return oe}function Le(ge,ke){if(ke+1>=ge.length)return;const Ie=ge[ke],O=ge[ke+1];if(Ie!==O)return ge.slice(0,ke)+O+Ie+ge.slice(ke+2)}}),define(Ae[32],Me([1,0,13]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(M||(M={})),function(I){const A="error",R="warning",m="warn",f="info",D="ignore";function L(l){return l?S.$af(A,l)?I.Error:S.$af(R,l)||S.$af(m,l)?I.Warning:S.$af(f,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=L;function k(l){switch(l){case I.Error:return A;case I.Warning:return R;case I.Info:return f;default:return D}}I.toString=k}(M||(M={})),e.default=M}),define(Ae[126],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(Ae[51],Me([1,0,18,13]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0;class I{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const w=$.charCodeAt(0),r=this.b.charCodeAt(this.c);return w-r}value(){return this.b[this.c]}}e.$0h=I;class A{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,M.$7e)($,this.b,0,$.length,this.c,this.d):(0,M.$9e)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$$h=A;class R{constructor($=!0,w=!0){this.f=$,this.g=w}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let w=$.length-1;w>=0;w--,this.c--){const r=this.b.charCodeAt(w);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,M.$7e)($,this.b,0,$.length,this.d,this.e):(0,M.$9e)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$_h=R;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class f{constructor($,w){this.f=$,this.g=w,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,M.$8e)($,this.c.scheme);if(this.d[this.e]===2)return(0,M.$8e)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,M.$6e)($,this.c.query);if(this.d[this.e]===5)return(0,M.$6e)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ai=f;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(L||(L={}));class k{static forUris($=()=>!1,w=()=>!1){return new k(new f($,w))}static forPaths($=!1){return new k(new R(void 0,!$))}static forStrings(){return new k(new I)}static forConfigKeys(){return new k(new A)}constructor($){this.b=$}clear(){this.c=void 0}fill($,w){if(w){const r=w.slice(0);(0,S.$Xb)(r);for(const c of r)this.set(c,$)}else{const r=$.slice(0);(0,S.$Xb)(r);for(const c of r)this.set(c[0],c[1])}}set($,w){const r=this.b.reset($);let c;this.c||(this.c=new D,this.c.segment=r.value());const s=[];for(c=this.c;;){const o=r.cmp(c.segment);if(o>0)c.left||(c.left=new D,c.left.segment=r.value()),s.push([-1,c]),c=c.left;else if(o<0)c.right||(c.right=new D,c.right.segment=r.value()),s.push([1,c]),c=c.right;else if(r.hasNext())r.next(),c.mid||(c.mid=new D,c.mid.segment=r.value()),s.push([0,c]),c=c.mid;else break}const i=c.value;c.value=w,c.key=$;for(let o=s.length-1;o>=0;o--){const a=s[o][1];a.updateHeight();const u=a.balanceFactor();if(u<-1||u>1){const t=s[o][0],d=s[o+1][0];if(t===1&&d===1)s[o][1]=a.rotateLeft();else if(t===-1&&d===-1)s[o][1]=a.rotateRight();else if(t===1&&d===-1)a.right=s[o+1][1]=s[o+1][1].rotateRight(),s[o][1]=a.rotateLeft();else if(t===-1&&d===1)a.left=s[o+1][1]=s[o+1][1].rotateLeft(),s[o][1]=a.rotateRight();else throw new Error;if(o>0)switch(s[o-1][0]){case-1:s[o-1][1].left=s[o][1];break;case 1:s[o-1][1].right=s[o][1];break;case 0:s[o-1][1].mid=s[o][1];break}else this.c=s[0][1]}}return i}get($){return this.d($)?.value}d($){const w=this.b.reset($);let r=this.c;for(;r;){const c=w.cmp(r.segment);if(c>0)r=r.left;else if(c<0)r=r.right;else if(w.hasNext())w.next(),r=r.mid;else break}return r}has($){const w=this.d($);return!(w?.value===void 0&&w?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,w){const r=this.b.reset($),c=[];let s=this.c;for(;s;){const i=r.cmp(s.segment);if(i>0)c.push([-1,s]),s=s.left;else if(i<0)c.push([1,s]),s=s.right;else if(r.hasNext())r.next(),c.push([0,s]),s=s.mid;else break}if(s){if(w?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:o,value:a,segment:u}=i;this.e(i.key,!1),s.key=o,s.value=a,s.segment=u}}else{const i=s.left??s.right;if(c.length>0){const[o,a]=c[c.length-1];switch(o){case-1:a.left=i;break;case 0:a.mid=i;break;case 1:a.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const o=c[i][1];o.updateHeight();const a=o.balanceFactor();if(a>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),c[i][1]=o.rotateLeft()):a<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),c[i][1]=o.rotateRight()),i>0)switch(c[i-1][0]){case-1:c[i-1][1].left=c[i][1];break;case 1:c[i-1][1].right=c[i][1];break;case 0:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const w=this.b.reset($);let r=this.c,c;for(;r;){const s=w.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(w.hasNext())w.next(),c=r.value||c,r=r.mid;else break}return r&&r.value||c}findSuperstr($){return this.g($,!1)}g($,w){const r=this.b.reset($);let c=this.c;for(;c;){const s=r.cmp(c.segment);if(s>0)c=c.left;else if(s<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else return c.mid?this.h(c.mid):w?c.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[w,r]of this)$(r,w)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const w=[];return this.j($,w),w[Symbol.iterator]()}j($,w){$&&($.left&&this.j($.left,w),$.value&&w.push([$.key,$.value]),$.mid&&this.j($.mid,w),$.right&&this.j($.right,w))}_isBalanced(){const $=w=>{if(!w)return!0;const r=w.balanceFactor();return r<-1||r>1?!1:$(w.left)&&$(w.right)};return $(this.c)}}e.$bi=k}),define(Ae[40],Me([1,0,89]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ck=e.ThemeColor=void 0;var M;(function(R){function m(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=m})(M||(e.ThemeColor=M={}));function I(R){return{id:R}}e.$ck=I;var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(i){const o=m.exec(i.id);if(!o)return f(S.$bk.error);const[,a,u]=o,t=["codicon","codicon-"+a];return u&&t.push("codicon-modifier-"+u.substring(1)),t}R.asClassNameArray=f;function D(i){return f(i).join(" ")}R.asClassName=D;function L(i){return"."+f(i).join(".")}R.asCSSSelector=L;function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||M.isThemeColor(i.color))}R.isThemeIcon=k;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function $(i){const o=l.exec(i);if(!o)return;const[,a]=o;return{id:a}}R.fromString=$;function w(i){return{id:i}}R.fromId=w;function r(i,o){let a=i.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),o&&(a=`${a}~${o}`),{id:a}}R.modify=r;function c(i){const o=i.id.lastIndexOf("~");if(o!==-1)return i.id.substring(o+1)}R.getModifier=c;function s(i,o){return i.id===o.id&&i.color?.id===o.color?.id}R.isEqual=s})(A||(e.ThemeIcon=A={}))}),define(Ae[127],Me([1,0,125,13,40]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=void 0;const A="$(",R=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function f(s){return s.replace(m,(i,o)=>o?i:`\\${i}`)}e.$dk=f;const D=new RegExp(`\\\\${R.source}`,"g");function L(s){return s.replace(D,i=>`\\${i}`)}e.$ek=L;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(s){return s.indexOf(A)===-1?s:s.replace(k,(i,o,a,u)=>a?i:o||u||"")}e.$fk=l;function $(s){return s?s.replace(/\$\((.*?)\)/g,(i,o)=>` ${o} `).trim():""}e.$gk=$;const w=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){w.lastIndex=0;let i="";const o=[];let a=0;for(;;){const u=w.lastIndex,t=w.exec(s),d=s.substring(u,t?.index);if(d.length>0){i+=d;for(let n=0;n<d.length;n++)o.push(a)}if(!t)break;a+=t[0].length}return{text:i,iconOffsets:o}}e.$hk=r;function c(s,i,o=!1){const{text:a,iconOffsets:u}=i;if(!u||u.length===0)return(0,S.$3j)(s,a,o);const t=(0,M.$Ue)(a," "),d=a.length-t.length,n=(0,S.$3j)(s,t,o);if(n)for(const b of n){const E=u[b.start+d]+d;b.start+=E,b.end+=E}return n}e.$ik=c}),define(Ae[33],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(I){return S.test(I)}e.$qg=M,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(m){for(let f=0;f<m.length;f++)m[f]=Math.floor(Math.random()*256);return m};const A=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){I(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let f=0,D="";return D+=R[A[f++]],D+=R[A[f++]],D+=R[A[f++]],D+=R[A[f++]],D+="-",D+=R[A[f++]],D+=R[A[f++]],D+="-",D+=R[A[f++]],D+=R[A[f++]],D+="-",D+=R[A[f++]],D+=R[A[f++]],D+="-",D+=R[A[f++]],D+=R[A[f++]],D+=R[A[f++]],D+=R[A[f++]],D+=R[A[f++]],D+=R[A[f++]],D}}()}),define(Ae[128],Me([1,0,18,68,33]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.$rt=e.$qt=e.$pt=void 0;function A(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$pt=A;function R(k,l,$){const w={id:(0,I.$rg)(),name:k,uri:l,data:$};return{asString:async()=>"",asFile:()=>w,value:void 0}}e.$qt=R;class m{constructor(){this.a=new Map}get size(){let l=0;for(const $ of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const $=[...this.a.keys()];return M.Iterable.some(this,([w,r])=>r.asFile())&&$.push("files"),L(f(l),$)}get(l){return this.a.get(this.b(l))?.[0]}append(l,$){const w=this.a.get(l);w?w.push($):this.a.set(this.b(l),[$])}replace(l,$){this.a.set(this.b(l),[$])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,$]of this.a)for(const w of $)yield[l,w]}b(l){return f(l)}}e.$rt=m;function f(k){return k.toLowerCase()}function D(k,l){return L(f(k),l.map(f))}e.$st=D;function L(k,l){if(k==="*/*")return l.length>0;if(l.includes(k))return!0;const $=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!$)return!1;const[w,r,c]=$;return c==="*"?l.some(s=>s.startsWith(r+"/")):!1}e.$tt=Object.freeze({create:k=>(0,S.$Mb)(k.map(l=>l.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$tt.split(k).filter(l=>!l.startsWith("#"))})}),define(Ae[129],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.StringEOL=void 0;var S;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function M(I){let A=0,R=0,m=0,f=0;for(let D=0,L=I.length;D<L;D++){const k=I.charCodeAt(D);k===13?(A===0&&(R=D),A++,D+1<L&&I.charCodeAt(D+1)===10?(f|=2,D++):f|=3,m=D+1):k===10&&(f|=1,A===0&&(R=D),A++,m=D+1)}return A===0&&(R=I.length),[A,R,I.length-m,f]}e.$wt=M}),define(Ae[130],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0,e.$us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[131],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$Tt=e.IndentAction=void 0;var S;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class M{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let f=0,D=m.notIn.length;f<D;f++)switch(m.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,f){if(m.getTokenCount()===0)return!0;const D=m.findTokenIndexAtOffset(f-2),L=m.getStandardTokenType(D);return this.isOK(L)}g(m,f){for(let D=m;D<=f;D++){const L=String.fromCharCode(D);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Tt=M;class I{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of m)A(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),A(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),A(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),A(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&A(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$Ut=I;function A(R,m,f){R.has(m)?R.get(m).push(f):R.set(m,[f])}}),define(Ae[132],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.NodeColor=e.$UB=void 0;class S{constructor(c,s){this.piece=c,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$VB)return I(this.right);let c=this;for(;c.parent!==e.$VB&&c.parent.left!==c;)c=c.parent;return c.parent===e.$VB?e.$VB:c.parent}prev(){if(this.left!==e.$VB)return A(this.left);let c=this;for(;c.parent!==e.$VB&&c.parent.right!==c;)c=c.parent;return c.parent===e.$VB?e.$VB:c.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$UB=S;var M;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$VB=new S(null,0),e.$VB.parent=e.$VB,e.$VB.left=e.$VB,e.$VB.right=e.$VB,e.$VB.color=0;function I(r){for(;r.left!==e.$VB;)r=r.left;return r}e.$WB=I;function A(r){for(;r.right!==e.$VB;)r=r.right;return r}e.$XB=A;function R(r){return r===e.$VB?0:r.size_left+r.piece.length+R(r.right)}function m(r){return r===e.$VB?0:r.lf_left+r.piece.lineFeedCnt+m(r.right)}function f(){e.$VB.parent=e.$VB}function D(r,c){const s=c.right;s.size_left+=c.size_left+(c.piece?c.piece.length:0),s.lf_left+=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),c.right=s.left,s.left!==e.$VB&&(s.left.parent=c),s.parent=c.parent,c.parent===e.$VB?r.root=s:c.parent.left===c?c.parent.left=s:c.parent.right=s,s.left=c,c.parent=s}e.$YB=D;function L(r,c){const s=c.left;c.left=s.right,s.right!==e.$VB&&(s.right.parent=c),s.parent=c.parent,c.size_left-=s.size_left+(s.piece?s.piece.length:0),c.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),c.parent===e.$VB?r.root=s:c===c.parent.right?c.parent.right=s:c.parent.left=s,s.right=c,c.parent=s}e.$ZB=L;function k(r,c){let s,i;if(c.left===e.$VB?(i=c,s=i.right):c.right===e.$VB?(i=c,s=i.left):(i=I(c.right),s=i.right),i===r.root){r.root=s,s.color=0,c.detach(),f(),r.root.parent=e.$VB;return}const o=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===c?(s.parent=i.parent,w(r,s)):(i.parent===c?s.parent=i:s.parent=i.parent,w(r,s),i.left=c.left,i.right=c.right,i.parent=c.parent,i.color=c.color,c===r.root?r.root=i:c===c.parent.left?c.parent.left=i:c.parent.right=i,i.left!==e.$VB&&(i.left.parent=i),i.right!==e.$VB&&(i.right.parent=i),i.size_left=c.size_left,i.lf_left=c.lf_left,w(r,i)),c.detach(),s.parent.left===s){const u=R(s),t=m(s);if(u!==s.parent.size_left||t!==s.parent.lf_left){const d=u-s.parent.size_left,n=t-s.parent.lf_left;s.parent.size_left=u,s.parent.lf_left=t,$(r,s.parent,d,n)}}if(w(r,s.parent),o){f();return}let a;for(;s!==r.root&&s.color===0;)s===s.parent.left?(a=s.parent.right,a.color===1&&(a.color=0,s.parent.color=1,D(r,s.parent),a=s.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.right.color===0&&(a.left.color=0,a.color=1,L(r,a),a=s.parent.right),a.color=s.parent.color,s.parent.color=0,a.right.color=0,D(r,s.parent),s=r.root)):(a=s.parent.left,a.color===1&&(a.color=0,s.parent.color=1,L(r,s.parent),a=s.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.left.color===0&&(a.right.color=0,a.color=1,D(r,a),a=s.parent.left),a.color=s.parent.color,s.parent.color=0,a.left.color=0,L(r,s.parent),s=r.root));s.color=0,f()}e.$1B=k;function l(r,c){for(w(r,c);c!==r.root&&c.parent.color===1;)if(c.parent===c.parent.parent.left){const s=c.parent.parent.right;s.color===1?(c.parent.color=0,s.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.right&&(c=c.parent,D(r,c)),c.parent.color=0,c.parent.parent.color=1,L(r,c.parent.parent))}else{const s=c.parent.parent.left;s.color===1?(c.parent.color=0,s.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.left&&(c=c.parent,L(r,c)),c.parent.color=0,c.parent.parent.color=1,D(r,c.parent.parent))}r.root.color=0}e.$2B=l;function $(r,c,s,i){for(;c!==r.root&&c!==e.$VB;)c.parent.left===c&&(c.parent.size_left+=s,c.parent.lf_left+=i),c=c.parent}e.$3B=$;function w(r,c){let s=0,i=0;if(c!==r.root){for(;c!==r.root&&c===c.parent.right;)c=c.parent;if(c!==r.root)for(c=c.parent,s=R(c.left)-c.size_left,i=m(c.left)-c.lf_left,c.size_left+=s,c.lf_left+=i;c!==r.root&&(s!==0||i!==0);)c.parent.left===c&&(c.parent.size_left+=s,c.parent.lf_left+=i),c=c.parent}}e.$4B=w}),define(Ae[90],Me([1,0,91,29,92,132,93]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=void 0;const m=65535;function f(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class D{constructor(i,o,a,u,t){this.lineStarts=i,this.cr=o,this.lf=a,this.crlf=u,this.isBasicASCII=t}}function L(s,i=!0){const o=[0];let a=1;for(let u=0,t=s.length;u<t;u++){const d=s.charCodeAt(u);d===13?u+1<t&&s.charCodeAt(u+1)===10?(o[a++]=u+2,u++):o[a++]=u+1:d===10&&(o[a++]=u+1)}return i?f(o):o}e.$$B=L;function k(s,i){s.length=0,s[0]=0;let o=1,a=0,u=0,t=0,d=!0;for(let b=0,E=i.length;b<E;b++){const h=i.charCodeAt(b);h===13?b+1<E&&i.charCodeAt(b+1)===10?(t++,s[o++]=b+2,b++):(a++,s[o++]=b+1):h===10?(u++,s[o++]=b+1):d&&h!==9&&(h<32||h>126)&&(d=!1)}const n=new D(f(s),a,u,t,d);return s.length=0,n}e.$_B=k;class l{constructor(i,o,a,u,t){this.bufferIndex=i,this.start=o,this.end=a,this.lineFeedCnt=u,this.length=t}}e.$aC=l;class ${constructor(i,o){this.buffer=i,this.lineStarts=o}}e.$bC=$;class w{constructor(i,o){this.a=[],this.c=i,this.d=o,this.b=0,i.root!==A.$VB&&i.iterate(i.root,a=>(a!==A.$VB&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(i){this.a=i,this.b=[]}get(i){for(let o=this.b.length-1;o>=0;o--){const a=this.b[o];if(a.nodeStartOffset<=i&&a.nodeStartOffset+a.node.piece.length>=i)return a}return null}get2(i){for(let o=this.b.length-1;o>=0;o--){const a=this.b[o];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<i&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=i)return a}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let o=!1;const a=this.b;for(let u=0;u<a.length;u++){const t=a[u];if(t.node.parent===null||t.nodeStartOffset>=i){a[u]=null,o=!0;continue}}if(o){const u=[];for(const t of a)t!==null&&u.push(t);this.b=u}}}class c{constructor(i,o,a){this.create(i,o,a)}create(i,o,a){this.a=[new $("",[0])],this.g={line:0,column:0},this.root=A.$VB,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=a;let u=null;for(let t=0,d=i.length;t<d;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=L(i[t].buffer));const n=new l(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),u=this.S(u,n)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const o=m,a=o-Math.floor(o/3),u=a*2;let t="",d=0;const n=[];if(this.iterate(this.root,b=>{const E=this.R(b),h=E.length;if(d<=a||d+h<u)return t+=E,d+=h,!0;const v=t.replace(/\r\n|\r|\n/g,i);return n.push(new $(v,L(v))),t=E,d=h,!0}),d>0){const b=t.replace(/\r\n|\r|\n/g,i);n.push(new $(b,L(b)))}this.create(n,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new w(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let o=0;return this.iterate(this.root,u=>{if(u===A.$VB)return!0;const t=this.R(u),d=t.length,n=i.G(o),b=i.G(o+d),E=i.getValueInRange2(n,b);return o+=d,t===E})}getOffsetAt(i,o){let a=0,u=this.root;for(;u!==A.$VB;)if(u.left!==A.$VB&&u.lf_left+1>=i)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=i){a+=u.size_left;const t=this.B(u,i-u.lf_left-2);return a+=t+o-1}else i-=u.lf_left+u.piece.lineFeedCnt,a+=u.size_left+u.piece.length,u=u.right;return a}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let o=this.root,a=0;const u=i;for(;o!==A.$VB;)if(o.size_left!==0&&o.size_left>=i)o=o.left;else if(o.size_left+o.piece.length>=i){const t=this.A(o,i-o.size_left);if(a+=o.lf_left+t.index,t.index===0){const d=this.getOffsetAt(a+1,1),n=u-d;return new S.$Vs(a+1,n+1)}return new S.$Vs(a+1,t.remainder+1)}else if(i-=o.size_left+o.piece.length,a+=o.lf_left+o.piece.lineFeedCnt,o.right===A.$VB){const t=this.getOffsetAt(a+1,1),d=u-i-t;return new S.$Vs(a+1,d+1)}else o=o.right;return new S.$Vs(1,1)}getValueInRange(i,o){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const a=this.H(i.startLineNumber,i.startColumn),u=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(a,u);return o?o!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,o):t}getValueInRange2(i,o){if(i.node===o.node){const n=i.node,b=this.a[n.piece.bufferIndex].buffer,E=this.u(n.piece.bufferIndex,n.piece.start);return b.substring(E+i.remainder,E+o.remainder)}let a=i.node;const u=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let d=u.substring(t+i.remainder,t+a.piece.length);for(a=a.next();a!==A.$VB;){const n=this.a[a.piece.bufferIndex].buffer,b=this.u(a.piece.bufferIndex,a.piece.start);if(a===o.node){d+=n.substring(b,b+o.remainder);break}else d+=n.substr(b,a.piece.length);a=a.next()}return d}getLinesContent(){const i=[];let o=0,a="",u=!1;return this.iterate(this.root,t=>{if(t===A.$VB)return!0;const d=t.piece;let n=d.length;if(n===0)return!0;const b=this.a[d.bufferIndex].buffer,E=this.a[d.bufferIndex].lineStarts,h=d.start.line,v=d.end.line;let P=E[h]+d.start.column;if(u&&(b.charCodeAt(P)===10&&(P++,n--),i[o++]=a,a="",u=!1,n===0))return!0;if(h===v)return!this.f&&b.charCodeAt(P+n-1)===13?(u=!0,a+=b.substr(P,n-1)):a+=b.substr(P,n),!0;a+=this.f?b.substring(P,Math.max(P,E[h+1]-this.e)):b.substring(P,E[h+1]).replace(/(\r\n|\r|\n)$/,""),i[o++]=a;for(let g=h+1;g<v;g++)a=this.f?b.substring(E[g],E[g+1]-this.e):b.substring(E[g],E[g+1]).replace(/(\r\n|\r|\n)$/,""),i[o++]=a;return!this.f&&b.charCodeAt(E[v]+d.end.column-1)===13?(u=!0,d.end.column===0?o--:a=b.substr(E[v],d.end.column-1)):a=b.substr(E[v],d.end.column),!0}),u&&(i[o++]=a,a=""),i[o++]=a,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const o=i.node.next();if(!o)return 0;const a=this.a[o.piece.bufferIndex],u=this.u(o.piece.bufferIndex,o.piece.start);return a.buffer.charCodeAt(u)}else{const o=this.a[i.node.piece.bufferIndex],u=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return o.buffer.charCodeAt(u)}}getLineCharCode(i,o){const a=this.H(i,o+1);return this.l(a)}getLineLength(i){if(i===this.getLineCount()){const o=this.getOffsetAt(i,1);return this.getLength()-o}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const o=this.G(i);return this.l(o)}findMatchesInNode(i,o,a,u,t,d,n,b,E,h,v){const P=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,d);let T;const N={line:0,column:0};let J,q;o._wordSeparators?(J=P.buffer.substring(p,y),q=U=>U+p,o.reset(0)):(J=P.buffer,q=U=>U,o.reset(p));do if(T=o.next(J),T){if(q(T.index)>=y)return h;this.s(i,q(T.index)-g,N);const U=this.t(i.piece.bufferIndex,t,N),C=N.line===t.line?N.column-t.column+u:N.column+1,F=C+T[0].length;if(v[h++]=(0,R.$7B)(new M.$Ws(a+U,C,a+U,F),T,b),q(T.index)+T[0].length>=y||h>=E)return h}while(T);return h}findMatchesLineByLine(i,o,a,u){const t=[];let d=0;const n=new R.$0B(o.wordSeparators,o.regex);let b=this.H(i.startLineNumber,i.startColumn);if(b===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let h=this.s(b.node,b.remainder);const v=this.s(E.node,E.remainder);if(b.node===E.node)return this.findMatchesInNode(b.node,n,i.startLineNumber,i.startColumn,h,v,o,a,u,d,t),t;let P=i.startLineNumber,g=b.node;for(;g!==E.node;){const y=this.t(g.piece.bufferIndex,h,g.piece.end);if(y>=1){const N=this.a[g.piece.bufferIndex].lineStarts,J=this.u(g.piece.bufferIndex,g.piece.start),q=N[h.line+y],U=P===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(g,n,P,U,h,this.s(g,q-J),o,a,u,d,t),d>=u)return t;P+=y}const T=P===i.startLineNumber?i.startColumn-1:0;if(P===i.endLineNumber){const N=this.getLineContent(P).substring(T,i.endColumn-1);return d=this.n(o,n,N,i.endLineNumber,T,d,t,a,u),t}if(d=this.n(o,n,this.getLineContent(P).substr(T),P,T,d,t,a,u),d>=u)return t;P++,b=this.H(P,1),g=b.node,h=this.s(b.node,b.remainder)}if(P===i.endLineNumber){const y=P===i.startLineNumber?i.startColumn-1:0,T=this.getLineContent(P).substring(y,i.endColumn-1);return d=this.n(o,n,T,i.endLineNumber,y,d,t,a,u),t}const p=P===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(E.node,n,P,p,h,v,o,a,u,d,t),t}n(i,o,a,u,t,d,n,b,E){const h=i.wordSeparators;if(!b&&i.simpleSearch){const P=i.simpleSearch,g=P.length,p=a.length;let y=-g;for(;(y=a.indexOf(P,y+g))!==-1;)if((!h||(0,R.$9B)(h,a,p,y,g))&&(n[d++]=new I.$cv(new M.$Ws(u,y+1+t,u,y+1+g+t),null),d>=E))return d;return d}let v;o.reset(0);do if(v=o.next(a),v&&(n[d++]=(0,R.$7B)(new M.$Ws(u,v.index+1+t,u,v.index+1+v[0].length+t),v,b),d>=E))return d;while(v);return d}insert(i,o,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==A.$VB){const{node:u,remainder:t,nodeStartOffset:d}=this.G(i),n=u.piece,b=n.bufferIndex,E=this.s(u,t);if(u.piece.bufferIndex===0&&n.end.line===this.g.line&&n.end.column===this.g.column&&d+n.length===i&&o.length<m){this.F(u,o),this.y();return}if(d===i)this.o(o,u),this.h.validate(i);else if(d+u.piece.length>i){const h=[];let v=new l(n.bufferIndex,E,n.end,this.t(n.bufferIndex,E,n.end),this.u(b,n.end)-this.u(b,E));if(this.K()&&this.M(o)&&this.I(u,t)===10){const y={line:v.start.line+1,column:0};v=new l(v.bufferIndex,y,v.end,this.t(v.bufferIndex,y,v.end),v.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(u,t-1)===13){const y=this.s(u,t-1);this.C(u,y),o="\r"+o,u.piece.length===0&&h.push(u)}else this.C(u,E);else this.C(u,E);const P=this.w(o);v.length>0&&this.S(u,v);let g=u;for(let p=0;p<P.length;p++)g=this.S(g,P[p]);this.v(h)}else this.q(o,u)}else{const u=this.w(o);let t=this.T(null,u[0]);for(let d=1;d<u.length;d++)t=this.S(t,u[d])}this.y()}delete(i,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===A.$VB)return;const a=this.G(i),u=this.G(i+o),t=a.node,d=u.node;if(t===d){const P=this.s(t,a.remainder),g=this.s(t,u.remainder);if(a.nodeStartOffset===i){if(o===t.piece.length){const p=t.next();(0,A.$1B)(this,t),this.N(p),this.y();return}this.D(t,g),this.h.validate(i),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===i+o){this.C(t,P),this.O(t),this.y();return}this.E(t,P,g),this.y();return}const n=[],b=this.s(t,a.remainder);this.C(t,b),this.h.validate(i),t.piece.length===0&&n.push(t);const E=this.s(d,u.remainder);this.D(d,E),d.piece.length===0&&n.push(d);const h=t.next();for(let P=h;P!==A.$VB&&P!==d;P=P.next())n.push(P);const v=t.piece.length===0?t.prev():t;this.v(n),this.O(v),this.y()}o(i,o){const a=[];if(this.K()&&this.M(i)&&this.L(o)){const d=o.piece,n={line:d.start.line+1,column:0},b=new l(d.bufferIndex,n,d.end,this.t(d.bufferIndex,n,d.end),d.length-1);o.piece=b,i+=`
`,(0,A.$3B)(this,o,-1,-1),o.piece.length===0&&a.push(o)}const u=this.w(i);let t=this.T(o,u[u.length-1]);for(let d=u.length-2;d>=0;d--)t=this.T(t,u[d]);this.N(t),this.v(a)}q(i,o){this.Q(i,o)&&(i+=`
`);const a=this.w(i),u=this.S(o,a[0]);let t=u;for(let d=1;d<a.length;d++)t=this.S(t,a[d]);this.N(u)}s(i,o,a){const u=i.piece,t=i.piece.bufferIndex,d=this.a[t].lineStarts,b=d[u.start.line]+u.start.column+o;let E=u.start.line,h=u.end.line,v=0,P=0,g=0;for(;E<=h&&(v=E+(h-E)/2|0,g=d[v],v!==h);)if(P=d[v+1],b<g)h=v-1;else if(b>=P)E=v+1;else break;return a?(a.line=v,a.column=b-g,null):{line:v,column:b-g}}t(i,o,a){if(a.column===0)return a.line-o.line;const u=this.a[i].lineStarts;if(a.line===u.length-1)return a.line-o.line;const t=u[a.line+1],d=u[a.line]+a.column;if(t>d+1)return a.line-o.line;const n=d-1;return this.a[i].buffer.charCodeAt(n)===13?a.line-o.line+1:a.line-o.line}u(i,o){return this.a[i].lineStarts[o.line]+o.column}v(i){for(let o=0;o<i.length;o++)(0,A.$1B)(this,i[o])}w(i){if(i.length>m){const h=[];for(;i.length>m;){const P=i.charCodeAt(m-1);let g;P===13||P>=55296&&P<=56319?(g=i.substring(0,m-1),i=i.substring(m-1)):(g=i.substring(0,m),i=i.substring(m));const p=L(g);h.push(new l(this.a.length,{line:0,column:0},{line:p.length-1,column:g.length-p[p.length-1]},p.length-1,g.length)),this.a.push(new $(g,p))}const v=L(i);return h.push(new l(this.a.length,{line:0,column:0},{line:v.length-1,column:i.length-v[v.length-1]},v.length-1,i.length)),this.a.push(new $(i,v)),h}let o=this.a[0].buffer.length;const a=L(i,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let h=0;h<a.length;h++)a[h]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+i,o+=1}else{if(o!==0)for(let h=0;h<a.length;h++)a[h]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,n=t-this.a[0].lineStarts[d],b={line:d,column:n},E=new l(0,u,b,this.t(0,u,b),t-o);return this.g=b,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,o=0){let a=this.root,u="";const t=this.h.get2(i);if(t){a=t.node;const d=this.B(a,i-t.nodeStartLineNumber-1),n=this.a[a.piece.bufferIndex].buffer,b=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===i)u=n.substring(b+d,b+a.piece.length);else{const E=this.B(a,i-t.nodeStartLineNumber);return n.substring(b+d,b+E-o)}}else{let d=0;const n=i;for(;a!==A.$VB;)if(a.left!==A.$VB&&a.lf_left>=i-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>i-1){const b=this.B(a,i-a.lf_left-2),E=this.B(a,i-a.lf_left-1),h=this.a[a.piece.bufferIndex].buffer,v=this.u(a.piece.bufferIndex,a.piece.start);return d+=a.size_left,this.h.set({node:a,nodeStartOffset:d,nodeStartLineNumber:n-(i-1-a.lf_left)}),h.substring(v+b,v+E-o)}else if(a.lf_left+a.piece.lineFeedCnt===i-1){const b=this.B(a,i-a.lf_left-2),E=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);u=E.substring(h+b,h+a.piece.length);break}else i-=a.lf_left+a.piece.lineFeedCnt,d+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==A.$VB;){const d=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const n=this.B(a,0),b=this.u(a.piece.bufferIndex,a.piece.start);return u+=d.substring(b,b+n-o),u}else{const n=this.u(a.piece.bufferIndex,a.piece.start);u+=d.substr(n,a.piece.length)}a=a.next()}return u}y(){let i=this.root,o=1,a=0;for(;i!==A.$VB;)o+=i.lf_left+i.piece.lineFeedCnt,a+=i.size_left+i.piece.length,i=i.right;this.b=o,this.c=a,this.h.validate(this.c)}A(i,o){const a=i.piece,u=this.s(i,o),t=u.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===o){const d=this.t(i.piece.bufferIndex,a.start,u);if(d!==t)return{index:d,remainder:0}}return{index:t,remainder:u.column}}B(i,o){if(o<0)return 0;const a=i.piece,u=this.a[a.bufferIndex].lineStarts,t=a.start.line+o+1;return t>a.end.line?u[a.end.line]+a.end.column-u[a.start.line]-a.start.column:u[t]-u[a.start.line]-a.start.column}C(i,o){const a=i.piece,u=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),d=o,n=this.u(a.bufferIndex,d),b=this.t(a.bufferIndex,a.start,d),E=b-u,h=n-t,v=a.length+h;i.piece=new l(a.bufferIndex,a.start,d,b,v),(0,A.$3B)(this,i,h,E)}D(i,o){const a=i.piece,u=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),d=o,n=this.t(a.bufferIndex,d,a.end),b=this.u(a.bufferIndex,d),E=n-u,h=t-b,v=a.length+h;i.piece=new l(a.bufferIndex,d,a.end,n,v),(0,A.$3B)(this,i,h,E)}E(i,o,a){const u=i.piece,t=u.start,d=u.end,n=u.length,b=u.lineFeedCnt,E=o,h=this.t(u.bufferIndex,u.start,E),v=this.u(u.bufferIndex,o)-this.u(u.bufferIndex,t);i.piece=new l(u.bufferIndex,u.start,E,h,v),(0,A.$3B)(this,i,v-n,h-b);const P=new l(u.bufferIndex,a,d,this.t(u.bufferIndex,a,d),this.u(u.bufferIndex,d)-this.u(u.bufferIndex,a)),g=this.S(i,P);this.N(g)}F(i,o){this.Q(o,i)&&(o+=`
`);const a=this.K()&&this.L(o)&&this.M(i),u=this.a[0].buffer.length;this.a[0].buffer+=o;const t=L(o,!1);for(let g=0;g<t.length;g++)t[g]+=u;if(a){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const d=this.a[0].lineStarts.length-1,n=this.a[0].buffer.length-this.a[0].lineStarts[d],b={line:d,column:n},E=i.piece.length+o.length,h=i.piece.lineFeedCnt,v=this.t(0,i.piece.start,b),P=v-h;i.piece=new l(i.piece.bufferIndex,i.piece.start,b,v,E),this.g=b,(0,A.$3B)(this,i,o.length,P)}G(i){let o=this.root;const a=this.h.get(i);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:i-a.nodeStartOffset};let u=0;for(;o!==A.$VB;)if(o.size_left>i)o=o.left;else if(o.size_left+o.piece.length>=i){u+=o.size_left;const t={node:o,remainder:i-o.size_left,nodeStartOffset:u};return this.h.set(t),t}else i-=o.size_left+o.piece.length,u+=o.size_left+o.piece.length,o=o.right;return null}H(i,o){let a=this.root,u=0;for(;a!==A.$VB;)if(a.left!==A.$VB&&a.lf_left>=i-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>i-1){const t=this.B(a,i-a.lf_left-2),d=this.B(a,i-a.lf_left-1);return u+=a.size_left,{node:a,remainder:Math.min(t+o-1,d),nodeStartOffset:u}}else if(a.lf_left+a.piece.lineFeedCnt===i-1){const t=this.B(a,i-a.lf_left-2);if(t+o-1<=a.piece.length)return{node:a,remainder:t+o-1,nodeStartOffset:u};o-=a.piece.length-t;break}else i-=a.lf_left+a.piece.lineFeedCnt,u+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==A.$VB;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),d=this.J(a);return{node:a,remainder:Math.min(o-1,t),nodeStartOffset:d}}else if(a.piece.length>=o-1){const t=this.J(a);return{node:a,remainder:o-1,nodeStartOffset:t}}else o-=a.piece.length;a=a.next()}return null}I(i,o){if(i.piece.lineFeedCnt<1)return-1;const a=this.a[i.piece.bufferIndex],u=this.u(i.piece.bufferIndex,i.piece.start)+o;return a.buffer.charCodeAt(u)}J(i){if(!i)return 0;let o=i.size_left;for(;i!==this.root;)i.parent.right===i&&(o+=i.parent.size_left+i.parent.piece.length),i=i.parent;return o}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$VB||i.piece.lineFeedCnt===0)return!1;const o=i.piece,a=this.a[o.bufferIndex].lineStarts,u=o.start.line,t=a[u]+o.start.column;return u===a.length-1||a[u+1]>t+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$VB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const o=i.prev();this.M(o)&&this.P(o,i)}}O(i){if(this.K()&&this.M(i)){const o=i.next();this.L(o)&&this.P(i,o)}}P(i,o){const a=[],u=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:u[i.piece.end.line]-u[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,n=i.piece.lineFeedCnt-1;i.piece=new l(i.piece.bufferIndex,i.piece.start,t,n,d),(0,A.$3B)(this,i,-1,-1),i.piece.length===0&&a.push(i);const b={line:o.piece.start.line+1,column:0},E=o.piece.length-1,h=this.t(o.piece.bufferIndex,b,o.piece.end);o.piece=new l(o.piece.bufferIndex,b,o.piece.end,h,E),(0,A.$3B)(this,o,-1,-1),o.piece.length===0&&a.push(o);const v=this.w(`\r
`);this.S(i,v[0]);for(let P=0;P<a.length;P++)(0,A.$1B)(this,a[P])}Q(i,o){if(this.K()&&this.M(i)){const a=o.next();if(this.L(a)){if(i+=`
`,a.piece.length===1)(0,A.$1B)(this,a);else{const u=a.piece,t={line:u.start.line+1,column:0},d=u.length-1,n=this.t(u.bufferIndex,t,u.end);a.piece=new l(u.bufferIndex,t,u.end,n,d),(0,A.$3B)(this,a,-1,-1)}return!0}}return!1}iterate(i,o){if(i===A.$VB)return o(A.$VB);const a=this.iterate(i.left,o);return a&&o(i)&&this.iterate(i.right,o)}R(i){if(i===A.$VB)return"";const o=this.a[i.piece.bufferIndex],a=i.piece,u=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return o.buffer.substring(u,t)}getPieceContent(i){const o=this.a[i.bufferIndex],a=this.u(i.bufferIndex,i.start),u=this.u(i.bufferIndex,i.end);return o.buffer.substring(a,u)}S(i,o){const a=new A.$UB(o,1);if(a.left=A.$VB,a.right=A.$VB,a.parent=A.$VB,a.size_left=0,a.lf_left=0,this.root===A.$VB)this.root=a,a.color=0;else if(i.right===A.$VB)i.right=a,a.parent=i;else{const t=(0,A.$WB)(i.right);t.left=a,a.parent=t}return(0,A.$2B)(this,a),a}T(i,o){const a=new A.$UB(o,1);if(a.left=A.$VB,a.right=A.$VB,a.parent=A.$VB,a.size_left=0,a.lf_left=0,this.root===A.$VB)this.root=a,a.color=0;else if(i.left===A.$VB)i.left=a,a.parent=i;else{const u=(0,A.$XB)(i.left);u.right=a,a.parent=u}return(0,A.$2B)(this,a),a}U(i){let o="";return this.iterate(i,a=>(o+=this.R(a),!0)),o}}e.$cC=c}),define(Ae[133],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T8=e.$S8=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const R=this.a.get(A);return this.a.delete(A),R}}addDragOperationTransfer(A,R){this.a.set(A,R)}}e.$S8=S;class M{constructor(A){this.identifier=A}}e.$T8=M}),define(Ae[134],Me([9,10]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(Ae[135],Me([1,0,5,6,134]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class A extends M.$Tc{constructor(l,$="",w="",r=!0,c){super(),this.h=this.B(new S.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=$,this.u=w,this.w=r,this.C=c}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,$){this.C&&await this.C(l)}}e.$Mi=A;class R extends M.$Tc{constructor(){super(...arguments),this.f=this.B(new S.$Wd),this.onWillRun=this.f.event,this.m=this.B(new S.$Wd),this.onDidRun=this.m.event}async run(l,$){if(!l.enabled)return;this.f.fire({action:l});let w;try{await this.u(l,$)}catch(r){w=r}this.m.fire({action:l,error:w})}async u(l,$){await l.run($)}}e.$Ni=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let $=[];for(const w of l)w.length&&($.length?$=[...$,new m,...w]:$=w);return $}static{this.ID="vs.actions.separator"}async run(){}}e.$Oi=m;class f{get actions(){return this.a}constructor(l,$,w,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=$,this.class=r,this.a=w}async run(){}}e.$Pi=f;class D extends A{static{this.ID="vs.actions.empty"}constructor(){super(D.ID,I.localize(0,null),void 0,!1)}}e.$Qi=D;function L(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked,run:async(...l)=>k.run(...l),tooltip:k.label}}e.$Ri=L}),define(Ae[136],Me([9,10]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(Ae[137],Me([1,0,136]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0;const M=60,I=M*60,A=I*24,R=A*7,m=A*30,f=A*365;function D(l,$,w,r){typeof l!="number"&&(l=l.getTime());const c=Math.round((new Date().getTime()-l)/1e3);if(c<-30)return(0,S.localize)(0,null,D(new Date().getTime()+c*1e3,!1));if(!r&&c<30)return(0,S.localize)(1,null);let s;return c<M?(s=c,$?s===1?w?(0,S.localize)(2,null,s):(0,S.localize)(3,null,s):w?(0,S.localize)(4,null,s):(0,S.localize)(5,null,s):s===1?w?(0,S.localize)(6,null,s):(0,S.localize)(7,null,s):w?(0,S.localize)(8,null,s):(0,S.localize)(9,null,s)):c<I?(s=Math.floor(c/M),$?s===1?w?(0,S.localize)(10,null,s):(0,S.localize)(11,null,s):w?(0,S.localize)(12,null,s):(0,S.localize)(13,null,s):s===1?w?(0,S.localize)(14,null,s):(0,S.localize)(15,null,s):w?(0,S.localize)(16,null,s):(0,S.localize)(17,null,s)):c<A?(s=Math.floor(c/I),$?s===1?w?(0,S.localize)(18,null,s):(0,S.localize)(19,null,s):w?(0,S.localize)(20,null,s):(0,S.localize)(21,null,s):s===1?w?(0,S.localize)(22,null,s):(0,S.localize)(23,null,s):w?(0,S.localize)(24,null,s):(0,S.localize)(25,null,s)):c<R?(s=Math.floor(c/A),$?s===1?(0,S.localize)(26,null,s):(0,S.localize)(27,null,s):s===1?(0,S.localize)(28,null,s):(0,S.localize)(29,null,s)):c<m?(s=Math.floor(c/R),$?s===1?w?(0,S.localize)(30,null,s):(0,S.localize)(31,null,s):w?(0,S.localize)(32,null,s):(0,S.localize)(33,null,s):s===1?w?(0,S.localize)(34,null,s):(0,S.localize)(35,null,s):w?(0,S.localize)(36,null,s):(0,S.localize)(37,null,s)):c<f?(s=Math.floor(c/m),$?s===1?w?(0,S.localize)(38,null,s):(0,S.localize)(39,null,s):w?(0,S.localize)(40,null,s):(0,S.localize)(41,null,s):s===1?w?(0,S.localize)(42,null,s):(0,S.localize)(43,null,s):w?(0,S.localize)(44,null,s):(0,S.localize)(45,null,s)):(s=Math.floor(c/f),$?s===1?w?(0,S.localize)(46,null,s):(0,S.localize)(47,null,s):w?(0,S.localize)(48,null,s):(0,S.localize)(49,null,s):s===1?w?(0,S.localize)(50,null,s):(0,S.localize)(51,null,s):w?(0,S.localize)(52,null,s):(0,S.localize)(53,null,s))}e.$xm=D;function L(l,$){const w=Math.abs(l/1e3);return w<1?$?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):w<M?$?(0,S.localize)(56,null,Math.round(l)/1e3):(0,S.localize)(57,null,Math.round(l)/1e3):w<I?$?(0,S.localize)(58,null,Math.round(l/(1e3*M))):(0,S.localize)(59,null,Math.round(l/(1e3*M))):w<A?$?(0,S.localize)(60,null,Math.round(l/(1e3*I))):(0,S.localize)(61,null,Math.round(l/(1e3*I))):(0,S.localize)(62,null,Math.round(l/(1e3*A)))}e.$ym=L;function k(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$zm=k}),define(Ae[138],Me([9,10]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(Ae[41],Me([1,0,18,16,138]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=void 0;function A(k,l){return l&&(k.stack||k.stacktrace)?I.localize(0,null,m(k),R(k.stack)||R(k.stacktrace)):m(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function m(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?I.localize(1,null,k.message):k.message||I.localize(2,null)}function f(k=null,l=!1){if(!k)return I.localize(3,null);if(Array.isArray(k)){const $=S.$Hb(k),w=f($[0],l);return $.length>1?I.localize(4,null,w,$.length):w}if(M.$Jf(k))return k;if(k.detail){const $=k.detail;if($.error)return A($.error,l);if($.exception)return A($.exception,l)}return k.stack?A(k,l):k.message?k.message:I.localize(5,null)}e.$Si=f;function D(k){const l=k;return l instanceof Error&&Array.isArray(l.actions)}e.$Ti=D;function L(k,l){let $;return typeof k=="string"?$=new Error(k):$=k,$.actions=l,$}e.$Ui=L}),define(Ae[139],Me([1,0,39,19]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=void 0;const I=new S.$V(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),A=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(P,g,p=!1){const y=P||"",T=g||"",N=I.value.collator.compare(y,T);return I.value.collatorIsNumeric&&N===0&&y!==T?y<T?-1:1:N}e.$Kq=m;function f(P,g){const p=A.value.collator;return P=P||"",g=g||"",a(p,P,g)}e.$Lq=f;function D(P,g){const p=A.value.collator;return P=P||"",g=g||"",n(P,g)||a(p,P,g)}e.$Mq=D;function L(P,g){const p=A.value.collator;return P=P||"",g=g||"",d(P,g)||a(p,P,g)}e.$Nq=L;function k(P,g){return P=P||"",g=g||"",P===g?0:P<g?-1:1}e.$Oq=k;function l(P,g){const[p,y]=i(P),[T,N]=i(g);let J=I.value.collator.compare(y,N);if(J===0){if(I.value.collatorIsNumeric&&y!==N)return y<N?-1:1;if(J=I.value.collator.compare(p,T),I.value.collatorIsNumeric&&J===0&&p!==T)return p<T?-1:1}return J}e.$Pq=l;function $(P,g){P=P||"",g=g||"";const p=o(P),y=o(g),T=A.value.collator,N=R.value.collator;return a(N,p,y)||a(T,P,g)}e.$Qq=$;function w(P,g){P=P||"",g=g||"";const p=o(P),y=o(g),T=A.value.collator,N=R.value.collator;return a(N,p,y)||n(P,g)||a(T,P,g)}e.$Rq=w;function r(P,g){P=P||"",g=g||"";const p=o(P),y=o(g),T=A.value.collator,N=R.value.collator;return a(N,p,y)||d(P,g)||a(T,P,g)}e.$Sq=r;function c(P,g){P=P||"",g=g||"";const p=o(P).toLowerCase(),y=o(g).toLowerCase();return p!==y?p<y?-1:1:P!==g?P<g?-1:1:0}e.$Tq=c;const s=/^(.*?)(\.([^.]*))?$/;function i(P,g=!1){const p=P?s.exec(P):[];let y=[p&&p[1]||"",p&&p[3]||""];return g&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function o(P){const g=P?s.exec(P):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function a(P,g,p){const y=P.compare(g,p);return y!==0?y:g.length!==p.length?g.length<p.length?-1:1:0}function u(P){const g=P.charAt(0);return g.toLocaleUpperCase()!==g}function t(P){const g=P.charAt(0);return g.toLocaleLowerCase()!==g}function d(P,g){return u(P)&&t(g)?-1:t(P)&&u(g)?1:0}function n(P,g){return t(P)&&u(g)?-1:u(P)&&t(g)?1:0}function b(P,g,p=!1){return p||(P=P&&P.toLowerCase(),g=g&&g.toLowerCase()),P===g?0:P<g?-1:1}function E(P,g,p=!1){const y=P.split(M.sep),T=g.split(M.sep),N=y.length-1,J=T.length-1;let q,U;for(let C=0;;C++){if(q=N===C,U=J===C,q&&U)return m(y[C],T[C],p);if(q)return-1;if(U)return 1;const F=b(y[C],T[C],p);if(F!==0)return F}}e.$Uq=E;function h(P,g,p){const y=P.toLowerCase(),T=g.toLowerCase(),N=v(P,g,p);if(N)return N;const J=y.endsWith(p),q=T.endsWith(p);if(J!==q)return J?-1:1;const U=m(y,T);return U!==0?U:y.localeCompare(T)}e.$Vq=h;function v(P,g,p){const y=P.toLowerCase(),T=g.toLowerCase(),N=y.startsWith(p),J=T.startsWith(p);if(N!==J)return N?-1:1;if(N&&J){if(y.length<T.length)return-1;if(y.length>T.length)return 1}return 0}e.$Wq=v}),define(Ae[45],Me([1,0,19,20,13,16]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function R(h){return h===47||h===92}e.$2f=R;function m(h){return h.replace(/[\\/]/g,S.$gc.sep)}e.$3f=m;function f(h){return h.indexOf("/")===-1&&(h=m(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$4f=f;function D(h,v=S.$gc.sep){if(!h)return"";const P=h.length,g=h.charCodeAt(0);if(R(g)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let y=3;const T=y;for(;y<P&&!R(h.charCodeAt(y));y++);if(T!==y&&!R(h.charCodeAt(y+1))){for(y+=1;y<P;y++)if(R(h.charCodeAt(y)))return h.slice(0,y+1).replace(/[\\/]/g,v)}}return v}else if(s(g)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+v:h.slice(0,2);let p=h.indexOf("://");if(p!==-1){for(p+=3;p<P;p++)if(R(h.charCodeAt(p)))return h.slice(0,p+1)}return""}e.$5f=D;function L(h){if(!M.$i||!h||h.length<5)return!1;let v=h.charCodeAt(0);if(v!==92||(v=h.charCodeAt(1),v!==92))return!1;let P=2;const g=P;for(;P<h.length&&(v=h.charCodeAt(P),v!==92);P++);return!(g===P||(v=h.charCodeAt(P+1),isNaN(v)||v===92))}e.$6f=L;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(h,v=M.$i){const P=v?k:l;return!(!h||h.length===0||/^\s+$/.test(h)||(P.lastIndex=0,P.test(h))||v&&$.test(h)||h==="."||h===".."||v&&h[h.length-1]==="."||v&&h.length!==h.trim().length||h.length>255)}e.$7f=w;function r(h,v,P){const g=h===v;return!P||g?g:!h||!v?!1:(0,I.$af)(h,v)}e.$8f=r;function c(h,v,P,g=S.sep){if(h===v)return!0;if(!h||!v||v.length>h.length)return!1;if(P){if(!(0,I.$bf)(h,v))return!1;if(v.length===h.length)return!0;let y=v.length;return v.charAt(v.length-1)===g&&y--,h.charAt(y)===g}return v.charAt(v.length-1)!==g&&(v+=g),h.indexOf(v)===0}e.$9f=c;function s(h){return h>=65&&h<=90||h>=97&&h<=122}e.$0f=s;function i(h,v){return M.$i&&h.endsWith(":")&&(h+=S.sep),(0,S.$ic)(h)||(h=(0,S.$jc)(v,h)),h=(0,S.$hc)(h),M.$i?(h=(0,I.$Ve)(h,S.sep),h.endsWith(":")&&(h+=S.sep)):(h=(0,I.$Ve)(h,S.sep),h||(h=S.sep)),h}e.$$f=i;function o(h){const v=(0,S.$hc)(h);return M.$i?h.length>3?!1:a(v)&&(h.length===2||v.charCodeAt(2)===92):v===S.$gc.sep}e.$_f=o;function a(h,v=M.$i){return v?s(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$ag=a;function u(h,v=M.$i){return a(h,v)?h[0]:void 0}e.$bg=u;function t(h,v,P){return v.length>h.length?-1:h===v?0:(P&&(h=h.toLowerCase(),v=v.toLowerCase()),h.indexOf(v))}e.$cg=t;function d(h){const v=h.split(":");let P,g,p;for(const y of v){const T=Number(y);(0,A.$Nf)(T)?g===void 0?g=T:p===void 0&&(p=T):P=P?[P,y].join(":"):y}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:g!==void 0?g:void 0,column:p!==void 0?p:g!==void 0?1:void 0}}e.$dg=d;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",b="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(h,v,P=8){let g="";for(let y=0;y<P;y++){let T;y===0&&M.$i&&!v&&(P===3||P===4)?T=b:T=n,g+=T.charAt(Math.floor(Math.random()*T.length))}let p;return v?p=`${v}-${g}`:p=g,h?(0,S.$jc)(h,p):p}e.$eg=E}),define(Ae[69],Me([1,0,19]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=e.$hs=void 0,e.$hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(L){const k=(0,S.$oc)(L),l=M[k.toLowerCase()];return l!==void 0?l:R(L)}e.$is=A;function R(L){const k=(0,S.$oc)(L);return I[k.toLowerCase()]}e.$js=R;function m(L){for(const k in I)if(I[k]===L)return k}e.$ks=m;const f=/^(.+)\/(.+?)(;.+)?$/;function D(L,k){const l=f.exec(L);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:k?void 0:L}e.$ls=D}),define(Ae[52],Me([1,0,23,2]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function I(f){return JSON.stringify(f,R)}e.$Ch=I;function A(f){let D=JSON.parse(f);return D=m(D),D}e.$Dh=A;function R(f,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:D.flags}:D}function m(f,D=0){if(!f||D>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return M.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof S.$ke||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let L=0;L<f.length;++L)f[L]=m(f[L],D+1);else for(const L in f)Object.hasOwnProperty.call(f,L)&&(f[L]=m(f[L],D+1))}return f}e.$Eh=m}),define(Ae[12],Me([1,0,15,20,13,2]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var R;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function m(l,$){return A.URI.isUri(l)?(0,I.$af)(l.scheme,$):(0,I.$bf)(l,$+":")}e.$fg=m;function f(l,...$){return $.some(w=>m(l,w))}e.$gg=f,e.$hg="vscode-tkn",e.$ig="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${R.vscodeRemoteResource}`}set($,w,r){this.a[$]=w,this.b[$]=r}setConnectionToken($,w){this.c[$]=w}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(o){return S.$1(o),$}const w=$.authority;let r=this.a[w];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const c=this.b[w],s=this.c[w];let i=`path=${encodeURIComponent($.path)}`;return typeof s=="string"&&(i+=`&${e.$ig}=${encodeURIComponent(s)}`),A.URI.from({scheme:M.$o?this.d:R.vscodeRemoteResource,authority:`${r}:${c}`,path:this.f,query:i})}}e.$jg=new D,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class L{static{this.a=e.$og}asBrowserUri($){const w=this.b($,fe);return this.uriToBrowserUri(w)}uriToBrowserUri($){return $.scheme===R.vscodeRemote?e.$jg.rewrite($):$.scheme===R.file&&(M.$m||M.$q===`${R.vscodeFileResource}://${L.a}`)?$.with({scheme:R.vscodeFileResource,authority:$.authority||L.a,query:null,fragment:null}):$}asFileUri($){const w=this.b($,fe);return this.uriToFileUri(w)}uriToFileUri($){return $.scheme===R.vscodeFileResource?$.with({scheme:R.file,authority:$.authority!==L.a?$.authority:null,query:null,fragment:null}):$}b($,w){return A.URI.isUri($)?$:A.URI.parse(w.toUrl($))}}e.$pg=new L;var k;(function(l){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze($.get("3"));const w="vscode-coi";function r(s){let i;typeof s=="string"?i=new URL(s).searchParams:s instanceof URL?i=s.searchParams:A.URI.isUri(s)&&(i=new URL(s.toString(!0)).searchParams);const o=i?.get(w);if(o)return $.get(o)}l.getHeadersFromQuery=r;function c(s,i,o){if(!globalThis.crossOriginIsolated)return;const a=i&&o?"3":o?"2":"1";s instanceof URLSearchParams?s.set(w,a):s[w]=a}l.addSearchParam=c})(k||(e.COI=k={}))}),define(Ae[24],Me([1,0,45,12,19,20,13,2]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function f($){return(0,m.$wc)($,!0)}e.$wg=f;class D{constructor(w){this.a=w}compare(w,r,c=!1){return w===r?0:(0,R.$6e)(this.getComparisonKey(w,c),this.getComparisonKey(r,c))}isEqual(w,r,c=!1){return w===r?!0:!w||!r?!1:this.getComparisonKey(w,c)===this.getComparisonKey(r,c)}getComparisonKey(w,r=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,r,c=!1){if(w.scheme===r.scheme){if(w.scheme===M.Schemas.file)return S.$9f(f(w),f(r),this.a(w))&&w.query===r.query&&(c||w.fragment===r.fragment);if((0,e.$Ng)(w.authority,r.authority))return S.$9f(w.path,r.path,this.a(w),"/")&&w.query===r.query&&(c||w.fragment===r.fragment)}return!1}joinPath(w,...r){return m.URI.joinPath(w,...r)}basenameOrAuthority(w){return(0,e.$Fg)(w)||w.authority}basename(w){return I.$gc.basename(w.path)}extname(w){return I.$gc.extname(w.path)}dirname(w){if(w.path.length===0)return w;let r;return w.scheme===M.Schemas.file?r=m.URI.file(I.$mc(f(w))).path:(r=I.$gc.dirname(w.path),w.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),r="/")),w.with({path:r})}normalizePath(w){if(!w.path.length)return w;let r;return w.scheme===M.Schemas.file?r=m.URI.file(I.$hc(f(w))).path:r=I.$gc.normalize(w.path),w.with({path:r})}relativePath(w,r){if(w.scheme!==r.scheme||!(0,e.$Ng)(w.authority,r.authority))return;if(w.scheme===M.Schemas.file){const i=I.$lc(f(w),f(r));return A.$i?S.$3f(i):i}let c=w.path||"/";const s=r.path||"/";if(this.a(w)){let i=0;for(const o=Math.min(c.length,s.length);i<o&&!(c.charCodeAt(i)!==s.charCodeAt(i)&&c.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);c=s.substr(0,i)+c.substr(i)}return I.$gc.relative(c,s)}resolvePath(w,r){if(w.scheme===M.Schemas.file){const c=m.URI.file(I.$kc(f(w),r));return w.with({authority:c.authority,path:c.path})}return r=S.$4f(r),w.with({path:I.$gc.resolve(w.path,r)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,r){return w===r||w!==void 0&&r!==void 0&&(0,R.$af)(w,r)}hasTrailingPathSeparator(w,r=I.sep){if(w.scheme===M.Schemas.file){const c=f(w);return c.length>S.$5f(c).length&&c[c.length-1]===r}else{const c=w.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,r=I.sep){return(0,e.$Og)(w,r)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,r=I.sep){let c=!1;if(w.scheme===M.Schemas.file){const s=f(w);c=s!==void 0&&s.length===S.$5f(s).length&&s[s.length-1]===r}else{r="/";const s=w.path;c=s.length===1&&s.charCodeAt(s.length-1)===47}return!c&&!(0,e.$Og)(w,r)?w.with({path:w.path+"/"}):w}}e.$xg=D,e.$yg=new D(()=>!1),e.$zg=new D($=>$.scheme===M.Schemas.file?!A.$k:!0),e.$Ag=new D($=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function L($,w){const r=[];for(let c=0;c<$.length;c++){const s=w($[c]);$.some((i,o)=>o===c?!1:(0,e.$Cg)(s,w(i)))||r.push($[c])}return r}e.$Rg=L;var k;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function w(r){const c=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(o=>{const[a,u]=o.split(":");a&&u&&c.set(a,u)});const i=r.path.substring(0,r.path.indexOf(";"));return i&&c.set($.META_DATA_MIME,i),c}$.parseMetaData=w})(k||(e.DataUri=k={}));function l($,w,r){if(w){let c=$.path;return c&&c[0]!==I.$gc.sep&&(c=I.$gc.sep+c),$.with({scheme:r,authority:w,path:c})}return $.with({scheme:r})}e.$Sg=l}),define(Ae[11],Me([1,0,21,15,5,6,24,20,126,39]),function(fe,e,S,M,I,A,R,m,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.Promises=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function L(me){return!!me&&typeof me.then=="function"}e.$Tg=L;function k(me){const G=new S.$7d,_=me(G.token),le=new Promise((de,Le)=>{const ge=G.token.onCancellationRequested(()=>{ge.dispose(),Le(new M.$5)});Promise.resolve(_).then(ke=>{ge.dispose(),G.dispose(),de(ke)},ke=>{ge.dispose(),G.dispose(),Le(ke)})});return new class{cancel(){G.cancel(),G.dispose()}then(de,Le){return le.then(de,Le)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}e.$Ug=k;function l(me,G,_){return new Promise((le,de)=>{const Le=G.onCancellationRequested(()=>{Le.dispose(),le(_)});me.then(le,de).finally(()=>Le.dispose())})}e.$Vg=l;function $(me,G){return new Promise((_,le)=>{const de=G.onCancellationRequested(()=>{de.dispose(),le(new M.$5)});me.then(_,le).finally(()=>de.dispose())})}e.$Wg=$;async function w(me){let G=-1;const _=me.map((le,de)=>le.then(Le=>(G=de,Le)));try{return await Promise.race(_)}finally{me.forEach((le,de)=>{de!==G&&le.cancel()})}}e.$Xg=w;function r(me,G,_){let le;const de=setTimeout(()=>{le?.(void 0),_?.()},G);return Promise.race([me.finally(()=>clearTimeout(de)),new Promise(Le=>le=Le)])}e.$Yg=r;function c(me){return new Promise((G,_)=>{const le=me();L(le)?le.then(G,_):G(le)})}e.$Zg=c;function s(){let me,G;return{promise:new Promise((le,de)=>{me=le,G=de}),resolve:me,reject:G}}e.$1g=s;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const _=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(_,_).then(le)})}return new Promise((_,le)=>{this.b.then(_,le)})}return this.a=G(),new Promise((_,le)=>{this.a.then(de=>{this.a=null,_(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$2g=i;class o{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$3g=o;class a{constructor(){this.a=new Map}queue(G,_){const de=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(G)===de&&this.a.delete(G)});return this.a.set(G,de),de}}e.$4g=a;const u=(me,G)=>{let _=!0;const le=setTimeout(()=>{_=!1,G()},me);return{isTriggered:()=>_,dispose:()=>{clearTimeout(le),_=!1}}},t=me=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,me())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class d{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,_=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((de,Le)=>{this.d=de,this.f=Le}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=_===f.$Td?t(le):u(_,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$5g=d;class n{constructor(G){this.a=new d(G),this.b=new i}trigger(G,_){return this.a.trigger(()=>this.b.queue(G),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$6g=n;class b{constructor(){this.a=!1,this.b=new Promise((G,_)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$7g=b;class E extends b{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$8g=E;function h(me,G){return G?new Promise((_,le)=>{const de=setTimeout(()=>{Le.dispose(),_()},me),Le=G.onCancellationRequested(()=>{clearTimeout(de),Le.dispose(),le(new M.$5)})}):k(_=>h(me,_))}e.$9g=h;function v(me,G=0,_){const le=setTimeout(()=>{me(),_&&de.dispose()},G),de=(0,A.$Rc)(()=>{clearTimeout(le),_?.deleteAndLeak(de)});return _?.add(de),de}e.$0g=v;function P(me){const G=[];let _=0;const le=me.length;function de(){return _<le?me[_++]():null}function Le(ge){ge!=null&&G.push(ge);const ke=de();return ke?ke.then(Le):Promise.resolve(G)}return Promise.resolve(null).then(Le)}e.$$g=P;function g(me,G=le=>!!le,_=null){let le=0;const de=me.length,Le=()=>{if(le>=de)return Promise.resolve(_);const ge=me[le++];return Promise.resolve(ge()).then(Ie=>G(Ie)?Promise.resolve(Ie):Le())};return Le()}e.$_g=g;function p(me,G=le=>!!le,_=null){if(me.length===0)return Promise.resolve(_);let le=me.length;const de=()=>{le=-1;for(const Le of me)Le.cancel?.()};return new Promise((Le,ge)=>{for(const ke of me)ke.then(Ie=>{--le>=0&&G(Ie)?(de(),Le(Ie)):le===0&&Le(_)}).catch(Ie=>{--le>=0&&(de(),ge(Ie))})})}e.$ah=p;class y{constructor(G){this.a=0,this.b=!1,this.f=G,this.g=[],this.d=0,this.h=new I.$Wd}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(G){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((_,le)=>{this.g.push({factory:G,c:_,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const G=this.g.shift();this.d++;const _=G.factory();_.then(G.c,G.e),_.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$bh=y;class T extends y{constructor(){super(1)}}e.$ch=T;class N{constructor(){this.a=new he,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$dh=N;class J{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new $e;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueSize(G,_=R.$yg){const le=_.getComparisonKey(G);return this.a.get(le)?.size??0}queueFor(G,_,le=R.$yg){const de=le.getComparisonKey(G);let Le=this.a.get(de);if(!Le){Le=new T;const ge=this.f++,ke=I.Event.once(Le.onDrained)(()=>{Le?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(ge,ke),this.a.set(de,Le)}return Le.queue(_)}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$eh=J;class q{constructor(G,_){this.a=-1,typeof G=="function"&&typeof _=="number"&&this.setIfNotSet(G,_)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,_){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},_)}setIfNotSet(G,_){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},_))}}e.$fh=q;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,_,le=globalThis){this.cancel();const de=le.setInterval(()=>{G()},_);this.d=(0,A.$Rc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$gh=U;class C{constructor(G,_){this.b=-1,this.a=G,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$hh=C;class F{constructor(G,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=G,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ih=F;class W extends C{constructor(G,_){super(G,_),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$jh=W;class re extends A.$Tc{constructor(G,_){super(),this.g=G,this.h=_,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of G)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$kh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$mh=(me,G)=>{(0,m.$B)(()=>{if(_)return;const le=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.$mh=(me,G,_)=>{const le=me.requestIdleCallback(G,typeof _=="number"?{timeout:_}:void 0);let de=!1;return{dispose(){de||(de=!0,me.cancelIdleCallback(le))}}},e.$lh=me=>(0,e.$mh)(globalThis,me)}();class ce{constructor(G,_){this.g=!1,this.d=()=>{try{this.j=_()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$mh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$nh=ce;class we extends ce{constructor(G){super(globalThis,G)}}e.$oh=we;async function De(me,G,_){let le;for(let de=0;de<_;de++)try{return await me()}catch(Le){le=Le,await h(G)}throw le}e.$ph=De;class he{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,_,le){return this.a={taskId:G,cancel:()=>le?.(),promise:_},_.then(()=>this.d(G),()=>this.d(G)),_}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{const{promise:_,resolve:le,reject:de}=s();this.b={run:G,promise:_,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$qh=he;class ve{constructor(G,_=()=>Date.now()){this.d=G,this.f=_,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$rh=ve;var se;(function(me){me[me.Resolved=0]="Resolved",me[me.Rejected=1]="Rejected"})(se||(se={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,_)=>{this.a=G,this.b=_})}complete(G){return new Promise(_=>{this.a(G),this.d={outcome:0,value:G},_()})}error(G){return new Promise(_=>{this.b(G),this.d={outcome:1,value:G},_()})}cancel(){return this.error(new M.$5)}}e.$sh=$e;var te;(function(me){async function G(le){let de;const Le=await Promise.all(le.map(ge=>ge.then(ke=>ke,ke=>{de||(de=ke)})));if(typeof de<"u")throw de;return Le}me.settled=G;function _(le){return new Promise(async(de,Le)=>{try{await le(de,Le)}catch(ge){Le(ge)}})}me.withAsyncBody=_})(te||(e.Promises=te={}));class X{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(G){this.a=void 0,this.b=void 0,this.d=!1,this.promise=G.then(_=>(this.a=_,this.d=!0,_),_=>{throw this.b=_,this.d=!0,_})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$th=X;class V{constructor(G){this.b=G,this.a=new D.$V(()=>new X(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$uh=V;var ie;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(ie||(ie={}));class Ce{static fromArray(G){return new Ce(_=>{_.emitMany(G)})}static fromPromise(G){return new Ce(async _=>{_.emitMany(await G)})}static fromPromises(G){return new Ce(async _=>{await Promise.all(G.map(async le=>_.emitOne(await le)))})}static merge(G){return new Ce(async _=>{await Promise.all(G.map(async le=>{for await(const de of le)_.emitOne(de)}))})}static{this.EMPTY=Ce.fromArray([])}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new I.$Wd,queueMicrotask(async()=>{const _={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(G(_)),this.j()}catch(le){this.k(le)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(G,_){return new Ce(async le=>{for await(const de of G)le.emitOne(_(de))})}map(G){return Ce.map(this,G)}static filter(G,_){return new Ce(async le=>{for await(const de of G)_(de)&&le.emitOne(de)})}filter(G){return Ce.filter(this,G)}static coalesce(G){return Ce.filter(G,_=>!!_)}coalesce(){return Ce.coalesce(this)}static async toPromise(G){const _=[];for await(const le of G)_.push(le);return _}toPromise(){return Ce.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.$vh=Ce;class Te extends Ce{constructor(G,_){super(_),this.l=G}cancel(){this.l.cancel()}}e.$wh=Te;function Pe(me){const G=new S.$7d,_=me(G.token);return new Te(G,async le=>{const de=G.token.onCancellationRequested(()=>{de.dispose(),G.dispose(),le.reject(new M.$5)});try{for await(const Le of _){if(G.token.isCancellationRequested)return;le.emitOne(Le)}de.dispose(),G.dispose()}catch(Le){de.dispose(),G.dispose(),le.reject(Le)}})}e.$xh=Pe;class be{constructor(){this.a=new $e,this.b=new Ce(le=>{if(G){le.reject(G);return}return _&&le.emitMany(_),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let G,_;this.f=le=>{_||(_=[]),_.push(le)},this.d=le=>{G||(G=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$yh=be}),define(Ae[34],Me([1,0,18,11,45,28,19,20,13]),function(fe,e,S,M,I,A,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=void 0;function D(){return Object.create(null)}e.$Jj=D,e.$Kj="**",e.$Lj="/";const L="[/\\\\]",k="[^/\\\\]",l=/\//g;function $(ce,we){switch(ce){case 0:return"";case 1:return`${k}*?`;default:return`(?:${L}|${k}+${L}${we?`|${L}${k}+`:""})*?`}}function w(ce,we){if(!ce)return[];const De=[];let he=!1,ve=!1,se="";for(const $e of ce){switch($e){case we:if(!he&&!ve){De.push(se),se="";continue}break;case"{":he=!0;break;case"}":he=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}se+=$e}return se&&De.push(se),De}e.$Mj=w;function r(ce){if(!ce)return"";let we="";const De=w(ce,e.$Lj);if(De.every(he=>he===e.$Kj))we=".*";else{let he=!1;De.forEach((ve,se)=>{if(ve===e.$Kj){if(he)return;we+=$(2,se===De.length-1)}else{let $e=!1,te="",X=!1,V="";for(const ie of ve){if(ie!=="}"&&$e){te+=ie;continue}if(X&&(ie!=="]"||!V)){let Ce;ie==="-"?Ce=ie:(ie==="^"||ie==="!")&&!V?Ce="^":ie===e.$Lj?Ce="":Ce=(0,f.$Pe)(ie),V+=Ce;continue}switch(ie){case"{":$e=!0;continue;case"[":X=!0;continue;case"}":{const Te=`(?:${w(te,",").map(Pe=>r(Pe)).join("|")})`;we+=Te,$e=!1,te="";break}case"]":{we+="["+V+"]",X=!1,V="";break}case"?":we+=k;continue;case"*":we+=$(1);continue;default:we+=(0,f.$Pe)(ie)}}se<De.length-1&&(De[se+1]!==e.$Kj||se+2<De.length)&&(we+=L)}he=ve===e.$Kj})}return we}const c=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Dc(1e4),d=function(){return!1},n=function(){return null};function b(ce,we){if(!ce)return n;let De;typeof ce!="string"?De=ce.pattern:De=ce,De=De.trim();const he=`${De}_${!!we.trimForExclusions}`;let ve=t.get(he);if(ve)return E(ve,ce);let se;return c.test(De)?ve=v(De.substr(4),De):(se=s.exec(h(De,we)))?ve=P(se[1],De):(we.trimForExclusions?o:i).test(De)?ve=g(De,we):(se=a.exec(h(De,we)))?ve=p(se[1].substr(1),De,!0):(se=u.exec(h(De,we)))?ve=p(se[1],De,!1):ve=y(De),t.set(he,ve),E(ve,ce)}function E(ce,we){if(typeof we=="string")return ce;const De=function(he,ve){return(0,I.$9f)(he,we.base,!m.$k)?ce((0,f.$Ue)(he.substr(we.base.length),R.sep),ve):null};return De.allBasenames=ce.allBasenames,De.allPaths=ce.allPaths,De.basenames=ce.basenames,De.patterns=ce.patterns,De}function h(ce,we){return we.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function v(ce,we){return function(De,he){return typeof De=="string"&&De.endsWith(ce)?we:null}}function P(ce,we){const De=`/${ce}`,he=`\\${ce}`,ve=function($e,te){return typeof $e!="string"?null:te?te===ce?we:null:$e===ce||$e.endsWith(De)||$e.endsWith(he)?we:null},se=[ce];return ve.basenames=se,ve.patterns=[we],ve.allBasenames=se,ve}function g(ce,we){const De=W(ce.slice(1,-1).split(",").map(te=>b(te,we)).filter(te=>te!==n),ce),he=De.length;if(!he)return n;if(he===1)return De[0];const ve=function(te,X){for(let V=0,ie=De.length;V<ie;V++)if(De[V](te,X))return ce;return null},se=De.find(te=>!!te.allBasenames);se&&(ve.allBasenames=se.allBasenames);const $e=De.reduce((te,X)=>X.allPaths?te.concat(X.allPaths):te,[]);return $e.length&&(ve.allPaths=$e),ve}function p(ce,we,De){const he=R.sep===R.$gc.sep,ve=he?ce:ce.replace(l,R.sep),se=R.sep+ve,$e=R.$gc.sep+ce;let te;return De?te=function(X,V){return typeof X=="string"&&(X===ve||X.endsWith(se)||!he&&(X===ce||X.endsWith($e)))?we:null}:te=function(X,V){return typeof X=="string"&&(X===ve||!he&&X===ce)?we:null},te.allPaths=[(De?"*/":"./")+ce],te}function y(ce){try{const we=new RegExp(`^${r(ce)}$`);return function(De){return we.lastIndex=0,typeof De=="string"&&we.test(De)?ce:null}}catch{return n}}function T(ce,we,De){return!ce||typeof we!="string"?!1:N(ce)(we,void 0,De)}e.$Nj=T;function N(ce,we={}){if(!ce)return d;if(typeof ce=="string"||J(ce)){const De=b(ce,we);if(De===n)return d;const he=function(ve,se){return!!De(ve,se)};return De.allBasenames&&(he.allBasenames=De.allBasenames),De.allPaths&&(he.allPaths=De.allPaths),he}return C(ce,we)}e.$Oj=N;function J(ce){const we=ce;return we?typeof we.base=="string"&&typeof we.pattern=="string":!1}e.$Pj=J;function q(ce){return ce.allBasenames||[]}e.$Qj=q;function U(ce){return ce.allPaths||[]}e.$Rj=U;function C(ce,we){const De=W(Object.getOwnPropertyNames(ce).map(te=>F(te,ce[te],we)).filter(te=>te!==n)),he=De.length;if(!he)return n;if(!De.some(te=>!!te.requiresSiblings)){if(he===1)return De[0];const te=function(ie,Ce){let Te;for(let Pe=0,be=De.length;Pe<be;Pe++){const me=De[Pe](ie,Ce);if(typeof me=="string")return me;(0,M.$Tg)(me)&&(Te||(Te=[]),Te.push(me))}return Te?(async()=>{for(const Pe of Te){const be=await Pe;if(typeof be=="string")return be}return null})():null},X=De.find(ie=>!!ie.allBasenames);X&&(te.allBasenames=X.allBasenames);const V=De.reduce((ie,Ce)=>Ce.allPaths?ie.concat(Ce.allPaths):ie,[]);return V.length&&(te.allPaths=V),te}const ve=function(te,X,V){let ie,Ce;for(let Te=0,Pe=De.length;Te<Pe;Te++){const be=De[Te];be.requiresSiblings&&V&&(X||(X=(0,R.$nc)(te)),ie||(ie=X.substr(0,X.length-(0,R.$oc)(te).length)));const me=be(te,X,ie,V);if(typeof me=="string")return me;(0,M.$Tg)(me)&&(Ce||(Ce=[]),Ce.push(me))}return Ce?(async()=>{for(const Te of Ce){const Pe=await Te;if(typeof Pe=="string")return Pe}return null})():null},se=De.find(te=>!!te.allBasenames);se&&(ve.allBasenames=se.allBasenames);const $e=De.reduce((te,X)=>X.allPaths?te.concat(X.allPaths):te,[]);return $e.length&&(ve.allPaths=$e),ve}function F(ce,we,De){if(we===!1)return n;const he=b(ce,De);if(he===n)return n;if(typeof we=="boolean")return he;if(we){const ve=we.when;if(typeof ve=="string"){const se=($e,te,X,V)=>{if(!V||!he($e,te))return null;const ie=ve.replace("$(basename)",()=>X),Ce=V(ie);return(0,M.$Tg)(Ce)?Ce.then(Te=>Te?ce:null):Ce?ce:null};return se.requiresSiblings=!0,se}}return he}function W(ce,we){const De=ce.filter(te=>!!te.basenames);if(De.length<2)return ce;const he=De.reduce((te,X)=>{const V=X.basenames;return V?te.concat(V):te},[]);let ve;if(we){ve=[];for(let te=0,X=he.length;te<X;te++)ve.push(we)}else ve=De.reduce((te,X)=>{const V=X.patterns;return V?te.concat(V):te},[]);const se=function(te,X){if(typeof te!="string")return null;if(!X){let ie;for(ie=te.length;ie>0;ie--){const Ce=te.charCodeAt(ie-1);if(Ce===47||Ce===92)break}X=te.substr(ie)}const V=he.indexOf(X);return V!==-1?ve[V]:null};se.basenames=he,se.patterns=ve,se.allBasenames=he;const $e=ce.filter(te=>!te.basenames);return $e.push(se),$e}function re(ce,we){return(0,S.$ub)(ce,we,(De,he)=>typeof De=="string"&&typeof he=="string"?De===he:typeof De!="string"&&typeof he!="string"?De.base===he.base&&De.pattern===he.pattern:!1)}e.$Sj=re}),define(Ae[46],Me([1,0,15,127,24,13,2]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class f{constructor(i="",o=!1){if(this.value=i,typeof this.value!="string")throw(0,S.$7)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(i,o=0){return this.value+=l(this.supportThemeIcons?(0,M.$dk)(i):i).replace(/([ \t]+)/g,(a,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,o){return this.value+=`
${$(o,i)}
`,this}appendLink(i,o,a){return this.value+="[",this.value+=this.c(o,"]"),this.value+="](",this.value+=this.c(String(i),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(i,o){const a=new RegExp((0,A.$Pe)(o),"g");return i.replace(a,(u,t)=>i.charAt(t-1)!=="\\"?`\\${u}`:u)}}e.$jk=f;function D(s){return L(s)?!s.value:Array.isArray(s)?s.every(D):!0}e.$kk=D;function L(s){return s instanceof f?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$lk=L;function k(s,i){return s===i?!0:!s||!i?!1:s.value===i.value&&s.isTrusted===i.isTrusted&&s.supportThemeIcons===i.supportThemeIcons&&s.supportHtml===i.supportHtml&&(s.baseUri===i.baseUri||!!s.baseUri&&!!i.baseUri&&(0,I.$Bg)(R.URI.from(s.baseUri),R.URI.from(i.baseUri)))}e.$mk=k;function l(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$nk=l;function $(s,i){const o=s.match(/^`+/gm)?.reduce((u,t)=>u.length>t.length?u:t).length??0,a=o>=3?o+1:3;return[`${"`".repeat(a)}${i}`,s,`${"`".repeat(a)}`].join(`
`)}e.$ok=$;function w(s){return s.replace(/"/g,"&quot;")}e.$pk=w;function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$qk=r;function c(s){const i=[],o=s.split("|").map(u=>u.trim());s=o[0];const a=o[1];if(a){const u=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),d=u?u[1]:"",n=t?t[1]:"",b=isFinite(parseInt(n)),E=isFinite(parseInt(d));b&&i.push(`width="${n}"`),E&&i.push(`height="${d}"`)}return{href:s,dimensions:i}}e.$rk=c}),define(Ae[94],Me([1,0,18,45,19,20,24,13]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=void 0;function f(b,E){const{os:h,tildify:v,relative:P}=E;if(P){const y=D(b,P,h);if(typeof y=="string")return y}let g=b.fsPath;if(h===1&&!A.$i?g=g.replace(/\//g,"\\"):h!==1&&A.$i&&(g=g.replace(/\\/g,"/")),h!==1&&v?.userHome){const y=v.userHome.fsPath;let T;b.scheme!==v.userHome.scheme&&b.path[0]===I.$gc.sep&&b.path[1]!==I.$gc.sep?T=v.userHome.with({path:b.path}).fsPath:T=g,g=l(T,y,h)}return(h===1?I.$fc:I.$gc).normalize(L(g,h===1))}e.$Xv=f;function D(b,E,h){const v=h===1?I.$fc:I.$gc,P=h===3?R.$yg:R.$Ag,g=E.getWorkspace(),p=(0,S.$Ob)(g.folders);if(!p)return;b.scheme!==p.uri.scheme&&b.path[0]===I.$gc.sep&&b.path[1]!==I.$gc.sep&&(b=p.uri.with({path:b.path}));const y=E.getWorkspaceFolder(b);if(!y)return;let T;if(P.isEqual(y.uri,b)?T="":T=P.relativePath(y.uri,b)??"",T&&(T=v.normalize(T)),g.folders.length>1&&!E.noPrefix){const N=y.name?y.name:P.basenameOrAuthority(y.uri);T=T?`${N} \u2022 ${T}`:N}return T}function L(b,E=A.$i){return(0,M.$ag)(b,E)?b.charAt(0).toUpperCase()+b.slice(1):b}e.$Yv=L;let k=Object.create(null);function l(b,E,h=A.OS){if(h===1||!b||!E)return b;let v=k.original===E?k.normalized:void 0;v||(v=E,A.$i&&(v=(0,M.$3f)(v)),v=`${(0,m.$Ve)(v,I.$gc.sep)}${I.$gc.sep}`,k={original:E,normalized:v});let P=b;return A.$i&&(P=(0,M.$3f)(P)),(h===3?P.startsWith(v):(0,m.$bf)(P,v))?`~/${P.substr(v.length)}`:b}e.$Zv=l;function $(b,E){return b.replace(/^~($|\/|\\)/,`${E}$1`)}e.$1v=$;const w="\u2026",r="\\\\",c="~";function s(b,E=I.sep){const h=new Array(b.length);let v=!1;for(let P=0;P<b.length;P++){const g=b[P];if(g===""){h[P]=`.${E}`;continue}if(!g){h[P]=g;continue}v=!0;let p="",y=g;y.indexOf(r)===0?(p=y.substr(0,y.indexOf(r)+r.length),y=y.substr(y.indexOf(r)+r.length)):y.indexOf(E)===0?(p=y.substr(0,y.indexOf(E)+E.length),y=y.substr(y.indexOf(E)+E.length)):y.indexOf(c)===0&&(p=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length));const T=y.split(E);for(let N=1;v&&N<=T.length;N++)for(let J=T.length-N;v&&J>=0;J--){v=!1;let q=T.slice(J,J+N).join(E);for(let U=0;!v&&U<b.length;U++)if(U!==P&&b[U]&&b[U].indexOf(q)>-1){const C=J+N===T.length,F=J>0&&b[U].indexOf(E)>-1?E+q:q,W=b[U].endsWith(F);v=!C||W}if(!v){let U="";(T[0].endsWith(":")||p!=="")&&(J===1&&(J=0,N++,q=T[0]+E+q),J>0&&(U=T[0]+E),U=p+U),J>0&&(U=U+w+E),U=U+q,J+N<T.length&&(U=U+E+w),h[P]=U}}v&&(h[P]=g)}return h}e.$2v=s;var i;(function(b){b[b.TEXT=0]="TEXT",b[b.VARIABLE=1]="VARIABLE",b[b.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function o(b,E=Object.create(null)){const h=[];let v=!1,P="";for(const g of b)if(g==="$"||v&&g==="{")P&&h.push({value:P,type:i.TEXT}),P="",v=!0;else if(g==="}"&&v){const p=E[P];if(typeof p=="string")p.length&&h.push({value:p,type:i.VARIABLE});else if(p){const y=h[h.length-1];(!y||y.type!==i.SEPARATOR)&&h.push({value:p.label,type:i.SEPARATOR})}P="",v=!1}else P+=g;return P&&!v&&h.push({value:P,type:i.TEXT}),h.filter((g,p)=>{if(g.type===i.SEPARATOR){const y=h[p-1],T=h[p+1];return[y,T].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map(g=>g.value).join("")}e.$3v=o;function a(b,E){return A.$j||E?b.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):b.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$4v=a;function u(b,E){return A.$j||E?b.replace(/\(&&\w\)|&&/g,""):A.$i?b.replace(/&&|&/g,h=>h==="&"?"&&":"&"):b.replace(/&&/g,"_")}e.$5v=u;function t(b){return b.replace(/&/g,"&&")}e.$6v=t;function d(b){if(b.endsWith("]")){const E=b.lastIndexOf(" [",b.length-2);if(E!==-1){const h=n(b.substring(0,E)),v=b.substring(E);return{name:h.name+v,parentPath:h.parentPath}}}return n(b)}e.$7v=d;function n(b){const E=b.indexOf("/")!==-1?I.$gc:I.$fc,h=E.basename(b),v=E.dirname(b);return h.length?{name:h,parentPath:v}:{name:v,parentPath:""}}}),define(Ae[140],Me([1,0,23,2]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function I(k){return k.toJSON()}class A{constructor(l){this.a=l}transformIncoming(l){const $=this.a.transformIncoming(l);return $===l?l:I(M.URI.from($))}transformOutgoing(l){const $=this.a.transformOutgoing(l);return $===l?l:I(M.URI.from($))}transformOutgoingURI(l){const $=this.a.transformOutgoing(l);return $===l?l:M.URI.from($)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$7m=A,e.$8m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,l,$){if(!k||$>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return l.transformOutgoing(k);for(const w in k)if(Object.hasOwnProperty.call(k,w)){const r=R(k[w],l,$+1);r!==null&&(k[w]=r)}}return null}function m(k,l){const $=R(k,l,0);return $===null?k:$}e.$9m=m;function f(k,l,$,w){if(!k||w>200)return null;if(typeof k=="object"){if(k.$mid===1)return $?M.URI.revive(l.transformIncoming(k)):l.transformIncoming(k);if(k instanceof S.$ke)return null;for(const r in k)if(Object.hasOwnProperty.call(k,r)){const c=f(k[r],l,$,w+1);c!==null&&(k[r]=c)}}return null}function D(k,l){const $=f(k,l,!1,0);return $===null?k:$}e.$0m=D;function L(k,l){const $=f(k,l,!0,0);return $===null?k:$}e.$$m=L}),define(Ae[141],Me([1,0,13,20,23]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=void 0;let A;function R(){return A||(A=new TextDecoder("UTF-16LE")),A}let m;function f(){return m||(m=new TextDecoder("UTF-16BE")),m}let D;function L(){return D||(D=M.$D()?R():f()),D}e.$ct=L;function k(w,r,c){const s=new Uint16Array(w.buffer,r,c);return c>0&&(s[0]===65279||s[0]===65534)?l(w,r,c):R().decode(s)}e.$dt=k;function l(w,r,c){const s=[];let i=0;for(let o=0;o<c;o++){const a=I.$me(w,r);r+=2,s[i++]=String.fromCharCode(a)}return s.join("")}class ${constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return L().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const c=this.a-this.d;c<=1&&(c===0||S.$ef(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const c=r.length;if(this.d+c>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<c;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$et=$}),define(Ae[142],Me([1,0,23,141]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0;function I(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(D,L,k,l){this.oldPosition=D,this.oldText=L,this.newPosition=k,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(D){return 4+2*D.length}static c(D,L,k){const l=L.length;S.$pe(D,l,k),k+=4;for(let $=0;$<l;$++)S.$ne(D,L.charCodeAt($),k),k+=2;return k}static d(D,L){const k=S.$oe(D,L);return L+=4,(0,M.$dt)(D,L,k)}writeSize(){return 8+A.a(this.oldText)+A.a(this.newText)}write(D,L){return S.$pe(D,this.oldPosition,L),L+=4,S.$pe(D,this.newPosition,L),L+=4,L=A.c(D,this.oldText,L),L=A.c(D,this.newText,L),L}static read(D,L,k){const l=S.$oe(D,L);L+=4;const $=S.$oe(D,L);L+=4;const w=A.d(D,L);L+=A.a(w);const r=A.d(D,L);return L+=A.a(r),k.push(new A(l,w,$,r)),L}}e.$ft=A;function R(f,D){return f===null||f.length===0?D:new m(f,D).compress()}e.$gt=R;class m{constructor(D,L){this.a=D,this.c=L,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let D=0,L=0,k=this.n(D),l=this.l(L);for(;D<this.f||L<this.h;){if(k===null){this.k(l),l=this.l(++L);continue}if(l===null){this.m(k),k=this.n(++D);continue}if(l.oldEnd<=k.newPosition){this.k(l),l=this.l(++L);continue}if(k.newEnd<=l.oldPosition){this.m(k),k=this.n(++D);continue}if(l.oldPosition<k.newPosition){const[s,i]=m.r(l,k.newPosition-l.oldPosition);this.k(s),l=i;continue}if(k.newPosition<l.oldPosition){const[s,i]=m.q(k,l.oldPosition-k.newPosition);this.m(s),k=i;continue}let r,c;if(l.oldEnd===k.newEnd)r=k,c=l,k=this.n(++D),l=this.l(++L);else if(l.oldEnd<k.newEnd){const[s,i]=m.q(k,l.oldLength);r=s,c=l,k=i,l=this.l(++L)}else{const[s,i]=m.r(l,k.newLength);r=k,c=s,k=this.n(++D),l=i}this.d[this.e++]=new A(r.oldPosition,r.oldText,c.newPosition,c.newText),this.g+=r.newLength-r.oldLength,this.j+=c.newLength-c.oldLength}const $=m.s(this.d);return m.t($)}k(D){this.d[this.e++]=m.o(this.g,D),this.j+=D.newLength-D.oldLength}l(D){return D<this.h?this.c[D]:null}m(D){this.d[this.e++]=m.p(this.j,D),this.g+=D.newLength-D.oldLength}n(D){return D<this.f?this.a[D]:null}static o(D,L){return new A(L.oldPosition-D,L.oldText,L.newPosition,L.newText)}static p(D,L){return new A(L.oldPosition,L.oldText,L.newPosition+D,L.newText)}static q(D,L){const k=D.newText.substr(0,L),l=D.newText.substr(L);return[new A(D.oldPosition,D.oldText,D.newPosition,k),new A(D.oldEnd,"",D.newPosition+L,l)]}static r(D,L){const k=D.oldText.substr(0,L),l=D.oldText.substr(L);return[new A(D.oldPosition,k,D.newPosition,D.newText),new A(D.oldPosition+L,l,D.newEnd,"")]}static s(D){if(D.length===0)return D;const L=[];let k=0,l=D[0];for(let $=1;$<D.length;$++){const w=D[$];l.oldEnd===w.oldPosition?l=new A(l.oldPosition,l.oldText+w.oldText,l.newPosition,l.newText+w.newText):(L[k++]=l,l=w)}return L[k++]=l,L}static t(D){if(D.length===0)return D;const L=[];let k=0;for(let l=0;l<D.length;l++){const $=D[l];$.oldText!==$.newText&&(L[k++]=$)}return L}}}),define(Ae[143],Me([1,0,34,19]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=void 0;function I(A,R,m,f,D,L){if(Array.isArray(A)){let k=0;for(const l of A){const $=I(l,R,m,f,D,L);if($===10)return $;$>k&&(k=$)}return k}else{if(typeof A=="string")return f?A==="*"?5:A===m?10:0:0;if(A){const{language:k,pattern:l,scheme:$,hasAccessToAllModels:w,notebookType:r}=A;if(!f&&!w)return 0;r&&D&&(R=D);let c=0;if($)if($===R.scheme)c=10;else if($==="*")c=5;else return 0;if(k)if(k===m)c=10;else if(k==="*")c=Math.max(c,5);else return 0;if(r)if(r===L)c=10;else if(r==="*"&&L!==void 0)c=Math.max(c,5);else return 0;if(l){let s;if(typeof l=="string"?s=l:s={...l,base:(0,M.$hc)(l.base)},s===R.fsPath||(0,S.$Nj)(s,R.fsPath))c=10;else return 0}return c}else return 0}}e.$Dt=I}),define(Ae[144],Me([1,0,5,13,29,92,90,129,142,6]),function(fe,e,S,M,I,A,R,m,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=void 0;class L extends D.$Tc{constructor(l,$,w,r,c,s,i){super(),this.m=this.B(new S.$Wd),this.onDidChangeContent=this.m.event,this.f=$,this.j=!s,this.g=r,this.h=c,this.c=new R.$cC(l,w,i)}equals(l){return!(l instanceof L)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,$){return this.c.getOffsetAt(l,$)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,$){const w=l+$,r=this.getPositionAt(l),c=this.getPositionAt(w);return new I.$Ws(r.lineNumber,r.column,c.lineNumber,c.column)}getValueInRange(l,$=0){if(l.isEmpty())return"";const w=this.n($);return this.c.getValueInRange(l,w)}getValueLengthInRange(l,$=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const w=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let c=0;const s=this.n($),i=this.getEOL();if(s.length!==i.length){const o=s.length-i.length,a=l.endLineNumber-l.startLineNumber;c=o*a}return r-w+c}getCharacterCountInRange(l,$=0){if(this.j){let w=0;const r=l.startLineNumber,c=l.endLineNumber;for(let s=r;s<=c;s++){const i=this.getLineContent(s),o=s===r?l.startColumn-1:0,a=s===c?l.endColumn-1:i.length;for(let u=o;u<a;u++)M.$ef(i.charCodeAt(u))?(w=w+1,u=u+1):w=w+1}return w+=this.n($).length*(c-r),w}return this.getValueLengthInRange(l,$)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,$){return this.c.getLineCharCode(l,$)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const $=M.$2e(this.getLineContent(l));return $===-1?0:$+1}getLineLastNonWhitespaceColumn(l){const $=M.$4e(this.getLineContent(l));return $===-1?0:$+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,$,w){let r=this.g,c=this.h,s=this.j,i=!0,o=[];for(let E=0;E<l.length;E++){const h=l[E];i&&h._isTracked&&(i=!1);const v=h.range;if(h.text){let T=!0;s||(T=!M.$pf(h.text),s=T),!r&&T&&(r=M.$of(h.text)),!c&&T&&(c=M.$rf(h.text))}let P="",g=0,p=0,y=0;if(h.text){let T;[g,p,y,T]=(0,m.$wt)(h.text);const N=this.getEOL();T===0||T===(N===`\r
`?2:1)?P=h.text:P=h.text.replace(/\r\n|\r|\n/g,N)}o[E]={sortIndex:E,identifier:h.identifier||null,range:v,rangeOffset:this.getOffsetAt(v.startLineNumber,v.startColumn),rangeLength:this.getValueLengthInRange(v),text:P,eolCount:g,firstLineLength:p,lastLineLength:y,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}o.sort(L.u);let a=!1;for(let E=0,h=o.length-1;E<h;E++){const v=o[E].range.getEndPosition(),P=o[E+1].range.getStartPosition();if(P.isBeforeOrEqual(v)){if(P.isBefore(v))throw new Error("Overlapping ranges are not allowed!");a=!0}}i&&(o=this.s(o));const u=w||$?L._getInverseEditRanges(o):[],t=[];if($)for(let E=0;E<o.length;E++){const h=o[E],v=u[E];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let P=v.startLineNumber;P<=v.endLineNumber;P++){let g="";P===v.startLineNumber&&(g=this.getLineContent(h.range.startLineNumber),M.$2e(g)!==-1)||t.push({lineNumber:P,oldContent:g})}}let d=null;if(w){let E=0;d=[];for(let h=0;h<o.length;h++){const v=o[h],P=u[h],g=this.getValueInRange(v.range),p=v.rangeOffset+E;E+=v.text.length-g.length,d[h]={sortIndex:v.sortIndex,identifier:v.identifier,range:P,text:g,textChange:new f.$ft(v.rangeOffset,g,p,v.text)}}a||d.sort((h,v)=>h.sortIndex-v.sortIndex)}this.g=r,this.h=c,this.j=s;const n=this.t(o);let b=null;if($&&t.length>0){t.sort((E,h)=>h.lineNumber-E.lineNumber),b=[];for(let E=0,h=t.length;E<h;E++){const v=t[E].lineNumber;if(E>0&&t[E-1].lineNumber===v)continue;const P=t[E].oldContent,g=this.getLineContent(v);g.length===0||g===P||M.$2e(g)!==-1||b.push(v)}}return this.m.fire(),new A.$gv(d,n,b)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let $=!1;const w=l[0].range,r=l[l.length-1].range,c=new I.$Ws(w.startLineNumber,w.startColumn,r.endLineNumber,r.endColumn);let s=w.startLineNumber,i=w.startColumn;const o=[];for(let n=0,b=l.length;n<b;n++){const E=l[n],h=E.range;$=$||E.forceMoveMarkers,o.push(this.getValueInRange(new I.$Ws(s,i,h.startLineNumber,h.startColumn))),E.text.length>0&&o.push(E.text),s=h.endLineNumber,i=h.endColumn}const a=o.join(""),[u,t,d]=(0,m.$wt)(a);return{sortIndex:0,identifier:l[0].identifier,range:c,rangeOffset:this.getOffsetAt(c.startLineNumber,c.startColumn),rangeLength:this.getValueLengthInRange(c,0),text:a,eolCount:u,firstLineLength:t,lastLineLength:d,forceMoveMarkers:$,isAutoWhitespaceEdit:!1}}t(l){l.sort(L.w);const $=[];for(let w=0;w<l.length;w++){const r=l[w],c=r.range.startLineNumber,s=r.range.startColumn,i=r.range.endLineNumber,o=r.range.endColumn;if(c===i&&s===o&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const a=new I.$Ws(c,s,i,o);$.push({range:a,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return $}findMatchesLineByLine(l,$,w,r){return this.c.findMatchesLineByLine(l,$,w,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,$){const w=l.startLineNumber,r=l.startColumn,[c,s,i]=(0,m.$wt)($);let o;if($.length>0){const a=c+1;a===1?o=new I.$Ws(w,r,w,r+s):o=new I.$Ws(w,r,w+a-1,i+1)}else o=new I.$Ws(w,r,w,r);return o}static _getInverseEditRanges(l){const $=[];let w=0,r=0,c=null;for(let s=0,i=l.length;s<i;s++){const o=l[s];let a,u;c?c.range.endLineNumber===o.range.startLineNumber?(a=w,u=r+(o.range.startColumn-c.range.endColumn)):(a=w+(o.range.startLineNumber-c.range.endLineNumber),u=o.range.startColumn):(a=o.range.startLineNumber,u=o.range.startColumn);let t;if(o.text.length>0){const d=o.eolCount+1;d===1?t=new I.$Ws(a,u,a,u+o.firstLineLength):t=new I.$Ws(a,u,a+d-1,o.lastLineLength+1)}else t=new I.$Ws(a,u,a,u);w=t.endLineNumber,r=t.endColumn,$.push(t),c=o}return $}static u(l,$){const w=I.$Ws.compareRangesUsingEnds(l.range,$.range);return w===0?l.sortIndex-$.sortIndex:w}static w(l,$){const w=I.$Ws.compareRangesUsingEnds(l.range,$.range);return w===0?$.sortIndex-l.sortIndex:-w}}e.$dC=L}),define(Ae[145],Me([1,0,13,90,144]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class A{constructor(f,D,L,k,l,$,w,r,c){this.a=f,this.b=D,this.c=L,this.d=k,this.e=l,this.f=$,this.g=w,this.h=r,this.j=c}k(f){const D=this.c+this.d+this.e,L=this.c+this.e;return D===0?f===1?`
`:`\r
`:L>D/2?`\r
`:`
`}create(f){const D=this.k(f),L=this.a;if(this.j&&(D===`\r
`&&(this.c>0||this.d>0)||D===`
`&&(this.c>0||this.e>0)))for(let l=0,$=L.length;l<$;l++){const w=L[l].buffer.replace(/\r\n|\r|\n/g,D),r=(0,M.$$B)(w);L[l]=new M.$bC(w,r)}const k=new I.$dC(L,this.b,D,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&S.$xf(f)&&(this.b=S.$wf,f=f.substr(1));const D=f.charCodeAt(f.length-1);D===13||D>=55296&&D<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=D):(this.m(f,!1),this.c=!1,this.d=D)}m(f,D){!D&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const D=(0,M.$_B)(this.e,f);this.a.push(new M.$bC(f,D.lineStarts)),this.f+=D.cr,this.g+=D.lf,this.h+=D.crlf,D.isBasicASCII||(this.l=!1,this.j||(this.j=S.$of(f)),this.k||(this.k=S.$rf(f)))}finish(f=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const D=(0,M.$$B)(f.buffer);f.lineStarts=D,this.d===13&&this.f++}}}e.$eC=R}),define(Ae[95],Me([1,0,23,20]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$=e.$3$=void 0;var I;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(I||(I={}));function A(k){for(let l=0,$=k.length;l<$;l+=4){const w=k[l+0],r=k[l+1],c=k[l+2],s=k[l+3];k[l+0]=s,k[l+1]=c,k[l+2]=r,k[l+3]=w}}function R(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$D()||A(l),S.$ke.wrap(l)}function m(k){const l=k.buffer;if(M.$D()||A(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const $=new Uint8Array(l.byteLength);return $.set(l),new Uint32Array($.buffer,$.byteOffset,$.length/4)}}function f(k){const l=new Uint32Array(D(k));let $=0;if(l[$++]=k.id,k.type==="full")l[$++]=1,l[$++]=k.data.length,l.set(k.data,$),$+=k.data.length;else{l[$++]=2,l[$++]=k.deltas.length;for(const w of k.deltas)l[$++]=w.start,l[$++]=w.deleteCount,w.data?(l[$++]=w.data.length,l.set(w.data,$),$+=w.data.length):l[$++]=0}return R(l)}e.$3$=f;function D(k){let l=0;if(l+=2,k.type==="full")l+=1+k.data.length;else{l+=1,l+=3*k.deltas.length;for(const $ of k.deltas)$.data&&(l+=$.data.length)}return l}function L(k){const l=m(k);let $=0;const w=l[$++];if(l[$++]===1){const i=l[$++],o=l.subarray($,$+i);return $+=i,{id:w,type:"full",data:o}}const c=l[$++],s=[];for(let i=0;i<c;i++){const o=l[$++],a=l[$++],u=l[$++];let t;u>0&&(t=l.subarray($,$+u),$+=u),s[i]={start:o,deleteCount:a,data:t}}return{id:w,type:"delta",deltas:s}}e.$4$=L}),define(Ae[146],Me([9,10]),function(fe,e){return fe.create("vs/editor/common/config/editorOptions",e)}),define(Ae[147],Me([1,0,18,26,20,130,148,146]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var f;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=D;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class k{constructor(x,pe,Ve,Ye){this.id=x,this.name=pe,this.defaultValue=Ve,this.schema=Ye}applyUpdate(x,pe){return $(x,pe)}compute(x,pe,Ve){return Ve}}class l{constructor(x,pe){this.newValue=x,this.didChange=pe}}e.ApplyUpdateResult=l;function $(Z,x){if(typeof Z!="object"||typeof x!="object"||!Z||!x)return new l(x,Z!==x);if(Array.isArray(Z)||Array.isArray(x)){const Ve=Array.isArray(Z)&&Array.isArray(x)&&S.$ub(Z,x);return new l(x,!Ve)}let pe=!1;for(const Ve in x)if(x.hasOwnProperty(Ve)){const Ye=$(Z[Ve],x[Ve]);Ye.didChange&&(Z[Ve]=Ye.newValue,pe=!0)}return new l(Z,pe)}class w{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,pe){return $(x,pe)}validate(x){return this.defaultValue}}class r{constructor(x,pe,Ve,Ye){this.id=x,this.name=pe,this.defaultValue=Ve,this.schema=Ye}applyUpdate(x,pe){return $(x,pe)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,pe,Ve){return Ve}}function c(Z,x){return typeof Z>"u"?x:Z==="false"?!1:!!Z}e.boolean=c;class s extends r{constructor(x,pe,Ve,Ye=void 0){typeof Ye<"u"&&(Ye.type="boolean",Ye.default=Ve),super(x,pe,Ve,Ye)}validate(x){return c(x,this.defaultValue)}}function i(Z,x,pe,Ve){if(typeof Z>"u")return x;let Ye=parseInt(Z,10);return isNaN(Ye)?x:(Ye=Math.max(pe,Ye),Ye=Math.min(Ve,Ye),Ye|0)}e.clampedInt=i;class o extends r{static clampedInt(x,pe,Ve,Ye){return i(x,pe,Ve,Ye)}constructor(x,pe,Ve,Ye,it,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Ve,st.minimum=Ye,st.maximum=it),super(x,pe,Ve,st),this.minimum=Ye,this.maximum=it}validate(x){return o.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function a(Z,x,pe,Ve){if(typeof Z>"u")return x;const Ye=u.float(Z,x);return u.clamp(Ye,pe,Ve)}e.clampedFloat=a;class u extends r{static clamp(x,pe,Ve){return x<pe?pe:x>Ve?Ve:x}static float(x,pe){if(typeof x=="number")return x;if(typeof x>"u")return pe;const Ve=parseFloat(x);return isNaN(Ve)?pe:Ve}constructor(x,pe,Ve,Ye,it){typeof it<"u"&&(it.type="number",it.default=Ve),super(x,pe,Ve,it),this.validationFn=Ye}validate(x){return this.validationFn(u.float(x,this.defaultValue))}}class t extends r{static string(x,pe){return typeof x!="string"?pe:x}constructor(x,pe,Ve,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.default=Ve),super(x,pe,Ve,Ye)}validate(x){return t.string(x,this.defaultValue)}}function d(Z,x,pe,Ve){return typeof Z!="string"?x:Ve&&Z in Ve?Ve[Z]:pe.indexOf(Z)===-1?x:Z}e.stringSet=d;class n extends r{constructor(x,pe,Ve,Ye,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Ye,it.default=Ve),super(x,pe,Ve,it),this.c=Ye}validate(x){return d(x,this.defaultValue,this.c)}}class b extends k{constructor(x,pe,Ve,Ye,it,st,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=it,Ne.default=Ye),super(x,pe,Ve,Ne),this.c=it,this.d=st}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function E(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(x){switch(x){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(x,pe,Ve){return Ve===0?x.accessibilitySupport:Ve}}class v extends k{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:m.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{insertSpace:c(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var P;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(P||(e.TextEditorCursorBlinkingStyle=P={}));function g(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(p||(e.TextEditorCursorStyle=p={}));function y(Z){switch(Z){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function T(Z){switch(Z){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class N extends w{constructor(){super(140)}compute(x,pe,Ve){const Ye=["monaco-editor"];return pe.get(39)&&Ye.push(pe.get(39)),x.extraEditorClassName&&Ye.push(x.extraEditorClassName),pe.get(73)==="default"?Ye.push("mouse-default"):pe.get(73)==="copy"&&Ye.push("mouse-copy"),pe.get(110)&&Ye.push("showUnused"),pe.get(138)&&Ye.push("showDeprecated"),Ye.join(" ")}}class J extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(x,pe,Ve){return Ve&&x.emptySelectionClipboard}}class q extends k{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:m.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:m.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{cursorMoveOnType:c(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":d(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":d(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(pe.loop,this.defaultValue.loop)}}}class U extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?U.OFF:x==="true"?U.ON:x:x?U.ON:U.OFF}}e.EditorFontLigatures=U;class C extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?C.OFF:x==="true"?C.TRANSLATE:x:x?C.TRANSLATE:C.OFF}compute(x,pe,Ve){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class F extends w{constructor(){super(50)}compute(x,pe,Ve){return x.fontInfo}}class W extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(x){const pe=u.float(x,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(pe,6,100)}compute(x,pe,Ve){return x.fontInfo.fontSize}}class re extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.d,maximum:re.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(o.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,re.d,re.e))}}class ce extends k{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Ve,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Ve,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Ve,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Ve,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Ve,description:m.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{multiple:d(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??d(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??d(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??d(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??d(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??d(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class we extends k{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:m.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),delay:o.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:c(pe.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:c(pe.above,this.defaultValue.above)}}}var De;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(De||(e.RenderMinimap=De={}));class he extends w{constructor(){super(143)}compute(x,pe,Ve){return he.computeLayout(pe,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const pe=x.height/x.lineHeight,Ve=Math.floor(x.paddingTop/x.lineHeight);let Ye=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(Ye=Math.max(Ye,pe-1));const it=(Ve+x.viewLineCount+Ye)/(x.pixelRatio*x.height),st=Math.floor(x.viewLineCount/it);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Ye,desiredRatio:it,minimapLineCount:st}}static c(x,pe){const Ve=x.outerWidth,Ye=x.outerHeight,it=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const st=pe.stableMinimapLayoutInput,Ne=st&&x.outerHeight===st.outerHeight&&x.lineHeight===st.lineHeight&&x.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&x.pixelRatio===st.pixelRatio&&x.scrollBeyondLastLine===st.scrollBeyondLastLine&&x.paddingTop===st.paddingTop&&x.paddingBottom===st.paddingBottom&&x.minimap.enabled===st.minimap.enabled&&x.minimap.side===st.minimap.side&&x.minimap.size===st.minimap.size&&x.minimap.showSlider===st.minimap.showSlider&&x.minimap.renderCharacters===st.minimap.renderCharacters&&x.minimap.maxColumn===st.minimap.maxColumn&&x.minimap.scale===st.minimap.scale&&x.verticalScrollbarWidth===st.verticalScrollbarWidth&&x.isViewportWrapping===st.isViewportWrapping,Mt=x.lineHeight,Jt=x.typicalHalfwidthCharacterWidth,_t=x.scrollBeyondLastLine,Ut=x.minimap.renderCharacters;let Et=it>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const ei=x.minimap.maxColumn,jt=x.minimap.size,ni=x.minimap.side,Yt=x.verticalScrollbarWidth,Qt=x.viewLineCount,Xe=x.remainingWidth,Bt=x.isViewportWrapping,ti=Ut?2:3;let ht=Math.floor(it*Ye);const mt=ht/it;let Kt=!1,ii=!1,Pt=ti*Et,dt=Et/it,Rt=1;if(jt==="fill"||jt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Tt,extraLinesBeyondLastLine:Ct,desiredRatio:Nt,minimapLineCount:Vt}=he.computeContainedMinimapLineCount({viewLineCount:Qt,scrollBeyondLastLine:_t,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:Ye,lineHeight:Mt,pixelRatio:it});if(Qt/Vt>1)Kt=!0,ii=!0,Et=1,Pt=1,dt=Et/it;else{let St=!1,zt=Et+1;if(jt==="fit"){const Dt=Math.ceil((Tt+Qt+Ct)*Pt);Bt&&Ne&&Xe<=pe.stableFitRemainingWidth?(St=!0,zt=pe.stableFitMaxMinimapScale):St=Dt>ht}if(jt==="fill"||St){Kt=!0;const Dt=Et;Pt=Math.min(Mt*it,Math.max(1,Math.floor(1/Nt))),Bt&&Ne&&Xe<=pe.stableFitRemainingWidth&&(zt=pe.stableFitMaxMinimapScale),Et=Math.min(zt,Math.max(1,Math.floor(Pt/ti))),Et>Dt&&(Rt=Math.min(2,Et/Dt)),dt=Et/it/Rt,ht=Math.ceil(Math.max(ft,Tt+Qt+Ct)*Pt),Bt?(pe.stableMinimapLayoutInput=x,pe.stableFitRemainingWidth=Xe,pe.stableFitMaxMinimapScale=Et):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const oi=Math.floor(ei*dt),Lt=Math.min(oi,Math.max(0,Math.floor((Xe-Yt-2)*dt/(Jt+dt)))+e.MINIMAP_GUTTER_WIDTH);let He=Math.floor(it*Lt);const Ft=He/it;He=Math.floor(He*Rt);const Wt=Ut?1:2,Zt=ni==="left"?0:Ve-Lt-Yt;return{renderMinimap:Wt,minimapLeft:Zt,minimapWidth:Lt,minimapHeightIsEditorHeight:Kt,minimapIsSampling:ii,minimapScale:Et,minimapLineHeight:Pt,minimapCanvasInnerWidth:He,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:mt}}static computeLayout(x,pe){const Ve=pe.outerWidth|0,Ye=pe.outerHeight|0,it=pe.lineHeight|0,st=pe.lineNumbersDigitCount|0,Ne=pe.typicalHalfwidthCharacterWidth,Mt=pe.maxDigitWidth,Jt=pe.pixelRatio,_t=pe.viewLineCount,Ut=x.get(135),Et=Ut==="inherit"?x.get(134):Ut,ei=Et==="inherit"?x.get(130):Et,jt=x.get(133),ni=pe.isDominatedByLongLines,Yt=x.get(57),Qt=x.get(67).renderType!==0,Xe=x.get(68),Bt=x.get(104),ti=x.get(83),ht=x.get(72),mt=x.get(102),Kt=mt.verticalScrollbarSize,ii=mt.verticalHasArrows,Pt=mt.arrowSize,dt=mt.horizontalScrollbarSize,Rt=x.get(43),oi=x.get(109)!=="never";let Lt=x.get(65);Rt&&oi&&(Lt+=16);let He=0;if(Qt){const It=Math.max(st,Xe);He=Math.round(It*Mt)}let Ft=0;Yt&&(Ft=it*pe.glyphMarginDecorationLaneCount);let Wt=0,Zt=Wt+Ft,ft=Zt+He,Tt=ft+Lt;const Ct=Ve-Ft-He-Lt;let Nt=!1,Vt=!1,Ot=-1;Et==="inherit"&&ni?(Nt=!0,Vt=!0):ei==="on"||ei==="bounded"?Vt=!0:ei==="wordWrapColumn"&&(Ot=jt);const St=he.c({outerWidth:Ve,outerHeight:Ye,lineHeight:it,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Jt,scrollBeyondLastLine:Bt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:ht,verticalScrollbarWidth:Kt,viewLineCount:_t,remainingWidth:Ct,isViewportWrapping:Vt},pe.memory||new L);St.renderMinimap!==0&&St.minimapLeft===0&&(Wt+=St.minimapWidth,Zt+=St.minimapWidth,ft+=St.minimapWidth,Tt+=St.minimapWidth);const zt=Ct-St.minimapWidth,Dt=Math.max(1,Math.floor((zt-Kt-2)/Ne)),yt=ii?Pt:0;return Vt&&(Ot=Math.max(1,Dt),ei==="bounded"&&(Ot=Math.min(Ot,jt))),{width:Ve,height:Ye,glyphMarginLeft:Wt,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Zt,lineNumbersWidth:He,decorationsLeft:ft,decorationsWidth:Lt,contentLeft:Tt,contentWidth:zt,minimap:St,viewportColumn:Dt,isWordWrapMinified:Nt,isViewportWrapping:Vt,wrappingColumn:Ot,verticalScrollbarWidth:Kt,horizontalScrollbarHeight:dt,overviewRuler:{top:yt,width:Kt,height:Ye-2*yt,right:0}}}}e.EditorLayoutInfoComputer=he;class ve extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(x){return d(x,"simple",["simple","advanced"])}compute(x,pe,Ve){return pe.get(2)===2?"advanced":Ve}}var se;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(se||(e.ShowLightbulbIconMode=se={}));class $e extends k{constructor(){const x={enabled:se.OnCode};super(64,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[se.Off,se.OnCode,se.On],default:x.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:d(x.enabled,this.defaultValue.enabled,[se.Off,se.OnCode,se.On])}}}class te extends k{constructor(){const x={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:10,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:m.localize(57,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:d(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:c(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class X extends k{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:m.localize(65,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:d(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),padding:c(pe.padding,this.defaultValue.padding)}}}class V extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):o.clampedInt(x,this.defaultValue,0,1e3)}compute(x,pe,Ve){return Ve<0?o.clampedInt(-Ve*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class ie extends u{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>u.clamp(x,0,150),{markdownDescription:m.localize(66,null)})}compute(x,pe,Ve){return x.fontInfo.lineHeight}}class Ce extends k{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:x.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:m.localize(77,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),autohide:c(pe.autohide,this.defaultValue.autohide),size:d(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(pe.side,this.defaultValue.side,["right","left"]),showSlider:d(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(pe.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(pe.scale,1,1,3),maxColumn:o.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Te(Z){return Z==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Pe extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{top:o.clampedInt(pe.top,0,0,1e3),bottom:o.clampedInt(pe.bottom,0,0,1e3)}}}class be extends k{constructor(){const x={enabled:!0,cycle:!0};super(85,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:m.localize(81,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),cycle:c(pe.cycle,this.defaultValue.cycle)}}}class me extends w{constructor(){super(141)}compute(x,pe,Ve){return x.pixelRatio}}class G extends k{constructor(){const x={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(88,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:x.strings,description:m.localize(85,null)},comments:{anyOf:pe,default:x.comments,description:m.localize(86,null)},other:{anyOf:pe,default:x.other,description:m.localize(87,null)}},default:x,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const Jt=x?"on":"off";return{comments:Jt,strings:Jt,other:Jt}}if(!x||typeof x!="object")return this.defaultValue;const{other:pe,comments:Ve,strings:Ye}=x,it=["on","inline","off"];let st,Ne,Mt;return typeof pe=="boolean"?st=pe?"on":"off":st=d(pe,this.defaultValue.other,it),typeof Ve=="boolean"?Ne=Ve?"on":"off":Ne=d(Ve,this.defaultValue.comments,it),typeof Ye=="boolean"?Mt=Ye?"on":"off":Mt=d(Ye,this.defaultValue.strings,it),{other:st,comments:Ne,strings:Mt}}}var _;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(_||(e.RenderLineNumbersType=_={}));class le extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(x){let pe=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(pe=4,Ve=x):x==="interval"?pe=3:x==="relative"?pe=2:x==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ve}}}function de(Z){const x=Z.get(97);return x==="editable"?Z.get(90):x!=="on"}e.filterValidationDecorations=de;class Le extends k{constructor(){const x=[],pe={type:"number",description:m.localize(94,null)};super(101,"rulers",x,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:x,description:m.localize(96,null)})}validate(x){if(Array.isArray(x)){const pe=[];for(const Ve of x)if(typeof Ve=="number")pe.push({column:o.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Ye=Ve;pe.push({column:o.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return pe.sort((Ve,Ye)=>Ve.column-Ye.column),pe}return this.defaultValue}}class ge extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function ke(Z,x){if(typeof Z!="string")return x;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ie extends k{constructor(){const x={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x,Ve=o.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=o.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ke(pe.vertical,this.defaultValue.vertical),horizontal:ke(pe.horizontal,this.defaultValue.horizontal),useShadows:c(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:o.clampedInt(pe.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:o.clampedInt(pe.verticalSliderSize,Ye,0,1e3),scrollByPage:c(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:c(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class O extends k{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:m.localize(115,null)}})}applyUpdate(x,pe){let Ve=!1;pe.allowedCharacters&&x&&(M.$Cn(x.allowedCharacters,pe.allowedCharacters)||(x={...x,allowedCharacters:pe.allowedCharacters},Ve=!0)),pe.allowedLocales&&x&&(M.$Cn(x.allowedLocales,pe.allowedLocales)||(x={...x,allowedLocales:pe.allowedLocales},Ve=!0));const Ye=super.applyUpdate(x,pe);return Ve?new l(Ye.newValue,!0):Ye}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{nonBasicASCII:Q(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Q(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Q(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,pe){if(typeof x!="object"||!x)return pe;const Ve={};for(const[Ye,it]of Object.entries(x))it===!0&&(Ve[Ye]=!0);return Ve}}class K extends k{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:m.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:x.fontFamily,description:m.localize(122,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),mode:d(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:c(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:c(pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class j extends k{constructor(){const x={enabled:A.$us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:m.localize(124,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(125,null),m.localize(126,null),m.localize(127,null)],default:x.bracketPairs,description:m.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null)],default:x.bracketPairsHorizontal,description:m.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:m.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:m.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:x.highlightActiveIndentation,description:m.localize(138,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{bracketPairs:Q(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Q(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Q(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Q(Z,x,pe){const Ve=pe.indexOf(Z);return Ve===-1?x:pe[Ve]}class oe extends k{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(139,null),m.localize(140,null)],default:x.insertMode,description:m.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:m.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:m.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:m.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null),m.localize(148,null)],default:x.selectionMode,markdownDescription:m.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:m.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:m.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:m.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:m.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:m.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{insertMode:d(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:c(pe.showIcons,this.defaultValue.showIcons),showStatusBar:c(pe.showStatusBar,this.defaultValue.showStatusBar),preview:c(pe.preview,this.defaultValue.preview),previewMode:d(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(pe.showMethods,this.defaultValue.showMethods),showFunctions:c(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(pe.showFields,this.defaultValue.showFields),showVariables:c(pe.showVariables,this.defaultValue.showVariables),showClasses:c(pe.showClasses,this.defaultValue.showClasses),showStructs:c(pe.showStructs,this.defaultValue.showStructs),showInterfaces:c(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(pe.showModules,this.defaultValue.showModules),showProperties:c(pe.showProperties,this.defaultValue.showProperties),showEvents:c(pe.showEvents,this.defaultValue.showEvents),showOperators:c(pe.showOperators,this.defaultValue.showOperators),showUnits:c(pe.showUnits,this.defaultValue.showUnits),showValues:c(pe.showValues,this.defaultValue.showValues),showConstants:c(pe.showConstants,this.defaultValue.showConstants),showEnums:c(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(pe.showKeywords,this.defaultValue.showKeywords),showWords:c(pe.showWords,this.defaultValue.showWords),showColors:c(pe.showColors,this.defaultValue.showColors),showFiles:c(pe.showFiles,this.defaultValue.showFiles),showReferences:c(pe.showReferences,this.defaultValue.showReferences),showFolders:c(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(pe.showSnippets,this.defaultValue.showSnippets),showUsers:c(pe.showUsers,this.defaultValue.showUsers),showIssues:c(pe.showIssues,this.defaultValue.showIssues)}}}class Ee extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(188,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:c(x.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class We extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(189,null),m.localize(190,null),m.localize(191,null),m.localize(192,null)],description:m.localize(193,null),default:"same"}})}validate(x){switch(x){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(x,pe,Ve){return pe.get(2)===2?0:Ve}}class Ze extends w{constructor(){super(144)}compute(x,pe,Ve){const Ye=pe.get(143);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}class _e extends k{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(196,null),m.localize(197,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),showDropSelector:d(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends k{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(200,null),m.localize(201,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),showPasteSelector:d(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?et:I.$k?ct:rt,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var vt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.letterSpacing=63]="letterSpacing",Z[Z.lightbulb=64]="lightbulb",Z[Z.lineDecorationsWidth=65]="lineDecorationsWidth",Z[Z.lineHeight=66]="lineHeight",Z[Z.lineNumbers=67]="lineNumbers",Z[Z.lineNumbersMinChars=68]="lineNumbersMinChars",Z[Z.linkedEditing=69]="linkedEditing",Z[Z.links=70]="links",Z[Z.matchBrackets=71]="matchBrackets",Z[Z.minimap=72]="minimap",Z[Z.mouseStyle=73]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=75]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=77]="multiCursorModifier",Z[Z.multiCursorPaste=78]="multiCursorPaste",Z[Z.multiCursorLimit=79]="multiCursorLimit",Z[Z.occurrencesHighlight=80]="occurrencesHighlight",Z[Z.overviewRulerBorder=81]="overviewRulerBorder",Z[Z.overviewRulerLanes=82]="overviewRulerLanes",Z[Z.padding=83]="padding",Z[Z.pasteAs=84]="pasteAs",Z[Z.parameterHints=85]="parameterHints",Z[Z.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=88]="quickSuggestions",Z[Z.quickSuggestionsDelay=89]="quickSuggestionsDelay",Z[Z.readOnly=90]="readOnly",Z[Z.readOnlyMessage=91]="readOnlyMessage",Z[Z.renameOnType=92]="renameOnType",Z[Z.renderControlCharacters=93]="renderControlCharacters",Z[Z.renderFinalNewline=94]="renderFinalNewline",Z[Z.renderLineHighlight=95]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=97]="renderValidationDecorations",Z[Z.renderWhitespace=98]="renderWhitespace",Z[Z.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Z[Z.roundedSelection=100]="roundedSelection",Z[Z.rulers=101]="rulers",Z[Z.scrollbar=102]="scrollbar",Z[Z.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=104]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=105]="scrollPredominantAxis",Z[Z.selectionClipboard=106]="selectionClipboard",Z[Z.selectionHighlight=107]="selectionHighlight",Z[Z.selectOnLineNumbers=108]="selectOnLineNumbers",Z[Z.showFoldingControls=109]="showFoldingControls",Z[Z.showUnused=110]="showUnused",Z[Z.snippetSuggestions=111]="snippetSuggestions",Z[Z.smartSelect=112]="smartSelect",Z[Z.smoothScrolling=113]="smoothScrolling",Z[Z.stickyScroll=114]="stickyScroll",Z[Z.stickyTabStops=115]="stickyTabStops",Z[Z.stopRenderingLineAfter=116]="stopRenderingLineAfter",Z[Z.suggest=117]="suggest",Z[Z.suggestFontSize=118]="suggestFontSize",Z[Z.suggestLineHeight=119]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Z[Z.suggestSelection=121]="suggestSelection",Z[Z.tabCompletion=122]="tabCompletion",Z[Z.tabIndex=123]="tabIndex",Z[Z.unicodeHighlighting=124]="unicodeHighlighting",Z[Z.unusualLineTerminators=125]="unusualLineTerminators",Z[Z.useShadowDOM=126]="useShadowDOM",Z[Z.useTabStops=127]="useTabStops",Z[Z.wordBreak=128]="wordBreak",Z[Z.wordSeparators=129]="wordSeparators",Z[Z.wordWrap=130]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=133]="wordWrapColumn",Z[Z.wordWrapOverride1=134]="wordWrapOverride1",Z[Z.wordWrapOverride2=135]="wordWrapOverride2",Z[Z.wrappingIndent=136]="wrappingIndent",Z[Z.wrappingStrategy=137]="wrappingStrategy",Z[Z.showDeprecated=138]="showDeprecated",Z[Z.inlayHints=139]="inlayHints",Z[Z.editorClassName=140]="editorClassName",Z[Z.pixelRatio=141]="pixelRatio",Z[Z.tabFocusMode=142]="tabFocusMode",Z[Z.layoutInfo=143]="layoutInfo",Z[Z.wrappingInfo=144]="wrappingInfo",Z[Z.defaultColorDecorators=145]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(vt||(e.EditorOption=vt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(202,null)})),acceptSuggestionOnEnter:Ue(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(203,null),""],markdownDescription:m.localize(204,null)})),accessibilitySupport:Ue(new h),accessibilityPageSize:Ue(new o(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(205,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",m.localize(206,null))),ariaRequired:Ue(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(208,null),m.localize(209,null),""],description:m.localize(210,null)})),autoClosingComments:Ue(new n(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(211,null),m.localize(212,null),""],description:m.localize(213,null)})),autoClosingDelete:Ue(new n(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(214,null),""],description:m.localize(215,null)})),autoClosingOvertype:Ue(new n(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(216,null),""],description:m.localize(217,null)})),autoClosingQuotes:Ue(new n(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoIndent:Ue(new b(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],E,{enumDescriptions:[m.localize(221,null),m.localize(222,null),m.localize(223,null),m.localize(224,null),m.localize(225,null)],description:m.localize(226,null)})),automaticLayout:Ue(new s(13,"automaticLayout",!1)),autoSurround:Ue(new n(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),bracketPairColorization:Ue(new j),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new s(115,"stickyTabStops",!1,{description:m.localize(231,null)})),codeLens:Ue(new s(17,"codeLens",!0,{description:m.localize(232,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:m.localize(233,null)})),codeLensFontSize:Ue(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(234,null)})),colorDecorators:Ue(new s(20,"colorDecorators",!0,{description:m.localize(235,null)})),colorDecoratorActivatedOn:Ue(new n(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),colorDecoratorsLimit:Ue(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(240,null)})),columnSelection:Ue(new s(22,"columnSelection",!1,{description:m.localize(241,null)})),comments:Ue(new v),contextmenu:Ue(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(242,null)})),cursorBlinking:Ue(new b(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:m.localize(243,null)})),cursorSmoothCaretAnimation:Ue(new n(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),cursorStyle:Ue(new b(28,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:m.localize(248,null)})),cursorSurroundingLines:Ue(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(249,null)})),cursorSurroundingLinesStyle:Ue(new n(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(250,null),m.localize(251,null)],markdownDescription:m.localize(252,null)})),cursorWidth:Ue(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(253,null)})),disableLayerHinting:Ue(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new s(34,"domReadOnly",!1)),dragAndDrop:Ue(new s(35,"dragAndDrop",!0,{description:m.localize(254,null)})),emptySelectionClipboard:Ue(new J),dropIntoEditor:Ue(new _e),stickyScroll:Ue(new te),experimentalWhitespaceRendering:Ue(new n(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new u(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:m.localize(259,null)})),find:Ue(new q),fixedOverflowWidgets:Ue(new s(42,"fixedOverflowWidgets",!1)),folding:Ue(new s(43,"folding",!0,{description:m.localize(260,null)})),foldingStrategy:Ue(new n(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),foldingHighlight:Ue(new s(45,"foldingHighlight",!0,{description:m.localize(264,null)})),foldingImportsByDefault:Ue(new s(46,"foldingImportsByDefault",!1,{description:m.localize(265,null)})),foldingMaximumRegions:Ue(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(266,null)})),unfoldOnClickAfterEndOfLine:Ue(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(267,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(268,null)})),fontInfo:Ue(new F),fontLigatures2:Ue(new U),fontSize:Ue(new W),fontWeight:Ue(new re),fontVariations:Ue(new C),formatOnPaste:Ue(new s(55,"formatOnPaste",!1,{description:m.localize(269,null)})),formatOnType:Ue(new s(56,"formatOnType",!1,{description:m.localize(270,null)})),glyphMargin:Ue(new s(57,"glyphMargin",!0,{description:m.localize(271,null)})),gotoLocation:Ue(new ce),hideCursorInOverviewRuler:Ue(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(272,null)})),hover:Ue(new we),inDiffEditor:Ue(new s(61,"inDiffEditor",!1)),letterSpacing:Ue(new u(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>u.clamp(Z,-5,20),{description:m.localize(273,null)})),lightbulb:Ue(new $e),lineDecorationsWidth:Ue(new V),lineHeight:Ue(new ie),lineNumbers:Ue(new le),lineNumbersMinChars:Ue(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new s(69,"linkedEditing",!1,{description:m.localize(274,null)})),links:Ue(new s(70,"links",!0,{description:m.localize(275,null)})),matchBrackets:Ue(new n(71,"matchBrackets","always",["always","near","never"],{description:m.localize(276,null)})),minimap:Ue(new Ce),mouseStyle:Ue(new n(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new u(74,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:m.localize(277,null)})),mouseWheelZoom:Ue(new s(75,"mouseWheelZoom",!1,{markdownDescription:I.$j?m.localize(278,null):m.localize(279,null)})),multiCursorMergeOverlapping:Ue(new s(76,"multiCursorMergeOverlapping",!0,{description:m.localize(280,null)})),multiCursorModifier:Ue(new b(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[m.localize(281,null),m.localize(282,null)],markdownDescription:m.localize(283,null)})),multiCursorPaste:Ue(new n(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(284,null),m.localize(285,null)],markdownDescription:m.localize(286,null)})),multiCursorLimit:Ue(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(287,null)})),occurrencesHighlight:Ue(new n(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(288,null),m.localize(289,null),m.localize(290,null)],markdownDescription:m.localize(291,null)})),overviewRulerBorder:Ue(new s(81,"overviewRulerBorder",!0,{description:m.localize(292,null)})),overviewRulerLanes:Ue(new o(82,"overviewRulerLanes",3,0,3)),padding:Ue(new Pe),pasteAs:Ue(new at),parameterHints:Ue(new be),peekWidgetDefaultFocus:Ue(new n(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(293,null),m.localize(294,null)],description:m.localize(295,null)})),definitionLinkOpensInPeek:Ue(new s(87,"definitionLinkOpensInPeek",!1,{description:m.localize(296,null)})),quickSuggestions:Ue(new G),quickSuggestionsDelay:Ue(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(297,null)})),readOnly:Ue(new s(90,"readOnly",!1)),readOnlyMessage:Ue(new ge),renameOnType:Ue(new s(92,"renameOnType",!1,{description:m.localize(298,null),markdownDeprecationMessage:m.localize(299,null)})),renderControlCharacters:Ue(new s(93,"renderControlCharacters",!0,{description:m.localize(300,null),restricted:!0})),renderFinalNewline:Ue(new n(94,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(301,null)})),renderLineHighlight:Ue(new n(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(302,null)],description:m.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Ue(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(304,null)})),renderValidationDecorations:Ue(new n(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new n(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(305,null),m.localize(306,null),m.localize(307,null),""],description:m.localize(308,null)})),revealHorizontalRightPadding:Ue(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new s(100,"roundedSelection",!0,{description:m.localize(309,null)})),rulers:Ue(new Le),scrollbar:Ue(new Ie),scrollBeyondLastColumn:Ue(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(310,null)})),scrollBeyondLastLine:Ue(new s(104,"scrollBeyondLastLine",!0,{description:m.localize(311,null)})),scrollPredominantAxis:Ue(new s(105,"scrollPredominantAxis",!0,{description:m.localize(312,null)})),selectionClipboard:Ue(new s(106,"selectionClipboard",!0,{description:m.localize(313,null),included:I.$k})),selectionHighlight:Ue(new s(107,"selectionHighlight",!0,{description:m.localize(314,null)})),selectOnLineNumbers:Ue(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new n(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(315,null),m.localize(316,null),m.localize(317,null)],description:m.localize(318,null)})),showUnused:Ue(new s(110,"showUnused",!0,{description:m.localize(319,null)})),showDeprecated:Ue(new s(138,"showDeprecated",!0,{description:m.localize(320,null)})),inlayHints:Ue(new X),snippetSuggestions:Ue(new n(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(321,null),m.localize(322,null),m.localize(323,null),m.localize(324,null)],description:m.localize(325,null)})),smartSelect:Ue(new Ee),smoothScrolling:Ue(new s(113,"smoothScrolling",!1,{description:m.localize(326,null)})),stopRenderingLineAfter:Ue(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new oe),inlineSuggest:Ue(new K),inlineCompletionsAccessibilityVerbose:Ue(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(327,null)})),suggestFontSize:Ue(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new s(120,"suggestOnTriggerCharacters",!0,{description:m.localize(330,null)})),suggestSelection:Ue(new n(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(331,null),m.localize(332,null),m.localize(333,null)],description:m.localize(334,null)})),tabCompletion:Ue(new n(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(335,null),m.localize(336,null),m.localize(337,null)],description:m.localize(338,null)})),tabIndex:Ue(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new O),unusualLineTerminators:Ue(new n(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(339,null),m.localize(340,null),m.localize(341,null)],description:m.localize(342,null)})),useShadowDOM:Ue(new s(126,"useShadowDOM",!0)),useTabStops:Ue(new s(127,"useTabStops",!0,{description:m.localize(343,null)})),wordBreak:Ue(new n(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(344,null),m.localize(345,null)],description:m.localize(346,null)})),wordSeparators:Ue(new t(129,"wordSeparators",R.$vs,{description:m.localize(347,null)})),wordWrap:Ue(new n(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(348,null),m.localize(349,null),m.localize(350,null),m.localize(351,null)],description:m.localize(352,null)})),wordWrapBreakAfterCharacters:Ue(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(353,null)})),wordWrapOverride1:Ue(new n(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new n(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new N),defaultColorDecorators:Ue(new s(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(354,null)})),pixelRatio:Ue(new me),tabFocusMode:Ue(new s(142,"tabFocusMode",!1,{markdownDescription:m.localize(355,null)})),layoutInfo:Ue(new he),wrappingInfo:Ue(new Ze),wrappingIndent:Ue(new We),wrappingStrategy:Ue(new ve)}}),define(Ae[149],Me([9,10]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[150],Me([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[151],Me([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[152],Me([9,10]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[153],Me([9,10]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[154],Me([9,10]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(Ae[155],Me([9,10]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(Ae[156],Me([9,10]),function(fe,e){return fe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[157],Me([9,10]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(Ae[158],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ae[159],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatProvider",e)}),define(Ae[160],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[161],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[162],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[163],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[164],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[165],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[166],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[167],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[168],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[169],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[170],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[171],Me([9,10]),function(fe,e){return fe.create("vs/workbench/common/configuration",e)}),define(Ae[172],Me([9,10]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(Ae[173],Me([9,10]),function(fe,e){return fe.create("vs/workbench/common/views",e)}),define(Ae[174],Me([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[175],Me([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[176],Me([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[177],Me([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[178],Me([9,10]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[179],Me([9,10]),function(fe,e){return fe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ae[180],Me([9,10]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[181],Me([9,10]),function(fe,e){return fe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[182],Me([1,0,15,151]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.TokenType=void 0;var I;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(I||(e.TokenType=I={}));function A(...D){switch(D.length){case 1:return(0,M.localize)(0,null,D[0]);case 2:return(0,M.localize)(1,null,D[0],D[1]);case 3:return(0,M.localize)(2,null,D[0],D[1],D[2]);default:return}}const R=(0,M.localize)(3,null),m=(0,M.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const k=this.d,l=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:l};this.g.push({offset:k,lexeme:l,additionalInfo:L}),this.f.push($)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const k=this.c.substring(this.d,this.e),l=f.b.get(k);l?this.k(l):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,k=!1,l=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(m);return}const w=this.c.charCodeAt(L);if(k)k=!1;else if(w===47&&!l){L++;break}else w===91?l=!0:w===92?k=!0:w===93&&(l=!1);L++}for(;L<this.c.length&&f.a.has(this.c.charCodeAt(L));)L++;this.e=L;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$3i=f}),define(Ae[183],Me([1,0,24,32,153,297]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function f(s){return s=s.trim(),s==="*"||R.test(s)}e.$cp=f;function D(s){if(!f(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$dp=D;function L(s){if(!s)return null;const i=s.majorBase,o=s.majorMustEqual,a=s.minorBase;let u=s.minorMustEqual;const t=s.patchBase;let d=s.patchMustEqual;s.hasCaret&&(i===0||(u=!1),d=!1);let n=0;if(s.preRelease){const b=m.exec(s.preRelease);if(b){const[,E,h,v]=b;n=Date.UTC(Number(E),Number(h)-1,Number(v))}}return{majorBase:i,majorMustEqual:o,minorBase:a,minorMustEqual:u,patchBase:t,patchMustEqual:d,isMinimum:s.hasGreaterEquals,notBefore:n}}e.$ep=L;function k(s,i,o){let a;typeof s=="string"?a=L(D(s)):a=s;let u;i instanceof Date?u=i.getTime():typeof i=="string"&&(u=new Date(i).getTime());let t;if(typeof o=="string"?t=L(D(o)):t=o,!a||!t)return!1;const d=a.majorBase,n=a.minorBase,b=a.patchBase;let E=t.majorBase,h=t.minorBase,v=t.patchBase;const P=t.notBefore;let g=t.majorMustEqual,p=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?d>E?!0:d<E?!1:n>h?!0:n<h||u&&u<P?!1:b>=v:(d===1&&E===0&&(!g||!p||!y)&&(E=1,h=0,v=0,g=!0,p=!1,y=!1),d<E?!1:d>E?!g:n<h?!1:n>h?!p:b<v?!1:b>v?!y:!(u&&u<P))}e.$fp=k;function l(s,i,o,a,u){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([M.default.Error,I.localize(0,null)]),t;if(typeof a.name!="string")return t.push([M.default.Error,I.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([M.default.Error,I.localize(2,null,"version")]),t;if(!a.engines)return t.push([M.default.Error,I.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([M.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!c(a.extensionDependencies))return t.push([M.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!c(a.activationEvents))return t.push([M.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([M.default.Error,I.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([M.default.Warning,I.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([M.default.Error,I.localize(9,null,"main")]),t;{const b=(0,S.$Ig)(o,a.main);(0,S.$Cg)(b,o)||t.push([M.default.Warning,I.localize(10,null,b.path,o.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([M.default.Error,I.localize(11,null,"browser")]),t;{const b=(0,S.$Ig)(o,a.browser);(0,S.$Cg)(b,o)||t.push([M.default.Warning,I.localize(12,null,b.path,o.path)])}}if(!A.valid(a.version))return t.push([M.default.Error,I.localize(13,null)]),t;const d=[];if(!$(s,i,a,u,d))for(const b of d)t.push([M.default.Error,b]);return t}e.$gp=l;function $(s,i,o,a,u){return a||typeof o.main>"u"&&typeof o.browser>"u"?!0:r(s,i,o.engines.vscode,u)}e.$hp=$;function w(s,i,o){return s==="*"||r(i,o,s)}e.$ip=w;function r(s,i,o,a=[]){const u=L(D(o));if(!u)return a.push(I.localize(14,null,o)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return a.push(I.localize(15,null,o)),!1}else if(!u.majorMustEqual)return a.push(I.localize(16,null,o)),!1;return k(s,i,u)?!0:(a.push(I.localize(17,null,s,o)),!1)}function c(s){if(!Array.isArray(s))return!1;for(let i=0,o=s.length;i<o;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Ae[70],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class S{constructor(I,A=[],R=!1){this.ctor=I,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.$5h=S}),define(Ae[53],Me([1,0,70]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const M=[];var I;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function A(m,f,D){f instanceof S.$5h||(f=new S.$5h(f,[],!!D)),M.push([m,f])}e.$1r=A;function R(){return M}e.$2r=R}),define(Ae[184],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class S{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=S;class M{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const m=this.lookupOrInsertNode(A),f=this.lookupOrInsertNode(R);m.outgoing.set(f.key,f),f.incoming.set(m.key,m)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const m of this.a.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let m=this.a.get(R);return m||(m=new S(R,A),this.a.set(R,m)),m}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,m]of this.a)A.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const m=new Set([A]),f=this.c(R,m);if(f)return f}}c(A,R){for(const[m,f]of A.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const D=this.c(f,R);if(D)return D;R.delete(m)}}}e.$Fq=M}),define(Ae[4],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e._util=void 0;var S;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(S||(e._util=S={})),e.$7h=I("instantiationService");function M(R,m,f){m[S.DI_TARGET]===m?m[S.DI_DEPENDENCIES].push({id:R,index:f}):(m[S.DI_DEPENDENCIES]=[{id:R,index:f}],m[S.DI_TARGET]=m)}function I(R){if(S.serviceIds.has(R))return S.serviceIds.get(R);const m=function(f,D,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(m,f,L)};return m.toString=()=>R,S.serviceIds.set(R,m),m}e.$8h=I;function A(R){return R}e.$9h=A}),define(Ae[47],Me([1,0,16,2,4]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.ConfigurationTarget=e.$Di=e.$Ci=e.$Bi=void 0,e.$Bi=(0,I.$8h)("configurationService");function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof M.URI)}e.$Ci=A;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof M.URI)}e.$Di=R;var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function f(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ei=f;function D(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$Fi=D;function L(s,i){const o=Object.create(null);for(const a in s)k(o,a,s[a],i);return o}e.$Gi=L;function k(s,i,o,a){const u=i.split("."),t=u.pop();let d=s;for(let n=0;n<u.length;n++){const b=u[n];let E=d[b];switch(typeof E){case"undefined":E=d[b]=Object.create(null);break;case"object":break;default:a(`Ignoring ${i} as ${u.slice(0,n+1).join(".")} is ${JSON.stringify(E)}`);return}d=E}if(typeof d=="object"&&d!==null)try{d[t]=o}catch{a(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(d)}`)}else a(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(d)}`)}e.$Hi=k;function l(s,i){const o=i.split(".");$(s,o)}e.$Ii=l;function $(s,i){const o=i.shift();if(i.length===0){delete s[o];return}if(Object.keys(s).indexOf(o)!==-1){const a=s[o];typeof a=="object"&&!Array.isArray(a)&&($(a,i),Object.keys(a).length===0&&delete s[o])}}function w(s,i,o){function a(d,n){let b=d;for(const E of n){if(typeof b!="object"||b===null)return;b=b[E]}return b}const u=i.split("."),t=a(s,u);return typeof t>"u"?o:t}e.$Ji=w;function r(s,i,o){Object.keys(i).forEach(a=>{a!=="__proto__"&&(a in s?S.$Lf(s[a])&&S.$Lf(i[a])?r(s[a],i[a],o):o&&(s[a]=i[a]):s[a]=i[a])})}e.$Ki=r;function c(s){return s.replace(/[\[\]]/g,"")}e.$Li=c}),define(Ae[35],Me([1,0,20,13,182,4,150,15]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.ContextKeyExprType=e.$4i=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",S.$j),f.set("isLinux",S.$k),f.set("isWindows",S.$i),f.set("isWeb",S.$o),f.set("isMacNative",S.$j&&!S.$o),f.set("isEdge",S.$H),f.set("isFirefox",S.$F),f.set("isChrome",S.$E),f.set("isSafari",S.$G);function D(X,V){if(f.get(X)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(X,V)}e.$4i=D;const L=Object.prototype.hasOwnProperty;var k;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const l={regexParsingWithErrorRecovery:!0},$=(0,R.localize)(0,null),w=(0,R.localize)(1,null),r=(0,R.localize)(2,null),c=(0,R.localize)(3,null),s=(0,R.localize)(4,null),i=(0,R.localize)(5,null),o=(0,R.localize)(6,null),a=(0,R.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new I.$3i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const Ce=this.D(),Te=Ce.type===17?i:void 0;throw this.h.push({message:s,offset:Ce.offset,lexeme:I.$3i.getLexeme(Ce),additionalInfo:Te}),u.c}return ie}catch(ie){if(ie!==u.c)throw ie;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ie=this.o();V.push(ie)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ie=this.s();V.push(ie)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),E.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,c),ie?.negate()}case 17:return this.z(),T.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,c),ie}case 17:{const ie=V.lexeme;if(this.z(),this.y(9)){const Te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Te.type!==10)throw this.B("REGEX",Te);const Pe=Te.lexeme,be=Pe.lastIndexOf("/"),me=be===Pe.length-1?void 0:this.w(Pe.substring(be+1));let G;try{G=new RegExp(Pe.substring(1,be),me)}catch{throw this.B("REGEX",Te)}return F.create(ie,G)}switch(Te.type){case 10:case 19:{const Pe=[Te.lexeme];this.z();let be=this.D(),me=0;for(let Le=0;Le<Te.lexeme.length;Le++)Te.lexeme.charCodeAt(Le)===40?me++:Te.lexeme.charCodeAt(Le)===41&&me--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:me++;break;case 1:me--;break;case 10:case 18:for(let Le=0;Le<be.lexeme.length;Le++)be.lexeme.charCodeAt(Le)===40?me++:Te.lexeme.charCodeAt(Le)===41&&me--}if(me<0)break;Pe.push(I.$3i.getLexeme(be)),this.z(),be=this.D()}const G=Pe.join(""),_=G.lastIndexOf("/"),le=_===G.length-1?void 0:this.w(G.substring(_+1));let de;try{de=new RegExp(G.substring(1,_),le)}catch{throw this.B("REGEX",Te)}return t.regex(ie,de)}case 18:{const Pe=Te.lexeme;this.z();let be=null;if(!(0,M.$Ke)(Pe)){const me=Pe.indexOf("/"),G=Pe.lastIndexOf("/");if(me!==G&&me>=0){const _=Pe.slice(me+1,G),le=Pe[G+1]==="i"?"i":"";try{be=new RegExp(_,le)}catch{throw this.B("REGEX",Te)}}}if(be===null)throw this.B("REGEX",Te);return F.create(ie,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Te=this.u();return t.notIn(ie,Te)}switch(this.D().type){case 3:{this.z();const Te=this.u();if(this.x().type===18)return t.equals(ie,Te);switch(Te){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,Te)}}case 4:{this.z();const Te=this.u();if(this.x().type===18)return t.notEquals(ie,Te);switch(Te){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,Te)}}case 5:return this.z(),U.create(ie,this.u());case 6:return this.z(),C.create(ie,this.u());case 7:return this.z(),J.create(ie,this.u());case 8:return this.z(),q.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:o,offset:V.offset,lexeme:"",additionalInfo:a}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ie){if(this.C(V))return this.z();throw this.B(ie,this.D())}B(V,ie,Ce){const Te=(0,R.localize)(8,null,V,I.$3i.getLexeme(ie)),Pe=ie.offset,be=I.$3i.getLexeme(ie);return this.h.push({message:Te,offset:Pe,lexeme:be,additionalInfo:Ce}),u.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$5i=u;class t{static false(){return E.INSTANCE}static true(){return h.INSTANCE}static has(V){return v.create(V)}static equals(V,ie){return P.create(V,ie)}static notEquals(V,ie){return y.create(V,ie)}static regex(V,ie){return F.create(V,ie)}static in(V,ie){return g.create(V,ie)}static notIn(V,ie){return p.create(V,ie)}static not(V){return T.create(V)}static and(...V){return ce.create(V,null,!0)}static or(...V){return we.create(V,null,!0)}static greater(V,ie){return J.create(V,ie)}static greaterEquals(V,ie){return q.create(V,ie)}static smaller(V,ie){return U.create(V,ie)}static smallerEquals(V,ie){return C.create(V,ie)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$6i=t;function d(X){const V=new u({regexParsingWithErrorRecovery:!1});return X.map(ie=>(V.parse(ie),V.lexingErrors.length>0?V.lexingErrors.map(Ce=>({errorMessage:Ce.additionalInfo?(0,R.localize)(9,null,Ce.additionalInfo):(0,R.localize)(10,null),offset:Ce.offset,length:Ce.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ce=>({errorMessage:Ce.additionalInfo?`${Ce.message}. ${Ce.additionalInfo}`:Ce.message,offset:Ce.offset,length:Ce.lexeme.length})):[]))}e.$7i=d;function n(X,V){const ie=X?X.substituteConstants():void 0,Ce=V?V.substituteConstants():void 0;return!ie&&!Ce?!0:!ie||!Ce?!1:ie.equals(Ce)}e.$8i=n;function b(X,V){return X.cmp(V)}class E{static{this.INSTANCE=new E}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return h.INSTANCE}}e.$9i=E;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return E.INSTANCE}}e.$0i=h;class v{static create(V,ie=null){const Ce=f.get(V);return typeof Ce=="boolean"?Ce?h.INSTANCE:E.INSTANCE:new v(V,ie)}constructor(V,ie){this.key=V,this.c=ie,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:he(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=f.get(this.key);return typeof V=="boolean"?V?h.INSTANCE:E.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.$$i=v;class P{static create(V,ie,Ce=null){if(typeof ie=="boolean")return ie?v.create(V,Ce):T.create(V,Ce);const Te=f.get(V);return typeof Te=="boolean"?ie===(Te?"true":"false")?h.INSTANCE:E.INSTANCE:new P(V,ie,Ce)}constructor(V,ie,Ce){this.c=V,this.d=ie,this.f=Ce,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=f.get(this.c);if(typeof V=="boolean"){const ie=V?"true":"false";return this.d===ie?h.INSTANCE:E.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$_i=P;class g{static create(V,ie){return new g(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ie=V.getValue(this.f),Ce=V.getValue(this.d);return Array.isArray(ie)?ie.includes(Ce):typeof Ce=="string"&&typeof ie=="object"&&ie!==null?L.call(ie,Ce):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$aj=g;class p{static create(V,ie){return new p(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=11,this.c=g.create(V,ie)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$bj=p;class y{static create(V,ie,Ce=null){if(typeof ie=="boolean")return ie?T.create(V,Ce):v.create(V,Ce);const Te=f.get(V);return typeof Te=="boolean"?ie===(Te?"true":"false")?E.INSTANCE:h.INSTANCE:new y(V,ie,Ce)}constructor(V,ie,Ce){this.c=V,this.d=ie,this.f=Ce,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=f.get(this.c);if(typeof V=="boolean"){const ie=V?"true":"false";return this.d===ie?E.INSTANCE:h.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$cj=y;class T{static create(V,ie=null){const Ce=f.get(V);return typeof Ce=="boolean"?Ce?E.INSTANCE:h.INSTANCE:new T(V,ie)}constructor(V,ie){this.c=V,this.d=ie,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=f.get(this.c);return typeof V=="boolean"?V?E.INSTANCE:h.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$dj=T;function N(X,V){if(typeof X=="string"){const ie=parseFloat(X);isNaN(ie)||(X=ie)}return typeof X=="string"||typeof X=="number"?V(X):E.INSTANCE}class J{static create(V,ie,Ce=null){return N(ie,Te=>new J(V,Te,Ce))}constructor(V,ie,Ce){this.c=V,this.d=ie,this.f=Ce,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$ej=J;class q{static create(V,ie,Ce=null){return N(ie,Te=>new q(V,Te,Ce))}constructor(V,ie,Ce){this.c=V,this.d=ie,this.f=Ce,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$fj=q;class U{static create(V,ie,Ce=null){return N(ie,Te=>new U(V,Te,Ce))}constructor(V,ie,Ce){this.c=V,this.d=ie,this.f=Ce,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$gj=U;class C{static create(V,ie,Ce=null){return N(ie,Te=>new C(V,Te,Ce))}constructor(V,ie,Ce){this.c=V,this.d=ie,this.f=Ce,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$hj=C;class F{static create(V,ie){return new F(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ie=this.f?this.f.source:"",Ce=V.f?V.f.source:"";return ie<Ce?-1:ie>Ce?1:0}equals(V){if(V.type===this.type){const ie=this.f?this.f.source:"",Ce=V.f?V.f.source:"";return this.d===V.d&&ie===Ce}return!1}substituteConstants(){return this}evaluate(V){const ie=V.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$ij=F;class W{static create(V){return new W(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new W(this.c.map(V))}negate(){return this.c}}e.$jj=W;function re(X){let V=null;for(let ie=0,Ce=X.length;ie<Ce;ie++){const Te=X[ie].substituteConstants();if(X[ie]!==Te&&V===null){V=[];for(let Pe=0;Pe<ie;Pe++)V[Pe]=X[Pe]}V!==null&&(V[ie]=Te)}return V===null?X:V}class ce{static create(V,ie,Ce){return ce.d(V,ie,Ce)}constructor(V,ie){this.expr=V,this.c=ie,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ie=0,Ce=this.expr.length;ie<Ce;ie++){const Te=b(this.expr[ie],V.expr[ie]);if(Te!==0)return Te}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ie=0,Ce=this.expr.length;ie<Ce;ie++)if(!this.expr[ie].equals(V.expr[ie]))return!1;return!0}return!1}substituteConstants(){const V=re(this.expr);return V===this.expr?this:ce.create(V,this.c,!1)}evaluate(V){for(let ie=0,Ce=this.expr.length;ie<Ce;ie++)if(!this.expr[ie].evaluate(V))return!1;return!0}static d(V,ie,Ce){const Te=[];let Pe=!1;for(const be of V)if(be){if(be.type===1){Pe=!0;continue}if(be.type===0)return E.INSTANCE;if(be.type===6){Te.push(...be.expr);continue}Te.push(be)}if(Te.length===0&&Pe)return h.INSTANCE;if(Te.length!==0){if(Te.length===1)return Te[0];Te.sort(b);for(let be=1;be<Te.length;be++)Te[be-1].equals(Te[be])&&(Te.splice(be,1),be--);if(Te.length===1)return Te[0];for(;Te.length>1;){const be=Te[Te.length-1];if(be.type!==9)break;Te.pop();const me=Te.pop(),G=Te.length===0,_=we.create(be.expr.map(le=>ce.create([le,me],null,Ce)),null,G);_&&(Te.push(_),Te.sort(b))}if(Te.length===1)return Te[0];if(Ce){for(let be=0;be<Te.length;be++)for(let me=be+1;me<Te.length;me++)if(Te[be].negate().equals(Te[me]))return E.INSTANCE;if(Te.length===1)return Te[0]}return new ce(Te,ie)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ie of this.expr)V.push(...ie.keys());return V}map(V){return new ce(this.expr.map(ie=>ie.map(V)),null)}negate(){if(!this.c){const V=[];for(const ie of this.expr)V.push(ie.negate());this.c=we.create(V,this,!0)}return this.c}}e.$kj=ce;class we{static create(V,ie,Ce){return we.d(V,ie,Ce)}constructor(V,ie){this.expr=V,this.c=ie,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ie=0,Ce=this.expr.length;ie<Ce;ie++){const Te=b(this.expr[ie],V.expr[ie]);if(Te!==0)return Te}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ie=0,Ce=this.expr.length;ie<Ce;ie++)if(!this.expr[ie].equals(V.expr[ie]))return!1;return!0}return!1}substituteConstants(){const V=re(this.expr);return V===this.expr?this:we.create(V,this.c,!1)}evaluate(V){for(let ie=0,Ce=this.expr.length;ie<Ce;ie++)if(this.expr[ie].evaluate(V))return!0;return!1}static d(V,ie,Ce){let Te=[],Pe=!1;if(V){for(let be=0,me=V.length;be<me;be++){const G=V[be];if(G){if(G.type===0){Pe=!0;continue}if(G.type===1)return h.INSTANCE;if(G.type===9){Te=Te.concat(G.expr);continue}Te.push(G)}}if(Te.length===0&&Pe)return E.INSTANCE;Te.sort(b)}if(Te.length!==0){if(Te.length===1)return Te[0];for(let be=1;be<Te.length;be++)Te[be-1].equals(Te[be])&&(Te.splice(be,1),be--);if(Te.length===1)return Te[0];if(Ce){for(let be=0;be<Te.length;be++)for(let me=be+1;me<Te.length;me++)if(Te[be].negate().equals(Te[me]))return h.INSTANCE;if(Te.length===1)return Te[0]}return new we(Te,ie)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ie of this.expr)V.push(...ie.keys());return V}map(V){return new we(this.expr.map(ie=>ie.map(V)),null)}negate(){if(!this.c){const V=[];for(const ie of this.expr)V.push(ie.negate());for(;V.length>1;){const ie=V.shift(),Ce=V.shift(),Te=[];for(const Pe of te(ie))for(const be of te(Ce))Te.push(ce.create([Pe,be],null,!1));V.unshift(we.create(Te,null,!1))}this.c=we.create(V,this,!0)}return this.c}}e.$lj=we;class De extends v{static{this.d=[]}static all(){return De.d.values()}constructor(V,ie,Ce){super(V,null),this.f=ie,typeof Ce=="object"?De.d.push({...Ce,key:V}):Ce!==!0&&De.d.push({key:V,description:Ce,type:ie!=null?typeof ie:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return P.create(this.key,V)}notEqualsTo(V){return y.create(this.key,V)}}e.$mj=De,e.$nj=(0,A.$8h)("contextKeyService");function he(X,V){return X<V?-1:X>V?1:0}function ve(X,V,ie,Ce){return X<ie?-1:X>ie?1:V<Ce?-1:V>Ce?1:0}function se(X,V){if(X.type===0||V.type===1)return!0;if(X.type===9)return V.type===9?$e(X.expr,V.expr):!1;if(V.type===9){for(const ie of V.expr)if(se(X,ie))return!0;return!1}if(X.type===6){if(V.type===6)return $e(V.expr,X.expr);for(const ie of X.expr)if(se(ie,V))return!0;return!1}return X.equals(V)}e.$oj=se;function $e(X,V){let ie=0,Ce=0;for(;ie<X.length&&Ce<V.length;){const Te=X[ie].cmp(V[Ce]);if(Te<0)return!1;Te===0&&ie++,Ce++}return ie===X.length}function te(X){return X.type===9?X.expr:[X]}}),define(Ae[185],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=void 0,e.$ci=(0,S.$8h)("environmentService"),e.$di=(0,S.$9h)(e.$ci)}),define(Ae[96],Me([1,0,152,4]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ExtensionGalleryErrorCode=e.$Co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0,e.$po="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$qo=new RegExp(e.$po),e.$ro="__web_extension",e.$so="skipWalkthrough",e.$to="extensionsSync",e.$uo="dependecyOrPackExtensionInstall";function I(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$vo=I;function A(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$wo=A;function R(o,a){switch(o){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$xo=R;function m(o,a){return a==="web"&&!o.includes("web")}e.$yo=m;function f(o,a,u){return m(a,u)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===u}e.$zo=f;function D(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$Ao=D;var L;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var k;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var l;(function(o){o.Install="install",o.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var $;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Bo=(0,M.$8h)("extensionGalleryService");var w;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Unknown="Unknown",o.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var r;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class c extends Error{constructor(a,u){super(a),this.code=u,this.name=u}}e.$Co=c;var s;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class i extends Error{constructor(a,u){super(a),this.code=u,this.name=u}}e.$Do=i,e.$Eo=(0,M.$8h)("extensionManagementService"),e.$Fo="extensionsIdentifiers/disabled",e.$Go="extensionsIdentifiers/enabled",e.$Ho=(0,M.$8h)("IGlobalExtensionEnablementService"),e.$Io=(0,M.$8h)("IExtensionTipsService"),e.$Jo=(0,S.localize2)(0,"Extensions"),e.$Ko=(0,S.localize2)(1,"Preferences")}),define(Ae[42],Me([1,0,51,19,13,16,2,154,4,20,12,39]),function(fe,e,S,M,I,A,R,m,f,D,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileKind=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileOperationResult=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileChangeType=e.$Kk=e.FileOperation=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderErrorCode=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileSystemProviderCapabilities=e.$uk=e.FilePermission=e.FileType=e.$tk=e.$sk=void 0,e.$sk=(0,f.$8h)("fileService");function l(se){return se.create===!0}e.$tk=l;var $;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var w;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(w||(e.FilePermission=w={}));function r(se){const $e=se;return!!$e&&typeof $e.onDidChange=="function"}e.$uk=r;var c;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function s(se){return!!(se.capabilities&2)}e.$vk=s;function i(se){return!!(se.capabilities&8)}e.$wk=i;function o(se){return!!(se.capabilities&131072)}e.$xk=o;function a(se){return!!(se.capabilities&4)}e.$yk=a;function u(se){return!!(se.capabilities&16)}e.$zk=u;function t(se){return s(se)?!!(se.capabilities&16384):!1}e.$Ak=t;function d(se){return s(se)?!!(se.capabilities&32768):!1}e.$Bk=d;function n(se){return!!(se.capabilities&65536)}e.$Ck=n;function b(se){return!!(se.capabilities&2048)}e.$Dk=b;var E;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class h extends Error{static create($e,te){const X=new h($e.toString(),te);return g(X,te),X}constructor($e,te){super($e),this.code=te}}e.$Ek=h;function v(se,$e){return h.create(se,$e)}e.$Fk=v;function P(se){return se||v((0,m.localize)(0,null),E.Unknown)}e.$Gk=P;function g(se,$e){return se.name=$e?`${$e} (FileSystemError)`:"FileSystemError",se}e.$Hk=g;function p(se){if(!se)return E.Unknown;if(se instanceof h)return se.code;const $e=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!$e)return E.Unknown;switch($e[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.$Ik=p;function y(se){if(se instanceof C)return se.fileOperationResult;switch(p(se)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 9;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileTooLarge:return 7;default:return 10}}e.$Jk=y;var T;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class N{constructor($e,te,X){this.resource=$e,this.operation=te,this.target=X}isOperation($e){return this.operation===$e}}e.$Kk=N;var J;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(J||(e.FileChangeType=J={}));class q{static{this.a=null}constructor($e,te){this.c=te,this.b=void 0,this.d=new k.$V(()=>{const X=S.$bi.forUris(()=>this.c);return X.fill(this.rawAdded.map(V=>[V,!0])),X}),this.f=new k.$V(()=>{const X=S.$bi.forUris(()=>this.c);return X.fill(this.rawUpdated.map(V=>[V,!0])),X}),this.g=new k.$V(()=>{const X=S.$bi.forUris(()=>this.c);return X.fill(this.rawDeleted.map(V=>[V,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of $e){switch(X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}this.b!==q.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains($e,...te){return this.h($e,{includeChildren:!1},...te)}affects($e,...te){return this.h($e,{includeChildren:!0},...te)}h($e,te,...X){if(!$e)return!1;const V=X.length>0;return!!((!V||X.includes(1))&&(this.d.value.get($e)||te.includeChildren&&this.d.value.findSuperstr($e))||(!V||X.includes(0))&&(this.f.value.get($e)||te.includeChildren&&this.f.value.findSuperstr($e))||(!V||X.includes(2))&&(this.g.value.findSubstr($e)||te.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Lk=q;function U(se,$e,te){return!se||!$e||se===$e||$e.length>se.length?!1:($e.charAt($e.length-1)!==M.sep&&($e+=M.sep),te?(0,I.$bf)(se,$e):se.indexOf($e)===0)}e.$Mk=U;class C extends Error{constructor($e,te,X){super($e),this.fileOperationResult=te,this.options=X}}e.$Nk=C;class F extends C{constructor($e,te,X,V){super($e,te,V),this.fileOperationResult=te,this.size=X}}e.$Ok=F;class W extends C{constructor($e,te,X){super($e,2,X),this.stat=te}}e.$Pk=W;var re;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$Qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Sk="files.associations",e.$Tk="files.exclude",e.$Uk="files.readonlyInclude",e.$Vk="files.readonlyExclude",e.$Wk="files.readonlyFromPermissions";var ce;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$Xk="";function we(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.$Yk=we;async function De(se,$e){if(!$e.hasProvider(R.URI.from({scheme:se.scheme})))return new Promise(te=>{const X=$e.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===se.scheme&&V.added&&(X.dispose(),te())})})}e.$Zk=De;class he{static{this.KB=1024}static{this.MB=he.KB*he.KB}static{this.GB=he.MB*he.KB}static{this.TB=he.GB*he.KB}static formatSize($e){return(0,A.$Nf)($e)||($e=0),$e<he.KB?(0,m.localize)(1,null,$e.toFixed(0)):$e<he.MB?(0,m.localize)(2,null,($e/he.KB).toFixed(2)):$e<he.GB?(0,m.localize)(3,null,($e/he.MB).toFixed(2)):$e<he.TB?(0,m.localize)(4,null,($e/he.GB).toFixed(2)):(0,m.localize)(5,null,($e/he.TB).toFixed(2))}}e.$1k=he;function ve(se){const $e=typeof se=="string"||se?.scheme===L.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===L.Schemas.file?1024*he.MB:$e?10*he.MB:D.$o?50*he.MB:1024*he.MB}e.$2k=ve}),define(Ae[71],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=void 0;class S{constructor(...I){this.a=new Map;for(const[A,R]of I)this.set(A,R)}set(I,A){const R=this.a.get(I);return this.a.set(I,A),R}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$6h=S}),define(Ae[186],Me([1,0,11,15,6,70,184,4,71,187]),function(fe,e,S,M,I,A,R,m,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const L=!1;class k extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class l{constructor(c=new f.$6h,s=!1,i,o=L){this.f=c,this.g=s,this.h=i,this.i=o,this.o=new Set,this.f.set(m.$7h,this),this._globalGraph=o?i?._globalGraph??new R.$Fq(a=>a):void 0}createChild(c){return new l(c,this.g,this,this.i)}invokeFunction(c,...s){const i=w.traceInvocation(this.i,c);let o=!1;try{return c({get:u=>{if(o)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(u,i);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...s)}finally{o=!0,i.stop()}}createInstance(c,...s){let i,o;return c instanceof A.$5h?(i=w.traceCreation(this.i,c.ctor),o=this.j(c.ctor,c.staticArguments.concat(s),i)):(i=w.traceCreation(this.i,c),o=this.j(c,s,i)),i.stop(),o}j(c,s=[],i){const o=m._util.getServiceDependencies(c).sort((t,d)=>t.index-d.index),a=[];for(const t of o){const d=this.m(t.id,i);d||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(d)}const u=o.length>0?o[0].index:s.length;if(s.length!==u){console.trace(`[createInstance] First service dependency of ${c.name} at position ${u+1} conflicts with ${s.length} static arguments`);const t=u-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,u)}return Reflect.construct(c,s.concat(a))}k(c,s){if(this.f.get(c)instanceof A.$5h)this.f.set(c,s);else if(this.h)this.h.k(c,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const s=this.f.get(c);return!s&&this.h?this.h.l(c):s}m(c,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const i=this.l(c);return i instanceof A.$5h?this.q(c,i,s.branch(c,!0)):(s.branch(c,!1),i)}q(c,s,i){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,s,i)}finally{this.o.delete(c)}}r(c,s,i){const o=new R.$Fq(t=>t.id.toString());let a=0;const u=[{id:c,desc:s,_trace:i}];for(;u.length;){const t=u.pop();if(o.lookupOrInsertNode(t),a++>1e3)throw new k(o);for(const d of m._util.getServiceDependencies(t.desc.ctor)){const n=this.l(d.id);if(n||this.u(`[createInstance] ${c} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),n instanceof A.$5h){const b={id:d.id,desc:n,_trace:t._trace.branch(d.id,!0)};o.insertEdge(t,b),u.push(b)}}}for(;;){const t=o.roots();if(t.length===0){if(!o.isEmpty())throw new k(o);break}for(const{data:d}of t){if(this.l(d.id)instanceof A.$5h){const b=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,b)}o.removeNode(d)}}return this.l(c)}s(c,s,i=[],o,a){if(this.f.get(c)instanceof A.$5h)return this.t(c,s,i,o,a);if(this.h)return this.h.s(c,s,i,o,a);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(c,s,i=[],o,a){if(o){const u=new l(void 0,this.g,this,this.i);u.c=String(c);const t=new Map,d=new S.$oh(()=>{const n=u.j(s,i,a);for(const[b,E]of t){const h=n[b];if(typeof h=="function")for(const v of E)v.disposable=h.apply(n,v.listener)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,b){if(!d.isInitialized&&typeof b=="string"&&(b.startsWith("onDid")||b.startsWith("onWill"))){let v=t.get(b);return v||(v=new D.$4c,t.set(b,v)),(g,p,y)=>{if(d.isInitialized)return d.value[b](g,p,y);{const T={listener:[g,p,y],disposable:void 0},N=v.push(T);return(0,I.$Rc)(()=>{N(),T.disposable?.dispose()})}}}if(b in n)return n[b];const E=d.value;let h=E[b];return typeof h!="function"||(h=h.bind(E),n[b]=h),h},set(n,b,E){return d.value[b]=E,!0},getPrototypeOf(n){return s.prototype}})}else return this.j(s,i,a)}u(c,s){if(s&&console.warn(c),this.g)throw new Error(c)}}e.$Gq=l;var $;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})($||($={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,s){return c?new w(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(c,s){return c?new w(1,s.name):w.c}static{this.f=0}constructor(c,s){this.type=c,this.name=s,this.g=Date.now(),this.h=[]}branch(c,s){const i=new w(3,c.toString());return this.h.push([c,s,i]),i}stop(){const c=Date.now()-this.g;w.f+=c;let s=!1;function i(a,u){const t=[],d=new Array(a+1).join("	");for(const[n,b,E]of u.h)if(b&&E){s=!0,t.push(`${d}CREATES -> ${n}`);const h=i(a+1,E);h&&t.push(h)}else t.push(`${d}uses -> ${n}`);return t.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(c>2||s)&&w.all.add(o.join(`
`))}}e.$Hq=w}),define(Ae[14],Me([1,0,41,5,97,6,28,20,24,16,2,35,4]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.log=e.$sj=e.LogLevel=e.$rj=e.$qj=e.$pj=void 0,e.$pj=(0,l.$8h)("logService"),e.$qj=(0,l.$8h)("loggerService");function $(){return new Date().toISOString()}function w(g){return(0,D.$Nf)(g)}e.$rj=w;var r;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$sj=r.Info;function c(g,p,y){switch(p){case r.Trace:g.trace(y);break;case r.Debug:g.debug(y);break;case r.Info:g.info(y);break;case r.Warning:g.warn(y);break;case r.Error:g.error(y);break;case r.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=c;function s(g,p=!1){let y="";for(let T=0;T<g.length;T++){let N=g[T];if(N instanceof Error&&(N=(0,S.$Si)(N,p)),typeof N=="object")try{N=JSON.stringify(N)}catch{}y+=(T>0?" ":"")+N}return y}class i extends A.$Tc{constructor(){super(...arguments),this.b=e.$sj,this.c=this.B(new M.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==r.Off&&this.b<=p}}e.$uj=i;class o extends i{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...y){this.f(r.Trace)&&this.g(r.Trace,s([p,...y],!0))}debug(p,...y){this.f(r.Debug)&&this.g(r.Debug,s([p,...y]))}info(p,...y){this.f(r.Info)&&this.g(r.Info,s([p,...y]))}warn(p,...y){this.f(r.Warning)&&this.g(r.Warning,s([p,...y]))}error(p,...y){if(this.f(r.Error))if(p instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=p.stack,this.g(r.Error,s(T))}else this.g(r.Error,s([p,...y]))}flush(){}}e.$vj=o;class a extends i{constructor(p=e.$sj){super(),this.setLevel(p),this.g=!m.$i}trace(p,...y){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,p,...y):console.log(`[main ${$()}]`,p,...y))}debug(p,...y){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,p,...y):console.log(`[main ${$()}]`,p,...y))}info(p,...y){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,p,...y):console.log(`[main ${$()}]`,p,...y))}warn(p,...y){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,p,...y):console.warn(`[main ${$()}]`,p,...y))}error(p,...y){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,p,...y):console.error(`[main ${$()}]`,p,...y))}flush(){}}e.$wj=a;class u extends i{constructor(p=e.$sj,y=!0){super(),this.g=y,this.setLevel(p)}trace(p,...y){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...y):console.log(p,...y))}debug(p,...y){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...y):console.log(p,...y))}info(p,...y){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...y):console.log(p,...y))}warn(p,...y){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...y):console.log(p,...y))}error(p,...y){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...y):console.error(p,...y))}flush(){}}e.$xj=u;class t extends i{constructor(p,y=e.$sj){super(),this.g=p,this.setLevel(y)}trace(p,...y){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(p),...y])}debug(p,...y){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(p),...y])}info(p,...y){this.f(r.Info)&&this.g.log(r.Info,[this.h(p),...y])}warn(p,...y){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(p),...y])}error(p,...y){this.f(r.Error)&&this.g.log(r.Error,[this.h(p),...y])}h(p){return typeof p=="string"?p:(0,S.$Si)(p,this.f(r.Trace))}flush(){}}e.$yj=t;class d extends i{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const y of this.g)y.setLevel(p);super.setLevel(p)}trace(p,...y){for(const T of this.g)T.trace(p,...y)}debug(p,...y){for(const T of this.g)T.debug(p,...y)}info(p,...y){for(const T of this.g)T.info(p,...y)}warn(p,...y){for(const T of this.g)T.warn(p,...y)}error(p,...y){for(const T of this.g)T.error(p,...y)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose();super.dispose()}}e.$zj=d;class n extends A.$Tc{constructor(p,y,T){if(super(),this.h=p,this.j=y,this.b=new R.$Ac,this.c=this.B(new M.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Wd),this.onDidChangeVisibility=this.g.event,T)for(const N of T)this.b.set(N.resource,{logger:void 0,info:N})}m(p){return(0,D.$Jf)(p)?[...this.b.values()].find(y=>y.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,y){const T=this.n(p),N=(0,D.$Jf)(p)?p:y?.id??(0,I.$Vi)(T.toString()).toString(16);let J=this.b.get(T)?.logger;const q=y?.logLevel==="always"?r.Trace:y?.logLevel;J||(J=this.s(T,q??this.getLogLevel(T)??this.h,{...y,id:N}));const U={logger:J,info:{resource:T,id:N,logLevel:q,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(U.info),this.b.set(T,U),J}n(p){return(0,D.$Jf)(p)?(0,f.$Ig)(this.j,`${p}.log`):p}setLogLevel(p,y){if(L.URI.isUri(p)){const T=p,N=y,J=this.b.get(T);J&&N!==J.info.logLevel&&(J.info.logLevel=N===this.h?void 0:N,J.logger?.setLevel(N),this.b.set(J.info.resource,J),this.f.fire([T,N]))}else{this.h=p;for(const[T,N]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,y){const T=this.m(p);T&&y!==!T.info.hidden&&(T.info.hidden=!y,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,y]))}getLogLevel(p){let y;return p&&(y=this.b.get(p)?.info.logLevel),y??this.h}registerLogger(p){const y=this.b.get(p.resource);y?y.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const y=this.b.get(p);y&&(y.logger&&y.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Aj=n;class b{constructor(){this.onDidChangeLogLevel=new M.$Wd().event}setLevel(p){}getLevel(){return r.Info}trace(p,...y){}debug(p,...y){}info(p,...y){}warn(p,...y){}error(p,...y){}critical(p,...y){}dispose(){}flush(){}}e.$Bj=b;class E extends b{}e.$Cj=E;function h(g){if(g.verbose)return r.Trace;if(typeof g.logLevel=="string"){const p=P(g.logLevel.toLowerCase());if(p!==void 0)return p}return e.$sj}e.$Dj=h;function v(g){switch(g){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}e.$Ej=v;function P(g){switch(g){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$Fj=P,e.$Gj=new k.$mj("logLevel",v(r.Info))}),define(Ae[188],Me([1,0,6,14]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=void 0;class I extends S.$Tc{constructor(R,m=[]){super(),this.a=new M.$zj([R,...m]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...m){this.a.trace(R,...m)}debug(R,...m){this.a.debug(R,...m)}info(R,...m){this.a.info(R,...m)}warn(R,...m){this.a.warn(R,...m)}error(R,...m){this.a.error(R,...m)}flush(){this.a.flush()}}e.$XO=I}),define(Ae[98],Me([1,0,32,155,4]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var R;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(f){function D(w,r){return r-w}f.compare=D;const L=Object.create(null);L[f.Error]=(0,M.localize)(0,null),L[f.Warning]=(0,M.localize)(1,null),L[f.Info]=(0,M.localize)(2,null);function k(w){return L[w]||""}f.toString=k;function l(w){switch(w){case S.default.Error:return f.Error;case S.default.Warning:return f.Warning;case S.default.Info:return f.Info;case S.default.Ignore:return f.Hint}}f.fromSeverity=l;function $(w){switch(w){case f.Error:return S.default.Error;case f.Warning:return S.default.Warning;case f.Info:return S.default.Info;case f.Hint:return S.default.Ignore}}f.toSeverity=$}(R||(e.MarkerSeverity=R={}));var m;(function(f){const D="";function L(l){return k(l,!0)}f.makeKey=L;function k(l,$){const w=[D];return l.source?w.push(l.source.replace("\xA6","\\\xA6")):w.push(D),l.code?typeof l.code=="string"?w.push(l.code.replace("\xA6","\\\xA6")):w.push(l.code.value.replace("\xA6","\\\xA6")):w.push(D),l.severity!==void 0&&l.severity!==null?w.push(R.toString(l.severity)):w.push(D),l.message&&$?w.push(l.message.replace("\xA6","\\\xA6")):w.push(D),l.startLineNumber!==void 0&&l.startLineNumber!==null?w.push(l.startLineNumber.toString()):w.push(D),l.startColumn!==void 0&&l.startColumn!==null?w.push(l.startColumn.toString()):w.push(D),l.endLineNumber!==void 0&&l.endLineNumber!==null?w.push(l.endLineNumber.toString()):w.push(D),l.endColumn!==void 0&&l.endColumn!==null?w.push(l.endColumn.toString()):w.push(D),w.push(D),w.join("\xA6")}f.makeKeyOptionalMessage=k})(m||(e.IMarkerData=m={})),e.$Ct=(0,I.$8h)("markerService")}),define(Ae[189],Me([1,0,5,32,4]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.NotificationsFilter=e.$sv=e.NeverShowAgainScope=e.NotificationPriority=e.$rv=e.Severity=void 0,e.Severity=M.default,e.$rv=(0,I.$8h)("notificationService");var A;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var R;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function m(k){if(k){const l=k;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$sv=m;var f;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class D{constructor(){this.progress=new L,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$tv=D;class L{infinite(){}done(){}total(l){}worked(l){}}e.$uv=L}),define(Ae[190],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=void 0,e.$Hj=(0,S.$8h)("productService"),e.$Ij="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(fe,e,S,M){var I=arguments.length,A=I<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,S):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(fe,e,S,M);else for(var m=fe.length-1;m>=0;m--)(R=fe[m])&&(A=(I<3?R(A):I>3?R(e,S,A):R(e,S))||A);return I>3&&A&&Object.defineProperty(e,S,A),A},qe=this&&this.__param||function(fe,e){return function(S,M){e(S,M,fe)}};define(Ae[99],Me([1,0,11,21,6,4]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.ProgressLocation=e.$vv=void 0,e.$vv=(0,A.$8h)("progressService");var R;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$wv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$xv=m;class f{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const $=this.d;this.d=()=>{$?.(),l()}}):Promise.resolve()}}e.$yv=f;let D=class extends I.$Tc{constructor(l,$){super(),this.a=new S.$sh,$.withProgress(l,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,I.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$zv=D,e.$zv=D=Je([qe(1,e.$vv)],D);class L extends I.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Sc)}start(l){this.stop();const $=++this.a,w=new M.$7d;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Rc)(()=>w.cancel())),this.b.add((0,I.$Rc)(()=>this.c?this.c.done():void 0)),{id:$,token:w.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$Av=L,e.$Bv=(0,A.$8h)("editorProgressService")}),define(Ae[30],Me([1,0,54,16]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class I{constructor(){this.a=new Map}add(R,m){S.ok(M.$Jf(R)),S.ok(M.$Lf(m)),S.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,m)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Kn=new I}),define(Ae[72],Me([1,0,5,30]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln={JSONContribution:"base.contributions.json"};function I(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class A{constructor(){this.b=new S.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,D){this.a[I(f)]=D,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;M.$Kn.add(e.$Ln.JSONContribution,R)}),define(Ae[55],Me([1,0,18,5,16,149,47,72,30]),function(fe,e,S,M,I,A,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ConfigurationScope=e.$Pn=e.EditPresentationTypes=void 0;var D;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(D||(e.EditPresentationTypes=D={})),e.$Pn={Configuration:"base.contributions.configuration"};var L;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn="vscode://schemas/settings/resourceLanguage",e.$Xn="vscode://schemas/settings/configurationDefaults";const k=f.$Kn.as(m.$Ln.JSONContribution);class l{constructor(){this.h=new Set,this.i=new M.$Wd,this.onDidSchemaChange=this.i.event,this.j=new M.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Wn,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const n=new Set;this.n(t,d,n),k.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const d=new Set;this.o(t,d),k.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const n=new Set;this.o(d,n),this.n(t,!1,n),k.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const n=[];for(const{overrides:b,source:E}of t)for(const h in b)if(d.add(h),e.$Zn.test(h)){const v=this.a.get(h),P=v?.valuesSources??new Map;if(E)for(const T of Object.keys(b[h]))P.set(T,E);const g={...v?.value||{},...b[h]};this.a.set(h,{source:E,value:g,valuesSources:P});const p=(0,R.$Li)(h),y={type:"object",default:g,description:A.localize(1,null,p),$ref:e.$Wn,defaultDefaultValue:g,source:I.$Jf(E)?void 0:E,defaultValueSource:E};n.push(...r(h)),this.d[h]=y,this.b.properties[h]=y}else{this.a.set(h,{value:b[h],source:E});const v=this.d[h];v&&(this.w(h,v),this.r(h,v))}this.m(n)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:n,source:b}of t)for(const E in n){const h=this.a.get(E),v=I.$Jf(b)?b:b?.id,P=I.$Jf(h?.source)?h?.source:h?.source?.id;if(v===P)if(d.add(E),this.a.delete(E),e.$Zn.test(E))delete this.d[E],delete this.b.properties[E];else{const g=this.d[E];g&&(this.w(E,g),this.r(E,g))}}this.u()}deltaConfiguration(t){let d=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,n){t.forEach(b=>{this.p(b,d,b.extensionInfo,b.restrictedProperties,void 0,n),this.c.push(b),this.q(b)})}o(t,d){const n=b=>{if(b.properties)for(const E in b.properties){d.add(E);const h=this.d[E];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[E],this.s(E,b.properties[E])}b.allOf?.forEach(E=>n(E))};for(const b of t){n(b);const E=this.c.indexOf(b);E!==-1&&this.c.splice(E,1)}}p(t,d=!0,n,b,E=3,h){E=I.$Sf(t.scope)?E:t.scope;const v=t.properties;if(v)for(const g in v){const p=v[g];if(d&&o(g,p)){delete v[g];continue}if(p.source=n,p.defaultDefaultValue=v[g].default,this.w(g,p),e.$Zn.test(g)?p.scope=void 0:(p.scope=I.$Sf(p.scope)?E:p.scope,p.restricted=I.$Sf(p.restricted)?!!b?.includes(g):p.restricted),v[g].hasOwnProperty("included")&&!v[g].included){this.f[g]=v[g],delete v[g];continue}else this.d[g]=v[g],v[g].policy?.name&&this.e.set(v[g].policy.name,g);!v[g].deprecationMessage&&v[g].markdownDeprecationMessage&&(v[g].deprecationMessage=v[g].markdownDeprecationMessage),h.add(g)}const P=t.allOf;if(P)for(const g of P)this.p(g,d,n,b,E,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=n=>{const b=n.properties;if(b)for(const h in b)this.r(h,b[h]);n.allOf?.forEach(d)};d(t)}r(t,d){switch(e.$Qn.properties[t]=d,d.scope){case 1:e.$Rn.properties[t]=d;break;case 2:e.$Sn.properties[t]=d;break;case 6:e.$Tn.properties[t]=d;break;case 3:e.$Un.properties[t]=d;break;case 4:e.$Vn.properties[t]=d;break;case 5:e.$Vn.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.$Qn.properties[t],d.scope){case 1:delete e.$Rn.properties[t];break;case 2:delete e.$Sn.properties[t];break;case 6:delete e.$Tn.properties[t];break;case 3:delete e.$Un.properties[t];break;case 4:case 5:delete e.$Vn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$Wn};this.w(d,n),e.$Qn.properties[d]=n,e.$Rn.properties[d]=n,e.$Sn.properties[d]=n,e.$Tn.properties[d]=n,e.$Un.properties[d]=n,e.$Vn.properties[d]=n}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$Wn};e.$Qn.patternProperties[e.$Yn]=t,e.$Rn.patternProperties[e.$Yn]=t,e.$Sn.patternProperties[e.$Yn]=t,e.$Tn.patternProperties[e.$Yn]=t,e.$Un.patternProperties[e.$Yn]=t,e.$Vn.patternProperties[e.$Yn]=t,this.i.fire()}w(t,d){const n=this.a.get(t);let b=n?.value,E=n?.source;I.$Qf(b)&&(b=d.defaultDefaultValue,E=void 0),I.$Qf(b)&&(b=s(d.type)),d.default=b,d.defaultValueSource=E}}const $="\\[([^\\]]+)\\]",w=new RegExp($,"g");e.$Yn=`^(${$})+$`,e.$Zn=new RegExp(e.$Yn);function r(u){const t=[];if(e.$Zn.test(u)){let d=w.exec(u);for(;d?.length;){const n=d[1].trim();n&&t.push(n),d=w.exec(u)}}return(0,S.$Mb)(t)}e.$1n=r;function c(u){return u.reduce((t,d)=>`${t}[${d}]`,"")}e.$2n=c;function s(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$3n=s;const i=new l;f.$Kn.add(e.$Pn.Configuration,i);function o(u,t){return u.trim()?e.$Zn.test(u)?A.localize(7,null,u):i.getConfigurationProperties()[u]!==void 0?A.localize(8,null,u):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,u,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$4n=o;function a(){const u=[],t=i.getConfigurationProperties();for(const d of Object.keys(t))u.push([d,t[d].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$5n=a}),define(Ae[191],Me([1,0,18,5,120,6,28,26,16,2,47,55,30]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0;function $(d){return Object.isFrozen(d)?d:m.$zn(d)}class w{constructor(n={},b=[],E=[],h){this.b=n,this.c=b,this.d=E,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(b=>{if(b instanceof w)return b;const E=new r("");return E.parseRaw(b),E.configurationModel});this.f=n.reduce((b,E)=>E===b?E:b.merge(E),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,L.$Ji)(this.contents,n):this.contents}inspect(n,b){const E=this;return{get value(){return $(E.rawConfiguration.getValue(n))},get override(){return b?$(E.rawConfiguration.getOverrideValue(n,b)):void 0},get merged(){return $(b?E.rawConfiguration.override(b).getValue(n):E.rawConfiguration.getValue(n))},get overrides(){const h=[];for(const{contents:v,identifiers:P,keys:g}of E.rawConfiguration.overrides){const p=new w(v,g).getValue(n);p!==void 0&&h.push({identifiers:P,value:p})}return h.length?$(h):void 0}}}getOverrideValue(n,b){const E=this.i(b);return E?n?(0,L.$Ji)(E,n):E:void 0}getKeysForOverrideIdentifier(n){const b=[];for(const E of this.overrides)E.identifiers.includes(n)&&b.push(...E.keys);return S.$Mb(b)}getAllOverrideIdentifiers(){const n=[];for(const b of this.overrides)n.push(...b.identifiers);return S.$Mb(n)}override(n){let b=this.a.get(n);return b||(b=this.g(n),this.a.set(n,b)),b}merge(...n){const b=m.$yn(this.contents),E=m.$yn(this.overrides),h=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const P of n)if(v.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(b,P.contents);for(const g of P.overrides){const[p]=E.filter(y=>S.$ub(y.identifiers,g.identifiers));p?(this.h(p.contents,g.contents),p.keys.push(...g.keys),p.keys=S.$Mb(p.keys)):E.push(m.$yn(g))}for(const g of P.keys)h.indexOf(g)===-1&&h.push(g)}return new w(b,h,E,v.every(P=>P instanceof w)?void 0:v)}g(n){const b=this.i(n);if(!b||typeof b!="object"||!Object.keys(b).length)return this;const E={};for(const h of S.$Mb([...Object.keys(this.contents),...Object.keys(b)])){let v=this.contents[h];const P=b[h];P&&(typeof v=="object"&&typeof P=="object"?(v=m.$yn(v),this.h(v,P)):v=P),E[h]=v}return new w(E,this.keys,this.overrides)}h(n,b){for(const E of Object.keys(b)){if(E in n&&f.$Lf(n[E])&&f.$Lf(b[E])){this.h(n[E],b[E]);continue}n[E]=m.$yn(b[E])}}i(n){let b=null,E=null;const h=v=>{v&&(E?this.h(E,v):E=m.$yn(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===n?b=v.contents:v.identifiers.includes(n)&&h(v.contents);return h(b),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,b){this.j(n,b,!0)}setValue(n,b){this.j(n,b,!1)}removeValue(n){const b=this.keys.indexOf(n);b!==-1&&(this.keys.splice(b,1),(0,L.$Ii)(this.contents,n),k.$Zn.test(n)&&this.overrides.splice(this.overrides.findIndex(E=>S.$ub(E.identifiers,(0,k.$1n)(n))),1))}j(n,b,E){(0,L.$Hi)(this.contents,n,b,h=>console.error(h)),E=E||this.keys.indexOf(n)===-1,E&&this.keys.push(n),k.$Zn.test(n)&&this.overrides.push({identifiers:(0,k.$1n)(n),keys:Object.keys(this.contents[n]),contents:(0,L.$Gi)(this.contents[n],h=>console.error(h))})}}e.$6n=w;class r{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,b){if(!f.$Sf(n)){const E=this.g(n);this.parseRaw(E,b)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,b){this.a=n;const{contents:E,keys:h,overrides:v,restricted:P,hasExcludedProperties:g}=this.h(n,b);this.b=new w(E,h,v,g?[n]:void 0),this.c=P||[]}g(n){let b={},E=null,h=[];const v=[],P=[];function g(y){Array.isArray(h)?h.push(y):E!==null&&(h[E]=y)}const p={onObjectBegin:()=>{const y={};g(y),v.push(h),h=y,E=null},onObjectProperty:y=>{E=y},onObjectEnd:()=>{h=v.pop()},onArrayBegin:()=>{const y=[];g(y),v.push(h),h=y,E=null},onArrayEnd:()=>{h=v.pop()},onLiteralValue:g,onError:(y,T,N)=>{P.push({error:y,offset:T,length:N})}};if(n)try{I.$mn(n,p),b=h[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return b}h(n,b){const E=l.$Kn.as(k.$Pn.Configuration).getConfigurationProperties(),h=this.i(n,E,!0,b);n=h.raw;const v=(0,L.$Gi)(n,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),P=Object.keys(n),g=this.j(n,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:v,keys:P,overrides:g,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(n,b,E,h){let v=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:v};const P={},g=[];for(const p in n)if(k.$Zn.test(p)&&E){const y=this.i(n[p],b,!1,h);P[p]=y.raw,v=v||y.hasExcludedProperties,g.push(...y.restricted)}else{const y=b[p],T=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&g.push(p),!h.exclude?.includes(p)&&(h.include?.includes(p)||(T===void 0||h.scopes===void 0||h.scopes.includes(T))&&!(h.skipRestricted&&y?.restricted))?P[p]=n[p]:v=!0}return{raw:P,restricted:g,hasExcludedProperties:v}}j(n,b){const E=[];for(const h of Object.keys(n))if(k.$Zn.test(h)){const v={};for(const P in n[h])v[P]=n[h][P];E.push({identifiers:(0,k.$1n)(h),keys:Object.keys(v),contents:(0,L.$Gi)(v,b)})}return E}}e.$7n=r;class c extends A.$Tc{constructor(n,b,E,h){super(),this.c=n,this.f=b,this.g=h,this.b=this.B(new M.$Wd),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&E.isEqual(v.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new w}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$8n=c;class s{constructor(n,b,E,h,v,P,g,p,y,T,N,J,q){this.a=n,this.b=b,this.c=E,this.overrideIdentifiers=h,this.d=v,this.f=P,this.g=g,this.h=p,this.i=y,this.j=T,this.k=N,this.l=J,this.m=q}get value(){return $(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(n,b,E,h,v=new w,P=new w,g=new R.$Ac,p=new w,y=new R.$Ac){this.c=n,this.d=b,this.f=E,this.g=h,this.h=v,this.i=P,this.j=g,this.l=p,this.m=y,this.a=null,this.b=new R.$Ac,this.n=null}getValue(n,b,E){return this.p(n,b,E).getValue(n)}updateValue(n,b,E={}){let h;E.resource?(h=this.m.get(E.resource),h||(h=new w,this.m.set(E.resource,h))):h=this.l,b===void 0?h.removeValue(n):h.setValue(n,b),E.resource||(this.a=null)}inspect(n,b,E){const h=this.p(n,b,E),v=this.t(b.resource,E),P=b.resource?this.m.get(b.resource)||this.l:this.l,g=new Set;for(const p of h.overrides)for(const y of p.identifiers)h.getOverrideValue(n,y)!==void 0&&g.add(y);return new s(n,b,h.getValue(n),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.i:void 0,v||void 0,P)}keys(n){const b=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:b?b.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,b){this.j.set(n,b),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,b){const E=[];if(!b){const{added:h,updated:v,removed:P}=u(this.c,n);b=[...h,...v,...P]}for(const h of b)for(const v of(0,k.$1n)(h)){const P=this.c.getKeysForOverrideIdentifier(v),g=n.getKeysForOverrideIdentifier(v),p=[...g.filter(y=>P.indexOf(y)===-1),...P.filter(y=>g.indexOf(y)===-1),...P.filter(y=>!m.$Cn(this.c.override(v).getValue(y),n.override(v).getValue(y)))];E.push([v,p])}return this.updateDefaultConfiguration(n),{keys:b,overrides:E}}compareAndUpdatePolicyConfiguration(n){const{added:b,updated:E,removed:h}=u(this.d,n),v=[...b,...E,...h];return v.length&&this.updatePolicyConfiguration(n),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:b,updated:E,removed:h,overrides:v}=u(this.applicationConfiguration,n),P=[...b,...E,...h];return P.length&&this.updateApplicationConfiguration(n),{keys:P,overrides:v}}compareAndUpdateLocalUserConfiguration(n){const{added:b,updated:E,removed:h,overrides:v}=u(this.localUserConfiguration,n),P=[...b,...E,...h];return P.length&&this.updateLocalUserConfiguration(n),{keys:P,overrides:v}}compareAndUpdateRemoteUserConfiguration(n){const{added:b,updated:E,removed:h,overrides:v}=u(this.remoteUserConfiguration,n),P=[...b,...E,...h];return P.length&&this.updateRemoteUserConfiguration(n),{keys:P,overrides:v}}compareAndUpdateWorkspaceConfiguration(n){const{added:b,updated:E,removed:h,overrides:v}=u(this.workspaceConfiguration,n),P=[...b,...E,...h];return P.length&&this.updateWorkspaceConfiguration(n),{keys:P,overrides:v}}compareAndUpdateFolderConfiguration(n,b){const E=this.folderConfigurations.get(n),{added:h,updated:v,removed:P,overrides:g}=u(E,b),p=[...h,...v,...P];return(p.length||!E)&&this.updateFolderConfiguration(n,b),{keys:p,overrides:g}}compareAndDeleteFolderConfiguration(n){const b=this.folderConfigurations.get(n);if(!b)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:E,updated:h,removed:v,overrides:P}=u(b,void 0);return{keys:[...E,...h,...v],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,b,E){let h=this.q(b,E);return b.overrideIdentifier&&(h=h.override(b.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(h=h.merge(this.d)),h}q({resource:n},b){let E=this.r();if(b&&n){const h=b.getFolder(n);h&&(E=this.s(h.uri)||E);const v=this.m.get(n);v&&(E=E.merge(v))}return E}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let b=this.b.get(n);if(!b){const E=this.r(),h=this.j.get(n);h?(b=E.merge(h),this.b.set(n,b)):b=E}return b}t(n,b){if(b&&n){const E=b.getFolder(n);if(E)return this.j.get(E.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,b)=>{const{contents:E,overrides:h,keys:v}=this.j.get(b);return n.push([b,{contents:E,overrides:h,keys:v}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(b=>n.add(b)),this.userConfiguration.keys.forEach(b=>n.add(b)),this.i.keys.forEach(b=>n.add(b)),this.j.forEach(b=>b.keys.forEach(E=>n.add(E))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(b=>n.add(b)),this.userConfiguration.getAllOverrideIdentifiers().forEach(b=>n.add(b)),this.i.getAllOverrideIdentifiers().forEach(b=>n.add(b)),this.j.forEach(b=>b.getAllOverrideIdentifiers().forEach(E=>n.add(E))),[...n.values()]}v(n){const b=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(E=>b.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(E=>b.add(E)),this.i.getKeysForOverrideIdentifier(n).forEach(E=>b.add(E)),this.j.forEach(E=>E.getKeysForOverrideIdentifier(n).forEach(h=>b.add(h))),[...b.values()]}static parse(n){const b=this.w(n.defaults),E=this.w(n.policy),h=this.w(n.application),v=this.w(n.user),P=this.w(n.workspace),g=n.folders.reduce((p,y)=>(p.set(D.URI.revive(y[0]),this.w(y[1])),p),new R.$Ac);return new i(b,E,h,v,new w,P,g,new w,new R.$Ac)}static w(n){return new w(n.contents,n.keys,n.overrides)}}e.$9n=i;function o(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const n=new Set,b=new Map;for(const h of d)h.keys.forEach(v=>n.add(v)),h.overrides.forEach(([v,P])=>{const g=(0,R.$xc)(b,v,new Set);P.forEach(p=>g.add(p))});const E=[];return b.forEach((h,v)=>E.push([v,[...h.values()]])),{keys:[...n.values()],overrides:E}}e.$0n=o;class a{constructor(n,b,E,h){this.change=n,this.f=b,this.g=E,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const v of n.keys)this.affectedKeys.add(v);for(const[,v]of n.overrides)for(const P of v)this.affectedKeys.add(P);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(n,b){const E=this.a+n,h=this.d.indexOf(E);if(h<0)return!1;const v=h+E.length;if(v>=this.d.length)return!1;const P=this.d.charCodeAt(v);if(P!==this.b&&P!==this.c)return!1;if(b){const g=this.previousConfiguration?this.previousConfiguration.getValue(n,b,this.f?.workspace):void 0,p=this.g.getValue(n,b,this.h);return!m.$Cn(g,p)}return!0}}e.$$n=a;function u(d,n){const{added:b,removed:E,updated:h}=t(n?.rawConfiguration,d?.rawConfiguration),v=[],P=d?.getAllOverrideIdentifiers()||[],g=n?.getAllOverrideIdentifiers()||[];if(n){const p=g.filter(y=>!P.includes(y));for(const y of p)v.push([y,n.getKeysForOverrideIdentifier(y)])}if(d){const p=P.filter(y=>!g.includes(y));for(const y of p)v.push([y,d.getKeysForOverrideIdentifier(y)])}if(n&&d){for(const p of P)if(g.includes(p)){const y=t({contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)},{contents:n.getOverrideValue(void 0,p)||{},keys:n.getKeysForOverrideIdentifier(p)});v.push([p,[...y.added,...y.removed,...y.updated]])}}return{added:b,removed:E,updated:h,overrides:v}}function t(d,n){const b=d?n?d.keys.filter(v=>n.keys.indexOf(v)===-1):[...d.keys]:[],E=n?d?n.keys.filter(v=>d.keys.indexOf(v)===-1):[...n.keys]:[],h=[];if(d&&n){for(const v of n.keys)if(d.keys.indexOf(v)!==-1){const P=(0,L.$Ji)(n.contents,v),g=(0,L.$Ji)(d.contents,v);m.$Cn(P,g)||h.push(v)}}return{added:b,removed:E,updated:h}}}),define(Ae[100],Me([1,0,15,4]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.RemoteAuthorityResolverErrorCode=e.$_k=e.$$k=e.RemoteConnectionType=e.$0k=void 0,e.$0k=(0,M.$8h)("remoteAuthorityResolverService");var I;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class A{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$$k=A;class R{constructor(k,l){this.host=k,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$_k=R;var m;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class f extends S.$bb{static isNotAvailable(k){return k instanceof f&&k._code===m.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof f&&k._code===m.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof f&&k._code===m.NoResolverFound}static isInvalidAuthority(k){return k instanceof f&&k._code===m.InvalidAuthority}static isHandled(k){return k instanceof f&&k.isHandled}constructor(k,l=m.Unknown,$){super(k),this._message=k,this._code=l,this._detail=$,this.isHandled=l===m.NotAvailable&&$===!0,Object.setPrototypeOf(this,f.prototype)}}e.$al=f;function D(L){const k=L.indexOf("+");return k===-1?L:L.substring(0,k)}e.$bl=D}),define(Ae[56],Me([1,0,12]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0;function M(D){return D.scheme===S.Schemas.vscodeRemote?D.authority:void 0}e.$cl=M;function I(D){if(!D)return;const L=D.indexOf("+");return L<0?D:D.substr(0,L)}e.$dl=I;function A(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.$el=A;function R(D){const{host:L,port:k}=f(D);if(typeof k>"u")throw new Error(`Invalid remote authority: ${D}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:L,port:k}}e.$fl=R;function m(D,L){let{host:k,port:l}=f(D);return typeof l>"u"&&(l=L),{host:k,port:l}}e.$gl=m;function f(D){const L=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const k=D.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const l=D.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:D,port:void 0}}}),define(Ae[22],Me([1,0,13,4,56]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function A(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$lm=A,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class f{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,s){if(typeof c>"u"||c===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof c=="string"||typeof s=="string"){const i=typeof c=="string"?c:c.value,o=typeof s=="string"?s:s.value;return S.$af(i,o)}return c._lower===s._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$nm=f;class D{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const s of c)this.add(s)}add(c){this.c.add(f.toKey(c))}delete(c){return this.c.delete(f.toKey(c))}has(c){return this.c.has(f.toKey(c))}}e.$om=D;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(f.toKey(c))}get(c){return this.c.get(f.toKey(c))}has(c){return this.c.has(f.toKey(c))}set(c,s){this.c.set(f.toKey(c),s)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=L;function k(r){return l(r)}e.$qm=k;function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.$rm=l;function $(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.$sm=$;function w(r,c){if(c){const s=`onResolveRemoteAuthority:${(0,I.$dl)(c)}`;return!!r.activationEvents?.includes(s)}return!1}e.$tm=w,e.$um=(0,M.$8h)("IBuiltinExtensionsScannerService")}),define(Ae[101],Me([1,0,15,22]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(R,m){this.a.set(R,m)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const f of R){const D=this.readActivationEvents(f);D.length>0&&(m[M.$nm.toKey(f.identifier)]=D)}return m}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let f=0;f<m.length;f++)m[f]==="onUri"&&(m[f]=`onUri:${M.$nm.toKey(R.identifier)}`);if(!R.contributes)return m;for(const f in R.contributes){const D=this.a.get(f);if(!D)continue;const L=R.contributes[f],k=Array.isArray(L)?L:[L];try{D(k,m)}catch(l){(0,S.$1)(l)}}return m}}e.$pF=I,e.$qF=new I}),define(Ae[192],Me([1,0,20,73,33]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function A(f){if(S.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function R(f,D,L,k,l,$,w,r,c){const s=Object.create(null);s["common.machineId"]=$,s["common.sqmId"]=w,s.sessionID=(0,I.$rg)()+Date.now(),s.commitHash=k,s.version=l,s["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,S.$h)(S.$u),s["common.nodePlatform"]=M.$dc,s["common.nodeArch"]=L,s["common.product"]=c||"desktop",r&&(s["common.msftInternal"]=r);let i=0;const o=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),S.$l&&(s["common.snap"]="true");const a=A(D);return a&&(s["common.platformDetail"]=a),s}e.$Lo=R;function m(f){const D=M.env.USERDNSDOMAIN;if(!D)return!1;const L=D.toLowerCase();return f.some(k=>L===k)}e.$Mo=m}),define(Ae[193],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0,e.$wl=(0,S.$8h)("telemetryService"),e.$xl=(0,S.$8h)("customEndpointTelemetryService"),e.$yl="telemetry.currentSessionDate",e.$zl="telemetry.firstSessionDate",e.$Al="telemetry.lastSessionDate",e.$Bl="telemetry.machineId",e.$Cl="telemetry.sqmId",e.$Dl="telemetry",e.$El="telemetry.telemetryLevel",e.$Fl="telemetry.enableCrashReporter",e.$Gl="telemetry.enableTelemetry";var M;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var I;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ae[57],Me([1,0,26,16,56,192,193]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class m{constructor(d){this.value=d,this.isTrustedTelemetryValue=!0}}e.$No=m;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=f,e.$Po=new f;class D{async publicLog(d,n,b){}async publicLogError(d,n,b){}}e.$Qo=D,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function L(t,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!t.enableTelemetry)}e.$Uo=L;function k(t,d){return d.extensionTestsLocationURI?!0:!(d.isBuilt||d.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Vo=k;function l(t){const d=t.getValue(R.$El),n=t.getValue(R.$Fl);if(t.getValue(R.$Gl)===!1||n===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=l;function $(t){const d={},n={},b={};c(t,b);for(let E in b){E=E.length>150?E.substr(E.length-149):E;const h=b[E];typeof h=="number"?n[E]=h:typeof h=="boolean"?n[E]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${h.length}`),d[E]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(d[E]=h)}return{properties:d,measurements:n}}e.$Xo=$;const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const d=(0,I.$dl)(t);return w.has(d)?d:"other"}e.$Yo=r;function c(t,d,n=0,b){if(t)for(const E of Object.getOwnPropertyNames(t)){const h=t[E],v=b?b+E:E;Array.isArray(h)?d[v]=(0,S.$Dn)(h):h instanceof Date?d[v]=h.toISOString():(0,M.$Lf)(h)?n<2?c(h,d,n+1,v+"."):d[v]=(0,S.$Dn)(h):d[v]=h}}function s(t,d){const n=t.msftInternalDomains||[],b=d.getValue("telemetry.internalTesting");return(0,A.$Mo)(n)||b}e.$Zo=s;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$1o=i;function o(t,d){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let n=t;const b=[];for(const P of d)for(;;){const g=P.exec(t);if(!g)break;b.push([g.index,P.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(n="";;){const P=h.exec(t);if(!P)break;const g=b.some(([p,y])=>P.index<y&&p<h.lastIndex);!E.test(P[0])&&!g&&(n+=t.substring(v,P.index)+"<REDACTED: user-file-path>",v=h.lastIndex)}return v<t.length&&(n+=t.substr(v)),n}function a(t){if(!t)return t;const d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of d)if(n.regex.test(t))return`<REDACTED: ${n.label}>`;return t}function u(t,d){return(0,S.$An)(t,n=>{if(n instanceof m||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let b=n.replaceAll("%20"," ");b=o(b,d);for(const E of d)b=b.replace(E,"");return b=a(b),b}})}e.$2o=u}),define(Ae[194],Me([1,0,13,96,22,20,2,15,73,57]),function(fe,e,S,M,I,A,R,m,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function L(n,b){return n.uuid&&b.uuid?n.uuid===b.uuid:n.id===b.id?!0:(0,S.$8e)(n.id,b.id)===0}e.$3o=L;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(b){const E=b.manifest?b.manifest.version:b.version,h=b.manifest?b.targetPlatform:b.properties.targetPlatform;return new l(b.identifier,E,h)}static parse(b){const E=k.exec(b);return E&&E[1]&&E[2]?new l({id:E[1]},E[2],E[4]||void 0):null}constructor(b,E,h="undefined"){this.version=E,this.targetPlatform=h,this.id=b.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(b){return b instanceof l?L(this,b)&&this.version===b.version&&this.targetPlatform===b.targetPlatform:!1}}e.$4o=l;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(n){const b=$.exec(n);return b&&b[1]?[c(b[1]),b[2]]:[c(n),void 0]}e.$5o=w;function r(n,b){return`${n}.${b}`}e.$6o=r;function c(n){return n.toLowerCase()}e.$7o=c;function s(n,b){return c(r(n??I.$jm,b))}e.$8o=s;function i(n,b){const E=[],h=v=>{for(const P of E)if(P.some(g=>L(b(g),b(v))))return P;return null};for(const v of n){const P=h(v);P?P.push(v):E.push([v])}return E}e.$9o=i;function o(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$0o=o;function a(n){return{id:new D.$No(n.identifier.id),name:new D.$No(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$$o=a,e.$_o=new I.$nm("pprice.better-merge");function u(n,b){const E=[],h=b.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const v=h.shift();if(v&&E.every(P=>!L(P.identifier,{id:v}))){const P=n.filter(g=>L(g.identifier,{id:v}));P.length===1&&(E.push(P[0]),h.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.$ap=u;async function t(n,b){if(!A.$k)return!1;let E;try{E=(await n.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{E=(await n.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){b.debug("Error while getting the os-release file.",(0,m.$0)(v))}}return!!E&&(E.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(n,b){const E=await t(n,b),h=(0,M.$xo)(E?"alpine":A.$u,f.$ec);return b.debug("ComputeTargetPlatform:",h),h}e.$bp=d}),define(Ae[195],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=void 0;function S(f){return[...f.entries()]}e.$Or=S;function M(f){return f?[...f.entries()]:[]}e.$Pr=M;function I(f){return new Map(f)}e.$Qr=I;function A(f){return new Map(f??[])}e.$Rr=A;function R(f){return Array.from(f.entries()).map(D=>[D[0],S(D[1].map),M(D[1].descriptionMap)])}e.$Sr=R;function m(f){return new Map(f.map(D=>[D[0],{map:I(D[1]),descriptionMap:A(D[2])}]))}e.$Tr=m}),define(Ae[196],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qsb=void 0;class S{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,A,R=5){const m=A(f=>{const D=typeof f=="string"?f:f.data;let L=this.a.get(I);if(L){L.data.push(D);return}const k=setTimeout(()=>this.flushBuffer(I),R);L={data:[D],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(I),m.dispose()}},this.a.set(I,L)});return m}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const A=this.a.get(I);A&&(this.a.delete(I),this.b(I,A.data.join("")))}}e.$Qsb=S}),define(Ae[197],Me([1,0,11,89,40,5,16,2,156,72,30]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.IconFontDefinition=e.IconContribution=e.$yw=void 0,e.$yw={IconContribution:"base.contributions.icons"};var k;(function(a){function u(t,d){let n=t.defaults;for(;I.ThemeIcon.isThemeIcon(n);){const b=w.getIcon(n.id);if(!b)return;n=b.defaults}return n}a.getDefinition=u})(k||(e.IconContribution=k={}));var l;(function(a){function u(d){return{weight:d.weight,style:d.style,src:d.src.map(n=>({format:n.format,location:n.location.toString()}))}}a.toJSONObject=u;function t(d){const n=b=>(0,R.$Jf)(b)?b:void 0;if(d&&Array.isArray(d.src)&&d.src.every(b=>(0,R.$Jf)(b.format)&&(0,R.$Jf)(b.location)))return{weight:n(d.weight),style:n(d.style),src:d.src.map(b=>({format:b.format,location:m.URI.parse(b.location)}))}}a.fromJSONObject=t})(l||(e.IconFontDefinition=l={}));class ${constructor(){this.a=new A.$Wd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(u,t,d,n){const b=this.b[u];if(b){if(d&&!b.description){b.description=d,this.d.properties[u].markdownDescription=`${d} $(${u})`;const v=this.e.enum.indexOf(u);v!==-1&&(this.e.enumDescriptions[v]=d),this.a.fire()}return b}const E={id:u,description:d,defaults:t,deprecationMessage:n};this.b[u]=E;const h={$ref:"#/definitions/icons"};return n&&(h.deprecationMessage=n),d&&(h.markdownDescription=`${d}: $(${u})`),this.d.properties[u]=h,this.e.enum.push(u),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:u}}deregisterIcon(u){delete this.b[u],delete this.d.properties[u];const t=this.e.enum.indexOf(u);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(u=>this.b[u])}getIcon(u){return this.b[u]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(u,t){const d=this.f[u];return d||(this.f[u]=t,this.a.fire(),t)}deregisterIconFont(u){delete this.f[u]}getIconFont(u){return this.f[u]}toString(){const u=(b,E)=>b.id.localeCompare(E.id),t=b=>{for(;I.ThemeIcon.isThemeIcon(b.defaults);)b=this.b[b.defaults.id];return`codicon codicon-${b?b.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(b=>this.b[b]);for(const b of n.filter(E=>!!E.description).sort(u))d.push(`|<i class="${t(b)}"></i>|${b.id}|${I.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const b of n.filter(E=>!I.ThemeIcon.isThemeIcon(E.defaults)).sort(u))d.push(`|<i class="${t(b)}"></i>|${b.id}|`);return d.join(`
`)}}const w=new $;L.$Kn.add(e.$yw.IconContribution,w);function r(a,u,t,d){return w.registerIcon(a,u,t,d)}e.$zw=r;function c(){return w}e.$Aw=c;function s(){const a=(0,M.$_j)();for(const u in a){const t="\\"+a[u].toString(16);w.registerIcon(u,{fontCharacter:t})}}s(),e.$Bw="vscode://schemas/icons";const i=L.$Kn.as(D.$Ln.JSONContribution);i.registerSchema(e.$Bw,w.getIconSchema());const o=new S.$hh(()=>i.notifySchemaChanged(e.$Bw),200);w.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$Cw=r("widget-close",M.$bk.close,(0,f.localize)(2,null)),e.$Dw=r("goto-previous-location",M.$bk.arrowUp,(0,f.localize)(3,null)),e.$Ew=r("goto-next-location",M.$bk.arrowDown,(0,f.localize)(4,null)),e.$Fw=I.ThemeIcon.modify(M.$bk.sync,"spin"),e.$Gw=I.ThemeIcon.modify(M.$bk.loading,"spin")}),define(Ae[198],Me([1,0,5,2,47,4,14]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.ProvidedOnAutoForward=e.$Ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dv=e.$Cv=void 0,e.$Cv=(0,A.$8h)("tunnelService"),e.$Dv=(0,A.$8h)("sharedTunnelsService");var m;(function(s){s.Http="http",s.Https="https"})(m||(e.TunnelProtocol=m={}));var f;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(f||(e.TunnelPrivacyId=f={}));function D(s){return!!s.forwardPort}e.$Ev=D;var L;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(L||(e.ProvidedOnAutoForward=L={}));function k(s,{checkQuery:i=!0}={}){if(s.scheme!=="http"&&s.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(o)return{address:o[1],port:+o[2]};if(!s.query||!i)return;const a=s.query.split("&");for(const u of a){const t=u.split("=")[1];if(/^https?:/.exec(t)){const d=k(M.URI.parse(t));if(d)return d}}}e.$Fv=k,e.$Gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function l(s){return e.$Gv.indexOf(s)>=0}e.$Hv=l,e.$Iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(s){return e.$Iv.indexOf(s)>=0}e.$Jv=$;function w(s,i,o,a){if(o===1)return!1;if(o===2&&$(i)){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(u?.length===4&&parseInt(u[1])>=18)return!1}return s<1024}e.$Kv=w;class r{constructor(i,o,a){this.remoteAddress=i,this.localAddress=o,this.b=a,this.a=new S.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lv=r;let c=class{constructor(i,o){this.k=i,this.l=o,this.a=new S.$Wd,this.onTunnelOpened=this.a.event,this.b=new S.$Wd,this.onTunnelClosed=this.b.event,this.c=new S.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],o=Array.from(this.e.values());for(const a of o){const u=Array.from(a.values());for(const t of u){const d=await t.value;d&&typeof d!="string"&&i.push(d)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:o}of i.values())await o.then(a=>typeof a!="string"?a?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,o,a,u,t){this.q(i,o,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:o,localAddress:a,privacy:u,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,o){($(i)||l(i))&&(i=e.$Gv[0]);const a=this.s(i,o);if(a)return++a.refcount,a.value}openTunnel(i,o,a,u,t,d=!1,n,b){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${a} on local port ${t}.`);const E=this.f??i;if(!E)return;if(o||(o="localhost"),u||(u=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const h=this.t(E,o,a,u,t,d,n,b);return h?h.then(v=>{if(v){if(typeof v=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(o,a),v}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(o,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const P=this.o(v);return(v.tunnelRemoteHost!==o||v.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&v.privacy!==n&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(P),P}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),h)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const o=this.e.get(i.tunnelRemoteHost);if(o){const a=o.get(i.tunnelRemotePort);a&&(a.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,a))}}}}async p(i,o,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${o}.`);const u=a.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(o),u}}async closeTunnel(i,o){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${o} `);const a=this.e.get(i);if(a&&a.has(o)){const u=a.get(o);u.refcount=0,await this.p(i,o,u)}}q(i,o,a){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(o,{refcount:1,value:a})}async r(i,o){const a=this.e.get(i);if(a){const u=a.get(o),t=u?await u.value:void 0;(!t||typeof t=="string")&&a.delete(o),a.size===0&&this.e.delete(i)}}s(i,o){const a=[i];l(i)?(a.push(...e.$Gv),a.push(...e.$Iv)):$(i)&&a.push(...e.$Iv);const u=a.map(t=>this.e.get(t));for(const t of u){const d=t?.get(o);if(d)return d}}canTunnel(i){return!!k(i)}u(i,o,a,u,t,d,n){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${a} on local port ${u}.`);const b=a;this.j.add(b);const E=u===void 0?a:u,h={elevationRequired:t?this.isPortPrivileged(E):!1},v={remoteAddress:{host:o,port:a},localAddressPort:u,privacy:d,public:d?d!==f.Private:void 0,protocol:n},P=i.forwardPort(v,h);return P?(this.q(o,a,P),P.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(b)})):this.j.delete(b),P}};e.$Mv=c,e.$Mv=c=Je([qe(0,R.$pj),qe(1,I.$Bi)],c)}),define(Ae[199],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nv=void 0,e.$Nv=(0,S.$8h)("editSessionIdentityService");var M;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Ae[200],Me([1,0,12]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=void 0;function M(f){return f.scheme!==S.Schemas.file&&f.scheme!==S.Schemas.vscodeRemote}e.$XK=M;function I(f){if(f.folders.length)return f.folders.every(D=>M(D.uri))?f.folders[0].uri:void 0;if(f.configuration&&M(f.configuration))return f.configuration}e.$YK=I;function A(f){return I(f)?.scheme}e.$ZK=A;function R(f){return I(f)?.authority}e.$1K=R;function m(f){return I(f)!==void 0}e.$2K=m}),define(Ae[48],Me([1,0,157,19,51,24,2,4,12]),function(fe,e,S,M,I,A,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.WorkbenchState=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0,e.$ei=(0,m.$8h)("contextService");function D(b){const E=b;return typeof E?.id=="string"&&R.URI.isUri(E.uri)}e.$fi=D;function L(b){return typeof b?.id=="string"&&!D(b)&&!l(b)}e.$gi=L,e.$hi={id:"ext-dev"},e.$ii={id:"empty-window"};function k(b,E){if(typeof b=="string"||typeof b>"u")return typeof b=="string"?{id:(0,M.$nc)(b)}:E?e.$hi:e.$ii;const h=b;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$ji=k;function l(b){const E=b;return typeof E?.id=="string"&&R.URI.isUri(E.configPath)}e.$ki=l;function $(b){const E=b;if(E?.uri)return{id:E.id,uri:R.URI.revive(E.uri)};const h=b;if(h?.configPath)return{id:h.id,configPath:R.URI.revive(h.configPath)};if(b?.id)return{id:b.id}}e.$li=$;var w;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function r(b){const E=b;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.$mi=r;function c(b){const E=b;return!!(E&&typeof E=="object"&&R.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.$ni=c;class s{constructor(E,h,v,P,g){this.h=E,this.j=v,this.k=P,this.l=g,this.c=I.$bi.forUris(this.l,()=>!0),this.folders=h}update(E){this.h=E.id,this.k=E.configuration,this.j=E.transient,this.l=E.l,this.folders=E.folders}get folders(){return this.g}set folders(E){this.g=E,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(E){this.k=E}getFolder(E){return E&&this.c.findSubstr(E)||null}n(){this.c=I.$bi.forUris(this.l,()=>!0);for(const E of this.folders)this.c.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$oi=s;class i{constructor(E,h){this.raw=h,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,A.$Ig)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$pi=i;function o(b){return new i({uri:b,index:0,name:(0,A.$Eg)(b)},{uri:b.toString()})}e.$qi=o,e.$ri="code-workspace",e.$si=`.${e.$ri}`,e.$ti=[{name:(0,S.localize)(0,null),extensions:[e.$ri]}],e.$ui="workspace.json";function a(b,E){return A.$zg.isEqualOrParent(b,E.untitledWorkspacesHome)}e.$vi=a;function u(b){let E;return R.URI.isUri(b)?E=b:E=b.configuration,E?.scheme===f.Schemas.tmp}e.$wi=u,e.$xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(b){return b.id===e.$xi}e.$yi=t;function d(b,E){return!a(b,E)&&!u(b)}e.$zi=d;function n(b){return(typeof b=="string"?(0,M.$oc)(b):(0,A.$Gg)(b))===e.$si}e.$Ai=n}),define(Ae[74],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class S{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const A=this.c++;return this.b.set(A,I),this.e(),A}get(I,A){return this.b.has(I)?this.b.get(I)[A]:void 0}delete(I){this.b.delete(I),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$sgc=S}),define(Ae[43],Me([1,0,12,24,4]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=e.$vgc=void 0;class A{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new M.$xg(m=>{const f=this.b.get(m.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(m,f){f===null?this.b.delete(m.scheme):this.b.set(m.scheme,f)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$vgc=A,e.$wgc=(0,I.$8h)("IExtHostFileSystemInfo")}),define(Ae[27],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=void 0,e.$QN=(0,S.$8h)("IExtHostInitDataService")}),define(Ae[201],Me([1,0,163,14,188,27]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;let R=class extends I.$XO{constructor(f,D,L){const k=L.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",l=L.remote.isRemote?(0,S.localize)(0,null):f?(0,S.localize)(1,null):(0,S.localize)(2,null);super(D.createLogger(k,{name:l}))}};e.$Cic=R,e.$Cic=R=Je([qe(1,M.$qj),qe(2,A.$QN)],R)}),define(Ae[202],Me([1,0,11]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0;class M{constructor(R,m,f){this.h=new Map,this.a=R,this.b=m,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(D=>(this.f=D,this)),this.g=this.c.onDidChangeStorage(D=>{D.shared===this.b&&D.key===this.a&&(this.f=D.value)}),this.i=new S.$hh(()=>{const D=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of D.values())L.complete()}catch(L){for(const k of D.values())k.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,m){let f=this.f[R];return typeof f>"u"&&(f=m),f}update(R,m){this.f[R]=m;const f=this.h.get(R);if(f!==void 0)return f.p;const D=new S.$sh;return this.h.set(R,D),this.i.isScheduled()||this.i.schedule(),D.p}dispose(){this.g.dispose()}}e.$ehc=M;class I extends M{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this.j=R}}e.$fhc=I}),define(Ae[203],Me([1,0,5,2]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;class I{constructor(R){this.c=R,this.a=new S.$Wd,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$Wd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,m,f,D){const k=this.c.getNotebookDocument(M.URI.revive(R)).acceptModelChanged(m.value,f,D);this.b.fire(k)}$acceptDirtyStateChanged(R,m){this.c.getNotebookDocument(M.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this.c.getNotebookDocument(M.URI.revive(R));this.a.fire(m.apiNotebook)}}e.$5hc=I}),define(Ae[17],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=e.$AN=void 0,e.$AN=(0,S.$8h)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$BN=M}),define(Ae[204],Me([1,0,22,5]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;class I{#e;constructor(R,m){this.b=new M.$Wd,this.onDidChange=this.b.event,this.a=S.$nm.toKey(R.identifier),this.#e=m,this.#e.onDidChangePassword(f=>{f.extensionId===this.a&&this.b.fire({key:f.key})})}get(R){return this.#e.get(this.a,R)}store(R,m){return this.#e.store(this.a,R,m)}delete(R){return this.#e.delete(this.a,R)}}e.$mhc=I}),define(Ae[58],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=void 0,e.$Ogc=(0,S.$8h)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Pgc=M}),define(Ae[205],Me([1,0,23]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylb=e.$Xlb=void 0;class M{constructor(){this.buffers=[]}add(f){let D=this.buffers.indexOf(f);return D<0&&(D=this.buffers.length,this.buffers.push(f)),D}}function I(m,f){if(f.serializeBuffersForPostMessage){const D=new M,k=JSON.stringify(m,($,w)=>{if(w instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:D.add(w)};if(ArrayBuffer.isView(w)){const r=A(w);if(r)return{$$vscode_array_buffer_reference$$:!0,index:D.add(w.buffer),view:{type:r,byteLength:w.byteLength,byteOffset:w.byteOffset}}}return w}),l=D.buffers.map($=>{const w=new Uint8Array($);return S.$ke.wrap(w)});return{message:k,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$Xlb=I;function A(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,f){const D=f.map(l=>{const $=new ArrayBuffer(l.byteLength);return new Uint8Array($).set(l.buffer),$}),L=f.length?(l,$)=>{if($&&typeof $=="object"&&$.$$vscode_array_buffer_reference$$){const w=$,{index:r}=w,c=D[r];if(w.view)switch(w.view.type){case 1:return new Int8Array(c,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return $}:void 0;return{message:JSON.parse(m,L),arrayBuffers:D}}e.$Ylb=R}),define(Ae[102],Me([1,0,172,16,2,6,4,30,42,12,41,135,32]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.$8E=e.$7E=e.EditorsOrder=e.$6E=e.CloseDirection=e.$5E=e.$4E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.EditorInputCapabilities=e.$UE=e.SaveReason=e.Verbosity=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=void 0,e.$HE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$IE={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$JE="workbench.editor.sidebysideEditor",e.$KE="workbench.editors.textDiffEditor",e.$LE="workbench.editors.binaryResourceDiffEditor";var $;(function(te){te[te.PROGRAMMATIC=1]="PROGRAMMATIC",te[te.USER=2]="USER",te[te.EDIT=3]="EDIT",te[te.NAVIGATION=4]="NAVIGATION",te[te.JUMP=5]="JUMP"})($||(e.EditorPaneSelectionChangeReason=$={}));var w;(function(te){te[te.IDENTICAL=1]="IDENTICAL",te[te.SIMILAR=2]="SIMILAR",te[te.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function r(te){const X=te;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.$ME=r;function c(te,X,V){for(const ie of V.visibleEditorPanes)if(ie.group.id===X&&te.matches(ie.input))return ie.getViewState()}e.$NE=c;function s(te){if(v(te))return!1;const X=te;return I.URI.isUri(X?.resource)}e.$OE=s;function i(te){if(v(te))return!1;const X=te;return X?.original!==void 0&&X.modified!==void 0}e.$PE=i;function o(te){if(v(te))return!1;const X=te;return!X||X.resources&&!Array.isArray(X.resources)?!1:!!X.resources||!!X.multiDiffSource}e.$QE=o;function a(te){if(v(te)||i(te))return!1;const X=te;return X?.primary!==void 0&&X.secondary!==void 0}e.$RE=a;function u(te){if(v(te))return!1;const X=te;return X?X.resource===void 0||X.resource.scheme===D.Schemas.untitled||X.forceUntitled===!0:!1}e.$SE=u;function t(te){if(v(te))return!1;const X=te;return I.URI.isUri(X?.base?.resource)&&I.URI.isUri(X?.input1?.resource)&&I.URI.isUri(X?.input2?.resource)&&I.URI.isUri(X?.result?.resource)}e.$TE=t;var d;(function(te){te[te.SHORT=0]="SHORT",te[te.MEDIUM=1]="MEDIUM",te[te.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var n;(function(te){te[te.EXPLICIT=1]="EXPLICIT",te[te.AUTO=2]="AUTO",te[te.FOCUS_CHANGE=3]="FOCUS_CHANGE",te[te.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class b{constructor(){this.a=new Map}registerSource(X,V){let ie=this.a.get(X);return ie||(ie={source:X,label:V},this.a.set(X,ie)),ie.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.$UE=new b;var E;(function(te){te[te.None=0]="None",te[te.Readonly=2]="Readonly",te[te.Untitled=4]="Untitled",te[te.Singleton=8]="Singleton",te[te.RequiresTrust=16]="RequiresTrust",te[te.CanSplitInGroup=32]="CanSplitInGroup",te[te.ForceDescription=64]="ForceDescription",te[te.CanDropIntoEditor=128]="CanDropIntoEditor",te[te.MultipleEditors=256]="MultipleEditors",te[te.Scratchpad=512]="Scratchpad",te[te.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(E||(e.EditorInputCapabilities=E={}));class h extends A.$Tc{}e.$VE=h;function v(te){return te instanceof h}e.$WE=v;function P(te){const X=te;return I.URI.isUri(X?.preferredResource)}function g(te){const X=te;return v(X?.primary)&&v(X?.secondary)}e.$XE=g;function p(te){const X=te;return v(X?.modified)&&v(X?.original)}e.$YE=p;function y(te,X,V,ie,Ce){return $e(ie,[(0,k.$Ri)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Te={...V,limits:{size:Number.MAX_VALUE}};te.openEditor(X,Te)}}),(0,k.$Ri)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>Ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$ZE=y;function T(te){return v(te?.editor)}e.$1E=T;function N(te){const X=te;return T(te)&&X?.group!==void 0}e.$2E=N;function J(te){const X=te;return typeof X?.groupId=="number"&&v(X.editor)}e.$3E=J;var q;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.REPLACE=1]="REPLACE",te[te.MOVE=2]="MOVE",te[te.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var U;(function(te){te[te.GROUP_ACTIVE=0]="GROUP_ACTIVE",te[te.GROUP_INDEX=1]="GROUP_INDEX",te[te.GROUP_LABEL=2]="GROUP_LABEL",te[te.GROUP_LOCKED=3]="GROUP_LOCKED",te[te.EDITOR_OPEN=4]="EDITOR_OPEN",te[te.EDITOR_CLOSE=5]="EDITOR_CLOSE",te[te.EDITOR_MOVE=6]="EDITOR_MOVE",te[te.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",te[te.EDITOR_LABEL=8]="EDITOR_LABEL",te[te.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",te[te.EDITOR_PIN=10]="EDITOR_PIN",te[te.EDITOR_STICKY=11]="EDITOR_STICKY",te[te.EDITOR_DIRTY=12]="EDITOR_DIRTY",te[te.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var C;(function(te){te[te.PRIMARY=1]="PRIMARY",te[te.SECONDARY=2]="SECONDARY",te[te.BOTH=3]="BOTH",te[te.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class F{getOriginalUri(X,V){if(!X)return;if(t(X))return e.$5E.getOriginalUri(X.result,V);if(V?.supportSideBySide){const{primary:Ce,secondary:Te}=this.a(X);if(Ce&&Te){if(V?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Ce,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Te,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getOriginalUri(Ce,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Te,{filterByScheme:V.filterByScheme});X=V.supportSideBySide===C.PRIMARY?Ce:Te}}if(i(X)||o(X)||a(X)||t(X))return;const ie=P(X)?X.preferredResource:X.resource;return!ie||!V||!V.filterByScheme?ie:this.b(ie,V.filterByScheme)}a(X){return g(X)||a(X)?{primary:X.primary,secondary:X.secondary}:p(X)||i(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,V){if(!X)return;if(t(X))return e.$5E.getCanonicalUri(X.result,V);if(V?.supportSideBySide){const{primary:Ce,secondary:Te}=this.a(X);if(Ce&&Te){if(V?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Ce,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Te,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getCanonicalUri(Ce,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Te,{filterByScheme:V.filterByScheme});X=V.supportSideBySide===C.PRIMARY?Ce:Te}}if(i(X)||o(X)||a(X)||t(X))return;const ie=X.resource;return!ie||!V||!V.filterByScheme?ie:this.b(ie,V.filterByScheme)}b(X,V){if(Array.isArray(V)){if(V.some(ie=>X.scheme===ie))return X}else if(V===X.scheme)return X}}var W;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.KEYBOARD=1]="KEYBOARD",te[te.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function re(te,X,V,ie){if(!te.isSticky(X))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return V===W.MOUSE||V===W.KEYBOARD;case"mouse":return V===W.MOUSE;case"keyboard":return V===W.KEYBOARD}return!1}e.$4E=re,e.$5E=new F;var ce;(function(te){te[te.LEFT=0]="LEFT",te[te.RIGHT=1]="RIGHT"})(ce||(e.CloseDirection=ce={}));class we{constructor(){this.c=new Map,this.d=new Map}start(X){const V=this.a=X.get(R.$7h);for(const[ie,Ce]of this.c)this.e(ie,Ce,V);this.c.clear()}e(X,V,ie){const Ce=ie.createInstance(V);this.d.set(X,Ce)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,M.$Uf)(this.b)}registerEditorSerializer(X,V){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,V,this.a):this.c.set(X,V),(0,A.$Rc)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}m.$Kn.add(e.$HE.EditorFactory,new we);async function De(te,X,V){return!te||!te.length?[]:await Promise.all(te.map(async ie=>{const Ce=I.URI.revive(ie.fileUri);if(!Ce){V.info("Cannot resolve the path because it is not valid.",ie);return}if(!await X.canHandleResource(Ce)){V.info("Cannot resolve the path because it cannot be handled",ie);return}let Pe=ie.exists,be=ie.type;if(typeof Pe!="boolean"||typeof be!="number")try{be=(await X.stat(Ce)).isDirectory?f.FileType.Directory:f.FileType.Unknown,Pe=!0}catch(G){V.error(G),Pe=!1}if(!Pe&&ie.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ie);return}if(be===f.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ie);return}const me={...ie.options,pinned:!0};return Pe?{resource:Ce,options:me}:{resource:Ce,options:me,forceUntitled:!0}}))}e.$6E=De;var he;(function(te){te[te.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",te[te.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function ve(te){const X=te;if(!X)return!1;const V=X;if(V.modified)return ve(V.modified);const ie=X;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$7E=ve;function se(te){return(0,L.$Ti)(te)}e.$8E=se;function $e(te,X,V){const ie=(0,L.$Ui)(te,X);return ie.forceMessage=V?.forceMessage,ie.forceSeverity=V?.forceSeverity,ie.allowDialog=V?.allowDialog,ie}e.$9E=$e}),define(Ae[206],Me([1,0,5,173,4,6,28,30,18,26,89,197]),function(fe,e,S,M,I,A,R,m,f,D,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$cF=e.ViewContentGroups=e.$bF=e.$aF=e.ViewContainerLocation=e.Extensions=e.$_E=e.$$E=e.$0E=void 0,e.$0E="views",e.$$E=(0,M.localize)(0,null),e.$_E=(0,k.$zw)("default-view-icon",L.$bk.window,(0,M.localize)(1,null));var l;(function(d){d.ViewContainersRegistry="workbench.registry.view.containers",d.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var $;(function(d){d[d.Sidebar=0]="Sidebar",d[d.Panel=1]="Panel",d[d.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$aF=[0,1,2];function w(d){switch(d){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$bF=w;class r extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$Wd),this.onDidRegister=this.c.event,this.f=this.B(new S.$Wd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(n,b,E){const h=this.get(n.id);if(h)return h;const v=n;return v.openCommandActionDescriptor=E?.doNotRegisterOpenCommand?void 0:v.openCommandActionDescriptor??{id:v.id},(0,R.$xc)(this.g,b,[]).push(v),E?.isDefault&&this.h.push(v),this.c.fire({viewContainer:v,viewContainerLocation:b}),v}deregisterViewContainer(n){for(const b of this.g.keys()){const E=this.g.get(b),h=E?.indexOf(n);if(h!==-1){E?.splice(h,1),E.length===0&&this.g.delete(b),this.f.fire({viewContainer:n,viewContainerLocation:b});return}}}get(n){return this.all.filter(b=>b.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(b=>this.getViewContainers(b).filter(E=>E?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(b=>this.getViewContainerLocation(b)===n)}}m.$Kn.add(l.ViewContainersRegistry,new r);var c;(function(d){d.Open="2_open",d.Debug="4_debug",d.SCM="5_scm",d.More="9_more"})(c||(e.ViewContentGroups=c={}));function s(d,n){const b=d.group??c.More,E=n.group??c.More;return b!==E?b.localeCompare(E):(d.order??5)-(n.order??5)}class i extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$Wd),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$Wd),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$Wd),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$Wd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(n,b){this.registerViews2([{views:n,viewContainer:b}])}registerViews2(n){n.forEach(({views:b,viewContainer:E})=>this.r(b,E)),this.c.fire(n)}deregisterViews(n,b){const E=this.s(n,b);E.length&&this.f.fire({views:E,viewContainer:b})}moveViews(n,b){for(const E of this.m.keys())if(E!==b){const h=this.s(n,E);h.length&&(this.r(h,b),this.g.fire({views:h,from:E,to:b}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const b of this.j){const E=(this.m.get(b)||[]).filter(h=>h.id===n)[0];if(E)return E}return null}getViewContainer(n){for(const b of this.j)if((this.m.get(b)||[]).filter(h=>h.id===n)[0])return b;return null}registerViewWelcomeContent(n,b){return this.n.add(n,b),this.h.fire(n),(0,A.$Rc)(()=>{this.n.delete(n,b),this.h.fire(n)})}registerViewWelcomeContent2(n,b){const E=new Map;for(const[h,v]of b)this.n.add(n,v),E.set(h,(0,A.$Rc)(()=>{this.n.delete(n,v),this.h.fire(n)}));return this.h.fire(n),E}getViewWelcomeContent(n){const b=[];return this.n.forEach(n,E=>b.push(E)),b.sort(s)}r(n,b){let E=this.m.get(b);E||(E=[],this.m.set(b,E),this.j.push(b));for(const h of n){if(this.getView(h.id)!==null)throw new Error((0,M.localize)(2,null,h.id));E.push(h)}}s(n,b){const E=this.m.get(b);if(!E)return[];const h=[],v=[];for(const P of E)n.includes(P)?h.push(P):v.push(P);return h.length&&(v.length?this.m.set(b,v):(this.m.delete(b),this.j.splice(this.j.indexOf(b),1))),h}}m.$Kn.add(l.ViewsRegistry,new i),e.$cF=(0,I.$8h)("viewDescriptorService");var o;(function(d){d[d.Default=0]="Default",d[d.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var a;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class u{constructor(n,b){this.c=!1,this.d=!1,(0,D.$Bn)(this,n),this.d=!!b,this.resolve=async E=>{if(b&&!this.c){const h=await b(E);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}E.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$dF=u;class t extends Error{constructor(n){super((0,M.localize)(3,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$eF=t}),define(Ae[207],Me([1,0,2,29,4]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oF=e.$nF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$mF=e.$lF=void 0;function A(D){return!!D&&typeof D=="object"&&"uri"in D&&D.uri instanceof S.URI&&"version"in D&&typeof D.version=="number"&&"ranges"in D&&Array.isArray(D.ranges)&&D.ranges.every(M.$Ws.isIRange)}e.$lF=A;function R(D){return!!D&&typeof D=="object"&&"documents"in D&&Array.isArray(D.documents)&&D.documents.every(A)}e.$mF=R;var m;(function(D){D[D.Down=0]="Down",D[D.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var f;(function(D){D[D.Action=1]="Action",D[D.Toolbar=2]="Toolbar"})(f||(e.ChatAgentCopyKind=f={})),e.$nF=(0,I.$8h)("IChatService"),e.$oF="accessibility.voice.keywordActivation"}),define(Ae[208],Me([1,0,5,11,174]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rmb=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new S.$Wd,this.n=new S.$Wd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,f,D,L){const k={command:m};if(f&&Object.keys(f).length>0&&(k.arguments=f),this.s("request",k),typeof L=="number"){const l=setTimeout(()=>{clearTimeout(l);const $=this.f.get(k.seq);if($){this.f.delete(k.seq);const w={type:"response",seq:0,request_seq:k.seq,success:!1,command:m,message:(0,I.localize)(0,null,L,m)};$(w)}},L)}return D&&this.f.set(k.seq,D),k.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,f){return m.type!=="event"||f.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,M.$9g)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const f=m,D=this.f.get(f.request_seq);D&&(this.f.delete(f.request_seq),D(f));break}}}}s(m,f){f.type=m,f.seq=this.d++,this.sendMessage(f)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((f,D)=>m.set(D,f)),await(0,M.$9g)(500),m.forEach((f,D)=>{f({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.f.delete(D)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$rmb=A}),define(Ae[209],Me([1,0,2,175,35,4]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$YH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$XH=e.MemoryRangeType=e.$WH=e.State=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=void 0,e.$OG="workbench.view.debug",e.$PG="workbench.debug.variablesView",e.$QG="workbench.debug.watchExpressionsView",e.$RG="workbench.debug.callStackView",e.$SG="workbench.debug.loadedScriptsView",e.$TG="workbench.debug.breakPointsView",e.$UG="workbench.debug.disassemblyView",e.$VG="workbench.panel.repl",e.$WG="workbench.panel.repl.view",e.$XG=new I.$mj("debugType",void 0,{type:"string",description:M.localize(0,null)}),e.$YG=new I.$mj("debugConfigurationType",void 0,{type:"string",description:M.localize(1,null)}),e.$ZG=new I.$mj("debugState","inactive",{type:"string",description:M.localize(2,null)}),e.$1G="debugUx",e.$2G=new I.$mj(e.$1G,"default",{type:"string",description:M.localize(3,null)}),e.$3G=new I.$mj("hasDebugged",!1,{type:"boolean",description:M.localize(4,null)}),e.$4G=new I.$mj("inDebugMode",!1,{type:"boolean",description:M.localize(5,null)}),e.$5G=new I.$mj("inDebugRepl",!1,{type:"boolean",description:M.localize(6,null)}),e.$6G=new I.$mj("breakpointWidgetVisible",!1,{type:"boolean",description:M.localize(7,null)}),e.$7G=new I.$mj("inBreakpointWidget",!1,{type:"boolean",description:M.localize(8,null)}),e.$8G=new I.$mj("breakpointsFocused",!0,{type:"boolean",description:M.localize(9,null)}),e.$9G=new I.$mj("watchExpressionsFocused",!0,{type:"boolean",description:M.localize(10,null)}),e.$0G=new I.$mj("watchExpressionsExist",!1,{type:"boolean",description:M.localize(11,null)}),e.$$G=new I.$mj("variablesFocused",!0,{type:"boolean",description:M.localize(12,null)}),e.$_G=new I.$mj("expressionSelected",!1,{type:"boolean",description:M.localize(13,null)}),e.$aH=new I.$mj("breakpointInputFocused",!1,{type:"boolean",description:M.localize(14,null)}),e.$bH=new I.$mj("callStackItemType",void 0,{type:"string",description:M.localize(15,null)}),e.$cH=new I.$mj("callStackSessionIsAttach",!1,{type:"boolean",description:M.localize(16,null)}),e.$dH=new I.$mj("callStackItemStopped",!1,{type:"boolean",description:M.localize(17,null)}),e.$eH=new I.$mj("callStackSessionHasOneThread",!1,{type:"boolean",description:M.localize(18,null)}),e.$fH=new I.$mj("watchItemType",void 0,{type:"string",description:M.localize(19,null)}),e.$gH=new I.$mj("canViewMemory",void 0,{type:"boolean",description:M.localize(20,null)}),e.$hH=new I.$mj("breakpointItemType",void 0,{type:"string",description:M.localize(21,null)}),e.$iH=new I.$mj("breakpointSupportsCondition",!1,{type:"boolean",description:M.localize(22,null)}),e.$jH=new I.$mj("loadedScriptsSupported",!1,{type:"boolean",description:M.localize(23,null)}),e.$kH=new I.$mj("loadedScriptsItemType",void 0,{type:"string",description:M.localize(24,null)}),e.$lH=new I.$mj("focusedSessionIsAttach",!1,{type:"boolean",description:M.localize(25,null)}),e.$mH=new I.$mj("focusedSessionIsNoDebug",!1,{type:"boolean",description:M.localize(26,null)}),e.$nH=new I.$mj("stepBackSupported",!1,{type:"boolean",description:M.localize(27,null)}),e.$oH=new I.$mj("restartFrameSupported",!1,{type:"boolean",description:M.localize(28,null)}),e.$pH=new I.$mj("stackFrameSupportsRestart",!1,{type:"boolean",description:M.localize(29,null)}),e.$qH=new I.$mj("jumpToCursorSupported",!1,{type:"boolean",description:M.localize(30,null)}),e.$rH=new I.$mj("stepIntoTargetsSupported",!1,{type:"boolean",description:M.localize(31,null)}),e.$sH=new I.$mj("breakpointsExist",!1,{type:"boolean",description:M.localize(32,null)}),e.$tH=new I.$mj("debuggersAvailable",!1,{type:"boolean",description:M.localize(33,null)}),e.$uH=new I.$mj("debugExtensionAvailable",!0,{type:"boolean",description:M.localize(34,null)}),e.$vH=new I.$mj("debugProtocolVariableMenuContext",void 0,{type:"string",description:M.localize(35,null)}),e.$wH=new I.$mj("debugSetVariableSupported",!1,{type:"boolean",description:M.localize(36,null)}),e.$xH=new I.$mj("debugSetExpressionSupported",!1,{type:"boolean",description:M.localize(37,null)}),e.$yH=new I.$mj("breakWhenValueChangesSupported",!1,{type:"boolean",description:M.localize(38,null)}),e.$zH=new I.$mj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:M.localize(39,null)}),e.$AH=new I.$mj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:M.localize(40,null)}),e.$BH=new I.$mj("terminateDebuggeeSupported",!1,{type:"boolean",description:M.localize(41,null)}),e.$CH=new I.$mj("suspendDebuggeeSupported",!1,{type:"boolean",description:M.localize(42,null)}),e.$DH=new I.$mj("variableEvaluateNamePresent",!1,{type:"boolean",description:M.localize(43,null)}),e.$EH=new I.$mj("variableIsReadonly",!1,{type:"boolean",description:M.localize(44,null)}),e.$FH=new I.$mj("variableValue",!1,{type:"string",description:M.localize(45,null)}),e.$GH=new I.$mj("variableType",!1,{type:"string",description:M.localize(46,null)}),e.$HH=new I.$mj("variableName",!1,{type:"string",description:M.localize(47,null)}),e.$IH=new I.$mj("variableLanguage",!1,{type:"string",description:M.localize(48,null)}),e.$JH=new I.$mj("variableExtensionId",!1,{type:"string",description:M.localize(49,null)}),e.$KH=new I.$mj("exceptionWidgetVisible",!1,{type:"boolean",description:M.localize(50,null)}),e.$LH=new I.$mj("multiSessionRepl",!1,{type:"boolean",description:M.localize(51,null)}),e.$MH=new I.$mj("multiSessionDebug",!1,{type:"boolean",description:M.localize(52,null)}),e.$NH=new I.$mj("disassembleRequestSupported",!1,{type:"boolean",description:M.localize(53,null)}),e.$OH=new I.$mj("disassemblyViewFocus",!1,{type:"boolean",description:M.localize(54,null)}),e.$PH=new I.$mj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:M.localize(55,null)}),e.$QH=new I.$mj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:M.localize(56,null)});const R=r=>M.localize(57,null,r);e.$RH=R,e.$SH="editor.contrib.debug",e.$TH="editor.contrib.breakpoint",e.$UH="debug",e.$VH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:M.localize(58,null)};var m;(function(r){r[r.Inactive=0]="Inactive",r[r.Initializing=1]="Initializing",r[r.Stopped=2]="Stopped",r[r.Running=3]="Running"})(m||(e.State=m={}));function f(r){switch(r){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$WH=f;var D;(function(r){r[r.Valid=0]="Valid",r[r.Unreadable=1]="Unreadable",r[r.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$XH="vscode-debug-memory";var L;(function(r){r[r.Initial=1]="Initial",r[r.Dynamic=2]="Dynamic"})(L||(e.DebugConfigurationProviderTriggerKind=L={}));var k;(function(r){r.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$YH=(0,A.$8h)("debugService");var l;(function(r){r[r.CONDITION=0]="CONDITION",r[r.HIT_COUNT=1]="HIT_COUNT",r[r.LOG_MESSAGE=2]="LOG_MESSAGE",r[r.TRIGGER_POINT=3]="TRIGGER_POINT"})(l||(e.BreakpointWidgetContext=l={}));var $;(function(r){r[r.Command=0]="Command",r[r.Tree=1]="Tree"})($||(e.DebugVisualizationType=$={}));var w;(function(r){r.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:S.URI.revive(c.iconPath.light),dark:S.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),r.serialize=c=>c})(w||(e.IDebugVisualization=w={}))}),define(Ae[210],Me([1,0,13,2,19,26,12,29,21,18]),function(fe,e,S,M,I,A,R,m,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=void 0;const L=/{([^}]+)}/g;function k(P,g,p){return P.replace(L,function(y,T){return g&&T.length>0&&T[0]!=="_"?y:p&&p.hasOwnProperty(T)?p[T]:y})}e.$dG=k;function l(P){const g={};for(const p of Object.keys(P))p.startsWith("!")||(g[p]=P[p]);return g}e.$eG=l;function $(P){return P.configuration.request==="attach"&&!w(P)&&(!P.parentSession||$(P.parentSession))}e.$fG=$;function w(P){let g=P.configuration.type;if(g)return g==="vslsShare"&&(g=P.configuration.adapterProxy.configuration.type),(0,S.$af)(g,"extensionhost")||(0,S.$af)(g,"pwa-extensionhost")?P:P.parentSession?w(P.parentSession):void 0}e.$gG=w;function r(P){return P.type&&(P.label||P.program||P.runtime)}e.$hG=r;function c(P,g,p){let y,T=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let J=null;for(;J=N.exec(P);){const q=J.index+1,U=q+J[0].length;if(q<=g&&U>=p){y=J[0],T=q;break}}if(y){const q=/\w+/g;let U=null;for(;(U=q.exec(y))&&!(U.index+1+T+U[0].length>=p););U&&(y=y.substring(0,q.lastIndex))}return y?{start:T,end:T+y.length-1}:{start:0,end:0}}e.$iG=c;async function s(P,g,p,y){if(P.evaluatableExpressionProvider.has(g)){const T=P.evaluatableExpressionProvider.ordered(g),N=(0,D.$Hb)(await Promise.all(T.map(async J=>{try{return await J.provideEvaluatableExpression(g,p,y??f.CancellationToken.None)}catch{return}})));if(N.length>0){let J=N[0].expression;const q=N[0].range;return J||(J=g.getLineContent(p.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:J}}}else{const T=g.getLineContent(p.lineNumber),{start:N,end:J}=c(T,p.column,p.column),q=T.substring(N-1,J);return{matchingExpression:q,range:new m.$Ws(p.lineNumber,N,p.lineNumber,N+q.length)}}return null}e.$jG=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(P){return!!(P&&P.match(i))}e.$kG=o;function a(P){if(typeof P.path=="string"&&!(typeof P.sourceReference=="number"&&P.sourceReference>0)){if(o(P.path))return M.URI.parse(P.path);if((0,I.$ic)(P.path))return M.URI.file(P.path)}return P.path}function u(P){if(typeof P.path=="object"){const g=M.URI.revive(P.path);if(g)return g.scheme===R.Schemas.file?g.fsPath:g.toString()}return P.path}function t(P,g){const p=g?a:u,y=(0,A.$yn)(P);return n(y,(T,N)=>{T&&N&&(N.path=p(N))}),y}e.$lG=t;function d(P,g){const p=g?a:u,y=(0,A.$yn)(P);return n(y,(T,N)=>{!T&&N&&(N.path=p(N))}),y}e.$mG=d;function n(P,g){switch(P.type){case"event":{const p=P;switch(p.event){case"output":g(!1,p.body.source);break;case"loadedSource":g(!1,p.body.source);break;case"breakpoint":g(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=P;switch(p.command){case"setBreakpoints":g(!0,p.arguments.source);break;case"breakpointLocations":g(!0,p.arguments.source);break;case"source":g(!0,p.arguments.source);break;case"gotoTargets":g(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(y=>g(!1,y));break;default:break}break}case"response":{const p=P;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(y=>g(!1,y.source));break;case"loadedSources":p.body.sources.forEach(y=>g(!1,y));break;case"scopes":p.body.scopes.forEach(y=>g(!1,y.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(y=>g(!1,y.source));break;case"setBreakpoints":p.body.breakpoints.forEach(y=>g(!1,y.source));break;case"disassemble":p.body?.instructions.forEach(T=>g(!1,T.location));break;default:break}break}}}function b(P){return P.filter(g=>!g.presentation?.hidden).sort((g,p)=>g.presentation?p.presentation?g.presentation.group?p.presentation.group?g.presentation.group!==p.presentation.group?g.presentation.group.localeCompare(p.presentation.group):E(g.presentation.order,p.presentation.order):-1:p.presentation.group?1:E(g.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.$nG=b;function E(P,g){return typeof P!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:P-g}async function h(P,g){const p=P.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(p!=="none"&&(await g.saveAll(),p==="allEditorsInActiveGroup")){const y=g.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await g.save({editor:y.input,groupId:y.group.id})}await P.reloadConfiguration()}e.$oG=h;const v=(P,g)=>!P||!g?P===g:P.name===g.name&&P.path===g.path&&P.sourceReference===g.sourceReference;e.$pG=v}),define(Ae[211],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uJ=e.CellExecutionUpdateType=void 0;var M;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$uJ=(0,S.$8h)("INotebookExecutionService")}),define(Ae[212],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfb=e.$Sfb=e.ProxyKernelState=e.$Rfb=void 0,e.$Rfb=100;var M;(function(I){I[I.Disconnected=1]="Disconnected",I[I.Connected=2]="Connected",I[I.Initializing=3]="Initializing"})(M||(e.ProxyKernelState=M={})),e.$Sfb=(0,S.$8h)("INotebookKernelService"),e.$Tfb=(0,S.$8h)("INotebookKernelHistoryService")}),define(Ae[213],Me([1,0,6,29,145,93]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Rb=void 0;class R extends S.$Tc{constructor(f,D,L){super(),this._source=f,this.b=D,this.c=L,this.a=void 0}f(f){const D=f.getLineCount();return new M.$Ws(1,1,D,this.g(f,D))}g(f,D){if(D<1||D>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(D)+1}get inputTextBuffer(){if(!this.b){const f=new I.$eC;f.acceptChunk(this._source);const D=f.finish(!0),{textBuffer:L,disposable:k}=D.create(1);this.b=L,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const D=new I.$eC;D.acceptChunk(f);const L=D.finish(!0),{textBuffer:k,disposable:l}=L.create(1);return this.B(l),k})),this.a}findInInputs(f){const L=new A.$5B(f,!1,!1,null).parseSearchRequest();if(!L)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,L,!0,5e3)}findInOutputs(f){const L=new A.$5B(f,!1,!1,null).parseSearchRequest();return L?this.outputTextBuffers.map(k=>{const l=k.findMatchesLineByLine(this.f(k),L,!0,5e3);if(l.length!==0)return{textBuffer:k,matches:l}}).filter(k=>!!k):[]}}e.$3Rb=R}),define(Ae[49],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fK=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(A){A.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class I{static fromExtHostTestItem(R,m,f=R.parent){if(R._isRoot)return new I([m]);const D=[R.id];for(let L=f;L&&L.id!==m;L=L.parent)D.push(L.id);return D.push(m),new I(D.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new I(R.split("\0"))}static join(R,m){return new I([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:I.isChild(R,m)?2:I.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.d=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new I(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let m=0;m<R.d&&m<this.d;m++)if(R.path[m]!==this.path[m])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$fK=I}),define(Ae[59],Me([1,0,2,91,29,49]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$mK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$lK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$kK=e.$jK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$iK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$hK=e.$gK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var m;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var f;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$gK=[2,4,8,16,32,64];const D=C=>"runId"in C;e.$hK=D;var L;(function(C){C.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),C.deserialize=(F,W)=>({range:I.$Ws.lift(W.range),uri:F.asCanonicalUri(S.URI.revive(W.uri))})})(L||(e.IRichLocation=L={}));var k;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(k||(e.TestMessageType=k={}));var l;(function(C){C.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&L.serialize(F.location)}),C.deserialize=(F,W)=>({message:W.message,type:0,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&L.deserialize(F,W.location)})})(l||(e.ITestErrorMessage=l={}));const $=(C,F)=>`${F?"s":"e"}${C}`;e.$iK=$;var w;(function(C){C.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&L.serialize(F.location)}),C.deserialize=(F,W)=>({message:W.message,type:1,offset:W.offset,length:W.length,location:W.location&&L.deserialize(F,W.location)})})(w||(e.ITestOutputMessage=w={}));var r;(function(C){C.serialize=F=>F.type===0?l.serialize(F):w.serialize(F),C.deserialize=(F,W)=>W.type===0?l.deserialize(F,W):w.deserialize(F,W)})(r||(e.ITestMessage=r={}));var c;(function(C){C.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),C.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(r.serialize)}),C.deserialize=(F,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(re=>r.deserialize(F,re))})})(c||(e.ITestTaskState=c={}));const s="\0",i=(C,F)=>C+s+F;e.$jK=i;const o=C=>{const F=C.indexOf(s);return{ctrlId:C.slice(0,F),tagId:C.slice(F+1)}};e.$kK=o;var a;(function(C){C.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),C.deserialize=(F,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?F.asCanonicalUri(S.URI.revive(W.uri)):void 0,range:W.range?I.$Ws.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(a||(e.ITestItem=a={}));var u;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var t;(function(C){C.serialize=F=>({expand:F.expand,item:a.serialize(F.item)}),C.deserialize=(F,W)=>({controllerId:A.$fK.root(W.item.extId),expand:W.expand,item:a.deserialize(F,W.item)})})(t||(e.InternalTestItem=t={}));var d;(function(C){C.serialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.uri!==void 0&&(W.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(W.range=F.item.range?.toJSON()),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}},C.deserialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.range!==void 0&&(W.range=F.item.range?I.$Ws.lift(F.item.range):null),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}}})(d||(e.ITestItemUpdate=d={}));const n=(C,F)=>{F.expand!==void 0&&(C.expand=F.expand),F.item!==void 0&&(C.item=C.item?Object.assign(C.item,F.item):F.item)};e.$lK=n;var b;(function(C){C.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(c.serializeWithoutMessages)}),C.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(c.serialize)}),C.deserialize=(F,W)=>({...t.deserialize(F,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(re=>c.deserialize(F,re)),retired:!0})})(b||(e.TestResultItem=b={}));var E;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(F,W)=>{F.covered+=W.covered,F.total+=W.total}})(E||(e.ICoveredCount=E={}));var h;(function(C){C.serialize=F=>({statement:F.statement,branch:F.branch,declaration:F.declaration,details:F.details?.map(p.serialize),uri:F.uri.toJSON()}),C.deserialize=(F,W)=>({statement:W.statement,branch:W.branch,declaration:W.declaration,details:W.details?.map(p.deserialize),uri:F.asCanonicalUri(S.URI.revive(W.uri))})})(h||(e.IFileCoverage=h={}));function v(C){return{...C,location:C.location?.toJSON()}}function P(C){return C.location=C.location?M.$Vs.isIPosition(C.location)?M.$Vs.lift(C.location):I.$Ws.lift(C.location):void 0,C}e.$mK=3;var g;(function(C){C[C.Declaration=0]="Declaration",C[C.Statement=1]="Statement",C[C.Branch=2]="Branch"})(g||(e.DetailType=g={}));var p;(function(C){C.serialize=F=>F.type===0?T.serialize(F):N.serialize(F),C.deserialize=F=>F.type===0?T.deserialize(F):N.deserialize(F)})(p||(e.CoverageDetails=p={}));var y;(function(C){C.serialize=v,C.deserialize=P})(y||(e.IBranchCoverage=y={}));var T;(function(C){C.serialize=v,C.deserialize=P})(T||(e.IDeclarationCoverage=T={}));var N;(function(C){C.serialize=F=>({...v(F),branches:F.branches?.map(y.serialize)}),C.deserialize=F=>({...P(F),branches:F.branches?.map(y.deserialize)})})(N||(e.IStatementCoverage=N={}));var J;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(J||(e.TestDiffOpType=J={}));var q;(function(C){C.deserialize=(F,W)=>W.op===0?{op:W.op,item:t.deserialize(F,W.item)}:W.op===1?{op:W.op,item:d.deserialize(W.item)}:W.op===2?{op:W.op,uri:F.asCanonicalUri(S.URI.revive(W.uri)),docv:W.docv}:W,C.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:d.serialize(F.item)}:F})(q||(e.TestsDiffOp=q={}));class U{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const W=this.v();for(const re of F)switch(re.op){case 0:this.l(t.deserialize(this.k,re.item),W);break;case 1:this.o(d.deserialize(re.item),W);break;case 3:this.p(re.itemId,W);break;case 5:this.q(re.itemId);break;case 4:this.updatePendingRoots(re.amount);break;case 6:this.c.set(re.tag.id,re.tag);break;case 7:this.c.delete(re.id);break}W.complete?.()}l(F,W){const re=A.$fK.parentId(F.item.extId)?.toString();let ce;if(!re)ce=this.w(F),this.g.add(ce),this.f.set(F.item.extId,ce);else if(this.f.has(re)){const we=this.f.get(re);we.children.add(F.item.extId),ce=this.w(F,we),this.f.set(F.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return W.add?.(ce),F.expand===2&&this.h++,ce}o(F,W){const re=this.f.get(F.extId);if(re)return F.expand!==void 0&&(re.expand===2&&this.h--,F.expand===2&&this.h++),(0,e.$lK)(re,F),W.update?.(re),re}p(F,W){const re=this.f.get(F);if(!re)return;const ce=A.$fK.parentId(re.item.extId)?.toString();ce?this.f.get(ce).children.delete(re.item.extId):this.g.delete(re);const we=[[F]];for(;we.length;)for(const De of we.pop()){const he=this.f.get(De);he&&(we.push(he.children),this.f.delete(De),W.remove?.(he,he!==re),he.expand===2&&this.h--)}}q(F){}updatePendingRoots(F){this.j+=F}v(){return{}}}e.$nK=U}),define(Ae[75],Me([1,0,11,5,6,54,59,49]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.TestItemEventOp=void 0;var f;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const D=(i,o)=>i===o,k=Object.entries({range:(i,o)=>i===o?!0:!i||!o?!1:i.equalsRange(o),busy:D,label:D,description:D,error:D,sortText:D,tags:(i,o)=>!(i.length!==o.length||i.some(a=>!o.includes(a)))}),l=(i,o)=>{let a;for(const[u,t]of k)t(i[u],o[u])||(a?a[u]=o[u]:a={[u]:o[u]});return a};class $ extends I.$Tc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new S.$hh(()=>this.flushDiff(),200)),this.g=this.B(new M.$Wd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(o){this.h=o;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===o.uri){a.docv=o.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===o.item.extId){(0,R.$lK)(a.item,o.item);return}if(a.op===0&&a.item.item.extId===o.item.extId){(0,R.$lK)(a.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,a){const u=this.tree.get(o);if(u){if((u.expandLevels===void 0||a>u.expandLevels)&&(u.expandLevels=a),u.expand===1){const t=this.M(u);return t.isOpen()?this.L(u,a-1):t.wait().then(()=>this.L(u,a-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,a-1)):this.L(u,a-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(o,a){switch(a.op){case 3:this.O(m.$fK.joinToString(o.fullId,a.id));break;case 0:this.z(a.item,o);break;case 5:for(const u of a.ops)this.w(o,u);break;case 1:this.C(a.new,a.old,o.fullId.toString());break;case 2:this.J(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:a.update}});break;case 6:this.y(o.actual.uri);break;default:(0,A.$6c)(a)}}y(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}z(o,a){const u=m.$fK.fromExtHostTestItem(o,this.root.id,a?.actual),t=this.s.getApiFor(o);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(o.id);let d=this.tree.get(u.toString());if(!d){d={fullId:u,actual:o,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},o.tags.forEach(this.D,this),this.tree.set(d.fullId.toString(),d),this.G(o,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:d.expand,item:this.s.toITestItem(o)}}),this.I(o,d,a);return}if(d.actual===o){this.H(o,d,a);return}if(d.actual.uri?.toString()!==o.uri?.toString())return this.O(u.toString()),this.z(o,a);const n=this.s.getChildren(d.actual),b=d.actual,E=l(this.s.toITestItem(b),this.s.toITestItem(o));this.s.getApiFor(b).listener=void 0,d.actual=o,d.expand=0,E&&(E.hasOwnProperty("tags")&&(this.C(o.tags,b.tags,u.toString()),delete E.tags),this.w(d,{op:4,update:E})),this.I(o,d,a);for(const[h,v]of n)this.s.getChildren(o).get(v.id)||this.O(m.$fK.joinToString(u,v.id));this.y(d.actual.uri)}C(o,a,u){const t=new Set(a.map(d=>d.id));for(const d of o)t.delete(d.id)||this.D(d);this.pushDiff({op:1,item:{extId:u,item:{tags:o.map(d=>(0,R.$jK)(this.s.controllerId,d.id))}}}),t.forEach(this.F,this)}D(o){const a=this.j.get(o.id);a?a.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$jK)(this.s.controllerId,o.id)}}))}F(o){const a=this.j.get(o);a&&!--a.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,R.$jK)(this.s.controllerId,o)}))}G(o,a){this.s.getApiFor(o).parent=a&&a.actual!==this.root?a.actual:void 0}H(o,a,u){this.G(o,u);const t=this.s.getApiFor(o);t.parent=u?.actual,t.listener=d=>this.w(a,d),this.J(a)}I(o,a,u){this.H(o,a,u);for(const[t,d]of this.s.getChildren(o))this.z(d,a)}J(o){let a;this.h?o.resolveBarrier?a=o.resolveBarrier.isOpen()?3:2:a=o.actual.canResolveChildren?1:0:a=0,a!==o.expand&&(o.expand=a,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:a}}),a===1&&o.expandLevels!==void 0&&this.M(o))}L(o,a){if(a<0)return;const u=[];for(const[t,d]of this.s.getChildren(o.actual)){const n=this.expand(m.$fK.joinToString(o.fullId,d.id),a);(0,S.$Tg)(n)&&u.push(n)}if(u.length)return Promise.all(u).then(()=>{})}M(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const d=new S.$7g;return d.open(),d}o.expand=2,this.N(o);const a=o.resolveBarrier=new S.$7g,u=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,d)};let t;try{t=this.h(o.actual===this.root?void 0:o.actual)}catch(d){u(d)}return(0,S.$Tg)(t)?t.catch(u).then(()=>{a.open(),this.J(o)}):(a.open(),this.J(o)),o.resolveBarrier}N(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}O(o){const a=this.tree.get(o);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const u=[a];for(;u.length;){const t=u.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.F(d.id);this.tree.delete(t.fullId.toString());for(const[d,n]of this.s.getChildren(t.actual))u.push(this.tree.get(m.$fK.joinToString(t.fullId,n.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$qN=$;class w extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$rN=w;class r extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$sN=r;class c extends Error{constructor(o,a,u){super(`TestItem with ID "${o}" is from controller "${a}" and cannot be added as a child of an item from controller "${u}".`)}}e.$tN=c;const s=(i,o,a)=>{let u=new Map;return{get size(){return u.size},forEach(t,d){for(const n of u.values())t.call(d,n,this)},[Symbol.iterator](){return u.entries()},replace(t){const d=new Map,n=new Set(u.keys()),b={op:5,ops:[]};for(const E of t){if(!(E instanceof a))throw new r(E.id);const h=o(E).controllerId;if(h!==i.controllerId)throw new c(E.id,h,i.controllerId);if(d.has(E.id))throw new w(E.id);d.set(E.id,E),n.delete(E.id),b.ops.push({op:0,item:E})}for(const E of n.keys())b.ops.push({op:3,id:E});i.listener?.(b),u=d},add(t){if(!(t instanceof a))throw new r(t.id);u.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){u.delete(t)&&i.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.$uN=s}),define(Ae[103],Me([1,0,75]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0;const M=new WeakMap,I=(R,m)=>{const f={controllerId:m};return M.set(R,f),f};e.$vN=I;const A=R=>{const m=M.get(R);if(!m)throw new S.$sN(R?.id||"<unknown>");return m};e.$wN=A}),define(Ae[76],Me([1,0,12,2]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hwb=e.$Gwb=e.$Fwb=e.$Ewb=e.$Dwb=void 0,e.$Dwb="vscode-cdn.net",e.$Ewb=`vscode-resource.${e.$Dwb}`,e.$Fwb=`'self' https://*.${e.$Dwb}`;function I(m,f){return m.scheme===S.Schemas.http||m.scheme===S.Schemas.https?m:(f&&f.authority&&f.isRemote&&m.scheme===S.Schemas.file&&(m=M.URI.from({scheme:S.Schemas.vscodeRemote,authority:f.authority,path:m.path})),M.URI.from({scheme:S.Schemas.https,authority:`${m.scheme}+${A(m.authority)}.${e.$Ewb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$Gwb=I;function A(m){return m.replace(/./g,f=>{const D=f.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?f:"-"+D.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(f,D)=>String.fromCharCode(parseInt(D,16)))}e.$Hwb=R}),define(Ae[214],Me([1,0,5,6,76]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class A{constructor(m,f,D){this.d=m,this.e=f,this.f=D,this.a=0,this.b=new M.$Sc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const L=f.getVisibleTextEditors();for(const k of this.c.values())L.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,f,D,L,k){let l;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===m){l=o;break}if(!l)throw new Error("not a visible editor");const $=this,w=this.a++,r=new S.$Wd,c=new S.$Wd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,I.$Gwb)(o,$.f)}get cspSource(){return I.$Fwb}set options(o){this.b=o,$.d.$setOptions(w,o)}get options(){return this.b}set html(o){this.a=o,$.d.$setHtml(w,o)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(o){return $.d.$postMessage(w,o)}},i=new class{constructor(){this.editor=m,this.line=f,this.height=D,this.webview=s,this.onDidDispose=c.event}dispose(){$.c.has(w)&&($.c.delete(w),$.d.$disposeEditorInset(w),c.fire(),c.dispose(),r.dispose())}};return this.d.$createEditorInset(w,l.id,l.value.document.uri,f+1,D,L||{},k.identifier,k.extensionLocation),this.c.set(w,{editor:m,inset:i,onDidReceiveMessage:r}),i}$onDidDispose(m){const f=this.c.get(m);f&&f.inset.dispose()}$onDidReceiveMessage(m,f){this.c.get(m)?.onDidReceiveMessage.fire(f)}}e.$Mgc=A}),define(Ae[104],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.$uK=void 0,e.$uK="__",e.$vK=(0,S.$8h)("IAuthenticationService")}),define(Ae[215],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nO=e.VariableKind=e.$mO=void 0,e.$mO=(0,S.$8h)("configurationResolverService");var M;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class I extends Error{constructor(R,m){super(m),this.variable=R}}e.$nO=I}),define(Ae[216],Me([1,0,19,73,16,26,20,94,178,215,13]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor($,w,r,c){this.h=new Map,this.a=$,this.b=w,this.g=r,c&&(this.c=c.then(s=>this.i(s)))}i($){if(R.$i){const w=Object.create(null);return Object.keys($).forEach(r=>{w[r.toLowerCase()]=$[r]}),w}return $}resolveWithEnvironment($,w,r){return this.l({env:this.i($),userHome:void 0},w?w.uri:void 0,r)}async resolveAsync($,w){const r={env:await this.c,userHome:await this.g};return this.l(r,$?$.uri:void 0,w)}async j($,w,r,c){const s=A.$yn(w);R.$i&&s.windows?Object.keys(s.windows).forEach(o=>s[o]=s.windows[o]):R.$j&&s.osx?Object.keys(s.osx).forEach(o=>s[o]=s.osx[o]):R.$k&&s.linux&&Object.keys(s.linux).forEach(o=>s[o]=s.linux[o]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,$?$.uri:void 0,s,r,c)}async resolveAnyAsync($,w,r){return this.j($,w,r)}async resolveAnyMap($,w,r){const c=new Map;return{newConfig:await this.j($,w,r,c),resolvedVariables:c}}resolveWithInteractionReplace($,w,r,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction($,w,r,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable($,w){if(this.h.has($))throw new Error("Variable "+$+" is contributed twice.");this.h.set($,w)}async l($,w,r,c,s){if(I.$Jf(r))return this.m($,w,r,c,s);if(Array.isArray(r))return Promise.all(r.map(i=>this.l($,w,i,c,s)));if(I.$Lf(r)){const i=Object.create(null),o=await Promise.all(Object.keys(r).map(async a=>[await this.m($,w,a,c,s),await this.l($,w,r[a],c,s)]));for(const[a,u]of o)i[a]=u;return i}return r}m($,w,r,c,s){return(0,L.$5e)(r,k.VARIABLE_REGEXP,async(i,o)=>{if(o.includes(k.VARIABLE_LHS))return i;let a=await this.o($,i,o,w,c);return s?.set(o,a),a!==i&&I.$Jf(a)&&a.match(k.VARIABLE_REGEXP)&&(a=await this.m($,w,a,c,s)),a})}n($){return this.b?this.b.getUriLabel($,{noPrefix:!0}):$.fsPath}async o($,w,r,c,s){let i;const o=r.split(":");o.length>1&&(r=o[0],i=o[1]);const a=d=>{const n=this.a.getFilePath();if(n)return(0,m.$Yv)(n);throw new D.$nO(d,(0,f.localize)(0,null,w))},u=d=>{const n=a(d);if(this.a.getWorkspaceFolderPathForFile){const b=this.a.getWorkspaceFolderPathForFile();if(b)return(0,m.$Yv)(b)}throw new D.$nO(d,(0,f.localize)(1,null,w,S.$nc(n)))},t=d=>{if(i){const n=this.a.getFolderUri(i);if(n)return n;throw new D.$nO(d,(0,f.localize)(2,null,w,i))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new D.$nO(d,(0,f.localize)(3,null,w)):new D.$nO(d,(0,f.localize)(4,null,w))};switch(r){case"env":if(i){if($.env){const d=$.env[R.$i?i.toLowerCase():i];if(I.$Jf(d))return d}return""}throw new D.$nO(D.VariableKind.Env,(0,f.localize)(5,null,w));case"config":if(i){const d=this.a.getConfigurationValue(c,i);if(I.$Sf(d))throw new D.$nO(D.VariableKind.Config,(0,f.localize)(6,null,w,i));if(I.$Lf(d))throw new D.$nO(D.VariableKind.Config,(0,f.localize)(7,null,w,i));return d}throw new D.$nO(D.VariableKind.Config,(0,f.localize)(8,null,w));case"command":return this.p(D.VariableKind.Command,w,i,s,"command");case"input":return this.p(D.VariableKind.Input,w,i,s,"input");case"extensionInstallFolder":if(i){const d=await this.a.getExtension(i);if(!d)throw new D.$nO(D.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,w,i));return this.n(d.extensionLocation)}throw new D.$nO(D.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,w));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,m.$Yv)(this.n(t(D.VariableKind.WorkspaceFolder)));case"cwd":return c||i?(0,m.$Yv)(this.n(t(D.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Yv)(S.$nc(this.n(t(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if($.userHome)return $.userHome;throw new D.$nO(D.VariableKind.UserHome,(0,f.localize)(11,null,w))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new D.$nO(D.VariableKind.LineNumber,(0,f.localize)(12,null,w))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new D.$nO(D.VariableKind.SelectedText,(0,f.localize)(13,null,w))}case"file":return a(D.VariableKind.File);case"fileWorkspaceFolder":return u(D.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$nc(u(D.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return c||i?S.$lc(this.n(t(D.VariableKind.RelativeFile)),a(D.VariableKind.RelativeFile)):a(D.VariableKind.RelativeFile);case"relativeFileDirname":{const d=S.$mc(a(D.VariableKind.RelativeFileDirname));if(c||i){const n=S.$lc(this.n(t(D.VariableKind.RelativeFileDirname)),d);return n.length===0?".":n}return d}case"fileDirname":return S.$mc(a(D.VariableKind.FileDirname));case"fileExtname":return S.$oc(a(D.VariableKind.FileExtname));case"fileBasename":return S.$nc(a(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=S.$nc(a(D.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-S.$oc(d).length)}case"fileDirnameBasename":return S.$nc(S.$mc(a(D.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||w}case"execInstallFolder":{const d=this.a.getAppRoot();return d||w}case"pathSeparator":case"/":return S.sep;default:try{const d=i?`${r}:${i}`:r;return this.p(D.VariableKind.Unknown,w,d,s,void 0)}catch{return w}}}}p($,w,r,c,s){if(r&&c){const i=s===void 0?c[r]:c[s+":"+r];if(typeof i=="string")return i;throw new D.$nO($,(0,f.localize)(14,null,w))}return w}}e.$BO=k}),define(Ae[105],Me([1,0,4,102]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.OpenEditorContext=e.GroupsOrder=e.$bD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$aD=void 0,e.$aD=(0,S.$8h)("editorGroupsService");var I;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var A;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var R;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var f;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function D(w){const r=w;return(0,M.$WE)(r?.editor)&&(0,M.$WE)(r?.replacement)}e.$bD=D;var L;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var k;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function l(w){const r=w;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}e.$cD=l;function $(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$dD=$}),define(Ae[217],Me([1,0,4,105]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=void 0,e.$eD=(0,S.$8h)("editorService"),e.$fD=-1,e.$gD=-2,e.$hD=-3;function I(A){const R=A;return typeof A=="number"||(0,M.$cD)(R)}e.$iD=I}),define(Ae[218],Me([1,0,4,185]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=void 0,e.$LK=(0,S.$9h)(M.$ci)}),define(Ae[106],Me([1,0,22,5,19,6,11]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z8b=e.$y8b=e.$x8b=e.$w8b=e.$v8b=void 0;class m{constructor(i,o){this.versionId=i,this.removedDueToLooping=o}}e.$v8b=m;class f{static isHostExtension(i,o,a){if(o.getExtensionDescription(i))return!1;const u=a.getExtensionDescription(i);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(i,o){this.j=i,this.c=new M.$Wd,this.onDidChange=this.c.event,this.d=0,this.e=o,this.k()}k(){this.e.sort(r),this.f=new S.$pm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const o=this.j.readActivationEvents(i);for(const a of o)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,o){this.e=c(this.e,o),this.e=this.e.concat(i);const a=f.l(this.e);return this.e=c(this.e,a.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,a)}static l(i){const o=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,b){this.addNode(n),this.addNode(b),this.c.has(n)?this.c.get(n).push(b):this.c.set(n,[b])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,b){const E=o.getArcs(n);for(let h=0;h<E.length;h++)if(!b.has(E[h]))return!1;return!0}getNodes(){return this.e}},a=new S.$pm;for(const n of i)if(a.set(n.identifier,n),n.extensionDependencies)for(const b of n.extensionDependencies)o.addArc(S.$nm.toKey(n.identifier),S.$nm.toKey(b));const u=new Set;o.getNodes().filter(n=>o.getArcs(n).length===0).forEach(n=>u.add(n));const t=o.getNodes().filter(n=>!u.has(n));let d;do{d=!1;for(let n=0;n<t.length;n++){const b=t[n];o.hasOnlyGoodArcs(b,u)&&(t.splice(n,1),n--,u.add(b),d=!0)}}while(d);return t.map(n=>a.get(n))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const o=this.h.get(i);return o?o.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const o=this.f.get(i);return o||void 0}getExtensionDescriptionByUUID(i){for(const o of this.g)if(o.uuid===i)return o}getExtensionDescriptionByIdOrUUID(i,o){return this.getExtensionDescription(i)??(o?this.getExtensionDescriptionByUUID(o):void 0)}}e.$w8b=f;class D{constructor(i,o){this.versionId=i,this.extensions=o}}e.$x8b=D;class L{constructor(i){this.d=new $,this.c=new f(i,[])}async acquireLock(i){const o=await this.d.acquire(i);return new k(this,o)}deltaExtensions(i,o,a){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(o,a)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,o){return this.c.getExtensionDescriptionByIdOrUUID(i,o)}}e.$y8b=L;class k extends A.$Tc{constructor(i,o){super(),this.f=i,this.c=!1,this.B(o)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$z8b=k;class l{constructor(i){this.name=i;const o=(0,R.$1g)();this.promise=o.promise,this.c=o.resolve}resolve(i){this.c(i)}}class ${constructor(){this.c=[],this.d=!1}async acquire(i){const o=new l(i);return this.c.push(o),this.e(),o.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let o=!0;const a=setTimeout(()=>{o&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{o&&(clearTimeout(a),o=!1,this.d=!1,this.e())};i.resolve((0,A.$Rc)(u))}}var w;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(w||(w={}));function r(s,i){const o=s.isBuiltin?0:s.isUnderDevelopment?2:1,a=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(o!==a)return o-a;const u=I.$gc.basename(s.extensionLocation.path),t=I.$gc.basename(i.extensionLocation.path);return u<t?-1:u>t?1:0}function c(s,i){const o=new S.$om(i);return s.filter(a=>!o.has(a.identifier))}}),define(Ae[77],Me([1,0,23]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$wm=e.$vm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(M||(e.UIKind=M={}));var I;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var A;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function R(D){const L=S.$ke.alloc(1);switch(D){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.$vm=R;function m(D,L){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.$wm=m;var f;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Ae[60],Me([1,0,4,5,14,27,77,56,57,26,2,6,166]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=e.$TN=e.$SN=e.$RN=void 0;let $=class extends k.$Tc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new M.$Wd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Wd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=L.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:f.$So,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(o=>{(0,I.$rj)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,o){const a=this.getTelemetryDetails(),u=new w(i,o,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(s,i,o){this.f=s,this.g=i,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,m.$dl)((0,f.$Yo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((o,a)=>{const u=o.filter(t=>!t.isDisposed);u.length===0?this.r.delete(a):this.r.set(a,u)}),this.r.forEach(o=>{for(const a of o)a.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const a=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(s.value),!1;let u=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(i),u=!0);return u}};e.$RN=$,e.$RN=$=Je([qe(0,A.$QN),qe(1,I.$qj)],$);class w{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,o,a,u,t,d){this.g=o,this.h=a,this.i=u,this.j=t,this.a=new M.$Wd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,f.$2o)(i,[]),this.c&&(i=(0,D.$Bn)(i,this.c)),this.b||(i=(0,D.$Bn)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const o={name:s.name,message:s.message,stack:s.stack,cause:s.cause},a=(0,f.$2o)(o,[]),u=new Error(a.message,{cause:a.cause});u.stack=a.stack,u.name=a.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(u,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$SN=w;function r(c){const s=Date.now()-new Date(c).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$TN=r,e.$UN=(0,S.$8h)("IExtHostTelemetry")}),define(Ae[25],Me([1,0,5,2,194,101,22,4]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.ActivationKind=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.ExtensionHostStartup=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$FF=Object.freeze({identifier:new R.$nm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$GF="extensions.webWorker",e.$HF=(0,m.$8h)("extensionService");class f{constructor(u){this.dependency=u}}e.$IF=f;var D;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(D||(e.ExtensionHostStartup=D={}));class L{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,t,d){this.c=u,this.d=t.slice(0),this.e=d.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$qF.createActivationEventsMap(this.d)}}set(u,t,d){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const n=[],b=[],E=[],h=[],v=k(this.d),P=k(t),g=(J,q)=>J.extensionLocation.toString()===q.extensionLocation.toString()||J.isBuiltin===q.isBuiltin||J.isUserBuiltin===q.isUserBuiltin||J.isUnderDevelopment===q.isUnderDevelopment;for(const J of this.d){const q=P.get(J.identifier);if(!q){n.push(J.identifier),v.delete(J.identifier);continue}if(!g(J,q)){n.push(J.identifier),v.delete(J.identifier);continue}}for(const J of t){const q=v.get(J.identifier);if(!q){b.push(J);continue}if(!g(q,J)){n.push(q.identifier),v.delete(q.identifier);continue}}const p=new R.$om(this.e),y=new R.$om(d);for(const J of this.e)y.has(J)||E.push(J);for(const J of d)p.has(J)||h.push(J);const T=A.$qF.createActivationEventsMap(b),N={versionId:u,toRemove:n,toAdd:b,addActivationEvents:T,myToRemove:E,myToAdd:h};return this.delta(N),N}delta(u){if(this.c>=u.versionId)return null;const{toRemove:t,toAdd:d,myToRemove:n,myToAdd:b}=u,E=new R.$om(t),h=new R.$om(n);for(let v=0;v<this.d.length;v++)E.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)h.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of d)this.d.push(v);for(const v of b)this.e.push(v);return this.f=null,u}containsExtension(u){for(const t of this.e)if(R.$nm.equals(t,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const d=A.$qF.readActivationEvents(t);for(const n of d)u.add(n)}return u}}e.$JF=L;function k(a){const u=new R.$pm;for(const t of a)u.set(t.identifier,t);return u}function l(a,u){return a.enabledApiProposals?a.enabledApiProposals.includes(u):!1}e.$KF=l;function $(a,u){if(!l(a,u))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.$LF=$;class w{constructor(u,t,d,n){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=d,this.activationReason=n}}e.$MF=w;class r{constructor(u,t){this.description=u,this.value=t}}e.$NF=r;var c;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(c||(e.ActivationKind=c={}));function s(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,I.$8o)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.$OF=s;function i(a,u){return{identifier:new R.$nm((0,I.$6o)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!u,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}e.$PF=i;class o{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,t){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$QF=o}),define(Ae[219],Me([1,0,15,106,22,25,14,11]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=e.$ahc=e.$_gc=e.$$gc=e.$0gc=e.$9gc=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(s,i,o,a){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=o,this.activateResolvedTime=a}}e.$9gc=f;class D{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$0gc=D;class L{constructor(s,i,o,a,u,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=o,this.module=a,this.exports=u,this.subscriptions=t}}e.$$gc=L;class k extends L{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$_gc=k;class l extends L{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ahc=l;class $ extends L{constructor(s){super(!0,s,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(s,i,o,a){this.g=a,this.a=s,this.b=i,this.c=o,this.d=new I.$pm,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,o]of this.d)s.push(o.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const o=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(o.map(a=>({id:a.identifier,reason:{startup:i,extensionId:a.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const o=this.a.getExtensionDescription(s);if(!o)throw new Error(`Extension '${s}' is not known`);return this.h([{id:o.identifier,reason:i}])}async h(s){const i=s.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(i.map(o=>o.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const u=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new $(u));return this.c.onExtensionActivationError(s.id,u,new A.$IF(s.id.value)),t}const o=[],a=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const u of a){if(this.m(u))continue;const t=this.d.get(u);if(t){o.push(t);continue}if(this.l(u)){o.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:s.reason}));continue}const d=this.a.getExtensionDescription(u);if(d){if(!d.main&&!d.browser)continue;o.push(this.j({id:d.identifier,reason:s.reason}));continue}const n=i.displayName||i.identifier.value,b=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${u}'`),E=this.k(s,i.displayName,[],new $(b));return this.c.onExtensionActivationError(i.identifier,b,new A.$IF(u)),E}return this.k(s,i.displayName,o,null)}k(s,i,o,a){const u=new r(s.id,i,s.reason,o,a,this.c,this.g);return this.d.set(s.id,u),u}l(s){return M.$w8b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$bhc=w,e.$bhc=w=Je([qe(3,R.$pj)],w);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,o,a,u,t,d){this.c=s,this.d=i,this.f=o,this.g=a,this.h=u,this.j=t,this.k=d,this.a=new m.$7g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);o.detail=i.value.activationFailedError,this.h=new $(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new $(i),this.b&&S.$4(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Je([qe(6,R.$pj)],r)}),define(Ae[220],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[221],Me([1,0,180,15,32,96,72,30,22,220,190,101]),function(fe,e,S,M,I,A,R,m,f,D,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=void 0;const l=m.$Kn.as(R.$Ln.JSONContribution);class ${constructor(u,t,d){this.a=u,this.b=t,this.c=d}d(u,t){this.a({type:u,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(I.default.Error,u)}warn(u){this.d(I.default.Warning,u)}info(u){this.d(I.default.Info,u)}}e.$zF=$;class w{static a(u){const t=new f.$om;for(let d=0,n=u.length;d<n;d++)t.add(u[d].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new w(t,[]);if(!t||!t.length)return new w([],u);const d=this.a(u),n=this.a(t),b=t.filter(h=>!d.has(h.description.identifier)),E=u.filter(h=>!n.has(h.description.identifier));return new w(b,E)}constructor(u,t){this.added=u,this.removed=t}}e.$AF=w;class r{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=w.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,M.$1)(u)}}}e.$BF=r;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$CF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$mm},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$po}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$po}},extensionKind:{description:S.localize(52,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new r(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,t),u.activationEventsGenerator&&k.$qF.register(u.extensionPoint,u.activationEventsGenerator),e.$CF.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,l.registerSchema(s,e.$CF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$DF=i;const o={ExtensionsRegistry:"ExtensionsRegistry"};m.$Kn.add(o.ExtensionsRegistry,new i),e.$EF=m.$Kn.as(o.ExtensionsRegistry),l.registerSchema(s,e.$CF),l.registerSchema(L.$Ij,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(Ae[222],Me([1,0,176,16,26,221,35,5]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DG=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var D;(function(l){function $(w,r,c){if(!w)return;const s=M.$Jf(w.type)?w.type:void 0;if(!s||s.length===0){c.error(S.localize(3,null));return}const i=[];if(Array.isArray(w.required))for(const o of w.required)M.$Jf(o)&&i.push(o);return{extensionId:r.value,taskType:s,required:i,properties:w.properties?I.$yn(w.properties):{},when:w.when?R.$6i.deserialize(w.when):void 0}}l.from=$})(D||(D={}));const L=A.$EF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,$)=>{for(const w of l)w.type&&$.push(`onTaskType:${w.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:f}});class k{constructor(){this.d=new m.$Wd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise(($,w)=>{L.setHandler((r,c)=>{this.c=void 0;try{for(const s of c.removed){const i=s.value;for(const o of i)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const s of c.added){const i=s.value;for(const o of i){const a=D.from(o,s.description.identifier,s.collector);a&&(this.a[a.taskType]=a)}}(c.removed.length>0||c.added.length>0)&&this.d.fire()}catch{}$(void 0)})})}onReady(){return this.b}get($){return this.a[$]}all(){return Object.keys(this.a).map($=>this.a[$])}getJsonSchema(){if(this.c===void 0){const $=[];for(const w of this.all()){const r={type:"object",additionalProperties:!1};w.required.length>0&&(r.required=w.required.slice(0)),w.properties!==void 0?r.properties=I.$yn(w.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[w.taskType]},$.push(r)}this.c={oneOf:$}}return this.c}}e.$DG=new k}),define(Ae[223],Me([1,0,177,16,24,26,35,222]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$NG=e.JsonSchemaVersion=e.ExecutionEngine=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$HG=e.ShellQuoting=e.$GG=e.$FG=e.$EG=void 0,e.$EG="settings",e.$FG=new R.$mj("taskRunning",!1,S.localize(0,null)),e.$GG=S.localize2(2,"Tasks");var f;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$HG="$customized",function(C){function F(W){if(!W)return C.Strong;switch(W.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=F}(f||(e.ShellQuoting=f={}));var D;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(D||(e.CommandOptions=D={}));var L;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(L||(e.RevealKind=L={})),function(C){function F(W){switch(W.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=F}(L||(e.RevealKind=L={}));var k;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(C){function F(W){switch(W.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=F}(k||(e.RevealProblemKind=k={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function F(W){switch(W.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=F}(l||(e.PanelKind=l={}));var $;(function(C){C.defaults={echo:!0,reveal:L.Always,revealProblems:k.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})($||(e.PresentationOptions=$={}));var w;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(w||(e.RuntimeType=w={})),function(C){function F(re){switch(re.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=F;function W(re){switch(re){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=W}(w||(e.RuntimeType=w={}));var r;(function(C){function F(W){return M.$Jf(W)?W:W.value}C.value=F})(r||(e.CommandString=r={}));var c;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function F(re){return re===C.Clean._id||re===C.Build._id||re===C.Rebuild._id||re===C.Test._id}C.is=F;function W(re){if(re!==void 0)return M.$Jf(re)?F(re)?{_id:re,isDefault:!1}:void 0:re}C.from=W})(c||(e.TaskGroup=c={}));var s;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function F(W){switch(W){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=F})(i||(e.TaskSourceKind=i={}));var o;(function(C){C.parallel="parallel",C.sequence="sequence"})(o||(e.DependsOrder=o={}));var a;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var u;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(F,W,re,ce,we,De){this._label="",this._id=F,W&&(this._label=W),re&&(this.type=re),this.runOptions=ce,this.configurationProperties=we,this._source=De}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,W=!1){if(F===void 0)return!1;if(M.$Jf(F))return F===this._label||F===this.configurationProperties.identifier||W&&F===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$IG=t;class d extends t{constructor(F,W,re,ce,we,De,he,ve){super(F,re,void 0,he,ve,W),this.command={},this._source=W,this.hasDefinedMatchers=De,we&&(this.command=we)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case w.Shell:W="shell";break;case w.Process:W="process";break;case w.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(F){return F instanceof d}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$EG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const re={type:e.$HG,folder:F,id:W};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new d(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$JG=d;class n extends t{constructor(F,W,re,ce,we,De,he){super(F,re,ce,De,he,W),this._source=W,this.configures=we}static is(F){return F instanceof n}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$EG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const re={type:e.$HG,folder:F,id:W};return JSON.stringify(re)}}e.$KG=n;class b extends t{constructor(F,W,re,ce,we,De,he,ve,se){super(F,re,ce,ve,se,W),this.defines=we,this.hasDefinedMatchers=he,this.command=De,this.icon=se.icon,this.hide=se.hide}clone(){return new b(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof b}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new b(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$LG=b;class E extends t{constructor(F,W,re,ce,we,De){super(F,re,ce,we,De,W),this._source=W}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new E(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$MG=E;var h;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(C){C._default=C.Terminal}(h||(e.ExecutionEngine=h={}));var v;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class P{constructor(F){this.c=new Map;for(let W=0;W<F.length;W++)this.c.set(F[W].uri.toString(),W)}compare(F,W){const re=F.getWorkspaceFolder(),ce=W.getWorkspaceFolder();if(re&&ce){let we=this.c.get(re.uri.toString());we=we===void 0?0:we+1;let De=this.c.get(ce.uri.toString());return De=De===void 0?0:De+1,we===De?F._label.localeCompare(W._label):we-De}else return!re&&ce?-1:re&&!ce?1:0}}e.$NG=P;var g;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(g||(e.TaskEventKind=g={}));var p;(function(C){C.SingleRun="singleRun",C.Background="background"})(p||(e.TaskRunType=p={}));var y;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var T;(function(C){function F(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function W(ve,se,$e){return{...F(ve),kind:"start",terminalId:se,resolvedVariables:$e}}C.start=W;function re(ve,se,$e){return{...F(ve),kind:"processStarted",terminalId:se,processId:$e}}C.processStarted=re;function ce(ve,se,$e){return{...F(ve),kind:"processEnded",terminalId:se,exitCode:$e}}C.processEnded=ce;function we(ve,se,$e){return{...F(ve),kind:"terminated",exitReason:$e,terminalId:se}}C.terminated=we;function De(ve,se,$e){return{...F(se),kind:ve,terminalId:$e}}C.general=De;function he(){return{kind:"changed"}}C.changed=he})(T||(e.TaskEvent=T={}));var N;(function(C){function F(re){const ce=Object.keys(re).sort();let we="";for(const De of ce){let he=re[De];he instanceof Object?he=F(he):typeof he=="string"&&(he=he.replace(/,/g,",,")),we+=De+","+he+","}return we}function W(re){const we={_key:F(re),type:re.taskType};return Object.assign(we,re),we}C.create=W})(N||(e.KeyedTaskIdentifier=N={}));var J;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(J||(e.TaskSettingId=J={}));var q;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var U;(function(C){function F(W,re){const ce=m.$DG.get(W.type);if(ce===void 0){const ve=A.$yn(W);return delete ve._key,N.create(ve)}const we=Object.create(null);we.type=ce.taskType;const De=new Set;ce.required.forEach(ve=>De.add(ve));const he=ce.properties;for(const ve of Object.keys(he)){const se=W[ve];if(se!=null)we[ve]=se;else if(De.has(ve)){const $e=he[ve];if($e.default!==void 0)we[ve]=A.$yn($e.default);else switch($e.type){case"boolean":we[ve]=!1;break;case"number":case"integer":we[ve]=0;break;case"string":we[ve]="";break;default:re.error(S.localize(1,null,JSON.stringify(W,void 0,0),ve));return}}}return N.create(we)}C.createTaskIdentifier=F})(U||(e.TaskDefinition=U={}))}),define(Ae[224],Me([1,0,15]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B8b=e.$A8b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,m)=>{this.b=R,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,S.$1)(R))}then(R,m){return this.j().then(R,m)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$A8b=M;class I extends M{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$B8b=I}),define(Ae[50],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=void 0;class S{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++S.count}}e.$Sv=S;const M=[];function I(m){const f=new S(m);return M[f.nid]=f,f}e.$Tv=I;function A(m){return M[m].sid}e.$Uv=A;class R{constructor(f){this.value=f}}e.$Vv=R}),define(Ae[3],Me([1,0,50]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pL=e.$oL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$nL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var I;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput"})(I||(e.TabInputKind=I={}));var A;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var f;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var D;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(D||(e.NotebookEditorRevealType=D={}));var L;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class k{static{this.a=0}static mixin(c){return c._id=k.a++,c}}e.$nL=k;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var $;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})($||(e.ISuggestResultDtoField=$={}));var w;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$oL={MainThreadAuthentication:(0,S.$Tv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$Tv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,S.$Tv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,S.$Tv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$Tv)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$Tv)("MainThreadClipboard"),MainThreadCommands:(0,S.$Tv)("MainThreadCommands"),MainThreadComments:(0,S.$Tv)("MainThreadComments"),MainThreadConfiguration:(0,S.$Tv)("MainThreadConfiguration"),MainThreadConsole:(0,S.$Tv)("MainThreadConsole"),MainThreadDebugService:(0,S.$Tv)("MainThreadDebugService"),MainThreadDecorations:(0,S.$Tv)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$Tv)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$Tv)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$Tv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$Tv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$Tv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$Tv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$Tv)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$Tv)("MainThreadErrors"),MainThreadTreeViews:(0,S.$Tv)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$Tv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$Tv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$Tv)("MainThreadLanguages"),MainThreadLogger:(0,S.$Tv)("MainThreadLogger"),MainThreadMessageService:(0,S.$Tv)("MainThreadMessageService"),MainThreadOutputService:(0,S.$Tv)("MainThreadOutputService"),MainThreadProgress:(0,S.$Tv)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$Tv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$Tv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$Tv)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$Tv)("MainThreadSecretState"),MainThreadStorage:(0,S.$Tv)("MainThreadStorage"),MainThreadSpeech:(0,S.$Tv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$Tv)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$Tv)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$Tv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$Tv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$Tv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$Tv)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$Tv)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$Tv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$Tv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$Tv)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$Tv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$Tv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$Tv)("MainThreadExtensionService"),MainThreadSCM:(0,S.$Tv)("MainThreadSCM"),MainThreadSearch:(0,S.$Tv)("MainThreadSearch"),MainThreadShare:(0,S.$Tv)("MainThreadShare"),MainThreadTask:(0,S.$Tv)("MainThreadTask"),MainThreadWindow:(0,S.$Tv)("MainThreadWindow"),MainThreadLabelService:(0,S.$Tv)("MainThreadLabelService"),MainThreadNotebook:(0,S.$Tv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$Tv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$Tv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$Tv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$Tv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$Tv)("MainThreadInteractive"),MainThreadChat:(0,S.$Tv)("MainThreadChat"),MainThreadInlineChat:(0,S.$Tv)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$Tv)("MainThreadTheming"),MainThreadTunnelService:(0,S.$Tv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$Tv)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$Tv)("MainThreadTimeline"),MainThreadTesting:(0,S.$Tv)("MainThreadTesting"),MainThreadLocalization:(0,S.$Tv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$Tv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$Tv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$Tv)("MainThreadIssueReporter")},e.$pL={ExtHostCommands:(0,S.$Tv)("ExtHostCommands"),ExtHostConfiguration:(0,S.$Tv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$Tv)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$Tv)("ExtHostDebugService"),ExtHostDecorations:(0,S.$Tv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$Tv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$Tv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$Tv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$Tv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$Tv)("ExtHostEditors"),ExtHostTreeViews:(0,S.$Tv)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$Tv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$Tv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$Tv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$Tv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$Tv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$Tv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$Tv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$Tv)("ExtHostStatusBar"),ExtHostShare:(0,S.$Tv)("ExtHostShare"),ExtHostExtensionService:(0,S.$Tv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$Tv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$Tv)("ExtHostTerminalService"),ExtHostSCM:(0,S.$Tv)("ExtHostSCM"),ExtHostSearch:(0,S.$Tv)("ExtHostSearch"),ExtHostTask:(0,S.$Tv)("ExtHostTask"),ExtHostWorkspace:(0,S.$Tv)("ExtHostWorkspace"),ExtHostWindow:(0,S.$Tv)("ExtHostWindow"),ExtHostWebviews:(0,S.$Tv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$Tv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$Tv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$Tv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$Tv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$Tv)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$Tv)("ExtHostProgress"),ExtHostComments:(0,S.$Tv)("ExtHostComments"),ExtHostSecretState:(0,S.$Tv)("ExtHostSecretState"),ExtHostStorage:(0,S.$Tv)("ExtHostStorage"),ExtHostUrls:(0,S.$Tv)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$Tv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$Tv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$Tv)("ExtHostOutputService"),ExtHostLabelService:(0,S.$Tv)("ExtHostLabelService"),ExtHostNotebook:(0,S.$Tv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$Tv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$Tv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$Tv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$Tv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$Tv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$Tv)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$Tv)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$Tv)("ExtHostChat"),ExtHostChatAgents2:(0,S.$Tv)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$Tv)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$Tv)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$Tv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$Tv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$Tv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$Tv)("ExtHostTheming"),ExtHostTunnelService:(0,S.$Tv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$Tv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$Tv)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$Tv)("ExtHostTimeline"),ExtHostTesting:(0,S.$Tv)("ExtHostTesting"),ExtHostTelemetry:(0,S.$Tv)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$Tv)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$Tv)("ExtHostIssueReporter")}}),define(Ae[78],Me([1,0,4,14,3,17]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=e.$Agc=e.$zgc=void 0,e.$zgc=(0,S.$8h)("IExtHostApiDeprecationService");let R=class{constructor(f,D){this.c=D,this.a=new Set,this.b=f.getProxy(I.$oL.MainThreadTelemetry)}report(f,D,L){const k=this.d(f,D);this.a.has(k)||(this.a.add(k),D.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:f}))}d(f,D){return`${f}-${D.identifier.value}`}};e.$Agc=R,e.$Agc=R=Je([qe(0,A.$AN),qe(1,M.$pj)],R),e.$Bgc=Object.freeze(new class{report(m,f,D){}})}),define(Ae[225],Me([1,0,68,6,3]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;class A{static{this.a=0}constructor(f,D){this.extension=f,this.provider=D,this.handle=A.a++}}class R{static{this.a=0}constructor(f){this.b=new Map,this.c=new Map,this.d=f.getProxy(I.$oL.MainThreadChat)}registerChatProvider(f,D,L){const k=new A(f,L);return this.b.set(k.handle,k),this.d.$registerChatProvider(k.handle,D),(0,M.$Rc)(()=>{this.d.$unregisterChatProvider(k.handle),this.b.delete(k.handle)})}transferChatSession(f,D){const L=S.Iterable.find(this.c.keys(),k=>this.c.get(k)===f)??0;typeof L=="number"&&this.d.$transferChatSession(L,D)}sendInteractiveRequestToProvider(f,D){this.d.$sendRequestToProvider(f,D)}async $prepareChat(f,D){const L=this.b.get(f);if(!L)return;const k=await L.provider.prepareSession(D);if(!k)return;const l=R.a++;return this.c.set(l,k),{id:l,requesterUsername:k.requester?.name,requesterAvatarIconUri:k.requester?.icon,responderUsername:k.responder?.name,responderAvatarIconUri:k.responder?.icon,inputPlaceholder:k.inputPlaceholder}}$releaseSession(f){this.c.delete(f)}}e.$Ggc=R}),define(Ae[226],Me([1,0,3]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;class M{constructor(A){const R=A.getProxy(S.$oL.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.$Kgc=M}),define(Ae[227],Me([1,0,26,3,27,17]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;let R=class{constructor(L,k){this.a=L.getProxy(M.$oL.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(L,k){const l=this,$=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){l.e(L,k,$,arguments)}})}e(L,k,l,$){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:f($,this.b)}),this.c&&this.f(L,l,$)}};e.$Bic=R,e.$Bic=R=Je([qe(0,A.$AN),qe(1,I.$QN)],R);const m=1e5;function f(D,L){const k=[];if(D.length)for(let l=0;l<D.length;l++){let $=D[l];if(typeof $>"u")$="undefined";else if($ instanceof Error){const w=$;w.stack?$=w.stack:$=w.toString()}k.push($)}if(L){const l=new Error().stack;l&&k.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.$Dn)(k);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Ae[228],Me([1,0,2,3,25]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;class A{constructor(m){this.a=m.getProxy(M.$oL.MainThreadDialogs)}showOpenDialog(m,f){return f?.allowUIResources&&(0,I.$LF)(m,"showLocal"),this.a.$showOpenDialog(f).then(D=>D?D.map(L=>S.URI.revive(L)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(f=>f?S.URI.revive(f):void 0)}}e.$Fhc=A}),define(Ae[229],Me([1,0,6,3]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;class I{constructor(R){this.b=0,this.a=R.getProxy(M.$oL.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,R),(0,S.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$1hc=I}),define(Ae[79],Me([1,0,20,13,2,4,14,3,27,17]),function(fe,e,S,M,I,A,R,m,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=e.$nhc=void 0;let L=class{constructor(l,$,w){this.f=w,this.d=new Map,this.a=$.getProxy(m.$oL.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===S.$g}getMessage(l,$){const{message:w,args:r,comment:c}=$;if(this.c)return(0,M.$Me)(w,r??{});let s=w;c&&c.length>0&&(s+=`/${Array.isArray(c)?c.join(""):c}`);const i=this.d.get(l)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,M.$Me)(i??w,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let $;const w=await this.g(l);if(!w){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(w),c=JSON.parse(r);$=l.isBuiltin?c.contents?.bundle:c}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${w}: ${r.message}`);return}$&&this.d.set(l.identifier.value,{contents:$,uri:w})}async g(l){if(l.isBuiltin){const $=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive($)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$nhc=L,e.$nhc=L=Je([qe(0,f.$QN),qe(1,D.$AN),qe(2,R.$pj)],L),e.$ohc=(0,A.$8h)("IExtHostLocalizationService")}),define(Ae[230],Me([1,0,14,3,27,17,2,52]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;let f=class extends S.$Aj{constructor(k,l){super(l.logLevel,l.logsLocation,l.loggers.map($=>(0,m.$Eh)($))),this.r=k.getProxy(M.$oL.MainThreadLogger)}$setLogLevel(k,l){l?this.setLogLevel(R.URI.revive(l),k):this.setLogLevel(k)}setVisibility(k,l){super.setVisibility(k,l),this.r.$setVisibility(k,l)}s(k,l,$){return new D(this.r,k,l,$)}};e.$Aic=f,e.$Aic=f=Je([qe(0,A.$AN),qe(1,I.$QN)],f);class D extends S.$vj{constructor(k,l,$,w){super(w?.logLevel==="always"),this.r=k,this.s=l,this.m=!1,this.n=[],this.setLevel($),this.r.$createLogger(l,w).then(()=>{this.u(this.n),this.m=!0})}g(k,l){const $=[[k,l]];this.m?this.u($):this.n.push(...$)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Ae[80],Me([1,0,3,4,6,17,23]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=e.$phc=void 0,e.$phc=(0,M.$8h)("IExtHostManagedSockets");let m=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(S.$oL.MainThreadManagedSockets)}setFactory(k,l){for(const $ of this.d.values())$.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(k,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const l=++this.b,$=await this.c.makeConnection(),w=new I.$Sc;return this.d.set(l,new D(l,$,w)),w.add((0,I.$Rc)(()=>this.d.delete(l))),w.add($.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),w.dispose()})),w.add($.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),w.dispose()})),w.add($.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,R.$ke.wrap(r)))),l}$remoteSocketWrite(k,l){this.d.get(k)?.actual.send(l.buffer)}$remoteSocketEnd(k){const l=this.d.get(k);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$qhc=m,e.$qhc=m=Je([qe(0,A.$AN)],m);class f{constructor(k,l){this.socketFactoryId=k,this.makeConnection=l}}class D extends I.$Tc{constructor(k,l,$){super(),this.socketId=k,this.actual=l,this.B($)}}}),define(Ae[231],Me([1,0,3,14,25]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;function A(m){return m&&m.title}let R=class{constructor(f,D){this.b=D,this.a=f.getProxy(S.$oL.MainThreadMessageService)}showMessage(f,D,L,k,l){const $={source:{identifier:f.identifier,label:f.displayName||f.name}};let w;typeof k=="string"||A(k)?w=[k,...l]:($.modal=k?.modal,$.useCustom=k?.useCustom,$.detail=k?.detail,w=l),$.useCustom&&(0,I.$LF)(f,"resolvers");const r=[];let c=!1;for(let s=0;s<w.length;s++){const i=w[s];if(typeof i=="string")r.push({title:i,handle:s,isCloseAffordance:!1});else if(typeof i=="object"){const{title:o,isCloseAffordance:a}=i;r.push({title:o,isCloseAffordance:!!a,handle:s}),a&&(c?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,i):c=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,i)}return this.a.$showMessage(D,L,$,r).then(s=>{if(typeof s=="number")return w[s]})}};e.$3hc=R,e.$3hc=R=Je([qe(1,M.$pj)],R)}),define(Ae[232],Me([1,0,6,16,2,25,3]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;class m{constructor(D){this.b=new Map,this.a=D.getProxy(R.$oL.MainThreadProfileContentHandlers)}registerProfileContentHandler(D,L,k){if((0,A.$LF)(D,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,k),this.a.$registerProfileContentHandler(L,k.name,k.description,D.identifier.value),(0,S.$Rc)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(D,L,k,l){const $=this.b.get(D);if(!$)throw new Error(`Unknown handler with id: ${D}`);return $.saveProfile(L,k,l)}async $readProfile(D,L,k){const l=this.b.get(D);if(!l)throw new Error(`Unknown handler with id: ${D}`);return l.readProfile((0,M.$Jf)(L)?L:I.URI.revive(L),k)}}e.$_hc=m}),define(Ae[81],Me([1,0,3,5,4]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=e.$khc=void 0;class A{constructor(m){this.b=new M.$Wd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(S.$oL.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,f){return this.a.$getPassword(m,f)}store(m,f,D){return this.a.$setPassword(m,f,D)}delete(m,f){return this.a.$deletePassword(m,f)}}e.$khc=A,e.$lhc=(0,I.$8h)("IExtHostSecretState")}),define(Ae[233],Me([1,0,21,6,3]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=void 0;class A{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(I.$oL.MainThreadSpeech)}async $createSpeechToTextSession(m,f){const D=this.c.get(m);if(!D)return;const L=new M.$Sc,k=new S.$7d;this.d.set(f,k);const l=L.add(D.provideSpeechToTextSession(k.token));L.add(l.onDidChange($=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,$)})),L.add(k.token.onCancellationRequested(()=>L.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,f){const D=this.c.get(m);if(!D)return;const L=new M.$Sc,k=new S.$7d;this.d.set(f,k);const l=L.add(D.provideKeywordRecognitionSession(k.token));L.add(l.onDidChange($=>{k.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(f,$)})),L.add(k.token.onCancellationRequested(()=>L.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,f,D){const L=A.a++;return this.c.set(L,D),this.b.$registerProvider(L,f,{extension:m,displayName:m.value}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(L),this.c.delete(L)})}}e.$gic=A}),define(Ae[82],Me([1,0,3,5,4]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=void 0;class A{constructor(m,f){this.c=f,this.b=new M.$Wd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(S.$oL.MainThreadStorage)}registerExtensionStorageKeysToSync(m,f){this.a.$registerExtensionStorageKeysToSync(m,f)}async initializeExtensionStorage(m,f,D){const L=await this.a.$initializeExtensionStorage(m,f);let k;return L&&(k=this.d(m,f,L)),k||D}setValue(m,f,D){return this.a.$setValue(m,f,D)}$acceptValue(m,f,D){const L=this.d(m,f,D);L&&this.b.fire({shared:m,key:f,value:L})}d(m,f,D){try{return JSON.parse(D)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${m}): ${L}`)}}}e.$chc=A,e.$dhc=(0,I.$8h)("IExtHostStorage")}),define(Ae[234],Me([1,0,6,12,2,3]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=void 0;class R{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(f){this.c=new Map,this.b=f.getProxy(A.$oL.MainThreadUriOpeners)}registerExternalUriOpener(f,D,L,k){if(this.c.has(D))throw new Error(`Opener with id '${D}' already registered`);const l=k.schemes.find($=>!R.a.has($));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(D,L),this.b.$registerUriOpener(D,k.schemes,f,k.label),(0,S.$Rc)(()=>{this.c.delete(D),this.b.$unregisterUriOpener(D)})}async $canOpenUri(f,D,L){const k=this.c.get(f);if(!k)throw new Error(`Unknown opener with id: ${f}`);const l=I.URI.revive(D);return k.canOpenExternalUri(l,L)}async $openUri(f,D,L){const k=this.c.get(f);if(!k)throw new Error(`Unknown opener id: '${f}'`);return k.openExternalUri(I.URI.revive(D.resolvedUri),{sourceUri:I.URI.revive(D.sourceUri)},L)}}e.$uic=R}),define(Ae[235],Me([1,0,3,2,6,15,22]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0;class m{static{this.a=0}constructor(D){this.c=new R.$om,this.d=new Map,this.b=D.getProxy(S.$oL.MainThreadUrls)}registerUriHandler(D,L){const k=D.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const l=m.a++;return this.c.add(k),this.d.set(l,L),this.b.$registerUriHandler(l,k,D.displayName||D.name),(0,I.$Rc)(()=>{this.c.delete(k),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(D,L){const k=this.d.get(D);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(L))}catch(l){(0,A.$1)(l)}return Promise.resolve(void 0)}async createAppUri(D){return M.URI.revive(await this.b.$createAppUri(D))}}e.$vic=m}),define(Ae[61],Me([1,0,5,6,12,26,2,183,205,76,3]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=e.$2gc=e.$1gc=e.$Zgc=void 0;class k{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,u,t,d,n,b,E){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$Wd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$Wd,this._onDidDispose=this.#h.event,this.#e=a,this.#t=u,this.#o=t,this.#n=d,this.#s=n,this.#r=b,this.#l=l(b),this.#d=$(b),this.#i=E}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,D.$Gwb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===I.Schemas.https||a.scheme===I.Schemas.http){let u=a.toString();return u.endsWith("/")||(u+="/"),u+" "+D.$Fwb}return D.$Fwb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),A.$Cn(this.#o,a)||this.#t.$setOptions(this.#e,c(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const u=(0,f.$Xlb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const u=this.#r.extensionLocation?.scheme===I.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,n,b,E,h,v)=>{const P=R.URI.from({scheme:E||"file",path:decodeURIComponent(h)}),g=(0,D.$Gwb)(P,{isRemote:u,authority:t}).toString();return`${n}${g}${v}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,n,b,E,h,v)=>{const P=R.URI.from({scheme:E||"file",path:decodeURIComponent(h)}),g=(0,D.$Gwb)(P,{isRemote:u,authority:t}).toString();return`${n}${g}${v}`})}}e.$Zgc=k;function l(o){try{const a=(0,m.$ep)((0,m.$dp)(o.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}e.$1gc=l;function $(o){try{const a=(0,m.$ep)((0,m.$dp)(o.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class w extends M.$Tc{constructor(a,u,t,d,n){super(),this.c=u,this.f=t,this.g=d,this.h=n,this.b=new Map,this.a=a.getProxy(L.$oL.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,u,t){const d=this.j(a);if(d){const{message:n}=(0,f.$Ylb)(u,t.value);d._onMessageEmitter.fire(n)}}$onMissingCsp(a,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,u,t){const d=new k(a,this.a,s(u),this.c,this.f,t,this.h);this.b.set(a,d);const n=d._onDidDispose(()=>{n.dispose(),this.deleteWebview(a)});return d}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$2gc=w;function r(o){return{id:o.identifier,location:o.extensionLocation}}e.$3gc=r;function c(o,a,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||i(o,a)}}e.$4gc=c;function s(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(a=>R.URI.from(a))}}function i(o,a){return[...(a?.getWorkspaceFolders()||[]).map(u=>u.uri),o.extensionLocation]}}),define(Ae[107],Me([1,0,5,3,2,12,13,4,17,25]),function(fe,e,S,M,I,A,R,m,f,D){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=e.$xic=void 0;let k=class{static{L=this}static{this.a={focused:!0,active:!0}}getState($){const w=this.d;return{get focused(){return w.focused},get active(){return(0,D.$LF)($,"windowActivity"),w.active}}}constructor($){this.c=new S.$Wd,this.onDidChangeWindowState=this.c.event,this.d=L.a,this.b=$.getProxy(M.$oL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:w,isActive:r})=>{this.onDidChangeWindowProperty("focused",w),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus($){this.onDidChangeWindowProperty("focused",$)}$onDidChangeWindowActive($){this.onDidChangeWindowProperty("active",$)}onDidChangeWindowProperty($,w){w!==this.d[$]&&(this.d={...this.d,[$]:w},this.c.fire(this.d))}openUri($,w){let r;if(typeof $=="string"){r=$;try{$=I.URI.parse($)}catch{return Promise.reject(`Invalid uri - '${$}'`)}}return(0,R.$Ke)($.scheme)?Promise.reject("Invalid scheme - cannot be empty"):$.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${$.scheme}'`):this.b.$openUri($,r,w)}async asExternalUri($,w){if((0,R.$Ke)($.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri($,w);return I.URI.from(r)}};e.$xic=k,e.$xic=k=L=Je([qe(0,f.$AN)],k),e.$yic=(0,m.$8h)("IExtHostWindow")}),define(Ae[236],Me([1,0,227,27,17]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=void 0;let A=class extends S.$Bic{constructor(m,f){super(m,f)}f(m,f,D){f.apply(console,D)}};e.$Kkc=A,e.$Kkc=A=Je([qe(0,I.$AN),qe(1,M.$QN)],A)}),define(Ae[237],Me([1,0,11,23,21,15,5,6,140,224,50]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=e.ResponsiveState=e.RequestInitiator=e.$D8b=e.$C8b=void 0;function l(y,T){try{return JSON.stringify(y,T)}catch{return"null"}}const $="$$ref$$",w={[$]:-1};class r{constructor(T,N){this.jsonString=T,this.referencedBuffers=N}}function c(y,T=null,N=!1){const J=[];return{jsonString:(N?l:JSON.stringify)(y,(U,C)=>{if(typeof C>"u")return w;if(typeof C=="object"){if(C instanceof M.$ke){const F=J.push(C)-1;return{[$]:F}}if(T)return T(U,C)}return C}),referencedBuffers:J}}e.$C8b=c;function s(y,T,N){return JSON.parse(y,(J,q)=>{if(q){const U=q[$];if(typeof U=="number")return T[U];if(N&&q.$mid===1)return N.transformIncoming(q)}return q})}e.$D8b=s;function i(y,T){return JSON.stringify(y,T)}function o(y){return y?(T,N)=>N&&N.$mid===1?y.transformOutgoing(N):N:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var u;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},d=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class b extends m.$Tc{static{k=d}static{this.a=3*1e3}constructor(T,N=null,J=null){super(),this[k]=!0,this.b=this.B(new R.$Wd),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=N,this.g=J,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let q=0,U=L.$Sv.count;q<U;q++)this.m[q]=null,this.s[q]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$hh(()=>this.H(),1e3)),this.c.onMessage(q=>this.L(q))}dispose(){this.j=!0,Object.keys(this.w).forEach(T=>{const N=this.w[T];delete this.w[T],N.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(T){this.z===0&&(this.C=Date.now()+b.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(T){this.C=Date.now()+b.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(T){this.y!==T&&(this.y=T,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(T){return this.g?(0,f.$0m)(T,this.g):T}getProxy(T){const{nid:N,sid:J}=T;return this.s[N]||(this.s[N]=this.J(N,J)),this.s[N]}J(T,N){const J={get:(q,U)=>(typeof U=="string"&&!q[U]&&U.charCodeAt(0)===36&&(q[U]=(...C)=>this.U(T,U,C)),U===n?N:q[U])};return new Proxy(Object.create(null),J)}set(T,N){return this.m[T.nid]=N,N}assertRegistered(T){for(let N=0,J=T.length;N<J;N++){const q=T[N];if(!this.m[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}L(T){if(this.j)return;const N=T.byteLength,J=h.read(T,0),q=J.readUInt8(),U=J.readUInt32();switch(q){case 1:case 2:{let{rpcId:C,method:F,args:W}=P.deserializeRequestJSONArgs(J);this.g&&(W=(0,f.$0m)(W,this.g)),this.M(N,U,C,F,W,q===2);break}case 3:case 4:{let{rpcId:C,method:F,args:W}=P.deserializeRequestMixedArgs(J);this.g&&(W=(0,f.$0m)(W,this.g)),this.M(N,U,C,F,W,q===4);break}case 5:{this.f?.logIncoming(N,U,0,"ack"),this.G(U);break}case 6:{this.N(N,U);break}case 7:{this.O(N,U,void 0);break}case 9:{let C=P.deserializeReplyOKJSON(J);this.g&&(C=(0,f.$0m)(C,this.g)),this.O(N,U,C);break}case 10:{const C=P.deserializeReplyOKJSONWithBuffers(J,this.g);this.O(N,U,C);break}case 8:{const C=P.deserializeReplyOKVSBuffer(J);this.O(N,U,C);break}case 11:{let C=P.deserializeReplyErrError(J);this.g&&(C=(0,f.$0m)(C,this.g)),this.P(N,U,C);break}case 12:{this.P(N,U,void 0);break}default:console.error("received unexpected message"),console.error(T)}}M(T,N,J,q,U,C){this.f?.logIncoming(T,N,1,`receiveRequest ${(0,L.$Uv)(J)}.${q}(`,U);const F=String(N);let W,re;if(C){const we=new I.$7d;U.push(we.token),W=this.Q(J,q,U),re=()=>we.cancel()}else W=this.Q(J,q,U),re=t;this.u[F]=re;const ce=P.serializeAcknowledged(N);this.f?.logOutgoing(ce.byteLength,N,1,"ack"),this.c.send(ce),W.then(we=>{delete this.u[F];const De=P.serializeReplyOK(N,we,this.h);this.f?.logOutgoing(De.byteLength,N,1,"reply:",we),this.c.send(De)},we=>{delete this.u[F];const De=P.serializeReplyErr(N,we);this.f?.logOutgoing(De.byteLength,N,1,"replyErr:",we),this.c.send(De)})}N(T,N){this.f?.logIncoming(T,N,1,"receiveCancel");const J=String(N);this.u[J]?.()}O(T,N,J){this.f?.logIncoming(T,N,0,"receiveReply:",J);const q=String(N);if(!this.w.hasOwnProperty(q))return;const U=this.w[q];delete this.w[q],U.resolveOk(J)}P(T,N,J){this.f?.logIncoming(T,N,0,"receiveReplyErr:",J);const q=String(N);if(!this.w.hasOwnProperty(q))return;const U=this.w[q];delete this.w[q];let C;J&&(J.$isError?(C=new Error,C.name=J.name,C.message=J.message,C.stack=J.stack):C=J),U.resolveErr(C)}Q(T,N,J){try{return Promise.resolve(this.S(T,N,J))}catch(q){return Promise.reject(q)}}S(T,N,J){const q=this.m[T];if(!q)throw new Error("Unknown actor "+(0,L.$Uv)(T));const U=q[N];if(typeof U!="function")throw new Error("Unknown method "+N+" on actor "+(0,L.$Uv)(T));return U.apply(q,J)}U(T,N,J){if(this.j)return new D.$B8b;let q=null;if(J.length>0&&I.CancellationToken.isCancellationToken(J[J.length-1])&&(q=J.pop()),q&&q.isCancellationRequested)return Promise.reject(A.$6());const U=P.serializeRequestArguments(J,this.h),C=++this.t,F=String(C),W=new D.$A8b,re=new m.$Sc;q&&re.add(q.onCancellationRequested(()=>{const we=P.serializeCancel(C);this.f?.logOutgoing(we.byteLength,C,0,"cancel"),this.c.send(P.serializeCancel(C))})),this.w[F]=new E(W,re),this.F(C);const ce=P.serializeRequest(C,T,N,U,!!q);return this.f?.logOutgoing(ce.byteLength,C,0,`request: ${(0,L.$Uv)(T)}.${N}(`,J),this.c.send(ce),W}}e.$E8b=b;class E{constructor(T,N){this.a=T,this.b=N}resolveOk(T){this.a.resolveOk(T),this.b.dispose()}resolveErr(T){this.a.resolveErr(T),this.b.dispose()}}class h{static alloc(T,N,J){const q=new h(M.$ke.alloc(J+1+4),0);return q.writeUInt8(T),q.writeUInt32(N),q}static read(T,N){return new h(T,N)}get buffer(){return this.a}constructor(T,N){this.a=T,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const J=this.a.slice(this.b,this.b+T).toString();return this.b+=T,J}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const J=this.a.slice(this.b,this.b+T).toString();return this.b+=T,J}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+T);return this.b+=T,N}static sizeMixedArray(T){let N=0;N+=1;for(let J=0,q=T.length;J<q;J++){const U=T[J];switch(N+=1,U.type){case 1:N+=this.sizeLongString(U.value);break;case 2:N+=this.sizeVSBuffer(U.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(U.value);for(let C=0;C<U.buffers.length;++C)N+=this.sizeVSBuffer(U.buffers[C]);break;case 4:break}}return N}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let N=0,J=T.length;N<J;N++){const q=T[N];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let U=0;U<q.buffers.length;++U)this.writeBuffer(q.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const N=new Array(T);for(let J=0;J<T;J++)switch(this.readUInt8()){case 1:N[J]=this.readLongString();break;case 2:N[J]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),C=this.readLongString(),F=[];for(let W=0;W<U;++W)F.push(this.readVSBuffer());N[J]=new L.$Vv(s(C,F,null));break}case 4:N[J]=void 0;break}return N}}var v;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(v||(v={}));class P{static a(T){for(let N=0,J=T.length;N<J;N++)if(T[N]instanceof M.$ke||T[N]instanceof L.$Vv||typeof T[N]>"u")return!0;return!1}static serializeRequestArguments(T,N){if(this.a(T)){const J=[];for(let q=0,U=T.length;q<U;q++){const C=T[q];if(C instanceof M.$ke)J[q]={type:2,value:C};else if(typeof C>"u")J[q]={type:4};else if(C instanceof L.$Vv){const{jsonString:F,referencedBuffers:W}=c(C.value,N);J[q]={type:3,value:M.$ke.fromString(F),buffers:W}}else J[q]={type:1,value:M.$ke.fromString(i(C,N))}}return{type:1,args:J}}return{type:0,args:i(T,N)}}static serializeRequest(T,N,J,q,U){switch(q.type){case 0:return this.b(T,N,J,q.args,U);case 1:return this.c(T,N,J,q.args,U)}}static b(T,N,J,q,U){const C=M.$ke.fromString(J),F=M.$ke.fromString(q);let W=0;W+=h.sizeUInt8(),W+=h.sizeShortString(C),W+=h.sizeLongString(F);const re=h.alloc(U?2:1,T,W);return re.writeUInt8(N),re.writeShortString(C),re.writeLongString(F),re.buffer}static deserializeRequestJSONArgs(T){const N=T.readUInt8(),J=T.readShortString(),q=T.readLongString();return{rpcId:N,method:J,args:JSON.parse(q)}}static c(T,N,J,q,U){const C=M.$ke.fromString(J);let F=0;F+=h.sizeUInt8(),F+=h.sizeShortString(C),F+=h.sizeMixedArray(q);const W=h.alloc(U?4:3,T,F);return W.writeUInt8(N),W.writeShortString(C),W.writeMixedArray(q),W.buffer}static deserializeRequestMixedArgs(T){const N=T.readUInt8(),J=T.readShortString(),q=T.readMixedArray(),U=new Array(q.length);for(let C=0,F=q.length;C<F;C++){const W=q[C];typeof W=="string"?U[C]=JSON.parse(W):U[C]=W}return{rpcId:N,method:J,args:U}}static serializeAcknowledged(T){return h.alloc(5,T,0).buffer}static serializeCancel(T){return h.alloc(6,T,0).buffer}static serializeReplyOK(T,N,J){if(typeof N>"u")return this.d(T);if(N instanceof M.$ke)return this.e(T,N);if(N instanceof L.$Vv){const{jsonString:q,referencedBuffers:U}=c(N.value,J,!0);return this.g(T,q,U)}else return this.f(T,l(N,J))}static d(T){return h.alloc(7,T,0).buffer}static e(T,N){let J=0;J+=h.sizeVSBuffer(N);const q=h.alloc(8,T,J);return q.writeVSBuffer(N),q.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,N){const J=M.$ke.fromString(N);let q=0;q+=h.sizeLongString(J);const U=h.alloc(9,T,q);return U.writeLongString(J),U.buffer}static g(T,N,J){const q=M.$ke.fromString(N);let U=0;U+=h.sizeUInt32,U+=h.sizeLongString(q);for(const F of J)U+=h.sizeVSBuffer(F);const C=h.alloc(10,T,U);C.writeUInt32(J.length),C.writeLongString(q);for(const F of J)C.writeBuffer(F);return C.buffer}static deserializeReplyOKJSON(T){const N=T.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(T,N){const J=T.readUInt32(),q=T.readLongString(),U=[];for(let C=0;C<J;++C)U.push(T.readVSBuffer());return new L.$Vv(s(q,U,N))}static serializeReplyErr(T,N){const J=N?l(A.$3(N),null):void 0;if(typeof J!="string")return this.h(T);const q=M.$ke.fromString(J);let U=0;U+=h.sizeLongString(q);const C=h.alloc(11,T,U);return C.writeLongString(q),C.buffer}static deserializeReplyErrError(T){const N=T.readLongString();return JSON.parse(N)}static h(T){return h.alloc(12,T,0).buffer}}var g;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var p;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(p||(p={}))}),define(Ae[238],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;const S=function(A){const R=m=>{globalThis.removeEventListener("message",R);const f=m.data;Object.defineProperties(globalThis,{postMessage:{value(D,L){f.postMessage(D,L)}},onmessage:{get(){return f.onmessage},set(D){f.onmessage=D}}}),f.addEventListener("message",D=>{globalThis.dispatchEvent(new MessageEvent("message",{data:D.data,ports:D.ports?[...D.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};globalThis.addEventListener("message",R)}.toString();class M extends EventTarget{constructor(A,R,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${S})('${R}'))`,D=new Blob([f],{type:"application/javascript"}),L=URL.createObjectURL(D),k=new MessageChannel,l=L,$={type:"_newWorker",id:l,port:k.port2,url:L,options:m};A($,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{A({type:"_terminateWorker",id:l}),URL.revokeObjectURL(L),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(w){k.port1.onmessage=w}},onmessageerror:{get(){return k.port1.onmessageerror},set(w){k.port1.onmessageerror=w}}}),k.port1.addEventListener("messageerror",w=>{const r=new MessageEvent("messageerror",{data:w.data});this.dispatchEvent(r)}),k.port1.addEventListener("message",w=>{const r=new MessageEvent("message",{data:w.data});this.dispatchEvent(r)}),k.port1.start()}}e.$Mkc=M}),define(Ae[239],Me([1,0,23,28,12,53,4]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.$_I=e.$$I=e.$0I=void 0,e.$0I=(0,R.$8h)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${m.join("")}]+`),D=7;function L($){if($.scheme!==I.Schemas.vscodeNotebookCell)return;const w=$.fragment.indexOf("s");if(w<0)return;const r=parseInt($.fragment.substring(0,w).replace(f,""),D),c=(0,S.$De)($.fragment.substring(w+1)).toString();if(!isNaN(r))return{handle:r,notebook:$.with({scheme:c,fragment:null})}}e.$$I=L;function k($,w){const r=w.toString(D),s=`${r.length<m.length?m[r.length-1]:"z"}${r}s${(0,S.$Ee)(S.$ke.fromString($.scheme),!0,!0)}`;return $.with({scheme:I.Schemas.vscodeNotebookCell,fragment:s})}e.$_I=k;class l{constructor(){this.a=new M.$Ac}getNotebook(w){if(w.scheme===I.Schemas.vscodeNotebookCell){const r=L(w);if(r){const c=this.a.get(r.notebook);if(c)return c}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$aJ=l,(0,A.$1r)(e.$0I,l,1)}),define(Ae[83],Me([1,0,23,34,68,69,12,19,20,35,239]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.CellStatusbarAlignment=e.$oJ=e.$nJ=e.$mJ=e.NotebookEditorPriority=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.CellKind=e.$dJ=e.$cJ=e.$bJ=void 0,e.$bJ="workbench.editor.notebook",e.$cJ="workbench.editor.notebookTextDiffEditor",e.$dJ="workbench.editor.interactive";var k;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(k||(e.CellKind=k={})),e.$eJ=["application/json","application/javascript","text/html","image/svg+xml",A.$hs.latex,A.$hs.markdown,"image/png","image/jpeg",A.$hs.text],e.$fJ=[A.$hs.latex,A.$hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$hs.text],e.$gJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$hJ="_notAvailable";var l;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var $;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var w;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var r;(function(W){W[W.WithHardKernelDependency=0]="WithHardKernelDependency",W[W.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",W[W.Pure=2]="Pure",W[W.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var c;(function(W){W.Always="always",W.Never="never",W.Optional="optional"})(c||(e.RendererMessagingSpec=c={}));var s;(function(W){W[W.ModelChange=1]="ModelChange",W[W.Move=2]="Move",W[W.ChangeCellLanguage=5]="ChangeCellLanguage",W[W.Initialize=6]="Initialize",W[W.ChangeCellMetadata=7]="ChangeCellMetadata",W[W.Output=8]="Output",W[W.OutputItem=9]="OutputItem",W[W.ChangeCellContent=10]="ChangeCellContent",W[W.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",W[W.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",W[W.ChangeCellMime=13]="ChangeCellMime",W[W.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var i;(function(W){W[W.Handle=0]="Handle",W[W.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var o;(function(W){W[W.Replace=1]="Replace",W[W.Output=2]="Output",W[W.Metadata=3]="Metadata",W[W.CellLanguage=4]="CellLanguage",W[W.DocumentMetadata=5]="DocumentMetadata",W[W.Move=6]="Move",W[W.OutputItems=7]="OutputItems",W[W.PartialMetadata=8]="PartialMetadata",W[W.PartialInternalMetadata=9]="PartialInternalMetadata"})(o||(e.CellEditType=o={}));var a;(function(W){W.scheme=R.Schemas.vscodeNotebookCell;function re(se,$e){return(0,L.$_I)(se,$e)}W.generate=re;function ce(se){return(0,L.$$I)(se)}W.parse=ce;function we(se,$e){return se.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${se.scheme!==R.Schemas.file?se.scheme:""}`})}W.generateCellOutputUri=we;function De(se){if(se.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!$e)return;const te=$e[1]&&$e[1]!==""?$e[1]:void 0,X=$e[2];return{outputId:te,notebook:se.with({scheme:X||R.Schemas.file,fragment:null})}}W.parseCellOutputUri=De;function he(se,$e,te){return W.generate(se,$e).with({scheme:te})}W.generateCellPropertyUri=he;function ve(se,$e){if(se.scheme===$e)return W.parse(se.with({scheme:W.scheme}))}W.parseCellPropertyUri=ve})(a||(e.CellUri=a={}));const u=W=>f.$i?W.replace(/\//g,"\\"):W;class t{constructor(re=[],ce=e.$eJ){this.e=ce,this.d=[...new Set(re)].map(we=>({pattern:we,matches:M.$Oj(u(we))}))}sort(re){const ce=new Map(I.Iterable.map(re,De=>[De,u(De)]));let we=[];for(const{matches:De}of this.d)for(const[he,ve]of ce)if(De(ve)){we.push(he),ce.delete(he);break}return ce.size&&(we=we.concat([...ce.keys()].sort((De,he)=>this.e.indexOf(De)-this.e.indexOf(he)))),we}prioritize(re,ce){const we=this.f(re);if(we===-1){this.d.unshift({pattern:re,matches:M.$Oj(u(re))});return}const De=new Set(ce.map(ve=>this.f(ve,we)));De.delete(-1);const he=Array.from(De).sort();this.d.splice(we+1,0,...he.map(ve=>this.d[ve]));for(let ve=he.length-1;ve>=0;ve--)this.d.splice(he[ve],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,ce=this.d.length){const we=u(re);for(let De=0;De<ce;De++)if(this.d[De].matches(we))return De;return-1}}e.$iJ=t;function d(W,re,ce,we=(De,he)=>De===he){const De=[];function he($e,te,X){if(te===0&&X.length===0)return;const V=De[De.length-1];V&&V.start+V.deleteCount===$e?(V.deleteCount+=te,V.toInsert.push(...X)):De.push({start:$e,deleteCount:te,toInsert:X})}let ve=0,se=0;for(;;){if(ve===W.length){he(ve,0,re.slice(se));break}if(se===re.length){he(ve,W.length-ve,[]);break}const $e=W[ve],te=re[se];if(we($e,te)){ve+=1,se+=1;continue}ce(te)?(he(ve,1,[]),ve+=1):(he(ve,0,[te]),se+=1)}return De}e.$jJ=d,e.$kJ=new D.$mj("notebookEditorCursorAtBoundary","none"),e.$lJ=new D.$mj("notebookEditorCursorAtLineBoundary","none");var n;(function(W){W.default="default",W.option="option"})(n||(e.NotebookEditorPriority=n={}));function b(W){const re=W;return!!((typeof re.include=="string"||M.$Pj(re.include))&&(typeof re.exclude=="string"||M.$Pj(re.exclude)))}e.$mJ=b;function E(W,re,ce){if(Array.isArray(W.viewType)&&W.viewType.indexOf(re)>=0||W.viewType===re)return!0;if(W.filenamePattern){const we=b(W.filenamePattern)?W.filenamePattern.include:W.filenamePattern,De=b(W.filenamePattern)?W.filenamePattern.exclude:void 0;if(M.$Nj(we,(0,m.$nc)(ce.fsPath).toLowerCase()))return!(De&&M.$Nj(De,(0,m.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$nJ=E,e.$oJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var h;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(h||(e.CellStatusbarAlignment=h={}));class v{static{this.d="notebook/"}static create(re){return`${v.d}${re}`}static parse(re){if(re.startsWith(v.d))return re.substring(v.d.length)}}e.$pJ=v;function P(W){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(W)}e.$qJ=P;const g=new TextDecoder;function p(W){const re=[];let ce=!1;for(const ve of W)(re.length===0||ce)&&(re.push(ve),ce=!0);let we=N(re);const De=S.$ke.concat(re.map(ve=>S.$ke.wrap(ve))),he=F(De);return we=we||he.byteLength!==De.byteLength,{data:he,didCompression:we}}e.$rJ=p,e.$sJ="\x1B[A";const y=e.$sJ.split("").map(W=>W.charCodeAt(0)),T=10;function N(W){let re=!1;return W.forEach((ce,we)=>{if(we===0||ce.length<e.$sJ.length)return;const De=W[we-1],he=ce.subarray(0,e.$sJ.length);if(he[0]===y[0]&&he[1]===y[1]&&he[2]===y[2]){const ve=De.lastIndexOf(T);if(ve===-1)return;re=!0,W[we-1]=De.subarray(0,ve),W[we]=ce.subarray(e.$sJ.length)}}),re}function J(W){let re=W;do W=re,re=W.replace(/[^\n]\x08/gm,"");while(re.length<W.length);return W}function q(W){for(W=W.replace(/\r+\n/gm,`
`);W.search(/\r[^$]/g)>-1;){const re=W.match(/^(.*)\r+/m)[1];let ce=W.match(/\r+(.*)$/m)[1];ce=ce+re.slice(ce.length,re.length),W=W.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return W}const U=8,C=13;function F(W){return!W.buffer.includes(U)&&!W.buffer.includes(C)?W:S.$ke.fromString(q(J(g.decode(W.buffer))))}}),define(Ae[7],Me([1,0,18,15,46,28,69,13,16,2,33,22,42,100,83]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w){"use strict";var r,c,s,i,o,a,u,t,d,n,b,E,h,v,P,g,p;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.ChatAgentResultFeedbackKind=e.$iN=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$hN=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.TestRunProfileKind=e.TestResultState=e.$ZM=e.$YM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$XM=e.NotebookVariablesRequestKind=e.$WM=e.$VM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$UM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.ColorThemeKind=e.$OM=e.$NM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$MM=e.$LM=e.DebugConsoleMode=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$FM=e.$EM=e.FileChangeType=e.$DM=e.$CM=e.$BM=e.$AM=e.InlineCompletionTriggerKind=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.ConfigurationTarget=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$dM=e.ViewBadge=e.ProgressLocation=e.$cM=e.$bM=e.TaskScope=e.ShellQuoting=e.$aM=e.$_L=e.$$L=e.TaskPanelKind=e.TaskRevealKind=e.$0L=e.TerminalLocation=e.$9L=e.$8L=e.$7L=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$6L=e.$5L=e.$4L=e.$3L=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$2L=e.StatusBarAlignment=e.ViewColumn=e.$1L=e.$ZL=e.$YL=e.$XL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$WL=e.$VL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.LanguageStatusSeverity=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.CodeActionTriggerKind=e.$JL=e.$IL=e.SymbolTag=e.SymbolKind=e.$HL=e.$GL=e.DocumentHighlightKind=e.$FL=e.$EL=e.$DL=e.$CL=e.DiagnosticSeverity=e.DiagnosticTag=e.$BL=e.$AL=e.FileEditType=e.$zL=e.$yL=e.$xL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function y(B){return Object.assign(B,{apply:function(...ne){if(ne.length===0)return Reflect.construct(B,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(B,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(B,[]);{const[Se,...Ge]=ne;return Reflect.construct(B,Ge,Se.constructor)}}})}var T;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(T||(e.TerminalOutputAnchor=T={}));var N;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let J=r=class{static from(...z){let ne=z;return new r(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$qL=J,e.$qL=J=r=Je([y],J);let q=c=class{static Min(...z){if(z.length===0)throw new TypeError;let ne=z[0];for(let Se=1;Se<z.length;Se++){const Ge=z[Se];Ge.isBefore(ne)&&(ne=Ge)}return ne}static Max(...z){if(z.length===0)throw new TypeError;let ne=z[0];for(let Se=1;Se<z.length;Se++){const Ge=z[Se];Ge.isAfter(ne)&&(ne=Ge)}return ne}static isPosition(z){if(!z)return!1;if(z instanceof c)return!0;const{line:ne,character:Se}=z;return typeof ne=="number"&&typeof Se=="number"}static of(z){if(z instanceof c)return z;if(this.isPosition(z))return new c(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ne){if(z<0)throw(0,M.$7)("line must be non-negative");if(ne<0)throw(0,M.$7)("character must be non-negative");this.c=z,this.e=ne}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ne=0){if(z===null||ne===null)throw(0,M.$7)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,ne=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&ne===0?this:new c(this.line+Se,this.character+ne)}with(z,ne=this.character){if(z===null||ne===null)throw(0,M.$7)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,ne=typeof z.character=="number"?z.character:this.character),Se===this.line&&ne===this.character?this:new c(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$rL=q,e.$rL=q=c=Je([y],q);let U=s=class{static isRange(z){return z instanceof s?!0:z?q.isPosition(z.start)&&q.isPosition(z.end):!1}static of(z){if(z instanceof s)return z;if(this.isRange(z))return new s(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ne,Se,Ge){let xe,ut;if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new q(z,ne),ut=new q(Se,Ge)):q.isPosition(z)&&q.isPosition(ne)&&(xe=q.of(z),ut=q.of(ne)),!xe||!ut)throw new Error("Invalid arguments");xe.isBefore(ut)?(this.c=xe,this.e=ut):(this.c=ut,this.e=xe)}contains(z){return s.isRange(z)?this.contains(z.start)&&this.contains(z.end):q.isPosition(z)?!(q.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ne=q.Max(z.start,this.c),Se=q.Min(z.end,this.e);if(!ne.isAfter(Se))return new s(ne,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ne=q.Min(z.start,this.c),Se=q.Max(z.end,this.end);return new s(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ne=this.end){if(z===null||ne===null)throw(0,M.$7)();let Se;return z?q.isPosition(z)?Se=z:(Se=z.start||this.start,ne=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new s(Se,ne)}toJSON(){return[this.start,this.end]}};e.$sL=U,e.$sL=U=s=Je([y],U);let C=i=class extends U{static isSelection(z){return z instanceof i?!0:z?U.isRange(z)&&q.isPosition(z.anchor)&&q.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ne,Se,Ge){let xe,ut;if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new q(z,ne),ut=new q(Se,Ge)):q.isPosition(z)&&q.isPosition(ne)&&(xe=q.of(z),ut=q.of(ne)),!xe||!ut)throw new Error("Invalid arguments");super(xe,ut),this.f=xe,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$tL=C,e.$tL=C=i=Je([y],C);const F=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,M.$7)("connectionToken")};class W{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ne,Se){if(typeof z!="string"||z.length===0)throw(0,M.$7)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,M.$7)("port");typeof Se<"u"&&F(Se),this.host=z,this.port=Math.round(ne),this.connectionToken=Se}}e.$uL=W;class re{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ne){this.makeConnection=z,this.connectionToken=ne,typeof ne<"u"&&F(ne)}}e.$vL=re;class ce extends Error{static NotAvailable(z,ne){return new ce(z,$.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(z){return new ce(z,$.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ne=$.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,ce.prototype)}}e.$wL=ce;var we;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(we||(e.EndOfLine=we={}));var De;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(De||(e.EnvironmentVariableMutatorType=De={}));let he=o=class{static isTextEdit(z){return z instanceof o?!0:z?U.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ne){return new o(z,ne)}static insert(z,ne){return o.replace(new U(z,z),ne)}static delete(z){return o.replace(z,"")}static setEndOfLine(z){const ne=new o(new U(new q(0,0),new q(0,0)),"");return ne.newEol=z,ne}get range(){return this.c}set range(z){if(z&&!U.isRange(z))throw(0,M.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,M.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,M.$7)("newEol");this.f=z}constructor(z,ne){this.c=z,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$xL=he,e.$xL=he=o=Je([y],he);let ve=a=class{static isNotebookCellEdit(z){return z instanceof a?!0:z?hi.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ne){return new a(z,ne)}static insertCells(z,ne){return new a(new hi(z,z),ne)}static deleteCells(z){return new a(z,[])}static updateCellMetadata(z,ne){const Se=new a(new hi(z,z),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(z){const ne=new a(new hi(0,0),[]);return ne.newNotebookMetadata=z,ne}constructor(z,ne){this.range=z,this.newCells=ne}};e.$yL=ve,e.$yL=ve=a=Je([y],ve);class se{static isSnippetTextEdit(z){return z instanceof se?!0:z?U.isRange(z.range)&&X.isSnippetString(z.snippet):!1}static replace(z,ne){return new se(z,ne)}static insert(z,ne){return se.replace(new U(z,z),ne)}constructor(z,ne){this.range=z,this.snippet=ne}}e.$zL=se;var $e;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let te=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ne,Se,Ge){this.c.push({_type:1,from:z,to:ne,options:Se,metadata:Ge})}createFile(z,ne,Se){this.c.push({_type:1,from:void 0,to:z,options:ne,metadata:Se})}deleteFile(z,ne,Se){this.c.push({_type:1,from:z,to:void 0,options:ne,metadata:Se})}e(z,ne,Se){this.c.push({_type:3,metadata:Se,uri:z,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(z,ne,Se,Ge){const xe=ne.start,ut=ne.end;(xe!==ut||Se.length>0)&&this.c.push({_type:5,uri:z,index:xe,count:ut-xe,cells:Se,metadata:Ge})}g(z,ne,Se,Ge){this.c.push({_type:3,metadata:Ge,uri:z,edit:{editType:3,index:ne,metadata:Se}})}replace(z,ne,Se,Ge){this.c.push({_type:2,uri:z,edit:new he(ne,Se),metadata:Ge})}insert(z,ne,Se,Ge){this.replace(z,new U(ne,ne),Se,Ge)}delete(z,ne,Se){this.replace(z,ne,"",Se)}has(z){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===z.toString())}set(z,ne){if(ne)for(const Se of ne){if(!Se)continue;let Ge,xe;Array.isArray(Se)?(Ge=Se[0],xe=Se[1]):Ge=Se,ve.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(z,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(z,Ge.newNotebookMetadata,xe):this.f(z,Ge.range,Ge.newCells,xe):se.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:z,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:z,edit:Ge,metadata:xe})}else{for(let Se=0;Se<this.c.length;Se++){const Ge=this.c[Se];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,S.$Ib)(this.c)}}get(z){const ne=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===z.toString()&&ne.push(Se.edit);return ne}entries(){const z=new A.$Ac;for(const ne of this.c)if(ne._type===2){let Se=z.get(ne.uri);Se||(Se=[ne.uri,[]],z.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$AL=te,e.$AL=te=Je([y],te);let X=u=class{static isSnippetString(z){return z instanceof u?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=u.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ne=this.e++){if(typeof z=="function"){const Se=new u;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=u.c(z);return this.value+="${",this.value+=ne,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ne=this.e++){const Se=z.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,ne){if(typeof ne=="function"){const Se=new u;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$BL=X,e.$BL=X=u=Je([y],X);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ie;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let Ce=t=class{static isLocation(z){return z instanceof t?!0:z?U.isRange(z.range)&&D.URI.isUri(z.uri):!1}constructor(z,ne){if(this.uri=z,ne)if(U.isRange(ne))this.range=U.of(ne);else if(q.isPosition(ne))this.range=new U(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$CL=Ce,e.$CL=Ce=t=Je([y],Ce);let Te=class{static is(z){return z?typeof z.message=="string"&&z.location&&U.isRange(z.location.range)&&D.URI.isUri(z.location.uri):!1}constructor(z,ne){this.location=z,this.message=ne}static isEqual(z,ne){return z===ne?!0:!z||!ne?!1:z.message===ne.message&&z.location.range.isEqual(ne.location.range)&&z.location.uri.toString()===ne.location.uri.toString()}};e.$DL=Te,e.$DL=Te=Je([y],Te);let Pe=class{constructor(z,ne,Se=ie.Error){if(!U.isRange(z))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=z,this.message=ne,this.severity=Se}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ne){return z===ne?!0:!z||!ne?!1:z.message===ne.message&&z.severity===ne.severity&&z.code===ne.code&&z.severity===ne.severity&&z.source===ne.source&&z.range.isEqual(ne.range)&&(0,S.$ub)(z.tags,ne.tags)&&(0,S.$ub)(z.relatedInformation,ne.relatedInformation,Te.isEqual)}};e.$EL=Pe,e.$EL=Pe=Je([y],Pe);let be=class{constructor(z,ne){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ne}};e.$FL=be,e.$FL=be=Je([y],be);var me;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(me||(e.DocumentHighlightKind=me={}));let G=class{constructor(z,ne=me.Text){this.range=z,this.kind=ne}toJSON(){return{range:this.range,kind:me[this.kind]}}};e.$GL=G,e.$GL=G=Je([y],G);let _=class{constructor(z,ne){this.uri=z,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$HL=_,e.$HL=_=Je([y],_);var le;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Le=d=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ne,Se,Ge,xe){this.name=z,this.kind=ne,this.containerName=xe,typeof Se=="string"&&(this.containerName=Se),Ge instanceof Ce?this.location=Ge:Se instanceof U&&(this.location=new Ce(Ge,Se)),d.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$IL=Le,e.$IL=Le=d=Je([y],Le);let ge=n=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(n.validate)}constructor(z,ne,Se,Ge,xe){this.name=z,this.detail=ne,this.kind=Se,this.range=Ge,this.selectionRange=xe,this.children=[],n.validate(this)}};e.$JL=ge,e.$JL=ge=n=Je([y],ge);var ke;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(ke||(e.CodeActionTriggerKind=ke={}));let Ie=class{constructor(z,ne){this.title=z,this.kind=ne}};e.$KL=Ie,e.$KL=Ie=Je([y],Ie);let O=class{static{b=this}static{this.c="."}constructor(z){this.value=z}append(z){return new b(this.value?this.value+b.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+b.c)}};e.$LL=O,e.$LL=O=b=Je([y],O),O.Empty=new O(""),O.QuickFix=O.Empty.append("quickfix"),O.Refactor=O.Empty.append("refactor"),O.RefactorExtract=O.Refactor.append("extract"),O.RefactorInline=O.Refactor.append("inline"),O.RefactorMove=O.Refactor.append("move"),O.RefactorRewrite=O.Refactor.append("rewrite"),O.Source=O.Empty.append("source"),O.SourceOrganizeImports=O.Source.append("organizeImports"),O.SourceFixAll=O.Source.append("fixAll"),O.Notebook=O.Empty.append("notebook");let K=class{constructor(z,ne){if(this.range=z,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$ML=K,e.$ML=K=Je([y],K);class j{constructor(z,ne,Se,Ge,xe,ut){this.kind=z,this.name=ne,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$NL=j;class H{constructor(z,ne){this.fromRanges=ne,this.from=z}}e.$OL=H;class Q{constructor(z,ne){this.fromRanges=ne,this.to=z}}e.$PL=Q;var oe;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(oe||(e.LanguageStatusSeverity=oe={}));let Ee=class{constructor(z,ne){this.range=z,this.command=ne}get isResolved(){return!!this.command}};e.$QL=Ee,e.$QL=Ee=Je([y],Ee);let Be=E=class{#e;static isMarkdownString(z){return z instanceof E?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ne=!1){this.#e=new I.$jk(z,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,ne){return this.#e.appendCodeblock(ne??"",z),this}};e.$RL=Be,e.$RL=Be=E=Je([y],Be);let We=class{constructor(z,ne){this.label=z,this.documentation=ne}};e.$SL=We,e.$SL=We=Je([y],We);let Ze=class{constructor(z,ne){this.label=z,this.documentation=ne,this.parameters=[]}};e.$TL=Ze,e.$TL=Ze=Je([y],Ze);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$UL=_e,e.$UL=_e=Je([y],_e);var at;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(at||(e.SignatureHelpTriggerKind=at={}));var rt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let et=class{constructor(z){this.value=z}};e.$VL=et,e.$VL=et=Je([y],et);let ct=class{constructor(z,ne,Se){this.position=z,this.label=ne,this.kind=Se}};e.$WL=ct,e.$WL=ct=Je([y],ct);var Ue;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var vt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(vt||(e.CompletionItemKind=vt={}));var Z;(function(B){B[B.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let x=class{constructor(z,ne){this.label=z,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&vt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$XL=x,e.$XL=x=Je([y],x);let pe=class{constructor(z=[],ne=!1){this.items=z,this.isIncomplete=ne}};e.$YL=pe,e.$YL=pe=Je([y],pe);let Ve=class{constructor(z,ne,Se){this.insertText=z,this.range=ne,this.command=Se}};e.$ZL=Ve,e.$ZL=Ve=Je([y],Ve);let Ye=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$1L=Ye,e.$1L=Ye=Je([y],Ye);var it;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var st;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function Ne(B,z){return`${k.$nm.toKey(B)}.${z}`}e.$2L=Ne;var Mt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Mt||(e.TextEditorLineNumbersStyle=Mt={}));var Jt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Jt||(e.TextDocumentSaveReason=Jt={}));var _t;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(_t||(e.TextEditorRevealType=_t={}));var Ut;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var Et;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var ei;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(ei||(e.DecorationRangeBehavior=ei={})),function(B){function z(ne){switch(ne){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var jt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(jt||(e.SyntaxTokenType=jt={})),function(B){function z(ne){switch(ne){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(jt||(e.SyntaxTokenType=jt={}));let ni=class{constructor(z,ne){if(ne&&!D.URI.isUri(ne))throw(0,M.$7)("target");if(!U.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.target=ne}};e.$3L=ni,e.$3L=ni=Je([y],ni);let Yt=class{constructor(z,ne,Se,Ge){this.red=z,this.green=ne,this.blue=Se,this.alpha=Ge}};e.$4L=Yt,e.$4L=Yt=Je([y],Yt);let Qt=class{constructor(z,ne){if(ne&&!(ne instanceof Yt))throw(0,M.$7)("color");if(!U.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.color=ne}};e.$5L=Qt,e.$5L=Qt=Je([y],Qt);let Xe=class{constructor(z){if(!z||typeof z!="string")throw(0,M.$7)("label");this.label=z}};e.$6L=Xe,e.$6L=Xe=Je([y],Xe);var Bt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Bt||(e.ColorFormat=Bt={}));var ti;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(ti||(e.SourceControlInputBoxValidationType=ti={}));var ht;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class mt{constructor(z,ne,Se){if(this.startIndex=z,this.length=ne,this.tooltip=Se,typeof z!="number"||z<0)throw(0,M.$7)("startIndex");if(typeof ne!="number"||ne<1)throw(0,M.$7)("length");if(Se!==void 0&&typeof Se!="string")throw(0,M.$7)("tooltip")}}e.$7L=mt;class Kt{constructor(z){this.uri=z}}e.$8L=Kt;class ii{constructor(z){this.terminalCommand=z}}e.$9L=ii;var Pt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Pt||(e.TerminalLocation=Pt={}));class dt{constructor(z){if(this.options=z,typeof z!="object")throw(0,M.$7)("options")}}e.$0L=dt;var Rt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var oi;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(oi||(e.TaskPanelKind=oi={}));let Lt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(z){switch(z){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(z,ne){if(this.label=ne,typeof z!="string"||typeof ne!="string")throw(0,M.$7)("name");this.c=z}get id(){return this.c}};e.$$L=Lt,e.$$L=Lt=h=Je([y],Lt);function He(B){let z="";for(let ne=0;ne<B.length;ne++)z+=B[ne].replace(/,/g,",,")+",";return z}let Ft=class{constructor(z,ne,Se){if(typeof z!="string")throw(0,M.$7)("process");this.e=[],this.c=z,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,M.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)z.push(ne);return He(z)}};e.$_L=Ft,e.$_L=Ft=Je([y],Ft);let Wt=class{constructor(z,ne,Se){if(this.f=[],Array.isArray(ne)){if(!z)throw(0,M.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z,this.f=ne,this.g=Se}else{if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z,this.g=ne}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)z.push(typeof ne=="string"?ne:ne.value);return He(z)}};e.$aM=Wt,e.$aM=Wt=Je([y],Wt);var Zt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Zt||(e.ShellQuoting=Zt={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Tt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,L.$rg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$bM=Tt;let Ct=class{static{v=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,ne,Se,Ge,xe,ut){this.k=!1,this.l=this.definition=z;let gt;typeof ne=="string"?(this.o=this.name=ne,this.w=this.source=Se,this.execution=Ge,gt=xe,this.k=!0):ne===ft.Global||ne===ft.Workspace?(this.target=ne,this.o=this.name=Se,this.w=this.source=Ge,this.execution=xe,gt=ut):(this.target=ne,this.o=this.name=Se,this.w=this.source=Ge,this.execution=xe,gt=ut),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ft?this.l={type:v.e,id:this.q.computeId()}:this.q instanceof Wt?this.l={type:v.f,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:v.c,id:this.q.computeId()}:this.l={type:v.g,id:(0,L.$rg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,M.$7)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,M.$7)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const ne=this.l.type;(v.g===ne||v.e===ne||v.f===ne||v.c===ne)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,M.$7)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$cM=Ct,e.$cM=Ct=v=Je([y],Ct);var Nt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Nt||(e.ProgressLocation=Nt={}));var Vt;(function(B){function z(ne){const Se=ne;return(0,f.$Nf)(Se.value)?Se.tooltip&&!(0,f.$Jf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}B.isViewBadge=z})(Vt||(e.ViewBadge=Vt={}));let Ot=P=class{static isTreeItem(z,ne){const Se=z;if(Se.checkboxState!==void 0){const Ge=(0,f.$Nf)(Se.checkboxState)?Se.checkboxState:(0,f.$Lf)(Se.checkboxState)&&(0,f.$Nf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,xe=!(0,f.$Nf)(Se.checkboxState)&&(0,f.$Lf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==zt.Checked&&Ge!==zt.Unchecked||xe!==void 0&&!(0,f.$Jf)(xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof P)return!0;if(Se.label!==void 0&&!(0,f.$Jf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,f.$Jf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,f.$Jf)(Se.iconPath)&&!D.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,f.$Jf)(Se.iconPath.id))){const Ge=Se.iconPath;if(!Ge||!(0,f.$Jf)(Ge.light)&&!D.URI.isUri(Ge.light)&&!(0,f.$Jf)(Ge.dark)&&!D.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,f.$Jf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!D.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,f.$Jf)(Se.tooltip)&&!(Se.tooltip instanceof Be)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<St.None&&Se.collapsibleState>St.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,f.$Jf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,ne=St.None){this.collapsibleState=ne,D.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$dM=Ot,e.$dM=Ot=P=Je([y],Ot);var St;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(St||(e.TreeItemCollapsibleState=St={}));var zt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(zt||(e.TreeItemCheckboxState=zt={}));let Dt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$eM=Dt,e.$eM=Dt=Je([y],Dt);class yt extends Dt{}e.$fM=yt;class It extends yt{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$gM=It;class kt{constructor(z,ne,Se,Ge){this.name=z,this.uri=ne,this._itemId=Se,this.c=Ge}data(){return this.c()}}e.$hM=kt;let li=class{#e=new Map;constructor(z){for(const[ne,Se]of z??[]){const Ge=this.#e.get(this.#t(ne));Ge?Ge.push(Se):this.#e.set(this.#t(ne),[Se])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,ne){this.#e.set(this.#t(z),[ne])}forEach(z,ne){for(const[Se,Ge]of this.#e)for(const xe of Ge)z.call(ne,xe,Se,this)}*[Symbol.iterator](){for(const[z,ne]of this.#e)for(const Se of ne)yield[z,Se]}#t(z){return z.toLowerCase()}};e.$iM=li,e.$iM=li=Je([y],li);let Gt=class{constructor(z){this.insertText=z}};e.$jM=Gt,e.$jM=Gt=Je([y],Gt);let ye=class{constructor(z,ne){this.label=ne,this.insertText=z}};e.$kM=ye,e.$kM=ye=Je([y],ye);let Fe=class{constructor(z,ne){this.id=z,this.color=ne}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$lM=Fe,e.$lM=Fe=Je([y],Fe),Fe.File=new Fe("file"),Fe.Folder=new Fe("folder");let ue=class{constructor(z){this.id=z}};e.$mM=ue,e.$mM=ue=Je([y],ue);var Y;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Y||(e.ConfigurationTarget=Y={}));let Re=class{get base(){return this.c}set base(z){this.c=z,this.e=D.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ne){if(typeof z!="string"&&(!z||!D.URI.isUri(z)&&!D.URI.isUri(z.uri)))throw(0,M.$7)("base");if(typeof ne!="string")throw(0,M.$7)("pattern");typeof z=="string"?this.baseUri=D.URI.file(z):D.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$nM=Re,e.$nM=Re=Je([y],Re);const je=new WeakMap;function Qe(B,z){je.set(B,z)}e.$oM=Qe;let Ke=class{constructor(z,ne,Se,Ge){this.enabled=typeof z=="boolean"?z:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=je.get(this)??(0,L.$rg)()),this.c}};e.$pM=Ke,e.$pM=Ke=Je([y],Ke);let nt=class extends Ke{constructor(z,ne,Se,Ge,xe){if(super(ne,Se,Ge,xe),z===null)throw(0,M.$7)("location");this.location=z}};e.$qM=nt,e.$qM=nt=Je([y],nt);let bt=class extends Ke{constructor(z,ne,Se,Ge,xe){super(ne,Se,Ge,xe),this.functionName=z}};e.$rM=bt,e.$rM=bt=Je([y],bt);let qt=class extends Ke{constructor(z,ne,Se,Ge,xe,ut,gt){if(super(Ge,xe,ut,gt),!ne)throw(0,M.$7)("dataId");this.label=z,this.dataId=ne,this.canPersist=Se}};e.$sM=qt,e.$sM=qt=Je([y],qt);let Xt=class{constructor(z,ne,Se){this.command=z,this.args=ne||[],this.options=Se}};e.$tM=Xt,e.$tM=Xt=Je([y],Xt);let pt=class{constructor(z,ne){this.port=z,this.host=ne}};e.$uM=pt,e.$uM=pt=Je([y],pt);let Ht=class{constructor(z){this.path=z}};e.$vM=Ht,e.$vM=Ht=Je([y],Ht);let Ri=class{constructor(z){this.implementation=z}};e.$wM=Ri,e.$wM=Ri=Je([y],Ri);let pi=class{constructor(z,ne,Se){this.session=z,this.threadId=ne,this.frameId=Se}};e.$xM=pi,e.$xM=pi=Je([y],pi);let vi=class{constructor(z,ne){this.session=z,this.threadId=ne}};e.$yM=vi,e.$yM=vi=Je([y],vi);let lt=class{constructor(z,ne){this.range=z,this.expression=ne}};e.$zM=lt,e.$zM=lt=Je([y],lt);var Yi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Yi||(e.InlineCompletionTriggerKind=Yi={}));let ai=class{constructor(z,ne){this.range=z,this.text=ne}};e.$AM=ai,e.$AM=ai=Je([y],ai);let fi=class{constructor(z,ne,Se=!0){this.range=z,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$BM=fi,e.$BM=fi=Je([y],fi);let Ei=class{constructor(z,ne){this.range=z,this.expression=ne}};e.$CM=Ei,e.$CM=Ei=Je([y],Ei);let Li=class{constructor(z,ne){this.frameId=z,this.stoppedLocation=ne}};e.$DM=Li,e.$DM=Li=Je([y],Li);var Qi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ai=g=class extends Error{static FileExists(z){return new g(z,l.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(z){return new g(z,l.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(z){return new g(z,l.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(z){return new g(z,l.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(z){return new g(z,l.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(z){return new g(z,l.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(z,ne=l.FileSystemProviderErrorCode.Unknown,Se){super(D.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,l.$Hk)(this,ne),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$EM=Ai,e.$EM=Ai=g=Je([y],Ai);let Di=class{constructor(z,ne,Se){this.start=z,this.end=ne,this.kind=Se}};e.$FM=Di,e.$FM=Di=Je([y],Di);var Zi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Zi||(e.FoldingRangeKind=Zi={}));var Mi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Mi||(e.CommentThreadCollapsibleState=Mi={}));var gi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(gi||(e.CommentMode=gi={}));var Xi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var ki;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(ki||(e.CommentThreadState=ki={}));class Fi{constructor(z,ne=[]){this.tokenTypes=z,this.tokenModifiers=ne}}e.$GM=Fi;function ln(B){return typeof B>"u"||(0,f.$Kf)(B)}class Ti{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ne=0,Se=z.tokenTypes.length;ne<Se;ne++)this.k.set(z.tokenTypes[ne],ne);for(let ne=0,Se=z.tokenModifiers.length;ne<Se;ne++)this.l.set(z.tokenModifiers[ne],ne)}}push(z,ne,Se,Ge,xe){if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.q(z,ne,Se,Ge,xe);if(U.isRange(z)&&typeof ne=="string"&&ln(Se))return this.o(z,ne,Se);throw(0,M.$7)()}o(z,ne,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ge=z.start.line,xe=z.start.character,ut=z.end.character-z.start.character,gt=this.k.get(ne);let xt=0;if(Se)for(const si of Se){if(!this.l.has(si))throw new Error("`tokenModifier` is not in the provided legend");const ui=this.l.get(si);xt|=1<<ui>>>0}this.q(Ge,xe,ut,gt,xt)}q(z,ne,Se,Ge,xe){if(this.f&&(z<this.c||z===this.c&&ne<this.e)){this.f=!1;const xt=this.g.length/5|0;let si=0,ui=0;for(let di=0;di<xt;di++){let $i=this.g[5*di],Gi=this.g[5*di+1];$i===0?($i=si,Gi+=ui):$i+=si,this.g[5*di]=$i,this.g[5*di+1]=Gi,si=$i,ui=Gi}}let ut=z,gt=ne;this.f&&this.j>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=gt,this.g[this.j++]=Se,this.g[this.j++]=Ge,this.g[this.j++]=xe,this.c=z,this.e=ne}static r(z){const ne=[],Se=z.length/5|0;for(let gt=0;gt<Se;gt++)ne[gt]=gt;ne.sort((gt,xt)=>{const si=z[5*gt],ui=z[5*xt];if(si===ui){const di=z[5*gt+1],$i=z[5*xt+1];return di-$i}return si-ui});const Ge=new Uint32Array(z.length);let xe=0,ut=0;for(let gt=0;gt<Se;gt++){const xt=5*ne[gt],si=z[xt+0],ui=z[xt+1],di=z[xt+2],$i=z[xt+3],Gi=z[xt+4],Cn=si-xe,Gn=Cn===0?ui-ut:ui,Ji=5*gt;Ge[Ji+0]=Cn,Ge[Ji+1]=Gn,Ge[Ji+2]=di,Ge[Ji+3]=$i,Ge[Ji+4]=Gi,xe=si,ut=ui}return Ge}build(z){return this.f?new mi(new Uint32Array(this.g),z):new mi(Ti.r(this.g),z)}}e.$HM=Ti;class mi{constructor(z,ne){this.resultId=ne,this.data=z}}e.$IM=mi;class hn{constructor(z,ne,Se){this.start=z,this.deleteCount=ne,this.data=Se}}e.$JM=hn;class dn{constructor(z,ne){this.resultId=ne,this.edits=z}}e.$KM=dn;var xi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(xi||(e.DebugConsoleMode=xi={}));class yi{constructor(z){this.name=z}}e.$LM=yi;let Ni=class{static{this.Back={iconPath:new Fe("arrow-left")}}constructor(){}};e.$MM=Ni,e.$MM=Ni=Je([y],Ni);var _i;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(_i||(e.QuickPickItemKind=_i={}));var Si;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Si||(e.InputBoxValidationSeverity=Si={}));var Oi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Oi||(e.ExtensionKind=Oi={}));class fn{static validate(z){if(typeof z.badge=="string"){let ne=(0,m.$kf)(z.badge,0);if(ne<z.badge.length&&(ne+=(0,m.$kf)(z.badge,ne)),z.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!Fe.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ne,Se){this.badge=z,this.tooltip=ne,this.color=Se}}e.$NM=fn;let Ii=class{constructor(z){this.kind=z}};e.$OM=Ii,e.$OM=Ii=Je([y],Ii);var zi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(zi||(e.ColorThemeKind=zi={}));class hi{static isNotebookRange(z){return z instanceof hi?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ne){if(z<0)throw(0,M.$7)("start must be positive");if(ne<0)throw(0,M.$7)("end must be positive");z<=ne?(this.c=z,this.e=ne):(this.c=ne,this.e=z)}with(z){let ne=this.c,Se=this.e;return z.start!==void 0&&(ne=z.start),z.end!==void 0&&(Se=z.end),ne===this.c&&Se===this.e?this:new hi(ne,Se)}}e.$PM=hi;class Ci{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ne=>Ci.isNotebookCellData(ne))}static isNotebookCellData(z){return!0}constructor(z,ne,Se,Ge,xe,ut,gt){this.kind=z,this.value=ne,this.languageId=Se,this.mime=Ge,this.outputs=xe??[],this.metadata=ut,this.executionSummary=gt,Ci.validate(this)}}e.$QM=Ci;class gn{constructor(z){this.cells=z}}e.$RM=gn;class ri{static isNotebookCellOutputItem(z){return z instanceof ri?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ne={name:z.name,message:z.message,stack:z.stack};return ri.json(ne,"application/vnd.code.notebook.error")}static stdout(z){return ri.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return ri.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ne="application/octet-stream"){return new ri(z,ne)}static#e=new TextEncoder;static text(z,ne=R.$hs.text){const Se=ri.#e.encode(String(z));return new ri(Se,ne)}static json(z,ne="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return ri.text(Se,ne)}constructor(z,ne){this.data=z,this.mime=ne;const Se=(0,R.$ls)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$SM=ri;class bi{static isNotebookCellOutput(z){return z instanceof bi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ne=!1){const Se=new Set,Ge=new Set;for(let xe=0;xe<z.length;xe++){const ut=z[xe],gt=(0,R.$ls)(ut.mime);if(!Se.has(gt)||(0,w.$qJ)(gt)){Se.add(gt);continue}Ge.add(xe),ne&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ge.size===0?z:z.filter((xe,ut)=>!Ge.has(ut))}constructor(z,ne,Se){this.items=bi.ensureUniqueMimeTypes(z,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,L.$rg)(),this.metadata=ne??Se)}}e.$TM=bi;var Ui;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Ui||(e.NotebookCellKind=Ui={}));var ze;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(ze||(e.NotebookCellExecutionState=ze={}));var ci;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ci||(e.NotebookCellStatusBarAlignment=ci={}));var ji;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ji||(e.NotebookEditorRevealType=ji={}));class tt{constructor(z,ne){this.text=z,this.alignment=ne}}e.$UM=tt;var $t;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})($t||(e.NotebookControllerAffinity=$t={}));var en;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(en||(e.NotebookControllerAffinity2=en={}));class mn{constructor(z,ne=[]){this.uri=z,this.provides=(0,S.$3b)(ne)}}e.$VM=mn;class tn{constructor(z){this.label=z}}e.$WM=tn;var nn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let wi=class{constructor(z,ne){this.label=z,this.timestamp=ne}};e.$XM=wi,e.$XM=wi=Je([y],wi);var rn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class an{constructor(z,ne){this.ranges=z,this.wordPattern=ne}}e.$YM=an;class $n{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$ZM=$n;var cn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Bi=class{constructor(z=void 0,ne=void 0,Se=void 0,Ge=!1){this.include=z,this.exclude=ne,this.profile=Se,this.continuous=Ge}};e.$1M=Bi,e.$1M=Bi=Je([y],Bi);let Wi=p=class{static diff(z,ne,Se){const Ge=new p(z);return Ge.expectedOutput=ne,Ge.actualOutput=Se,Ge}constructor(z){this.message=z}};e.$2M=Wi,e.$2M=Wi=p=Je([y],Wi);let Vi=class{constructor(z){this.id=z}};e.$3M=Vi,e.$3M=Vi=Je([y],Vi);class Pi{constructor(z,ne){this.covered=z,this.total=ne}}e.$4M=Pi;const qi=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class Hi{static fromDetails(z,ne){const Se=new Pi(0,0),Ge=new Pi(0,0),xe=new Pi(0,0);for(const gt of ne)if("branches"in gt){Se.total+=1,Se.covered+=gt.executed?1:0;for(const xt of gt.branches)Ge.total+=1,Ge.covered+=xt.executed?1:0}else xe.total+=1,xe.covered+=gt.executed?1:0;const ut=new Hi(z,Se,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return ut.detailedCoverage=ne,ut}constructor(z,ne,Se,Ge){this.uri=z,this.statementCoverage=ne,this.branchCoverage=Se,this.declarationCoverage=Ge,qi(ne),qi(Se),qi(Ge)}}e.$5M=Hi;class pn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se=[]){this.executed=z,this.location=ne,this.branches=Se}}e.$6M=pn;class ee{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se){this.executed=z,this.location=ne,this.label=Se}}e.$7M=ee;class ae{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se){this.name=z,this.executed=ne,this.location=Se}}e.$8M=ae;var Oe;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Oe||(e.ExternalUriOpenerPriority=Oe={}));var ot;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(ot||(e.WorkspaceTrustState=ot={}));var wt;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(wt||(e.PortAutoForwardAction=wt={}));class At{constructor(z,ne,Se,Ge,xe,ut){this.kind=z,this.name=ne,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$9M=At;class Ki{constructor(z){this.uri=z}}e.$0M=Ki;class Pn{constructor(z,ne){this.original=z,this.modified=ne}}e.$$M=Pn;class Rn{constructor(z,ne,Se,Ge){this.base=z,this.input1=ne,this.input2=Se,this.result=Ge}}e.$_M=Rn;class Ln{constructor(z,ne){this.uri=z,this.viewType=ne}}e.$aN=Ln;class An{constructor(z){this.viewType=z}}e.$bN=An;class Mn{constructor(z,ne){this.uri=z,this.notebookType=ne}}e.$cN=Mn;class Fn{constructor(z,ne,Se){this.original=z,this.modified=ne,this.notebookType=Se}}e.$dN=Fn;class Tn{constructor(){}}e.$eN=Tn;class Nn{constructor(z,ne){this.uri=z,this.inputBoxUri=ne}}e.$fN=Nn;class On{constructor(z){this.providerId=z}}e.$gN=On;var vn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var bn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(bn||(e.ChatAgentCopyKind=bn={}));var wn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class zn{constructor(z,ne){this.label=z,this.values=ne}}e.$hN=zn;var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant"})(En||(e.ChatMessageRole=En={}));class Un{constructor(z,ne){this.role=z,this.content=ne}}e.$iN=Un;var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Dn||(e.ChatAgentResultFeedbackKind=Dn={}));class jn{constructor(z){this.value=z}}e.$jN=jn;class Bn{constructor(z){this.value=typeof z=="string"?new Be(z):z}}e.$kN=Bn;class Wn{constructor(z,ne){this.value=z,this.baseUri=ne}}e.$lN=Wn;class Vn{constructor(z,ne){this.value=z,this.title=ne}}e.$mN=Vn;class qn{constructor(z){this.value=z}}e.$nN=qn;class Hn{constructor(z){this.value=z}}e.$oN=Hn;class Kn{constructor(z){this.value=z}}e.$pN=Kn;var kn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}));var In;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(In||(e.KeywordRecognitionStatus=In={}))}),define(Ae[240],Me([1,0,3,7]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$oL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,m,f){if(this.a.size===0)throw new Error("No related information providers registered");const D=this.a.get(R);if(!D)throw new Error("related information provider not found");return await D.provideRelatedInformation(m,f)??[]}getRelatedInformation(R,m,f){return this.c.$getAiRelatedInformation(m,f)}registerRelatedInformationProvider(R,m,f){const D=this.b;return this.b++,this.a.set(D,f),this.c.$registerAiRelatedInformationProvider(D,m),new M.$qL(()=>{this.c.$unregisterAiRelatedInformationProvider(D),this.a.delete(D)})}}e.$tgc=I}),define(Ae[241],Me([1,0,5,3,7,22,104]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class m{constructor(L){this.b=new Map,this.c=new S.$Wd,this.onDidChangeSessions=this.c.event,this.d=new f,this.f=new f,this.a=L.getProxy(M.$oL.MainThreadAuthentication)}async getSession(L,k,l,$={}){const w=A.$nm.toKey(L.identifier),r=[...l].sort().join(" ");return await this.d.getOrCreate(`${w} ${k} ${r}`,async()=>{await this.a.$ensureProvider(k);const c=L.displayName||L.name;return this.a.$getSession(k,l,w,c,$)})}async getSessions(L,k,l){const $=A.$nm.toKey(L.identifier),w=[...l].sort().join(" ");return await this.f.getOrCreate(`${$} ${w}`,async()=>{await this.a.$ensureProvider(k);const r=L.displayName||L.name;return this.a.$getSessions(k,l,$,r)})}async removeSession(L,k){const l=this.b.get(L);return l?l.provider.removeSession(k):this.a.$removeSession(L,k)}registerAuthenticationProvider(L,k,l,$){if(this.b.get(L))throw new Error(`An authentication provider with id '${L}' is already registered.`);this.b.set(L,{label:k,provider:l,options:$??{supportsMultipleAccounts:!1}});const w=l.onDidChangeSessions(r=>this.a.$sendDidChangeSessions(L,r));return this.a.$registerAuthenticationProvider(L,k,$?.supportsMultipleAccounts??!1),new I.$qL(()=>{w.dispose(),this.b.delete(L),this.a.$unregisterAuthenticationProvider(L)})}$createSession(L,k,l){const $=this.b.get(L);if($)return Promise.resolve($.provider.createSession(k,l));throw new Error(`Unable to find authentication provider with handle: ${L}`)}$removeSession(L,k){const l=this.b.get(L);if(l)return Promise.resolve(l.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${L}`)}$getSessions(L,k){const l=this.b.get(L);if(l)return Promise.resolve(l.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${L}`)}$onDidChangeAuthenticationSessions(L,k){return L.startsWith(R.$uK)||this.c.fire({provider:{id:L,label:k}}),Promise.resolve()}}e.$Egc=m;class f{constructor(){this.a=new Map}getOrCreate(L,k){const l=this.a.get(L);if(l)return l;const $=k().finally(()=>this.a.delete(L));return this.a.set(L,$),$}}}),define(Ae[108],Me([1,0,2,3,7,4,17,14,18,13,19,25]),function(fe,e,S,M,I,A,R,m,f,D,L,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=e.$Dhc=void 0;let $=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,c){this.h=c,this.f=new Map,this.g=r.getProxy(M.$oL.MainThreadDecorations)}registerFileDecorationProvider(r,c){const s=l.c++;this.f.set(s,{provider:r,extensionDescription:c}),this.g.$registerDecorationProvider(s,c.identifier.value);const i=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(s,null);return}const a=(0,f.$3b)(o);if(a.length<=l.d){this.g.$onDidChange(s,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",c.identifier.value,a.length);const u=a.map(n=>({uri:n,rank:(0,D.$Qe)(n.path,"/")})),t=(0,f.$zb)(u,(n,b)=>n.rank-b.rank||(0,D.$6e)(n.uri.path,b.uri.path)),d=[];e:for(const n of t){let b;for(const E of n){const h=(0,L.$mc)(E.uri.path);if(b!==h&&(b=h,d.push(E.uri)>=l.d))break e}}this.g.$onDidChange(s,d)});return new I.$qL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,c,s){if(!this.f.has(r))return Object.create(null);const i=Object.create(null),{provider:o,extensionDescription:a}=this.f.get(r);return await Promise.all(c.map(async u=>{try{const{uri:t,id:d}=u,n=await Promise.resolve(o.provideFileDecoration(S.URI.revive(t),s));if(!n)return;try{I.$NM.validate(n),n.badge&&typeof n.badge!="string"&&(0,k.$LF)(a,"codiconDecoration"),i[d]=[n.propagate,n.tooltip,n.badge,n.color]}catch(b){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${b}`)}}catch(t){this.h.error(t)}})),i}};e.$Dhc=$,e.$Dhc=$=l=Je([qe(0,R.$AN),qe(1,m.$pj)],$),e.$Ehc=(0,A.$8h)("IExtHostDecorations")}),define(Ae[242],Me([1,0,15,2,7,3,12,21,13]),function(fe,e,S,M,I,A,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class D{static{this.a=0}constructor(k,l,$){this.d=l,this.e=$,this.b=new Map,this.c=k.getProxy(A.$oL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const $=D.a++;this.b.set($,l),this.c.$registerTextContentProvider($,k);let w;if(typeof l.onDidChange=="function"){let r;w=l.onDidChange(async c=>{if(c.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(c))return;r&&await r;const s=this.$provideTextDocumentContent($,c).then(async i=>{if(!i&&typeof i!="string")return;const o=this.d.getDocument(c);if(!o)return;const a=(0,f.$1e)(i);if(!o.equalLines(a))return this.c.$onVirtualDocumentChange(c,i)}).catch(S.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new I.$qL(()=>{this.b.delete($)&&this.c.$unregisterTextContentProvider($),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(k,l){const $=this.b.get(k);return $?Promise.resolve($.provideTextDocumentContent(M.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Ghc=D}),define(Ae[109],Me([1,0,54,12,13,298,148,7,18]),function(fe,e,S,M,I,A,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.$DN=e.$CN=void 0;const D=new Map;function L(w,r){r?D.set(w,r):D.delete(w)}e.$CN=L;function k(w){return D.get(w)}class l extends A.$nv{constructor(r,c,s,i,o,a,u,t){super(c,s,i,o),this.c=r,this.m=a,this.q=u,this.notebook=t,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,f.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===M.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(c){return c?r.s(c):r.getText()},get eol(){return r.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(c){return r.t(c)},offsetAt(c){return r.u(c)},positionAt(c){return r.v(c)},validateRange(c){return r.w(c)},validatePosition(c){return r.x(c)},getWordRangeAtPosition(c,s){return r.y(c,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,S.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,S.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const c=this.w(r);if(c.isEmpty)return"";if(c.isSingleLine)return this.f[c.start.line].substring(c.start.character,c.end.character);const s=this.g,i=c.start.line,o=c.end.line,a=[];a.push(this.f[i].substring(c.start.character));for(let u=i+1;u<o;u++)a.push(this.f[u]);return a.push(this.f[o].substring(0,c.end.character)),a.join(s)}t(r){let c;if(r instanceof m.$rL?c=r.line:typeof r=="number"&&(c=r),typeof c!="number"||c<0||c>=this.f.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new $(c,this.f[c],c===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const c=this.j.getIndexOf(r),s=this.f[c.index].length;return new m.$rL(c.index,Math.min(c.remainder,s))}w(r){if(!(r instanceof m.$sL))throw new Error("Invalid argument");const c=this.x(r.start),s=this.x(r.end);return c===r.start&&s===r.end?r:new m.$sL(c.line,c.character,s.line,s.character)}x(r){if(!(r instanceof m.$rL))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:c,character:s}=r,i=!1;if(c<0)c=0,s=0,i=!0;else if(c>=this.f.length)c=this.f.length-1,s=this.f[c].length,i=!0;else{const o=this.f[c].length;s<0?(s=0,i=!0):s>o&&(s=o,i=!0)}return i?new m.$rL(c,s):r}y(r,c){const s=this.x(r);if(!c)c=k(this.m);else if((0,I.$Ze)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const i=(0,R.$zs)(s.character+1,(0,R.$xs)(c),this.f[s.line],0);if(i)return new m.$sL(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$DN=l;class ${constructor(r,c,s){this.a=r,this.b=c,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$sL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$sL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$EN=$}),define(Ae[243],Me([1,0,3,7]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$oL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,m,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const D=this.a.get(R);if(!D)throw new Error("Embedding vector provider not found");const L=await D.provideEmbeddingVector(m,f);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(R,m,f){const D=this.b;return this.b++,this.a.set(D,f),this.c.$registerAiEmbeddingVectorProvider(m,D),new M.$qL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(D),this.a.delete(D)})}}e.$Ihc=I}),define(Ae[62],Me([1,0,3,42,7,23,4,17,43,6,11,24,12]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=e.$Vgc=void 0;let w=$=class{constructor(c,s){this.b=new Map,this.c=new L.$eh,this.a=c.getProxy(S.$oL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(o){try{let a;const u=i.b.get(o.scheme);return u?(await i.a.$ensureActivation(o.scheme),a=await u.impl.stat(o)):a=await i.a.$stat(o),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===M.FilePermission.Readonly?1:void 0}}catch(a){$.e(a)}},async readDirectory(o){try{const a=i.b.get(o.scheme);return a?(await i.a.$ensureActivation(o.scheme),(await a.impl.readDirectory(o)).slice()):await i.a.$readdir(o)}catch(a){return $.e(a)}},async createDirectory(o){try{const a=i.b.get(o.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(o.scheme),await i.d(a.impl,a.extUri,o)):await i.a.$mkdir(o)}catch(a){return $.e(a)}},async readFile(o){try{const a=i.b.get(o.scheme);return a?(await i.a.$ensureActivation(o.scheme),(await a.impl.readFile(o)).slice()):(await i.a.$readFile(o)).buffer}catch(a){return $.e(a)}},async writeFile(o,a){try{const u=i.b.get(o.scheme);return u&&!u.isReadonly?(await i.a.$ensureActivation(o.scheme),await i.d(u.impl,u.extUri,u.extUri.dirname(o)),await i.c.queueFor(o,()=>Promise.resolve(u.impl.writeFile(o,a,{create:!0,overwrite:!0})))):await i.a.$writeFile(o,A.$ke.wrap(a))}catch(u){return $.e(u)}},async delete(o,a){try{const u=i.b.get(o.scheme);return u&&!u.isReadonly&&!a?.useTrash?(await i.a.$ensureActivation(o.scheme),await u.impl.delete(o,{recursive:!1,...a})):await i.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(u){return $.e(u)}},async rename(o,a,u){try{return await i.a.$rename(o,a,{overwrite:!1,...u})}catch(t){return $.e(t)}},async copy(o,a,u){try{return await i.a.$copy(o,a,{overwrite:!1,...u})}catch(t){return $.e(t)}},isWritableFileSystem(o){const a=s.getCapabilities(o);if(typeof a=="number")return!(a&2048)}})}async d(c,s,i){const o=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await c.stat(i)).type&M.FileType.Directory))throw I.$EM.FileExists(`Unable to create folder '${i.scheme===l.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(M.$Ik(a)!==M.FileSystemProviderErrorCode.FileNotFound)throw a;o.push(s.basename(i)),i=s.dirname(i)}for(let a=o.length-1;a>=0;a--){i=s.joinPath(i,o[a]);try{await c.createDirectory(i)}catch(u){if(M.$Ik(u)!==M.FileSystemProviderErrorCode.FileExists)throw u}}}static e(c){if(c instanceof I.$EM)throw c;if(c instanceof M.$Ek)switch(c.code){case M.FileSystemProviderErrorCode.FileExists:throw I.$EM.FileExists(c.message);case M.FileSystemProviderErrorCode.FileNotFound:throw I.$EM.FileNotFound(c.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw I.$EM.FileNotADirectory(c.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw I.$EM.FileIsADirectory(c.message);case M.FileSystemProviderErrorCode.NoPermissions:throw I.$EM.NoPermissions(c.message);case M.FileSystemProviderErrorCode.Unavailable:throw I.$EM.Unavailable(c.message);default:throw new I.$EM(c.message,c.name)}if(!(c instanceof Error))throw new I.$EM(String(c));if(c.name==="ENOPRO"||c.message.includes("ENOPRO"))throw I.$EM.Unavailable(c.message);switch(c.name){case M.FileSystemProviderErrorCode.FileExists:throw I.$EM.FileExists(c.message);case M.FileSystemProviderErrorCode.FileNotFound:throw I.$EM.FileNotFound(c.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw I.$EM.FileNotADirectory(c.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw I.$EM.FileIsADirectory(c.message);case M.FileSystemProviderErrorCode.NoPermissions:throw I.$EM.NoPermissions(c.message);case M.FileSystemProviderErrorCode.Unavailable:throw I.$EM.Unavailable(c.message);default:throw new I.$EM(c.message,c.name)}}addFileSystemProvider(c,s,i){return this.b.set(c,{impl:s,extUri:i?.isCaseSensitive?k.$yg:k.$Ag,isReadonly:!!i?.isReadonly}),(0,D.$Rc)(()=>this.b.delete(c))}getFileSystemProviderExtUri(c){return this.b.get(c)?.extUri??k.$yg}};e.$Vgc=w,e.$Vgc=w=$=Je([qe(0,m.$AN),qe(1,f.$wgc)],w),e.$Wgc=(0,R.$8h)("IExtHostConsumerFileSystem")}),define(Ae[244],Me([1,0,3,7]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;class I{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(S.$oL.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const f=this.a.get(R);if(!f)throw new Error("Issue request handler not found");const D=await f.handleIssueUrlRequest();if(!D)throw new Error("Issue request handler returned no result");return D}async $getIssueReporterData(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const D=await f.provideIssueData(m);if(!D)throw new Error("Issue data provider returned no result");return D}async $getIssueReporterTemplate(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const D=await f.provideIssueTemplate(m);if(!D)throw new Error("Issue template provider returned no result");return D}registerIssueUriRequestHandler(R,m){const f=R.identifier.value;return this.a.set(f,m),this.c.$registerIssueUriRequestHandler(f),new M.$qL(()=>{this.c.$unregisterIssueUriRequestHandler(f),this.a.delete(f)})}registerIssueDataProvider(R,m){const f=R.identifier.value;return this.b.set(f,m),this.c.$registerIssueDataProvider(f),new M.$qL(()=>{this.c.$unregisterIssueDataProvider(f),this.b.delete(f)})}}e.$Zhc=I}),define(Ae[84],Me([1,0,4,27,14,62,2]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=void 0,e.$Xgc=(0,S.$8h)("IExtensionStoragePaths");let m=class{constructor(D,L,k){this.d=L,this.f=k,this.a=D.workspace??void 0,this.b=D.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(D){return R.URI.joinPath(this.b.workspaceStorageHome,D)}async h(){if(!this.a)return Promise.resolve(void 0);const D=this.a.id,L=await this.g(D);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(R.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(D){if(this.c)return R.URI.joinPath(this.c,D.identifier.value)}globalValue(D){return R.URI.joinPath(this.b.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ygc=m,e.$Ygc=m=Je([qe(0,M.$QN),qe(1,I.$pj),qe(2,A.$Wgc)],m)}),define(Ae[245],Me([1,0,7,17,5]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=void 0;let A=class{constructor(m){this.a=new S.$OM(S.ColorThemeKind.Dark),this.b=new I.$Wd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let f;switch(m){case"light":f=S.ColorThemeKind.Light;break;case"hcDark":f=S.ColorThemeKind.HighContrast;break;case"hcLight":f=S.ColorThemeKind.HighContrastLight;break;default:f=S.ColorThemeKind.Dark}this.a=new S.$OM(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$qic=A,e.$qic=A=Je([qe(0,M.$AN)],A)}),define(Ae[85],Me([1,0,21,5,6,169,4,14,198,3,27,17,7]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Azb=e.$zzb=e.TunnelDtoConverter=void 0;class $ extends f.$Lv{}var w;(function(c){function s(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:o.protocol}}c.fromApiTunnel=s;function i(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==f.TunnelPrivacyId.ConstantPrivate&&o.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}c.fromServiceTunnel=i})(w||(e.TunnelDtoConverter=w={})),e.$zzb=(0,R.$8h)("IExtHostTunnelService");let r=class extends I.$Tc{constructor(s,i,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Wd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(D.$oL.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const o=await this.a.$openTunnel(i,s.displayName);if(o){const a=new $(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const o=this.u();return this.r.set(o,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,o),new l.$qL(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(s,i,o,a,u){const t=[];for(const n of s){const b=this.r.get(n);if(!b)return[];t.push(...await Promise.all(i.map(async E=>{let h;try{h=await b.provider.providePortAttributes({port:E,pid:o,commandLine:a},u)}catch{h=await b.provider.providePortAttributes(E,o,a,u)}return{providedAttributes:h,port:E}})))}const d=t.filter(n=>!!n.providedAttributes);return d.length>0?d.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,u)=>await s.provideTunnel(a,u,new S.$7d().token)??void 0;const o=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,I.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const o=s.tunnelFactory??(i?this.w(i):void 0);if(o){this.b=o;let a=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const u=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,I.$Rc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const o=this.g.get(s.host);o.has(s.port)&&(i&&o.get(s.port).disposeListener.dispose(),await o.get(s.port).tunnel.dispose(),o.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const a=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const u=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:a,disposeListener:u}),w.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(a=>this.f(a.host,a.port,a.detail??""))),o=s.filter((a,u)=>i[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(a=>a.port).join(", ")} to ${o.map(a=>a.port).join(", ")}`),o}};e.$Azb=r,e.$Azb=r=Je([qe(0,k.$AN),qe(1,L.$QN),qe(2,m.$pj)],r)}),define(Ae[8],Me([1,0,18,23,128,246,46,28,121,52,69,26,16,2,29,86,98,103,102,83,49,59,217,25,7,24]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o,a,u,t,d,n,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.ChatResponseTextPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$zN=e.$yN=e.MarkdownString=e.$xN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var E;(function(ye){function Fe(Y){const{selectionStartLineNumber:Re,selectionStartColumn:je,positionLineNumber:Qe,positionColumn:Ke}=Y,nt=new n.$rL(Re-1,je-1),bt=new n.$rL(Qe-1,Ke-1);return new n.$tL(nt,bt)}ye.to=Fe;function ue(Y){const{anchor:Re,active:je}=Y;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}ye.from=ue})(E||(e.Selection=E={}));var h;(function(ye){function Fe(Y){if(!Y)return;const{start:Re,end:je}=Y;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}ye.from=Fe;function ue(Y){if(!Y)return;const{startLineNumber:Re,startColumn:je,endLineNumber:Qe,endColumn:Ke}=Y;return new n.$sL(Re-1,je-1,Qe-1,Ke-1)}ye.to=ue})(h||(e.Range=h={}));var v;(function(ye){function Fe(Y){return{uri:Y.uri,range:h.from(Y.range)}}ye.from=Fe;function ue(Y){return new n.$CL($.URI.revive(Y.uri),h.to(Y.range))}ye.to=ue})(v||(e.Location=v={}));var P;(function(ye){function Fe(ue){switch(ue){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}ye.to=Fe})(P||(e.TokenType=P={}));var g;(function(ye){function Fe(Y){return new n.$rL(Y.lineNumber-1,Y.column-1)}ye.to=Fe;function ue(Y){return{lineNumber:Y.line+1,column:Y.character+1}}ye.from=ue})(g||(e.Position=g={}));var p;(function(ye){function Fe(Re,je,Qe){return(0,S.$Hb)((0,S.$3b)(Re).map(Ke=>ue(Ke,je,Qe)))}ye.from=Fe;function ue(Re,je,Qe){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:Qe?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:Y(Re.scheme,je),pattern:pe.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:Qe?.isBuiltin}}function Y(Re,je){return je&&typeof Re=="string"?je.transformOutgoingScheme(Re):Re}})(p||(e.DocumentSelector=p={}));var y;(function(ye){function Fe(Y){switch(Y){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}ye.from=Fe;function ue(Y){switch(Y){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}ye.to=ue})(y||(e.DiagnosticTag=y={}));var T;(function(ye){function Fe(Y){let Re;return Y.code&&((0,l.$Jf)(Y.code)||(0,l.$Nf)(Y.code)?Re=String(Y.code):Re={value:String(Y.code.value),target:Y.code.target}),{...h.from(Y.range),message:Y.message,source:Y.source,code:Re,severity:J.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(N.from),tags:Array.isArray(Y.tags)?(0,S.$Hb)(Y.tags.map(y.from)):void 0}}ye.from=Fe;function ue(Y){const Re=new n.$EL(h.to(Y),Y.message,J.to(Y.severity));return Re.source=Y.source,Re.code=(0,l.$Jf)(Y.code)?Y.code:Y.code?.value,Re.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(N.to),Re.tags=Y.tags&&(0,S.$Hb)(Y.tags.map(y.to)),Re}ye.to=ue})(T||(e.Diagnostic=T={}));var N;(function(ye){function Fe(Y){return{...h.from(Y.location.range),message:Y.message,resource:Y.location.uri}}ye.from=Fe;function ue(Y){return new n.$DL(new n.$CL(Y.resource,h.to(Y)),Y.message)}ye.to=ue})(N||(e.DiagnosticRelatedInformation=N={}));var J;(function(ye){function Fe(Y){switch(Y){case n.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ye.from=Fe;function ue(Y){switch(Y){case c.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}ye.to=ue})(J||(e.DiagnosticSeverity=J={}));var q;(function(ye){function Fe(Y){return typeof Y=="number"&&Y>=n.ViewColumn.One?Y-1:Y===n.ViewColumn.Beside?t.$gD:t.$fD}ye.from=Fe;function ue(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=ue})(q||(e.ViewColumn=q={}));function U(ye){return typeof ye.range<"u"}function C(ye){return ye.length===0?!0:!!U(ye[0])}e.$xN=C;var F;(function(ye){function Fe(Ke){return Ke.map(ye.from)}ye.fromMany=Fe;function ue(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Y(Ke){let nt;if(ue(Ke)){const{language:pt,value:Ht}=Ke;nt={value:"```"+pt+`
`+Ht+"\n```\n"}}else n.$RL.isMarkdownString(Ke)?nt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?nt={value:Ke}:nt={value:""};const bt=Object.create(null);nt.uris=bt;const qt=pt=>{try{let Ht=$.URI.parse(pt,!0);Ht=Ht.with({query:Re(Ht.query,bt)}),bt[pt]=Ht}catch{}return""},Xt=new f.marked.Renderer;return Xt.link=qt,Xt.image=pt=>typeof pt=="string"?qt(R.$rk(pt).href):"",(0,f.marked)(nt.value,{renderer:Xt}),nt}ye.from=Y;function Re(Ke,nt){if(!Ke)return Ke;let bt;try{bt=(0,D.$Dh)(Ke)}catch{}if(!bt)return Ke;let qt=!1;return bt=(0,k.$An)(bt,Xt=>{if($.URI.isUri(Xt)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[pt]=Xt,qt=!0,pt}else return}),qt?JSON.stringify(bt):Ke}function je(Ke){const nt=new n.$RL(Ke.value,Ke.supportThemeIcons);return nt.isTrusted=Ke.isTrusted,nt.supportHtml=Ke.supportHtml,nt.baseUri=Ke.baseUri?$.URI.from(Ke.baseUri):void 0,nt}ye.to=je;function Qe(Ke){if(Ke)return typeof Ke=="string"?Ke:ye.from(Ke)}ye.fromStrict=Qe})(F||(e.MarkdownString=F={}));function W(ye){return C(ye)?ye.map(Fe=>({range:h.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?F.fromMany(Fe.hoverMessage):Fe.hoverMessage?F.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):ye.map(Fe=>({range:h.from(Fe)}))}e.$yN=W;function re(ye){return typeof ye>"u"?ye:typeof ye=="string"?$.URI.file(ye):ye}e.$zN=re;var ce;(function(ye){function Fe(ue){return typeof ue>"u"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?re(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}ye.from=Fe})(ce||(e.ThemableDecorationAttachmentRenderOptions=ce={}));var we;(function(ye){function Fe(ue){return typeof ue>"u"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?re(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?ce.from(ue.before):void 0,after:ue.after?ce.from(ue.after):void 0}}ye.from=Fe})(we||(e.ThemableDecorationRenderOptions=we={}));var De;(function(ye){function Fe(ue){if(typeof ue>"u")return ue;switch(ue){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Fe})(De||(e.DecorationRangeBehavior=De={}));var he;(function(ye){function Fe(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?De.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?we.from(ue.light):void 0,dark:ue.dark?we.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?re(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?ce.from(ue.before):void 0,after:ue.after?ce.from(ue.after):void 0}}ye.from=Fe})(he||(e.DecorationRenderOptions=he={}));var ve;(function(ye){function Fe(Y){return{text:Y.newText,eol:Y.newEol&&ct.from(Y.newEol),range:h.from(Y.range)}}ye.from=Fe;function ue(Y){const Re=new n.$xL(h.to(Y.range),Y.text);return Re.newEol=typeof Y.eol>"u"?void 0:ct.to(Y.eol),Re}ye.to=ue})(ve||(e.TextEdit=ve={}));var se;(function(ye){function Fe(Y,Re){const je={edits:[]};if(Y instanceof n.$AL){const Qe=new m.$Bc;for(const Ke of Y._allEntries())Ke._type===1&&$.URI.isUri(Ke.to)&&Ke.from===void 0&&Qe.add(Ke.to);for(const Ke of Y._allEntries())if(Ke._type===1){let nt;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?nt={type:"base64",value:(0,M.$Ee)(M.$ke.wrap(Ke.options.contents))}:nt={type:"dataTransferItem",id:Ke.options.contents._itemId}),je.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:nt},metadata:Ke.metadata})}else Ke._type===2?je.edits.push({resource:Ke.uri,textEdit:ve.from(Ke.edit),versionId:Qe.has(Ke.uri)?void 0:Re?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?je.edits.push({resource:Ke.uri,textEdit:{range:h.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ke.uri)?void 0:Re?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?je.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&je.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(_t.from)}})}return je}ye.from=Fe;function ue(Y){const Re=new n.$AL,je=new m.$Ac;for(const Qe of Y.edits)if(Qe.textEdit){const Ke=Qe,nt=$.URI.revive(Ke.resource),bt=h.to(Ke.textEdit.range),qt=Ke.textEdit.text,Xt=Ke.textEdit.insertAsSnippet;let pt;Xt?pt=n.$zL.replace(bt,new n.$BL(qt)):pt=n.$xL.replace(bt,qt);const Ht=je.get(nt);Ht?Ht.push(pt):je.set(nt,[pt])}else Re.renameFile($.URI.revive(Qe.oldResource),$.URI.revive(Qe.newResource),Qe.options);for(const[Qe,Ke]of je)Re.set(Qe,Ke);return Re}ye.to=ue})(se||(e.WorkspaceEdit=se={}));var $e;(function(ye){const Fe=Object.create(null);Fe[n.SymbolKind.File]=0,Fe[n.SymbolKind.Module]=1,Fe[n.SymbolKind.Namespace]=2,Fe[n.SymbolKind.Package]=3,Fe[n.SymbolKind.Class]=4,Fe[n.SymbolKind.Method]=5,Fe[n.SymbolKind.Property]=6,Fe[n.SymbolKind.Field]=7,Fe[n.SymbolKind.Constructor]=8,Fe[n.SymbolKind.Enum]=9,Fe[n.SymbolKind.Interface]=10,Fe[n.SymbolKind.Function]=11,Fe[n.SymbolKind.Variable]=12,Fe[n.SymbolKind.Constant]=13,Fe[n.SymbolKind.String]=14,Fe[n.SymbolKind.Number]=15,Fe[n.SymbolKind.Boolean]=16,Fe[n.SymbolKind.Array]=17,Fe[n.SymbolKind.Object]=18,Fe[n.SymbolKind.Key]=19,Fe[n.SymbolKind.Null]=20,Fe[n.SymbolKind.EnumMember]=21,Fe[n.SymbolKind.Struct]=22,Fe[n.SymbolKind.Event]=23,Fe[n.SymbolKind.Operator]=24,Fe[n.SymbolKind.TypeParameter]=25;function ue(Re){return typeof Fe[Re]=="number"?Fe[Re]:6}ye.from=ue;function Y(Re){for(const je in Fe)if(Fe[je]===Re)return Number(je);return n.SymbolKind.Property}ye.to=Y})($e||(e.SymbolKind=$e={}));var te;(function(ye){function Fe(Y){switch(Y){case n.SymbolTag.Deprecated:return 1}}ye.from=Fe;function ue(Y){switch(Y){case 1:return n.SymbolTag.Deprecated}}ye.to=ue})(te||(e.SymbolTag=te={}));var X;(function(ye){function Fe(Y){return{name:Y.name,kind:$e.from(Y.kind),tags:Y.tags&&Y.tags.map(te.from),containerName:Y.containerName,location:Pe.from(Y.location)}}ye.from=Fe;function ue(Y){const Re=new n.$IL(Y.name,$e.to(Y.kind),Y.containerName,Pe.to(Y.location));return Re.tags=Y.tags&&Y.tags.map(te.to),Re}ye.to=ue})(X||(e.WorkspaceSymbol=X={}));var V;(function(ye){function Fe(Y){const Re={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:h.from(Y.range),selectionRange:h.from(Y.selectionRange),kind:$e.from(Y.kind),tags:Y.tags?.map(te.from)??[]};return Y.children&&(Re.children=Y.children.map(Fe)),Re}ye.from=Fe;function ue(Y){const Re=new n.$JL(Y.name,Y.detail,$e.to(Y.kind),h.to(Y.range),h.to(Y.selectionRange));return(0,S.$Lb)(Y.tags)&&(Re.tags=Y.tags.map(te.to)),Y.children&&(Re.children=Y.children.map(ue)),Re}ye.to=ue})(V||(e.DocumentSymbol=V={}));var ie;(function(ye){function Fe(Y){const Re=new n.$NL($e.to(Y.kind),Y.name,Y.detail||"",$.URI.revive(Y.uri),h.to(Y.range),h.to(Y.selectionRange));return Re._sessionId=Y._sessionId,Re._itemId=Y._itemId,Re}ye.to=Fe;function ue(Y,Re,je){if(Re=Re??Y._sessionId,je=je??Y._itemId,Re===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:je,name:Y.name,detail:Y.detail,kind:$e.from(Y.kind),uri:Y.uri,range:h.from(Y.range),selectionRange:h.from(Y.selectionRange),tags:Y.tags?.map(te.from)}}ye.from=ue})(ie||(e.CallHierarchyItem=ie={}));var Ce;(function(ye){function Fe(ue){return new n.$OL(ie.to(ue.from),ue.fromRanges.map(Y=>h.to(Y)))}ye.to=Fe})(Ce||(e.CallHierarchyIncomingCall=Ce={}));var Te;(function(ye){function Fe(ue){return new n.$PL(ie.to(ue.to),ue.fromRanges.map(Y=>h.to(Y)))}ye.to=Fe})(Te||(e.CallHierarchyOutgoingCall=Te={}));var Pe;(function(ye){function Fe(Y){return{range:Y.range&&h.from(Y.range),uri:Y.uri}}ye.from=Fe;function ue(Y){return new n.$CL($.URI.revive(Y.uri),h.to(Y.range))}ye.to=ue})(Pe||(e.location=Pe={}));var be;(function(ye){function Fe(Y){const Re=Y,je=Y;return{originSelectionRange:Re.originSelectionRange?h.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:je.uri,range:h.from(Re.targetRange?Re.targetRange:je.range),targetSelectionRange:Re.targetSelectionRange?h.from(Re.targetSelectionRange):void 0}}ye.from=Fe;function ue(Y){return{targetUri:$.URI.revive(Y.uri),targetRange:h.to(Y.range),targetSelectionRange:Y.targetSelectionRange?h.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?h.to(Y.originSelectionRange):void 0}}ye.to=ue})(be||(e.DefinitionLink=be={}));var me;(function(ye){function Fe(Y){return{range:h.from(Y.range),contents:F.fromMany(Y.contents)}}ye.from=Fe;function ue(Y){return new n.$FL(Y.contents.map(F.to),h.to(Y.range))}ye.to=ue})(me||(e.Hover=me={}));var G;(function(ye){function Fe(Y){return{range:h.from(Y.range),expression:Y.expression}}ye.from=Fe;function ue(Y){return new n.$zM(h.to(Y.range),Y.expression)}ye.to=ue})(G||(e.EvaluatableExpression=G={}));var _;(function(ye){function Fe(Y){if(Y instanceof n.$AM)return{type:"text",range:h.from(Y.range),text:Y.text};if(Y instanceof n.$BM)return{type:"variable",range:h.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof n.$CM)return{type:"expression",range:h.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Fe;function ue(Y){switch(Y.type){case"text":return{range:h.to(Y.range),text:Y.text};case"variable":return{range:h.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:h.to(Y.range),expression:Y.expression}}}ye.to=ue})(_||(e.InlineValue=_={}));var le;(function(ye){function Fe(Y){return{frameId:Y.frameId,stoppedLocation:h.from(Y.stoppedLocation)}}ye.from=Fe;function ue(Y){return new n.$DM(Y.frameId,h.to(Y.stoppedLocation))}ye.to=ue})(le||(e.InlineValueContext=le={}));var de;(function(ye){function Fe(Y){return{range:h.from(Y.range),kind:Y.kind}}ye.from=Fe;function ue(Y){return new n.$GL(h.to(Y.range),Y.kind)}ye.to=ue})(de||(e.DocumentHighlight=de={}));var Le;(function(ye){function Fe(Y){return{uri:Y.uri,highlights:Y.highlights.map(de.from)}}ye.from=Fe;function ue(Y){return new n.$HL($.URI.revive(Y.uri),Y.highlights.map(de.to))}ye.to=ue})(Le||(e.MultiDocumentHighlight=Le={}));var ge;(function(ye){function Fe(ue){switch(ue){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}ye.to=Fe})(ge||(e.CompletionTriggerKind=ge={}));var ke;(function(ye){function Fe(ue){return{triggerKind:ge.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}ye.to=Fe})(ke||(e.CompletionContext=ke={}));var Ie;(function(ye){function Fe(Y){switch(Y){case n.CompletionItemTag.Deprecated:return 1}}ye.from=Fe;function ue(Y){switch(Y){case 1:return n.CompletionItemTag.Deprecated}}ye.to=ue})(Ie||(e.CompletionItemTag=Ie={}));var O;(function(ye){const Fe=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function ue(je){return Fe.get(je)??9}ye.from=ue;const Y=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Re(je){return Y.get(je)??n.CompletionItemKind.Property}ye.to=Re})(O||(e.CompletionItemKind=O={}));var K;(function(ye){function Fe(ue,Y){const Re=new n.$XL(ue.label);return Re.insertText=ue.insertText,Re.kind=O.to(ue.kind),Re.tags=ue.tags?.map(Ie.to),Re.detail=ue.detail,Re.documentation=R.$lk(ue.documentation)?F.to(ue.documentation):ue.documentation,Re.sortText=ue.sortText,Re.filterText=ue.filterText,Re.preselect=ue.preselect,Re.commitCharacters=ue.commitCharacters,w.$Ws.isIRange(ue.range)?Re.range=h.to(ue.range):typeof ue.range=="object"&&(Re.range={inserting:h.to(ue.range.insert),replacing:h.to(ue.range.replace)}),Re.keepWhitespace=typeof ue.insertTextRules>"u"?!1:!!(ue.insertTextRules&1),typeof ue.insertTextRules<"u"&&ue.insertTextRules&4?Re.insertText=new n.$BL(ue.insertText):(Re.insertText=ue.insertText,Re.textEdit=Re.range instanceof n.$sL?new n.$xL(Re.range,Re.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Re.additionalTextEdits=ue.additionalTextEdits.map(je=>ve.to(je))),Re.command=Y&&ue.command?Y.fromInternal(ue.command):void 0,Re}ye.to=Fe})(K||(e.CompletionItem=K={}));var j;(function(ye){function Fe(Y){if(typeof Y.label!="string"&&!Array.isArray(Y.label))throw new TypeError("Invalid label");return{label:Y.label,documentation:F.fromStrict(Y.documentation)}}ye.from=Fe;function ue(Y){return{label:Y.label,documentation:R.$lk(Y.documentation)?F.to(Y.documentation):Y.documentation}}ye.to=ue})(j||(e.ParameterInformation=j={}));var H;(function(ye){function Fe(Y){return{label:Y.label,documentation:F.fromStrict(Y.documentation),parameters:Array.isArray(Y.parameters)?Y.parameters.map(j.from):[],activeParameter:Y.activeParameter}}ye.from=Fe;function ue(Y){return{label:Y.label,documentation:R.$lk(Y.documentation)?F.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(j.to):[],activeParameter:Y.activeParameter}}ye.to=ue})(H||(e.SignatureInformation=H={}));var Q;(function(ye){function Fe(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(H.from):[]}}ye.from=Fe;function ue(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(H.to):[]}}ye.to=ue})(Q||(e.SignatureHelp=Q={}));var oe;(function(ye){function Fe(ue,Y){const Re=new n.$WL(g.to(Y.position),typeof Y.label=="string"?Y.label:Y.label.map(Ee.to.bind(void 0,ue)),Y.kind&&Be.to(Y.kind));return Re.textEdits=Y.textEdits&&Y.textEdits.map(ve.to),Re.tooltip=R.$lk(Y.tooltip)?F.to(Y.tooltip):Y.tooltip,Re.paddingLeft=Y.paddingLeft,Re.paddingRight=Y.paddingRight,Re}ye.to=Fe})(oe||(e.InlayHint=oe={}));var Ee;(function(ye){function Fe(ue,Y){const Re=new n.$VL(Y.label);return Re.tooltip=R.$lk(Y.tooltip)?F.to(Y.tooltip):Y.tooltip,r.Command.is(Y.command)&&(Re.command=ue.fromInternal(Y.command)),Y.location&&(Re.location=Pe.to(Y.location)),Re}ye.to=Fe})(Ee||(e.InlayHintLabelPart=Ee={}));var Be;(function(ye){function Fe(Y){return Y}ye.from=Fe;function ue(Y){return Y}ye.to=ue})(Be||(e.InlayHintKind=Be={}));var We;(function(ye){function Fe(Y){return{range:h.from(Y.range),url:Y.target,tooltip:Y.tooltip}}ye.from=Fe;function ue(Y){let Re;if(Y.url)try{Re=typeof Y.url=="string"?$.URI.parse(Y.url,!0):$.URI.revive(Y.url)}catch{}return new n.$3L(h.to(Y.range),Re)}ye.to=ue})(We||(e.DocumentLink=We={}));var Ze;(function(ye){function Fe(Y){const Re=new n.$6L(Y.label);return Y.textEdit&&(Re.textEdit=ve.to(Y.textEdit)),Y.additionalTextEdits&&(Re.additionalTextEdits=Y.additionalTextEdits.map(je=>ve.to(je))),Re}ye.to=Fe;function ue(Y){return{label:Y.label,textEdit:Y.textEdit?ve.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Re=>ve.from(Re)):void 0}}ye.from=ue})(Ze||(e.ColorPresentation=Ze={}));var _e;(function(ye){function Fe(Y){return new n.$4L(Y[0],Y[1],Y[2],Y[3])}ye.to=Fe;function ue(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}ye.from=ue})(_e||(e.Color=_e={}));var at;(function(ye){function Fe(Y){return{range:h.from(Y.range)}}ye.from=Fe;function ue(Y){return new n.$ML(h.to(Y.range))}ye.to=ue})(at||(e.SelectionRange=at={}));var rt;(function(ye){function Fe(ue){switch(ue){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}ye.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var et;(function(ye){function Fe(Y){switch(Y){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.Interval:return 3;case n.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Fe;function ue(Y){switch(Y){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 3:return n.TextEditorLineNumbersStyle.Interval;case 1:default:return n.TextEditorLineNumbersStyle.On}}ye.to=ue})(et||(e.TextEditorLineNumbersStyle=et={}));var ct;(function(ye){function Fe(Y){if(Y===n.EndOfLine.CRLF)return 1;if(Y===n.EndOfLine.LF)return 0}ye.from=Fe;function ue(Y){if(Y===1)return n.EndOfLine.CRLF;if(Y===0)return n.EndOfLine.LF}ye.to=ue})(ct||(e.EndOfLine=ct={}));var Ue;(function(ye){function Fe(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Fe})(Ue||(e.ProgressLocation=Ue={}));var vt;(function(ye){function Fe(Y){const Re={start:Y.start+1,end:Y.end+1};return Y.kind&&(Re.kind=Z.from(Y.kind)),Re}ye.from=Fe;function ue(Y){const Re={start:Y.start-1,end:Y.end-1};return Y.kind&&(Re.kind=Z.to(Y.kind)),Re}ye.to=ue})(vt||(e.FoldingRange=vt={}));var Z;(function(ye){function Fe(Y){if(Y)switch(Y){case n.FoldingRangeKind.Comment:return r.$Mt.Comment;case n.FoldingRangeKind.Imports:return r.$Mt.Imports;case n.FoldingRangeKind.Region:return r.$Mt.Region}}ye.from=Fe;function ue(Y){if(Y)switch(Y.value){case r.$Mt.Comment.value:return n.FoldingRangeKind.Comment;case r.$Mt.Imports.value:return n.FoldingRangeKind.Imports;case r.$Mt.Region.value:return n.FoldingRangeKind.Region}}ye.to=ue})(Z||(e.FoldingRangeKind=Z={}));var x;(function(ye){function Fe(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?h.from(ue.selection):void 0,override:typeof ue.override=="boolean"?i.$IE.id:void 0}}ye.from=Fe})(x||(e.TextEditorOpenOptions=x={}));var pe;(function(ye){function Fe(je){return je instanceof n.$nM?je.toJSON():typeof je=="string"?je:ue(je)||Y(je)?new n.$nM(je.baseUri??je.base,je.pattern).toJSON():je}ye.from=Fe;function ue(je){const Qe=je;return Qe?$.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function Y(je){const Qe=je;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Re(je){return typeof je=="string"?je:new n.$nM($.URI.revive(je.baseUri),je.pattern)}ye.to=Re})(pe||(e.GlobPattern=pe={}));var Ve;(function(ye){function Fe(ue){if(ue){if(Array.isArray(ue))return ue.map(Fe);if(typeof ue=="string")return ue;{const Y=ue;return{language:Y.language,scheme:Y.scheme,pattern:pe.from(Y.pattern),exclusive:Y.exclusive,notebookType:Y.notebookType}}}else return}ye.from=Fe})(Ve||(e.LanguageSelector=Ve={}));var Ye;(function(ye){function Fe(Y){return!!Y&&typeof Y=="object"&&"documents"in Y&&Array.isArray(Y.documents)&&Y.documents.every(Re=>Array.isArray(Re)&&Re.every(je=>je&&typeof je=="object"&&"uri"in je&&$.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Qe=>Qe instanceof n.$sL)))}ye.is=Fe;function ue(Y){return{documents:Y.documents.map(Re=>Re.map(je=>({uri:$.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Qe=>h.from(Qe))})))}}ye.from=ue})(Ye||(e.MappedEditsContext=Ye={}));var it;(function(ye){function Fe(Y){return{start:Y.start,end:Y.end}}ye.from=Fe;function ue(Y){return new n.$PM(Y.start,Y.end)}ye.to=ue})(it||(e.NotebookRange=it={}));var st;(function(ye){function Fe(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}ye.to=Fe;function ue(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}ye.from=ue})(st||(e.NotebookCellExecutionSummary=st={}));var Ne;(function(ye){function Fe(ue){if(ue===o.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(ue===o.NotebookCellExecutionState.Pending)return;if(ue===o.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ue}`)}ye.to=Fe})(Ne||(e.NotebookCellExecutionState=Ne={}));var Mt;(function(ye){function Fe(Y){switch(Y){case n.NotebookCellKind.Markup:return o.CellKind.Markup;case n.NotebookCellKind.Code:default:return o.CellKind.Code}}ye.from=Fe;function ue(Y){switch(Y){case o.CellKind.Markup:return n.NotebookCellKind.Markup;case o.CellKind.Code:default:return n.NotebookCellKind.Code}}ye.to=ue})(Mt||(e.NotebookCellKind=Mt={}));var Jt;(function(ye){function Fe(Y){const Re={metadata:Y.metadata??Object.create(null),cells:[]};for(const je of Y.cells)n.$QM.validate(je),Re.cells.push(_t.from(je));return Re}ye.from=Fe;function ue(Y){const Re=new n.$RM(Y.cells.map(_t.to));return(0,l.$Wf)(Y.metadata)||(Re.metadata=Y.metadata),Re}ye.to=ue})(Jt||(e.NotebookData=Jt={}));var _t;(function(ye){function Fe(Y){return{cellKind:Mt.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:st.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(Et.from):[]}}ye.from=Fe;function ue(Y){return new n.$QM(Mt.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(Et.to):void 0,Y.metadata,Y.internalMetadata?st.to(Y.internalMetadata):void 0)}ye.to=ue})(_t||(e.NotebookCellData=_t={}));var Ut;(function(ye){function Fe(Y){return{mime:Y.mime,valueBytes:M.$ke.wrap(Y.data)}}ye.from=Fe;function ue(Y){return new n.$SM(Y.valueBytes.buffer,Y.mime)}ye.to=ue})(Ut||(e.NotebookCellOutputItem=Ut={}));var Et;(function(ye){function Fe(Y){return{outputId:Y.id,items:Y.items.map(Ut.from),metadata:Y.metadata}}ye.from=Fe;function ue(Y){const Re=Y.items.map(Ut.to);return new n.$TM(Re,Y.outputId,Y.metadata)}ye.to=ue})(Et||(e.NotebookCellOutput=Et={}));var ei;(function(ye){function Fe(Re){return Y(Re)?{include:pe.from(Re.include)??void 0,exclude:pe.from(Re.exclude)??void 0}:pe.from(Re)??void 0}ye.from=Fe;function ue(Re){return Y(Re)?{include:pe.to(Re.include),exclude:pe.to(Re.exclude)}:pe.to(Re)}ye.to=ue;function Y(Re){const je=Re;return je?!(0,l.$Sf)(je.include)&&!(0,l.$Sf)(je.exclude):!1}})(ei||(e.NotebookExclusiveDocumentPattern=ei={}));var jt;(function(ye){function Fe(ue,Y,Re){const je=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(je,Re),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}ye.from=Fe})(jt||(e.NotebookStatusBarItem=jt={}));var ni;(function(ye){function Fe(ue,Y,Re){const je=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{command:Y.toInternal(je,Re),label:ue.label,description:ue.description,detail:ue.detail,documentation:ue.documentation}}ye.from=Fe})(ni||(e.NotebookKernelSourceAction=ni={}));var Yt;(function(ye){function Fe(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{},cellContentMetadata:ue?.cellContentMetadata??{}}}ye.from=Fe})(Yt||(e.NotebookDocumentContentOptions=Yt={}));var Qt;(function(ye){function Fe(Y){return{uri:Y.uri,provides:Y.provides}}ye.from=Fe;function ue(Y){return new n.$VM($.URI.revive(Y.uri),Y.provides)}ye.to=ue})(Qt||(e.NotebookRendererScript=Qt={}));var Xe;(function(ye){function Fe(Y){return{message:F.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,contextValue:Y.contextValue,location:Y.location&&{range:h.from(Y.location.range),uri:Y.location.uri}}}ye.from=Fe;function ue(Y){const Re=new n.$2M(typeof Y.message=="string"?Y.message:F.to(Y.message));return Re.actualOutput=Y.actual,Re.expectedOutput=Y.expected,Re.contextValue=Y.contextValue,Re.location=Y.location?Pe.to(Y.location):void 0,Re}ye.to=ue})(Xe||(e.TestMessage=Xe={}));var Bt;(function(ye){ye.namespace=u.$jK,ye.denamespace=u.$kK})(Bt||(e.TestTag=Bt={}));var ti;(function(ye){function Fe(Y){const Re=(0,s.$wN)(Y).controllerId;return{extId:a.$fK.fromExtHostTestItem(Y,Re).toString(),label:Y.label,uri:$.URI.revive(Y.uri),busy:Y.busy,tags:Y.tags.map(je=>Bt.namespace(Re,je.id)),range:w.$Ws.lift(h.from(Y.range)),description:Y.description||null,sortText:Y.sortText||null,error:Y.error&&F.fromStrict(Y.error)||null}}ye.from=Fe;function ue(Y){return{parent:void 0,error:void 0,id:a.$fK.fromString(Y.extId).localId,label:Y.label,uri:$.URI.revive(Y.uri),tags:(Y.tags||[]).map(Re=>{const{tagId:je}=Bt.denamespace(Re);return new n.$3M(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:h.to(Y.range||void 0),canResolveChildren:!1,busy:Y.busy,description:Y.description||void 0,sortText:Y.sortText||void 0}}ye.toPlain=ue})(ti||(e.TestItem=ti={})),function(ye){function Fe(Y){return{id:Y.id}}ye.from=Fe;function ue(Y){return new n.$3M(Y.id)}ye.to=ue}(Bt||(e.TestTag=Bt={}));var ht;(function(ye){const Fe=(Y,Re)=>{const je=[];for(const[Ke,nt]of Re)a.$fK.compare(nt.item.extId,Ke)===2&&(Re.delete(Ke),je.push(nt));const Qe={...ti.toPlain(Y.item),parent:void 0,taskStates:Y.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(nt=>nt.type===0).map(Xe.to)})),children:je.map(Ke=>Fe(Ke,Re))};for(const Ke of Qe.children)Ke.parent=Qe;return Qe};function ue(Y){const Re=[],je=new Map;for(const Qe of Y.items){je.set(Qe.item.extId,Qe);const Ke=a.$fK.root(Qe.item.extId);Y.request.targets.some(nt=>nt.controllerId===Ke&&nt.testIds.includes(Qe.item.extId))&&Re.push(Qe)}return{completedAt:Y.completedAt,results:Re.map(Qe=>Fe(Qe,je))}}ye.to=ue})(ht||(e.TestResults=ht={}));var mt;(function(ye){function Fe(je){return{covered:je.covered,total:je.total}}function ue(je){return"line"in je?g.from(je):h.from(je)}function Y(je){return"branches"in je?{count:je.executed,location:ue(je.location),type:1,branches:je.branches.length?je.branches.map(Qe=>({count:Qe.executed,location:Qe.location&&ue(Qe.location),label:Qe.label})):void 0}:{type:0,name:je.name,count:je.executed,location:ue(je.location)}}ye.fromDetailed=Y;function Re(je){return{uri:je.uri,statement:Fe(je.statementCoverage),branch:je.branchCoverage&&Fe(je.branchCoverage),declaration:je.declarationCoverage&&Fe(je.declarationCoverage),details:je.detailedCoverage?.map(Y)}}ye.fromFile=Re})(mt||(e.TestCoverage=mt={}));var Kt;(function(ye){function Fe(ue){switch(ue){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}ye.to=Fe})(Kt||(e.CodeActionTriggerKind=Kt={}));var ii;(function(ye){function Fe(Y){const Re=new n.$9M($e.to(Y.kind),Y.name,Y.detail||"",$.URI.revive(Y.uri),h.to(Y.range),h.to(Y.selectionRange));return Re._sessionId=Y._sessionId,Re._itemId=Y._itemId,Re}ye.to=Fe;function ue(Y,Re,je){if(Re=Re??Y._sessionId,je=je??Y._itemId,Re===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:je,kind:$e.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:h.from(Y.range),selectionRange:h.from(Y.selectionRange),tags:Y.tags?.map(te.from)}}ye.from=ue})(ii||(e.TypeHierarchyItem=ii={}));var Pt;(function(ye){function Fe(ue){if(ue)return{value:ue.value,tooltip:ue.tooltip}}ye.from=Fe})(Pt||(e.ViewBadge=Pt={}));var dt;(function(ye){function Fe(je,Qe,Ke){const nt=Qe.fileData;return nt?new n.$gM(new n.$hM(nt.name,$.URI.revive(nt.uri),nt.id,(0,A.$db)(()=>Ke(nt.id)))):je===L.$hs.uriList&&Qe.uriListData?new n.$fM(Re(Qe.uriListData)):new n.$fM(Qe.asString)}ye.to=Fe;async function ue(je,Qe){const Ke=await Qe.asString();if(je===L.$hs.uriList)return{asString:Ke,fileData:void 0,uriListData:Y(Ke)};const nt=Qe.asFile();return{asString:Ke,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}ye.from=ue;function Y(je){return I.$tt.split(je).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return $.URI.parse(Qe)}catch{}return Qe})}function Re(je){return I.$tt.create(je.map(Qe=>typeof Qe=="string"?Qe:$.URI.revive(Qe)))}})(dt||(e.DataTransferItem=dt={}));var Rt;(function(ye){function Fe(Y,Re){const je=Y.items.map(([Qe,Ke])=>[Qe,dt.to(Qe,Ke,Re)]);return new n.$iM(je)}ye.toDataTransfer=Fe;async function ue(Y){const Re={items:[]},je=[];for(const[Qe,Ke]of Y)je.push((async()=>{Re.items.push([Qe,await dt.from(Qe,Ke)])})());return await Promise.all(je),Re}ye.from=ue})(Rt||(e.DataTransfer=Rt={}));var oi;(function(ye){function Fe(ue){return{kind:"reply",message:ue.message,title:ue.title,tooltip:ue.tooltip}}ye.from=Fe})(oi||(e.ChatFollowup=oi={}));var Lt;(function(ye){function Fe(ue){return"commandId"in ue?{kind:"command",title:ue.title??"",commandId:ue.commandId??"",when:ue.when??"",args:ue.args}:{kind:"reply",message:ue.message,title:ue.title,tooltip:ue.tooltip}}ye.from=Fe})(Lt||(e.ChatInlineFollowup=Lt={}));var He;(function(ye){function Fe(Y){const Re=new n.$iN(Ft.to(Y.role),Y.content);return Re.name=Y.name,Re}ye.to=Fe;function ue(Y){return{role:Ft.from(Y.role),content:Y.content,name:Y.name}}ye.from=ue})(He||(e.ChatMessage=He={}));var Ft;(function(ye){function Fe(Y){switch(Y){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant}}ye.to=Fe;function ue(Y){switch(Y){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.User:default:return 1}}ye.from=ue})(Ft||(e.ChatMessageRole=Ft={}));var Wt;(function(ye){function Fe(Re){const je={};for(const Qe of Object.keys(Re))je[Qe]=Re[Qe].map(ye.to);return je}ye.objectTo=Fe;function ue(Re){return{level:Zt.to(Re.level),kind:Re.kind,value:(0,$.$vc)(Re.value)?$.URI.revive(Re.value):Re.value,description:Re.description}}ye.to=ue;function Y(Re){return{level:Zt.from(Re.level),kind:Re.kind,value:Re.value,description:Re.description}}ye.from=Y})(Wt||(e.ChatVariable=Wt={}));var Zt;(function(ye){function Fe(Y){switch(Y){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}ye.to=Fe;function ue(Y){switch(Y){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}ye.from=ue})(Zt||(e.ChatVariableLevel=Zt={}));var ft;(function(ye){function Fe(ue){switch(ue){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return n.InteractiveEditorResponseFeedbackKind.Bug}}ye.to=Fe})(ft||(e.InteractiveEditorResponseFeedbackKind=ft={}));var Tt;(function(ye){function Fe(Y){return{kind:"markdownContent",content:F.from(new n.$RL().appendText(Y.value))}}ye.to=Fe;function ue(Y){return new n.$jN(Y.content.value)}ye.from=ue})(Tt||(e.ChatResponseTextPart=Tt={}));var Ct;(function(ye){function Fe(Y){return{kind:"markdownContent",content:F.from(Y.value)}}ye.to=Fe;function ue(Y){return new n.$kN(F.to(Y.content))}ye.from=ue})(Ct||(e.ChatResponseMarkdownPart=Ct={}));var Nt;(function(ye){function Fe(Y){const{value:Re,baseUri:je}=Y;function Qe(Ke,nt){return Ke.map(bt=>{const qt=$.URI.joinPath(nt,bt.name);return{label:bt.name,uri:qt,children:bt.children&&Qe(bt.children,qt)}})}return{kind:"treeData",treeData:{label:(0,b.$Fg)(je),uri:je,children:Qe(Re,je)}}}ye.to=Fe;function ue(Y){const Re=(0,D.$Eh)(Y.treeData);function je(nt){return nt.map(bt=>({name:bt.label,children:bt.children&&je(bt.children)}))}const Qe=Re.uri,Ke=Re.children?je(Re.children):[];return new n.$lN(Ke,Qe)}ye.from=ue})(Nt||(e.ChatResponseFilesPart=Nt={}));var Vt;(function(ye){function Fe(Y){return{kind:"inlineReference",name:Y.title,inlineReference:$.URI.isUri(Y.value)?Y.value:v.from(Y.value)}}ye.to=Fe;function ue(Y){const Re=(0,D.$Eh)(Y);return new n.$mN($.URI.isUri(Re.inlineReference)?Re.inlineReference:v.to(Re.inlineReference),Y.name)}ye.from=ue})(Vt||(e.ChatResponseAnchorPart=Vt={}));var Ot;(function(ye){function Fe(Y){return{kind:"progressMessage",content:F.from(Y.value)}}ye.to=Fe;function ue(Y){return new n.$nN(Y.content.value)}ye.from=ue})(Ot||(e.ChatResponseProgressPart=Ot={}));var St;(function(ye){function Fe(Y,Re,je){return{kind:"command",command:Re.toInternal(Y.value,je)??{command:Y.value.command,title:Y.value.title}}}ye.to=Fe;function ue(Y,Re){return new n.$oN(Re.fromInternal(Y.command)??{command:Y.command.id,title:Y.command.title})}ye.from=ue})(St||(e.ChatResponseCommandButtonPart=St={}));var zt;(function(ye){function Fe(Y){return{kind:"reference",reference:$.URI.isUri(Y.value)?Y.value:v.from(Y.value)}}ye.to=Fe;function ue(Y){const Re=(0,D.$Eh)(Y);return new n.$pN($.URI.isUri(Re.reference)?Re.reference:v.to(Re.reference))}ye.from=ue})(zt||(e.ChatResponseReferencePart=zt={}));var Dt;(function(ye){function Fe(Y){return Y instanceof n.$kN?Ct.to(Y):Y instanceof n.$mN?Vt.to(Y):Y instanceof n.$pN?zt.to(Y):Y instanceof n.$nN?Ot.to(Y):Y instanceof n.$lN?Nt.to(Y):{kind:"content",content:""}}ye.to=Fe;function ue(Y,Re){switch(Y.kind){case"markdownContent":return Ct.from(Y);case"inlineReference":return Vt.from(Y);case"reference":return zt.from(Y);case"progressMessage":return Ot.from(Y);case"treeData":return Nt.from(Y);case"command":return St.from(Y,Re)}return new n.$jN("")}ye.from=ue})(Dt||(e.ChatResponsePart=Dt={}));var yt;(function(ye){function Fe(Re,je){return"markdownContent"in je?((0,d.$LF)(Re,"chatAgents2Additions"),{content:F.from(je.markdownContent),kind:"markdownContent"}):"content"in je?"vulnerabilities"in je&&je.vulnerabilities?((0,d.$LF)(Re,"chatAgents2Additions"),{content:je.content,vulnerabilities:je.vulnerabilities,kind:"vulnerability"}):typeof je.content=="string"?{content:je.content,kind:"content"}:((0,d.$LF)(Re,"chatAgents2Additions"),{content:F.from(je.content),kind:"markdownContent"}):"documents"in je?{documents:je.documents.map(Qe=>({uri:Qe.uri,version:Qe.version,ranges:Qe.ranges.map(Ke=>h.from(Ke))})),kind:"usedContext"}:"reference"in je?{reference:"uri"in je.reference?{uri:je.reference.uri,range:h.from(je.reference.range)}:je.reference,kind:"reference"}:"inlineReference"in je?{inlineReference:"uri"in je.inlineReference?{uri:je.inlineReference.uri,range:h.from(je.inlineReference.range)}:je.inlineReference,name:je.title,kind:"inlineReference"}:"agentName"in je?((0,d.$LF)(Re,"chatAgents2Additions"),{agentName:je.agentName,command:je.command,kind:"agentDetection"}):"treeData"in je?{treeData:je.treeData,kind:"treeData"}:"message"in je?{content:F.from(je.message),kind:"progressMessage"}:void 0}ye.from=Fe;function ue(Re){switch(Re.kind){case"markdownContent":case"inlineReference":case"treeData":return ye.to(Re);case"content":return{content:Re.content};case"usedContext":return{documents:Re.documents.map(je=>({uri:$.URI.revive(je.uri),version:je.version,ranges:je.ranges.map(Qe=>h.to(Qe))}))};case"reference":return{reference:(0,$.$vc)(Re.reference)?$.URI.revive(Re.reference):v.to(Re.reference)};case"agentDetection":return;case"progressMessage":return{message:Re.content.value};case"vulnerability":return{content:Re.content,vulnerabilities:Re.vulnerabilities};default:return}}ye.to=ue;function Y(Re,je){switch(Re.kind){case"markdownContent":return{content:Re.content.value};case"inlineReference":return{inlineReference:(0,$.$vc)(Re.inlineReference)?$.URI.revive(Re.inlineReference):v.to(Re.inlineReference),title:Re.name};case"treeData":return{treeData:(0,D.$Eh)(Re.treeData)};case"command":return{command:je.fromInternal(Re.command)??{command:Re.command.id,title:Re.command.title}};default:return}}ye.toProgressContent=Y})(yt||(e.ChatResponseProgress=yt={}));var It;(function(ye){function Fe(ue){return{prompt:ue.message,variables:Wt.objectTo(ue.variables),command:ue.command,agentId:ue.agentId}}ye.to=Fe})(It||(e.ChatAgentRequest=It={}));var kt;(function(ye){function Fe(ue){return{label:ue.label,values:ue.values.map(Wt.from),insertText:ue.insertText,detail:ue.detail,documentation:ue.documentation}}ye.from=Fe})(kt||(e.ChatAgentCompletionItem=kt={}));var li;(function(ye){function Fe(ue){return{errorDetails:ue.errorDetails,metadata:ue.metadata}}ye.to=Fe})(li||(e.ChatAgentResult=li={}));var Gt;(function(ye){function Fe(ue,Y,Re){return"terminalCommand"in ue?{terminalCommand:ue.terminalCommand,shouldExecute:ue.shouldExecute}:"uri"in ue?{uri:ue.uri}:Y.toInternal(ue,Re)}ye.from=Fe})(Gt||(e.TerminalQuickFix=Gt={}))}),define(Ae[247],Me([1,0,3,17,8]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;let A=class{constructor(m,f){this.a=m.getProxy(S.$oL.MainThreadBulkEdits),this.b={getTextDocumentVersion:D=>f.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,f,D){const L=I.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,D?.isRefactoring??!1)}};e.$Fgc=A,e.$Fgc=A=Je([qe(0,M.$AN)],A)}),define(Ae[248],Me([1,0,18,11,41,5,46,6,63,2,158,3,8,7,207,25]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;class c{constructor(a,u,t,d,n,b){this.i=a,this.j=u,this.k=t,this.l=d,this.m=n,this.n=b,this.a=f.$Sd.create(!1),this.b=!1}close(){this.b=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.a.elapsed()}}get apiObject(){if(!this.g){let u=function(d){if(a.b){const n=new Error("Response stream has been closed");throw Error.captureStackTrace(n,d),n}};const a=this;this.a.reset();const t=d=>{typeof this.d>"u"&&"content"in d&&(this.d=this.a.elapsed()),this.k.$handleProgressChunk(this.j.requestId,d)};this.g={text(d){return u(this.text),this.markdown(new R.$jk().appendText(d)),this},markdown(d){u(this.markdown);const n=new $.$kN(d),b=l.ChatResponseMarkdownPart.to(n);return t(b),this},filetree(d,n){u(this.filetree);const b=new $.$lN(d,n),E=l.ChatResponseFilesPart.to(b);return t(E),this},anchor(d,n){u(this.anchor);const b=new $.$mN(d,n),E=l.ChatResponseAnchorPart.to(b);return t(E),this},button(d){u(this.anchor);const n=new $.$oN(d),b=l.ChatResponseCommandButtonPart.to(n,a.m,a.n);return t(b),this},progress(d){u(this.progress);const n=new $.$nN(d),b=l.ChatResponseProgressPart.to(n);return t(b),this},reference(d){u(this.reference);const n=new $.$pN(d),b=l.ChatResponseReferencePart.to(n);return t(b),this},push(d){u(this.push);const n=l.ChatResponsePart.to(d);return t(n),this},report(d){if(u(this.report),"placeholder"in d&&"resolvedContent"in d)return;const n=l.ChatResponseProgress.from(a.i,d);if(!n){a.l.error("Unknown progress type: "+JSON.stringify(d));return}return t(n),this}}}return this.g}}class s{static{this.a=0}constructor(a,u,t,d){this.i=u,this.j=t,this.k=d,this.b=new Map,this.g=new m.$3c,this.d=a.getProxy(k.$oL.MainThreadChatAgents2)}createChatAgent(a,u,t){const d=s.a++,n=new i(a,u,this.d,d,t);return this.b.set(d,n),this.d.$registerAgent(d,u,{}),n.apiAgent}async $invokeAgent(a,u,t,d){const n=this.b.get(a);if(!n)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);this.i.$updateAccesslist([{extension:n.extension.identifier,enabled:!0}]);let b=this.g.get(u.sessionId);b||(b=new m.$Sc,this.g.set(u.sessionId,b));const E=new c(n.extension,u,this.d,this.j,this.k.converter,b);try{const h=await this.l(u,t),v=n.invoke(l.ChatAgentRequest.to(u),{history:h},E.apiObject,d);return await(0,M.$Vg)(Promise.resolve(v).then(P=>{if(P?.metadata)try{JSON.stringify(P.metadata)}catch(g){const p=`result.metadata MUST be JSON.stringify-able. Got error: ${g.message}`;return this.j.error(`[${n.extension.identifier.value}] [@${n.id}] ${p}`,n.extension),{errorDetails:{message:p},timings:E.timings}}return{errorDetails:P?.errorDetails,timings:E.timings,metadata:P?.metadata}}),d)}catch(h){return this.j.error(h,n.extension),{errorDetails:{message:(0,L.localize)(0,null,(0,I.$Si)(h)),responseIsIncomplete:!0}}}finally{E.close(),this.i.$updateAccesslist([{extension:n.extension.identifier,enabled:!1}])}}async l(a,u){return(0,S.$Hb)(await Promise.all(u.history.map(async t=>{const d=l.ChatAgentResult.to(t.result),n=a.agentId===t.request.agentId?d:{...d,metadata:void 0};return{request:l.ChatAgentRequest.to(t.request),response:(0,S.$Hb)(t.response.map(b=>l.ChatResponsePart.from(b,this.k.converter))),result:n}})))}$releaseSession(a){this.g.deleteAndDispose(a)}async $provideSlashCommands(a,u){const t=this.b.get(a);return t?t.provideSlashCommands(u):[]}$provideFollowups(a,u,t){const d=this.b.get(a);if(!d)return Promise.resolve([]);const n=l.ChatAgentResult.to(u);return d.provideFollowups(n,t)}$acceptFeedback(a,u,t,d){const n=this.b.get(a);if(!n)return;const b=l.ChatAgentResult.to(u);let E;switch(t){case w.InteractiveSessionVoteDirection.Down:E=$.ChatAgentResultFeedbackKind.Unhelpful;break;case w.InteractiveSessionVoteDirection.Up:E=$.ChatAgentResultFeedbackKind.Helpful;break}n.acceptFeedback(Object.freeze(d?{result:b,kind:E,reportIssue:d}:{result:b,kind:E}))}$acceptAction(a,u,t){const d=this.b.get(a);if(!d||t.action.kind==="vote")return;const n=l.ChatAgentResult.to(u);if(t.action.kind==="command"){const b={kind:"command",commandButton:l.ChatResponseProgress.toProgressContent(t.action.commandButton,this.k.converter)};d.acceptAction(Object.freeze({action:b,result:n}));return}else d.acceptAction(Object.freeze({action:t.action,result:n}))}async $invokeCompletionProvider(a,u,t){const d=this.b.get(a);return d?(await d.invokeCompletionProvider(u,t)).map(l.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(a,u){const t=this.b.get(a);if(t)return await t.provideWelcomeMessage(u)}async $provideSampleQuestions(a,u){const t=this.b.get(a);if(t)return await t.provideSampleQuestions(u)}}e.$Igc=s;class i{constructor(a,u,t,d,n){this.extension=a,this.id=u,this.u=t,this.w=d,this.x=n,this.o=new A.$Wd,this.p=new A.$Wd}acceptFeedback(a){this.o.fire(a)}acceptAction(a){this.p.fire(a)}async invokeCompletionProvider(a,u){return this.s?await this.s.provider.provideCompletionItems(a,u)??[]:[]}async provideSlashCommands(a){if(!this.a)return[];const u=await this.a.provideCommands(a);return u?u.map(t=>({name:t.name,description:t.description,followupPlaceholder:t.followupPlaceholder,shouldRepopulate:t.shouldRepopulate,sampleRequest:t.sampleRequest})):[]}async provideFollowups(a,u){if(!this.b)return[];const t=await this.b.provideFollowups(a,u);return t?t.filter(d=>!(d&&"commandId"in d)).map(d=>l.ChatFollowup.from(d)):[]}async provideWelcomeMessage(a){if(!this.t)return[];const u=await this.t.provideWelcomeMessage(a);return u?u.map(t=>typeof t=="string"?t:l.MarkdownString.from(t)):[]}async provideSampleQuestions(a){if(!this.t||!this.t.provideSampleQuestions)return[];const u=await this.t.provideSampleQuestions(a);return u?u?.map(t=>l.ChatFollowup.from(t)):[]}get apiAgent(){let a=!1,u=!1;const t=()=>{a||u||(u=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.d??"",fullName:this.g,icon:this.i?this.i instanceof D.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof $.$lM?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.b!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q}),u=!1}))},d=this;return{get name(){return d.id},get description(){return d.d??""},set description(n){d.d=n,t()},get fullName(){return d.g??d.extension.displayName??d.extension.name},set fullName(n){d.g=n,t()},get iconPath(){return d.i},set iconPath(n){d.i=n,t()},get commandProvider(){return d.a},set commandProvider(n){d.a=n,t()},get followupProvider(){return d.b},set followupProvider(n){d.b=n,t()},get isDefault(){return(0,r.$LF)(d.extension,"defaultChatAgent"),d.j},set isDefault(n){(0,r.$LF)(d.extension,"defaultChatAgent"),d.j=n,t()},get helpTextPrefix(){return(0,r.$LF)(d.extension,"defaultChatAgent"),d.k},set helpTextPrefix(n){if((0,r.$LF)(d.extension,"defaultChatAgent"),!d.j)throw new Error("helpTextPrefix is only available on the default chat agent");d.k=n,t()},get helpTextPostfix(){return(0,r.$LF)(d.extension,"defaultChatAgent"),d.l},set helpTextPostfix(n){if((0,r.$LF)(d.extension,"defaultChatAgent"),!d.j)throw new Error("helpTextPostfix is only available on the default chat agent");d.l=n,t()},get isSecondary(){return(0,r.$LF)(d.extension,"defaultChatAgent"),d.n},set isSecondary(n){(0,r.$LF)(d.extension,"defaultChatAgent"),d.n=n,t()},get sampleRequest(){return d.m},set sampleRequest(n){d.m=n,t()},get supportIssueReporting(){return(0,r.$LF)(d.extension,"chatAgents2Additions"),d.q},set supportIssueReporting(n){(0,r.$LF)(d.extension,"chatAgents2Additions"),d.q=n,t()},get onDidReceiveFeedback(){return d.o.event},set agentVariableProvider(n){if(d.s=n,n){if(!n.triggerCharacters.length)throw new Error("triggerCharacters are required");d.u.$registerAgentCompletionsProvider(d.w,n.triggerCharacters)}else d.u.$unregisterAgentCompletionsProvider(d.w)},get agentVariableProvider(){return d.s},set welcomeMessageProvider(n){d.t=n,t()},get welcomeMessageProvider(){return d.t},onDidPerformAction:(0,r.$KF)(this.extension,"chatAgents2Additions")?this.p.event:void 0,dispose(){a=!0,d.a=void 0,d.b=void 0,d.o.dispose(),d.u.$unregisterAgent(d.w)}}}invoke(a,u,t,d){return this.x(a,u,t,d)}}}),define(Ae[249],Me([1,0,21,6,3,8,99,22,11,5,159,104]),function(fe,e,S,M,I,A,R,m,f,D,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;class l{constructor(c,s){this.option=c,this.stream=new f.$yh,this.stream=s??new f.$yh}}class ${constructor(c,s){this.cts=s,this.a=new Map,this.b=new f.$yh,this.c=!1;const i=this;this.apiObject={result:c,stream:i.b.asyncIterable},c.finally(()=>{if(this.c=!0,this.a.size>0)for(const[,o]of this.a)o.stream.resolve();else this.b.resolve()})}handleFragment(c){if(this.c)return;let s=this.a.get(c.index);s||(this.a.size===0?s=new l(c.index,this.b):s=new l(c.index),this.a.set(c.index,s)),s.stream.emitOne(c.part)}}class w{static{this.a=1}constructor(c,s,i){this.j=s,this.k=i,this.c=new D.$Wd,this.d=new D.$Wd,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Set,this.h=new m.$pm,this.i=new Map,this.b=c.getProxy(I.$oL.MainThreadChatProvider)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(c,s,i,o){const a=w.a++;return this.f.set(a,{extension:c,provider:i}),this.b.$registerProvider(a,s,{extension:c,model:o.name??""}),(0,M.$Rc)(()=>{this.f.delete(a),this.b.$unregisterProvider(a)})}async $provideLanguageModelResponse(c,s,i,o,a,u){const t=this.f.get(c);if(!t)return;const d=new R.$xv(async n=>{if(u.isCancellationRequested){this.j.warn(`[CHAT](${t.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(s,{index:n.index,part:n.part})});return t.provider.provideLanguageModelResponse(o.map(A.ChatMessage.to),a,m.$nm.toKey(i),d,u)}$updateLanguageModels(c){const s=[],i=[];if(c.added)for(const o of c.added)this.g.add(o),s.push(o);if(c.removed)for(const o of c.removed){this.g.delete(o),i.push(o);for(const[a,u]of this.i)u.languageModelId===o&&(u.res.cts.cancel(),this.i.delete(a))}this.d.fire(Object.freeze({added:Object.freeze(s),removed:Object.freeze(i)}))}getLanguageModelIds(){return Array.from(this.g)}$updateAccesslist(c){const s=new m.$om;for(const{extension:i,enabled:o}of c)this.h.get(i)!==o&&(this.h.set(i,o),s.add(i));this.c.fire(s)}async requestLanguageModelAccess(c,s,i){const o=c.identifier;if(this.h.get(o)===!1)throw new Error("Extension is NOT allowed to make chat requests");const a=i?.justification,u=await this.b.$prepareChatAccess(o,s,a);if(!u)throw this.h.get(o)?new Error(`Language model '${s}' NOT found`):new Error("Extension is NOT allowed to make chat requests");await this.l(c,s,a);const t=this;return{get model(){return u.model},get isRevoked(){return!t.h.get(o)||!t.g.has(s)},get onDidChangeAccess(){const d=D.Event.filter(t.c.event,b=>b.has(o)),n=D.Event.filter(t.d.event,b=>b.removed.includes(s));return D.Event.signal(D.Event.any(d,n))},makeChatRequest(d,n,b){if(!t.h.get(o))throw new Error("Access to chat has been revoked");if(!t.g.has(s))throw new Error("Language Model has been removed");const E=new S.$7d(b),h=Math.random()*1e6|0,v=t.b.$fetchResponse(o,s,h,d.map(A.ChatMessage.from),n??{},E.token),P=new $(v,E);return t.i.set(h,{languageModelId:s,res:P}),v.finally(()=>{t.i.delete(h),E.dispose()}),P.apiObject}}}async $handleResponseFragment(c,s){const i=this.i.get(c);i&&i.res.handleFragment(s)}async l(c,s,i){const o=k.$uK+s;if(!await this.k.getSession(c,o,[],{silent:!0}))try{await this.k.getSession(c,o,[],{forceNewSession:{detail:i??(0,L.localize)(0,null,s)}})}catch{throw new Error("Access to language model has not been granted")}}}e.$Hgc=w}),define(Ae[250],Me([1,0,6,3,15,8]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;class R{static{this.a=0}constructor(f){this.b=new Map,this.c=f.getProxy(M.$oL.MainThreadChatVariables)}async $resolveVariable(f,D,L){const k=this.b.get(f);if(k)try{const l=await k.resolver.resolve(k.data.name,{prompt:D},L);if(l)return l.map(A.ChatVariable.from)}catch(l){(0,I.$2)(l)}}registerVariableResolver(f,D,L,k){const l=R.a++;return this.b.set(l,{extension:f.identifier,data:{name:D,description:L},resolver:k}),this.c.$registerVariable(l,{name:D,description:L}),(0,S.$Rc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$Jgc=R}),define(Ae[251],Me([1,0,11,67,5,6,2,86,22,8,7,3,25]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;function $(w,r,c){const s=w.getProxy(k.$oL.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new f.$pm,r.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const v=this.b.get(h.handle);return v?v.value:h}else if(h&&h.$mid===7){const v=this.b.get(h.commentControlHandle);if(!v)return h;const P=v.getCommentThread(h.commentThreadHandle);return P?P.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const v=this.b.get(h.thread.commentControlHandle);if(!v)return h;const P=v.getCommentThread(h.thread.commentThreadHandle);return P?h.$mid===8?P.value:{thread:P.value,text:h.text}:h}else if(h&&h.$mid===10){const v=this.b.get(h.thread.commentControlHandle);if(!v)return h;const P=v.getCommentThread(h.thread.commentThreadHandle);if(!P)return h;const g=h.commentUniqueId,p=P.getCommentByUniqueId(g);return p||h}else if(h&&h.$mid===11){const v=this.b.get(h.thread.commentControlHandle);if(!v)return h;const P=v.getCommentThread(h.thread.commentThreadHandle);if(!P)return h;const g=h.text,p=h.commentUniqueId,y=P.getCommentByUniqueId(p);return y?(typeof y.body=="string"?y.body=g:y.body=new L.$RL(g),y):h}return h}})}createCommentController(h,v,P){const g=i.a++,p=new a(h,g,v,P);this.b.set(p.handle,p);const y=this.c.get(h.identifier)||[];return y.push(p),this.c.set(h.identifier,y),p.value}async $createCommentThreadTemplate(h,v,P){const g=this.b.get(h);g&&g.$createCommentThreadTemplate(v,P)}async $setActiveComment(h,v){const P=this.b.get(h);P&&P.$setActiveComment(v??void 0)}async $updateCommentThreadTemplate(h,v,P){const g=this.b.get(h);g&&g.$updateCommentThreadTemplate(v,P)}$deleteCommentThread(h,v){this.b.get(h)?.$deleteCommentThread(v)}$provideCommentingRanges(h,v,P){const g=this.b.get(h);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const p=c.getDocument(R.URI.revive(v));return(0,S.$Zg)(async()=>{const y=await g.commentingRangeProvider.provideCommentingRanges(p,P);let T;return Array.isArray(y)?T={ranges:y,fileComments:!1}:y?T={ranges:y.ranges||[],fileComments:y.fileComments||!1}:T=y??void 0,T}).then(y=>{let T;return y&&(T={ranges:y.ranges.map(N=>D.Range.from(N)),fileComments:y.fileComments}),T})}$toggleReaction(h,v,P,g,p){const y=this.b.get(h);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,S.$Zg)(()=>{const T=y.getCommentThread(v);if(T){const N=T.getCommentByUniqueId(g.uniqueIdInThread);if(y!==void 0&&N&&y.reactionHandler)return y.reactionHandler(N,d(p))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,v,P,g,p,y,T,N){this.m=v,this.n=P,this.o=g,this.p=p,this.q=y,this.extensionDescription=T,this.r=N,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Wd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Uc,this.l.value=new A.$Sc,this.n===void 0&&(this.n=`${h}.${this.handle}`),s.$createCommentThread(v,this.handle,this.n,this.o,D.Range.from(this.p),T.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{s.$deleteCommentThread(v,this.handle)}});const J=this;this.value={get uri(){return J.uri},get range(){return J.range},set range(q){J.range=q},get comments(){return J.comments},set comments(q){J.comments=q},get collapsibleState(){return J.collapsibleState},set collapsibleState(q){J.collapsibleState=q},get canReply(){return J.canReply},set canReply(q){J.canReply=q},get contextValue(){return J.contextValue},set contextValue(q){J.contextValue=q},get label(){return J.label},set label(q){J.label=q},get state(){return J.state},set state(q){J.state=q},dispose:()=>{J.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Sc);const h=P=>Object.prototype.hasOwnProperty.call(this.b,P),v={};h("range")&&(v.range=D.Range.from(this.p)),h("label")&&(v.label=this.label),h("contextValue")&&(v.contextValue=this.contextValue??null),h("comments")&&(v.comments=this.q.map(P=>u(this,P,this.k,this.extensionDescription))),h("collapsibleState")&&(v.collapseState=n(this.g)),h("canReply")&&(v.canReply=this.canReply),h("state")&&(v.state=b(this.h)),h("isTemplate")&&(v.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(h){for(const v of this.k){const P=v[0],g=v[1];if(h===g)return P}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}Je([(0,M.$Ah)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$LF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$LF)(this.h,"activeComment"),this.f}constructor(h,v,P,g){this.h=h,this.i=v,this.j=P,this.k=g,this.a=new Map,s.$registerCommentController(this.handle,P,g,this.h.identifier.value);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(y){p.options=y},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(y){p.commentingRangeProvider=y},get reactionHandler(){return p.reactionHandler},set reactionHandler(y){p.reactionHandler=y},get activeCommentThread(){return p.activeCommentThread},createCommentThread(y,T,N){return p.createCommentThread(y,T,N).value},dispose:()=>{p.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(h,v,P){v===void 0&&(0,l.$LF)(this.h,"fileComments");const g=new o(this.id,this.handle,void 0,h,v,P,this.h,!1);return this.a.set(g.handle,g),g}$setActiveComment(h){if(!h){this.e=void 0,this.f=void 0;return}const v=this.a.get(h.commentThreadHandle);v&&(this.e=h.uniqueIdInThread?v.getCommentByUniqueId(h.uniqueIdInThread):void 0,this.f=v)}$createCommentThreadTemplate(h,v){const P=new o(this.id,this.handle,void 0,R.URI.revive(h),D.Range.to(v),[],this.h,!0);return P.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(P.handle,P),P}$updateCommentThreadTemplate(h,v){const P=this.a.get(h);P&&(P.range=D.Range.to(v))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.g.forEach(h=>h.dispose())}}function u(E,h,v,P){let g=v.get(h);return g||(g=++E.commentHandle,v.set(h,g)),h.state!==void 0&&(0,l.$LF)(P,"commentsDraftState"),h.reactions?.some(p=>p.reactors!==void 0)&&(0,l.$LF)(P,"commentReactor"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:g,body:typeof h.body=="string"?h.body:D.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(p=>t(p)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(E){return{label:E.label,iconPath:E.iconPath?D.$zN(E.iconPath):void 0,count:E.count,hasReacted:E.authorHasReacted,reactors:E.reactors&&E.reactors.length>0&&typeof E.reactors[0]!="string"?E.reactors.map(h=>h.name):E.reactors}}function d(E){return{label:E.label||"",count:E.count||0,iconPath:E.iconPath?R.URI.revive(E.iconPath):"",authorHasReacted:E.hasReacted||!1,reactors:E.reactors?.map(h=>({name:h}))}}function n(E){if(E!==void 0)switch(E){case L.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function b(E){if(E!==void 0)switch(E){case L.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new i}e.$Ngc=$}),define(Ae[252],Me([1,0,21,97,6,12,24,2,8,61,74,3,7]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;class ${constructor(d,n){this.document=d,this.b=n,this.a=1,this.c=new L.$sgc("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,n){await this.f(d).undo(),n||this.disposeBackup()}async redo(d,n){await this.f(d).redo(),n||this.disposeBackup()}disposeEdits(d){for(const n of d)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=u(this.document.uri)+this.a++;return(0,R.$Ig)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const n=this.c.get(d,0);if(!n)throw new Error("No edit found");return n}}class w{constructor(){this.a=new Map}get(d,n){return this.a.get(this.b(d,n))}add(d,n,b){const E=this.b(d,n.uri);if(this.a.has(E))throw new Error(`Document already exists for viewType:${d} resource:${n.uri}`);const h=new $(n,b);return this.a.set(E,h),h}delete(d,n){const b=this.b(d,n.uri);this.a.delete(b)}b(d,n){return`${d}@@@${n}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class c{constructor(){this.a=new Map}addTextProvider(d,n,b){return this.b(0,d,n,b)}addCustomProvider(d,n,b){return this.b(1,d,n,b)}get(d){return this.a.get(d)}b(d,n,b,E){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:d,extension:b,provider:E}),new l.$qL(()=>this.a.delete(n))}}class s{constructor(d,n,b,E,h){this.d=n,this.f=b,this.g=E,this.h=h,this.b=new c,this.c=new w,this.a=d.getProxy(k.$oL.MainThreadCustomEditors)}registerCustomEditorProvider(d,n,b,E){const h=new I.$Sc;return o(b)?(h.add(this.b.addTextProvider(n,d,b)),this.a.$registerTextEditorProvider((0,D.$3gc)(d),n,E.webviewOptions||{},{supportsMove:!!b.moveCustomTextEditor},(0,D.$1gc)(d))):(h.add(this.b.addCustomProvider(n,d,b)),i(b)&&h.add(b.onDidChangeCustomDocument(v=>{const P=this.i(n,v.document.uri);if(a(v)){const g=P.addEdit(v);this.a.$onDidEdit(v.document.uri,n,g,v.label)}else this.a.$onContentChange(v.document.uri,n)})),this.a.$registerCustomEditorProvider((0,D.$3gc)(d),n,E.webviewOptions||{},!!E.supportsMultipleEditorsPerDocument,(0,D.$1gc)(d))),l.$qL.from(h,new l.$qL(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(d,n,b,E,h){const v=this.b.get(n);if(!v)throw new Error(`No provider found for '${n}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${n}'`);const P=m.URI.revive(d),g=await v.provider.openCustomDocument(P,{backupId:b,untitledDocumentData:E?.buffer},h);let p;return i(v.provider)&&this.f&&(p=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(n,g,p),{editable:i(v.provider)}}async $disposeCustomDocument(d,n){const b=this.b.get(n);if(!b)throw new Error(`No provider found for '${n}'`);if(b.type!==1)throw new Error(`Invalid provider type for '${n}'`);const E=m.URI.revive(d),{document:h}=this.i(n,E);this.c.delete(n,h),h.dispose()}async $resolveCustomEditor(d,n,b,E,h,v){const P=this.b.get(b);if(!P)throw new Error(`No provider found for '${b}'`);const g=f.ViewColumn.to(h),p=this.g.createNewWebview(n,E.contentOptions,P.extension),y=this.h.createNewWebviewPanel(n,b,E.title,g,E.options,p,E.active),T=m.URI.revive(d);switch(P.type){case 1:{const{document:N}=this.i(b,T);return P.provider.resolveCustomEditor(N,y,v)}case 0:{const N=this.d.getDocument(T);return P.provider.resolveCustomTextEditor(N,y,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,n,b){this.i(n,d).disposeEdits(b)}async $onMoveCustomEditor(d,n,b){const E=this.b.get(b);if(!E)throw new Error(`No provider found for '${b}'`);if(!E.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${b}'`);const h=this.h.getWebviewPanel(d);if(!h)throw new Error("No webview found");const v=m.URI.revive(n),P=this.d.getDocument(v);await E.provider.moveCustomTextEditor(P,h,S.CancellationToken.None)}async $undo(d,n,b,E){return this.i(n,d).undo(b,E)}async $redo(d,n,b,E){return this.i(n,d).redo(b,E)}async $revert(d,n,b){const E=this.i(n,d);await this.j(n).revertCustomDocument(E.document,b),E.disposeBackup()}async $onSave(d,n,b){const E=this.i(n,d);await this.j(n).saveCustomDocument(E.document,b),E.disposeBackup()}async $onSaveAs(d,n,b,E){const h=this.i(n,d);return this.j(n).saveCustomDocumentAs(h.document,m.URI.revive(b),E)}async $backup(d,n,b){const E=this.i(n,d),v=await this.j(n).backupCustomDocument(E.document,{destination:E.getNewBackupUri()},b);return E.updateBackup(v),v.id}i(d,n){const b=this.c.get(d,m.URI.revive(n));if(!b)throw new Error("No custom document found");return b}j(d){const b=this.b.get(d)?.provider;if(!b||!i(b))throw new Error("Custom document is not editable");return b}}e.$6gc=s;function i(t){return!!t.onDidChangeCustomDocument}function o(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const d=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,M.$Vi)(d)+""}}),define(Ae[253],Me([1,0,160,98,2,3,7,8,5,14,28,43]),function(fe,e,S,M,I,A,R,m,f,D,L,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=e.$xgc=void 0;class ${#e;#t;#i;constructor(c,s,i,o,a,u,t,d){this.d=c,this.e=s,this.f=i,this.g=o,this.h=a,this.c=!1,this.f=Math.max(o,i),this.#i=new L.$Ac(n=>u.getComparisonKey(n)),this.#e=t,this.#t=d}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(c,s){if(!c){this.clear();return}this.j();let i=[];if(I.URI.isUri(c)){if(!s){this.delete(c);return}this.#i.set(c,s.slice()),i=[c]}else if(Array.isArray(c)){i=[];let u;c=[...c].sort($.k);for(const t of c){const[d,n]=t;if((!u||d.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=d,i.push(d),this.#i.set(d,[])),n)this.#i.get(d)?.push(...n);else{const b=this.#i.get(d);b&&(b.length=0)}}}if(this.#t.fire(i),!this.#e)return;const o=[];let a=0;for(const u of i){let t=[];const d=this.#i.get(u);if(d)if(d.length>this.g){t=[];const n=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let b=0;b<4;b++)for(const E of d)if(E.severity===n[b]&&t.push({...m.Diagnostic.from(E),modelVersionId:this.h(u)})===this.g)break e;t.push({severity:M.MarkerSeverity.Info,message:(0,S.localize)(0,null,d.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=d.map(n=>({...m.Diagnostic.from(n),modelVersionId:this.h(u)}));if(o.push([u,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,o)}delete(c){this.j(),this.#t.fire([c]),this.#i.delete(c),this.#e?.$changeMany(this.e,[[c,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(c,s){this.j();for(const[i,o]of this)c.call(s,i,o,this)}*[Symbol.iterator](){this.j();for(const c of this.#i.keys())yield[c,this.get(c)]}get(c){this.j();const s=this.#i.get(c);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(c){return this.j(),Array.isArray(this.#i.get(c))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(c,s){return c[0].toString()<s[0].toString()?-1:c[0].toString()>s[0].toString()?1:0}}e.$xgc=$;let w=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(c){const s=new L.$Ac;for(const i of c)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(c,s,i,o){this.j=s,this.k=i,this.l=o,this.g=new Map,this.h=new f.$1d({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,l._mapper),this.f=c.getProxy(A.$oL.MainThreadDiagnostics)}createDiagnosticCollection(c,s){const{g:i,f:o,h:a,j:u,k:t,l:d}=this,n=new class{$changeMany(h,v){o.$changeMany(h,v),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,h,v.length===0?"CLEARING":v)}$clear(h){o.$clear(h),u.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,h)}dispose(){o.dispose()}};let b;if(!s)s="_generated_diagnostic_collection_name_#"+l.c++,b=s;else if(!i.has(s))b=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do b=s+l.c++;while(i.has(b))}return new class extends ${constructor(){super(s,b,l.e,l.d,h=>d.getDocument(h)?.version,t.extUri,n,a),i.set(b,this)}dispose(){super.dispose(),i.delete(b)}}}getDiagnostics(c){if(c)return this.m(c);{const s=new Map,i=[];for(const o of this.g.values())o.forEach((a,u)=>{let t=s.get(a.toString());typeof t>"u"&&(t=i.length,s.set(a.toString(),t),i.push([a,[]])),i[t][1]=i[t][1].concat(...u)});return i}}m(c){let s=[];for(const i of this.g.values())i.has(c)&&(s=s.concat(i.get(c)));return s}$acceptMarkersChange(c){if(!this.n){const s="_generated_mirror",i=new $(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of c)this.n.set(I.URI.revive(s),i.map(m.Diagnostic.to))}};e.$ygc=w,e.$ygc=w=l=Je([qe(1,D.$pj),qe(2,k.$wgc)],w)}),define(Ae[254],Me([1,0,2,15,7,8,187]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class m{constructor(D,L,k,l={timeout:1500,errors:3}){this.c=D,this.d=L,this.f=k,this.g=l,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(D){return(L,k,l)=>{const w={dispose:this.a.push([L,k,D])};return Array.isArray(l)&&l.push(w),w}}async $participateInSave(D,L){const k=S.URI.revive(D);let l=!1;const $=setTimeout(()=>l=!0,this.g.timeout),w=[];try{for(const r of[...this.a]){if(l)break;const c=this.d.getDocument(k),s=await this.h(r,{document:c,reason:A.TextDocumentSaveReason.to(L)});w.push(s)}}finally{clearTimeout($)}return w}h([D,L,k],l){const $=this.b.get(D);return typeof $=="number"&&$>this.g.errors?Promise.resolve(!1):this.i(k,D,L,l).then(()=>!0,w=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const r=this.b.get(D);this.b.set(D,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(D,L,k,l){const $=[],w=Date.now(),{document:r,reason:c}=l,{version:s}=r,i=Object.freeze({document:r,reason:c,waitUntil(o){if(Object.isFrozen($))throw(0,M.$8)("waitUntil can not be called async");$.push(Promise.resolve(o))}});try{L.apply(k,[i])}catch(o){return Promise.reject(o)}return Object.freeze($),new Promise((o,a)=>{const u=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all($).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(u),o(t)}).catch(t=>{clearTimeout(u),a(t)})}).then(o=>{const a={edits:[]};for(const u of o)if(Array.isArray(u)&&u.every(t=>t instanceof I.$xL))for(const{newText:t,newEol:d,range:n}of u)a.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:n&&A.Range.from(n),text:t,eol:d&&A.EndOfLine.from(d)}});if(a.edits.length!==0)return s===r.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$Hhc=m}),define(Ae[255],Me([1,0,5,6,2,3,109,8,16,26,7]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class k{constructor($,w){this.a=new S.$Wd,this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Sc,this.h=new Map,this.f=$.getProxy(A.$oL.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(r=>{for(const c of r)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const c of r)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const w=this.g.getDocument($);if(w)return w}getDocument($){const w=this.getDocumentData($);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return w.document}ensureDocumentData($){const w=this.g.getDocument($);if(w)return Promise.resolve(w);let r=this.h.get($.toString());return r||(r=this.f.$tryOpenDocument($).then(c=>{this.h.delete($.toString());const s=I.URI.revive(c);return(0,f.$Uf)(this.g.getDocument(s))},c=>(this.h.delete($.toString()),Promise.reject(c))),this.h.set($.toString(),r)),r}createDocumentData($){return this.f.$tryCreateDocument($).then(w=>I.URI.revive(w))}$acceptModelLanguageChanged($,w){const r=I.URI.revive($),c=this.g.getDocument(r);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId(w),this.a.fire(c.document)}$acceptModelSaved($){const w=I.URI.revive($),r=this.g.getDocument(w);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(r.document)}$acceptDirtyStateChanged($,w){const r=I.URI.revive($),c=this.g.getDocument(r);if(!c)throw new Error("unknown document");c._acceptIsDirty(w),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,w,r){const c=I.URI.revive($),s=this.g.getDocument(c);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(w);let i;w.isUndoing?i=L.TextDocumentChangeReason.Undo:w.isRedoing&&(i=L.TextDocumentChangeReason.Redo),this.c.fire((0,D.$zn)({document:s.document,contentChanges:w.changes.map(o=>({range:m.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:i}))}setWordDefinitionFor($,w){(0,R.$CN)($,w)}}e.$ugc=k}),define(Ae[64],Me([1,0,256,5,16,2,4,3,17,8,7]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=e.$7gc=void 0,e.$7gc=(0,R.$8h)("IExtHostEditorTabs");class k{constructor(c,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(c)}get apiObject(){if(!this.a){const c=this,s={get isActive(){return c.b.id===c.e()},get label(){return c.b.label},get input(){return c.c},get isDirty(){return c.b.isDirty},get isPinned(){return c.b.isPinned},get isPreview(){return c.b.isPreview},get group(){return c.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(c){this.b=c,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new L.$0M(A.URI.revive(this.b.input.uri));case 2:return new L.$$M(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new L.$_M(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new L.$aN(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new L.$bN(this.b.input.viewType);case 4:return new L.$cN(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new L.$dN(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new L.$eN;case 9:return new L.$fN(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new L.$gN(this.b.input.providerId);default:return}}}class l{constructor(c,s){this.c=[],this.d="",this.b=c,this.e=s;for(const i of c.tabs)i.isActive&&(this.d=i.id),this.c.push(new k(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const c=this,s={get isActive(){return c.b.groupId===c.e()},get viewColumn(){return D.ViewColumn.to(c.b.viewColumn)},get activeTab(){return c.c.find(i=>i.tabId===c.d)?.apiObject},get tabs(){return Object.freeze(c.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(c){this.b=c}acceptTabOperation(c){if(c.kind===0){const i=new k(c.tabDto,this,()=>this.activeTabId());return this.c.splice(c.index,0,i),c.tabDto.isActive&&(this.d=i.tabId),i}else if(c.kind===1){const i=this.c.splice(c.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(c.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this.c.splice(c.index,0,i),i}const s=this.c.find(i=>i.tabId===c.tabDto.id);if(!s)throw new Error("INVALID tab");return c.tabDto.isActive?this.d=c.tabDto.id:this.d===c.tabDto.id&&!c.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(c.tabDto),s}activeTabId(){return this.d}}let $=class{constructor(c){this.b=new M.$Wd,this.c=new M.$Wd,this.e=[],this.a=c.getProxy(m.$oL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const c=this,s={onDidChangeTabGroups:c.c.event,onDidChangeTabs:c.b.event,get all(){return Object.freeze(c.e.map(i=>i.apiObject))},get activeTabGroup(){const i=c.d;return(0,I.$Uf)(c.e.find(a=>a.groupId===i)?.apiObject)},close:async(i,o)=>{const a=Array.isArray(i)?i:[i];return a.length?w(a[0])?this.j(a,o):this.i(a,o):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(c){const s=new Set(this.e.map(n=>n.groupId)),i=new Set(c.map(n=>n.groupId)),o=(0,S.$L)(s,i),a=this.e.filter(n=>o.removed.includes(n.groupId)).map(n=>n.apiObject),u=[],t=[];this.e=c.map(n=>{const b=new l(n,()=>this.d);return o.added.includes(b.groupId)?u.push(b.apiObject):t.push(b.apiObject),b});const d=(0,I.$Uf)(c.find(n=>n.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:u,closed:a,changed:t}))}$acceptTabGroupUpdate(c){const s=this.e.find(i=>i.groupId===c.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(c),c.isActive&&(this.d=c.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const s=this.e.find(o=>o.groupId===c.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(c);switch(c.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(c){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===c)return i}h(c){return this.e.find(s=>s.apiObject===c)}async i(c,s){const i=[];for(const o of c){const a=this.g(o);if(!a)throw new Error("Tab close: Invalid tab not found!");i.push(a.tabId)}return this.a.$closeTab(i,s)}async j(c,s){const i=[];for(const o of c){const a=this.h(o);if(!a)throw new Error("Group close: Invalid group not found!");i.push(a.groupId)}return this.a.$closeGroup(i,s)}};e.$8gc=$,e.$8gc=$=Je([qe(0,f.$AN)],$);function w(r){return r.tabs!==void 0}}),define(Ae[257],Me([1,0,2,3,6,7,8,299,13,23,25,46]),function(fe,e,S,M,I,A,R,m,f,D,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const c=this.a.indexOf(r);c>=0&&(this.a.splice(c,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),c=[];let s,i,o=14,a=14;for(const u of r){let t=s?(0,f.$cf)(s,u):0;for(t===0?i=1:i=a;t<u.length;t++)t+1===u.length?(o=a,a=9):a+=1,c.push([i,u.toUpperCase().charCodeAt(t),a]),c.push([i,u.toLowerCase().charCodeAt(t),a]),i=a;s=u,a=o}c.push([9,58,10]),c.push([10,47,12]),this.b=new m.$ZZ(c)}}provideDocumentLinks(r){this.c();const c=[],s=m.$1Z.computeLinks({getLineContent(i){return r.lineAt(i-1).text},getLineCount(){return r.lineCount}},this.b);for(const i of s){const o=R.DocumentLink.to(i);o.target&&c.push(o)}return c}}class ${constructor(r,c){this.i=c,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(M.$oL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,c,s,i={}){if($.j(s),this.d.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const o=this.h++;this.b.add(c),this.d.add(c),this.c.set(o,s);let a=2;i.isCaseSensitive&&(a+=1024),i.isReadonly&&(a+=2048),typeof s.copy=="function"&&(a+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,L.$LF)(r,"fsChunks"),a+=4);let u;i.isReadonly&&(0,k.$lk)(i.isReadonly)&&i.isReadonly.value!==""&&(u={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(o,c,a,u).catch(d=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${c}`),console.error(d)});const t=s.onDidChangeFile(d=>{const n=[];for(const b of d){const{uri:E,type:h}=b;if(E.scheme!==c)continue;let v;switch(h){case A.FileChangeType.Changed:v=0;break;case A.FileChangeType.Created:v=1;break;case A.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:E,type:v})}this.a.$onFileSystemChange(o,n)});return(0,I.$Rc)(()=>{t.dispose(),this.b.delete(c),this.d.delete(c),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:c,ctime:s,mtime:i,size:o,permissions:a}=r;return{type:c,ctime:s,mtime:i,size:o,permissions:a}}$stat(r,c){return Promise.resolve(this.l(r).stat(S.URI.revive(c))).then(s=>$.k(s))}$readdir(r,c){return Promise.resolve(this.l(r).readDirectory(S.URI.revive(c)))}$readFile(r,c){return Promise.resolve(this.l(r).readFile(S.URI.revive(c))).then(s=>D.$ke.wrap(s))}$writeFile(r,c,s,i){return Promise.resolve(this.l(r).writeFile(S.URI.revive(c),s.buffer,i))}$delete(r,c,s){return Promise.resolve(this.l(r).delete(S.URI.revive(c),s))}$rename(r,c,s,i){return Promise.resolve(this.l(r).rename(S.URI.revive(c),S.URI.revive(s),i))}$copy(r,c,s,i){const o=this.l(r);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(S.URI.revive(c),S.URI.revive(s),i))}$mkdir(r,c){return Promise.resolve(this.l(r).createDirectory(S.URI.revive(c)))}$watch(r,c,s,i){const o=this.l(r).watch(S.URI.revive(s),i);this.f.set(c,o)}$unwatch(r,c){const s=this.f.get(c);s&&(s.dispose(),this.f.delete(c))}$open(r,c,s){const i=this.l(r);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(S.URI.revive(c),s))}$close(r,c){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(c))}$read(r,c,s,i){const o=this.l(r);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const a=D.$ke.alloc(i);return Promise.resolve(o.read(c,s,a.buffer,0,i)).then(u=>a.slice(0,u))}$write(r,c,s,i){const o=this.l(r);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(c,s,i.buffer,0,i.byteLength))}l(r){const c=this.c.get(r);if(!c){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return c}}e.$Jhc=$}),define(Ae[258],Me([1,0,5,34,2,3,8,7,39]),function(fe,e,S,M,I,A,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;class D{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor($,w,r,c,s,i){this.a=Math.random(),this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const o=(0,M.$Oj)(s),a=typeof s=="string",u=i?.correlate,t=c(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(u&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const n of d.created){const b=I.URI.revive(n);o(b.fsPath)&&(!a||w.getWorkspaceFolder(b))&&this.b.fire(b)}if(!i?.ignoreChangeEvents)for(const n of d.changed){const b=I.URI.revive(n);o(b.fsPath)&&(!a||w.getWorkspaceFolder(b))&&this.c.fire(b)}if(!i?.ignoreDeleteEvents)for(const n of d.deleted){const b=I.URI.revive(n);o(b.fsPath)&&(!a||w.getWorkspaceFolder(b))&&this.d.fire(b)}}});this.g=m.$qL.from(this.i($,r,s,i,i?.correlate),this.b,this.c,this.d,t)}i($,w,r,c,s){const i=m.$qL.from();if(typeof r=="string")return i;const o=$.getProxy(A.$oL.MainThreadFileSystemEventService);let a=!1;return(r.pattern.includes(M.$Kj)||r.pattern.includes(M.$Lj))&&(a=!0),o.$watch(w.identifier.value,this.a,r.baseUri,{recursive:a,excludes:c?.excludes??[]},!!s),m.$qL.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class L{constructor($){this.a=$,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(I.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor($,w,r){this.j=$,this.k=w,this.l=r,this.a=new S.$Wd,this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd,this.g=new S.$Yd,this.h=new S.$Yd,this.i=new S.$Yd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher($,w,r,c){return new D(this.j,$,w,this.a.event,R.GlobPattern.from(r),c)}$onFileEvent($){this.a.fire(new L($))}$onDidRunFileOperation($,w){switch($){case 2:this.b.fire(Object.freeze({files:w.map(r=>({oldUri:I.URI.revive(r.source),newUri:I.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(r=>I.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(r=>I.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent($){return this.m($,this.g)}getOnWillCreateFileEvent($){return this.m($,this.h)}getOnWillDeleteFileEvent($){return this.m($,this.i)}m($,w){return(r,c,s)=>{const i=function(a){r.call(c,a)};return i.extension=$,w.event(i,void 0,s)}}async $onWillRunFileOperation($,w,r,c){switch($){case 2:return await this.n(this.g,{files:w.map(s=>({oldUri:I.URI.revive(s.source),newUri:I.URI.revive(s.target)}))},r,c);case 1:return await this.n(this.i,{files:w.map(s=>I.URI.revive(s.target))},r,c);case 0:case 3:return await this.n(this.h,{files:w.map(s=>I.URI.revive(s.target))},r,c)}}async n($,w,r,c){const s=new Set,i=[];if(await $.fireAsync(w,c,async(a,u)=>{const t=Date.now(),d=await Promise.resolve(a);d instanceof m.$AL&&(i.push([u.extension,d]),s.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",u.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const o={edits:[]};for(const[,a]of i){const{edits:u}=R.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(u)}return{edit:o,extensionNames:Array.from(s)}}}e.$Khc=k}),define(Ae[259],Me([1,0,2,26,8,7,86,3,13,29,18,16,300,21,22,6,95,88,74,63,15,11,25,162]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o,a,u,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;class n{constructor(O,K){this.d=O,this.e=K}async provideDocumentSymbols(O,K){const j=this.d.getDocument(O),H=await this.e.provideDocumentSymbols(j,K);if(!(0,L.$Kb)(H))return H[0]instanceof A.$JL?H.map(I.DocumentSymbol.from):n.f(H)}static f(O){O=O.slice(0).sort((H,Q)=>{let oe=H.location.range.start.compareTo(Q.location.range.start);return oe===0&&(oe=Q.location.range.end.compareTo(H.location.range.end)),oe});const K=[],j=[];for(const H of O){const Q={name:H.name||"!!MISSING: name!!",kind:I.SymbolKind.from(H.kind),tags:H.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:I.Range.from(H.location.range),selectionRange:I.Range.from(H.location.range),children:[]};for(;;){if(j.length===0){j.push(Q),K.push(Q);break}const oe=j[j.length-1];if(D.$Ws.containsRange(oe.range,Q.range)&&!D.$Ws.equalsRange(oe.range,Q.range)){oe.children?.push(Q),j.push(Q);break}j.pop()}}return K}}class b{constructor(O,K,j,H,Q,oe){this.f=O,this.g=K,this.h=j,this.j=H,this.k=Q,this.l=oe,this.d=new i.$sgc("CodeLens"),this.e=new Map}async provideCodeLenses(O,K){const j=this.f.getDocument(O),H=await this.h.provideCodeLenses(j,K);if(!H||K.isCancellationRequested)return;const Q=this.d.add(H),oe=new r.$Sc;this.e.set(Q,oe);const Ee={cacheId:Q,lenses:[]};for(let Be=0;Be<H.length;Be++)Ee.lenses.push({cacheId:[Q,Be],range:I.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,oe)});return Ee}async resolveCodeLens(O,K){const j=O.cacheId&&this.d.get(...O.cacheId);if(!j)return;let H;if(typeof this.h.resolveCodeLens!="function"||j.isResolved?H=j:H=await this.h.resolveCodeLens(j,K),H||(H=j),K.isCancellationRequested)return;const Q=O.cacheId&&this.e.get(O.cacheId[0]);if(Q){if(!H.command){const oe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,oe),this.l.error(oe);return}return O.command=this.g.toInternal(H.command,Q),O}}releaseCodeLenses(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}}function E(Ie){return Array.isArray(Ie)?Ie.map(I.DefinitionLink.from):Ie?[I.DefinitionLink.from(Ie)]:[]}class h{constructor(O,K){this.d=O,this.e=K}async provideDefinition(O,K,j){const H=this.d.getDocument(O),Q=I.Position.to(K),oe=await this.e.provideDefinition(H,Q,j);return E(oe)}}class v{constructor(O,K){this.d=O,this.e=K}async provideDeclaration(O,K,j){const H=this.d.getDocument(O),Q=I.Position.to(K),oe=await this.e.provideDeclaration(H,Q,j);return E(oe)}}class P{constructor(O,K){this.d=O,this.e=K}async provideImplementation(O,K,j){const H=this.d.getDocument(O),Q=I.Position.to(K),oe=await this.e.provideImplementation(H,Q,j);return E(oe)}}class g{constructor(O,K){this.d=O,this.e=K}async provideTypeDefinition(O,K,j){const H=this.d.getDocument(O),Q=I.Position.to(K),oe=await this.e.provideTypeDefinition(H,Q,j);return E(oe)}}class p{constructor(O,K){this.d=O,this.e=K}async provideHover(O,K,j){const H=this.d.getDocument(O),Q=I.Position.to(K),oe=await this.e.provideHover(H,Q,j);if(!(!oe||(0,L.$Kb)(oe.contents)))return oe.range||(oe.range=H.getWordRangeAtPosition(Q)),oe.range||(oe.range=new A.$sL(Q,Q)),I.Hover.from(oe)}}class y{constructor(O,K){this.d=O,this.e=K}async provideEvaluatableExpression(O,K,j){const H=this.d.getDocument(O),Q=I.Position.to(K),oe=await this.e.provideEvaluatableExpression(H,Q,j);if(oe)return I.EvaluatableExpression.from(oe)}}class T{constructor(O,K){this.d=O,this.e=K}async provideInlineValues(O,K,j,H){const Q=this.d.getDocument(O),oe=await this.e.provideInlineValues(Q,I.Range.to(K),I.InlineValueContext.to(j),H);if(Array.isArray(oe))return oe.map(Ee=>I.InlineValue.from(Ee))}}class N{constructor(O,K){this.d=O,this.e=K}async provideDocumentHighlights(O,K,j){const H=this.d.getDocument(O),Q=I.Position.to(K),oe=await this.e.provideDocumentHighlights(H,Q,j);if(Array.isArray(oe))return oe.map(I.DocumentHighlight.from)}}class J{constructor(O,K){this.d=O,this.e=K}async provideMultiDocumentHighlights(O,K,j,H){const Q=this.d.getDocument(O),oe=j.map(We=>this.d.getDocument(We)),Ee=I.Position.to(K),Be=await this.e.provideMultiDocumentHighlights(Q,Ee,oe,H);if(Array.isArray(Be))return Be.map(I.MultiDocumentHighlight.from)}}class q{constructor(O,K){this.d=O,this.e=K}async provideLinkedEditingRanges(O,K,j){const H=this.d.getDocument(O),Q=I.Position.to(K),oe=await this.e.provideLinkedEditingRanges(H,Q,j);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,L.$Hb)(oe.ranges.map(I.Range.from)),wordPattern:oe.wordPattern}}}class U{constructor(O,K){this.d=O,this.e=K}async provideReferences(O,K,j,H){const Q=this.d.getDocument(O),oe=I.Position.to(K),Ee=await this.e.provideReferences(Q,oe,j,H);if(Array.isArray(Ee))return Ee.map(I.location.from)}}class C{static{this.d=1e3}constructor(O,K,j,H,Q,oe,Ee){this.g=O,this.h=K,this.j=j,this.k=H,this.l=Q,this.m=oe,this.n=Ee,this.e=new i.$sgc("CodeAction"),this.f=new Map}async provideCodeActions(O,K,j,H){const Q=this.g.getDocument(O),oe=l.$Ys.isISelection(K)?I.Selection.to(K):I.Range.to(K),Ee=[];for(const rt of this.j.getDiagnostics(O))if(oe.intersection(rt.range)&&Ee.push(rt)>C.d)break;const Be={diagnostics:Ee,only:j.only?new A.$LL(j.only):void 0,triggerKind:I.CodeActionTriggerKind.to(j.trigger)},We=await this.k.provideCodeActions(Q,oe,Be,H);if(!(0,L.$Lb)(We)||H.isCancellationRequested)return;const Ze=this.e.add(We),_e=new r.$Sc;this.f.set(Ze,_e);const at=[];for(let rt=0;rt<We.length;rt++){const et=We[rt];if(et)if(C.o(et))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,_e)});else{Be.only&&(et.kind?Be.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=et.ranges??[];at.push({cacheId:[Ze,rt],title:et.title,command:et.command&&this.h.toInternal(et.command,_e),diagnostics:et.diagnostics&&et.diagnostics.map(I.Diagnostic.from),edit:et.edit&&I.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,t.$KF)(this.m,"codeActionAI")?et.isAI:!1,ranges:(0,t.$KF)(this.m,"codeActionRanges")?(0,L.$Hb)(ct.map(I.Range.from)):void 0,disabled:et.disabled?.reason})}}return{cacheId:Ze,actions:at}}async resolveCodeAction(O,K){const[j,H]=O,Q=this.e.get(j,H);if(!Q||C.o(Q))return{};if(!this.k.resolveCodeAction)return{};const oe=await this.k.resolveCodeAction(Q,K)??Q;let Ee;oe.edit&&(Ee=I.WorkspaceEdit.from(oe.edit,void 0));let Be;if(oe.command){const We=this.f.get(j);We&&(Be=this.h.toInternal(oe.command,We))}return{edit:Ee,command:Be}}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}class F{static toInternalProviderId(O,K){return O+"."+K}constructor(O,K,j,H,Q){this.d=O,this.e=K,this.f=j,this.g=H,this.h=Q}async prepareDocumentPaste(O,K,j,H){if(!this.f.prepareDocumentPaste)return;const Q=this.e.getDocument(O),oe=K.map(We=>I.Range.to(We)),Ee=I.DataTransfer.toDataTransfer(j,()=>{throw new a.$$});if(await this.f.prepareDocumentPaste(Q,oe,Ee,H),H.isCancellationRequested)return;const Be=Array.from(Ee).filter(([,We])=>!(We instanceof A.$fM));return I.DataTransfer.from(Be)}async providePasteEdits(O,K,j,H,Q){if(!this.f.provideDocumentPasteEdits)return;const oe=this.e.getDocument(K),Ee=j.map(Ze=>I.Range.to(Ze)),Be=I.DataTransfer.toDataTransfer(H,async Ze=>(await this.d.$resolvePasteFileData(this.g,O,Ze)).buffer),We=await this.f.provideDocumentPasteEdits(oe,Ee,Be,Q);if(We)return{label:We.label??(0,d.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:F.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class W{constructor(O,K){this.d=O,this.e=K}async provideDocumentFormattingEdits(O,K,j){const H=this.d.getDocument(O),Q=await this.e.provideDocumentFormattingEdits(H,K,j);if(Array.isArray(Q))return Q.map(I.TextEdit.from)}}class re{constructor(O,K){this.d=O,this.e=K}async provideDocumentRangeFormattingEdits(O,K,j,H){const Q=this.d.getDocument(O),oe=I.Range.to(K),Ee=await this.e.provideDocumentRangeFormattingEdits(Q,oe,j,H);if(Array.isArray(Ee))return Ee.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,K,j,H){(0,k.$Tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Q=this.d.getDocument(O),oe=K.map(I.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Q,oe,j,H);if(Array.isArray(Ee))return Ee.map(I.TextEdit.from)}}class ce{constructor(O,K){this.d=O,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,K,j,H,Q){const oe=this.d.getDocument(O),Ee=I.Position.to(K),Be=await this.e.provideOnTypeFormattingEdits(oe,Ee,j,H,Q);if(Array.isArray(Be))return Be.map(I.TextEdit.from)}}class we{constructor(O,K){this.e=O,this.f=K,this.d=new i.$sgc("WorkspaceSymbols")}async provideWorkspaceSymbols(O,K){const j=await this.e.provideWorkspaceSymbols(O,K);if(!(0,L.$Lb)(j))return{symbols:[]};const H=this.d.add(j),Q={cacheId:H,symbols:[]};for(let oe=0;oe<j.length;oe++){const Ee=j[oe];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Q.symbols.push({...I.WorkspaceSymbol.from(Ee),cacheId:[H,oe]})}return Q}async resolveWorkspaceSymbol(O,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const j=this.d.get(...O.cacheId);if(j){const H=await this.e.resolveWorkspaceSymbol(j,K);return H&&(0,M.$Bn)(O,I.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class De{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,K,j){this.d=O,this.e=K,this.f=j}async provideRenameEdits(O,K,j,H){const Q=this.d.getDocument(O),oe=I.Position.to(K);try{const Ee=await this.e.provideRenameEdits(Q,oe,j,H);return Ee?I.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Be=De.g(Ee);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(O,K,j){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(O),Q=I.Position.to(K);try{const oe=await this.e.prepareRename(H,Q,j);let Ee,Be;if(A.$sL.isRange(oe)?(Ee=oe,Be=H.getText(oe)):(0,k.$Lf)(oe)&&(Ee=oe.range,Be=oe.placeholder),!Ee||!Be)return;if(Ee.start.line>Q.line||Ee.end.line<Q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Ee),text:Be}}catch(oe){const Ee=De.g(oe);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(oe)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class he{constructor(O,K,j){this.d=O,this.e=K,this.f=j}async provideNewSymbolNames(O,K,j){const H=this.d.getDocument(O),Q=I.Range.to(K);try{const oe=await this.e.provideNewSymbolNames(H,Q,j);return oe||void 0}catch(oe){this.f.error(he.g(oe)??JSON.stringify(oe,null,"	"));return}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class ve{constructor(O,K){this.resultId=O,this.tokens=K}}class se{constructor(O,K){this.f=O,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,K,j){const H=this.f.getDocument(O),Q=K!==0?this.d.get(K):null;let oe=typeof Q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,Q.resultId,j):await this.g.provideDocumentSemanticTokens(H,j);return Q&&this.d.delete(K),oe?(oe=se.h(oe),this.o(se.n(Q,oe),oe)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return se.j(O)?se.k(O)?O:new A.$IM(new Uint32Array(O.data),O.resultId):se.l(O)?se.m(O)?O:new A.$KM(O.edits.map(K=>new A.$JM(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const K of O.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(O,K){if(!se.j(K)||!O||!O.tokens)return K;const j=O.tokens,H=j.length,Q=K.data,oe=Q.length;let Ee=0;const Be=Math.min(H,oe);for(;Ee<Be&&j[Ee]===Q[Ee];)Ee++;if(Ee===H&&Ee===oe)return new A.$KM([],K.resultId);let We=0;const Ze=Be-Ee;for(;We<Ze&&j[H-We-1]===Q[oe-We-1];)We++;return new A.$KM([{start:Ee,deleteCount:H-Ee-We,data:Q.subarray(Ee,oe-We)}],K.resultId)}o(O,K){if(se.j(O)){const j=this.e++;return this.d.set(j,new ve(O.resultId,O.data)),(0,c.$3$)({id:j,type:"full",data:O.data})}if(se.l(O)){const j=this.e++;return se.j(K)?this.d.set(j,new ve(K.resultId,K.data)):this.d.set(j,new ve(O.resultId)),(0,c.$3$)({id:j,type:"delta",deltas:(O.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class $e{constructor(O,K){this.d=O,this.e=K}async provideDocumentRangeSemanticTokens(O,K,j){const H=this.d.getDocument(O),Q=await this.e.provideDocumentRangeSemanticTokens(H,I.Range.to(K),j);return Q?this.f(Q):null}f(O){return(0,c.$3$)({id:0,type:"full",data:O.data})}}class te{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,K,j,H,Q){this.f=O,this.g=K,this.h=j,this.j=H,this.k=Q,this.d=new i.$sgc("CompletionItem"),this.e=new Map}async provideCompletionItems(O,K,j,H){const Q=this.f.getDocument(O),oe=I.Position.to(K),Ee=Q.getWordRangeAtPosition(oe)||new A.$sL(oe,oe),Be=Ee.with({end:oe}),We=new o.$Sd,Ze=await this.h.provideCompletionItems(Q,oe,H,I.CompletionContext.to(j));if(!Ze||H.isCancellationRequested)return;const _e=Array.isArray(Ze)?new A.$YL(Ze):Ze,at=te.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),rt=new r.$Sc;this.e.set(at,rt);const et=[],ct={x:at,b:et,a:{replace:I.Range.from(Ee),insert:I.Range.from(Be)},c:_e.isIncomplete||void 0,d:We.elapsed()};for(let Ue=0;Ue<_e.items.length;Ue++){const vt=_e.items[Ue],Z=this.l(vt,[at,Ue],Be,Ee);et.push(Z)}return ct}async resolveCompletionItem(O,K){if(typeof this.h.resolveCompletionItem!="function")return;const j=this.d.get(...O);if(!j)return;const H=this.l(j,O),Q=await this.h.resolveCompletionItem(j,K);if(!Q)return;const oe=this.l(Q,O);return(H.h!==oe.h||H.i!==oe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==oe.n||H.o!==oe.o||!(0,M.$Cn)(H.p,oe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:oe.d,c:oe.c,l:oe.l,h:oe.h,i:oe.i,n:oe.n,o:oe.o,p:oe.p}}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,K,j,H){const Q=this.e.get(K[0]);if(!Q)throw Error("DisposableStore is missing...");const oe=this.g.toInternal(O.command,Q),Ee={x:K,a:O.label,b:O.kind!==void 0?I.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(I.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:I.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(I.TextEdit.from),n:oe?.$ident,o:oe?.id,p:oe?.$ident?void 0:oe?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=O.textEdit.newText):typeof O.insertText=="string"?Ee.h=O.insertText:O.insertText instanceof A.$BL&&(Ee.h=O.insertText.value,Ee.i|=4);let Be;return O.textEdit?Be=O.textEdit.range:O.range&&(Be=O.range),A.$sL.isRange(Be)?Ee.j=I.Range.from(Be):Be&&(!j?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Ee.j={insert:I.Range.from(Be.inserting),replace:I.Range.from(Be.replacing)}),Ee}}class X{async provideInlineCompletions(O,K,j,H){}disposeCompletions(O){}handleDidShowCompletionItem(O,K,j){}handlePartialAccept(O,K,j){}}class V extends X{constructor(O,K,j,H){super(),this.f=O,this.g=K,this.h=j,this.j=H,this.d=new ie,this.e=(0,t.$KF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$KF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,K,j,H){const Q=this.g.getDocument(O),oe=I.Position.to(K),Ee=await this.h.provideInlineCompletionItems(Q,oe,{selectedCompletionInfo:j.selectedSuggestionInfo?{range:I.Range.to(j.selectedSuggestionInfo.range),text:j.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[j.triggerKind]},H);if(!Ee||H.isCancellationRequested)return;const Be=Array.isArray(Ee)?Ee:Ee.items,We=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],Ze=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:Be}),items:Be.map((rt,et)=>{let ct;rt.command&&(_e||(_e=new r.$Sc),ct=this.j.toInternal(rt.command,_e));const Ue=rt.insertText;return{insertText:typeof Ue=="string"?Ue:{snippet:Ue.value},filterText:rt.filterText,range:rt.range?I.Range.from(rt.range):void 0,command:ct,idx:et,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:We.map(rt=>(_e||(_e=new r.$Sc),this.j.toInternal(rt,_e))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,K,j){const H=this.d.get(O)?.items[K];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,j)}handlePartialAccept(O,K,j){const H=this.d.get(O)?.items[K];H&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(H,j)}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const K=this.e++;return this.d.set(K,O),K}disposeReferenceId(O){const K=this.d.get(O);return this.d.delete(O),K}get(O){return this.d.get(O)}}class Ce{constructor(O,K){this.e=O,this.f=K,this.d=new i.$sgc("SignatureHelp")}async provideSignatureHelp(O,K,j,H){const Q=this.e.getDocument(O),oe=I.Position.to(K),Ee=this.g(j),Be=await this.f.provideSignatureHelp(Q,oe,H,Ee);if(Be){const We=this.d.add([Be]);return{...I.SignatureHelp.from(Be),id:We}}}g(O){let K;if(O.activeSignatureHelp){const j=I.SignatureHelp.to(O.activeSignatureHelp),H=this.d.get(O.activeSignatureHelp.id,0);H?(K=H,K.activeSignature=j.activeSignature,K.activeParameter=j.activeParameter):K=j}return{...O,activeSignatureHelp:K}}releaseSignatureHelp(O){this.d.delete(O)}}class Te{constructor(O,K,j,H,Q){this.f=O,this.g=K,this.h=j,this.j=H,this.k=Q,this.d=new i.$sgc("InlayHints"),this.e=new Map}async provideInlayHints(O,K,j){const H=this.f.getDocument(O),Q=I.Range.to(K),oe=await this.h.provideInlayHints(H,Q,j);if(!Array.isArray(oe)||oe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`);return}if(j.isCancellationRequested)return;const Ee=this.d.add(oe);this.e.set(Ee,new r.$Sc);const Be={hints:[],cacheId:Ee};for(let We=0;We<oe.length;We++)this.l(oe[We],Q)&&Be.hints.push(this.m(oe[We],[Ee,We]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`),Be}async resolveInlayHint(O,K){if(typeof this.h.resolveInlayHint!="function")return;const j=this.d.get(...O);if(!j)return;const H=await this.h.resolveInlayHint(j,K);if(H&&this.l(H))return this.m(H,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,K){return O.label.length===0||Array.isArray(O.label)&&O.label.every(j=>j.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(K&&!K.contains(O.position))}m(O,K){const j=this.e.get(K[0]);if(!j)throw Error("DisposableStore is missing...");const H={label:"",cacheId:K,tooltip:I.MarkdownString.fromStrict(O.tooltip),position:I.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(I.TextEdit.from),kind:O.kind&&I.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};if(typeof O.label=="string")H.label=O.label;else{const Q=[];H.label=Q;for(const oe of O.label){if(!oe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:oe.value,tooltip:I.MarkdownString.fromStrict(oe.tooltip)};A.$CL.isLocation(oe.location)&&(Ee.location=I.location.from(oe.location)),oe.command&&(Ee.command=this.g.toInternal(oe.command,j)),Q.push(Ee)}}return H}}class Pe{constructor(O,K){this.e=O,this.f=K,this.d=new i.$sgc("DocumentLink")}async provideLinks(O,K){const j=this.e.getDocument(O),H=await this.f.provideDocumentLinks(j,K);if(!(!Array.isArray(H)||H.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(Pe.g).map(I.DocumentLink.from)};{const Q=this.d.add(H),oe={links:[],cacheId:Q};for(let Ee=0;Ee<H.length;Ee++){if(!Pe.g(H[Ee]))continue;const Be=I.DocumentLink.from(H[Ee]);Be.cacheId=[Q,Ee],oe.links.push(Be)}return oe}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,K){if(typeof this.f.resolveDocumentLink!="function")return;const j=this.d.get(...O);if(!j)return;const H=await this.f.resolveDocumentLink(j,K);if(!(!H||!Pe.g(H)))return I.DocumentLink.from(H)}releaseLinks(O){this.d.delete(O)}}class be{constructor(O,K){this.d=O,this.e=K}async provideColors(O,K){const j=this.d.getDocument(O),H=await this.e.provideDocumentColors(j,K);return Array.isArray(H)?H.map(oe=>({color:I.Color.from(oe.color),range:I.Range.from(oe.range)})):[]}async provideColorPresentations(O,K,j){const H=this.d.getDocument(O),Q=I.Range.to(K.range),oe=I.Color.to(K.color),Ee=await this.e.provideColorPresentations(oe,{document:H,range:Q},j);if(Array.isArray(Ee))return Ee.map(I.ColorPresentation.from)}}class me{constructor(O,K){this.d=O,this.e=K}async provideFoldingRanges(O,K,j){const H=this.d.getDocument(O),Q=await this.e.provideFoldingRanges(H,K,j);if(Array.isArray(Q))return Q.map(I.FoldingRange.from)}}class G{constructor(O,K,j){this.d=O,this.e=K,this.f=j}async provideSelectionRanges(O,K,j){const H=this.d.getDocument(O),Q=K.map(I.Position.to),oe=await this.e.provideSelectionRanges(H,Q,j);if(!(0,L.$Lb)(oe))return[];if(oe.length!==Q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Be=0;Be<Q.length;Be++){const We=[];Ee.push(We);let Ze=Q[Be],_e=oe[Be];for(;;){if(!_e.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(We.push(I.SelectionRange.from(_e)),!_e.parent)break;Ze=_e.range,_e=_e.parent}}return Ee}}class _{constructor(O,K){this.f=O,this.g=K,this.d=new s.$FN(""),this.e=new Map}async prepareSession(O,K,j){const H=this.f.getDocument(O),Q=I.Position.to(K),oe=await this.g.prepareCallHierarchy(H,Q,j);if(!oe)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(oe)?oe.map(Be=>this.h(Ee,Be)):[this.h(Ee,oe)]}async provideCallsTo(O,K,j){const H=this.j(O,K);if(!H)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyIncomingCalls(H,j);if(Q)return Q.map(oe=>({from:this.h(O,oe.from),fromRanges:oe.fromRanges.map(Ee=>I.Range.from(Ee))}))}async provideCallsFrom(O,K,j){const H=this.j(O,K);if(!H)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyOutgoingCalls(H,j);if(Q)return Q.map(oe=>({to:this.h(O,oe.to),fromRanges:oe.fromRanges.map(Ee=>I.Range.from(Ee))}))}releaseSession(O){this.e.delete(O)}h(O,K){const j=this.e.get(O),H=I.CallHierarchyItem.from(K,O,j.size.toString(36));return j.set(H._itemId,K),H}j(O,K){return this.e.get(O)?.get(K)}}class le{constructor(O,K){this.f=O,this.g=K,this.d=new s.$FN(""),this.e=new Map}async prepareSession(O,K,j){const H=this.f.getDocument(O),Q=I.Position.to(K),oe=await this.g.prepareTypeHierarchy(H,Q,j);if(!oe)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(oe)?oe.map(Be=>this.h(Ee,Be)):[this.h(Ee,oe)]}async provideSupertypes(O,K,j){const H=this.j(O,K);if(!H)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySupertypes(H,j);if(Q)return Q.map(oe=>this.h(O,oe))}async provideSubtypes(O,K,j){const H=this.j(O,K);if(!H)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySubtypes(H,j);if(Q)return Q.map(oe=>this.h(O,oe))}releaseSession(O){this.e.delete(O)}h(O,K){const j=this.e.get(O),H=I.TypeHierarchyItem.from(K,O,j.size.toString(36));return j.set(H._itemId,K),H}j(O,K){return this.e.get(O)?.get(K)}}class de{static toInternalProviderId(O,K){return O+"."+K}constructor(O,K,j,H,Q){this.d=O,this.e=K,this.f=j,this.g=H,this.h=Q}async provideDocumentOnDropEdits(O,K,j,H,Q){const oe=this.e.getDocument(K),Ee=I.Position.to(j),Be=I.DataTransfer.toDataTransfer(H,async Ze=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,Ze)).buffer),We=await this.f.provideDocumentDropEdits(oe,Ee,Be,Q);if(We)return{label:We.label??(0,d.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:de.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class Le{constructor(O,K){this.d=O,this.e=K}async provideMappedEdits(O,K,j,H){const Q=S.URI.revive(O),oe=this.d.getDocument(Q),Ee=j.documents.map(Ze=>Ze.map(_e=>({uri:S.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(at=>I.Range.to(at))}))),Be={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(oe,K,Be,H);return We?I.WorkspaceEdit.from(We):null}}class ge{constructor(O,K){this.adapter=O,this.extension=K}}class ke{static{this.d=0}constructor(O,K,j,H,Q,oe,Ee,Be){this.g=K,this.h=j,this.j=H,this.k=Q,this.l=oe,this.m=Ee,this.n=Be,this.f=new Map,this.e=O.getProxy(m.$oL.MainThreadLanguageFeatures)}o(O,K){return I.DocumentSelector.from(O,this.g,K)}p(O){return new A.$qL(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return ke.d++}async s(O,K,j,H,Q,oe=!1){const Ee=this.f.get(O);if(!Ee||!(Ee.adapter instanceof K))return H;const Be=Date.now();oe||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${j.toString().replace(/[\r\n]/g,"")}'`);const We=j(Ee.adapter,Ee.extension);return Promise.resolve(We).catch(Ze=>{(0,a.$4)(Ze)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(Ze),this.n.onExtensionError(Ee.extension.identifier,Ze))}).finally(()=>{oe||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),$.CancellationToken.isCancellationToken(Q)?(0,u.$Wg)(We,Q):We}t(O,K){const j=this.q();return this.f.set(j,new ge(O,K)),j}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,K,j,H){const Q=this.t(new n(this.h,j),O),oe=H&&H.label||ke.u(O);return this.e.$registerDocumentSymbolProvider(Q,this.o(K,O),oe),this.p(Q)}$provideDocumentSymbols(O,K,j){return this.s(O,n,H=>H.provideDocumentSymbols(S.URI.revive(K),j),void 0,j)}registerCodeLensProvider(O,K,j){const H=this.q(),Q=typeof j.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new ge(new b(this.h,this.j.converter,j,O,this.n,this.l),O)),this.e.$registerCodeLensSupport(H,this.o(K,O),Q);let oe=this.p(H);if(Q!==void 0){const Ee=j.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(Q));oe=A.$qL.from(oe,Ee)}return oe}$provideCodeLenses(O,K,j){return this.s(O,b,H=>H.provideCodeLenses(S.URI.revive(K),j),void 0,j)}$resolveCodeLens(O,K,j){return this.s(O,b,H=>H.resolveCodeLens(K,j),void 0,void 0)}$releaseCodeLenses(O,K){this.s(O,b,j=>Promise.resolve(j.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(O,K,j){const H=this.t(new h(this.h,j),O);return this.e.$registerDefinitionSupport(H,this.o(K,O)),this.p(H)}$provideDefinition(O,K,j,H){return this.s(O,h,Q=>Q.provideDefinition(S.URI.revive(K),j,H),[],H)}registerDeclarationProvider(O,K,j){const H=this.t(new v(this.h,j),O);return this.e.$registerDeclarationSupport(H,this.o(K,O)),this.p(H)}$provideDeclaration(O,K,j,H){return this.s(O,v,Q=>Q.provideDeclaration(S.URI.revive(K),j,H),[],H)}registerImplementationProvider(O,K,j){const H=this.t(new P(this.h,j),O);return this.e.$registerImplementationSupport(H,this.o(K,O)),this.p(H)}$provideImplementation(O,K,j,H){return this.s(O,P,Q=>Q.provideImplementation(S.URI.revive(K),j,H),[],H)}registerTypeDefinitionProvider(O,K,j){const H=this.t(new g(this.h,j),O);return this.e.$registerTypeDefinitionSupport(H,this.o(K,O)),this.p(H)}$provideTypeDefinition(O,K,j,H){return this.s(O,g,Q=>Q.provideTypeDefinition(S.URI.revive(K),j,H),[],H)}registerHoverProvider(O,K,j,H){const Q=this.t(new p(this.h,j),O);return this.e.$registerHoverProvider(Q,this.o(K,O)),this.p(Q)}$provideHover(O,K,j,H){return this.s(O,p,Q=>Q.provideHover(S.URI.revive(K),j,H),void 0,H)}registerEvaluatableExpressionProvider(O,K,j,H){const Q=this.t(new y(this.h,j),O);return this.e.$registerEvaluatableExpressionProvider(Q,this.o(K,O)),this.p(Q)}$provideEvaluatableExpression(O,K,j,H){return this.s(O,y,Q=>Q.provideEvaluatableExpression(S.URI.revive(K),j,H),void 0,H)}registerInlineValuesProvider(O,K,j,H){const Q=typeof j.onDidChangeInlineValues=="function"?this.q():void 0,oe=this.t(new T(this.h,j),O);this.e.$registerInlineValuesProvider(oe,this.o(K,O),Q);let Ee=this.p(oe);if(Q!==void 0){const Be=j.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Q));Ee=A.$qL.from(Ee,Be)}return Ee}$provideInlineValues(O,K,j,H,Q){return this.s(O,T,oe=>oe.provideInlineValues(S.URI.revive(K),j,H,Q),void 0,Q)}registerDocumentHighlightProvider(O,K,j){const H=this.t(new N(this.h,j),O);return this.e.$registerDocumentHighlightProvider(H,this.o(K,O)),this.p(H)}registerMultiDocumentHighlightProvider(O,K,j){const H=this.t(new J(this.h,j),O);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(K,O)),this.p(H)}$provideDocumentHighlights(O,K,j,H){return this.s(O,N,Q=>Q.provideDocumentHighlights(S.URI.revive(K),j,H),void 0,H)}$provideMultiDocumentHighlights(O,K,j,H,Q){return this.s(O,J,oe=>oe.provideMultiDocumentHighlights(S.URI.revive(K),j,H.map(Ee=>S.URI.revive(Ee)),Q),void 0,Q)}registerLinkedEditingRangeProvider(O,K,j){const H=this.t(new q(this.h,j),O);return this.e.$registerLinkedEditingRangeProvider(H,this.o(K,O)),this.p(H)}$provideLinkedEditingRanges(O,K,j,H){return this.s(O,q,async Q=>{const oe=await Q.provideLinkedEditingRanges(S.URI.revive(K),j,H);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?ke.w(oe.wordPattern):void 0}},void 0,H)}registerReferenceProvider(O,K,j){const H=this.t(new U(this.h,j),O);return this.e.$registerReferenceSupport(H,this.o(K,O)),this.p(H)}$provideReferences(O,K,j,H,Q){return this.s(O,U,oe=>oe.provideReferences(S.URI.revive(K),j,H,Q),void 0,Q)}registerCodeActionProvider(O,K,j,H){const Q=new r.$Sc,oe=this.t(new C(this.h,this.j.converter,this.k,j,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(oe,this.o(K,O),{providedKinds:H?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:H?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Q)}))},ke.u(O),!!j.resolveCodeAction),Q.add(this.p(oe)),Q}$provideCodeActions(O,K,j,H,Q){return this.s(O,C,oe=>oe.provideCodeActions(S.URI.revive(K),j,H,Q),void 0,Q)}$resolveCodeAction(O,K,j){return this.s(O,C,H=>H.resolveCodeAction(K,j),{},void 0)}$releaseCodeActions(O,K){this.s(O,C,j=>Promise.resolve(j.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(O,K,j){const H=this.t(new W(this.h,j),O);return this.e.$registerDocumentFormattingSupport(H,this.o(K,O),O.identifier,O.displayName||O.name),this.p(H)}$provideDocumentFormattingEdits(O,K,j,H){return this.s(O,W,Q=>Q.provideDocumentFormattingEdits(S.URI.revive(K),j,H),void 0,H)}registerDocumentRangeFormattingEditProvider(O,K,j){const H=typeof j.provideDocumentRangesFormattingEdits=="function",Q=this.t(new re(this.h,j),O);return this.e.$registerRangeFormattingSupport(Q,this.o(K,O),O.identifier,O.displayName||O.name,H),this.p(Q)}$provideDocumentRangeFormattingEdits(O,K,j,H,Q){return this.s(O,re,oe=>oe.provideDocumentRangeFormattingEdits(S.URI.revive(K),j,H,Q),void 0,Q)}$provideDocumentRangesFormattingEdits(O,K,j,H,Q){return this.s(O,re,oe=>oe.provideDocumentRangesFormattingEdits(S.URI.revive(K),j,H,Q),void 0,Q)}registerOnTypeFormattingEditProvider(O,K,j,H){const Q=this.t(new ce(this.h,j),O);return this.e.$registerOnTypeFormattingSupport(Q,this.o(K,O),H,O.identifier),this.p(Q)}$provideOnTypeFormattingEdits(O,K,j,H,Q,oe){return this.s(O,ce,Ee=>Ee.provideOnTypeFormattingEdits(S.URI.revive(K),j,H,Q,oe),void 0,oe)}registerWorkspaceSymbolProvider(O,K){const j=this.t(new we(K,this.l),O);return this.e.$registerNavigateTypeSupport(j,typeof K.resolveWorkspaceSymbol=="function"),this.p(j)}$provideWorkspaceSymbols(O,K,j){return this.s(O,we,H=>H.provideWorkspaceSymbols(K,j),{symbols:[]},j)}$resolveWorkspaceSymbol(O,K,j){return this.s(O,we,H=>H.resolveWorkspaceSymbol(K,j),void 0,void 0)}$releaseWorkspaceSymbols(O,K){this.s(O,we,j=>j.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(O,K,j){const H=this.t(new De(this.h,j,this.l),O);return this.e.$registerRenameSupport(H,this.o(K,O),De.supportsResolving(j)),this.p(H)}$provideRenameEdits(O,K,j,H,Q){return this.s(O,De,oe=>oe.provideRenameEdits(S.URI.revive(K),j,H,Q),void 0,Q)}$resolveRenameLocation(O,K,j,H){return this.s(O,De,Q=>Q.resolveRenameLocation(S.URI.revive(K),j,H),void 0,H)}registerNewSymbolNamesProvider(O,K,j){const H=this.t(new he(this.h,j,this.l),O);return this.e.$registerNewSymbolNamesProvider(H,this.o(K,O)),this.p(H)}$provideNewSymbolNames(O,K,j,H){return this.s(O,he,Q=>Q.provideNewSymbolNames(S.URI.revive(K),j,H),void 0,H)}registerDocumentSemanticTokensProvider(O,K,j,H){const Q=this.t(new se(this.h,j),O),oe=typeof j.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Q,this.o(K,O),H,oe);let Ee=this.p(Q);if(oe){const Be=j.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(oe));Ee=A.$qL.from(Ee,Be)}return Ee}$provideDocumentSemanticTokens(O,K,j,H){return this.s(O,se,Q=>Q.provideDocumentSemanticTokens(S.URI.revive(K),j,H),null,H)}$releaseDocumentSemanticTokens(O,K){this.s(O,se,j=>j.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,K,j,H){const Q=this.t(new $e(this.h,j),O);return this.e.$registerDocumentRangeSemanticTokensProvider(Q,this.o(K,O),H),this.p(Q)}$provideDocumentRangeSemanticTokens(O,K,j,H){return this.s(O,$e,Q=>Q.provideDocumentRangeSemanticTokens(S.URI.revive(K),j,H),null,H)}registerCompletionItemProvider(O,K,j,H){const Q=this.t(new te(this.h,this.j.converter,j,this.m,O),O);return this.e.$registerCompletionsProvider(Q,this.o(K,O),H,te.supportsResolving(j),O.identifier),this.p(Q)}$provideCompletionItems(O,K,j,H,Q){return this.s(O,te,oe=>oe.provideCompletionItems(S.URI.revive(K),j,H,Q),void 0,Q)}$resolveCompletionItem(O,K,j){return this.s(O,te,H=>H.resolveCompletionItem(K,j),void 0,j)}$releaseCompletionItems(O,K){this.s(O,te,j=>j.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(O,K,j,H){const Q=new V(O,this.h,j,this.j.converter),oe=this.t(Q,O);return this.e.$registerInlineCompletionsSupport(oe,this.o(K,O),Q.supportsHandleEvents,w.$nm.toKey(O.identifier.value),H?.yieldTo?.map(Ee=>w.$nm.toKey(Ee))||[]),this.p(oe)}$provideInlineCompletions(O,K,j,H,Q){return this.s(O,X,oe=>oe.provideInlineCompletions(S.URI.revive(K),j,H,Q),void 0,Q)}$handleInlineCompletionDidShow(O,K,j,H){this.s(O,X,async Q=>{Q.handleDidShowCompletionItem(K,j,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,K,j,H){this.s(O,X,async Q=>{Q.handlePartialAccept(K,j,H)},void 0,void 0)}$freeInlineCompletionsList(O,K){this.s(O,X,async j=>{j.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(O,K,j,H){const Q=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,oe=this.t(new Ce(this.h,j),O);return this.e.$registerSignatureHelpProvider(oe,this.o(K,O),Q),this.p(oe)}$provideSignatureHelp(O,K,j,H,Q){return this.s(O,Ce,oe=>oe.provideSignatureHelp(S.URI.revive(K),j,H,Q),void 0,Q)}$releaseSignatureHelp(O,K){this.s(O,Ce,j=>j.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(O,K,j){const H=typeof j.onDidChangeInlayHints=="function"?this.q():void 0,Q=this.t(new Te(this.h,this.j.converter,j,this.l,O),O);this.e.$registerInlayHintsProvider(Q,this.o(K,O),typeof j.resolveInlayHint=="function",H,ke.u(O));let oe=this.p(Q);if(H!==void 0){const Ee=j.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));oe=A.$qL.from(oe,Ee)}return oe}$provideInlayHints(O,K,j,H){return this.s(O,Te,Q=>Q.provideInlayHints(S.URI.revive(K),j,H),void 0,H)}$resolveInlayHint(O,K,j){return this.s(O,Te,H=>H.resolveInlayHint(K,j),void 0,j)}$releaseInlayHints(O,K){this.s(O,Te,j=>j.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(O,K,j){const H=this.t(new Pe(this.h,j),O);return this.e.$registerDocumentLinkProvider(H,this.o(K,O),typeof j.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(O,K,j){return this.s(O,Pe,H=>H.provideLinks(S.URI.revive(K),j),void 0,j,K.scheme==="output")}$resolveDocumentLink(O,K,j){return this.s(O,Pe,H=>H.resolveLink(K,j),void 0,void 0,!0)}$releaseDocumentLinks(O,K){this.s(O,Pe,j=>j.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(O,K,j){const H=this.t(new be(this.h,j),O);return this.e.$registerDocumentColorProvider(H,this.o(K,O)),this.p(H)}$provideDocumentColors(O,K,j){return this.s(O,be,H=>H.provideColors(S.URI.revive(K),j),[],j)}$provideColorPresentations(O,K,j,H){return this.s(O,be,Q=>Q.provideColorPresentations(S.URI.revive(K),j,H),void 0,H)}registerFoldingRangeProvider(O,K,j){const H=this.q(),Q=typeof j.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new ge(new me(this.h,j),O)),this.e.$registerFoldingRangeProvider(H,this.o(K,O),O.identifier,Q);let oe=this.p(H);if(Q!==void 0){const Ee=j.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Q));oe=A.$qL.from(oe,Ee)}return oe}$provideFoldingRanges(O,K,j,H){return this.s(O,me,Q=>Q.provideFoldingRanges(S.URI.revive(K),j,H),void 0,H)}registerSelectionRangeProvider(O,K,j){const H=this.t(new G(this.h,j,this.l),O);return this.e.$registerSelectionRangeProvider(H,this.o(K,O)),this.p(H)}$provideSelectionRanges(O,K,j,H){return this.s(O,G,Q=>Q.provideSelectionRanges(S.URI.revive(K),j,H),[],H)}registerCallHierarchyProvider(O,K,j){const H=this.t(new _(this.h,j),O);return this.e.$registerCallHierarchyProvider(H,this.o(K,O)),this.p(H)}$prepareCallHierarchy(O,K,j,H){return this.s(O,_,Q=>Promise.resolve(Q.prepareSession(S.URI.revive(K),j,H)),void 0,H)}$provideCallHierarchyIncomingCalls(O,K,j,H){return this.s(O,_,Q=>Q.provideCallsTo(K,j,H),void 0,H)}$provideCallHierarchyOutgoingCalls(O,K,j,H){return this.s(O,_,Q=>Q.provideCallsFrom(K,j,H),void 0,H)}$releaseCallHierarchy(O,K){this.s(O,_,j=>Promise.resolve(j.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(O,K,j){const H=this.t(new le(this.h,j),O);return this.e.$registerTypeHierarchyProvider(H,this.o(K,O)),this.p(H)}$prepareTypeHierarchy(O,K,j,H){return this.s(O,le,Q=>Promise.resolve(Q.prepareSession(S.URI.revive(K),j,H)),void 0,H)}$provideTypeHierarchySupertypes(O,K,j,H){return this.s(O,le,Q=>Q.provideSupertypes(K,j,H),void 0,H)}$provideTypeHierarchySubtypes(O,K,j,H){return this.s(O,le,Q=>Q.provideSubtypes(K,j,H),void 0,H)}$releaseTypeHierarchy(O,K){this.s(O,le,j=>Promise.resolve(j.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(O,K,j,H){const Q=this.q();this.f.set(Q,new ge(new de(this.e,this.h,j,Q,O),O));const oe=(0,t.$KF)(O,"dropMetadata")&&H?de.toInternalProviderId(O.identifier.value,H.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Q,this.o(K,O),oe,(0,t.$KF)(O,"dropMetadata")?H:void 0),this.p(Q)}$provideDocumentOnDropEdits(O,K,j,H,Q,oe){return this.s(O,de,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(K,S.URI.revive(j),H,Q,oe)),void 0,void 0)}registerMappedEditsProvider(O,K,j){const H=this.t(new Le(this.h,j),O);return this.e.$registerMappedEditsProvider(H,this.o(K,O)),this.p(H)}$provideMappedEdits(O,K,j,H,Q){return this.s(O,Le,oe=>Promise.resolve(oe.provideMappedEdits(K,j,H,Q)),null,Q)}registerDocumentPasteEditProvider(O,K,j,H){const Q=this.q();this.f.set(Q,new ge(new F(this.e,this.h,j,Q,O),O));const oe=F.toInternalProviderId(O.identifier.value,H.id);return this.e.$registerPasteEditProvider(Q,this.o(K,O),oe,{supportsCopy:!!j.prepareDocumentPaste,supportsPaste:!!j.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(Q)}$prepareDocumentPaste(O,K,j,H,Q){return this.s(O,F,oe=>oe.prepareDocumentPaste(S.URI.revive(K),j,H,Q),void 0,Q)}$providePasteEdits(O,K,j,H,Q,oe){return this.s(O,F,Ee=>Ee.providePasteEdits(K,S.URI.revive(j),H,Q,oe),void 0,oe)}static w(O){return{pattern:O.source,flags:O.flags}}static y(O){return{decreaseIndentPattern:ke.w(O.decreaseIndentPattern),increaseIndentPattern:ke.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ke.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ke.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:ke.w(O.beforeText),afterText:O.afterText?ke.w(O.afterText):void 0,previousLineText:O.previousLineText?ke.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(ke.z)}static C(O){return{open:O.open,close:O.close,notIn:O.notIn?O.notIn.map(K=>A.SyntaxTokenType.toString(K)):void 0}}static D(O){return O.map(ke.C)}setLanguageConfiguration(O,K,j){const{wordPattern:H}=j;if(H&&(0,f.$Ze)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(K,H):this.h.setWordDefinitionFor(K,void 0),j.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),j.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const Q=this.q(),oe={comments:j.comments,brackets:j.brackets,wordPattern:j.wordPattern?ke.w(j.wordPattern):void 0,indentationRules:j.indentationRules?ke.y(j.indentationRules):void 0,onEnterRules:j.onEnterRules?ke.B(j.onEnterRules):void 0,__electricCharacterSupport:j.__electricCharacterSupport,__characterPairSupport:j.__characterPairSupport,autoClosingPairs:j.autoClosingPairs?ke.D(j.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Q,K,oe),this.p(Q)}$setWordDefinitions(O){for(const K of O)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$Cgc=ke}),define(Ae[260],Me([1,0,3,8,7,32,11,6,25]),function(fe,e,S,M,I,A,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;class D{constructor(k,l,$,w){this.c=l,this.d=$,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(S.$oL.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,l){await this.a.$changeLanguage(k,l);const $=this.c.getDocumentData(k);if(!$)throw new Error(`document '${k.toString()}' NOT found`);return $.document}async tokenAtPosition(k,l){const $=k.version,w=M.Position.from(l),r=await this.a.$tokensAtPosition(k.uri,w),c={type:I.StandardTokenType.Other,range:k.getWordRangeAtPosition(l)??new I.$sL(l.line,l.character,l.line,l.character)};if(!r)return c;const s={range:M.Range.to(r.range),type:M.TokenType.to(r.type)};return!s.range.contains(l)||$!==k.version?c:s}createLanguageStatusItem(k,l,$){const w=this.f++,r=this.a,c=this.g,s=`${k.identifier.value}/${l}`;if(c.has(s))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);c.add(s);const i={selector:$,id:l,name:k.displayName??k.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const a=new m.$Sc,u=()=>{if(o?.dispose(),!c.has(s)){console.warn(`LanguageStatusItem (${l}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,R.$0g)(()=>{a.clear(),this.a.$setLanguageStatus(w,{id:s,name:i.name??k.displayName??k.name,source:k.displayName??k.name,selector:M.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===I.LanguageStatusSeverity.Error?A.default.Error:i.severity===I.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:i.command&&this.d.toInternal(i.command,a),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){a.dispose(),o?.dispose(),r.$removeLanguageStatus(w),c.delete(s)},get id(){return i.id},get name(){return i.name},set name(d){i.name=d,u()},get selector(){return i.selector},set selector(d){i.selector=d,u()},get text(){return i.text},set text(d){i.text=d,u()},set text2(d){(0,f.$LF)(k,"languageStatusText"),i.text=d,u()},get text2(){return(0,f.$LF)(k,"languageStatusText"),i.text},get detail(){return i.detail},set detail(d){i.detail=d,u()},get severity(){return i.severity},set severity(d){i.severity=d,u()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(d){i.accessibilityInformation=d,u()},get command(){return i.command},set command(d){i.command=d,u()},get busy(){return i.busy},set busy(d){i.busy=d,u()}};return u(),t}}e.$2hc=D}),define(Ae[261],Me([1,0,12,2,8,7,83]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=e.$Mhc=void 0;class m{constructor(k,l,$,w){this.start=k,this.deletedCount=l,this.deletedItems=$,this.items=w}asApiEvent(){return{range:new A.$PM(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(k,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,l,$){this.notebook=k,this.h=l,this.j=$,this.handle=$.handle,this.uri=M.URI.revive($.uri),this.cellKind=$.cellKind,this.a=$.outputs.map(I.NotebookCellOutput.to),this.e=$.internalMetadata??{},this.b=Object.freeze($.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to($.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const $={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return k.g},set mime(w){k.g=w},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze($)}return this.f}setOutputs(k){this.a=k.map(I.NotebookCellOutput.to)}setOutputItems(k,l,$){const w=$.map(I.NotebookCellOutputItem.to),r=this.a.find(c=>c.id===k);if(r&&(l||(r.items.length=0),r.items.push(...w),r.items.length>1&&r.items.every(c=>R.$qJ(c.mime)))){const c=new Map,s=[];r.items.forEach(i=>{let o;c.has(i.mime)?o=c.get(i.mime):(o=[],c.set(i.mime,o),s.push(i.mime)),o.push(i.data)}),r.items.length=0,s.forEach(i=>{const o=R.$rJ(c.get(i));r.items.push({mime:i,data:o.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$Mhc=f;class D{static{this.a=0}constructor(k,l,$,w,r){this.k=k,this.l=l,this.m=$,this.uri=w,this.handle=D.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,l={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===S.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt($){return $=k.n($),k.b[$].apiCell},getCells($){return($?k.p($):k.b).map(r=>r.apiCell)},save(){return k.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,l,$){this.g=k.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:$});const w={notebook:this.apiNotebook,metadata:$,cellChanges:[],contentChanges:[]},r=[];for(const s of k.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,w.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,w.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const c=new Map;for(let s=0;s<r.length;s++){const i=r[s],o=c.get(i.cell);if(o===void 0){const a=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});c.set(i.cell,a-1)}else w.cellChanges[o]={...w.cellChanges[o],...i}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let l=k.start|0,$=k.end|0;return l<0&&(l=0),$>this.b.length&&($=this.b.length),k.with({start:l,end:$})}p(k){k=this.o(k);const l=[];for(let $=k.start;$<k.end;$++)l.push(this.b[$]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,l,$){if(this.j)return;const w=[],r=[],c=[];if(k.reverse().forEach(s=>{const o=s[2].map(t=>{const d=new f(this,this.l,t);return l||r.push(f.asModelAddData(this.apiNotebook,t)),d}),a=new m(s[0],s[1],[],o),u=this.b.splice(s[0],s[1],...o);for(const t of u)c.push(t.uri),a.deletedItems.push(t.apiCell);w.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:c}),$)for(const s of w)$.push(s.asApiEvent())}s(k,l,$,w){const r=this.b.splice(k,l);this.b.splice($,0,...r);const c=[new m(k,l,r.map(s=>s.apiCell),[]),new m($,0,[],r)];for(const s of c)w.push(s.asApiEvent())}t(k,l){this.b[k].setOutputs(l)}u(k,l,$,w){this.b[k].setOutputItems(l,$,w)}v(k,l){const $=this.b[k];$.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged($.uri,l)}w(k,l){const $=this.b[k];$.apiCell.mime=l}x(k,l){this.b[k].setMetadata(l)}y(k,l){this.b[k].setInternalMetadata(l)}getCellFromApiCell(k){return this.b.find(l=>l.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(l=>l.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$Nhc=D}),define(Ae[262],Me([1,0,5,2,8,7]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class R{constructor(f,D,L,k={timeout:1500,errors:3}){this.b=f,this.c=D,this.d=L,this.f=k,this.a=new S.$Yd}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(D,L,k)=>{const l=function(w){D.call(L,w)};return l.extension=f,this.a.event(l,void 0,k)}}async $participateInSave(f,D,L){const k=M.URI.revive(f),l=this.c.getNotebookDocument(k);if(!l)throw new Error("Unable to resolve notebook document");const $=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(D)},L,async(r,c)=>{const s=Date.now(),i=await await Promise.resolve(r);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!L.isCancellationRequested&&i&&(i instanceof A.$AL?$.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if($.length===0)return!0;const w={edits:[]};for(const r of $){const{edits:c}=I.WorkspaceEdit.from(r);w.edits=w.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(w)}}e.$4hc=R}),define(Ae[110],Me([1,0,15,8,7]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,f,D,L,k,l){this.id=m,this.f=f,this.notebookData=D,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=L,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(f){this.selections=[f]},get selections(){return m.a},set selections(f){if(!Array.isArray(f)||!f.every(I.$PM.isNotebookRange))throw(0,S.$7)("selections");m.a=f,m.g(f)},get visibleRanges(){return m.b},revealRange(f,D){m.f.$tryRevealRange(m.id,M.NotebookRange.from(f),D??I.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(M.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$Ohc=A}),define(Ae[263],Me([1,0,5,14,8]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;let A=class{constructor(m,f){this.c=m,this.d=f,this.a=new S.$Wd,this.b=new S.$Wd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,f);const D=this.d.getEditorById(m);f.visibleRanges&&D._acceptVisibleRanges(f.visibleRanges.ranges.map(I.NotebookRange.to)),f.selections&&D._acceptSelections(f.selections.selections.map(I.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const f in m)this.d.getEditorById(f)._acceptViewColumn(I.ViewColumn.to(m[f]))}};e.$6hc=A,e.$6hc=A=Je([qe(0,M.$pj)],A)}),define(Ae[264],Me([1,0,5,3,110]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;class A{constructor(m,f){this.c=f,this.a=new Map,this.b=m.getProxy(M.$oL.MainThreadNotebookRenderers)}$postRendererMessage(m,f,D){const L=this.c.getEditorById(m);this.a.get(f)?.fire({editor:L.apiEditor,message:D})}createRendererMessaging(m,f){if(!m.contributes?.notebookRenderer?.some(L=>L.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(L,k,l)=>this.d(f).event(L,k,l),postMessage:(L,k)=>{I.$Ohc.apiEditorsToExtHost.has(L)&&([L,k]=[k,L]);const l=k&&I.$Ohc.apiEditorsToExtHost.get(k);return this.b.$postMessage(l?.id,f,L)}}}d(m){let f=this.a.get(m);return f||(f=new S.$Wd({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(m)}}),this.a.set(m,f),f)}}e.$9hc=A}),define(Ae[265],Me([1,0,8,99,21,67,15]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;class m{constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,l,$){const w=this.b++,{title:r,location:c,cancellable:s}=l,i={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(w,{location:S.ProgressLocation.from(c),title:r,source:i,cancellable:s},k.isUnderDevelopment?void 0:k.identifier.value).catch(R.$2),this.d(w,$,!!s)}d(k,l,$){let w;$&&(w=new I.$7d,this.c.set(k,w));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),w?.dispose()};let c;try{c=l(new D(this.a,k),$&&w?w.token:I.CancellationToken.None)}catch(s){throw r(k),s}return c.then(s=>r(k),s=>r(k)),c}$acceptProgressCanceled(k){const l=this.c.get(k);l&&(l.cancel(),this.c.delete(k))}}e.$aic=m;function f(L,k){return L.message=k.message,typeof k.increment=="number"&&(typeof L.increment=="number"?L.increment+=k.increment:L.increment=k.increment),L}class D extends M.$xv{constructor(k,l){super($=>this.throttledReport($)),this.c=k,this.d=l}throttledReport(k){this.c.$progressReport(this.d,k)}}Je([(0,A.$Bh)(100,(L,k)=>f(L,k),()=>Object.create(null))],D.prototype,"throttledReport",null)}),define(Ae[266],Me([1,0,2,3,11,8]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;class R{static{this.a=0}constructor(f,D){this.d=D,this.c=new Map,this.b=f.getProxy(M.$oL.MainThreadQuickDiff)}$provideOriginalResource(f,D,L){const k=S.URI.revive(D),l=this.c.get(f);return l?(0,I.$Zg)(()=>l.provideOriginalResource(k,L)).then($=>$||null):Promise.resolve(null)}registerQuickDiffProvider(f,D,L,k){const l=R.a++;return this.c.set(l,D),this.b.$registerQuickDiffProvider(l,A.DocumentSelector.from(f,this.d),L,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$bic=R}),define(Ae[267],Me([1,0,21,5,6,3,2,7,15,18,32,40,25,8]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;function w(r,c,s){const i=r.getProxy(A.$oL.MainThreadQuickOpen);class o{constructor(v,P){this.e=new Map,this.f=0,this.a=v,this.b=P}showQuickPick(v,P,g,p=S.CancellationToken.None){this.c=void 0;const y=Promise.resolve(P),T=++this.f,N=i.$show(T,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},p),J={},q=N.then(()=>J);return Promise.race([q,y]).then(U=>{if(U===J)return;const C=(0,l.$KF)(v,"quickPickItemTooltip");return y.then(F=>{const W=[];for(let re=0;re<F.length;re++){const ce=F[re];if(typeof ce=="string")W.push({label:ce,handle:re});else if(ce.kind===m.QuickPickItemKind.Separator)W.push({type:"separator",label:ce.label});else{ce.tooltip&&!C&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const we=ce.iconPath?n(ce.iconPath):void 0;W.push({label:ce.label,iconPath:we?.iconPath,iconClass:we?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:C?$.MarkdownString.fromStrict(ce.tooltip):void 0,handle:re})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=re=>{g.onDidSelectItem(F[re])}),i.$setItems(T,W),N.then(re=>{if(typeof re=="number")return F[re];if(Array.isArray(re))return re.map(ce=>F[ce])})})}).then(void 0,U=>{if(!(0,f.$4)(U))return i.$setError(T,U),Promise.reject(U)})}$onItemSelected(v){this.c?.(v)}showInput(v,P=S.CancellationToken.None){return this.d=v?.validateInput,i.$input(v,typeof this.d=="function",P).then(void 0,g=>{if(!(0,f.$4)(g))return Promise.reject(g)})}async $validateInput(v){if(!this.d)return;const P=await this.d(v);if(!P||typeof P=="string")return P;let g;switch(P.severity){case m.InputBoxValidationSeverity.Info:g=L.default.Info;break;case m.InputBoxValidationSeverity.Warning:g=L.default.Warning;break;case m.InputBoxValidationSeverity.Error:g=L.default.Error;break;default:g=P.message?L.default.Error:L.default.Ignore;break}return{content:P.message,severity:g}}async showWorkspaceFolderPick(v,P=S.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!g)return;const p=await this.a.getWorkspaceFolders2();if(p)return p.find(y=>y.uri.toString()===g.uri.toString())}createQuickPick(v){const P=new b(v,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}createInputBox(v){const P=new E(v,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}$onDidChangeValue(v,P){this.e.get(v)?._fireDidChangeValue(P)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,P){const g=this.e.get(v);g instanceof b&&g._fireDidChangeActive(P)}$onDidChangeSelection(v,P){const g=this.e.get(v);g instanceof b&&g._fireDidChangeSelection(P)}$onDidTriggerButton(v,P){this.e.get(v)?._fireDidTriggerButton(P)}$onDidTriggerItemButton(v,P,g){const p=this.e.get(v);p instanceof b&&p._fireDidTriggerItemButton(P,g)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class a{static{this.a=1}constructor(v,P){this.x=v,this.y=P,this._id=b.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Wd,this.q=new M.$Wd,this.r=new M.$Wd,this.s=new M.$Wd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((P,g)=>{const p=P===m.$MM.Back?-1:g;this.o.set(p,P)}),this.z({buttons:v.map((P,g)=>({...n(P.iconPath),tooltip:P.tooltip,handle:P===m.$MM.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const P=this.o.get(v);P&&this.r.fire(P)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(v){if(!this.v){for(const P of Object.keys(v)){const g=v[P];this.u[P]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function u(h){if(h instanceof m.$lM)return{id:h.id};const v=d(h),P=t(h);return{dark:typeof v=="string"?R.URI.file(v):v,light:typeof P=="string"?R.URI.file(P):P}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function d(h){return typeof h=="object"&&"dark"in h?h.dark:h}function n(h){const v=u(h);let P,g;return"id"in v?g=k.ThemeIcon.asClassName(v):P=v,{iconPath:P,iconClass:g}}class b extends a{constructor(v,P){super(v.identifier,P),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Wd,this.L=[],this.M=new M.$Wd,this.N=new M.$Wd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((p,y)=>{this.C.set(y,p),this.D.set(p,y)});const P=(0,l.$KF)(this.O,"quickPickItemTooltip"),g=[];for(let p=0;p<v.length;p++){const y=v[p];if(y.kind===m.QuickPickItemKind.Separator)g.push({type:"separator",label:y.label});else{y.tooltip&&!P&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const T=y.iconPath?n(y.iconPath):void 0;g.push({handle:p,label:y.label,iconPath:T?.iconPath,iconClass:T?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:P?$.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((N,J)=>({...n(N.iconPath),tooltip:N.tooltip,handle:J}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(P=>this.D.has(P)),this.z({activeItems:this.J.map(P=>this.D.get(P))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(P=>this.D.has(P)),this.z({selectedItems:this.L.map(P=>this.D.get(P))})}_fireDidChangeActive(v){const P=(0,D.$Hb)(v.map(g=>this.C.get(g)));this.J=P,this.K.fire(P)}_fireDidChangeSelection(v){const P=(0,D.$Hb)(v.map(g=>this.C.get(g)));this.L=P,this.M.fire(P)}_fireDidTriggerItemButton(v,P){const g=this.C.get(v);if(!g||!g.buttons||!g.buttons.length)return;const p=g.buttons[P];p&&this.N.fire({button:p,item:g})}}class E extends a{constructor(v,P){super(v.identifier,P),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:L.default.Error}):this.z({validationMessage:v.message,severity:v.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new o(c,s)}e.$cic=w}),define(Ae[268],Me([1,0,2,5,67,6,11,3,18,139,14,22,40,8,25,12,20]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=e.$dic=void 0;function i(T){return T instanceof S.URI}function o(T,N){return T.scheme===r.Schemas.file&&N.scheme===r.Schemas.file&&c.$k?T.toString()===N.toString():T.toString().toLowerCase()===N.toString().toLowerCase()}function a(T){if(T)return typeof T.iconPath=="string"?S.URI.file(T.iconPath):S.URI.isUri(T.iconPath)||l.ThemeIcon.isThemeIcon(T.iconPath)?T.iconPath:void 0}function u(T){if(T.icon){if(S.URI.isUri(T.icon))return T.icon;if(l.ThemeIcon.isThemeIcon(T.icon))return T.icon;{const N=T.icon;return{light:N.light,dark:N.dark}}}else return}function t(T,N){if(!T.iconPath&&!N.iconPath)return 0;if(T.iconPath){if(!N.iconPath)return 1}else return-1;const J=typeof T.iconPath=="string"?T.iconPath:S.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id,q=typeof N.iconPath=="string"?N.iconPath:S.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,D.$Uq)(J,q)}function d(T,N){let J=0;if(T.strikeThrough!==N.strikeThrough)return T.strikeThrough?1:-1;if(T.faded!==N.faded)return T.faded?1:-1;if(T.tooltip!==N.tooltip)return(T.tooltip||"").localeCompare(N.tooltip||"");if(J=t(T,N),J!==0)return J;if(T.light&&N.light)J=t(T.light,N.light);else{if(T.light)return 1;if(N.light)return-1}if(J!==0)return J;if(T.dark&&N.dark)J=t(T.dark,N.dark);else{if(T.dark)return 1;if(N.dark)return-1}return J}function n(T,N){if(T.command!==N.command)return T.command<N.command?-1:1;if(T.title!==N.title)return T.title<N.title?-1:1;if(T.tooltip!==N.tooltip){if(T.tooltip!==void 0&&N.tooltip!==void 0)return T.tooltip<N.tooltip?-1:1;if(T.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(T.arguments===N.arguments)return 0;if(T.arguments)if(N.arguments){if(T.arguments.length!==N.arguments.length)return T.arguments.length-N.arguments.length}else return 1;else return-1;for(let J=0;J<T.arguments.length;J++){const q=T.arguments[J],U=N.arguments[J];if(q!==U&&!(i(q)&&i(U)&&o(q,U)))return q<U?-1:1}return 0}function b(T,N){let J=(0,D.$Uq)(T.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(J!==0)return J;if(T.command&&N.command)J=n(T.command,N.command);else{if(T.command)return 1;if(N.command)return-1}if(J!==0)return J;if(T.decorations&&N.decorations)J=d(T.decorations,N.decorations);else{if(T.decorations)return 1;if(N.decorations)return-1}if(T.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)J=(0,D.$Uq)(T.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(T.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(T.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)J=(0,D.$Uq)(T.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(T.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return J}function E(T,N){for(let J=0;J<T.length;J++)if(T[J]!==N[J])return!1;return!0}function h(T,N){return T.command===N.command&&T.title===N.title&&T.tooltip===N.tooltip&&(T.arguments&&N.arguments?E(T.arguments,N.arguments):T.arguments===N.arguments)}function v(T,N){return(0,f.$ub)(T,N,h)}class P{#e;#t;get value(){return this.d}set value(N){N=N??"",this.#e.$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){this.#e.$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,w.$LF)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,w.$LF)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,this.#e.$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,this.#e.$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,this.#e.$setInputBoxVisibility(this.l,N))}get document(){return(0,w.$LF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(N,J,q,U,C){this.k=N,this.l=U,this.m=C,this.d="",this.e=new M.$Wd,this.f="",this.h=!0,this.j=!0,this.#t=J,this.#e=q}showValidationMessage(N,J){(0,w.$LF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,N,J)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$dic=P;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,J,q,U,C,F,W){this.q=N,this.s=J,this.t=q,this.u=U,this.v=C,this.multiDiffEditorEnableViewChanges=F,this.w=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Wd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Wd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,J){const q=this.h.get(N);return q?(0,R.$Zg)(()=>this.s.executeCommand(q.command,...q.arguments||[],J)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort(b),q=(0,f.$Db)(this.o,N,b).map(F=>{const W=F.toInsert.map(re=>{const ce=this.e++;this.g.set(ce,re);const we=re.resourceUri;let De;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const me=new A.$Sc;De=this.s.converter.toInternal(re.command,me),this.j.set(ce,me)}else this.h.set(ce,re.command);const he=(0,w.$KF)(this.w,"scmMultiDiffEditor"),ve=he?re.multiDiffEditorOriginalUri:void 0,se=he?re.multiFileDiffEditorModifiedUri:void 0,$e=a(re.decorations),te=re.decorations&&a(re.decorations.light)||$e,X=re.decorations&&a(re.decorations.dark)||$e,V=[te,X],ie=re.decorations&&re.decorations.tooltip||"",Ce=re.decorations&&!!re.decorations.strikeThrough,Te=re.decorations&&!!re.decorations.faded,Pe=re.contextValue||"";return{rawResource:[ce,we,V,ie,Ce,Te,Pe,De,ve,se],handle:ce}});return{start:F.start,deleteCount:F.deleteCount,toInsert:W}}),U=q.map(({start:F,deleteCount:W,toInsert:re})=>[F,W,re.map(ce=>ce.rawResource)]),C=q.reverse();for(const{start:F,deleteCount:W,toInsert:re}of C){const ce=re.map(De=>De.handle),we=this.n.splice(F,W,...ce);for(const De of we)this.g.delete(De),this.h.delete(De),this.j.get(De)?.dispose(),this.j.delete(De)}return this.o=N,U}dispose(){this.l=!0,this.m.fire()}}class p{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,this.#e.$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let J;(0,w.$KF)(this.x,"quickDiffProvider")&&(J=N?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:J})}get historyProvider(){return(0,w.$LF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,w.$LF)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new A.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,this.#e.$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new A.$Sc,this.o=N;const J=this.y.converter.toInternal(N,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:J})}get actionButton(){return(0,w.$LF)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,w.$LF)(this.x,"scmActionButton"),this.p.value=new A.$Sc,this.q=N;const J=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(q=>q.map(U=>this.y.converter.toInternal(U,this.p.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:J??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.t&&N&&v(this.t,N))return;this.s.value=new A.$Sc,this.t=N;const J=(N||[]).map(q=>this.y.converter.toInternal(q,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:J})}get selected(){return this.u}constructor(N,J,q,U,C,F,W){this.x=N,this.y=U,this.z=C,this.A=F,this.B=W,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Uc,this.m=void 0,this.n=new A.$Uc,this.o=void 0,this.p=new A.$Uc,this.s=new A.$Uc,this.t=void 0,this.u=!1,this.v=new M.$Wd,this.onDidChangeSelection=this.v.event,this.w=p.d++,this.C=new Map,this.D=new Set,this.#e=q;const re=S.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:W?`rootUri=${encodeURIComponent(W.toString())}`:void 0});this.f=new P(N,J,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,C,F,W,re)}createResourceGroup(N,J,q){const U=(0,w.$KF)(this.x,"scmMultiDiffEditor")&&q?.multiDiffEditorEnableViewChanges===!0,C=new g(this.#e,this.y,this.w,N,J,U,this.x),F=M.Event.once(C.onDidDispose)(()=>this.C.delete(C));return this.C.set(C,F),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const N=[],J=[];for(const[q,U]of this.C){U.dispose();const C=q.onDidUpdateResourceStates(()=>{this.D.add(q),this.eventuallyUpdateResourceStates()});M.Event.once(q.onDidDispose)(()=>{this.D.delete(q),C.dispose(),this.e.delete(q.handle),this.#e.$unregisterGroup(this.w,q.handle)}),N.push([q.handle,q.id,q.label,q.features,q.multiDiffEditorEnableViewChanges]);const F=q._takeResourceStateSnapshot();F.length>0&&J.push([q.handle,F]),this.e.set(q.handle,q)}this.#e.$registerGroups(this.w,N,J),this.C.clear()}eventuallyUpdateResourceStates(){const N=[];this.D.forEach(J=>{const q=J._takeResourceStateSnapshot();q.length!==0&&N.push([J.handle,q])}),N.length>0&&this.#e.$spliceResourceStates(this.w,N),this.D.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,I.$Ah)(100)],p.prototype,"eventuallyAddResourceGroups",null),Je([(0,I.$Ah)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(N,J,q,U){this.l=J,this.m=q,this.n=U,this.g=new Map,this.h=new k.$pm,this.j=new M.$Wd,this.e=N.getProxy(m.$oL.MainThreadSCM),this.f=N.getProxy(m.$oL.MainThreadTelemetry),J.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const F=this.g.get(C.sourceControlHandle);if(!F)return C;const W=F.getResourceGroup(C.groupHandle);return W?W.getResourceState(C.handle):C}else if(C&&C.$mid===4){const F=this.g.get(C.sourceControlHandle);return F?F.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const F=this.g.get(C.handle);return F||C}return C}})}createSourceControl(N,J,q,U){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,J,q,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const C=s.d++,F=new p(N,this.m,this.e,this.l,J,q,U);this.g.set(C,F);const W=this.h.get(N.identifier)||[];return W.push(F),this.h.set(N.identifier,W),F}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const J=this.h.get(N.identifier),q=J&&J[J.length-1];return q&&q.inputBox}$provideOriginalResource(N,J,q){const U=S.URI.revive(J);this.n.trace("ExtHostSCM#$provideOriginalResource",N,U.toString());const C=this.g.get(N);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Zg)(()=>C.quickDiffProvider.provideOriginalResource(U,q)).then(F=>F||null)}$onInputBoxValueChange(N,J){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const q=this.g.get(N);return q&&q.inputBox.$onInputBoxValueChange(J),Promise.resolve(void 0)}$executeResourceCommand(N,J,q,U){this.n.trace("ExtHostSCM#$executeResourceCommand",N,J,q);const C=this.g.get(N);if(!C)return Promise.resolve(void 0);const F=C.getResourceGroup(J);return F?F.$executeResourceCommand(q,U):Promise.resolve(void 0)}$validateInput(N,J,q){this.n.trace("ExtHostSCM#$validateInput",N);const U=this.g.get(N);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Zg)(()=>U.inputBox.validateInput(J,q)).then(C=>{if(!C)return Promise.resolve(void 0);const F=$.MarkdownString.fromStrict(C.message);return F?Promise.resolve([F,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,J,q,U){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(J,q,U)??void 0}async $provideHistoryItems(N,J,q,U){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(J,q,U))?.map(W=>({...W,icon:u(W)}))??void 0}async $provideHistoryItemSummary(N,J,q,U){const C=this.g.get(N)?.historyProvider;if(typeof C?.provideHistoryItemSummary!="function")return;const F=await C.provideHistoryItemSummary(J,q,U);return F?{...F,icon:u(F)}:void 0}async $provideHistoryItemChanges(N,J,q,U){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(J,q,U)??void 0}};e.$eic=y,e.$eic=y=s=Je([qe(3,L.$pj)],y)}),define(Ae[269],Me([1,0,3,8,2]),function(fe,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0;class A{static{this.a=0}constructor(m,f){this.d=f,this.c=new Map,this.b=m.getProxy(S.$oL.MainThreadShare)}async $provideShare(m,f,D){return await this.c.get(m)?.provideShare({selection:M.Range.to(f.selection),resourceUri:I.URI.revive(f.resourceUri)},D)??void 0}registerShareProvider(m,f){const D=A.a++;return this.c.set(D,f),this.b.$registerShareProvider(D,M.DocumentSelector.from(m,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(D),this.c.delete(D)}}}}e.$fic=A}),define(Ae[270],Me([1,0,7,3,165,6,8,16]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=e.$hic=void 0;class f{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$mM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$mM("statusBarItem.warningForeground")]])}#e;#t;constructor(l,$,w,r,c,s=S.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new A.$Sc,this.#e=l,this.#t=$,c&&r){this.c=(0,S.$2L)(r.identifier,c);const o=w.get(this.c);o&&(s=o.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,i=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(f.a++);this.e=r,this.f=c,this.g=s,this.h=this.u(i)}u(l){if((0,m.$Nf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!f.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new A.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let $;this.m?$=this.m:$=(0,I.localize)(0,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=f.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,$,this.k,r,this.r?.internal,w,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$hic=f;class D{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const $={message:l};return this.b.unshift($),this.c(),new S.$qL(()=>{const w=this.b.indexOf($);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class L{constructor(l,$){this.e=new Map,this.a=l.getProxy(M.$oL.MainThreadStatusBar),this.b=$,this.c=new D(this)}$acceptStaticEntries(l){for(const $ of l)this.e.set($.entryId,$)}createStatusBarEntry(l,$,w,r){return new f(this.a,this.b,this.e,l,$,w,r)}setStatusBarMessage(l,$){const w=this.c.setMessage(l);let r;return typeof $=="number"?r=setTimeout(()=>w.dispose(),$):typeof $<"u"&&$.then(()=>w.dispose(),()=>w.dispose()),new S.$qL(()=>{w.dispose(),clearTimeout(r)})}}e.$iic=L}),define(Ae[111],Me([1,0,29,103,49,75,59,8,2]),function(fe,e,S,M,I,A,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=e.$ON=e.$NN=e.$MN=void 0;const D=(o,a,u,t)=>{let d=a;return{enumerable:!0,configurable:!1,get(){return d},set(n){if(!u(d,n)){const b=d;d=n,o.listener?.(t(n,b))}}}},L=(o,a)=>o===a,k={range:(o,a)=>o===a?!0:!o||!a?!1:o.isEqual(a),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(o,a)=>!(o.length!==a.length||o.some(u=>!a.find(t=>u.id===t.id)))},l=o=>a=>({op:4,update:o(a)}),$=(o,a)=>({range:(()=>{let u;const t=l(d=>({range:S.$Ws.lift(m.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return u},set(d){o.listener?.({op:6}),k.range(u,d)||(u=d,o.listener?.(t(d)))}}})(),label:D(o,a,k.label,l(u=>({label:u}))),description:D(o,void 0,k.description,l(u=>({description:u}))),sortText:D(o,void 0,k.sortText,l(u=>({sortText:u}))),canResolveChildren:D(o,!1,k.canResolveChildren,u=>({op:2,state:u})),busy:D(o,!1,k.busy,l(u=>({busy:u}))),error:D(o,void 0,k.error,l(u=>({error:m.MarkdownString.fromStrict(u)||null}))),tags:D(o,[],k.tags,(u,t)=>({op:1,new:u.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),w=o=>{const a=I.$fK.fromString(o.extId),u=new c(a.controllerId,a.localId,o.label,f.URI.revive(o.uri)||void 0);return u.range=m.Range.to(o.range||void 0),u.description=o.description||void 0,u.sortText=o.sortText||void 0,u.tags=o.tags.map(t=>m.TestTag.to({id:(0,R.$kK)(t).tagId})),u},r=o=>{let a;for(const u of o.tests){const t=w(u.item);(0,M.$wN)(t).parent=a,a=t}return a};e.$MN=r;class c{constructor(a,u,t,d){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const n=(0,M.$vN)(this,a);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof s?void 0:n.parent}},children:{value:(0,A.$uN)(n,M.$wN,c),enumerable:!0,writable:!1},...$(n,t)})}}e.$NN=c;class s extends c{constructor(a,u){super(a,a,u,void 0),this._isRoot=!0}}e.$ON=s;class i extends A.$qN{constructor(a,u,t){super({controllerId:a,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:M.$wN,getChildren:d=>d.children,root:new s(a,u),toITestItem:m.TestItem.from})}}e.$PN=i}),define(Ae[31],Me([1,0,16,7,8,26,3,18,14,52,29,91,2,6,4,17,111,23,50,41,63,57,60,33]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o,a,u,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=void 0;let n=class{#e;#t;#i;constructor(g,p,y){this.b=new Map,this.c=new Map,this.#e=g.getProxy(R.$oL.MainThreadCommands),this.d=p,this.#i=y,this.#t=g.getProxy(R.$oL.MainThreadTelemetry),this.converter=new b(this,T=>{const N=this.c.get(T);return N?.result===h.Void?N:void 0},p),this.f=[{processArgument(T){return(0,D.$Eh)(T)}},{processArgument(T){return(0,A.$An)(T,function(N){if(L.$Ws.isIRange(N))return I.Range.to(N);if(k.$Vs.isIPosition(N))return I.Position.to(N);if(L.$Ws.isIRange(N.range)&&l.URI.isUri(N.uri))return I.location.to(N);if(N instanceof s.$ke)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const p=this.registerCommand(!1,g.id,async(...y)=>{const T=g.args.map((J,q)=>{if(!J.validate(y[q]))throw new Error(`Invalid argument '${J.name}' when running '${g.id}', received: ${typeof y[q]=="object"?JSON.stringify(y[q],null,"	"):y[q]} `);return J.convert(y[q])}),N=await this.executeCommand(g.internalId,...T);return g.result.convert(N,y,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new M.$qL(()=>{p.dispose(),this.c.delete(g.id)})}registerCommand(g,p,y,T,N,J){if(this.d.trace("ExtHostCommands#registerCommand",p),!p.trim().length)throw new Error("invalid id");if(this.b.has(p))throw new Error(`command '${p}' already exists`);return this.b.set(p,{callback:y,thisArg:T,metadata:N,extension:J}),g&&this.#e.$registerCommand(p),new M.$qL(()=>{this.b.delete(p)&&g&&this.#e.$unregisterCommand(p)})}executeCommand(g,...p){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,p,!0)}async g(g,p,y){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,p,!1);{let T=!1;const N=(0,A.$An)(p,function(J){if(J instanceof M.$rL)return I.Position.from(J);if(J instanceof M.$sL)return I.Range.from(J);if(J instanceof M.$CL)return I.location.from(J);if(M.$PM.isNotebookRange(J))return I.NotebookRange.from(J);if(J instanceof ArrayBuffer)return T=!0,s.$ke.wrap(new Uint8Array(J));if(J instanceof Uint8Array)return T=!0,s.$ke.wrap(J);if(J instanceof s.$ke)return T=!0,J;if(!Array.isArray(J))return J});try{const J=await this.#e.$executeCommand(g,T?new i.$Vv(N):N,y);return(0,D.$Eh)(J)}catch(J){if(J instanceof Error&&J.message==="$executeCommand:retry")return this.g(g,p,!1);throw J}}}async h(g,p,y){const T=this.b.get(g);if(!T)throw new Error("Unknown command");const{callback:N,thisArg:J,metadata:q}=T;if(q?.args)for(let C=0;C<q.args.length;C++)try{(0,S.$1f)(p[C],q.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${q.args[C].name}' - ${q.args[C].description}`)}const U=a.$Sd.create();try{return await N.apply(J,p)}catch(C){if(g===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...p);F&&(g=F.command)}if(this.d.error(C,g,T.extension?.identifier),!y)throw C;if(T.extension?.identifier){const F=this.#i.onExtensionError(T.extension.identifier,C);this.d.trace("forwarded error to extension?",F,T.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Si)(C)),this.id=g,this.source=T.extension?.displayName??T.extension?.name}}}finally{this.j(T,g,U.elapsed())}}j(g,p,y){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new u.$No(p),duration:y})}$executeContributedCommand(g,...p){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const y=this.b.get(g);return y?(p=p.map(T=>this.f.reduce((N,J)=>J.processArgument(N,y.extension?.identifier),T)),this.h(g,p,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(p=>(g&&(p=p.filter(y=>y[0]!=="_")),p))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[p,y]of this.b){const{metadata:T}=y;T&&(g[p]=T)}return Promise.resolve(g)}};e.$VN=n,e.$VN=n=Je([qe(0,r.$AN),qe(1,f.$pj),qe(2,t.$UN)],n),e.$WN=(0,w.$8h)("IExtHostCommands");class b{constructor(g,p,y){this.d=g,this.f=p,this.g=y,this.delegatingCommandId=`__vsc${(0,d.$rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,p){if(!g)return;const y={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return y;const T=this.f(g.command);if(T)y.id=T.internalId,y.arguments=T.args.map((N,J)=>N.convert(g.arguments&&g.arguments[J]));else if((0,m.$Lb)(g.arguments)){const N=`${g.command} /${++this.c}`;this.b.set(N,g),p.add((0,$.$Rc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),y.$ident=N,y.id=this.delegatingCommandId,y.arguments=[N],this.g.trace("CommandsConverter#CREATE",g.command,N)}return y}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const p=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],p?p.command:"MISSING"),p?this.d.executeCommand(p.command,...p.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$XN=b;class E{static{this.Uri=new E("uri","Uri of a text document",g=>l.URI.isUri(g),g=>g)}static{this.Position=new E("position","A position in a text document",g=>M.$rL.isPosition(g),I.Position.from)}static{this.Range=new E("range","A range in a text document",g=>M.$sL.isRange(g),I.Range.from)}static{this.Selection=new E("selection","A selection in a text document",g=>M.$tL.isSelection(g),I.Selection.from)}static{this.Number=new E("number","",g=>typeof g=="number",g=>g)}static{this.String=new E("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=E.Arr(E.String)}static Arr(g){return new E(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,p=>Array.isArray(p)&&p.every(y=>g.validate(y)),p=>p.map(y=>g.convert(y)))}static{this.CallHierarchyItem=new E("item","A call hierarchy item",g=>g instanceof M.$NL,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new E("item","A type hierarchy item",g=>g instanceof M.$9M,I.TypeHierarchyItem.from)}static{this.TestItem=new E("testItem","A VS Code TestItem",g=>g instanceof c.$NN,I.TestItem.from)}constructor(g,p,y,T){this.name=g,this.description=p,this.validate=y,this.convert=T}optional(){return new E(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,p){return new E(g??this.name,p??this.description,this.validate,this.convert)}}e.$YN=E;class h{static{this.Void=new h("no result",g=>g)}constructor(g,p){this.description=g,this.convert=p}}e.$ZN=h;class v{constructor(g,p,y,T,N){this.id=g,this.internalId=p,this.description=y,this.args=T,this.result=N}}e.$1N=v}),define(Ae[271],Me([1,0,18,12,2,86,95,35,31,8,7]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;const k=[new f.$1N("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$YN.Uri,f.$YN.Position],new f.$ZN("A promise that resolves to an array of DocumentHighlight-instances.",$(D.DocumentHighlight.to))),new f.$1N("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$YN.Uri],new f.$ZN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,c)=>{if((0,S.$Kb)(r))return;class s extends L.$IL{static to(o){const a=new s(o.name,D.SymbolKind.to(o.kind),o.containerName||"",new L.$CL(c[0],D.Range.to(o.range)));return a.detail=o.detail,a.range=a.location.range,a.selectionRange=D.Range.to(o.selectionRange),a.children=o.children?o.children.map(s.to):[],a}}return r.map(s.to)})),new f.$1N("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$YN.Uri,new f.$YN("options","Formatting options",r=>!0,r=>r)],new f.$ZN("A promise that resolves to an array of TextEdits.",$(D.TextEdit.to))),new f.$1N("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$YN.Uri,f.$YN.Range,new f.$YN("options","Formatting options",r=>!0,r=>r)],new f.$ZN("A promise that resolves to an array of TextEdits.",$(D.TextEdit.to))),new f.$1N("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$YN.Uri,f.$YN.Position,new f.$YN("ch","Trigger character",r=>typeof r=="string",r=>r),new f.$YN("options","Formatting options",r=>!0,r=>r)],new f.$ZN("A promise that resolves to an array of TextEdits.",$(D.TextEdit.to))),new f.$1N("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$YN.Uri,f.$YN.Position],new f.$ZN("A promise that resolves to an array of Location or LocationLink instances.",w)),new f.$1N("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$YN.Uri,f.$YN.Position],new f.$ZN("A promise that resolves to an array of Location or LocationLink instances.",w)),new f.$1N("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$YN.Uri,f.$YN.Position],new f.$ZN("A promise that resolves to an array of Location or LocationLink instances.",w)),new f.$1N("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$YN.Uri,f.$YN.Position],new f.$ZN("A promise that resolves to an array of Location or LocationLink instances.",w)),new f.$1N("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$YN.Uri,f.$YN.Position],new f.$ZN("A promise that resolves to an array of Location-instances.",$(D.location.to))),new f.$1N("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$YN.Uri,f.$YN.Position],new f.$ZN("A promise that resolves to an array of Hover-instances.",$(D.Hover.to))),new f.$1N("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$YN.Uri,new f.$YN("position","A position in a text document",r=>Array.isArray(r)&&r.every(c=>L.$rL.isPosition(c)),r=>r.map(D.Position.from))],new f.$ZN("A promise that resolves to an array of ranges.",r=>r.map(c=>{let s;for(const i of c.reverse())s=new L.$ML(D.Range.to(i),s);return s}))),new f.$1N("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$YN.String.with("query","Search string")],new f.$ZN("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(D.WorkspaceSymbol.to))),new f.$1N("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$YN.Uri,f.$YN.Position],new f.$ZN("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(D.CallHierarchyItem.to))),new f.$1N("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$YN.CallHierarchyItem],new f.$ZN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(D.CallHierarchyIncomingCall.to))),new f.$1N("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$YN.CallHierarchyItem],new f.$ZN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(D.CallHierarchyOutgoingCall.to))),new f.$1N("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$YN.Uri,f.$YN.Position],new f.$ZN("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:D.Range.to(r.range),placeholder:r.text}})),new f.$1N("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$YN.Uri,f.$YN.Position,f.$YN.String.with("newName","The new symbol name")],new f.$ZN("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return D.WorkspaceEdit.to(r)}})),new f.$1N("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$YN.Uri,f.$YN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$ZN("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(D.DocumentLink.to))),new f.$1N("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$YN.Uri],new f.$ZN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new L.$GM(r.tokenTypes,r.tokenModifiers)})),new f.$1N("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$YN.Uri],new f.$ZN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const c=(0,R.$4$)(r);if(c.type==="full")return new L.$IM(c.data,void 0)})),new f.$1N("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$YN.Uri,f.$YN.Range.optional()],new f.$ZN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new L.$GM(r.tokenTypes,r.tokenModifiers)})),new f.$1N("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$YN.Uri,f.$YN.Range],new f.$ZN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const c=(0,R.$4$)(r);if(c.type==="full")return new L.$IM(c.data,void 0)})),new f.$1N("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$YN.Uri,f.$YN.Position,f.$YN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$YN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$ZN("A promise that resolves to a CompletionList-instance.",(r,c,s)=>{if(!r)return new L.$YL([]);const i=r.suggestions.map(o=>D.CompletionItem.to(o,s));return new L.$YL(i,r.incomplete)})),new f.$1N("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$YN.Uri,f.$YN.Position,f.$YN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$ZN("A promise that resolves to SignatureHelp.",r=>{if(r)return D.SignatureHelp.to(r)})),new f.$1N("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$YN.Uri,f.$YN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$ZN("A promise that resolves to an array of CodeLens-instances.",(r,c,s)=>$(i=>new L.$QL(D.Range.to(i.range),i.command&&s.fromInternal(i.command)))(r))),new f.$1N("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$YN.Uri,new f.$YN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>L.$sL.isRange(r),r=>L.$tL.isSelection(r)?D.Selection.from(r):D.Range.from(r)),f.$YN.String.with("kind","Code action kind to return code actions for").optional(),f.$YN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$ZN("A promise that resolves to an array of Command-instances.",(r,c,s)=>$(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const o=new L.$KL(i.title,i.kind?new L.$LL(i.kind):void 0);return i.edit&&(o.edit=D.WorkspaceEdit.to(i.edit)),i.command&&(o.command=s.fromInternal(i.command)),o.isPreferred=i.isPreferred,o}})(r))),new f.$1N("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$YN.Uri],new f.$ZN("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(c=>new L.$5L(D.Range.to(c.range),D.Color.to(c.color))):[])),new f.$1N("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$YN("color","The color to show and insert",r=>r instanceof L.$4L,D.Color.from),new f.$YN("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:D.Range.from(r.range)}))],new f.$ZN("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(D.ColorPresentation.to):[])),new f.$1N("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$YN.Uri,f.$YN.Range],new f.$ZN("A promise that resolves to an array of Inlay objects",(r,c,s)=>r.map(D.InlayHint.to.bind(void 0,s)))),new f.$1N("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$YN.Uri],new f.$ZN("A promise that resolves to an array of FoldingRange objects",(r,c)=>{if(r)return r.map(D.FoldingRange.to)})),new f.$1N("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$ZN("A promise that resolves to an array of NotebookContentProvider static info objects.",$(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(c=>D.NotebookExclusiveDocumentPattern.to(c))})))),new f.$1N("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$YN.Uri,f.$YN.Range,new f.$YN("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof L.$sL,r=>D.InlineValueContext.from(r))],new f.$ZN("A promise that resolves to an array of InlineValue objects",r=>r.map(D.InlineValue.to))),new f.$1N("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$YN("uriOrString","Uri-instance or string (only http/https)",r=>I.URI.isUri(r)||typeof r=="string"&&(0,M.$gg)(r,M.Schemas.http,M.Schemas.https),r=>r),new f.$YN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[D.ViewColumn.from(r),void 0]:[D.ViewColumn.from(r.viewColumn),D.TextEditorOpenOptions.from(r)])).optional(),f.$YN.String.with("label","").optional()],f.$ZN.Void),new f.$1N("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$YN.Uri.with("resource","Resource to open"),f.$YN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$YN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[D.ViewColumn.from(r),void 0]:[D.ViewColumn.from(r.viewColumn),D.TextEditorOpenOptions.from(r)])).optional()],f.$ZN.Void),new f.$1N("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$YN.Uri.with("left","Left-hand side resource of the diff editor"),f.$YN.Uri.with("right","Right-hand side resource of the diff editor"),f.$YN.String.with("title","Human readable title for the diff editor").optional(),new f.$YN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[D.ViewColumn.from(r.viewColumn),D.TextEditorOpenOptions.from(r)]).optional()],f.$ZN.Void),new f.$1N("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$YN.String.with("title","Human readable title for the changes editor"),new f.$YN("resourceList","List of resources to compare",r=>{for(const c of r){if(c.length!==3)return!1;const[s,i,o]=c;if(!I.URI.isUri(s)||!I.URI.isUri(i)&&i!==void 0&&i!==null||!I.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},r=>r)],f.$ZN.Void),new f.$1N("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$YN.Uri,f.$YN.Position],new f.$ZN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(D.TypeHierarchyItem.to))),new f.$1N("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$YN.TypeHierarchyItem],new f.$ZN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(D.TypeHierarchyItem.to))),new f.$1N("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$YN.TypeHierarchyItem],new f.$ZN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(D.TypeHierarchyItem.to))),new f.$1N("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$YN.TestItem],f.$ZN.Void),new f.$1N("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$YN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$ZN.Void),new f.$1N("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$YN.String.with("name","The context key name"),new f.$YN("value","The context key value",()=>!0,r=>r)],f.$ZN.Void),new f.$1N("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$YN.Uri,f.$YN.StringArray,new f.$YN("MappedEditsContext","Mapped Edits Context",r=>D.MappedEditsContext.is(r),r=>D.MappedEditsContext.from(r))],new f.$ZN("A promise that resolves to a workspace edit or null",r=>r?D.WorkspaceEdit.to(r):null))];class l{static register(c){k.forEach(c.registerApiCommand,c),this.a(c)}static a(c){c.registerCommand(!1,"_validateWhenClauses",m.$7i)}}e.$Dgc=l;function $(r){return c=>{if(Array.isArray(c))return c.map(r)}}function w(r){if(!Array.isArray(r))return;const c=[];for(const s of r)A.$It(s)?c.push(D.DefinitionLink.to(s)):c.push(D.location.to(s));return c}}),define(Ae[272],Me([1,0,11,6,2,3,31,8,7]),function(fe,e,S,M,I,A,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class D{static{this.a=0}constructor($,w){this.extension=$,this.provider=w,this.handle=D.a++}}class L{constructor($){this.session=$,this.responses=[]}}class k{static{this.a=0}constructor($,w,r,c){this.f=r,this.g=c,this.b=new Map,this.d=new Map,this.e=$.getProxy(A.$oL.MainThreadInlineChat),w.registerApiCommand(new R.$1N("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$YN("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?m.Range.from(s.initialRange):void 0,initialSelection:f.$tL.isSelection(s.initialSelection)?m.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?m.Position.from(s.position):void 0}})],R.$ZN.Void))}registerProvider($,w,r){const c=new D($,w);return this.b.set(c.handle,c),this.e.$registerInteractiveEditorProvider(c.handle,r?.label??$.displayName??$.name,$.identifier.value,typeof w.handleInteractiveEditorResponseFeedback=="function",typeof w.provideFollowups=="function",r?.supportReportIssue??!1),(0,M.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(c.handle),this.b.delete(c.handle)})}async $prepareSession($,w,r,c){const s=this.b.get($);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(I.URI.revive(w)),o=m.Selection.to(r),a=await s.provider.prepareInteractiveEditorSession({document:i,selection:o},c);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const u=k.a++;return this.d.set(u,new L(a)),{id:u,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(a.wholeRange),message:a.message}}async $provideResponse($,w,r,c){const s=this.b.get($);if(!s)return;const i=this.d.get(w.id);if(!i)return;const o={prompt:r.prompt,selection:m.Selection.to(r.selection),wholeRange:m.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this.f.getDocument(I.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let a=!1;const u={report:async P=>{if(!r.live&&P.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||c.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:P.message,edits:P.edits?.map(m.TextEdit.from),editsShouldBeInstant:P.editsShouldBeInstant,slashCommand:P.slashCommand?.command,markdownFragment:f.$RL.isMarkdownString(P.content)?P.content.value:P.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,o,u,c));let d;try{d=await(0,S.$Vg)(t,c)}finally{a=!0}if(!d)return;const n=i.responses.push(d)-1,b={wholeRange:m.Range.from(d.wholeRange),placeholder:d.placeholder};if(!k.h(d))return{...b,id:n,type:"editorEdit",message:m.MarkdownString.from(d.contents),edits:[]};const{edits:E,contents:h}=d,v=h!==void 0?m.MarkdownString.from(h):void 0;return E instanceof f.$AL?{...b,id:n,type:"bulkEdit",edits:m.WorkspaceEdit.from(E),message:v}:{...b,id:n,type:"editorEdit",edits:E.map(m.TextEdit.from),message:v}}async $provideFollowups($,w,r,c){const s=this.b.get($),i=this.d.get(w),o=i?.responses[r];if(s&&o&&s.provider.provideFollowups){const a=Promise.resolve(s.provider.provideFollowups(i.session,o,c));return(await(0,S.$Vg)(a,c))?.map(m.ChatInlineFollowup.from)}}$handleFeedback($,w,r,c){const s=this.b.get($),i=this.d.get(w),o=i?.responses[r];if(s&&o){const a=m.InteractiveEditorResponseFeedbackKind.to(c);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,o,a)}}$releaseSession($,w){}static h($){return typeof $=="object"&&typeof $.edits=="object"}}e.$Lhc=k}),define(Ae[273],Me([1,0,2,31]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;class I{constructor(R,m,f,D,L){this.a=m,this.b=f,this.c=D;const k=new M.$1N("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$YN("showOptions","Show Options",l=>!0,l=>l),new M.$YN("resource","Interactive resource Uri",l=>!0,l=>l),new M.$YN("controllerId","Notebook controller Id",l=>!0,l=>l),new M.$YN("title","Interactive editor title",l=>!0,l=>l)],new M.$ZN("Notebook and input URI",l=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const $=this.a.getEditorById(l.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",$.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:$.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(R,m,f,D){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:f,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(S.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Yhc=I}),define(Ae[274],Me([1,0,18,11,21,5,6,28,2,22,14,3,31,8,7,76,211,25,50,212]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=e.$7hc=void 0;let a=class{constructor(v,P,g,p,y){this.m=P,this.n=g,this.o=p,this.q=y,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$Wd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=v.getProxy(k.$oL.MainThreadNotebookKernels);const T=new l.$1N("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$YN("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const J=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:J}}else if(N&&"notebookEditor"in N){const J=this.n.getIdByEditor(N.notebookEditor);if(J===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:J}}return N})],l.$ZN.Void);this.o.registerApiCommand(T)}createNotebookController(v,P,g,p,y,T){for(const $e of this.j.values())if($e.controller.id===P&&D.$nm.equals(v.identifier,$e.extensionId))throw new Error(`notebook controller with id '${P}' ALREADY exist`);const N=this.k++,J=this;this.q.trace(`NotebookController[${N}], CREATED by ${v.identifier.value}, ${P}`);const q=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${v.identifier}'`);let U=!1;const C=new A.$Wd,F=new A.$Wd,W={id:E(v.identifier,P),notebookType:g,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:p||v.identifier.value,preloads:T?T.map($.NotebookRendererScript.from):[]};let re=y??q,ce,we;this.a.$addKernel(N,W).catch($e=>{console.log($e),U=!0});let De=0;const he=()=>{if(U)return;const $e=++De;Promise.resolve().then(()=>{$e===De&&this.a.$updateKernel(N,W)})},ve=new m.$Ac,se={get id(){return P},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:C.event,get label(){return W.label},set label($e){W.label=$e??v.displayName??v.name,he()},get detail(){return W.detail??""},set detail($e){W.detail=$e,he()},get description(){return W.description??""},set description($e){W.description=$e,he()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages($e){W.supportedLanguages=$e,he()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder($e){W.supportsExecutionOrder=$e,he()},get rendererScripts(){return W.preloads?W.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler($e){re=$e??q},get interruptHandler(){return ce},set interruptHandler($e){ce=$e,W.supportsInterrupt=!!$e,he()},set variableProvider($e){(0,s.$LF)(v,"notebookVariableProvider"),we=$e,W.hasVariableProvider=!!$e,$e?.onDidChangeVariables(te=>J.a.$variablesUpdated(te.uri)),he()},get variableProvider(){return we},createNotebookCellExecution($e){if(U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.notebook.uri))throw J.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return J._createNotebookCellExecution($e,E(v.identifier,this.id))},createNotebookExecution($e){if((0,s.$LF)(v,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.uri))throw J.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return J._createNotebookExecution($e,E(v.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${N}], DISPOSED`),U=!0,this.j.delete(N),C.dispose(),F.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity($e,te){te===w.NotebookControllerAffinity2.Hidden&&(0,s.$LF)(v,"notebookControllerAffinityHidden"),J.a.$updateNotebookPriority(N,$e.uri,te)},onDidReceiveMessage:F.event,postMessage($e,te){return(0,s.$LF)(v,"notebookMessaging"),J.a.$postMessage(N,te&&J.n.getIdByEditor(te),$e)},asWebviewUri($e){return(0,s.$LF)(v,"notebookMessaging"),(0,r.$Gwb)($e,J.m.remote)}};return this.j.set(N,{extensionId:v.identifier,controller:se,onDidReceiveMessage:F,onDidChangeSelection:C,associatedNotebooks:ve}),se}getIdByController(v){for(const[P,g]of this.j)if(g.controller===v)return E(g.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,P){const g=this.g++,p=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${v.identifier.value}`),this.a.$addKernelDetectionTask(g,P);const y={dispose:()=>{this.f.delete(g),p.a.$removeKernelDetectionTask(g)}};return this.f.set(g,y),y}registerKernelSourceActionProvider(v,P,g){const p=this.i++,y=typeof g.onDidChangeNotebookKernelSourceActions=="function"?p:void 0,T=this;this.h.set(p,g),this.q.trace(`NotebookKernelSourceActionProvider[${p}], CREATED by ${v.identifier.value}`),this.a.$addKernelSourceActionProvider(p,p,P);let N;return y!==void 0&&(N=g.onDidChangeNotebookKernelSourceActions(J=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(p),T.a.$removeKernelSourceActionProvider(p,p),N?.dispose()}}}async $provideKernelSourceActions(v,P){const g=this.h.get(v);if(g){const p=new R.$Sc;return(await g.provideNotebookKernelSourceActions(P)??[]).map(T=>$.NotebookKernelSourceAction.from(T,this.o.converter,p))}return[]}$acceptNotebookAssociation(v,P,g){const p=this.j.get(v);if(p){const y=this.n.getNotebookDocument(f.URI.revive(P));g?p.associatedNotebooks.set(y.uri,!0):p.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${v}] ASSOCIATE notebook`,y.uri.toString(),g),p.onDidChangeSelection.fire({selected:g,notebook:y.apiNotebook})}}async $executeCells(v,P,g){const p=this.j.get(v);if(!p)return;const y=this.n.getNotebookDocument(f.URI.revive(P)),T=[];for(const N of g){const J=y.getCell(N);J&&T.push(J.apiCell)}try{this.q.trace(`NotebookController[${v}] EXECUTE cells`,y.uri.toString(),T.length),await p.controller.executeHandler.call(p.controller,T,y.apiNotebook,p.controller)}catch(N){this.q.error(`NotebookController[${v}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(v,P,g){const p=this.j.get(v);if(!p)return;const y=this.n.getNotebookDocument(f.URI.revive(P));if(p.controller.interruptHandler)await p.controller.interruptHandler.call(p.controller,y.apiNotebook);else for(const T of g){const N=y.getCell(T);N&&this.b.get(N.uri)?.cancel()}if(p.controller.interruptHandler){const T=this.c.get(y.uri);g.length&&Array.isArray(T)&&T.length&&T.forEach(N=>N.dispose())}}async $provideVariables(v,P,g,p,y,T,N){const J=this.j.get(v);if(!J)return;const q=this.n.getNotebookDocument(f.URI.revive(g)),U=J.controller.variableProvider;if(!U)return;let C;if(p!==void 0){if(C=this.s[p],!C)return}else this.s={};const F=y==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,W=U.provideVariables(q.apiNotebook,C,F,T,N);let re=0;for await(const ce of W){if(N.isCancellationRequested)return;const we={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:J.extensionId.value};if(this.s[we.id]=ce.variable,this.a.$receiveVariable(P,we),re++>=o.$Rfb)return}}$acceptKernelMessageFromRenderer(v,P,g){const p=this.j.get(v);if(!p)return;const y=this.n.getEditorById(P);p.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:g}))}$cellExecutionChanged(v,P,g){const y=this.n.getNotebookDocument(f.URI.revive(v)).getCell(P);if(y){const T=g?$.NotebookCellExecutionState.to(g):w.NotebookCellExecutionState.Idle;T!==void 0&&this.l.fire({cell:y.apiCell,state:T})}}_createNotebookCellExecution(v,P){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this.n.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!p)throw new Error("invalid cell");if(this.b.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const y=new t(P,p,this.a);this.b.set(p.uri,y);const T=y.onDidChangeState(()=>{y.state===u.Resolved&&(y.dispose(),T.dispose(),this.b.delete(p.uri))});return y.asApiObject()}_createNotebookExecution(v,P){const g=this.n.getNotebookDocument(v.uri),p=v.getCells().find(N=>{const J=g.getCellFromApiCell(N);return J&&this.b.has(J.uri)});if(p)throw new Error(`duplicate cell execution for ${p.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const y=new n(P,g,this.a),T=y.onDidChangeState(()=>{y.state===d.Resolved&&(y.dispose(),T.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[y,T]),y.asApiObject()}};e.$7hc=a,e.$7hc=a=Je([qe(4,L.$pj)],a);var u;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(u||(u={}));class t extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(v,P,g){super(),this.m=P,this.n=g,this.b=t.a++,this.c=new A.$Wd,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new I.$7d),this.h=new b(10,p=>this.s(p)),this.j=P.internalMetadata.executionOrder,this.n.$createExecution(this.b,v,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(v){await this.h.addItem(v)}async s(v){const P=Array.isArray(v)?v:[v];return this.n.$updateExecution(this.b,new i.$Vv(P))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(v){let P=this.m;if(v&&(P=this.m.notebook.getCellFromApiCell(v)),!P)throw new Error("INVALID cell");return P.handle}y(v){return v.map(P=>{const g=w.$TM.ensureUniqueMimeTypes(P.items,!0);return g===P.items?$.NotebookCellOutput.from(P):$.NotebookCellOutput.from({items:g,id:P.id,metadata:P.metadata})})}async z(v,P,g){const p=this.w(P),y=this.y((0,S.$3b)(v));return this.r({editType:c.CellExecutionUpdateType.Output,cellHandle:p,append:g,outputs:y})}async C(v,P,g){return v=w.$TM.ensureUniqueMimeTypes((0,S.$3b)(v),!0),this.r({editType:c.CellExecutionUpdateType.OutputItems,items:v.map($.NotebookCellOutputItem.from),outputId:P.id,append:g})}asApiObject(){const v=this;return Object.freeze({get token(){return v.g.token},get cell(){return v.m.apiCell},get executionOrder(){return v.j},set executionOrder(g){v.j=g,v.s([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:v.j}])},start(g){if(v.f===u.Resolved||v.f===u.Started)throw new Error("Cannot call start again");v.f=u.Started,v.c.fire(),v.s({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,p){if(v.f===u.Resolved)throw new Error("Cannot call resolve twice");v.f=u.Resolved,v.c.fire(),v.h.flush(),v.n.$completeExecution(v.b,new i.$Vv({runEndTime:p,lastRunSuccess:g}))},clearOutput(g){return v.t(),v.z([],g,!1)},appendOutput(g,p){return v.t(),v.z(g,p,!0)},replaceOutput(g,p){return v.t(),v.z(g,p,!1)},appendOutputItems(g,p){return v.t(),v.C(g,p,!0)},replaceOutputItems(g,p){return v.t(),v.C(g,p,!1)}})}}var d;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(d||(d={}));class n extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(v,P,g){super(),this.h=P,this.j=g,this.b=n.a++,this.c=new A.$Wd,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new I.$7d),this.j.$createNotebookExecution(this.b,v,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===d.Resolved||this.f===d.Started)throw new Error("Cannot call start again");this.f=d.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===d.Resolved)throw new Error("Cannot call resolve twice");this.f=d.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class b{constructor(v,P){this.f=v,this.g=P,this.a=[],this.b=Date.now()}addItem(v){return this.a.push(v),this.c||(this.c=new M.$sh,this.b=Date.now(),(0,M.$9g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const v=this.c;this.c=void 0;const P=this.a;return this.a=[],this.g(P).finally(()=>v.complete())}}function E(h,v){return`${h.value}/${v}`}e.$8hc=E}),define(Ae[65],Me([1,0,5,3,4,2,17,6,7,167,15,195,21,33,196,40,11,8,31]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=e.$ihc=e.$hhc=e.$ghc=void 0,e.$ghc=(0,I.$8h)("IExtHostTerminalService");class o{constructor(g,p,y,T){this.l=g,this._id=p,this.m=y,this.n=T,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(J=>this.f=J);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(J,q=!0){N.q(),N.l.$sendText(N._id,J,q)},show(J){N.q(),N.l.$show(N._id,J)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(g,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??p?.cwd??void 0,env:g.env??void 0,icon:E(g.iconPath)??void 0,color:r.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,isFeatureTerminal:p?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:p?.useShellEnvironment??void 0,location:p?.location||this.o(g.location,p?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,p,y,T,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:T,color:r.ThemeColor.isThemeColor(N)?N.id:void 0,location:p?.location||this.o(g,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(g,p){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&p?{parentTerminal:p}:"viewColumn"in g?{viewColumn:s.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.n=g}setExitStatus(g,p){this.h=Object.freeze({code:g,reason:p})}setDimensions(g,p){return g===this.d&&p===this.g||g===0||p===0?!1:(this.d=g,this.g=p,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(g){this.k=g}_setProcessId(g){this.f?(this.f(g),this.f=void 0):this.b.then(p=>{p!==g&&(this.b=Promise.resolve(g))})}}e.$hhc=o;class a{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new S.$Wd,this.onProcessData=this.a.event,this.b=new S.$Wd,this.d=new S.$Wd,this.onDidChangeProperty=this.d.event,this.f=new S.$Wd,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,p){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${p}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,p){this.g.setDimensions?.({columns:g,rows:p})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(p=>this.a.fire(p)),this.g.onDidClose?.((p=void 0)=>{this.f.fire(p===void 0?void 0:p)}),this.g.onDidOverrideDimensions?.(p=>{p&&this.d.fire({type:"overrideDimensions",value:{cols:p.columns,rows:p.rows}})}),this.g.onDidChangeName?.(p=>{this.d.fire({type:"title",value:p})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends m.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,p,y){super(),this.Q=p,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$Wd,this.onDidCloseTerminal=this.H.event,this.I=new S.$Wd,this.onDidOpenTerminal=this.I.event,this.J=new S.$Wd,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$Wd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$Wd,this.onDidChangeTerminalState=this.M.event,this.N=new S.$Wd,this.onDidChangeShell=this.N.event,this.O=new S.$Wd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$Wd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(M.$oL.MainThreadTerminalService),this.y=new w.$Qsb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:T=>{const N=J=>{const q=J;return this.W(q.instanceId)?.value};switch(T?.$mid){case 15:return N(T);default:{if(Array.isArray(T))for(let J=0;J<T.length&&T[J].$mid===15;J++)T[J]=N(T[J]);return T}}}}),this.B({dispose:()=>{for(const[T,N]of this.g)N.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,p){const y=new o(this.a,(0,$.$rg)(),g,g.name),T=new a(g.pty);return y.createExtensionTerminal(g.location,p,this.R(g,p).resolvedExtHostIdentifier,E(g.iconPath),h(g.color)).then(N=>{const J=this.S(N,T);this.h[N]=J}),this.f.push(y),y.value}R(g,p){if(p=p||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const y=g.location.parentTerminal;if(y){const T=this.f.find(N=>N.value===y);T&&(p.resolvedExtHostIdentifier=T._id)}}else g.location&&typeof g.location!="object"?p.location=g.location:p.location&&typeof p.location=="object"&&"splitActiveTerminal"in p.location&&(p.location={splitActiveTerminal:!0});return p}attachPtyToTerminal(g,p){if(!this.W(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const T=new a(p),N=this.S(g,T);this.h[g]=N}async $acceptActiveTerminalChanged(g){const p=this.b;if(g===null){this.b=void 0,p!==this.b&&this.J.fire(this.b);return}const y=this.W(g);y&&(this.b=y,p!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,p){const y=this.W(g);y&&this.O.fire({terminal:y.value,data:p})}async $acceptTerminalDimensions(g,p,y){const T=this.W(g);T&&T.setDimensions(p,y)&&this.L.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(g,p){const y=this.W(g);y&&this.P.fire({terminal:y.value,...p})}async $acceptTerminalMaximumDimensions(g,p,y){this.g.get(g)?.resize(p,y)}async $acceptTerminalTitleChange(g,p){const y=this.W(g);y&&(y.name=p)}async $acceptTerminalClosed(g,p,y){const T=this.Y(this.f,g);if(T!==null){const N=this.f.splice(T,1)[0];N.setExitStatus(p,y),this.H.fire(N.value)}}$acceptTerminalOpened(g,p,y,T){if(p){const q=this.Y(this.f,p);if(q!==null){this.f[q]._id=g,this.I.fire(this.terminals[q]),this.f[q].isOpen=!0;return}}const N={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:A.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},J=new o(this.a,g,N,y);this.f.push(J),this.I.fire(J.value),J.isOpen=!0}async $acceptTerminalProcessId(g,p){this.W(g)?._setProcessId(p)}async $startExtensionTerminal(g,p){const y=this.W(g);if(!y)return{message:(0,D.localize)(0,null,g)};y.isOpen||await new Promise(N=>{const J=this.onDidOpenTerminal(async q=>{q===y.value&&(J.dispose(),N())})});const T=this.g.get(g);T?T.startSendingEvents(p):this.j[g]={initialDimensions:p}}S(g,p){const y=new m.$Sc;y.add(p.onProcessReady(N=>this.a.$sendProcessReady(g,N.pid,N.cwd,N.windowsPty))),y.add(p.onDidChangeProperty(N=>this.a.$sendProcessProperty(g,N))),this.y.startBuffering(g,p.onProcessData),y.add(p.onProcessExit(N=>this.U(g,N))),this.g.set(g,p);const T=this.j[g];return T&&p instanceof a&&(p.startSendingEvents(T.initialDimensions),delete this.j[g]),y}$acceptProcessAckDataEvent(g,p){this.g.get(g)?.acknowledgeDataEvent(p)}$acceptProcessInput(g,p){this.g.get(g)?.input(p)}$acceptTerminalInteraction(g){const p=this.W(g);p?.setInteractedWith()&&this.M.fire(p.value)}$acceptTerminalSelection(g,p){this.W(g)?.setSelection(p)}$acceptProcessResize(g,p,y){try{this.g.get(g)?.resize(p,y)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(g,p){this.g.get(g)?.shutdown(p)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(p=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:p}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(p=>this.a.$sendProcessProperty(g,{type:"cwd",value:p}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new f.$qL(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,p,y){if(this.C.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this.C.set(p,y),this.a.$registerProfileProvider(p,g.identifier.value),new f.$qL(()=>{this.C.delete(p),this.a.$unregisterProfileProvider(p)})}registerTerminalQuickFixProvider(g,p,y){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,y),this.a.$registerQuickFixProvider(g,p),new f.$qL(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,p){const y=new l.$7d().token;if(y.isCancellationRequested)return;const T=this.D.get(g);if(!T)return;const N=await T.provideTerminalQuickFixes(p,y);if(N===null||Array.isArray(N)&&N.length===0)return;const J=new m.$Sc;if(this.w.value=J,!Array.isArray(N))return N?s.TerminalQuickFix.from(N,this.Q.converter,J):void 0;const q=[];for(const U of N){const C=s.TerminalQuickFix.from(U,this.Q.converter,J);C&&q.push(C)}return q}async $createContributedProfileTerminal(g,p){const y=new l.$7d().token;let T=await this.C.get(g)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,p);return}this.createTerminalFromOptions(T.options,p)}}async $provideLinks(g,p){const y=this.W(g);if(!y)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const N=new l.$7d;this.G.set(g,N);const J=[],q={terminal:y.value,line:p},U=[];for(const W of this.z)U.push(c.Promises.withAsyncBody(async re=>{N.token.onCancellationRequested(()=>re({provider:W,links:[]}));const ce=await W.provideTerminalLinks(q,N.token)||[];N.token.isCancellationRequested||re({provider:W,links:ce})}));const C=await Promise.all(U);if(N.token.isCancellationRequested)return[];const F=new Map;for(const W of C)W&&W.links.length>0&&J.push(...W.links.map(re=>{const ce={id:u++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return F.set(ce.id,{provider:W.provider,link:re}),ce}));return this.F.set(g,F),J}$activateLink(g,p){const y=this.F.get(g)?.get(p);y&&y.provider.handleTerminalLink(y.link)}U(g,p){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const y=this.h[g];y&&(y.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,p)}W(g){return this.X(this.f,g)}X(g,p){const y=this.Y(g,p);return y!==null?g[y]:null}Y(g,p){const y=g.findIndex(T=>T._id===p);return y===-1?null:y}getEnvironmentVariableCollection(g){let p=this.n.get(g.identifier.value);return p||(p=new d,this.$(g.identifier.value,p)),p.getScopedEnvironmentVariableCollection(void 0)}Z(g,p){const y=(0,k.$Or)(p.map),T=(0,k.$Pr)(p.descriptionMap);this.a.$setEnvironmentVariableCollection(g,p.persistent,y.length===0?void 0:y,T)}$initEnvironmentVariableCollections(g){g.forEach(p=>{const y=p[0],T=new d(p[1]);this.$(y,T)})}$acceptDefaultProfile(g,p){const y=this.s;this.s=g,this.u=p,y?.path!==g.path&&this.N.fire(g.path)}$(g,p){this.n.set(g,p),p.onDidChangeCollection(()=>{this.Z(g,p)})}};e.$ihc=t,e.$ihc=t=Je([qe(1,i.$WN),qe(2,R.$AN)],t);class d{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$Wd,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const p=this.h(g);let y=this.a.get(p);return y||(y=new n(this,g),this.a.set(p,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(g,p,y,T){this.f(g,{value:p,type:f.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:T})}append(g,p,y,T){this.f(g,{value:p,type:f.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:T})}prepend(g,p,y,T){this.f(g,{value:p,type:f.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:T})}f(g,p){if(p.options&&p.options.applyAtProcessCreation===!1&&!p.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(g,p.scope),T=this.map.get(y),N=p.options?{applyAtProcessCreation:p.options.applyAtProcessCreation??!1,applyAtShellIntegration:p.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==p.value||T.type!==p.type||T.options?.applyAtProcessCreation!==N.applyAtProcessCreation||T.options?.applyAtShellIntegration!==N.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index){const J=this.g(g,p.scope),q={variable:g,...p,options:N};this.map.set(J,q),this.d.fire()}}get(g,p){const y=this.g(g,p),T=this.map.get(y);return T?v(T):void 0}g(g,p){const y=this.h(p);return y.length?`${g}:::${y}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const p=new Map;for(const[y,T]of this.map)this.h(T.scope)===this.h(g)&&p.set(T.variable,v(T));return p}delete(g,p){const y=this.g(g,p);this.map.delete(y),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[p,y]of this.map)y.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(p);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,p){const y=this.h(p),T=this.descriptionMap.get(y);if(!T||T.description!==g){let N;typeof g=="string"?N=g:N=g?.value.split(`

`)[0];const J={description:N,scope:p};this.descriptionMap.set(y,J),this.d.fire()}}getDescription(g){const p=this.h(g);return this.descriptionMap.get(p)?.description}k(g){const p=this.h(g);this.descriptionMap.delete(p)}}class n{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,p){this.b=g,this.d=p,this.a=new S.$Wd}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,p,y){this.b.replace(g,p,y,this.d)}append(g,p,y){this.b.append(g,p,y,this.d)}prepend(g,p,y){this.b.prepend(g,p,y,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,p){this.b.getVariableMap(this.d).forEach((y,T)=>g.call(p,T,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let b=class extends t{constructor(g,p){super(!1,g,p)}createTerminal(g,p,y){throw new L.$_}createTerminalFromOptions(g,p){throw new L.$_}};e.$jhc=b,e.$jhc=b=Je([qe(0,i.$WN),qe(1,R.$AN)],b);function E(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function h(P){return r.ThemeColor.isThemeColor(P)?P:void 0}function v(P){const g={...P};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ae[275],Me([1,0,11,23,21,5,246,97,6,26,16,33,14,3,17,111,8,7,49,75,59,25]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=e.$oic=e.$nic=e.$mic=void 0;let t=class extends f.$Tc{constructor(U,C,F,W){super(),this.w=W,this.f=this.B(new A.$Wd),this.g=new Map,this.s=this.B(new A.$Wd),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy($.$oL.MainThreadTesting),this.m=new y(this.h),this.j=new E(this.h,C),F.registerArgumentProcessor({processArgument:re=>{switch(re?.$mid){case 16:{const ce=re,we=ce.tests[ce.tests.length-1].item.extId;return this.g.get(i.$fK.root(we))?.collection.tree.get(we)?.actual??(0,r.$MN)(re)}case 18:{const{extId:ce,message:we}=re;return{test:this.g.get(i.$fK.root(ce))?.collection.tree.get(ce)?.actual,message:c.TestMessage.to(we)}}default:return re}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const re=await F.executeCommand("_testing.getExplorerSelection"),ce=we=>{const De=this.g.get(i.$fK.root(we));if(De)return i.$fK.isRoot(we)?De.controller:De.collection.tree.get(we)?.actual};return{include:re?.include.map(ce).filter(L.$Rf)||[],exclude:re?.exclude.map(ce).filter(L.$Rf)||[]}})}createTestController(U,C,F,W){if(this.g.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const re=new f.$Sc,ce=re.add(new r.$PN(C,F,this.w));ce.root.label=F;const we=new Map,De=new Set,he=this.h,ve={items:ce.root.children,get label(){return F},set label($e){F=$e,ce.root.label=$e,he.$updateController(C,{label:F})},get refreshHandler(){return W},set refreshHandler($e){W=$e,he.$updateController(C,{canRefresh:!!$e})},get id(){return C},createRunProfile:($e,te,X,V,ie,Ce)=>{let Te=(0,m.$Vi)($e);for(;we.has(Te);)Te++;return new N(this.h,we,De,this.s.event,C,Te,$e,te,X,V,ie,Ce)},createTestItem($e,te,X){return new r.$NN(C,$e,te,X)},createTestRun:($e,te,X=!0)=>this.j.createTestRun(U,C,ce,$e,te,X),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const te=$e instanceof Array?$e:[$e];this.h.$markTestRetired(te.map(X=>i.$fK.fromExtHostTestItem(X,C).toString()))}},set resolveHandler($e){ce.resolveHandler=$e},get resolveHandler(){return ce.resolveHandler},dispose:()=>{re.dispose()}};he.$registerTestController(C,F,!!W),re.add((0,f.$Rc)(()=>he.$unregisterTestController(C)));const se={controller:ve,collection:ce,profiles:we,extension:U,activeProfiles:De};return this.g.set(C,se),re.add((0,f.$Rc)(()=>this.g.delete(C))),re.add(ce.onDidGenerateDiff($e=>he.$publishDiff(C,$e.map(a.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(U,C=I.CancellationToken.None){const F=h(U);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.g.get(F.controllerId);if(!W)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(re=>i.$fK.fromExtHostTestItem(re,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:J[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:U.exclude?.map(re=>re.id)},C)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,C,F){return await this.j.getCoverageReport(U,C)?.provideFileCoverage(F)??[]}async $resolveFileCoverage(U,C,F,W){return await this.j.getCoverageReport(U,C)?.resolveFileCoverage(F,W)??[]}$configureRunProfile(U,C){this.g.get(U)?.profiles.get(C)?.configureHandler?.()}$setDefaultRunProfiles(U){const C=new Map;for(const[F,W]of Object.entries(U)){const re=this.g.get(F);if(!re)continue;const ce=new Map,we=W.filter(he=>!re.activeProfiles.has(he)),De=[...re.activeProfiles].filter(he=>!W.includes(he));for(const he of we)ce.set(he,!0),re.activeProfiles.add(he);for(const he of De)ce.set(he,!1),re.activeProfiles.delete(he);ce.size&&C.set(F,ce)}this.s.fire(C)}async $refreshTests(U,C){await this.g.get(U)?.controller.refreshHandler?.(C)}$publishTestResults(U){this.results=Object.freeze(U.map(C=>(0,D.$zn)(c.TestResults.to(C))).concat(this.results).sort((C,F)=>F.completedAt-C.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,C){const F=this.g.get(i.$fK.fromString(U).controllerId)?.collection;F&&(await F.expand(U,C<0?1/0:C),F.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(C=>a.TestsDiffOp.deserialize({asCanonicalUri:F=>F},C)))}async $runControllerTests(U,C){return Promise.all(U.map(F=>this.y(F,!1,C)))}async $startContinuousRun(U,C){const F=new I.$7d(C),W=await Promise.all(U.map(re=>this.y(re,!0,F.token)));return!C.isCancellationRequested&&!W.some(re=>re.error)&&await new Promise(re=>C.onCancellationRequested(re)),F.dispose(!0),W}async y(U,C,F){const W=this.g.get(U.controllerId);if(!W)return{};const{collection:re,profiles:ce,extension:we}=W,De=ce.get(U.profileId);if(!De)return{};const he=U.testIds.map(te=>re.tree.get(te)).filter(L.$Rf),ve=U.excludeExtIds.map(te=>W.collection.tree.get(te)).filter(L.$Rf).filter(te=>he.some(X=>X.fullId.compare(te.fullId)===2));if(!he.length)return{};const se=new s.$1M(he.some(te=>te.actual instanceof r.$ON)?void 0:he.map(te=>te.actual),ve.map(te=>te.actual),De,C),$e=(0,a.$hK)(U)&&this.j.prepareForMainThreadTestRun(se,v.fromInternal(U,W.collection),we,F);try{return await De.runHandler(se,F),{}}catch(te){return{error:String(te)}}finally{$e&&($e.hasRunningTasks&&!F.isCancellationRequested&&await A.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$mic=t,e.$mic=t=Je([qe(0,w.$AN),qe(1,l.$pj)],t);const d=1e4;var n;(function(q){q[q.Running=0]="Running",q[q.Cancelling=1]="Cancelling",q[q.Ended=2]="Ended"})(n||(n={}));class b extends f.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,C,F,W,re){super(),this.s=U,this.w=C,this.y=F,this.z=W,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Wd),this.m=this.B(new A.$Wd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new I.$7d(re));const ce=this.B(new S.$hh(()=>this.C(),d));this.B(this.h.token.onCancellationRequested(()=>ce.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const C=this.s.id,F=this.s.controllerId,W=(0,k.$rg)(),re=this.y,ce=this.m;let we;const De=$e=>(te,...X)=>{if(ve){this.z.warn(`Setting the state of test "${te.id}" is a no-op after the run ends.`);return}this.s.isIncluded(te)&&(this.F(te),$e(te,...X))},he=($e,te)=>{const X=te instanceof Array?te.map(c.TestMessage.from):[c.TestMessage.from(te)];if($e.uri&&$e.range){const V={range:c.Range.from($e.range),uri:$e.uri};for(const ie of X)ie.location=ie.location||V}this.w.$appendTestMessagesInRun(C,W,i.$fK.fromExtHostTestItem($e,F).toString(),X)};let ve=!1;const se={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return we?.provider},set coverageProvider($e){(0,u.$LF)(re,"testCoverage"),we=$e&&new P($e),ce.fire({taskId:W,runId:C,coverage:we})},enqueued:De($e=>{this.w.$updateTestStateInRun(C,W,i.$fK.fromExtHostTestItem($e,F).toString(),1)}),skipped:De($e=>{this.w.$updateTestStateInRun(C,W,i.$fK.fromExtHostTestItem($e,F).toString(),5)}),started:De($e=>{this.w.$updateTestStateInRun(C,W,i.$fK.fromExtHostTestItem($e,F).toString(),2)}),errored:De(($e,te,X)=>{he($e,te),this.w.$updateTestStateInRun(C,W,i.$fK.fromExtHostTestItem($e,F).toString(),6,X)}),failed:De(($e,te,X)=>{he($e,te),this.w.$updateTestStateInRun(C,W,i.$fK.fromExtHostTestItem($e,F).toString(),4,X)}),passed:De(($e,te)=>{this.w.$updateTestStateInRun(C,W,i.$fK.fromExtHostTestItem($e,this.s.controllerId).toString(),3,te)}),appendOutput:($e,te,X)=>{ve||(X&&(this.s.isIncluded(X)?this.F(X):X=void 0),this.w.$appendOutputToRun(C,W,M.$ke.fromString($e),te&&c.location.from(te),X&&i.$fK.fromExtHostTestItem(X,F).toString()))},end:()=>{ve||(ve=!0,this.w.$finishedTestRunTask(C,W),this.f.delete(W),this.f.size||this.D())}};return this.f.set(W,{run:se}),this.w.$startedTestRunTask(C,{id:W,name:U,running:!0}),se}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof r.$NN))throw new o.$sN(U.id);if(this.g.has(i.$fK.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const C=[],F=this.s.colllection.root;for(;;){const W=c.TestItem.from(U);if(C.unshift(W),this.g.has(W.extId)||(this.g.add(W.extId),U===F))break;U=U.parent||F}this.w.$addTestsToRun(this.s.controllerId,this.s.id,C)}dispose(){this.D(),super.dispose()}}class E{get trackers(){return this.c.values()}constructor(U,C){this.g=U,this.h=C,this.c=new Map,this.f=[]}getCoverageReport(U,C){return this.f.find(F=>F.runId===U)?.coverage.get(C)}prepareForMainThreadTestRun(U,C,F,W){return this.j(U,C,F,W)}cancelRunById(U){for(const C of this.c.values())if(C.id===U){C.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,C,F,W,re,ce){const we=this.c.get(W);if(we)return we.createRun(re);const De=v.fromPublic(C,F,W,ce),he=h(W);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!W.continuous,profile:he&&{group:J[he.kind],id:he.profileId},exclude:W.exclude?.map(se=>i.$fK.fromExtHostTestItem(se,F.root.id).toString())??[],id:De.id,include:W.include?.map(se=>i.$fK.fromExtHostTestItem(se,F.root.id).toString())??[F.root.id],persist:ce});const ve=this.j(W,De,U);return A.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(De.id),ve.dispose()}),ve.createRun(re)}j(U,C,F,W){const re=new b(C,this.g,F,this.h,W);this.c.set(U,re);let ce;const we=re.onDidCoverage(({runId:De,taskId:he,coverage:ve})=>{ce||(ce={runId:De,coverage:new Map},this.f.unshift(ce),this.f.length>a.$mK&&this.f.pop()),ce.coverage.set(he,ve),this.g.$signalCoverageAvailable(De,he,!!ve)});return A.Event.once(re.onEnd)(()=>{this.c.delete(U),we.dispose()}),re}}e.$nic=E;const h=q=>{if(q.profile){if(!(q.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class v{static fromPublic(U,C,F,W){return new v(U,(0,k.$rg)(),F.include?.map(re=>i.$fK.fromExtHostTestItem(re,U).toString())??[U],F.exclude?.map(re=>i.$fK.fromExtHostTestItem(re,U).toString())??[],W,C)}static fromInternal(U,C){return new v(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,C)}constructor(U,C,F,W,re,ce){this.controllerId=U,this.id=C,this.isPersisted=re,this.colllection=ce,this.c=F.map(we=>we+"\0"),this.f=W.map(we=>we+"\0")}isIncluded(U){const C=i.$fK.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const F of this.f)if(C===F||C.startsWith(F))return!1;for(const F of this.c)if(C===F||C.startsWith(F))return!0;return!1}}e.$oic=v;class P{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(c.TestCoverage.fromFile)??[]}catch(C){throw this.c=void 0,C}}async resolveFileCoverage(U,C){const F=await this.c;let W=F?.[U];return!this.provider||!F||!W?[]:(W.detailedCoverage||(W=F[U]=await this.provider.resolveFileCoverage?.(W,C)??W),W.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class g{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,c.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const C=i.$fK.parentId(U.item.extId);if(C&&this.h.has(C.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:C,g:F}=this;return{get added(){return[...U].map(W=>W.revived)},get updated(){return[...C].map(W=>W.revived)},get removed(){return[...F].map(W=>W.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class p extends a.$nK{constructor(){super(...arguments),this.s=new A.$Wd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,C){return{...U,revived:c.TestItem.toPlain(U.item),depth:C?C.depth+1:0,children:new Set}}v(){return new g(this.s)}}class y{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(C=>C.revived)},dispose:(0,R.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new p({asCanonicalUri:C=>C});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const T=(q,U,C,F)=>{C?Object.assign(C,F):U.$updateTestRunConfig(q.controllerId,q.profileId,F)};class N{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,T(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,T(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),T(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,T(this,this.#e,this.#n,{tag:U?c.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,T(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return A.Event.chain(this.#i,U=>U.map(C=>C.get(this.controllerId)?.get(this.profileId)).filter(L.$Rf))}constructor(U,C,F,W,re,ce,we,De,he,ve=!1,se=void 0,$e=!1){this.controllerId=re,this.profileId=ce,this.f=we,this.kind=De,this.runHandler=he,this._tag=se,this.g=$e,this.#e=U,this.#s=C,this.#t=F,this.#i=W,C.set(ce,this);const te=J[De];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${De}`);ve&&F.add(ce),this.#n={profileId:ce,controllerId:re,tag:se?c.TestTag.namespace(this.controllerId,se.id):null,label:we,group:te,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:$e},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$pic=N;const J={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Ae[112],Me([1,0,54,15,88,8,7]),function(fe,e,S,M,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=e.$IN=e.$HN=void 0;class m{static{this.c=new I.$FN("TextEditorDecorationType")}constructor(l,$,w){const r=m.c.nextId();l.$registerTextEditorDecorationType($.identifier,r,A.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$HN=m;class f{constructor(l,$){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=$.undoStopBefore,this.f=$.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,$){this.k();let w=null;if(l instanceof R.$rL)w=new R.$sL(l,l);else if(l instanceof R.$sL)w=l;else throw new Error("Unrecognized location");this.l(w,$,!1)}insert(l,$){this.k(),this.l(new R.$sL(l,l),$,!0)}delete(l){this.k();let $=null;if(l instanceof R.$sL)$=l;else throw new Error("Unrecognized location");this.l($,null,!0)}l(l,$,w){const r=this.c.validateRange(l);this.g.push({range:r,text:$,forceMoveMarkers:w})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=l}}class D{constructor(l,$,w,r){this.c=l,this.d=$,this._accept(w),this.e=r;const c=this;this.value={get tabSize(){return c.f},set tabSize(s){c.n(s)},get indentSize(){return c.g},set indentSize(s){c.p(s)},get insertSpaces(){return c.j},set insertSpaces(s){c.s(s)},get cursorStyle(){return c.k},set cursorStyle(s){c.t(s)},get lineNumbers(){return c.l},set lineNumbers(s){c.u(s)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}n(l){const $=this.m(l);if($!==null){if(typeof $=="number"){if(this.f===$)return;this.f=$}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:$}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}p(l){const $=this.o(l);if($!==null){if(typeof $=="number"){if(this.h===$)return;this.g=$,this.h=$}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:$}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const $=this.q(l);if(typeof $=="boolean"){if(this.j===$)return;this.j=$}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:$}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(l)})))}assign(l){const $={};let w=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(w=!0,$.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,w=!0,$.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(w=!0,$.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,w=!0,$.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(w=!0,$.insertSpaces=r):this.j!==r&&(this.j=r,w=!0,$.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,w=!0,$.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,w=!0,$.lineNumbers=A.TextEditorLineNumbersStyle.from(l.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,$))}v(l,$){$.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(w)})}}e.$IN=D;class L{constructor(l,$,w,r,c,s,i,o){this.id=l,this.j=$,this.k=w,this.g=!1,this.h=new Set,this.c=c,this.d=new D(this.j,this.id,s,w),this.e=i,this.f=o;const a=this;this.value=Object.freeze({get document(){return r.value},set document(u){throw new M.$9("document")},get selection(){return a.c&&a.c[0]},set selection(u){if(!(u instanceof R.$tL))throw(0,M.$7)("selection");a.c=[u],a.l()},get selections(){return a.c},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof R.$tL)))throw(0,M.$7)("selections");a.c=u,a.l()},get visibleRanges(){return a.e},set visibleRanges(u){throw new M.$9("visibleRanges")},get options(){return a.d.value},set options(u){a.g||a.d.assign(u)},get viewColumn(){return a.f},set viewColumn(u){throw new M.$9("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new f(r.value,t);return u(d),a.m(d)},insertSnippet(u,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!t||Array.isArray(t)&&t.length===0)n=a.c.map(b=>A.Range.from(b));else if(t instanceof R.$rL){const{lineNumber:b,column:E}=A.Position.from(t);n=[{startLineNumber:b,startColumn:E,endLineNumber:b,endColumn:E}]}else if(t instanceof R.$sL)n=[A.Range.from(t)];else{n=[];for(const b of t)if(b instanceof R.$sL)n.push(A.Range.from(b));else{const{lineNumber:E,column:h}=A.Position.from(b);n.push({startLineNumber:E,startColumn:h,endLineNumber:E,endColumn:h})}}return $.$tryInsertSnippet(l,r.value.version,u.value,n,d)},setDecorations(u,t){const d=t.length===0;d&&!a.h.has(u.key)||(d?a.h.delete(u.key):a.h.add(u.key),a.n(()=>{if(A.$xN(t))return $.$trySetDecorations(l,u.key,A.$yN(t));{const n=new Array(4*t.length);for(let b=0,E=t.length;b<E;b++){const h=t[b];n[4*b]=h.start.line+1,n[4*b+1]=h.start.character+1,n[4*b+2]=h.end.line+1,n[4*b+3]=h.end.character+1}return $.$trySetDecorationsFast(l,u.key,n)}}))},revealRange(u,t){a.n(()=>$.$tryRevealRange(l,A.Range.from(u),t||R.TextEditorRevealType.Default))},show(u){$.$tryShowEditor(l,A.ViewColumn.from(u))},hide(){$.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,S.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,S.ok)(!this.g),this.f=l}_acceptSelections(l){(0,S.ok)(!this.g),this.c=l}async l(){const l=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const $=l.finalize();if($.edits.length===0&&!$.setEndOfLine)return Promise.resolve(!0);const w=$.edits.map(c=>c.range);w.sort((c,s)=>c.end.line===s.end.line?c.end.character===s.end.character?c.start.line===s.start.line?c.start.character-s.start.character:c.start.line-s.start.line:c.end.character-s.end.character:c.end.line-s.end.line);for(let c=0,s=w.length-1;c<s;c++){const i=w[c].end;if(w[c+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=$.edits.map(c=>({range:A.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,$.documentVersionId,r,{setEndOfLine:typeof $.setEndOfLine=="number"?A.EndOfLine.from($.setEndOfLine):void 0,undoStopBefore:$.undoStopBefore,undoStopAfter:$.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,$=>($ instanceof Error&&$.name==="DISPOSED"||this.k.warn($),null))}}e.$JN=L}),define(Ae[66],Me([1,0,54,5,6,2,4,3,109,17,112,8,14,28,12,68,39]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=void 0;class s{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(a,u){this.h=a,this.i=u,this.a=null,this.b=new Map,this.c=new $.$Ac,this.d=new M.$Wd,this.e=new M.$Wd,this.f=new M.$Wd,this.g=new M.$Wd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const u=[],t=[],d=[];if(a.removedDocuments)for(const n of a.removedDocuments){const b=A.URI.revive(n),E=this.c.get(b);E?.unref()&&(this.c.delete(b),u.push(E.value))}if(a.addedDocuments)for(const n of a.addedDocuments){const b=A.URI.revive(n.uri);let E=this.c.get(b);if(E&&b.scheme!==w.Schemas.vscodeNotebookCell&&b.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${b} already exists!'`);E||(E=new s(new f.$DN(this.h.getProxy(m.$oL.MainThreadDocuments),b,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(b,E),t.push(E.value)),E.ref()}if(a.removedEditors)for(const n of a.removedEditors){const b=this.b.get(n);this.b.delete(n),b&&d.push(b)}if(a.addedEditors)for(const n of a.addedEditors){const b=A.URI.revive(n.documentUri);S.ok(this.c.has(b),`document '${b}' does not exist`),S.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const E=this.c.get(b).value,h=new L.$JN(n.id,this.h.getProxy(m.$oL.MainThreadTextEditors),this.i,new c.$V(()=>E.document),n.selections.map(k.Selection.to),n.options,n.visibleRanges.map(v=>k.Range.to(v)),typeof n.editorPosition=="number"?k.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,h)}a.newActiveEditor!==void 0&&(S.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,I.$Oc)(u),(0,I.$Oc)(d),a.removedDocuments&&this.e.fire(u),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return r.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const u=this.b.get(this.a);return a?u:u?.value}allEditors(){return[...this.b.values()]}};e.$KN=i,e.$KN=i=Je([qe(0,D.$AN),qe(1,l.$pj)],i),e.$LN=(0,R.$8h)("IExtHostDocumentsAndEditors")}),define(Ae[276],Me([1,0,18,5,3,112,8,7]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;class f{constructor(L,k){this.i=k,this.a=new M.$Wd,this.b=new M.$Wd,this.c=new M.$Wd,this.d=new M.$Wd,this.f=new M.$Wd,this.g=new M.$Wd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(I.$oL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const k=this.i.allEditors();return L?k:k.map(l=>l.value)}async showTextDocument(L,k,l){let $;typeof k=="number"?$={position:R.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?$={position:R.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?R.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:$={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(L.uri,$),r=w&&this.i.getEditor(w);if(r)return r.value;throw w?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,k){return new A.$HN(this.h,L,k).value}$acceptEditorPropertiesChanged(L,k){const l=this.i.getEditor(L);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const $=k.selections.selections.map(R.Selection.to);l._acceptSelections($)}if(k.visibleRanges){const $=S.$Hb(k.visibleRanges.map(R.Range.to));l._acceptVisibleRanges($)}if(k.options&&this.b.fire({textEditor:l.value,options:{...k.options,lineNumbers:R.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const $=m.TextEditorSelectionChangeKind.fromValue(k.selections.source),w=k.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:w,kind:$})}if(k.visibleRanges){const $=S.$Hb(k.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:$})}}$acceptEditorPositionData(L){for(const k in L){const l=this.i.getEditor(k);if(!l)throw new Error("Unknown text editor");const $=R.ViewColumn.to(L[k]);l.value.viewColumn!==$&&(l._acceptViewColumn($),this.d.fire({textEditor:l.value,viewColumn:$}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.$Lgc=f}),define(Ae[277],Me([1,0,2,4,3,6,7,8,22,16]),function(fe,e,S,M,I,A,R,m,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=void 0,e.$ric=(0,M.$8h)("IExtHostTimeline");class L{constructor($,w){this.b=new Map,this.c=new Map,this.a=$.getProxy(I.$oL.MainThreadTimeline),w.registerArgumentProcessor({processArgument:(r,c)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&f.$nm.equals(c,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:S.URI.revive(r.uri);return this.c.get(r.source)?.get(k(s))?.get(r.handle)}else return;return r}})}async $getTimeline($,w,r,c){return this.b.get($)?.provider.provideTimeline(S.URI.revive(w),r,c)}registerTimelineProvider($,w,r,c){const s=new A.$Sc,i=this.d(w.id,c,s).bind(this);let o;w.onDidChange&&(o=w.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:w.id}),this));const a=this.c;return this.f({...w,scheme:$,onDidChange:void 0,async provideTimeline(u,t,d){t?.resetCache&&(s.clear(),a.get(w.id)?.clear());const n=await w.provideTimeline(u,t,d);if(n==null)return;const b=i(u,t);return{...n,source:w.id,items:n.items.map(b)}},dispose(){for(const u of a.values())u.get(w.id)?.clear();o?.dispose(),s.dispose()}},r)}d($,w,r){return(c,s)=>{let i;if(s?.cacheResults){let o=this.c.get($);o===void 0&&(o=new Map,this.c.set($,o));const a=k(c);i=o.get(a),i===void 0&&(i=new Map,o.set(a,i))}return o=>{const{iconPath:a,...u}=o,t=`${$}|${o.id??o.timestamp}`;i?.set(t,o);let d,n,b;o.iconPath&&(a instanceof R.$lM?b={id:a.id,color:a.color}:S.URI.isUri(a)?(d=a,n=a):{light:d,dark:n}=a);let E;return R.$RL.isMarkdownString(u.tooltip)?E=m.MarkdownString.from(u.tooltip):(0,D.$Jf)(u.tooltip)?E=u.tooltip:R.$RL.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=m.MarkdownString.from(u.detail)):(0,D.$Jf)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=u.detail),{...u,id:u.id??void 0,handle:t,source:$,command:o.command?w.toInternal(o.command,r):void 0,icon:d,iconDark:n,themeIcon:b,tooltip:E,accessibilityInformation:o.accessibilityInformation}}}}f($,w){if(this.b.get($.id))throw new Error(`Timeline Provider ${$.id} already exists.`);return this.a.$registerTimelineProvider({id:$.id,label:$.label,scheme:$.scheme}),this.b.set($.id,{provider:$,extension:w}),(0,A.$Rc)(()=>{for(const c of this.c.values())c.get($.id)?.clear();this.b.delete($.id),this.a.$unregisterTimelineProvider($.id),$.dispose()})}}e.$sic=L;function k(l){return l?.toString()}}),define(Ae[278],Me([1,0,168,24,2,5,6,206,11,7,16,18,8,46,21,133,25]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;function s(a,u){if((0,L.$Jf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class i extends R.$Tc{constructor(u,t,d){super(),this.f=u,this.g=t,this.h=d,this.a=new Map,this.b=new r.$S8;function n(b){return b&&b.$treeViewId&&(b.$treeItemHandle||b.$selectedTreeItems||b.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:b=>n(b)?this.r(b):Array.isArray(b)&&b.length>0?b.map(E=>n(E)?this.r(E):E):b})}registerTreeDataProvider(u,t,d){const n=this.createTreeView(u,{treeDataProvider:t},d);return{dispose:()=>n.dispose()}}createTreeView(u,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=t.dragAndDropController?.dropMimeTypes??[],b=t.dragAndDropController?.dragMimeTypes??[],E=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,v=this.m(u,t,d),P={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:n,dragMimeTypes:b,hasHandleDrag:E,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(u,P),p={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,c.$LF)(d,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,c.$LF)(d,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(y){(0,$.$lk)(y)&&(0,c.$LF)(d,"treeViewMarkdownMessage"),v.message=y},get title(){return v.title},set title(y){v.title=y},get description(){return v.description},set description(y){v.description=y},get badge(){return v.badge},set badge(y){y!==void 0&&D.ViewBadge.isViewBadge(y)?v.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(v.badge=void 0)},reveal:(y,T)=>v.reveal(y,T),dispose:async()=>{await g,this.a.delete(u),v.dispose()}};return this.B(p),p}$getChildren(u,t){const d=this.a.get(u);return d?d.getChildren(t):Promise.reject(new m.$eF(u))}async $handleDrop(u,t,d,n,b,E,h,v){const P=this.a.get(u);if(!P)return Promise.reject(new m.$eF(u));const g=l.DataTransfer.toDataTransfer(d,async p=>(await this.f.$resolveDropFileData(u,t,p)).buffer);return h===u&&v&&await this.j(g,P,v,b,E),P.onDrop(g,n,b)}async j(u,t,d,n,b){const E=this.b.removeDragOperationTransfer(b);if(E)(await E)?.forEach((h,v)=>{h&&u.set(v,h)});else if(b&&t.handleDrag){const h=t.handleDrag(d,u,n);this.b.addDragOperationTransfer(b,h),await h}return u}async $handleDrag(u,t,d,n){const b=this.a.get(u);if(!b)return Promise.reject(new m.$eF(u));const E=await this.j(new D.$iM,b,t,n,d);if(!(!E||n.isCancellationRequested))return l.DataTransfer.from(E)}async $hasResolve(u){const t=this.a.get(u);if(!t)throw new m.$eF(u);return t.hasResolve}$resolve(u,t,d){const n=this.a.get(u);if(!n)throw new m.$eF(u);return n.resolveTreeItem(t,d)}$setExpanded(u,t,d){const n=this.a.get(u);if(!n)throw new m.$eF(u);n.setExpanded(t,d)}$setSelectionAndFocus(u,t,d){const n=this.a.get(u);if(!n)throw new m.$eF(u);n.setSelectionAndFocus(t,d)}$setVisible(u,t){const d=this.a.get(u);if(!d){if(!t)return;throw new m.$eF(u)}d.setVisible(t)}$changeCheckboxState(u,t){const d=this.a.get(u);if(!d)throw new m.$eF(u);d.setCheckboxState(t)}m(u,t,d){const n=this.B(new o(u,t,this.f,this.g.converter,this.h,d));return this.a.set(u,n),n}r(u){const t=this.a.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.$tic=i;class o extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,L.$Sf)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,t,d,n,b,E){if(super(),this.I=u,this.J=d,this.L=n,this.M=b,this.N=E,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$Wd),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$Wd),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$Wd),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$Wd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$Wd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$Wd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$Wd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$7d,E.contributes&&E.contributes.views)for(const g in E.contributes.views)for(const p of E.contributes.views[g])p.id===u&&(this.P=p.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let h,v;const P=A.Event.debounce(this.F.event,(g,p)=>(g||(g={message:!1,elements:[]}),p.element!==!1&&(h||(h=new Promise(y=>v=y),this.G=this.G.then(()=>h)),Array.isArray(p.element)?g.elements.push(...p.element):g.elements.push(p.element)),p.message&&(g.message=!0),g),200,!0);this.B(P(({message:g,elements:p})=>{p.length&&(this.H=this.H.then(()=>{const y=v;return h=null,this.$(p).then(()=>y())})),g&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let d=this.X(u);return d||(d=await this.Y(t)),d?d.map(n=>n.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const d=(0,L.$Sf)(t.select)?!0:t.select,n=(0,L.$Sf)(t.focus)?!1:t.focus,b=(0,L.$Sf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then(E=>this.W(u,E[E.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:E.map(v=>v.item)},{select:d,focus:n,expand:b})),E=>this.M.error(E)):this.J.$reveal(this.I,void 0,{select:d,focus:n,expand:b})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=l.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,t){const d=this.getExtensionElement(u);d&&(t?this.u.fire(Object.freeze({element:d})):this.w.fire(Object.freeze({element:d})))}setSelectionAndFocus(u,t){const d=!(0,k.$ub)(this.s,u);this.s=u;const n=this.t!==t;this.t=t,d&&this.y.fire(Object.freeze({selection:this.selectedElements})),n&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async d=>{const n=this.getExtensionElement(d.treeItemHandle);return n?{extensionItem:n,treeItem:await this.f.getTreeItem(n),newState:d.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(u,t,d){const n=[];for(const b of u){const E=this.getExtensionElement(b);E&&n.push(E)}if(!(!this.g?.handleDrag||n.length===0))return await this.g.handleDrag(n,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,t,d){const n=t?this.getExtensionElement(t):void 0;if(!(!n&&t||!this.g?.handleDrop))return(0,f.$Zg)(()=>this.g?.handleDrop?this.g.handleDrop(n,u,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,t){if(!this.f.resolveTreeItem)return;const d=this.j.get(u);if(d){const n=this.m.get(d);if(n){const b=await this.f.resolveTreeItem(n.extensionItem,d,t)??n.extensionItem;return this.hb(b),n.item.tooltip=this.eb(b.tooltip),n.item.command=this.fb(n.disposableStore,b.command),n.item}}}S(u){return this.U(u).then(t=>t?this.S(t).then(d=>this.W(t,d[d.length-1]).then(n=>(d.push(n),d))):Promise.resolve([]))}U(u){const t=this.m.get(u);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,f.$Zg)(()=>this.f.getParent(u))}W(u,t){const d=this.m.get(u);return d?Promise.resolve(d):(0,f.$Zg)(()=>this.f.getTreeItem(u)).then(n=>this.kb(u,n,t,!0)).then(n=>this.getChildren(t?t.item.handle:void 0).then(()=>{const b=this.getExtensionElement(n);if(b){const E=this.m.get(b);if(E)return Promise.resolve(E)}throw new Error(`Cannot resolve tree item for element ${n} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let t;if(typeof u=="string"){const d=this.getExtensionElement(u);t=d?this.m.get(d):void 0}else t=u;return t&&t.children||void 0}return this.h}async Y(u){this.rb(u);const t=new w.$7d(this.Z.token);try{const d=u?this.m.get(u):void 0,n=await this.f.getChildren(u);if(t.token.isCancellationRequested)return;const b=(0,k.$Hb)(n||[]),E=await Promise.all((0,k.$Hb)(b).map(v=>this.f.getTreeItem(v)));if(t.token.isCancellationRequested)return;const h=E.map((v,P)=>v?this.db(b[P],v,d):null);return(0,k.$Hb)(h)}finally{t.dispose()}}$(u){if(u.some(d=>!d))return this.Z.dispose(!0),this.Z=new w.$7d,this.tb(),this.J.$refresh(this.I);{const d=this.ab(u);if(d.length)return this.bb(d)}return Promise.resolve(void 0)}ab(u){const t=new Set,d=u.map(b=>this.m.get(b));for(const b of d)if(b&&!t.has(b.item.handle)){let E=b;for(;E&&E.parent&&d.findIndex(h=>E&&E.parent&&h&&h.item.handle===E.parent.item.handle)===-1;){const h=this.j.get(E.parent.item.handle);E=h?this.m.get(h):void 0}E&&!E.parent&&t.add(b.item.handle)}const n=[];return t.forEach(b=>{const E=this.j.get(b);if(E){const h=this.m.get(E);h&&(!h.parent||!t.has(h.parent.item.handle))&&n.push(b)}}),n}bb(u){const t={};return Promise.all(u.map(d=>this.cb(d).then(n=>{n&&(t[d]=n.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(u){const t=this.getExtensionElement(u);if(t){const d=this.m.get(t);if(d)return this.rb(t),(0,f.$Zg)(()=>this.f.getTreeItem(t)).then(n=>{if(n){const b=this.ib(t,n,d.parent);return this.pb(t,b,d,d.parent),d.dispose(),b}return null})}return Promise.resolve(null)}db(u,t,d){const n=this.ib(u,t,d);if(t.id&&this.j.has(n.item.handle))throw new Error((0,S.localize)(0,null,t.id));return this.ob(u,n),this.qb(n,d),n}eb(u){return D.$RL.isMarkdownString(u)?l.MarkdownString.from(u):u}fb(u,t){return t?{...this.L.toInternal(t,u),originalId:t.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let t,d,n;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,d=u.checkboxState.tooltip,n=u.checkboxState.accessibilityInformation),{isChecked:t===D.TreeItemCheckboxState.Checked,tooltip:d,accessibilityInformation:n}}hb(u){if(!D.$dM.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,t,d){this.hb(t);const n=this.B(new R.$Sc),b=this.kb(u,t,d),E=this.lb(t);return{item:{handle:b,parentHandle:d?d.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(n,t.command),contextValue:t.contextValue,icon:E,iconDark:this.mb(t)||E,themeIcon:this.jb(t),collapsibleState:(0,L.$Sf)(t.collapsibleState)?D.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:n,dispose(){n.dispose()}}}jb(u){return u.iconPath instanceof D.$lM?u.iconPath:void 0}kb(u,{id:t,label:d,resourceUri:n},b,E){if(t)return`${o.b}/${t}`;const h=s(d,this.N),v=b?b.item.handle:o.a;let P=h?h.label:n?(0,M.$Fg)(n):"";P=P.indexOf("/")!==-1?P.replace("/","//"):P;const g=this.m.has(u)?this.m.get(u).item.handle:void 0,p=this.X(b)||[];let y,T=0;do{if(y=`${v}/${T}:${P}`,E||!this.j.has(y)||g===y)break;T++}while(T<=p.length);return y}lb(u){if(u.iconPath&&!(u.iconPath instanceof D.$lM))return typeof u.iconPath=="string"||I.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof D.$lM)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return I.URI.isUri(u)?u:I.URI.file(u)}ob(u,t){this.j.set(t.item.handle,u),this.m.set(u,t)}pb(u,t,d,n){this.j.delete(t.item.handle),this.m.delete(u),t.item.handle!==d.item.handle&&this.j.delete(d.item.handle),this.ob(u,t);const b=this.X(n)||[],E=b.filter(h=>h.item.handle===d.item.handle)[0];E&&b.splice(b.indexOf(E),1,t)}qb(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const t=this.m.get(u);if(t){if(t.children)for(const d of t.children){const n=this.j.get(d.item.handle);n&&this.sb(n)}t.children=void 0}}else this.tb()}sb(u){const t=this.m.get(u);if(t){if(t.children)for(const d of t.children){const n=this.j.get(d.item.handle);n&&this.sb(n)}this.m.delete(u),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[279],Me([1,0,5,6,2,33,8,61,3,7]),function(fe,e,S,M,I,A,R,m,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;class L extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(w,r,c,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$Wd),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$Wd),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=r,this.#n=c,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,I.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(w){this.#l||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#u=w.active,this.#c=w.visible,this.#o=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:R.ViewColumn.from(w),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends M.$Tc{static c(){return(0,A.$rg)()}constructor(w,r,c){super(),this.j=r,this.m=c,this.g=new Map,this.h=new Map,this.f=w.getProxy(f.$oL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,r,c,s,i={}){const o=typeof s=="object"?s.viewColumn:s,a={viewColumn:R.ViewColumn.from(o),preserveFocus:typeof s=="object"&&!!s.preserveFocus},u=(0,m.$1gc)(w),t=k.c();this.f.$createWebviewPanel((0,m.$3gc)(w),t,r,{title:c,panelOptions:l(i),webviewOptions:(0,m.$4gc)(w,this.m,i),serializeBuffersForPostMessage:u},a);const d=this.j.createNewWebview(t,i,w);return this.createNewWebviewPanel(t,r,c,o,i,d,!0)}$onDidChangeWebviewPanelViewStates(w){const r=Object.keys(w);r.sort((c,s)=>{const i=w[c],o=w[s];return i.active?1:o.active?-1:+i.visible-+o.visible});for(const c of r){const s=this.getWebviewPanel(c);if(!s)continue;const i=w[c];s._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,r,c){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:c,extension:w}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,m.$1gc)(w)}),new D.$qL(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(w,r,c,s){const i=this.h.get(r);if(!i)throw new Error(`No serializer found for '${r}'`);const{serializer:o,extension:a}=i,u=this.j.createNewWebview(w,c.webviewOptions,a),t=this.createNewWebviewPanel(w,r,c.title,s,c.panelOptions,u,c.active);await o.deserializeWebviewPanel(t,c.state)}createNewWebviewPanel(w,r,c,s,i,o,a){const u=new L(w,this.f,o,{viewType:r,title:c,viewColumn:s,panelOptions:i,active:a});return this.g.set(w,u),u}getWebviewPanel(w){return this.g.get(w)}}e.$5gc=k;function l($){return{enableFindWidget:$.enableFindWidget,retainContextWhenHidden:$.retainContextWhenHidden}}}),define(Ae[280],Me([1,0,5,6,61,8,3,7]),function(fe,e,S,M,I,A,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;class f extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(k,l,$,w,r,c){super(),this.#s=!1,this.#u=this.B(new S.$Wd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$Wd),this.onDidDispose=this.#l.event,this.#i=$,this.#a=w,this.#e=k,this.#t=l,this.#n=r,this.#r=c}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#o}set description(k){this.a(),this.#o!==k&&(this.#o=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#s||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#s)throw new Error("Webview is disposed")}}class D{constructor(k,l){this.d=l,this.b=new Map,this.c=new Map,this.a=k.getProxy(R.$oL.MainThreadWebviewViews)}registerWebviewViewProvider(k,l,$,w){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:$,extension:k}),this.a.$registerWebviewViewProvider((0,I.$3gc)(k),l,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$1gc)(k)}),new m.$qL(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(k,l,$,w,r){const c=this.b.get(l);if(!c)throw new Error(`No view provider found for '${l}'`);const{provider:s,extension:i}=c,o=this.d.createNewWebview(k,{},i),a=new f(k,this.a,l,$,o,!0);this.c.set(k,a),await s.resolveWebviewView(a,{state:w},r)}async $onDidChangeWebviewViewVisibility(k,l){this.e(k)._setVisible(l)}async $disposeWebviewView(k){const l=this.e(k);this.c.delete(k),l.dispose(),this.d.deleteWebview(k)}e(k){const l=this.c.get(k);if(!l)throw new Error("No webview found");return l}}e.$wic=D}),define(Ae[281],Me([1,0,5,30,35,4]),function(fe,e,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.$JK=e.OutputChannelUpdateMode=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=void 0,e.$zK="text/x-code-output",e.$AK="output",e.$BK="Log",e.$CK="text/x-code-log-output",e.$DK="log",e.$EK="workbench.panel.output",e.$FK=new I.$mj("inOutput",!1),e.$GK=new I.$mj("activeLogOutput",!1),e.$HK=new I.$mj("outputView.scrollLock",!1),e.$IK=(0,A.$8h)("outputService");var R;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$JK={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new S.$Wd,this.onDidRegisterChannel=this.b.event,this.c=new S.$Wd,this.onDidRemoveChannel=this.c.event}registerChannel(D){this.a.has(D.id)||(this.a.set(D.id,D),this.b.fire(D.id))}getChannels(){const D=[];return this.a.forEach(L=>D.push(L)),D}getChannel(D){return this.a.get(D)}removeChannel(D){this.a.delete(D),this.c.fire(D)}}M.$Kn.add(e.$JK.OutputChannels,new m),e.$KK=new I.$mj("activeOutputChannel","")}),define(Ae[113],Me([1,0,3,4,17,22,14,281,62,27,43,137,23,16,42,5,6]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=e.$0hc=void 0;class s extends R.$vj{get disposed(){return this.n}constructor(u,t,d,n,b){super(),this.id=u,this.name=t,this.r=d,this.s=n,this.extension=b,this.m=0,this.n=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(E=>this.setLevel(E)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.m;this.info(u),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(u,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.s.$close(this.id)}g(u,t){this.m+=l.$ke.fromString(t).byteLength,(0,R.log)(this.r,u,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(u){this.append(u)}}let o=class{constructor(u,t,d,n,b,E){this.i=t,this.j=d,this.k=n,this.l=b,this.m=E,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(S.$oL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.$zm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(u,t,d){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const n=typeof t=="object"&&t.log,b=(0,$.$Jf)(t)?t:void 0;if((0,$.$Jf)(b)&&!b.trim())throw new Error("illegal argument `languageId`. must not be empty");let E;const h=this.i.environment.extensionLogLevel?.find(([P])=>A.$nm.equals(d.identifier,P))?.[1];h&&(E=(0,R.$Fj)(h));const v=n?this.o(u,E,d):this.n(u,b,d);return v.then(P=>{this.g.set(P.id,P),P.visible=P.id===this.h}),n?this.r(u,E??this.m.getLevel(),v):this.q(u,v)}async n(u,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,b=this.k.extUri.joinPath(n,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),E=this.l.createLogger(b,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(u,b,t,d.identifier.value);return new s(h,u,E,this.a,d)}async o(u,t,d){const n=await this.p(d),b=u.replace(/[\\/:\*\?"<>\|]/g,""),E=this.k.extUri.joinPath(n,`${b}.log`),h=`${d.identifier.value}.${b}`,v=this.l.createLogger(E,{id:h,name:u,logLevel:t,extensionId:d.identifier.value});return new i(h,u,v,this.a,d)}p(u){let t=this.d.get(u.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(n){if((0,w.$Ik)(n)!==w.FileSystemProviderErrorCode.FileExists)throw n}return d})())}return t}q(u,t){let d=!1;const n=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return u},append(b){n(),t.then(E=>E.append(b))},appendLine(b){n(),t.then(E=>E.appendLine(b))},clear(){n(),t.then(b=>b.clear())},replace(b){n(),t.then(E=>E.replace(b))},show(b,E){n(),t.then(h=>h.show(b,E))},hide(){n(),t.then(b=>b.hide())},dispose(){d=!0,t.then(b=>b.dispose())}}}r(u,t,d){const n=new c.$Sc,b=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},E=n.add(new r.$Wd);function h(v){t=v,E.fire(v)}return d.then(v=>{n.add(v),v.logLevel!==t&&h(v.logLevel),n.add(v.onDidChangeLogLevel(P=>h(P)))}),{...this.q(u,d),get logLevel(){return t},onDidChangeLogLevel:E.event,trace(v,...P){b(),d.then(g=>g.trace(v,...P))},debug(v,...P){b(),d.then(g=>g.debug(v,...P))},info(v,...P){b(),d.then(g=>g.info(v,...P))},warn(v,...P){b(),d.then(g=>g.warn(v,...P))},error(v,...P){b(),d.then(g=>g.error(v,...P))},dispose(){n.dispose()}}}};e.$0hc=o,e.$0hc=o=Je([qe(0,I.$AN),qe(1,D.$QN),qe(2,f.$Wgc),qe(3,L.$wgc),qe(4,R.$qj),qe(5,R.$pj)],o),e.$$hc=(0,M.$8h)("IExtHostOutputService")}),define(Ae[114],Me([1,0,4,11]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Om=(0,S.$8h)("remoteAgentService"),e.$Pm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let A=1/0;for(let m=0;m<this.maxSampleCount;m++){const f=await I.getRoundTripTime();if(f===void 0)return;A=Math.min(A,f/2),await(0,M.$9g)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(A):R=this.initial.reduce((m,f)=>m+f,0)/this.initial.length,this.lastMeasurement={initial:R,current:A,average:this.average.reduce((m,f)=>m+f,0)/this.average.length,high:typeof R>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ae[282],Me([1,0,171,55,30,48,47,6,5,114,20,26,11]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=void 0,e.$7H=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$8H=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$9H=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$0H=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$$H={ConfigurationMigration:"base.contributions.configuration.migration"};class ${constructor(){this.migrations=[],this.a=new f.$Wd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const w=new $;I.$Kn.add(e.$$H.ConfigurationMigration,w);let r=class extends m.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,o){super(),this.a=i,this.b=o,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const u of a.added)await this.f(u,w.migrations)})),this.c(w.migrations),this.B(w.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(i){await this.f(void 0,i);for(const o of this.b.getWorkspace().folders)await this.f(o,i)}async f(i,o){await Promise.all([o.map(a=>this.g(a,i?.uri))])}async g(i,o){const a=this.a.inspect(i.key,{resource:o}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,d]of u){const n=a[t];if(!n)continue;const b=[];if(n.value!==void 0){const E=await this.h(i,t,n.value,o,void 0);for(const h of E??[])b.push([h,[]])}for(const{identifiers:E,value:h}of n.overrides??[])if(h!==void 0){const v=await this.h(i,t,h,o,E);for(const P of v??[])b.push([P,E])}b.length&&await Promise.allSettled(b.map(async([[E,h],v])=>this.a.updateValue(E,h.value,{resource:o,overrideIdentifiers:v},d)))}}async h(i,o,a,u,t){const d=b=>{const h=this.a.inspect(b,{resource:u})[o];if(h)return t?h.overrides?.find(({identifiers:v})=>(0,k.$Cn)(v,t))?.value:h.value},n=await i.migrateFn(a,d);return Array.isArray(n)?n:[[i.key,n]]}};e.$_H=r,e.$_H=r=Je([qe(0,R.$Bi),qe(1,A.$ei)],r);let c=class extends m.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new l.$sh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!L.$i&&(await this.b.getEnvironment())?.os!==1)return;I.$Kn.as(M.$Pn.Configuration).registerConfiguration({...e.$9H,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$aI=c,e.$aI=c=Je([qe(0,D.$Om)],c)}),define(Ae[283],Me([1,0,34,12,19,24,179,282,55,4,30]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdb=e.$Udb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Tdb=e.$Sdb=void 0,e.$Sdb=(0,D.$8h)("editorResolverService"),e.$Tdb="workbench.editorAssociations";const k=L.$Kn.as(f.$Pn.Configuration),l={...m.$8H,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(l);var $;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})($||(e.RegisteredEditorPriority=$={}));var w;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function r(s){switch(s){case $.exclusive:return 5;case $.default:return 4;case $.builtin:return 3;case $.option:default:return 1}}e.$Udb=r;function c(s,i){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(i.scheme))return!1;const u=typeof s=="string"&&s.indexOf(I.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,A.$Fg)(i);return S.$Nj(typeof s=="string"?s.toLowerCase():s,u.toLowerCase())}e.$Vdb=c}),define(Ae[284],Me([1,0,45,12,19,20,24,2,4,200,48,218,114]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$4K=e.$3K=void 0,e.$3K=(0,f.$8h)("pathService");let w=$=class{constructor(c,s,i,o){this.d=c,this.e=s,this.f=i,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??c})()}hasValidBasename(c,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(o=>this.h(c,o,s)):this.h(c,s,i)}h(c,s,i){return c.scheme===M.Schemas.file||c.scheme===M.Schemas.vscodeRemote?(0,S.$7f)(i??(0,R.$Fg)(c),s===1):!0}get defaultUriScheme(){return $.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(c,s){if(c.remoteAuthority)return M.Schemas.vscodeRemote;const i=(0,D.$ZK)(s.getWorkspace());if(i)return i;const o=s.getWorkspace().folders[0];if(o)return o.uri.scheme;const a=s.getWorkspace().configuration;return a?a.scheme:M.Schemas.file}userHome(c){return c?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(c=>c===1?I.$fc:I.$gc)}async fileURI(c){let s="";if(await this.a===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const o=c.indexOf("/",2);o===-1?(s=c.substring(2),c="/"):(s=c.substring(2,o),c=c.substring(o)||"/")}return m.URI.from({scheme:M.Schemas.file,authority:s,path:c,query:"",fragment:""})}};e.$4K=w,e.$4K=w=$=Je([qe(1,l.$Om),qe(2,k.$LK),qe(3,L.$ei)],w)}),define(Ae[115],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$DJ=e.$CJ=void 0;class S{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new S(0,0)}with(R){return new S(0,0)}}e.$CJ=S;class M{constructor(R,m,f,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(R,m),this.end=new S(f,D)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new M(0,0,0,0)}with(R){return new M(0,0,0,0)}}e.$DJ=M;var I;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Ae[44],Me([1,0,18,34,26,45,13,4,19,15,115,11]),function(fe,e,S,M,I,A,R,m,f,D,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.SearchErrorCode=e.$SJ=e.$RJ=e.SearchSortOrder=e.ViewMode=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.SearchCompletionExitCode=e.$MJ=e.$LJ=e.$KJ=e.QueryType=e.SearchProviderType=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.$EJ="workbench.view.search",e.$FJ="workbench.panel.search",e.$GJ="workbench.view.search",e.$HJ="search-result",e.$IJ="search.exclude";const l="\u27EA ",$=" characters skipped \u27EB",w=(l.length+$.length+5)*2;e.$JJ=(0,m.$8h)("searchService");var r;(function(he){he[he.file=0]="file",he[he.text=1]="text"})(r||(e.SearchProviderType=r={}));var c;(function(he){he[he.File=1]="File",he[he.Text=2]="Text"})(c||(e.QueryType=c={}));function s(he){return!!he.preview}e.$KJ=s;function i(he){return!!he.resource}e.$LJ=i;function o(he){return!!he.message}e.$MJ=o;var a;(function(he){he[he.Normal=0]="Normal",he[he.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class u{constructor(ve){this.resource=ve,this.results=[]}}e.$NJ=u;class t{constructor(ve,se,$e,te){this.ranges=se,this.webviewIndex=te;const X=Array.isArray(se)?se:[se];if($e&&$e.matchLines===1&&d(X)){ve=(0,R.$Cf)(ve,$e.matchLines);let V="",ie=0,Ce=0;const Te=Math.floor($e.charsPerLine/5),Pe=[];for(const be of X){const me=Math.max(be.startColumn-Te,0),G=be.startColumn+$e.charsPerLine;if(me>Ce+Te+w){const _=l+(me-Ce)+$;V+=_+ve.slice(me,G),ie+=me-(Ce+_.length)}else V+=ve.slice(Ce,G);Pe.push(new b(0,be.startColumn-ie,be.endColumn-ie)),Ce=G}this.preview={text:V,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const V=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ve,matches:(0,S.$2b)(se,ie=>new n(ie.startLineNumber-V,ie.startColumn,ie.endLineNumber-V,ie.endColumn))}}}}e.$OJ=t;function d(he){const ve=he[0].startLineNumber;for(const se of he)if(se.startLineNumber!==ve||se.endLineNumber!==ve)return!1;return!0}class n{constructor(ve,se,$e,te){this.startLineNumber=ve,this.startColumn=se,this.endLineNumber=$e,this.endColumn=te}}e.$PJ=n;class b extends n{constructor(ve,se,$e){super(ve,se,ve,$e)}}e.$QJ=b;var E;(function(he){he.List="list",he.Tree="tree"})(E||(e.ViewMode=E={}));var h;(function(he){he.Default="default",he.FileNames="fileNames",he.Type="type",he.Modified="modified",he.CountDescending="countDescending",he.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function v(he,ve=!0){const se=he&&he.files&&he.files.exclude,$e=ve&&he&&he.search&&he.search.exclude;if(!se&&!$e)return;if(!se||!$e)return se||$e;let te=Object.create(null);return te=I.$Bn(te,I.$yn(se)),te=I.$Bn(te,I.$yn($e),!0),te}e.$RJ=v;function P(he,ve){return he.excludePattern&&M.$Nj(he.excludePattern,ve)?!1:he.includePattern||he.usingSearchPaths?he.includePattern&&M.$Nj(he.includePattern,ve)?!0:he.usingSearchPaths?!!he.folderQueries&&he.folderQueries.some(se=>{const $e=se.folder.fsPath;if(A.$9f(ve,$e)){const te=f.$lc($e,ve);return!se.includePattern||!!M.$Nj(se.includePattern,te)}else return!1}):!1:!0}e.$SJ=P;var g;(function(he){he[he.unknownEncoding=1]="unknownEncoding",he[he.regexParseError=2]="regexParseError",he[he.globParseError=3]="globParseError",he[he.invalidLiteral=4]="invalidLiteral",he[he.rgProcessError=5]="rgProcessError",he[he.other=6]="other",he[he.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class p extends Error{constructor(ve,se){super(ve),this.code=se}}e.$TJ=p;function y(he){const ve=he.message;if((0,D.$4)(he))return new p(ve,g.canceled);try{const se=JSON.parse(ve);return new p(se.message,se.code)}catch{return new p(ve,g.other)}}e.$UJ=y;function T(he){const ve={message:he.message,code:he.code};return new Error(JSON.stringify(ve))}e.$VJ=T;function N(he){return he.type==="error"?!0:he.type==="success"}e.$WJ=N;function J(he){return he.type==="success"}e.$XJ=J;function q(he){return!!he.path}e.$YJ=q;function U(he,ve,se=!0){const $e=he.searchPath?he.searchPath:he.relativePath;return se?(0,R.$zf)($e,ve):M.$Nj(ve,$e)}e.$ZJ=U;class C{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$1J=C;function F(he,ve){const se={...he||{},...ve||{}};return Object.keys(se).filter($e=>{const te=se[$e];return typeof te=="boolean"&&te})}e.$2J=F;class W{constructor(ve,se){this.c=null,this.a={...ve.excludePattern||{},...se.excludePattern||{}},this.b=M.$Oj(this.a);let $e=ve.includePattern;se.includePattern&&($e?$e={...$e,...se.includePattern}:$e=se.includePattern),$e&&(this.c=M.$Oj($e))}matchesExcludesSync(ve,se,$e){return!!(this.b&&this.b(ve,se,$e))}includedInQuerySync(ve,se,$e){return!(this.b&&this.b(ve,se,$e)||this.c&&!this.c(ve,se,$e))}includedInQuery(ve,se,$e){const te=this.b(ve,se,$e),X=()=>this.c?!!this.c(ve,se,$e):!0;return(0,k.$Tg)(te)?te.then(V=>V?!1:X()):X()}hasSiblingExcludeClauses(){return re(this.a)}}e.$3J=W;function re(he){for(const ve in he)if(typeof he[ve]!="boolean")return!0;return!1}function ce(he){if(!he)return;let ve;return se=>(ve||(ve=(he()||Promise.resolve([])).then($e=>$e?De($e):{})),ve.then($e=>!!$e[se]))}e.$4J=ce;function we(he){if(!he)return;let ve;return se=>{if(!ve){const $e=he();ve=$e?De($e):{}}return!!ve[se]}}e.$5J=we;function De(he){const ve={};for(const se of he)ve[se]=!0;return ve}}),define(Ae[36],Me([1,0,18,11,21,5,6,51,12,123,24,13,2,170,4,14,189,48,43,27,17,8,7,58,44,3,52]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o,a,u,t,d,n,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=e.$Qgc=void 0;function h(J,q,U){return new L.$xg(C=>p(C,U)).isEqual(J,q)}function v(J,q,U){return h(J.uri,q.uri,U)?0:(0,k.$6e)(J.uri.toString(),q.uri.toString())}function P(J,q,U){return J.index!==q.index?J.index<q.index?-1:1:h(J.uri,q.uri,U)?(0,k.$6e)(J.name,q.name):(0,k.$6e)(J.uri.toString(),q.uri.toString())}function g(J,q,U,C){const F=J.slice(0).sort((re,ce)=>U(re,ce,C)),W=q.slice(0).sort((re,ce)=>U(re,ce,C));return(0,S.$Eb)(F,W,(re,ce)=>U(re,ce,C))}function p(J,q){const U=q.getCapabilities(J.scheme);return!(U&&U&1024)}class y extends s.$oi{static toExtHostWorkspace(q,U,C,F){if(!q)return{workspace:null,added:[],removed:[]};const{id:W,name:re,folders:ce,configuration:we,transient:De,isUntitled:he}=q,ve=[],se=U;U?ce.forEach((V,ie)=>{const Ce=l.URI.revive(V.uri),Te=y.o(C||U,Ce,F);Te?(Te.name=V.name,Te.index=V.index,ve.push(Te)):ve.push({uri:Ce,name:V.name,index:ie})}):ve.push(...ce.map(({uri:V,name:ie,index:Ce})=>({uri:l.URI.revive(V),name:ie,index:Ce}))),ve.sort((V,ie)=>V.index<ie.index?-1:1);const $e=new y(W,re,ve,!!De,we?l.URI.revive(we):null,!!he,V=>p(V,F)),{added:te,removed:X}=g(se?se.workspaceFolders:[],$e.workspaceFolders,v,F);return{workspace:$e,added:te,removed:X}}static o(q,U,C){for(let F=0;F<q.folders.length;F++){const W=q.workspaceFolders[F];if(h(W.uri,U,C))return W}}constructor(q,U,C,F,W,re,ce){super(q,C.map(we=>new s.$pi(we)),F,W,ce),this.t=U,this.u=re,this.q=[],this.s=m.$bi.forUris(ce),C.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,U){return U&&this.s.get(q)&&(q=(0,L.$Hg)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let T=class{constructor(q,U,C,F,W){this.c=new A.$Wd,this.onDidChangeWorkspace=this.c.event,this.g=new A.$Wd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new A.$Yd,this.C=new Map,this.h=F,this.s=C,this.t=W,this.j=new D.$$l,this.k=new M.$7g,this.o=q.getProxy(b.$oL.MainThreadWorkspace),this.q=q.getProxy(b.$oL.MainThreadMessageService);const re=U.workspace;this.l=re?new y(re.id,re.name,[],!!re.transient,re.configuration?l.URI.revive(re.configuration):null,!!re.isUntitled,ce=>p(ce,C)):void 0}$initializeWorkspace(q,U){this.v=U,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:f.Schemas.untitled,path:(0,L.$Fg)((0,L.$Hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,U,C,...F){const W=[];if(Array.isArray(F)&&F.forEach(he=>{l.URI.isUri(he.uri)&&!W.some(ve=>h(ve.uri,he.uri,this.s))&&W.push({uri:he.uri,name:he.name||(0,L.$Eg)(he.uri)})}),this.n||[U,C].some(he=>typeof he!="number"||he<0)||C===0&&W.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(U+C>re.length)return!1;const ce=re.slice(0);ce.splice(U,C,...W.map(he=>({uri:he.uri,name:he.name||(0,L.$Eg)(he.uri),index:void 0})));for(let he=0;he<ce.length;he++){const ve=ce[he];if(ce.some((se,$e)=>$e!==he&&h(ve.uri,se.uri,this.s)))return!1}ce.forEach((he,ve)=>he.index=ve);const{added:we,removed:De}=g(re,ce,P,this.s);if(we.length===0&&De.length===0)return!1;if(this.o){const he=q.displayName||q.name;this.o.$updateWorkspaceFolders(he,U,C,W).then(void 0,ve=>{this.n=void 0;const se={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(c.Severity.Error,(0,$.localize)(0,null,he,ve.toString()),se,[])})}return this.y(ce),!0}getWorkspaceFolder(q,U){if(this.x)return this.x.getWorkspaceFolder(q,U)}async getWorkspaceFolder2(q,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,U)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,U){let C,F="";if(typeof q=="string"?(C=l.URI.file(q),F=q):typeof q<"u"&&(C=q,F=q.fsPath),!C)return F;const W=this.getWorkspaceFolder(C,!0);if(!W)return F;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let re=(0,L.$Kg)(W.uri,C);return U&&W.name&&(re=`${W.name}/${re}`),re}y(q){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:U,added:C,removed:F}=y.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:F}))}findFiles(q,U,C,F,W=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let re="",ce=!0;return U===null?ce=!1:U!==void 0&&(typeof U=="string"?re=U:re=U.pattern),this.z(q,void 0,{exclude:re,maxResults:C,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},W)}findFiles2(q,U={},C,F=I.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${C.value}, entryPoint: findFiles2`),this.z(void 0,q,U,F)}async z(q,U,C,F=I.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const W=typeof C.exclude=="string"?C.exclude:C.exclude?C.exclude.pattern:void 0,re={ignoreSymlinks:typeof C.followSymlinks=="boolean"?!C.followSymlinks:void 0,disregardIgnoreFiles:typeof C.useIgnoreFiles=="boolean"?!C.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof C.useGlobalIgnoreFiles=="boolean"?!C.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof C.useParentIgnoreFiles=="boolean"?!C.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof C.useDefaultExcludes=="boolean"?!C.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof C.useDefaultSearchExcludes=="boolean"?!C.useDefaultSearchExcludes:!1,maxResults:C.maxResults,excludePattern:W,shouldGlobSearch:typeof C.fuzzy=="boolean"?!C.fuzzy:!0,_reason:"startFileSearch"};let ce;if(q){const{includePattern:we,folder:De}=N(u.GlobPattern.from(q));ce=De,re.includePattern=we}else{const{includePattern:we,folder:De}=N(u.GlobPattern.from(U));ce=De,re.filePattern=we}return this.o.$startFileSearch(ce??null,re,F).then(we=>Array.isArray(we)?we.map(De=>l.URI.revive(De)):[])}async findTextInFiles(q,U,C,F,W=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),ce=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:we,folder:De}=N(u.GlobPattern.from(U.include)),he=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ve={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ce,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:we,excludePattern:he},se=!1;if(this.u[re]=$e=>{if(se)return;const te=l.URI.revive($e.resource);$e.results.forEach(X=>{const V=(0,E.$Eh)(X);(0,n.$KJ)(V)?C({uri:te,preview:{text:V.preview.text,matches:(0,S.$2b)(V.preview.matches,ie=>new t.$sL(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,S.$2b)(V.ranges,ie=>new t.$sL(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):C({uri:te,text:V.text,lineNumber:V.lineNumber})})},W.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(q,De??null,ve,re,W);return delete this.u[re],$e||{}}catch($e){throw delete this.u[re],$e}}$handleTextSearchResult(q,U){this.u[U]?.(q)}async save(q){const U=await this.o.$save(q,{saveAs:!1});return l.URI.revive(U)}async saveAs(q){const U=await this.o.$save(q,{saveAs:!0});return l.URI.revive(U)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,U){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,U);const C=this.t.transformOutgoingScheme(q),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,C),(0,R.$Rc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(q,U){this.h.info("Getting edit session identifier for workspaceFolder",q);const C=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const F=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!F),!F)return;const W=await F.provideEditSessionIdentity(C,U);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(q,U,C,F){this.h.info("Getting edit session identifier for workspaceFolder",q);const W=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const re=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!re),!re)return;const ce=await re.provideEditSessionIdentityMatch?.(U,C,F);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(q){return(U,C,F)=>{const W=function(ce){U.call(C,ce)};return W.extension=q,this.B.event(W,void 0,F)}}async $onWillCreateEditSessionIdentity(q,U,C){const F=await this.resolveWorkspaceFolder(l.URI.revive(q));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},U,async(W,re)=>{const ce=Date.now();await Promise.resolve(W),Date.now()-ce>C&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(q,U){if(this.C.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.C.set(q,U);const C=this.t.transformOutgoingScheme(q),F=this.A++;return this.o.$registerCanonicalUriProvider(F,C),(0,R.$Rc)(()=>{this.C.delete(q),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(q,U,C){const F=this.C.get(q.scheme);if(!F)return;const W=await F.provideCanonicalUri?.(l.URI.revive(q),U,C);if(W)return W}async $provideCanonicalUri(q,U,C){return this.provideCanonicalUri(l.URI.revive(q),{targetScheme:U},C)}};e.$Qgc=T,e.$Qgc=T=Je([qe(0,a.$AN),qe(1,o.$QN),qe(2,i.$wgc),qe(3,r.$pj),qe(4,d.$Ogc)],T),e.$Rgc=(0,w.$8h)("IExtHostWorkspace");function N(J){let q,U;return J&&(typeof J=="string"?q=J:(q=J.pattern,U=l.URI.revive(J.baseUri))),{includePattern:q,folder:U}}}),define(Ae[37],Me([1,0,26,5,36,3,7,191,55,16,11,4,17,14,2]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=e.$Tgc=e.$Sgc=void 0;function r(d,n){if(n){const b=n.split(".");let E=d;for(let h=0;E&&h<b.length;h++)E=E[b[h]];return E}}function c(d){return d instanceof w.URI}function s(d){return d&&d.uri instanceof w.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function o(d){return d&&d.uri instanceof w.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function a(d){if(c(d))return{resource:d};if(s(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(o(d))return{resource:d.uri};if(d===null)return{resource:null}}let u=class{constructor(n,b,E){this.a=n.getProxy(A.$oL.MainThreadConfiguration),this.c=b,this.b=E,this.d=new L.$7g,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new t(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,b){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(n,b))}};e.$Sgc=u,e.$Sgc=u=Je([qe(0,l.$AN),qe(1,I.$Rgc),qe(2,$.$pj)],u);class t{constructor(n,b,E,h){this.a=new M.$Wd,this.b=n,this.f=h,this.c=b,this.e=m.$9n.parse(E),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,b){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$9n.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(b,E))}getConfiguration(n,b,E){const h=a(b)||{},v=this.g(n?r(this.e.getValue(void 0,h,this.c.workspace),n):this.e.getValue(void 0,h,this.c.workspace));n&&this.h(n,h,E?.identifier);function P(p){if(p==null)return null;if(typeof p=="boolean")return p?2:5;switch(p){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(p){return typeof r(v,p)<"u"},get:(p,y)=>{this.h(n?`${n}.${p}`:p,h,E?.identifier);let T=r(v,p);if(typeof T>"u")T=y;else{let N;const J=(q,U)=>{if((0,D.$Lf)(q)){let C;const F=()=>{N=N||(0,S.$yn)(v),C=C||r(N,U)};return new Proxy(q,{get:(W,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return F(),()=>C;if(N)return C=C||r(N,U),C[re];const ce=W[re];return typeof re=="string"?J(ce,`${U}.${re}`):ce},set:(W,re,ce)=>(F(),C&&(C[re]=ce),!0),deleteProperty:(W,re)=>(F(),C&&delete C[re],!0),defineProperty:(W,re,ce)=>(F(),C&&Object.defineProperty(C,re,ce),!0)})}return Array.isArray(q)?(0,S.$yn)(q):q};T=J(T,p)}return T},update:(p,y,T,N)=>{p=n?`${n}.${p}`:p;const J=P(T);return y!==void 0?this.b.$updateConfigurationOption(J,p,y,h,N):this.b.$removeConfigurationOption(J,p,h,N)},inspect:p=>{p=n?`${n}.${p}`:p;const y=this.e.inspect(p,h,this.c.workspace);if(y)return{key:p,defaultValue:(0,S.$yn)(y.policy?.value??y.default?.value),globalValue:(0,S.$yn)(y.user?.value??y.application?.value),workspaceValue:(0,S.$yn)(y.workspace?.value),workspaceFolderValue:(0,S.$yn)(y.workspaceFolder?.value),defaultLanguageValue:(0,S.$yn)(y.default?.override),globalLanguageValue:(0,S.$yn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,S.$yn)(y.workspace?.override),workspaceFolderLanguageValue:(0,S.$yn)(y.workspaceFolder?.override),languageIds:(0,S.$yn)(y.overrideIdentifiers)}}};return typeof v=="object"&&(0,S.$Bn)(g,v,!1),Object.freeze(g)}g(n){const b=E=>(0,D.$Lf)(E)?new Proxy(E,{get:(h,v)=>b(h[v]),set:(h,v,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(h,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(h,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return b(n)}h(n,b,E){const h=f.$Zn.test(n)?4:this.d.get(n),v=E?`[${E.value}] `:"";if(h===4){typeof b?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){b?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,b){const E=new m.$$n(n,b,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,v)=>E.affectsConfiguration(h,a(v))})}k(n){return n.reduce((b,E)=>(b.set(E[0],E[1]),b),new Map)}}e.$Tgc=t,e.$Ugc=(0,k.$8h)("IExtHostConfiguration")}),define(Ae[116],Me([1,0,2,11,5,3,7,36,66,37,21,65,17,27,4,12,20,14,78,223,15]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=e.$kic=e.$jic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(J){function q(C){if(C!=null)return C}J.from=q;function U(C){if(C!=null)return C}J.to=U})(u||(u={}));var t;(function(J){function q(C){if(C!=null)return C}J.from=q;function U(C){if(C!=null)return C}J.to=U})(t||(t={}));var d;(function(J){function q(C){if(C!=null)return C}J.from=q;function U(C){if(C!=null)return C}J.to=U})(d||(d={}));var n;(function(J){function q(F){if(F){const W=F;return W&&!!W.process}else return!1}J.is=q;function U(F){if(F==null)return;const W={process:F.process,args:F.args};return F.options&&(W.options=d.from(F.options)),W}J.from=U;function C(F){if(F!=null)return new R.$_L(F.process,F.args,F.options)}J.to=C})(n||(n={}));var b;(function(J){function q(C){if(C!=null)return C}J.from=q;function U(C){if(C!=null)return C}J.to=U})(b||(b={}));var E;(function(J){function q(F){if(F){const W=F;return W&&(!!W.commandLine||!!W.command)}else return!1}J.is=q;function U(F){if(F==null)return;const W={};return F.commandLine!==void 0?W.commandLine=F.commandLine:(W.command=F.command,W.args=F.args),F.options&&(W.options=b.from(F.options)),W}J.from=U;function C(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new R.$aM(F.commandLine,F.options):new R.$aM(F.command,F.args?F.args:[],F.options)}J.to=C})(E||(E={}));var h;(function(J){function q(F){if(F){const W=F;return W&&W.customExecution==="customExecution"}else return!1}J.is=q;function U(F){return{customExecution:"customExecution"}}J.from=U;function C(F,W){return W.get(F)}J.to=C})(h||(e.CustomExecutionDTO=h={}));var v;(function(J){function q(U,C){let F;return U.scope!==void 0&&typeof U.scope!="number"?F=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&C&&C.workspaceFile?F=C.workspaceFile:F=o.$EG),{id:U._id,workspaceFolder:F}}J.from=q})(v||(e.TaskHandleDTO=v={}));var P;(function(J){function q(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}J.from=q})(P||(P={}));var g;(function(J){function q(F,W){if(F==null)return[];const re=[];for(const ce of F){const we=U(ce,W);we&&re.push(we)}return re}J.fromMany=q;function U(F,W){if(F==null)return;let re;F.execution instanceof R.$_L?re=n.from(F.execution):F.execution instanceof R.$aM?re=E.from(F.execution):F.execution&&F.execution instanceof R.$bM&&(re=h.from(F.execution));const ce=u.from(F.definition);let we;return F.scope?typeof F.scope=="number"?we=F.scope:we=F.scope.uri:we=R.TaskScope.Workspace,!ce||!we?void 0:{_id:F._id,definition:ce,name:F.name,source:{extensionId:W.identifier.value,label:F.source,scope:we},execution:re,isBackground:F.isBackground,group:P.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}J.from=U;async function C(F,W,re){if(F==null)return;let ce;n.is(F.execution)?ce=n.to(F.execution):E.is(F.execution)?ce=E.to(F.execution):h.is(F.execution)&&(ce=h.to(F._id,re));const we=u.to(F.definition);let De;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?De=F.source.scope:De=await W.resolveWorkspaceFolder(S.URI.revive(F.source.scope)):De=R.TaskScope.Workspace),!we||!De)return;const he=new R.$cM(we,De,F.name,F.source.label,ce,F.problemMatchers);return F.isBackground!==void 0&&(he.isBackground=F.isBackground),F.group!==void 0&&(he.group=R.$$L.from(F.group._id),he.group&&F.group.isDefault&&(he.group=new R.$$L(he.group.id,he.group.label),F.group.isDefault===!0&&(he.group.isDefault=F.group.isDefault))),F.presentationOptions&&(he.presentationOptions=t.to(F.presentationOptions)),F._id&&(he._id=F._id),F.detail&&(he.detail=F.detail),he}J.to=C})(g||(e.TaskDTO=g={}));var p;(function(J){function q(C){return C}J.from=q;function U(C){if(C)return Object.assign(Object.create(null),C)}J.to=U})(p||(p={}));class y{#e;constructor(q,U,C){this._id=U,this.a=C,this.#e=q}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}let T=class{constructor(q,U,C,F,W,re,ce,we){this.q=new I.$Wd,this.r=new I.$Wd,this.s=new I.$Wd,this.u=new I.$Wd,this.a=q.getProxy(A.$oL.MainThreadTask),this.b=C,this.c=F,this.d=W,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=we,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,U,C){if(!C)return new R.$qL(()=>{});const F=this.x();return this.j.set(F,{type:U,provider:C,extension:q}),this.a.$registerTaskProvider(F,U),new R.$qL(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(q,U){this.a.$registerTaskSystem(q,U)}fetchTasks(q){return this.a.$fetchTasks(p.from(q)).then(async U=>{const C=[];for(const F of U){const W=await g.to(F,this.b,this.m);W&&C.push(W)}return C})}get taskExecutions(){const q=[];return this.k.forEach(U=>q.push(U)),q}terminateTask(q){if(!(q instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,U,C){const F=this.m.get(q.id);F&&(this.o.set(q.id,F),this.e.attachPtyToTerminal(U,await F.callback(C))),this.p=q.id,this.q.fire({execution:await this.z(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){if(!this.l.has(q.id))return;const U=await this.z(q);this.l.delete(q.id),this.k.delete(q.id),this.B(q),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const U=await this.z(q.id);this.s.fire({execution:U,processId:q.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(q){const U=await this.z(q.id);this.u.fire({execution:U,exitCode:q.exitCode})}$provideTasks(q,U){const C=this.j.get(q);if(!C)return Promise.reject(new Error("no handler found"));const F=[],W=(0,M.$Zg)(()=>C.provider.provideTasks(L.CancellationToken.None)).then(re=>this.v(U,F,C,re));return new Promise(re=>{W.then(ce=>{Promise.all(F).then(()=>{re(ce)})})})}async $resolveTask(q,U){const C=this.j.get(q);if(!C)return Promise.reject(new Error("no handler found"));if(U.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${C.type}].`);const F=await g.to(U,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const W=await C.provider.resolveTask(F,L.CancellationToken.None);if(!W)return;this.A(W,C);const re=g.from(W,C.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(re.execution)&&await this.y(re,W,!0),await this.w(re)}x(){return this.h++}async y(q,U,C){const F=await this.a.$createTaskId(q);!C&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,U.execution)),this.m.set(F,U.execution)}async z(q,U){if(typeof q=="string"){const W=this.l.get(q);if(!W)throw new a.$bb("Unexpected: The specified task is missing an execution");return W}const C=this.l.get(q.id);if(C)return C;let F;return U?F=Promise.resolve(new y(this,q.id,U)):F=g.to(q.task,this.b,this.m).then(W=>{if(!W)throw new a.$bb("Unexpected: Task does not exist.");return new y(this,q.id,W)}),this.l.set(q.id,F),F.then(W=>(this.k.set(q.id,W),W))}A(q,U){q._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}B(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const C=this.n.values();let F=C.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=C.next()}};e.$jic=T,e.$jic=T=Je([qe(0,l.$AN),qe(1,$.$QN),qe(2,m.$Rgc),qe(3,f.$LN),qe(4,D.$Ugc),qe(5,k.$ghc),qe(6,s.$pj),qe(7,i.$zgc)],T);let N=class extends T{constructor(q,U,C,F,W,re,ce,we){super(q,U,C,F,W,re,ce,we),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:c.$h(0)})}async executeTask(q,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const C=g.from(U,q);if(C===void 0)throw new Error("Task is not valid");if(h.is(C.execution))await this.y(C,U,!1);else throw new a.$_;const F=await this.z(await this.a.$getTaskExecution(C),U);return this.a.$executeTask(C).catch(W=>{throw new Error(W)}),F}v(q,U,C,F){const W=[];if(F)for(const re of F){if(this.A(re,C),!re.definition||!q[re.definition.type]){const we=re.source?re.source:"No task source";this.f.warn(`The task [${we}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=g.from(re,C.extension);ce&&h.is(ce.execution)?(W.push(ce),U.push(this.y(ce,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:C.extension}}async w(q){if(h.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,U,C){}};e.$kic=N,e.$kic=N=Je([qe(0,l.$AN),qe(1,$.$QN),qe(2,m.$Rgc),qe(3,f.$LN),qe(4,D.$Ugc),qe(5,k.$ghc),qe(6,s.$pj),qe(7,i.$zgc)],N),e.$lic=(0,w.$8h)("IExtHostTask")}),define(Ae[285],Me([1,0,44,29]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.$_J=e.$$J=void 0;function I(R){return"cellResults"in R}e.$$J=I,e.$_J="rawCell#";function A(R,m){let f=-1;const D=[];let L=[];return R.forEach(l=>{l.range.startLineNumber!==f&&L.length>0&&(D.push([...L]),L=[]),L.push(l),f=l.range.endLineNumber}),L.length>0&&D.push([...L]),D.map(l=>{const $=[],w=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let c=w;c<=r;c++)$.push(m.getLineContent(c));return new S.$OJ($.join(`
`)+`
`,l.map(c=>new M.$Ws(c.range.startLineNumber-1,c.range.startColumn-1,c.range.endLineNumber-1,c.range.endColumn-1)))})}e.$aK=A}),define(Ae[286],Me([1,0,164,23,5,6,28,13,16,2,42,74,3,31,8,7,50,261,110,26,12,213,285,283]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o,a,u,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class n{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,h,v,P,g,p){this.q=v,this.r=P,this.s=g,this.t=p,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new I.$Wd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Wd,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Wd,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Wd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$sgc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=E.getProxy(l.$oL.MainThreadNotebook),this.c=E.getProxy(l.$oL.MainThreadNotebookDocuments),this.d=E.getProxy(l.$oL.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const T=y.notebookEditor?.notebookUri,N=y.cell.handle,q=this.g.get(T)?.getCell(N);if(q)return q.apiCell}if(y&&y.$mid===14){const T=y.uri,N=this.g.get(T);if(N)return N.apiNotebook}return y}}),n.B(h)}getEditorById(E){const h=this.h.get(E);if(!h)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(E){for(const[h,v]of this.h)if(v.apiEditor===E)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,h){const v=this.g.get(E);if(!v&&!h)throw new Error(`NO notebook document for '${E}'`);return v}static u(E,h){if(!h)return;const v=h.filenamePattern.map(P=>w.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(h.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:h.displayName,filenamePattern:v,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,h,v){const P=n.a++,g=typeof v.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set(P,v),this.b.$registerNotebookCellStatusBarItemProvider(P,g,h);let p;return g!==void 0&&(p=v.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(g))),new r.$qL(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,g),p?.dispose()})}async createNotebookDocument(E){const h=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&w.NotebookData.from(E.content)});return D.URI.revive(h)}async openNotebookDocument(E){const h=this.g.get(E);if(h)return h.apiNotebook;const v=await this.c.$tryOpenNotebook(E),P=this.g.get(D.URI.revive(v));return(0,f.$Uf)(P?.apiNotebook)}async showNotebookDocument(E,h){D.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let v;typeof h=="object"?v={position:w.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(w.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:v={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,v),g=P&&this.h.get(P)?.apiEditor;if(g)return g;throw P?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,h,v,P){const g=this.f.get(E),p=D.URI.revive(h),y=this.g.get(p);if(!y||!g)return;const T=y.getCellFromIndex(v);if(!T)return;const N=await g.provideCellStatusBarItems(T.apiCell,P);if(!N)return;const J=new A.$Sc,q=this.p.add([J]),C=(Array.isArray(N)?N:[N]).map(F=>w.NotebookStatusBarItem.from(F,this.i,J));return{cacheId:q,items:C}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,h,v,P,g){if((0,m.$Ke)(h))throw new Error("viewType cannot be empty or just whitespace");const p=this.w++;return this.x.set(p,{viewType:h,serializer:v,options:P}),this.b.$registerNotebookSerializer(p,{id:E.identifier,location:E.extensionLocation},h,w.NotebookDocumentContentOptions.from(P),n.u(E,g)),(0,A.$Rc)(()=>{this.b.$unregisterNotebookSerializer(p)})}async $dataToNotebook(E,h,v){const P=this.x.get(E);if(!P)throw new Error("NO serializer found");const g=await P.serializer.deserializeNotebook(h.buffer,v);return new c.$Vv(w.NotebookData.from(g))}async $notebookToData(E,h,v){const P=this.x.get(E);if(!P)throw new Error("NO serializer found");const g=await P.serializer.serializeNotebook(w.NotebookData.to(h.value),v);return M.$ke.wrap(g)}async $saveNotebook(E,h,v,P,g){const p=D.URI.revive(h),y=this.x.get(E);if(!y)throw new Error("NO serializer found");const T=this.g.get(p);if(!T)throw new Error("Document NOT found");if(T.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(p.scheme))throw new L.$Nk((0,S.localize)(0,null,this.z(p)),6);await this.y(p,P);const N={metadata:(0,o.$Gn)(T.apiNotebook.metadata,F=>!(y.options?.transientDocumentMetadata??{})[F]),cells:[]};for(const F of T.apiNotebook.getCells()){const W=new r.$QM(F.kind,F.document.getText(),F.document.languageId,F.mime,y.options?.transientOutputs?[]:[...F.outputs],F.metadata,F.executionSummary);W.metadata=(0,o.$Gn)(F.metadata,re=>!(y.options?.transientCellMetadata??{})[re]),N.cells.push(W)}const J=await y.serializer.serializeNotebook(N,g);await this.s.value.writeFile(p,J);const q=this.s.getFileSystemProviderExtUri(p.scheme),U=await this.s.value.stat(p);return{name:q.basename(p),isFile:(U.type&L.FileType.File)!==0,isDirectory:(U.type&L.FileType.Directory)!==0,isSymbolicLink:(U.type&L.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&L.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(p.scheme),locked:!!((U.permissions??0)&L.FilePermission.Locked),etag:L.$Yk({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(E,h,v,P,g){const p=this.x.get(E)?.serializer;if(!p)return{limitHit:!1,results:[]};const y=new R.$Bc;await(async(U,C,F)=>{await Promise.all(U.map(async W=>await Promise.all(W.filenamePatterns.map(re=>{const ce={_reason:F._reason,folderQueries:F.folderQueries,includePattern:F.includePattern,excludePattern:F.excludePattern,maxResults:F.maxResults,type:1,filePattern:re};return this.t.doInternalFileSearchWithCustomCallback(ce,C,we=>{we.forEach(De=>{y.has(De)||P.some(ve=>W.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(se=>(0,d.$Vdb)(se,De)))||y.add(De)})})}))))})(v,g,h);const N=new R.$Ac;let J=!1;const q=Array.from(y).map(async U=>{const C=[];try{if(g.isCancellationRequested)return;if(h.maxResults&&[...N.values()].reduce((ce,we)=>ce+we.cellResults.length,0)>h.maxResults){J=!0;return}const F=[],W=this.g.get(U);if(W)W.apiNotebook.getCells().forEach(we=>F.push({input:we.document.getText(),outputs:we.outputs.flatMap(De=>De.items.map(he=>he.data.toString()))}));else{const ce=await this.s.value.readFile(U),we=M.$ke.fromString(ce.toString()),De=await p.deserializeNotebook(we.buffer,g);if(g.isCancellationRequested)return;w.NotebookData.from(De).cells.forEach(ve=>F.push({input:ve.source,outputs:ve.outputs.flatMap(se=>se.items.map($e=>$e.valueBytes.toString()))}))}if(g.isCancellationRequested)return;F.forEach((ce,we)=>{const De=h.contentPattern.pattern,he=new u.$3Rb(ce.input,void 0,ce.outputs),ve=he.findInInputs(De),se=he.findInOutputs(De),$e=se.flatMap(te=>(0,t.$aK)(te.matches,te.textBuffer)).map((te,X)=>(te.webviewIndex=X,te));if(ve.length>0||se.length>0){const te={index:we,contentResults:(0,t.$aK)(ve,he.inputTextBuffer),webviewResults:$e};C.push(te)}});const re={resource:U,cellResults:C};N.set(U,re);return}catch{return}});return await Promise.all(q),{limitHit:J,results:[...N.values()]}}async y(E,h){const v=await this.s.value.stat(E);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==L.$Xk&&typeof v.mtime=="number"&&typeof v.size=="number"&&h.mtime<v.mtime&&h.etag!==L.$Yk({mtime:h.mtime,size:v.size}))throw new L.$Nk((0,S.localize)(1,null),3,h)}z(E){return E.scheme===a.Schemas.file?E.fsPath:E.toString()}A(E,h,v){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const P=new i.$Ohc(h,this.d,E,v.visibleRanges.map(w.NotebookRange.to),v.selections.map(w.NotebookRange.to),typeof v.viewColumn=="number"?w.ViewColumn.to(v.viewColumn):void 0);this.h.set(h,P)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const v of E.value.removedDocuments){const P=D.URI.revive(v),g=this.g.get(P);g&&(g.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(p=>p.document.uri)}),this.n.fire(g.apiNotebook));for(const p of this.h.values())p.notebookData.uri.toString()===P.toString()&&this.h.delete(p.id)}if(E.value.addedDocuments){const v=[];for(const P of E.value.addedDocuments){const g=D.URI.revive(P.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const p=new s.$Nhc(this.c,this.q,this.r,g,P);v.push(...P.cells.map(y=>s.$Mhc.asModelAddData(p.apiNotebook,y))),this.g.get(g)?.dispose(),this.g.set(g,p),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(p.apiNotebook)}}if(E.value.addedEditors)for(const v of E.value.addedEditors){if(this.h.has(v.id))return;const P=D.URI.revive(v.documentUri),g=this.g.get(P);g&&this.A(g,v.id,v)}const h=[];if(E.value.removedEditors)for(const v of E.value.removedEditors){const P=this.h.get(v);P&&(this.h.delete(v),this.k?.id===P.id&&(this.k=void 0),h.push(P))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const v=new Set;this.l.forEach(P=>v.add(P.id));for(const P of this.h.values()){const g=v.has(P.id);P._acceptVisibility(g)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.h.get(E.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${E.value.newActiveEditor}`),this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(E){const h=$.$YN.String.with("notebookType","A notebook type"),v=new $.$1N("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new $.$YN("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>M.$ke.wrap(g))],new $.$ZN("Notebook Data",g=>w.NotebookData.to(g.value))),P=new $.$1N("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new $.$YN("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new c.$Vv(w.NotebookData.from(g)))],new $.$ZN("Bytes",g=>g.buffer));E.registerApiCommand(v),E.registerApiCommand(P)}}e.$Xhc=n}),define(Ae[287],Me([1,0,19,21,41,34,24,63,44]),function(fe,e,S,M,I,A,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;class D{constructor(l,$,w){this.k=l,this.l=$,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&A.$Oj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&A.$Oj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const $=this.k.folderQueries||[];return new Promise((w,r)=>{const c=s=>{this.f++,l(s)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),o=S.$nc(i);this.j&&this.j(i,o)||this.v(c,{base:s,basename:o})}),Promise.all($.map(s=>this.p(s,c))).then(s=>{w({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,I.$Si)(s)))})})}async p(l,$){const w=new M.$7d,r=this.q(l),c=this.r(),s=new f.$3J(this.k,l),i=!s.hasSiblingExcludeClauses();let o;try{this.h.add(w),o=m.$Sd.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,w.token),u=o.elapsed(),t=m.$Sd.create();return this.g&&!this.e||(a&&a.forEach(d=>{const n=S.$gc.relative(l.folder.path,d.path);if(i){const b=S.$nc(d.path);this.v($,{base:l.folder,relativePath:n,basename:b});return}this.s(c,l.folder,n,$)}),this.g&&!this.e)?null:(this.u(c,s,$),{providerTime:u,postProcessTime:t.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(l){const $=(0,f.$2J)(this.k.includePattern,l.includePattern),w=(0,f.$2J)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:w,includes:$,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},$,w,r){if(w===this.a){const s=S.$nc(this.a);this.v(r,{base:$,relativePath:this.a,basename:s})}function c(s){const i=S.$nc(s),o=S.$mc(s);let a=l[o];a||(a=l[o]=[],c(o)),a.push({base:$,relativePath:s,basename:i})}c(w)}u({rootEntries:l,pathToEntries:$},w,r){const c=this,s=this.a;function i(o){const a=(0,f.$5J)(()=>o.map(u=>u.basename));for(let u=0,t=o.length;u<t;u++){const d=o[u],{relativePath:n,basename:b}=d;if(w.matchesExcludesSync(n,b,s!==b?a:void 0))continue;const E=$[n];if(E)i(E);else{if(n===s)continue;c.v(r,d)}if(c.e)break}}i(l)}v(l,$){(!this.b||$.relativePath&&this.b($.relativePath,$.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l($))}}class L{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,$,w,r){const c=this.c(l.cacheKey),s=new D(l,$,c&&c.token);let i=0;const o=a=>{i+=a.length,w(a.map(u=>this.d(u)))};return this.e(s,L.a,o,r).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:a.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new M.$7d),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Ig(l.base,l.relativePath)}:{resource:l.base}}e(l,$,w,r){const c=r.onCancellationRequested(()=>{l.cancel()}),s=o=>{o&&(i.push(o),$>0&&i.length>=$&&(w(i),i=[]))};let i=[];return l.search(s).then(o=>(i.length&&w(i),c.dispose(),o),o=>(i.length&&w(i),c.dispose(),Promise.reject(o)))}}e.$Phc=L}),define(Ae[288],Me([1,0,18,256,34,94,28,12,19,24,13,16,2,93,181,47,14,48,105,284,44]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6K=e.$5K=void 0;let u=class{constructor(p,y,T,N,J){this.a=p,this.b=y,this.c=T,this.d=N,this.e=J}text(p,y,T={}){p=this.f(p,T);const N=this.a.getValue(),J=y&&y.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(y?.map(s.$qi),T),type:2,contentPattern:p,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:N.search.usePCRE2||J||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}f(p,y){const T=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const N={...p,wordSeparators:T.editor.wordSeparators};return this.j(p,y)&&(N.isCaseSensitive=!0),this.k(p)&&(N.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),N}file(p,y={}){return{...this.h(p,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(p,y){return p?(p=Array.isArray(p)?p.map(E):E(p),y?this.parseSearchPaths(p):{pattern:d(...Array.isArray(p)?p:[p])}):{}}h(p=[],y={}){const T=this.g(y.includePattern,y.expandPatterns),N=this.g(y.excludePattern,y.expandPatterns),J=p.length>1,q=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(F=>this.q(F,y,N)):p.map(F=>this.r(F,y,N,J))).filter(F=>!!F),U={_reason:y._reason,folderQueries:q,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:N.pattern,includePattern:T.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const F=S.$Hb(S.$Rb(this.c.groups.map(ce=>ce.editors.map(we=>we.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const W=F.filter(ce=>(0,a.$SJ)(U,ce.fsPath)),re=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(re)),{...U,...re}}const C=y.extraFileResources&&y.extraFileResources.filter(F=>(0,a.$SJ)(U,F.fsPath));return U.extraFileResources=C&&C.length?C:void 0,U}i(p){const y=[],T=new R.$Ac,N={};let J=!1;return p.forEach(q=>{if(q.scheme===m.Schemas.walkThrough)return;if((0,D.$Mg)(q)){const C=this.b.getWorkspaceFolder(q)?.uri??q.with({path:f.$mc(q.fsPath)});let F=T.get(C);F||(J=!0,F={folder:C,includePattern:{}},y.push(F),T.set(C,F));const W=f.$lc(C.fsPath,q.fsPath);(0,k.$Uf)(F.includePattern)[W.replace(/\\/g,"/")]=!0}else q.fsPath&&(J=!0,N[q.fsPath]=!0)}),{folderQueries:y,includePattern:N,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}j(p,y){if(y.isSmartCase){if(p.isRegExp){if(L.$Af(p.pattern,!0))return!0}else if(L.$Af(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,$.$6B)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const y=re=>f.$ic(re)||/^\.\.?([\/\\]|$)/.test(re),N=(Array.isArray(p)?p:n(p)).map(re=>{const ce=this.e.resolvedUserHome;return ce?(0,A.$1v)(re,ce.scheme===m.Schemas.file?ce.fsPath:ce.path):re}),J=M.$K(N,re=>y(re)?"searchPaths":"exprSegments"),q=(J.exprSegments||[]).map(re=>L.$Ve(re,"/")).map(re=>L.$Ve(re,"\\")).map(re=>(re[0]==="."&&(re="*"+re),b(re))),U={},C=this.m(J.searchPaths||[]);C&&C.length&&(U.searchPaths=C);const F=S.$Rb(q),W=d(...F);return W&&(U.pattern=W),U}l(p,y){return y.disregardExcludeSettings?void 0:(0,a.$RJ)(p,!y.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const y=p.flatMap(N=>{let{pathPortion:J,globPortion:q}=t(N);return q&&(q=h(q)),this.n(J).flatMap(C=>this.o(C,q))}),T=new Map;return y.forEach(N=>{const J=N.searchPath.toString(),q=T.get(J);q?N.pattern&&(q.pattern=q.pattern||{},q.pattern[N.pattern]=!0):T.set(J,{searchPath:N.searchPath,pattern:N.pattern?d(N.pattern):void 0})}),Array.from(T.values())}n(p){if(f.$ic(p)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==m.Schemas.file?[{searchPath:y[0].uri.with({path:p})}]:[{searchPath:l.URI.file(f.$hc(p))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(p=E(p),p.startsWith("../")||p===".."){const N=f.$gc.resolve(y.path,p);return[{searchPath:y.with({path:N})}]}const T=h(p);return[{searchPath:y,pattern:T}]}else{if(p==="./"||p===".\\")return[];{const y=p.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(J=>{const q=y.match(new RegExp(`^${L.$Pe(J.name)}(?:/(.*)|$)`));return q?{match:q,folder:J}:null}).filter(k.$Rf);if(N.length)return N.map(J=>{const q=J.match[1];return{searchPath:J.folder.uri,pattern:q&&h(q)}});{const J=p.match(/\.[\/\\](.+)[\/\\]?/),q=J?J[1]:p,U=w.localize(0,null,q);throw new Error(U)}}}}o(p,y){const T=p.pattern&&y?`${p.pattern}/${y}`:p.pattern||y,N=[{searchPath:p.searchPath,pattern:T}];return T&&!T.endsWith("**")&&N.push({searchPath:p.searchPath,pattern:T+"/**"}),N}q(p,y,T){const N=this.r((0,s.$qi)(p.searchPath),y,T,!1);return N?{...N,includePattern:p.pattern}:null}r(p,y,T,N){let J;const q=l.URI.isUri(p)?p:p.uri;if(T.searchPaths){const re=T.searchPaths.filter(ce=>(0,D.$Bg)(ce.searchPath,q))[0];if(re&&!re.pattern)return null;re&&(J=re.pattern)}const U=this.a.getValue({resource:q}),F={...this.l(U,y)||{},...J||{}},W=l.URI.isUri(p)?(0,D.$Fg)(p):p.name;return{folder:q,folderName:N?W:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!U.search.followSymlinks}}};e.$5K=u,e.$5K=u=Je([qe(0,r.$Bi),qe(1,s.$ei),qe(2,i.$aD),qe(3,c.$pj),qe(4,o.$3K)],u);function t(g){const p=g.match(/[\*\{\}\(\)\[\]\?]/);if(p){const y=p.index,T=g.substr(0,y).match(/[/|\\][^/\\]*$/);if(T){let N=g.substr(0,T.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:g.substr((T.index||0)+1)}}}return{pathPortion:g}}function d(...g){return g.length?g.reduce((p,y)=>(p[y]=!0,p),Object.create(null)):void 0}function n(g){return I.$Mj(g,",").map(p=>p.trim()).filter(p=>!!p.length)}function b(g){return[`**/${g}/**`,`**/${g}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function E(g){return g.replace(/\\/g,"/")}function h(g){return E(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(g){return g.replace(/([?*[\]])/g,"[$1]")}function P(g,p){g=S.$Mb(g,N=>N.toString());const y=[],T=p.getWorkspace();return g&&g.forEach(N=>{let J;if(p.getWorkbenchState()===2)J=(0,D.$Kg)(T.folders[0].uri,N),J&&J!=="."&&(J="./"+J);else{const q=p.getWorkspaceFolder(N);if(q){const U=q.name;if(T.folders.filter(F=>F.name===U).length===1){const F=(0,D.$Kg)(q.uri,N);F===""?J=`./${q.name}`:J=`./${q.name}/${F}`}else J=N.fsPath}}J&&y.push(v(J))}),y}e.$6K=P}),define(Ae[289],Me([1,0,24,2,21,15,4,288,44,48,11]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xtb=e.$wtb=void 0;const k=7e3;function l(c,s){const i=s.activationEvents;if(!i)return Promise.resolve(void 0);const o=[],a=[];for(const E of i)if(/^workspaceContains:/.test(E)){const h=E.substr(18);h.indexOf("*")>=0||h.indexOf("?")>=0||c.forceUsingSearch?a.push(h):o.push(h)}if(o.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:u,resolve:t}=(0,L.$1g)(),d=E=>t({activationEvent:E}),n=Promise.all(o.map(E=>$(c,E,d))).then(()=>{}),b=w(c,s.identifier,a,d);return Promise.all([n,b]).then(()=>{t(void 0)}),u}e.$wtb=l;async function $(c,s,i){for(const o of c.folders)if(await c.exists(S.$Ig(M.URI.revive(o),s))){i(`workspaceContains:${s}`);return}}async function w(c,s,i,o){if(i.length===0)return Promise.resolve(void 0);const a=new I.$7d,u=c.checkExists(c.folders,i,a.token),t=setTimeout(async()=>{a.cancel(),c.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},k);let d=!1;try{d=await u}catch(n){A.$4(n)||A.$1(n)}a.dispose(),clearTimeout(t),d&&o(`workspaceContains:${i.join(",")}`)}function r(c,s,i,o){const a=c.get(R.$7h),u=c.get(f.$JJ),d=a.createInstance(m.$5K).file(s.map(n=>(0,D.$qi)(M.URI.revive(n))),{_reason:"checkExists",includePattern:i,exists:!0});return u.fileSearch(d,o).then(n=>!!n.limitHit,n=>A.$4(n)?!1:Promise.reject(n))}e.$xtb=r}),define(Ae[38],Me([1,0,161,19,87,24,11,6,51,2,14,3,37,219,82,36,25,106,15,22,23,202,7,100,4,27,84,17,71,85,65,5,289,81,204,12,79,63,20,80]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o,a,u,t,d,n,b,E,h,v,P,g,p,y,T,N,J,q,U,C,F){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=e.$thc=e.$shc=e.$rhc=void 0,e.$rhc=(0,n.$8h)("IHostUtils");let re=W=class extends m.$Tc{constructor(X,V,ie,Ce,Te,Pe,be,me,G,_,le,de){super(),this.X=de,this.a=this.B(new p.$Wd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ie,this.f=be,this.j=Ce,this.m=Te,this.s=Pe,this.t=G,this.u=_,this.w=le,this.y=this.g.getProxy(k.$oL.MainThreadWorkspace),this.z=this.g.getProxy(k.$oL.MainThreadTelemetry),this.C=this.g.getProxy(k.$oL.MainThreadExtensionService),this.D=new R.$7g,this.F=new R.$7g,this.G=new R.$7g,this.H=new R.$7g,this.I=new $e(this.f.extensions.activationEvents),this.L=new s.$w8b(this.I,this.f.extensions.allExtensions);const Le=new o.$om(this.f.extensions.myExtensions);this.J=new s.$w8b(this.I,ve(this.L,Le)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${De(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${De(this.J)}`)),this.M=new w.$chc(this.g,this.s),this.N=new T.$khc(this.g),this.O=me,this.h=X.createChild(new v.$6h([w.$dhc,this.M],[T.$lhc,this.N])),this.P=this.B(new $.$bhc(this.J,this.L,{onExtensionActivationError:(ge,ke,Ie)=>{this.C.$onExtensionActivationError(ge,i.$3(ke),Ie)},actualActivateExtension:async(ge,ke)=>{if(s.$w8b.isHostExtension(ge,this.J,this.L))return await this.C.$activateExtension(ge,ke),new $.$ahc;const Ie=this.J.getExtensionDescription(ge);return this.db(Ie,ke)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(X){i.$1(X)}}async Y(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(Te=>Te.identifier).filter(Te=>this.isActivated(Te)).map(Te=>this.cb(Te))}catch{}await Promise.all(X)}terminate(X,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Ce=>{this.s.error(Ce)}),this.g.dispose();const ie=this.Y();Promise.race([(0,R.$9g)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const V=await this.C.$getExtension(X);return V&&{...V,identifier:new o.$nm(V.identifier.value),extensionLocation:D.URI.revive(V.extensionLocation)}}Z(X,V){return this.P.activateByEvent(X,V)}$(X,V){return this.P.activateById(X,V)}activateByIdWithErrors(X,V){return this.$(X,V).then(()=>{const ie=this.P.getActivatedExtension(X);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async ab(X){if(X.scheme===J.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(X.fsPath);return D.URI.file(V)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(X=>new se(X))),this.Q}async bb(X){const V=f.$bi.forUris(ie=>A.$zg.ignorePathCasing(ie));return await Promise.all(X.map(async ie=>{if(this.ub(ie)){const Ce=await this.ab(ie.extensionLocation);V.set(Ce,ie)}})),V}cb(X){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return V;const ie=this.P.getActivatedExtension(X);if(!ie)return V;try{typeof ie.module.deactivate=="function"&&(V=Promise.resolve(ie.module.deactivate()).then(void 0,Ce=>(this.s.error(Ce),Promise.resolve(void 0))))}catch(Ce){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(Ce)}try{(0,m.$Oc)(ie.subscriptions)}catch(Ce){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(Ce)}return V}async db(X,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.fb(X,V).then(ie=>{const Ce=ie.activationTimes;return this.C.$onDidActivateExtension(X.identifier,Ce.codeLoadingTime,Ce.activateCallTime,Ce.activateResolvedTime,V),this.eb(X,V,"success",Ce),ie},ie=>{throw this.eb(X,V,"failure"),ie})}eb(X,V,ie,Ce){const Te=we(X,V);this.z.$publicLog2("extensionActivationTimes",{...Te,...Ce||{},outcome:ie})}fb(X,V){const ie=we(X,V);this.z.$publicLog2("activatePlugin",ie);const Ce=this.ub(X);if(!Ce)return Promise.resolve(new $.$_gc($.$9gc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${X.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Te=new $.$0gc(V.startup);return Promise.all([this.vb(X,(0,A.$Ig)(X.extensionLocation,Ce),Te),this.gb(X)]).then(Pe=>(I.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),W.hb(this.s,X.identifier,Pe[0],Pe[1],Te))).then(Pe=>(I.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),Pe))}gb(X){const V=new u.$fhc(X,this.M),ie=new u.$ehc(X.identifier.value,!1,this.M),Ce=new N.$mhc(X,this.N),Te=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Pe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([V.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const be=this;let me,G;const _=(0,c.$KF)(X,"ipc")?this.f.messagePorts?.get(o.$nm.toKey(X.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ie,secrets:Ce,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(le){return M.$jc(X.extensionLocation.fsPath,le)},get storagePath(){return be.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return be.O.globalValue(X).fsPath},get logPath(){return M.$jc(be.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return D.URI.joinPath(be.f.logsLocation,X.identifier.value)},get storageUri(){return be.O.workspaceValue(X)},get globalStorageUri(){return be.O.globalValue(X)},get extensionMode(){return Te},get extension(){return me===void 0&&(me=new he(be,X.identifier,X,Pe,!1)),me},get extensionRuntime(){return(0,c.$LF)(X,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!G){if(!_)return;const le=p.Event.buffer(p.Event.fromDOMEventEmitter(_,"message",de=>de.data));_.start(),G={onDidReceiveMessage:le,postMessage:_.postMessage.bind(_)}}return G}})})}static hb(X,V,ie,Ce,Te){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(X,V,ie,Ce,Te).then(Pe=>new $.$$gc(!1,null,Te.build(),ie,Pe,Ce.subscriptions))}static ib(X,V,ie,Ce,Te){if(typeof ie.activate=="function")try{Te.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Pe=typeof global=="object"?global:self,be=ie.activate.apply(Pe,[Ce]);return Te.activateCallStop(),Te.activateResolveStart(),Promise.resolve(be).then(me=>(Te.activateResolveStop(),me))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(ie)}jb(X,V){this.$(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:V}).then(void 0,ie=>{this.s.error(ie)})}kb(X,V=0){const Ce=Date.now();(0,C.$B)(()=>{for(let Te=V;Te<X.length;Te+=1){const Pe=X[Te];for(const be of Pe.activationEvents??[])if(be==="onStartupFinished")if(Date.now()-Ce>50){this.kb(X,Te);break}else this.jb(Pe,be)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(X=>{const V=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(V)this.kb(ie);else for(const Ce of ie)if(Ce.activationEvents)for(const Te of Ce.activationEvents)Te==="onStartupFinished"&&this.jb(Ce,Te)})}mb(){const X=this.Z("*",!0).then(void 0,Pe=>{this.s.error(Pe)});this.B(this.j.onDidChangeWorkspace(Pe=>this.nb(Pe.added)));const V=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(V),Ce=this.pb(),Te=Promise.all([Ce,X,ie]).then(()=>{});return Promise.race([Te,(0,R.$9g)(1e4)]).then(()=>{this.lb()}),Te}nb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(X,V))).then(()=>{})}async ob(X,V){if(this.isActivated(V.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,Ce={logService:this.s,folders:X.map(Pe=>Pe.uri),forceUsingSearch:ie||!this.c.fsExists,exists:Pe=>this.c.fsExists(Pe.fsPath),checkExists:(Pe,be,me)=>this.y.$checkExists(Pe,be,me)},Te=await(0,y.$wtb)(Ce,V);if(Te)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Te.activationEvent}).then(void 0,Pe=>this.s.error(Pe))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(X){throw console.error(X),X}}async qb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:V}=this.f.environment;if(!X||!V)throw new Error(S.localize(0,null));const ie=await this.vb(null,V,new $.$0gc(!1));if(!ie||typeof ie.run!="function")throw new Error(S.localize(1,null,V.toString()));return new Promise((Ce,Te)=>{const Pe=(G,_)=>{G?(C.$t&&this.s.error("Test runner called back with error",G),Te(G)):(C.$t&&(_?this.s.info(`Test runner called back with ${_} failures.`):this.s.info("Test runner called back with successful outcome.")),Ce(typeof _=="number"&&_>0?1:0))},be=(0,A.$wg)(V),me=ie.run(be,Pe);me&&me.then&&me.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Ce(0)}).catch(G=>{C.$t&&this.s.error("Test runner finished with error",G),Te(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$9g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,V){return this.R[X]=V,(0,m.$Rc)(()=>{delete this.R[X]})}async getRemoteExecServer(X){const{resolver:V}=await this.sb(X);return V?.resolveExecServer?.(X,{resolveAttempt:0})}async sb(X){const V=X.indexOf("+");if(V===-1)throw new t.$wL("Not an authority that can be resolved!",d.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=X.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(X,V){const ie=U.$Sd.create(!1),Ce=()=>`[resolveAuthority(${(0,d.$bl)(X)},${V})][${ie.elapsed()}ms] `,Te=K=>this.s.info(`${Ce()}${K}`),Pe=K=>this.s.warn(`${Ce()}${K}`),be=(K,j=void 0)=>this.s.error(`${Ce()}${K}`,j),me=K=>{if(K instanceof t.$wL)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K},G=async K=>{Te(`activating resolver for ${K}...`);const{resolver:j,authorityPrefix:H}=await this.sb(K);if(!j)throw be(`no resolver for ${H}`),new t.$wL(`No remote extension installed to resolve ${H}.`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:j,authorityPrefix:H,remoteAuthority:K}},_=X.split(/@|%40/g).reverse();Te(`activating remote resolvers ${_.join(" -> ")}`);let le;try{le=await Promise.all(_.map(G)).catch(async K=>{if(!(K instanceof t.$wL)||K._code!==d.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw K;return Pe(`resolving nested authorities failed: ${K.message}`),[await G(X)]})}catch(K){return me(K)}const de=new R.$gh;de.cancelAndSet(()=>Te("waiting..."),1e3);let Le,ge;for(const[K,{authorityPrefix:j,resolver:H,remoteAuthority:Q}]of le.entries())try{if(K===le.length-1)Te("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${j}`),Le=await H.resolve(Q,{resolveAttempt:V,execServer:ge}),I.mark(`code/extHost/didResolveAuthorityOK/${j}`),Te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$vL.isManagedResolvedAuthority(Le)?Le:void 0));else{if(Te(`invoking resolveExecServer() for ${Q}`),I.mark(`code/extHost/willResolveExecServer/${j}`),ge=await H.resolveExecServer?.(Q,{resolveAttempt:V,execServer:ge}),!ge)throw new t.$wL(`Exec server was not available for ${Q}`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${j}`)}}catch(oe){return I.mark(`code/extHost/didResolveAuthorityError/${j}`),be("returned an error",oe),de.dispose(),me(oe)}de.dispose();const ke={environmentTunnels:Le.environmentTunnels,features:Le.tunnelFeatures?{elevation:Le.tunnelFeatures.elevation,privacyOptions:Le.tunnelFeatures.privacyOptions,protocol:Le.tunnelFeatures.protocol===void 0?!0:Le.tunnelFeatures.protocol}:void 0},Ie={extensionHostEnv:Le.extensionHostEnv,isTrusted:Le.isTrusted,authenticationSession:Le.authenticationSessionForInitializingExtensions?{id:Le.authenticationSessionForInitializingExtensions.id,providerId:Le.authenticationSessionForInitializingExtensions.providerId}:void 0};Te(`returned ${t.$vL.isManagedResolvedAuthority(Le)?"managed authority":`${Le.host}:${Le.port}`}`);let O;if(t.$vL.isManagedResolvedAuthority(Le)){const K=V;this.X.setFactory(K,Le.makeConnection),O={authority:X,connectTo:new d.$$k(K),connectionToken:Le.connectionToken}}else O={authority:X,connectTo:new d.$_k(Le.host,Le.port),connectionToken:Le.connectionToken};return{type:"ok",value:{authority:O,options:Ie,tunnelInformation:ke}}}async $getCanonicalURI(X,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,d.$bl)(X)})`);const{resolver:ie}=await this.sb(X);if(!ie)return null;const Ce=D.URI.revive(V);if(typeof ie.getCanonicalURI>"u")return Ce;const Te=await(0,R.$Zg)(()=>ie.getCanonicalURI(Ce));return Te||Ce}$startExtensionHost(X){X.toAdd.forEach(Ce=>Ce.extensionLocation=D.URI.revive(Ce.extensionLocation));const{globalRegistry:V,myExtensions:ie}=ce(this.I,this.L,this.J,X);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ie),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${De(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${De(this.J)}`)),this.rb()}$activateByEvent(X,V){return V===1?this.D.wait().then(ie=>this.Z(X,!1)):this.G.wait().then(ie=>this.Z(X,!1))}async $activate(X,V){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.$(X,V),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(Pe=>Pe.extensionLocation=D.URI.revive(Pe.extensionLocation));const{globalRegistry:V,myExtensions:ie}=ce(this.I,this.L,this.J,X),Ce=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ie),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${De(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${De(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const V=a.$ke.alloc(X),ie=Math.random()%256;for(let Ce=0;Ce<X;Ce++)V.writeUInt8(ie,Ce);return V}async $updateRemoteConnectionData(X){this.W=X,this.a.fire()}};e.$shc=re,e.$shc=re=W=Je([qe(0,n.$7h),qe(1,e.$rhc),qe(2,h.$AN),qe(3,r.$Rgc),qe(4,l.$Ugc),qe(5,L.$pj),qe(6,b.$QN),qe(7,E.$Xgc),qe(8,P.$zzb),qe(9,g.$ghc),qe(10,q.$ohc),qe(11,F.$phc)],re);function ce(te,X,V,ie){te.addActivationEvents(ie.addActivationEvents);const Ce=new s.$w8b(te,X.getAllExtensionDescriptions());Ce.deltaExtensions(ie.toAdd,ie.toRemove);const Te=new o.$om(V.getAllExtensionDescriptions().map(be=>be.identifier));for(const be of ie.myToRemove)Te.delete(be);for(const be of ie.myToAdd)Te.add(be);const Pe=ve(Ce,Te);return{globalRegistry:Ce,myExtensions:Pe}}function we(te,X){return{id:te.identifier.value,name:te.name,extensionVersion:te.version,publisherDisplayName:te.publisher,activationEvents:te.activationEvents?te.activationEvents.join(","):null,isBuiltin:te.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function De(te){return te.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$thc=(0,n.$8h)("IExtHostExtensionService");class he{#e;#t;#i;constructor(X,V,ie,Ce,Te){this.#e=X,this.#t=V,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=M.$hc((0,A.$wg)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=Ce,this.isFromDifferentExtensionHost=Te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$uhc=he;function ve(te,X){return te.getAllExtensionDescriptions().filter(V=>X.has(V.identifier))}class se{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$vhc=se;class $e{constructor(X){this.a=new o.$pm,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const V of Object.keys(X))this.a.set(V,X[V])}}}),define(Ae[290],Me([1,0,87,2,3,37,25,22,17,27,4,38,14,13]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;let r=class{constructor(a,u,t,d,n,b,E){this.c=a,this.d=u,this.e=t,this.f=d,this.g=n,this.h=b,this.i=E,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new s(this.c,u,this.d,a,this.i)),this.register(this.e.createInstance(c)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,u,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const u of a.nodeModuleName)this.a.set(u,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(u=>a.alternativeModuleName(u))}};e.$Dic=r,e.$Dic=r=Je([qe(2,L.$7h),qe(3,A.$Ugc),qe(4,k.$thc),qe(5,D.$QN),qe(6,l.$pj)],r);let c=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&w.a.size){const u=(0,$.$Pe)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",d=`@${t}+\\/${t}+|${t}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${n}\\/)(${d})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const u=this.b.exec(this.c(a));if(!u)return;const[,t,d,n]=u,b=w.a.get(d);if(b!==void 0)return console.warn(`${d} as been renamed to ${b}, please update your imports`),t+b+n}c(a){return a.replace(/\\/g,"/")}};c=w=Je([qe(0,D.$QN)],c);class s{constructor(a,u,t,d,n){this.c=a,this.d=u,this.e=t,this.f=d,this.g=n,this.nodeModuleName="vscode",this.a=new m.$pm}load(a,u){const t=this.d.findSubstr(u);if(t){let d=this.a.get(t.identifier);return d||(d=this.c(t,this.e,this.f),this.a.set(t.identifier,d)),d}if(!this.b){let d="";this.d.forEach((n,b)=>d+=`	${b} -> ${n.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${d}`),this.b=this.c(R.$FF,this.e,this.f)}return this.b}}let i=class{constructor(a,u,t){this.e=a,this.f=u,this.nodeModuleName=["open","opn"],this.d=t.getProxy(I.$oL.MainThreadTelemetry);const d=t.getProxy(I.$oL.MainThreadWindow);this.c=(n,b)=>{const E=M.URI.parse(n);return b?this.g(n,b):E.scheme==="http"||E.scheme==="https"?d.$openUri(E,n,{allowTunneling:!0}):E.scheme==="mailto"||E.scheme===this.f?d.$openUri(E,n,{}):this.g(n,b)}}load(a,u,t){const d=this.e.findSubstr(u);return d&&(this.a=d.identifier.value,this.h()),this.b=t(a),this.c}g(a,u){return this.i(),this.b(a,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([qe(2,f.$AN)],i)}),define(Ae[117],Me([1,0,39,6,19,73,4,66,64,38,7,36,216,37]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=void 0,e.$whc=(0,R.$8h)("IExtHostVariableResolverProvider");class w extends l.$BO{constructor(s,i,o,a,u,t,d){function n(){if(o){const b=o.activeEditor();if(b)return b.document.uri;const E=a.tabGroups.all.find(h=>h.isActive)?.activeTab;if(E!==void 0){if(E.input instanceof L.$$M||E.input instanceof L.$dN)return E.input.modified;if(E.input instanceof L.$0M||E.input instanceof L.$cN||E.input instanceof L.$aN)return E.input.uri}}}super({getFolderUri:b=>{const E=t.folders.filter(h=>h.name===b);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(b,E)=>u.getConfiguration(void 0,b).get(E),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const b=n();if(b)return I.$hc(b.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const b=n();if(b){const E=i.getWorkspaceFolder(b);if(E)return I.$hc(E.uri.fsPath)}}},getSelectedText:()=>{if(o){const b=o.activeEditor();if(b&&!b.selection.isEmpty)return b.document.getText(b.selection)}},getLineNumber:()=>{if(o){const b=o.activeEditor();if(b)return String(b.selection.end.line+1)}},getExtension:b=>s.getExtension(b)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(A.env))}}let r=class extends M.$Tc{constructor(s,i,o,a,u){super(),this.b=s,this.c=i,this.g=o,this.h=a,this.j=u,this.a=new S.$V(async()=>{const t=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async b=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,t,n,this.m())})}getResolver(){return this.a.value}m(){}};e.$xhc=r,e.$xhc=r=Je([qe(0,D.$thc),qe(1,k.$Rgc),qe(2,m.$LN),qe(3,$.$Ugc),qe(4,f.$7gc)],r)}),define(Ae[118],Me([1,0,11,5,2,22,4,3,64,38,17,7,36,208,210,37,117,6,40,31]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=e.$Bhc=e.$Ahc=e.$zhc=e.$yhc=void 0,e.$yhc=(0,R.$8h)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q?.api}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.w.value}constructor(h,v,P,g,p,y,T){this.I=v,this.J=P,this.K=g,this.L=p,this.M=y,this.N=T,this.l=new Map,this.E=new Map,this.G=new Map,this.H=0,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new M.$Wd,this.n=new M.$Wd,this.o=new M.$Wd,this.u=new M.$Wd,this.k=h.getProxy(m.$oL.MainThreadDebugService),this.z=new M.$Wd,this.B=new M.$Wd,this.w=new t(this.k),this.y=new Map,this.J.getExtensionRegistry().then(N=>{N.onDidChange(J=>{this.O(N)}),this.O(N)})}asDebugSourceUri(h,v){const P=h;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let g=`debug:${encodeURIComponent(P.path||"")}`,p="?";return v&&(g+=`${p}session=${encodeURIComponent(v.id)}`,p="&"),g+=`${p}ref=${P.sourceReference}`,I.URI.parse(g)}else{if(P.path)return I.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}O(h){const v=[];for(const P of h.getAllExtensionDescriptions())if(P.contributes){const g=P.contributes.debuggers;if(g&&g.length>0)for(const p of g)(0,w.$hG)(p)&&v.push(p.type)}this.k.$registerDebugTypes(v)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){const h=[];return this.y.forEach(v=>h.push(v)),h}async $resolveDebugVisualizer(h,v){const P=this.G.get(h);if(!P)throw new Error(`No debug visualizer found with id '${h}'`);let{v:g,provider:p}=P;if(g.visualization||(g=await p.resolveDebugVisualization?.(g,v)||g,P.v=g),!g.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${p}'`);return this.db(g.visualization)}async $executeDebugVisualizerCommand(h){const v=this.G.get(h);if(!v)throw new Error(`No debug visualizer found with id '${h}'`);const P=v.v.visualization;P&&"command"in P&&this.N.executeCommand(P.command,...P.arguments||[])}async $provideDebugVisualizers(h,v,P,g){const p=this.l.get(P.sessionId),y=this.cb(h,v),T=this.E.get(y);if(!p||!T)return[];const N=await T.provideDebugVisualization({session:p.api,variable:P.variable,containerId:P.containerId,frameId:P.frameId,threadId:P.threadId},g);return N?N.map(J=>{const q=++this.H;this.G.set(q,{v:J,provider:T});const U=J.iconPath?this.eb(J.iconPath):void 0;return{id:q,name:J.name,iconClass:U?.iconClass,iconPath:U?.iconPath,visualization:this.db(J.visualization)}}):[]}$disposeDebugVisualizers(h){for(const v of h)this.G.delete(v)}registerDebugVisualizationProvider(h,v,P){if(!h.contributes?.debugVisualizers?.some(y=>y.id===v))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${v})`);const g=A.$nm.toKey(h.identifier),p=this.cb(g,v);if(this.E.has(p))throw new Error(`A debug visualization provider with id '${v}' is already registered`);return this.E.set(p,P),this.k.$registerDebugVisualizer(g,v),(0,s.$Rc)(()=>{this.k.$unregisterDebugVisualizer(g,v),this.E.delete(v)})}addBreakpoints(h){const v=h.filter(p=>{const y=p.id;return this.y.has(y)?!1:(this.y.set(y,p),!0)});this.$(v,[],[]);const P=[],g=new Map;for(const p of v)if(p instanceof k.$qM){let y=g.get(p.location.uri.toString());y||(y={type:"sourceMulti",uri:p.location.uri,lines:[]},g.set(p.location.uri.toString(),y),P.push(y)),y.lines.push({id:p.id,enabled:p.enabled,condition:p.condition,hitCondition:p.hitCondition,logMessage:p.logMessage,line:p.location.range.start.line,character:p.location.range.start.character})}else p instanceof k.$rM&&P.push({type:"function",id:p.id,enabled:p.enabled,hitCondition:p.hitCondition,logMessage:p.logMessage,condition:p.condition,functionName:p.functionName});return this.k.$registerBreakpoints(P)}removeBreakpoints(h){const v=h.filter(y=>this.y.delete(y.id));this.$([],v,[]);const P=v.filter(y=>y instanceof k.$qM).map(y=>y.id),g=v.filter(y=>y instanceof k.$rM).map(y=>y.id),p=v.filter(y=>y instanceof k.$sM).map(y=>y.id);return this.k.$unregisterBreakpoints(P,g,p)}startDebugging(h,v,P){return this.k.$startDebugging(h?h.uri:void 0,v,{parentSessionID:P.parentSession?P.parentSession.id:void 0,lifecycleManagedByParent:P.lifecycleManagedByParent,repl:P.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact,suppressSaveBeforeStart:P.suppressSaveBeforeStart,suppressDebugStatusbar:P.suppressDebugStatusbar??P.debugUI?.simple,suppressDebugToolbar:P.suppressDebugToolbar??P.debugUI?.simple,suppressDebugView:P.suppressDebugView??P.debugUI?.simple})}stopDebugging(h){return this.k.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,v,P){if(!v)return new k.$qL(()=>{});const g=this.d++;return this.f.push({type:h,handle:g,provider:v}),this.k.$registerDebugConfigurationProvider(h,P,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,g),new k.$qL(()=>{this.f=this.f.filter(p=>p.provider!==v),this.k.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(h,v,P){if(!P)return new k.$qL(()=>{});if(!this.W(h,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.S(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this.g++;return this.h.push({type:v,handle:g,factory:P}),this.k.$registerDebugAdapterDescriptorFactory(v,g),new k.$qL(()=>{this.h=this.h.filter(p=>p.factory!==P),this.k.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(h,v){if(!v)return new k.$qL(()=>{});const P=this.i++;return this.j.push({type:h,handle:P,factory:v}),new k.$qL(()=>{this.j=this.j.filter(g=>g.factory!==v)})}async $runInTerminal(h,v){return Promise.resolve(void 0)}async $substituteVariables(h,v){let P;const g=await this.bb(h);return g&&(P={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.M.getResolver()).resolveAnyAsync(P,v)}P(h,v){if(h.type==="implementation")return new n(h.implementation)}Q(){}async $startDASession(h,v){const P=this,g=await this.ab(v);return this.Y(this.S(g.type),g).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const y=this.R(p),T=this.P(y,g);if(!T)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const N=T;return this.C.set(h,N),this.X(g).then(J=>(J&&this.D.set(h,J),N.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const U=q,C={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this.F||(this.F=this.Q());try{if(this.F){const F=await this.F.sign(U.arguments.value);C.body={signature:F},N.sendResponse(C)}else throw new Error("no signer")}catch(F){C.success=!1,C.message=F.message,N.sendResponse(C)}}else J&&J.onDidSendMessage&&J.onDidSendMessage(q),q=(0,w.$mG)(q,!0),P.k.$acceptDAMessage(h,q)}),N.onError(q=>{J&&J.onError&&J.onError(q),this.k.$acceptDAError(h,q.name,q.message,q.stack)}),N.onExit(q=>{J&&J.onExit&&J.onExit(q??void 0,void 0),this.k.$acceptDAExit(h,q??void 0,void 0)}),J&&J.onWillStartSession&&J.onWillStartSession(),N.startSession()))})}$sendDAMessage(h,v){v=(0,w.$lG)(v,!1);const P=this.D.get(h);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(v),this.C.get(h)?.sendMessage(v)}$stopDASession(h){const v=this.D.get(h);this.D.delete(h),v&&v.onWillStopSession&&v.onWillStopSession();const P=this.C.get(h);return this.C.delete(h),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const v=[],P=[],g=[];if(h.added)for(const p of h.added){const y=p.id;if(y&&!this.y.has(y)){let T;if(p.type==="function")T=new k.$rM(p.functionName,p.enabled,p.condition,p.hitCondition,p.logMessage);else if(p.type==="data")T=new k.$sM(p.label,p.dataId,p.canPersist,p.enabled,p.hitCondition,p.condition,p.logMessage);else{const N=I.URI.revive(p.uri);T=new k.$qM(new k.$CL(N,new k.$rL(p.line,p.character)),p.enabled,p.condition,p.hitCondition,p.logMessage)}(0,k.$oM)(T,y),this.y.set(y,T),v.push(T)}}if(h.removed)for(const p of h.removed){const y=this.y.get(p);y&&(this.y.delete(p),P.push(y))}if(h.changed){for(const p of h.changed)if(p.id){const y=this.y.get(p.id);if(y){if(y instanceof k.$rM&&p.type==="function"){const T=y;T.enabled=p.enabled,T.condition=p.condition,T.hitCondition=p.hitCondition,T.logMessage=p.logMessage,T.functionName=p.functionName}else if(y instanceof k.$qM&&p.type==="source"){const T=y;T.enabled=p.enabled,T.condition=p.condition,T.hitCondition=p.hitCondition,T.logMessage=p.logMessage,T.location=new k.$CL(I.URI.revive(p.uri),new k.$rL(p.line,p.character))}g.push(y)}}}this.$(v,P,g)}async $acceptStackFrameFocus(h){let v;const P=h.sessionId?await this.ab(h.sessionId):void 0;if(!P)throw new Error("no DebugSession found for debug focus context");h.kind==="thread"?v=new k.$yM(P.api,h.threadId):v=new k.$xM(P.api,h.threadId,h.frameId),this.A=v,this.B.fire(this.A)}$provideDebugConfigurations(h,v,P){return(0,S.$Zg)(async()=>{const g=this.V(h);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const p=await this.bb(v);return g.provideDebugConfigurations(p,P)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(h,v,P,g){return(0,S.$Zg)(async()=>{const p=this.V(h);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.bb(v);return p.resolveDebugConfiguration(y,P,g)})}$resolveDebugConfigurationWithSubstitutedVariables(h,v,P,g){return(0,S.$Zg)(async()=>{const p=this.V(h);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.bb(v);return p.resolveDebugConfigurationWithSubstitutedVariables(y,P,g)})}async $provideDebugAdapter(h,v){const P=this.U(h);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.ab(v);return this.Y(P,g).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.R(p)})}async $acceptDebugSessionStarted(h){const v=await this.ab(h);this.m.fire(v.api)}async $acceptDebugSessionTerminated(h){const v=await this.ab(h);v&&(this.n.fire(v.api),this.l.delete(v.id))}async $acceptDebugSessionActiveChanged(h){this.q=h?await this.ab(h):void 0,this.o.fire(this.q?.api)}async $acceptDebugSessionNameChanged(h,v){(await this.ab(h))?._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(h,v){const g={session:(await this.ab(h)).api,event:v.event,body:v.body};this.u.fire(g)}R(h){if(h instanceof k.$tM)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof k.$uM)return{type:"server",port:h.port,host:h.host};if(h instanceof k.$vM)return{type:"pipeServer",path:h.path};if(h instanceof k.$wM)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}S(h){const v=this.h.filter(P=>P.type===h);if(v.length>0)return v[0].factory}U(h){const v=this.h.filter(P=>P.handle===h);if(v.length>0)return v[0].factory}V(h){const v=this.f.filter(P=>P.handle===h);if(v.length>0)return v[0].provider}W(h,v){if(h.contributes){const P=h.contributes.debuggers;if(P&&P.length>0){for(const g of P)if(g.label&&g.type&&g.type===v)return!0}}return!1}X(h){const P=h.configuration.type,g=this.j.filter(p=>p.type===P||p.type==="*").map(p=>(0,S.$Zg)(()=>p.factory.createDebugAdapterTracker(h.api)).then(y=>y,y=>null));return Promise.race([Promise.all(g).then(p=>{const y=p.filter(T=>!!T);if(y.length>0)return new d(y)}),new Promise(p=>setTimeout(()=>p(void 0),1e3))]).catch(p=>{})}async Y(h,v){const P=v.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new k.$uM(P));if(h){const p=await this.J.getExtensionRegistry();return(0,S.$Zg)(()=>h.createDebugAdapterDescriptor(v.api,this.Z(v,p))).then(y=>{if(y)return y})}const g=await this.J.getExtensionRegistry();return Promise.resolve(this.Z(v,g))}Z(h,v){}$(h,v,P){(h.length>0||v.length>0||P.length>0)&&this.z.fire(Object.freeze({added:h,removed:v,changed:P}))}async ab(h){if(h)if(typeof h=="string"){const v=this.l.get(h);if(v)return v}else{let v=this.l.get(h.id);if(!v){const P=await this.bb(h.folderUri),g=h.parent?this.l.get(h.parent):void 0;v=new u(this.k,h.id,h.type,h.name,P,h.configuration,g?.api),this.l.set(v.id,v),this.k.$sessionCached(v.id)}return v}throw new Error("cannot find session")}bb(h){if(h){const v=I.URI.revive(h);return this.I.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}cb(h,v){return`${h}\0${v}`}db(h){if(h){if("title"in h&&"command"in h)return{type:0};throw new Error("Unsupported debug visualization type")}}eb(h){const v=this.fb(h);let P,g;return"id"in v?g=i.ThemeIcon.asClassName(v):P=v,{iconPath:P,iconClass:g}}fb(h){if(h instanceof k.$lM)return{id:h.id};const v=typeof h=="object"&&"dark"in h?h.dark:h,P=typeof h=="object"&&"light"in h?h.light:h;return{dark:typeof v=="string"?I.URI.file(v):v,light:typeof P=="string"?I.URI.file(P):P}}};e.$zhc=a,e.$zhc=a=Je([qe(0,L.$AN),qe(1,l.$Rgc),qe(2,D.$thc),qe(3,r.$Ugc),qe(4,f.$7gc),qe(5,c.$whc),qe(6,o.$WN)],a);class u{constructor(h,v,P,g,p,y,T){this.f=h,this.g=v,this.h=P,this.i=g,this.j=p,this.k=y,this.l=T}get api(){const h=this;return this.d??=Object.freeze({id:h.g,type:h.h,get name(){return h.i},set name(v){h.i=v,h.f.$setDebugSessionName(h.g,v)},parentSession:h.l,workspaceFolder:h.j,configuration:h.k,customRequest(v,P){return h.f.$customDebugAdapterRequest(h.g,v,P)},getDebugProtocolBreakpoint(v){return h.f.$getDebugProtocolBreakpoint(h.g,v.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(h){this.i=h}get configuration(){return this.k}}e.$Ahc=u;class t{constructor(h){this.value=Object.freeze({append(v){h.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.$Bhc=t;class d{constructor(h){this.d=h}onWillStartSession(){this.d.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.d.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.d.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(h):void 0)}onWillStopSession(){this.d.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.d.forEach(v=>v.onError?v.onError(h):void 0)}onExit(h,v){this.d.forEach(P=>P.onExit?P.onExit(h,v):void 0)}}class n extends $.$rmb{constructor(h){super(),this.h=h,h.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.h.handleMessage(h)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends a{constructor(h,v,P,g,p,y,T){super(h,v,P,g,p,y,T)}};e.$Chc=b,e.$Chc=b=Je([qe(0,L.$AN),qe(1,l.$Rgc),qe(2,D.$thc),qe(3,r.$Ugc),qe(4,f.$7gc),qe(5,c.$whc),qe(6,o.$WN)],b)}),define(Ae[291],Me([1,0,15,87,2,3,237,14,53,71,27,186,17,58,38,60]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=e.$Eic=void 0;class c{static async installEarlyHandler(o){Error.stackTraceLimit=100;const a=o.get(m.$pj),t=o.get(l.$AN).getProxy(A.$oL.MainThreadErrors);S.setUnexpectedErrorHandler(d=>{a.error(d);const n=S.$3(d);t.$onUnexpectedError(n)})}static async installFullHandler(o){const a=o.get(m.$pj),u=o.get(l.$AN),t=o.get(w.$thc),d=o.get(r.$UN),n=u.getProxy(A.$oL.MainThreadExtensionService),b=u.getProxy(A.$oL.MainThreadErrors),E=await t.getExtensionPathIndex(),h=new WeakMap;function v(p,y){if(h.has(p))return h.get(p).stack;let T="",N,J;for(const U of y)T+=`
	at ${U.toString()}`,J=U.getFileName(),!N&&J&&(N=E.findSubstr(I.URI.file(J)));const q=`${p.name||"Error"}: ${p.message||""}${T}`;return h.set(p,{extensionIdentifier:N?.identifier,stack:q}),q}const P=Symbol("prepareStackTrace wrapped");let g=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(p){if(p===v||!p||p[P]){g=p||v;return}g=function(y,T){return v(y,T),p.call(Error,y,T)},Object.assign(g,{[P]:!0})}}),S.setUnexpectedErrorHandler(p=>{a.error(p);const y=S.$3(p),T=h.get(p);if(!T?.extensionIdentifier){b.$onUnexpectedError(y);return}n.$onExtensionRuntimeError(T.extensionIdentifier,y);const N=d.onExtensionError(T.extensionIdentifier,p);a.trace("forwarded error to extension?",N,T)})}}e.$Eic=c;class s{constructor(o,a,u,t,d){this.a=u,this.b=new R.$E8b(o,null,t),a=s.e(a,this.b);const n=new D.$6h(...(0,f.$2r)());n.set(L.$QN,{_serviceBrand:void 0,...a,messagePorts:d}),n.set(l.$AN,new l.$BN(this.b)),n.set($.$Ogc,new $.$Pgc(t)),n.set(w.$rhc,u);const b=new k.$Gq(n,!0);b.invokeFunction(c.installEarlyHandler),this.d=b.invokeFunction(E=>E.get(m.$pj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=b.invokeFunction(E=>E.get(w.$thc)),this.c.initialize(),b.invokeFunction(c.installFullHandler)}async asBrowserUri(o){const a=this.b.getProxy(A.$oL.MainThreadExtensionService);return I.URI.revive(await a.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,a){o.extensions.allExtensions.forEach(t=>{t.extensionLocation=I.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),o.environment.appRoot=I.URI.revive(a.transformIncomingURIs(o.environment.appRoot));const u=o.environment.extensionDevelopmentLocationURI;return u&&(o.environment.extensionDevelopmentLocationURI=u.map(t=>I.URI.revive(a.transformIncomingURIs(t)))),o.environment.extensionTestsLocationURI=I.URI.revive(a.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=I.URI.revive(a.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=I.URI.revive(a.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=I.URI.revive(a.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=I.URI.revive(a.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=I.URI.revive(a.transformIncomingURIs(o.logsLocation)),o.workspace=a.transformIncomingURIs(o.workspace),o}}e.$Fic=s}),define(Ae[292],Me([1,0,18,11,21,41,12,19,24,2,44]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=e.$Shc=e.$Rhc=e.$Qhc=void 0;class k{constructor(i,o,a,u){this.d=i,this.e=o,this.f=a,this.g=u,this.a=null,this.b=!1,this.c=0}search(i,o){const a=this.d.folderQueries||[],u=new I.$7d(o);return new Promise((t,d)=>{this.a=new $(i);let n=!1;const b=(E,h)=>{if(!n&&!this.b){const v=this.h(E);r(E)&&typeof this.d.maxResults=="number"&&this.c+v>this.d.maxResults&&(this.b=!0,n=!0,u.cancel(),E=this.j(E,this.d.maxResults-this.c));const P=this.h(E);this.c+=P,(P>0||!r(E))&&this.a.add(E,h)}};Promise.all(a.map((E,h)=>this.k(E,v=>b(v,h),u.token))).then(E=>{u.dispose(),this.a.flush();const h=E.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||h,messages:(0,S.$Rb)(E.map(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[])),stats:{type:this.g}})},E=>{u.dispose();const h=(0,A.$Si)(E);d(new Error(h))})})}h(i){return r(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,o){const a=Array.isArray(i.ranges)?i.ranges:[i.ranges],u=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:a.slice(0,o),preview:{matches:u.slice(0,o),text:i.preview.text},uri:i.uri}}async k(i,o,a){const u=new L.$3J(this.d,i),t=[],d={report:E=>{if(!this.l(E))return;const h=i.folder.scheme===R.Schemas.file?(0,L.$4J)(()=>this.f.readdir(f.$Hg(E.uri))):void 0,v=f.$Kg(i.folder,E.uri);if(v){const P=u.includedInQuery(v,m.$nc(v),h);(0,M.$Tg)(P)?t.push(P.then(g=>{g&&o(E)})):P&&o(E)}}},n=this.n(i),b=await this.e.provideTextSearchResults(l(this.d.contentPattern),n,d,a);return t.length&&await Promise.all(t),b}l(i){if(r(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const o=(0,L.$2J)(this.d.includePattern,i.includePattern),a=(0,L.$2J)(this.d.excludePattern,i.excludePattern),u={folder:D.URI.from(i.folder),excludes:a,includes:o,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return u.usePCRE2=this.d.usePCRE2,u}}e.$Qhc=k;function l(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class ${constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new c(512,o=>this.g(o))}add(i,o){this.d&&(this.b!==o||!f.$Bg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:i.uri,results:[]}),this.d.results.push(w(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Rhc=$;function w(s){return r(s)?{preview:{matches:(0,S.$2b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,S.$2b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}e.$Shc=r;class c{static{this.a=4e3}static{this.b=50}constructor(i,o){this.g=i,this.h=o,this.c=0,this.d=[],this.e=0}addItem(i,o){i&&this.j(i,o)}addItems(i,o){i&&this.k(i,o)}j(i,o){this.d.push(i),this.e+=o,this.l()}k(i,o){this.d=this.d.concat(i),this.e+=o,this.l()}l(){this.c<c.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},c.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Thc=c}),define(Ae[119],Me([1,0,6,3,4,287,17,58,14,2,292]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=e.$Vhc=e.$Uhc=void 0,e.$Uhc=(0,I.$8h)("IExtHostSearch");let k=class{constructor(r,c,s){this.k=r,this.l=c,this.n=s,this.c=this.k.getProxy(M.$oL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.$Phc}o(r){return this.l.transformOutgoingScheme(r)}registerTextSearchProvider(r,c){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,c),this.c.$registerTextSearchProvider(s,this.o(r)),(0,S.$Rc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,c){if(this.i.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,c),this.c.$registerFileSearchProvider(s,this.o(r)),(0,S.$Rc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,c,s,i){const o=l(s),a=this.h.get(r);if(a)return this.j.fileSearch(o,a,u=>{this.c.$handleFileMatch(r,c,u.map(t=>t.resource))},i);throw new Error("unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,c,s){return{messages:[]}}$clearCache(r){return this.j.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,c,s,i){const o=this.e.get(r);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${r}`);const a=l(s);return this.q(a,o).search(t=>this.c.$handleTextMatch(r,c,t),i)}$enableExtensionHostSearch(){}q(r,c){return new L.$Qhc(r,c,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$Vhc=k,e.$Vhc=k=Je([qe(0,R.$AN),qe(1,m.$Ogc),qe(2,f.$pj)],k);function l(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map($),extraFileResources:w.extraFileResources&&w.extraFileResources.map(r=>D.URI.revive(r))}}e.$Whc=l;function $(w){return{...w,folder:D.URI.revive(w.folder)}}}),define(Ae[293],Me([1,0,21,15,5,6,12,32,2,147,143,131,92,22,42,14,56,57,199,3,240,271,78,241,247,225,248,249,250,226,214,31,251,37,252,118,108,253,228,242,254,255,66,64,243,38,257,62,258,43,27,272,273,244,229,259,260,79,80,231,286,262,203,263,274,264,113,232,265,266,267,17,268,119,81,269,233,270,82,84,116,60,65,275,276,245,277,278,85,8,7,234,58,235,61,279,280,107,36,209,77,25,115]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o,a,u,t,d,n,b,E,h,v,P,g,p,y,T,N,J,q,U,C,F,W,re,ce,we,De,he,ve,se,$e,te,X,V,ie,Ce,Te,Pe,be,me,G,_,le,de,Le,ge,ke,Ie,O,K,j,H,Q,oe,Ee,Be,We,Ze,_e,at,rt,et,ct,Ue,vt,Z,x,pe,Ve,Ye,it,st,Ne,Mt,Jt,_t,Ut,Et,ei,jt,ni,Yt,Qt,Xe,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;function ti(ht){const mt=ht.get(X.$QN),Kt=ht.get(te.$wgc),ii=ht.get(se.$Wgc),Pt=ht.get(he.$thc),dt=ht.get(ni.$Rgc),Rt=ht.get(Ue.$UN),oi=ht.get(T.$Ugc),Lt=ht.get(Jt.$Ogc),He=ht.get(oe.$AN),Ft=ht.get(rt.$dhc),Wt=ht.get(et.$Xgc),Zt=ht.get(r.$qj),ft=ht.get(r.$pj),Tt=ht.get(it.$zzb),Ct=ht.get(t.$zgc),Nt=ht.get(jt.$yic),Vt=ht.get(We.$lhc),Ot=ht.get(we.$7gc),St=ht.get(G.$phc);He.set(o.$pL.ExtHostFileSystemInfo,Kt),He.set(o.$pL.ExtHostLogLevelServiceShape,Zt),He.set(o.$pL.ExtHostWorkspace,dt),He.set(o.$pL.ExtHostConfiguration,oi),He.set(o.$pL.ExtHostExtensionService,Pt),He.set(o.$pL.ExtHostStorage,Ft),He.set(o.$pL.ExtHostTunnelService,Tt),He.set(o.$pL.ExtHostWindow,Nt),He.set(o.$pL.ExtHostSecretState,Vt),He.set(o.$pL.ExtHostTelemetry,Rt),He.set(o.$pL.ExtHostEditorTabs,Ot),He.set(o.$pL.ExtHostManagedSockets,St);const zt=He.set(o.$pL.ExtHostDecorations,ht.get(q.$Ehc)),Dt=He.set(o.$pL.ExtHostDocumentsAndEditors,ht.get(ce.$LN)),yt=He.set(o.$pL.ExtHostCommands,ht.get(p.$WN)),It=He.set(o.$pL.ExtHostTerminalService,ht.get(vt.$ghc)),kt=He.set(o.$pL.ExtHostDebugService,ht.get(J.$yhc)),li=He.set(o.$pL.ExtHostSearch,ht.get(Be.$Uhc)),Gt=He.set(o.$pL.ExtHostTask,ht.get(ct.$lic)),ye=He.set(o.$pL.ExtHostOutputService,ht.get(O.$$hc)),Fe=He.set(o.$pL.ExtHostLocalization,ht.get(me.$ohc)),ue=He.set(o.$pL.ExtHostUrls,new _t.$vic(He)),Y=He.set(o.$pL.ExtHostDocuments,new re.$ugc(He,Dt)),Re=He.set(o.$pL.ExtHostDocumentContentProviders,new F.$Ghc(He,Dt,ft)),je=He.set(o.$pL.ExtHostDocumentSaveParticipant,new W.$Hhc(ft,Y,He.getProxy(o.$oL.MainThreadBulkEdits))),Qe=He.set(o.$pL.ExtHostNotebook,new le.$Xhc(He,yt,Dt,Y,ii,li)),Ke=He.set(o.$pL.ExtHostNotebookDocuments,new Le.$5hc(Qe)),nt=He.set(o.$pL.ExtHostNotebookEditors,new ge.$6hc(ft,Qe)),bt=He.set(o.$pL.ExtHostNotebookKernels,new ke.$7hc(He,mt,Qe,yt,ft)),qt=He.set(o.$pL.ExtHostNotebookRenderers,new Ie.$9hc(He,Qe)),Xt=He.set(o.$pL.ExtHostNotebookDocumentSaveParticipant,new de.$4hc(ft,Qe,He.getProxy(o.$oL.MainThreadBulkEdits))),pt=He.set(o.$pL.ExtHostEditors,new x.$Lgc(He,Dt)),Ht=He.set(o.$pL.ExtHostTreeViews,new Ye.$tic(He.getProxy(o.$oL.MainThreadTreeViews),yt,ft)),Ri=He.set(o.$pL.ExtHostEditorInsets,new g.$Mgc(He.getProxy(o.$oL.MainThreadEditorInsets),pt,mt.remote)),pi=He.set(o.$pL.ExtHostDiagnostics,new U.$ygc(He,ft,Kt,Dt)),vi=He.set(o.$pL.ExtHostLanguages,new be.$2hc(He,Y,yt.converter,Lt)),lt=He.set(o.$pL.ExtHostLanguageFeatures,new Pe.$Cgc(He,Lt,Y,yt,pi,ft,Ct,Rt)),Yi=He.set(o.$pL.ExtHostFileSystem,new ve.$Jhc(He,lt)),ai=He.set(o.$pL.ExtHostFileSystemEventService,new $e.$Khc(He,ft,Dt)),fi=He.set(o.$pL.ExtHostQuickOpen,(0,Q.$cic)(He,dt,yt)),Ei=He.set(o.$pL.ExtHostSCM,new Ee.$eic(He,yt,Y,ft)),Li=He.set(o.$pL.ExtHostQuickDiff,new H.$bic(He,Lt)),Qi=He.set(o.$pL.ExtHostShare,new Ze.$fic(He,Lt)),Ai=He.set(o.$pL.ExtHostComments,(0,y.$Ngc)(He,yt,Y)),Di=He.set(o.$pL.ExtHostProgress,new j.$aic(He.getProxy(o.$oL.MainThreadProgress))),Zi=He.set(o.$pL.ExtHostLabelService,new Te.$1hc(He)),Mi=He.set(o.$pL.ExtHostTheming,new pe.$qic(He)),gi=He.set(o.$pL.ExtHostAuthentication,new d.$Egc(He)),Xi=He.set(o.$pL.ExtHostTimeline,new Ve.$sic(He,yt)),ki=He.set(o.$pL.ExtHostWebviews,new Ut.$2gc(He,mt.remote,dt,ft,Ct)),Fi=He.set(o.$pL.ExtHostWebviewPanels,new Et.$5gc(He,ki,dt)),ln=He.set(o.$pL.ExtHostCustomEditors,new N.$6gc(He,Y,Wt,ki,Fi)),Ti=He.set(o.$pL.ExtHostWebviewViews,new ei.$wic(He,ki)),mi=He.set(o.$pL.ExtHostTesting,new Z.$mic(He,ft,yt,Dt)),hn=He.set(o.$pL.ExtHostUriOpeners,new Mt.$uic(He)),dn=He.set(o.$pL.ExtHostProfileContentHandlers,new K.$_hc(He));He.set(o.$pL.ExtHostInteractive,new ie.$Yhc(He,Qe,Dt,yt,ft));const xi=He.set(o.$pL.ExtHostInlineChat,new V.$Lhc(He,yt,Y,ft)),yi=He.set(o.$pL.ExtHostChatProvider,new h.$Hgc(He,ft,gi)),Ni=He.set(o.$pL.ExtHostChatAgents2,new E.$Igc(He,yi,ft,yt)),_i=He.set(o.$pL.ExtHostChatVariables,new v.$Jgc(He)),Si=He.set(o.$pL.ExtHostChat,new b.$Ggc(He)),Oi=He.set(o.$pL.ExtHostAiRelatedInformation,new a.$tgc(He)),fn=He.set(o.$pL.ExtHostAiEmbeddingVector,new De.$Ihc(He)),Ii=He.set(o.$pL.ExtHostIssueReporter,new Ce.$Zhc(He)),zi=He.set(o.$pL.ExtHostStatusBar,new at.$iic(He,yt.converter)),hi=He.set(o.$pL.ExtHostSpeech,new _e.$gic(He)),Ci=Object.values(o.$pL);He.assertRegistered(Ci);const gn=new n.$Fgc(He,Dt),ri=new P.$Kgc(He),bi=new _.$3hc(He,ft),Ui=new C.$Fhc(He);return u.$Dgc.register(yt),function(ze,ci,ji){function tt(ee){return(ae,Oe,ot)=>{const wt=ee(At=>{try{ae.call(Oe,At)}catch(Ki){M.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Ki.toString()}`,{cause:Ki})),Rt.onExtensionError(ze.identifier,Ki)}});return ot?.push(wt),wt}}const $t=function(){let ee=!ze.isUnderDevelopment;function ae(){ee||(ft.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Oe(ot){if(Array.isArray(ot))ot.forEach(Oe);else if(typeof ot=="string")ae();else{const wt=ot;typeof wt.scheme>"u"&&ae(),typeof wt.exclusive=="boolean"&&(0,Xe.$LF)(ze,"documentFiltersExclusive")}return ot}}(),en={getSession(ee,ae,Oe){return gi.getSession(ze,ee,ae,Oe)},getSessions(ee,ae){return(0,Xe.$LF)(ze,"authGetSessions"),gi.getSessions(ze,ee,ae)},async hasSession(ee,ae){return(0,Xe.$LF)(ze,"authSession"),!!await gi.getSession(ze,ee,ae,{silent:!0})},get onDidChangeSessions(){return tt(gi.onDidChangeSessions)},registerAuthenticationProvider(ee,ae,Oe,ot){return gi.registerAuthenticationProvider(ee,ae,Oe,ot)}},mn={registerCommand(ee,ae,Oe){return yt.registerCommand(!0,ee,ae,Oe,void 0,ze)},registerTextEditorCommand(ee,ae,Oe){return yt.registerCommand(!0,ee,(...ot)=>{const wt=pt.getActiveTextEditor();if(!wt){ft.warn("Cannot execute "+ee+" because there is no active text editor.");return}return wt.edit(At=>{ae.apply(Oe,[wt,At,...ot])}).then(At=>{At||ft.warn("Edits from command "+ee+" were not applied.")},At=>{ft.warn("An error occurred while running command "+ee,At)})},void 0,void 0,ze)},registerDiffInformationCommand:(ee,ae,Oe)=>((0,Xe.$LF)(ze,"diffCommand"),yt.registerCommand(!0,ee,async(...ot)=>{const wt=Dt.activeEditor(!0);if(!wt){ft.warn("Cannot execute "+ee+" because there is no active text editor.");return}const At=await pt.getDiffInformation(wt.id);ae.apply(Oe,[At,...ot])},void 0,void 0,ze)),executeCommand(ee,...ae){return yt.executeCommand(ee,...ae)},getCommands(ee=!1){return yt.getCommands(ee)}},tn={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return ri.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return tt(It.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return tt(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$LF)(ze,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$LF)(ze,"telemetry"),tt(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Ue.$TN)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,ae){return Ue.$SN.validateSender(ee),Rt.instantiateLogger(ze,ee,ae)},openExternal(ee,ae){return Nt.openUri(ee,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===mt.environment.appUriScheme)return ue.createAppUri(ee);try{return await Nt.asExternalUri(ee,{allowTunneling:!!mt.remote.authority})}catch(ae){if((0,R.$fg)(ee,R.Schemas.http)||(0,R.$fg)(ee,R.Schemas.https))return ee;throw ae}},get remoteName(){return(0,c.$dl)(mt.remote.authority)},get remoteAuthority(){return(0,Xe.$LF)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return tt(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(ee){return(0,Xe.$LF)(ze,"handleIssueUri"),Ii.registerIssueUriRequestHandler(ze,ee)},registerIssueDataProvider(ee){return(0,Xe.$LF)(ze,"handleIssueUri"),Ii.registerIssueDataProvider(ze,ee)},get appQuality(){return(0,Xe.$LF)(ze,"resolvers"),mt.quality},get appCommit(){return(0,Xe.$LF)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(tn);const nn={createTestController(ee,ae,Oe){return mi.createTestController(ze,ee,ae,Oe)},createTestObserver(){return(0,Xe.$LF)(ze,"testObserver"),mi.createTestObserver()},runTests(ee){return(0,Xe.$LF)(ze,"testObserver"),mi.runTests(ee)},get onDidChangeTestResults(){return(0,Xe.$LF)(ze,"testObserver"),tt(mi.onResultsChanged)},get testResults(){return(0,Xe.$LF)(ze,"testObserver"),mi.results}},wi=mt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,rn={getExtension(ee,ae){(0,Xe.$KF)(ze,"extensionsAny")||(ae=!1);const Oe=ci.mine.getExtensionDescription(ee);if(Oe)return new he.$uhc(Pt,ze.identifier,Oe,wi,!1);if(ae){const ot=ci.all.getExtensionDescription(ee);if(ot)return new he.$uhc(Pt,ze.identifier,ot,wi,!0)}},get all(){const ee=[];for(const ae of ci.mine.getAllExtensionDescriptions())ee.push(new he.$uhc(Pt,ze.identifier,ae,wi,!1));return ee},get allAcrossExtensionHosts(){(0,Xe.$LF)(ze,"extensionsAny");const ee=new $.$om(ci.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ae=[];for(const Oe of ci.all.getAllExtensionDescriptions()){const ot=!ee.has(Oe.identifier);ae.push(new he.$uhc(Pt,ze.identifier,Oe,wi,ot))}return ae},get onDidChange(){return(0,Xe.$KF)(ze,"extensionsAny")?tt(I.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):tt(ci.mine.onDidChange)}},sn={createDiagnosticCollection(ee){return pi.createDiagnosticCollection(ze.identifier,ee)},get onDidChangeDiagnostics(){return tt(pi.onDidChangeDiagnostics)},getDiagnostics:ee=>pi.getDiagnostics(ee),getLanguages(){return vi.getLanguages()},setTextDocumentLanguage(ee,ae){return vi.changeLanguage(ee.uri,ae)},match(ee,ae){const Oe=Y.getDocumentData(ae.uri)?.notebook;return(0,L.$Dt)(st.LanguageSelector.from(ee),ae.uri,ae.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ee,ae,Oe){return lt.registerCodeActionProvider(ze,$t(ee),ae,Oe)},registerDocumentPasteEditProvider(ee,ae,Oe){return(0,Xe.$LF)(ze,"documentPaste"),lt.registerDocumentPasteEditProvider(ze,$t(ee),ae,Oe)},registerCodeLensProvider(ee,ae){return lt.registerCodeLensProvider(ze,$t(ee),ae)},registerDefinitionProvider(ee,ae){return lt.registerDefinitionProvider(ze,$t(ee),ae)},registerDeclarationProvider(ee,ae){return lt.registerDeclarationProvider(ze,$t(ee),ae)},registerImplementationProvider(ee,ae){return lt.registerImplementationProvider(ze,$t(ee),ae)},registerTypeDefinitionProvider(ee,ae){return lt.registerTypeDefinitionProvider(ze,$t(ee),ae)},registerHoverProvider(ee,ae){return lt.registerHoverProvider(ze,$t(ee),ae,ze.identifier)},registerEvaluatableExpressionProvider(ee,ae){return lt.registerEvaluatableExpressionProvider(ze,$t(ee),ae,ze.identifier)},registerInlineValuesProvider(ee,ae){return lt.registerInlineValuesProvider(ze,$t(ee),ae,ze.identifier)},registerDocumentHighlightProvider(ee,ae){return lt.registerDocumentHighlightProvider(ze,$t(ee),ae)},registerMultiDocumentHighlightProvider(ee,ae){return lt.registerMultiDocumentHighlightProvider(ze,$t(ee),ae)},registerLinkedEditingRangeProvider(ee,ae){return lt.registerLinkedEditingRangeProvider(ze,$t(ee),ae)},registerReferenceProvider(ee,ae){return lt.registerReferenceProvider(ze,$t(ee),ae)},registerRenameProvider(ee,ae){return lt.registerRenameProvider(ze,$t(ee),ae)},registerNewSymbolNamesProvider(ee,ae){return(0,Xe.$LF)(ze,"newSymbolNamesProvider"),lt.registerNewSymbolNamesProvider(ze,$t(ee),ae)},registerDocumentSymbolProvider(ee,ae,Oe){return lt.registerDocumentSymbolProvider(ze,$t(ee),ae,Oe)},registerWorkspaceSymbolProvider(ee){return lt.registerWorkspaceSymbolProvider(ze,ee)},registerDocumentFormattingEditProvider(ee,ae){return lt.registerDocumentFormattingEditProvider(ze,$t(ee),ae)},registerDocumentRangeFormattingEditProvider(ee,ae){return lt.registerDocumentRangeFormattingEditProvider(ze,$t(ee),ae)},registerOnTypeFormattingEditProvider(ee,ae,Oe,...ot){return lt.registerOnTypeFormattingEditProvider(ze,$t(ee),ae,[Oe].concat(ot))},registerDocumentSemanticTokensProvider(ee,ae,Oe){return lt.registerDocumentSemanticTokensProvider(ze,$t(ee),ae,Oe)},registerDocumentRangeSemanticTokensProvider(ee,ae,Oe){return lt.registerDocumentRangeSemanticTokensProvider(ze,$t(ee),ae,Oe)},registerSignatureHelpProvider(ee,ae,Oe,...ot){return typeof Oe=="object"?lt.registerSignatureHelpProvider(ze,$t(ee),ae,Oe):lt.registerSignatureHelpProvider(ze,$t(ee),ae,typeof Oe>"u"?[]:[Oe,...ot])},registerCompletionItemProvider(ee,ae,...Oe){return lt.registerCompletionItemProvider(ze,$t(ee),ae,Oe)},registerInlineCompletionItemProvider(ee,ae,Oe){return ae.handleDidShowCompletionItem&&(0,Xe.$LF)(ze,"inlineCompletionsAdditions"),ae.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$LF)(ze,"inlineCompletionsAdditions"),Oe&&(0,Xe.$LF)(ze,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(ze,$t(ee),ae,Oe)},registerDocumentLinkProvider(ee,ae){return lt.registerDocumentLinkProvider(ze,$t(ee),ae)},registerColorProvider(ee,ae){return lt.registerColorProvider(ze,$t(ee),ae)},registerFoldingRangeProvider(ee,ae){return lt.registerFoldingRangeProvider(ze,$t(ee),ae)},registerSelectionRangeProvider(ee,ae){return lt.registerSelectionRangeProvider(ze,ee,ae)},registerCallHierarchyProvider(ee,ae){return lt.registerCallHierarchyProvider(ze,ee,ae)},registerTypeHierarchyProvider(ee,ae){return lt.registerTypeHierarchyProvider(ze,ee,ae)},setLanguageConfiguration:(ee,ae)=>lt.setLanguageConfiguration(ze,ee,ae),getTokenInformationAtPosition(ee,ae){return(0,Xe.$LF)(ze,"tokenInformation"),vi.tokenAtPosition(ee,ae)},registerInlayHintsProvider(ee,ae){return lt.registerInlayHintsProvider(ze,ee,ae)},createLanguageStatusItem(ee,ae){return vi.createLanguageStatusItem(ze,ee,ae)},registerDocumentDropEditProvider(ee,ae,Oe){return lt.registerDocumentOnDropEditProvider(ze,ee,ae,(0,Xe.$KF)(ze,"dropMetadata")?Oe:void 0)}},on={get activeTextEditor(){return pt.getActiveTextEditor()},get visibleTextEditors(){return pt.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(ee,ae,Oe){f.URI.isUri(ee)&&ee.scheme===R.Schemas.vscodeRemote&&!ee.authority&&Ct.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const ot=await(f.URI.isUri(ee)?Promise.resolve(an.openTextDocument(ee)):Promise.resolve(ee));return pt.showTextDocument(ot,ae,Oe)},createTextEditorDecorationType(ee){return pt.createTextEditorDecorationType(ze,ee)},onDidChangeActiveTextEditor(ee,ae,Oe){return tt(pt.onDidChangeActiveTextEditor)(ee,ae,Oe)},onDidChangeVisibleTextEditors(ee,ae,Oe){return tt(pt.onDidChangeVisibleTextEditors)(ee,ae,Oe)},onDidChangeTextEditorSelection(ee,ae,Oe){return tt(pt.onDidChangeTextEditorSelection)(ee,ae,Oe)},onDidChangeTextEditorOptions(ee,ae,Oe){return tt(pt.onDidChangeTextEditorOptions)(ee,ae,Oe)},onDidChangeTextEditorVisibleRanges(ee,ae,Oe){return tt(pt.onDidChangeTextEditorVisibleRanges)(ee,ae,Oe)},onDidChangeTextEditorViewColumn(ee,ae,Oe){return tt(pt.onDidChangeTextEditorViewColumn)(ee,ae,Oe)},onDidCloseTerminal(ee,ae,Oe){return tt(It.onDidCloseTerminal)(ee,ae,Oe)},onDidOpenTerminal(ee,ae,Oe){return tt(It.onDidOpenTerminal)(ee,ae,Oe)},onDidChangeActiveTerminal(ee,ae,Oe){return tt(It.onDidChangeActiveTerminal)(ee,ae,Oe)},onDidChangeTerminalDimensions(ee,ae,Oe){return(0,Xe.$LF)(ze,"terminalDimensions"),tt(It.onDidChangeTerminalDimensions)(ee,ae,Oe)},onDidChangeTerminalState(ee,ae,Oe){return tt(It.onDidChangeTerminalState)(ee,ae,Oe)},onDidWriteTerminalData(ee,ae,Oe){return(0,Xe.$LF)(ze,"terminalDataWriteEvent"),tt(It.onDidWriteTerminalData)(ee,ae,Oe)},onDidExecuteTerminalCommand(ee,ae,Oe){return(0,Xe.$LF)(ze,"terminalExecuteCommandEvent"),tt(It.onDidExecuteTerminalCommand)(ee,ae,Oe)},get state(){return Nt.getState(ze)},onDidChangeWindowState(ee,ae,Oe){return tt(Nt.onDidChangeWindowState)(ee,ae,Oe)},showInformationMessage(ee,...ae){return bi.showMessage(ze,m.default.Info,ee,ae[0],ae.slice(1))},showWarningMessage(ee,...ae){return bi.showMessage(ze,m.default.Warning,ee,ae[0],ae.slice(1))},showErrorMessage(ee,...ae){return bi.showMessage(ze,m.default.Error,ee,ae[0],ae.slice(1))},showQuickPick(ee,ae,Oe){return fi.showQuickPick(ze,ee,ae,Oe)},showWorkspaceFolderPick(ee){return fi.showWorkspaceFolderPick(ee)},showInputBox(ee,ae){return fi.showInput(ee,ae)},showOpenDialog(ee){return Ui.showOpenDialog(ze,ee)},showSaveDialog(ee){return Ui.showSaveDialog(ee)},createStatusBarItem(ee,ae,Oe){let ot,wt,At;return typeof ee=="string"?(ot=ee,wt=ae,At=Oe):(wt=ee,At=ae),zi.createStatusBarEntry(ze,ot,wt,At)},setStatusBarMessage(ee,ae){return zi.setStatusBarMessage(ee,ae)},withScmProgress(ee){return Ct.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Di.withProgress(ze,{location:Ne.ProgressLocation.SourceControl},(ae,Oe)=>ee({report(ot){}}))},withProgress(ee,ae){return Di.withProgress(ze,ee,ae)},createOutputChannel(ee,ae){return ye.createOutputChannel(ee,ae,ze)},createWebviewPanel(ee,ae,Oe,ot){return Fi.createWebviewPanel(ze,ee,ae,Oe,ot)},createWebviewTextEditorInset(ee,ae,Oe,ot){return(0,Xe.$LF)(ze,"editorInsets"),Ri.createWebviewEditorInset(ee,ae,Oe,ot,ze)},createTerminal(ee,ae,Oe){return typeof ee=="object"?"pty"in ee?It.createExtensionTerminal(ee):It.createTerminalFromOptions(ee):It.createTerminal(ee,ae,Oe)},registerTerminalLinkProvider(ee){return It.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,ae){return It.registerProfileProvider(ze,ee,ae)},registerTerminalQuickFixProvider(ee,ae){return(0,Xe.$LF)(ze,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(ee,ze.identifier.value,ae)},registerTreeDataProvider(ee,ae){return Ht.registerTreeDataProvider(ee,ae,ze)},createTreeView(ee,ae){return Ht.createTreeView(ee,ae,ze)},registerWebviewPanelSerializer:(ee,ae)=>Fi.registerWebviewPanelSerializer(ze,ee,ae),registerCustomEditorProvider:(ee,ae,Oe={})=>ln.registerCustomEditorProvider(ze,ee,ae,Oe),registerFileDecorationProvider(ee){return zt.registerFileDecorationProvider(ee,ze)},registerUriHandler(ee){return ue.registerUriHandler(ze,ee)},createQuickPick(){return fi.createQuickPick(ze)},createInputBox(){return fi.createInputBox(ze)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(ee,ae,Oe){return tt(Mi.onDidChangeActiveColorTheme)(ee,ae,Oe)},registerWebviewViewProvider(ee,ae,Oe){return Ti.registerWebviewViewProvider(ze,ee,ae,Oe?.webviewOptions)},get activeNotebookEditor(){return Qe.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,ae,Oe){return tt(Qe.onDidChangeActiveNotebookEditor)(ee,ae,Oe)},get visibleNotebookEditors(){return Qe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return tt(Qe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,ae,Oe){return tt(nt.onDidChangeNotebookEditorSelection)(ee,ae,Oe)},onDidChangeNotebookEditorVisibleRanges(ee,ae,Oe){return tt(nt.onDidChangeNotebookEditorVisibleRanges)(ee,ae,Oe)},showNotebookDocument(ee,ae){return Qe.showNotebookDocument(ee,ae)},registerExternalUriOpener(ee,ae,Oe){return(0,Xe.$LF)(ze,"externalUriOpener"),hn.registerExternalUriOpener(ze.identifier,ee,ae,Oe)},registerProfileContentHandler(ee,ae){return(0,Xe.$LF)(ze,"profileContentHandlers"),dn.registerProfileContentHandler(ze,ee,ae)},registerQuickDiffProvider(ee,ae,Oe,ot){return(0,Xe.$LF)(ze,"quickDiffProvider"),Li.registerQuickDiffProvider($t(ee),ae,Oe,ot)},get tabGroups(){return Ot.tabGroups},registerShareProvider(ee,ae){return(0,Xe.$LF)(ze,"shareProvider"),Qi.registerShareProvider($t(ee),ae)}},an={get rootPath(){return Ct.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(ee){throw new M.$9("rootPath")},getWorkspaceFolder(ee){return dt.getWorkspaceFolder(ee)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(ee){throw new M.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(ee){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(ee,ae,...Oe)=>dt.updateWorkspaceFolders(ze,ee,ae||0,...Oe),onDidChangeWorkspaceFolders:function(ee,ae,Oe){return tt(dt.onDidChangeWorkspace)(ee,ae,Oe)},asRelativePath:(ee,ae)=>dt.getRelativePath(ee,ae),findFiles:(ee,ae,Oe,ot)=>dt.findFiles(ee,ae,Oe,ze.identifier,ot),findFiles2:(ee,ae,Oe)=>((0,Xe.$LF)(ze,"findFiles2"),dt.findFiles2(ee,ae,ze.identifier,Oe)),findTextInFiles:(ee,ae,Oe,ot)=>{(0,Xe.$LF)(ze,"findTextInFiles");let wt,At;return typeof ae=="object"?(wt=ae,At=Oe):(wt={},At=ae,ot=Oe),dt.findTextInFiles(ee,wt||{},At,ze.identifier,ot)},save:ee=>dt.save(ee),saveAs:ee=>dt.saveAs(ee),saveAll:ee=>dt.saveAll(ee),applyEdit(ee,ae){return gn.applyWorkspaceEdit(ee,ze,ae)},createFileSystemWatcher:(ee,ae,Oe,ot)=>{let wt;return typeof ae=="boolean"?wt={ignoreCreateEvents:!!ae,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!ot,correlate:!1}:ae&&((0,Xe.$LF)(ze,"createFileSystemWatcher"),wt={...ae,correlate:!0}),ai.createFileSystemWatcher(dt,ze,ee,wt)},get textDocuments(){return Y.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new M.$9("textDocuments")},openTextDocument(ee){let ae;const Oe=ee;if(typeof ee=="string")ae=Promise.resolve(f.URI.file(ee));else if(f.URI.isUri(ee))ae=Promise.resolve(ee);else if(!Oe||typeof Oe=="object")ae=Y.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(ot=>(ot.scheme===R.Schemas.vscodeRemote&&!ot.authority&&Ct.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),Y.ensureDocumentData(ot).then(wt=>wt.document)))},onDidOpenTextDocument:(ee,ae,Oe)=>tt(Y.onDidAddDocument)(ee,ae,Oe),onDidCloseTextDocument:(ee,ae,Oe)=>tt(Y.onDidRemoveDocument)(ee,ae,Oe),onDidChangeTextDocument:(ee,ae,Oe)=>tt(Y.onDidChangeDocument)(ee,ae,Oe),onDidSaveTextDocument:(ee,ae,Oe)=>tt(Y.onDidSaveDocument)(ee,ae,Oe),onWillSaveTextDocument:(ee,ae,Oe)=>tt(je.getOnWillSaveTextDocumentEvent(ze))(ee,ae,Oe),get notebookDocuments(){return Qe.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,ae){let Oe;if(f.URI.isUri(ee))Oe=ee,await Qe.openNotebookDocument(ee);else if(typeof ee=="string")Oe=f.URI.revive(await Qe.createNotebookDocument({viewType:ee,content:ae}));else throw new Error("Invalid arguments");return Qe.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ee,ae,Oe){return tt(Ke.onDidSaveNotebookDocument)(ee,ae,Oe)},onDidChangeNotebookDocument(ee,ae,Oe){return tt(Ke.onDidChangeNotebookDocument)(ee,ae,Oe)},onWillSaveNotebookDocument(ee,ae,Oe){return tt(Xt.getOnWillSaveNotebookDocumentEvent(ze))(ee,ae,Oe)},get onDidOpenNotebookDocument(){return tt(Qe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return tt(Qe.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,ae,Oe,ot){return Qe.registerNotebookSerializer(ze,ee,ae,Oe,(0,Xe.$KF)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ee,ae,Oe)=>tt(ji.onDidChangeConfiguration)(ee,ae,Oe),getConfiguration(ee,ae){return ae=arguments.length===1?void 0:ae,ji.getConfiguration(ee,ae,ze)},registerTextDocumentContentProvider(ee,ae){return Re.registerTextDocumentContentProvider(ee,ae)},registerTaskProvider:(ee,ae)=>(Ct.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(ze,ee,ae)),registerFileSystemProvider(ee,ae,Oe){return(0,A.$Qc)(Yi.registerFileSystemProvider(ze,ee,ae,Oe),ii.addFileSystemProvider(ee,ae,Oe))},get fs(){return ii.value},registerFileSearchProvider:(ee,ae)=>((0,Xe.$LF)(ze,"fileSearchProvider"),li.registerFileSearchProvider(ee,ae)),registerTextSearchProvider:(ee,ae)=>((0,Xe.$LF)(ze,"textSearchProvider"),li.registerTextSearchProvider(ee,ae)),registerRemoteAuthorityResolver:(ee,ae)=>((0,Xe.$LF)(ze,"resolvers"),Pt.registerRemoteAuthorityResolver(ee,ae)),registerResourceLabelFormatter:ee=>((0,Xe.$LF)(ze,"resolvers"),Zi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Xe.$LF)(ze,"resolvers"),Pt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,ae,Oe)=>tt(ai.onDidCreateFile)(ee,ae,Oe),onDidDeleteFiles:(ee,ae,Oe)=>tt(ai.onDidDeleteFile)(ee,ae,Oe),onDidRenameFiles:(ee,ae,Oe)=>tt(ai.onDidRenameFile)(ee,ae,Oe),onWillCreateFiles:(ee,ae,Oe)=>tt(ai.getOnWillCreateFileEvent(ze))(ee,ae,Oe),onWillDeleteFiles:(ee,ae,Oe)=>tt(ai.getOnWillDeleteFileEvent(ze))(ee,ae,Oe),onWillRenameFiles:(ee,ae,Oe)=>tt(ai.getOnWillRenameFileEvent(ze))(ee,ae,Oe),openTunnel:ee=>((0,Xe.$LF)(ze,"tunnels"),Tt.openTunnel(ze,ee).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,Xe.$LF)(ze,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(ee,ae,Oe)=>((0,Xe.$LF)(ze,"tunnels"),tt(Tt.onDidChangeTunnels)(ee,ae,Oe)),registerPortAttributesProvider:(ee,ae)=>((0,Xe.$LF)(ze,"portsAttributes"),Tt.registerPortsAttributesProvider(ee,ae)),registerTunnelProvider:(ee,ae)=>((0,Xe.$LF)(ze,"tunnelFactory"),Tt.registerTunnelProvider(ee,ae)),registerTimelineProvider:(ee,ae)=>((0,Xe.$LF)(ze,"timeline"),Xi.registerTimelineProvider(ee,ae,ze.identifier,yt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:ee=>((0,Xe.$LF)(ze,"workspaceTrust"),dt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,ae,Oe)=>tt(dt.onDidGrantWorkspaceTrust)(ee,ae,Oe),registerEditSessionIdentityProvider:(ee,ae)=>((0,Xe.$LF)(ze,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(ee,ae)),onWillCreateEditSessionIdentity:(ee,ae,Oe)=>((0,Xe.$LF)(ze,"editSessionIdentityProvider"),tt(dt.getOnWillCreateEditSessionIdentityEvent(ze))(ee,ae,Oe)),registerCanonicalUriProvider:(ee,ae)=>((0,Xe.$LF)(ze,"canonicalUriProvider"),dt.registerCanonicalUriProvider(ee,ae)),getCanonicalUri:(ee,ae,Oe)=>((0,Xe.$LF)(ze,"canonicalUriProvider"),dt.provideCanonicalUri(ee,ae,Oe))},$n={get inputBox(){return Ct.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Ei.getLastInputBox(ze)},createSourceControl(ee,ae,Oe){return Ei.createSourceControl(ze,ee,ae,Oe)}},cn={createCommentController(ee,ae){return Ai.createCommentController(ze,ee,ae)}},un={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get stackFrameFocus(){return kt.stackFrameFocus},registerDebugVisualizationProvider(ee,ae){return(0,Xe.$LF)(ze,"debugVisualization"),kt.registerDebugVisualizationProvider(ze,ee,ae)},onDidStartDebugSession(ee,ae,Oe){return tt(kt.onDidStartDebugSession)(ee,ae,Oe)},onDidTerminateDebugSession(ee,ae,Oe){return tt(kt.onDidTerminateDebugSession)(ee,ae,Oe)},onDidChangeActiveDebugSession(ee,ae,Oe){return tt(kt.onDidChangeActiveDebugSession)(ee,ae,Oe)},onDidReceiveDebugSessionCustomEvent(ee,ae,Oe){return tt(kt.onDidReceiveDebugSessionCustomEvent)(ee,ae,Oe)},onDidChangeBreakpoints(ee,ae,Oe){return tt(kt.onDidChangeBreakpoints)(ee,ae,Oe)},onDidChangeStackFrameFocus(ee,ae,Oe){return(0,Xe.$LF)(ze,"debugFocus"),tt(kt.onDidChangeStackFrameFocus)(ee,ae,Oe)},registerDebugConfigurationProvider(ee,ae,Oe){return kt.registerDebugConfigurationProvider(ee,ae,Oe||Yt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,ae){return kt.registerDebugAdapterDescriptorFactory(ze,ee,ae)},registerDebugAdapterTrackerFactory(ee,ae){return kt.registerDebugAdapterTrackerFactory(ee,ae)},startDebugging(ee,ae,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?kt.startDebugging(ee,ae,{parentSession:Oe}):kt.startDebugging(ee,ae,Oe||{})},stopDebugging(ee){return kt.stopDebugging(ee)},addBreakpoints(ee){return kt.addBreakpoints(ee)},removeBreakpoints(ee){return kt.removeBreakpoints(ee)},asDebugSourceUri(ee,ae){return kt.asDebugSourceUri(ee,ae)}},Bi={registerTaskProvider:(ee,ae)=>Gt.registerTaskProvider(ze,ee,ae),fetchTasks:ee=>Gt.fetchTasks(ee),executeTask:ee=>Gt.executeTask(ze,ee),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(ee,ae,Oe)=>tt(Gt.onDidStartTask)(ee,ae,Oe),onDidEndTask:(ee,ae,Oe)=>tt(Gt.onDidEndTask)(ee,ae,Oe),onDidStartTaskProcess:(ee,ae,Oe)=>tt(Gt.onDidStartTaskProcess)(ee,ae,Oe),onDidEndTaskProcess:(ee,ae,Oe)=>tt(Gt.onDidEndTaskProcess)(ee,ae,Oe)},Wi={createNotebookController(ee,ae,Oe,ot,wt){return bt.createNotebookController(ze,ee,ae,Oe,ot,(0,Xe.$KF)(ze,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,ae)=>Qe.registerNotebookCellStatusBarItemProvider(ze,ee,ae),createRendererMessaging(ee){return qt.createRendererMessaging(ze,ee)},createNotebookControllerDetectionTask(ee){return(0,Xe.$LF)(ze,"notebookKernelSource"),bt.createNotebookControllerDetectionTask(ze,ee)},registerKernelSourceActionProvider(ee,ae){return(0,Xe.$LF)(ze,"notebookKernelSource"),bt.registerKernelSourceActionProvider(ze,ee,ae)},onDidChangeNotebookCellExecutionState(ee,ae,Oe){return(0,Xe.$LF)(ze,"notebookCellExecutionState"),tt(bt.onDidChangeNotebookCellExecutionState)(ee,ae,Oe)}},Vi={t(...ee){if(typeof ee[0]=="string"){const ae=ee.shift(),Oe=!ee||typeof ee[0]!="object"?ee:ee[0];return Fe.getMessage(ze.identifier.value,{message:ae,args:Oe})}return Fe.getMessage(ze.identifier.value,ee[0])},get bundle(){return Fe.getBundle(ze.identifier.value)},get uri(){return Fe.getBundleUri(ze.identifier.value)}},Pi={_version:1,registerInteractiveEditorSessionProvider(ee,ae){return(0,Xe.$LF)(ze,"interactive"),xi.registerProvider(ze,ee,ae)},registerInteractiveSessionProvider(ee,ae){return(0,Xe.$LF)(ze,"interactive"),Si.registerChatProvider(ze,ee,ae)},sendInteractiveRequestToProvider(ee,ae){return(0,Xe.$LF)(ze,"interactive"),Si.sendInteractiveRequestToProvider(ee,ae)},transferChatSession(ee,ae){return(0,Xe.$LF)(ze,"interactive"),Si.transferChatSession(ee,ae)}},qi={getRelatedInformation(ee,ae){return(0,Xe.$LF)(ze,"aiRelatedInformation"),Oi.getRelatedInformation(ze,ee,ae)},registerRelatedInformationProvider(ee,ae){return(0,Xe.$LF)(ze,"aiRelatedInformation"),Oi.registerRelatedInformationProvider(ze,ee,ae)},registerEmbeddingVectorProvider(ee,ae){return(0,Xe.$LF)(ze,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(ze,ee,ae)}},Hi={registerChatResponseProvider(ee,ae,Oe){return(0,Xe.$LF)(ze,"chatProvider"),yi.registerLanguageModel(ze.identifier,ee,ae,Oe)},requestLanguageModelAccess(ee,ae){return(0,Xe.$LF)(ze,"chatRequestAccess"),yi.requestLanguageModelAccess(ze,ee,ae)},get languageModels(){return(0,Xe.$LF)(ze,"chatRequestAccess"),yi.getLanguageModelIds()},onDidChangeLanguageModels:(ee,ae,Oe)=>((0,Xe.$LF)(ze,"chatRequestAccess"),yi.onDidChangeProviders(ee,ae,Oe)),registerVariable(ee,ae,Oe){return(0,Xe.$LF)(ze,"chatAgents2"),_i.registerVariableResolver(ze,ee,ae,Oe)},registerMappedEditsProvider(ee,ae){return(0,Xe.$LF)(ze,"mappedEditsProvider"),lt.registerMappedEditsProvider(ze,ee,ae)},createChatAgent(ee,ae){return(0,Xe.$LF)(ze,"chatAgents2"),Ni.createChatAgent(ze,ee,ae)}},pn={registerSpeechProvider(ee,ae){return(0,Xe.$LF)(ze,"speech"),hi.registerProvider(ze.identifier,ee,ae)}};return{version:mt.version,ai:qi,authentication:en,commands:mn,comments:cn,chat:Hi,debug:un,env:tn,extensions:rn,interactive:Pi,l10n:Vi,languages:sn,notebooks:Wi,scm:$n,speech:pn,tasks:Bi,tests:nn,window:on,workspace:an,Breakpoint:Ne.$pM,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$iN,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$hN,CallHierarchyIncomingCall:Ne.$OL,CallHierarchyItem:Ne.$NL,CallHierarchyOutgoingCall:Ne.$PL,CancellationError:M.$5,CancellationTokenSource:S.$7d,CandidatePortSource:o.CandidatePortSource,CodeAction:Ne.$KL,CodeActionKind:Ne.$LL,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$QL,Color:Ne.$4L,ColorInformation:Ne.$5L,ColorPresentation:Ne.$6L,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$XL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$YL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$bM,DebugAdapterExecutable:Ne.$tM,DebugAdapterInlineImplementation:Ne.$wM,DebugAdapterNamedPipeServer:Ne.$vM,DebugAdapterServer:Ne.$uM,DebugConfigurationProviderTriggerKind:Yt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DebugVisualization:Ne.$LM,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$EL,DiagnosticRelatedInformation:Ne.$DL,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$qL,DocumentHighlight:Ne.$GL,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$HL,DocumentLink:Ne.$3L,DocumentSymbol:Ne.$JL,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$zM,InlineValueText:Ne.$AM,InlineValueVariableLookup:Ne.$BM,InlineValueEvaluatableExpression:Ne.$CM,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:I.$Wd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$NM,FileDecoration2:Ne.$NM,FileSystemError:Ne.$EM,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:Ne.$FM,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$rM,InlineCompletionItem:Ne.$ZL,InlineCompletionList:Ne.$1L,Hover:Ne.$FL,IndentAction:k.IndentAction,Location:Ne.$CL,MarkdownString:Ne.$RL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$SL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$rL,ProcessExecution:Ne.$_L,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$MM,Range:Ne.$sL,RelativePattern:Ne.$nM,Selection:Ne.$tL,SelectionRange:Ne.$ML,SemanticTokens:Ne.$IM,SemanticTokensBuilder:Ne.$HM,SemanticTokensEdit:Ne.$JM,SemanticTokensEdits:Ne.$KM,SemanticTokensLegend:Ne.$GM,ShellExecution:Ne.$aM,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$UL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$TL,SnippetString:Ne.$BL,SourceBreakpoint:Ne.$qM,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$IL,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$cM,TaskGroup:Ne.$$L,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$7L,TerminalQuickFixTerminalCommand:Ne.$9L,TerminalQuickFixOpener:Ne.$8L,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$0L,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$xL,SnippetTextEdit:Ne.$zL,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$mM,ThemeIcon:Ne.$lM,TreeItem:Ne.$dM,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$9M,UIKind:Qt.UIKind,Uri:f.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$AL,DocumentDropEdit:Ne.$jM,DocumentPasteEdit:Ne.$kM,InlayHint:Ne.$WL,InlayHintLabelPart:Ne.$VL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$wL,ResolvedAuthority:Ne.$uL,ManagedResolvedAuthority:Ne.$vL,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$XM,NotebookRange:Ne.$PM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$QM,NotebookData:Ne.$RM,NotebookRendererScript:Ne.$VM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$TM,NotebookCellOutputItem:Ne.$SM,NotebookCellStatusBarItem:Ne.$UM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$yL,NotebookKernelSourceAction:Ne.$WM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$ZM,LinkedEditingRanges:Ne.$YM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$1M,TestMessage:Ne.$2M,TestTag:Ne.$3M,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Bt.TextSearchCompleteMessageType,DataTransfer:Ne.$iM,DataTransferItem:Ne.$eM,CoveredCount:Ne.$4M,FileCoverage:Ne.$5M,StatementCoverage:Ne.$6M,BranchCoverage:Ne.$7M,DeclarationCoverage:Ne.$8M,FunctionCoverage:Ne.$8M,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$0M,TabInputTextDiff:Ne.$$M,TabInputTextMerge:Ne.$_M,TabInputCustom:Ne.$aN,TabInputNotebook:Ne.$cN,TabInputNotebookDiff:Ne.$dN,TabInputWebview:Ne.$bN,TabInputTerminal:Ne.$eN,TabInputInteractiveWindow:Ne.$fN,TabInputChat:Ne.$gN,TelemetryTrustedValue:s.$No,LogLevel:r.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatAgentCopyKind:Ne.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$xM,ThreadFocus:Ne.$yM,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus,KeywordRecognitionStatus:Ne.KeywordRecognitionStatus,ChatResponseTextPart:Ne.$jN,ChatResponseMarkdownPart:Ne.$kN,ChatResponseFileTreePart:Ne.$lN,ChatResponseAnchorPart:Ne.$mN,ChatResponseProgressPart:Ne.$nN,ChatResponseReferencePart:Ne.$pN,ChatResponseCommandButtonPart:Ne.$oN}}}e.$zic=ti}),define(Ae[294],Me([1,0,53,113,36,108,37,31,66,65,116,118,119,82,85,78,107,62,43,81,60,64,230,14,117,79,80]),function(fe,e,S,M,I,A,R,m,f,D,L,k,l,$,w,r,c,s,i,o,a,u,t,d,n,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$1r)(b.$ohc,b.$nhc,1),(0,S.$1r)(d.$qj,t.$Aic,1),(0,S.$1r)(r.$zgc,r.$Agc,1),(0,S.$1r)(m.$WN,m.$VN,0),(0,S.$1r)(R.$Ugc,R.$Sgc,0),(0,S.$1r)(s.$Wgc,s.$Vgc,0),(0,S.$1r)(k.$yhc,k.$Chc,0),(0,S.$1r)(A.$Ehc,A.$Dhc,0),(0,S.$1r)(f.$LN,f.$KN,0),(0,S.$1r)(E.$phc,E.$qhc,0),(0,S.$1r)(i.$wgc,i.$vgc,0),(0,S.$1r)(M.$$hc,M.$0hc,1),(0,S.$1r)(l.$Uhc,l.$Vhc,0),(0,S.$1r)($.$dhc,$.$chc,0),(0,S.$1r)(L.$lic,L.$kic,0),(0,S.$1r)(D.$ghc,D.$jhc,0),(0,S.$1r)(w.$zzb,w.$Azb,0),(0,S.$1r)(c.$yic,c.$xic,0),(0,S.$1r)(I.$Rgc,I.$Qgc,0),(0,S.$1r)(o.$lhc,o.$khc,0),(0,S.$1r)(a.$UN,a.$RN,0),(0,S.$1r)(u.$7gc,u.$8gc,0),(0,S.$1r)(n.$whc,n.$xhc,0)}),define(Ae[295],Me([1,0,293,38,2,290,7,11,236]),function(fe,e,S,M,I,A,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=void 0;class D extends A.$Dic{j(){}getModule($,w){for(const r of this.b){const c=r($);if(c){$=c;break}}if(this.a.has($))return this.a.get($).load($,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class L extends M.$shc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(f.$Kkc);const $=this.h.invokeFunction(S.$zic);this.r=this.h.createInstance(D,$,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub($){return $.browser}async vb($,w,r){w=w.with({path:k(w.path,".js")});const c=$?.identifier.value;c&&performance.mark(`code/extHost/willFetchExtensionCode/${c}`);const s=I.URI.revive(await this.C.$asBrowserUri(w)),i=await fetch(s.toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c}`),i.status!==200)throw new Error(i.statusText);const o=await i.text(),a=`${w.toString(!0)}#vscode-extension`,u=`${o}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",u)}catch(E){throw console.error(c?`Loading code for extension ${c} failed: ${E.message}`:`Loading code failed: ${E.message}`),console.error(`${w.toString(!0)}${typeof E.line=="number"?` line ${E.line}`:""}${typeof E.column=="number"?` column ${E.column}`:""}`),console.error(E),E}$&&await this.w.initializeLocalizedMessages($);const d={},n={exports:d},b=E=>{const h=this.r.getModule(E,w);if(h===void 0)throw new Error(`Cannot load module '${E}'`);return h};try{return r.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c}`),t(n,d,b),n.exports!==d?n.exports:d}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c}`),r.codeLoadingStop()}}async $setRemoteEnvironment($){}async zb($=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+$;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await(0,m.$9g)(10)}}e.$Lkc=L;function k(l,$){return l.endsWith($)?l:l+$}}),define(Ae[296],Me([1,0,70,53,14,38,201,84,295]),function(fe,e,S,M,I,A,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$1r)(I.$pj,new S.$5h(R.$Cic,[!0],!0)),(0,M.$1r)(A.$thc,f.$Lkc,0),(0,M.$1r)(m.$Xgc,m.$Ygc,0)}),define(Ae[301],Me([1,0,23,5,77,291,238,19,87,12,2,294,296]),function(fe,e,S,M,I,A,R,m,f,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function $(t){return/^(file|vscode-remote):/i.test(t)}const w=fetch.bind(self);function r(t){self.fetch=async function(d,n){return d instanceof Request||$(String(d))&&(d=(await t(L.URI.parse(String(d)))).toString(!0)),w(d,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,n,b,E,h){(async()=>($(n.toString())&&(n=(await t(L.URI.parse(n.toString()))).toString(!0)),super.open(d,n,b??!0,E,h)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(d,n){if(/^file:/i.test(d.toString()))d=D.$pg.uriToBrowserUri(L.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const E=`(${function(g){function p(N){return typeof N=="string"||N instanceof URL?String(N).replace(/^file:\/\//i,"vscode-file://vscode-app"):N}const y=fetch.bind(self);self.fetch=function(N,J){return N instanceof Request?y(N,J):y(p(N),J)},self.XMLHttpRequest=class extends XMLHttpRequest{open(N,J,q,U,C){return super.open(N,p(J),q??!0,U,C)}};const T=importScripts.bind(self);self.importScripts=(...N)=>{T(...N.map(p))},T(g)}.toString()}('${d}'))`;n=n||{},n.name=`${name} -> ${n.name||m.$nc(d.toString())}`;const h=new Blob([E],{type:"application/javascript"}),v=URL.createObjectURL(h);return new t(v,n)}}else self.Worker=class extends R.$Mkc{constructor(t,d){super(l,t,{name:m.$nc(t.toString()),...d})}};const c=new class{constructor(){this.pid=void 0}exit(t){k()}};class s{constructor(){const d=new MessageChannel,n=new M.$Wd;let b=!1;l(d.port2,[d.port2]),d.port1.onmessage=E=>{const{data:h}=E;if(!(h instanceof ArrayBuffer)){console.warn("UNKNOWN data received",h);return}const v=S.$ke.wrap(new Uint8Array(h,0,h.byteLength));if((0,I.$wm)(v,2)){b=!0,o("received terminate message from renderer");return}n.fire(v)},this.protocol={onMessage:n.event,send:E=>{if(!b){const h=E.buffer.buffer.slice(E.buffer.byteOffset,E.buffer.byteOffset+E.buffer.byteLength);d.port1.postMessage(h,[h])}}}}}function i(t){return new Promise(d=>{const n=t.onMessage(b=>{n.dispose();const E=JSON.parse(b.toString());t.send((0,I.$vm)(0)),d({protocol:t,initData:E})});t.send((0,I.$vm)(1))})}let o=t=>k();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function u(){f.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(d){a(d)&&i(t.protocol).then(n=>{f.mark("code/extHost/didWaitForInitData");const b=new A.$Fic(n.protocol,n.initData,c,null,d.data);r(E=>b.asBrowserUri(E)),o=E=>b.terminate(E)})}}}e.create=u})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/420099cb092f0994ecb1e7af4c679dc0ffe57fa3/core/vs/workbench/api/worker/extensionHostWorker.js.map
